/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ue=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/async","vs/platform/files/common/files","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/map","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/strings","fs","vs/platform/product/common/productService","vs/base/common/json","os","vs/base/common/process","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/processes","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/languagePacks/common/languagePacks","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/storage/common/storage","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/jsonSchema","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/console","vs/amdX","vs/base/node/macAddress","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/base/common/date","vs/base/common/jsonErrorMessages","vs/platform/contextkey/common/scanner","vs/base/common/charCode","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionsApiProposals","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/externalServices/common/serviceMachineId","vs/platform/externalServices/common/marketplace","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","vs/base/common/marshallingIds","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],he=function(Y){for(var e=[],S=0,P=Y.length;S<P;S++)e[S]=ue[Y[S]];return e};define(ue[74],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.LoaderEventType=e.$R=void 0,e.$R=!1;var S;(function(v){v[v.LoaderAvailable=1]="LoaderAvailable",v[v.BeginLoadingScript=10]="BeginLoadingScript",v[v.EndLoadingScriptOK=11]="EndLoadingScriptOK",v[v.EndLoadingScriptError=12]="EndLoadingScriptError",v[v.BeginInvokeFactory=21]="BeginInvokeFactory",v[v.EndInvokeFactory=22]="EndInvokeFactory",v[v.NodeBeginEvaluatingScript=31]="NodeBeginEvaluatingScript",v[v.NodeEndEvaluatingScript=32]="NodeEndEvaluatingScript",v[v.NodeBeginNativeRequire=33]="NodeBeginNativeRequire",v[v.NodeEndNativeRequire=34]="NodeEndNativeRequire",v[v.CachedDataFound=60]="CachedDataFound",v[v.CachedDataMissed=61]="CachedDataMissed",v[v.CachedDataRejected=62]="CachedDataRejected",v[v.CachedDataCreated=63]="CachedDataCreated"})(S||(e.LoaderEventType=S={}));class P{static get(){const k=new Map,L=new Map,O=new Map,w=new Map;function a(p,I){p.has(I.detail)||p.set(I.detail,-I.timestamp)}function f(p,I){const b=p.get(I.detail);b&&(b>=0||p.set(I.detail,b+I.timestamp))}let c=[];typeof Y=="function"&&typeof Y.getStats=="function"&&(c=Y.getStats().slice(0).sort((p,I)=>p.timestamp-I.timestamp));for(const p of c)switch(p.type){case S.BeginLoadingScript:a(k,p);break;case S.EndLoadingScriptOK:case S.EndLoadingScriptError:f(k,p);break;case S.BeginInvokeFactory:a(L,p);break;case S.EndInvokeFactory:f(L,p);break;case S.NodeBeginNativeRequire:a(O,p);break;case S.NodeEndNativeRequire:f(O,p);break;case S.NodeBeginEvaluatingScript:a(w,p);break;case S.NodeEndEvaluatingScript:f(w,p);break}let m=0;O.forEach(p=>m+=p);function d(p){const I=[];return p.forEach((b,h)=>I.push([h,b])),I}return{amdLoad:d(k),amdInvoke:d(L),nodeRequire:d(O),nodeEval:d(w),nodeRequireTotal:m}}static toMarkdownTable(k,L){let O="";const w=[];return k.forEach((a,f)=>{w[f]=a.length}),L.forEach(a=>{a.forEach((f,c)=>{typeof f>"u"&&(f=a[c]="-");const m=f.toString().length;w[c]=Math.max(m,w[c])})}),k.forEach((a,f)=>{O+=`| ${a+" ".repeat(w[f]-a.toString().length)} `}),O+=`|
`,k.forEach((a,f)=>{O+=`| ${"-".repeat(w[f])} `}),O+=`|
`,L.forEach(a=>{a.forEach((f,c)=>{typeof f<"u"&&(O+=`| ${f+" ".repeat(w[c]-f.toString().length)} `)}),O+=`|
`}),O}}e.$S=P}),define(ue[55],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=P,e.$0h=v,e.$$h=k;function S(L){return(O,w,a)=>{let f=null,c=null;if(typeof a.value=="function"?(f="value",c=a.value):typeof a.get=="function"&&(f="get",c=a.get),!c)throw new Error("not supported");a[f]=L(c,w)}}function P(L,O,w){let a=null,f=null;if(typeof w.value=="function"?(a="value",f=w.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof w.get=="function"&&(a="get",f=w.get),!f)throw new Error("not supported");const c=`$memoize$${O}`;w[a]=function(...m){return this.hasOwnProperty(c)||Object.defineProperty(this,c,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,m)}),this[c]}}function v(L,O,w){return S((a,f)=>{const c=`$debounce$${f}`,m=`$debounce$result$${f}`;return function(...d){this[m]||(this[m]=w?w():void 0),clearTimeout(this[c]),O&&(this[m]=O(this[m],...d),d=[this[m]]),this[c]=setTimeout(()=>{a.apply(this,d),this[m]=w?w():void 0},L)}})}function k(L,O,w){return S((a,f)=>{const c=`$throttle$timer$${f}`,m=`$throttle$result$${f}`,d=`$throttle$lastRun$${f}`,p=`$throttle$pending$${f}`;return function(...I){if(this[m]||(this[m]=w?w():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),O&&(this[m]=O(this[m],...I)),this[p])return;const b=this[d]+L;b<=Date.now()?(this[d]=Date.now(),a.apply(this,[this[m]]),this[m]=w?w():void 0):(this[p]=!0,this[c]=setTimeout(()=>{this[p]=!1,this[d]=Date.now(),a.apply(this,[this[m]]),this[m]=w?w():void 0},b-Date.now()))}})}}),define(ue[75],he([0,1,7]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=P,e.$ed=v,e.$fd=k,e.$gd=L,e.$hd=O,e.$id=w;function P(a,f){if(!a)throw new Error(f?`Assertion failed (${f})`:"Assertion Failed")}function v(a,f="Unreachable"){throw new Error(f)}function k(a,f="unexpected state"){if(!a)throw new S.$bb(`Assertion Failed: ${f}`)}function L(a){a||(0,S.$Y)(new S.$bb("Soft Assertion Failed"))}function O(a){if(!a()){debugger;a(),(0,S.$Y)(new S.$bb("Assertion Failed"))}}function w(a,f){let c=0;for(;c<a.length-1;){const m=a[c],d=a[c+1];if(!f(m,d))return!1;c++}return!0}}),define(ue[34],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=L,e.$Wn=c,e.$Xn=m,e.$Yn=d,e.$Zn=p,e.$1n=I,e.$2n=b,e.$3n=h,e.$4n=g,e.$5n=R,e.$6n=y;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var v;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(v||(e.ParseErrorCode=v={}));var k;(function(i){i.DEFAULT={allowTrailingComma:!0}})(k||(e.ParseOptions=k={}));function L(i,l=!1){let n=0;const s=i.length;let t="",r=0,o=P.Unknown,u=S.None;function $(Q){let te=0,ae=0;for(;te<Q;){const le=i.charCodeAt(n);if(le>=f._0&&le<=f._9)ae=ae*16+le-f._0;else if(le>=f.A&&le<=f.F)ae=ae*16+le-f.A+10;else if(le>=f.a&&le<=f.f)ae=ae*16+le-f.a+10;else break;n++,te++}return te<Q&&(ae=-1),ae}function N(Q){n=Q,t="",r=0,o=P.Unknown,u=S.None}function C(){const Q=n;if(i.charCodeAt(n)===f._0)n++;else for(n++;n<i.length&&a(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===f.dot)if(n++,n<i.length&&a(i.charCodeAt(n)))for(n++;n<i.length&&a(i.charCodeAt(n));)n++;else return u=S.UnexpectedEndOfNumber,i.substring(Q,n);let te=n;if(n<i.length&&(i.charCodeAt(n)===f.E||i.charCodeAt(n)===f.e))if(n++,(n<i.length&&i.charCodeAt(n)===f.plus||i.charCodeAt(n)===f.minus)&&n++,n<i.length&&a(i.charCodeAt(n))){for(n++;n<i.length&&a(i.charCodeAt(n));)n++;te=n}else u=S.UnexpectedEndOfNumber;return i.substring(Q,te)}function A(){let Q="",te=n;for(;;){if(n>=s){Q+=i.substring(te,n),u=S.UnexpectedEndOfString;break}const ae=i.charCodeAt(n);if(ae===f.doubleQuote){Q+=i.substring(te,n),n++;break}if(ae===f.backslash){if(Q+=i.substring(te,n),n++,n>=s){u=S.UnexpectedEndOfString;break}switch(i.charCodeAt(n++)){case f.doubleQuote:Q+='"';break;case f.backslash:Q+="\\";break;case f.slash:Q+="/";break;case f.b:Q+="\b";break;case f.f:Q+="\f";break;case f.n:Q+=`
`;break;case f.r:Q+="\r";break;case f.t:Q+="	";break;case f.u:{const de=$(4);de>=0?Q+=String.fromCharCode(de):u=S.InvalidUnicode;break}default:u=S.InvalidEscapeCharacter}te=n;continue}if(ae>=0&&ae<=31)if(w(ae)){Q+=i.substring(te,n),u=S.UnexpectedEndOfString;break}else u=S.InvalidCharacter;n++}return Q}function D(){if(t="",u=S.None,r=n,n>=s)return r=s,o=P.EOF;let Q=i.charCodeAt(n);if(O(Q)){do n++,t+=String.fromCharCode(Q),Q=i.charCodeAt(n);while(O(Q));return o=P.Trivia}if(w(Q))return n++,t+=String.fromCharCode(Q),Q===f.carriageReturn&&i.charCodeAt(n)===f.lineFeed&&(n++,t+=`
`),o=P.LineBreakTrivia;switch(Q){case f.openBrace:return n++,o=P.OpenBraceToken;case f.closeBrace:return n++,o=P.CloseBraceToken;case f.openBracket:return n++,o=P.OpenBracketToken;case f.closeBracket:return n++,o=P.CloseBracketToken;case f.colon:return n++,o=P.ColonToken;case f.comma:return n++,o=P.CommaToken;case f.doubleQuote:return n++,t=A(),o=P.StringLiteral;case f.slash:{const te=n-1;if(i.charCodeAt(n+1)===f.slash){for(n+=2;n<s&&!w(i.charCodeAt(n));)n++;return t=i.substring(te,n),o=P.LineCommentTrivia}if(i.charCodeAt(n+1)===f.asterisk){n+=2;const ae=s-1;let le=!1;for(;n<ae;){if(i.charCodeAt(n)===f.asterisk&&i.charCodeAt(n+1)===f.slash){n+=2,le=!0;break}n++}return le||(n++,u=S.UnexpectedEndOfComment),t=i.substring(te,n),o=P.BlockCommentTrivia}return t+=String.fromCharCode(Q),n++,o=P.Unknown}case f.minus:if(t+=String.fromCharCode(Q),n++,n===s||!a(i.charCodeAt(n)))return o=P.Unknown;case f._0:case f._1:case f._2:case f._3:case f._4:case f._5:case f._6:case f._7:case f._8:case f._9:return t+=C(),o=P.NumericLiteral;default:for(;n<s&&U(Q);)n++,Q=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return o=P.TrueKeyword;case"false":return o=P.FalseKeyword;case"null":return o=P.NullKeyword}return o=P.Unknown}return t+=String.fromCharCode(Q),n++,o=P.Unknown}}function U(Q){if(O(Q)||w(Q))return!1;switch(Q){case f.closeBrace:case f.closeBracket:case f.openBrace:case f.openBracket:case f.doubleQuote:case f.colon:case f.comma:case f.slash:return!1}return!0}function G(){let Q;do Q=D();while(Q>=P.LineCommentTrivia&&Q<=P.Trivia);return Q}return{setPosition:N,getPosition:()=>n,scan:l?G:D,getToken:()=>o,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>u}}function O(i){return i===f.space||i===f.tab||i===f.verticalTab||i===f.formFeed||i===f.nonBreakingSpace||i===f.ogham||i>=f.enQuad&&i<=f.zeroWidthSpace||i===f.narrowNoBreakSpace||i===f.mathematicalSpace||i===f.ideographicSpace||i===f.byteOrderMark}function w(i){return i===f.lineFeed||i===f.carriageReturn||i===f.lineSeparator||i===f.paragraphSeparator}function a(i){return i>=f._0&&i<=f._9}var f;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(f||(f={}));function c(i,l){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let o=!1;function u($,N,C,A){r.value=$,r.offset=N,r.length=C,r.type=A,r.colonOffset=void 0,t=r}try{R(i,{onObjectBegin:($,N)=>{if(l<=$)throw s;t=void 0,o=l>$,n.push("")},onObjectProperty:($,N,C)=>{if(l<N||(u($,N,C,"property"),n[n.length-1]=$,l<=N+C))throw s},onObjectEnd:($,N)=>{if(l<=$)throw s;t=void 0,n.pop()},onArrayBegin:($,N)=>{if(l<=$)throw s;t=void 0,n.push(0)},onArrayEnd:($,N)=>{if(l<=$)throw s;t=void 0,n.pop()},onLiteralValue:($,N,C)=>{if(l<N||(u($,N,C,y($)),l<=N+C))throw s},onSeparator:($,N,C)=>{if(l<=N)throw s;if($===":"&&t&&t.type==="property")t.colonOffset=N,o=!1,t=void 0;else if($===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(o=!0,n[n.length-1]=""),t=void 0}}})}catch($){if($!==s)throw $}return{path:n,previousNode:t,isAtPropertyKey:o,matches:$=>{let N=0;for(let C=0;N<$.length&&C<n.length;C++)if($[N]===n[C]||$[N]==="*")N++;else if($[N]!=="**")return!1;return N===$.length}}}function m(i,l=[],n=k.DEFAULT){let s=null,t=[];const r=[];function o($){Array.isArray(t)?t.push($):s!==null&&(t[s]=$)}return R(i,{onObjectBegin:()=>{const $={};o($),r.push(t),t=$,s=null},onObjectProperty:$=>{s=$},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const $=[];o($),r.push(t),t=$,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:o,onError:($,N,C)=>{l.push({error:$,offset:N,length:C})}},n),t[0]}function d(i,l=[],n=k.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t($){s.type==="property"&&(s.length=$-s.offset,s=s.parent)}function r($){return s.children.push($),$}R(i,{onObjectBegin:$=>{s=r({type:"object",offset:$,length:-1,parent:s,children:[]})},onObjectProperty:($,N,C)=>{s=r({type:"property",offset:N,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:$,offset:N,length:C,parent:s})},onObjectEnd:($,N)=>{s.length=$+N-s.offset,s=s.parent,t($+N)},onArrayBegin:($,N)=>{s=r({type:"array",offset:$,length:-1,parent:s,children:[]})},onArrayEnd:($,N)=>{s.length=$+N-s.offset,s=s.parent,t($+N)},onLiteralValue:($,N,C)=>{r({type:y($),offset:N,length:C,parent:s,value:$}),t(N+C)},onSeparator:($,N,C)=>{s.type==="property"&&($===":"?s.colonOffset=N:$===","&&t(N))},onError:($,N,C)=>{l.push({error:$,offset:N,length:C})}},n);const u=s.children[0];return u&&delete u.parent,u}function p(i,l){if(!i)return;let n=i;for(const s of l)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}function I(i){if(!i.parent||!i.parent.children)return[];const l=I(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;l.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&l.push(n)}return l}function b(i){switch(i.type){case"array":return i.children.map(b);case"object":{const l=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(l[n.children[0].value]=b(s))}return l}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function h(i,l,n=!1){return l>=i.offset&&l<i.offset+i.length||n&&l===i.offset+i.length}function g(i,l,n=!1){if(h(i,l,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=l;t++){const r=g(s[t],l,n);if(r)return r}return i}}function R(i,l,n=k.DEFAULT){const s=L(i,!1);function t(K){return K?()=>K(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(K){return K?ie=>K(ie,s.getTokenOffset(),s.getTokenLength()):()=>!0}const o=t(l.onObjectBegin),u=r(l.onObjectProperty),$=t(l.onObjectEnd),N=t(l.onArrayBegin),C=t(l.onArrayEnd),A=r(l.onLiteralValue),D=r(l.onSeparator),U=t(l.onComment),G=r(l.onError),Q=n&&n.disallowComments,te=n&&n.allowTrailingComma;function ae(){for(;;){const K=s.scan();switch(s.getTokenError()){case S.InvalidUnicode:le(v.InvalidUnicode);break;case S.InvalidEscapeCharacter:le(v.InvalidEscapeCharacter);break;case S.UnexpectedEndOfNumber:le(v.UnexpectedEndOfNumber);break;case S.UnexpectedEndOfComment:Q||le(v.UnexpectedEndOfComment);break;case S.UnexpectedEndOfString:le(v.UnexpectedEndOfString);break;case S.InvalidCharacter:le(v.InvalidCharacter);break}switch(K){case P.LineCommentTrivia:case P.BlockCommentTrivia:Q?le(v.InvalidCommentToken):U();break;case P.Unknown:le(v.InvalidSymbol);break;case P.Trivia:case P.LineBreakTrivia:break;default:return K}}}function le(K,ie=[],se=[]){if(G(K),ie.length+se.length>0){let T=s.getToken();for(;T!==P.EOF;){if(ie.indexOf(T)!==-1){ae();break}else if(se.indexOf(T)!==-1)break;T=ae()}}}function de(K){const ie=s.getTokenValue();return K?A(ie):u(ie),ae(),!0}function H(){switch(s.getToken()){case P.NumericLiteral:{let K=0;try{K=JSON.parse(s.getTokenValue()),typeof K!="number"&&(le(v.InvalidNumberFormat),K=0)}catch{le(v.InvalidNumberFormat)}A(K);break}case P.NullKeyword:A(null);break;case P.TrueKeyword:A(!0);break;case P.FalseKeyword:A(!1);break;default:return!1}return ae(),!0}function Z(){return s.getToken()!==P.StringLiteral?(le(v.PropertyNameExpected,[],[P.CloseBraceToken,P.CommaToken]),!1):(de(!1),s.getToken()===P.ColonToken?(D(":"),ae(),J()||le(v.ValueExpected,[],[P.CloseBraceToken,P.CommaToken])):le(v.ColonExpected,[],[P.CloseBraceToken,P.CommaToken]),!0)}function B(){o(),ae();let K=!1;for(;s.getToken()!==P.CloseBraceToken&&s.getToken()!==P.EOF;){if(s.getToken()===P.CommaToken){if(K||le(v.ValueExpected,[],[]),D(","),ae(),s.getToken()===P.CloseBraceToken&&te)break}else K&&le(v.CommaExpected,[],[]);Z()||le(v.ValueExpected,[],[P.CloseBraceToken,P.CommaToken]),K=!0}return $(),s.getToken()!==P.CloseBraceToken?le(v.CloseBraceExpected,[P.CloseBraceToken],[]):ae(),!0}function M(){N(),ae();let K=!1;for(;s.getToken()!==P.CloseBracketToken&&s.getToken()!==P.EOF;){if(s.getToken()===P.CommaToken){if(K||le(v.ValueExpected,[],[]),D(","),ae(),s.getToken()===P.CloseBracketToken&&te)break}else K&&le(v.CommaExpected,[],[]);J()||le(v.ValueExpected,[],[P.CloseBracketToken,P.CommaToken]),K=!0}return C(),s.getToken()!==P.CloseBracketToken?le(v.CloseBracketExpected,[P.CloseBracketToken],[]):ae(),!0}function J(){switch(s.getToken()){case P.OpenBracketToken:return M();case P.OpenBraceToken:return B();case P.StringLiteral:return de(!0);default:return H()}}return ae(),s.getToken()===P.EOF?n.allowEmptyContent?!0:(le(v.ValueExpected,[],[]),!1):J()?(s.getToken()!==P.EOF&&le(v.EndOfFileExpected,[],[]),!0):(le(v.ValueExpected,[],[]),!1)}function y(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),define(ue[76],he([0,1,34]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7n=P,e.$8n=v,e.$9n=O,e.$0n=w;function P(a,f,c){let m,d,p,I,b;if(f){for(I=f.offset,b=I+f.length,p=I;p>0&&!w(a,p-1);)p--;let u=b;for(;u<a.length&&!w(a,u);)u++;d=a.substring(p,u),m=L(d,c)}else d=a,m=0,p=0,I=0,b=a.length;const h=O(c,a);let g=!1,R=0,y;c.insertSpaces?y=k(" ",c.tabSize||4):y="	";const i=(0,S.$Vn)(d,!1);let l=!1;function n(){return h+k(y,m+R)}function s(){let u=i.scan();for(g=!1;u===S.SyntaxKind.Trivia||u===S.SyntaxKind.LineBreakTrivia;)g=g||u===S.SyntaxKind.LineBreakTrivia,u=i.scan();return l=u===S.SyntaxKind.Unknown||i.getTokenError()!==S.ScanError.None,u}const t=[];function r(u,$,N){!l&&$<b&&N>I&&a.substring($,N)!==u&&t.push({offset:$,length:N-$,content:u})}let o=s();if(o!==S.SyntaxKind.EOF){const u=i.getTokenOffset()+p,$=k(y,m);r($,p,u)}for(;o!==S.SyntaxKind.EOF;){let u=i.getTokenOffset()+i.getTokenLength()+p,$=s(),N="";for(;!g&&($===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia);){const A=i.getTokenOffset()+p;r(" ",u,A),u=i.getTokenOffset()+i.getTokenLength()+p,N=$===S.SyntaxKind.LineCommentTrivia?n():"",$=s()}if($===S.SyntaxKind.CloseBraceToken)o!==S.SyntaxKind.OpenBraceToken&&(R--,N=n());else if($===S.SyntaxKind.CloseBracketToken)o!==S.SyntaxKind.OpenBracketToken&&(R--,N=n());else{switch(o){case S.SyntaxKind.OpenBracketToken:case S.SyntaxKind.OpenBraceToken:R++,N=n();break;case S.SyntaxKind.CommaToken:case S.SyntaxKind.LineCommentTrivia:N=n();break;case S.SyntaxKind.BlockCommentTrivia:g?N=n():N=" ";break;case S.SyntaxKind.ColonToken:N=" ";break;case S.SyntaxKind.StringLiteral:if($===S.SyntaxKind.ColonToken){N="";break}case S.SyntaxKind.NullKeyword:case S.SyntaxKind.TrueKeyword:case S.SyntaxKind.FalseKeyword:case S.SyntaxKind.NumericLiteral:case S.SyntaxKind.CloseBraceToken:case S.SyntaxKind.CloseBracketToken:$===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia?N=" ":$!==S.SyntaxKind.CommaToken&&$!==S.SyntaxKind.EOF&&(l=!0);break;case S.SyntaxKind.Unknown:l=!0;break}g&&($===S.SyntaxKind.LineCommentTrivia||$===S.SyntaxKind.BlockCommentTrivia)&&(N=n())}const C=i.getTokenOffset()+p;r(N,u,C),o=$}return t}function v(a,f){const c=JSON.stringify(a,void 0,f.insertSpaces?f.tabSize||4:"	");return f.eol!==void 0?c.replace(/\r\n|\r|\n/g,f.eol):c}function k(a,f){let c="";for(let m=0;m<f;m++)c+=a;return c}function L(a,f){let c=0,m=0;const d=f.tabSize||4;for(;c<a.length;){const p=a.charAt(c);if(p===" ")m++;else if(p==="	")m+=d;else break;c++}return Math.floor(m/d)}function O(a,f){for(let c=0;c<f.length;c++){const m=f.charAt(c);if(m==="\r")return c+1<f.length&&f.charAt(c+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return a&&a.eol||`
`}function w(a,f){return`\r
`.indexOf(a.charAt(f))!==-1}}),define(ue[77],he([0,1,34,76]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=v,e.$_n=k,e.$ao=L,e.$bo=O,e.$co=w;function v(a,f,c){return k(a,f,void 0,c)}function k(a,f,c,m,d){const p=f.slice(),I=[],b=(0,S.$Yn)(a,I);let h,g;for(;p.length>0&&(g=p.pop(),h=(0,S.$Zn)(b,p),h===void 0&&c!==void 0);)typeof g=="string"?c={[g]:c}:c=[c];if(h)if(h.type==="object"&&typeof g=="string"&&Array.isArray(h.children)){const R=(0,S.$Zn)(h,[g]);if(R!==void 0)if(c===void 0){if(!R.parent)throw new Error("Malformed AST");const y=h.children.indexOf(R.parent);let i,l=R.parent.offset+R.parent.length;if(y>0){const n=h.children[y-1];i=n.offset+n.length}else i=h.offset+1,h.children.length>1&&(l=h.children[1].offset);return L(a,{offset:i,length:l-i,content:""},m)}else return L(a,{offset:R.offset,length:R.length,content:JSON.stringify(c)},m);else{if(c===void 0)return[];const y=`${JSON.stringify(g)}: ${JSON.stringify(c)}`,i=d?d(h.children.map(n=>n.children[0].value)):h.children.length;let l;if(i>0){const n=h.children[i-1];l={offset:n.offset+n.length,length:0,content:","+y}}else h.children.length===0?l={offset:h.offset+1,length:0,content:y}:l={offset:h.offset+1,length:0,content:y+","};return L(a,l,m)}}else if(h.type==="array"&&typeof g=="number"&&Array.isArray(h.children))if(c!==void 0){const R=`${JSON.stringify(c)}`;let y;if(h.children.length===0||g===0)y={offset:h.offset+1,length:0,content:h.children.length===0?R:R+","};else{const i=g===-1||g>h.children.length?h.children.length:g,l=h.children[i-1];y={offset:l.offset+l.length,length:0,content:","+R}}return L(a,y,m)}else{const R=g,y=h.children[R];let i;if(h.children.length===1)i={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===R){const l=h.children[R-1],n=l.offset+l.length,s=h.offset+h.length;i={offset:n,length:s-2-n,content:""}}else i={offset:y.offset,length:h.children[R+1].offset-y.offset,content:""};return L(a,i,m)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${h.type}`);else return c===void 0?[]:L(a,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(c)},m)}function L(a,f,c){let m=O(a,f),d=f.offset,p=f.offset+f.content.length;if(f.length===0||f.content.length===0){for(;d>0&&!(0,P.$0n)(m,d-1);)d--;for(;p<m.length&&!(0,P.$0n)(m,p);)p++}const I=(0,P.$7n)(m,{offset:d,length:p-d},c);for(let h=I.length-1;h>=0;h--){const g=I[h];m=O(m,g),d=Math.min(d,g.offset),p=Math.max(p,g.offset+g.length),p+=g.content.length-g.length}const b=a.length-(m.length-p)-d;return[{offset:d,length:b,content:m.substring(d,p)}]}function O(a,f){return a.substring(0,f.offset)+f.content+a.substring(f.offset+f.length)}function w(a,f){const c=f.slice(0).sort((d,p)=>{const I=d.offset-p.offset;return I===0?d.length-p.length:I});let m=a.length;for(let d=c.length-1;d>=0;d--){const p=c[d];if(p.offset+p.length<=m)a=O(a,p);else throw new Error("Overlapping edit");m=p.offset}return a}}),define(ue[78],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=S;function S(k){let L=!1;const O=new Map,w=new Map;if(v(k,I=>{if(k===I)return!0;const b=JSON.stringify(I);if(b.length<30)return!0;const h=O.get(b);if(!h){const g={schemas:[I]};return O.set(b,g),w.set(I,g),!0}return h.schemas.push(I),w.set(I,h),L=!0,!1}),O.clear(),!L)return JSON.stringify(k);let f="$defs";for(;k.hasOwnProperty(f);)f+="_";const c=[];function m(I){return JSON.stringify(I,(b,h)=>{if(h!==I){const g=w.get(h);if(g&&g.schemas.length>1)return g.id||(g.id=`_${c.length}`,c.push(g.schemas[0])),{$ref:`#/${f}/${g.id}`}}return h})}const d=m(k),p=[];for(let I=0;I<c.length;I++)p.push(`"_${I}":${m(c[I])}`);return p.length?`${d.substring(0,d.length-1)},"${f}":{${p.join(",")}}}`:d}function P(k){return typeof k=="object"&&k!==null}function v(k,L){if(!k||typeof k!="object")return;const O=(...d)=>{for(const p of d)P(p)&&c.push(p)},w=(...d)=>{for(const p of d)if(P(p))for(const I in p){const b=p[I];P(b)&&c.push(b)}},a=(...d)=>{for(const p of d)if(Array.isArray(p))for(const I of p)P(I)&&c.push(I)},f=d=>{if(Array.isArray(d))for(const p of d)P(p)&&c.push(p);else P(d)&&c.push(d)},c=[k];let m=c.pop();for(;m;)L(m)&&(O(m.additionalItems,m.additionalProperties,m.not,m.contains,m.propertyNames,m.if,m.then,m.else,m.unevaluatedItems,m.unevaluatedProperties),w(m.definitions,m.$defs,m.properties,m.patternProperties,m.dependencies,m.dependentSchemas),a(m.anyOf,m.allOf,m.oneOf,m.prefixItems),f(m.items)),m=c.pop()}}),define(ue[79],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=S,e.rot=P,e.$Pm=O;function S(w,a,f){return Math.min(Math.max(w,a),f)}function P(w,a){return(a+w%a)%a}class v{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=v;class k{constructor(){this.a=1,this.b=0}update(a){return this.b=this.b+(a-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=k;class L{constructor(a){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(a),this.c.fill(0,0,a)}update(a){const f=this.c[this.d];return this.c[this.d]=a,this.d=(this.d+1)%this.c.length,this.e-=f,this.e+=a,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=L;function O(w,a,f,c,m,d,p,I){const b=p-f,h=I-c,g=m-f,R=d-c,y=w-f,i=a-c,l=b*b+h*h,n=b*g+h*R,s=b*y+h*i,t=g*g+R*R,r=g*y+R*i,o=1/(l*t-n*n),u=(t*s-n*r)*o,$=(l*r-n*s)*o;return u>=0&&$>=0&&u+$<1}}),function(){function Y(v){const k=[];typeof v=="number"&&k.push("code/timeOrigin",v);function L(w){k.push(w,Date.now())}function O(){const w=[];for(let a=0;a<k.length;a+=2)w.push({name:k[a],startTime:k[a+1]});return w}return{mark:L,getMarks:O}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Y():{mark(v){performance.mark(v)},getMarks(){let v=performance.timeOrigin;typeof v!="number"&&(v=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const k=[{name:"code/timeOrigin",startTime:Math.round(v)}];for(const L of performance.getEntriesByType("mark"))k.push({name:L.name,startTime:Math.round(v+L.startTime)});return k}};if(typeof process=="object"){const v=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return Y(v)}else return console.trace("perf-util loaded in UNKNOWN environment"),Y()}function S(v){return v.MonacoPerformanceMarks||(v.MonacoPerformanceMarks=e()),v.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=S(P))}(),define(ue[56],he([0,1,12]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=k,e.$lm=L;var P;(function(O){O[O.stdout=0]="stdout",O[O.stderr=1]="stderr"})(P||(e.Source=P={}));var v;(function(O){O[O.Success=0]="Success",O[O.Unknown=1]="Unknown",O[O.AccessDenied=2]="AccessDenied",O[O.ProcessNotFound=3]="ProcessNotFound"})(v||(e.TerminateResponseCode=v={}));function k(O,...w){const a=w.reduce((m,d)=>(m[d]=!0,m),{}),f=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(O).filter(m=>!a[m]).forEach(m=>{for(let d=0;d<f.length;d++)if(m.search(f[d])!==-1){delete O[m];break}})}function L(O){O&&(delete O.DEBUG,S.$l&&delete O.LD_PRELOAD)}}),function(Y,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var P in S)(typeof exports=="object"?exports:Y)[P]=S[P]}}(typeof self<"u"?self:this,function(){return function(Y){var e={};function S(P){if(e[P])return e[P].exports;var v=e[P]={i:P,l:!1,exports:{}};return Y[P].call(v.exports,v,v.exports,S),v.l=!0,v.exports}return S.m=Y,S.c=e,S.d=function(P,v,k){S.o(P,v)||Object.defineProperty(P,v,{enumerable:!0,get:k})},S.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},S.t=function(P,v){if(1&v&&(P=S(P)),8&v||4&v&&typeof P=="object"&&P&&P.__esModule)return P;var k=Object.create(null);if(S.r(k),Object.defineProperty(k,"default",{enumerable:!0,value:P}),2&v&&typeof P!="string")for(var L in P)S.d(k,L,function(O){return P[O]}.bind(null,L));return k},S.n=function(P){var v=P&&P.__esModule?function(){return P.default}:function(){return P};return S.d(v,"a",v),v},S.o=function(P,v){return Object.prototype.hasOwnProperty.call(P,v)},S.p="",S(S.s=0)}([function(Y,e,S){(function(P){var v;e=Y.exports=T,v=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var k=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,O=e.re=[],w=e.src=[],a=0,f=a++;w[f]="0|[1-9]\\d*";var c=a++;w[c]="[0-9]+";var m=a++;w[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=a++;w[d]="("+w[f]+")\\.("+w[f]+")\\.("+w[f]+")";var p=a++;w[p]="("+w[c]+")\\.("+w[c]+")\\.("+w[c]+")";var I=a++;w[I]="(?:"+w[f]+"|"+w[m]+")";var b=a++;w[b]="(?:"+w[c]+"|"+w[m]+")";var h=a++;w[h]="(?:-("+w[I]+"(?:\\."+w[I]+")*))";var g=a++;w[g]="(?:-?("+w[b]+"(?:\\."+w[b]+")*))";var R=a++;w[R]="[0-9A-Za-z-]+";var y=a++;w[y]="(?:\\+("+w[R]+"(?:\\."+w[R]+")*))";var i=a++,l="v?"+w[d]+w[h]+"?"+w[y]+"?";w[i]="^"+l+"$";var n="[v=\\s]*"+w[p]+w[g]+"?"+w[y]+"?",s=a++;w[s]="^"+n+"$";var t=a++;w[t]="((?:<|>)?=?)";var r=a++;w[r]=w[c]+"|x|X|\\*";var o=a++;w[o]=w[f]+"|x|X|\\*";var u=a++;w[u]="[v=\\s]*("+w[o]+")(?:\\.("+w[o]+")(?:\\.("+w[o]+")(?:"+w[h]+")?"+w[y]+"?)?)?";var $=a++;w[$]="[v=\\s]*("+w[r]+")(?:\\.("+w[r]+")(?:\\.("+w[r]+")(?:"+w[g]+")?"+w[y]+"?)?)?";var N=a++;w[N]="^"+w[t]+"\\s*"+w[u]+"$";var C=a++;w[C]="^"+w[t]+"\\s*"+w[$]+"$";var A=a++;w[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=a++;w[D]="(?:~>?)";var U=a++;w[U]="(\\s*)"+w[D]+"\\s+",O[U]=new RegExp(w[U],"g");var G=a++;w[G]="^"+w[D]+w[u]+"$";var Q=a++;w[Q]="^"+w[D]+w[$]+"$";var te=a++;w[te]="(?:\\^)";var ae=a++;w[ae]="(\\s*)"+w[te]+"\\s+",O[ae]=new RegExp(w[ae],"g");var le=a++;w[le]="^"+w[te]+w[u]+"$";var de=a++;w[de]="^"+w[te]+w[$]+"$";var H=a++;w[H]="^"+w[t]+"\\s*("+n+")$|^$";var Z=a++;w[Z]="^"+w[t]+"\\s*("+l+")$|^$";var B=a++;w[B]="(\\s*)"+w[t]+"\\s*("+n+"|"+w[u]+")",O[B]=new RegExp(w[B],"g");var M=a++;w[M]="^\\s*("+w[u]+")\\s+-\\s+("+w[u]+")\\s*$";var J=a++;w[J]="^\\s*("+w[$]+")\\s+-\\s+("+w[$]+")\\s*$";var K=a++;w[K]="(<|>)?=?\\s*\\*";for(var ie=0;ie<35;ie++)v(ie,w[ie]),O[ie]||(O[ie]=new RegExp(w[ie]));function se(V,_){if(V instanceof T)return V;if(typeof V!="string"||V.length>k||!(_?O[s]:O[i]).test(V))return null;try{return new T(V,_)}catch{return null}}function T(V,_){if(V instanceof T){if(V.loose===_)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>k)throw new TypeError("version is longer than "+k+" characters");if(!(this instanceof T))return new T(V,_);v("SemVer",V,_),this.loose=_;var ee=V.trim().match(_?O[s]:O[i]);if(!ee)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(we){if(/^[0-9]+$/.test(we)){var Se=+we;if(Se>=0&&Se<L)return Se}return we}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=se,e.valid=function(V,_){var ee=se(V,_);return ee?ee.version:null},e.clean=function(V,_){var ee=se(V.trim().replace(/^[=v]+/,""),_);return ee?ee.version:null},e.SemVer=T,T.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},T.prototype.toString=function(){return this.version},T.prototype.compare=function(V){return v("SemVer.compare",this.version,this.loose,V),V instanceof T||(V=new T(V,this.loose)),this.compareMain(V)||this.comparePre(V)},T.prototype.compareMain=function(V){return V instanceof T||(V=new T(V,this.loose)),z(this.major,V.major)||z(this.minor,V.minor)||z(this.patch,V.patch)},T.prototype.comparePre=function(V){if(V instanceof T||(V=new T(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var _=0;do{var ee=this.prerelease[_],we=V.prerelease[_];if(v("prerelease compare",_,ee,we),ee===void 0&&we===void 0)return 0;if(we===void 0)return 1;if(ee===void 0)return-1;if(ee!==we)return z(ee,we)}while(++_)},T.prototype.inc=function(V,_){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",_);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",_);break;case"prepatch":this.prerelease.length=0,this.inc("patch",_),this.inc("pre",_);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",_),this.inc("pre",_);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}_&&(this.prerelease[0]===_?isNaN(this.prerelease[1])&&(this.prerelease=[_,0]):this.prerelease=[_,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,_,ee,we){typeof ee=="string"&&(we=ee,ee=void 0);try{return new T(V,ee).inc(_,we).version}catch{return null}},e.diff=function(V,_){if(F(V,_))return null;var ee=se(V),we=se(_);if(ee.prerelease.length||we.prerelease.length){for(var Se in ee)if((Se==="major"||Se==="minor"||Se==="patch")&&ee[Se]!==we[Se])return"pre"+Se;return"prerelease"}for(var Se in ee)if((Se==="major"||Se==="minor"||Se==="patch")&&ee[Se]!==we[Se])return Se},e.compareIdentifiers=z;var W=/^[0-9]+$/;function z(V,_){var ee=W.test(V),we=W.test(_);return ee&&we&&(V=+V,_=+_),ee&&!we?-1:we&&!ee?1:V<_?-1:V>_?1:0}function E(V,_,ee){return new T(V,ee).compare(new T(_,ee))}function j(V,_,ee){return E(V,_,ee)>0}function X(V,_,ee){return E(V,_,ee)<0}function F(V,_,ee){return E(V,_,ee)===0}function q(V,_,ee){return E(V,_,ee)!==0}function x(V,_,ee){return E(V,_,ee)>=0}function ne(V,_,ee){return E(V,_,ee)<=0}function oe(V,_,ee,we){var Se;switch(_){case"===":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),Se=V===ee;break;case"!==":typeof V=="object"&&(V=V.version),typeof ee=="object"&&(ee=ee.version),Se=V!==ee;break;case"":case"=":case"==":Se=F(V,ee,we);break;case"!=":Se=q(V,ee,we);break;case">":Se=j(V,ee,we);break;case">=":Se=x(V,ee,we);break;case"<":Se=X(V,ee,we);break;case"<=":Se=ne(V,ee,we);break;default:throw new TypeError("Invalid operator: "+_)}return Se}function ce(V,_){if(V instanceof ce){if(V.loose===_)return V;V=V.value}if(!(this instanceof ce))return new ce(V,_);v("comparator",V,_),this.loose=_,this.parse(V),this.semver===ve?this.value="":this.value=this.operator+this.semver.version,v("comp",this)}e.rcompareIdentifiers=function(V,_){return z(_,V)},e.major=function(V,_){return new T(V,_).major},e.minor=function(V,_){return new T(V,_).minor},e.patch=function(V,_){return new T(V,_).patch},e.compare=E,e.compareLoose=function(V,_){return E(V,_,!0)},e.rcompare=function(V,_,ee){return E(_,V,ee)},e.sort=function(V,_){return V.sort(function(ee,we){return e.compare(ee,we,_)})},e.rsort=function(V,_){return V.sort(function(ee,we){return e.rcompare(ee,we,_)})},e.gt=j,e.lt=X,e.eq=F,e.neq=q,e.gte=x,e.lte=ne,e.cmp=oe,e.Comparator=ce;var ve={};function fe(V,_){if(V instanceof fe)return V.loose===_?V:new fe(V.raw,_);if(V instanceof ce)return new fe(V.value,_);if(!(this instanceof fe))return new fe(V,_);if(this.loose=_,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function $e(V){return!V||V.toLowerCase()==="x"||V==="*"}function pe(V,_,ee,we,Se,De,ke,Ce,Re,Le,qe,Ae,Te){return((_=$e(ee)?"":$e(we)?">="+ee+".0.0":$e(Se)?">="+ee+"."+we+".0":">="+_)+" "+(Ce=$e(Re)?"":$e(Le)?"<"+(+Re+1)+".0.0":$e(qe)?"<"+Re+"."+(+Le+1)+".0":Ae?"<="+Re+"."+Le+"."+qe+"-"+Ae:"<="+Ce)).trim()}function me(V,_){for(var ee=0;ee<V.length;ee++)if(!V[ee].test(_))return!1;if(_.prerelease.length){for(ee=0;ee<V.length;ee++)if(v(V[ee].semver),V[ee].semver!==ve&&V[ee].semver.prerelease.length>0){var we=V[ee].semver;if(we.major===_.major&&we.minor===_.minor&&we.patch===_.patch)return!0}return!1}return!0}function ge(V,_,ee){try{_=new fe(_,ee)}catch{return!1}return _.test(V)}function Ee(V,_,ee,we){var Se,De,ke,Ce,Re;switch(V=new T(V,we),_=new fe(_,we),ee){case">":Se=j,De=ne,ke=X,Ce=">",Re=">=";break;case"<":Se=X,De=x,ke=j,Ce="<",Re="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ge(V,_,we))return!1;for(var Le=0;Le<_.set.length;++Le){var qe=_.set[Le],Ae=null,Te=null;if(qe.forEach(function(Fe){Fe.semver===ve&&(Fe=new ce(">=0.0.0")),Ae=Ae||Fe,Te=Te||Fe,Se(Fe.semver,Ae.semver,we)?Ae=Fe:ke(Fe.semver,Te.semver,we)&&(Te=Fe)}),Ae.operator===Ce||Ae.operator===Re||(!Te.operator||Te.operator===Ce)&&De(V,Te.semver)||Te.operator===Re&&ke(V,Te.semver))return!1}return!0}ce.prototype.parse=function(V){var _=this.loose?O[H]:O[Z],ee=V.match(_);if(!ee)throw new TypeError("Invalid comparator: "+V);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new T(ee[2],this.loose):this.semver=ve},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(V){return v("Comparator.test",V,this.loose),this.semver===ve||(typeof V=="string"&&(V=new T(V,this.loose)),oe(V,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(V,_){if(!(V instanceof ce))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(V.value,_),ge(this.value,ee,_);if(V.operator==="")return ee=new fe(this.value,_),ge(V.semver,ee,_);var we=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),Ce=oe(this.semver,"<",V.semver,_)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Re=oe(this.semver,">",V.semver,_)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return we||Se||De&&ke||Ce||Re},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(V){var _=this.loose;V=V.trim(),v("range",V,_);var ee=_?O[J]:O[M];V=V.replace(ee,pe),v("hyphen replace",V),V=V.replace(O[B],"$1$2$3"),v("comparator trim",V,O[B]),V=(V=(V=V.replace(O[U],"$1~")).replace(O[ae],"$1^")).split(/\s+/).join(" ");var we=_?O[H]:O[Z],Se=V.split(" ").map(function(De){return function(ke,Ce){return v("comp",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(qe){return function(Ae,Te){v("caret",Ae,Te);var Fe=Te?O[de]:O[le];return Ae.replace(Fe,function(Ue,Pe,Ie,Oe,Ne){var je;return v("caret",Ae,Ue,Pe,Ie,Oe,Ne),$e(Pe)?je="":$e(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":$e(Oe)?je=Pe==="0"?">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+".0 <"+(+Pe+1)+".0.0":Ne?(v("replaceCaret pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+Ne+" <"+(+Pe+1)+".0.0"):(v("no pr"),je=Pe==="0"?Ie==="0"?">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+Ie+"."+(+Oe+1):">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0":">="+Pe+"."+Ie+"."+Oe+" <"+(+Pe+1)+".0.0"),v("caret return",je),je})}(qe,Le)}).join(" ")}(ke,Ce),v("caret",ke),ke=function(Re,Le){return Re.trim().split(/\s+/).map(function(qe){return function(Ae,Te){var Fe=Te?O[Q]:O[G];return Ae.replace(Fe,function(Ue,Pe,Ie,Oe,Ne){var je;return v("tilde",Ae,Ue,Pe,Ie,Oe,Ne),$e(Pe)?je="":$e(Ie)?je=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":$e(Oe)?je=">="+Pe+"."+Ie+".0 <"+Pe+"."+(+Ie+1)+".0":Ne?(v("replaceTilde pr",Ne),Ne.charAt(0)!=="-"&&(Ne="-"+Ne),je=">="+Pe+"."+Ie+"."+Oe+Ne+" <"+Pe+"."+(+Ie+1)+".0"):je=">="+Pe+"."+Ie+"."+Oe+" <"+Pe+"."+(+Ie+1)+".0",v("tilde return",je),je})}(qe,Le)}).join(" ")}(ke,Ce),v("tildes",ke),ke=function(Re,Le){return v("replaceXRanges",Re,Le),Re.split(/\s+/).map(function(qe){return function(Ae,Te){Ae=Ae.trim();var Fe=Te?O[C]:O[N];return Ae.replace(Fe,function(Ue,Pe,Ie,Oe,Ne,je){v("xRange",Ae,Ue,Pe,Ie,Oe,Ne,je);var Ve=$e(Ie),ze=Ve||$e(Oe),Be=ze||$e(Ne);return Pe==="="&&Be&&(Pe=""),Ve?Ue=Pe===">"||Pe==="<"?"<0.0.0":"*":Pe&&Be?(ze&&(Oe=0),Be&&(Ne=0),Pe===">"?(Pe=">=",ze?(Ie=+Ie+1,Oe=0,Ne=0):Be&&(Oe=+Oe+1,Ne=0)):Pe==="<="&&(Pe="<",ze?Ie=+Ie+1:Oe=+Oe+1),Ue=Pe+Ie+"."+Oe+"."+Ne):ze?Ue=">="+Ie+".0.0 <"+(+Ie+1)+".0.0":Be&&(Ue=">="+Ie+"."+Oe+".0 <"+Ie+"."+(+Oe+1)+".0"),v("xRange return",Ue),Ue})}(qe,Le)}).join(" ")}(ke,Ce),v("xrange",ke),ke=function(Re,Le){return v("replaceStars",Re,Le),Re.trim().replace(O[K],"")}(ke,Ce),v("stars",ke),ke}(De,_)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(De){return!!De.match(we)})),Se=Se.map(function(De){return new ce(De,_)})},fe.prototype.intersects=function(V,_){if(!(V instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(we){return V.set.some(function(Se){return Se.every(function(De){return we.intersects(De,_)})})})})},e.toComparators=function(V,_){return new fe(V,_).set.map(function(ee){return ee.map(function(we){return we.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new T(V,this.loose));for(var _=0;_<this.set.length;_++)if(me(this.set[_],V))return!0;return!1},e.satisfies=ge,e.maxSatisfying=function(V,_,ee){var we=null,Se=null;try{var De=new fe(_,ee)}catch{return null}return V.forEach(function(ke){De.test(ke)&&(we&&Se.compare(ke)!==-1||(Se=new T(we=ke,ee)))}),we},e.minSatisfying=function(V,_,ee){var we=null,Se=null;try{var De=new fe(_,ee)}catch{return null}return V.forEach(function(ke){De.test(ke)&&(we&&Se.compare(ke)!==1||(Se=new T(we=ke,ee)))}),we},e.validRange=function(V,_){try{return new fe(V,_).range||"*"}catch{return null}},e.ltr=function(V,_,ee){return Ee(V,_,"<",ee)},e.gtr=function(V,_,ee){return Ee(V,_,">",ee)},e.outside=Ee,e.prerelease=function(V,_){var ee=se(V,_);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(V,_,ee){return V=new fe(V,ee),_=new fe(_,ee),V.intersects(_)},e.coerce=function(V){if(V instanceof T)return V;if(typeof V!="string")return null;var _=V.match(O[A]);return _==null?null:se((_[1]||"0")+"."+(_[2]||"0")+"."+(_[3]||"0"))}}).call(this,S(1))},function(Y,e){var S,P,v=Y.exports={};function k(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function O(b){if(S===setTimeout)return setTimeout(b,0);if((S===k||!S)&&setTimeout)return S=setTimeout,setTimeout(b,0);try{return S(b,0)}catch{try{return S.call(null,b,0)}catch{return S.call(this,b,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:k}catch{S=k}try{P=typeof clearTimeout=="function"?clearTimeout:L}catch{P=L}})();var w,a=[],f=!1,c=-1;function m(){f&&w&&(f=!1,w.length?a=w.concat(a):c=-1,a.length&&d())}function d(){if(!f){var b=O(m);f=!0;for(var h=a.length;h;){for(w=a,a=[];++c<h;)w&&w[c].run();c=-1,h=a.length}w=null,f=!1,function(g){if(P===clearTimeout)return clearTimeout(g);if((P===L||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(g);try{P(g)}catch{try{return P.call(null,g)}catch{return P.call(this,g)}}}(b)}}function p(b,h){this.fun=b,this.array=h}function I(){}v.nextTick=function(b){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];a.push(new p(b,h)),a.length!==1||f||O(d)},p.prototype.run=function(){this.fun.apply(null,this.array)},v.title="browser",v.browser=!0,v.env={},v.argv=[],v.version="",v.versions={},v.on=I,v.addListener=I,v.once=I,v.off=I,v.removeListener=I,v.removeAllListeners=I,v.emit=I,v.prependListener=I,v.prependOnceListener=I,v.listeners=function(b){return[]},v.binding=function(b){throw new Error("process.binding is not supported")},v.cwd=function(){return"/"},v.chdir=function(b){throw new Error("process.chdir is not supported")},v.umask=function(){return 0}}])}),define(ue[80],he([0,1]),function(Y,e){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ss=void 0;class P{constructor(O,w,a){this.level=O,this.key=w,this.value=a,this.forward=[]}}const v=void 0;class k{constructor(O,w=2**16){this.comparator=O,this[S]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(w)|0),this.e=new P(this.c,v,v)}get size(){return this.f}clear(){this.e=new P(this.c,v,v),this.f=0}has(O){return!!k.g(this,O,this.comparator)}get(O){return k.g(this,O,this.comparator)?.value}set(O,w){return k.h(this,O,w,this.comparator)&&(this.f+=1),this}delete(O){const w=k.k(this,O,this.comparator);return w&&(this.f-=1),w}forEach(O,w){let a=this.e.forward[0];for(;a;)O.call(w,a.value,a.key,this),a=a.forward[0]}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let O=this.e.forward[0];for(;O;)yield[O.key,O.value],O=O.forward[0]}*keys(){let O=this.e.forward[0];for(;O;)yield O.key,O=O.forward[0]}*values(){let O=this.e.forward[0];for(;O;)yield O.value,O=O.forward[0]}toString(){let O="[SkipList]:",w=this.e.forward[0];for(;w;)O+=`node(${w.key}, ${w.value}, lvl:${w.level})`,w=w.forward[0];return O}static g(O,w,a){let f=O.e;for(let c=O.d-1;c>=0;c--)for(;f.forward[c]&&a(f.forward[c].key,w)<0;)f=f.forward[c];if(f=f.forward[0],f&&a(f.key,w)===0)return f}static h(O,w,a,f){const c=[];let m=O.e;for(let d=O.d-1;d>=0;d--){for(;m.forward[d]&&f(m.forward[d].key,w)<0;)m=m.forward[d];c[d]=m}if(m=m.forward[0],m&&f(m.key,w)===0)return m.value=a,!1;{const d=k.j(O);if(d>O.d){for(let p=O.d;p<d;p++)c[p]=O.e;O.d=d}m=new P(d,w,a);for(let p=0;p<d;p++)m.forward[p]=c[p].forward[p],c[p].forward[p]=m;return!0}}static j(O,w=.5){let a=1;for(;Math.random()<w&&a<O.c;)a+=1;return a}static k(O,w,a){const f=[];let c=O.e;for(let m=O.d-1;m>=0;m--){for(;c.forward[m]&&a(c.forward[m].key,w)<0;)c=c.forward[m];f[m]=c}if(c=c.forward[0],!c||a(c.key,w)!==0)return!1;for(let m=0;m<O.d&&f[m].forward[m]===c;m++)f[m].forward[m]=c.forward[m];for(;O.d>0&&O.e.forward[O.d-1]===v;)O.d-=1;return!0}}e.$Ss=k}),define(ue[47],he([0,1,7,2]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=v,e.$ze=k,e.$Ae=L,e.$Be=O,e.$Ce=a,e.$De=f,e.$Ee=c,e.$Fe=m,e.$Ge=d,e.$He=p,e.$Ie=I,e.$Je=b,e.$Ke=h,e.$Le=g,e.$Me=R;function v(y){const i=y;return i?typeof i.read=="function":!1}function k(y){const i=y;return i?[i.on,i.pause,i.resume,i.destroy].every(l=>typeof l=="function"):!1}function L(y){const i=y;return i?k(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function O(y,i){return new w(y,i)}class w{constructor(i,l){this.e=i,this.f=l,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(l=>this.d.push(l))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(l=>l(i))}h(i){this.c.error.length===0?(0,S.$Y)(i):this.c.error.slice(0).forEach(l=>l(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,l){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(l),this.resume();break;case"end":this.c.end.push(l),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(l),this.a.flowing&&this.k();break}}removeListener(i,l){if(this.a.destroyed)return;let n;switch(i){case"data":n=this.c.data;break;case"end":n=this.c.end;break;case"error":n=this.c.error;break}if(n){const s=n.indexOf(l);s>=0&&n.splice(s,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const l=[...this.d];this.d.length=0,l.forEach(n=>n())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(y,i){const l=[];let n;for(;(n=y.read())!==null;)l.push(n);return i(l)}function f(y,i,l){const n=[];let s;for(;(s=y.read())!==null&&n.length<l;)n.push(s);return s===null&&n.length>0?i(n):{read:()=>{if(n.length>0)return n.shift();if(typeof s<"u"){const t=s;return s=void 0,t}return y.read()}}}function c(y,i){return new Promise((l,n)=>{const s=[];m(y,{onData:t=>{i&&s.push(t)},onError:t=>{i?n(t):l(void 0)},onEnd:()=>{l(i?i(s):void 0)}})})}function m(y,i,l){y.on("error",n=>{l?.isCancellationRequested||i.onError(n)}),y.on("end",()=>{l?.isCancellationRequested||i.onEnd()}),y.on("data",n=>{l?.isCancellationRequested||i.onData(n)})}function d(y,i){return new Promise((l,n)=>{const s=new P.$Tc,t=[],r=$=>{if(t.push($),t.length>i)return s.dispose(),y.pause(),l({stream:y,buffer:t,ended:!1})},o=$=>(s.dispose(),n($)),u=()=>(s.dispose(),l({stream:y,buffer:t,ended:!0}));s.add((0,P.$Sc)(()=>y.removeListener("error",o))),y.on("error",o),s.add((0,P.$Sc)(()=>y.removeListener("end",u))),y.on("end",u),s.add((0,P.$Sc)(()=>y.removeListener("data",r))),y.on("data",r)})}function p(y,i){const l=O(i);return l.end(y),l}function I(){const y=O(()=>{throw new Error("not supported")});return y.end(),y}function b(y){let i=!1;return{read:()=>i?null:(i=!0,y)}}function h(y,i,l){const n=O(l);return m(y,{onData:s=>n.write(i.data(s)),onError:s=>n.error(i.error?i.error(s):s),onEnd:()=>n.end()}),n}function g(y,i,l){let n=!1;return{read:()=>{const s=i.read();return n?s:(n=!0,s!==null?l([y,s]):y)}}}function R(y,i,l){let n=!1;const s=O(l);return m(i,{onData:t=>n?s.write(t):(n=!0,s.write(l([y,t]))),onError:t=>s.error(t),onEnd:()=>{n||(n=!0,s.write(y)),s.end()}}),s}});var We=this&&this.__createBinding||(Object.create?function(Y,e,S,P){P===void 0&&(P=S);var v=Object.getOwnPropertyDescriptor(e,S);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[S]}}),Object.defineProperty(Y,P,v)}:function(Y,e,S,P){P===void 0&&(P=S),Y[P]=e[S]}),xe=this&&this.__setModuleDefault||(Object.create?function(Y,e){Object.defineProperty(Y,"default",{enumerable:!0,value:e})}:function(Y,e){Y.default=e}),ye=this&&this.__importStar||function(Y){if(Y&&Y.__esModule)return Y;var e={};if(Y!=null)for(var S in Y)S!=="default"&&Object.prototype.hasOwnProperty.call(Y,S)&&We(e,Y,S);return xe(e,Y),e};define(ue[13],he([0,1,146,47]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=a,e.$Pe=f,e.$Qe=c,e.$Re=m,e.$Se=d,e.$Te=p,e.$Ue=I,e.$Ve=b,e.$We=h,e.$Xe=g,e.$Ye=R,e.$Ze=y,e.$1e=i,e.$2e=l,e.$3e=n,e.$4e=s,e.$5e=t,e.$6e=r,e.$7e=o,e.$8e=N,P=ye(P);const v=typeof Buffer<"u",k=new S.$T(()=>new Uint8Array(256));let L,O;class w{static alloc(A){return v?new w(Buffer.allocUnsafe(A)):new w(new Uint8Array(A))}static wrap(A){return v&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new w(A)}static fromString(A,D){return!(D?.dontUseNodeBuffer||!1)&&v?new w(Buffer.from(A)):(L||(L=new TextEncoder),new w(L.encode(A)))}static fromByteArray(A){const D=w.alloc(A.length);for(let U=0,G=A.length;U<G;U++)D.buffer[U]=A[U];return D}static concat(A,D){if(typeof D>"u"){D=0;for(let Q=0,te=A.length;Q<te;Q++)D+=A[Q].byteLength}const U=w.alloc(D);let G=0;for(let Q=0,te=A.length;Q<te;Q++){const ae=A[Q];U.set(ae,G),G+=ae.byteLength}return U}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=w.alloc(this.byteLength);return A.set(this),A}toString(){return v?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(A,D){return new w(this.buffer.subarray(A,D))}set(A,D){if(A instanceof w)this.buffer.set(A.buffer,D);else if(A instanceof Uint8Array)this.buffer.set(A,D);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),D);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),D);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return m(this.buffer,A)}writeUInt32BE(A,D){d(this.buffer,A,D)}readUInt32LE(A){return p(this.buffer,A)}writeUInt32LE(A,D){I(this.buffer,A,D)}readUInt8(A){return b(this.buffer,A)}writeUInt8(A,D){h(this.buffer,A,D)}indexOf(A,D=0){return a(this.buffer,A instanceof w?A.buffer:A,D)}}e.$Ne=w;function a(C,A,D=0){const U=A.byteLength,G=C.byteLength;if(U===0)return 0;if(U===1)return C.indexOf(A[0]);if(U>G-D)return-1;const Q=k.value;Q.fill(A.length);for(let de=0;de<A.length;de++)Q[A[de]]=A.length-de-1;let te=D+A.length-1,ae=te,le=-1;for(;te<G;)if(C[te]===A[ae]){if(ae===0){le=te;break}te--,ae--}else te+=Math.max(A.length-ae,Q[C[te]]),ae=A.length-1;return le}function f(C,A){return C[A+0]<<0>>>0|C[A+1]<<8>>>0}function c(C,A,D){C[D+0]=A&255,A=A>>>8,C[D+1]=A&255}function m(C,A){return C[A]*2**24+C[A+1]*2**16+C[A+2]*2**8+C[A+3]}function d(C,A,D){C[D+3]=A,A=A>>>8,C[D+2]=A,A=A>>>8,C[D+1]=A,A=A>>>8,C[D]=A}function p(C,A){return C[A+0]<<0>>>0|C[A+1]<<8>>>0|C[A+2]<<16>>>0|C[A+3]<<24>>>0}function I(C,A,D){C[D+0]=A&255,A=A>>>8,C[D+1]=A&255,A=A>>>8,C[D+2]=A&255,A=A>>>8,C[D+3]=A&255}function b(C,A){return C[A]}function h(C,A,D){C[D]=A}function g(C){return P.$Ce(C,A=>w.concat(A))}function R(C){return P.$Je(C)}function y(C){return P.$Ee(C,A=>w.concat(A))}async function i(C){return C.ended?w.concat(C.buffer):w.concat([...C.buffer,await y(C.stream)])}function l(C){return P.$He(C,A=>w.concat(A))}function n(C){return P.$Ke(C,{data:A=>typeof A=="string"?w.fromString(A):w.wrap(A)},A=>w.concat(A))}function s(C){return P.$Be(A=>w.concat(A),C)}function t(C,A){return P.$Le(C,A,D=>w.concat(D))}function r(C,A){return P.$Me(C,A,D=>w.concat(D))}function o(C){let A=0,D=0,U=0;const G=new Uint8Array(Math.floor(C.length/4*3)),Q=ae=>{switch(D){case 3:G[U++]=A|ae,D=0;break;case 2:G[U++]=A|ae>>>2,A=ae<<6,D=3;break;case 1:G[U++]=A|ae>>>4,A=ae<<4,D=2;break;default:A=ae<<2,D=1}};for(let ae=0;ae<C.length;ae++){const le=C.charCodeAt(ae);if(le>=65&&le<=90)Q(le-65);else if(le>=97&&le<=122)Q(le-97+26);else if(le>=48&&le<=57)Q(le-48+52);else if(le===43||le===45)Q(62);else if(le===47||le===95)Q(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${C[ae]}`)}}const te=U;for(;D>0;)Q(0);return w.wrap(G).slice(0,te)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",$="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function N({buffer:C},A=!0,D=!1){const U=D?$:u;let G="";const Q=C.byteLength%3;let te=0;for(;te<C.byteLength-Q;te+=3){const ae=C[te+0],le=C[te+1],de=C[te+2];G+=U[ae>>>2],G+=U[(ae<<4|le>>>4)&63],G+=U[(le<<2|de>>>6)&63],G+=U[de&63]}if(Q===1){const ae=C[te+0];G+=U[ae>>>2],G+=U[ae<<4&63],A&&(G+="==")}else if(Q===2){const ae=C[te+0],le=C[te+1];G+=U[ae>>>2],G+=U[(ae<<4|le>>>4)&63],G+=U[le<<2&63],A&&(G+="=")}return G}}),define(ue[27],he([0,1,3]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=P,e.$eo=v,e.$fo=L,e.$go=w,e.$ho=a,e.$io=f,e.$jo=c,e.$ko=m,e.$lo=d,e.$mo=p,e.$no=I,e.$oo=b,e.$po=h;function P(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const R=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([y,i])=>{R[y]=i&&typeof i=="object"?P(i):i}),R}function v(g){if(!g||typeof g!="object")return g;const R=[g];for(;R.length>0;){const y=R.shift();Object.freeze(y);for(const i in y)if(k.call(y,i)){const l=y[i];typeof l=="object"&&!Object.isFrozen(l)&&!(0,S.$hg)(l)&&R.push(l)}}return g}const k=Object.prototype.hasOwnProperty;function L(g,R){return O(g,R,new Set)}function O(g,R,y){if((0,S.$ng)(g))return g;const i=R(g);if(typeof i<"u")return i;if(Array.isArray(g)){const l=[];for(const n of g)l.push(O(n,R,y));return l}if((0,S.$gg)(g)){if(y.has(g))throw new Error("Cannot clone recursive data-structure");y.add(g);const l={};for(const n in g)k.call(g,n)&&(l[n]=O(g[n],R,y));return y.delete(g),l}return g}function w(g,R,y=!0){return(0,S.$gg)(g)?((0,S.$gg)(R)&&Object.keys(R).forEach(i=>{i in g?y&&((0,S.$gg)(g[i])&&(0,S.$gg)(R[i])?w(g[i],R[i],y):g[i]=R[i]):g[i]=R[i]}),g):R}function a(g,R){if(g===R)return!0;if(g==null||R===null||R===void 0||typeof g!=typeof R||typeof g!="object"||Array.isArray(g)!==Array.isArray(R))return!1;let y,i;if(Array.isArray(g)){if(g.length!==R.length)return!1;for(y=0;y<g.length;y++)if(!a(g[y],R[y]))return!1}else{const l=[];for(i in g)l.push(i);l.sort();const n=[];for(i in R)n.push(i);if(n.sort(),!a(l,n))return!1;for(y=0;y<l.length;y++)if(!a(g[l[y]],R[l[y]]))return!1}return!0}function f(g){const R=new Set;return JSON.stringify(g,(y,i)=>{if((0,S.$gg)(i)||Array.isArray(i)){if(R.has(i))return"[Circular]";R.add(i)}return typeof i=="bigint"?`[BigInt ${i.toString()}]`:i})}function c(g,R){const y=Object.create(null);return!g||!R||Object.keys(R).forEach(l=>{const n=g[l],s=R[l];a(n,s)||(y[l]=s)}),y}function m(g,R){const y=R.toLowerCase(),i=Object.keys(g).find(l=>l.toLowerCase()===y);return i?g[i]:g[R]}function d(g,R){const y=Object.create(null);for(const[i,l]of Object.entries(g))R(i,l)&&(y[i]=l);return y}function p(g){let R=[];for(;Object.prototype!==g;)R=R.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return R}function I(g){const R=[];for(const y of p(g))typeof g[y]=="function"&&R.push(y);return R}function b(g,R){const y=l=>function(){const n=Array.prototype.slice.call(arguments,0);return R(l,n)},i={};for(const l of g)i[l]=y(l);return i}function h(g,R){const y={};for(const[i,l]of Object.entries(g))y[i]=R(l,i);return y}}),define(ue[43],he([0,1,31]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$wj=void 0,e.$sj=P,e.$tj=v,e.$uj=k,e.$vj=O,e.$xj=I,S=ye(S);function P(h){return v(h,0)}function v(h,g){switch(typeof h){case"object":return h===null?k(349,g):Array.isArray(h)?w(h,g):a(h,g);case"string":return O(h,g);case"boolean":return L(h,g);case"number":return k(h,g);case"undefined":return k(937,g);default:return k(617,g)}}function k(h,g){return(g<<5)-g+h|0}function L(h,g){return k(h?433:863,g)}function O(h,g){g=k(149417,g);for(let R=0,y=h.length;R<y;R++)g=k(h.charCodeAt(R),g);return g}function w(h,g){return g=k(104579,g),h.reduce((R,y)=>v(y,R),g)}function a(h,g){return g=k(181387,g),Object.keys(h).sort().reduce((R,y)=>(R=O(y,R),v(h[y],R)),g)}class f{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=v(g,this.g),this.g}}e.$wj=f;var c;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(c||(c={}));function m(h,g,R=32){const y=R-g,i=~((1<<y)-1);return(h<<g|(i&h)>>>y)>>>0}function d(h,g=0,R=h.byteLength,y=0){for(let i=0;i<R;i++)h[g+i]=y}function p(h,g,R="0"){for(;h.length<g;)h=R+h;return h}function I(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(R=>R.toString(16).padStart(2,"0")).join(""):p((h>>>0).toString(16),g/4)}class b{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(c.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const R=g.length;if(R===0)return;const y=this.p;let i=this.r,l=this.u,n,s;for(l!==0?(n=l,s=-1,l=0):(n=g.charCodeAt(0),s=0);;){let t=n;if(S.$Jf(n))if(s+1<R){const r=g.charCodeAt(s+1);S.$Kf(r)?(s++,t=S.$Lf(n,r)):t=c.UNICODE_REPLACEMENT}else{l=n;break}else S.$Kf(n)&&(t=c.UNICODE_REPLACEMENT);if(i=this.w(y,i,t),s++,s<R)n=g.charCodeAt(s);else break}this.r=i,this.u=l}w(g,R,y){return y<128?g[R++]=y:y<2048?(g[R++]=192|(y&1984)>>>6,g[R++]=128|(y&63)>>>0):y<65536?(g[R++]=224|(y&61440)>>>12,g[R++]=128|(y&4032)>>>6,g[R++]=128|(y&63)>>>0):(g[R++]=240|(y&1835008)>>>18,g[R++]=128|(y&258048)>>>12,g[R++]=128|(y&4032)>>>6,g[R++]=128|(y&63)>>>0),R>=c.BLOCK_SIZE&&(this.y(),R-=c.BLOCK_SIZE,this.t+=c.BLOCK_SIZE,g[0]=g[c.BLOCK_SIZE+0],g[1]=g[c.BLOCK_SIZE+1],g[2]=g[c.BLOCK_SIZE+2]),R}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,c.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),I(this.h)+I(this.l)+I(this.m)+I(this.n)+I(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=b.g,R=this.q;for(let u=0;u<64;u+=4)g.setUint32(u,R.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)g.setUint32(u,m(g.getUint32(u-12,!1)^g.getUint32(u-32,!1)^g.getUint32(u-56,!1)^g.getUint32(u-64,!1),1),!1);let y=this.h,i=this.l,l=this.m,n=this.n,s=this.o,t,r,o;for(let u=0;u<80;u++)u<20?(t=i&l|~i&n,r=1518500249):u<40?(t=i^l^n,r=1859775393):u<60?(t=i&l|i&n|l&n,r=2400959708):(t=i^l^n,r=3395469782),o=m(y,5)+t+s+r+g.getUint32(u*4,!1)&4294967295,s=n,n=l,l=m(i,30),i=y,y=o;this.h=this.h+y&4294967295,this.l=this.l+i&4294967295,this.m=this.m+l&4294967295,this.n=this.n+n&4294967295,this.o=this.o+s&4294967295}}e.$yj=b}),define(ue[57],he([0,1,31]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),S=ye(S);var P;(function(v){v[v.Ignore=0]="Ignore",v[v.Info=1]="Info",v[v.Warning=2]="Warning",v[v.Error=3]="Error"})(P||(P={})),function(v){const k="error",L="warning",O="warn",w="info",a="ignore";function f(m){return m?S.$Ff(k,m)?v.Error:S.$Ff(L,m)||S.$Ff(O,m)?v.Warning:S.$Ff(w,m)?v.Info:v.Ignore:v.Ignore}v.fromValue=f;function c(m){switch(m){case v.Error:return k;case v.Warning:return L;case v.Info:return w;default:return a}}v.toString=c}(P||(P={})),e.default=P}),define(ue[81],he([0,1,11]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=P,e.$dr=v,e.$er=k,e.log=O;function P(a){const f=a;return f&&typeof f.type=="string"&&typeof f.severity=="string"}function v(a){const f=[];let c;try{const m=JSON.parse(a.arguments),d=m[m.length-1];d&&d.__$stack&&(m.pop(),c=d.__$stack),f.push(...m)}catch{f.push("Unable to log remote console arguments",a.arguments)}return{args:f,stack:c}}function k(a){if(typeof a!="string")return k(v(a).stack);const f=a;if(f){const c=L(f),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(c||"");if(m&&m.length===4)return{uri:S.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}function L(a){if(!a)return a;const f=a.indexOf(`
`);return f===-1?a:a.substring(0,f)}function O(a,f){const{args:c,stack:m}=v(a),d=typeof c[0]=="string"&&c.length===1;let p=L(m);p&&(p=`(${p.trim()})`);let I=[];if(typeof c[0]=="string"?p&&d?I=[`%c[${f}] %c${c[0]} %c${p}`,w("blue"),w(""),w("grey")]:I=[`%c[${f}] %c${c[0]}`,w("blue"),w(""),...c.slice(1)]:I=[`%c[${f}]%`,w("blue"),...c],p&&!d&&I.push(p),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,I)}function w(a){return`color: ${a}`}}),define(ue[48],he([0,1,13,11,147]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=k,e.$ai=L,e.$bi=w;function k(a){return JSON.stringify(a,O)}function L(a){let f=JSON.parse(a);return f=w(f),f}function O(a,f){return f instanceof RegExp?{$mid:v.MarshalledId.Regexp,source:f.source,flags:f.flags}:f}function w(a,f=0){if(!a||f>200)return a;if(typeof a=="object"){switch(a.$mid){case v.MarshalledId.Uri:return P.URI.revive(a);case v.MarshalledId.Regexp:return new RegExp(a.source,a.flags);case v.MarshalledId.Date:return new Date(a.source)}if(a instanceof S.$Ne||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let c=0;c<a.length;++c)a[c]=w(a[c],f+1);else for(const c in a)Object.hasOwnProperty.call(a,c)&&(a[c]=w(a[c],f+1))}return a}}),define(ue[82],he([0,1,74,14,12,3,11]),function(Y,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BE=c,e.$CE=m,v=ye(v);class O{constructor(p,I,b){this.id=p,this.dependencies=I,this.callback=b}}class w{static{this.INSTANCE=new w}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,I,b)=>{typeof p!="string"&&(b=I,I=p,p=null),(typeof I!="object"||!Array.isArray(I))&&(b=I,I=null),this.c.push(new O(p,I,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const I=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!I)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(I.dependencies)&&I.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${I.dependencies.join(", ")}`);return typeof I.callback=="function"?I.callback([]):I.callback}h(p){return new Promise((I,b)=>{const h=document.createElement("script");h.setAttribute("async","async"),h.setAttribute("type","text/javascript");const g=()=>{h.removeEventListener("load",R),h.removeEventListener("error",y)},R=i=>{g(),I(this.c.pop())},y=i=>{g(),b(i)};h.addEventListener("load",R),h.addEventListener("error",y),this.f&&(p=this.f.createScriptURL(p)),h.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(h)})}i(p){return new Promise((I,b)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),I(this.c.pop())}catch(h){b(h)}})}async j(p){try{const I=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,h=globalThis._VSCODE_NODE_MODULES.module,g=L.URI.parse(p).fsPath,R=I.readFileSync(g).toString(),y=h.wrap(R.replace(/^#!.*/,""));return new b.Script(y).runInThisContext().apply(),this.c.pop()}catch(I){throw I}}}const a=new Map;let f={};typeof globalThis.require=="object"&&(f=globalThis.require.paths??{});async function c(d,p,I){if(S.$R){I===void 0&&(I=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),f[d]&&(d=f[d]);const b=p?`${d}/${p}`:d;if(a.has(b))return a.get(b);let h;if(/^\w[\w\d+.-]*:\/\//.test(b))h=b;else{const i=`${I&&!v.$p?P.$Vg:P.$Ug}/${b}`;h=P.$Yg.asBrowserUri(i).toString(!0)}const g=w.INSTANCE.load(h);return a.set(b,g),g}else return await new Promise((b,h)=>{Y([d],b,h)}).then(ye)}function m(d,p){(0,k.$og)(S.$R);const h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit&&!v.$p,g=`${d}/${p}`,y=`${h?P.$Vg:P.$Ug}/${g}`;return P.$Yg.asBrowserUri(y).toString(!0)}}),define(ue[28],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=P;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(v){return S.test(v)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let v;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?v=crypto.getRandomValues.bind(crypto):v=function(O){for(let w=0;w<O.length;w++)O[w]=Math.floor(Math.random()*256);return O};const k=new Uint8Array(16),L=[];for(let O=0;O<256;O++)L.push(O.toString(16).padStart(2,"0"));return function(){v(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let w=0,a="";return a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+="-",a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a+=L[k[w++]],a}}()}),define(ue[83],he([0,1,35]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=k;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function v(L){const O=L.replace(/\-/g,":").toLowerCase();return!P.has(O)}function k(){const L=(0,S.networkInterfaces)();for(const O in L){const w=L[O];if(w){for(const{mac:a}of w)if(v(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ue[84],he([0,1,35,49,28,83,12]),function(Y,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rn=void 0,e.$Sn=w,e.$Tn=c,e.$Un=m,v=ye(v),e.$Rn=new class{c(d){return this.a||(this.a=P.$Ki.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(d)}value(){if(this.b===void 0){let d=0,p=0;const I=(0,S.networkInterfaces)();for(const b in I){const h=I[b];if(h)for(const{mac:g,internal:R}of h)R||(p+=1,this.c(g.toUpperCase())&&(d+=1))}this.b=p>0?d/p:0}return this.b}};let O;async function w(d){return O||(O=(async()=>await a(d)||v.$1g())()),O}async function a(d){try{const p=await new Promise((b,h)=>{Y(["crypto"],b,h)}).then(ye),I=(0,k.$Qn)();return p.createHash("sha256").update(I,"utf8").digest("hex")}catch(p){d(p);return}}const f="Software\\Microsoft\\SQMClient";async function c(d){if(L.$j){const p=await new Promise((I,b)=>{Y(["@vscode/windows-registry"],I,b)}).then(ye);try{return p.GetStringRegKey("HKEY_LOCAL_MACHINE",f,"MachineId")||""}catch(I){return d(I),""}}return""}async function m(d){try{return await(await new Promise((b,h)=>{Y(["@vscode/deviceid"],b,h)}).then(ye)).getDeviceId()}catch(p){return d(p),""}}}),define(ue[85],he([0,1,35,15,29]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=g,e.$wm=R,S=ye(S),P=ye(P),v=ye(v);const k=/^\d+$/,L=/^Microsoft.PowerShell_.*/,O=/^Microsoft.PowerShellPreview_.*/;var w;(function(y){y[y.x64=0]="x64",y[y.x86=1]="x86",y[y.ARM=2]="ARM"})(w||(w={}));let a;switch(process.arch){case"ia32":a=w.x86;break;case"arm":case"arm64":a=w.ARM;break;default:a=w.x64;break}let f;process.env.PROCESSOR_ARCHITEW6432?f=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?w.ARM:w.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?f=w.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?f=w.x86:f=w.x64;class c{constructor(i,l,n){this.exePath=i,this.displayName=l,this.a=n}async exists(){return this.a===void 0&&(this.a=await v.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:y=!1}={}){return y?a===w.x64?process.env["ProgramFiles(x86)"]||null:f===w.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:y=!1,findPreview:i=!1}={}){const l=m({useAlternateBitness:y});if(!l)return null;const n=P.$jc(l,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(n))return null;let s=-1,t=null;for(const u of await v.Promises.readdir(n)){let $=-1;if(i){const C=u.indexOf("-");if(C<0)continue;const A=u.substring(0,C);if(!k.test(A)||u.substring(C+1)!=="preview")continue;$=parseInt(A,10)}else{if(!k.test(u))continue;$=parseInt(u,10)}if($<=s)continue;const N=P.$jc(n,u,"pwsh.exe");await v.SymlinkSupport.existsFile(N)&&(t=N,s=$)}if(!t)return null;const r=l.includes("x86")?" (x86)":"",o=i?" Preview":"";return new c(t,`PowerShell${o}${r}`,!0)}async function p({findPreview:y}={}){if(!process.env.LOCALAPPDATA)return null;const i=P.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:l,pwshMsixName:n}=y?{pwshMsixDirRegex:O,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:L,pwshMsixName:"PowerShell (Store)"};for(const s of await v.Promises.readdir(i))if(l.test(s)){const t=P.$jc(i,s,"pwsh.exe");return new c(t,n)}return null}function I(){const y=P.$jc(S.homedir(),".dotnet","tools","pwsh.exe");return new c(y,".NET Core PowerShell Global Tool")}function b(){const y=P.$jc(process.env.windir,a===w.x86&&f!==w.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new c(y,"Windows PowerShell",!0)}async function*h(){let y=await d();y&&(yield y),y=await d({useAlternateBitness:!0}),y&&(yield y),y=await p(),y&&(yield y),y=I(),y&&(yield y),y=await d({findPreview:!0}),y&&(yield y),y=await p({findPreview:!0}),y&&(yield y),y=await d({useAlternateBitness:!0,findPreview:!0}),y&&(yield y),y=b(),y&&(yield y)}async function*g(){for await(const y of h())await y.exists()&&(yield y)}async function R(){for await(const y of g())return y;return null}}),define(ue[58],he([0,1,32,15,12,36,56,3,29]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=a,e.$ym=f,P=ye(P),v=ye(v),k=ye(k),O=ye(O),w=ye(w),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function a(m=k.env){return m.comspec||"cmd.exe"}function f(m){let d=[],p=!1;const I=function(b){if(p){d.push(b);return}(!m.send(b,g=>{if(g&&console.error(g),p=!1,d.length>0){const R=d.slice(0);d=[],R.forEach(y=>I(y))}})||v.$j)&&(p=!0)};return{send:I}}var c;(function(m){async function d(p,I,b){if(P.$ic(p))return p;if(I===void 0&&(I=k.cwd()),P.$mc(p)!=="."||(b===void 0&&O.$eg(k.env.PATH)&&(b=k.env.PATH.split(P.$tc)),b===void 0||b.length===0))return P.$jc(I,p);async function g(R){if(await w.Promises.exists(R)){let y;try{y=await S.promises.stat(R)}catch(i){i.message.startsWith("EACCES")&&(y=await S.promises.lstat(R))}return y?!y.isDirectory():!1}return!1}for(const R of b){let y;if(P.$ic(R)?y=P.$jc(R,p):y=P.$jc(I,R,p),await g(y))return y;let i=y+".com";if(await g(i)||(i=y+".exe",await g(i)))return i}return P.$jc(I,p)}m.findExecutable=d})(c||(e.win32=c={}))}),define(ue[86],he([0,1,35,12,85,58]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=L,P=ye(P),k=ye(k);async function L(c,m){return c===P.OperatingSystem.Windows?P.$j?f():k.$xm(m):w(c,m)}let O=null;function w(c,m){if(P.$l&&c===P.OperatingSystem.Macintosh||P.$k&&c===P.OperatingSystem.Linux)return"/bin/bash";if(!O){let d;if(P.$j)d="/bin/bash";else{if(d=m.SHELL,!d)try{d=(0,S.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}O=d}return O}let a=null;async function f(){return a||(a=(await(0,v.$wm)()).exePath),a}});var be=this&&this.__decorate||function(Y,e,S,P){var v=arguments.length,k=v<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,S):P,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")k=Reflect.decorate(Y,e,S,P);else for(var O=Y.length-1;O>=0;O--)(L=Y[O])&&(k=(v<3?L(k):v>3?L(e,S,k):L(e,S))||k);return v>3&&k&&Object.defineProperty(e,S,k),k};define(ue[59],he([0,1,19,8,13,21,55,7,4,2,48,31,3]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.ProxyChannel=e.$mi=e.$ji=e.$ii=e.$hi=e.RequestInitiator=e.$gi=e.$di=e.$ci=void 0,e.$ei=o,e.$fi=u,e.$ki=U,e.$li=G,c=ye(c);var d;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(d||(d={}));function p(B){switch(B){case d.Promise:return"req";case d.PromiseCancel:return"cancel";case d.EventListen:return"subscribe";case d.EventDispose:return"unsubscribe"}}var I;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(I||(I={}));function b(B){switch(B){case I.Initialize:return"init";case I.PromiseSuccess:return"reply:";case I.PromiseError:case I.PromiseErrorObj:return"replyErr:";case I.EventFire:return"event:"}}var h;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(h||(h={}));function g(B){let M=0;for(let J=0;;J+=7){const K=B.read(1);if(M|=(K.buffer[0]&127)<<J,!(K.buffer[0]&128))return M}}const R=s(0);function y(B,M){if(M===0){B.write(R);return}let J=0;for(let ie=M;ie!==0;ie=ie>>>7)J++;const K=v.$Ne.alloc(J);for(let ie=0;M!==0;ie++)K.buffer[ie]=M&127,M=M>>>7,M>0&&(K.buffer[ie]|=128);B.write(K)}class i{constructor(M){this.b=M,this.a=0}read(M){const J=this.b.slice(this.a,this.a+M);return this.a+=J.byteLength,J}}e.$ci=i;class l{constructor(){this.a=[]}get buffer(){return v.$Ne.concat(this.a)}write(M){this.a.push(M)}}e.$di=l;var n;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(n||(n={}));function s(B){const M=v.$Ne.alloc(1);return M.writeUInt8(B,0),M}const t={Undefined:s(n.Undefined),String:s(n.String),Buffer:s(n.Buffer),VSBuffer:s(n.VSBuffer),Array:s(n.Array),Object:s(n.Object),Uint:s(n.Int)},r=typeof Buffer<"u";function o(B,M){if(typeof M>"u")B.write(t.Undefined);else if(typeof M=="string"){const J=v.$Ne.fromString(M);B.write(t.String),y(B,J.byteLength),B.write(J)}else if(r&&Buffer.isBuffer(M)){const J=v.$Ne.wrap(M);B.write(t.Buffer),y(B,J.byteLength),B.write(J)}else if(M instanceof v.$Ne)B.write(t.VSBuffer),y(B,M.byteLength),B.write(M);else if(Array.isArray(M)){B.write(t.Array),y(B,M.length);for(const J of M)o(B,J)}else if(typeof M=="number"&&(M|0)===M)B.write(t.Uint),y(B,M);else{const J=v.$Ne.fromString(JSON.stringify(M));B.write(t.Object),y(B,J.byteLength),B.write(J)}}function u(B){switch(B.read(1).readUInt8(0)){case n.Undefined:return;case n.String:return B.read(g(B)).toString();case n.Buffer:return B.read(g(B)).buffer;case n.VSBuffer:return B.read(g(B));case n.Array:{const J=g(B),K=[];for(let ie=0;ie<J;ie++)K.push(u(B));return K}case n.Object:return JSON.parse(B.read(g(B)).toString());case n.Int:return g(B)}}class ${constructor(M,J,K=null,ie=1e3){this.h=M,this.j=J,this.k=K,this.l=ie,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(se=>this.q(se)),this.m({type:I.Initialize})}registerChannel(M,J){this.b.set(M,J),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case I.Initialize:{const J=this.o([M.type]);this.k?.logOutgoing(J,0,N.OtherSide,b(M.type));return}case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:{const J=this.o([M.type,M.id],M.data);this.k?.logOutgoing(J,M.id,N.OtherSide,b(M.type),M.data);return}}}o(M,J=void 0){const K=new l;return o(K,M),o(K,J),this.p(K.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const J=new i(M),K=u(J),ie=u(J),se=K[0];switch(se){case d.Promise:return this.k?.logIncoming(M.byteLength,K[1],N.OtherSide,`${p(se)}: ${K[2]}.${K[3]}`,ie),this.s({type:se,id:K[1],channelName:K[2],name:K[3],arg:ie});case d.EventListen:return this.k?.logIncoming(M.byteLength,K[1],N.OtherSide,`${p(se)}: ${K[2]}.${K[3]}`,ie),this.t({type:se,id:K[1],channelName:K[2],name:K[3],arg:ie});case d.PromiseCancel:return this.k?.logIncoming(M.byteLength,K[1],N.OtherSide,`${p(se)}`),this.u({type:se,id:K[1]});case d.EventDispose:return this.k?.logIncoming(M.byteLength,K[1],N.OtherSide,`${p(se)}`),this.u({type:se,id:K[1]})}}s(M){const J=this.b.get(M.channelName);if(!J){this.v(M);return}const K=new k.$we;let ie;try{ie=J.call(this.j,M.name,M.arg,K.token)}catch(W){ie=Promise.reject(W)}const se=M.id;ie.then(W=>{this.m({id:se,data:W,type:I.PromiseSuccess})},W=>{W instanceof Error?this.m({id:se,data:{message:W.message,name:W.name,stack:W.stack?W.stack.split(`
`):void 0},type:I.PromiseError}):this.m({id:se,data:W,type:I.PromiseErrorObj})}).finally(()=>{T.dispose(),this.d.delete(M.id)});const T=(0,a.$Sc)(()=>K.cancel());this.d.set(M.id,T)}t(M){const J=this.b.get(M.channelName);if(!J){this.v(M);return}const K=M.id,se=J.listen(this.j,M.name,M.arg)(T=>this.m({id:K,data:T,type:I.EventFire}));this.d.set(M.id,se)}u(M){const J=this.d.get(M.id);J&&(J.dispose(),this.d.delete(M.id))}v(M){let J=this.g.get(M.channelName);J||(J=[],this.g.set(M.channelName,J));const K=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===d.Promise&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:I.PromiseError})},this.l);J.push({request:M,timeoutTimer:K})}w(M){const J=this.g.get(M);if(J){for(const K of J)switch(clearTimeout(K.timeoutTimer),K.request.type){case d.Promise:this.s(K.request);break;case d.EventListen:this.t(K.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$gi=$;var N;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(N||(e.RequestInitiator=N={}));class C{constructor(M,J=null){this.l=M,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new w.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=J}getChannel(M){const J=this;return{call(K,ie,se){return J.a?Promise.reject(new O.$4):J.m(M,K,ie,se)},listen(K,ie){return J.a?w.Event.None:J.o(M,K,ie)}}}m(M,J,K,ie=k.CancellationToken.None){const se=this.g++,T=d.Promise,W={id:se,type:T,channelName:M,name:J,arg:K};if(ie.isCancellationRequested)return Promise.reject(new O.$4);let z;return new Promise((j,X)=>{if(ie.isCancellationRequested)return X(new O.$4);const F=()=>{const oe=ce=>{switch(ce.type){case I.PromiseSuccess:this.f.delete(se),j(ce.data);break;case I.PromiseError:{this.f.delete(se);const ve=new Error(ce.data.message);ve.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,ve.name=ce.data.name,X(ve);break}case I.PromiseErrorObj:this.f.delete(se),X(ce.data);break}};this.f.set(se,oe),this.p(W)};let q=null;this.b===h.Idle?F():(q=(0,P.$rh)(oe=>this.u()),q.then(()=>{q=null,F()}));const x=()=>{q?(q.cancel(),q=null):this.p({id:se,type:d.PromiseCancel}),X(new O.$4)},ne=ie.onCancellationRequested(x);z=(0,a.$Rc)((0,a.$Sc)(x),ne),this.d.add(z)}).finally(()=>{z.dispose(),this.d.delete(z)})}o(M,J,K){const ie=this.g++,se=d.EventListen,T={id:ie,type:se,channelName:M,name:J,arg:K};let W=null;const z=new w.$le({onWillAddFirstListener:()=>{W=(0,P.$rh)(j=>this.u()),W.then(()=>{W=null,this.d.add(z),this.p(T)})},onDidRemoveLastListener:()=>{W?(W.cancel(),W=null):(this.d.delete(z),this.p({id:ie,type:d.EventDispose}))}}),E=j=>z.fire(j.data);return this.f.set(ie,E),z.event}p(M){switch(M.type){case d.Promise:case d.EventListen:{const J=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(J,M.id,N.LocalSide,`${p(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case d.PromiseCancel:case d.EventDispose:{const J=this.q([M.type,M.id]);this.j?.logOutgoing(J,M.id,N.LocalSide,p(M.type));return}}}q(M,J=void 0){const K=new l;return o(K,M),o(K,J),this.r(K.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const J=new i(M),K=u(J),ie=u(J),se=K[0];switch(se){case I.Initialize:return this.j?.logIncoming(M.byteLength,0,N.LocalSide,b(se)),this.t({type:K[0]});case I.PromiseSuccess:case I.PromiseError:case I.EventFire:case I.PromiseErrorObj:return this.j?.logIncoming(M.byteLength,K[1],N.LocalSide,b(se),ie),this.t({type:K[0],id:K[1],data:ie})}}t(M){if(M.type===I.Initialize){this.b=h.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return w.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$hi=C,be([L.$9h],C.prototype,"onDidInitializePromise",null);class A{get connections(){const M=[];return this.f.forEach(J=>M.push(J)),M}constructor(M,J,K){this.a=new Map,this.f=new Set,this.g=new w.$le,this.onDidAddConnection=this.g.event,this.h=new w.$le,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(M(({protocol:ie,onDidClientDisconnect:se})=>{const T=w.Event.once(ie.onMessage);this.j.add(T(W=>{const z=new i(W),E=u(z),j=new $(ie,E,J,K),X=new C(ie,J);this.a.forEach((q,x)=>j.registerChannel(x,q));const F={channelServer:j,channelClient:X,ctx:E};this.f.add(F),this.g.fire(F),this.j.add(se(()=>{j.dispose(),X.dispose(),this.f.delete(F),this.h.fire(F)}))}))}))}getChannel(M,J){const K=this;return{call(ie,se,T){let W;if((0,m.$sg)(J)){const E=(0,S.$2b)(K.connections.filter(J));W=E?Promise.resolve(E):w.Event.toPromise(w.Event.filter(K.onDidAddConnection,J))}else W=J.routeCall(K,ie,se);const z=W.then(E=>E.channelClient.getChannel(M));return U(z).call(ie,se,T)},listen(ie,se){if((0,m.$sg)(J))return K.k(M,J,ie,se);const T=J.routeEvent(K,ie,se).then(W=>W.channelClient.getChannel(M));return U(T).listen(ie,se)}}}k(M,J,K,ie){const se=this;let T;const W=new w.$le({onWillAddFirstListener:()=>{T=new a.$Tc;const z=new w.$re,E=new Map,j=F=>{const x=F.channelClient.getChannel(M).listen(K,ie),ne=z.add(x);E.set(F,ne)},X=F=>{const q=E.get(F);q&&(q.dispose(),E.delete(F))};se.connections.filter(J).forEach(j),w.Event.filter(se.onDidAddConnection,J)(j,void 0,T),se.onDidRemoveConnection(X,void 0,T),z.event(W.fire,W,T),T.add(z)},onDidRemoveLastListener:()=>{T?.dispose(),T=void 0}});return W.event}registerChannel(M,J){this.a.set(M,J);for(const K of this.f)K.channelServer.registerChannel(M,J)}dispose(){this.j.dispose();for(const M of this.f)M.channelClient.dispose(),M.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ii=A;class D{constructor(M,J,K=null){const ie=new l;o(ie,J),M.send(ie.buffer),this.a=new C(M,K),this.d=new $(M,J,K)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,J){this.d.registerChannel(M,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ji=D;function U(B){return{call(M,J,K){return B.then(ie=>ie.call(M,J,K))},listen(M,J){const K=new w.$ue;return B.then(ie=>K.input=ie.listen(M,J)),K.event}}}function G(B){let M=!1;return{call(J,K,ie){return M?B.call(J,K,ie):(0,P.$Fh)(0).then(()=>M=!0).then(()=>B.call(J,K,ie))},listen(J,K){if(M)return B.listen(J,K);const ie=new w.$ue;return(0,P.$Fh)(0).then(()=>M=!0).then(()=>ie.input=B.listen(J,K)),ie.event}}}class Q{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const J of M.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await w.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.$mi=Q;var te;(function(B){function M(se,T,W){const z=se,E=W&&W.disableMarshalling,j=new Map;for(const X in z)K(X)&&j.set(X,w.Event.buffer(z[X],!0,void 0,T));return new class{listen(X,F,q){const x=j.get(F);if(x)return x;const ne=z[F];if(typeof ne=="function"){if(ie(F))return ne.call(z,q);if(K(F))return j.set(F,w.Event.buffer(z[F],!0,void 0,T)),j.get(F)}throw new O.$ab(`Event not found: ${F}`)}call(X,F,q){const x=z[F];if(typeof x=="function"){if(!E&&Array.isArray(q))for(let oe=0;oe<q.length;oe++)q[oe]=(0,f.$bi)(q[oe]);let ne=x.apply(z,q);return ne instanceof Promise||(ne=Promise.resolve(ne)),ne}throw new O.$ab(`Method not found: ${F}`)}}}B.fromService=M;function J(se,T){const W=T&&T.disableMarshalling;return new Proxy({},{get(z,E){if(typeof E=="string")return T?.properties?.has(E)?T.properties.get(E):ie(E)?function(j){return se.listen(E,j)}:K(E)?se.listen(E):async function(...j){let X;T&&!(0,m.$ng)(T.context)?X=[T.context,...j]:X=j;const F=await se.call(E,X);return W?F:(0,f.$bi)(F)};throw new O.$ab(`Property not found: ${String(E)}`)}})}B.toService=J;function K(se){return se[0]==="o"&&se[1]==="n"&&c.$Ef(se.charCodeAt(2))}function ie(se){return/^onDynamic/.test(se)&&c.$Ef(se.charCodeAt(9))}})(te||(e.ProxyChannel=te={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const M=B.toString();if(M!=="[object Object]")return M}return B}function de(B){return Array.isArray(B)?B.map(le):le(B)}function H(B,M,J,K,ie,se,T){T=de(T);const W=ae[ie],z=W[K%W.length];let E=[`%c[${B}]%c[${String(M).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${se}`,"color: darkgreen","color: grey","color: grey",`color: ${z}`];/\($/.test(se)?(E=E.concat(T),E.push(")")):E.push(T),console.log.apply(console,E)}class Z{constructor(M,J){this.d=M,this.f=J,this.a=0,this.b=0}logOutgoing(M,J,K,ie,se){this.b+=M,H(this.d,this.b,M,J,K,ie,se)}logIncoming(M,J,K,ie,se){this.a+=M,H(this.f,this.a,M,J,K,ie,se)}}e.$ni=Z}),define(ue[87],he([0,1,60,8,13,21,81,7,4,2,27,58,56,59]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0,O=ye(O);class p extends d.$gi{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:w.Event.fromNodeEventEmitter(process,"message",g=>v.$Ne.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$gr=p;class I{constructor(h,g){this.i=h,this.j=g,this.c=new Set,this.g=new Map,this.h=new w.$le,this.onDidProcessExit=this.h.event;const R=g&&g.timeout?g.timeout:6e4;this.b=new P.$Bh(R),this.d=null,this.f=null}getChannel(h){const g=this;return{call(R,y,i){return g.k(h,R,y,i)},listen(R,y){return g.l(h,R,y)}}}k(h,g,R,y=k.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(O.$5());this.b.cancel();const i=this.n(h),l=(0,P.$rh)(t=>i.call(g,R,t)),n=y.onCancellationRequested(()=>l.cancel()),s=(0,a.$Sc)(()=>l.cancel());return this.c.add(s),l.finally(()=>{n.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),l}l(h,g,R){if(!this.b)return w.Event.None;this.b.cancel();let y;const i=new w.$le({onWillAddFirstListener:()=>{y=this.n(h).listen(g,R)(i.fire,i),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,f.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,m.$lm)(g.env),this.d=(0,S.fork)(this.i,h,g);const R=new w.$le,i=w.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,L.$cr)(o)){(0,L.log)(o,`IPC Library: ${this.j.serverName}`);return}R.fire(v.$Ne.wrap(Buffer.from(o,"base64")))}),l=this.j.useQueue?(0,c.$ym)(this.d):this.d,n=o=>this.d&&this.d.connected&&l.send(o.buffer.toString("base64")),s=R.event,t={send:n,onMessage:s};this.f=new d.$hi(t);const r=()=>this.o();process.once("exit",r),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",r),i.dispose(),this.c.forEach($=>(0,a.$Pc)($)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(h){let g=this.g.get(h);return g||(g=this.m.getChannel(h),this.g.set(h,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$hr=I}),define(ue[88],he([0,1,8,4,2,48,3]),function(Y,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.StorageState=e.StorageHint=void 0,e.$cq=w;var O;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(O||(e.StorageHint=O={}));function w(m){const d=m;return d?.changed instanceof Map||d?.deleted instanceof Set}var a;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(a||(e.StorageState=a={}));class f extends v.$Uc{static{this.a=100}constructor(d,p=Object.create(null)){super(),this.r=d,this.s=p,this.b=this.B(new P.$oe),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new S.$Ch(f.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(d=>this.u(d)))}u(d){this.b.pause();try{d.changed?.forEach((p,I)=>this.w(I,p)),d.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(d,p){if(this.c===a.Closed)return;let I=!1;(0,L.$ng)(p)?I=this.f.delete(d):this.f.get(d)!==p&&(this.f.set(d,p),I=!0),I&&this.b.fire({key:d,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(d,p){const I=this.f.get(d);return(0,L.$ng)(I)?p:I}getBoolean(d,p){const I=this.get(d);return(0,L.$ng)(I)?p:I==="true"}getNumber(d,p){const I=this.get(d);return(0,L.$ng)(I)?p:parseInt(I,10)}getObject(d,p){const I=this.get(d);return(0,L.$ng)(I)?p:(0,k.$ai)(I)}async set(d,p,I=!1){if(this.c===a.Closed)return;if((0,L.$ng)(p))return this.delete(d,I);const b=(0,L.$gg)(p)||Array.isArray(p)?(0,k.$_h)(p):String(p);if(this.f.get(d)!==b)return this.f.set(d,b),this.j.set(d,b),this.h.delete(d),this.b.fire({key:d,external:I}),this.D()}async delete(d,p=!1){if(!(this.c===a.Closed||!this.f.delete(d)))return this.h.has(d)||this.h.add(d),this.j.delete(d),this.b.fire({key:d,external:p}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const d={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(d).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(d){if(!(this.c===a.Closed||this.m))return this.D(d)}async D(d){return this.s.hint===O.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),d)}async whenFlushed(){if(this.z)return new Promise(d=>this.n.push(d))}isInMemory(){return this.s.hint===O.STORAGE_IN_MEMORY}}e.$dq=f;class c{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(d){d.insert?.forEach((p,I)=>this.a.set(I,p)),d.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$eq=c}),define(ue[89],he([0,1,5]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=a,e.$2m=f,e.$3m=c;const P=60,v=P*60,k=v*24,L=k*7,O=k*30,w=k*365;function a(m,d,p,I){typeof m!="number"&&(m=m.getTime());const b=Math.round((new Date().getTime()-m)/1e3);if(b<-30)return(0,S.localize)(12976,null,a(new Date().getTime()+b*1e3,!1));if(!I&&b<30)return(0,S.localize)(12977,null);let h;return b<P?(h=b,d?h===1?p?(0,S.localize)(12978,null,h):(0,S.localize)(12979,null,h):p?(0,S.localize)(12980,null,h):(0,S.localize)(12981,null,h):h===1?p?(0,S.localize)(12982,null,h):(0,S.localize)(12983,null,h):p?(0,S.localize)(12984,null,h):(0,S.localize)(12985,null,h)):b<v?(h=Math.floor(b/P),d?h===1?p?(0,S.localize)(12986,null,h):(0,S.localize)(12987,null,h):p?(0,S.localize)(12988,null,h):(0,S.localize)(12989,null,h):h===1?p?(0,S.localize)(12990,null,h):(0,S.localize)(12991,null,h):p?(0,S.localize)(12992,null,h):(0,S.localize)(12993,null,h)):b<k?(h=Math.floor(b/v),d?h===1?p?(0,S.localize)(12994,null,h):(0,S.localize)(12995,null,h):p?(0,S.localize)(12996,null,h):(0,S.localize)(12997,null,h):h===1?p?(0,S.localize)(12998,null,h):(0,S.localize)(12999,null,h):p?(0,S.localize)(13e3,null,h):(0,S.localize)(13001,null,h)):b<L?(h=Math.floor(b/k),d?h===1?(0,S.localize)(13002,null,h):(0,S.localize)(13003,null,h):h===1?(0,S.localize)(13004,null,h):(0,S.localize)(13005,null,h)):b<O?(h=Math.floor(b/L),d?h===1?p?(0,S.localize)(13006,null,h):(0,S.localize)(13007,null,h):p?(0,S.localize)(13008,null,h):(0,S.localize)(13009,null,h):h===1?p?(0,S.localize)(13010,null,h):(0,S.localize)(13011,null,h):p?(0,S.localize)(13012,null,h):(0,S.localize)(13013,null,h)):b<w?(h=Math.floor(b/O),d?h===1?p?(0,S.localize)(13014,null,h):(0,S.localize)(13015,null,h):p?(0,S.localize)(13016,null,h):(0,S.localize)(13017,null,h):h===1?p?(0,S.localize)(13018,null,h):(0,S.localize)(13019,null,h):p?(0,S.localize)(13020,null,h):(0,S.localize)(13021,null,h)):(h=Math.floor(b/w),d?h===1?p?(0,S.localize)(13022,null,h):(0,S.localize)(13023,null,h):p?(0,S.localize)(13024,null,h):(0,S.localize)(13025,null,h):h===1?p?(0,S.localize)(13026,null,h):(0,S.localize)(13027,null,h):p?(0,S.localize)(13028,null,h):(0,S.localize)(13029,null,h))}function f(m,d){const p=Math.abs(m/1e3);return p<1?d?(0,S.localize)(13030,null,m):(0,S.localize)(13031,null,m):p<P?d?(0,S.localize)(13032,null,Math.round(m)/1e3):(0,S.localize)(13033,null,Math.round(m)/1e3):p<v?d?(0,S.localize)(13034,null,Math.round(m/(1e3*P))):(0,S.localize)(13035,null,Math.round(m/(1e3*P))):p<k?d?(0,S.localize)(13036,null,Math.round(m/(1e3*v))):(0,S.localize)(13037,null,Math.round(m/(1e3*v))):(0,S.localize)(13038,null,Math.round(m/(1e3*k)))}function c(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ue[38],he([0,1,19,3,5]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=w,e.$qj=a,e.$rj=f,S=ye(S),P=ye(P),v=ye(v);function k(c,m){return m&&(c.stack||c.stacktrace)?v.localize(12970,null,O(c),L(c.stack)||L(c.stacktrace)):O(c)}function L(c){return Array.isArray(c)?c.join(`
`):c}function O(c){return c.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${c.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof c.code=="string"&&typeof c.errno=="number"&&typeof c.syscall=="string"?v.localize(12971,null,c.message):c.message||v.localize(12972,null)}function w(c=null,m=!1){if(!c)return v.localize(12973,null);if(Array.isArray(c)){const d=S.$Gb(c),p=w(d[0],m);return d.length>1?v.localize(12974,null,p,d.length):p}if(P.$eg(c))return c;if(c.detail){const d=c.detail;if(d.error)return k(d.error,m);if(d.exception)return k(d.exception,m)}return c.stack?k(c,m):c.message?c.message:v.localize(12975,null)}function a(c){const m=c;return m instanceof Error&&Array.isArray(m.actions)}function f(c,m){let d;return typeof c=="string"?d=new Error(c):d=c,d.actions=m,d}}),define(ue[90],he([0,1,5,34]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=v;function v(k){switch(k){case P.ParseErrorCode.InvalidSymbol:return(0,S.localize)(12961,null);case P.ParseErrorCode.InvalidNumberFormat:return(0,S.localize)(12962,null);case P.ParseErrorCode.PropertyNameExpected:return(0,S.localize)(12963,null);case P.ParseErrorCode.ValueExpected:return(0,S.localize)(12964,null);case P.ParseErrorCode.ColonExpected:return(0,S.localize)(12965,null);case P.ParseErrorCode.CommaExpected:return(0,S.localize)(12966,null);case P.ParseErrorCode.CloseBraceExpected:return(0,S.localize)(12967,null);case P.ParseErrorCode.CloseBracketExpected:return(0,S.localize)(12968,null);case P.ParseErrorCode.EndOfFileExpected:return(0,S.localize)(12969,null);default:return""}}}),define(ue[50],he([0,1,32,8,15,3,29,5]),function(Y,e,S,P,v,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=e.$zq=void 0,e.zip=b,e.$Cq=h,e.$Dq=R,v=ye(v),O=ye(O),e.$zq="end of central directory record signature not found";const w=new RegExp(e.$zq);class a extends Error{constructor(i,l){let n=l.message;switch(i){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=i,this.cause=l}}e.$Aq=a;function f(y){const i=y.externalFileAttributes>>16||33188;return[448,56,7].map(l=>i&l).reduce((l,n)=>l+n,i&61440)}function c(y){if(y instanceof a)return y;let i;return w.test(y.message)&&(i="CorruptZip"),new a(i,y)}function m(y,i,l,n,s,t){const r=v.$mc(i),o=v.$jc(n,r);if(!o.startsWith(n))return Promise.reject(new Error(O.localize(12938,null,i)));const u=v.$jc(n,i);let $;return t.onCancellationRequested(()=>{$?.destroy()}),Promise.resolve(S.promises.mkdir(o,{recursive:!0})).then(()=>new Promise((N,C)=>{if(!t.isCancellationRequested)try{$=(0,S.createWriteStream)(u,{mode:l}),$.once("close",()=>N()),$.once("error",C),y.once("error",C),y.pipe($)}catch(A){C(A)}}))}function d(y,i,l,n){let s=(0,P.$rh)(()=>Promise.resolve()),t=0;const r=n.onCancellationRequested(()=>{s.cancel(),y.close()});return new Promise((o,u)=>{const $=new P.$zh,N=C=>{C.isCancellationRequested||(t++,y.readEntry())};y.once("error",u),y.once("close",()=>s.then(()=>{n.isCancellationRequested||y.entryCount===t?o():u(new a("Incomplete",new Error(O.localize(12939,null,t,y.entryCount))))},u)),y.readEntry(),y.on("entry",C=>{if(n.isCancellationRequested)return;if(!l.sourcePathRegex.test(C.fileName)){N(n);return}const A=C.fileName.replace(l.sourcePathRegex,"");if(/\/$/.test(A)){const G=v.$jc(i,A);s=(0,P.$rh)(Q=>S.promises.mkdir(G,{recursive:!0}).then(()=>N(Q)).then(void 0,u));return}const D=I(y,C),U=f(C);s=(0,P.$rh)(G=>$.queue(()=>D.then(Q=>m(Q,A,U,i,l,G).then(()=>N(G)))).then(null,u))})}).finally(()=>r.dispose())}async function p(y,i=!1){const{open:l}=await new Promise((n,s)=>{Y(["yauzl"],n,s)}).then(ye);return new Promise((n,s)=>{l(y,i?{lazyEntries:!0}:void 0,(t,r)=>{t?s(c(t)):n((0,k.$pg)(r))})})}function I(y,i){return new Promise((l,n)=>{y.openReadStream(i,(s,t)=>{s?n(c(s)):l((0,k.$pg)(t))})})}async function b(y,i){const{ZipFile:l}=await new Promise((n,s)=>{Y(["yazl"],n,s)}).then(ye);return new Promise((n,s)=>{const t=new l;i.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const r=(0,S.createWriteStream)(y);t.outputStream.pipe(r),t.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(y))})}function h(y,i,l={},n){const s=new RegExp(l.sourcePath?`^${l.sourcePath}`:"");let t=p(y,!0);return l.overwrite&&(t=t.then(r=>L.Promises.rm(i).then(()=>r))),t.then(r=>d(r,i,{sourcePathRegex:s},n))}function g(y,i){return p(y).then(l=>new Promise((n,s)=>{l.on("entry",t=>{t.fileName===i&&I(l,t).then(r=>n(r),r=>s(r))}),l.once("close",()=>s(new Error(O.localize(12940,null,i))))}))}function R(y,i){return g(y,i).then(l=>new Promise((n,s)=>{const t=[];l.once("error",s),l.on("data",r=>t.push(r)),l.on("end",()=>n(Buffer.concat(t)))}))}}),define(ue[91],he([0,1,92,7,5]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var k;(function(f){f[f.LParen=0]="LParen",f[f.RParen=1]="RParen",f[f.Neg=2]="Neg",f[f.Eq=3]="Eq",f[f.NotEq=4]="NotEq",f[f.Lt=5]="Lt",f[f.LtEq=6]="LtEq",f[f.Gt=7]="Gt",f[f.GtEq=8]="GtEq",f[f.RegexOp=9]="RegexOp",f[f.RegexStr=10]="RegexStr",f[f.True=11]="True",f[f.False=12]="False",f[f.In=13]="In",f[f.Not=14]="Not",f[f.And=15]="And",f[f.Or=16]="Or",f[f.Str=17]="Str",f[f.QuotedStr=18]="QuotedStr",f[f.Error=19]="Error",f[f.EOF=20]="EOF"})(k||(e.TokenType=k={}));function L(...f){switch(f.length){case 1:return(0,v.localize)(11574,null,f[0]);case 2:return(0,v.localize)(11575,null,f[0],f[1]);case 3:return(0,v.localize)(11576,null,f[0],f[1],f[2]);default:return}}const O=(0,v.localize)(11577,null),w=(0,v.localize)(11578,null);class a{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(c){switch(c.type){case k.LParen:return"(";case k.RParen:return")";case k.Neg:return"!";case k.Eq:return c.isTripleEq?"===":"==";case k.NotEq:return c.isTripleEq?"!==":"!=";case k.Lt:return"<";case k.LtEq:return"<=";case k.Gt:return">=";case k.GtEq:return">=";case k.RegexOp:return"=~";case k.RegexStr:return c.lexeme;case k.True:return"true";case k.False:return"false";case k.In:return"in";case k.Not:return"not";case k.And:return"&&";case k.Or:return"||";case k.Str:return c.lexeme;case k.QuotedStr:return c.lexeme;case k.Error:return c.lexeme;case k.EOF:return"EOF";default:throw(0,P.$7)(`unhandled token type: ${JSON.stringify(c)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(c=>c.charCodeAt(0)))}static{this.b=new Map([["not",k.Not],["in",k.In],["false",k.False],["true",k.True]])}get errors(){return this.g}reset(c){return this.c=c,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case S.CharCode.OpenParen:this.k(k.LParen);break;case S.CharCode.CloseParen:this.k(k.RParen);break;case S.CharCode.ExclamationMark:if(this.h(S.CharCode.Equals)){const m=this.h(S.CharCode.Equals);this.f.push({type:k.NotEq,offset:this.d,isTripleEq:m})}else this.k(k.Neg);break;case S.CharCode.SingleQuote:this.o();break;case S.CharCode.Slash:this.q();break;case S.CharCode.Equals:if(this.h(S.CharCode.Equals)){const m=this.h(S.CharCode.Equals);this.f.push({type:k.Eq,offset:this.d,isTripleEq:m})}else this.h(S.CharCode.Tilde)?this.k(k.RegexOp):this.l(L("==","=~"));break;case S.CharCode.LessThan:this.k(this.h(S.CharCode.Equals)?k.LtEq:k.Lt);break;case S.CharCode.GreaterThan:this.k(this.h(S.CharCode.Equals)?k.GtEq:k.Gt);break;case S.CharCode.Ampersand:this.h(S.CharCode.Ampersand)?this.k(k.And):this.l(L("&&"));break;case S.CharCode.Pipe:this.h(S.CharCode.Pipe)?this.k(k.Or):this.l(L("||"));break;case S.CharCode.Space:case S.CharCode.CarriageReturn:case S.CharCode.Tab:case S.CharCode.LineFeed:case S.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(k.EOF),Array.from(this.f)}h(c){return this.r()||this.c.charCodeAt(this.e)!==c?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?S.CharCode.Null:this.c.charCodeAt(this.e)}k(c){this.f.push({type:c,offset:this.d})}l(c){const m=this.d,d=this.c.substring(this.d,this.e),p={type:k.Error,offset:this.d,lexeme:d};this.g.push({offset:m,lexeme:d,additionalInfo:c}),this.f.push(p)}n(){this.m.lastIndex=this.d;const c=this.m.exec(this.c);if(c){this.e=this.d+c[0].length;const m=this.c.substring(this.d,this.e),d=a.b.get(m);d?this.k(d):this.f.push({type:k.Str,lexeme:m,offset:this.d})}}o(){for(;this.j()!==S.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:k.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let c=this.e,m=!1,d=!1;for(;;){if(c>=this.c.length){this.e=c,this.l(w);return}const I=this.c.charCodeAt(c);if(m)m=!1;else if(I===S.CharCode.Slash&&!d){c++;break}else I===S.CharCode.OpenSquareBracket?d=!0:I===S.CharCode.Backslash?m=!0:I===S.CharCode.CloseSquareBracket&&(d=!1);c++}for(;c<this.c.length&&a.a.has(this.c.charCodeAt(c));)c++;this.e=c;const p=this.c.substring(this.d,this.e);this.f.push({type:k.RegexStr,lexeme:p,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=a}),define(ue[93],he([0,1,89,55,14,15,36,16,11]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=f,e.$7m=c,e.$4m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,k.$mc)(v.$Yg.asFileUri("").fsPath)}get userHome(){return w.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return w.URI.file((0,k.$jc)(this.userDataPath,"User"))}get tmpDir(){return w.URI.file(this.b.tmpDir)}get cacheHome(){return w.URI.file(this.userDataPath)}get stateResource(){return(0,O.$fh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:v.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,O.$fh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const d=(0,S.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,k.$jc)(this.userDataPath,"logs",d)}return w.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,O.$fh)(w.URI.file((0,k.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,O.$fh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,O.$fh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,O.$fh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=L.env.VSCODE_PORTABLE;return d?w.URI.file((0,k.$jc)(d,"argv.json")):(0,O.$fh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return w.URI.file((0,k.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,k.$kc)(d):(0,k.$hc)((0,k.$jc)(v.$Yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?w.URI.file((0,k.$kc)(d)):w.URI.file((0,k.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,k.$kc)(d);const p=L.env.VSCODE_EXTENSIONS;if(p)return p;const I=L.env.VSCODE_PORTABLE;return I?(0,k.$jc)(I,"extensions"):(0,O.$fh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(p=>/^[^:/?#]+?:\/\//.test(p)?w.URI.parse(p):w.URI.file((0,k.$hc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?w.URI.parse(d):w.URI.file((0,k.$hc)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return f(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.$4m.test(d))}get extensionLogLevel(){const d=[];for(const p of this.args.log||[]){const I=e.$4m.exec(p);I&&I[1]&&I[2]&&d.push([I[1],I[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,O.$fh)(w.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=L.env.VSCODE_PORTABLE;return d?w.URI.file((0,k.$jc)(d,"policy.json")):(0,O.$fh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,p,I){this.a=d,this.b=p,this.c=I,this.editSessionId=this.args.editSessionId}}e.$5m=a,be([P.$9h],a.prototype,"appRoot",null),be([P.$9h],a.prototype,"userHome",null),be([P.$9h],a.prototype,"userDataPath",null),be([P.$9h],a.prototype,"appSettingsHome",null),be([P.$9h],a.prototype,"tmpDir",null),be([P.$9h],a.prototype,"cacheHome",null),be([P.$9h],a.prototype,"stateResource",null),be([P.$9h],a.prototype,"userRoamingDataHome",null),be([P.$9h],a.prototype,"userDataSyncHome",null),be([P.$9h],a.prototype,"sync",null),be([P.$9h],a.prototype,"machineSettingsResource",null),be([P.$9h],a.prototype,"workspaceStorageHome",null),be([P.$9h],a.prototype,"localHistoryHome",null),be([P.$9h],a.prototype,"keyboardLayoutResource",null),be([P.$9h],a.prototype,"argvResource",null),be([P.$9h],a.prototype,"isExtensionDevelopment",null),be([P.$9h],a.prototype,"untitledWorkspacesHome",null),be([P.$9h],a.prototype,"builtinExtensionsPath",null),be([P.$9h],a.prototype,"extensionsPath",null),be([P.$9h],a.prototype,"extensionDevelopmentLocationURI",null),be([P.$9h],a.prototype,"extensionDevelopmentKind",null),be([P.$9h],a.prototype,"extensionTestsLocationURI",null),be([P.$9h],a.prototype,"debugExtensionHost",null),be([P.$9h],a.prototype,"logLevel",null),be([P.$9h],a.prototype,"extensionLogLevel",null),be([P.$9h],a.prototype,"serviceMachineIdResource",null),be([P.$9h],a.prototype,"disableTelemetry",null),be([P.$9h],a.prototype,"disableWorkspaceTrust",null),be([P.$9h],a.prototype,"useInMemorySecretStorage",null),be([P.$9h],a.prototype,"policyFile",null);function f(m,d){return c(m["inspect-extensions"],m["inspect-brk-extensions"],5870,d,m.debugId,m.extensionEnvironment)}function c(m,d,p,I,b,h){const R=Number(d||m)||(I?null:p),y=R?!!d:!1;let i;if(h)try{i=JSON.parse(h)}catch{}return{port:R,break:y,debugId:b,env:i}}}),function(){function Y(e,S,P){function v(L,O){const w=k(L,O),a=[w];return e.isAbsolute(w)||a.unshift(P),e.resolve(...a)}function k(L,O){process.env.VSCODE_DEV&&(O="code-oss-dev");const w=process.env.VSCODE_PORTABLE;if(w)return e.join(w,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,O);const f=L["user-data-dir"];if(f)return f;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const c=process.env.USERPROFILE;if(typeof c!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(c,"AppData","Roaming")}break;case"darwin":a=e.join(S.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(S.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,O)}return{getUserDataPath:v}}if(typeof define=="function")define(ue[94],he([148,35,36]),function(e,S,P){return Y(e,S,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),S=require("os");module.exports=Y(e,S,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ue[95],he([0,1,35,93,94]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=L,e.$0m=O;class k extends P.$5m{constructor(a,f){super(a,{homeDir:(0,S.homedir)(),tmpDir:(0,S.tmpdir)(),userDataDir:(0,v.getUserDataPath)(a,f.nameShort)},f)}}e.$8m=k;function L(w,a){return(0,P.$7m)(w["inspect-ptyhost"],w["inspect-brk-ptyhost"],5877,a,w.extensionEnvironment)}function O(w,a){return(0,P.$7m)(w["inspect-sharedprocess"],w["inspect-brk-sharedprocess"],5879,a,w.extensionEnvironment)}}),define(ue[96],he([0,1,3,5]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=v;function v(L,O,w,a){try{k(L,O,w,a)}catch(f){L.error(f?.message??f)}return O}function k(L,O,w,a){const f=(c,m,d)=>{const p=c[m];if((0,S.$eg)(p)){const I=p,b=I.length;if(b>1&&I[0]==="%"&&I[b-1]==="%"){const h=I.substr(1,b-2);let g=w[h];g===void 0&&a&&(g=a[h]);const R=typeof g=="string"?g:g?.message,y=a?.[h],i=typeof y=="string"?y:y?.message;if(!R){i||L.warn(`[${O.name}]: ${(0,P.localize)(11457,null,h)}`);return}if(d&&(m==="title"||m==="category")&&i&&i!==R){const l={value:R,original:i};c[m]=l}else c[m]=R}}else if((0,S.$gg)(p))for(const I in p)p.hasOwnProperty(I)&&(I==="commands"?f(p,I,!0):f(p,I,d));else if(Array.isArray(p))for(let I=0;I<p.length;I++)f(p,I,d)};for(const c in O)O.hasOwnProperty(c)&&f(O,c)}}),define(ue[97],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const S={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(S)}),define(ue[51],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class S{constructor(v,k=[],L=!1){this.ctor=v,this.staticArguments=k,this.supportsDelayedInstantiation=L}}e.$Bi=S}),define(ue[98],he([0,1,51]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Qs=k,e.$Rs=L;const P=[];var v;(function(O){O[O.Eager=0]="Eager",O[O.Delayed=1]="Delayed"})(v||(e.InstantiationType=v={}));function k(O,w,a){w instanceof S.$Bi||(w=new S.$Bi(w,[],!!a)),P.push([O,w])}function L(){return P}}),define(ue[99],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class S{constructor(k,L){this.key=k,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$tr=S;class P{constructor(k){this.b=k,this.a=new Map}roots(){const k=[];for(const L of this.a.values())L.outgoing.size===0&&k.push(L);return k}insertEdge(k,L){const O=this.lookupOrInsertNode(k),w=this.lookupOrInsertNode(L);O.outgoing.set(w.key,w),w.incoming.set(O.key,O)}removeNode(k){const L=this.b(k);this.a.delete(L);for(const O of this.a.values())O.outgoing.delete(L),O.incoming.delete(L)}lookupOrInsertNode(k){const L=this.b(k);let O=this.a.get(L);return O||(O=new S(L,k),this.a.set(L,O)),O}lookup(k){return this.a.get(this.b(k))}isEmpty(){return this.a.size===0}toString(){const k=[];for(const[L,O]of this.a)k.push(`${L}
	(-> incoming)[${[...O.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...O.outgoing.keys()].join(",")}]
`);return k.join(`
`)}findCycleSlow(){for(const[k,L]of this.a){const O=new Set([k]),w=this.c(L,O);if(w)return w}}c(k,L){for(const[O,w]of k.outgoing){if(L.has(O))return[...L,O].join(" -> ");L.add(O);const a=this.c(w,L);if(a)return a;L.delete(O)}}}e.$ur=P}),define(ue[30],he([0,1,3,11,10]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=k,e.$aj=L,e.$bj=w,e.$cj=a,e.$dj=f,e.$ej=c,e.$fj=m,e.$gj=p,e.$hj=I,e.$ij=b,S=ye(S),e.$$i=(0,v.$Ei)("configurationService");function k(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof P.URI)}function L(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof P.URI)}var O;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(O||(e.ConfigurationTarget=O={}));function w(h){switch(h){case O.APPLICATION:return"APPLICATION";case O.USER:return"USER";case O.USER_LOCAL:return"USER_LOCAL";case O.USER_REMOTE:return"USER_REMOTE";case O.WORKSPACE:return"WORKSPACE";case O.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case O.DEFAULT:return"DEFAULT";case O.MEMORY:return"MEMORY"}}function a(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}function f(h,g){const R=Object.create(null);for(const y in h)c(R,y,h[y],g);return R}function c(h,g,R,y){const i=g.split("."),l=i.pop();let n=h;for(let s=0;s<i.length;s++){const t=i[s];let r=n[t];switch(typeof r){case"undefined":r=n[t]=Object.create(null);break;case"object":if(r===null){y(`Ignoring ${g} as ${i.slice(0,s+1).join(".")} is null`);return}break;default:y(`Ignoring ${g} as ${i.slice(0,s+1).join(".")} is ${JSON.stringify(r)}`);return}n=r}if(typeof n=="object"&&n!==null)try{n[l]=R}catch{y(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(n)}`)}else y(`Ignoring ${g} as ${i.join(".")} is ${JSON.stringify(n)}`)}function m(h,g){const R=g.split(".");d(h,R)}function d(h,g){const R=g.shift();if(g.length===0){delete h[R];return}if(Object.keys(h).indexOf(R)!==-1){const y=h[R];typeof y=="object"&&!Array.isArray(y)&&(d(y,g),Object.keys(y).length===0&&delete h[R])}}function p(h,g,R){function y(n,s){let t=n;for(const r of s){if(typeof t!="object"||t===null)return;t=t[r]}return t}const i=g.split("."),l=y(h,i);return typeof l>"u"?R:l}function I(h,g,R){Object.keys(g).forEach(y=>{y!=="__proto__"&&(y in h?S.$gg(h[y])&&S.$gg(g[y])?I(h[y],g[y],R):R&&(h[y]=g[y]):h[y]=g[y])})}function b(h){return h.replace(/[\[\]]/g,"")}}),define(ue[100],he([0,1,92,12,31,91,10,5,7]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=f,e.$Dj=s,e.$Ej=t,e.$Xj=se;const a=new Map;a.set("false",!1),a.set("true",!0),a.set("isMac",P.$k),a.set("isLinux",P.$l),a.set("isWindows",P.$j),a.set("isWeb",P.$p),a.set("isMacNative",P.$k&&!P.$p),a.set("isEdge",P.$I),a.set("isFirefox",P.$G),a.set("isChrome",P.$F),a.set("isSafari",P.$H);function f(z,E){if(a.get(z)!==void 0)throw(0,w.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");a.set(z,E)}const c=Object.prototype.hasOwnProperty;var m;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const d={regexParsingWithErrorRecovery:!0},p=(0,O.localize)(11588,null),I=(0,O.localize)(11589,null),b=(0,O.localize)(11590,null),h=(0,O.localize)(11591,null),g=(0,O.localize)(11592,null),R=(0,O.localize)(11593,null),y=(0,O.localize)(11594,null),i=(0,O.localize)(11595,null);class l{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(E=d){this.k=E,this.d=new k.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(E){if(E===""){this.h.push({message:p,offset:0,lexeme:"",additionalInfo:I});return}this.f=this.d.reset(E).scan(),this.g=0,this.h=[];try{const j=this.l();if(!this.E()){const X=this.D(),F=X.type===k.TokenType.Str?R:void 0;throw this.h.push({message:g,offset:X.offset,lexeme:k.$zj.getLexeme(X),additionalInfo:F}),l.c}return j}catch(j){if(j!==l.c)throw j;return}}l(){return this.m()}m(){const E=[this.o()];for(;this.y(k.TokenType.Or);){const j=this.o();E.push(j)}return E.length===1?E[0]:n.or(...E)}o(){const E=[this.s()];for(;this.y(k.TokenType.And);){const j=this.s();E.push(j)}return E.length===1?E[0]:n.and(...E)}s(){if(this.y(k.TokenType.Neg)){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),o.INSTANCE;case k.TokenType.False:return this.z(),u.INSTANCE;case k.TokenType.LParen:{this.z();const j=this.l();return this.A(k.TokenType.RParen,h),j?.negate()}case k.TokenType.Str:return this.z(),U.create(E.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",E)}}return this.t()}t(){const E=this.D();switch(E.type){case k.TokenType.True:return this.z(),n.true();case k.TokenType.False:return this.z(),n.false();case k.TokenType.LParen:{this.z();const j=this.l();return this.A(k.TokenType.RParen,h),j}case k.TokenType.Str:{const j=E.lexeme;if(this.z(),this.y(k.TokenType.RegexOp)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==k.TokenType.RegexStr)throw this.B("REGEX",F);const q=F.lexeme,x=q.lastIndexOf("/"),ne=x===q.length-1?void 0:this.w(q.substring(x+1));let oe;try{oe=new RegExp(q.substring(1,x),ne)}catch{throw this.B("REGEX",F)}return de.create(j,oe)}switch(F.type){case k.TokenType.RegexStr:case k.TokenType.Error:{const q=[F.lexeme];this.z();let x=this.D(),ne=0;for(let $e=0;$e<F.lexeme.length;$e++)F.lexeme.charCodeAt($e)===S.CharCode.OpenParen?ne++:F.lexeme.charCodeAt($e)===S.CharCode.CloseParen&&ne--;for(;!this.E()&&x.type!==k.TokenType.And&&x.type!==k.TokenType.Or;){switch(x.type){case k.TokenType.LParen:ne++;break;case k.TokenType.RParen:ne--;break;case k.TokenType.RegexStr:case k.TokenType.QuotedStr:for(let $e=0;$e<x.lexeme.length;$e++)x.lexeme.charCodeAt($e)===S.CharCode.OpenParen?ne++:F.lexeme.charCodeAt($e)===S.CharCode.CloseParen&&ne--}if(ne<0)break;q.push(k.$zj.getLexeme(x)),this.z(),x=this.D()}const oe=q.join(""),ce=oe.lastIndexOf("/"),ve=ce===oe.length-1?void 0:this.w(oe.substring(ce+1));let fe;try{fe=new RegExp(oe.substring(1,ce),ve)}catch{throw this.B("REGEX",F)}return n.regex(j,fe)}case k.TokenType.QuotedStr:{const q=F.lexeme;this.z();let x=null;if(!(0,v.$cf)(q)){const ne=q.indexOf("/"),oe=q.lastIndexOf("/");if(ne!==oe&&ne>=0){const ce=q.slice(ne+1,oe),ve=q[oe+1]==="i"?"i":"";try{x=new RegExp(ce,ve)}catch{throw this.B("REGEX",F)}}}if(x===null)throw this.B("REGEX",F);return de.create(j,x)}default:throw this.B("REGEX",this.D())}}if(this.y(k.TokenType.Not)){this.A(k.TokenType.In,b);const F=this.u();return n.notIn(j,F)}switch(this.D().type){case k.TokenType.Eq:{this.z();const F=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.equals(j,F);switch(F){case"true":return n.has(j);case"false":return n.not(j);default:return n.equals(j,F)}}case k.TokenType.NotEq:{this.z();const F=this.u();if(this.x().type===k.TokenType.QuotedStr)return n.notEquals(j,F);switch(F){case"true":return n.not(j);case"false":return n.has(j);default:return n.notEquals(j,F)}}case k.TokenType.Lt:return this.z(),ae.create(j,this.u());case k.TokenType.LtEq:return this.z(),le.create(j,this.u());case k.TokenType.Gt:return this.z(),Q.create(j,this.u());case k.TokenType.GtEq:return this.z(),te.create(j,this.u());case k.TokenType.In:return this.z(),n.in(j,this.u());default:return n.has(j)}}case k.TokenType.EOF:throw this.h.push({message:y,offset:E.offset,lexeme:"",additionalInfo:i}),l.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const E=this.D();switch(E.type){case k.TokenType.Str:case k.TokenType.QuotedStr:return this.z(),E.lexeme;case k.TokenType.True:return this.z(),"true";case k.TokenType.False:return this.z(),"false";case k.TokenType.In:return this.z(),"in";default:return""}}w(E){return E.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(E){return this.C(E)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(E,j){if(this.C(E))return this.z();throw this.B(j,this.D())}B(E,j,X){const F=(0,O.localize)(11596,null,E,k.$zj.getLexeme(j)),q=j.offset,x=k.$zj.getLexeme(j);return this.h.push({message:F,offset:q,lexeme:x,additionalInfo:X}),l.c}C(E){return this.D().type===E}D(){return this.f[this.g]}E(){return this.D().type===k.TokenType.EOF}}e.$Bj=l;class n{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(E){return $.create(E)}static equals(E,j){return N.create(E,j)}static notEquals(E,j){return D.create(E,j)}static regex(E,j){return de.create(E,j)}static in(E,j){return C.create(E,j)}static notIn(E,j){return A.create(E,j)}static not(E){return U.create(E)}static and(...E){return B.create(E,null,!0)}static or(...E){return M.create(E,null,!0)}static greater(E,j){return Q.create(E,j)}static greaterEquals(E,j){return te.create(E,j)}static smaller(E,j){return ae.create(E,j)}static smallerEquals(E,j){return le.create(E,j)}static{this.c=new l({regexParsingWithErrorRecovery:!1})}static deserialize(E){return E==null?void 0:this.c.parse(E)}}e.$Cj=n;function s(z){const E=new l({regexParsingWithErrorRecovery:!1});return z.map(j=>(E.parse(j),E.lexingErrors.length>0?E.lexingErrors.map(X=>({errorMessage:X.additionalInfo?(0,O.localize)(11597,null,X.additionalInfo):(0,O.localize)(11598,null),offset:X.offset,length:X.lexeme.length})):E.parsingErrors.length>0?E.parsingErrors.map(X=>({errorMessage:X.additionalInfo?`${X.message}. ${X.additionalInfo}`:X.message,offset:X.offset,length:X.lexeme.length})):[]))}function t(z,E){const j=z?z.substituteConstants():void 0,X=E?E.substituteConstants():void 0;return!j&&!X?!0:!j||!X?!1:j.equals(X)}function r(z,E){return z.cmp(E)}class o{static{this.INSTANCE=new o}constructor(){this.type=m.False}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!1}serialize(){return"false"}keys(){return[]}map(E){return this}negate(){return u.INSTANCE}}e.$Fj=o;class u{static{this.INSTANCE=new u}constructor(){this.type=m.True}cmp(E){return this.type-E.type}equals(E){return E.type===this.type}substituteConstants(){return this}evaluate(E){return!0}serialize(){return"true"}keys(){return[]}map(E){return this}negate(){return o.INSTANCE}}e.$Gj=u;class ${static create(E,j=null){const X=a.get(E);return typeof X=="boolean"?X?u.INSTANCE:o.INSTANCE:new $(E,j)}constructor(E,j){this.key=E,this.c=j,this.type=m.Defined}cmp(E){return E.type!==this.type?this.type-E.type:K(this.key,E.key)}equals(E){return E.type===this.type?this.key===E.key:!1}substituteConstants(){const E=a.get(this.key);return typeof E=="boolean"?E?u.INSTANCE:o.INSTANCE:this}evaluate(E){return!!E.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(E){return E.mapDefined(this.key)}negate(){return this.c||(this.c=U.create(this.key,this)),this.c}}e.$Hj=$;class N{static create(E,j,X=null){if(typeof j=="boolean")return j?$.create(E,X):U.create(E,X);const F=a.get(E);return typeof F=="boolean"?j===(F?"true":"false")?u.INSTANCE:o.INSTANCE:new N(E,j,X)}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=m.Equals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=a.get(this.c);if(typeof E=="boolean"){const j=E?"true":"false";return this.d===j?u.INSTANCE:o.INSTANCE}return this}evaluate(E){return E.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(E){return E.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Ij=N;class C{static create(E,j){return new C(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=m.In,this.c=null}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.d,this.f,E.d,E.f)}equals(E){return E.type===this.type?this.d===E.d&&this.f===E.f:!1}substituteConstants(){return this}evaluate(E){const j=E.getValue(this.f),X=E.getValue(this.d);return Array.isArray(j)?j.includes(X):typeof X=="string"&&typeof j=="object"&&j!==null?c.call(j,X):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(E){return E.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Jj=C;class A{static create(E,j){return new A(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=m.NotIn,this.c=C.create(E,j)}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(E){return E.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=A;class D{static create(E,j,X=null){if(typeof j=="boolean")return j?U.create(E,X):$.create(E,X);const F=a.get(E);return typeof F=="boolean"?j===(F?"true":"false")?o.INSTANCE:u.INSTANCE:new D(E,j,X)}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=m.NotEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){const E=a.get(this.c);if(typeof E=="boolean"){const j=E?"true":"false";return this.d===j?o.INSTANCE:u.INSTANCE}return this}evaluate(E){return E.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(E){return E.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Lj=D;class U{static create(E,j=null){const X=a.get(E);return typeof X=="boolean"?X?o.INSTANCE:u.INSTANCE:new U(E,j)}constructor(E,j){this.c=E,this.d=j,this.type=m.Not}cmp(E){return E.type!==this.type?this.type-E.type:K(this.c,E.c)}equals(E){return E.type===this.type?this.c===E.c:!1}substituteConstants(){const E=a.get(this.c);return typeof E=="boolean"?E?o.INSTANCE:u.INSTANCE:this}evaluate(E){return!E.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(E){return E.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Mj=U;function G(z,E){if(typeof z=="string"){const j=parseFloat(z);isNaN(j)||(z=j)}return typeof z=="string"||typeof z=="number"?E(z):o.INSTANCE}class Q{static create(E,j,X=null){return G(j,F=>new Q(E,F,X))}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=m.Greater}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Nj=Q;class te{static create(E,j,X=null){return G(j,F=>new te(E,F,X))}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=m.GreaterEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(E){return E.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Oj=te;class ae{static create(E,j,X=null){return G(j,F=>new ae(E,F,X))}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=m.Smaller}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Pj=ae;class le{static create(E,j,X=null){return G(j,F=>new le(E,F,X))}constructor(E,j,X){this.c=E,this.d=j,this.f=X,this.type=m.SmallerEquals}cmp(E){return E.type!==this.type?this.type-E.type:ie(this.c,this.d,E.c,E.d)}equals(E){return E.type===this.type?this.c===E.c&&this.d===E.d:!1}substituteConstants(){return this}evaluate(E){return typeof this.d=="string"?!1:parseFloat(E.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(E){return E.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Qj=le;class de{static create(E,j){return new de(E,j)}constructor(E,j){this.d=E,this.f=j,this.type=m.Regex,this.c=null}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.d<E.d)return-1;if(this.d>E.d)return 1;const j=this.f?this.f.source:"",X=E.f?E.f.source:"";return j<X?-1:j>X?1:0}equals(E){if(E.type===this.type){const j=this.f?this.f.source:"",X=E.f?E.f.source:"";return this.d===E.d&&j===X}return!1}substituteConstants(){return this}evaluate(E){const j=E.getValue(this.d);return this.f?this.f.test(j):!1}serialize(){const E=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${E}`}keys(){return[this.d]}map(E){return E.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=H.create(this)),this.c}}e.$Rj=de;class H{static create(E){return new H(E)}constructor(E){this.c=E,this.type=m.NotRegex}cmp(E){return E.type!==this.type?this.type-E.type:this.c.cmp(E.c)}equals(E){return E.type===this.type?this.c.equals(E.c):!1}substituteConstants(){return this}evaluate(E){return!this.c.evaluate(E)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(E){return new H(this.c.map(E))}negate(){return this.c}}e.$Sj=H;function Z(z){let E=null;for(let j=0,X=z.length;j<X;j++){const F=z[j].substituteConstants();if(z[j]!==F&&E===null){E=[];for(let q=0;q<j;q++)E[q]=z[q]}E!==null&&(E[j]=F)}return E===null?z:E}class B{static create(E,j,X){return B.d(E,j,X)}constructor(E,j){this.expr=E,this.c=j,this.type=m.And}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let j=0,X=this.expr.length;j<X;j++){const F=r(this.expr[j],E.expr[j]);if(F!==0)return F}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let j=0,X=this.expr.length;j<X;j++)if(!this.expr[j].equals(E.expr[j]))return!1;return!0}return!1}substituteConstants(){const E=Z(this.expr);return E===this.expr?this:B.create(E,this.c,!1)}evaluate(E){for(let j=0,X=this.expr.length;j<X;j++)if(!this.expr[j].evaluate(E))return!1;return!0}static d(E,j,X){const F=[];let q=!1;for(const x of E)if(x){if(x.type===m.True){q=!0;continue}if(x.type===m.False)return o.INSTANCE;if(x.type===m.And){F.push(...x.expr);continue}F.push(x)}if(F.length===0&&q)return u.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(r);for(let x=1;x<F.length;x++)F[x-1].equals(F[x])&&(F.splice(x,1),x--);if(F.length===1)return F[0];for(;F.length>1;){const x=F[F.length-1];if(x.type!==m.Or)break;F.pop();const ne=F.pop(),oe=F.length===0,ce=M.create(x.expr.map(ve=>B.create([ve,ne],null,X)),null,oe);ce&&(F.push(ce),F.sort(r))}if(F.length===1)return F[0];if(X){for(let x=0;x<F.length;x++)for(let ne=x+1;ne<F.length;ne++)if(F[x].negate().equals(F[ne]))return o.INSTANCE;if(F.length===1)return F[0]}return new B(F,j)}}serialize(){return this.expr.map(E=>E.serialize()).join(" && ")}keys(){const E=[];for(const j of this.expr)E.push(...j.keys());return E}map(E){return new B(this.expr.map(j=>j.map(E)),null)}negate(){if(!this.c){const E=[];for(const j of this.expr)E.push(j.negate());this.c=M.create(E,this,!0)}return this.c}}e.$Tj=B;class M{static create(E,j,X){return M.d(E,j,X)}constructor(E,j){this.expr=E,this.c=j,this.type=m.Or}cmp(E){if(E.type!==this.type)return this.type-E.type;if(this.expr.length<E.expr.length)return-1;if(this.expr.length>E.expr.length)return 1;for(let j=0,X=this.expr.length;j<X;j++){const F=r(this.expr[j],E.expr[j]);if(F!==0)return F}return 0}equals(E){if(E.type===this.type){if(this.expr.length!==E.expr.length)return!1;for(let j=0,X=this.expr.length;j<X;j++)if(!this.expr[j].equals(E.expr[j]))return!1;return!0}return!1}substituteConstants(){const E=Z(this.expr);return E===this.expr?this:M.create(E,this.c,!1)}evaluate(E){for(let j=0,X=this.expr.length;j<X;j++)if(this.expr[j].evaluate(E))return!0;return!1}static d(E,j,X){let F=[],q=!1;if(E){for(let x=0,ne=E.length;x<ne;x++){const oe=E[x];if(oe){if(oe.type===m.False){q=!0;continue}if(oe.type===m.True)return u.INSTANCE;if(oe.type===m.Or){F=F.concat(oe.expr);continue}F.push(oe)}}if(F.length===0&&q)return o.INSTANCE;F.sort(r)}if(F.length!==0){if(F.length===1)return F[0];for(let x=1;x<F.length;x++)F[x-1].equals(F[x])&&(F.splice(x,1),x--);if(F.length===1)return F[0];if(X){for(let x=0;x<F.length;x++)for(let ne=x+1;ne<F.length;ne++)if(F[x].negate().equals(F[ne]))return u.INSTANCE;if(F.length===1)return F[0]}return new M(F,j)}}serialize(){return this.expr.map(E=>E.serialize()).join(" || ")}keys(){const E=[];for(const j of this.expr)E.push(...j.keys());return E}map(E){return new M(this.expr.map(j=>j.map(E)),null)}negate(){if(!this.c){const E=[];for(const j of this.expr)E.push(j.negate());for(;E.length>1;){const j=E.shift(),X=E.shift(),F=[];for(const q of W(j))for(const x of W(X))F.push(B.create([q,x],null,!1));E.unshift(M.create(F,null,!1))}this.c=M.create(E,this,!0)}return this.c}}e.$Uj=M;class J extends ${static{this.d=[]}static all(){return J.d.values()}constructor(E,j,X){super(E,null),this.f=j,typeof X=="object"?J.d.push({...X,key:E}):X!==!0&&J.d.push({key:E,description:X,type:j!=null?typeof j:void 0})}bindTo(E){return E.createKey(this.key,this.f)}getValue(E){return E.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(E){return N.create(this.key,E)}notEqualsTo(E){return D.create(this.key,E)}}e.$Vj=J,e.$Wj=(0,L.$Ei)("contextKeyService");function K(z,E){return z<E?-1:z>E?1:0}function ie(z,E,j,X){return z<j?-1:z>j?1:E<X?-1:E>X?1:0}function se(z,E){if(z.type===m.False||E.type===m.True)return!0;if(z.type===m.Or)return E.type===m.Or?T(z.expr,E.expr):!1;if(E.type===m.Or){for(const j of E.expr)if(se(z,j))return!0;return!1}if(z.type===m.And){if(E.type===m.And)return T(E.expr,z.expr);for(const j of z.expr)if(se(j,E))return!0;return!1}return z.equals(E)}function T(z,E){let j=0,X=0;for(;j<z.length&&X<E.length;){const F=z[j].cmp(E[X]);if(F<0)return!1;F===0&&j++,X++}return j===z.length}function W(z){return z.type===m.Or?z.expr:[z]}}),define(ue[61],he([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1o=void 0,e.$1o=(0,S.$Ei)("downloadService")}),define(ue[17],he([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,S.$Ei)("environmentService"),e.$Mi=(0,S.$Fi)(e.$Li)}),define(ue[62],he([0,1,13,7,5,9]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=L;async function L(f,c,m,d,p,I){let b;try{await O(f,c,m,d,p,I)}catch(h){b=h}finally{b&&p.errorTransformer&&(b=p.errorTransformer(b)),typeof b<"u"&&m.error(b),m.end()}}async function O(f,c,m,d,p,I){w(I);const b=await f.open(c,{create:!1});try{w(I);let h=0,g=0,R=p&&typeof p.length=="number"?p.length:void 0,y=S.$Ne.alloc(Math.min(p.bufferSize,typeof R=="number"?R:p.bufferSize)),i=p&&typeof p.position=="number"?p.position:0,l=0;do g=await f.read(b,i,y.buffer,l,y.byteLength-l),i+=g,l+=g,h+=g,typeof R=="number"&&(R-=g),l===y.byteLength&&(await m.write(d(y)),y=S.$Ne.alloc(Math.min(p.bufferSize,typeof R=="number"?R:p.bufferSize)),l=0);while(g>0&&(typeof R!="number"||R>0)&&w(I)&&a(h,p));if(l>0){let n=l;typeof R=="number"&&(n=Math.min(l,R)),m.write(d(y.slice(0,n)))}}catch(h){throw(0,k.$nl)(h)}finally{await f.close(b)}}function w(f){if(f.isCancellationRequested)throw(0,P.$5)();return!0}function a(f,c){if(typeof c?.limits?.size=="number"&&f>c.limits.size)throw(0,k.$ml)((0,v.localize)(11373,null),k.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ue[101],he([0,1,32,2,52,4,9,11,8]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;class a extends P.$Uc{constructor(){super(),this.a=this.B(new k.$le),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$le),this.onDidLogMessage=this.b.event,this.c=this.B(new k.$le),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new P.$4c),this.m=new Set,this.n=this.B(new w.$Ch(this.y())),this.r=5007,this.s=new w.$2h,this.R=!1,this.B(this.f(c=>this.t(c)))}t(c){this.u(c)&&this.z(c)}u(c){return(0,v.$3q)(c)}async watch(c){this.s.isSettled||this.s.complete(),this.s=new w.$2h;try{this.h.clear(),this.g.clear();for(const m of c)this.u(m)?this.h.set(m.correlationId,m):this.g.add(m);for(const[m]of this.j)this.h.has(m)||(this.j.deleteAndDispose(m),this.m.delete(m));return await this.w(!1)}finally{this.s.complete()}}w(c){return this.n.trigger(()=>this.N([...this.g,...Array.from(this.h.values()).filter(m=>!this.j.has(m.correlationId))]),c?this.y():0)}y(){return 800}isSuspended(c){return typeof c.correlationId!="number"?!1:this.m.has(c.correlationId)?"polling":this.j.has(c.correlationId)}async z(c){if(this.j.has(c.correlationId))return;const m=new P.$Tc;this.j.set(c.correlationId,m),await this.s.p,!m.isDisposed&&(this.D(c,m),this.w(!0))}C(c){this.j.deleteAndDispose(c.correlationId),this.m.delete(c.correlationId),this.w(!1)}D(c,m){this.F(c,m)?(this.P(`reusing an existing recursive watcher to monitor ${c.path}`),this.m.delete(c.correlationId)):(this.G(c,m),this.m.add(c.correlationId))}F(c,m){const d=this.O?.subscribe(c.path,(p,I)=>{m.isDisposed||(p?this.D(c,m):I?.type===L.FileChangeType.ADDED&&this.H(c))});return d?(m.add(d),!0):!1}G(c,m){let d=!1;const p=(I,b)=>{if(m.isDisposed)return;const h=this.I(I),g=this.I(b),R=d;d=h,!h&&(g||R)&&this.H(c)};this.P(`starting fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.watchFile)(c.path,{persistent:!1,interval:this.r},p)}catch(I){this.Q(`fs.watchFile() failed with error ${I} on path ${c.path} (correlationId: ${c.correlationId})`)}m.add((0,P.$Sc)(()=>{this.P(`stopping fs.watchFile() on ${c.path} (correlationId: ${c.correlationId})`);try{(0,S.unwatchFile)(c.path,p)}catch(I){this.Q(`fs.unwatchFile() failed with error ${I} on path ${c.path} (correlationId: ${c.correlationId})`)}}))}H(c){this.P(`detected ${c.path} exists again, resuming watcher (correlationId: ${c.correlationId})`);const m={resource:O.URI.file(c.path),type:L.FileChangeType.ADDED,cId:c.correlationId};this.a.fire([m]),this.J(m,c),this.C(c)}I(c){return c.ctimeMs===0&&c.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}J(c,m){if(this.R){const d=` >> normalized ${c.type===L.FileChangeType.ADDED?"[ADDED]":c.type===L.FileChangeType.DELETED?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`;this.L(d,m)}}L(c,m){this.R&&this.P(`${c}${typeof m.correlationId=="number"?` <${m.correlationId}> `:""}`)}M(c){return`${c.path} (excludes: ${c.excludes.length>0?c.excludes:"<none>"}, includes: ${c.includes&&c.includes.length>0?JSON.stringify(c.includes):"<all>"}, filter: ${(0,v.$ar)(c.filter)}, correlationId: ${typeof c.correlationId=="number"?c.correlationId:"<none>"})`}async setVerboseLogging(c){this.R=c}}e.$jr=a}),define(ue[102],he([0,1,4,149,101,12,150,63]),function(Y,e,S,P,v,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qr=void 0;class w extends v.$jr{constructor(f){super(),this.O=f,this.onDidError=S.Event.None,this.watchers=new Set}async N(f){f=this.Z(f);const c=[],m=new Set(Array.from(this.watchers));for(const d of f){const p=this.W(d);p&&(0,P.$Dk)(p.request.excludes,d.excludes)&&(0,P.$Dk)(p.request.includes,d.includes)?m.delete(p):c.push(d)}c.length&&this.P(`Request to start watching: ${c.map(d=>this.M(d)).join(",")}`),m.size&&this.P(`Request to stop watching: ${Array.from(m).map(d=>this.M(d.request)).join(",")}`);for(const d of m)this.Y(d);for(const d of c)this.X(d)}W(f){for(const c of this.watchers)if(typeof f.correlationId=="number"||typeof c.request.correlationId=="number"){if(c.request.correlationId===f.correlationId)return c}else if((0,O.$Cg)(c.request.path,f.path,!k.$l))return c}X(f){const c=new L.$or(f,this.O,d=>this.a.fire(d),()=>this.c.fire(f),d=>this.b.fire(d),this.R),m={request:f,instance:c};this.watchers.add(m)}async stop(){await super.stop();for(const f of this.watchers)this.Y(f)}Y(f){this.P("stopping file watcher",f),this.watchers.delete(f),f.instance.dispose()}Z(f){const c=new Map;for(const m of f){const d=k.$l?m.path:m.path.toLowerCase();let p=c.get(m.correlationId);p||(p=new Map,c.set(m.correlationId,p)),p.has(d)&&this.P(`ignoring a request for watching who's path is already watched: ${this.M(m)}`),p.set(d,m)}return Array.from(c.values()).map(m=>Array.from(m.values())).flat()}async setVerboseLogging(f){super.setVerboseLogging(f);for(const c of this.watchers)c.instance.setVerboseLogging(f)}P(f,c){this.R&&this.b.fire({type:"trace",message:this.bb(f,c)})}Q(f){this.b.fire({type:"warn",message:this.bb(f)})}bb(f,c){return c?`[File Watcher (node.js)] ${f} (${this.M(c.request)})`:`[File Watcher (node.js)] ${f}`}}e.$qr=w}),define(ue[103],he([0,1,52,102]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rr=void 0;class v extends S.$6q{constructor(L,O,w){super(L,O,w),this.s()}r(L){return L.add(new P.$qr(void 0))}}e.$rr=v}),define(ue[104],he([0,1,14,59,87,52]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=void 0;class L extends k.$7q{constructor(w,a,f){super(w,a,f),this.s()}r(w){const a=w.add(new v.$hr(S.$Yg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return w.add(a.onDidProcessExit(({code:f,signal:c})=>this.t(`terminated by itself with code ${f}, signal: ${c} (ETERM)`))),P.ProxyChannel.toService((0,P.$li)(a.getChannel("watcher")))}}e.$ir=L}),define(ue[64],he([0,1]),function(Y,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class S{constructor(...v){this.a=new Map;for(const[k,L]of v)this.set(k,L)}set(v,k){const L=this.a.get(v);return this.a.set(v,k),L}has(v){return this.a.has(v)}get(v){return this.a.get(v)}}e.$Ci=S}),define(ue[105],he([0,1,8,7,2,51,99,10,64,151]),function(Y,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;const f=!1;class c extends Error{constructor(b){super("cyclic dependency between services"),this.message=b.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${b.toString()}`}}class m{constructor(b=new w.$Ci,h=!1,g,R=f){this.i=b,this.j=h,this.k=g,this.l=R,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(O.$Di,this),this._globalGraph=R?g?._globalGraph??new L.$ur(y=>y):void 0}dispose(){if(!this.f){this.f=!0,(0,v.$Pc)(this.h),this.h.clear();for(const b of this.g)(0,v.$Oc)(b)&&b.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(b,h){this.m();const g=this,R=new class extends m{dispose(){g.h.delete(R),super.dispose()}}(b,this.j,this,this.l);return this.h.add(R),h?.add(R),R}invokeFunction(b,...h){this.m();const g=p.traceInvocation(this.l,b);let R=!1;try{return b({get:i=>{if(R)throw(0,P.$7)("service accessor is only valid during the invocation of its target method");const l=this.s(i,g);if(!l)throw new Error(`[invokeFunction] unknown service '${i}'`);return l}},...h)}finally{R=!0,g.stop()}}createInstance(b,...h){this.m();let g,R;return b instanceof k.$Bi?(g=p.traceCreation(this.l,b.ctor),R=this.o(b.ctor,b.staticArguments.concat(h),g)):(g=p.traceCreation(this.l,b),R=this.o(b,h,g)),g.stop(),R}o(b,h=[],g){const R=O._util.getServiceDependencies(b).sort((l,n)=>l.index-n.index),y=[];for(const l of R){const n=this.s(l.id,g);n||this.y(`[createInstance] ${b.name} depends on UNKNOWN service ${l.id}.`,!1),y.push(n)}const i=R.length>0?R[0].index:h.length;if(h.length!==i){console.trace(`[createInstance] First service dependency of ${b.name} at position ${i+1} conflicts with ${h.length} static arguments`);const l=i-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,i)}return Reflect.construct(b,h.concat(y))}q(b,h){if(this.i.get(b)instanceof k.$Bi)this.i.set(b,h);else if(this.k)this.k.q(b,h);else throw new Error("illegalState - setting UNKNOWN service instance")}r(b){const h=this.i.get(b);return!h&&this.k?this.k.r(b):h}s(b,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(b));const g=this.r(b);return g instanceof k.$Bi?this.u(b,g,h.branch(b,!0)):(h.branch(b,!1),g)}u(b,h,g){if(this.t.has(b))throw new Error(`illegal state - RECURSIVELY instantiating service '${b}'`);this.t.add(b);try{return this.v(b,h,g)}finally{this.t.delete(b)}}v(b,h,g){const R=new L.$ur(n=>n.id.toString());let y=0;const i=[{id:b,desc:h,_trace:g}],l=new Set;for(;i.length;){const n=i.pop();if(!l.has(String(n.id))){if(l.add(String(n.id)),R.lookupOrInsertNode(n),y++>1e3)throw new c(R);for(const s of O._util.getServiceDependencies(n.desc.ctor)){const t=this.r(s.id);if(t||this.y(`[createInstance] ${b} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(s.id)),t instanceof k.$Bi){const r={id:s.id,desc:t,_trace:n._trace.branch(s.id,!0)};R.insertEdge(n,r),i.push(r)}}}}for(;;){const n=R.roots();if(n.length===0){if(!R.isEmpty())throw new c(R);break}for(const{data:s}of n){if(this.r(s.id)instanceof k.$Bi){const r=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,r)}R.removeNode(s)}}return this.r(b)}w(b,h,g=[],R,y){if(this.i.get(b)instanceof k.$Bi)return this.x(b,h,g,R,y,this.g);if(this.k)return this.k.w(b,h,g,R,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}x(b,h,g=[],R,y,i){if(R){const l=new m(void 0,this.j,this,this.l);l.c=String(b);const n=new Map,s=new S.$Xh(()=>{const t=l.o(h,g,y);for(const[r,o]of n){const u=t[r];if(typeof u=="function")for(const $ of o)$.disposable=u.apply(t,$.listener)}return n.clear(),i.add(t),t});return new Proxy(Object.create(null),{get(t,r){if(!s.isInitialized&&typeof r=="string"&&(r.startsWith("onDid")||r.startsWith("onWill"))){let $=n.get(r);return $||($=new a.$5c,n.set(r,$)),(C,A,D)=>{if(s.isInitialized)return s.value[r](C,A,D);{const U={listener:[C,A,D],disposable:void 0},G=$.push(U);return(0,v.$Sc)(()=>{G(),U.disposable?.dispose()})}}}if(r in t)return t[r];const o=s.value;let u=o[r];return typeof u!="function"||(u=u.bind(o),t[r]=u),u},set(t,r,o){return s.value[r]=o,!0},getPrototypeOf(t){return h.prototype}})}else{const l=this.o(h,g,y);return i.add(l),l}}y(b,h){if(h&&console.warn(b),this.j)throw new Error(b)}}e.$vr=m;var d;(function(I){I[I.None=0]="None",I[I.Creation=1]="Creation",I[I.Invocation=2]="Invocation",I[I.Branch=3]="Branch"})(d||(d={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(d.None,null)}stop(){}branch(){return this}}}static traceInvocation(b,h){return b?new p(d.Invocation,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(b,h){return b?new p(d.Creation,h.name):p.c}static{this.f=0}constructor(b,h){this.type=b,this.name=h,this.g=Date.now(),this.h=[]}branch(b,h){const g=new p(d.Branch,b.toString());return this.h.push([b,h,g]),g}stop(){const b=Date.now()-this.g;p.f+=b;let h=!1;function g(y,i){const l=[],n=new Array(y+1).join("	");for(const[s,t,r]of i.h)if(t&&r){h=!0,l.push(`${n}CREATES -> ${s}`);const o=g(y+1,r);o&&l.push(o)}else l.push(`${n}uses -> ${s}`);return l.join(`
`)}const R=[`${this.type===d.Creation?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${b.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(b>2||h)&&p.all.add(R.join(`
`))}}e.$wr=p}),define(ue[6],he([0,1,5,38,4,43,2,25,12,16,3,11,100,10]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=I,e.log=h,e.$nk=u,e.$ok=$,e.$pk=N,e.$qk=C,S=ye(S),e.$_j=(0,d.$Ei)("logService"),e.$ak=(0,d.$Ei)("loggerService");function p(){return new Date().toISOString()}function I(A){return(0,f.$ig)(A)}var b;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$ck=b.Info;function h(A,D,U){switch(D){case b.Trace:A.trace(U);break;case b.Debug:A.debug(U);break;case b.Info:A.info(U);break;case b.Warning:A.warn(U);break;case b.Error:A.error(U);break;case b.Off:break;default:throw new Error(`Invalid log level ${D}`)}}function g(A,D=!1){let U="";for(let G=0;G<A.length;G++){let Q=A[G];if(Q instanceof Error&&(Q=(0,P.$pj)(Q,D)),typeof Q=="object")try{Q=JSON.stringify(Q)}catch{}U+=(G>0?" ":"")+Q}return U}class R extends L.$Uc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new v.$le),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==b.Off&&this.b<=D}}e.$ek=R;class y extends R{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...U){this.f(b.Trace)&&this.g(b.Trace,g([D,...U],!0))}debug(D,...U){this.f(b.Debug)&&this.g(b.Debug,g([D,...U]))}info(D,...U){this.f(b.Info)&&this.g(b.Info,g([D,...U]))}warn(D,...U){this.f(b.Warning)&&this.g(b.Warning,g([D,...U]))}error(D,...U){if(this.f(b.Error))if(D instanceof Error){const G=Array.prototype.slice.call(arguments);G[0]=D.stack,this.g(b.Error,g(G))}else this.g(b.Error,g([D,...U]))}flush(){}}e.$fk=y;class i extends R{constructor(D=e.$ck){super(),this.setLevel(D),this.g=!w.$j}trace(D,...U){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,D,...U):console.log(`[main ${p()}]`,D,...U))}debug(D,...U){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,D,...U):console.log(`[main ${p()}]`,D,...U))}info(D,...U){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,D,...U):console.log(`[main ${p()}]`,D,...U))}warn(D,...U){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,D,...U):console.warn(`[main ${p()}]`,D,...U))}error(D,...U){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,D,...U):console.error(`[main ${p()}]`,D,...U))}flush(){}}e.$gk=i;class l extends R{constructor(D=e.$ck,U=!0){super(),this.g=U,this.setLevel(D)}trace(D,...U){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...U):console.log(D,...U))}debug(D,...U){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...U):console.log(D,...U))}info(D,...U){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...U):console.log(D,...U))}warn(D,...U){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...U):console.log(D,...U))}error(D,...U){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...U):console.error(D,...U))}flush(){}}e.$hk=l;class n extends R{constructor(D,U=e.$ck){super(),this.g=D,this.setLevel(U)}trace(D,...U){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(D),...U])}debug(D,...U){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(D),...U])}info(D,...U){this.f(b.Info)&&this.g.log(b.Info,[this.h(D),...U])}warn(D,...U){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(D),...U])}error(D,...U){this.f(b.Error)&&this.g.log(b.Error,[this.h(D),...U])}h(D){return typeof D=="string"?D:(0,P.$pj)(D,this.f(b.Trace))}flush(){}}e.$ik=n;class s extends R{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const U of this.g)U.setLevel(D);super.setLevel(D)}trace(D,...U){for(const G of this.g)G.trace(D,...U)}debug(D,...U){for(const G of this.g)G.debug(D,...U)}info(D,...U){for(const G of this.g)G.info(D,...U)}warn(D,...U){for(const G of this.g)G.warn(D,...U)}error(D,...U){for(const G of this.g)G.error(D,...U)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose();super.dispose()}}e.$jk=s;class t extends L.$Uc{constructor(D,U,G){if(super(),this.h=D,this.j=U,this.b=new O.$Ac,this.c=this.B(new v.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new v.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new v.$le),this.onDidChangeVisibility=this.g.event,G)for(const Q of G)this.b.set(Q.resource,{logger:void 0,info:Q})}m(D){return(0,f.$eg)(D)?[...this.b.values()].find(U=>U.info.id===D):this.b.get(D)}getLogger(D){return this.m(D)?.logger}createLogger(D,U){const G=this.n(D),Q=(0,f.$eg)(D)?D:U?.id??(0,k.$sj)(G.toString()).toString(16);let te=this.b.get(G)?.logger;const ae=U?.logLevel==="always"?b.Trace:U?.logLevel;te||(te=this.s(G,ae??this.getLogLevel(G)??this.h,{...U,id:Q}));const le={logger:te,info:{resource:G,id:Q,logLevel:ae,name:U?.name,hidden:U?.hidden,extensionId:U?.extensionId,when:U?.when}};return this.registerLogger(le.info),this.b.set(G,le),te}n(D){return(0,f.$eg)(D)?(0,a.$fh)(this.j,`${D}.log`):D}setLogLevel(D,U){if(c.URI.isUri(D)){const G=D,Q=U,te=this.b.get(G);te&&Q!==te.info.logLevel&&(te.info.logLevel=Q===this.h?void 0:Q,te.logger?.setLevel(Q),this.b.set(te.info.resource,te),this.f.fire([G,Q]))}else{this.h=D;for(const[G,Q]of this.b.entries())this.b.get(G)?.info.logLevel===void 0&&Q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,U){const G=this.m(D);G&&U!==!G.info.hidden&&(G.info.hidden=!U,this.b.set(G.info.resource,G),this.g.fire([G.info.resource,U]))}getLogLevel(D){let U;return D&&(U=this.b.get(D)?.info.logLevel),U??this.h}registerLogger(D){const U=this.b.get(D.resource);U?U.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const U=this.b.get(D);U&&(U.logger&&U.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[U.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=t;class r{constructor(){this.onDidChangeLogLevel=new v.$le().event}setLevel(D){}getLevel(){return b.Info}trace(D,...U){}debug(D,...U){}info(D,...U){}warn(D,...U){}error(D,...U){}critical(D,...U){}dispose(){}flush(){}}e.$lk=r;class o extends r{}e.$mk=o;function u(A){if(A.verbose)return b.Trace;if(typeof A.logLevel=="string"){const D=C(A.logLevel.toLowerCase());if(D!==void 0)return D}return e.$ck}function $(A){switch(A){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}function N(A){switch(A){case b.Trace:return{original:"Trace",value:S.localize(11307,null)};case b.Debug:return{original:"Debug",value:S.localize(11308,null)};case b.Info:return{original:"Info",value:S.localize(11309,null)};case b.Warning:return{original:"Warning",value:S.localize(11310,null)};case b.Error:return{original:"Error",value:S.localize(11311,null)};case b.Off:return{original:"Off",value:S.localize(11312,null)}}}function C(A){switch(A){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$rk=new m.$Vj("logLevel",$(b.Info))}),define(ue[106],he([0,1,19,8,7,4,63,2,15,52,6]),function(Y,e,S,P,v,k,L,O,w,a,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class c extends O.$Uc{constructor(d,p){super(),this.a=d,this.b=p,this.c=this.B(new k.$le),this.onDidChangeFile=this.c.event,this.g=this.B(new k.$le),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new P.$Ch(0)),this.w=[],this.y=this.B(new P.$Ch(0))}watch(d,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(d,p):this.z(d,p)}n(d,p){const I={path:this.J(d),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},b=(0,S.$Sb)(this.j,I);return this.r(),(0,O.$Sc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(d=>(0,v.$Y)(d))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,a.$8q)(p)),p=>this.G(p),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)})));const d=this.b?.watcher?.recursive?.usePolling;if(d===!0)for(const p of this.j)(0,a.$4q)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(d))for(const p of this.j)(0,a.$4q)(p)&&d.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(d,p){const I={path:this.J(d),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},b=(0,S.$Sb)(this.w,I);return this.C(),(0,O.$Sc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(d=>(0,v.$Y)(d))}D(){return this.u||(this.u=this.B(this.F(d=>this.c.fire((0,a.$8q)(d)),d=>this.G(d),this.a.getLevel()===f.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===f.LogLevel.Trace)}))),this.u.watch(this.w)}G(d){d.type==="error"&&this.g.fire(d.message),this.H(d)}H(d){this.a[d.type](d.message)}I(d){return(0,w.$hc)(d.fsPath)}J(d){const p=this.I(d);return(0,L.$Gg)(p)}}e.$br=c});var re=this&&this.__param||function(Y,e){return function(S,P){e(S,P,Y)}};define(ue[107],he([0,1,19,8,13,21,4,43,65,2,49,14,108,16,47,5,9,62,6,7]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g,R){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;let i=class extends a.$Uc{static{y=this}constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new L.$le),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$le),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$le),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new L.$le),this.onDidRunOperation=this.r.event,this.X=this.B(new L.$le),this.Y=this.B(new L.$le),this.onDidFilesChange=this.Y.event,this.Z=this.B(new L.$le),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new P.$Nh)}registerProvider(n,s){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${n}`);const t=new a.$Tc;return this.h.set(n,s),this.c.fire({added:!0,scheme:n,provider:s}),t.add(s.onDidChangeFile(r=>{const o=new b.$sl(r,!this.S(s));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof s.onDidWatchError=="function"&&t.add(s.onDidWatchError(r=>this.Z.fire(new Error(r)))),t.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:n}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:n,provider:s}),this.h.delete(n),(0,a.$Pc)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const s=[];this.f.fire({scheme:n,join(t){s.push(t)}}),!this.h.has(n)&&await P.Promises.settled(s)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,s){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return w.Iterable.map(this.h,([n,s])=>({scheme:n,capabilities:s.capabilities}))}async j(n){if(!(0,d.$jh)(n))throw new b.$ul((0,I.localize)(11380,null,this.sb(n)),b.FileOperationResult.FILE_INVALID_PATH);await this.activateProvider(n.scheme);const s=this.h.get(n.scheme);if(!s){const t=new R.$ab;throw t.message=(0,I.localize)(11381,null,n.toString()),t}return s}async m(n){const s=await this.j(n);if((0,b.$fl)(s)||(0,b.$cl)(s)||(0,b.$gl)(s))return s;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(n){const s=await this.j(n);if((0,b.$fl)(s)||(0,b.$cl)(s))return s;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,s){try{return await this.s(n,s)}catch(t){throw(0,b.$pl)(t)===b.FileSystemProviderErrorCode.FileNotFound?new b.$ul((0,I.localize)(11382,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND):(0,b.$nl)(t)}}async s(n,s){const t=await this.j(n),r=this.S(t),o=s?.resolveTo,u=s?.resolveSingleChildDescendants,$=s?.resolveMetadata,N=await t.stat(n);let C;return this.t(t,n,N,void 0,!!$,(A,D)=>(C||(C=f.$Ki.forUris(()=>!r),C.set(n,!0),o&&C.fill(!0,o)),C.get(A.resource)||C.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&u?D===1:!1))}async t(n,s,t,r,o,u){const{providerExtUri:$}=this.R(n),N={resource:s,name:$.basename(s),isFile:(t.type&b.FileType.File)!==0,isDirectory:(t.type&b.FileType.Directory)!==0,isSymbolicLink:(t.type&b.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&b.FilePermission.Readonly)||!!(n.capabilities&b.FileSystemProviderCapabilities.Readonly),locked:!!((t.permissions??0)&b.FilePermission.Locked),etag:(0,b.$Fl)({mtime:t.mtime,size:t.size}),children:void 0};if(N.isDirectory&&u(N,r)){try{const C=await n.readdir(s),A=await P.Promises.settled(C.map(async([D,U])=>{try{const G=$.joinPath(s,D),Q=o?await n.stat(G):{type:U};return await this.t(n,G,Q,C.length,o,u)}catch(G){return this.b.trace(G),null}}));N.children=(0,S.$Gb)(A)}catch(C){this.b.trace(C),N.children=[]}return N}return N}async resolveAll(n){return P.Promises.settled(n.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const s=await this.j(n),t=await s.stat(n);return this.t(s,n,t,void 0,!0,()=>!1)}async exists(n){const s=await this.j(n);try{return!!await s.stat(n)}catch{return!1}}async canCreateFile(n,s){try{await this.u(n,s)}catch(t){return t}return!0}async u(n,s){if(!s?.overwrite&&await this.exists(n))throw new b.$ul((0,I.localize)(11383,null,this.sb(n)),b.FileOperationResult.FILE_MODIFIED_SINCE,s)}async createFile(n,s=v.$Ne.fromString(""),t){await this.u(n,t);const r=await this.writeFile(n,s);return this.r.fire(new b.$rl(n,b.FileOperation.CREATE,r)),r}async writeFile(n,s,t){const r=this.qb(await this.n(n),n),{providerExtUri:o}=this.R(r);let u=t;if((0,b.$il)(r)&&!u?.atomic){const $=r.enforceAtomicWriteFile?.(n);$&&(u={...t,atomic:$})}try{await this.w(r,n,u)||await this.U(r,o.dirname(n));let N;if((0,b.$cl)(r)&&!(s instanceof v.$Ne))if((0,p.$ze)(s)){const C=await(0,p.$Ge)(s,3);C.ended?N=v.$Ne.concat(C.buffer):N=C}else N=(0,p.$De)(s,C=>v.$Ne.concat(C),3);else N=s;!(0,b.$fl)(r)||(0,b.$cl)(r)&&N instanceof v.$Ne||(0,b.$cl)(r)&&(0,b.$il)(r)&&u?.atomic?await this.hb(r,n,u,N):await this.db(r,n,u,N instanceof v.$Ne?(0,v.$Ye)(N):N),this.r.fire(new b.$rl(n,b.FileOperation.WRITE))}catch($){throw new b.$ul((0,I.localize)(11384,null,this.sb(n),(0,b.$nl)($).toString()),(0,b.$ql)($),u)}return this.resolve(n,{resolveMetadata:!0})}async w(n,s,t){const r=!!t?.unlock;if(r&&!(n.capabilities&b.FileSystemProviderCapabilities.FileWriteUnlock))throw new Error((0,I.localize)(11385,null,this.sb(s)));if(!!t?.atomic){if(!(n.capabilities&b.FileSystemProviderCapabilities.FileAtomicWrite))throw new Error((0,I.localize)(11386,null,this.sb(s)));if(!(n.capabilities&b.FileSystemProviderCapabilities.FileReadWrite))throw new Error((0,I.localize)(11387,null,this.sb(s)));if(r)throw new Error((0,I.localize)(11388,null,this.sb(s)))}let u;try{u=await n.stat(s)}catch{return}if(u.type&b.FileType.Directory)throw new b.$ul((0,I.localize)(11389,null,this.sb(s)),b.FileOperationResult.FILE_IS_DIRECTORY,t);if(this.rb(s,u),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==b.$El&&typeof u.mtime=="number"&&typeof u.size=="number"&&t.mtime<u.mtime&&t.etag!==(0,b.$Fl)({mtime:t.mtime,size:u.size}))throw new b.$ul((0,I.localize)(11390,null),b.FileOperationResult.FILE_MODIFIED_SINCE,t);return u}async readFile(n,s,t){const r=await this.m(n);return s?.atomic?this.z(r,n,s,t):this.C(r,n,s,t)}async z(n,s,t,r){return new Promise((o,u)=>{this.cb.queueFor(s,async()=>{try{const $=await this.C(n,s,t,r);o($)}catch($){u($)}},this.R(n).providerExtUri)})}async C(n,s,t,r){const o=await this.D(n,s,{...t,preferUnbuffered:!0},r);return{...o,value:await(0,v.$Ze)(o.value)}}async readFileStream(n,s,t){const r=await this.m(n);return this.D(r,n,s,t)}async D(n,s,t,r){const o=new k.$we(r);let u=t;(0,b.$hl)(n)&&n.enforceAtomicReadFile?.(s)&&(u={...t,atomic:!0});const $=this.J(s,u).then(C=>C,C=>{throw o.dispose(!0),C});let N;try{return typeof u?.etag=="string"&&u.etag!==b.$El&&await $,u?.atomic&&(0,b.$hl)(n)||!((0,b.$fl)(n)||(0,b.$gl)(n))||(0,b.$cl)(n)&&u?.preferUnbuffered?N=this.I(n,s,u):(0,b.$gl)(n)?N=this.G(n,s,o.token,u):N=this.H(n,s,o.token,u),N.on("end",()=>o.dispose()),N.on("error",()=>o.dispose()),{...await $,value:N}}catch(C){throw N&&await(0,p.$Ee)(N),this.F(C,s,u)}}F(n,s,t){const r=(0,I.localize)(11391,null,this.sb(s),(0,b.$nl)(n).toString());return n instanceof b.$wl?new b.$wl(r,n.stat,t):n instanceof b.$vl?new b.$vl(r,n.fileOperationResult,n.size,n.options):new b.$ul(r,(0,b.$ql)(n),t)}G(n,s,t,r=Object.create(null)){const o=n.readFileStream(s,r,t);return(0,p.$Ke)(o,{data:u=>u instanceof v.$Ne?u:v.$Ne.wrap(u),error:u=>this.F(u,s,r)},u=>v.$Ne.concat(u))}H(n,s,t,r=Object.create(null)){const o=(0,v.$4e)();return(0,h.$1q)(n,s,o,u=>u,{...r,bufferSize:this.a,errorTransformer:u=>this.F(u,s,r)},t),o}I(n,s,t){const r=(0,p.$Be)(o=>v.$Ne.concat(o));return(async()=>{try{let o;t?.atomic&&(0,b.$hl)(n)?o=await n.readFile(s,{atomic:!0}):o=await n.readFile(s),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(s,o.byteLength,t),r.end(v.$Ne.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async J(n,s){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new b.$ul((0,I.localize)(11392,null,this.sb(n)),b.FileOperationResult.FILE_IS_DIRECTORY,s);if(typeof s?.etag=="string"&&s.etag!==b.$El&&s.etag===t.etag)throw new b.$wl((0,I.localize)(11393,null),t,s);return this.L(n,t.size,s),t}L(n,s,t){if(typeof t?.limits?.size=="number"&&s>t.limits.size)throw new b.$vl((0,I.localize)(11394,null,this.sb(n)),b.FileOperationResult.FILE_TOO_LARGE,s,t)}async canMove(n,s,t){return this.M(n,s,"move",t)}async canCopy(n,s,t){return this.M(n,s,"copy",t)}async M(n,s,t,r){if(n.toString()!==s.toString())try{const o=t==="move"?this.qb(await this.n(n),n):await this.m(n),u=this.qb(await this.n(s),s);await this.Q(o,n,u,s,t,r)}catch(o){return o}return!0}async move(n,s,t){const r=this.qb(await this.n(n),n),o=this.qb(await this.n(s),s),u=await this.N(r,n,o,s,"move",!!t),$=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$rl(n,u==="move"?b.FileOperation.MOVE:b.FileOperation.COPY,$)),$}async copy(n,s,t){const r=await this.m(n),o=this.qb(await this.n(s),s),u=await this.N(r,n,o,s,"copy",!!t),$=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new b.$rl(n,u==="copy"?b.FileOperation.COPY:b.FileOperation.MOVE,$)),$}async N(n,s,t,r,o,u){if(s.toString()===r.toString())return o;const{exists:$,isSameResourceWithDifferentPathCase:N}=await this.Q(n,s,t,r,o,u);if($&&!N&&u&&await this.del(r,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(r)),o==="copy"){if(n===t&&(0,b.$dl)(n))await n.copy(s,r,{overwrite:u});else{const C=await this.resolve(s);C.isDirectory?await this.P(n,C,t,r):await this.O(n,s,t,r)}return o}else return n===t?(await n.rename(s,r,{overwrite:u}),o):(await this.N(n,s,t,r,"copy",u),await this.del(s,{recursive:!0}),"copy")}async O(n,s,t,r){if((0,b.$fl)(n)&&(0,b.$fl)(t))return this.jb(n,s,t,r);if((0,b.$fl)(n)&&(0,b.$cl)(t))return this.pb(n,s,t,r);if((0,b.$cl)(n)&&(0,b.$fl)(t))return this.nb(n,s,t,r);if((0,b.$cl)(n)&&(0,b.$cl)(t))return this.lb(n,s,t,r)}async P(n,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await P.Promises.settled(s.children.map(async o=>{const u=this.R(t).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.P(n,await this.resolve(o.resource),t,u):this.O(n,o.resource,t,u)}))}async Q(n,s,t,r,o,u){let $=!1;if(n===t){const{providerExtUri:C,isPathCaseSensitive:A}=this.R(n);if(A||($=C.isEqual(s,r)),$&&o==="copy")throw new Error((0,I.localize)(11395,null,this.sb(s),this.sb(r)));if(!$&&C.isEqualOrParent(r,s))throw new Error((0,I.localize)(11396,null,this.sb(s),this.sb(r)))}const N=await this.exists(r);if(N&&!$){if(!u)throw new b.$ul((0,I.localize)(11397,null,this.sb(s),this.sb(r)),b.FileOperationResult.FILE_MOVE_CONFLICT);if(n===t){const{providerExtUri:C}=this.R(n);if(C.isEqualOrParent(s,r))throw new Error((0,I.localize)(11398,null,this.sb(s),this.sb(r)))}}return{exists:N,isSameResourceWithDifferentPathCase:$}}R(n){const s=this.S(n);return{providerExtUri:s?d.$8g:d.$0g,isPathCaseSensitive:s}}S(n){return!!(n.capabilities&b.FileSystemProviderCapabilities.PathCaseSensitive)}async createFolder(n){const s=this.qb(await this.j(n),n);await this.U(s,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new b.$rl(n,b.FileOperation.CREATE,t)),t}async U(n,s){const t=[],{providerExtUri:r}=this.R(n);for(;!r.isEqual(s,r.dirname(s));)try{if(!((await n.stat(s)).type&b.FileType.Directory))throw new Error((0,I.localize)(11399,null,this.sb(s)));break}catch(o){if((0,b.$pl)(o)!==b.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(r.basename(s)),s=r.dirname(s)}for(let o=t.length-1;o>=0;o--){s=r.joinPath(s,t[o]);try{await n.mkdir(s)}catch(u){if((0,b.$pl)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(n,s){try{await this.W(n,s)}catch(t){return t}return!0}async W(n,s){const t=this.qb(await this.j(n),n),r=!!s?.useTrash;if(r&&!(t.capabilities&b.FileSystemProviderCapabilities.Trash))throw new Error((0,I.localize)(11400,null,this.sb(n)));const o=s?.atomic;if(o&&!(t.capabilities&b.FileSystemProviderCapabilities.FileAtomicDelete))throw new Error((0,I.localize)(11401,null,this.sb(n)));if(r&&o)throw new Error((0,I.localize)(11402,null,this.sb(n)));let u;try{u=await t.stat(n)}catch{}if(u)this.rb(n,u);else throw new b.$ul((0,I.localize)(11403,null,this.sb(n)),b.FileOperationResult.FILE_NOT_FOUND);if(!!!s?.recursive){const N=await this.resolve(n);if(N.isDirectory&&Array.isArray(N.children)&&N.children.length>0)throw new Error((0,I.localize)(11404,null,this.sb(n)))}return t}async del(n,s){const t=await this.W(n,s);let r=s;if((0,b.$jl)(t)&&!r?.atomic){const N=t.enforceAtomicDelete?.(n);N&&(r={...s,atomic:N})}const o=!!r?.useTrash,u=!!r?.recursive,$=r?.atomic??!1;await t.delete(n,{recursive:u,useTrash:o,atomic:$}),this.r.fire(new b.$rl(n,b.FileOperation.DELETE))}async cloneFile(n,s){const t=await this.j(n),r=this.qb(await this.n(s),s);if(!(t===r&&this.R(t).providerExtUri.isEqual(n,s)))return t===r&&(0,b.$el)(t)?t.cloneFile(n,s):(await this.U(r,this.R(r).providerExtUri.dirname(s)),t===r&&(0,b.$dl)(t)?this.cb.queueFor(n,()=>t.copy(n,s,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(n,()=>this.O(t,n,r,s),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(n,s){return this.watch(n,{...s,correlationId:y.ab++})}watch(n,s={recursive:!1,excludes:[]}){const t=new a.$Tc;let r=!1,o=()=>{r=!0};t.add((0,a.$Sc)(()=>o())),(async()=>{try{const $=await this.bb(n,s);r?(0,a.$Pc)($):o=()=>(0,a.$Pc)($)}catch($){this.b.error($)}})();const u=s.correlationId;if(typeof u=="number"){const $=t.add(new L.$le);return t.add(this.X.event(C=>{C.correlates(u)&&$.fire(C)})),{onDidChange:$.event,dispose:()=>t.dispose()}}return t}async bb(n,s){const t=await this.j(n),r=(0,O.$sj)([this.R(t).providerExtUri.getComparisonKey(n),s]);let o=this.$.get(r);return o||(o={count:0,disposable:t.watch(n,s)},this.$.set(r,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(r)))})}dispose(){super.dispose();for(const[,n]of this.$)(0,a.$Pc)(n.disposable);this.$.clear()}async db(n,s,t,r){return this.cb.queueFor(s,async()=>{const o=await n.open(s,{create:!0,unlock:t?.unlock??!1});try{(0,p.$ze)(r)||(0,p.$Ae)(r)?await this.eb(n,o,r):await this.fb(n,o,r)}catch(u){throw(0,b.$nl)(u)}finally{await n.close(o)}},this.R(n).providerExtUri)}async eb(n,s,t){let r=0,o;if((0,p.$Ae)(t)){if(t.buffer.length>0){const u=v.$Ne.concat(t.buffer);await this.gb(n,s,u,u.byteLength,r,0),r+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((u,$)=>{(0,p.$Fe)(o,{onData:async N=>{o.pause();try{await this.gb(n,s,N,N.byteLength,r,0)}catch(C){return $(C)}r+=N.byteLength,setTimeout(()=>o.resume())},onError:N=>$(N),onEnd:()=>u()})})}async fb(n,s,t){let r=0,o;for(;(o=t.read())!==null;)await this.gb(n,s,o,o.byteLength,r,0),r+=o.byteLength}async gb(n,s,t,r,o,u){let $=0;for(;$<r;){const N=await n.write(s,o+$,t.buffer,u+$,r-$);$+=N}}async hb(n,s,t,r){return this.cb.queueFor(s,()=>this.ib(n,s,t,r),this.R(n).providerExtUri)}async ib(n,s,t,r){let o;r instanceof v.$Ne?o=r:(0,p.$ze)(r)?o=await(0,v.$Ze)(r):(0,p.$Ae)(r)?o=await(0,v.$1e)(r):o=(0,v.$Xe)(r),await n.writeFile(s,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(n,s,t,r){return this.cb.queueFor(r,()=>this.kb(n,s,t,r),this.R(t).providerExtUri)}async kb(n,s,t,r){let o,u;try{o=await n.open(s,{create:!1}),u=await t.open(r,{create:!0,unlock:!1});const $=v.$Ne.alloc(this.a);let N=0,C=0,A=0;do A=await n.read(o,N,$.buffer,C,$.byteLength-C),await this.gb(t,u,$,A,N,C),N+=A,C+=A,C===$.byteLength&&(C=0);while(A>0)}catch($){throw(0,b.$nl)($)}finally{await P.Promises.settled([typeof o=="number"?n.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async lb(n,s,t,r){return this.cb.queueFor(r,()=>this.mb(n,s,t,r),this.R(t).providerExtUri)}async mb(n,s,t,r){return t.writeFile(r,await n.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(n,s,t,r){return this.cb.queueFor(r,()=>this.ob(n,s,t,r),this.R(t).providerExtUri)}async ob(n,s,t,r){const o=await t.open(r,{create:!0,unlock:!1});try{const u=await n.readFile(s);await this.gb(t,o,v.$Ne.wrap(u),u.byteLength,0,0)}catch(u){throw(0,b.$nl)(u)}finally{await t.close(o)}}async pb(n,s,t,r){const o=await(0,v.$Ze)(this.H(n,s,k.CancellationToken.None));await this.hb(t,r,void 0,o)}qb(n,s){if(n.capabilities&b.FileSystemProviderCapabilities.Readonly)throw new b.$ul((0,I.localize)(11405,null,this.sb(s)),b.FileOperationResult.FILE_PERMISSION_DENIED);return n}rb(n,s){if((s.permissions??0)&b.FilePermission.Readonly)throw new b.$ul((0,I.localize)(11406,null,this.sb(n)),b.FileOperationResult.FILE_PERMISSION_DENIED)}sb(n){return n.scheme===c.Schemas.file?n.fsPath:n.toString(!0)}};e.$2q=i,e.$2q=i=y=be([re(0,g.$_j)],i)}),define(ue[109],he([0,1,32,8,25,13,4,63,2,15,12,16,47,29,5,9,62,106,104,103]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sr=void 0;class y extends h.$br{static{this.L=!1}constructor(l,n){super(l,n),this.onDidChangeCapabilities=L.Event.None,this.P=new v.$Ac(s=>c.$9g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=I.FileSystemProviderCapabilities.FileReadWrite|I.FileSystemProviderCapabilities.FileOpenReadWriteClose|I.FileSystemProviderCapabilities.FileReadStream|I.FileSystemProviderCapabilities.FileFolderCopy|I.FileSystemProviderCapabilities.FileWriteUnlock|I.FileSystemProviderCapabilities.FileAtomicRead|I.FileSystemProviderCapabilities.FileAtomicWrite|I.FileSystemProviderCapabilities.FileAtomicDelete|I.FileSystemProviderCapabilities.FileClone,f.$l&&(this.M|=I.FileSystemProviderCapabilities.PathCaseSensitive)),this.M}async stat(l){try{const{stat:n,symbolicLink:s}=await d.SymlinkSupport.stat(this.I(l));return{type:this.O(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:I.FilePermission.Locked}}catch(n){throw this.hb(n)}}async N(l){try{return await this.stat(l)}catch{return}}async readdir(l){try{const n=await d.Promises.readdir(this.I(l),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async t=>{try{let r;t.isSymbolicLink()?r=(await this.stat((0,c.$fh)(l,t.name))).type:r=this.O(t),s.push([t.name,r])}catch(r){this.a.trace(r)}})),s}catch(n){throw this.hb(n)}}O(l,n){let s;return n?.dangling?s=I.FileType.Unknown:l.isFile()?s=I.FileType.File:l.isDirectory()?s=I.FileType.Directory:s=I.FileType.Unknown,n&&(s|=I.FileType.SymbolicLink),s}async Q(l){const n=this.I(l);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.P.get(l);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const t=new P.$Dh;return this.P.set(l,t),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,w.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.P.get(l)===t&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.P.delete(l)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),t.open()})}async readFile(l,n){let s;try{n?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(l)})`),s=await this.Q(l));const t=this.I(l);return await S.promises.readFile(t)}catch(t){throw this.hb(t)}finally{s?.dispose()}}R(l){y.L&&this.a.trace(l)}readFileStream(l,n,s){const t=(0,m.$Be)(r=>k.$Ne.concat(r.map(o=>k.$Ne.wrap(o))).buffer);return(0,b.$1q)(this,l,t,r=>r.buffer,{...n,bufferSize:256*1024},s),t}async writeFile(l,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(l)?this.U(l,(0,c.$fh)((0,c.$eh)(l),`${(0,c.$ch)(l)}${s.atomic.postfix}`),n,s):this.W(l,n,s)}async S(l){try{const n=this.I(l),{symbolicLink:s}=await d.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async U(l,n,s,t){const r=new w.$Tc;try{r.add(await this.Q(l)),r.add(await this.Q(n)),await this.W(n,s,t,!0);try{await this.rename(n,l,{overwrite:!0})}catch(o){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}finally{r.dispose()}}async W(l,n,s,t){let r;try{const o=this.I(l);if(!s.create||!s.overwrite){if(await d.Promises.exists(o)){if(!s.overwrite)throw(0,I.$ml)((0,p.localize)(11364,null),I.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,I.$ml)((0,p.localize)(11365,null),I.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(l,{create:!0,unlock:s.unlock},t),await this.write(r,0,n,0,n.byteLength)}catch(o){throw await this.ib(l,o)}finally{typeof r=="number"&&await this.close(r)}}static{this.$=!0}static configureFlushOnWrite(l){y.$=l}async open(l,n,s){const t=this.I(l);let r;(0,I.$al)(n)&&!s&&(r=await this.Q(l));let o;try{if((0,I.$al)(n)&&n.unlock)try{const{stat:$}=await d.SymlinkSupport.stat(t);$.mode&128||await S.promises.chmod(t,$.mode|128)}catch($){$.code!=="ENOENT"&&this.a.trace($)}let u;if((0,I.$al)(n)){if(f.$j)try{await S.promises.truncate(t,0),u="r+"}catch($){$.code!=="ENOENT"&&this.a.trace($)}u||(u="w")}else u="r";o=await d.Promises.open(t,u)}catch(u){throw r?.dispose(),(0,I.$al)(n)?await this.ib(l,u):this.hb(u)}if(this.X.set(o,0),(0,I.$al)(n)&&this.Z.set(o,l),r){const u=this.Y.get(o);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${o} (${t})`),this.Y.set(o,r),u&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${o} (${t})`),u.dispose())}return o}async close(l){const n=this.Y.get(l);try{if(this.X.delete(l),this.Z.delete(l)&&y.$)try{await d.Promises.fdatasync(l)}catch(s){y.configureFlushOnWrite(!1),this.a.error(s)}return await d.Promises.close(l)}catch(s){throw this.hb(s)}finally{n&&(this.Y.get(l)===n&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${l}`),this.Y.delete(l)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${l}`),n.dispose())}}async read(l,n,s,t,r){const o=this.ab(l,n);let u=null;try{u=(await d.Promises.read(l,s,t,r,o)).bytesRead}catch($){throw this.hb($)}finally{this.bb(l,o,u)}return u}ab(l,n){return n===this.X.get(l)?null:n}bb(l,n,s){const t=this.X.get(l);typeof t=="number"&&(typeof n=="number"||(typeof s=="number"?this.X.set(l,t+s):this.X.delete(l)))}async write(l,n,s,t,r){return(0,P.$Yh)(()=>this.cb(l,n,s,t,r),100,3)}async cb(l,n,s,t,r){const o=this.ab(l,n);let u=null;try{u=(await d.Promises.write(l,s,t,r,o)).bytesWritten}catch($){throw await this.ib(this.Z.get(l),$)}finally{this.bb(l,o,u)}return u}async mkdir(l){try{await S.promises.mkdir(this.I(l))}catch(n){throw this.hb(n)}}async delete(l,n){try{const s=this.I(l);if(n.recursive){let t;n?.atomic!==!1&&n.atomic.postfix&&(t=(0,a.$jc)((0,a.$mc)(s),`${(0,a.$nc)(s)}${n.atomic.postfix}`)),await d.Promises.rm(s,d.RimRafMode.MOVE,t)}else try{await S.promises.unlink(s)}catch(t){if(t.code==="EPERM"||t.code==="EISDIR"){let r=!1;try{const{stat:o,symbolicLink:u}=await d.SymlinkSupport.stat(s);r=o.isDirectory()&&!u}catch{}if(r)await S.promises.rmdir(s);else throw t}else throw t}}catch(s){throw this.hb(s)}}async rename(l,n,s){const t=this.I(l),r=this.I(n);if(t!==r)try{await this.db(l,n,"move",s.overwrite),await d.Promises.rename(t,r)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,p.localize)(11366,null,(0,a.$nc)(t),(0,a.$nc)((0,a.$mc)(r)),o.toString()))),this.hb(o)}}async copy(l,n,s){const t=this.I(l),r=this.I(n);if(t!==r)try{await this.db(l,n,"copy",s.overwrite),await d.Promises.copy(t,r,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,p.localize)(11367,null,(0,a.$nc)(t),(0,a.$nc)((0,a.$mc)(r)),o.toString()))),this.hb(o)}}async db(l,n,s,t){const r=this.I(l),o=this.I(n);let u=!1;if(!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive)||(u=(0,O.$Cg)(r,o,!0)),u){if(s==="copy")throw(0,I.$ml)((0,p.localize)(11368,null),I.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const N=await this.N(l);if(!N)throw(0,I.$ml)((0,p.localize)(11369,null),I.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(n);if(C){if(!t)throw(0,I.$ml)((0,p.localize)(11370,null),I.FileSystemProviderErrorCode.FileExists);N.type&I.FileType.File&&C.type&I.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(l,n){return this.eb(l,n,!1)}async eb(l,n,s){const t=this.I(l),r=this.I(n),o=!!(this.capabilities&I.FileSystemProviderCapabilities.PathCaseSensitive);if((0,O.$Cg)(t,r,!o))return;const u=new w.$Tc;try{u.add(await this.Q(l)),u.add(await this.Q(n)),s&&await S.promises.mkdir((0,a.$mc)(r),{recursive:!0}),await S.promises.copyFile(t,r)}catch($){if($.code==="ENOENT"&&!s)return this.eb(l,n,!0);throw this.hb($)}finally{u.dispose()}}t(l,n,s){return new g.$ir(t=>l(t),t=>n(t),s)}F(l,n,s){return new R.$rr(t=>l(t),t=>n(t),s)}hb(l){if(l instanceof I.$ll)return l;let n=l,s;switch(l.code){case"ENOENT":s=I.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=I.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=I.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=I.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=I.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=I.FileSystemProviderErrorCode.Unknown;break;default:s=I.FileSystemProviderErrorCode.Unknown}return(0,I.$ml)(n,s)}async ib(l,n){let s=this.hb(n);if(l&&s.code===I.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await d.SymlinkSupport.stat(this.I(l));t.mode&128||(s=(0,I.$ml)(n,I.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.a.trace(t)}return s}}e.$sr=y}),define(ue[110],he([0,1,2,6]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=void 0;class v extends S.$Uc{constructor(L,O=[]){super(),this.a=new P.$jk([L,...O]),this.B(L.onDidChangeLogLevel(w=>this.setLevel(w)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...O){this.a.trace(L,...O)}debug(L,...O){this.a.debug(L,...O)}info(L,...O){this.a.info(L,...O)}warn(L,...O){this.a.warn(L,...O)}error(L,...O){this.a.error(L,...O)}flush(){this.a.flush()}}e.$JR=v}),define(ue[111],he([0,1,9,6]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yR=void 0;var v;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(v||(v={}));async function k(a,f,c,m,d){try{const p=await new Promise((b,h)=>{Y(["@vscode/spdlog"],b,h)}).then(ye);p.setFlushOn(v.Trace);const I=await p.createAsyncRotatingLogger(a,f,c,m);return d?I.clearFormatters():I.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),I}catch(p){console.error(p)}return null}function L(a,f,c){switch(f){case P.LogLevel.Trace:a.trace(c);break;case P.LogLevel.Debug:a.debug(c);break;case P.LogLevel.Info:a.info(c);break;case P.LogLevel.Warning:a.warn(c);break;case P.LogLevel.Error:a.error(c);break;case P.LogLevel.Off:break;default:throw new Error(`Invalid log level ${f}`)}}function O(a,f){switch(f){case P.LogLevel.Trace:a.setLevel(v.Trace);break;case P.LogLevel.Debug:a.setLevel(v.Debug);break;case P.LogLevel.Info:a.setLevel(v.Info);break;case P.LogLevel.Warning:a.setLevel(v.Warning);break;case P.LogLevel.Error:a.setLevel(v.Error);break;case P.LogLevel.Off:a.setLevel(v.Off);break;default:throw new Error(`Invalid log level ${f}`)}}class w extends P.$fk{constructor(f,c,m,d,p){super(),this.m=[],this.setLevel(p),this.n=this.s(f,c,m,d),this.B(this.onDidChangeLogLevel(I=>{this.r&&O(this.r,I)}))}async s(f,c,m,d){const p=m?6:1,I=30/p*S.$Hl.MB,b=await k(f,c,I,p,d);if(b){this.r=b,O(this.r,this.getLevel());for(const{level:h,message:g}of this.m)L(this.r,h,g);this.m=[]}}g(f,c){this.r?L(this.r,f,c):this.getLevel()<=f&&this.m.push({level:f,message:c})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$yR=w}),define(ue[112],he([0,1,28,6,111]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;class k extends P.$kk{s(O,w,a){return new v.$yR((0,S.$1g)(),O.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,w)}}e.$zR=k}),define(ue[39],he([0,1,4,65,2,10]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=void 0,e.$so=(0,k.$Ei)("policy");class L extends v.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new S.$le),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const f=Object.keys(this.f).length;return this.f={...a,...this.f},f!==Object.keys(this.f).length&&await this.j(a),P.Iterable.reduce(this.g.entries(),(c,[m,d])=>({...c,[m]:d}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return P.Iterable.reduce(Object.entries(this.f),(a,[f,c])=>({...a,[f]:{definition:c,value:this.g.get(f)}}),{})}}e.$to=L;class O{constructor(){this.onDidChange=S.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$uo=O}),define(ue[113],he([0,1,8,4,65,3,9,6,39]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;function a(c,m){const d=[];for(const p of new Set(v.Iterable.concat(c.keys(),m.keys())))c.get(p)!==m.get(p)&&d.push(p);return d}let f=class extends w.$to{constructor(m,d,p){super(),this.m=m,this.n=d,this.s=p,this.c=this.B(new S.$Ch(500));const I=P.Event.filter(d.onDidFilesChange,b=>b.affects(m));this.B(d.watch(m)),this.B(I(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const d=await this.n.readFile(this.m),p=JSON.parse(d.value.toString());if(!(0,k.$gg)(p))throw new Error("Policy file isn't a JSON object");for(const I of Object.keys(p))this.f[I]&&m.set(I,p[I])}catch(d){d.fileOperationResult!==L.FileOperationResult.FILE_NOT_FOUND&&this.s.error("[FilePolicyService] Failed to read policies",d)}return m}async w(){const m=await this.u(),d=a(this.g,m);this.g=m,d.length>0&&this.h.fire(d)}};e.$Rhc=f,e.$Rhc=f=be([re(1,L.$_k),re(2,O.$_j)],f)}),define(ue[114],he([0,1,39,8,2,6]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=void 0;let L=class extends S.$to{constructor(w,a){super(),this.m=w,this.n=a,this.a=new P.$yh,this.b=this.B(new v.$Vc)}async j(w){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(w).length} policy definitions`);const{createWatcher:a}=await new Promise((f,c)=>{Y(["@vscode/policy-watcher"],f,c)}).then(ye);await this.a.queue(()=>new Promise((f,c)=>{try{this.b.value=a(this.n,w,m=>{this.t(m),f()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),c(m)}}))}t(w){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(w)}`);for(const a in w){const f=w[a];f===void 0?this.g.delete(a):this.g.set(a,f)}this.h.fire(Object.keys(w))}};e.$Qhc=L,e.$Qhc=L=be([re(0,k.$_j)],L)}),define(ue[33],he([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,S.$Ei)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(ue[37],he([0,1,75,3]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,S=ye(S),P=ye(P);class v{constructor(){this.a=new Map}add(L,O){S.ok(P.$eg(L)),S.ok(P.$gg(O)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,O)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$qo=new v}),define(ue[115],he([0,1,4,78,37]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,v=ye(v),e.$ro={JSONContribution:"base.contributions.json"};function k(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class L{constructor(){this.b=new S.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(a,f){this.a[k(a)]=f,this.b.fire(a)}notifySchemaChanged(a){this.b.fire(a)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(a){const f=this.a[a];return f?(0,P.$7j)(f):void 0}hasSchemaContent(a){return!!this.a[a]}}const O=new L;v.$qo.add(e.$ro.JSONContribution,O)}),define(ue[40],he([0,1,19,4,3,5,30,115,37]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=I,e.$Ho=b,e.$Io=h,e.$Jo=R,e.$Ko=y,e.$Lo=i,e.$Mo=l,v=ye(v),k=ye(k);var a;(function(n){n.Multiline="multilineText",n.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$vo={Configuration:"base.contributions.configuration"};var f;(function(n){n[n.APPLICATION=1]="APPLICATION",n[n.MACHINE=2]="MACHINE",n[n.WINDOW=3]="WINDOW",n[n.RESOURCE=4]="RESOURCE",n[n.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",n[n.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f||(e.ConfigurationScope=f={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const c=w.$qo.as(O.$ro.JSONContribution);class m{constructor(){this.a=[],this.i=new Set,this.j=new P.$le,this.onDidSchemaChange=this.j.event,this.k=new P.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:k.localize(11600,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},c.registerSchema(e.$Co,this.h),this.z()}registerConfiguration(s,t=!0){this.registerConfigurations([s],t)}registerConfigurations(s,t=!0){const r=new Set;this.r(s,t,r),c.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:r})}deregisterConfigurations(s){const t=new Set;this.s(s,t),c.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:t})}updateConfigurations({add:s,remove:t}){const r=new Set;this.s(t,r),this.r(s,!1,r),c.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:r})}registerDefaultConfigurations(s){const t=new Set;this.l(s,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}l(s,t){this.a.push(...s);const r=[];for(const{overrides:o,source:u}of s)for(const $ in o){t.add($);const N=this.b.get($)??this.b.set($,{configurationDefaultOverrides:[]}).get($),C=o[$];if(N.configurationDefaultOverrides.push({value:C,source:u}),e.$Fo.test($)){const A=this.o($,C,u,N.configurationDefaultOverrideValue);if(!A)continue;N.configurationDefaultOverrideValue=A,this.n($,A,u),r.push(...I($))}else{const A=this.p($,C,u,N.configurationDefaultOverrideValue);if(!A)continue;N.configurationDefaultOverrideValue=A;const D=this.e[$];D&&(this.A($,D),this.w($,D))}}this.q(r)}deregisterDefaultConfigurations(s){const t=new Set;this.m(s,t),this.j.fire(),this.k.fire({properties:t,defaultsOverrides:!0})}m(s,t){for(const r of s){const o=this.a.indexOf(r);o!==-1&&this.a.splice(o,1)}for(const{overrides:r,source:o}of s)for(const u in r){const $=this.b.get(u);if(!$)continue;const N=$.configurationDefaultOverrides.findIndex(C=>o?C.source?.id===o.id:C.value===r[u]);if(N!==-1){if($.configurationDefaultOverrides.splice(N,1),$.configurationDefaultOverrides.length===0&&this.b.delete(u),e.$Fo.test(u)){let C;for(const A of $.configurationDefaultOverrides)C=this.o(u,A.value,A.source,C);C&&!v.$rg(C.value)?($.configurationDefaultOverrideValue=C,this.n(u,C,o)):(this.b.delete(u),delete this.e[u],delete this.c.properties[u])}else{let C;for(const D of $.configurationDefaultOverrides)C=this.p(u,D.value,D.source,C);$.configurationDefaultOverrideValue=C;const A=this.e[u];A&&(this.A(u,A),this.w(u,A))}t.add(u)}}this.y()}n(s,t,r){const o={type:"object",default:t.value,description:k.localize(11601,null,(0,L.$ij)(s)),$ref:e.$Co,defaultDefaultValue:t.value,source:r,defaultValueSource:r};this.e[s]=o,this.c.properties[s]=o}o(s,t,r,o){const u=o?.value||{},$=o?.source??new Map;if(!($ instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const N of Object.keys(t)){const C=t[N];if(v.$gg(C)&&(v.$lg(u[N])||v.$gg(u[N]))){if(u[N]={...u[N]??{},...C},r)for(const D in C)$.set(`${N}.${D}`,r)}else u[N]=C,r?$.set(N,r):$.delete(N)}return{value:u,source:$}}p(s,t,r,o){const u=this.e[s],$=o?.value??u?.defaultDefaultValue;let N=r;if(v.$gg(t)&&(u!==void 0&&u.type==="object"||u===void 0&&(v.$lg($)||v.$gg($)))){if(N=o?.source??new Map,!(N instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const A in t)r&&N.set(`${s}.${A}`,r);t={...v.$gg($)?$:{},...t}}return{value:t,source:N}}deltaConfiguration(s){let t=!1;const r=new Set;s.removedDefaults&&(this.m(s.removedDefaults,r),t=!0),s.addedDefaults&&(this.l(s.addedDefaults,r),t=!0),s.removedConfigurations&&this.s(s.removedConfigurations,r),s.addedConfigurations&&this.r(s.addedConfigurations,!1,r),this.j.fire(),this.k.fire({properties:r,defaultsOverrides:t})}notifyConfigurationSchemaUpdated(...s){this.j.fire()}registerOverrideIdentifiers(s){this.q(s),this.j.fire()}q(s){for(const t of s)this.i.add(t);this.y()}r(s,t,r){s.forEach(o=>{this.u(o,t,o.extensionInfo,o.restrictedProperties,void 0,r),this.d.push(o),this.v(o)})}s(s,t){const r=o=>{if(o.properties)for(const u in o.properties){t.add(u);const $=this.e[u];$?.policy?.name&&this.f.delete($.policy.name),delete this.e[u],this.x(u,o.properties[u])}o.allOf?.forEach(u=>r(u))};for(const o of s){r(o);const u=this.d.indexOf(o);u!==-1&&this.d.splice(u,1)}}u(s,t=!0,r,o,u=f.WINDOW,$){u=v.$ng(s.scope)?u:s.scope;const N=s.properties;if(N)for(const A in N){const D=N[A];if(t&&R(A,D)){delete N[A];continue}if(D.source=r,D.defaultDefaultValue=N[A].default,this.A(A,D),e.$Fo.test(A)?D.scope=void 0:(D.scope=v.$ng(D.scope)?u:D.scope,D.restricted=v.$ng(D.restricted)?!!o?.includes(A):D.restricted),N[A].hasOwnProperty("included")&&!N[A].included){this.g[A]=N[A],delete N[A];continue}else this.e[A]=N[A],N[A].policy?.name&&this.f.set(N[A].policy.name,A);!N[A].deprecationMessage&&N[A].markdownDeprecationMessage&&(N[A].deprecationMessage=N[A].markdownDeprecationMessage),$.add(A)}const C=s.allOf;if(C)for(const A of C)this.u(A,t,r,o,u,$)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const s=new Map;for(const[t,r]of this.b)r.configurationDefaultOverrideValue&&s.set(t,r.configurationDefaultOverrideValue);return s}v(s){const t=r=>{const o=r.properties;if(o)for(const $ in o)this.w($,o[$]);r.allOf?.forEach(t)};t(s)}w(s,t){switch(e.$wo.properties[s]=t,t.scope){case f.APPLICATION:e.$xo.properties[s]=t;break;case f.MACHINE:e.$yo.properties[s]=t;break;case f.MACHINE_OVERRIDABLE:e.$zo.properties[s]=t;break;case f.WINDOW:e.$Ao.properties[s]=t;break;case f.RESOURCE:e.$Bo.properties[s]=t;break;case f.LANGUAGE_OVERRIDABLE:e.$Bo.properties[s]=t,this.h.properties[s]=t;break}}x(s,t){switch(delete e.$wo.properties[s],t.scope){case f.APPLICATION:delete e.$xo.properties[s];break;case f.MACHINE:delete e.$yo.properties[s];break;case f.MACHINE_OVERRIDABLE:delete e.$zo.properties[s];break;case f.WINDOW:delete e.$Ao.properties[s];break;case f.RESOURCE:case f.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[s],delete this.h.properties[s];break}}y(){for(const s of this.i.values()){const t=`[${s}]`,r={type:"object",description:k.localize(11602,null),errorMessage:k.localize(11603,null),$ref:e.$Co};this.A(t,r),e.$wo.properties[t]=r,e.$xo.properties[t]=r,e.$yo.properties[t]=r,e.$zo.properties[t]=r,e.$Ao.properties[t]=r,e.$Bo.properties[t]=r}}z(){const s={type:"object",description:k.localize(11604,null),errorMessage:k.localize(11605,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=s,e.$xo.patternProperties[e.$Eo]=s,e.$yo.patternProperties[e.$Eo]=s,e.$zo.patternProperties[e.$Eo]=s,e.$Ao.patternProperties[e.$Eo]=s,e.$Bo.patternProperties[e.$Eo]=s,this.j.fire()}A(s,t){const r=this.b.get(s)?.configurationDefaultOverrideValue;let o,u;r&&(!t.disallowConfigurationDefault||!r.source)&&(o=r.value,u=r.source),v.$lg(o)&&(o=t.defaultDefaultValue,u=void 0),v.$lg(o)&&(o=h(t.type)),t.default=o,t.defaultValueSource=u}}const d="\\[([^\\]]+)\\]",p=new RegExp(d,"g");e.$Eo=`^(${d})+$`,e.$Fo=new RegExp(e.$Eo);function I(n){const s=[];if(e.$Fo.test(n)){let t=p.exec(n);for(;t?.length;){const r=t[1].trim();r&&s.push(r),t=p.exec(n)}}return(0,S.$Lb)(s)}function b(n){return n.reduce((s,t)=>`${s}[${t}]`,"")}function h(n){switch(Array.isArray(n)?n[0]:n){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const g=new m;w.$qo.add(e.$vo.Configuration,g);function R(n,s){return n.trim()?e.$Fo.test(n)?k.localize(11607,null,n):g.getConfigurationProperties()[n]!==void 0?k.localize(11608,null,n):s.policy?.name&&g.getPolicyConfigurations().get(s.policy?.name)!==void 0?k.localize(11609,null,n,s.policy?.name,g.getPolicyConfigurations().get(s.policy?.name)):null:k.localize(11606,null)}function y(){const n=[],s=g.getConfigurationProperties();for(const t of Object.keys(s))n.push([t,s[t].scope]);return n.push(["launch",f.RESOURCE]),n.push(["task",f.RESOURCE]),n}function i(n){const s={};for(const t of n){const r=t.properties;if(v.$gg(r))for(const o in r)s[o]=r[o];t.allOf&&Object.assign(s,i(t.allOf))}return s}function l(n){switch(n){case"application":return f.APPLICATION;case"machine":return f.MACHINE;case"resource":return f.RESOURCE;case"machine-overridable":return f.MACHINE_OVERRIDABLE;case"language-overridable":return f.LANGUAGE_OVERRIDABLE;default:return f.WINDOW}}}),define(ue[66],he([0,1,19,4,34,2,25,27,3,11,30,40,9,37]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$Ro=y,S=ye(S),v=ye(v),O=ye(O),w=ye(w);function p(s){return Object.isFrozen(s)?s:O.$eo(s)}class I{static createEmptyModel(t){return new I({},[],[],void 0,t)}constructor(t,r,o,u,$){this.b=t,this.c=r,this.d=o,this.raw=u,this.f=$,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(r=>{if(r instanceof I)return r;const o=new b("",this.f);return o.parseRaw(r),o.configurationModel});this.g=t.reduce((r,o)=>o===r?o:r.merge(o),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,f.$gj)(this.contents,t):this.contents}inspect(t,r){const o=this;return{get value(){return p(o.rawConfiguration.getValue(t))},get override(){return r?p(o.rawConfiguration.getOverrideValue(t,r)):void 0},get merged(){return p(r?o.rawConfiguration.override(r).getValue(t):o.rawConfiguration.getValue(t))},get overrides(){const u=[];for(const{contents:$,identifiers:N,keys:C}of o.rawConfiguration.overrides){const A=new I($,C,[],void 0,o.f).getValue(t);A!==void 0&&u.push({identifiers:N,value:A})}return u.length?p(u):void 0}}}getOverrideValue(t,r){const o=this.j(r);return o?t?(0,f.$gj)(o,t):o:void 0}getKeysForOverrideIdentifier(t){const r=[];for(const o of this.overrides)o.identifiers.includes(t)&&r.push(...o.keys);return S.$Lb(r)}getAllOverrideIdentifiers(){const t=[];for(const r of this.overrides)t.push(...r.identifiers);return S.$Lb(t)}override(t){let r=this.a.get(t);return r||(r=this.h(t),this.a.set(t,r)),r}merge(...t){const r=O.$do(this.contents),o=O.$do(this.overrides),u=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const N of t)if($.push(...N.raw?.length?N.raw:[N]),!N.isEmpty()){this.i(r,N.contents);for(const C of N.overrides){const[A]=o.filter(D=>S.$tb(D.identifiers,C.identifiers));A?(this.i(A.contents,C.contents),A.keys.push(...C.keys),A.keys=S.$Lb(A.keys)):o.push(O.$do(C))}for(const C of N.keys)u.indexOf(C)===-1&&u.push(C)}return new I(r,u,o,$.every(N=>N instanceof I)?void 0:$,this.f)}h(t){const r=this.j(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;const o={};for(const u of S.$Lb([...Object.keys(this.contents),...Object.keys(r)])){let $=this.contents[u];const N=r[u];N&&(typeof $=="object"&&typeof N=="object"?($=O.$do($),this.i($,N)):$=N),o[u]=$}return new I(o,this.keys,this.overrides,void 0,this.f)}i(t,r){for(const o of Object.keys(r)){if(o in t&&w.$gg(t[o])&&w.$gg(r[o])){this.i(t[o],r[o]);continue}t[o]=O.$do(r[o])}}j(t){let r=null,o=null;const u=$=>{$&&(o?this.i(o,$):o=O.$do($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===t?r=$.contents:$.identifiers.includes(t)&&u($.contents);return u(r),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,r){this.k(t,r,!0)}setValue(t,r){this.k(t,r,!1)}removeValue(t){const r=this.keys.indexOf(t);r!==-1&&(this.keys.splice(r,1),(0,f.$fj)(this.contents,t),c.$Fo.test(t)&&this.overrides.splice(this.overrides.findIndex(o=>S.$tb(o.identifiers,(0,c.$Go)(t))),1))}k(t,r,o){if((0,f.$ej)(this.contents,t,r,u=>this.f.error(u)),o=o||this.keys.indexOf(t)===-1,o&&this.keys.push(t),c.$Fo.test(t)){const u=(0,c.$Go)(t),$={identifiers:u,keys:Object.keys(this.contents[t]),contents:(0,f.$dj)(this.contents[t],C=>this.f.error(C))},N=this.overrides.findIndex(C=>S.$tb(C.identifiers,u));N!==-1?this.overrides[N]=$:this.overrides.push($)}}}e.$No=I;class b{constructor(t,r){this.f=t,this.g=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||I.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,r){if(!w.$ng(t)){const o=this.h(t);this.parseRaw(o,r)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,r){this.a=t;const{contents:o,keys:u,overrides:$,restricted:N,hasExcludedProperties:C}=this.i(t,r);this.b=new I(o,u,$,C?[t]:void 0,this.g),this.c=N||[]}h(t){let r={},o=null,u=[];const $=[],N=[];function C(D){Array.isArray(u)?u.push(D):o!==null&&(u[o]=D)}const A={onObjectBegin:()=>{const D={};C(D),$.push(u),u=D,o=null},onObjectProperty:D=>{o=D},onObjectEnd:()=>{u=$.pop()},onArrayBegin:()=>{const D=[];C(D),$.push(u),u=D,o=null},onArrayEnd:()=>{u=$.pop()},onLiteralValue:C,onError:(D,U,G)=>{N.push({error:D,offset:U,length:G})}};if(t)try{v.$5n(t,A),r=u[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return r}i(t,r){const o=d.$qo.as(c.$vo.Configuration).getConfigurationProperties(),u=this.j(t,o,!0,r);t=u.raw;const $=(0,f.$dj)(t,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),N=Object.keys(t),C=this.l(t,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:$,keys:N,overrides:C,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}j(t,r,o,u){let $=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:$};const N={},C=[];for(const A in t)if(c.$Fo.test(A)&&o){const D=this.j(t[A],r,!1,u);N[A]=D.raw,$=$||D.hasExcludedProperties,C.push(...D.restricted)}else{const D=r[A],U=D?typeof D.scope<"u"?D.scope:c.ConfigurationScope.WINDOW:void 0;D?.restricted&&C.push(A),!u.exclude?.includes(A)&&(u.include?.includes(A)||(U===void 0||u.scopes===void 0||u.scopes.includes(U))&&!(u.skipRestricted&&D?.restricted))?N[A]=t[A]:$=!0}return{raw:N,restricted:C,hasExcludedProperties:$}}l(t,r){const o=[];for(const u of Object.keys(t))if(c.$Fo.test(u)){const $={};for(const N in t[u])$[N]=t[u][N];o.push({identifiers:(0,c.$Go)(u),keys:Object.keys($),contents:(0,f.$dj)($,r)})}return o}}e.$Oo=b;class h extends k.$Uc{constructor(t,r,o,u,$){super(),this.c=t,this.f=r,this.g=u,this.h=$,this.b=this.B(new P.$le),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),$),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(P.Event.any(P.Event.filter(this.g.onDidFilesChange,N=>N.contains(this.c)),P.Event.filter(this.g.onDidRunOperation,N=>(N.isOperation(m.FileOperation.CREATE)||N.isOperation(m.FileOperation.COPY)||N.isOperation(m.FileOperation.DELETE)||N.isOperation(m.FileOperation.WRITE))&&o.isEqual(N.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return I.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Po=h;class g{constructor(t,r,o,u,$,N,C,A,D,U,G,Q,te){this.a=t,this.b=r,this.c=o,this.overrideIdentifiers=u,this.d=$,this.f=N,this.g=C,this.h=A,this.i=D,this.j=U,this.k=G,this.l=Q,this.m=te}get value(){return p(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class R{constructor(t,r,o,u,$,N,C,A,D,U){this.j=t,this.l=r,this.m=o,this.n=u,this.p=$,this.q=N,this.r=C,this.s=A,this.t=D,this.u=U,this.h=null,this.i=new L.$Ac,this.v=null}getValue(t,r,o){return this.w(t,r,o).getValue(t)}updateValue(t,r,o={}){let u;o.resource?(u=this.t.get(o.resource),u||(u=I.createEmptyModel(this.u),this.t.set(o.resource,u))):u=this.s,r===void 0?u.removeValue(t):u.setValue(t,r),o.resource||(this.h=null)}inspect(t,r,o){const u=this.w(t,r,o),$=this.A(r.resource,o),N=r.resource?this.t.get(r.resource)||this.s:this.s,C=new Set;for(const A of u.overrides)for(const D of A.identifiers)u.getOverrideValue(t,D)!==void 0&&C.add(D);return new g(t,r,u.getValue(t),C.size?[...C]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,$||void 0,N)}keys(t){const r=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:r?r.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,r){this.r.set(t,r),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=[];if(!r){const{added:u,updated:$,removed:N}=l(this.j,t);r=[...u,...$,...N]}for(const u of r)for(const $ of(0,c.$Go)(u)){const N=this.j.getKeysForOverrideIdentifier($),C=t.getKeysForOverrideIdentifier($),A=[...C.filter(D=>N.indexOf(D)===-1),...N.filter(D=>C.indexOf(D)===-1),...N.filter(D=>!O.$ho(this.j.override($).getValue(D),t.override($).getValue(D)))];o.push([$,A])}return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdatePolicyConfiguration(t){const{added:r,updated:o,removed:u}=l(this.l,t),$=[...r,...o,...u];return $.length&&this.updatePolicyConfiguration(t),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:r,updated:o,removed:u,overrides:$}=l(this.applicationConfiguration,t),N=[...r,...o,...u];return N.length&&this.updateApplicationConfiguration(t),{keys:N,overrides:$}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:u,overrides:$}=l(this.localUserConfiguration,t),N=[...r,...o,...u];return N.length&&this.updateLocalUserConfiguration(t),{keys:N,overrides:$}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:u,overrides:$}=l(this.remoteUserConfiguration,t),N=[...r,...o,...u];return N.length&&this.updateRemoteUserConfiguration(t),{keys:N,overrides:$}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:u,overrides:$}=l(this.workspaceConfiguration,t),N=[...r,...o,...u];return N.length&&this.updateWorkspaceConfiguration(t),{keys:N,overrides:$}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:u,updated:$,removed:N,overrides:C}=l(o,r),A=[...u,...$,...N];return(A.length||!o)&&this.updateFolderConfiguration(t,r),{keys:A,overrides:C}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:u,removed:$,overrides:N}=l(r,void 0);return{keys:[...o,...u,...$],overrides:N}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,r,o){let u=this.x(r,o);return r.overrideIdentifier&&(u=u.override(r.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(u=u.merge(this.l)),u}x({resource:t},r){let o=this.y();if(r&&t){const u=r.getFolder(t);u&&(o=this.z(u.uri)||o);const $=this.t.get(t);$&&(o=o.merge($))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let r=this.i.get(t);if(!r){const o=this.y(),u=this.r.get(t);u?(r=o.merge(u),this.i.set(t,r)):r=o}return r}A(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,r)=>{const{contents:o,overrides:u,keys:$}=this.r.get(r);return t.push([r,{contents:o,overrides:u,keys:$}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(r=>t.add(r)),this.userConfiguration.keys.forEach(r=>t.add(r)),this.q.keys.forEach(r=>t.add(r)),this.r.forEach(r=>r.keys.forEach(o=>t.add(o))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(r=>t.add(r)),this.userConfiguration.getAllOverrideIdentifiers().forEach(r=>t.add(r)),this.q.getAllOverrideIdentifiers().forEach(r=>t.add(r)),this.r.forEach(r=>r.getAllOverrideIdentifiers().forEach(o=>t.add(o))),[...t.values()]}D(t){const r=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.q.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u))),[...r.values()]}static parse(t,r){const o=this.E(t.defaults,r),u=this.E(t.policy,r),$=this.E(t.application,r),N=this.E(t.user,r),C=this.E(t.workspace,r),A=t.folders.reduce((D,U)=>(D.set(a.URI.revive(U[0]),this.E(U[1],r)),D),new L.$Ac);return new R(o,u,$,N,I.createEmptyModel(r),C,A,I.createEmptyModel(r),new L.$Ac,r)}static E(t,r){return new I(t.contents,t.keys,t.overrides,void 0,r)}}e.$Qo=R;function y(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const u of s)u.keys.forEach($=>t.add($)),u.overrides.forEach(([$,N])=>{const C=(0,L.$xc)(r,$,new Set);N.forEach(A=>C.add(A))});const o=[];return r.forEach((u,$)=>o.push([$,[...u.values()]])),{keys:[...t.values()],overrides:o}}class i{constructor(t,r,o,u,$){this.change=t,this.f=r,this.g=o,this.h=u,this.i=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const N of t.keys)this.affectedKeys.add(N);for(const[,N]of t.overrides)for(const C of N)this.affectedKeys.add(C);this.d=this.a;for(const N of this.affectedKeys)this.d+=N+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=R.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,r){const o=this.a+t,u=this.d.indexOf(o);if(u<0)return!1;const $=u+o.length;if($>=this.d.length)return!1;const N=this.d.charCodeAt($);if(N!==this.b&&N!==this.c)return!1;if(r){const C=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.f?.workspace):void 0,A=this.g.getValue(t,r,this.h);return!O.$ho(C,A)}return!0}}e.$So=i;function l(s,t){const{added:r,removed:o,updated:u}=n(t?.rawConfiguration,s?.rawConfiguration),$=[],N=s?.getAllOverrideIdentifiers()||[],C=t?.getAllOverrideIdentifiers()||[];if(t){const A=C.filter(D=>!N.includes(D));for(const D of A)$.push([D,t.getKeysForOverrideIdentifier(D)])}if(s){const A=N.filter(D=>!C.includes(D));for(const D of A)$.push([D,s.getKeysForOverrideIdentifier(D)])}if(t&&s){for(const A of N)if(C.includes(A)){const D=n({contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)},{contents:t.getOverrideValue(void 0,A)||{},keys:t.getKeysForOverrideIdentifier(A)});$.push([A,[...D.added,...D.removed,...D.updated]])}}return{added:r,removed:o,updated:u,overrides:$}}function n(s,t){const r=s?t?s.keys.filter($=>t.keys.indexOf($)===-1):[...s.keys]:[],o=t?s?t.keys.filter($=>s.keys.indexOf($)===-1):[...t.keys]:[],u=[];if(s&&t){for(const $ of t.keys)if(s.keys.indexOf($)!==-1){const N=(0,f.$gj)(t.contents,$),C=(0,f.$gj)(s.contents,$);O.$ho(N,C)||u.push($)}}return{added:r,removed:o,updated:u}}}),define(ue[116],he([0,1,19,4,2,27,3,66,40,6,39,37]),function(Y,e,S,P,v,k,L,O,w,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=e.$Uo=e.$To=void 0;class m extends v.$Uc{get configurationModel(){return this.b}constructor(b){super(),this.c=b,this.a=this.B(new P.$le),this.onDidChangeConfiguration=this.a.event,this.b=O.$No.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(c.$qo.as(w.$vo.Configuration).onDidUpdateConfiguration(({properties:b,defaultsOverrides:h})=>this.f(Array.from(b),h))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(b,h){this.j(b,c.$qo.as(w.$vo.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:b})}g(){return{}}h(){this.b=O.$No.createEmptyModel(this.c);const b=c.$qo.as(w.$vo.Configuration).getConfigurationProperties();this.j(Object.keys(b),b)}j(b,h){const g=this.g();for(const R of b){const y=g[R],i=h[R];y!==void 0?this.b.setValue(R,y):i?this.b.setValue(R,i.default):this.b.removeValue(R)}}}e.$To=m;class d{constructor(){this.onDidChangeConfiguration=P.Event.None,this.configurationModel=O.$No.createEmptyModel(new a.$mk)}async initialize(){return this.configurationModel}}e.$Uo=d;let p=class extends v.$Uc{get configurationModel(){return this.b}constructor(b,h,g){super(),this.c=b,this.f=h,this.g=g,this.a=this.B(new P.$le),this.onDidChangeConfiguration=this.a.event,this.b=O.$No.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(b=>this.j(b))),this.B(this.c.onDidChangeConfiguration(async({properties:b})=>this.m(await this.h(b),!0))),this.b}async h(b){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",b);const h={},g=[],R=c.$qo.as(w.$vo.Configuration).getConfigurationProperties();for(const y of b){const i=R[y];if(!i){g.push(y);continue}if(i.policy){if(i.type!=="string"&&i.type!=="number"){this.g.warn(`Policy ${i.policy.name} has unsupported type ${i.type}`);continue}g.push(y),h[i.policy.name]={type:i.type}}}return(0,L.$rg)(h)||await this.f.updatePolicyDefinitions(h),g}j(b){this.g.trace("PolicyConfiguration#onDidChangePolicies",b);const h=c.$qo.as(w.$vo.Configuration).getPolicyConfigurations(),g=(0,S.$Gb)(b.map(R=>h.get(R)));this.m(g,!0)}m(b,h){this.g.trace("PolicyConfiguration#update",b);const g=c.$qo.as(w.$vo.Configuration).getConfigurationProperties(),R=[],y=this.b.isEmpty();for(const i of b){const l=g[i]?.policy?.name;if(l){const n=this.f.getPolicyValue(l);(y?n!==void 0:!(0,k.$ho)(this.b.getValue(i),n))&&R.push([i,n])}else this.b.getValue(i)!==void 0&&R.push([i,void 0])}if(R.length){this.g.trace("PolicyConfiguration#changed",R);const i=this.b;this.b=O.$No.createEmptyModel(this.g);for(const l of i.keys)this.b.setValue(l,i.getValue(l));for(const[l,n]of R)n===void 0?this.b.removeValue(l):this.b.setValue(l,n);h&&this.a.fire(this.b)}}};e.$Vo=p,e.$Vo=p=be([re(1,f.$so),re(2,a.$_j)],p)}),define(ue[117],he([0,1,19,8,13,4,34,77,2,25,27,12,16,30,66,40,116,9,39]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wo=void 0;class R extends w.$Uc{constructor(l,n,s,t){super(),this.m=l,this.n=t,this.h=this.B(new k.$le),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$To(t)),this.c=s instanceof g.$uo?new b.$Uo:this.B(new b.$Vo(this.b,s,t)),this.f=this.B(new p.$Po(this.m,{},m.$9g,n,t)),this.a=new p.$Qo(this.b.configurationModel,this.c.configurationModel,p.$No.createEmptyModel(t),p.$No.createEmptyModel(t),p.$No.createEmptyModel(t),p.$No.createEmptyModel(t),new a.$Ac,p.$No.createEmptyModel(t),new a.$Ac,t),this.j=new y(l,n,this),this.g=this.B(new P.$Qh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:o})=>this.s(r,o))),this.B(this.c.onDidChangeConfiguration(r=>this.t(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[l,n,s]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$Qo(l,n,p.$No.createEmptyModel(this.n),s,p.$No.createEmptyModel(this.n),p.$No.createEmptyModel(this.n),new a.$Ac,p.$No.createEmptyModel(this.n),new a.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(l,n){const s=typeof l=="string"?l:void 0,t=(0,d.$_i)(l)?l:(0,d.$_i)(n)?n:{};return this.a.getValue(s,t,void 0)}async updateValue(l,n,s,t,r){const o=(0,d.$aj)(s)?s:(0,d.$_i)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,u=o?t:s;if(u!==void 0&&u!==d.ConfigurationTarget.USER_LOCAL&&u!==d.ConfigurationTarget.USER)throw new Error(`Unable to write ${l} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,S.$Lb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const $=this.inspect(l,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if($.policyValue!==void 0)throw new Error(`Unable to write ${l} because it is configured in system policy.`);if((0,f.$ho)(n,$.defaultValue)&&(n=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const C=o.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(D=>(0,S.$tb)([...D.identifiers].sort(),C));A&&(o.overrideIdentifiers=A.identifiers)}const N=o?.overrideIdentifiers?.length?[(0,I.$Ho)(o.overrideIdentifiers),l]:[l];await this.j.write(N,n),await this.reloadConfiguration()}inspect(l,n={}){return this.a.inspect(l,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const l=await this.f.loadConfiguration();this.r(l)}r(l){const n=this.a.toData(),s=this.a.compareAndUpdateLocalUserConfiguration(l);this.u(s,n,d.ConfigurationTarget.USER)}s(l,n){const s=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(l,n);this.u(t,s,d.ConfigurationTarget.DEFAULT)}t(l){const n=this.a.toData(),s=this.a.compareAndUpdatePolicyConfiguration(l);this.u(s,n,d.ConfigurationTarget.DEFAULT)}u(l,n,s){const t=new p.$So(l,{data:n},this.a,void 0,this.n);t.source=s,this.h.fire(t)}}e.$Wo=R;class y{constructor(l,n,s){this.b=l,this.c=n,this.d=s,this.a=new P.$Lh}write(l,n){return this.a.queue(()=>this.e(l,n))}async e(l,n){let s;try{s=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===h.FileOperationResult.FILE_NOT_FOUND)s="{}";else throw o}const t=[];if((0,L.$Xn)(s,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(s,l,n);s=(0,O.$co)(s,r),await this.c.writeFile(this.b,v.$Ne.fromString(s))}f(l,n,s){const{tabSize:t,insertSpaces:r,eol:o}=this.h;if(!n.length){const u=JSON.stringify(s,null,r?" ".repeat(t):"	");return[{content:u,length:u.length,offset:0}]}return(0,O.$_n)(l,n,s,{tabSize:t,insertSpaces:r,eol:o})}get h(){if(!this.g){let l=c.OS===c.OperatingSystem.Linux||c.OS===c.OperatingSystem.Macintosh?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(l=n),this.g={eol:l,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ue[67],he([0,1,14]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=P,e.$hn=v,e.$in=k,e.$jn=L;function P(w){return w.scheme===S.Schemas.vscodeRemote?w.authority:void 0}function v(w){if(!w)return;const a=w.indexOf("+");return a<0?w:w.substr(0,a)}function k(w){const{host:a,port:f}=O(w);if(typeof f>"u")throw new Error(`Invalid remote authority: ${w}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:f}}function L(w,a){let{host:f,port:c}=O(w);return typeof c>"u"&&(c=a),{host:f,port:c}}function O(w){const a=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const f=w.match(/^(\[[0-9a-z:]+\])$/);if(f)return{host:f[1],port:void 0};const c=w.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:w,port:void 0}}}),define(ue[22],he([0,1,31,10,67]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=k,e.$tn=c,e.$un=m,e.$vn=d,e.$wn=p,e.$xn=I,e.$yn=b,S=ye(S),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function k(h){if(typeof h=="object"&&h!==null&&h.supported!==!0)return h.description}e.$pn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(h){h[h.System=0]="System",h[h.User=1]="User"})(L||(e.ExtensionType=L={}));var O;(function(h){h.WIN32_X64="win32-x64",h.WIN32_ARM64="win32-arm64",h.LINUX_X64="linux-x64",h.LINUX_ARM64="linux-arm64",h.LINUX_ARMHF="linux-armhf",h.ALPINE_X64="alpine-x64",h.ALPINE_ARM64="alpine-arm64",h.DARWIN_X64="darwin-x64",h.DARWIN_ARM64="darwin-arm64",h.WEB="web",h.UNIVERSAL="universal",h.UNKNOWN="unknown",h.UNDEFINED="undefined"})(O||(e.TargetPlatform=O={}));class w{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,R){if(typeof g>"u"||g===null)return typeof R>"u"||R===null;if(typeof R>"u"||R===null)return!1;if(typeof g=="string"||typeof R=="string"){const y=typeof g=="string"?g:g.value,i=typeof R=="string"?R:R.value;return S.$Ff(y,i)}return g._lower===R._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$qn=w;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const R of g)this.add(R)}add(g){this.c.add(w.toKey(g))}delete(g){return this.c.delete(w.toKey(g))}has(g){return this.c.has(w.toKey(g))}}e.$rn=a;class f{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(w.toKey(g))}get(g){return this.c.get(w.toKey(g))}has(g){return this.c.has(w.toKey(g))}set(g,R){this.c.set(w.toKey(g),R)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=f;function c(h){return m(h)}function m(h){return h.contributes&&h.contributes.localizations?h.contributes.localizations.length>0:!1}function d(h){return h.contributes&&h.contributes.authentication?h.contributes.authentication.length>0:!1}function p(h,g){if(g){const R=`onResolveRemoteAuthority:${(0,v.$hn)(g)}`;return!!h.activationEvents?.includes(R)}return!1}function I(h){return h.map(g=>{const[R,y]=g.split("@");return{proposalName:R,version:y?parseInt(y):void 0}})}function b(h){return h.map(g=>g.split("@")[0])}e.$zn=(0,P.$Ei)("IBuiltinExtensionsScannerService")}),define(ue[20],he([0,1,12,5,22,10]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.ExtensionManagementErrorCode=e.$lp=e.ExtensionGalleryErrorCode=e.$kp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0,e.$ep=O,e.$fp=w,e.$gp=a,e.$hp=f,e.$ip=c,e.$jp=m,e.$0o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$o=new RegExp(e.$0o),e.$_o="__web_extension",e.$ap="skipWalkthrough",e.$bp="extensionInstallSource",e.$cp="dependecyOrPackExtensionInstall",e.$dp="clientTargetPlatform";var L;(function(i){i.COMMAND="command",i.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function O(i){switch(i){case v.TargetPlatform.WIN32_X64:return"Windows 64 bit";case v.TargetPlatform.WIN32_ARM64:return"Windows ARM";case v.TargetPlatform.LINUX_X64:return"Linux 64 bit";case v.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case v.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case v.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case v.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case v.TargetPlatform.DARWIN_X64:return"Mac";case v.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case v.TargetPlatform.WEB:return"Web";case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;case v.TargetPlatform.UNKNOWN:return v.TargetPlatform.UNKNOWN;case v.TargetPlatform.UNDEFINED:return v.TargetPlatform.UNDEFINED}}function w(i){switch(i){case v.TargetPlatform.WIN32_X64:return v.TargetPlatform.WIN32_X64;case v.TargetPlatform.WIN32_ARM64:return v.TargetPlatform.WIN32_ARM64;case v.TargetPlatform.LINUX_X64:return v.TargetPlatform.LINUX_X64;case v.TargetPlatform.LINUX_ARM64:return v.TargetPlatform.LINUX_ARM64;case v.TargetPlatform.LINUX_ARMHF:return v.TargetPlatform.LINUX_ARMHF;case v.TargetPlatform.ALPINE_X64:return v.TargetPlatform.ALPINE_X64;case v.TargetPlatform.ALPINE_ARM64:return v.TargetPlatform.ALPINE_ARM64;case v.TargetPlatform.DARWIN_X64:return v.TargetPlatform.DARWIN_X64;case v.TargetPlatform.DARWIN_ARM64:return v.TargetPlatform.DARWIN_ARM64;case v.TargetPlatform.WEB:return v.TargetPlatform.WEB;case v.TargetPlatform.UNIVERSAL:return v.TargetPlatform.UNIVERSAL;default:return v.TargetPlatform.UNKNOWN}}function a(i,l){switch(i){case S.Platform.Windows:return l==="x64"?v.TargetPlatform.WIN32_X64:l==="arm64"?v.TargetPlatform.WIN32_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Linux:return l==="x64"?v.TargetPlatform.LINUX_X64:l==="arm64"?v.TargetPlatform.LINUX_ARM64:l==="arm"?v.TargetPlatform.LINUX_ARMHF:v.TargetPlatform.UNKNOWN;case"alpine":return l==="x64"?v.TargetPlatform.ALPINE_X64:l==="arm64"?v.TargetPlatform.ALPINE_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Mac:return l==="x64"?v.TargetPlatform.DARWIN_X64:l==="arm64"?v.TargetPlatform.DARWIN_ARM64:v.TargetPlatform.UNKNOWN;case S.Platform.Web:return v.TargetPlatform.WEB}}function f(i,l){return l===v.TargetPlatform.WEB&&!i.includes(v.TargetPlatform.WEB)}function c(i,l,n){return f(l,n)?!1:i===v.TargetPlatform.UNDEFINED||i===v.TargetPlatform.UNIVERSAL?!0:i===v.TargetPlatform.UNKNOWN?!1:i===n}function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}var d;(function(i){i[i.NoneOrRelevance=0]="NoneOrRelevance",i[i.LastUpdatedDate=1]="LastUpdatedDate",i[i.Title=2]="Title",i[i.PublisherName=3]="PublisherName",i[i.InstallCount=4]="InstallCount",i[i.PublishedDate=10]="PublishedDate",i[i.AverageRating=6]="AverageRating",i[i.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var p;(function(i){i[i.Default=0]="Default",i[i.Ascending=1]="Ascending",i[i.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var I;(function(i){i.Install="install",i.Uninstall="uninstall"})(I||(e.StatisticType=I={}));var b;(function(i){i[i.None=1]="None",i[i.Install=2]="Install",i[i.Update=3]="Update",i[i.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$kp=(0,k.$Ei)("extensionGalleryService");var h;(function(i){i.Timeout="Timeout",i.Cancelled="Cancelled",i.Failed="Failed",i.DownloadFailedWriting="DownloadFailedWriting"})(h||(e.ExtensionGalleryErrorCode=h={}));class g extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$lp=g;var R;(function(i){i.Unsupported="Unsupported",i.Deprecated="Deprecated",i.Malicious="Malicious",i.Incompatible="Incompatible",i.IncompatibleApi="IncompatibleApi",i.IncompatibleTargetPlatform="IncompatibleTargetPlatform",i.ReleaseVersionNotFound="ReleaseVersionNotFound",i.Invalid="Invalid",i.Download="Download",i.DownloadSignature="DownloadSignature",i.DownloadFailedWriting="DownloadFailedWriting",i.UpdateMetadata="UpdateMetadata",i.Extract="Extract",i.Scanning="Scanning",i.ScanningExtension="ScanningExtension",i.ReadUninstalled="ReadUninstalled",i.UnsetUninstalled="UnsetUninstalled",i.Delete="Delete",i.Rename="Rename",i.IntializeDefaultProfile="IntializeDefaultProfile",i.AddToProfile="AddToProfile",i.InstalledExtensionNotFound="InstalledExtensionNotFound",i.PostInstall="PostInstall",i.CorruptZip="CorruptZip",i.IncompleteZip="IncompleteZip",i.Signature="Signature",i.NotAllowed="NotAllowed",i.Gallery="Gallery",i.Cancelled="Cancelled",i.Unknown="Unknown",i.Internal="Internal"})(R||(e.ExtensionManagementErrorCode=R={}));class y extends Error{constructor(l,n){super(l),this.code=n,this.name=n}}e.$mp=y,e.$np=(0,k.$Ei)("extensionManagementService"),e.$op="extensionsIdentifiers/disabled",e.$pp="extensionsIdentifiers/enabled",e.$qp=(0,k.$Ei)("IGlobalExtensionEnablementService"),e.$rp=(0,k.$Ei)("IExtensionTipsService"),e.$sp=(0,P.localize2)(11490,"Extensions"),e.$tp=(0,P.localize2)(11491,"Preferences")}),define(ue[118],he([0,1,2,22,9]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=void 0;class k extends S.$Uc{constructor(O,w,a,f,c){super(),this.a=O,this.b=w,this.c=a,this.f=c,this.B(f.onDidInstallExtensions(m=>this.g(m))),this.B(f.onDidUninstallExtension(m=>this.h(m)))}g(O){for(const w of O)w.local&&this.invalidate(w.profileLocation)}h(O){O.error||this.invalidate(O.profileLocation)}async invalidate(O){if(O)for(const w of this.a.profiles)this.c.extUri.isEqual(w.extensionsResource,O)&&await this.j(w);else await this.j(this.a.defaultProfile)}async j(O){try{await this.b.del(this.c.extUri.joinPath(O.cacheHome,P.$kn))}catch(w){(0,v.$ql)(w)!==v.FileOperationResult.FILE_NOT_FOUND&&this.f.error(w)}}}e.$Vq=k});var Me=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(ue[44],he([0,1,16,57,5,45,22,97]),function(Y,e,S,P,v,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=f,e.$Zp=c,e.$1p=m,e.$2p=d,e.$3p=p,e.$4p=I,e.$5p=b,e.$6p=h,P=Me(P),v=ye(v),k=ye(k);const w=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,a=/^-(\d{4})(\d{2})(\d{2})$/;function f(y){return y=y.trim(),y==="*"||w.test(y)}function c(y){if(!f(y))return null;if(y=y.trim(),y==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=y.match(w);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}function m(y){if(!y)return null;const i=y.majorBase,l=y.majorMustEqual,n=y.minorBase;let s=y.minorMustEqual;const t=y.patchBase;let r=y.patchMustEqual;y.hasCaret&&(i===0||(s=!1),r=!1);let o=0;if(y.preRelease){const u=a.exec(y.preRelease);if(u){const[,$,N,C]=u;o=Date.UTC(Number($),Number(N)-1,Number(C))}}return{majorBase:i,majorMustEqual:l,minorBase:n,minorMustEqual:s,patchBase:t,patchMustEqual:r,isMinimum:y.hasGreaterEquals,notBefore:o}}function d(y,i,l){let n;typeof y=="string"?n=m(c(y)):n=y;let s;i instanceof Date?s=i.getTime():typeof i=="string"&&(s=new Date(i).getTime());let t;if(typeof l=="string"?t=m(c(l)):t=l,!n||!t)return!1;const r=n.majorBase,o=n.minorBase,u=n.patchBase;let $=t.majorBase,N=t.minorBase,C=t.patchBase;const A=t.notBefore;let D=t.majorMustEqual,U=t.minorMustEqual,G=t.patchMustEqual;return t.isMinimum?r>$?!0:r<$?!1:o>N?!0:o<N||s&&s<A?!1:u>=C:(r===1&&$===0&&(!D||!U||!G)&&($=1,N=0,C=0,D=!0,U=!1,G=!1),r<$?!1:r>$?!D:o<N?!1:o>N?!U:u<C?!1:u>C?!G:!(s&&s<A))}function p(y,i,l,n,s,t){const r=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return r.push([P.default.Error,v.localize(11421,null)]),r;if(typeof n.name!="string")return r.push([P.default.Error,v.localize(11422,null,"name")]),r;if(typeof n.version!="string")return r.push([P.default.Error,v.localize(11423,null,"version")]),r;if(!n.engines)return r.push([P.default.Error,v.localize(11424,null,"engines")]),r;if(typeof n.engines.vscode!="string")return r.push([P.default.Error,v.localize(11425,null,"engines.vscode")]),r;if(typeof n.extensionDependencies<"u"&&!R(n.extensionDependencies))return r.push([P.default.Error,v.localize(11426,null,"extensionDependencies")]),r;if(typeof n.activationEvents<"u"){if(!R(n.activationEvents))return r.push([P.default.Error,v.localize(11427,null,"activationEvents")]),r;if(typeof n.main>"u"&&typeof n.browser>"u")return r.push([P.default.Error,v.localize(11428,null,"activationEvents","main","browser")]),r}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&r.push([P.default.Warning,v.localize(11429,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return r.push([P.default.Error,v.localize(11430,null,"main")]),r;{const $=(0,S.$fh)(l,n.main);(0,S.$_g)($,l)||r.push([P.default.Warning,v.localize(11431,null,$.path,l.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return r.push([P.default.Error,v.localize(11432,null,"browser")]),r;{const $=(0,S.$fh)(l,n.browser);(0,S.$_g)($,l)||r.push([P.default.Warning,v.localize(11433,null,$.path,l.path)])}}if(!k.valid(n.version))return r.push([P.default.Error,v.localize(11434,null)]),r;const o=[];if(!I(y,i,n,s,o))for(const $ of o)r.push([P.default.Error,$]);if(t&&n.enabledApiProposals?.length){const $=[];if(!h([...n.enabledApiProposals],$))for(const N of $)r.push([P.default.Error,N])}return r}function I(y,i,l,n,s){return n||typeof l.main>"u"&&typeof l.browser>"u"?!0:g(y,i,l.engines.vscode,s)}function b(y,i,l){return y==="*"||g(i,l,y)}function h(y,i){if(y.length===0)return!0;const l=Array.isArray(i)?i:void 0,n=(l?void 0:i)??O.allApiProposals,s=[],t=(0,L.$xn)(y);for(const{proposalName:r,version:o}of t){const u=n[r];u&&o&&u.version!==o&&s.push(v.localize(11435,null,r))}return l?.push(...s),s.length===0}function g(y,i,l,n=[]){const s=m(c(l));if(!s)return n.push(v.localize(11436,null,l)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return n.push(v.localize(11437,null,l)),!1}else if(!s.majorMustEqual)return n.push(v.localize(11438,null,l)),!1;return d(y,i,s)?!0:(n.push(v.localize(11439,null,y,l)),!1)}function R(y){if(!Array.isArray(y))return!1;for(let i=0,l=y.length;i<l;i++)if(typeof y[i]!="string")return!1;return!0}}),define(ue[68],he([0,1,21,2,12,5,20,10]),function(Y,e,S,P,v,k,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=void 0,e.$0r=w;function w(f){return f.tags.find(c=>c.startsWith("lp-"))?.split("lp-")[1]}e.$$r=(0,O.$Ei)("languagePackService");let a=class extends P.$Uc{constructor(c){super(),this.c=c}async getAvailableLanguages(){const c=new S.$we;setTimeout(()=>c.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},c.token)}catch{return[]}const p=m.firstPage.filter(I=>I.properties.localizedLanguages?.length&&I.tags.some(b=>b.startsWith("lp-"))).map(I=>{const b=I.properties.localizedLanguages?.[0],h=w(I);return{...this.f(h,b,I),extensionId:I.identifier.id,galleryExtension:I}});return p.push(this.f("en","English")),p}f(c,m,d){const p=m??c;let I;if(p!==c&&(I=`(${c})`),c.toLowerCase()===v.$x.toLowerCase()&&(I??="",I+=(0,k.localize)(11343,null)),d?.installCount){I??="";const b=d.installCount;let h;b>1e6?h=`${Math.floor(b/1e5)/10}M`:b>1e3?h=`${Math.floor(b/1e3)}K`:h=String(b),I+=` $(cloud-download) ${h}`}return{id:c,label:p,description:I}}};e.$_r=a,e.$_r=a=be([re(0,L.$kp)],a)}),define(ue[46],he([0,1,13,7,2,5,40,10,6,37]),function(Y,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$9p=m,e.$0p=d,e.$$p=p,e.$_p=I,e.$aq=b,e.$bq=h,e.$7p=(0,O.$Ei)("requestService");class f{constructor(i){this.b=i}toJSON(){if(!this.a){const i=Object.create(null);for(const l in this.b)l.toLowerCase()==="authorization"||l.toLowerCase()==="proxy-authorization"?i[l]="*****":i[l]=this.b[l];this.a=i}return this.a}}class c extends v.$Uc{constructor(i){super(),this.b=0,this.a=i.createLogger("network",{name:(0,k.localize)(11208,null),when:w.$rk.isEqualTo((0,w.$ok)(w.LogLevel.Trace)).serialize()})}async c(i,l,n){const s=`${i} #${++this.b}: ${l.url}`;this.a.trace(`${s} - begin`,l.type,new f(l.headers??{}));try{const t=await n();return this.a.trace(`${s} - end`,l.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${s} - error`,l.type,(0,P.$9)(t)),t}}}e.$8p=c;function m(y){return y.res.statusCode&&y.res.statusCode>=200&&y.res.statusCode<300||y.res.statusCode===1223}function d(y){return y.res.statusCode===204}async function p(y){return d(y)?null:(await(0,S.$Ze)(y.stream)).toString()}async function I(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);return p(y)}async function b(y){if(!m(y))throw new Error("Server returned "+y.res.statusCode);if(d(y))return null;const l=(await(0,S.$Ze)(y.stream)).toString();try{return JSON.parse(l)}catch(n){throw n.message+=`:
`+l,n}}function h(y){R(y)}let g;function R(y){const i=a.$qo.as(L.$vo.Configuration),l=g;g={id:"http",order:15,title:(0,k.localize)(11209,null),type:"object",scope:y,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,k.localize)(11210,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,k.localize)(11211,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,k.localize)(11212,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,k.localize)(11213,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,k.localize)(11214,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,k.localize)(11215,null),(0,k.localize)(11216,null),(0,k.localize)(11217,null),(0,k.localize)(11218,null)],default:"override",description:(0,k.localize)(11219,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,k.localize)(11220,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,k.localize)(11221,null),restricted:!0}}},i.updateConfigurations({add:[g],remove:l?[l]:[]})}R(L.ConfigurationScope.APPLICATION)}),define(ue[119],he([0,1,21,14,9,46]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YR=void 0;let L=class{constructor(w,a){this.a=w,this.b=a}async download(w,a,f=S.CancellationToken.None){if(w.scheme===P.Schemas.file||w.scheme===P.Schemas.vscodeRemote){await this.b.copy(w,a);return}const c={type:"GET",url:w.toString(!0)},m=await this.a.request(c,f);if(m.res.statusCode===200)await this.b.writeFile(a,m.stream);else{const d=await(0,k.$_p)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${d}`)}}};e.$YR=L,e.$YR=L=be([re(0,k.$7p),re(1,v.$_k)],L)}),define(ue[120],he([0,1,121,3]),function(Y,e,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=k;function v(L,O){return L.protocol==="http:"?O.HTTP_PROXY||O.http_proxy||null:L.protocol==="https:"&&(O.HTTPS_PROXY||O.https_proxy||O.HTTP_PROXY||O.http_proxy)||null}async function k(L,O,w={}){const a=(0,S.parse)(L),f=w.proxyUrl||v(a,O);if(!f)return null;const c=(0,S.parse)(f);if(!/^https?:$/.test(c.protocol||""))return null;const m={host:c.hostname||"",port:(c.port?+c.port:0)||(c.protocol==="https"?443:80),auth:c.auth,rejectUnauthorized:(0,P.$kg)(w.strictSSL)?w.strictSSL:!0};if(a.protocol==="http:"){const d=await new Promise((p,I)=>{Y(["http-proxy-agent"],p,I)}).then(ye);return new d.HttpProxyAgent(f,m)}else{const d=await new Promise((p,I)=>{Y(["https-proxy-agent"],p,I)}).then(ye);return new d.HttpsProxyAgent(f,m)}}}),define(ue[122],he([0,1,60,15,5,21,38,7,12,28,86,152,8,79]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=I;let p;async function I(h,g,R,y){return R["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):w.$j?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,c.$Jm)(y)&&!R["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,c.$Jm)(y)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(i,l)=>{const n=new k.$we;let s=1e4;const t=h.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(s=(0,d.$Km)(t,1,120)*1e3);const r=setTimeout(()=>{n.dispose(!0),l(new Error((0,v.localize)(11205,null)))},s);try{i(await b(g,n.token))}catch(o){!(0,O.$3)(o)&&!n.token.isCancellationRequested?l(new Error((0,v.localize)(11206,null,(0,L.$pj)(o)))):i({})}finally{clearTimeout(r),n.dispose()}})),p)}async function b(h,g){const R=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",R);const y=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",y);const i=(0,a.$1g)().replace(/-/g,"").substr(0,12),l=new RegExp(i+"({.*})"+i),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",n);const s=await(0,f.$zm)(w.OS,n);return h.trace("getUnixShellEnvironment#shell",s),new Promise((t,r)=>{if(g.isCancellationRequested)return r(new O.$4);const o=(0,P.$nc)(s);let u,$;const N="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${N} -p '''${i}'' + JSON.stringify(process.env) + ''${i}'''`,$=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,$=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${i}", json.dumps(dict(os.environ)), "${i}")`,$=["-i","-l","-c"]):(u=`'${process.execPath}' ${N} -p '"${i}" + JSON.stringify(process.env) + "${i}"'`,o==="tcsh"||o==="csh"?$=["-ic"]:$=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify($),u);const C=(0,S.spawn)(s,[...$,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});g.onCancellationRequested(()=>(C.kill(),r(new O.$4))),C.on("error",U=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,L.$pj)(U)),r(U)});const A=[];C.stdout.on("data",U=>A.push(U));const D=[];C.stderr.on("data",U=>D.push(U)),C.on("close",(U,G)=>{const Q=Buffer.concat(A).toString("utf8");h.trace("getUnixShellEnvironment#raw",Q);const te=Buffer.concat(D).toString("utf8");if(te.trim()&&h.trace("getUnixShellEnvironment#stderr",te),U||G)return r(new Error((0,v.localize)(11207,null,U,G)));const ae=l.exec(Q),le=ae?ae[1]:"{}";try{const de=JSON.parse(le);R?de.ELECTRON_RUN_AS_NODE=R:delete de.ELECTRON_RUN_AS_NODE,y?de.ELECTRON_NO_ATTACH_CONSOLE=y:delete de.ELECTRON_NO_ATTACH_CONSOLE,delete de.VSCODE_RESOLVING_ENVIRONMENT,delete de.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",de),t(de)}catch(de){h.error("getUnixShellEnvironment#errorCaught",(0,L.$pj)(de)),r(de)}})})}}),define(ue[123],he([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BR=e.$AR=void 0,e.$AR=(0,S.$Ei)("stateReadService"),e.$BR=(0,S.$Ei)("stateService")}),define(ue[69],he([0,1,8,13,2,3,17,9,6]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ER=e.$DR=e.$CR=e.SaveStrategy=void 0;var a;(function(d){d[d.IMMEDIATE=0]="IMMEDIATE",d[d.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class f extends v.$Uc{constructor(p,I,b,h){super(),this.h=p,this.j=I,this.m=b,this.n=h,this.a=Object.create(null),this.b="",this.c=this.B(new S.$Ch(this.j===a.IMMEDIATE?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==O.FileOperationResult.FILE_NOT_FOUND&&this.m.error(p)}}getItem(p,I){const b=this.a[p];return(0,k.$ng)(b)?I:b}setItem(p,I){this.setItems([{key:p,data:I}])}setItems(p){let I=!1;for(const{key:b,data:h}of p)this.a[b]!==h&&((0,k.$ng)(h)?(0,k.$lg)(this.a[b])||(this.a[b]=void 0,I=!0):(this.a[b]=h,I=!0));I&&this.s()}removeItem(p){(0,k.$lg)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,P.$Ne.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(I){this.m.error(I)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$CR=f;let c=class extends v.$Uc{constructor(p,I,b,h){super(),this.a=this.B(new f(I.stateResource,p,b,h))}async init(){await this.a.init()}getItem(p,I){return this.a.getItem(p,I)}};e.$DR=c,e.$DR=c=be([re(1,L.$Li),re(2,w.$_j),re(3,O.$_k)],c);class m extends c{setItem(p,I){this.a.setItem(p,I)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$ER=m}),define(ue[70],he([0,1,12,36,28]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=L,e.$vp=O;function k(w){if(S.$v===S.Platform.Linux&&/^penguin(\.|$)/i.test(w))return"chromebook"}function L(w,a,f,c,m,d,p,I,b,h){const g=Object.create(null);g["common.machineId"]=d,g["common.sqmId"]=p,g["common.devDeviceId"]=I,g.sessionID=(0,v.$1g)()+Date.now(),g.commitHash=c,g.version=m,g["common.platformVersion"]=(w||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,S.$i)(S.$v),g["common.nodePlatform"]=P.$dc,g["common.nodeArch"]=f,g["common.product"]=h||"desktop",b&&(g["common.msftInternal"]=b);let R=0;const y=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-y,enumerable:!0},"common.sequence":{get:()=>R++,enumerable:!0}}),S.$m&&(g["common.snap"]="true");const i=k(a);return i&&(g["common.platformDetail"]=i),g}function O(w){const a=P.env.USERDNSDOMAIN;if(!a)return!1;const f=a.toLowerCase();return w.some(c=>f===c)}}),define(ue[18],he([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,S.$Ei)("telemetryService"),e.$_l=(0,S.$Ei)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var P;(function(k){k[k.NONE=0]="NONE",k[k.CRASH=1]="CRASH",k[k.ERROR=2]="ERROR",k[k.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var v;(function(k){k.OFF="off",k.CRASH="crash",k.ERROR="error",k.ON="all"})(v||(e.TelemetryConfiguration=v={}))}),define(ue[71],he([0,1,7,10,6,18]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.ExtensionSignatureVerificationCode=e.$sq=void 0,e.$sq=(0,P.$Ei)("IExtensionSignatureVerificationService");var L;(function(a){a.Success="Success",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(L||(e.ExtensionSignatureVerificationCode=L={}));class O extends Error{constructor(f){super(f),this.code=f}}e.$tq=O;let w=class{constructor(f,c){this.b=f,this.c=c}d(){return this.a||(this.a=new Promise((f,c)=>Y(["@vscode/vsce-sign"],async m=>f(m),c))),this.a}async verify(f,c,m,d){let p;const I=f.identifier.id;try{p=await this.d()}catch(R){return this.b.error("Could not load vsce-sign module",(0,S.$9)(R)),this.b.info(`Extension signature verification is not done: ${I}`),!1}const b=new Date().getTime();let h;try{this.b.trace(`Verifying extension signature for ${I}...`),h=await p.verify(c,m,this.b.getLevel()===v.LogLevel.Trace)}catch(R){h={code:L.UnknownError,didExecute:!1,output:(0,S.$9)(R)}}const g=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${I}: ${h.code}. Executed: ${h.didExecute}. Duration: ${g}ms.`),this.b.trace(`Extension signature verification output for ${I}:
${h.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:I,extensionVersion:f.version,code:h.code,internalCode:h.internalCode,duration:g,didExecute:h.didExecute,clientTargetPlatform:d}),h.code===L.Success)return!0;throw new O(h.code)}};e.$uq=w,e.$uq=w=be([re(0,v.$_j),re(1,k.$$l)],w)}),define(ue[41],he([0,1,27,3,67,70,18]),function(Y,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$Dp=f,e.$Ep=c,e.$Fp=m,e.$Gp=d,e.$Hp=I,e.$Ip=h,e.$Jp=g,e.$Kp=i;class O{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$wp=O;class w{constructor(){this.telemetryLevel=L.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xp=w,e.$yp=new w;class a{async publicLog(n,s,t){}async publicLogError(n,s,t){}}e.$zp=a,e.$Ap="telemetry",e.$Bp="extensionTelemetryLog",e.$Cp={log:()=>null,flush:()=>Promise.resolve(null)};function f(l,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!l.enableTelemetry)}function c(l,n){return n.extensionTestsLocationURI?!0:!(n.isBuilt||n.disableTelemetry||l.enableTelemetry&&l.aiConfig?.ariaKey)}function m(l){const n=l.getValue(L.$hm),s=l.getValue(L.$im);if(l.getValue(L.$jm)===!1||s===!1)return L.TelemetryLevel.NONE;switch(n??L.TelemetryConfiguration.ON){case L.TelemetryConfiguration.ON:return L.TelemetryLevel.USAGE;case L.TelemetryConfiguration.ERROR:return L.TelemetryLevel.ERROR;case L.TelemetryConfiguration.CRASH:return L.TelemetryLevel.CRASH;case L.TelemetryConfiguration.OFF:return L.TelemetryLevel.NONE}}function d(l){const n={},s={},t={};b(l,t);for(let r in t){r=r.length>150?r.substr(r.length-149):r;const o=t[r];typeof o=="number"?s[r]=o:typeof o=="boolean"?s[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),n[r]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(n[r]=o)}return{properties:n,measurements:s}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function I(l){if(!l)return"none";const n=(0,v.$hn)(l);return p.has(n)?n:"other"}function b(l,n,s=0,t){if(l)for(const r of Object.getOwnPropertyNames(l)){const o=l[r],u=t?t+r:r;Array.isArray(o)?n[u]=(0,S.$io)(o):o instanceof Date?n[u]=o.toISOString():(0,P.$gg)(o)?s<2?b(o,n,s+1,u+"."):n[u]=(0,S.$io)(o):n[u]=o}}function h(l,n){const s=l.msftInternalDomains||[],t=n.getValue("telemetry.internalTesting");return(0,k.$vp)(s)||t}function g(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}function R(l,n){if(!l||!l.includes("/")&&!l.includes("\\"))return l;let s=l;const t=[];for(const $ of n)for(;;){const N=$.exec(l);if(!N)break;t.push([N.index,$.lastIndex])}const r=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(s="";;){const $=o.exec(l);if(!$)break;const N=t.some(([C,A])=>$.index<A&&C<o.lastIndex);!r.test($[0])&&!N&&(s+=l.substring(u,$.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<l.length&&(s+=l.substr(u)),s}function y(l){if(!l)return l;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of n)if(s.regex.test(l))return`<REDACTED: ${s.label}>`;return l}function i(l,n){return(0,S.$fo)(l,s=>{if(s instanceof O||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let t=s.replaceAll("%20"," ");t=R(t,n);for(const r of n)t=t.replace(r,"");return t=y(t),t}})}}),define(ue[26],he([0,1,31,20,22,12,11,7,36,41]),function(Y,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Mp=void 0,e.$Lp=f,e.$Np=p,e.$Op=I,e.$Pp=b,e.$Qp=h,e.$Rp=g,e.$Sp=R,e.$Tp=y,e.$Vp=i,e.$Wp=n;function f(s,t){return s.uuid&&t.uuid?s.uuid===t.uuid:s.id===t.id?!0:(0,S.$Af)(s.id,t.id)===0}const c=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(t){const r=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new m(t.identifier,r,o)}static parse(t){const r=c.exec(t);return r&&r[1]&&r[2]?new m({id:r[1]},r[2],r[4]||void 0):null}constructor(t,r,o=v.TargetPlatform.UNDEFINED){this.identifier=t,this.version=r,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==v.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof m?f(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$Mp=m;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(s){const t=d.exec(s);return t&&t[1]?[b(t[1]),t[2]]:[b(s),void 0]}function I(s,t){return`${s}.${t}`}function b(s){return s.toLowerCase()}function h(s,t){return b(I(s??v.$mn,t))}function g(s,t){const r=[],o=u=>{for(const $ of r)if($.some(N=>f(t(N),t(u))))return $;return null};for(const u of s){const $=o(u);$?$.push(u):r.push([u])}return r}function R(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function y(s){return{id:new a.$wp(s.identifier.id),name:new a.$wp(s.name),version:s.version,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Up=new v.$qn("pprice.better-merge");function i(s,t){const r=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&r.every($=>!f($.identifier,{id:u}))){const $=s.filter(N=>f(N.identifier,{id:u}));$.length===1&&(r.push($[0]),o.push(...$[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}async function l(s,t){if(!k.$l)return!1;let r;try{r=(await s.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await s.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,O.$9)(u))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function n(s,t){const r=await l(s,t),o=(0,P.$gp)(r?"alpine":k.$v,w.$ec);return t.debug("ComputeTargetPlatform:",o),o}}),define(ue[124],he([0,1,21,7,14,16,45,11,5,20,26,22]),function(Y,e,S,P,v,k,L,O,w,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=void 0;const m=I=>(0,w.localize)(11458,null,I),d=(0,w.localize)(11459,null,"ms-dotnettools.csharp");let p=class{constructor(b,h,g){this.a=b,this.b=h,this.d=g}get f(){}async listExtensions(b,h,g){let R=await this.b.getInstalled(c.ExtensionType.User,g);const y=c.$pn.map(l=>l.toLowerCase());if(h&&h!==""){if(y.indexOf(h.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}R=R.filter(l=>l.manifest.categories?l.manifest.categories.map(s=>s.toLowerCase()).indexOf(h.toLowerCase())>-1:!1)}else if(h===""){this.a.info("Possible Categories: "),y.forEach(l=>{this.a.info(l)});return}this.f&&this.a.info((0,w.localize)(11460,null,this.f)),R=R.sort((l,n)=>l.identifier.id.localeCompare(n.identifier.id));let i;for(const l of R)i!==l.identifier.id&&(i=l.identifier.id,this.a.info(b?`${i}@${l.manifest.version}`:i))}async installExtensions(b,h,g,R){const y=[];try{b.length&&this.a.info(this.f?(0,w.localize)(11461,null,this.f):(0,w.localize)(11462,null));const i=[],l=[],n=(t,r,o)=>{l.push({id:t,version:r!=="prerelease"?r:void 0,installOptions:{...g,isBuiltin:o,installPreReleaseVersion:r==="prerelease"||g.installPreReleaseVersion}})};for(const t of b)if(t instanceof O.URI)i.push({vsix:t,installOptions:g});else{const[r,o]=(0,f.$Np)(t);n(r,o,!1)}for(const t of h)if(t instanceof O.URI)i.push({vsix:t,installOptions:{...g,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[r,o]=(0,f.$Np)(t);n(r,o,!0)}const s=await this.b.getInstalled(void 0,g.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:t,installOptions:r})=>{try{await this.h(t,r,R,s)}catch(o){this.a.error(o),y.push(t.toString())}})),l.length){const t=await this.g(l,s,R);y.push(...t)}}catch(i){throw this.a.error((0,w.localize)(11463,null,(0,P.$9)(i))),i}if(y.length)throw new Error((0,w.localize)(11464,null,y.join(", ")))}async updateExtensions(b){const h=await this.b.getInstalled(c.ExtensionType.User,b),g=[];for(const l of h)l.identifier.uuid&&g.push({...l.identifier,preRelease:l.preRelease});this.a.trace((0,w.localize)(11465,null,g.length));const R=await this.d.getExtensions(g,{compatible:!0},S.CancellationToken.None),y=[];for(const l of R)for(const n of h)(0,f.$Lp)(n.identifier,l.identifier)&&(0,L.gt)(l.version,n.manifest.version)&&y.push({extension:l,options:{operation:a.InstallOperation.Update,installPreReleaseVersion:n.preRelease,profileLocation:b,isApplicationScoped:n.isApplicationScoped}});if(!y.length){this.a.info((0,w.localize)(11466,null));return}this.a.info((0,w.localize)(11467,null,y.map(l=>l.extension.identifier.id).join(", ")));const i=await this.b.installGalleryExtensions(y);for(const l of i)l.error?this.a.error((0,w.localize)(11468,null,l.identifier.id,(0,P.$9)(l.error))):this.a.info((0,w.localize)(11469,null,l.identifier.id,l.local?.manifest.version))}async g(b,h,g){if(b=b.filter(({id:l,version:n})=>{const s=h.find(t=>(0,f.$Lp)(t.identifier,{id:l}));if(s){if(!g&&(!n||n==="prerelease"&&s.preRelease))return this.a.info((0,w.localize)(11470,null,l,s.manifest.version,l)),!1;if(n&&s.manifest.version===n)return this.a.info((0,w.localize)(11471,null,`${l}@${n}`)),!1}return!0}),!b.length)return[];const R=[],y=[],i=await this.j(b);if(await Promise.all(b.map(async({id:l,version:n,installOptions:s})=>{const t=i.get(l.toLowerCase());if(!t){this.a.error(`${m(n?`${l}@${n}`:l)}
${d}`),R.push(l);return}try{const o=await this.d.getManifest(t,S.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),R.push(l);return}const r=h.find(o=>(0,f.$Lp)(o.identifier,t.identifier));if(r){if(t.version===r.manifest.version){this.a.info((0,w.localize)(11472,null,n?`${l}@${n}`:l));return}this.a.info((0,w.localize)(11473,null,l,t.version))}s.isBuiltin?this.a.info(n?(0,w.localize)(11474,null,l,n):(0,w.localize)(11475,null,l)):this.a.info(n?(0,w.localize)(11476,null,l,n):(0,w.localize)(11477,null,l)),y.push({extension:t,options:{...s,installGivenVersion:!!n,isApplicationScoped:s.isApplicationScoped||r?.isApplicationScoped}})})),y.length){const l=await this.b.installGalleryExtensions(y);for(const n of l)n.error?(this.a.error((0,w.localize)(11478,null,n.identifier.id,(0,P.$9)(n.error))),R.push(n.identifier.id)):this.a.info((0,w.localize)(11479,null,n.identifier.id,n.local?.manifest.version))}return R}async h(b,h,g,R){const y=await this.b.getManifest(b);if(!y)throw new Error("Invalid vsix");if(await this.l(y,g,h.profileLocation,R))try{await this.b.install(b,{...h,installGivenVersion:!0}),this.a.info((0,w.localize)(11480,null,(0,k.$ch)(b)))}catch(l){if((0,P.$3)(l))this.a.info((0,w.localize)(11481,null,(0,k.$ch)(b)));else throw l}}async j(b){const h=new Map,g=b.some(i=>i.installOptions.installPreReleaseVersion),R=await this.b.getTargetPlatform(),y=[];for(const i of b)a.$$o.test(i.id)&&y.push({...i,preRelease:g});if(y.length){const i=await this.d.getExtensions(y,{targetPlatform:R},S.CancellationToken.None);for(const l of i)h.set(l.identifier.id.toLowerCase(),l)}return h}k(b){return!0}async l(b,h,g,R){if(!h){const y={id:(0,f.$Qp)(b.publisher,b.name)},i=R.find(l=>(0,f.$Lp)(y,l.identifier)&&(0,L.gt)(l.manifest.version,b.version));if(i)return this.a.info((0,w.localize)(11482,null,i.identifier.id,i.manifest.version,b.version)),!1}return this.k(b)}async uninstallExtensions(b,h,g){const R=async i=>{if(i instanceof O.URI){const l=await this.b.getManifest(i);return(0,f.$Op)(l.publisher,l.name)}return i},y=[];for(const i of b){const l=await R(i),s=(await this.b.getInstalled(void 0,g)).filter(t=>(0,f.$Lp)(t.identifier,{id:l}));if(!s.length)throw new Error(`${this.m(l)}
${d}`);if(s.some(t=>t.type===c.ExtensionType.System)){this.a.info((0,w.localize)(11483,null,l));return}if(!h&&s.some(t=>t.isBuiltin)){this.a.info((0,w.localize)(11484,null,l));return}this.a.info((0,w.localize)(11485,null,l));for(const t of s)await this.b.uninstall(t,{profileLocation:g}),y.push(t);this.f?this.a.info((0,w.localize)(11486,null,l,this.f)):this.a.info((0,w.localize)(11487,null,l))}}async locateExtension(b){const h=await this.b.getInstalled();b.forEach(g=>{h.forEach(R=>{if(R.identifier.id===g&&R.location.scheme===v.Schemas.file){this.a.info(R.location.fsPath);return}})})}m(b){return this.f?(0,w.localize)(11488,null,b,this.f):(0,w.localize)(11489,null,b)}};e.$vq=p,e.$vq=p=be([re(1,a.$np),re(2,a.$kp)],p)}),define(ue[125],he([0,1,7,4,2,25,26,22,9]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=void 0;class a extends v.$Uc{constructor(c,m,d,p,I,b,h){super(),this.f=c,this.g=m,this.h=d,this.j=p,this.m=I,this.n=b,this.r=h,this.a=this.B(new P.$le),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new v.$4c),this.s().then(null,g=>h.error("Error while initializing Extensions Watcher",(0,S.$9)(g)))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(c=>this.u(c.added))),this.B(this.j.onAddExtensions(c=>this.w(c))),this.B(this.j.onDidAddExtensions(c=>this.y(c))),this.B(this.j.onRemoveExtensions(c=>this.z(c))),this.B(this.j.onDidRemoveExtensions(c=>this.C(c))),this.B(this.n.onDidFilesChange(c=>this.D(c)))}async u(c){try{c.length&&await Promise.all(c.map(m=>(this.c.set(m.id,(0,v.$Rc)(this.n.watch(this.m.extUri.dirname(m.extensionsResource)),this.n.watch(m.extensionsResource))),this.G(m.extensionsResource))))}catch(m){throw this.r.error(m),m}}async w(c){for(const m of c.extensions)this.I(this.L(m.identifier,m.version),c.profileLocation)}async y(c){for(const m of c.extensions){const d=this.L(m.identifier,m.version);c.error?this.J(d,c.profileLocation):this.I(d,c.profileLocation)}}async z(c){for(const m of c.extensions)this.J(this.L(m.identifier,m.version),c.profileLocation)}async C(c){const m=[],d=[];for(const p of c.extensions){const I=this.L(p.identifier,p.version);c.error?this.I(I,c.profileLocation):(this.J(I,c.profileLocation),this.b.has(I)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),d.push(this.f.scanInstalledExtensionAtLocation(p.location).then(b=>{b?m.push(b):this.r.info("Extension not found at the location",p.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(d),m.length&&await this.H(m)}catch(p){this.r.error(p)}}D(c){for(const m of this.h.profiles)c.contains(m.extensionsResource,w.FileChangeType.UPDATED,w.FileChangeType.ADDED)&&this.F(m.extensionsResource)}async F(c){const m=[],d=[],p=await this.j.scanProfileExtensions(c),I=new Set,b=new Set;for(const[h,g]of this.b)g.has(c)&&b.add(h);for(const h of p){const g=this.L(h.identifier,h.version);I.add(g),b.has(g)||(m.push(h.identifier),this.I(g,c))}for(const h of b)if(!I.has(h)){const g=this.M(h);g&&(d.push(g.identifier),this.J(h,c))}(m.length||d.length)&&this.a.fire({added:m.length?{extensions:m,profileLocation:c}:void 0,removed:d.length?{extensions:d,profileLocation:c}:void 0})}async G(c){const m=await this.j.scanProfileExtensions(c);for(const d of m)this.I(this.L(d.identifier,d.version),c)}async H(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(d=>!this.b.has(this.L(d.identifier,d.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}I(c,m){let d=this.b.get(c);d||this.b.set(c,d=new k.$Bc(p=>this.m.extUri.getComparisonKey(p))),d.add(m)}J(c,m){const d=this.b.get(c);d&&d.delete(m),d?.size||this.b.delete(c)}L(c,m){return`${O.$qn.toKey(c.id)}@${m}`}M(c){const[m,d]=(0,L.$Np)(c);return d?{identifier:{id:m},version:d}:void 0}}e.$Wq=a}),define(ue[126],he([0,1,32,153,19,8,2,14,15,29,17,20,26,6,68,11]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,S=ye(S);let b=class extends p.$_r{constructor(y,i,l,n){super(l),this.h=y,this.j=n,this.g=this.B(new h(i,n)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(y,i){const n=(await this.g.getLanguagePacks())[i];if(!n){this.j.warn(`No language pack found for ${i}`);return}const s=n.translations[y];return s?I.URI.file(s):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),i=Object.keys(y).map(l=>{const n=y[l];return{...this.f(l,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return i.push(this.f("en","English")),i.sort((l,n)=>l.label.localeCompare(n.label)),i}async m(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",y.identifier.id),await this.update())}async n(y){const i=await this.g.getLanguagePacks();Object.keys(i).some(l=>i[l]&&i[l].extensions.some(n=>(0,m.$Lp)(n.extensionIdentifier,y.identifier)))&&(this.j.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,i]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),l=await this.g.update(i);return!(0,v.$tb)(Object.keys(y),Object.keys(l))}};e.$as=b,e.$as=b=be([re(0,c.$np),re(1,f.$Mi),re(2,c.$kp),re(3,d.$_j)],b);let h=class extends L.$Uc{constructor(y,i){super(),this.j=i,this.c={},this.f=(0,w.$jc)(y.userDataPath,"languagepacks.json"),this.g=new k.$Lh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.s(i=>{Object.keys(i).forEach(l=>delete i[l]),this.m(i,...y)}).then(()=>this.c)}m(y,...i){for(const l of i)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.n(y,l);Object.keys(y).forEach(l=>this.r(y[l]))}n(y,i){const l=i.identifier,n=i.manifest.contributes&&i.manifest.contributes.localizations?i.manifest.contributes.localizations:[];for(const s of n)if(i.location.scheme===O.Schemas.file&&g(s)){let t=y[s.languageId];t||(t={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},y[s.languageId]=t);const r=t.extensions.filter(o=>(0,m.$Lp)(o.extensionIdentifier,l))[0];r?r.version=i.manifest.version:t.extensions.push({extensionIdentifier:l,version:i.manifest.version});for(const o of s.translations)t.translations[o.id]=(0,w.$jc)(i.location.fsPath,o.path)}}r(y){if(y){const i=(0,P.createHash)("md5");for(const l of y.extensions)i.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);y.hash=i.digest("hex")}}s(y=()=>null){return this.g.queue(()=>{let i=null;return S.promises.readFile(this.f,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch{return{}}}).then(l=>(i=y(l),l)).then(l=>{for(const s of Object.keys(l))l[s]||delete l[s];this.c=l,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),a.Promises.writeFile(this.f,n)}).then(()=>i,l=>this.j.error(l))})}};h=be([re(0,f.$Mi),re(1,d.$_j)],h);function g(R){if(typeof R.languageId!="string"||!Array.isArray(R.translations)||R.translations.length===0)return!1;for(const y of R.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(R.languageName&&typeof R.languageName!="string"||R.localizedLanguageName&&typeof R.localizedLanguageName!="string")}}),define(ue[127],he([0,1,82,7,27,41]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wR=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",O="https://mobile.events.data.microsoft.com/ping";async function w(f,c,m){const d=await(0,S.$BE)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,S.$BE)("@microsoft/1ds-post-js","dist/ms.post.js"),I=new d.AppInsightsCore,b=new p.PostChannel,h={instrumentationKey:f,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[b]]};if(m){h.extensionConfig={};const g={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};h.extensionConfig[b.identifier]=g}return I.initialize(h,[]),I.addTelemetryInitializer(g=>{g.ext=g.ext??{},g.ext.web=g.ext.web??{},g.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',c&&(g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),I}class a{constructor(c,m,d,p,I){this.e=c,this.f=m,this.g=d,this.h=I,this.c=L,this.d=O,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(c){if(this.a){if(typeof this.a!="string"){c(this.a);return}this.b||(this.b=w(this.a,this.e,this.h)),this.b.then(m=>{c(m)},m=>{(0,P.$Y)(m),console.error(m)})}}log(c,m){if(!this.a)return;m=(0,v.$go)(m,this.g),m=(0,k.$Gp)(m);const d=this.f+"/"+c;try{this.i(p=>{p.pluginVersionString=m?.properties.version??"Unknown",p.track({name:d,baseData:{name:d,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(c=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,c(void 0)})})}):Promise.resolve(void 0)}}e.$wR=a});var Me=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(ue[128],he([0,1,2,27,12,31,5,30,40,129,33,37,18,41]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0,a=Me(a);let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,g,R){this.k=g,this.l=R,this.d={},this.i=new S.$Tc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.devDeviceId=this.c["common.devDeviceId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=m.TelemetryLevel.USAGE,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const y of this.f)this.j.push(new RegExp((0,k.$hf)(y),"gi")),y.indexOf("\\")>=0&&this.j.push(new RegExp((0,k.$hf)(y.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(y=>{(y.affectsConfiguration(m.$hm)||y.affectsConfiguration(m.$jm)||y.affectsConfiguration(m.$im))&&this.m()}))}setExperimentProperty(h,g){this.d[h]=g}m(){let h=(0,d.$Fp)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const R=g.usage?m.TelemetryLevel.USAGE:g.error?m.TelemetryLevel.ERROR:m.TelemetryLevel.NONE;h=Math.min(h,R)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,g,R){this.g<g||(R=(0,P.$go)(R,this.d),R=(0,d.$Kp)(R,this.j),R=(0,P.$go)(R,this.c),this.b.forEach(y=>y.log(h,R)))}publicLog(h,g){this.n(h,m.TelemetryLevel.USAGE,g)}publicLog2(h,g){this.publicLog(h,g)}publicLogError(h,g){this.h&&this.n(h,m.TelemetryLevel.ERROR,g)}publicLogError2(h,g){this.publicLogError(h,g)}};e.$gs=p,e.$gs=p=be([re(1,O.$$i),re(2,f.$sk)],p);function I(){const b=(0,L.localize)(11186,null,a.default.nameLong),h=a.default.privacyStatementUrl?(0,L.localize)(11188,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,L.localize)(11187,null,"https://aka.ms/vscode-telemetry"),g=v.$p?"":(0,L.localize)(11189,null),R=(0,L.localize)(11190,null),y=(0,L.localize)(11191,null),i=(0,L.localize)(11192,null),l=(0,L.localize)(11193,null),n=`
|       | ${R} | ${y} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,L.localize)(11194,null);return`
${b} ${h} ${g}

&nbsp;

${l}
${n}

&nbsp;

${s}
`}c.$qo.as(w.$vo.Configuration).registerConfiguration({id:m.$gm,order:1,type:"object",title:(0,L.localize)(11195,null),properties:{[m.$hm]:{type:"string",enum:[m.TelemetryConfiguration.ON,m.TelemetryConfiguration.ERROR,m.TelemetryConfiguration.CRASH,m.TelemetryConfiguration.OFF],enumDescriptions:[(0,L.localize)(11196,null),(0,L.localize)(11197,null),(0,L.localize)(11198,null),(0,L.localize)(11199,null)],markdownDescription:I(),default:m.TelemetryConfiguration.ON,restricted:!0,scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}}),c.$qo.as(w.$vo.Configuration).registerConfiguration({id:m.$gm,order:110,type:"object",title:(0,L.localize)(11200,null),properties:{[m.$jm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,L.localize)(11202,null,a.default.nameLong,a.default.privacyStatementUrl):(0,L.localize)(11201,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(11203,null,`\`#${m.$hm}#\``),scope:w.ConfigurationScope.APPLICATION,tags:["usesOnlineServices","telemetry"]}}})}),define(ue[130],he([0,1,13,21,154,127]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xR=void 0,v=ye(v);async function L(f,c){const m=await c.request(f,P.CancellationToken.None),d=(await(0,S.$Ze)(m.stream)).toString(),p=m.res.statusCode??200;return{headers:m.res.headers,statusCode:p,responseData:d}}async function O(f){const c={method:f.type,headers:f.headers};return new Promise((d,p)=>{const I=v.request(f.url??"",c,b=>{b.on("data",function(h){d({headers:b.headers,statusCode:b.statusCode??200,responseData:h.toString()})}),b.on("error",function(h){p(h)})});I.write(f.data,b=>{b&&p(b)}),I.end()})}async function w(f,c,m){const d=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),p={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:d};try{const I=f?await L(p,f):await O(p);m(I.statusCode,I.headers,I.responseData)}catch{m(0,{})}}class a extends k.$wR{constructor(c,m,d,p,I){const b={sendPOST:(h,g)=>{w(c,h,g)}};super(m,d,p,I,b)}}e.$xR=a}),define(ue[131],he([0,1,32,15,29]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=k,S=ye(S);async function k(L,O){const w=Object.create(null),a=(c,m)=>{const d=JSON.parse(c);w[m]=d};if(O){const c=[],m=await v.Promises.readdir(O);for(const p of m)try{(await S.promises.stat((0,P.$jc)(O,p))).isDirectory()&&c.push(p)}catch{}const d=[];for(const p of c)(await v.Promises.readdir((0,P.$jc)(O,p))).filter(b=>b==="telemetry.json").length===1&&d.push(p);for(const p of d){const I=(await S.promises.readFile((0,P.$jc)(O,p,"telemetry.json"))).toString();a(I,p)}}let f=(await S.promises.readFile((0,P.$jc)(L,"telemetry-core.json"))).toString();return a(f,"vscode-core"),f=(await S.promises.readFile((0,P.$jc)(L,"telemetry-extensions.json"))).toString(),a(f,"vscode-extensions"),JSON.stringify(w,null,4)}}),define(ue[132],he([0,1,12,84,18]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$shc=k,e.$thc=L,e.$uhc=O;async function k(w,a){let f=w.getItem(v.$dm);return(typeof f!="string"||S.$k&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,P.$Sn)(a.error.bind(a))),f}async function L(w,a){let f=w.getItem(v.$em);return typeof f!="string"&&(f=await(0,P.$Tn)(a.error.bind(a))),f}async function O(w,a){let f=w.getItem(v.$fm);return typeof f!="string"&&(f=await(0,P.$Un)(a.error.bind(a))),f}}),define(ue[23],he([0,1,10]),function(Y,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,S.$Ei)("IUriIdentityService")}),define(ue[133],he([0,1,23,98,9,16,80,4,2]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class a{static{this._clock=0}constructor(m){this.uri=m,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let f=class{constructor(m){this.g=m,this.c=new w.$Tc,this.f=2**16;const d=new Map,p=I=>{let b=d.get(I.scheme);return b===void 0&&(b=m.hasProvider(I)&&!this.g.hasCapability(I,v.FileSystemProviderCapabilities.PathCaseSensitive),d.set(I.scheme,b)),b};this.c.add(O.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(I=>{d.delete(I.scheme)})),this.extUri=new k.$7g(p),this.d=new L.$Ss((I,b)=>this.extUri.compare(I,b,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,k.$gh)(m));const d=this.d.get(m);return d?d.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new a(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((p,I)=>p[1].time<I[1].time?1:p[1].time>I[1].time?-1:0);a._clock=0,this.d.clear();const d=this.f*.5;for(let p=0;p<d;p++)this.d.set(m[p][0],m[p][1].touch())}};e.$Ts=f,e.$Ts=f=be([re(0,v.$_k)],f),(0,P.$Qs)(S.$Jl,f,P.InstantiationType.Delayed)}),define(ue[134],he([0,1,4,2,9,49,25]),function(Y,e,S,P,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;class O extends P.$Uc{constructor(a,f,c,m,d,p){super(),this.f=a,this.g=f,this.h=c,this.j=m,this.m=d,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new S.$le),this.onDidChangeFile=this.a.event,this.b=k.$Ki.forUris(()=>!(this.capabilities&v.FileSystemProviderCapabilities.PathCaseSensitive)),this.c=new L.$Bc(I=>this.m.extUri.getComparisonKey(this.t(I))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(I=>this.s(I)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,f){return this.g.open(this.t(a),f)}close(a){return this.g.close(a)}read(a,f,c,m,d){return this.g.read(a,f,c,m,d)}write(a,f,c,m,d){return this.g.write(a,f,c,m,d)}watch(a,f){this.b.set(a,a);const c=this.g.watch(this.t(a),f);return(0,P.$Sc)(()=>{this.b.delete(a),c.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,f,c){return this.g.rename(this.t(a),this.t(f),c)}readFile(a,f){return this.g.readFile(this.t(a),f)}readFileStream(a,f,c){return this.g.readFileStream(this.t(a),f,c)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,f,c){return this.g.writeFile(this.t(a),f,c)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,f){return this.g.delete(this.t(a),f)}copy(a,f,c){if((0,v.$dl)(this.g))return this.g.copy(this.t(a),this.t(f),c);throw new Error("copy not supported")}cloneFile(a,f){if((0,v.$el)(this.g))return this.g.cloneFile(this.t(a),this.t(f));throw new Error("clone not supported")}s(a){const f=[];for(const c of a){if(c.resource.scheme!==this.f)continue;const m=this.u(c.resource);this.b.findSubstr(m)&&f.push({resource:m,type:c.type,cId:c.cId})}f.length&&(this.n.debug("User data changed"),this.a.fire(f))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Shc=O}),define(ue[135],he([0,1,5,15,49,16,11,10,14]),function(Y,e,S,P,v,k,L,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=a,e.$Pi=f,e.$Si=c,e.$Ti=m,e.$Ui=d,e.$Vi=I,e.$Wi=b,e.$Zi=R,e.$5i=y,e.$6i=i,e.$8i=l,e.$9i=n,e.$0i=s,e.$Ni=(0,O.$Ei)("contextService");function a(t){const r=t;return typeof r?.id=="string"&&L.URI.isUri(r.uri)}function f(t){return typeof t?.id=="string"&&!a(t)&&!m(t)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function c(t,r){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,P.$nc)(t)}:r?e.$Qi:e.$Ri;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function m(t){const r=t;return typeof r?.id=="string"&&L.URI.isUri(r.configPath)}function d(t){const r=t;if(r?.uri)return{id:r.id,uri:L.URI.revive(r.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:L.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var p;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function I(t){const r=t;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}function b(t){const r=t;return!!(r&&typeof r=="object"&&L.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}class h{constructor(r,o,u,$,N){this.h=r,this.j=u,this.k=$,this.l=N,this.c=v.$Ki.forUris(this.l,()=>!0),this.folders=o}update(r){this.h=r.id,this.k=r.configuration,this.j=r.transient,this.l=r.l,this.folders=r.folders}get folders(){return this.g}set folders(r){this.g=r,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(r){this.k=r}getFolder(r){return r&&this.c.findSubstr(r)||null}n(){this.c=v.$Ki.forUris(this.l,()=>!0);for(const r of this.folders)this.c.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=h;class g{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,k.$fh)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=g;function R(t){return new g({uri:t,index:0,name:(0,k.$bh)(t)},{uri:t.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,S.localize)(11019,null),extensions:[e.$1i]}],e.$4i="workspace.json";function y(t,r){return k.$9g.isEqualOrParent(t,r.untitledWorkspacesHome)}function i(t){let r;return L.URI.isUri(t)?r=t:r=t.configuration,r?.scheme===w.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function l(t){return t.id===e.$7i}function n(t,r){return!y(t,r)&&!i(t)}function s(t){return(typeof t=="string"?(0,P.$oc)(t):(0,k.$dh)(t))===e.$2i}}),define(ue[24],he([0,1,43,4,2,16,11,5,17,9,10,6,135,25,23,8,28,31,3]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=y,e.$Ml=i,e.$Nl=l;var R;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(R||(e.ProfileResourceType=R={}));function y(t){const r=t;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&L.URI.isUri(r.location)&&L.URI.isUri(r.globalStorageHome)&&L.URI.isUri(r.settingsResource)&&L.URI.isUri(r.keybindingsResource)&&L.URI.isUri(r.tasksResource)&&L.URI.isUri(r.snippetsHome)&&L.URI.isUri(r.extensionsResource))}e.$Ll=(0,f.$Ei)("IUserDataProfilesService");function i(t,r){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:L.URI.revive(t.location).with({scheme:r}),globalStorageHome:L.URI.revive(t.globalStorageHome).with({scheme:r}),settingsResource:L.URI.revive(t.settingsResource).with({scheme:r}),keybindingsResource:L.URI.revive(t.keybindingsResource).with({scheme:r}),tasksResource:L.URI.revive(t.tasksResource).with({scheme:r}),snippetsHome:L.URI.revive(t.snippetsHome).with({scheme:r}),extensionsResource:L.URI.revive(t.extensionsResource).with({scheme:r}),cacheHome:L.URI.revive(t.cacheHome).with({scheme:r}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function l(t,r,o,u,$,N){return{id:t,name:r,location:o,isDefault:!1,shortName:$?.shortName,icon:$?.icon,globalStorageHome:N&&$?.useDefaultFlags?.globalState?N.globalStorageHome:(0,k.$fh)(o,"globalStorage"),settingsResource:N&&$?.useDefaultFlags?.settings?N.settingsResource:(0,k.$fh)(o,"settings.json"),keybindingsResource:N&&$?.useDefaultFlags?.keybindings?N.keybindingsResource:(0,k.$fh)(o,"keybindings.json"),tasksResource:N&&$?.useDefaultFlags?.tasks?N.tasksResource:(0,k.$fh)(o,"tasks.json"),snippetsHome:N&&$?.useDefaultFlags?.snippets?N.snippetsHome:(0,k.$fh)(o,"snippets"),extensionsResource:N&&$?.useDefaultFlags?.extensions?N.extensionsResource:(0,k.$fh)(o,"extensions.json"),cacheHome:(0,k.$fh)(u,t),useDefaultFlags:$?.useDefaultFlags,isTransient:$?.transient}}let n=class extends v.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(r,o,u,$){super(),this.t=r,this.u=o,this.w=u,this.y=$,this.f=!0,this.h=this.B(new P.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new P.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new P.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new P.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new d.$Ac,workspaces:new d.$Ac,emptyWindows:new Map},this.profilesHome=(0,k.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,k.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(r){this.f!==r&&(this.z=void 0,this.f=r)}isEnabled(){return this.f}get C(){if(!this.z){const r=this.D(),o=[r];if(this.f)try{for(const N of this.O()){if(!N.name||!(0,g.$eg)(N.name)||!N.location){this.y.warn("Skipping the invalid stored profile",N.location||N.name);continue}o.push(l((0,k.$ch)(N.location),N.name,N.location,this.g,{shortName:N.shortName,icon:N.icon,useDefaultFlags:N.useDefaultFlags},r))}}catch(N){this.y.error(N)}const u=new d.$Ac,$=new Map;if(o.length)try{const N=this.Q();if(N.workspaces)for(const[C,A]of Object.entries(N.workspaces)){const D=L.URI.parse(C),U=o.find(G=>G.id===A);U&&u.set(D,U)}if(N.emptyWindows)for(const[C,A]of Object.entries(N.emptyWindows)){const D=o.find(U=>U.id===A);D&&$.set(C,D)}}catch(N){this.y.error(N)}this.z={profiles:o,workspaces:u,emptyWindows:$}}return this.z}D(){const r=l("__default__profile__",(0,O.localize)(11066,null),this.t.userRoamingDataHome,this.g);return{...r,extensionsResource:this.S()??r.extensionsResource,isDefault:!0}}async createTransientProfile(r){const o="Temp",u=new RegExp(`${(0,h.$hf)(o)}\\s(\\d+)`);let $=0;for(const C of this.profiles){const A=u.exec(C.name),D=A?parseInt(A[1]):0;$=D>$?D:$}const N=`${o} ${$+1}`;return this.createProfile((0,S.$sj)((0,b.$1g)()).toString(16),N,{transient:!0},r)}async createNamedProfile(r,o,u){return this.createProfile((0,S.$sj)((0,b.$1g)()).toString(16),r,o,u)}async createProfile(r,o,u,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const N=await this.F(r,o,u);return $&&await this.setProfileForWorkspace($,N),N}async F(r,o,u){if(!(0,g.$eg)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let $=this.r.get(o);return $||($=(async()=>{try{if(this.profiles.find(D=>D.name===o||D.id===r))throw new Error(`Profile with ${o} name already exists`);const C=l(r,o,(0,k.$fh)(this.profilesHome,r),this.g,u,this.defaultProfile);await this.u.createFolder(C.location);const A=[];return this.j.fire({profile:C,join(D){A.push(D)}}),await I.Promises.settled(A),this.I([C],[],[]),C}finally{this.r.delete(o)}})(),this.r.set(o,$)),$}async updateProfile(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find($=>$.id===r.id);if(!u)throw new Error(`Profile '${r.name}' does not exist`);return u=l(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(r.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find($=>$.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);const u=[];this.m.fire({profile:o,join($){u.push($)}});try{await Promise.allSettled(u)}catch($){this.y.error($)}for(const $ of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get($)?.id&&this.C.emptyWindows.delete($);for(const $ of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get($)?.id&&this.C.workspaces.delete($);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch($){(0,a.$ql)($)!==a.FileOperationResult.FILE_NOT_FOUND&&this.y.error($)}}async setProfileForWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find($=>$.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.L(r,u)}unsetWorkspace(r,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(r,void 0,o)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const r=await this.u.resolve(this.profilesHome);await Promise.all((r.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const r=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(r.map(o=>this.removeProfile(o)))}getProfileForWorkspace(r){const o=this.G(r),u=L.URI.isUri(o)?this.C.workspaces.get(o):this.C.emptyWindows.get(o);return u||((0,m.$Oi)(r)?this.s.folders.get(r.uri):(0,m.$Ti)(r)?this.s.workspaces.get(r.configPath):this.s.emptyWindows.get(r.id))}G(r){return(0,m.$Oi)(r)?r.uri:(0,m.$Ti)(r)?r.configPath:r.id}H(r){return!!([...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,r.location))||[...this.s.folders.values()].some(o=>this.w.extUri.isEqual(o.location,r.location)))}I(r,o,u){const $=[...this.profiles,...r],N=[],C=this.s.profiles;this.s.profiles=[];for(let A of $){if(A.isDefault||o.some(U=>A.id===U.id))continue;A=u.find(U=>A.id===U.id)??A;const D=C.find(U=>A.id===U.id);if(A.isTransient)this.s.profiles.push(A);else{if(D){for(const[U,G]of this.s.emptyWindows.entries())if(A.id===G.id){this.L({id:U},A);break}for(const[U,G]of this.s.workspaces.entries())if(A.id===G.id){this.L({id:"",configPath:U},A);break}for(const[U,G]of this.s.folders.entries())if(A.id===G.id){this.L({id:"",uri:U},A);break}}N.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags})}}this.P(N),this.z=void 0,this.J(r,o,u)}J(r,o,u){this.h.fire({added:r,removed:o,updated:u,all:this.profiles})}L(r,o,u){if(u=o?.isTransient?!0:u,u)(0,m.$Oi)(r)?(this.s.folders.delete(r.uri),o&&this.s.folders.set(r.uri,o)):(0,m.$Ti)(r)?(this.s.workspaces.delete(r.configPath),o&&this.s.workspaces.set(r.configPath,o)):(this.s.emptyWindows.delete(r.id),o&&this.s.emptyWindows.set(r.id,o));else{this.L(r,void 0,!0);const $=this.G(r);L.URI.isUri($)?(this.C.workspaces.delete($),o&&this.C.workspaces.set($,o)):(this.C.emptyWindows.delete($),o&&this.C.emptyWindows.set($,o)),this.M()}}M(){const r={};for(const[u,$]of this.C.workspaces.entries())r[u.toString()]=$.id;const o={};for(const[u,$]of this.C.emptyWindows.entries())o[u.toString()]=$.id;this.R({workspaces:r,emptyWindows:o}),this.z=void 0}N(r){const o={},u=this.D();if(r.workspaces)for(const[N,C]of Object.entries(r.workspaces)){const A=L.URI.parse(C);o[N]=this.w.extUri.isEqual(A,u.location)?u.id:this.w.extUri.basename(A)}const $={};if(r.emptyWindows)for(const[N,C]of Object.entries(r.emptyWindows)){const A=L.URI.parse(C);$[N]=this.w.extUri.isEqual(A,u.location)?u.id:this.w.extUri.basename(A)}return{workspaces:o,emptyWindows:$}}O(){return[]}P(r){throw new Error("not implemented")}Q(){return{}}R(r){throw new Error("not implemented")}S(){}};e.$Ol=n,e.$Ol=n=be([re(0,w.$Li),re(1,a.$_k),re(2,p.$Jl),re(3,c.$_j)],n);class s extends n{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(r){this.a=r}Q(){return this.X}R(r){this.X=r}}e.$Pl=s}),define(ue[53],he([0,1,19,8,21,7,4,2,25,12,3,11,5,20,26,22,44,6,33,18,23,24]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g,R,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Eq=void 0,e.$Fq=n,m=ye(m);let l=class extends O.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(o,u,$,N,C,A){super(),this.z=o,this.C=u,this.D=$,this.F=N,this.G=C,this.H=A,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new L.$le),this.s=this.B(new L.$le),this.t=this.B(new L.$le),this.u=this.B(new L.$le),this.w=this.B(new L.$le),this.y=[],this.B((0,O.$Sc)(()=>{this.j.forEach(({task:D})=>D.cancel()),this.m.forEach(D=>D.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(o){const u=await this.getTargetPlatform();return o.allTargetPlatforms.some($=>(0,d.$ip)($,o.allTargetPlatforms,u))}async installFromGallery(o,u={}){try{const N=(await this.installGalleryExtensions([{extension:o,options:u}])).find(({identifier:C})=>(0,p.$Lp)(C,o.identifier));if(N?.local)return N?.local;throw N?.error?N.error:new d.$mp(`Unknown error while installing extension ${o.identifier.id}`,d.ExtensionManagementErrorCode.Unknown)}catch($){throw n($)}}async installGalleryExtensions(o){if(!this.z.isEnabled())throw new d.$mp(m.localize(11492,null),d.ExtensionManagementErrorCode.NotAllowed);const u=[],$=[];return await Promise.allSettled(o.map(async({extension:N,options:C})=>{try{const A=await this.N(N,!!C?.installGivenVersion,!!C?.installPreReleaseVersion,C.productVersion??{version:this.G.version,date:this.G.date});$.push({...A,options:C})}catch(A){u.push({identifier:N.identifier,operation:d.InstallOperation.Install,source:N,error:A,profileLocation:C.profileLocation??this.W()})}})),$.length&&u.push(...await this.I($)),u}async uninstall(o,u){return this.F.trace("ExtensionManagementService#uninstall",o.identifier.id),this.uninstallExtensions([{extension:o,options:u}])}async toggleAppliationScope(o,u){if((0,I.$tn)(o.manifest)||o.isBuiltin)return o;if(o.isApplicationScoped){let $=await this.updateMetadata(o,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(u,this.H.defaultProfile.extensionsResource)||($=await this.Z(o,this.H.defaultProfile.extensionsResource,u));for(const N of this.H.profiles){const C=(await this.getInstalled(I.ExtensionType.User,N.extensionsResource)).find(A=>(0,p.$Lp)(A.identifier,o.identifier));C?this.w.fire({local:C,profileLocation:N.extensionsResource}):this.u.fire({identifier:o.identifier,profileLocation:N.extensionsResource})}return $}else{const $=this.D.extUri.isEqual(u,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(o,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.Z(o,u,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:$.identifier,operation:d.InstallOperation.Install,local:$,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),$}}getExtensionsControlManifest(){const o=new Date().getTime();return(!this.g||o-this.h>1e3*60*5)&&(this.g=this.U(),this.h=o),this.g}registerParticipant(o){this.y.push(o)}async resetPinnedStateForAllUserExtensions(o){try{await this.L(this.H.profiles.map(async u=>{const $=await this.getInstalled(I.ExtensionType.User,u.extensionsResource);await this.L($.map(async N=>{N.pinned!==o&&await this.updateMetadata(N,{pinned:o},u.extensionsResource)}))}))}catch(u){throw this.F.error("Error while resetting pinned state for all user extensions",(0,k.$9)(u)),u}}async I(o){const u=new Map,$=new Map,N=[],C=(D,U)=>`${p.$Mp.create(D).toString()}-${U.toString()}`,A=(D,U,G,Q)=>{const te=this.X(D,U,G),ae=`${(0,p.$Qp)(D.publisher,D.name)}-${G.profileLocation.toString()}`;$.set(ae,{task:te,root:Q}),this.n.fire({identifier:te.identifier,source:U,profileLocation:G.profileLocation}),this.F.info("Installing extension:",te.identifier.id,G),c.URI.isUri(U)||this.j.set(C(U,G.profileLocation),{task:te,waitingTasks:[]})};try{for(const{manifest:D,extension:U,options:G}of o){const Q=G.isApplicationScoped||G.isBuiltin||(0,I.$tn)(D),te={...G,installOnlyNewlyAddedFromExtensionPack:G.installOnlyNewlyAddedFromExtensionPack??!c.URI.isUri(U),isApplicationScoped:Q,profileLocation:Q?this.H.defaultProfile.extensionsResource:G.profileLocation??this.W(),productVersion:G.productVersion??{version:this.G.version,date:this.G.date}},ae=c.URI.isUri(U)?void 0:this.j.get(C(U,te.profileLocation));ae?(this.F.info("Extension is already requested to install",ae.task.identifier.id,te.profileLocation.toString()),N.push(ae.task.waitUntilTaskIsFinished())):A(D,U,te,void 0)}return await Promise.all([...$.values()].map(async({task:D})=>{if(D.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",D.identifier.id);else try{const U=await this.M(D.identifier,D.manifest,!!D.options.installOnlyNewlyAddedFromExtensionPack,!!D.options.installPreReleaseVersion,D.options.profileLocation,D.options.productVersion),G=await this.getInstalled(void 0,D.options.profileLocation,D.options.productVersion),Q={...D.options,context:{...D.options.context,[d.$cp]:!0}};for(const{gallery:te,manifest:ae}of(0,S.$Lb)(U,({gallery:le})=>le.identifier.id)){if($.has(`${te.identifier.id.toLowerCase()}-${Q.profileLocation.toString()}`))continue;const le=this.j.get(C(te,Q.profileLocation));if(le){if(this.J(D,le.task)){const de=le.task.identifier;this.F.info("Waiting for already requested installing extension",de.id,D.identifier.id,Q.profileLocation.toString()),le.waitingTasks.push(D),N.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,H=>H.some(Z=>(0,p.$Lp)(Z.identifier,de)))).then(H=>{if(this.F.info("Finished waiting for already requested installing extension",de.id,D.identifier.id,Q.profileLocation.toString()),!H.find(B=>(0,p.$Lp)(B.identifier,de))?.local)throw new Error(`Extension ${de.id} is not installed`)}))}}else G.some(({identifier:de})=>(0,p.$Lp)(de,te.identifier))||A(ae,te,Q,D)}}catch(U){if(c.URI.isUri(D.source))(0,S.$Kb)(D.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",D.identifier.id,U.message),(0,S.$Kb)(D.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",D.identifier.id,U.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",D.identifier.id),U}})),await this.L([...$.entries()].map(async([D,{task:U}])=>{const G=new Date().getTime();let Q;try{Q=await U.run(),await this.L(this.y.map(te=>te.postInstall(Q,U.source,U.options,v.CancellationToken.None)),d.ExtensionManagementErrorCode.PostInstall)}catch(te){const ae=n(te);throw c.URI.isUri(U.source)||s(this.C,U.operation===d.InstallOperation.Update?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Tp)(U.source),error:ae,source:U.options.context?.[d.$bp]}),u.set(D,{error:ae,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,applicationScoped:U.options.isApplicationScoped}),this.F.error("Error while installing the extension",U.identifier.id,(0,k.$9)(ae),U.options.profileLocation.toString()),ae}if(!c.URI.isUri(U.source)){const te=U.operation===d.InstallOperation.Update,ae=te?void 0:(new Date().getTime()-U.source.lastUpdated)/1e3;if(s(this.C,te?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,p.$Tp)(U.source),verificationStatus:U.verificationStatus,duration:new Date().getTime()-G,durationSinceUpdate:ae,source:U.options.context?.[d.$bp]}),a.$p&&U.operation!==d.InstallOperation.Update)try{await this.z.reportStatistic(Q.manifest.publisher,Q.manifest.name,Q.manifest.version,d.StatisticType.Install)}catch{}}u.set(D,{local:Q,identifier:U.identifier,operation:U.operation,source:U.source,context:U.options.context,profileLocation:U.options.profileLocation,applicationScoped:Q.isApplicationScoped})})),N.length&&await this.L(N),[...u.values()]}catch(D){const U=(te,ae,le)=>{const de=[];te.manifest.extensionDependencies?.length&&de.push(...te.manifest.extensionDependencies),te.manifest.extensionPack?.length&&de.push(...te.manifest.extensionPack);for(const H of de){if(le.includes(H.toLowerCase()))continue;le.push(H.toLowerCase());const Z=u.get(`${H.toLowerCase()}-${ae.toString()}`);Z?.local&&(le=U(Z.local,ae,le))}return le},G=te=>({identifier:te.identifier,operation:d.InstallOperation.Install,source:te.source,context:te.options.context,profileLocation:te.options.profileLocation,error:D}),Q=[];for(const[te,{task:ae,root:le}]of $){const de=u.get(te);de?de.local&&le&&!u.get(`${le.identifier.id.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local&&(Q.push(this.Y(de.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),u.set(te,G(ae))):(ae.cancel(),u.set(te,G(ae)))}for(const[te,{task:ae}]of $){const le=u.get(te);if(!le?.local||ae.options.donotIncludePackAndDependencies)continue;U(le.local,ae.options.profileLocation,[le.local.identifier.id.toLowerCase()]).slice(1).some(H=>$.has(`${H.toLowerCase()}-${ae.options.profileLocation.toString()}`)&&!u.get(`${H.toLowerCase()}-${ae.options.profileLocation.toString()}`)?.local)&&(Q.push(this.Y(le.local,{versionOnly:!0,profileLocation:ae.options.profileLocation})),u.set(te,G(ae)))}throw Q.length&&await Promise.allSettled(Q.map(async te=>{try{await te.run(),this.F.info("Rollback: Uninstalled extension",te.extension.identifier.id)}catch(ae){this.F.warn("Rollback: Error while uninstalling extension",te.extension.identifier.id,(0,k.$9)(ae))}})),D}finally{for(const{task:D}of $.values())D.source&&!c.URI.isUri(D.source)&&this.j.delete(C(D.source,D.options.profileLocation));if(u.size){const D=[...u.values()];for(const U of D)U.local&&this.F.info("Extension installed successfully:",U.identifier.id,U.profileLocation.toString());this.s.fire(D)}}}J(o,u){for(const[,{task:$,waitingTasks:N}]of this.j.entries())if($===o&&(N.includes(u)||N.some(C=>this.J(C,u)))||$===u&&N[0]&&!this.J(o,N[0]))return!1;return!0}async L(o,u){const $=[],N=[],C=await Promise.allSettled(o);for(const D of C)D.status==="fulfilled"?$.push(D.value):N.push(n(D.reason,u));if(!N.length)return $;if(N.length===1)throw N[0];let A=new d.$mp("",d.ExtensionManagementErrorCode.Unknown);for(const D of N)A=new d.$mp(A.message?`${A.message}, ${D.message}`:D.message,D.code!==d.ExtensionManagementErrorCode.Unknown&&D.code!==d.ExtensionManagementErrorCode.Internal?D.code:A.code);throw A}async M(o,u,$,N,C,A){if(!this.z.isEnabled())return[];const D=await this.getInstalled(void 0,C,A),U=[],G=[],Q=async(te,ae)=>{U.push(te);const le=ae.extensionDependencies||[],de=[...le];if(ae.extensionPack){const H=$?D.find(Z=>(0,p.$Lp)(Z.identifier,te)):void 0;for(const Z of ae.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(B=>(0,p.$Lp)({id:B},{id:Z}))||de.every(B=>!(0,p.$Lp)({id:B},{id:Z}))&&de.push(Z)}if(de.length){const H=de.filter(Z=>U.every(B=>!(0,p.$Lp)(B,{id:Z})));if(H.length){const Z=await this.z.getExtensions(H.map(B=>({id:B,preRelease:N})),v.CancellationToken.None);for(const B of Z){if(U.find(K=>(0,p.$Lp)(K,B.identifier)))continue;const M=le.some(K=>(0,p.$Lp)({id:K},B.identifier));let J;try{J=await this.N(B,!1,N,A)}catch(K){if(M)throw K;this.F.info("Skipping the packed extension as it cannot be installed",B.identifier.id,(0,k.$9)(K));continue}G.push({gallery:J.extension,manifest:J.manifest}),await Q(J.extension.identifier,J.manifest)}}}};return await Q(o,u),G}async N(o,u,$,N){let C;const A=await this.getExtensionsControlManifest();if(A.malicious.some(G=>(0,p.$Lp)(o.identifier,G)))throw new d.$mp(m.localize(11493,null,o.identifier.id),d.ExtensionManagementErrorCode.Malicious);const D=A.deprecated[o.identifier.id.toLowerCase()];if(D?.extension?.autoMigrate){if(this.F.info(`The '${o.identifier.id}' extension is deprecated, fetching the compatible '${D.extension.id}' extension instead.`),C=(await this.z.getExtensions([{id:D.extension.id,preRelease:D.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:N},v.CancellationToken.None))[0],!C)throw new d.$mp(m.localize(11494,null,o.identifier.id,D.extension.id),d.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(o)){const G=await this.getTargetPlatform();throw new d.$mp(m.localize(11495,null,o.identifier.id,this.G.nameLong,(0,d.$ep)(G)),d.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(C=await this.O(o,u,$,N),!C){const G=[];throw(0,b.$6p)(o.properties.enabledApiProposals??[],G)?!$&&o.properties.isPreReleaseVersion&&(await this.z.getExtensions([o.identifier],v.CancellationToken.None))[0]?new d.$mp(m.localize(11497,null,o.displayName??o.identifier.id),d.ExtensionManagementErrorCode.ReleaseVersionNotFound):new d.$mp(m.localize(11498,null,o.identifier.id,this.G.nameLong,this.G.version),d.ExtensionManagementErrorCode.Incompatible):new d.$mp(m.localize(11496,null,o.displayName??o.identifier.id,G[0]),d.ExtensionManagementErrorCode.IncompatibleApi)}}this.F.info("Getting Manifest...",C.identifier.id);const U=await this.z.getManifest(C,v.CancellationToken.None);if(U===null)throw new d.$mp(`Missing manifest for extension ${C.identifier.id}`,d.ExtensionManagementErrorCode.Invalid);if(U.version!==C.version)throw new d.$mp(`Cannot install '${C.identifier.id}' extension because of version mismatch in Marketplace`,d.ExtensionManagementErrorCode.Invalid);return{extension:C,manifest:U}}async O(o,u,$,N){const C=await this.getTargetPlatform();let A=null;return!u&&o.hasPreReleaseVersion&&o.properties.isPreReleaseVersion!==$&&(A=(await this.z.getExtensions([{...o.identifier,preRelease:$}],{targetPlatform:C,compatible:!0,productVersion:N},v.CancellationToken.None))[0]||null),!A&&await this.z.isExtensionCompatible(o,$,C,N)&&(A=o),A||(u?A=(await this.z.getExtensions([{...o.identifier,version:o.version}],{targetPlatform:C,compatible:!0,productVersion:N},v.CancellationToken.None))[0]||null:A=await this.z.getCompatibleExtension(o,$,C,N)),A}async uninstallExtensions(o){const u=(G,Q)=>`${G.identifier.id.toLowerCase()}${Q.versionOnly?`-${G.manifest.version}`:""}@${Q.profileLocation.toString()}`,$=(G,Q)=>{const te=this.Y(G,Q);return this.m.set(u(te.extension,Q),te),this.F.info("Uninstalling extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,Q.profileLocation.toString()),this.t.fire({identifier:G.identifier,profileLocation:Q.profileLocation,applicationScoped:G.isApplicationScoped}),te},N=(G,Q,te)=>{te?this.F.error("Failed to uninstall extension from the profile:",`${G.identifier.id}@${G.manifest.version}`,Q.profileLocation.toString(),te.message):this.F.info("Successfully uninstalled extension from the profile",`${G.identifier.id}@${G.manifest.version}`,Q.profileLocation.toString()),s(this.C,"extensionGallery:uninstall",{extensionData:(0,p.$Sp)(G),error:te}),this.u.fire({identifier:G.identifier,error:te?.code,profileLocation:Q.profileLocation,applicationScoped:G.isApplicationScoped})},C=[],A=[],D=[],U=new w.$Ac;for(const{extension:G,options:Q}of o){const te={...Q,profileLocation:G.isApplicationScoped?this.H.defaultProfile.extensionsResource:Q?.profileLocation??this.W()},ae=this.m.get(u(G,te));ae?(this.F.info("Extensions is already requested to uninstall",G.identifier.id),D.push(ae.waitUntilTaskIsFinished())):C.push($(G,te))}try{for(const G of C.slice(0)){let Q=U.get(G.options.profileLocation);if(Q||U.set(G.options.profileLocation,Q=await this.getInstalled(I.ExtensionType.User,G.options.profileLocation)),G.options.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${G.extension.identifier.id}@${G.extension.manifest.version}`);else{const te=this.R(G.extension,Q);for(const ae of te)this.m.has(u(ae,G.options))?this.F.info("Extensions is already requested to uninstall",ae.identifier.id):C.push($(ae,G.options))}G.options.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${G.extension.identifier.id}@${G.extension.manifest.version}`):this.P(C.map(te=>te.extension),Q,G.extension)}await this.L(C.map(async G=>{try{if(await G.run(),await this.L(this.y.map(Q=>Q.postUninstall(G.extension,G.options,v.CancellationToken.None))),G.extension.identifier.uuid)try{await this.z.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,d.StatisticType.Uninstall)}catch{}}catch(Q){const te=n(Q);throw N(G.extension,G.options,te),te}finally{A.push(G)}})),D.length&&await this.L(D);for(const G of C)N(G.extension,G.options)}catch(G){const Q=n(G);for(const te of C){try{te.cancel()}catch{}A.includes(te)||N(te.extension,te.options,Q)}throw Q}finally{for(const G of C)this.m.delete(u(G.extension,G.options))||this.F.warn("Uninstallation task is not found in the cache",G.extension.identifier.id)}}P(o,u,$){for(const N of o){const C=this.S(N,u);if(C.length){const A=C.filter(D=>!o.some(U=>(0,p.$Lp)(U.identifier,D.identifier)));if(A.length)throw new Error(this.Q(N,A,$))}}}Q(o,u,$){return $===o?u.length===1?m.localize(11499,null,$.manifest.displayName||$.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?m.localize(11500,null,$.manifest.displayName||$.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):m.localize(11501,null,$.manifest.displayName||$.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):u.length===1?m.localize(11502,null,$.manifest.displayName||$.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name):u.length===2?m.localize(11503,null,$.manifest.displayName||$.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name):m.localize(11504,null,$.manifest.displayName||$.manifest.name,o.manifest.displayName||o.manifest.name,u[0].manifest.displayName||u[0].manifest.name,u[1].manifest.displayName||u[1].manifest.name)}R(o,u,$=[]){if($.indexOf(o)!==-1)return[];$.push(o);const N=o.manifest.extensionPack?o.manifest.extensionPack:[];if(N.length){const C=u.filter(D=>!D.isBuiltin&&N.some(U=>(0,p.$Lp)({id:U},D.identifier))),A=[];for(const D of C)A.push(...this.R(D,u,$));return[...C,...A]}return[]}S(o,u){return u.filter($=>$.manifest.extensionDependencies&&$.manifest.extensionDependencies.some(N=>(0,p.$Lp)({id:N},o.identifier)))}async U(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(o){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,k.$9)(o)),{malicious:[],deprecated:{},search:[]}}}};e.$Eq=l,e.$Eq=l=be([re(0,d.$kp),re(1,R.$$l),re(2,y.$Jl),re(3,h.$_j),re(4,g.$sk),re(5,i.$Ll)],l);function n(r,o){if(r instanceof d.$mp)return r;let u;return r instanceof d.$lp?u=new d.$mp(r.message,r.code===d.ExtensionGalleryErrorCode.DownloadFailedWriting?d.ExtensionManagementErrorCode.DownloadFailedWriting:d.ExtensionManagementErrorCode.Gallery):u=new d.$mp(r.message,(0,k.$3)(r)?d.ExtensionManagementErrorCode.Cancelled:o??d.ExtensionManagementErrorCode.Internal),u.stack=r.stack,u}function s(r,o,{extensionData:u,verificationStatus:$,duration:N,error:C,source:A,durationSinceUpdate:D}){let U,G;(0,f.$mg)($)&&($===!0?$="Verified":($===!1||(U=d.ExtensionManagementErrorCode.Signature,G=$),$="Unverified")),C&&(U=C.code,C.code===d.ExtensionManagementErrorCode.Signature&&(G=C.message)),r.publicLog(o,{...u,verificationStatus:$,success:!C,duration:N,errorcode:U,errorcodeDetail:G,durationSinceUpdate:D,source:A})}class t{constructor(){this.d=new P.$Dh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,P.$rh)(o=>this.h(o))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,P.$rh)(o=>new Promise((u,$)=>{const N=o.onCancellationRequested(()=>{N.dispose(),$(new k.$4)})})),this.d.open()),this.g.cancel()}}e.$Gq=t}),define(ue[42],he([0,1,8,13,2,4,25,11,20,26,9,10,6,24,23,3,7,18]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(n){n.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",n.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g||(e.ExtensionsProfileScanningErrorCode=g={}));class R extends Error{constructor(s,t){super(s),this.code=t}}e.$Hq=R,e.$Iq=(0,c.$Ei)("IExtensionsProfileScannerService");let y=class extends v.$Uc{constructor(s,t,r,o,u,$){super(),this.j=s,this.m=t,this.n=r,this.r=o,this.s=u,this.t=$,this.b=this.B(new k.$le),this.onAddExtensions=this.b.event,this.c=this.B(new k.$le),this.onDidAddExtensions=this.c.event,this.f=this.B(new k.$le),this.onRemoveExtensions=this.f.event,this.g=this.B(new k.$le),this.onDidRemoveExtensions=this.g.event,this.h=new L.$Ac}scanProfileExtensions(s,t){return this.u(s,void 0,t)}async addExtensionsToProfile(s,t,r){const o=[],u=[];try{return await this.u(t,$=>{const N=[];if(r)N.push(...$);else for(const C of $)s.some(([A])=>(0,a.$Lp)(A.identifier,C.identifier)&&A.manifest.version!==C.version)?o.push(C):N.push(C);for(const[C,A]of s){const D=N.findIndex(G=>(0,a.$Lp)(G.identifier,C.identifier)&&G.version===C.manifest.version),U={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:A};D===-1?(u.push(U),N.push(U)):N.splice(D,1,U)}return u.length&&this.b.fire({extensions:u,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),N}),u.length&&this.c.fire({extensions:u,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),u}catch($){throw u.length&&this.c.fire({extensions:u,error:$,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:$,profileLocation:t}),$}}async updateMetadata(s,t){const r=[];return await this.u(t,o=>{const u=[];for(const $ of o){const N=s.find(([C])=>(0,a.$Lp)(C.identifier,$.identifier)&&C.manifest.version===$.version);N&&($.metadata={...$.metadata,...N[1]},r.push($)),u.push($)}return u}),r}async removeExtensionFromProfile(s,t){const r=[];try{await this.u(t,o=>{const u=[];for(const $ of o)(0,a.$Lp)($.identifier,s.identifier)?r.push($):u.push($);return r.length&&this.f.fire({extensions:r,profileLocation:t}),u}),r.length&&this.g.fire({extensions:r,profileLocation:t})}catch(o){throw r.length&&this.g.fire({extensions:r,error:o,profileLocation:t}),o}}async u(s,t,r){return this.F(s).queue(async()=>{let o=[],u;try{const $=await this.m.readFile(s);u=JSON.parse($.value.toString().trim()||"[]")}catch($){if((0,f.$ql)($)!==f.FileOperationResult.FILE_NOT_FOUND)throw $;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&r?.bailOutWhenFileNotFound)throw new R((0,b.$9)($),g.ERROR_PROFILE_NOT_FOUND)}if(u){Array.isArray(u)||this.w(s);let $=!1;for(const N of u){i(N)||this.w(s);let C;if((0,I.$eg)(N.relativeLocation)&&N.relativeLocation)C=this.z(N.relativeLocation);else if((0,I.$eg)(N.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${N.location}`);continue}else{C=O.URI.revive(N.location);const A=this.y(C);A&&($=!0,N.relativeLocation=A)}(0,I.$lg)(N.metadata?.hasPreReleaseVersion)&&N.metadata?.preRelease&&($=!0,N.metadata.hasPreReleaseVersion=!0),o.push({identifier:N.identifier,location:C,version:N.version,metadata:N.metadata})}$&&await this.m.writeFile(s,P.$Ne.fromString(JSON.stringify(u)))}if(t){o=t(o);const $=o.map(N=>({identifier:N.identifier,version:N.version,location:N.location.toJSON(),relativeLocation:this.y(N.location),metadata:N.metadata}));await this.m.writeFile(s,P.$Ne.fromString(JSON.stringify($)))}return o})}w(s){const t=new R(`Invalid extensions content in ${s.toString()}`,g.ERROR_INVALID_CONTENT);throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let r;try{r=(await this.m.readFile(s)).value.toString()}catch(u){if((0,f.$ql)(u)===f.FileOperationResult.FILE_NOT_FOUND)return;throw u}this.t.info("Migrating extensions from old default profile location",s.toString());let o;try{const u=JSON.parse(r);Array.isArray(u)&&u.every($=>i($))?o=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,P.$Ne.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,f.$ql)(u)===f.FileOperationResult.FILE_MODIFIED_SINCE)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(s)}catch(u){(0,f.$ql)(u)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}try{await this.m.del(t)}catch(u){(0,f.$ql)(u)!==f.FileOperationResult.FILE_NOT_FOUND&&this.t.error(u)}return o})()),this.C}F(s){let t=this.h.get(s);return t||(t=new S.$Lh,this.h.set(s,t)),t}};e.$Jq=y,e.$Jq=y=be([re(1,f.$_k),re(2,d.$Ll),re(3,p.$Jl),re(4,h.$$l),re(5,m.$_j)],y);function i(n){return(0,I.$gg)(n)&&(0,w.$jp)(n.identifier)&&(l(n.location)||(0,I.$eg)(n.location)&&n.location)&&((0,I.$lg)(n.relativeLocation)||(0,I.$eg)(n.relativeLocation))&&n.version&&(0,I.$eg)(n.version)}function l(n){return n?(0,I.$eg)(n.path)&&(0,I.$eg)(n.scheme):!1}});var Me=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(ue[54],he([0,1,19,8,27,13,7,34,90,2,14,15,12,16,45,57,3,11,5,17,26,22,44,9,10,6,33,4,48,42,24,23,96]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g,R,y,i,l,n,s,t,r,o,u,$,N,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qq=e.$Oq=e.$Nq=e.$Mq=e.Translations=void 0,e.$Pq=ae,v=ye(v),c=ye(c),m=ye(m),p=ye(p),I=Me(I);var D;(function(de){function H(Z,B){if(Z===B)return!0;const M=Object.keys(Z),J=new Set;for(const K of Object.keys(B))J.add(K);if(M.length!==J.size)return!1;for(const K of M){if(Z[K]!==B[K])return!1;J.delete(K)}return J.size===0}de.equals=H})(D||(e.Translations=D={})),e.$Mq=(0,s.$Ei)("IExtensionsScannerService");let U=class extends a.$Uc{constructor(H,Z,B,M,J,K,ie,se,T,W,z,E){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Z,this.r=B,this.s=M,this.t=J,this.u=K,this.w=ie,this.y=se,this.z=T,this.C=W,this.D=z,this.F=E,this.g=this.B(new o.$le),this.onDidChangeCache=this.g.event,this.h=(0,d.$fh)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(te,this.s,this.h)),this.m=this.B(this.F.createInstance(te,this.s,this.h)),this.n=this.B(this.F.createInstance(Q,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(i.ExtensionType.System))),this.B(this.m.onDidChangeCache(()=>this.g.fire(i.ExtensionType.User)))}getTargetPlatform(){return this.G||(this.G=(0,y.$Wp)(this.w,this.y)),this.G}async scanAllExtensions(H,Z,B){const[M,J]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Z)]),K=B?await this.scanExtensionsUnderDevelopment(H,[...M,...J]):[];return this.L(M,J,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Z=[];Z.push(this.M(!!H.useCache,H.language)),Z.push(this.N(H.language,!!H.checkControlFile));const[B,M]=await Promise.all(Z);return this.J([...B,...M],i.ExtensionType.System,H,!1)}async scanUserExtensions(H){const Z=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,M=await this.P(Z,!!H.profileLocation,i.ExtensionType.User,!H.includeUninstalled,H.language,!0,B,H.productVersion??this.R()),J=H.useCache&&!M.devMode&&M.excludeObsolete?this.m:this.n;let K;try{K=await J.scanExtensions(M)}catch(ie){if(ie instanceof $.$Hq&&ie.code===$.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I(),K=await J.scanExtensions(M);else throw ie}return K=await this.J(K,i.ExtensionType.User,H,!0),this.y.trace("Scanned user extensions:",K.length),K}async scanExtensionsUnderDevelopment(H,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(M=>M.scheme===f.Schemas.file).map(async M=>{const J=await this.P(M,!1,i.ExtensionType.User,!0,H.language,!1,void 0,H.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(J)).map(ie=>(ie.type=Z.find(se=>(0,y.$Lp)(se.identifier,ie.identifier))?.type??ie.type,this.n.validate(ie,J)))}))).flat();return this.J(B,"development",H,!0)}return[]}async scanExistingExtension(H,Z,B){const M=await this.P(H,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),J=await this.n.scanExtension(M);return!J||!B.includeInvalid&&!J.isValid?null:J}async scanOneOrMultipleExtensions(H,Z,B){const M=await this.P(H,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),J=await this.n.scanOneOrMultipleExtensions(M);return this.J(J,Z,B,!0)}async scanMultipleExtensions(H,Z,B){const M=[];return await Promise.all(H.map(async J=>{const K=await this.scanOneOrMultipleExtensions(J,Z,B);M.push(...K)})),this.J(M,Z,B,!0)}async scanMetadata(H){const Z=(0,d.$fh)(H,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(H,Z){const B=(0,d.$fh)(H,"package.json"),M=(await this.w.readFile(B)).value.toString(),J=JSON.parse(M);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,J.__metadata={...J.__metadata,...Z},await this.w.writeFile((0,d.$fh)(H,"package.json"),k.$Ne.fromString(JSON.stringify(J,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof $.$Hq&&H.code===$.ExtensionsProfileScanningErrorCode.ERROR_PROFILE_NOT_FOUND)await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,k.$Ne.fromString(JSON.stringify([])))}catch(Z){(0,n.$ql)(Z)!==n.FileOperationResult.FILE_NOT_FOUND&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$9)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Z,B,M){return B.includeAllVersions||(H=this.L(Z===i.ExtensionType.System?H:void 0,Z===i.ExtensionType.User?H:void 0,Z==="development"?H:void 0,await this.getTargetPlatform(),M)),B.includeInvalid||(H=H.filter(J=>J.isValid)),H.sort((J,K)=>{const ie=c.$nc(J.location.fsPath),se=c.$nc(K.location.fsPath);return ie<se?-1:ie>se?1:0})}L(H,Z,B,M,J){const K=(se,T,W)=>{if(se.isValid&&!T.isValid)return!1;if(se.isValid===T.isValid){if(J&&p.gt(se.manifest.version,T.manifest.version))return this.y.debug(`Skipping extension ${T.location.path} with lower version ${T.manifest.version} in favour of ${se.location.path} with version ${se.manifest.version}`),!1;if(p.eq(se.manifest.version,T.manifest.version)){if(se.type===i.ExtensionType.System)return this.y.debug(`Skipping extension ${T.location.path} in favour of system extension ${se.location.path} with same version`),!1;if(se.targetPlatform===M)return this.y.debug(`Skipping extension ${T.location.path} from different target platform ${T.targetPlatform}`),!1}}return W?this.y.warn(`Overwriting user extension ${se.location.path} with ${T.location.path}.`):this.y.debug(`Overwriting user extension ${se.location.path} with ${T.location.path}.`),!0},ie=new i.$sn;return H?.forEach(se=>{const T=ie.get(se.identifier.id);(!T||K(T,se,!1))&&ie.set(se.identifier.id,se)}),Z?.forEach(se=>{const T=ie.get(se.identifier.id);if(!T&&H&&se.type===i.ExtensionType.System){this.y.debug(`Skipping obsolete system extension ${se.location.path}.`);return}(!T||K(T,se,!1))&&ie.set(se.identifier.id,se)}),B?.forEach(se=>{const T=ie.get(se.identifier.id);(!T||K(T,se,!0))&&ie.set(se.identifier.id,se),ie.set(se.identifier.id,se)}),[...ie.values()]}async M(H,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,i.ExtensionType.System,!0,Z,!0,void 0,this.R()),J=await(H&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",J.length),J}async N(H,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const M=Z?await this.O():{},J=[],K=h.URI.file(c.$hc(c.$jc(f.$Yg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const se of B){const T=M[se.name]||"marketplace";switch(T){case"disabled":break;case"marketplace":J.push((0,d.$fh)(K,se.name));break;default:J.push(h.URI.file(T));break}}const ie=await Promise.all(J.map(async se=>this.n.scanExtension(await this.P(se,!1,i.ExtensionType.System,!0,H,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ie.length),(0,S.$Gb)(ie)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Z,B,M,J,K,ie,se){const T=await this.f(J??m.$x),W=await this.Q(H),z=Z&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=z?await this.Q(z):void 0;return new G(H,W,z,E,Z,ie,B,M,K,se.version,se.date,this.C.commit,!this.z.isBuilt,J,T)}async Q(H){try{const Z=await this.w.stat(H);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$Nq=U,e.$Nq=U=be([re(4,N.$Ll),re(5,$.$Iq),re(6,n.$_k),re(7,t.$_j),re(8,R.$Li),re(9,r.$sk),re(10,C.$Jl),re(11,s.$Di)],U);class G{constructor(H,Z,B,M,J,K,ie,se,T,W,z,E,j,X,F){this.location=H,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=M,this.profile=J,this.profileScanOptions=K,this.type=ie,this.excludeObsolete=se,this.validate=T,this.productVersion=W,this.productDate=z,this.productCommit=E,this.devMode=j,this.language=X,this.translations=F}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Z){return(0,d.$$g)(H.location,Z.location)&&H.mtime===Z.mtime&&(0,d.$$g)(H.applicationExtensionslocation,Z.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&H.profile===Z.profile&&v.$ho(H.profileScanOptions,Z.profileScanOptions)&&H.type===Z.type&&H.excludeObsolete===Z.excludeObsolete&&H.validate===Z.validate&&H.productVersion===Z.productVersion&&H.productDate===Z.productDate&&H.productCommit===Z.productCommit&&H.devMode===Z.devMode&&H.language===Z.language&&D.equals(H.translations,Z.translations)}}e.$Oq=G;let Q=class extends a.$Uc{constructor(H,Z,B,M,J,K,ie){super(),this.g=H,this.h=Z,this.j=B,this.m=M,this.n=K,this.r=ie,this.f=J.extensionsEnabledWithApiProposalVersion?.map(se=>se.toLowerCase())??[]}async scanExtensions(H){const Z=H.profile?await this.t(H):await this.s(H);let B={};if(H.excludeObsolete&&H.type===i.ExtensionType.User)try{const M=(await this.m.readFile(this.g)).value.toString();B=JSON.parse(M)}catch{}return(0,b.$rg)(B)?Z:Z.filter(M=>!B[y.$Mp.create(M).toString()])}async s(H){const Z=await this.m.resolve(H.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async M=>{if(!M.isDirectory||H.type===i.ExtensionType.User&&(0,d.$ch)(M.resource).indexOf(".")===0)return null;const J=new G(M.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(J)}));return(0,S.$Gb)(B).sort((M,J)=>M.location.path<J.location.path?-1:1)}async t(H){let Z=await this.u(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.j.extUri.isEqual(H.location,H.applicationExtensionslocation)){Z=Z.filter(M=>!M.metadata?.isApplicationScoped);const B=await this.u(H.applicationExtensionslocation,M=>!!M.metadata?.isBuiltin||!!M.metadata?.isApplicationScoped,H);Z.push(...B)}return Z}async u(H,Z,B){const M=await this.h.scanProfileExtensions(H,B.profileScanOptions);if(!M.length)return[];const J=await Promise.all(M.map(async K=>{if(Z(K)){const ie=new G(K.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ie,K.metadata)}return null}));return(0,S.$Gb)(J)}async scanOneOrMultipleExtensions(H){try{if(await this.m.exists((0,d.$fh)(H.location,"package.json"))){const Z=await this.scanExtension(H);return Z?[Z]:[]}else return await this.scanExtensions(H)}catch(Z){return this.r.error(`Error scanning extensions at ${H.location.path}:`,(0,L.$9)(Z)),[]}}async scanExtension(H,Z){try{let B=await this.w(H.location);if(B){B.publisher||(B.publisher=i.$mn),Z=Z??B.__metadata,delete B.__metadata;const M=(0,y.$Qp)(B.publisher,B.name),J=Z?.id?{id:M,uuid:Z.id}:{id:M},K=Z?.isSystem?i.ExtensionType.System:H.type,ie=K===i.ExtensionType.System||!!Z?.isBuiltin;B=await this.y(H.location,B,G.createNlsConfiguration(H));let se={type:K,identifier:J,manifest:B,location:H.location,isBuiltin:ie,targetPlatform:Z?.targetPlatform??i.TargetPlatform.UNDEFINED,publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return H.validate&&(se=this.validate(se,H)),B.enabledApiProposals&&(!this.n.isBuilt||this.f.includes(M.toLowerCase()))&&(B.originalEnabledApiProposals=B.enabledApiProposals,B.enabledApiProposals=(0,i.$yn)([...B.enabledApiProposals])),se}}catch(B){H.type!==i.ExtensionType.System&&this.r.error(B)}return null}validate(H,Z){let B=!0;const M=this.n.isBuilt&&this.f.includes(H.identifier.id.toLowerCase()),J=(0,l.$3p)(Z.productVersion,Z.productDate,Z.location,H.manifest,H.isBuiltin,M);for(const[K,ie]of J)K===I.default.Error&&(B=!1,this.r.error(this.F(Z.location,ie)));return H.isValid=B,H.validations=J,H}async w(H){const Z=(0,d.$fh)(H,"package.json");let B;try{B=(await this.m.readFile(Z)).value.toString()}catch(J){return(0,n.$ql)(J)!==n.FileOperationResult.FILE_NOT_FOUND&&this.r.error(this.F(H,(0,g.localize)(11450,null,Z.path,J.message))),null}let M;try{M=JSON.parse(B)}catch{const K=[];(0,O.$Xn)(B,K);for(const ie of K)this.r.error(this.F(H,(0,g.localize)(11451,null,Z.path,ie.offset,ie.length,(0,w.$Kq)(ie.error))));return null}return(0,O.$6n)(M)!=="object"?(this.r.error(this.F(H,(0,g.localize)(11452,null,Z.path))),null):M}async y(H,Z,B){const M=await this.z(H,Z,B);if(M)try{const J=[],K=await this.C(M.default,J);if(J.length>0)return J.forEach(se=>{this.r.error(this.F(H,(0,g.localize)(11453,null,M.default?.path,(0,w.$Kq)(se.error))))}),Z;if((0,O.$6n)(M)!=="object")return this.r.error(this.F(H,(0,g.localize)(11454,null,M.default?.path))),Z;const ie=M.values||Object.create(null);return(0,A.$Lq)(this.r,Z,ie,K)}catch{}return Z}async z(H,Z,B){const M=(0,d.$fh)(H,"package.nls.json"),J=(T,W)=>{W.forEach(z=>{this.r.error(this.F(H,(0,g.localize)(11455,null,T?.path,(0,w.$Kq)(z.error))))})},K=T=>{this.r.error(this.F(H,(0,g.localize)(11456,null,T?.path)))},ie=`${Z.publisher}.${Z.name}`,se=B.translations[ie];if(se)try{const T=h.URI.file(se),W=(await this.m.readFile(T)).value.toString(),z=[],E=(0,O.$Xn)(W,z);return z.length>0?(J(T,z),{values:void 0,default:M}):(0,O.$6n)(E)!=="object"?(K(T),{values:void 0,default:M}):{values:E.contents?E.contents.package:void 0,default:M}}catch{return{values:void 0,default:M}}else{if(!await this.m.exists(M))return;let W;try{W=await this.D(H,B)}catch{return}if(!W.localized)return{values:void 0,default:W.original};try{const z=(await this.m.readFile(W.localized)).value.toString(),E=[],j=(0,O.$Xn)(z,E);return E.length>0?(J(W.localized,E),{values:void 0,default:W.original}):(0,O.$6n)(j)!=="object"?(K(W.localized),{values:void 0,default:W.original}):{values:j,default:W.original}}catch{return{values:void 0,default:W.original}}}}async C(H,Z){if(H)try{const B=(await this.m.readFile(H)).value.toString();return(0,O.$Xn)(B,Z)}catch{}}D(H,Z){return new Promise((B,M)=>{const J=K=>{const ie=(0,d.$fh)(H,`package.nls.${K}.json`);this.m.exists(ie).then(se=>{se&&B({localized:ie,original:(0,d.$fh)(H,"package.nls.json")});const T=K.lastIndexOf("-");T===-1?B({localized:(0,d.$fh)(H,"package.nls.json"),original:null}):(K=K.substring(0,T),J(K))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,d.$fh)(H,"package.nls.json"),original:null});J(Z.language)})}F(H,Z){return`[${H.path}]: ${Z}`}};Q=be([re(1,$.$Iq),re(2,C.$Jl),re(3,n.$_k),re(4,r.$sk),re(5,R.$Li),re(6,t.$_j)],Q);let te=class extends Q{constructor(H,Z,B,M,J,K,ie,se,T){super(Z,M,J,K,ie,se,T),this.J=H,this.L=B,this.H=this.B(new P.$Ch(3e3)),this.I=this.B(new o.$le),this.onDidChangeCache=this.I.event}async scanExtensions(H){const Z=this.P(H),B=await this.M(Z);if(this.G=H,B&&B.input&&G.equals(B.input,this.G))return this.r.debug("Using cached extensions scan result",H.type===i.ExtensionType.System?"system":"user",H.location.toString()),this.H.trigger(()=>this.O()),B.result.map(J=>(J.location=h.URI.revive(J.location),J));const M=await super.scanExtensions(H);return await this.N(Z,{input:H,result:M}),M}async M(H){try{const Z=await this.m.readFile(H),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,u.$bi)(B.input)}}catch(Z){this.r.debug("Error while reading the extension cache file:",H.path,(0,L.$9)(Z))}return null}async N(H,Z){try{await this.m.writeFile(H,k.$Ne.fromString(JSON.stringify(Z)))}catch(B){this.r.debug("Error while writing the extension cache file:",H.path,(0,L.$9)(B))}}async O(){if(!this.G)return;const H=this.P(this.G),Z=await this.M(H);if(!Z)return;const B=Z.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.G)));if(!v.$ho(M,B))try{this.r.info("Invalidating Cache",B,M),await this.m.del(H),this.I.fire()}catch(J){this.r.error(J)}}P(H){const Z=this.Q(H);return this.j.extUri.joinPath(Z.cacheHome,H.type===i.ExtensionType.System?i.$ln:i.$kn)}Q(H){return H.type===i.ExtensionType.System?this.L.defaultProfile:H.profile?this.j.extUri.isEqual(H.location,this.J.extensionsResource)?this.J:this.L.profiles.find(Z=>this.j.extUri.isEqual(H.location,Z.extensionsResource))??this.J:this.L.defaultProfile}};te=be([re(2,N.$Ll),re(3,$.$Iq),re(4,C.$Jl),re(5,n.$_k),re(6,r.$sk),re(7,R.$Li),re(8,t.$_j)],te);function ae(de,H){const Z=(0,y.$Op)(de.manifest.publisher,de.manifest.name);return{id:Z,identifier:new i.$qn(Z),isBuiltin:de.type===i.ExtensionType.System,isUserBuiltin:de.type===i.ExtensionType.User&&de.isBuiltin,isUnderDevelopment:H,extensionLocation:de.location,uuid:de.identifier.uuid,targetPlatform:de.targetPlatform,publisherDisplayName:de.publisherDisplayName,...de.manifest}}class le extends U{constructor(H,Z,B,M,J,K,ie,se,T,W,z,E){super(H,Z,(0,d.$fh)(B,".vscode-oss-dev","extensions","control.json"),M,J,K,ie,se,T,W,z,E),this.S=(async()=>{if(m.$A)try{const j=await this.w.readFile(h.URI.file(m.$A));return JSON.parse(j.value.toString())}catch{}return Object.create(null)})()}f(H){return this.S}}e.$Qq=le}),define(ue[136],he([0,1,60,8,38,4,2,14,15,29,6,24]),function(Y,e,S,P,v,k,L,O,w,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;let m=class extends L.$Uc{constructor(p,I){super(),this.b=p,this.f=I,this.a=new P.$Kh(5)}async postUninstall(p){const I=this.g(p,"uninstall");I&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(I.script,"uninstall",I.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(b){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(b)}}));try{await a.Promises.rm(this.m(p))}catch(b){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(b)}}g(p,I){const b=`vscode:${I}`;if(p.location.scheme===O.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[b]=="string"){const h=p.manifest.scripts[b].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${b} should be a node script`),null):{script:(0,w.$jc)(p.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(p,I,b,h,g){return new Promise((R,y)=>{const i=this.j(p,I,b,g);let l;const n=s=>{l&&(clearTimeout(l),l=null),s?y(s):R(void 0)};i.on("error",s=>{n((0,v.$pj)(s)||"Unknown")}),i.on("exit",(s,t)=>{n(s?`post-${I} process exited with code ${s}`:void 0)}),h&&(l=setTimeout(()=>{l=null,i.kill(),y("timed out")},5e3))})}j(p,I,b,h){const g={silent:!0,execArgv:void 0},R=(0,S.fork)(p,[`--type=extension-post-${I}`,...b],g);R.stdout.setEncoding("utf8"),R.stderr.setEncoding("utf8");const y=k.Event.fromNodeEventEmitter(R.stdout,"data"),i=k.Event.fromNodeEventEmitter(R.stderr,"data");this.B(y(s=>this.f.info(h.identifier.id,h.manifest.version,`post-${I}`,s))),this.B(i(s=>this.f.error(h.identifier.id,h.manifest.version,`post-${I}`,s)));const l=k.Event.any(k.Event.map(y,s=>({data:`%c${s}`,format:[""]}),this.q),k.Event.map(i,s=>({data:`%c${s}`,format:["color: red"]}),this.q));return k.Event.debounce(l,(s,t)=>s?{data:s.data+t.data,format:[...s.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(s=>{console.group(h.identifier.id),console.log(s.data,...s.format),console.groupEnd()}),R}m(p){return(0,w.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$Uq=m,e.$Uq=m=be([re(0,c.$Ll),re(1,f.$_j)],m)}),define(ue[72],he([0,1,50,5,53,20]),function(Y,e,S,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=L,e.$Sq=O;function L(w){let a=k.ExtensionManagementErrorCode.Extract;return w instanceof S.$Aq&&(w.type==="CorruptZip"?a=k.ExtensionManagementErrorCode.CorruptZip:w.type==="Incomplete"&&(a=k.ExtensionManagementErrorCode.IncompleteZip)),(0,v.$Fq)(w,a)}async function O(w){let a;try{a=await(0,S.$Dq)(w,"extension/package.json")}catch(f){throw L(f)}try{return JSON.parse(a.toString("utf8"))}catch{throw new k.$mp((0,P.localize)(11440,null),k.ExtensionManagementErrorCode.Invalid)}}}),define(ue[137],he([0,1,8,7,2,14,16,45,3,28,29,50,30,17,53,20,26,72,71,9,6,18]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g,R,y,i){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0,O=ye(O);let n=class extends v.$Uc{static{l=this}static{this.c=".sigzip"}constructor(t,r,o,u,$,N,C){super(),this.h=r,this.j=o,this.m=u,this.n=$,this.r=N,this.t=C,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,r,o,u){await this.g;const $=await this.w(t,r);let N=!1;if(o&&this.u(t)){let C;try{C=await this.y(t)}catch(A){try{await this.delete($)}catch(D){this.t.error(D)}throw A}try{N=await this.n.verify(t,$.fsPath,C.fsPath,u)}catch(A){if(N=A.code,N===g.ExtensionSignatureVerificationCode.PackageIsInvalidZip||N===g.ExtensionSignatureVerificationCode.SignatureArchiveIsInvalidZip){try{await this.delete($)}catch(D){this.t.error(D)}throw new I.$mp(c.$zq,I.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(C)}catch(A){this.t.error(A)}}}return{location:$,verificationStatus:N}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,w.$kg)(r)?r:!0}async w(t,r){try{const o=(0,L.$fh)(this.extensionsDownloadDir,this.G(t)),u=await this.C(t,"vsix",async()=>{await this.z(t,o,$=>this.j.download(t,$,r));try{await this.D(o.fsPath,"extension/package.json")}catch($){try{await this.h.del(o)}catch(N){this.t.warn(`Error while deleting: ${o.path}`,(0,P.$9)(N))}throw $}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:u}),o}catch(o){throw(0,p.$Fq)(o,I.ExtensionManagementErrorCode.Download)}}async y(t){try{const r=(0,L.$fh)(this.extensionsDownloadDir,`.${(0,a.$1g)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,r);try{await this.D(r.fsPath,".signature.p7s")}catch(u){try{await this.h.del(r)}catch($){this.t.warn(`Error while deleting: ${r.path}`,(0,P.$9)($))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),r}catch(r){throw(0,p.$Fq)(r,I.ExtensionManagementErrorCode.DownloadSignature)}}async z(t,r,o){if(await this.h.exists(r))return;if(r.scheme!==k.Schemas.file){await o(r);return}const u=(0,L.$fh)(this.extensionsDownloadDir,`.${(0,a.$1g)()}`);try{await o(u)}catch($){try{await this.h.del(u)}catch{}throw $}try{await f.Promises.rename(u.fsPath,r.fsPath,2*60*1e3)}catch($){try{await this.h.del(u)}catch{}let N=!1;try{N=await this.h.exists(r)}catch{}if(N)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.t.info(`Rename failed because of ${(0,P.$9)($)}. Deleted the file from downloaded location`,u.path),$}}async C(t,r,o,u){let $=1;for(;;)try{return await o(),$}catch(N){if($++>u)throw N;this.t.warn(`Failed downloading ${r}. ${(0,P.$9)(N)}. Retry again...`,t.identifier.id)}}async D(t,r){try{await(0,c.$Dq)(t,r)}catch(o){throw(0,h.$Rq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],o=[],u=[];for(const C of t.children)if(C.name.endsWith(l.c))u.push(C.resource);else{const A=b.$Mp.parse(C.name);A&&o.push([A,C])}const $=(0,b.$Rp)(o,([C])=>C),N=[];for(const C of $)C.sort((A,D)=>O.rcompare(A[0].version,D[0].version)),r.push(...C.slice(1).map(A=>A[1].resource)),N.push(C[0][1]);N.sort((C,A)=>C.mtime-A.mtime),r.push(...N.slice(0,Math.max(0,N.length-this.f)).map(C=>C.resource)),r.push(...u),await S.Promises.settled(r.map(C=>(this.t.trace("Deleting from cache",C.path),this.h.del(C))))}}catch(t){this.t.error(t)}}G(t){return this.f?b.$Mp.create(t).toString().toLowerCase():(0,a.$1g)()}};e.$Tq=n,e.$Tq=n=l=be([re(0,d.$Mi),re(1,R.$_k),re(2,I.$kp),re(3,m.$$i),re(4,g.$sq),re(5,i.$$l),re(6,y.$_j)],n)}),define(ue[138],he([0,1,32,8,13,21,38,7,4,43,2,25,14,15,16,45,3,11,28,29,50,5,61,17,53,20,26,42,54,137,136,72,118,125,22,44,9,10,6,33,18,23,24]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g,R,y,i,l,n,s,t,r,o,u,$,N,C,A,D,U,G,Q,te,ae,le,de,H,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=e.$Xq=void 0,S=ye(S),d=ye(d),I=ye(I),R=ye(R),i=ye(i),e.$Xq=(0,te.$Fi)(t.$np);const B=".vsctmp";let M=class extends s.$Eq{constructor(T,W,z,E,j,X,F,q,x,ne,oe,ce){super(T,W,oe,z,ne,ce),this.db=j,this.eb=X,this.fb=F,this.gb=q,this.hb=x,this.cb=new Map,this.sb=new c.$Bc;const ve=this.B(q.createInstance(N.$Uq));this.$=this.B(q.createInstance(J,$e=>ve.postUninstall($e))),this.ab=this.B(new A.$Vq(ce,x,oe,this,this.F)),this.bb=this.B(q.createInstance($.$Tq));const fe=this.B(new D.$Wq(this,this.db,ce,X,oe,x,z));this.B(fe.onDidChangeExtensionsByAnotherSource($e=>this.rb($e))),this.tb()}getTargetPlatform(){return this.ib||(this.ib=(0,r.$Wp)(this.hb,this.F)),this.ib}async zip(T){this.F.trace("ExtensionManagementService#zip",T.identifier.id);const W=await this.qb(T),z=await(0,y.zip)((0,p.$fh)(this.bb.extensionsDownloadDir,(0,g.$1g)()).fsPath,W);return h.URI.file(z)}async getManifest(T){const{location:W,cleanup:z}=await this.kb(T),E=d.$kc(W.fsPath);try{return await(0,C.$Sq)(E)}finally{await z()}}getInstalled(T,W=this.H.defaultProfile.extensionsResource,z={version:this.G.version,date:this.G.date}){return this.$.scanExtensions(T??null,W,z)}scanAllUserInstalledExtensions(){return this.$.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(T){return this.$.scanUserExtensionAtLocation(T)}async install(T,W={}){this.F.trace("ExtensionManagementService#install",T.toString());const{location:z,cleanup:E}=await this.kb(T);try{const j=await(0,C.$Sq)(d.$kc(z.fsPath)),X=(0,r.$Qp)(j.publisher,j.name);if(j.engines&&j.engines.vscode&&!(0,G.$5p)(j.engines.vscode,this.G.version,this.G.date))throw new Error(i.localize(11441,null,X,this.G.version));const q=(await this.I([{manifest:j,extension:z,options:W}])).find(({identifier:x})=>(0,r.$Lp)(x,{id:X}));if(q?.local)return q.local;throw q?.error?q.error:(0,s.$Fq)(new Error(`Unknown error while installing extension ${X}`))}finally{await E()}}async installFromLocation(T,W){this.F.trace("ExtensionManagementService#installFromLocation",T.toString());const z=await this.$.scanUserExtensionAtLocation(T);if(!z||!z.manifest.name||!z.manifest.version)throw new Error(`Cannot find a valid extension from the location ${T.toString()}`);return await this.vb([[z,{source:"resource"}]],W),this.F.info("Successfully installed extension",z.identifier.id,W.toString()),z}async installExtensionsFromProfile(T,W,z){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",T,W.toString(),z.toString());const E=(await this.getInstalled(U.ExtensionType.User,W)).filter(j=>T.some(X=>(0,r.$Lp)(X,j.identifier)));if(E.length){const j=await Promise.all(E.map(X=>this.$.scanMetadata(X,W)));await this.vb(E.map((X,F)=>[X,j[F]]),z),this.F.info("Successfully installed extensions",E.map(X=>X.identifier.id),z.toString())}return E}async updateMetadata(T,W,z){return this.F.trace("ExtensionManagementService#updateMetadata",T.identifier.id),W.isPreReleaseVersion&&(W.preRelease=!0,W.hasPreReleaseVersion=!0),W.isMachineScoped===!1&&(W.isMachineScoped=void 0),W.isBuiltin===!1&&(W.isBuiltin=void 0),W.pinned===!1&&(W.pinned=void 0),T=await this.$.updateMetadata(T,W,z),this.ab.invalidate(z),this.w.fire({local:T,profileLocation:z}),T}async reinstallFromGallery(T){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.z.isEnabled())throw new Error(i.localize(11442,null));const W=await this.getTargetPlatform(),[z]=await this.z.getExtensions([{...T.identifier,preRelease:T.preRelease}],{targetPlatform:W,compatible:!0},k.CancellationToken.None);if(!z)throw new Error(i.localize(11443,null));await this.$.setUninstalled(T);try{await this.$.removeUninstalledExtension(T)}catch(E){throw new Error(i.localize(11444,null,(0,L.$pj)(E)))}return this.installFromGallery(z)}Z(T,W,z,E){return this.$.copyExtension(T,W,z,E)}copyExtensions(T,W){return this.$.copyExtensions(T,W,{version:this.G.version,date:this.G.date})}markAsUninstalled(...T){return this.$.setUninstalled(...T)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.$.cleanUp()}catch(T){this.F.error(T)}}async download(T,W,z){const{location:E}=await this.bb.download(T,W,!z);return E}async kb(T){if(T.scheme===m.Schemas.file)return{location:T,async cleanup(){}};this.F.trace("Downloading extension from",T.toString());const W=(0,p.$fh)(this.bb.extensionsDownloadDir,(0,g.$1g)());return await this.fb.download(T,W),this.F.info("Downloaded extension to",W.toString()),{location:W,cleanup:async()=>{try{await this.hb.del(W)}catch(E){this.F.error(E)}}}}W(){return this.H.defaultProfile.extensionsResource}X(T,W,z){const E=W instanceof h.URI?new r.$Mp({id:(0,r.$Qp)(T.publisher,T.name)},T.version):r.$Mp.create(W);return this.gb.createInstance(K,E,T,W,z,(j,X)=>{if(W instanceof h.URI)return this.pb(E,W,z,X);let F=this.cb.get(E.toString());return F||(this.cb.set(E.toString(),F=this.ob(E,W,j,z,X)),F.finally(()=>this.cb.delete(E.toString()))),F},this.$)}Y(T,W){return new ie(T,W,this.eb)}async ob(T,W,z,E,j){const{verificationStatus:X,location:F}=await this.bb.download(W,z,!E.donotVerifySignature,E.context?.[t.$dp]);try{if(j.isCancellationRequested)throw new O.$4;const q=await(0,C.$Sq)(F.fsPath);if(!new r.$Mp(W.identifier,W.version).equals(new r.$Mp({id:(0,r.$Qp)(q.publisher,q.name)},q.version)))throw new t.$mp(i.localize(11445,null,W.identifier.id),t.ExtensionManagementErrorCode.Invalid);return{local:await this.$.extractUserExtension(T,F.fsPath,{id:W.identifier.uuid,publisherId:W.publisherId,publisherDisplayName:W.publisherDisplayName,targetPlatform:W.properties.targetPlatform,isApplicationScoped:E.isApplicationScoped,isMachineScoped:E.isMachineScoped,isBuiltin:E.isBuiltin,isPreReleaseVersion:W.properties.isPreReleaseVersion,hasPreReleaseVersion:W.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:E.installGivenVersion?!0:!!E.pinned,preRelease:(0,b.$kg)(E.preRelease)?E.preRelease:E.installPreReleaseVersion||W.properties.isPreReleaseVersion,source:"gallery"},!1,j),verificationStatus:X}}catch(q){try{await this.bb.delete(F)}catch(x){this.F.warn("Error while deleting the downloaded file",F.toString(),(0,O.$9)(x))}throw(0,s.$Fq)(q)}}async pb(T,W,z,E){return{local:await this.$.extractUserExtension(T,d.$kc(W.fsPath),{isApplicationScoped:z.isApplicationScoped,isMachineScoped:z.isMachineScoped,isBuiltin:z.isBuiltin,installedTimestamp:Date.now(),pinned:z.installGivenVersion?!0:!!z.pinned,source:"vsix"},z.keepExisting??!0,E)}}async qb(T){const W=async E=>{let j=await R.Promises.readdir(E);j=j.map(q=>d.$jc(E,q));const X=await Promise.all(j.map(q=>S.promises.stat(q)));let F=Promise.resolve([]);return X.forEach((q,x)=>{const ne=j[x];q.isFile()&&(F=F.then(oe=>[...oe,ne])),q.isDirectory()&&(F=F.then(oe=>W(ne).then(ce=>[...oe,...ce])))}),F};return(await W(T.location.fsPath)).map(E=>({path:`extension/${d.$lc(T.location.fsPath,E)}`,localPath:E}))}async rb({added:T,removed:W}){if(W){const z=T&&this.D.extUri.isEqual(W.profileLocation,T.profileLocation)?W.extensions.filter(E=>T.extensions.every(j=>!(0,r.$Lp)(j,E))):W.extensions;for(const E of z)this.F.info("Extensions removed from another source",E.id,W.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:W.profileLocation})}if(T){const E=(await this.getInstalled(U.ExtensionType.User,T.profileLocation)).filter(j=>T.extensions.some(X=>(0,r.$Lp)(X,j.identifier)));this.s.fire(E.map(j=>(this.F.info("Extensions added from another source",j.identifier.id,T.profileLocation.toString()),{identifier:j.identifier,local:j,profileLocation:T.profileLocation,operation:t.InstallOperation.None})))}}async tb(){this.B(this.$.onExtract(W=>this.sb.add(W)));const T=await this.hb.resolve(this.db.userExtensionsLocation);for(const W of T.children??[])W.isDirectory&&this.sb.add(W.resource);this.B(this.hb.watch(this.db.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(W=>this.ub(W)))}async ub(T){if(!T.affects(this.db.userExtensionsLocation,Q.FileChangeType.ADDED))return;const W=[];for(const z of T.rawAdded){if(this.sb.has(z)||!this.D.extUri.isEqual(this.D.extUri.dirname(z),this.db.userExtensionsLocation)||this.D.extUri.isEqual(z,this.D.extUri.joinPath(this.db.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(z).startsWith(".")||!(await this.hb.stat(z)).isDirectory)continue;const E=await this.$.scanUserExtensionAtLocation(z);E&&E.installedTimestamp===void 0&&(this.sb.add(z),W.push(E))}W.length&&(await this.vb(W.map(z=>[z,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",W.map(z=>z.identifier.id)))}async vb(T,W){const z=T.map(E=>E[0]);await this.wb(z),await this.eb.addExtensionsToProfile(T,W),this.s.fire(z.map(E=>({local:E,identifier:E.identifier,operation:t.InstallOperation.None,profileLocation:W})))}async wb(T){const W=await this.$.getUninstalledExtensions();for(const z of T){const E=r.$Mp.create(z);W[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.$.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$Yq=M,e.$Yq=M=be([re(0,t.$kp),re(1,de.$$l),re(2,ae.$_j),re(3,n.$Mi),re(4,u.$Mq),re(5,o.$Iq),re(6,l.$1o),re(7,te.$Di),re(8,Q.$_k),re(9,le.$sk),re(10,H.$Jl),re(11,Z.$Ll)],M);let J=class extends f.$Uc{constructor(T,W,z,E,j,X,F){super(),this.n=T,this.s=W,this.t=z,this.u=E,this.w=j,this.y=X,this.z=F,this.h=this.B(new w.$le),this.onExtract=this.h.event,this.j=new c.$Ac,this.m=new c.$Ac,this.c=(0,p.$fh)(this.t.userExtensionsLocation,".obsolete"),this.g=new P.$Lh}async cleanUp(){await this.J(),await this.I()}async scanExtensions(T,W,z){try{const E={includeInvalid:!0,profileLocation:W,productVersion:z};let j=[];if(T===null||T===U.ExtensionType.System){let X=this.j.get(W);X||(X=this.t.scanAllExtensions({includeInvalid:!0,useCache:!0},E,!1).finally(()=>this.j.delete(W)),this.j.set(W,X)),j.push(...await X)}else if(T===U.ExtensionType.User){let X=this.m.get(W);X||(X=this.t.scanUserExtensions(E).finally(()=>this.m.delete(W)),this.m.set(W,X)),j.push(...await X)}return j=T!==null?j.filter(X=>X.type===T):j,await Promise.all(j.map(X=>this.H(X)))}catch(E){throw(0,s.$Fq)(E,t.ExtensionManagementErrorCode.Scanning)}}async scanAllUserExtensions(T){try{const W=await this.t.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return await Promise.all(W.map(z=>this.H(z)))}catch(W){throw(0,s.$Fq)(W,t.ExtensionManagementErrorCode.Scanning)}}async scanUserExtensionAtLocation(T){try{const W=await this.t.scanExistingExtension(T,U.ExtensionType.User,{includeInvalid:!0});if(W)return await this.H(W)}catch(W){this.z.error(W)}return null}async extractUserExtension(T,W,z,E,j){const X=T.toString(),F=h.URI.file(d.$jc(this.t.userExtensionsLocation.fsPath,`.${(0,g.$1g)()}`)),q=h.URI.file(d.$jc(this.t.userExtensionsLocation.fsPath,X));if(await this.s.exists(q)){if(!E)try{return await this.scanLocalExtension(q,U.ExtensionType.User)}catch(x){this.z.warn(`Error while scanning the existing extension at ${q.path}. Deleting the existing extension and extracting it.`,(0,O.$9)(x))}try{await this.D(T.id,q,"removeExisting")}catch{throw new t.$mp(i.localize(11446,null,q.fsPath,T.id),t.ExtensionManagementErrorCode.Delete)}}try{if(j.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started extracting the extension from ${W} to ${q.fsPath}`),await(0,y.$Cq)(W,F.fsPath,{sourcePath:"extension",overwrite:!0},j),this.z.info(`Extracted extension to ${q}:`,T.id)}catch(x){throw(0,C.$Rq)(x)}try{await this.t.updateMetadata(F,z)}catch(x){throw this.y.publicLog2("extension:extract",{extensionId:T.id,code:`${(0,Q.$ql)(x)}`}),(0,s.$Fq)(x,t.ExtensionManagementErrorCode.UpdateMetadata)}if(j.isCancellationRequested)throw new O.$4;try{this.z.trace(`Started renaming the extension from ${F.fsPath} to ${q.fsPath}`),await this.G(F.fsPath,q.fsPath),this.z.info("Renamed to",q.fsPath)}catch(x){if(x.code==="ENOTEMPTY"){this.z.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);try{await this.s.del(F,{recursive:!0})}catch{}}else throw this.z.info(`Rename failed because of ${(0,O.$9)(x)}. Deleted from extracted location`,F),x}this.h.fire(q)}catch(x){try{await this.s.del(F,{recursive:!0})}catch{}throw x}return this.scanLocalExtension(q,U.ExtensionType.User)}async scanMetadata(T,W){return W?(await this.C(T,W))?.metadata:this.t.scanMetadata(T.location)}async C(T,W){return(await this.u.scanProfileExtensions(W)).find(E=>(0,r.$Lp)(E.identifier,T.identifier))}async updateMetadata(T,W,z){try{z?await this.u.updateMetadata([[T,W]],z):await this.t.updateMetadata(T.location,W)}catch(E){throw this.y.publicLog2("extension:extract",{extensionId:T.identifier.id,code:`${(0,Q.$ql)(E)}`,isProfile:!!z}),(0,s.$Fq)(E,t.ExtensionManagementErrorCode.UpdateMetadata)}return this.scanLocalExtension(T.location,T.type,z)}async getUninstalledExtensions(){try{return await this.F()}catch(T){throw(0,s.$Fq)(T,t.ExtensionManagementErrorCode.ReadUninstalled)}}async setUninstalled(...T){const W=T.map(z=>r.$Mp.create(z));await this.F(z=>W.forEach(E=>{z[E.toString()]=!0,this.z.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(T){try{await this.F(W=>delete W[T.toString()])}catch(W){throw(0,s.$Fq)(W,t.ExtensionManagementErrorCode.UnsetUninstalled)}}async removeExtension(T,W){if(this.w.extUri.isEqualOrParent(T.location,this.t.userExtensionsLocation))return this.D(T.identifier.id,T.location,W)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.F(W=>delete W[r.$Mp.create(T).toString()])}async copyExtension(T,W,z,E){const j=await this.C(T,W),X=await this.C(T,z);if(E={...j?.metadata,...E},X)if(this.w.extUri.isEqual(X.location,T.location))await this.u.updateMetadata([[T,{...X.metadata,...E}]],z);else{const F=await this.scanLocalExtension(X.location,T.type,z);await this.u.removeExtensionFromProfile(F,z),await this.u.addExtensionsToProfile([[T,{...X.metadata,...E}]],z)}else await this.u.addExtensionsToProfile([[T,E]],z);return this.scanLocalExtension(T.location,T.type,z)}async copyExtensions(T,W,z){const E=await this.scanExtensions(U.ExtensionType.User,T,z),j=await Promise.all(E.filter(X=>!X.isApplicationScoped).map(async X=>[X,await this.scanMetadata(X,T)]));await this.u.addExtensionsToProfile(j,W)}async D(T,W,z){this.z.trace(`Deleting ${z} extension from disk`,T,W.fsPath);const E=this.w.extUri.joinPath(this.w.extUri.dirname(W),`${this.w.extUri.basename(W)}.${(0,a.$sj)((0,g.$1g)()).toString(16)}${B}`);await this.G(W.fsPath,E.fsPath),await this.s.del(E,{recursive:!0}),this.z.info(`Deleted ${z} extension from disk`,T,W.fsPath)}F(T){return this.g.queue(async()=>{let W;try{W=(await this.s.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,Q.$ql)(E)!==Q.FileOperationResult.FILE_NOT_FOUND)throw E}let z={};if(W)try{z=JSON.parse(W)}catch{}return T&&(T(z),Object.keys(z).length?await this.s.writeFile(this.c,v.$Ne.fromString(JSON.stringify(z))):await this.s.del(this.c)),z})}async G(T,W){try{await R.Promises.rename(T,W,2*60*1e3)}catch(z){throw(0,s.$Fq)(z,t.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(T,W,z){try{if(z){const j=(await this.t.scanUserExtensions({profileLocation:z})).find(X=>this.w.extUri.isEqual(X.location,T));if(j)return await this.H(j)}else{const E=await this.t.scanExistingExtension(T,W,{includeInvalid:!0});if(E)return await this.H(E)}throw new t.$mp(i.localize(11447,null,T.path),t.ExtensionManagementErrorCode.ScanningExtension)}catch(E){throw(0,s.$Fq)(E,t.ExtensionManagementErrorCode.ScanningExtension)}}async H(T){const W=await this.s.resolve(T.location);let z,E;return W.children&&(z=W.children.find(({name:j})=>/^readme(\.txt|\.md|)$/i.test(j))?.resource,E=W.children.find(({name:j})=>/^changelog(\.txt|\.md|)$/i.test(j))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:z,changelogUrl:E,publisherDisplayName:T.metadata?.publisherDisplayName,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!T.metadata?.hasPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated,pinned:!!T.metadata?.pinned,isWorkspaceScoped:!1,source:T.metadata?.source??(T.identifier.uuid?"gallery":"vsix")}}async I(){const T=await this.getUninstalledExtensions();if(Object.keys(T).length===0){this.z.debug("No uninstalled extensions found.");return}this.z.debug("Removing uninstalled extensions:",Object.keys(T));const W=await this.t.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),z=new Set;for(const j of W)T[r.$Mp.create(j).toString()]||z.add(j.identifier.id.toLowerCase());try{const j=(0,r.$Rp)(W,X=>X.identifier);await P.Promises.settled(j.map(async X=>{const F=X.sort((q,x)=>I.rcompare(q.manifest.version,x.manifest.version))[0];z.has(F.identifier.id.toLowerCase())||await this.n(await this.H(F))}))}catch(j){this.z.error(j)}const E=W.filter(j=>j.metadata&&T[r.$Mp.create(j).toString()]);await Promise.allSettled(E.map(j=>this.removeUninstalledExtension(j)))}async J(){this.z.trace("ExtensionManagementService#removeTempDeleteFolders");let T;try{T=await this.s.resolve(this.t.userExtensionsLocation)}catch(W){(0,Q.$ql)(W)!==Q.FileOperationResult.FILE_NOT_FOUND&&this.z.error(W);return}if(T?.children)try{await Promise.allSettled(T.children.map(async W=>{if(!(!W.isDirectory||!W.name.endsWith(B))){this.z.trace("Deleting the temporarily deleted folder",W.resource.toString());try{await this.s.del(W.resource,{recursive:!0}),this.z.trace("Deleted the temporarily deleted folder",W.resource.toString())}catch(z){(0,Q.$ql)(z)!==Q.FileOperationResult.FILE_NOT_FOUND&&this.z.error(z)}}}))}catch{}}};e.$Zq=J,e.$Zq=J=be([re(1,Q.$_k),re(2,u.$Mq),re(3,o.$Iq),re(4,H.$Jl),re(5,de.$$l),re(6,ae.$_j)],J);let K=class extends s.$Gq{get operation(){return this.options.operation??this.j}get verificationStatus(){return this.k}constructor(T,W,z,E,j,X,F,q,x,ne,oe,ce){super(),this.l=T,this.manifest=W,this.source=z,this.options=E,this.m=j,this.n=X,this.o=F,this.p=q,this.q=x,this.s=ne,this.t=oe,this.u=ce,this.j=t.InstallOperation.Install,this.identifier=this.l.identifier}async h(T){const z=(await this.n.scanExtensions(U.ExtensionType.User,this.options.profileLocation,this.options.productVersion)).find(F=>(0,r.$Lp)(F.identifier,this.identifier));z&&(this.j=t.InstallOperation.Update);const E={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,isSystem:z?.type===U.ExtensionType.System?!0:void 0,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:this.source instanceof h.URI?"vsix":"gallery"};let j;if(this.source instanceof h.URI){if(z&&this.l.equals(new r.$Mp(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(i.localize(11448,null,this.manifest.displayName||this.manifest.name))}const F=await this.w(this.l);if(F)try{await this.n.removeExtension(F,"existing")}catch{throw new Error(i.localize(11449,null,this.manifest.displayName||this.manifest.name))}}else{if(E.id=this.source.identifier.uuid,E.publisherId=this.source.publisherId,E.publisherDisplayName=this.source.publisherDisplayName,E.targetPlatform=this.source.properties.targetPlatform,E.updated=!!z,E.isPreReleaseVersion=this.source.properties.isPreReleaseVersion,E.hasPreReleaseVersion=z?.hasPreReleaseVersion||this.source.properties.isPreReleaseVersion,E.preRelease=(0,b.$kg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.source.properties.isPreReleaseVersion||z?.preRelease,z&&z.type!==U.ExtensionType.System&&z.manifest.version===this.source.version)return this.n.updateMetadata(z,E,this.options.profileLocation);j=await this.w(this.l)}if(T.isCancellationRequested)throw(0,s.$Fq)(new O.$4);if(!j){const F=await this.m(this.operation,T);j=F.local,this.k=F.verificationStatus}if(this.o.extUri.isEqual(this.q.defaultProfile.extensionsResource,this.options.profileLocation))try{await this.s.initializeDefaultProfileExtensions()}catch(F){throw(0,s.$Fq)(F,t.ExtensionManagementErrorCode.IntializeDefaultProfile)}if(T.isCancellationRequested)throw(0,s.$Fq)(new O.$4);try{await this.t.addExtensionsToProfile([[j,E]],this.options.profileLocation,!j.isValid)}catch(F){throw(0,s.$Fq)(F,t.ExtensionManagementErrorCode.AddToProfile)}const X=await this.n.scanLocalExtension(j.location,U.ExtensionType.User,this.options.profileLocation);if(!X)throw new t.$mp("Cannot find the installed extension",t.ExtensionManagementErrorCode.InstalledExtensionNotFound);return this.source instanceof h.URI&&this.x(j,T),X}async w(T){return(await this.n.getUninstalledExtensions())[T.toString()]?(this.u.trace("Removing the extension from uninstalled list:",T.id),await this.n.setInstalled(T),this.u.info("Removed the extension from uninstalled list:",T.id),(await this.n.scanAllUserExtensions(!0)).find(E=>r.$Mp.create(E).equals(T))):void 0}async x(T,W){try{let[z]=await this.p.getExtensions([{id:T.identifier.id,version:T.manifest.version}],W);if(z||([z]=await this.p.getExtensions([{id:T.identifier.id}],W)),z){const E={id:z.identifier.uuid,publisherDisplayName:z.publisherDisplayName,publisherId:z.publisherId,isPreReleaseVersion:z.properties.isPreReleaseVersion,hasPreReleaseVersion:T.hasPreReleaseVersion||z.properties.isPreReleaseVersion,preRelease:z.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.n.updateMetadata(T,E,this.options.profileLocation)}}catch{}}};K=be([re(6,H.$Jl),re(7,t.$kp),re(8,Z.$Ll),re(9,u.$Mq),re(10,o.$Iq),re(11,ae.$_j)],K);class ie extends s.$Gq{constructor(T,W,z){super(),this.extension=T,this.options=W,this.j=z}async h(T){await this.j.removeExtensionFromProfile(this.extension,this.options.profileLocation)}}}),define(ue[139],he([0,1,6,24,23,18,42,9,17,11]),function(Y,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IR=void 0;let f=class extends L.$Jq{constructor(m,d,p,I,b,h){super(a.URI.file(m.extensionsPath),d,p,I,b,h)}};e.$IR=f,e.$IR=f=be([re(0,w.$Mi),re(1,O.$_k),re(2,P.$Ll),re(3,v.$Jl),re(4,k.$$l),re(5,S.$_j)],f)}),define(ue[140],he([0,1,11,17,42,54,9,10,6,33,23,24]),function(Y,e,S,P,v,k,L,O,w,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;let m=class extends k.$Qq{constructor(p,I,b,h,g,R,y,i){super(S.URI.file(g.builtinExtensionsPath),S.URI.file(g.extensionsPath),g.userHome,p.defaultProfile,p,I,b,h,g,R,y,i)}};e.$phc=m,e.$phc=m=be([re(0,c.$Ll),re(1,v.$Iq),re(2,L.$_k),re(3,w.$_j),re(4,P.$Mi),re(5,a.$sk),re(6,f.$Jl),re(7,O.$Di)],m)}),define(ue[73],he([0,1,8,4,2,108,3,88,10,24]),function(Y,e,S,P,v,k,L,O,w,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$jq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hq=e.$gq=e.$fq=void 0,e.$iq=d,e.$kq=I,e.$mq=h,e.$fq="__$__isNewStorageMarker",e.$gq="__$__targetStorageMarker",e.$hq=(0,w.$Ei)("storageService");var f;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(f||(e.WillSaveStateReason=f={}));var c;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(c||(e.StorageScope=c={}));var m;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function d(g){const R=g.get(e.$gq);if(R)try{return JSON.parse(R)}catch{}return Object.create(null)}class p extends v.$Uc{static{this.a=60*1e3}constructor(R={flushInterval:p.a}){super(),this.m=R,this.b=this.B(new P.$oe),this.c=this.B(new P.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new P.$le),this.onWillSaveState=this.f.event,this.h=this.B(new S.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new v.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(R,y,i){return P.Event.filter(this.b.event,l=>l.scope===R&&(y===void 0||l.key===y),i)}n(){this.j.value=(0,S.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,v.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,k.mark)("code/willInitStorage");try{await this.O()}finally{(0,k.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(R,y){const{key:i,external:l}=y;if(i===e.$gq){switch(R){case c.APPLICATION:this.H=void 0;break;case c.PROFILE:this.F=void 0;break;case c.WORKSPACE:this.C=void 0;break}this.c.fire({scope:R})}else this.b.fire({scope:R,key:i,target:this.J(R)[i],external:l})}w(R){this.f.fire({reason:R})}get(R,y,i){return this.P(y)?.get(R,i)}getBoolean(R,y,i){return this.P(y)?.getBoolean(R,i)}getNumber(R,y,i){return this.P(y)?.getNumber(R,i)}getObject(R,y,i){return this.P(y)?.getObject(R,i)}storeAll(R,y){this.y(()=>{for(const i of R)this.store(i.key,i.value,i.scope,i.target,y)})}store(R,y,i,l,n=!1){if((0,L.$ng)(y)){this.remove(R,i,n);return}this.y(()=>{this.z(R,i,l),this.P(i)?.set(R,y,n)})}remove(R,y,i=!1){this.y(()=>{this.z(R,y,void 0),this.P(y)?.delete(R,i)})}y(R){this.b.pause(),this.c.pause();try{R()}finally{this.b.resume(),this.c.resume()}}keys(R,y){const i=[],l=this.J(R);for(const n of Object.keys(l))l[n]===y&&i.push(n);return i}z(R,y,i,l=!1){const n=this.J(y);typeof i=="number"?n[R]!==i&&(n[R]=i,this.P(y)?.set(e.$gq,JSON.stringify(n),l)):typeof n[R]=="number"&&(delete n[R],this.P(y)?.set(e.$gq,JSON.stringify(n),l))}get D(){return this.C||(this.C=this.L(c.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(c.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(c.APPLICATION)),this.H}J(R){switch(R){case c.APPLICATION:return this.I;case c.PROFILE:return this.G;default:return this.D}}L(R){const y=this.P(R);return y?d(y):Object.create(null)}isNew(R){return this.getBoolean(e.$fq,R)===!0}async flush(R=f.NONE){this.f.fire({reason:R});const y=this.P(c.APPLICATION),i=this.P(c.PROFILE),l=this.P(c.WORKSPACE);switch(R){case f.NONE:await S.Promises.settled([y?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve()]);break;case f.SHUTDOWN:await S.Promises.settled([y?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve()]);break}}async log(){const R=this.P(c.APPLICATION)?.items??new Map,y=this.P(c.PROFILE)?.items??new Map,i=this.P(c.WORKSPACE)?.items??new Map;return h(R,y,i,this.Q(c.APPLICATION)??"",this.Q(c.PROFILE)??"",this.Q(c.WORKSPACE)??"")}async optimize(R){return await this.flush(),this.P(R)?.optimize()}async switch(R,y){return this.w(f.NONE),(0,a.$Kl)(R)?this.R(R,y):this.S(R,y)}M(R,y){return!(R.id===y.id||I(y)&&I(R))}N(R,y,i){this.y(()=>{const l=new Set;for(const[n,s]of R)l.add(n),y.get(n)!==s&&this.u(i,{key:n,external:!0});for(const[n]of y.items)l.has(n)||this.u(i,{key:n,external:!0})})}}e.$jq=p;function I(g){return g.isDefault||!!g.useDefaultFlags?.globalState}class b extends p{constructor(){super(),this.U=this.B(new O.$dq(new O.$eq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new O.$dq(new O.$eq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new O.$dq(new O.$eq,{hint:O.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(R=>this.u(c.WORKSPACE,R))),this.B(this.W.onDidChangeStorage(R=>this.u(c.PROFILE,R))),this.B(this.U.onDidChangeStorage(R=>this.u(c.APPLICATION,R)))}P(R){switch(R){case c.APPLICATION:return this.U;case c.PROFILE:return this.W;default:return this.X}}Q(R){switch(R){case c.APPLICATION:return"inMemory (application)";case c.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(R){return!1}}e.$lq=b;async function h(g,R,y,i,l,n){const s=D=>{try{return JSON.parse(D)}catch{return D}},t=new Map,r=new Map;g.forEach((D,U)=>{t.set(U,D),r.set(U,s(D))});const o=new Map,u=new Map;R.forEach((D,U)=>{o.set(U,D),u.set(U,s(D))});const $=new Map,N=new Map;y.forEach((D,U)=>{$.set(U,D),N.set(U,s(D))}),console.group(i!==l?`Storage: Application (path: ${i})`:`Storage: Application & Profile (path: ${i}, default profile)`);const C=[];if(t.forEach((D,U)=>{C.push({key:U,value:D})}),console.table(C),console.groupEnd(),console.log(r),i!==l){console.group(`Storage: Profile (path: ${l}, profile specific)`);const D=[];o.forEach((U,G)=>{D.push({key:G,value:U})}),console.table(D),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${n})`);const A=[];$.forEach((D,U)=>{A.push({key:U,value:D})}),console.table(A),console.groupEnd(),console.log(N)}}),define(ue[141],he([0,1,13,28,73]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=k;async function k(L,O,w){let a=w&&w.get("storage.serviceMachineId",v.StorageScope.APPLICATION)||null;if(a)return a;try{const c=(await O.readFile(L.serviceMachineIdResource)).value.toString();a=(0,P.$Zg)(c)?c:null}catch{a=null}if(!a){a=(0,P.$1g)();try{await O.writeFile(L.serviceMachineIdResource,S.$Ne.fromString(a))}catch{}}return w?.store("storage.serviceMachineId",a,v.StorageScope.APPLICATION,v.StorageTarget.MACHINE),a}}),define(ue[142],he([0,1,141,18,41]),function(Y,e,S,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=k;async function k(L,O,w,a,f,c,m){const d={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${O.nameShort})`};if((0,v.$Dp)(O,w)&&(0,v.$Fp)(a)===P.TelemetryLevel.USAGE){const p=await(0,S.$nq)(w,f,c);d["X-Market-User-Id"]=p,d["VSCode-SessionId"]=m.machineId||p}return d}}),define(ue[143],he([0,1,19,21,7,12,36,3,11,30,17,20,26,22,44,9,6,33,46,142,73,18,155]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g,R,y,i,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0,e.$pq=T;const n=k.$p?d.TargetPlatform.WEB:(0,c.$gp)(k.$v,L.$ec),s="X-Market-Search-Activity-Id";var t;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function r(...F){return String(F.reduce((q,x)=>q|x,0))}var o;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const u={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},$={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",EnabledApiProposals:"Microsoft.VisualStudio.Code.EnabledApiProposals",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support",ExecutesCode:"Microsoft.VisualStudio.Code.ExecutesCode"},C={pageNumber:1,pageSize:10,sortBy:c.SortBy.NoneOrRelevance,sortOrder:c.SortOrder.Default,flags:t.None,criteria:[],assetTypes:[]};class A{constructor(q=C){this.d=q}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(q,x=this.d.pageSize){return new A({...this.d,pageNumber:q,pageSize:x})}withFilter(q,...x){const ne=[...this.d.criteria,...x.length?x.map(oe=>({filterType:q,value:oe})):[{filterType:q}]];return new A({...this.d,criteria:ne})}withSortBy(q){return new A({...this.d,sortBy:q})}withSortOrder(q){return new A({...this.d,sortOrder:q})}withFlags(...q){return new A({...this.d,flags:q.reduce((x,ne)=>x|ne,0)})}withAssetTypes(...q){return new A({...this.d,assetTypes:q})}withSource(q){return new A({...this.d,source:q})}get raw(){const{criteria:q,pageNumber:x,pageSize:ne,sortBy:oe,sortOrder:ce,flags:ve,assetTypes:fe}=this.d;return{filters:[{criteria:q,pageNumber:x,pageSize:ne,sortBy:oe,sortOrder:ce}],assetTypes:fe,flags:ve}}get searchText(){const q=this.d.criteria.filter(x=>x.filterType===o.SearchText)[0];return q&&q.value?q.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(q=>String(q.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(F,q){const x=(F||[]).filter(ne=>ne.statisticName===q)[0];return x?x.value:0}function U(F){const q="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(ne=>ne.assetType.indexOf(q)===0).reduce((ne,oe)=>{const ce=te(F,oe.assetType);return ce&&ne.push([oe.assetType.substring(q.length),ce]),ne},[])}function G(F){if(F.properties){const q=F.properties.filter(oe=>oe.key===u.Repository),x=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ne=q.filter(oe=>x.test(oe.value))[0];return ne?{uri:ne.value,fallbackUri:ne.value}:null}return te(F,u.Repository)}function Q(F){return{uri:`${F.fallbackAssetUri}/${u.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${u.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function te(F,q){return F.files.filter(ne=>ne.assetType===q)[0]?{uri:`${F.assetUri}/${q}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${q}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function ae(F,q){const x=F.properties?F.properties.filter(oe=>oe.key===q):[],ne=x.length>0&&x[0].value;return ne?ne.split(",").map(oe=>(0,m.$Pp)(oe)):[]}function le(F){const q=F.properties?F.properties.filter(x=>x.key===$.Engine):[];return q.length>0&&q[0].value||""}function de(F){const q=F.properties?F.properties.filter(x=>x.key===$.PreRelease):[];return q.length>0&&q[0].value==="true"}function H(F){const q=F.properties?F.properties.filter(x=>x.key===$.ExecutesCode):[];return q.length>0?q[0].value==="true":void 0}function Z(F){const q=F.properties?F.properties.filter(ne=>ne.key===$.EnabledApiProposals):[],x=q.length>0&&q[0].value||"";return x?x.split(","):[]}function B(F){const q=F.properties?F.properties.filter(ne=>ne.key===$.LocalizedLanguages):[],x=q.length>0&&q[0].value||"";return x?x.split(","):[]}function M(F){return F.properties?.find(q=>q.key===$.SponsorLink)?.value}function J(F){return F.properties?.find(q=>q.key===$.SupportLink)?.value}function K(F){return F.indexOf("preview")!==-1}function ie(F){return F.targetPlatform?(0,c.$fp)(F.targetPlatform):d.TargetPlatform.UNDEFINED}function se(F){const q=(0,S.$Lb)(F.versions.map(ie)),x=!!F.tags?.includes(c.$_o),ne=q.indexOf(d.TargetPlatform.WEB);return x?ne===-1&&q.push(d.TargetPlatform.WEB):ne!==-1&&q.splice(ne,1),q}function T(F,q){for(let x=0;x<F.length;x++){const ne=F[x];if(ne.version===F[x-1]?.version){let oe=x;if(ie(ne)===q)for(;oe>0&&F[oe-1].version===ne.version;)oe--;oe!==x&&(F.splice(x,1),F.splice(oe,0,ne))}}return F}function W(F,q,x){F.telemetryData={index:q,querySource:x,queryActivityId:F.queryContext?.[s]}}function z(F,q,x,ne){const oe=F.versions[0],ce={manifest:te(q,u.Manifest),readme:te(q,u.Details),changelog:te(q,u.Changelog),license:te(q,u.License),repository:G(q),download:Q(q),icon:te(q,u.Icon),signature:te(q,u.Signature),coreTranslations:U(q)};return{type:"gallery",identifier:{id:(0,m.$Qp)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:q.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:M(oe),description:F.shortDescription??"",installCount:D(F.statistics,"install"),rating:D(F.statistics,"averagerating"),ratingCount:D(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:x,assets:ce,properties:{dependencies:ae(q,$.Dependency),extensionPack:ae(q,$.ExtensionPack),engine:le(q),enabledApiProposals:Z(q),localizedLanguages:B(q),targetPlatform:ie(q),isPreReleaseVersion:de(q),executesCode:H(q)},hasPreReleaseVersion:de(oe),hasReleaseVersion:!0,preview:K(F.flags),isSigned:!!ce.signature,queryContext:ne,supportLink:J(oe)}}let E=class{constructor(q,x,ne,oe,ce,ve,fe,$e){this.l=x,this.n=ne,this.o=oe,this.q=ce,this.u=ve,this.w=fe,this.x=$e;const pe=fe.extensionsGallery,me=pe?.servicePPEUrl&&$e.getValue("_extensionsGallery.enablePPE");this.d=me?pe.servicePPEUrl:pe?.serviceUrl,this.g=me?void 0:pe?.searchUrl,this.h=pe?.controlUrl,this.k=fe.extensionsEnabledWithApiProposalVersion?.map(ge=>ge.toLowerCase())??[],this.j=(0,R.$oq)(fe.version,fe,this.o,this.x,this.u,q,this.q)}y(q=""){return`${this.d}${q}`}isEnabled(){return!!this.d}async getExtensions(q,x,ne){const oe=P.CancellationToken.isCancellationToken(x)?{}:x,ce=P.CancellationToken.isCancellationToken(x)?x:ne,ve=[],fe=[],$e=[],pe=[];let me=!0;for(const V of q){V.uuid?fe.push(V.uuid):ve.push(V.id);const _=!!(V.version||V.preRelease);$e.push({id:V.id,uuid:V.uuid,includePreRelease:_}),V.version&&pe.push({id:V.id,uuid:V.uuid,version:V.version}),me=me&&!!V.hasPreRelease&&!_}if(!fe.length&&!ve.length)return[];let ge=new A().withPage(1,q.length);fe.length&&(ge=ge.withFilter(o.ExtensionId,...fe)),ve.length&&(ge=ge.withFilter(o.ExtensionName,...ve)),(oe.queryAllVersions||me)&&(ge=ge.withFlags(ge.flags,t.IncludeVersions)),oe.source&&(ge=ge.withSource(oe.source));const{extensions:Ee}=await this.B(ge,{targetPlatform:oe.targetPlatform??n,includePreRelease:$e,versions:pe,compatible:!!oe.compatible,productVersion:oe.productVersion??{version:this.w.version,date:this.w.date}},ce);return oe.source&&Ee.forEach((V,_)=>W(V,_,oe.source)),Ee}async getCompatibleExtension(q,x,ne,oe={version:this.w.version,date:this.w.date}){if((0,c.$hp)(q.allTargetPlatforms,ne))return null;if(await this.isExtensionCompatible(q,x,ne))return q;const ce=new A().withFlags(t.IncludeVersions).withPage(1,1).withFilter(o.ExtensionId,q.identifier.uuid),{extensions:ve}=await this.B(ce,{targetPlatform:ne,compatible:!0,includePreRelease:x,productVersion:oe},P.CancellationToken.None);return ve[0]||null}async isExtensionCompatible(q,x,ne,oe={version:this.w.version,date:this.w.date}){if(!(0,c.$ip)(q.properties.targetPlatform,q.allTargetPlatforms,ne)||!x&&q.properties.isPreReleaseVersion)return!1;let ce=q.properties.engine;if(!ce){const ve=await this.getManifest(q,P.CancellationToken.None);if(!ve)throw new Error("Manifest was not found");ce=ve.engines.vscode}return!(!(0,p.$5p)(ce,oe.version,oe.date)||!this.z(q.identifier,q.properties.enabledApiProposals))}z(q,x){return!x||!this.k.includes(q.id.toLowerCase())?!0:(0,p.$6p)(x)}async A(q,x,ne,oe,ce,ve,fe={version:this.w.version,date:this.w.date}){if(!(0,c.$ip)(ie(x),ce,ve)||ne!=="any"&&de(x)!==(ne==="prerelease"))return!1;if(oe)try{const $e=await this.G(q,x);if(!(0,p.$5p)($e,fe.version,fe.date))return!1}catch($e){return this.n.error(`Error while getting the engine for the version ${x.version}.`,(0,v.$9)($e)),!1}return!0}async query(q,x){let ne=q.text||"";const oe=q.pageSize??50;let ce=new A().withPage(1,oe);ne?(ne=ne.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,Ee)=>(ce=ce.withFilter(o.Category,Ee||ge),"")),ne=ne.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,Ee)=>(ce=ce.withFilter(o.Tag,Ee||ge),"")),ne=ne.replace(/\bfeatured(\s+|\b|$)/g,()=>(ce=ce.withFilter(o.Featured),"")),ne=ne.trim(),ne&&(ne=ne.length<200?ne:ne.substring(0,200),ce=ce.withFilter(o.SearchText,ne)),ce=ce.withSortBy(c.SortBy.NoneOrRelevance)):q.ids?ce=ce.withFilter(o.ExtensionId,...q.ids):q.names?ce=ce.withFilter(o.ExtensionName,...q.names):ce=ce.withSortBy(c.SortBy.InstallCount),typeof q.sortBy=="number"&&(ce=ce.withSortBy(q.sortBy)),typeof q.sortOrder=="number"&&(ce=ce.withSortOrder(q.sortOrder)),q.source&&(ce=ce.withSource(q.source));const ve=async(me,ge)=>{const{extensions:Ee,total:V}=await this.B(me,{targetPlatform:n,compatible:!1,includePreRelease:!!q.includePreRelease,productVersion:q.productVersion??{version:this.w.version,date:this.w.date}},ge);return Ee.forEach((_,ee)=>W(_,(me.pageNumber-1)*me.pageSize+ee,q.source)),{extensions:Ee,total:V}},{extensions:fe,total:$e}=await ve(ce,x),pe=async(me,ge)=>{if(ge.isCancellationRequested)throw new v.$4;const{extensions:Ee}=await ve(ce.withPage(me+1),ge);return Ee};return{firstPage:fe,total:$e,pageSize:ce.pageSize,getPage:pe}}async B(q,x,ne){const oe=q.flags;q.flags&t.IncludeLatestVersionOnly&&q.flags&t.IncludeVersions&&(q=q.withFlags(q.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(q.flags&t.IncludeLatestVersionOnly)&&!(q.flags&t.IncludeVersions)&&(q=q.withFlags(q.flags,t.IncludeLatestVersionOnly)),x.versions?.length&&(q=q.withFlags(q.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),q=q.withFlags(q.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ce,total:ve,context:fe}=await this.D(q,ne);if(!(q.flags&t.IncludeLatestVersionOnly)){const ge=[];for(const Ee of ce){const V=await this.C(Ee,x,fe);V&&ge.push(V)}return{extensions:ge,total:ve}}const pe=[],me=new Map;for(let ge=0;ge<ce.length;ge++){const Ee=ce[ge],V={id:(0,m.$Qp)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},_=(0,O.$kg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(we=>(0,m.$Lp)(we,V))?.includePreRelease;if(x.compatible&&(0,c.$hp)(se(Ee),x.targetPlatform))continue;const ee=await this.C(Ee,x,fe);!ee||ee.properties.isPreReleaseVersion&&(!_||!ee.hasReleaseVersion)||!ee.properties.isPreReleaseVersion&&ee.properties.targetPlatform!==x.targetPlatform&&ee.hasPreReleaseVersion?me.set(Ee.extensionId,ge):pe.push([ge,ee])}if(me.size){const ge=new l.$fe,Ee=new A().withFlags(oe&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,me.size).withFilter(o.ExtensionId,...me.keys()),{extensions:V}=await this.B(Ee,x,ne);this.q.publicLog2("galleryService:additionalQuery",{duration:ge.elapsed(),count:me.size});for(const _ of V){const ee=me.get(_.identifier.uuid);pe.push([ee,_])}}return{extensions:pe.sort((ge,Ee)=>ge[0]-Ee[0]).map(([,ge])=>ge),total:ve}}async C(q,x,ne){const oe={id:(0,m.$Qp)(q.publisher.publisherName,q.extensionName),uuid:q.extensionId},ce=x.versions?.find(pe=>(0,m.$Lp)(pe,oe))?.version,ve=(0,O.$kg)(x.includePreRelease)?x.includePreRelease:!!x.includePreRelease.find(pe=>(0,m.$Lp)(pe,oe))?.includePreRelease,fe=se(q),$e=T(q.versions,x.targetPlatform);if(x.compatible&&(0,c.$hp)(fe,x.targetPlatform))return null;for(let pe=0;pe<$e.length;pe++){const me=$e[pe];if(!(ce&&me.version!==ce)){if(await this.A(oe.id,me,ve?"any":"release",x.compatible,fe,x.targetPlatform,x.productVersion))return x.compatible&&!this.z(oe,Z(me))?null:z(q,me,fe,ne);if(ce&&me.version===ce)return null}}return ce||x.compatible?null:z(q,q.versions[0],fe)}async D(q,x){if(!this.isEnabled())throw new Error("No extension gallery service configured.");q=q.withFlags(q.flags,t.ExcludeNonValidated).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExcludeWithFlags,r(t.Unpublished));const ne=await this.j,oe=JSON.stringify(q.raw),ce={...ne,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(oe.length)},ve=new l.$fe;let fe,$e,pe=0;try{if(fe=await this.l.request({type:"POST",url:this.g&&q.criteria.some(ge=>ge.filterType===o.SearchText)?this.g:this.y("/extensionquery"),data:oe,headers:ce},x),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:pe};const me=await(0,g.$aq)(fe);if(me){const ge=me.results[0],Ee=ge.extensions,V=ge.resultMetadata&&ge.resultMetadata.filter(_=>_.metadataType==="ResultCount")[0];return pe=V&&V.metadataItems.filter(_=>_.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:pe,context:fe.res.headers.activityid?{[s]:fe.res.headers.activityid}:{}}}return{galleryExtensions:[],total:pe}}catch(me){if((0,v.$3)(me))throw $e=c.ExtensionGalleryErrorCode.Cancelled,me;{const ge=(0,v.$9)(me);throw $e=ge.startsWith("XHR timeout")?c.ExtensionGalleryErrorCode.Timeout:c.ExtensionGalleryErrorCode.Failed,new c.$lp(ge,$e)}}finally{this.q.publicLog2("galleryService:query",{...q.telemetryData,requestBodySize:String(oe.length),duration:ve.elapsed(),success:!!fe&&(0,g.$9p)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:$e,count:String(pe)})}}async reportStatistic(q,x,ne,oe){if(!this.isEnabled())return;const ce=k.$p?this.y(`/itemName/${q}.${x}/version/${ne}/statType/${oe===c.StatisticType.Install?"1":"3"}/vscodewebextension`):this.y(`/publishers/${q}/extensions/${x}/${ne}/stats?statType=${oe}`),ve=k.$p?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",$e={...await this.j,Accept:ve};try{await this.l.request({type:"POST",url:ce,headers:$e},P.CancellationToken.None)}catch{}}async download(q,x,ne){this.n.trace("ExtensionGalleryService#download",q.identifier.id);const oe=(0,m.$Tp)(q),ce=new Date().getTime(),ve=ne===c.InstallOperation.Install?"install":ne===c.InstallOperation.Update?"update":"",fe=ve?{uri:`${q.assets.download.uri}${w.URI.parse(q.assets.download.uri).query?"&":"?"}${ve}=true`,fallbackUri:`${q.assets.download.fallbackUri}${w.URI.parse(q.assets.download.fallbackUri).query?"&":"?"}${ve}=true`}:q.assets.download,$e=q.queryContext?.[s]?{[s]:q.queryContext[s]}:void 0,pe=await this.F(q.identifier.id,fe,u.VSIX,$e?{headers:$e}:void 0);try{await this.u.writeFile(x,pe.stream)}catch(me){try{await this.u.del(x)}catch(ge){this.n.warn(`Error while deleting the file ${x.toString()}`,(0,v.$9)(ge))}throw new c.$lp((0,v.$9)(me),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}this.q.publicLog("galleryService:downloadVSIX",{...oe,duration:new Date().getTime()-ce})}async downloadSignatureArchive(q,x){if(!q.assets.signature)throw new Error("No signature asset found");this.n.trace("ExtensionGalleryService#downloadSignatureArchive",q.identifier.id);const ne=await this.F(q.identifier.id,q.assets.signature,u.Signature);try{await this.u.writeFile(x,ne.stream)}catch(oe){try{await this.u.del(x)}catch(ce){this.n.warn(`Error while deleting the file ${x.toString()}`,(0,v.$9)(ce))}throw new c.$lp((0,v.$9)(oe),c.ExtensionGalleryErrorCode.DownloadFailedWriting)}}async getReadme(q,x){if(q.assets.readme){const ne=await this.F(q.identifier.id,q.assets.readme,u.Details,{},x);return await(0,g.$_p)(ne)||""}return""}async getManifest(q,x){if(q.assets.manifest){const ne=await this.F(q.identifier.id,q.assets.manifest,u.Manifest,{},x),oe=await(0,g.$_p)(ne);return oe?JSON.parse(oe):null}return null}async E(q,x,ne){const oe=te(x,u.Manifest);if(!oe)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},ve=await this.F(q,oe,u.Manifest,{headers:ce});return await(0,g.$aq)(ve)}async getCoreTranslation(q,x){const ne=q.assets.coreTranslations.filter(oe=>oe[0]===x.toUpperCase())[0];if(ne){const oe=await this.F(q.identifier.id,ne[1],ne[0]),ce=await(0,g.$_p)(oe);return ce?JSON.parse(ce):null}return null}async getChangelog(q,x){if(q.assets.changelog){const ne=await this.F(q.identifier.id,q.assets.changelog,u.Changelog,{},x);return await(0,g.$_p)(ne)||""}return""}async getAllCompatibleVersions(q,x,ne){let oe=new A().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);q.uuid?oe=oe.withFilter(o.ExtensionId,q.uuid):oe=oe.withFilter(o.ExtensionName,q.id);const{galleryExtensions:ce}=await this.D(oe,P.CancellationToken.None);if(!ce.length)return[];const ve=se(ce[0]);if((0,c.$hp)(ve,ne))return[];const fe=[];await Promise.all(ce[0].versions.map(async me=>{try{await this.A(q.id,me,x?"any":"release",!0,ve,ne)&&this.z(q,Z(me))&&fe.push(me)}catch{}}));const $e=[],pe=new Set;for(const me of T(fe,ne))pe.has(me.version)||(pe.add(me.version),$e.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:de(me)}));return $e}async F(q,x,ne,oe={},ce=P.CancellationToken.None){const ve=await this.j,fe={type:"GET"},$e={...ve,...oe.headers||{}};oe={...oe,...fe,headers:$e};const pe=x.uri,me=x.fallbackUri,ge={...oe,url:pe};try{const Ee=await this.l.request(ge,ce);if(Ee.res.statusCode===200)return Ee;const V=await(0,g.$_p)(Ee);throw new Error(`Expected 200, got back ${Ee.res.statusCode} instead.

${V}`)}catch(Ee){if((0,v.$3)(Ee))throw Ee;const V=(0,v.$9)(Ee);this.q.publicLog2("galleryService:cdnFallback",{extension:q,assetType:ne,message:V});const _={...oe,url:me};return this.l.request(_,ce)}}async G(q,x){let ne=le(x);if(!ne){this.q.publicLog2("galleryService:engineFallback",{extension:q,version:x.version});const oe=await this.E(q,x,P.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ne=oe.engines.vscode}return ne}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const q=await this.l.request({type:"GET",url:this.h},P.CancellationToken.None);if(q.res.statusCode!==200)throw new Error("Could not get extensions report.");const x=await(0,g.$aq)(q),ne=[],oe={},ce=[],ve=[];if(x){for(const fe of x.malicious)ne.push({id:fe});if(x.migrateToPreRelease)for(const[fe,$e]of Object.entries(x.migrateToPreRelease))(!$e.engine||(0,p.$5p)($e.engine,this.w.version,this.w.date))&&(oe[fe.toLowerCase()]={disallowInstall:!0,extension:{id:$e.id,displayName:$e.displayName,autoMigrate:{storage:!!$e.migrateStorage},preRelease:!0}});if(x.deprecated)for(const[fe,$e]of Object.entries(x.deprecated))$e&&(oe[fe.toLowerCase()]=(0,O.$kg)($e)?{}:$e);if(x.search)for(const fe of x.search)ce.push(fe);if(Array.isArray(x.extensionsEnabledWithPreRelease))for(const fe of x.extensionsEnabledWithPreRelease)ve.push(fe.toLowerCase())}return{malicious:ne,deprecated:oe,search:ce,extensionsEnabledWithPreRelease:ve}}};E=be([re(1,g.$7p),re(2,b.$_j),re(3,f.$Li),re(4,i.$$l),re(5,I.$_k),re(6,h.$sk),re(7,a.$$i)],E);let j=class extends E{constructor(q,x,ne,oe,ce,ve,fe,$e){super(q,x,ne,oe,ce,ve,fe,$e)}};e.$qq=j,e.$qq=j=be([re(0,y.$hq),re(1,g.$7p),re(2,b.$_j),re(3,f.$Li),re(4,i.$$l),re(5,I.$_k),re(6,h.$sk),re(7,a.$$i)],j);let X=class extends E{constructor(q,x,ne,oe,ce,ve,fe){super(void 0,q,x,ne,oe,ce,ve,fe)}};e.$rq=X,e.$rq=X=be([re(0,g.$7p),re(1,b.$_j),re(2,f.$Li),re(3,i.$$l),re(4,I.$_k),re(5,h.$sk),re(6,a.$$i)],X)}),define(ue[144],he([0,1,11,17,9,6,123,23,24,3,69]),function(Y,e,S,P,v,k,L,O,w,a,f){"use strict";var c,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$HR=e.$GR=e.$FR=void 0;let d=class extends w.$Ol{static{c=this}static{this.a="profileAssociationsMigration"}constructor(h,g,R,y,i){super(R,y,g,i),this.U=h,this.W=R}O(){return this.U.getItem(c.b,[]).map(g=>({...g,location:(0,a.$eg)(g.location)?this.w.extUri.joinPath(this.profilesHome,g.location):S.URI.revive(g.location)}))}Q(){const h=this.U.getItem(c.c,{});return this.U.getItem(c.a,!1)?h:this.N(h)}S(){return this.w.extUri.joinPath(S.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$FR=d,e.$FR=d=c=be([re(0,L.$AR),re(1,O.$Jl),re(2,P.$Mi),re(3,v.$_k),re(4,k.$_j)],d);let p=m=class extends d{constructor(h,g,R,y,i){super(h,g,R,y,i),this.$=h}P(h){h.length?this.$.setItem(m.b,h.map(g=>({...g,location:this.w.extUri.basename(g.location)}))):this.$.removeItem(m.b)}O(){const h=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(h),this.$.setItem("userDataProfilesMigration",!0)),h}R(h){h.emptyWindows||h.workspaces?this.$.setItem(m.c,h):this.$.removeItem(m.c)}Q(){const h="workspaceAndProfileInfo",g=this.$.getItem(h,void 0);if(g){this.$.removeItem(h);const y=g.reduce((i,{workspace:l,profile:n})=>(i[S.URI.revive(l).toString()]=S.URI.revive(n).toString(),i),{});this.$.setItem(m.c,{workspaces:y})}const R=super.Q();return this.$.getItem(m.a,!1)||(this.R(R),this.$.setItem(m.a,!0)),R}};e.$GR=p,e.$GR=p=m=be([re(0,L.$BR),re(1,O.$Jl),re(2,P.$Mi),re(3,v.$_k),re(4,k.$_j)],p);let I=class extends p{constructor(h,g,R,y){super(new f.$ER(f.SaveStrategy.IMMEDIATE,g,y,R),h,g,R,y)}async init(){return await this.$.init(),super.init()}};e.$HR=I,e.$HR=I=be([re(0,O.$Jl),re(1,P.$Mi),re(2,v.$_k),re(3,k.$_j)],I)}),define(ue[145],he([0,1,121,8,13,7,3,30,17,122,6,46,120,156]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0,e.$fs=b;let p=class extends c.$8p{constructor(g,R,y,i){super(i),this.m=g,this.n=R,this.r=y,this.s(),this.B(g.onDidChangeConfiguration(l=>{l.affectsConfiguration("http")&&this.s()}))}s(){const g=this.m.getValue("http");this.f=g?.proxy,this.g=!!g?.proxyStrictSSL,this.h=g?.proxyAuthorization}async request(g,R){const{f:y,g:i}=this;let l;try{l=await(0,a.$Qm)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,k.$9)(t)))}const n={...process.env,...l},s=g.agent?g.agent:await(0,m.$ds)(g.url||"",n,{proxyUrl:y,strictSSL:i});return g.agent=s,g.strictSSL=i,this.h&&(g.headers={...g.headers||{},"Proxy-Authorization":this.h}),this.c(g.isChromiumNetwork?"electron":"node",g,()=>b(g,R))}async resolveProxy(g){}async lookupAuthorization(g){}async lookupKerberosAuthorization(g){try{const R=await new Promise((s,t)=>{Y(["kerberos"],s,t)}).then(ye),y=new URL(g),i=this.m.getValue("http.proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${y.hostname}`:`HTTP@${y.hostname}`);return this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication lookup",`proxyURL:${y}`,`spn:${i}`),"Negotiate "+await(await R.initializeClient(i)).step("")}catch(R){this.r.debug("RequestService#lookupKerberosAuthorization Kerberos authentication failed",R);return}}async loadCertificates(){return(await new Promise((R,y)=>{Y(["@vscode/proxy-agent"],R,y)}).then(ye)).loadSystemCertificates({log:this.r})}};e.$es=p,e.$es=p=be([re(0,O.$$i),re(1,w.$Mi),re(2,f.$_j),re(3,f.$ak)],p);async function I(h){return((0,S.parse)(h.url).protocol==="https:"?await new Promise((y,i)=>{Y(["https"],y,i)}).then(ye):await new Promise((y,i)=>{Y(["http"],y,i)}).then(ye)).request}async function b(h,g){return P.Promises.withAsyncBody(async(R,y)=>{const i=(0,S.parse)(h.url),l=h.getRawRequest?h.getRawRequest(h):await I(h),n={hostname:i.hostname,port:i.port?parseInt(i.port):i.protocol==="https:"?443:80,protocol:i.protocol,path:i.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,L.$kg)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(n.auth=h.user+":"+h.password);const s=l(n,t=>{const r=(0,L.$ig)(h.followRedirects)?h.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&r>0&&t.headers.location)b({...h,url:t.headers.location,followRedirects:r-1},g).then(R,y);else{let o=t;!h.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,d.createGunzip)())),R({res:t,stream:(0,v.$3e)(o)})}});s.on("error",y),h.timeout&&s.setTimeout(h.timeout),h.isChromiumNetwork&&s.removeHeader("Content-Length"),h.data&&typeof h.data=="string"&&s.write(h.data),s.end(),g.onCancellationRequested(()=>{s.abort(),y(new k.$4)})})}});var Me=this&&this.__importDefault||function(Y){return Y&&Y.__esModule?Y:{default:Y}};define(ue[157],he([0,1,32,35,8,38,7,2,14,15,12,36,11,30,117,61,119,17,95,143,20,71,124,42,54,138,140,9,107,109,51,105,64,68,126,6,113,39,114,129,33,46,145,69,70,18,128,41,130,131,23,133,24,144,132,139,110,112,5,134,158]),function(Y,e,S,P,v,k,L,O,w,a,f,c,m,d,p,I,b,h,g,R,y,i,l,n,s,t,r,o,u,$,N,C,A,D,U,G,Q,te,ae,le,de,H,Z,B,M,J,K,ie,se,T,W,z,E,j,X,F,q,x,ne,oe,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe,S=ye(S),le=Me(le);class ve extends O.$Uc{constructor(pe){super(),this.b=pe,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[pe,me]=await this.f();return pe.invokeFunction(async ge=>{const Ee=ge.get(G.$_j),V=ge.get(o.$_k),_=ge.get(h.$Mi),ee=ge.get(E.$Ll);Ee.info("CLI main",this.b),this.h(Ee),await this.j(_,V,ee,pe),await Promise.all(me.map(we=>{(0,v.$vh)(we.flush(),1e3)}))})}async f(){const pe=new A.$Ci,me={_serviceBrand:void 0,...le.default};pe.set(de.$sk,me);const ge=new g.$8m(this.b,me);pe.set(h.$Mi,ge),await Promise.all([this.g(ge.appSettingsHome.with({scheme:w.Schemas.file}).fsPath),this.g(ge.extensionsPath)].map(Ie=>Ie?S.promises.mkdir(Ie,{recursive:!0}):void 0));const Ee=new x.$zR((0,G.$nk)(ge),ge.logsHome);pe.set(G.$ak,Ee);const V=this.B(Ee.createLogger("cli",{name:(0,ne.localize)(12920,null)})),_=[];Ee.getLogLevel()===G.LogLevel.Trace&&_.push(new G.$hk(Ee.getLogLevel()));const ee=this.B(new q.$JR(V,_));pe.set(G.$_j,ee);const we=this.B(new u.$2q(ee));pe.set(o.$_k,we);const Se=this.B(new $.$sr(ee));we.registerProvider(w.Schemas.file,Se);const De=new z.$Ts(we);pe.set(W.$Jl,De);const ke=new B.$DR(B.SaveStrategy.DELAYED,ge,ee,we),Ce=new j.$FR(ke,De,ge,we,ee);pe.set(E.$Ll,Ce),we.registerProvider(w.Schemas.vscodeUserData,new oe.$Shc(w.Schemas.file,Se,w.Schemas.vscodeUserData,Ce,De,ee));const Re=f.$j&&me.win32RegValueName?this.B(new ae.$Qhc(ee,me.win32RegValueName)):ge.policyFile?this.B(new Q.$Rhc(ge.policyFile,we,ee)):new te.$uo;pe.set(te.$so,Re);const Le=this.B(new p.$Wo(Ce.defaultProfile.settingsResource,we,Re,ee));pe.set(d.$$i,Le),await Promise.all([ke.init(),Le.initialize()]);let qe;try{qe=await(0,X.$shc)(ke,ee)}catch(Ie){Ie.code!=="ENOENT"&&ee.error(Ie)}const Ae=await(0,X.$thc)(ke,ee),Te=await(0,X.$uhc)(ke,ee);Ce.init(),pe.set(W.$Jl,new z.$Ts(we));const Fe=new Z.$es(Le,ge,ee,Ee);pe.set(H.$7p,Fe),pe.set(I.$1o,new N.$Bi(b.$YR,void 0,!0)),pe.set(n.$Iq,new N.$Bi(F.$IR,void 0,!0)),pe.set(s.$Mq,new N.$Bi(r.$phc,void 0,!0)),pe.set(i.$sq,new N.$Bi(i.$uq,void 0,!0)),pe.set(t.$Xq,new N.$Bi(t.$Yq,void 0,!0)),pe.set(y.$kp,new N.$Bi(R.$rq,void 0,!0)),pe.set(D.$$r,new N.$Bi(U.$as,void 0,!1));const Ue=[],Pe=(0,ie.$Ip)(me,Le);if((0,ie.$Dp)(me,ge)){me.aiConfig&&me.aiConfig.ariaKey&&Ue.push(new se.$xR(Fe,Pe,"monacoworkbench",null,me.aiConfig.ariaKey));const Ie={appenders:Ue,sendErrorTelemetry:!1,commonProperties:(0,M.$up)((0,P.release)(),(0,P.hostname)(),process.arch,me.commit,me.version,qe,Ae,Te,Pe),piiPaths:(0,ie.$Jp)(ge)};pe.set(J.$$l,new N.$Bi(K.$gs,[Ie],!1))}else pe.set(J.$$l,ie.$yp);return[new C.$vr(pe),Ue]}g(pe){if(f.$j){const me=(0,ce.getUNCHost)(pe);me&&(0,ce.addUNCHostToAllowlist)(me)}return pe}h(pe){(0,L.setUnexpectedErrorHandler)(me=>{const ge=(0,k.$pj)(me,!0);ge&&pe.error(`[uncaught exception in CLI]: ${ge}`)}),process.on("uncaughtException",me=>{(0,L.$X)(me)||(0,L.$Y)(me)}),process.on("unhandledRejection",me=>(0,L.$Y)(me))}async j(pe,me,ge,Ee){let V;if(pe.args.profile&&(V=ge.profiles.find(ee=>ee.name===pe.args.profile),!V))throw new Error(`Profile '${pe.args.profile}' not found.`);const _=(V??ge.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Ee.createInstance(l.$vq,new G.$hk(G.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,_);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:_};return Ee.createInstance(l.$vq,new G.$hk(G.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ee.createInstance(l.$vq,new G.$hk(G.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,_);if(this.b["update-extensions"])return Ee.createInstance(l.$vq,new G.$hk(G.LogLevel.Info,!1)).updateExtensions(_);if(this.b["locate-extension"])return Ee.createInstance(l.$vq,new G.$hk(G.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,T.$8hc)(pe.appRoot,pe.extensionsPath))}}m(pe){return pe.map(me=>/\.vsix$/i.test(me)?m.URI.file((0,a.$ic)(me)?me:(0,a.$jc)((0,c.cwd)(),me)):me)}}async function fe($e){const pe=new ve($e);try{await pe.run()}finally{pe.dispose()}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/22e3447b4b410dcf8426bf70743c5dd4030d6122/core/vs/code/node/cliProcessMain.js.map
