/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var he=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/base/common/strings","vs/base/common/async","vs/nls","vs/base/common/charCode","vs/base/common/decorators","vs/base/common/process","vs/platform/terminal/common/terminal","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/platform/terminal/common/capabilities/capabilities","vs/base/common/lazy","vs/base/common/resources","vs/base/common/map","vs/base/common/marshallingIds","vs/base/node/pfs","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/functional","vs/base/common/processes","vs/base/common/objects","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/sandbox/node/electronTypes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/symbols","vs/base/common/uint","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/uuid","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/base/common/date","vs/base/common/errorMessage","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","util","minimist","node-pty","vs/base/common/performance","@xterm/headless","vs/platform/terminal/node/ptyHostMain"],fe=function(ie){for(var e=[],c=0,t=ie.length;c<t;c++)e[c]=he[ie[c]];return e};define(he[43],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lb=void 0,e.$eb=c,e.$fb=t,e.$gb=S,e.$hb=w,e.$ib=B,e.$jb=A,e.$kb=$,e.$mb=L,e.$nb=b,e.$ob=d,e.$pb=u,e.$qb=a;function c(h,f){const l=t(h,f);if(l!==-1)return h[l]}function t(h,f,l=h.length-1){for(let s=l;s>=0;s--){const p=h[s];if(f(p))return s}return-1}function S(h,f){const l=w(h,f);return l===-1?void 0:h[l]}function w(h,f,l=0,s=h.length){let p=l,E=s;for(;p<E;){const n=Math.floor((p+E)/2);f(h[n])?p=n+1:E=n}return p-1}function B(h,f){const l=A(h,f);return l===h.length?void 0:h[l]}function A(h,f,l=0,s=h.length){let p=l,E=s;for(;p<E;){const n=Math.floor((p+E)/2);f(h[n])?E=n:p=n+1}return p}function $(h,f,l=0,s=h.length){const p=A(h,f,l,s);return p===h.length?-1:p}class r{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(r.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!f(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const l=w(this.e,f,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}e.$lb=r;function L(h,f){if(h.length===0)return;let l=h[0];for(let s=1;s<h.length;s++){const p=h[s];f(p,l)>0&&(l=p)}return l}function b(h,f){if(h.length===0)return;let l=h[0];for(let s=1;s<h.length;s++){const p=h[s];f(p,l)>=0&&(l=p)}return l}function d(h,f){return L(h,(l,s)=>-f(l,s))}function u(h,f){if(h.length===0)return-1;let l=0;for(let s=1;s<h.length;s++){const p=h[s];f(p,h[l])>0&&(l=s)}return l}function a(h,f){for(const l of h){const s=f(l);if(s!==void 0)return s}}}),define(he[13],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharCode=void 0;var c;(function(t){t[t.Null=0]="Null",t[t.Backspace=8]="Backspace",t[t.Tab=9]="Tab",t[t.LineFeed=10]="LineFeed",t[t.CarriageReturn=13]="CarriageReturn",t[t.Space=32]="Space",t[t.ExclamationMark=33]="ExclamationMark",t[t.DoubleQuote=34]="DoubleQuote",t[t.Hash=35]="Hash",t[t.DollarSign=36]="DollarSign",t[t.PercentSign=37]="PercentSign",t[t.Ampersand=38]="Ampersand",t[t.SingleQuote=39]="SingleQuote",t[t.OpenParen=40]="OpenParen",t[t.CloseParen=41]="CloseParen",t[t.Asterisk=42]="Asterisk",t[t.Plus=43]="Plus",t[t.Comma=44]="Comma",t[t.Dash=45]="Dash",t[t.Period=46]="Period",t[t.Slash=47]="Slash",t[t.Digit0=48]="Digit0",t[t.Digit1=49]="Digit1",t[t.Digit2=50]="Digit2",t[t.Digit3=51]="Digit3",t[t.Digit4=52]="Digit4",t[t.Digit5=53]="Digit5",t[t.Digit6=54]="Digit6",t[t.Digit7=55]="Digit7",t[t.Digit8=56]="Digit8",t[t.Digit9=57]="Digit9",t[t.Colon=58]="Colon",t[t.Semicolon=59]="Semicolon",t[t.LessThan=60]="LessThan",t[t.Equals=61]="Equals",t[t.GreaterThan=62]="GreaterThan",t[t.QuestionMark=63]="QuestionMark",t[t.AtSign=64]="AtSign",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.OpenSquareBracket=91]="OpenSquareBracket",t[t.Backslash=92]="Backslash",t[t.CloseSquareBracket=93]="CloseSquareBracket",t[t.Caret=94]="Caret",t[t.Underline=95]="Underline",t[t.BackTick=96]="BackTick",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.OpenCurlyBrace=123]="OpenCurlyBrace",t[t.Pipe=124]="Pipe",t[t.CloseCurlyBrace=125]="CloseCurlyBrace",t[t.Tilde=126]="Tilde",t[t.NoBreakSpace=160]="NoBreakSpace",t[t.U_Combining_Grave_Accent=768]="U_Combining_Grave_Accent",t[t.U_Combining_Acute_Accent=769]="U_Combining_Acute_Accent",t[t.U_Combining_Circumflex_Accent=770]="U_Combining_Circumflex_Accent",t[t.U_Combining_Tilde=771]="U_Combining_Tilde",t[t.U_Combining_Macron=772]="U_Combining_Macron",t[t.U_Combining_Overline=773]="U_Combining_Overline",t[t.U_Combining_Breve=774]="U_Combining_Breve",t[t.U_Combining_Dot_Above=775]="U_Combining_Dot_Above",t[t.U_Combining_Diaeresis=776]="U_Combining_Diaeresis",t[t.U_Combining_Hook_Above=777]="U_Combining_Hook_Above",t[t.U_Combining_Ring_Above=778]="U_Combining_Ring_Above",t[t.U_Combining_Double_Acute_Accent=779]="U_Combining_Double_Acute_Accent",t[t.U_Combining_Caron=780]="U_Combining_Caron",t[t.U_Combining_Vertical_Line_Above=781]="U_Combining_Vertical_Line_Above",t[t.U_Combining_Double_Vertical_Line_Above=782]="U_Combining_Double_Vertical_Line_Above",t[t.U_Combining_Double_Grave_Accent=783]="U_Combining_Double_Grave_Accent",t[t.U_Combining_Candrabindu=784]="U_Combining_Candrabindu",t[t.U_Combining_Inverted_Breve=785]="U_Combining_Inverted_Breve",t[t.U_Combining_Turned_Comma_Above=786]="U_Combining_Turned_Comma_Above",t[t.U_Combining_Comma_Above=787]="U_Combining_Comma_Above",t[t.U_Combining_Reversed_Comma_Above=788]="U_Combining_Reversed_Comma_Above",t[t.U_Combining_Comma_Above_Right=789]="U_Combining_Comma_Above_Right",t[t.U_Combining_Grave_Accent_Below=790]="U_Combining_Grave_Accent_Below",t[t.U_Combining_Acute_Accent_Below=791]="U_Combining_Acute_Accent_Below",t[t.U_Combining_Left_Tack_Below=792]="U_Combining_Left_Tack_Below",t[t.U_Combining_Right_Tack_Below=793]="U_Combining_Right_Tack_Below",t[t.U_Combining_Left_Angle_Above=794]="U_Combining_Left_Angle_Above",t[t.U_Combining_Horn=795]="U_Combining_Horn",t[t.U_Combining_Left_Half_Ring_Below=796]="U_Combining_Left_Half_Ring_Below",t[t.U_Combining_Up_Tack_Below=797]="U_Combining_Up_Tack_Below",t[t.U_Combining_Down_Tack_Below=798]="U_Combining_Down_Tack_Below",t[t.U_Combining_Plus_Sign_Below=799]="U_Combining_Plus_Sign_Below",t[t.U_Combining_Minus_Sign_Below=800]="U_Combining_Minus_Sign_Below",t[t.U_Combining_Palatalized_Hook_Below=801]="U_Combining_Palatalized_Hook_Below",t[t.U_Combining_Retroflex_Hook_Below=802]="U_Combining_Retroflex_Hook_Below",t[t.U_Combining_Dot_Below=803]="U_Combining_Dot_Below",t[t.U_Combining_Diaeresis_Below=804]="U_Combining_Diaeresis_Below",t[t.U_Combining_Ring_Below=805]="U_Combining_Ring_Below",t[t.U_Combining_Comma_Below=806]="U_Combining_Comma_Below",t[t.U_Combining_Cedilla=807]="U_Combining_Cedilla",t[t.U_Combining_Ogonek=808]="U_Combining_Ogonek",t[t.U_Combining_Vertical_Line_Below=809]="U_Combining_Vertical_Line_Below",t[t.U_Combining_Bridge_Below=810]="U_Combining_Bridge_Below",t[t.U_Combining_Inverted_Double_Arch_Below=811]="U_Combining_Inverted_Double_Arch_Below",t[t.U_Combining_Caron_Below=812]="U_Combining_Caron_Below",t[t.U_Combining_Circumflex_Accent_Below=813]="U_Combining_Circumflex_Accent_Below",t[t.U_Combining_Breve_Below=814]="U_Combining_Breve_Below",t[t.U_Combining_Inverted_Breve_Below=815]="U_Combining_Inverted_Breve_Below",t[t.U_Combining_Tilde_Below=816]="U_Combining_Tilde_Below",t[t.U_Combining_Macron_Below=817]="U_Combining_Macron_Below",t[t.U_Combining_Low_Line=818]="U_Combining_Low_Line",t[t.U_Combining_Double_Low_Line=819]="U_Combining_Double_Low_Line",t[t.U_Combining_Tilde_Overlay=820]="U_Combining_Tilde_Overlay",t[t.U_Combining_Short_Stroke_Overlay=821]="U_Combining_Short_Stroke_Overlay",t[t.U_Combining_Long_Stroke_Overlay=822]="U_Combining_Long_Stroke_Overlay",t[t.U_Combining_Short_Solidus_Overlay=823]="U_Combining_Short_Solidus_Overlay",t[t.U_Combining_Long_Solidus_Overlay=824]="U_Combining_Long_Solidus_Overlay",t[t.U_Combining_Right_Half_Ring_Below=825]="U_Combining_Right_Half_Ring_Below",t[t.U_Combining_Inverted_Bridge_Below=826]="U_Combining_Inverted_Bridge_Below",t[t.U_Combining_Square_Below=827]="U_Combining_Square_Below",t[t.U_Combining_Seagull_Below=828]="U_Combining_Seagull_Below",t[t.U_Combining_X_Above=829]="U_Combining_X_Above",t[t.U_Combining_Vertical_Tilde=830]="U_Combining_Vertical_Tilde",t[t.U_Combining_Double_Overline=831]="U_Combining_Double_Overline",t[t.U_Combining_Grave_Tone_Mark=832]="U_Combining_Grave_Tone_Mark",t[t.U_Combining_Acute_Tone_Mark=833]="U_Combining_Acute_Tone_Mark",t[t.U_Combining_Greek_Perispomeni=834]="U_Combining_Greek_Perispomeni",t[t.U_Combining_Greek_Koronis=835]="U_Combining_Greek_Koronis",t[t.U_Combining_Greek_Dialytika_Tonos=836]="U_Combining_Greek_Dialytika_Tonos",t[t.U_Combining_Greek_Ypogegrammeni=837]="U_Combining_Greek_Ypogegrammeni",t[t.U_Combining_Bridge_Above=838]="U_Combining_Bridge_Above",t[t.U_Combining_Equals_Sign_Below=839]="U_Combining_Equals_Sign_Below",t[t.U_Combining_Double_Vertical_Line_Below=840]="U_Combining_Double_Vertical_Line_Below",t[t.U_Combining_Left_Angle_Below=841]="U_Combining_Left_Angle_Below",t[t.U_Combining_Not_Tilde_Above=842]="U_Combining_Not_Tilde_Above",t[t.U_Combining_Homothetic_Above=843]="U_Combining_Homothetic_Above",t[t.U_Combining_Almost_Equal_To_Above=844]="U_Combining_Almost_Equal_To_Above",t[t.U_Combining_Left_Right_Arrow_Below=845]="U_Combining_Left_Right_Arrow_Below",t[t.U_Combining_Upwards_Arrow_Below=846]="U_Combining_Upwards_Arrow_Below",t[t.U_Combining_Grapheme_Joiner=847]="U_Combining_Grapheme_Joiner",t[t.U_Combining_Right_Arrowhead_Above=848]="U_Combining_Right_Arrowhead_Above",t[t.U_Combining_Left_Half_Ring_Above=849]="U_Combining_Left_Half_Ring_Above",t[t.U_Combining_Fermata=850]="U_Combining_Fermata",t[t.U_Combining_X_Below=851]="U_Combining_X_Below",t[t.U_Combining_Left_Arrowhead_Below=852]="U_Combining_Left_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_Below=853]="U_Combining_Right_Arrowhead_Below",t[t.U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below=854]="U_Combining_Right_Arrowhead_And_Up_Arrowhead_Below",t[t.U_Combining_Right_Half_Ring_Above=855]="U_Combining_Right_Half_Ring_Above",t[t.U_Combining_Dot_Above_Right=856]="U_Combining_Dot_Above_Right",t[t.U_Combining_Asterisk_Below=857]="U_Combining_Asterisk_Below",t[t.U_Combining_Double_Ring_Below=858]="U_Combining_Double_Ring_Below",t[t.U_Combining_Zigzag_Above=859]="U_Combining_Zigzag_Above",t[t.U_Combining_Double_Breve_Below=860]="U_Combining_Double_Breve_Below",t[t.U_Combining_Double_Breve=861]="U_Combining_Double_Breve",t[t.U_Combining_Double_Macron=862]="U_Combining_Double_Macron",t[t.U_Combining_Double_Macron_Below=863]="U_Combining_Double_Macron_Below",t[t.U_Combining_Double_Tilde=864]="U_Combining_Double_Tilde",t[t.U_Combining_Double_Inverted_Breve=865]="U_Combining_Double_Inverted_Breve",t[t.U_Combining_Double_Rightwards_Arrow_Below=866]="U_Combining_Double_Rightwards_Arrow_Below",t[t.U_Combining_Latin_Small_Letter_A=867]="U_Combining_Latin_Small_Letter_A",t[t.U_Combining_Latin_Small_Letter_E=868]="U_Combining_Latin_Small_Letter_E",t[t.U_Combining_Latin_Small_Letter_I=869]="U_Combining_Latin_Small_Letter_I",t[t.U_Combining_Latin_Small_Letter_O=870]="U_Combining_Latin_Small_Letter_O",t[t.U_Combining_Latin_Small_Letter_U=871]="U_Combining_Latin_Small_Letter_U",t[t.U_Combining_Latin_Small_Letter_C=872]="U_Combining_Latin_Small_Letter_C",t[t.U_Combining_Latin_Small_Letter_D=873]="U_Combining_Latin_Small_Letter_D",t[t.U_Combining_Latin_Small_Letter_H=874]="U_Combining_Latin_Small_Letter_H",t[t.U_Combining_Latin_Small_Letter_M=875]="U_Combining_Latin_Small_Letter_M",t[t.U_Combining_Latin_Small_Letter_R=876]="U_Combining_Latin_Small_Letter_R",t[t.U_Combining_Latin_Small_Letter_T=877]="U_Combining_Latin_Small_Letter_T",t[t.U_Combining_Latin_Small_Letter_V=878]="U_Combining_Latin_Small_Letter_V",t[t.U_Combining_Latin_Small_Letter_X=879]="U_Combining_Latin_Small_Letter_X",t[t.LINE_SEPARATOR=8232]="LINE_SEPARATOR",t[t.PARAGRAPH_SEPARATOR=8233]="PARAGRAPH_SEPARATOR",t[t.NEXT_LINE=133]="NEXT_LINE",t[t.U_CIRCUMFLEX=94]="U_CIRCUMFLEX",t[t.U_GRAVE_ACCENT=96]="U_GRAVE_ACCENT",t[t.U_DIAERESIS=168]="U_DIAERESIS",t[t.U_MACRON=175]="U_MACRON",t[t.U_ACUTE_ACCENT=180]="U_ACUTE_ACCENT",t[t.U_CEDILLA=184]="U_CEDILLA",t[t.U_MODIFIER_LETTER_LEFT_ARROWHEAD=706]="U_MODIFIER_LETTER_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_RIGHT_ARROWHEAD=707]="U_MODIFIER_LETTER_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_UP_ARROWHEAD=708]="U_MODIFIER_LETTER_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_DOWN_ARROWHEAD=709]="U_MODIFIER_LETTER_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING=722]="U_MODIFIER_LETTER_CENTRED_RIGHT_HALF_RING",t[t.U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING=723]="U_MODIFIER_LETTER_CENTRED_LEFT_HALF_RING",t[t.U_MODIFIER_LETTER_UP_TACK=724]="U_MODIFIER_LETTER_UP_TACK",t[t.U_MODIFIER_LETTER_DOWN_TACK=725]="U_MODIFIER_LETTER_DOWN_TACK",t[t.U_MODIFIER_LETTER_PLUS_SIGN=726]="U_MODIFIER_LETTER_PLUS_SIGN",t[t.U_MODIFIER_LETTER_MINUS_SIGN=727]="U_MODIFIER_LETTER_MINUS_SIGN",t[t.U_BREVE=728]="U_BREVE",t[t.U_DOT_ABOVE=729]="U_DOT_ABOVE",t[t.U_RING_ABOVE=730]="U_RING_ABOVE",t[t.U_OGONEK=731]="U_OGONEK",t[t.U_SMALL_TILDE=732]="U_SMALL_TILDE",t[t.U_DOUBLE_ACUTE_ACCENT=733]="U_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_RHOTIC_HOOK=734]="U_MODIFIER_LETTER_RHOTIC_HOOK",t[t.U_MODIFIER_LETTER_CROSS_ACCENT=735]="U_MODIFIER_LETTER_CROSS_ACCENT",t[t.U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR=741]="U_MODIFIER_LETTER_EXTRA_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_HIGH_TONE_BAR=742]="U_MODIFIER_LETTER_HIGH_TONE_BAR",t[t.U_MODIFIER_LETTER_MID_TONE_BAR=743]="U_MODIFIER_LETTER_MID_TONE_BAR",t[t.U_MODIFIER_LETTER_LOW_TONE_BAR=744]="U_MODIFIER_LETTER_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR=745]="U_MODIFIER_LETTER_EXTRA_LOW_TONE_BAR",t[t.U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK=746]="U_MODIFIER_LETTER_YIN_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK=747]="U_MODIFIER_LETTER_YANG_DEPARTING_TONE_MARK",t[t.U_MODIFIER_LETTER_UNASPIRATED=749]="U_MODIFIER_LETTER_UNASPIRATED",t[t.U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD=751]="U_MODIFIER_LETTER_LOW_DOWN_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_UP_ARROWHEAD=752]="U_MODIFIER_LETTER_LOW_UP_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD=753]="U_MODIFIER_LETTER_LOW_LEFT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD=754]="U_MODIFIER_LETTER_LOW_RIGHT_ARROWHEAD",t[t.U_MODIFIER_LETTER_LOW_RING=755]="U_MODIFIER_LETTER_LOW_RING",t[t.U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT=756]="U_MODIFIER_LETTER_MIDDLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT=757]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_GRAVE_ACCENT",t[t.U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT=758]="U_MODIFIER_LETTER_MIDDLE_DOUBLE_ACUTE_ACCENT",t[t.U_MODIFIER_LETTER_LOW_TILDE=759]="U_MODIFIER_LETTER_LOW_TILDE",t[t.U_MODIFIER_LETTER_RAISED_COLON=760]="U_MODIFIER_LETTER_RAISED_COLON",t[t.U_MODIFIER_LETTER_BEGIN_HIGH_TONE=761]="U_MODIFIER_LETTER_BEGIN_HIGH_TONE",t[t.U_MODIFIER_LETTER_END_HIGH_TONE=762]="U_MODIFIER_LETTER_END_HIGH_TONE",t[t.U_MODIFIER_LETTER_BEGIN_LOW_TONE=763]="U_MODIFIER_LETTER_BEGIN_LOW_TONE",t[t.U_MODIFIER_LETTER_END_LOW_TONE=764]="U_MODIFIER_LETTER_END_LOW_TONE",t[t.U_MODIFIER_LETTER_SHELF=765]="U_MODIFIER_LETTER_SHELF",t[t.U_MODIFIER_LETTER_OPEN_SHELF=766]="U_MODIFIER_LETTER_OPEN_SHELF",t[t.U_MODIFIER_LETTER_LOW_LEFT_ARROW=767]="U_MODIFIER_LETTER_LOW_LEFT_ARROW",t[t.U_GREEK_LOWER_NUMERAL_SIGN=885]="U_GREEK_LOWER_NUMERAL_SIGN",t[t.U_GREEK_TONOS=900]="U_GREEK_TONOS",t[t.U_GREEK_DIALYTIKA_TONOS=901]="U_GREEK_DIALYTIKA_TONOS",t[t.U_GREEK_KORONIS=8125]="U_GREEK_KORONIS",t[t.U_GREEK_PSILI=8127]="U_GREEK_PSILI",t[t.U_GREEK_PERISPOMENI=8128]="U_GREEK_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_PERISPOMENI=8129]="U_GREEK_DIALYTIKA_AND_PERISPOMENI",t[t.U_GREEK_PSILI_AND_VARIA=8141]="U_GREEK_PSILI_AND_VARIA",t[t.U_GREEK_PSILI_AND_OXIA=8142]="U_GREEK_PSILI_AND_OXIA",t[t.U_GREEK_PSILI_AND_PERISPOMENI=8143]="U_GREEK_PSILI_AND_PERISPOMENI",t[t.U_GREEK_DASIA_AND_VARIA=8157]="U_GREEK_DASIA_AND_VARIA",t[t.U_GREEK_DASIA_AND_OXIA=8158]="U_GREEK_DASIA_AND_OXIA",t[t.U_GREEK_DASIA_AND_PERISPOMENI=8159]="U_GREEK_DASIA_AND_PERISPOMENI",t[t.U_GREEK_DIALYTIKA_AND_VARIA=8173]="U_GREEK_DIALYTIKA_AND_VARIA",t[t.U_GREEK_DIALYTIKA_AND_OXIA=8174]="U_GREEK_DIALYTIKA_AND_OXIA",t[t.U_GREEK_VARIA=8175]="U_GREEK_VARIA",t[t.U_GREEK_OXIA=8189]="U_GREEK_OXIA",t[t.U_GREEK_DASIA=8190]="U_GREEK_DASIA",t[t.U_IDEOGRAPHIC_FULL_STOP=12290]="U_IDEOGRAPHIC_FULL_STOP",t[t.U_LEFT_CORNER_BRACKET=12300]="U_LEFT_CORNER_BRACKET",t[t.U_RIGHT_CORNER_BRACKET=12301]="U_RIGHT_CORNER_BRACKET",t[t.U_LEFT_BLACK_LENTICULAR_BRACKET=12304]="U_LEFT_BLACK_LENTICULAR_BRACKET",t[t.U_RIGHT_BLACK_LENTICULAR_BRACKET=12305]="U_RIGHT_BLACK_LENTICULAR_BRACKET",t[t.U_OVERLINE=8254]="U_OVERLINE",t[t.UTF8_BOM=65279]="UTF8_BOM",t[t.U_FULLWIDTH_SEMICOLON=65307]="U_FULLWIDTH_SEMICOLON",t[t.U_FULLWIDTH_COMMA=65292]="U_FULLWIDTH_COMMA"})(c||(e.CharCode=c={}))}),define(he[44],fe([0,1]),function(ie,e){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$g=void 0,e.$c=t,e.$d=S,e.$e=w,e.$f=B;function t($,r){const L=Object.create(null);for(const b of $){const d=r(b);let u=L[d];u||(u=L[d]=[]),u.push(b)}return L}function S($,r){const L=[],b=[];for(const d of $)r.has(d)||L.push(d);for(const d of r)$.has(d)||b.push(d);return{removed:L,added:b}}function w($,r){const L=[],b=[];for(const[d,u]of $)r.has(d)||L.push(u);for(const[d,u]of r)$.has(d)||b.push(u);return{removed:L,added:b}}function B($,r){const L=new Set;for(const b of r)$.has(b)&&L.add(b);return L}class A{static{c=Symbol.toStringTag}constructor(r,L){this.b=L,this.a=new Map,this[c]="SetWithKey";for(const b of r)this.add(b)}get size(){return this.a.size}add(r){const L=this.b(r);return this.a.set(L,r),this}delete(r){return this.a.delete(this.b(r))}has(r){return this.a.has(this.b(r))}*entries(){for(const r of this.a.values())yield[r,r]}keys(){return this.values()}*values(){for(const r of this.a.values())yield r}clear(){this.a.clear()}forEach(r,L){this.a.forEach(b=>r.call(L,b,b,this))}[Symbol.iterator](){return this.values()}}e.$g=A}),define(he[14],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=t,e.$0h=S,e.$$h=w;function c(B){return(A,$,r)=>{let L=null,b=null;if(typeof r.value=="function"?(L="value",b=r.value):typeof r.get=="function"&&(L="get",b=r.get),!b)throw new Error("not supported");r[L]=B(b,$)}}function t(B,A,$){let r=null,L=null;if(typeof $.value=="function"?(r="value",L=$.value,L.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(r="get",L=$.get),!L)throw new Error("not supported");const b=`$memoize$${A}`;$[r]=function(...d){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:L.apply(this,d)}),this[b]}}function S(B,A,$){return c((r,L)=>{const b=`$debounce$${L}`,d=`$debounce$result$${L}`;return function(...u){this[d]||(this[d]=$?$():void 0),clearTimeout(this[b]),A&&(this[d]=A(this[d],...u),u=[this[d]]),this[b]=setTimeout(()=>{r.apply(this,u),this[d]=$?$():void 0},B)}})}function w(B,A,$){return c((r,L)=>{const b=`$throttle$timer$${L}`,d=`$throttle$result$${L}`,u=`$throttle$lastRun$${L}`,a=`$throttle$pending$${L}`;return function(...h){if(this[d]||(this[d]=$?$():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),A&&(this[d]=A(this[d],...h)),this[a])return;const f=this[u]+B;f<=Date.now()?(this[u]=Date.now(),r.apply(this,[this[d]]),this[d]=$?$():void 0):(this[a]=!0,this[b]=setTimeout(()=>{this[a]=!1,this[u]=Date.now(),r.apply(this,[this[d]]),this[d]=$?$():void 0},f-Date.now()))}})}}),define(he[7],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$8=e.$4=e.$V=e.$U=void 0,e.setUnexpectedErrorHandler=t,e.$X=S,e.$Y=w,e.$Z=B,e.$1=A,e.$2=$,e.$3=L,e.$5=d,e.$6=u,e.$7=a,e.$9=f;class c{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?E.isErrorNoTelemetry(i)?new E(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(m=>{m(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$U=c,e.$V=new c;function t(o){e.$V.setUnexpectedErrorHandler(o)}function S(o){if(!o||typeof o!="object")return!1;const i=o;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}function w(o){L(o)||e.$V.onUnexpectedError(o)}function B(o){L(o)||e.$V.onUnexpectedExternalError(o)}function A(o){if(o instanceof Error){const{name:i,message:m}=o,R=o.stacktrace||o.stack;return{$isError:!0,name:i,message:m,stack:R,noTelemetry:E.isErrorNoTelemetry(o)}}return o}function $(o){let i;return o.noTelemetry?i=new E:(i=new Error,i.name=o.name),i.message=o.message,i.stack=o.stack,i}const r="Canceled";function L(o){return o instanceof b?!0:o instanceof Error&&o.name===r&&o.message===r}class b extends Error{constructor(){super(r),this.name=this.message}}e.$4=b;function d(){const o=new Error(r);return o.name=o.message,o}function u(o){return o?new Error(`Illegal argument: ${o}`):new Error("Illegal argument")}function a(o){return o?new Error(`Illegal state: ${o}`):new Error("Illegal state")}class h extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=h;function f(o){return o?o.message?o.message:o.stack?o.stack.split(`
`)[0]:String(o):"Error"}class l extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$0=l;class s extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$$=s;class p extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=p;class E extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof E)return i;const m=new E;return m.message=i.message,m.stack=i.stack,m}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$ab=E;class n extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$bb=n}),define(he[17],fe([0,1,7,43]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$8b=e.$7b=e.CompareResult=void 0,e.$rb=S,e.$sb=w,e.$tb=B,e.$ub=A,e.$vb=$,e.$wb=r,e.$xb=L,e.$yb=b,e.$zb=d,e.$Ab=u,e.$Bb=a,e.$Cb=h,e.$Db=f,e.top=l,e.$Fb=s,e.$Gb=E,e.$Hb=n,e.$Ib=o,e.$Jb=i,e.$Kb=m,e.$Lb=R,e.$Mb=C,e.$Nb=v,e.$Ob=_,e.$Pb=k,e.$Qb=M,e.$Rb=q,e.$Sb=I,e.$Tb=y,e.$Ub=U,e.$Vb=D,e.$Wb=P,e.$Xb=F,e.$Yb=Q,e.$Zb=V,e.$1b=Z,e.$2b=re,e.$3b=ae,e.$4b=X,e.$5b=ee,e.$6b=le,e.$9b=ge,e.$ac=oe;function S(N,K=0){return N[N.length-(1+K)]}function w(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}function B(N,K,T=(O,H)=>O===H){if(N===K)return!0;if(!N||!K||N.length!==K.length)return!1;for(let O=0,H=N.length;O<H;O++)if(!T(N[O],K[O]))return!1;return!0}function A(N,K){const T=N.length-1;K<T&&(N[K]=N[T]),N.pop()}function $(N,K,T){return r(N.length,O=>T(N[O],K))}function r(N,K){let T=0,O=N-1;for(;T<=O;){const H=(T+O)/2|0,x=K(H);if(x<0)T=H+1;else if(x>0)O=H-1;else return H}return-(T+1)}function L(N,K,T){if(N=N|0,N>=K.length)throw new TypeError("invalid index");const O=K[Math.floor(K.length*Math.random())],H=[],x=[],ne=[];for(const be of K){const ve=T(be,O);ve<0?H.push(be):ve>0?x.push(be):ne.push(be)}return N<H.length?L(N,H,T):N<H.length+ne.length?ne[0]:L(N-(H.length+ne.length),x,T)}function b(N,K){const T=[];let O;for(const H of N.slice(0).sort(K))!O||K(O[0],H)!==0?(O=[H],T.push(O)):O.push(H);return T}function*d(N,K){let T,O;for(const H of N)O!==void 0&&K(O,H)?T.push(H):(T&&(yield T),T=[H]),O=H;T&&(yield T)}function u(N,K){for(let T=0;T<=N.length;T++)K(T===0?void 0:N[T-1],T===N.length?void 0:N[T])}function a(N,K){for(let T=0;T<N.length;T++)K(T===0?void 0:N[T-1],N[T],T+1===N.length?void 0:N[T+1])}function h(N,K,T){const O=[];function H(be,ve,De){if(ve===0&&De.length===0)return;const me=O[O.length-1];me&&me.start+me.deleteCount===be?(me.deleteCount+=ve,me.toInsert.push(...De)):O.push({start:be,deleteCount:ve,toInsert:De})}let x=0,ne=0;for(;;){if(x===N.length){H(x,0,K.slice(ne));break}if(ne===K.length){H(x,N.length-x,[]);break}const be=N[x],ve=K[ne],De=T(be,ve);De===0?(x+=1,ne+=1):De<0?(H(x,1,[]),x+=1):De>0&&(H(x,0,[ve]),ne+=1)}return O}function f(N,K,T){const O=h(N,K,T),H=[],x=[];for(const ne of O)H.push(...N.slice(ne.start,ne.start+ne.deleteCount)),x.push(...ne.toInsert);return{removed:H,added:x}}function l(N,K,T){if(T===0)return[];const O=N.slice(0,T).sort(K);return p(N,K,O,T,N.length),O}function s(N,K,T,O,H){return T===0?Promise.resolve([]):new Promise((x,ne)=>{(async()=>{const be=N.length,ve=N.slice(0,T).sort(K);for(let De=T,me=Math.min(T+O,be);De<be;De=me,me=Math.min(me+O,be)){if(De>T&&await new Promise(de=>setTimeout(de)),H&&H.isCancellationRequested)throw new c.$4;p(N,K,ve,De,me)}return ve})().then(x,ne)})}function p(N,K,T,O,H){for(const x=T.length;O<H;O++){const ne=N[O];if(K(ne,T[x-1])<0){T.pop();const be=(0,t.$jb)(T,ve=>K(ne,ve)<0);T.splice(be,0,ne)}}}function E(N){return N.filter(K=>!!K)}function n(N){let K=0;for(let T=0;T<N.length;T++)N[T]&&(N[K]=N[T],K+=1);N.length=K}function o(N,K,T){N.splice(T,0,N.splice(K,1)[0])}function i(N){return!Array.isArray(N)||N.length===0}function m(N){return Array.isArray(N)&&N.length>0}function R(N,K=T=>T){const T=new Set;return N.filter(O=>{const H=K(O);return T.has(H)?!1:(T.add(H),!0)})}function C(N){const K=new Set;return T=>{const O=N(T);return K.has(O)?!1:(K.add(O),!0)}}function v(N,K){return N.length>0?N[0]:K}function _(N,K){return N.length>0?N[N.length-1]:K}function k(N,K,T=(O,H)=>O===H){let O=0;for(let H=0,x=Math.min(N.length,K.length);H<x&&T(N[H],K[H]);H++)O++;return O}function M(N,K){let T=typeof K=="number"?N:0;typeof K=="number"?T=N:(T=0,K=N);const O=[];if(T<=K)for(let H=T;H<K;H++)O.push(H);else for(let H=T;H>K;H--)O.push(H);return O}function q(N,K,T){return N.reduce((O,H)=>(O[K(H)]=T?T(H):H,O),Object.create(null))}function I(N,K){return N.push(K),()=>y(N,K)}function y(N,K){const T=N.indexOf(K);if(T>-1)return N.splice(T,1),K}function U(N,K,T){const O=N.slice(0,K),H=N.slice(K);return O.concat(T,H)}function D(N,K){let T;if(typeof K=="number"){let O=K;T=()=>{const H=Math.sin(O++)*179426549;return H-Math.floor(H)}}else T=Math.random;for(let O=N.length-1;O>0;O-=1){const H=Math.floor(T()*(O+1)),x=N[O];N[O]=N[H],N[H]=x}}function P(N,K){const T=N.indexOf(K);T>-1&&(N.splice(T,1),N.unshift(K))}function F(N,K){const T=N.indexOf(K);T>-1&&(N.splice(T,1),N.push(K))}function Q(N,K){for(const T of K)N.push(T)}function V(N,K){return Array.isArray(N)?N.map(K):K(N)}function Z(N){return Array.isArray(N)?N:[N]}function re(N){return N[Math.floor(Math.random()*N.length)]}function ae(N,K,T){const O=j(N,K),H=N.length,x=T.length;N.length=H+x;for(let ne=H-1;ne>=O;ne--)N[ne+x]=N[ne];for(let ne=0;ne<x;ne++)N[ne+O]=T[ne]}function X(N,K,T,O){const H=j(N,K);let x=N.splice(H,T);return x===void 0&&(x=[]),ae(N,H,O),x}function j(N,K){return K<0?Math.max(K+N.length,0):Math.min(K,N.length)}var J;(function(N){function K(x){return x<0}N.isLessThan=K;function T(x){return x<=0}N.isLessThanOrEqual=T;function O(x){return x>0}N.isGreaterThan=O;function H(x){return x===0}N.isNeitherLessOrGreaterThan=H,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function ee(N,K){return(T,O)=>K(N(T),N(O))}function le(...N){return(K,T)=>{for(const O of N){const H=O(K,T);if(!J.isNeitherLessOrGreaterThan(H))return H}return J.neitherLessOrGreaterThan}}const W=(N,K)=>N-K;e.$7b=W;const ce=(N,K)=>(0,e.$7b)(N?1:0,K?1:0);e.$8b=ce;function ge(N){return(K,T)=>-N(K,T)}class te{constructor(K){this.g=K,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(K){let T=this.c;for(;T<this.g.length&&K(this.g[T]);)T++;const O=T===this.c?null:this.g.slice(this.c,T);return this.c=T,O}takeFromEndWhile(K){let T=this.d;for(;T>=0&&K(this.g[T]);)T--;const O=T===this.d?null:this.g.slice(T+1,this.d+1);return this.d=T,O}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const K=this.g[this.c];return this.c++,K}removeLast(){const K=this.g[this.d];return this.d--,K}takeCount(K){const T=this.g.slice(this.c,this.c+K);return this.c+=K,T}}e.$0b=te;class g{static{this.empty=new g(K=>{})}constructor(K){this.iterate=K}forEach(K){this.iterate(T=>(K(T),!0))}toArray(){const K=[];return this.iterate(T=>(K.push(T),!0)),K}filter(K){return new g(T=>this.iterate(O=>K(O)?T(O):!0))}map(K){return new g(T=>this.iterate(O=>T(K(O))))}some(K){let T=!1;return this.iterate(O=>(T=K(O),!T)),T}findFirst(K){let T;return this.iterate(O=>K(O)?(T=O,!1):!0),T}findLast(K){let T;return this.iterate(O=>(K(O)&&(T=O),!0)),T}findLastMaxBy(K){let T,O=!0;return this.iterate(H=>((O||J.isGreaterThan(K(H,T)))&&(O=!1,T=H),!0)),T}}e.$$b=g;class G{constructor(K){this.c=K}static createSortPermutation(K,T){const O=Array.from(K.keys()).sort((H,x)=>T(K[H],K[x]));return new G(O)}apply(K){return K.map((T,O)=>K[this.c[O]])}inverse(){const K=this.c.slice();for(let T=0;T<this.c.length;T++)K[this.c[T]]=T;return new G(K)}}e.$_b=G;async function oe(N,K){return(await Promise.all(N.map(async(O,H)=>({element:O,ok:await K(O,H)})))).find(O=>O.ok)?.element}}),define(he[45],fe([0,1,7]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=t,e.$ed=S,e.$fd=w,e.$gd=B,e.$hd=A,e.$id=$;function t(r,L){if(!r)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}function S(r,L="Unreachable"){throw new Error(L)}function w(r,L="unexpected state"){if(!r)throw new c.$bb(`Assertion Failed: ${L}`)}function B(r){r||(0,c.$Y)(new c.$bb("Soft Assertion Failed"))}function A(r){if(!r()){debugger;r(),(0,c.$Y)(new c.$bb("Assertion Failed"))}}function $(r,L){let b=0;for(;b<r.length-1;){const d=r[b],u=r[b+1];if(!L(d,u))return!1;b++}return!0}}),define(he[31],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=c;function c(t,S){const w=this;let B=!1,A;return function(){if(B)return A;if(B=!0,S)try{A=t.apply(w,arguments)}finally{S()}else A=t.apply(w,arguments);return A}}}),define(he[46],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var c;(function(t){function S(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}t.is=S;const w=Object.freeze([]);function B(){return w}t.empty=B;function*A(i){yield i}t.single=A;function $(i){return S(i)?i:A(i)}t.wrap=$;function r(i){return i||w}t.from=r;function*L(i){for(let m=i.length-1;m>=0;m--)yield i[m]}t.reverse=L;function b(i){return!i||i[Symbol.iterator]().next().done===!0}t.isEmpty=b;function d(i){return i[Symbol.iterator]().next().value}t.first=d;function u(i,m){let R=0;for(const C of i)if(m(C,R++))return!0;return!1}t.some=u;function a(i,m){for(const R of i)if(m(R))return R}t.find=a;function*h(i,m){for(const R of i)m(R)&&(yield R)}t.filter=h;function*f(i,m){let R=0;for(const C of i)yield m(C,R++)}t.map=f;function*l(i,m){let R=0;for(const C of i)yield*m(C,R++)}t.flatMap=l;function*s(...i){for(const m of i)yield*m}t.concat=s;function p(i,m,R){let C=R;for(const v of i)C=m(C,v);return C}t.reduce=p;function*E(i,m,R=i.length){for(m<0&&(m+=i.length),R<0?R+=i.length:R>i.length&&(R=i.length);m<R;m++)yield i[m]}t.slice=E;function n(i,m=Number.POSITIVE_INFINITY){const R=[];if(m===0)return[R,i];const C=i[Symbol.iterator]();for(let v=0;v<m;v++){const _=C.next();if(_.done)return[R,t.empty()];R.push(_.value)}return[R,{[Symbol.iterator](){return C}}]}t.consume=n;async function o(i){const m=[];for await(const R of i)m.push(R);return Promise.resolve(m)}t.asyncToArray=o})(c||(e.Iterable=c={}))}),define(he[24],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class c{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=c}),define(he[47],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class c{static{this.Undefined=new c(void 0)}constructor(w){this.element=w,this.next=c.Undefined,this.prev=c.Undefined}}class t{constructor(){this.a=c.Undefined,this.b=c.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===c.Undefined}clear(){let w=this.a;for(;w!==c.Undefined;){const B=w.next;w.prev=c.Undefined,w.next=c.Undefined,w=B}this.a=c.Undefined,this.b=c.Undefined,this.c=0}unshift(w){return this.d(w,!1)}push(w){return this.d(w,!0)}d(w,B){const A=new c(w);if(this.a===c.Undefined)this.a=A,this.b=A;else if(B){const r=this.b;this.b=A,A.prev=r,r.next=A}else{const r=this.a;this.a=A,A.next=r,r.prev=A}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(A))}}shift(){if(this.a!==c.Undefined){const w=this.a.element;return this.e(this.a),w}}pop(){if(this.b!==c.Undefined){const w=this.b.element;return this.e(this.b),w}}e(w){if(w.prev!==c.Undefined&&w.next!==c.Undefined){const B=w.prev;B.next=w.next,w.next.prev=B}else w.prev===c.Undefined&&w.next===c.Undefined?(this.a=c.Undefined,this.b=c.Undefined):w.next===c.Undefined?(this.b=this.b.prev,this.b.next=c.Undefined):w.prev===c.Undefined&&(this.a=this.a.next,this.a.prev=c.Undefined);this.c-=1}*[Symbol.iterator](){let w=this.a;for(;w!==c.Undefined;)yield w.element,w=w.next}}e.$5c=t}),define(he[26],fe([0,1]),function(ie,e){"use strict";var c,t,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=w,e.$yc=B,e.$zc=A,e.$Ic=E;function w(n,o,i){let m=n.get(o);return m===void 0&&(m=i,n.set(o,m)),m}function B(n){const o=[];return n.forEach((i,m)=>{o.push(`${m} => ${i}`)}),`Map(${n.size}) {${o.join(", ")}}`}function A(n){const o=[];return n.forEach(i=>{o.push(i)}),`Set(${n.size}) {${o.join(", ")}}`}class ${constructor(o,i){this.uri=o,this.value=i}}function r(n){return Array.isArray(n)}class L{static{this.c=o=>o.toString()}constructor(o,i){if(this[c]="ResourceMap",o instanceof L)this.d=new Map(o.d),this.e=i??L.c;else if(r(o)){this.d=new Map,this.e=i??L.c;for(const[m,R]of o)this.set(m,R)}else this.d=new Map,this.e=o??L.c}set(o,i){return this.d.set(this.e(o),new $(o,i)),this}get(o){return this.d.get(this.e(o))?.value}has(o){return this.d.has(this.e(o))}get size(){return this.d.size}clear(){this.d.clear()}delete(o){return this.d.delete(this.e(o))}forEach(o,i){typeof i<"u"&&(o=o.bind(i));for(const[m,R]of this.d)o(R.value,R.uri,this)}*values(){for(const o of this.d.values())yield o.value}*keys(){for(const o of this.d.values())yield o.uri}*entries(){for(const o of this.d.values())yield[o.uri,o.value]}*[(c=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.d)yield[o.uri,o.value]}}e.$Ac=L;class b{constructor(o,i){this[t]="ResourceSet",!o||typeof o=="function"?this.c=new L(o):(this.c=new L(i),o.forEach(this.add,this))}get size(){return this.c.size}add(o){return this.c.set(o,o),this}clear(){this.c.clear()}delete(o){return this.c.delete(o)}forEach(o,i){this.c.forEach((m,R)=>o.call(i,R,R,this))}has(o){return this.c.has(o)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(t=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=b;var d;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class u{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(o){return this.c.has(o)}get(o,i=d.None){const m=this.c.get(o);if(m)return i!==d.None&&this.m(m,i),m.value}set(o,i,m=d.None){let R=this.c.get(o);if(R)R.value=i,m!==d.None&&this.m(R,m);else{switch(R={key:o,value:i,next:void 0,previous:void 0},m){case d.None:this.k(R);break;case d.AsOld:this.j(R);break;case d.AsNew:this.k(R);break;default:this.k(R);break}this.c.set(o,R),this.f++}return this}delete(o){return!!this.remove(o)}remove(o){const i=this.c.get(o);if(i)return this.c.delete(o),this.l(i),this.f--,i.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const o=this.d;return this.c.delete(o.key),this.l(o),this.f--,o.value}forEach(o,i){const m=this.g;let R=this.d;for(;R;){if(i?o.bind(i)(R.value,R.key,this):o(R.value,R.key,this),this.g!==m)throw new Error("LinkedMap got modified during iteration.");R=R.next}}keys(){const o=this,i=this.g;let m=this.d;const R={[Symbol.iterator](){return R},next(){if(o.g!==i)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:m.key,done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return R}values(){const o=this,i=this.g;let m=this.d;const R={[Symbol.iterator](){return R},next(){if(o.g!==i)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:m.value,done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return R}entries(){const o=this,i=this.g;let m=this.d;const R={[Symbol.iterator](){return R},next(){if(o.g!==i)throw new Error("LinkedMap got modified during iteration.");if(m){const C={value:[m.key,m.value],done:!1};return m=m.next,C}else return{value:void 0,done:!0}}};return R}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(o){if(o>=this.size)return;if(o===0){this.clear();return}let i=this.d,m=this.size;for(;i&&m>o;)this.c.delete(i.key),i=i.next,m--;this.d=i,this.f=m,i&&(i.previous=void 0),this.g++}i(o){if(o>=this.size)return;if(o===0){this.clear();return}let i=this.e,m=this.size;for(;i&&m>o;)this.c.delete(i.key),i=i.previous,m--;this.e=i,this.f=m,i&&(i.next=void 0),this.g++}j(o){if(!this.d&&!this.e)this.e=o;else if(this.d)o.next=this.d,this.d.previous=o;else throw new Error("Invalid list");this.d=o,this.g++}k(o){if(!this.d&&!this.e)this.d=o;else if(this.e)o.previous=this.e,this.e.next=o;else throw new Error("Invalid list");this.e=o,this.g++}l(o){if(o===this.d&&o===this.e)this.d=void 0,this.e=void 0;else if(o===this.d){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.d=o.next}else if(o===this.e){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.e=o.previous}else{const i=o.next,m=o.previous;if(!i||!m)throw new Error("Invalid list");i.previous=m,m.next=i}o.next=void 0,o.previous=void 0,this.g++}m(o,i){if(!this.d||!this.e)throw new Error("Invalid list");if(!(i!==d.AsOld&&i!==d.AsNew)){if(i===d.AsOld){if(o===this.d)return;const m=o.next,R=o.previous;o===this.e?(R.next=void 0,this.e=R):(m.previous=R,R.next=m),o.previous=void 0,o.next=this.d,this.d.previous=o,this.d=o,this.g++}else if(i===d.AsNew){if(o===this.e)return;const m=o.next,R=o.previous;o===this.d?(m.previous=void 0,this.d=m):(m.previous=R,R.next=m),o.next=void 0,o.previous=this.e,this.e.next=o,this.e=o,this.g++}}}toJSON(){const o=[];return this.forEach((i,m)=>{o.push([m,i])}),o}fromJSON(o){this.clear();for(const[i,m]of o)this.set(i,m)}}e.$Cc=u;class a extends u{constructor(o,i=1){super(),this.n=o,this.o=Math.min(Math.max(0,i),1)}get limit(){return this.n}set limit(o){this.n=o,this.p()}get ratio(){return this.o}set ratio(o){this.o=Math.min(Math.max(0,o),1),this.p()}get(o,i=d.AsNew){return super.get(o,i)}peek(o){return super.get(o,d.None)}set(o,i){return super.set(o,i,d.AsNew),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class h extends a{constructor(o,i=1){super(o,i)}q(o){this.h(o)}set(o,i){return super.set(o,i),this.p(),this}}e.$Dc=h;class f extends a{constructor(o,i=1){super(o,i)}q(o){this.i(o)}set(o,i){return this.n<=this.size&&!this.has(o)&&this.q(Math.round(this.n*this.o)-1),super.set(o,i),this}}e.$Ec=f;class l{constructor(){this.c=new Map}add(o){return this.c.set(o,(this.c.get(o)||0)+1),this}delete(o){let i=this.c.get(o)||0;return i===0?!1:(i--,i===0?this.c.delete(o):this.c.set(o,i),!0)}has(o){return this.c.has(o)}}e.$Fc=l;class s{constructor(o){if(this.c=new Map,this.d=new Map,o)for(const[i,m]of o)this.set(i,m)}clear(){this.c.clear(),this.d.clear()}set(o,i){this.c.set(o,i),this.d.set(i,o)}get(o){return this.c.get(o)}getKey(o){return this.d.get(o)}delete(o){const i=this.c.get(o);return i===void 0?!1:(this.c.delete(o),this.d.delete(i),!0)}forEach(o,i){this.c.forEach((m,R)=>{o.call(i,m,R,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=s;class p{constructor(){this.c=new Map}add(o,i){let m=this.c.get(o);m||(m=new Set,this.c.set(o,m)),m.add(i)}delete(o,i){const m=this.c.get(o);m&&(m.delete(i),m.size===0&&this.c.delete(o))}forEach(o,i){const m=this.c.get(o);m&&m.forEach(i)}get(o){const i=this.c.get(o);return i||new Set}}e.$Hc=p;function E(n,o){if(n===o)return!0;if(n.size!==o.size)return!1;for(const[i,m]of n)if(!o.has(i)||o.get(i)!==m)return!1;for(const[i]of o)if(!n.has(i))return!1;return!0}}),define(he[2],fe([0,1,17,44,26,31,46]),function(ie,e,c,t,S,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=L,e.$Lc=b,e.$Mc=d,e.$Nc=h,e.$Oc=f,e.$Pc=l,e.$Qc=s,e.$Rc=p,e.$Sc=E,e.$3c=M;const A=!1;let $=null;class r{constructor(){this.b=new Map}static{this.a=0}c(y){let U=this.b.get(y);return U||(U={parent:null,source:null,isSingleton:!1,value:y,idx:r.a++},this.b.set(y,U)),U}trackDisposable(y){const U=this.c(y);U.source||(U.source=new Error().stack)}setParent(y,U){const D=this.c(y);D.parent=U}markAsDisposed(y){this.b.delete(y)}markAsSingleton(y){this.c(y).isSingleton=!0}f(y,U){const D=U.get(y);if(D)return D;const P=y.parent?this.f(this.c(y.parent),U):y;return U.set(y,P),P}getTrackedDisposables(){const y=new Map;return[...this.b.entries()].filter(([,D])=>D.source!==null&&!this.f(D,y).isSingleton).flatMap(([D])=>D)}computeLeakingDisposables(y=10,U){let D;if(U)D=U;else{const Z=new Map,re=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,Z).isSingleton);if(re.length===0)return;const ae=new Set(re.map(X=>X.value));if(D=re.filter(X=>!(X.parent&&ae.has(X.parent))),D.length===0)throw new Error("There are cyclic diposable chains!")}if(!D)return;function P(Z){function re(X,j){for(;X.length>0&&j.some(J=>typeof J=="string"?J===X[0]:X[0].match(J));)X.shift()}const ae=Z.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return re(ae,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ae.reverse()}const F=new S.$Hc;for(const Z of D){const re=P(Z);for(let ae=0;ae<=re.length;ae++)F.add(re.slice(0,ae).join(`
`),Z)}D.sort((0,c.$5b)(Z=>Z.idx,c.$7b));let Q="",V=0;for(const Z of D.slice(0,y)){V++;const re=P(Z),ae=[];for(let X=0;X<re.length;X++){let j=re[X];j=`(shared with ${F.get(re.slice(0,X+1).join(`
`)).size}/${D.length} leaks) at ${j}`;const ee=F.get(re.slice(0,X).join(`
`)),le=(0,t.$c)([...ee].map(W=>P(W)[X]),W=>W);delete le[re[X]];for(const[W,ce]of Object.entries(le))ae.unshift(`    - stacktraces of ${ce.length} other leaks continue with ${W}`);ae.unshift(j)}Q+=`


==================== Leaking disposable ${V}/${D.length}: ${Z.value.constructor.name} ====================
${ae.join(`
`)}
============================================================

`}return D.length>y&&(Q+=`


... and ${D.length-y} more leaking disposables

`),{leaks:D,details:Q}}}e.$Jc=r;function L(I){$=I}if(A){const I="__is_disposable_tracked__";L(new class{trackDisposable(y){const U=new Error("Potentially leaked disposable").stack;setTimeout(()=>{y[I]||console.log(U)},3e3)}setParent(y,U){if(y&&y!==o.None)try{y[I]=!0}catch{}}markAsDisposed(y){if(y&&y!==o.None)try{y[I]=!0}catch{}}markAsSingleton(y){}})}function b(I){return $?.trackDisposable(I),I}function d(I){$?.markAsDisposed(I)}function u(I,y){$?.setParent(I,y)}function a(I,y){if($)for(const U of I)$.setParent(U,y)}function h(I){return $?.markAsSingleton(I),I}function f(I){return typeof I=="object"&&I!==null&&typeof I.dispose=="function"&&I.dispose.length===0}function l(I){if(B.Iterable.is(I)){const y=[];for(const U of I)if(U)try{U.dispose()}catch(D){y.push(D)}if(y.length===1)throw y[0];if(y.length>1)throw new AggregateError(y,"Encountered errors while disposing of store");return Array.isArray(I)?[]:I}else if(I)return I.dispose(),I}function s(I){for(const y of I)f(y)&&y.dispose();return[]}function p(...I){const y=E(()=>l(I));return a(I,y),y}function E(I){const y=b({dispose:(0,w.$cb)(()=>{d(y),I()})});return y}class n{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(d(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(y){if(!y)return y;if(y===this)throw new Error("Cannot register a disposable on itself!");return u(y,this),this.g?n.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(y),y}delete(y){if(y){if(y===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(y),y.dispose()}}deleteAndLeak(y){y&&this.f.has(y)&&(this.f.delete(y),u(y,null))}}e.$Tc=n;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new n,b(this),u(this.q,this)}dispose(){d(this),this.q.dispose()}B(y){if(y===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(y)}}e.$Uc=o;class i{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(y){this.b||y===this.a||(this.a?.dispose(),y&&u(y,this),this.a=y)}clear(){this.value=void 0}dispose(){this.b=!0,d(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const y=this.a;return this.a=void 0,y&&u(y,null),y}}e.$Vc=i;class m{constructor(y){this.a=new i,this.b=!1,this.a.value=y}get value(){return this.a.value}set value(y){this.b||y===this.a.value||(this.a.value=y)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=m;class R{constructor(y){this.b=y,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=R;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(y){let U=y;return this.unset=()=>U=void 0,this.isset=()=>U!==void 0,this.dispose=()=>{U&&(U(),U=void 0,d(this))},this}}e.$Yc=C;class v{constructor(){this.a=new Map}acquire(y,...U){let D=this.a.get(y);D||(D={counter:0,object:this.b(y,...U)},this.a.set(y,D));const{object:P}=D,F=(0,w.$cb)(()=>{--D.counter===0&&(this.c(y,D.object),this.a.delete(y))});return D.counter++,{object:P,dispose:F}}}e.$Zc=v;class _{constructor(y){this.a=y}async acquire(y,...U){const D=this.a.acquire(y,...U);try{return{object:await D.object,dispose:()=>D.dispose()}}catch(P){throw D.dispose(),P}}}e.$1c=_;class k{constructor(y){this.object=y}dispose(){}}e.$2c=k;function M(I){const y=new n;try{I(y)}finally{y.dispose()}}class q{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){d(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(y){return this.a.has(y)}get size(){return this.a.size}get(y){return this.a.get(y)}set(y,U,D=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),D||this.a.get(y)?.dispose(),this.a.set(y,U)}deleteAndDispose(y){this.a.get(y)?.dispose(),this.a.delete(y)}deleteAndLeak(y){const U=this.a.get(y);return this.a.delete(y),U}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=q}),define(he[27],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MarshalledId=void 0;var c;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadInstance=8]="CommentThreadInstance",t[t.CommentThreadReply=9]="CommentThreadReply",t[t.CommentNode=10]="CommentNode",t[t.CommentThreadNode=11]="CommentThreadNode",t[t.TimelineActionContext=12]="TimelineActionContext",t[t.NotebookCellActionContext=13]="NotebookCellActionContext",t[t.NotebookActionContext=14]="NotebookActionContext",t[t.TerminalContext=15]="TerminalContext",t[t.TestItemContext=16]="TestItemContext",t[t.Date=17]="Date",t[t.TestMessageMenuArgs=18]="TestMessageMenuArgs"})(c||(e.MarshalledId=c={}))}),define(he[48],fe([0,1,26]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=void 0,e.$mm=S,e.$nm=B;const t=new c.$Dc(1e4);function S(r){return $(r,"NFC",t)}const w=new c.$Dc(1e4);function B(r){return $(r,"NFD",w)}const A=/[^\u0000-\u0080]/;function $(r,L,b){if(!r)return r;const d=b.get(r);if(d)return d;let u;return A.test(r)?u=r.normalize(L):u=r,b.set(r,u),u}e.$om=function(){const r=/[\u0300-\u036f]/g;return function(L){return B(L).replace(r,"")}}()}),function(){function ie(S){const w=[];typeof S=="number"&&w.push("code/timeOrigin",S);function B($){w.push($,Date.now())}function A(){const $=[];for(let r=0;r<w.length;r+=2)$.push({name:w[r],startTime:w[r+1]});return $}return{mark:B,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const w=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const B of performance.getEntriesByType("mark"))w.push({name:B.name,startTime:Math.round(S+B.startTime)});return w}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function c(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return c(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=c(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=c(t))}(),define(he[3],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.OS=e.OperatingSystem=e.$C=e.$B=e.$A=e.$z=e.$y=e.Language=e.$x=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.Platform=e.$h=void 0,e.$i=o,e.$E=_,e.$K=k,e.$h="en";let c=!1,t=!1,S=!1,w=!1,B=!1,A=!1,$=!1,r=!1,L=!1,b=!1,d,u=e.$h,a=e.$h,h,f;const l=globalThis;let s;typeof l.vscode<"u"&&typeof l.vscode.process<"u"?s=l.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(s=process);const p=typeof s?.versions?.electron=="string",E=p&&s?.type==="renderer";if(typeof s=="object"){c=s.platform==="win32",t=s.platform==="darwin",S=s.platform==="linux",w=S&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,$=p,L=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,d=e.$h,u=e.$h;const M=s.env.VSCODE_NLS_CONFIG;if(M)try{const q=JSON.parse(M);d=q.userLocale,a=q.osLocale,u=q.resolvedLanguage||e.$h,h=q.languagePack?.translationsConfigFile}catch{}B=!0}else typeof navigator=="object"&&!E?(f=navigator.userAgent,c=f.indexOf("Windows")>=0,t=f.indexOf("Macintosh")>=0,r=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,S=f.indexOf("Linux")>=0,b=f?.indexOf("Mobi")>=0,A=!0,u=globalThis._VSCODE_NLS_LANGUAGE||e.$h,d=navigator.language.toLowerCase(),a=d):console.error("Unable to resolve platform.");var n;(function(M){M[M.Web=0]="Web",M[M.Mac=1]="Mac",M[M.Linux=2]="Linux",M[M.Windows=3]="Windows"})(n||(e.Platform=n={}));function o(M){switch(M){case n.Web:return"Web";case n.Mac:return"Mac";case n.Linux:return"Linux";case n.Windows:return"Windows"}}let i=n.Web;t?i=n.Mac:c?i=n.Windows:S&&(i=n.Linux),e.$j=c,e.$k=t,e.$l=S,e.$m=w,e.$n=B,e.$o=$,e.$p=A,e.$q=A&&typeof l.importScripts=="function",e.$r=e.$q?l.origin:void 0,e.$s=r,e.$t=b,e.$u=L,e.$v=i,e.$w=f,e.$x=u;var m;(function(M){function q(){return e.$x}M.value=q;function I(){return e.$x.length===2?e.$x==="en":e.$x.length>=3?e.$x[0]==="e"&&e.$x[1]==="n"&&e.$x[2]==="-":!1}M.isDefaultVariant=I;function y(){return e.$x==="en"}M.isDefault=y})(m||(e.Language=m={})),e.$y=d,e.$z=a,e.$A=h,e.$B=typeof l.postMessage=="function"&&!l.importScripts,e.$C=(()=>{if(e.$B){const M=[];l.addEventListener("message",I=>{if(I.data&&I.data.vscodeScheduleAsyncWork)for(let y=0,U=M.length;y<U;y++){const D=M[y];if(D.id===I.data.vscodeScheduleAsyncWork){M.splice(y,1),D.callback();return}}});let q=0;return I=>{const y=++q;M.push({id:y,callback:I}),l.postMessage({vscodeScheduleAsyncWork:y},"*")}}return M=>setTimeout(M)})();var R;(function(M){M[M.Windows=1]="Windows",M[M.Macintosh=2]="Macintosh",M[M.Linux=3]="Linux"})(R||(e.OperatingSystem=R={})),e.OS=t||r?R.Macintosh:c?R.Windows:R.Linux;let C=!0,v=!1;function _(){if(!v){v=!0;const M=new Uint8Array(2);M[0]=1,M[1]=2,C=new Uint16Array(M.buffer)[0]===513}return C}e.$F=!!(e.$w&&e.$w.indexOf("Chrome")>=0),e.$G=!!(e.$w&&e.$w.indexOf("Firefox")>=0),e.$H=!!(!e.$F&&e.$w&&e.$w.indexOf("Safari")>=0),e.$I=!!(e.$w&&e.$w.indexOf("Edg/")>=0),e.$J=!!(e.$w&&e.$w.indexOf("Android")>=0);function k(M){return parseFloat(M)>=20}}),define(he[15],fe([0,1,3]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let t;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const w=S.process;t={get platform(){return w.platform},get arch(){return w.arch},get env(){return w.env},cwd(){return w.cwd()}}}else typeof process<"u"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return c.$j?"win32":c.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.$dc=t.platform,e.$ec=t.arch});var Qe=this&&this.__createBinding||(Object.create?function(ie,e,c,t){t===void 0&&(t=c);var S=Object.getOwnPropertyDescriptor(e,c);(!S||("get"in S?!e.__esModule:S.writable||S.configurable))&&(S={enumerable:!0,get:function(){return e[c]}}),Object.defineProperty(ie,t,S)}:function(ie,e,c,t){t===void 0&&(t=c),ie[t]=e[c]}),Ze=this&&this.__setModuleDefault||(Object.create?function(ie,e){Object.defineProperty(ie,"default",{enumerable:!0,value:e})}:function(ie,e){ie.default=e}),Se=this&&this.__importStar||function(ie){if(ie&&ie.__esModule)return ie;var e={};if(ie!=null)for(var c in ie)c!=="default"&&Object.prototype.hasOwnProperty.call(ie,c)&&Qe(e,ie,c);return Ze(e,ie),e};define(he[5],fe([0,1,15]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0,c=Se(c);const t=65,S=97,w=90,B=122,A=46,$=47,r=92,L=58,b=63;class d extends Error{constructor(m,R,C){let v;typeof R=="string"&&R.indexOf("not ")===0?(v="must not be",R=R.replace(/^not /,"")):v="must be";const _=m.indexOf(".")!==-1?"property":"argument";let k=`The "${m}" ${_} ${v} of type ${R}`;k+=`. Received type ${typeof C}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function u(i,m){if(i===null||typeof i!="object")throw new d(m,"Object",i)}function a(i,m){if(typeof i!="string")throw new d(m,"string",i)}const h=c.$dc==="win32";function f(i){return i===$||i===r}function l(i){return i===$}function s(i){return i>=t&&i<=w||i>=S&&i<=B}function p(i,m,R,C){let v="",_=0,k=-1,M=0,q=0;for(let I=0;I<=i.length;++I){if(I<i.length)q=i.charCodeAt(I);else{if(C(q))break;q=$}if(C(q)){if(!(k===I-1||M===1))if(M===2){if(v.length<2||_!==2||v.charCodeAt(v.length-1)!==A||v.charCodeAt(v.length-2)!==A){if(v.length>2){const y=v.lastIndexOf(R);y===-1?(v="",_=0):(v=v.slice(0,y),_=v.length-1-v.lastIndexOf(R)),k=I,M=0;continue}else if(v.length!==0){v="",_=0,k=I,M=0;continue}}m&&(v+=v.length>0?`${R}..`:"..",_=2)}else v.length>0?v+=`${R}${i.slice(k+1,I)}`:v=i.slice(k+1,I),_=I-k-1;k=I,M=0}else q===A&&M!==-1?++M:M=-1}return v}function E(i){return i?`${i[0]==="."?"":"."}${i}`:""}function n(i,m){u(m,"pathObject");const R=m.dir||m.root,C=m.base||`${m.name||""}${E(m.ext)}`;return R?R===m.root?`${R}${C}`:`${R}${i}${C}`:C}e.$fc={resolve(...i){let m="",R="",C=!1;for(let v=i.length-1;v>=-1;v--){let _;if(v>=0){if(_=i[v],a(_,`paths[${v}]`),_.length===0)continue}else m.length===0?_=c.cwd():(_=c.env[`=${m}`]||c.cwd(),(_===void 0||_.slice(0,2).toLowerCase()!==m.toLowerCase()&&_.charCodeAt(2)===r)&&(_=`${m}\\`));const k=_.length;let M=0,q="",I=!1;const y=_.charCodeAt(0);if(k===1)f(y)&&(M=1,I=!0);else if(f(y))if(I=!0,f(_.charCodeAt(1))){let U=2,D=U;for(;U<k&&!f(_.charCodeAt(U));)U++;if(U<k&&U!==D){const P=_.slice(D,U);for(D=U;U<k&&f(_.charCodeAt(U));)U++;if(U<k&&U!==D){for(D=U;U<k&&!f(_.charCodeAt(U));)U++;(U===k||U!==D)&&(q=`\\\\${P}\\${_.slice(D,U)}`,M=U)}}}else M=1;else s(y)&&_.charCodeAt(1)===L&&(q=_.slice(0,2),M=2,k>2&&f(_.charCodeAt(2))&&(I=!0,M=3));if(q.length>0)if(m.length>0){if(q.toLowerCase()!==m.toLowerCase())continue}else m=q;if(C){if(m.length>0)break}else if(R=`${_.slice(M)}\\${R}`,C=I,I&&m.length>0)break}return R=p(R,!C,"\\",f),C?`${m}\\${R}`:`${m}${R}`||"."},normalize(i){a(i,"path");const m=i.length;if(m===0)return".";let R=0,C,v=!1;const _=i.charCodeAt(0);if(m===1)return l(_)?"\\":i;if(f(_))if(v=!0,f(i.charCodeAt(1))){let M=2,q=M;for(;M<m&&!f(i.charCodeAt(M));)M++;if(M<m&&M!==q){const I=i.slice(q,M);for(q=M;M<m&&f(i.charCodeAt(M));)M++;if(M<m&&M!==q){for(q=M;M<m&&!f(i.charCodeAt(M));)M++;if(M===m)return`\\\\${I}\\${i.slice(q)}\\`;M!==q&&(C=`\\\\${I}\\${i.slice(q,M)}`,R=M)}}}else R=1;else s(_)&&i.charCodeAt(1)===L&&(C=i.slice(0,2),R=2,m>2&&f(i.charCodeAt(2))&&(v=!0,R=3));let k=R<m?p(i.slice(R),!v,"\\",f):"";return k.length===0&&!v&&(k="."),k.length>0&&f(i.charCodeAt(m-1))&&(k+="\\"),C===void 0?v?`\\${k}`:k:v?`${C}\\${k}`:`${C}${k}`},isAbsolute(i){a(i,"path");const m=i.length;if(m===0)return!1;const R=i.charCodeAt(0);return f(R)||m>2&&s(R)&&i.charCodeAt(1)===L&&f(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let m,R;for(let _=0;_<i.length;++_){const k=i[_];a(k,"path"),k.length>0&&(m===void 0?m=R=k:m+=`\\${k}`)}if(m===void 0)return".";let C=!0,v=0;if(typeof R=="string"&&f(R.charCodeAt(0))){++v;const _=R.length;_>1&&f(R.charCodeAt(1))&&(++v,_>2&&(f(R.charCodeAt(2))?++v:C=!1))}if(C){for(;v<m.length&&f(m.charCodeAt(v));)v++;v>=2&&(m=`\\${m.slice(v)}`)}return e.$fc.normalize(m)},relative(i,m){if(a(i,"from"),a(m,"to"),i===m)return"";const R=e.$fc.resolve(i),C=e.$fc.resolve(m);if(R===C||(i=R.toLowerCase(),m=C.toLowerCase(),i===m))return"";let v=0;for(;v<i.length&&i.charCodeAt(v)===r;)v++;let _=i.length;for(;_-1>v&&i.charCodeAt(_-1)===r;)_--;const k=_-v;let M=0;for(;M<m.length&&m.charCodeAt(M)===r;)M++;let q=m.length;for(;q-1>M&&m.charCodeAt(q-1)===r;)q--;const I=q-M,y=k<I?k:I;let U=-1,D=0;for(;D<y;D++){const F=i.charCodeAt(v+D);if(F!==m.charCodeAt(M+D))break;F===r&&(U=D)}if(D!==y){if(U===-1)return C}else{if(I>y){if(m.charCodeAt(M+D)===r)return C.slice(M+D+1);if(D===2)return C.slice(M+D)}k>y&&(i.charCodeAt(v+D)===r?U=D:D===2&&(U=3)),U===-1&&(U=0)}let P="";for(D=v+U+1;D<=_;++D)(D===_||i.charCodeAt(D)===r)&&(P+=P.length===0?"..":"\\..");return M+=U,P.length>0?`${P}${C.slice(M,q)}`:(C.charCodeAt(M)===r&&++M,C.slice(M,q))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const m=e.$fc.resolve(i);if(m.length<=2)return i;if(m.charCodeAt(0)===r){if(m.charCodeAt(1)===r){const R=m.charCodeAt(2);if(R!==b&&R!==A)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(s(m.charCodeAt(0))&&m.charCodeAt(1)===L&&m.charCodeAt(2)===r)return`\\\\?\\${m}`;return i},dirname(i){a(i,"path");const m=i.length;if(m===0)return".";let R=-1,C=0;const v=i.charCodeAt(0);if(m===1)return f(v)?i:".";if(f(v)){if(R=C=1,f(i.charCodeAt(1))){let M=2,q=M;for(;M<m&&!f(i.charCodeAt(M));)M++;if(M<m&&M!==q){for(q=M;M<m&&f(i.charCodeAt(M));)M++;if(M<m&&M!==q){for(q=M;M<m&&!f(i.charCodeAt(M));)M++;if(M===m)return i;M!==q&&(R=C=M+1)}}}}else s(v)&&i.charCodeAt(1)===L&&(R=m>2&&f(i.charCodeAt(2))?3:2,C=R);let _=-1,k=!0;for(let M=m-1;M>=C;--M)if(f(i.charCodeAt(M))){if(!k){_=M;break}}else k=!1;if(_===-1){if(R===-1)return".";_=R}return i.slice(0,_)},basename(i,m){m!==void 0&&a(m,"suffix"),a(i,"path");let R=0,C=-1,v=!0,_;if(i.length>=2&&s(i.charCodeAt(0))&&i.charCodeAt(1)===L&&(R=2),m!==void 0&&m.length>0&&m.length<=i.length){if(m===i)return"";let k=m.length-1,M=-1;for(_=i.length-1;_>=R;--_){const q=i.charCodeAt(_);if(f(q)){if(!v){R=_+1;break}}else M===-1&&(v=!1,M=_+1),k>=0&&(q===m.charCodeAt(k)?--k===-1&&(C=_):(k=-1,C=M))}return R===C?C=M:C===-1&&(C=i.length),i.slice(R,C)}for(_=i.length-1;_>=R;--_)if(f(i.charCodeAt(_))){if(!v){R=_+1;break}}else C===-1&&(v=!1,C=_+1);return C===-1?"":i.slice(R,C)},extname(i){a(i,"path");let m=0,R=-1,C=0,v=-1,_=!0,k=0;i.length>=2&&i.charCodeAt(1)===L&&s(i.charCodeAt(0))&&(m=C=2);for(let M=i.length-1;M>=m;--M){const q=i.charCodeAt(M);if(f(q)){if(!_){C=M+1;break}continue}v===-1&&(_=!1,v=M+1),q===A?R===-1?R=M:k!==1&&(k=1):R!==-1&&(k=-1)}return R===-1||v===-1||k===0||k===1&&R===v-1&&R===C+1?"":i.slice(R,v)},format:n.bind(null,"\\"),parse(i){a(i,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return m;const R=i.length;let C=0,v=i.charCodeAt(0);if(R===1)return f(v)?(m.root=m.dir=i,m):(m.base=m.name=i,m);if(f(v)){if(C=1,f(i.charCodeAt(1))){let U=2,D=U;for(;U<R&&!f(i.charCodeAt(U));)U++;if(U<R&&U!==D){for(D=U;U<R&&f(i.charCodeAt(U));)U++;if(U<R&&U!==D){for(D=U;U<R&&!f(i.charCodeAt(U));)U++;U===R?C=U:U!==D&&(C=U+1)}}}}else if(s(v)&&i.charCodeAt(1)===L){if(R<=2)return m.root=m.dir=i,m;if(C=2,f(i.charCodeAt(2))){if(R===3)return m.root=m.dir=i,m;C=3}}C>0&&(m.root=i.slice(0,C));let _=-1,k=C,M=-1,q=!0,I=i.length-1,y=0;for(;I>=C;--I){if(v=i.charCodeAt(I),f(v)){if(!q){k=I+1;break}continue}M===-1&&(q=!1,M=I+1),v===A?_===-1?_=I:y!==1&&(y=1):_!==-1&&(y=-1)}return M!==-1&&(_===-1||y===0||y===1&&_===M-1&&_===k+1?m.base=m.name=i.slice(k,M):(m.name=i.slice(k,_),m.base=i.slice(k,M),m.ext=i.slice(_,M))),k>0&&k!==C?m.dir=i.slice(0,k-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null};const o=(()=>{if(h){const i=/\\/g;return()=>{const m=c.cwd().replace(i,"/");return m.slice(m.indexOf("/"))}}return()=>c.cwd()})();e.$gc={resolve(...i){let m="",R=!1;for(let C=i.length-1;C>=-1&&!R;C--){const v=C>=0?i[C]:o();a(v,`paths[${C}]`),v.length!==0&&(m=`${v}/${m}`,R=v.charCodeAt(0)===$)}return m=p(m,!R,"/",l),R?`/${m}`:m.length>0?m:"."},normalize(i){if(a(i,"path"),i.length===0)return".";const m=i.charCodeAt(0)===$,R=i.charCodeAt(i.length-1)===$;return i=p(i,!m,"/",l),i.length===0?m?"/":R?"./":".":(R&&(i+="/"),m?`/${i}`:i)},isAbsolute(i){return a(i,"path"),i.length>0&&i.charCodeAt(0)===$},join(...i){if(i.length===0)return".";let m;for(let R=0;R<i.length;++R){const C=i[R];a(C,"path"),C.length>0&&(m===void 0?m=C:m+=`/${C}`)}return m===void 0?".":e.$gc.normalize(m)},relative(i,m){if(a(i,"from"),a(m,"to"),i===m||(i=e.$gc.resolve(i),m=e.$gc.resolve(m),i===m))return"";const R=1,C=i.length,v=C-R,_=1,k=m.length-_,M=v<k?v:k;let q=-1,I=0;for(;I<M;I++){const U=i.charCodeAt(R+I);if(U!==m.charCodeAt(_+I))break;U===$&&(q=I)}if(I===M)if(k>M){if(m.charCodeAt(_+I)===$)return m.slice(_+I+1);if(I===0)return m.slice(_+I)}else v>M&&(i.charCodeAt(R+I)===$?q=I:I===0&&(q=0));let y="";for(I=R+q+1;I<=C;++I)(I===C||i.charCodeAt(I)===$)&&(y+=y.length===0?"..":"/..");return`${y}${m.slice(_+q)}`},toNamespacedPath(i){return i},dirname(i){if(a(i,"path"),i.length===0)return".";const m=i.charCodeAt(0)===$;let R=-1,C=!0;for(let v=i.length-1;v>=1;--v)if(i.charCodeAt(v)===$){if(!C){R=v;break}}else C=!1;return R===-1?m?"/":".":m&&R===1?"//":i.slice(0,R)},basename(i,m){m!==void 0&&a(m,"ext"),a(i,"path");let R=0,C=-1,v=!0,_;if(m!==void 0&&m.length>0&&m.length<=i.length){if(m===i)return"";let k=m.length-1,M=-1;for(_=i.length-1;_>=0;--_){const q=i.charCodeAt(_);if(q===$){if(!v){R=_+1;break}}else M===-1&&(v=!1,M=_+1),k>=0&&(q===m.charCodeAt(k)?--k===-1&&(C=_):(k=-1,C=M))}return R===C?C=M:C===-1&&(C=i.length),i.slice(R,C)}for(_=i.length-1;_>=0;--_)if(i.charCodeAt(_)===$){if(!v){R=_+1;break}}else C===-1&&(v=!1,C=_+1);return C===-1?"":i.slice(R,C)},extname(i){a(i,"path");let m=-1,R=0,C=-1,v=!0,_=0;for(let k=i.length-1;k>=0;--k){const M=i.charCodeAt(k);if(M===$){if(!v){R=k+1;break}continue}C===-1&&(v=!1,C=k+1),M===A?m===-1?m=k:_!==1&&(_=1):m!==-1&&(_=-1)}return m===-1||C===-1||_===0||_===1&&m===C-1&&m===R+1?"":i.slice(m,C)},format:n.bind(null,"/"),parse(i){a(i,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return m;const R=i.charCodeAt(0)===$;let C;R?(m.root="/",C=1):C=0;let v=-1,_=0,k=-1,M=!0,q=i.length-1,I=0;for(;q>=C;--q){const y=i.charCodeAt(q);if(y===$){if(!M){_=q+1;break}continue}k===-1&&(M=!1,k=q+1),y===A?v===-1?v=q:I!==1&&(I=1):v!==-1&&(I=-1)}if(k!==-1){const y=_===0&&R?1:_;v===-1||I===0||I===1&&v===k-1&&v===_+1?m.base=m.name=i.slice(y,k):(m.name=i.slice(y,v),m.base=i.slice(y,k),m.ext=i.slice(v,k))}return _>0?m.dir=i.slice(0,_-1):R&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=h?e.$fc.normalize:e.$gc.normalize,e.$ic=h?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=h?e.$fc.join:e.$gc.join,e.$kc=h?e.$fc.resolve:e.$gc.resolve,e.$lc=h?e.$fc.relative:e.$gc.relative,e.$mc=h?e.$fc.dirname:e.$gc.dirname,e.$nc=h?e.$fc.basename:e.$gc.basename,e.$oc=h?e.$fc.extname:e.$gc.extname,e.$pc=h?e.$fc.format:e.$gc.format,e.$qc=h?e.$fc.parse:e.$gc.parse,e.$rc=h?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=h?e.$fc.sep:e.$gc.sep,e.$tc=h?e.$fc.delimiter:e.$gc.delimiter}),define(he[32],fe([0,1,3]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$km=w,e.$lm=B;var t;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(t||(e.Source=t={}));var S;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function w(A,...$){const r=$.reduce((d,u)=>(d[u]=!0,d),{}),L=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(A).filter(d=>!r[d]).forEach(d=>{for(let u=0;u<L.length;u++)if(d.search(L[u])!==-1){delete A[d];break}})}function B(A){A&&(delete A.DEBUG,c.$l&&delete A.LD_PRELOAD)}}),define(he[49],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fe=void 0;const c=globalThis.performance&&typeof globalThis.performance.now=="function";class t{static create(w){return new t(w)}constructor(w){this.c=c&&w===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$fe=t}),define(he[4],fe([0,1,7,31,2,47,49]),function(ie,e,c,t,S,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$he=e.Event=void 0,e.$ie=u;const A=!1,$=!1,r=!1;var L;(function(P){P.None=()=>S.$Uc.None;function F(me){if(r){const{onDidAddListener:de}=me,pe=h.create();let we=0;me.onDidAddListener=()=>{++we===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),de?.()}}}function Q(me,de){return W(me,()=>{},0,void 0,!0,void 0,de)}P.defer=Q;function V(me){return(de,pe=null,we)=>{let Ee=!1,_e;return _e=me(Pe=>{if(!Ee)return _e?_e.dispose():Ee=!0,de.call(pe,Pe)},null,we),Ee&&_e.dispose(),_e}}P.once=V;function Z(me,de,pe){return ee((we,Ee=null,_e)=>me(Pe=>we.call(Ee,de(Pe)),null,_e),pe)}P.map=Z;function re(me,de,pe){return ee((we,Ee=null,_e)=>me(Pe=>{de(Pe),we.call(Ee,Pe)},null,_e),pe)}P.forEach=re;function ae(me,de,pe){return ee((we,Ee=null,_e)=>me(Pe=>de(Pe)&&we.call(Ee,Pe),null,_e),pe)}P.filter=ae;function X(me){return me}P.signal=X;function j(...me){return(de,pe=null,we)=>{const Ee=(0,S.$Rc)(...me.map(_e=>_e(Pe=>de.call(pe,Pe))));return le(Ee,we)}}P.any=j;function J(me,de,pe,we){let Ee=pe;return Z(me,_e=>(Ee=de(Ee,_e),Ee),we)}P.reduce=J;function ee(me,de){let pe;const we={onWillAddFirstListener(){pe=me(Ee.fire,Ee)},onDidRemoveLastListener(){pe?.dispose()}};de||F(we);const Ee=new i(we);return de?.add(Ee),Ee.event}function le(me,de){return de instanceof Array?de.push(me):de&&de.add(me),me}function W(me,de,pe=100,we=!1,Ee=!1,_e,Pe){let Ie,Re,Ce,Le=0,Me;const He={leakWarningThreshold:_e,onWillAddFirstListener(){Ie=me(Ke=>{Le++,Re=de(Re,Ke),we&&!Ce&&(ze.fire(Re),Re=void 0),Me=()=>{const Ye=Re;Re=void 0,Ce=void 0,(!we||Le>1)&&ze.fire(Ye),Le=0},typeof pe=="number"?(clearTimeout(Ce),Ce=setTimeout(Me,pe)):Ce===void 0&&(Ce=0,queueMicrotask(Me))})},onWillRemoveListener(){Ee&&Le>0&&Me?.()},onDidRemoveLastListener(){Me=void 0,Ie.dispose()}};Pe||F(He);const ze=new i(He);return Pe?.add(ze),ze.event}P.debounce=W;function ce(me,de=0,pe){return P.debounce(me,(we,Ee)=>we?(we.push(Ee),we):[Ee],de,void 0,!0,void 0,pe)}P.accumulate=ce;function ge(me,de=(we,Ee)=>we===Ee,pe){let we=!0,Ee;return ae(me,_e=>{const Pe=we||!de(_e,Ee);return we=!1,Ee=_e,Pe},pe)}P.latch=ge;function te(me,de,pe){return[P.filter(me,de,pe),P.filter(me,we=>!de(we),pe)]}P.split=te;function g(me,de=!1,pe=[],we){let Ee=pe.slice(),_e=me(Re=>{Ee?Ee.push(Re):Ie.fire(Re)});we&&we.add(_e);const Pe=()=>{Ee?.forEach(Re=>Ie.fire(Re)),Ee=null},Ie=new i({onWillAddFirstListener(){_e||(_e=me(Re=>Ie.fire(Re)),we&&we.add(_e))},onDidAddFirstListener(){Ee&&(de?setTimeout(Pe):Pe())},onDidRemoveLastListener(){_e&&_e.dispose(),_e=null}});return we&&we.add(Ie),Ie.event}P.buffer=g;function G(me,de){return(we,Ee,_e)=>{const Pe=de(new N);return me(function(Ie){const Re=Pe.evaluate(Ie);Re!==oe&&we.call(Ee,Re)},void 0,_e)}}P.chain=G;const oe=Symbol("HaltChainable");class N{constructor(){this.f=[]}map(de){return this.f.push(de),this}forEach(de){return this.f.push(pe=>(de(pe),pe)),this}filter(de){return this.f.push(pe=>de(pe)?pe:oe),this}reduce(de,pe){let we=pe;return this.f.push(Ee=>(we=de(we,Ee),we)),this}latch(de=(pe,we)=>pe===we){let pe=!0,we;return this.f.push(Ee=>{const _e=pe||!de(Ee,we);return pe=!1,we=Ee,_e?Ee:oe}),this}evaluate(de){for(const pe of this.f)if(de=pe(de),de===oe)break;return de}}function K(me,de,pe=we=>we){const we=(...Ie)=>Pe.fire(pe(...Ie)),Ee=()=>me.on(de,we),_e=()=>me.removeListener(de,we),Pe=new i({onWillAddFirstListener:Ee,onDidRemoveLastListener:_e});return Pe.event}P.fromNodeEventEmitter=K;function T(me,de,pe=we=>we){const we=(...Ie)=>Pe.fire(pe(...Ie)),Ee=()=>me.addEventListener(de,we),_e=()=>me.removeEventListener(de,we),Pe=new i({onWillAddFirstListener:Ee,onDidRemoveLastListener:_e});return Pe.event}P.fromDOMEventEmitter=T;function O(me){return new Promise(de=>V(me)(de))}P.toPromise=O;function H(me){const de=new i;return me.then(pe=>{de.fire(pe)},()=>{de.fire(void 0)}).finally(()=>{de.dispose()}),de.event}P.fromPromise=H;function x(me,de){return me(pe=>de.fire(pe))}P.forward=x;function ne(me,de,pe){return de(pe),me(we=>de(we))}P.runAndSubscribe=ne;class be{constructor(de,pe){this._observable=de,this.f=0,this.g=!1;const we={onWillAddFirstListener:()=>{de.addObserver(this)},onDidRemoveLastListener:()=>{de.removeObserver(this)}};pe||F(we),this.emitter=new i(we),pe&&pe.add(this.emitter)}beginUpdate(de){this.f++}handlePossibleChange(de){}handleChange(de,pe){this.g=!0}endUpdate(de){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ve(me,de){return new be(me,de).emitter.event}P.fromObservable=ve;function De(me){return(de,pe,we)=>{let Ee=0,_e=!1;const Pe={beginUpdate(){Ee++},endUpdate(){Ee--,Ee===0&&(me.reportChanges(),_e&&(_e=!1,de.call(pe)))},handlePossibleChange(){},handleChange(){_e=!0}};me.addObserver(Pe),me.reportChanges();const Ie={dispose(){me.removeObserver(Pe)}};return we instanceof S.$Tc?we.add(Ie):Array.isArray(we)&&we.push(Ie),Ie}}P.fromObservableLight=De})(L||(e.Event=L={}));class b{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${b.f++}`,b.all.add(this)}start(F){this.g=new B.$fe,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$he=b;let d=-1;function u(P){const F=d;return d=P,{dispose(){d=F}}}class a{static{this.f=1}constructor(F,Q,V=(a.f++).toString(16).padStart(3,"0")){this.j=F,this.threshold=Q,this.name=V,this.h=0}dispose(){this.g?.clear()}check(F,Q){const V=this.threshold;if(V<=0||Q<V)return;this.g||(this.g=new Map);const Z=this.g.get(F.value)||0;if(this.g.set(F.value,Z+1),this.h-=1,this.h<=0){this.h=V*.5;const[re,ae]=this.getMostFrequentStack(),X=`[${this.name}] potential listener LEAK detected, having ${Q} listeners already. MOST frequent listener (${ae}):`;console.warn(X),console.warn(re);const j=new f(X,re);this.j(j)}return()=>{const re=this.g.get(F.value)||0;this.g.set(F.value,re-1)}}getMostFrequentStack(){if(!this.g)return;let F,Q=0;for(const[V,Z]of this.g)(!F||Q<Z)&&(F=[V,Z],Q=Z);return F}}class h{static create(){const F=new Error;return new h(F.stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f extends Error{constructor(F,Q){super(F),this.name="ListenerLeakError",this.stack=Q}}e.$je=f;class l extends Error{constructor(F,Q){super(F),this.name="ListenerRefusalError",this.stack=Q}}e.$ke=l;let s=0;class p{constructor(F){this.value=F,this.id=s++}}const E=2,n=(P,F)=>{if(P instanceof p)F(P);else for(let Q=0;Q<P.length;Q++){const V=P[Q];V&&F(V)}};let o;if(A){const P=[];setInterval(()=>{P.length!==0&&(console.warn("[LEAKING LISTENERS] GC'ed these listeners that were NOT yet disposed:"),console.warn(P.join(`
`)),P.length=0)},3e3),o=new FinalizationRegistry(F=>{typeof F=="string"&&P.push(F)})}class i{constructor(F){this.z=0,this.f=F,this.g=d>0||this.f?.leakWarningThreshold?new a(F?.onListenerError??c.$Y,this.f?.leakWarningThreshold??d):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.w=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.w?.current===this&&this.w.reset(),this.u){if($){const F=this.u;queueMicrotask(()=>{n(F,Q=>Q.stack?.print())})}this.u=void 0,this.z=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,Q,V)=>{if(this.g&&this.z>this.g.threshold**2){const j=`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far (${this.z} vs ${this.g.threshold})`;console.warn(j);const J=this.g.getMostFrequentStack()??["UNKNOWN stack",-1],ee=new l(`${j}. HINT: Stack shows most frequent listener (${J[1]}-times)`,J[0]);return(this.f?.onListenerError||c.$Y)(ee),S.$Uc.None}if(this.m)return S.$Uc.None;Q&&(F=F.bind(Q));const Z=new p(F);let re,ae;this.g&&this.z>=Math.ceil(this.g.threshold*.2)&&(Z.stack=h.create(),re=this.g.check(Z.stack,this.z+1)),$&&(Z.stack=ae??h.create()),this.u?this.u instanceof p?(this.w??=new R,this.u=[this.u,Z]):this.u.push(Z):(this.f?.onWillAddFirstListener?.(this),this.u=Z,this.f?.onDidAddFirstListener?.(this)),this.z++;const X=(0,S.$Sc)(()=>{o?.unregister(X),re?.(),this.A(Z)});if(V instanceof S.$Tc?V.add(X):Array.isArray(V)&&V.push(X),o){const j=new Error().stack.split(`
`).slice(2,3).join(`
`).trim(),J=/(file:|vscode-file:\/\/vscode-app)?(\/[^:]*:\d+:\d+)/.exec(j);o.register(X,J?.[2]??j,X)}return X},this.q}A(F){if(this.f?.onWillRemoveListener?.(this),!this.u)return;if(this.z===1){this.u=void 0,this.f?.onDidRemoveLastListener?.(this),this.z=0;return}const Q=this.u,V=Q.indexOf(F);if(V===-1)throw console.log("disposed?",this.m),console.log("size?",this.z),console.log("arr?",JSON.stringify(this.u)),new Error("Attempted to dispose unknown listener");this.z--,Q[V]=void 0;const Z=this.w.current===this;if(this.z*E<=Q.length){let re=0;for(let ae=0;ae<Q.length;ae++)Q[ae]?Q[re++]=Q[ae]:Z&&(this.w.end--,re<this.w.i&&this.w.i--);Q.length=re}}B(F,Q){if(!F)return;const V=this.f?.onListenerError||c.$Y;if(!V){F.value(Q);return}try{F.value(Q)}catch(Z){V(Z)}}C(F){const Q=F.current.u;for(;F.i<F.end;)this.B(Q[F.i++],F.value);F.reset()}fire(F){if(this.w?.current&&(this.C(this.w),this.j?.stop()),this.j?.start(this.z),this.u)if(this.u instanceof p)this.B(this.u,F);else{const Q=this.w;Q.enqueue(this,F,this.u.length),this.C(Q)}this.j?.stop()}hasListeners(){return this.z>0}}e.$le=i;const m=()=>new R;e.$me=m;class R{constructor(){this.i=-1,this.end=0}enqueue(F,Q,V){this.i=0,this.end=V,this.current=F,this.value=Q}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class C extends i{async fireAsync(F,Q,V){if(this.u)for(this.h||(this.h=new w.$5c),n(this.u,Z=>this.h.push([Z.value,F]));this.h.size>0&&!Q.isCancellationRequested;){const[Z,re]=this.h.shift(),ae=[],X={...re,token:Q,waitUntil:j=>{if(Object.isFrozen(ae))throw new Error("waitUntil can NOT be called asynchronous");V&&(j=V(j,Z)),ae.push(j)}};try{Z(X)}catch(j){(0,c.$Y)(j);continue}Object.freeze(ae),await Promise.allSettled(ae).then(j=>{for(const J of j)J.status==="rejected"&&(0,c.$Y)(J.reason)})}}}e.$ne=C;class v extends i{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new w.$5c,this.t=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.t(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.z&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$oe=v;class _ extends v{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$pe=_;class k extends i{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(Q=>super.fire(Q)),this.h=[]}))}}e.$qe=k;class M{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const Q={event:F,listener:null};this.h.push(Q),this.g&&this.m(Q);const V=()=>{this.g&&this.o(Q);const Z=this.h.indexOf(Q);this.h.splice(Z,1)};return(0,S.$Sc)((0,t.$cb)(V))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(Q=>this.f.fire(Q))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$re=M;class q{constructor(F,Q,V,Z){this.f=new S.$Tc;const re=this.f.add(new M),ae=this.f.add(new S.$4c);function X(j){ae.set(j,re.add(Z(j)))}for(const j of F)X(j);this.f.add(Q(j=>{X(j)})),this.f.add(V(j=>{ae.deleteAndDispose(j)})),this.event=re.event}dispose(){this.f.dispose()}}e.$se=q;class I{constructor(){this.f=[]}wrapEvent(F,Q,V){return(Z,re,ae)=>F(X=>{const j=this.f[this.f.length-1];if(!Q){j?j.buffers.push(()=>Z.call(re,X)):Z.call(re,X);return}const J=j;if(!J){Z.call(re,Q(V,X));return}J.items??=[],J.items.push(X),J.buffers.length===0&&j.buffers.push(()=>{J.reducedResult??=V?J.items.reduce(Q,V):J.items.reduce(Q),Z.call(re,J.reducedResult)})},void 0,ae)}bufferEvents(F){const Q={buffers:new Array};this.f.push(Q);const V=F();return this.f.pop(),Q.buffers.forEach(Z=>Z()),V}}e.$te=I;class y{constructor(){this.f=!1,this.g=L.None,this.h=S.$Uc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ue=y;class U{static const(F){return new D(F)}constructor(F){this.g=F,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$ve=U;class D{constructor(F){this.value=F,this.onDidChange=L.None}}}),define(he[18],fe([0,1,4]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$we=e.CancellationToken=void 0,e.$xe=A;const t=Object.freeze(function($,r){const L=setTimeout($.bind(r),0);return{dispose(){clearTimeout(L)}}});var S;(function($){function r(L){return L===$.None||L===$.Cancelled||L instanceof w?!0:!L||typeof L!="object"?!1:typeof L.isCancellationRequested=="boolean"&&typeof L.onCancellationRequested=="function"}$.isCancellationToken=r,$.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:c.Event.None}),$.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(S||(e.CancellationToken=S={}));class w{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?t:(this.b||(this.b=new c.$le),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class B{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new w),this.f}cancel(){this.f?this.f instanceof w&&this.f.cancel():this.f=S.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof w&&this.f.dispose():this.f=S.None}}e.$we=B;function A($){const r=new B;return $.add({dispose(){r.cancel()}}),r.token}}),define(he[50],fe([0,1,18]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_e=e.$$e=e.$9e=void 0,e.$0e=S;class t{constructor($){this.b=$,this.a=null}get(){if(this.a)return this.a;const $=new c.$we,r=this.b($.token);return this.a={promise:r,dispose:()=>{this.a=null,$.cancel(),$.dispose()}},this.a}}e.$9e=t;function S(A){return A}class w{constructor($,r){this.a=void 0,this.b=void 0,typeof $=="function"?(this.c=$,this.d=S):(this.c=r,this.d=$.getCacheKey)}get($){const r=this.d($);return this.b!==r&&(this.b=r,this.a=this.c($)),this.a}}e.$$e=w;class B{get cachedValues(){return this.a}constructor($,r){this.a=new Map,this.b=new Map,typeof $=="function"?(this.c=$,this.d=S):(this.c=r,this.d=$.getCacheKey)}get($){const r=this.d($);if(this.b.has(r))return this.b.get(r);const L=this.c($);return this.a.set($,L),this.b.set(r,L),L}}e.$_e=B}),define(he[51],fe([0,1,7,2]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=S,e.$ze=w,e.$Ae=B,e.$Be=A,e.$Ce=r,e.$De=L,e.$Ee=b,e.$Fe=d,e.$Ge=u,e.$He=a,e.$Ie=h,e.$Je=f,e.$Ke=l,e.$Le=s,e.$Me=p;function S(E){const n=E;return n?typeof n.read=="function":!1}function w(E){const n=E;return n?[n.on,n.pause,n.resume,n.destroy].every(o=>typeof o=="function"):!1}function B(E){const n=E;return n?w(n.stream)&&Array.isArray(n.buffer)&&typeof n.ended=="boolean":!1}function A(E,n){return new $(E,n)}class ${constructor(n,o){this.e=n,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(n){if(!this.a.destroyed){if(this.a.flowing)this.g(n);else if(this.b.data.push(n),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(n){this.a.destroyed||(this.a.flowing?this.h(n):this.b.error.push(n))}end(n){this.a.destroyed||(typeof n<"u"&&this.write(n),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(n){this.c.data.slice(0).forEach(o=>o(n))}h(n){this.c.error.length===0?(0,c.$Y)(n):this.c.error.slice(0).forEach(o=>o(n))}i(){this.c.end.slice(0).forEach(n=>n())}on(n,o){if(!this.a.destroyed)switch(n){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(n,o){if(this.a.destroyed)return;let i;switch(n){case"data":i=this.c.data;break;case"end":i=this.c.end;break;case"error":i=this.c.error;break}if(i){const m=i.indexOf(o);m>=0&&i.splice(m,1)}}j(){if(this.b.data.length>0){const n=this.e(this.b.data);this.g(n),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(i=>i())}}k(){if(this.c.error.length>0){for(const n of this.b.error)this.h(n);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(E,n){const o=[];let i;for(;(i=E.read())!==null;)o.push(i);return n(o)}function L(E,n,o){const i=[];let m;for(;(m=E.read())!==null&&i.length<o;)i.push(m);return m===null&&i.length>0?n(i):{read:()=>{if(i.length>0)return i.shift();if(typeof m<"u"){const R=m;return m=void 0,R}return E.read()}}}function b(E,n){return new Promise((o,i)=>{const m=[];d(E,{onData:R=>{n&&m.push(R)},onError:R=>{n?i(R):o(void 0)},onEnd:()=>{o(n?n(m):void 0)}})})}function d(E,n,o){E.on("error",i=>{o?.isCancellationRequested||n.onError(i)}),E.on("end",()=>{o?.isCancellationRequested||n.onEnd()}),E.on("data",i=>{o?.isCancellationRequested||n.onData(i)})}function u(E,n){return new Promise((o,i)=>{const m=new t.$Tc,R=[],C=k=>{if(R.push(k),R.length>n)return m.dispose(),E.pause(),o({stream:E,buffer:R,ended:!1})},v=k=>(m.dispose(),i(k)),_=()=>(m.dispose(),o({stream:E,buffer:R,ended:!0}));m.add((0,t.$Sc)(()=>E.removeListener("error",v))),E.on("error",v),m.add((0,t.$Sc)(()=>E.removeListener("end",_))),E.on("end",_),m.add((0,t.$Sc)(()=>E.removeListener("data",C))),E.on("data",C)})}function a(E,n){const o=A(n);return o.end(E),o}function h(){const E=A(()=>{throw new Error("not supported")});return E.end(),E}function f(E){let n=!1;return{read:()=>n?null:(n=!0,E)}}function l(E,n,o){const i=A(o);return d(E,{onData:m=>i.write(n.data(m)),onError:m=>i.error(n.error?n.error(m):m),onEnd:()=>i.end()}),i}function s(E,n,o){let i=!1;return{read:()=>{const m=n.read();return i?m:(i=!0,m!==null?o([E,m]):E)}}}function p(E,n,o){let i=!1;const m=A(o);return d(n,{onData:R=>i?m.write(R):(i=!0,m.write(o([E,R]))),onError:R=>m.error(R),onEnd:()=>{i||(i=!0,m.write(E)),m.end()}}),m}}),define(he[19],fe([0,1,24,51]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=r,e.$Pe=L,e.$Qe=b,e.$Re=d,e.$Se=u,e.$Te=a,e.$Ue=h,e.$Ve=f,e.$We=l,e.$Xe=s,e.$Ye=p,e.$Ze=E,e.$1e=n,e.$2e=o,e.$3e=i,e.$4e=m,e.$5e=R,e.$6e=C,e.$7e=v,e.$8e=M,t=Se(t);const S=typeof Buffer<"u",w=new c.$T(()=>new Uint8Array(256));let B,A;class ${static alloc(I){return S?new $(Buffer.allocUnsafe(I)):new $(new Uint8Array(I))}static wrap(I){return S&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new $(I)}static fromString(I,y){return!(y?.dontUseNodeBuffer||!1)&&S?new $(Buffer.from(I)):(B||(B=new TextEncoder),new $(B.encode(I)))}static fromByteArray(I){const y=$.alloc(I.length);for(let U=0,D=I.length;U<D;U++)y.buffer[U]=I[U];return y}static concat(I,y){if(typeof y>"u"){y=0;for(let P=0,F=I.length;P<F;P++)y+=I[P].byteLength}const U=$.alloc(y);let D=0;for(let P=0,F=I.length;P<F;P++){const Q=I[P];U.set(Q,D),D+=Q.byteLength}return U}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=$.alloc(this.byteLength);return I.set(this),I}toString(){return S?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(I,y){return new $(this.buffer.subarray(I,y))}set(I,y){if(I instanceof $)this.buffer.set(I.buffer,y);else if(I instanceof Uint8Array)this.buffer.set(I,y);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),y);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),y);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return d(this.buffer,I)}writeUInt32BE(I,y){u(this.buffer,I,y)}readUInt32LE(I){return a(this.buffer,I)}writeUInt32LE(I,y){h(this.buffer,I,y)}readUInt8(I){return f(this.buffer,I)}writeUInt8(I,y){l(this.buffer,I,y)}indexOf(I,y=0){return r(this.buffer,I instanceof $?I.buffer:I,y)}}e.$Ne=$;function r(q,I,y=0){const U=I.byteLength,D=q.byteLength;if(U===0)return 0;if(U===1)return q.indexOf(I[0]);if(U>D-y)return-1;const P=w.value;P.fill(I.length);for(let Z=0;Z<I.length;Z++)P[I[Z]]=I.length-Z-1;let F=y+I.length-1,Q=F,V=-1;for(;F<D;)if(q[F]===I[Q]){if(Q===0){V=F;break}F--,Q--}else F+=Math.max(I.length-Q,P[q[F]]),Q=I.length-1;return V}function L(q,I){return q[I+0]<<0>>>0|q[I+1]<<8>>>0}function b(q,I,y){q[y+0]=I&255,I=I>>>8,q[y+1]=I&255}function d(q,I){return q[I]*2**24+q[I+1]*2**16+q[I+2]*2**8+q[I+3]}function u(q,I,y){q[y+3]=I,I=I>>>8,q[y+2]=I,I=I>>>8,q[y+1]=I,I=I>>>8,q[y]=I}function a(q,I){return q[I+0]<<0>>>0|q[I+1]<<8>>>0|q[I+2]<<16>>>0|q[I+3]<<24>>>0}function h(q,I,y){q[y+0]=I&255,I=I>>>8,q[y+1]=I&255,I=I>>>8,q[y+2]=I&255,I=I>>>8,q[y+3]=I&255}function f(q,I){return q[I]}function l(q,I,y){q[y]=I}function s(q){return t.$Ce(q,I=>$.concat(I))}function p(q){return t.$Je(q)}function E(q){return t.$Ee(q,I=>$.concat(I))}async function n(q){return q.ended?$.concat(q.buffer):$.concat([...q.buffer,await E(q.stream)])}function o(q){return t.$He(q,I=>$.concat(I))}function i(q){return t.$Ke(q,{data:I=>typeof I=="string"?$.fromString(I):$.wrap(I)},I=>$.concat(I))}function m(q){return t.$Be(I=>$.concat(I),q)}function R(q,I){return t.$Le(q,I,y=>$.concat(y))}function C(q,I){return t.$Me(q,I,y=>$.concat(y))}function v(q){let I=0,y=0,U=0;const D=new Uint8Array(Math.floor(q.length/4*3)),P=Q=>{switch(y){case 3:D[U++]=I|Q,y=0;break;case 2:D[U++]=I|Q>>>2,I=Q<<6,y=3;break;case 1:D[U++]=I|Q>>>4,I=Q<<4,y=2;break;default:I=Q<<2,y=1}};for(let Q=0;Q<q.length;Q++){const V=q.charCodeAt(Q);if(V>=65&&V<=90)P(V-65);else if(V>=97&&V<=122)P(V-97+26);else if(V>=48&&V<=57)P(V-48+52);else if(V===43||V===45)P(62);else if(V===47||V===95)P(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${q[Q]}`)}}const F=U;for(;y>0;)P(0);return $.wrap(D).slice(0,F)}const _="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function M({buffer:q},I=!0,y=!1){const U=y?k:_;let D="";const P=q.byteLength%3;let F=0;for(;F<q.byteLength-P;F+=3){const Q=q[F+0],V=q[F+1],Z=q[F+2];D+=U[Q>>>2],D+=U[(Q<<4|V>>>4)&63],D+=U[(V<<2|Z>>>6)&63],D+=U[Z&63]}if(P===1){const Q=q[F+0];D+=U[Q>>>2],D+=U[Q<<4&63],I&&(D+="==")}else if(P===2){const Q=q[F+0],V=q[F+1];D+=U[Q>>>2],D+=U[(Q<<4|V>>>4)&63],D+=U[V<<2&63],I&&(D+="=")}return D}}),define(he[52],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(he[9],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=c,e.$fg=t,e.$gg=S,e.$hg=w,e.$ig=B,e.$jg=A,e.$kg=$,e.$lg=r,e.$mg=L,e.$ng=b,e.$og=d,e.$pg=u,e.$qg=a,e.$rg=f,e.$sg=l,e.$tg=s,e.$ug=p,e.$vg=E;function c(n){return typeof n=="string"}function t(n){return Array.isArray(n)&&n.every(o=>c(o))}function S(n){return typeof n=="object"&&n!==null&&!Array.isArray(n)&&!(n instanceof RegExp)&&!(n instanceof Date)}function w(n){const o=Object.getPrototypeOf(Uint8Array);return typeof n=="object"&&n instanceof o}function B(n){return typeof n=="number"&&!isNaN(n)}function A(n){return!!n&&typeof n[Symbol.iterator]=="function"}function $(n){return n===!0||n===!1}function r(n){return typeof n>"u"}function L(n){return!b(n)}function b(n){return r(n)||n===null}function d(n,o){if(!n)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}function u(n){if(b(n))throw new Error("Assertion Failed: argument is undefined or null");return n}function a(...n){const o=[];for(let i=0;i<n.length;i++){const m=n[i];if(b(m))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);o.push(m)}return o}const h=Object.prototype.hasOwnProperty;function f(n){if(!S(n))return!1;for(const o in n)if(h.call(n,o))return!1;return!0}function l(n){return typeof n=="function"}function s(...n){return n.length>0&&n.every(l)}function p(n,o){const i=Math.min(n.length,o.length);for(let m=0;m<i;m++)E(n[m],o[m])}function E(n,o){if(c(o)){if(typeof n!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(l(o)){try{if(n instanceof o)return}catch{}if(!b(n)&&n.constructor===o||o.length===1&&o.call(void 0,n)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(he[33],fe([0,1,9]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=t,e.$eo=S,e.$fo=B,e.$go=$,e.$ho=r,e.$io=L,e.$jo=b,e.$ko=d,e.$lo=u,e.$mo=a,e.$no=h,e.$oo=f,e.$po=l;function t(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const p=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([E,n])=>{p[E]=n&&typeof n=="object"?t(n):n}),p}function S(s){if(!s||typeof s!="object")return s;const p=[s];for(;p.length>0;){const E=p.shift();Object.freeze(E);for(const n in E)if(w.call(E,n)){const o=E[n];typeof o=="object"&&!Object.isFrozen(o)&&!(0,c.$hg)(o)&&p.push(o)}}return s}const w=Object.prototype.hasOwnProperty;function B(s,p){return A(s,p,new Set)}function A(s,p,E){if((0,c.$ng)(s))return s;const n=p(s);if(typeof n<"u")return n;if(Array.isArray(s)){const o=[];for(const i of s)o.push(A(i,p,E));return o}if((0,c.$gg)(s)){if(E.has(s))throw new Error("Cannot clone recursive data-structure");E.add(s);const o={};for(const i in s)w.call(s,i)&&(o[i]=A(s[i],p,E));return E.delete(s),o}return s}function $(s,p,E=!0){return(0,c.$gg)(s)?((0,c.$gg)(p)&&Object.keys(p).forEach(n=>{n in s?E&&((0,c.$gg)(s[n])&&(0,c.$gg)(p[n])?$(s[n],p[n],E):s[n]=p[n]):s[n]=p[n]}),s):p}function r(s,p){if(s===p)return!0;if(s==null||p===null||p===void 0||typeof s!=typeof p||typeof s!="object"||Array.isArray(s)!==Array.isArray(p))return!1;let E,n;if(Array.isArray(s)){if(s.length!==p.length)return!1;for(E=0;E<s.length;E++)if(!r(s[E],p[E]))return!1}else{const o=[];for(n in s)o.push(n);o.sort();const i=[];for(n in p)i.push(n);if(i.sort(),!r(o,i))return!1;for(E=0;E<o.length;E++)if(!r(s[o[E]],p[o[E]]))return!1}return!0}function L(s){const p=new Set;return JSON.stringify(s,(E,n)=>{if((0,c.$gg)(n)||Array.isArray(n)){if(p.has(n))return"[Circular]";p.add(n)}return typeof n=="bigint"?`[BigInt ${n.toString()}]`:n})}function b(s,p){const E=Object.create(null);return!s||!p||Object.keys(p).forEach(o=>{const i=s[o],m=p[o];r(i,m)||(E[o]=m)}),E}function d(s,p){const E=p.toLowerCase(),n=Object.keys(s).find(o=>o.toLowerCase()===E);return n?s[n]:s[p]}function u(s,p){const E=Object.create(null);for(const[n,o]of Object.entries(s))p(n,o)&&(E[n]=o);return E}function a(s){let p=[];for(;Object.prototype!==s;)p=p.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return p}function h(s){const p=[];for(const E of a(s))typeof s[E]=="function"&&p.push(E);return p}function f(s,p){const E=o=>function(){const i=Array.prototype.slice.call(arguments,0);return p(o,i)},n={};for(const o of s)n[o]=E(o);return n}function l(s,p){const E={};for(const[n,o]of Object.entries(s))E[n]=p(o,n);return E}}),define(he[53],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Constants=void 0,e.$af=t,e.$bf=S;var c;(function(w){w[w.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",w[w.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",w[w.MAX_UINT_8=255]="MAX_UINT_8",w[w.MAX_UINT_16=65535]="MAX_UINT_16",w[w.MAX_UINT_32=4294967295]="MAX_UINT_32",w[w.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(c||(e.Constants=c={}));function t(w){return w<0?0:w>c.MAX_UINT_8?c.MAX_UINT_8:w|0}function S(w){return w<0?0:w>c.MAX_UINT_32?c.MAX_UINT_32:w|0}}),define(he[10],fe([0,1,50,13,24,53]),function(ie,e,c,t,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.GraphemeBreakType=e.$4f=e.$Vf=e.$Of=e.$Nf=void 0,e.$cf=B,e.$df=$,e.$ef=L,e.$ff=b,e.$gf=d,e.$hf=u,e.$if=a,e.$jf=h,e.$kf=f,e.$lf=l,e.$mf=s,e.$nf=p,e.$of=E,e.$pf=n,e.$qf=o,e.$rf=i,e.$sf=m,e.$tf=R,e.$uf=C,e.$vf=v,e.$wf=_,e.$xf=k,e.$yf=M,e.$zf=q,e.$Af=I,e.$Bf=y,e.$Cf=U,e.$Df=D,e.$Ef=P,e.$Ff=F,e.$Gf=Q,e.$Hf=V,e.$If=Z,e.$Jf=re,e.$Kf=ae,e.$Lf=X,e.$Mf=j,e.$Pf=W,e.$Qf=ce,e.$Rf=ge,e.$Sf=te,e.$Tf=oe,e.$Uf=K,e.$Wf=T,e.$Xf=O,e.$Yf=H,e.$Zf=x,e.$1f=be,e.$2f=ve,e.$3f=me,e.$5f=de,e.$6f=pe,e.$7f=we,e.$8f=Ee,e.$9f=_e,e.$0f=Pe,e.$$f=Ie,e.$_f=Re,e.$ag=ze;function B(z){return!z||typeof z!="string"?!0:z.trim().length===0}const A=/{(\d+)}/g;function $(z,...Y){return Y.length===0?z:z.replace(A,function(se,ue){const ye=parseInt(ue,10);return isNaN(ye)||ye<0||ye>=Y.length?se:Y[ye]})}const r=/{([^}]+)}/g;function L(z,Y){return Object.keys(Y).length===0?z:z.replace(r,(se,ue)=>Y[ue]??se)}function b(z){return z.replace(/[<>"'&]/g,Y=>{switch(Y){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Y})}function d(z){return z.replace(/[<>&]/g,function(Y){switch(Y){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Y}})}function u(z){return z.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function a(z,Y){let se=0,ue=z.indexOf(Y);for(;ue!==-1;)se++,ue=z.indexOf(Y,ue+Y.length);return se}function h(z,Y,se="\u2026"){return z.length<=Y?z:`${z.substr(0,Y)}${se}`}function f(z,Y,se="\u2026"){if(z.length<=Y)return z;const ue=Math.ceil(Y/2)-se.length/2,ye=Math.floor(Y/2)-se.length/2;return`${z.substr(0,ue)}${se}${z.substr(z.length-ye)}`}function l(z,Y=" "){const se=s(z,Y);return p(se,Y)}function s(z,Y){if(!z||!Y)return z;const se=Y.length;if(se===0||z.length===0)return z;let ue=0;for(;z.indexOf(Y,ue)===ue;)ue=ue+se;return z.substring(ue)}function p(z,Y){if(!z||!Y)return z;const se=Y.length,ue=z.length;if(se===0||ue===0)return z;let ye=ue,Ae=-1;for(;Ae=z.lastIndexOf(Y,ye-1),!(Ae===-1||Ae+se!==ye);){if(Ae===0)return"";ye=Ae}return z.substring(0,ye)}function E(z){return z.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function n(z){return z.replace(/\*/g,"")}function o(z,Y,se={}){if(!z)throw new Error("Cannot create regex from empty string");Y||(z=u(z)),se.wholeWord&&(/\B/.test(z.charAt(0))||(z="\\b"+z),/\B/.test(z.charAt(z.length-1))||(z=z+"\\b"));let ue="";return se.global&&(ue+="g"),se.matchCase||(ue+="i"),se.multiline&&(ue+="m"),se.unicode&&(ue+="u"),new RegExp(z,ue)}function i(z){return z.source==="^"||z.source==="^$"||z.source==="$"||z.source==="^\\s*$"?!1:!!(z.exec("")&&z.lastIndex===0)}function m(z){return z.split(/\r\n|\r|\n/)}function R(z){const Y=[],se=z.split(/(\r\n|\r|\n)/);for(let ue=0;ue<Math.ceil(se.length/2);ue++)Y.push(se[2*ue]+(se[2*ue+1]??""));return Y}function C(z){for(let Y=0,se=z.length;Y<se;Y++){const ue=z.charCodeAt(Y);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return Y}return-1}function v(z,Y=0,se=z.length){for(let ue=Y;ue<se;ue++){const ye=z.charCodeAt(ue);if(ye!==t.CharCode.Space&&ye!==t.CharCode.Tab)return z.substring(Y,ue)}return z.substring(Y,se)}function _(z,Y=z.length-1){for(let se=Y;se>=0;se--){const ue=z.charCodeAt(se);if(ue!==t.CharCode.Space&&ue!==t.CharCode.Tab)return se}return-1}function k(z,Y,se){const ue=[];let ye=0;for(const Ae of z.matchAll(Y)){if(ue.push(z.slice(ye,Ae.index)),Ae.index===void 0)throw new Error("match.index should be defined");ye=Ae.index+Ae[0].length,ue.push(se(Ae[0],...Ae.slice(1),Ae.index,z,Ae.groups))}return ue.push(z.slice(ye)),Promise.all(ue).then(Ae=>Ae.join(""))}function M(z,Y){return z<Y?-1:z>Y?1:0}function q(z,Y,se=0,ue=z.length,ye=0,Ae=Y.length){for(;se<ue&&ye<Ae;se++,ye++){const Te=z.charCodeAt(se),Ue=Y.charCodeAt(ye);if(Te<Ue)return-1;if(Te>Ue)return 1}const ke=ue-se,Fe=Ae-ye;return ke<Fe?-1:ke>Fe?1:0}function I(z,Y){return y(z,Y,0,z.length,0,Y.length)}function y(z,Y,se=0,ue=z.length,ye=0,Ae=Y.length){for(;se<ue&&ye<Ae;se++,ye++){let Te=z.charCodeAt(se),Ue=Y.charCodeAt(ye);if(Te===Ue)continue;if(Te>=128||Ue>=128)return q(z.toLowerCase(),Y.toLowerCase(),se,ue,ye,Ae);D(Te)&&(Te-=32),D(Ue)&&(Ue-=32);const Oe=Te-Ue;if(Oe!==0)return Oe}const ke=ue-se,Fe=Ae-ye;return ke<Fe?-1:ke>Fe?1:0}function U(z){return z>=t.CharCode.Digit0&&z<=t.CharCode.Digit9}function D(z){return z>=t.CharCode.a&&z<=t.CharCode.z}function P(z){return z>=t.CharCode.A&&z<=t.CharCode.Z}function F(z,Y){return z.length===Y.length&&y(z,Y)===0}function Q(z,Y){const se=Y.length;return Y.length>z.length?!1:y(z,Y,0,se)===0}function V(z,Y){const se=Math.min(z.length,Y.length);let ue;for(ue=0;ue<se;ue++)if(z.charCodeAt(ue)!==Y.charCodeAt(ue))return ue;return se}function Z(z,Y){const se=Math.min(z.length,Y.length);let ue;const ye=z.length-1,Ae=Y.length-1;for(ue=0;ue<se;ue++)if(z.charCodeAt(ye-ue)!==Y.charCodeAt(Ae-ue))return ue;return se}function re(z){return 55296<=z&&z<=56319}function ae(z){return 56320<=z&&z<=57343}function X(z,Y){return(z-55296<<10)+(Y-56320)+65536}function j(z,Y,se){const ue=z.charCodeAt(se);if(re(ue)&&se+1<Y){const ye=z.charCodeAt(se+1);if(ae(ye))return X(ue,ye)}return ue}function J(z,Y){const se=z.charCodeAt(Y-1);if(ae(se)&&Y>1){const ue=z.charCodeAt(Y-2);if(re(ue))return X(ue,se)}return se}class ee{get offset(){return this.e}constructor(Y,se=0){this.c=Y,this.d=Y.length,this.e=se}setOffset(Y){this.e=Y}prevCodePoint(){const Y=J(this.c,this.e);return this.e-=Y>=w.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Y}nextCodePoint(){const Y=j(this.c,this.d,this.e);return this.e+=Y>=w.Constants.UNICODE_SUPPLEMENTARY_PLANE_BEGIN?2:1,Y}eol(){return this.e>=this.d}}e.$Nf=ee;class le{get offset(){return this.c.offset}constructor(Y,se=0){this.c=new ee(Y,se)}nextGraphemeLength(){const Y=Me.getInstance(),se=this.c,ue=se.offset;let ye=Y.getGraphemeBreakType(se.nextCodePoint());for(;!se.eol();){const Ae=se.offset,ke=Y.getGraphemeBreakType(se.nextCodePoint());if(Ce(ye,ke)){se.setOffset(Ae);break}ye=ke}return se.offset-ue}prevGraphemeLength(){const Y=Me.getInstance(),se=this.c,ue=se.offset;let ye=Y.getGraphemeBreakType(se.prevCodePoint());for(;se.offset>0;){const Ae=se.offset,ke=Y.getGraphemeBreakType(se.prevCodePoint());if(Ce(ke,ye)){se.setOffset(Ae);break}ye=ke}return ue-se.offset}eol(){return this.c.eol()}}e.$Of=le;function W(z,Y){return new le(z,Y).nextGraphemeLength()}function ce(z,Y){return new le(z,Y).prevGraphemeLength()}function ge(z,Y){Y>0&&ae(z.charCodeAt(Y))&&Y--;const se=Y+W(z,Y);return[se-ce(z,se),se]}function te(z){const Y=new le(z);let se=0;for(;!Y.eol();)se++,Y.nextGraphemeLength();return se}let g;function G(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function oe(z){return g||(g=G()),g.test(z)}const N=/^[\t\n\r\x20-\x7E]*$/;function K(z){return N.test(z)}e.$Vf=/[\u2028\u2029]/;function T(z){return e.$Vf.test(z)}function O(z){return z>=11904&&z<=55215||z>=63744&&z<=64255||z>=65281&&z<=65374}function H(z){return z>=127462&&z<=127487||z===8986||z===8987||z===9200||z===9203||z>=9728&&z<=10175||z===11088||z===11093||z>=127744&&z<=128591||z>=128640&&z<=128764||z>=128992&&z<=129008||z>=129280&&z<=129535||z>=129648&&z<=129782}function x(z,Y,se=""){const ue=z.trimStart();if(ue.length<Y)return ue;const ye=/\b/g;let Ae=0;for(;ye.test(ue)&&!(ue.length-ye.lastIndex<Y);)Ae=ye.lastIndex,ye.lastIndex+=1;return Ae===0?ue:se+ue.substring(Ae).trimStart()}const ne=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*be(z){let Y=0;for(const se of z.matchAll(ne))Y!==se.index&&(yield{isCode:!1,str:z.substring(Y,se.index)}),yield{isCode:!0,str:se[0]},Y=se.index+se[0].length;Y!==z.length&&(yield{isCode:!1,str:z.substring(Y)})}function ve(z){return z&&(z=z.replace(ne,"")),z}const De=/\\\[.*?\\\]/g;function me(z){return ve(z).replace(De,"")}e.$4f=String.fromCharCode(t.CharCode.UTF8_BOM);function de(z){return!!(z&&z.length>0&&z.charCodeAt(0)===t.CharCode.UTF8_BOM)}function pe(z){return de(z)?z.substr(1):z}function we(z,Y){if(!z||!Y||z.length<Y.length)return!1;const se=Y.length,ue=z.toLowerCase();let ye=0,Ae=-1;for(;ye<se;){const ke=ue.indexOf(Y[ye],Ae+1);if(ke<0)return!1;Ae=ke,ye++}return!0}function Ee(z,Y=!1){return z?(Y&&(z=z.replace(/\\./g,"")),z.toLowerCase()!==z):!1}function _e(z){return z.charAt(0).toUpperCase()+z.slice(1)}function Pe(z,Y=1){if(Y===0)return"";let se=-1;do se=z.indexOf(`
`,se+1),Y--;while(Y>0&&se>=0);return se===-1?z:(z[se-1]==="\r"&&se--,z.substr(0,se))}function Ie(z){const Y=t.CharCode.Z-t.CharCode.A+1;return z=z%(2*Y),z<Y?String.fromCharCode(t.CharCode.a+z):String.fromCharCode(t.CharCode.A+z-Y)}function Re(z){return Me.getInstance().getGraphemeBreakType(z)}function Ce(z,Y){return z===Le.Other?Y!==Le.Extend&&Y!==Le.SpacingMark:z===Le.CR&&Y===Le.LF?!1:z===Le.Control||z===Le.CR||z===Le.LF||Y===Le.Control||Y===Le.CR||Y===Le.LF?!0:!(z===Le.L&&(Y===Le.L||Y===Le.V||Y===Le.LV||Y===Le.LVT)||(z===Le.LV||z===Le.V)&&(Y===Le.V||Y===Le.T)||(z===Le.LVT||z===Le.T)&&Y===Le.T||Y===Le.Extend||Y===Le.ZWJ||Y===Le.SpacingMark||z===Le.Prepend||z===Le.ZWJ&&Y===Le.Extended_Pictographic||z===Le.Regional_Indicator&&Y===Le.Regional_Indicator)}var Le;(function(z){z[z.Other=0]="Other",z[z.Prepend=1]="Prepend",z[z.CR=2]="CR",z[z.LF=3]="LF",z[z.Control=4]="Control",z[z.Extend=5]="Extend",z[z.Regional_Indicator=6]="Regional_Indicator",z[z.SpacingMark=7]="SpacingMark",z[z.L=8]="L",z[z.V=9]="V",z[z.T=10]="T",z[z.LV=11]="LV",z[z.LVT=12]="LVT",z[z.ZWJ=13]="ZWJ",z[z.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=He()}getGraphemeBreakType(Y){if(Y<32)return Y===t.CharCode.LineFeed?Le.LF:Y===t.CharCode.CarriageReturn?Le.CR:Le.Control;if(Y<127)return Le.Other;const se=this.d,ue=se.length/3;let ye=1;for(;ye<=ue;)if(Y<se[3*ye])ye=2*ye;else if(Y>se[3*ye+1])ye=2*ye+1;else return se[3*ye+2];return Le.Other}}function He(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(z,Y){if(z===0)return 0;const se=Ke(z,Y);if(se!==void 0)return se;const ue=new ee(Y,z);return ue.prevCodePoint(),ue.offset}function Ke(z,Y){const se=new ee(Y,z);let ue=se.prevCodePoint();for(;Ye(ue)||ue===Ge.emojiVariantSelector||ue===Ge.enclosingKeyCap;){if(se.offset===0)return;ue=se.prevCodePoint()}if(!H(ue))return;let ye=se.offset;return ye>0&&se.prevCodePoint()===Ge.zwj&&(ye=se.offset),ye}function Ye(z){return 127995<=z&&z<=127999}var Ge;(function(z){z[z.zwj=8205]="zwj",z[z.emojiVariantSelector=65039]="emojiVariantSelector",z[z.enclosingKeyCap=8419]="enclosingKeyCap"})(Ge||(Ge={})),e.$bg="\xA0";class We{static{this.c=new S.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new c.$$e({getCacheKey:JSON.stringify},Y=>{function se(Oe){const je=new Map;for(let Ne=0;Ne<Oe.length;Ne+=2)je.set(Oe[Ne],Oe[Ne+1]);return je}function ue(Oe,je){const Ne=new Map(Oe);for(const[Ve,Je]of je)Ne.set(Ve,Je);return Ne}function ye(Oe,je){if(!Oe)return je;const Ne=new Map;for(const[Ve,Je]of Oe)je.has(Ve)&&Ne.set(Ve,Je);return Ne}const Ae=this.c.value;let ke=Y.filter(Oe=>!Oe.startsWith("_")&&Oe in Ae);ke.length===0&&(ke=["_default"]);let Fe;for(const Oe of ke){const je=se(Ae[Oe]);Fe=ye(Fe,je)}const Te=se(Ae._common),Ue=ue(Te,Fe);return new We(Ue)})}static getInstance(Y){return We.d.get(Array.from(Y))}static{this.e=new S.$T(()=>Object.keys(We.c.value).filter(Y=>!Y.startsWith("_")))}static getLocales(){return We.e.value}constructor(Y){this.f=Y}isAmbiguous(Y){return this.f.has(Y)}containsAmbiguousCharacter(Y){for(let se=0;se<Y.length;se++){const ue=Y.codePointAt(se);if(typeof ue=="number"&&this.isAmbiguous(ue))return!0}return!1}getPrimaryConfusable(Y){return this.f.get(Y)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$cg=We;class qe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(qe.c())),this.d}static isInvisibleCharacter(Y){return qe.e().has(Y)}static containsInvisibleCharacter(Y){for(let se=0;se<Y.length;se++){const ue=Y.codePointAt(se);if(typeof ue=="number"&&qe.isInvisibleCharacter(ue))return!0}return!1}static get codePoints(){return qe.e()}}e.$dg=qe}),define(he[34],fe([0,1,13,5,3,10,9]),function(ie,e,c,t,S,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=A,e.$xg=$,e.$yg=r,e.$zg=L,e.$Ag=b,e.$Bg=h,e.$Cg=f,e.$Dg=l,e.$Eg=s,e.$Fg=p,e.$Gg=E,e.$Hg=n,e.$Ig=o,e.$Jg=i,e.$Kg=m,e.$Lg=R,e.$Mg=_;function A(k){return k===c.CharCode.Slash||k===c.CharCode.Backslash}function $(k){return k.replace(/[\\/]/g,t.$gc.sep)}function r(k){return k.indexOf("/")===-1&&(k=$(k)),/^[a-zA-Z]:(\/|$)/.test(k)&&(k="/"+k),k}function L(k,M=t.$gc.sep){if(!k)return"";const q=k.length,I=k.charCodeAt(0);if(A(I)){if(A(k.charCodeAt(1))&&!A(k.charCodeAt(2))){let U=3;const D=U;for(;U<q&&!A(k.charCodeAt(U));U++);if(D!==U&&!A(k.charCodeAt(U+1))){for(U+=1;U<q;U++)if(A(k.charCodeAt(U)))return k.slice(0,U+1).replace(/[\\/]/g,M)}}return M}else if(s(I)&&k.charCodeAt(1)===c.CharCode.Colon)return A(k.charCodeAt(2))?k.slice(0,2)+M:k.slice(0,2);let y=k.indexOf("://");if(y!==-1){for(y+=3;y<q;y++)if(A(k.charCodeAt(y)))return k.slice(0,y+1)}return""}function b(k){if(!S.$j||!k||k.length<5)return!1;let M=k.charCodeAt(0);if(M!==c.CharCode.Backslash||(M=k.charCodeAt(1),M!==c.CharCode.Backslash))return!1;let q=2;const I=q;for(;q<k.length&&(M=k.charCodeAt(q),M!==c.CharCode.Backslash);q++);return!(I===q||(M=k.charCodeAt(q+1),isNaN(M)||M===c.CharCode.Backslash))}const d=/[\\/:\*\?"<>\|]/g,u=/[/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(k,M=S.$j){const q=M?d:u;return!(!k||k.length===0||/^\s+$/.test(k)||(q.lastIndex=0,q.test(k))||M&&a.test(k)||k==="."||k===".."||M&&k[k.length-1]==="."||M&&k.length!==k.trim().length||k.length>255)}function f(k,M,q){const I=k===M;return!q||I?I:!k||!M?!1:(0,w.$Ff)(k,M)}function l(k,M,q,I=t.sep){if(k===M)return!0;if(!k||!M||M.length>k.length)return!1;if(q){if(!(0,w.$Gf)(k,M))return!1;if(M.length===k.length)return!0;let U=M.length;return M.charAt(M.length-1)===I&&U--,k.charAt(U)===I}return M.charAt(M.length-1)!==I&&(M+=I),k.indexOf(M)===0}function s(k){return k>=c.CharCode.A&&k<=c.CharCode.Z||k>=c.CharCode.a&&k<=c.CharCode.z}function p(k,M){return S.$j&&k.endsWith(":")&&(k+=t.sep),(0,t.$ic)(k)||(k=(0,t.$jc)(M,k)),k=(0,t.$hc)(k),E(k)}function E(k){return S.$j?(k=(0,w.$nf)(k,t.sep),k.endsWith(":")&&(k+=t.sep)):(k=(0,w.$nf)(k,t.sep),k||(k=t.sep)),k}function n(k){const M=(0,t.$hc)(k);return S.$j?k.length>3?!1:o(M)&&(k.length===2||M.charCodeAt(2)===c.CharCode.Backslash):M===t.$gc.sep}function o(k,M=S.$j){return M?s(k.charCodeAt(0))&&k.charCodeAt(1)===c.CharCode.Colon:!1}function i(k,M=S.$j){return o(k,M)?k[0]:void 0}function m(k,M,q){return M.length>k.length?-1:k===M?0:(q&&(k=k.toLowerCase(),M=M.toLowerCase()),k.indexOf(M))}function R(k){const M=k.split(":");let q,I,y;for(const U of M){const D=Number(U);(0,B.$ig)(D)?I===void 0?I=D:y===void 0&&(y=D):q=q?[q,U].join(":"):U}if(!q)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:q,line:I!==void 0?I:void 0,column:y!==void 0?y:I!==void 0?1:void 0}}const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",v="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function _(k,M,q=8){let I="";for(let U=0;U<q;U++){let D;U===0&&S.$j&&!M&&(q===3||q===4)?D=v:D=C,I+=D.charAt(Math.floor(Math.random()*D.length))}let y;return M?y=`${M}-${I}`:y=I,k?(0,t.$jc)(k,y):y}}),define(he[54],fe([0,1,10]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$wj=void 0,e.$sj=t,e.$tj=S,e.$uj=w,e.$vj=A,e.$xj=h,c=Se(c);function t(l){return S(l,0)}function S(l,s){switch(typeof l){case"object":return l===null?w(349,s):Array.isArray(l)?$(l,s):r(l,s);case"string":return A(l,s);case"boolean":return B(l,s);case"number":return w(l,s);case"undefined":return w(937,s);default:return w(617,s)}}function w(l,s){return(s<<5)-s+l|0}function B(l,s){return w(l?433:863,s)}function A(l,s){s=w(149417,s);for(let p=0,E=l.length;p<E;p++)s=w(l.charCodeAt(p),s);return s}function $(l,s){return s=w(104579,s),l.reduce((p,E)=>S(E,p),s)}function r(l,s){return s=w(181387,s),Object.keys(l).sort().reduce((p,E)=>(p=A(E,p),S(l[E],p)),s)}class L{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=S(s,this.g),this.g}}e.$wj=L;var b;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function d(l,s,p=32){const E=p-s,n=~((1<<E)-1);return(l<<s|(n&l)>>>E)>>>0}function u(l,s=0,p=l.byteLength,E=0){for(let n=0;n<p;n++)l[s+n]=E}function a(l,s,p="0"){for(;l.length<s;)l=p+l;return l}function h(l,s=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(p=>p.toString(16).padStart(2,"0")).join(""):a((l>>>0).toString(16),s/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(b.BLOCK_SIZE+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const p=s.length;if(p===0)return;const E=this.p;let n=this.r,o=this.u,i,m;for(o!==0?(i=o,m=-1,o=0):(i=s.charCodeAt(0),m=0);;){let R=i;if(c.$Jf(i))if(m+1<p){const C=s.charCodeAt(m+1);c.$Kf(C)?(m++,R=c.$Lf(i,C)):R=b.UNICODE_REPLACEMENT}else{o=i;break}else c.$Kf(i)&&(R=b.UNICODE_REPLACEMENT);if(n=this.w(E,n,R),m++,m<p)i=s.charCodeAt(m);else break}this.r=n,this.u=o}w(s,p,E){return E<128?s[p++]=E:E<2048?(s[p++]=192|(E&1984)>>>6,s[p++]=128|(E&63)>>>0):E<65536?(s[p++]=224|(E&61440)>>>12,s[p++]=128|(E&4032)>>>6,s[p++]=128|(E&63)>>>0):(s[p++]=240|(E&1835008)>>>18,s[p++]=128|(E&258048)>>>12,s[p++]=128|(E&4032)>>>6,s[p++]=128|(E&63)>>>0),p>=b.BLOCK_SIZE&&(this.y(),p-=b.BLOCK_SIZE,this.t+=b.BLOCK_SIZE,s[0]=s[b.BLOCK_SIZE+0],s[1]=s[b.BLOCK_SIZE+1],s[2]=s[b.BLOCK_SIZE+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,b.UNICODE_REPLACEMENT)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=f.g,p=this.q;for(let _=0;_<64;_+=4)s.setUint32(_,p.getUint32(_,!1),!1);for(let _=64;_<320;_+=4)s.setUint32(_,d(s.getUint32(_-12,!1)^s.getUint32(_-32,!1)^s.getUint32(_-56,!1)^s.getUint32(_-64,!1),1),!1);let E=this.h,n=this.l,o=this.m,i=this.n,m=this.o,R,C,v;for(let _=0;_<80;_++)_<20?(R=n&o|~n&i,C=1518500249):_<40?(R=n^o^i,C=1859775393):_<60?(R=n&o|n&i|o&i,C=2400959708):(R=n^o^i,C=3395469782),v=d(E,5)+R+m+C+s.getUint32(_*4,!1)&4294967295,m=i,i=o,o=d(n,30),n=E,E=v;this.h=this.h+E&4294967295,this.l=this.l+n&4294967295,this.m=this.m+o&4294967295,this.n=this.n+i&4294967295,this.o=this.o+m&4294967295}}e.$yj=f}),define(he[55],fe([0,1,17,13,10]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class w{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const h=a.charCodeAt(0),f=this.b.charCodeAt(this.c);return h-f}value(){return this.b[this.c]}}e.$Gi=w;class B{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===t.CharCode.Period)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,S.$zf)(a,this.b,0,a.length,this.c,this.d):(0,S.$Bf)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=B;class A{constructor(a=!0,h=!0){this.f=a,this.g=h}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let h=a.length-1;h>=0;h--,this.c--){const f=this.b.charCodeAt(h);if(!(f===t.CharCode.Slash||this.f&&f===t.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const h=this.b.charCodeAt(this.e);if(h===t.CharCode.Slash||this.f&&h===t.CharCode.Backslash)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,S.$zf)(a,this.b,0,a.length,this.d,this.e):(0,S.$Bf)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=A;var $;(function(u){u[u.Scheme=1]="Scheme",u[u.Authority=2]="Authority",u[u.Path=3]="Path",u[u.Query=4]="Query",u[u.Fragment=5]="Fragment"})($||($={}));class r{constructor(a,h){this.f=a,this.g=h,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push($.Scheme),this.c.authority&&this.d.push($.Authority),this.c.path&&(this.b=new A(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push($.Path)),this.g(a)||(this.c.query&&this.d.push($.Query),this.c.fragment&&this.d.push($.Fragment)),this.e=0,this}next(){return this.d[this.e]===$.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===$.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===$.Scheme)return(0,S.$Af)(a,this.c.scheme);if(this.d[this.e]===$.Authority)return(0,S.$Af)(a,this.c.authority);if(this.d[this.e]===$.Path)return this.b.cmp(a);if(this.d[this.e]===$.Query)return(0,S.$yf)(a,this.c.query);if(this.d[this.e]===$.Fragment)return(0,S.$yf)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===$.Scheme)return this.c.scheme;if(this.d[this.e]===$.Authority)return this.c.authority;if(this.d[this.e]===$.Path)return this.b.value();if(this.d[this.e]===$.Query)return this.c.query;if(this.d[this.e]===$.Fragment)return this.c.fragment;throw new Error}}e.$Ji=r;class L{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var b;(function(u){u[u.Left=-1]="Left",u[u.Mid=0]="Mid",u[u.Right=1]="Right"})(b||(b={}));class d{static forUris(a=()=>!1,h=()=>!1){return new d(new r(a,h))}static forPaths(a=!1){return new d(new A(void 0,!a))}static forStrings(){return new d(new w)}static forConfigKeys(){return new d(new B)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,h){if(h){const f=h.slice(0);(0,c.$Vb)(f);for(const l of f)this.set(l,a)}else{const f=a.slice(0);(0,c.$Vb)(f);for(const l of f)this.set(l[0],l[1])}}set(a,h){const f=this.b.reset(a);let l;this.c||(this.c=new L,this.c.segment=f.value());const s=[];for(l=this.c;;){const E=f.cmp(l.segment);if(E>0)l.left||(l.left=new L,l.left.segment=f.value()),s.push([b.Left,l]),l=l.left;else if(E<0)l.right||(l.right=new L,l.right.segment=f.value()),s.push([b.Right,l]),l=l.right;else if(f.hasNext())f.next(),l.mid||(l.mid=new L,l.mid.segment=f.value()),s.push([b.Mid,l]),l=l.mid;else break}const p=l.value;l.value=h,l.key=a;for(let E=s.length-1;E>=0;E--){const n=s[E][1];n.updateHeight();const o=n.balanceFactor();if(o<-1||o>1){const i=s[E][0],m=s[E+1][0];if(i===b.Right&&m===b.Right)s[E][1]=n.rotateLeft();else if(i===b.Left&&m===b.Left)s[E][1]=n.rotateRight();else if(i===b.Right&&m===b.Left)n.right=s[E+1][1]=s[E+1][1].rotateRight(),s[E][1]=n.rotateLeft();else if(i===b.Left&&m===b.Right)n.left=s[E+1][1]=s[E+1][1].rotateLeft(),s[E][1]=n.rotateRight();else throw new Error;if(E>0)switch(s[E-1][0]){case b.Left:s[E-1][1].left=s[E][1];break;case b.Right:s[E-1][1].right=s[E][1];break;case b.Mid:s[E-1][1].mid=s[E][1];break}else this.c=s[0][1]}}return p}get(a){return this.d(a)?.value}d(a){const h=this.b.reset(a);let f=this.c;for(;f;){const l=h.cmp(f.segment);if(l>0)f=f.left;else if(l<0)f=f.right;else if(h.hasNext())h.next(),f=f.mid;else break}return f}has(a){const h=this.d(a);return!(h?.value===void 0&&h?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,h){const f=this.b.reset(a),l=[];let s=this.c;for(;s;){const p=f.cmp(s.segment);if(p>0)l.push([b.Left,s]),s=s.left;else if(p<0)l.push([b.Right,s]),s=s.right;else if(f.hasNext())f.next(),l.push([b.Mid,s]),s=s.mid;else break}if(s){if(h?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const p=this.f(s.right);if(p.key){const{key:E,value:n,segment:o}=p;this.e(p.key,!1),s.key=E,s.value=n,s.segment=o}}else{const p=s.left??s.right;if(l.length>0){const[E,n]=l[l.length-1];switch(E){case b.Left:n.left=p;break;case b.Mid:n.mid=p;break;case b.Right:n.right=p;break}}else this.c=p}for(let p=l.length-1;p>=0;p--){const E=l[p][1];E.updateHeight();const n=E.balanceFactor();if(n>1?(E.right.balanceFactor()>=0||(E.right=E.right.rotateRight()),l[p][1]=E.rotateLeft()):n<-1&&(E.left.balanceFactor()<=0||(E.left=E.left.rotateLeft()),l[p][1]=E.rotateRight()),p>0)switch(l[p-1][0]){case b.Left:l[p-1][1].left=l[p][1];break;case b.Right:l[p-1][1].right=l[p][1];break;case b.Mid:l[p-1][1].mid=l[p][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const h=this.b.reset(a);let f=this.c,l;for(;f;){const s=h.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(h.hasNext())h.next(),l=f.value||l,f=f.mid;else break}return f&&f.value||l}findSuperstr(a){return this.g(a,!1)}g(a,h){const f=this.b.reset(a);let l=this.c;for(;l;){const s=f.cmp(l.segment);if(s>0)l=l.left;else if(s<0)l=l.right;else if(f.hasNext())f.next(),l=l.mid;else return l.mid?this.h(l.mid):h?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[h,f]of this)a(f,h)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const h=[];return this.j(a,h),h[Symbol.iterator]()}j(a,h){a&&(a.left&&this.j(a.left,h),a.value&&h.push([a.key,a.value]),a.mid&&this.j(a.mid,h),a.right&&this.j(a.right,h))}_isBalanced(){const a=h=>{if(!h)return!0;const f=h.balanceFactor();return f<-1||f>1?!1:a(h.left)&&a(h.right)};return a(this.c)}}e.$Ki=d}),define(he[6],fe([0,1,13,27,5,3]),function(ie,e,c,t,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=f,e.$wc=o,S=Se(S);const B=/^\w[\w\d+.-]*$/,A=/^\//,$=/^\/\//;function r(v,_){if(!v.scheme&&_)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${v.authority}", path: "${v.path}", query: "${v.query}", fragment: "${v.fragment}"}`);if(v.scheme&&!B.test(v.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(v.path){if(v.authority){if(!A.test(v.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if($.test(v.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function L(v,_){return!v&&!_?"file":v}function b(v,_){switch(v){case"https":case"http":case"file":_?_[0]!==u&&(_=u+_):_=u;break}return _}const d="",u="/",a=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(_){return _ instanceof h?!0:_?typeof _.authority=="string"&&typeof _.fragment=="string"&&typeof _.path=="string"&&typeof _.query=="string"&&typeof _.scheme=="string"&&typeof _.fsPath=="string"&&typeof _.with=="function"&&typeof _.toString=="function":!1}constructor(_,k,M,q,I,y=!1){typeof _=="object"?(this.scheme=_.scheme||d,this.authority=_.authority||d,this.path=_.path||d,this.query=_.query||d,this.fragment=_.fragment||d):(this.scheme=L(_,y),this.authority=k||d,this.path=b(this.scheme,M||d),this.query=q||d,this.fragment=I||d,r(this,y))}get fsPath(){return o(this,!1)}with(_){if(!_)return this;let{scheme:k,authority:M,path:q,query:I,fragment:y}=_;return k===void 0?k=this.scheme:k===null&&(k=d),M===void 0?M=this.authority:M===null&&(M=d),q===void 0?q=this.path:q===null&&(q=d),I===void 0?I=this.query:I===null&&(I=d),y===void 0?y=this.fragment:y===null&&(y=d),k===this.scheme&&M===this.authority&&q===this.path&&I===this.query&&y===this.fragment?this:new s(k,M,q,I,y)}static parse(_,k=!1){const M=a.exec(_);return M?new s(M[2]||d,C(M[4]||d),C(M[5]||d),C(M[7]||d),C(M[9]||d),k):new s(d,d,d,d,d)}static file(_){let k=d;if(w.$j&&(_=_.replace(/\\/g,u)),_[0]===u&&_[1]===u){const M=_.indexOf(u,2);M===-1?(k=_.substring(2),_=u):(k=_.substring(2,M),_=_.substring(M)||u)}return new s("file",k,_,d,d)}static from(_,k){return new s(_.scheme,_.authority,_.path,_.query,_.fragment,k)}static joinPath(_,...k){if(!_.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let M;return w.$j&&_.scheme==="file"?M=h.file(S.$fc.join(o(_,!0),...k)).path:M=S.$gc.join(_.path,...k),_.with({path:M})}toString(_=!1){return i(this,_)}toJSON(){return this}static revive(_){if(_){if(_ instanceof h)return _;{const k=new s(_);return k._formatted=_.external??null,k._fsPath=_._sep===l?_.fsPath??null:null,k}}else return _}[Symbol.for("debug.description")](){return`URI(${this.toString()})`}}e.URI=h;function f(v){return!v||typeof v!="object"?!1:typeof v.scheme=="string"&&(typeof v.authority=="string"||typeof v.authority>"u")&&(typeof v.path=="string"||typeof v.path>"u")&&(typeof v.query=="string"||typeof v.query>"u")&&(typeof v.fragment=="string"||typeof v.fragment>"u")}const l=w.$j?1:void 0;class s extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(_=!1){return _?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const _={$mid:t.MarshalledId.Uri};return this._fsPath&&(_.fsPath=this._fsPath,_._sep=l),this._formatted&&(_.external=this._formatted),this.path&&(_.path=this.path),this.scheme&&(_.scheme=this.scheme),this.authority&&(_.authority=this.authority),this.query&&(_.query=this.query),this.fragment&&(_.fragment=this.fragment),_}}const p={[c.CharCode.Colon]:"%3A",[c.CharCode.Slash]:"%2F",[c.CharCode.QuestionMark]:"%3F",[c.CharCode.Hash]:"%23",[c.CharCode.OpenSquareBracket]:"%5B",[c.CharCode.CloseSquareBracket]:"%5D",[c.CharCode.AtSign]:"%40",[c.CharCode.ExclamationMark]:"%21",[c.CharCode.DollarSign]:"%24",[c.CharCode.Ampersand]:"%26",[c.CharCode.SingleQuote]:"%27",[c.CharCode.OpenParen]:"%28",[c.CharCode.CloseParen]:"%29",[c.CharCode.Asterisk]:"%2A",[c.CharCode.Plus]:"%2B",[c.CharCode.Comma]:"%2C",[c.CharCode.Semicolon]:"%3B",[c.CharCode.Equals]:"%3D",[c.CharCode.Space]:"%20"};function E(v,_,k){let M,q=-1;for(let I=0;I<v.length;I++){const y=v.charCodeAt(I);if(y>=c.CharCode.a&&y<=c.CharCode.z||y>=c.CharCode.A&&y<=c.CharCode.Z||y>=c.CharCode.Digit0&&y<=c.CharCode.Digit9||y===c.CharCode.Dash||y===c.CharCode.Period||y===c.CharCode.Underline||y===c.CharCode.Tilde||_&&y===c.CharCode.Slash||k&&y===c.CharCode.OpenSquareBracket||k&&y===c.CharCode.CloseSquareBracket||k&&y===c.CharCode.Colon)q!==-1&&(M+=encodeURIComponent(v.substring(q,I)),q=-1),M!==void 0&&(M+=v.charAt(I));else{M===void 0&&(M=v.substr(0,I));const U=p[y];U!==void 0?(q!==-1&&(M+=encodeURIComponent(v.substring(q,I)),q=-1),M+=U):q===-1&&(q=I)}}return q!==-1&&(M+=encodeURIComponent(v.substring(q))),M!==void 0?M:v}function n(v){let _;for(let k=0;k<v.length;k++){const M=v.charCodeAt(k);M===c.CharCode.Hash||M===c.CharCode.QuestionMark?(_===void 0&&(_=v.substr(0,k)),_+=p[M]):_!==void 0&&(_+=v[k])}return _!==void 0?_:v}function o(v,_){let k;return v.authority&&v.path.length>1&&v.scheme==="file"?k=`//${v.authority}${v.path}`:v.path.charCodeAt(0)===c.CharCode.Slash&&(v.path.charCodeAt(1)>=c.CharCode.A&&v.path.charCodeAt(1)<=c.CharCode.Z||v.path.charCodeAt(1)>=c.CharCode.a&&v.path.charCodeAt(1)<=c.CharCode.z)&&v.path.charCodeAt(2)===c.CharCode.Colon?_?k=v.path.substr(1):k=v.path[1].toLowerCase()+v.path.substr(2):k=v.path,w.$j&&(k=k.replace(/\//g,"\\")),k}function i(v,_){const k=_?n:E;let M="",{scheme:q,authority:I,path:y,query:U,fragment:D}=v;if(q&&(M+=q,M+=":"),(I||q==="file")&&(M+=u,M+=u),I){let P=I.indexOf("@");if(P!==-1){const F=I.substr(0,P);I=I.substr(P+1),P=F.lastIndexOf(":"),P===-1?M+=k(F,!1,!1):(M+=k(F.substr(0,P),!1,!1),M+=":",M+=k(F.substr(P+1),!1,!0)),M+="@"}I=I.toLowerCase(),P=I.lastIndexOf(":"),P===-1?M+=k(I,!1,!0):(M+=k(I.substr(0,P),!1,!0),M+=I.substr(P))}if(y){if(y.length>=3&&y.charCodeAt(0)===c.CharCode.Slash&&y.charCodeAt(2)===c.CharCode.Colon){const P=y.charCodeAt(1);P>=c.CharCode.A&&P<=c.CharCode.Z&&(y=`/${String.fromCharCode(P+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===c.CharCode.Colon){const P=y.charCodeAt(0);P>=c.CharCode.A&&P<=c.CharCode.Z&&(y=`${String.fromCharCode(P+32)}:${y.substr(2)}`)}M+=k(y,!0,!1)}return U&&(M+="?",M+=k(U,!1,!1)),D&&(M+="#",M+=_?D:E(D,!1,!1)),M}function m(v){try{return decodeURIComponent(v)}catch{return v.length>3?v.substr(0,3)+m(v.substr(3)):v}}const R=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function C(v){return v.match(R)?v.replace(R,_=>m(_)):v}}),define(he[56],fe([0,1,6]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=t,e.$dr=S,e.$er=w,e.log=A;function t(r){const L=r;return L&&typeof L.type=="string"&&typeof L.severity=="string"}function S(r){const L=[];let b;try{const d=JSON.parse(r.arguments),u=d[d.length-1];u&&u.__$stack&&(d.pop(),b=u.__$stack),L.push(...d)}catch{L.push("Unable to log remote console arguments",r.arguments)}return{args:L,stack:b}}function w(r){if(typeof r!="string")return w(S(r).stack);const L=r;if(L){const b=B(L),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(d&&d.length===4)return{uri:c.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}function B(r){if(!r)return r;const L=r.indexOf(`
`);return L===-1?r:r.substring(0,L)}function A(r,L){const{args:b,stack:d}=S(r),u=typeof b[0]=="string"&&b.length===1;let a=B(d);a&&(a=`(${a.trim()})`);let h=[];if(typeof b[0]=="string"?a&&u?h=[`%c[${L}] %c${b[0]} %c${a}`,$("blue"),$(""),$("grey")]:h=[`%c[${L}] %c${b[0]}`,$("blue"),$(""),...b.slice(1)]:h=[`%c[${L}]%`,$("blue"),...b],a&&!u&&h.push(a),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,h)}function $(r){return`color: ${r}`}}),define(he[57],fe([0,1,19,6,27]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=w,e.$ai=B,e.$bi=$;function w(r){return JSON.stringify(r,A)}function B(r){let L=JSON.parse(r);return L=$(L),L}function A(r,L){return L instanceof RegExp?{$mid:S.MarshalledId.Regexp,source:L.source,flags:L.flags}:L}function $(r,L=0){if(!r||L>200)return r;if(typeof r=="object"){switch(r.$mid){case S.MarshalledId.Uri:return t.URI.revive(r);case S.MarshalledId.Regexp:return new RegExp(r.source,r.flags);case S.MarshalledId.Date:return new Date(r.source)}if(r instanceof c.$Ne||r instanceof Uint8Array)return r;if(Array.isArray(r))for(let b=0;b<r.length;++b)r[b]=$(r[b],L+1);else for(const b in r)Object.hasOwnProperty.call(r,b)&&(r[b]=$(r[b],L+1))}return r}}),define(he[20],fe([0,1,7,3,10,6,5]),function(ie,e,c,t,S,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=$,e.$Og=r,e.$Sg=b,c=Se(c),t=Se(t),B=Se(B);var A;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",a.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(A||(e.Schemas=A={}));function $(a,h){return w.URI.isUri(a)?(0,S.$Ff)(a.scheme,h):(0,S.$Gf)(a,h+":")}function r(a,...h){return h.some(f=>$(a,f))}e.$Pg="vscode-tkn",e.$Qg="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h,f){this.f=b(h,f)}getServerRootPath(){return this.f}get g(){return B.$gc.join(this.f,A.vscodeRemoteResource)}set(h,f,l){this.a[h]=f,this.b[h]=l}setConnectionToken(h,f){this.c[h]=f}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(n){return c.$Y(n),h}const f=h.authority;let l=this.a[f];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const s=this.b[f],p=this.c[f];let E=`path=${encodeURIComponent(h.path)}`;return typeof p=="string"&&(E+=`&${e.$Qg}=${encodeURIComponent(p)}`),w.URI.from({scheme:t.$p?this.d:A.vscodeRemoteResource,authority:`${l}:${s}`,path:this.g,query:E})}}e.$Rg=new L;function b(a,h){return B.$gc.join(h??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class d{static{this.a=e.$Xg}asBrowserUri(h){const f=this.b(h,ie);return this.uriToBrowserUri(f)}uriToBrowserUri(h){return h.scheme===A.vscodeRemote?e.$Rg.rewrite(h):h.scheme===A.file&&(t.$n||t.$r===`${A.vscodeFileResource}://${d.a}`)?h.with({scheme:A.vscodeFileResource,authority:h.authority||d.a,query:null,fragment:null}):h}asFileUri(h){const f=this.b(h,ie);return this.uriToFileUri(f)}uriToFileUri(h){return h.scheme===A.vscodeFileResource?h.with({scheme:A.file,authority:h.authority!==d.a?h.authority:null,query:null,fragment:null}):h}b(h,f){return w.URI.isUri(h)?h:w.URI.parse(f.toUrl(h))}}e.$Yg=new d;var u;(function(a){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(h.get("3"));const f="vscode-coi";function l(p){let E;typeof p=="string"?E=new URL(p).searchParams:p instanceof URL?E=p.searchParams:w.URI.isUri(p)&&(E=new URL(p.toString(!0)).searchParams);const n=E?.get(f);if(n)return h.get(n)}a.getHeadersFromQuery=l;function s(p,E,n){if(!globalThis.crossOriginIsolated)return;const o=E&&n?"3":n?"2":"1";p instanceof URLSearchParams?p.set(f,o):p[f]=o}a.addSearchParam=s})(u||(e.COI=u={}))}),define(he[25],fe([0,1,13,34,20,5,3,10,6]),function(ie,e,c,t,S,w,B,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=r,e.$oh=b,e.$ph=u,t=Se(t),w=Se(w);function r(a){return(0,$.$wc)(a,!0)}class L{constructor(h){this.a=h}compare(h,f,l=!1){return h===f?0:(0,A.$yf)(this.getComparisonKey(h,l),this.getComparisonKey(f,l))}isEqual(h,f,l=!1){return h===f?!0:!h||!f?!1:this.getComparisonKey(h,l)===this.getComparisonKey(f,l)}getComparisonKey(h,f=!1){return h.with({path:this.a(h)?h.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(h){return this.a(h)}isEqualOrParent(h,f,l=!1){if(h.scheme===f.scheme){if(h.scheme===S.Schemas.file)return t.$Dg(r(h),r(f),this.a(h))&&h.query===f.query&&(l||h.fragment===f.fragment);if((0,e.$kh)(h.authority,f.authority))return t.$Dg(h.path,f.path,this.a(h),"/")&&h.query===f.query&&(l||h.fragment===f.fragment)}return!1}joinPath(h,...f){return $.URI.joinPath(h,...f)}basenameOrAuthority(h){return(0,e.$ch)(h)||h.authority}basename(h){return w.$gc.basename(h.path)}extname(h){return w.$gc.extname(h.path)}dirname(h){if(h.path.length===0)return h;let f;return h.scheme===S.Schemas.file?f=$.URI.file(w.$mc(r(h))).path:(f=w.$gc.dirname(h.path),h.authority&&f.length&&f.charCodeAt(0)!==c.CharCode.Slash&&(console.error(`dirname("${h.toString})) resulted in a relative path`),f="/")),h.with({path:f})}normalizePath(h){if(!h.path.length)return h;let f;return h.scheme===S.Schemas.file?f=$.URI.file(w.$hc(r(h))).path:f=w.$gc.normalize(h.path),h.with({path:f})}relativePath(h,f){if(h.scheme!==f.scheme||!(0,e.$kh)(h.authority,f.authority))return;if(h.scheme===S.Schemas.file){const p=w.$lc(r(h),r(f));return B.$j?t.$xg(p):p}let l=h.path||"/";const s=f.path||"/";if(this.a(h)){let p=0;for(const E=Math.min(l.length,s.length);p<E&&!(l.charCodeAt(p)!==s.charCodeAt(p)&&l.charAt(p).toLowerCase()!==s.charAt(p).toLowerCase());p++);l=s.substr(0,p)+l.substr(p)}return w.$gc.relative(l,s)}resolvePath(h,f){if(h.scheme===S.Schemas.file){const l=$.URI.file(w.$kc(r(h),f));return h.with({authority:l.authority,path:l.path})}return f=t.$yg(f),h.with({path:w.$gc.resolve(h.path,f)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,f){return h===f||h!==void 0&&f!==void 0&&(0,A.$Ff)(h,f)}hasTrailingPathSeparator(h,f=w.sep){if(h.scheme===S.Schemas.file){const l=r(h);return l.length>t.$zg(l).length&&l[l.length-1]===f}else{const l=h.path;return l.length>1&&l.charCodeAt(l.length-1)===c.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,f=w.sep){return(0,e.$lh)(h,f)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,f=w.sep){let l=!1;if(h.scheme===S.Schemas.file){const s=r(h);l=s!==void 0&&s.length===t.$zg(s).length&&s[s.length-1]===f}else{f="/";const s=h.path;l=s.length===1&&s.charCodeAt(s.length-1)===c.CharCode.Slash}return!l&&!(0,e.$lh)(h,f)?h.with({path:h.path+"/"}):h}}e.$7g=L,e.$8g=new L(()=>!1),e.$9g=new L(a=>a.scheme===S.Schemas.file?!B.$l:!0),e.$0g=new L(a=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function b(a,h){const f=[];for(let l=0;l<a.length;l++){const s=h(a[l]);a.some((p,E)=>E===l?!1:(0,e.$_g)(s,h(p)))||f.push(a[l])}return f}var d;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function h(f){const l=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(E=>{const[n,o]=E.split(":");n&&o&&l.set(n,o)});const p=f.path.substring(0,f.path.indexOf(";"));return p&&l.set(a.META_DATA_MIME,p),l}a.parseMetaData=h})(d||(e.DataUri=d={}));function u(a,h,f){if(h){let l=a.path;return l&&l[0]!==w.$gc.sep&&(l=w.$gc.sep+l),a.with({scheme:f,authority:h,path:l})}return a.with({scheme:f})}}),define(he[11],fe([0,1,18,7,4,2,25,3,52,24]),function(ie,e,c,t,S,w,B,A,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=L,e.$rh=b,e.$sh=d,e.$th=u,e.$uh=a,e.$vh=h,e.$wh=f,e.$xh=l,e.$Fh=v,e.$Gh=_,e.$Hh=k,e.$Ih=M,e.$Jh=q,e.$Yh=j,e.$7h=N;function L(T){return!!T&&typeof T.then=="function"}function b(T){const O=new c.$we,H=T(O.token),x=new Promise((ne,be)=>{const ve=O.token.onCancellationRequested(()=>{ve.dispose(),be(new t.$4)});Promise.resolve(H).then(De=>{ve.dispose(),O.dispose(),ne(De)},De=>{ve.dispose(),O.dispose(),be(De)})});return new class{cancel(){O.cancel(),O.dispose()}then(ne,be){return x.then(ne,be)}catch(ne){return this.then(void 0,ne)}finally(ne){return x.finally(ne)}}}function d(T,O,H){return new Promise((x,ne)=>{const be=O.onCancellationRequested(()=>{be.dispose(),x(H)});T.then(x,ne).finally(()=>be.dispose())})}function u(T,O){return new Promise((H,x)=>{const ne=O.onCancellationRequested(()=>{ne.dispose(),x(new t.$4)});T.then(H,x).finally(()=>ne.dispose())})}async function a(T){let O=-1;const H=T.map((x,ne)=>x.then(be=>(O=ne,be)));try{return await Promise.race(H)}finally{T.forEach((x,ne)=>{ne!==O&&x.cancel()})}}function h(T,O,H){let x;const ne=setTimeout(()=>{x?.(void 0),H?.()},O);return Promise.race([T.finally(()=>clearTimeout(ne)),new Promise(be=>x=be)])}function f(T){return new Promise((O,H)=>{const x=T();L(x)?x.then(O,H):O(x)})}function l(){let T,O;return{promise:new Promise((x,ne)=>{T=x,O=ne}),resolve:T,reject:O}}class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(O){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=O,!this.b){const H=()=>{if(this.b=null,this.f)return;const x=this.queue(this.d);return this.d=null,x};this.b=new Promise(x=>{this.a.then(H,H).then(x)})}return new Promise((H,x)=>{this.b.then(H,x)})}return this.a=O(),new Promise((H,x)=>{this.a.then(ne=>{this.a=null,H(ne)},ne=>{this.a=null,x(ne)})})}dispose(){this.f=!0}}e.$yh=s;class p{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.$zh=p;class E{constructor(){this.a=new Map}queue(O,H){const ne=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(H).finally(()=>{this.a.get(O)===ne&&this.a.delete(O)});return this.a.set(O,ne),ne}}e.$Ah=E;const n=(T,O)=>{let H=!0;const x=setTimeout(()=>{H=!1,O()},T);return{isTriggered:()=>H,dispose:()=>{clearTimeout(x),H=!1}}},o=T=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,T())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class i{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,H=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((ne,be)=>{this.d=ne,this.f=be}).then(()=>{if(this.b=null,this.d=null,this.g){const ne=this.g;return this.g=null,ne()}}));const x=()=>{this.a=null,this.d?.(null)};return this.a=H===$.$ge?o(x):n(H,x),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new t.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=i;class m{constructor(O){this.a=new i(O),this.b=new s}trigger(O,H){return this.a.trigger(()=>this.b.queue(O),H)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=m;class R{constructor(){this.a=!1,this.b=new Promise((O,H)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=R;class C extends R{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.$Eh=C;function v(T,O){return O?new Promise((H,x)=>{const ne=setTimeout(()=>{be.dispose(),H()},T),be=O.onCancellationRequested(()=>{clearTimeout(ne),be.dispose(),x(new t.$4)})}):b(H=>v(T,H))}function _(T,O=0,H){const x=setTimeout(()=>{T(),H&&ne.dispose()},O),ne=(0,w.$Sc)(()=>{clearTimeout(x),H?.deleteAndLeak(ne)});return H?.add(ne),ne}function k(T){const O=[];let H=0;const x=T.length;function ne(){return H<x?T[H++]():null}function be(ve){ve!=null&&O.push(ve);const De=ne();return De?De.then(be):Promise.resolve(O)}return Promise.resolve(null).then(be)}function M(T,O=x=>!!x,H=null){let x=0;const ne=T.length,be=()=>{if(x>=ne)return Promise.resolve(H);const ve=T[x++];return Promise.resolve(ve()).then(me=>O(me)?Promise.resolve(me):be())};return be()}function q(T,O=x=>!!x,H=null){if(T.length===0)return Promise.resolve(H);let x=T.length;const ne=()=>{x=-1;for(const be of T)be.cancel?.()};return new Promise((be,ve)=>{for(const De of T)De.then(me=>{--x>=0&&O(me)?(ne(),be(me)):x===0&&be(H)}).catch(me=>{--x>=0&&(ne(),ve(me))})})}class I{constructor(O){this.a=0,this.b=!1,this.f=O,this.g=[],this.d=0,this.h=new S.$le}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(O){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((H,x)=>{this.g.push({factory:O,c:H,e:x}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const O=this.g.shift();this.d++;const H=O.factory();H.then(O.c,O.e),H.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=I;class y extends I{constructor(){super(1)}}e.$Lh=y;class U{constructor(){this.a=new J,this.b=0}queue(O){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,O())):this.a.run(this.b++,O())}}e.$Mh=U;class D{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const O=new W;return this.b.add(O),O.p}g(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueSize(O,H=B.$8g){const x=H.getComparisonKey(O);return this.a.get(x)?.size??0}queueFor(O,H,x=B.$8g){const ne=x.getComparisonKey(O);let be=this.a.get(ne);if(!be){be=new y;const ve=this.f++,De=S.Event.once(be.onDrained)(()=>{be?.dispose(),this.a.delete(ne),this.h(),this.d?.deleteAndDispose(ve),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new w.$4c),this.d.set(ve,De),this.a.set(ne,be)}return be.queue(H)}h(){this.g()&&this.j()}j(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=D;class P{constructor(O,H){this.b=!1,this.a=-1,typeof O=="function"&&typeof H=="number"&&this.setIfNotSet(O,H)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,H){if(this.b)throw new t.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},H)}setIfNotSet(O,H){if(this.b)throw new t.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},H))}}e.$Oh=P;class F{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(O,H,x=globalThis){if(this.f)throw new t.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const ne=x.setInterval(()=>{O()},H);this.d=(0,w.$Sc)(()=>{x.clearInterval(ne),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=F;class Q{constructor(O,H){this.b=-1,this.a=O,this.d=H,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=Q;class V{constructor(O,H){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.a=O,this.b=H,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=V;class Z extends Q{constructor(O,H){super(O,H),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.$Sh=Z;class re extends w.$Uc{constructor(O,H){super(),this.g=O,this.h=H,this.a=[],this.b=this.B(new w.$Vc),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const H of O)this.a.push(H);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(T,O)=>{(0,A.$C)(()=>{if(H)return;const x=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.$Vh=(T,O,H)=>{const x=T.requestIdleCallback(O,typeof H=="number"?{timeout:H}:void 0);let ne=!1;return{dispose(){ne||(ne=!0,T.cancelIdleCallback(x))}}},e.$Uh=T=>(0,e.$Vh)(globalThis,T)}();class ae{constructor(O,H){this.g=!1,this.d=()=>{try{this.j=H()}catch(x){this.l=x}finally{this.g=!0}},this.f=(0,e.$Vh)(O,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=ae;class X extends ae{constructor(O){super(globalThis,O)}}e.$Xh=X;async function j(T,O,H){let x;for(let ne=0;ne<H;ne++)try{return await T()}catch(be){x=be,await v(O)}throw x}class J{isRunning(O){return typeof O=="number"?this.a?.taskId===O:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(O,H,x){return this.a={taskId:O,cancel:()=>x?.(),promise:H},H.then(()=>this.d(O),()=>this.d(O)),H}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this.b)this.b.run=O;else{const{promise:H,resolve:x,reject:ne}=l();this.b={run:O,promise:H,promiseResolve:x,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=J;class ee{constructor(O,H=()=>Date.now()){this.d=O,this.f=H,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.$1h=ee;var le;(function(T){T[T.Resolved=0]="Resolved",T[T.Rejected=1]="Rejected"})(le||(le={}));class W{get isRejected(){return this.d?.outcome===le.Rejected}get isResolved(){return this.d?.outcome===le.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===le.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((O,H)=>{this.a=O,this.b=H})}complete(O){return new Promise(H=>{this.a(O),this.d={outcome:le.Resolved,value:O},H()})}error(O){return new Promise(H=>{this.b(O),this.d={outcome:le.Rejected,value:O},H()})}cancel(){return this.error(new t.$4)}}e.$2h=W;var ce;(function(T){async function O(x){let ne;const be=await Promise.all(x.map(ve=>ve.then(De=>De,De=>{ne||(ne=De)})));if(typeof ne<"u")throw ne;return be}T.settled=O;function H(x){return new Promise(async(ne,be)=>{try{await x(ne,be)}catch(ve){be(ve)}})}T.withAsyncBody=H})(ce||(e.Promises=ce={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(O){this.a=void 0,this.b=void 0,this.d=!1,this.promise=O.then(H=>(this.a=H,this.d=!0,H),H=>{throw this.b=H,this.d=!0,H})}requireValue(){if(!this.d)throw new t.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=ge;class te{constructor(O){this.b=O,this.a=new r.$T(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=te;var g;(function(T){T[T.Initial=0]="Initial",T[T.DoneOK=1]="DoneOK",T[T.DoneError=2]="DoneError"})(g||(g={}));class G{static fromArray(O){return new G(H=>{H.emitMany(O)})}static fromPromise(O){return new G(async H=>{H.emitMany(await O)})}static fromPromises(O){return new G(async H=>{await Promise.all(O.map(async x=>H.emitOne(await x)))})}static merge(O){return new G(async H=>{await Promise.all(O.map(async x=>{for await(const ne of x)H.emitOne(ne)}))})}static{this.EMPTY=G.fromArray([])}constructor(O,H){this.a=g.Initial,this.b=[],this.d=null,this.f=H,this.g=new S.$le,queueMicrotask(async()=>{const x={emitOne:ne=>this.h(ne),emitMany:ne=>this.j(ne),reject:ne=>this.l(ne)};try{await Promise.resolve(O(x)),this.k()}catch(ne){this.l(ne)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===g.DoneError)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===g.DoneOK)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(O,H){return new G(async x=>{for await(const ne of O)x.emitOne(H(ne))})}map(O){return G.map(this,O)}static filter(O,H){return new G(async x=>{for await(const ne of O)H(ne)&&x.emitOne(ne)})}filter(O){return G.filter(this,O)}static coalesce(O){return G.filter(O,H=>!!H)}coalesce(){return G.coalesce(this)}static async toPromise(O){const H=[];for await(const x of O)H.push(x);return H}toPromise(){return G.toPromise(this)}h(O){this.a===g.Initial&&(this.b.push(O),this.g.fire())}j(O){this.a===g.Initial&&(this.b=this.b.concat(O),this.g.fire())}k(){this.a===g.Initial&&(this.a=g.DoneOK,this.g.fire())}l(O){this.a===g.Initial&&(this.a=g.DoneError,this.d=O,this.g.fire())}}e.$5h=G;class oe extends G{constructor(O,H){super(H),this.m=O}cancel(){this.m.cancel()}}e.$6h=oe;function N(T){const O=new c.$we,H=T(O.token);return new oe(O,async x=>{const ne=O.token.onCancellationRequested(()=>{ne.dispose(),O.dispose(),x.reject(new t.$4)});try{for await(const be of H){if(O.token.isCancellationRequested)return;x.emitOne(be)}ne.dispose(),O.dispose()}catch(be){ne.dispose(),O.dispose(),x.reject(be)}})}class K{constructor(O){this.a=new W,this.b=new G(ne=>{if(H){ne.reject(H);return}return x&&ne.emitMany(x),this.d=be=>ne.reject(be),this.f=be=>ne.emitOne(be),this.a.p},O);let H,x;this.f=ne=>{x||(x=[]),x.push(ne)},this.d=ne=>{H||(H=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(O){this.d(O),this.a.complete()}emitOne(O){this.f(O)}}e.$8h=K}),define(he[58],fe([0,1,19,27,6]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=$,e.$On=L,e.$Pn=b;function w(d){return d.toJSON()}class B{constructor(u){this.a=u}transformIncoming(u){const a=this.a.transformIncoming(u);return a===u?u:w(S.URI.from(a))}transformOutgoing(u){const a=this.a.transformOutgoing(u);return a===u?u:w(S.URI.from(a))}transformOutgoingURI(u){const a=this.a.transformOutgoing(u);return a===u?u:S.URI.from(a)}transformOutgoingScheme(u){return this.a.transformOutgoingScheme(u)}}e.$Ln=B,e.$Mn=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function A(d,u,a){if(!d||a>200)return null;if(typeof d=="object"){if(d instanceof S.URI)return u.transformOutgoing(d);for(const h in d)if(Object.hasOwnProperty.call(d,h)){const f=A(d[h],u,a+1);f!==null&&(d[h]=f)}}return null}function $(d,u){const a=A(d,u,0);return a===null?d:a}function r(d,u,a,h){if(!d||h>200)return null;if(typeof d=="object"){if(d.$mid===t.MarshalledId.Uri)return a?S.URI.revive(u.transformIncoming(d)):u.transformIncoming(d);if(d instanceof c.$Ne)return null;for(const f in d)if(Object.hasOwnProperty.call(d,f)){const l=r(d[f],u,a,h+1);l!==null&&(d[f]=l)}}return null}function L(d,u){const a=r(d,u,!1,0);return a===null?d:a}function b(d,u){const a=r(d,u,!0,0);return a===null?d:a}}),define(he[59],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=t;const c=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(S){return c.test(S)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(A){for(let $=0;$<A.length;$++)A[$]=Math.floor(Math.random()*256);return A};const w=new Uint8Array(16),B=[];for(let A=0;A<256;A++)B.push(A.toString(16).padStart(2,"0"));return function(){S(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let $=0,r="";return r+=B[w[$++]],r+=B[w[$++]],r+=B[w[$++]],r+=B[w[$++]],r+="-",r+=B[w[$++]],r+=B[w[$++]],r+="-",r+=B[w[$++]],r+=B[w[$++]],r+="-",r+=B[w[$++]],r+=B[w[$++]],r+="-",r+=B[w[$++]],r+=B[w[$++]],r+=B[w[$++]],r+=B[w[$++]],r+=B[w[$++]],r+=B[w[$++]],r}}()}),define(he[28],fe([0,1,35,21,100,11,34,48,5,3,25,6]),function(ie,e,c,t,S,w,B,A,$,r,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=p,e.whenDeleted=o,e.configureFlushOnWrite=v,e.writeFileSync=k,c=Se(c);var d;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(d||(e.RimRafMode=d={}));async function u(V,Z=d.UNLINK,re){if((0,B.$Hg)(V))throw new Error("rimraf - will refuse to recursively delete root");return Z===d.UNLINK?h(V):a(V,re)}async function a(V,Z=(0,B.$Mg)((0,t.tmpdir)())){try{try{await c.promises.rename(V,Z)}catch(re){return re.code==="ENOENT"?void 0:h(V)}h(Z).catch(re=>{})}catch(re){if(re.code!=="ENOENT")throw re}}async function h(V){return c.promises.rm(V,{recursive:!0,force:!0,maxRetries:3})}function f(V){if((0,B.$Hg)(V))throw new Error("rimraf - will refuse to recursively delete root");c.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}async function l(V,Z){return E(await(Z?s(V):c.promises.readdir(V)))}async function s(V){try{return await c.promises.readdir(V,{withFileTypes:!0})}catch(ae){console.warn("[node.js fs] readdir with filetypes failed with error: ",ae)}const Z=[],re=await l(V);for(const ae of re){let X=!1,j=!1,J=!1;try{const ee=await c.promises.lstat((0,$.$jc)(V,ae));X=ee.isFile(),j=ee.isDirectory(),J=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}Z.push({name:ae,isFile:()=>X,isDirectory:()=>j,isSymbolicLink:()=>J})}return Z}function p(V){return E(c.readdirSync(V))}function E(V){return V.map(Z=>typeof Z=="string"?r.$k?(0,A.$mm)(Z):Z:(Z.name=r.$k?(0,A.$mm)(Z.name):Z.name,Z))}async function n(V){const Z=await l(V),re=[];for(const ae of Z)await i.existsDirectory((0,$.$jc)(V,ae))&&re.push(ae);return re}function o(V,Z=1e3){return new Promise(re=>{let ae=!1;const X=setInterval(()=>{ae||(ae=!0,c.access(V,j=>{ae=!1,j&&(clearInterval(X),re(void 0))}))},Z)})}var i;(function(V){async function Z(X){let j;try{if(j=await c.promises.lstat(X),!j.isSymbolicLink())return{stat:j}}catch{}try{return{stat:await c.promises.stat(X),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(J){if(J.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(r.$j&&J.code==="EACCES")try{return{stat:await c.promises.stat(await c.promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw ee}throw J}}V.stat=Z;async function re(X){try{const{stat:j,symbolicLink:J}=await V.stat(X);return j.isFile()&&J?.dangling!==!0}catch{}return!1}V.existsFile=re;async function ae(X){try{const{stat:j,symbolicLink:J}=await V.stat(X);return j.isDirectory()&&J?.dangling!==!0}catch{}return!1}V.existsDirectory=ae})(i||(e.SymlinkSupport=i={}));const m=new w.$Nh;function R(V,Z,re){return m.queueFor(b.URI.file(V),()=>{const ae=M(re);return new Promise((X,j)=>_(V,Z,ae,J=>J?j(J):X()))},L.$9g)}let C=!0;function v(V){C=V}function _(V,Z,re,ae){if(!C)return c.writeFile(V,Z,{mode:re.mode,flag:re.flag},ae);c.open(V,re.flag,re.mode,(X,j)=>{if(X)return ae(X);c.writeFile(j,Z,J=>{if(J)return c.close(j,()=>ae(J));c.fdatasync(j,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),v(!1)),c.close(j,le=>ae(le))))})})}function k(V,Z,re){const ae=M(re);if(!C)return c.writeFileSync(V,Z,{mode:ae.mode,flag:ae.flag});const X=c.openSync(V,ae.flag,ae.mode);try{c.writeFileSync(X,Z);try{c.fdatasyncSync(X)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),v(!1)}}finally{c.closeSync(X)}}function M(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function q(V,Z,re=6e4){if(V!==Z)try{r.$j&&typeof re=="number"?await I(V,Z,Date.now(),re):await c.promises.rename(V,Z)}catch(ae){if(V.toLowerCase()!==Z.toLowerCase()&&ae.code==="EXDEV"||V.endsWith("."))await y(V,Z,{preserveSymlinks:!1}),await u(V,d.MOVE);else throw ae}}async function I(V,Z,re,ae,X=0){try{return await c.promises.rename(V,Z)}catch(j){if(j.code!=="EACCES"&&j.code!=="EPERM"&&j.code!=="EBUSY")throw j;if(Date.now()-re>=ae)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${j}`),j;if(X===0){let J=!1;try{const{stat:ee}=await i.stat(Z);ee.isFile()||(J=!0)}catch{}if(J)throw j}return await(0,w.$Fh)(Math.min(100,X*10)),I(V,Z,re,ae,X+1)}}async function y(V,Z,re){return D(V,Z,{root:{source:V,target:Z},options:re,handledSourcePaths:new Set})}const U=511;async function D(V,Z,re){if(re.handledSourcePaths.has(V))return;re.handledSourcePaths.add(V);const{stat:ae,symbolicLink:X}=await i.stat(V);if(X){if(re.options.preserveSymlinks)try{return await Q(V,Z,re)}catch{}if(X.dangling)return}return ae.isDirectory()?P(V,Z,ae.mode&U,re):F(V,Z,ae.mode&U)}async function P(V,Z,re,ae){await c.promises.mkdir(Z,{recursive:!0,mode:re});const X=await l(V);for(const j of X)await D((0,$.$jc)(V,j),(0,$.$jc)(Z,j),ae)}async function F(V,Z,re){await c.promises.copyFile(V,Z),await c.promises.chmod(Z,re)}async function Q(V,Z,re){let ae=await c.promises.readlink(V);(0,B.$Dg)(ae,re.root.source,!r.$l)&&(ae=(0,$.$jc)(re.root.target,ae.substr(re.root.source.length+1))),await c.promises.symlink(ae,Z)}e.Promises=new class{get read(){return(V,Z,re,ae,X)=>new Promise((j,J)=>{c.read(V,Z,re,ae,X,(ee,le,W)=>ee?J(ee):j({bytesRead:le,buffer:W}))})}get write(){return(V,Z,re,ae,X)=>new Promise((j,J)=>{c.write(V,Z,re,ae,X,(ee,le,W)=>ee?J(ee):j({bytesWritten:le,buffer:W}))})}get fdatasync(){return(0,S.promisify)(c.fdatasync)}get open(){return(0,S.promisify)(c.open)}get close(){return(0,S.promisify)(c.close)}get realpath(){return(0,S.promisify)(c.realpath)}async exists(V){try{return await c.promises.access(V),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return n}get writeFile(){return R}get rm(){return u}get rename(){return q}get copy(){return y}}}),define(he[60],fe([0,1,21,5,28]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vm=s,e.$wm=p,c=Se(c),t=Se(t),S=Se(S);const w=/^\d+$/,B=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var $;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})($||($={}));let r;switch(process.arch){case"ia32":r=$.x86;break;case"arm":case"arm64":r=$.ARM;break;default:r=$.x64;break}let L;process.env.PROCESSOR_ARCHITEW6432?L=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?$.ARM:$.x64:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?L=$.ARM:process.env.PROCESSOR_ARCHITECTURE==="X86"?L=$.x86:L=$.x64;class b{constructor(n,o,i){this.exePath=n,this.displayName=o,this.a=i}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function d({useAlternateBitness:E=!1}={}){return E?r===$.x64?process.env["ProgramFiles(x86)"]||null:L===$.x64&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:E=!1,findPreview:n=!1}={}){const o=d({useAlternateBitness:E});if(!o)return null;const i=t.$jc(o,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(i))return null;let m=-1,R=null;for(const _ of await S.Promises.readdir(i)){let k=-1;if(n){const q=_.indexOf("-");if(q<0)continue;const I=_.substring(0,q);if(!w.test(I)||_.substring(q+1)!=="preview")continue;k=parseInt(I,10)}else{if(!w.test(_))continue;k=parseInt(_,10)}if(k<=m)continue;const M=t.$jc(i,_,"pwsh.exe");await S.SymlinkSupport.existsFile(M)&&(R=M,m=k)}if(!R)return null;const C=o.includes("x86")?" (x86)":"",v=n?" Preview":"";return new b(R,`PowerShell${v}${C}`,!0)}async function a({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const n=t.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(n))return null;const{pwshMsixDirRegex:o,pwshMsixName:i}=E?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:B,pwshMsixName:"PowerShell (Store)"};for(const m of await S.Promises.readdir(n))if(o.test(m)){const R=t.$jc(n,m,"pwsh.exe");return new b(R,i)}return null}function h(){const E=t.$jc(c.homedir(),".dotnet","tools","pwsh.exe");return new b(E,".NET Core PowerShell Global Tool")}function f(){const E=t.$jc(process.env.windir,r===$.x86&&L!==$.x86?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(E,"Windows PowerShell",!0)}async function*l(){let E=await u();E&&(yield E),E=await u({useAlternateBitness:!0}),E&&(yield E),E=await a(),E&&(yield E),E=h(),E&&(yield E),E=await u({findPreview:!0}),E&&(yield E),E=await a({findPreview:!0}),E&&(yield E),E=await u({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=f(),E&&(yield E)}async function*s(){for await(const E of l())await E.exists()&&(yield E)}async function p(){for await(const E of s())return E;return null}}),define(he[36],fe([0,1,35,5,3,15,32,9,28]),function(ie,e,c,t,S,w,B,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$xm=r,e.$ym=L,t=Se(t),S=Se(S),w=Se(w),A=Se(A),$=Se($),Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return B.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return B.TerminateResponseCode}});function r(d=w.env){return d.comspec||"cmd.exe"}function L(d){let u=[],a=!1;const h=function(f){if(a){u.push(f);return}(!d.send(f,s=>{if(s&&console.error(s),a=!1,u.length>0){const p=u.slice(0);u=[],p.forEach(E=>h(E))}})||S.$j)&&(a=!0)};return{send:h}}var b;(function(d){async function u(a,h,f){if(t.$ic(a))return a;if(h===void 0&&(h=w.cwd()),t.$mc(a)!=="."||(f===void 0&&A.$eg(w.env.PATH)&&(f=w.env.PATH.split(t.$tc)),f===void 0||f.length===0))return t.$jc(h,a);async function s(p){if(await $.Promises.exists(p)){let E;try{E=await c.promises.stat(p)}catch(n){n.message.startsWith("EACCES")&&(E=await c.promises.lstat(p))}return E?!E.isDirectory():!1}return!1}for(const p of f){let E;if(t.$ic(p)?E=t.$jc(p,a):E=t.$jc(h,p,a),await s(E))return E;let n=E+".com";if(await s(n)||(n=E+".exe",await s(n)))return n}return t.$jc(h,a)}d.findExecutable=u})(b||(e.win32=b={}))}),define(he[61],fe([0,1,29,20]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=S;function S(B){return new Promise((A,$)=>{let r;const L=new Map;function b(u,a,h,f,l){const s=L.get(a);if(u===B||s){const p={name:d(h),cmd:h,pid:u,ppid:a,load:f,mem:l};L.set(u,p),u===B&&(r=p),s&&(s.children||(s.children=[]),s.children.push(p),s.children.length>1&&(s.children=s.children.sort((E,n)=>E.pid-n.pid)))}}function d(u){const a=/--utility-sub-type=network/i,h=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,l=/conhost\.exe.+--headless/i,s=/--type=([a-zA-Z-]+)/;if(h.exec(u))return"electron-crash-reporter";if(f.exec(u))return"winpty-agent";if(l.exec(u))return"conpty-agent";let p=s.exec(u);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?a.exec(u)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const E=/[a-zA-Z-]+\.js/g;let n="";do p=E.exec(u),p&&(n+=p+" ");while(p);return n&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${n})`:u}if(process.platform==="win32"){const u=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,h)=>{ie(["@vscode/windows-process-tree"],a,h)}).then(Se).then(a=>{a.getProcessList(B,h=>{if(!h){$(new Error(`Root process ${B} not found`));return}a.getProcessCpuUsage(h,f=>{const l=new Map;f.forEach(s=>{const p=u(s.commandLine||"");l.set(s.pid,{name:d(p),cmd:p,pid:s.pid,ppid:s.ppid,load:s.cpu||0,mem:s.memory||0})}),r=l.get(B),r?(l.forEach(s=>{const p=l.get(s.ppid);p&&(p.children||(p.children=[]),p.children.push(s))}),l.forEach(s=>{s.children&&(s.children=s.children.sort((p,E)=>p.pid-E.pid))}),A(r)):$(new Error(`Root process ${B} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let u=function(){let a=[r];const h=[];for(;a.length;){const l=a.shift();l&&(h.push(l.pid),l.children&&(a=a.concat(l.children)))}let f=JSON.stringify(t.$Yg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+h.join(" "),(0,c.exec)(f,{},(l,s,p)=>{if(l||p)$(l||new Error(p.toString()));else{const E=s.toString().split(`
`);for(let n=0;n<h.length;n++){const o=L.get(h[n]);o.load=parseFloat(E[n])}if(!r){$(new Error(`Root process ${B} not found`));return}A(r)}})};(0,c.exec)("which ps",{},(a,h,f)=>{if(a||f)if(process.platform!=="linux")$(a||new Error(f.toString()));else{const l=JSON.stringify(t.$Yg.asFileUri("vs/base/node/ps.sh").fsPath);(0,c.exec)(l,{},(s,p,E)=>{s||E?$(s||new Error(E.toString())):(w(p,b),u())})}else{const l=h.toString().trim();(0,c.exec)(`${l} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,E,n)=>{p||n&&!n.includes("screen size is bogus")?$(p||new Error(n.toString())):(w(E,b),process.platform==="linux"?u():r?A(r):$(new Error(`Root process ${B} not found`)))})}})}})}function w(B,A){const $=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=B.toString().split(`
`);for(const L of r){const b=$.exec(L.trim());b&&b.length===6&&A(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(he[62],fe([0,1,21,3,60,36]),function(ie,e,c,t,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=B,t=Se(t),w=Se(w);async function B(b,d){return b===t.OperatingSystem.Windows?t.$j?L():w.$xm(d):$(b,d)}let A=null;function $(b,d){if(t.$l&&b===t.OperatingSystem.Macintosh||t.$k&&b===t.OperatingSystem.Linux)return"/bin/bash";if(!A){let u;if(t.$j)u="/bin/bash";else{if(u=d.SHELL,!u)try{u=(0,c.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}A=u}return A}let r=null;async function L(){return r||(r=(await(0,S.$wm)()).exePath),r}});var $e=this&&this.__decorate||function(ie,e,c,t){var S=arguments.length,w=S<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,c):t,B;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(ie,e,c,t);else for(var A=ie.length-1;A>=0;A--)(B=ie[A])&&(w=(S<3?B(w):S>3?B(e,c,w):B(e,c))||w);return S>3&&w&&Object.defineProperty(e,c,w),w};define(he[30],fe([0,1,17,11,19,18,14,7,4,2,57,10,9]),function(ie,e,c,t,S,w,B,A,$,r,L,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ni=e.ProxyChannel=e.$mi=e.$ji=e.$ii=e.$hi=e.RequestInitiator=e.$gi=e.$di=e.$ci=void 0,e.$ei=v,e.$fi=_,e.$ki=U,e.$li=D,b=Se(b);var u;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(u||(u={}));function a(X){switch(X){case u.Promise:return"req";case u.PromiseCancel:return"cancel";case u.EventListen:return"subscribe";case u.EventDispose:return"unsubscribe"}}var h;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(h||(h={}));function f(X){switch(X){case h.Initialize:return"init";case h.PromiseSuccess:return"reply:";case h.PromiseError:case h.PromiseErrorObj:return"replyErr:";case h.EventFire:return"event:"}}var l;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(l||(l={}));function s(X){let j=0;for(let J=0;;J+=7){const ee=X.read(1);if(j|=(ee.buffer[0]&127)<<J,!(ee.buffer[0]&128))return j}}const p=m(0);function E(X,j){if(j===0){X.write(p);return}let J=0;for(let le=j;le!==0;le=le>>>7)J++;const ee=S.$Ne.alloc(J);for(let le=0;j!==0;le++)ee.buffer[le]=j&127,j=j>>>7,j>0&&(ee.buffer[le]|=128);X.write(ee)}class n{constructor(j){this.b=j,this.a=0}read(j){const J=this.b.slice(this.a,this.a+j);return this.a+=J.byteLength,J}}e.$ci=n;class o{constructor(){this.a=[]}get buffer(){return S.$Ne.concat(this.a)}write(j){this.a.push(j)}}e.$di=o;var i;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(i||(i={}));function m(X){const j=S.$Ne.alloc(1);return j.writeUInt8(X,0),j}const R={Undefined:m(i.Undefined),String:m(i.String),Buffer:m(i.Buffer),VSBuffer:m(i.VSBuffer),Array:m(i.Array),Object:m(i.Object),Uint:m(i.Int)},C=typeof Buffer<"u";function v(X,j){if(typeof j>"u")X.write(R.Undefined);else if(typeof j=="string"){const J=S.$Ne.fromString(j);X.write(R.String),E(X,J.byteLength),X.write(J)}else if(C&&Buffer.isBuffer(j)){const J=S.$Ne.wrap(j);X.write(R.Buffer),E(X,J.byteLength),X.write(J)}else if(j instanceof S.$Ne)X.write(R.VSBuffer),E(X,j.byteLength),X.write(j);else if(Array.isArray(j)){X.write(R.Array),E(X,j.length);for(const J of j)v(X,J)}else if(typeof j=="number"&&(j|0)===j)X.write(R.Uint),E(X,j);else{const J=S.$Ne.fromString(JSON.stringify(j));X.write(R.Object),E(X,J.byteLength),X.write(J)}}function _(X){switch(X.read(1).readUInt8(0)){case i.Undefined:return;case i.String:return X.read(s(X)).toString();case i.Buffer:return X.read(s(X)).buffer;case i.VSBuffer:return X.read(s(X));case i.Array:{const J=s(X),ee=[];for(let le=0;le<J;le++)ee.push(_(X));return ee}case i.Object:return JSON.parse(X.read(s(X)).toString());case i.Int:return s(X)}}class k{constructor(j,J,ee=null,le=1e3){this.h=j,this.j=J,this.k=ee,this.l=le,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:h.Initialize})}registerChannel(j,J){this.b.set(j,J),setTimeout(()=>this.w(j),0)}m(j){switch(j.type){case h.Initialize:{const J=this.o([j.type]);this.k?.logOutgoing(J,0,M.OtherSide,f(j.type));return}case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:{const J=this.o([j.type,j.id],j.data);this.k?.logOutgoing(J,j.id,M.OtherSide,f(j.type),j.data);return}}}o(j,J=void 0){const ee=new o;return v(ee,j),v(ee,J),this.p(ee.buffer)}p(j){try{return this.h.send(j),j.byteLength}catch{return 0}}q(j){const J=new n(j),ee=_(J),le=_(J),W=ee[0];switch(W){case u.Promise:return this.k?.logIncoming(j.byteLength,ee[1],M.OtherSide,`${a(W)}: ${ee[2]}.${ee[3]}`,le),this.s({type:W,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case u.EventListen:return this.k?.logIncoming(j.byteLength,ee[1],M.OtherSide,`${a(W)}: ${ee[2]}.${ee[3]}`,le),this.t({type:W,id:ee[1],channelName:ee[2],name:ee[3],arg:le});case u.PromiseCancel:return this.k?.logIncoming(j.byteLength,ee[1],M.OtherSide,`${a(W)}`),this.u({type:W,id:ee[1]});case u.EventDispose:return this.k?.logIncoming(j.byteLength,ee[1],M.OtherSide,`${a(W)}`),this.u({type:W,id:ee[1]})}}s(j){const J=this.b.get(j.channelName);if(!J){this.v(j);return}const ee=new w.$we;let le;try{le=J.call(this.j,j.name,j.arg,ee.token)}catch(ge){le=Promise.reject(ge)}const W=j.id;le.then(ge=>{this.m({id:W,data:ge,type:h.PromiseSuccess})},ge=>{ge instanceof Error?this.m({id:W,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split(`
`):void 0},type:h.PromiseError}):this.m({id:W,data:ge,type:h.PromiseErrorObj})}).finally(()=>{ce.dispose(),this.d.delete(j.id)});const ce=(0,r.$Sc)(()=>ee.cancel());this.d.set(j.id,ce)}t(j){const J=this.b.get(j.channelName);if(!J){this.v(j);return}const ee=j.id,W=J.listen(this.j,j.name,j.arg)(ce=>this.m({id:ee,data:ce,type:h.EventFire}));this.d.set(j.id,W)}u(j){const J=this.d.get(j.id);J&&(J.dispose(),this.d.delete(j.id))}v(j){let J=this.g.get(j.channelName);J||(J=[],this.g.set(j.channelName,J));const ee=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===u.Promise&&this.m({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.l}ms`,stack:void 0},type:h.PromiseError})},this.l);J.push({request:j,timeoutTimer:ee})}w(j){const J=this.g.get(j);if(J){for(const ee of J)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case u.Promise:this.s(ee.request);break;case u.EventListen:this.t(ee.request);break}this.g.delete(j)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$gi=k;var M;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(M||(e.RequestInitiator=M={}));class q{constructor(j,J=null){this.l=j,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$le,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=J}getChannel(j){const J=this;return{call(ee,le,W){return J.a?Promise.reject(new A.$4):J.m(j,ee,le,W)},listen(ee,le){return J.a?$.Event.None:J.o(j,ee,le)}}}m(j,J,ee,le=w.CancellationToken.None){const W=this.g++,ce=u.Promise,ge={id:W,type:ce,channelName:j,name:J,arg:ee};if(le.isCancellationRequested)return Promise.reject(new A.$4);let te;return new Promise((G,oe)=>{if(le.isCancellationRequested)return oe(new A.$4);const N=()=>{const H=x=>{switch(x.type){case h.PromiseSuccess:this.f.delete(W),G(x.data);break;case h.PromiseError:{this.f.delete(W);const ne=new Error(x.data.message);ne.stack=Array.isArray(x.data.stack)?x.data.stack.join(`
`):x.data.stack,ne.name=x.data.name,oe(ne);break}case h.PromiseErrorObj:this.f.delete(W),oe(x.data);break}};this.f.set(W,H),this.p(ge)};let K=null;this.b===l.Idle?N():(K=(0,t.$rh)(H=>this.u()),K.then(()=>{K=null,N()}));const T=()=>{K?(K.cancel(),K=null):this.p({id:W,type:u.PromiseCancel}),oe(new A.$4)},O=le.onCancellationRequested(T);te=(0,r.$Rc)((0,r.$Sc)(T),O),this.d.add(te)}).finally(()=>{te.dispose(),this.d.delete(te)})}o(j,J,ee){const le=this.g++,W=u.EventListen,ce={id:le,type:W,channelName:j,name:J,arg:ee};let ge=null;const te=new $.$le({onWillAddFirstListener:()=>{ge=(0,t.$rh)(G=>this.u()),ge.then(()=>{ge=null,this.d.add(te),this.p(ce)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(te),this.p({id:le,type:u.EventDispose}))}}),g=G=>te.fire(G.data);return this.f.set(le,g),te.event}p(j){switch(j.type){case u.Promise:case u.EventListen:{const J=this.q([j.type,j.id,j.channelName,j.name],j.arg);this.j?.logOutgoing(J,j.id,M.LocalSide,`${a(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case u.PromiseCancel:case u.EventDispose:{const J=this.q([j.type,j.id]);this.j?.logOutgoing(J,j.id,M.LocalSide,a(j.type));return}}}q(j,J=void 0){const ee=new o;return v(ee,j),v(ee,J),this.r(ee.buffer)}r(j){try{return this.l.send(j),j.byteLength}catch{return 0}}s(j){const J=new n(j),ee=_(J),le=_(J),W=ee[0];switch(W){case h.Initialize:return this.j?.logIncoming(j.byteLength,0,M.LocalSide,f(W)),this.t({type:ee[0]});case h.PromiseSuccess:case h.PromiseError:case h.EventFire:case h.PromiseErrorObj:return this.j?.logIncoming(j.byteLength,ee[1],M.LocalSide,f(W),le),this.t({type:ee[0],id:ee[1],data:le})}}t(j){if(j.type===h.Initialize){this.b=l.Idle,this.k.fire();return}this.f.get(j.id)?.(j)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Pc)(this.d.values()),this.d.clear()}}e.$hi=q,$e([B.$9h],q.prototype,"onDidInitializePromise",null);class I{get connections(){const j=[];return this.f.forEach(J=>j.push(J)),j}constructor(j,J,ee){this.a=new Map,this.f=new Set,this.g=new $.$le,this.onDidAddConnection=this.g.event,this.h=new $.$le,this.onDidRemoveConnection=this.h.event,this.j=new r.$Tc,this.j.add(j(({protocol:le,onDidClientDisconnect:W})=>{const ce=$.Event.once(le.onMessage);this.j.add(ce(ge=>{const te=new n(ge),g=_(te),G=new k(le,g,J,ee),oe=new q(le,J);this.a.forEach((K,T)=>G.registerChannel(T,K));const N={channelServer:G,channelClient:oe,ctx:g};this.f.add(N),this.g.fire(N),this.j.add(W(()=>{G.dispose(),oe.dispose(),this.f.delete(N),this.h.fire(N)}))}))}))}getChannel(j,J){const ee=this;return{call(le,W,ce){let ge;if((0,d.$sg)(J)){const g=(0,c.$2b)(ee.connections.filter(J));ge=g?Promise.resolve(g):$.Event.toPromise($.Event.filter(ee.onDidAddConnection,J))}else ge=J.routeCall(ee,le,W);const te=ge.then(g=>g.channelClient.getChannel(j));return U(te).call(le,W,ce)},listen(le,W){if((0,d.$sg)(J))return ee.k(j,J,le,W);const ce=J.routeEvent(ee,le,W).then(ge=>ge.channelClient.getChannel(j));return U(ce).listen(le,W)}}}k(j,J,ee,le){const W=this;let ce;const ge=new $.$le({onWillAddFirstListener:()=>{ce=new r.$Tc;const te=new $.$re,g=new Map,G=N=>{const T=N.channelClient.getChannel(j).listen(ee,le),O=te.add(T);g.set(N,O)},oe=N=>{const K=g.get(N);K&&(K.dispose(),g.delete(N))};W.connections.filter(J).forEach(G),$.Event.filter(W.onDidAddConnection,J)(G,void 0,ce),W.onDidRemoveConnection(oe,void 0,ce),te.event(ge.fire,ge,ce),ce.add(te)},onDidRemoveLastListener:()=>{ce?.dispose(),ce=void 0}});return ge.event}registerChannel(j,J){this.a.set(j,J);for(const ee of this.f)ee.channelServer.registerChannel(j,J)}dispose(){this.j.dispose();for(const j of this.f)j.channelClient.dispose(),j.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ii=I;class y{constructor(j,J,ee=null){const le=new o;v(le,J),j.send(le.buffer),this.a=new q(j,ee),this.d=new k(j,J,ee)}getChannel(j){return this.a.getChannel(j)}registerChannel(j,J){this.d.registerChannel(j,J)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ji=y;function U(X){return{call(j,J,ee){return X.then(le=>le.call(j,J,ee))},listen(j,J){const ee=new $.$ue;return X.then(le=>ee.input=le.listen(j,J)),ee.event}}}function D(X){let j=!1;return{call(J,ee,le){return j?X.call(J,ee,le):(0,t.$Fh)(0).then(()=>j=!0).then(()=>X.call(J,ee,le))},listen(J,ee){if(j)return X.listen(J,ee);const le=new $.$ue;return(0,t.$Fh)(0).then(()=>j=!0).then(()=>le.input=X.listen(J,ee)),le.event}}}class P{constructor(j){this.a=j}routeCall(j){return this.b(j)}routeEvent(j){return this.b(j)}async b(j){for(const J of j.connections)if(await Promise.resolve(this.a(J.ctx)))return Promise.resolve(J);return await $.Event.toPromise(j.onDidAddConnection),await this.b(j)}}e.$mi=P;var F;(function(X){function j(W,ce,ge){const te=W,g=ge&&ge.disableMarshalling,G=new Map;for(const oe in te)ee(oe)&&G.set(oe,$.Event.buffer(te[oe],!0,void 0,ce));return new class{listen(oe,N,K){const T=G.get(N);if(T)return T;const O=te[N];if(typeof O=="function"){if(le(N))return O.call(te,K);if(ee(N))return G.set(N,$.Event.buffer(te[N],!0,void 0,ce)),G.get(N)}throw new A.$ab(`Event not found: ${N}`)}call(oe,N,K){const T=te[N];if(typeof T=="function"){if(!g&&Array.isArray(K))for(let H=0;H<K.length;H++)K[H]=(0,L.$bi)(K[H]);let O=T.apply(te,K);return O instanceof Promise||(O=Promise.resolve(O)),O}throw new A.$ab(`Method not found: ${N}`)}}}X.fromService=j;function J(W,ce){const ge=ce&&ce.disableMarshalling;return new Proxy({},{get(te,g){if(typeof g=="string")return ce?.properties?.has(g)?ce.properties.get(g):le(g)?function(G){return W.listen(g,G)}:ee(g)?W.listen(g):async function(...G){let oe;ce&&!(0,d.$ng)(ce.context)?oe=[ce.context,...G]:oe=G;const N=await W.call(g,oe);return ge?N:(0,L.$bi)(N)};throw new A.$ab(`Property not found: ${String(g)}`)}})}X.toService=J;function ee(W){return W[0]==="o"&&W[1]==="n"&&b.$Ef(W.charCodeAt(2))}function le(W){return/^onDynamic/.test(W)&&b.$Ef(W.charCodeAt(9))}})(F||(e.ProxyChannel=F={}));const Q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const j=X.toString();if(j!=="[object Object]")return j}return X}function Z(X){return Array.isArray(X)?X.map(V):V(X)}function re(X,j,J,ee,le,W,ce){ce=Z(ce);const ge=Q[le],te=ge[ee%ge.length];let g=[`%c[${X}]%c[${String(j).padStart(7," ")}]%c[len: ${String(J).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${te}`];/\($/.test(W)?(g=g.concat(ce),g.push(")")):g.push(ce),console.log.apply(console,g)}class ae{constructor(j,J){this.d=j,this.f=J,this.a=0,this.b=0}logOutgoing(j,J,ee,le,W){this.b+=j,re(this.d,this.b,j,J,ee,le,W)}logIncoming(j,J,ee,le,W){this.a+=j,re(this.f,this.a,j,J,ee,le,W)}}e.$ni=ae}),define(he[63],fe([0,1,29,11,19,18,56,7,4,2,33,36,32,30]),function(ie,e,c,t,S,w,B,A,$,r,L,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0,A=Se(A);class a extends u.$gi{constructor(l){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",s=>S.$Ne.wrap(Buffer.from(s,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$gr=a;class h{constructor(l,s){this.i=l,this.j=s,this.c=new Set,this.g=new Map,this.h=new $.$le,this.onDidProcessExit=this.h.event;const p=s&&s.timeout?s.timeout:6e4;this.b=new t.$Bh(p),this.d=null,this.f=null}getChannel(l){const s=this;return{call(p,E,n){return s.k(l,p,E,n)},listen(p,E){return s.l(l,p,E)}}}k(l,s,p,E=w.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(A.$5());this.b.cancel();const n=this.n(l),o=(0,t.$rh)(R=>n.call(s,p,R)),i=E.onCancellationRequested(()=>o.cancel()),m=(0,r.$Sc)(()=>o.cancel());return this.c.add(m),o.finally(()=>{i.dispose(),this.c.delete(m),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),o}l(l,s,p){if(!this.b)return $.Event.None;this.b.cancel();let E;const n=new $.$le({onWillAddFirstListener:()=>{E=this.n(l).listen(s,p)(n.fire,n),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return n.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,L.$do)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(v=>!/^--inspect(-brk)?=/.test(v)).filter(v=>!v.startsWith("--vscode-"))),(0,d.$lm)(s.env),this.d=(0,c.fork)(this.i,l,s);const p=new $.$le,n=$.Event.fromNodeEventEmitter(this.d,"message",v=>v)(v=>{if((0,B.$cr)(v)){(0,B.log)(v,`IPC Library: ${this.j.serverName}`);return}p.fire(S.$Ne.wrap(Buffer.from(v,"base64")))}),o=this.j.useQueue?(0,b.$ym)(this.d):this.d,i=v=>this.d&&this.d.connected&&o.send(v.buffer.toString("base64")),m=p.event,R={send:i,onMessage:m};this.f=new u.$hi(R);const C=()=>this.o();process.once("exit",C),this.d.on("error",v=>console.warn('IPC "'+this.j.serverName+'" errored with '+v)),this.d.on("exit",(v,_)=>{process.removeListener("exit",C),n.dispose(),this.c.forEach(k=>(0,r.$Pc)(k)),this.c.clear(),v!==0&&_!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+v+" and signal "+_),this.b?.cancel(),this.o(),this.h.fire({code:v,signal:_})})}return this.f}n(l){let s=this.g.get(l);return s||(s=this.m.getChannel(l),this.g.set(l,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$hr=h}),define(he[37],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8X=c;function c(t){return!!t.parentPort}}),define(he[64],fe([0,1,37,19,30,4,9,17]),function(ie,e,c,t,S,w,B,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9X=void 0,e.$0X=L;class ${constructor(d){this.a=d,this.onMessage=w.Event.fromNodeEventEmitter(this.a,"message",u=>u.data?t.$Ne.wrap(u.data):t.$Ne.alloc(0)),d.start()}send(d){this.a.postMessage(d.buffer)}disconnect(){this.a.close()}}class r extends S.$ii{static b(d){(0,B.$og)((0,c.$8X)(process),"Electron Utility Process");const u=new w.$le;return process.parentPort.on("message",a=>{if(d?.handledClientConnection(a))return;const h=(0,A.$Nb)(a.ports);h&&u.fire(h)}),w.Event.map(u.event,a=>({protocol:new $(a),onDidClientDisconnect:w.Event.fromNodeEventEmitter(a,"close")}))}constructor(d){super(r.b(d))}}e.$9X=r;function L(b,d,u){const a=h=>{h.data===d&&(b.removeListener("message",a),u())};b.on("message",a)}}),define(he[12],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localize=S,e.localize2=B;const c=globalThis._VSCODE_NLS_LANGUAGE==="pseudo"||typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;function t(A,$){let r;return $.length===0?r=A:r=A.replace(/\{(\d+)\}/g,(L,b)=>{const d=b[0],u=$[d];let a=L;return typeof u=="string"?a=u:(typeof u=="number"||typeof u=="boolean"||u===void 0||u===null)&&(a=String(u)),a}),c&&(r="\uFF3B"+r.replace(/[aouei]/g,"$&$&")+"\uFF3D"),r}function S(A,$,...r){return t(typeof A=="number"?w(A,$):$,r)}function w(A,$){const r=globalThis._VSCODE_NLS_MESSAGES?.[A];if(typeof r!="string"){if(typeof $=="string")return $;throw new Error(`!!! NLS MISSING: ${A} !!!`)}return r}function B(A,$,...r){let L;typeof A=="number"?L=w(A,$):L=$;const b=t(L,r);return{value:b,original:$===L?b:t($,r)}}}),define(he[65],fe([0,1,12]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=r,e.$2m=L,e.$3m=b;const t=60,S=t*60,w=S*24,B=w*7,A=w*30,$=w*365;function r(d,u,a,h){typeof d!="number"&&(d=d.getTime());const f=Math.round((new Date().getTime()-d)/1e3);if(f<-30)return(0,c.localize)(12976,null,r(new Date().getTime()+f*1e3,!1));if(!h&&f<30)return(0,c.localize)(12977,null);let l;return f<t?(l=f,u?l===1?a?(0,c.localize)(12978,null,l):(0,c.localize)(12979,null,l):a?(0,c.localize)(12980,null,l):(0,c.localize)(12981,null,l):l===1?a?(0,c.localize)(12982,null,l):(0,c.localize)(12983,null,l):a?(0,c.localize)(12984,null,l):(0,c.localize)(12985,null,l)):f<S?(l=Math.floor(f/t),u?l===1?a?(0,c.localize)(12986,null,l):(0,c.localize)(12987,null,l):a?(0,c.localize)(12988,null,l):(0,c.localize)(12989,null,l):l===1?a?(0,c.localize)(12990,null,l):(0,c.localize)(12991,null,l):a?(0,c.localize)(12992,null,l):(0,c.localize)(12993,null,l)):f<w?(l=Math.floor(f/S),u?l===1?a?(0,c.localize)(12994,null,l):(0,c.localize)(12995,null,l):a?(0,c.localize)(12996,null,l):(0,c.localize)(12997,null,l):l===1?a?(0,c.localize)(12998,null,l):(0,c.localize)(12999,null,l):a?(0,c.localize)(13e3,null,l):(0,c.localize)(13001,null,l)):f<B?(l=Math.floor(f/w),u?l===1?(0,c.localize)(13002,null,l):(0,c.localize)(13003,null,l):l===1?(0,c.localize)(13004,null,l):(0,c.localize)(13005,null,l)):f<A?(l=Math.floor(f/B),u?l===1?a?(0,c.localize)(13006,null,l):(0,c.localize)(13007,null,l):a?(0,c.localize)(13008,null,l):(0,c.localize)(13009,null,l):l===1?a?(0,c.localize)(13010,null,l):(0,c.localize)(13011,null,l):a?(0,c.localize)(13012,null,l):(0,c.localize)(13013,null,l)):f<$?(l=Math.floor(f/A),u?l===1?a?(0,c.localize)(13014,null,l):(0,c.localize)(13015,null,l):a?(0,c.localize)(13016,null,l):(0,c.localize)(13017,null,l):l===1?a?(0,c.localize)(13018,null,l):(0,c.localize)(13019,null,l):a?(0,c.localize)(13020,null,l):(0,c.localize)(13021,null,l)):(l=Math.floor(f/$),u?l===1?a?(0,c.localize)(13022,null,l):(0,c.localize)(13023,null,l):a?(0,c.localize)(13024,null,l):(0,c.localize)(13025,null,l):l===1?a?(0,c.localize)(13026,null,l):(0,c.localize)(13027,null,l):a?(0,c.localize)(13028,null,l):(0,c.localize)(13029,null,l))}function L(d,u){const a=Math.abs(d/1e3);return a<1?u?(0,c.localize)(13030,null,d):(0,c.localize)(13031,null,d):a<t?u?(0,c.localize)(13032,null,Math.round(d)/1e3):(0,c.localize)(13033,null,Math.round(d)/1e3):a<S?u?(0,c.localize)(13034,null,Math.round(d/(1e3*t))):(0,c.localize)(13035,null,Math.round(d/(1e3*t))):a<w?u?(0,c.localize)(13036,null,Math.round(d/(1e3*S))):(0,c.localize)(13037,null,Math.round(d/(1e3*S))):(0,c.localize)(13038,null,Math.round(d/(1e3*w)))}function b(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(he[66],fe([0,1,17,9,12]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=$,e.$qj=r,e.$rj=L,c=Se(c),t=Se(t),S=Se(S);function w(b,d){return d&&(b.stack||b.stacktrace)?S.localize(12970,null,A(b),B(b.stack)||B(b.stacktrace)):A(b)}function B(b){return Array.isArray(b)?b.join(`
`):b}function A(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?S.localize(12971,null,b.message):b.message||S.localize(12972,null)}function $(b=null,d=!1){if(!b)return S.localize(12973,null);if(Array.isArray(b)){const u=c.$Gb(b),a=$(u[0],d);return u.length>1?S.localize(12974,null,a,u.length):a}if(t.$eg(b))return b;if(b.detail){const u=b.detail;if(u.error)return w(u.error,d);if(u.exception)return w(u.exception,d)}return b.stack?w(b,d):b.message?b.message:S.localize(12975,null)}function r(b){const d=b;return d instanceof Error&&Array.isArray(d.actions)}function L(b,d){let u;return typeof b=="string"?u=new Error(b):u=b,u.actions=d,u}}),define(he[67],fe([0,1,13,7,12]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var w;(function(L){L[L.LParen=0]="LParen",L[L.RParen=1]="RParen",L[L.Neg=2]="Neg",L[L.Eq=3]="Eq",L[L.NotEq=4]="NotEq",L[L.Lt=5]="Lt",L[L.LtEq=6]="LtEq",L[L.Gt=7]="Gt",L[L.GtEq=8]="GtEq",L[L.RegexOp=9]="RegexOp",L[L.RegexStr=10]="RegexStr",L[L.True=11]="True",L[L.False=12]="False",L[L.In=13]="In",L[L.Not=14]="Not",L[L.And=15]="And",L[L.Or=16]="Or",L[L.Str=17]="Str",L[L.QuotedStr=18]="QuotedStr",L[L.Error=19]="Error",L[L.EOF=20]="EOF"})(w||(e.TokenType=w={}));function B(...L){switch(L.length){case 1:return(0,S.localize)(11574,null,L[0]);case 2:return(0,S.localize)(11575,null,L[0],L[1]);case 3:return(0,S.localize)(11576,null,L[0],L[1],L[2]);default:return}}const A=(0,S.localize)(11577,null),$=(0,S.localize)(11578,null);class r{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(b){switch(b.type){case w.LParen:return"(";case w.RParen:return")";case w.Neg:return"!";case w.Eq:return b.isTripleEq?"===":"==";case w.NotEq:return b.isTripleEq?"!==":"!=";case w.Lt:return"<";case w.LtEq:return"<=";case w.Gt:return">=";case w.GtEq:return">=";case w.RegexOp:return"=~";case w.RegexStr:return b.lexeme;case w.True:return"true";case w.False:return"false";case w.In:return"in";case w.Not:return"not";case w.And:return"&&";case w.Or:return"||";case w.Str:return b.lexeme;case w.QuotedStr:return b.lexeme;case w.Error:return b.lexeme;case w.EOF:return"EOF";default:throw(0,t.$7)(`unhandled token type: ${JSON.stringify(b)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(b=>b.charCodeAt(0)))}static{this.b=new Map([["not",w.Not],["in",w.In],["false",w.False],["true",w.True]])}get errors(){return this.g}reset(b){return this.c=b,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case c.CharCode.OpenParen:this.k(w.LParen);break;case c.CharCode.CloseParen:this.k(w.RParen);break;case c.CharCode.ExclamationMark:if(this.h(c.CharCode.Equals)){const d=this.h(c.CharCode.Equals);this.f.push({type:w.NotEq,offset:this.d,isTripleEq:d})}else this.k(w.Neg);break;case c.CharCode.SingleQuote:this.o();break;case c.CharCode.Slash:this.q();break;case c.CharCode.Equals:if(this.h(c.CharCode.Equals)){const d=this.h(c.CharCode.Equals);this.f.push({type:w.Eq,offset:this.d,isTripleEq:d})}else this.h(c.CharCode.Tilde)?this.k(w.RegexOp):this.l(B("==","=~"));break;case c.CharCode.LessThan:this.k(this.h(c.CharCode.Equals)?w.LtEq:w.Lt);break;case c.CharCode.GreaterThan:this.k(this.h(c.CharCode.Equals)?w.GtEq:w.Gt);break;case c.CharCode.Ampersand:this.h(c.CharCode.Ampersand)?this.k(w.And):this.l(B("&&"));break;case c.CharCode.Pipe:this.h(c.CharCode.Pipe)?this.k(w.Or):this.l(B("||"));break;case c.CharCode.Space:case c.CharCode.CarriageReturn:case c.CharCode.Tab:case c.CharCode.LineFeed:case c.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(w.EOF),Array.from(this.f)}h(b){return this.r()||this.c.charCodeAt(this.e)!==b?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?c.CharCode.Null:this.c.charCodeAt(this.e)}k(b){this.f.push({type:b,offset:this.d})}l(b){const d=this.d,u=this.c.substring(this.d,this.e),a={type:w.Error,offset:this.d,lexeme:u};this.g.push({offset:d,lexeme:u,additionalInfo:b}),this.f.push(a)}n(){this.m.lastIndex=this.d;const b=this.m.exec(this.c);if(b){this.e=this.d+b[0].length;const d=this.c.substring(this.d,this.e),u=r.b.get(d);u?this.k(u):this.f.push({type:w.Str,lexeme:d,offset:this.d})}}o(){for(;this.j()!==c.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:w.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let b=this.e,d=!1,u=!1;for(;;){if(b>=this.c.length){this.e=b,this.l($);return}const h=this.c.charCodeAt(b);if(d)d=!1;else if(h===c.CharCode.Slash&&!u){b++;break}else h===c.CharCode.OpenSquareBracket?u=!0:h===c.CharCode.Backslash?d=!0:h===c.CharCode.CloseSquareBracket&&(u=!1);b++}for(;b<this.c.length&&r.a.has(this.c.charCodeAt(b));)b++;this.e=b;const a=this.c.substring(this.d,this.e);this.f.push({type:w.RegexStr,lexeme:a,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=r}),define(he[68],fe([0,1,65,14,20,5,15,25,6]),function(ie,e,c,t,S,w,B,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=L,e.$7m=b,e.$4m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,w.$mc)(S.$Yg.asFileUri("").fsPath)}get userHome(){return $.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return $.URI.file((0,w.$jc)(this.userDataPath,"User"))}get tmpDir(){return $.URI.file(this.b.tmpDir)}get cacheHome(){return $.URI.file(this.userDataPath)}get stateResource(){return(0,A.$fh)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,A.$fh)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,c.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,w.$jc)(this.userDataPath,"logs",u)}return $.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,A.$fh)($.URI.file((0,w.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,A.$fh)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,A.$fh)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,A.$fh)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=B.env.VSCODE_PORTABLE;return u?$.URI.file((0,w.$jc)(u,"argv.json")):(0,A.$fh)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return $.URI.file((0,w.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,w.$kc)(u):(0,w.$hc)((0,w.$jc)(S.$Yg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?$.URI.file((0,w.$kc)(u)):$.URI.file((0,w.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,w.$kc)(u);const a=B.env.VSCODE_EXTENSIONS;if(a)return a;const h=B.env.VSCODE_PORTABLE;return h?(0,w.$jc)(h,"extensions"):(0,A.$fh)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(a=>/^[^:/?#]+?:\/\//.test(a)?$.URI.parse(a):$.URI.file((0,w.$hc)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?$.URI.parse(u):$.URI.file((0,w.$hc)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return L(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!B.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$4m.test(u))}get extensionLogLevel(){const u=[];for(const a of this.args.log||[]){const h=e.$4m.exec(a);h&&h[1]&&h[2]&&u.push([h[1],h[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,A.$fh)($.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=B.env.VSCODE_PORTABLE;return u?$.URI.file((0,w.$jc)(u,"policy.json")):(0,A.$fh)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,a,h){this.a=u,this.b=a,this.c=h,this.editSessionId=this.args.editSessionId}}e.$5m=r,$e([t.$9h],r.prototype,"appRoot",null),$e([t.$9h],r.prototype,"userHome",null),$e([t.$9h],r.prototype,"userDataPath",null),$e([t.$9h],r.prototype,"appSettingsHome",null),$e([t.$9h],r.prototype,"tmpDir",null),$e([t.$9h],r.prototype,"cacheHome",null),$e([t.$9h],r.prototype,"stateResource",null),$e([t.$9h],r.prototype,"userRoamingDataHome",null),$e([t.$9h],r.prototype,"userDataSyncHome",null),$e([t.$9h],r.prototype,"sync",null),$e([t.$9h],r.prototype,"machineSettingsResource",null),$e([t.$9h],r.prototype,"workspaceStorageHome",null),$e([t.$9h],r.prototype,"localHistoryHome",null),$e([t.$9h],r.prototype,"keyboardLayoutResource",null),$e([t.$9h],r.prototype,"argvResource",null),$e([t.$9h],r.prototype,"isExtensionDevelopment",null),$e([t.$9h],r.prototype,"untitledWorkspacesHome",null),$e([t.$9h],r.prototype,"builtinExtensionsPath",null),$e([t.$9h],r.prototype,"extensionsPath",null),$e([t.$9h],r.prototype,"extensionDevelopmentLocationURI",null),$e([t.$9h],r.prototype,"extensionDevelopmentKind",null),$e([t.$9h],r.prototype,"extensionTestsLocationURI",null),$e([t.$9h],r.prototype,"debugExtensionHost",null),$e([t.$9h],r.prototype,"logLevel",null),$e([t.$9h],r.prototype,"extensionLogLevel",null),$e([t.$9h],r.prototype,"serviceMachineIdResource",null),$e([t.$9h],r.prototype,"disableTelemetry",null),$e([t.$9h],r.prototype,"disableWorkspaceTrust",null),$e([t.$9h],r.prototype,"useInMemorySecretStorage",null),$e([t.$9h],r.prototype,"policyFile",null);function L(d,u){return b(d["inspect-extensions"],d["inspect-brk-extensions"],5870,u,d.debugId,d.extensionEnvironment)}function b(d,u,a,h,f,l){const p=Number(u||d)||(h?null:a),E=p?!!u:!1;let n;if(l)try{n=JSON.parse(l)}catch{}return{port:p,break:E,debugId:f,env:n}}});var Xe=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[69],fe([0,1,101,3,12]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bm=e.$Am=void 0,e.$Cm=A,e.$Dm=r,e.$Em=u,e.$Fm=a,c=Xe(c);const w={o:(0,S.localize)(11511,null),e:(0,S.localize)(11512,null),t:(0,S.localize)(11513,null)};e.$Am=["tunnel","serve-web"],e.$Bm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(11514,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(11515,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(11516,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(11517,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(11518,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(11519,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(11520,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(11521,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11522,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(11523,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(11524,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(11525,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(11526,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(11527,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(11528,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(11529,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(11530,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(11531,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(11532,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(11533,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(11534,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(11535,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(11536,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(11537,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(11538,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(11539,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(11540,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(11541,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(11542,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(11543,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(11544,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(11545,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,S.localize)(11546,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(11547,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(11548,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(11549,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},"enable-tracing":{type:"string"},"trace-startup-format":{type:"string"},"trace-startup-file":{type:"string"},"trace-startup-duration":{type:"string"},_:{type:"string[]"}};const B={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function A(h,f,l=B){const s=h.find(v=>v.length>0&&v[0]!=="-"),p={},E=["_"],n=[],o={};let i;for(const v in f){const _=f[v];_.type==="subcommand"?v===s&&(i=_):(_.alias&&(p[v]=_.alias),_.type==="string"||_.type==="string[]"?(E.push(v),_.deprecates&&E.push(..._.deprecates)):_.type==="boolean"&&(n.push(v),_.deprecates&&n.push(..._.deprecates)),_.global&&(o[v]=_))}if(i&&s){const v=o;for(const q in i.options)v[q]=i.options[q];const _=h.filter(q=>q!==s),k=l.getSubcommandReporter?l.getSubcommandReporter(s):void 0,M=A(_,v,k);return{[s]:M,_:[]}}const m=(0,c.default)(h,{string:E,boolean:n,alias:p}),R={},C=m;R._=m._.map(v=>String(v)).filter(v=>v.length>0),delete C._;for(const v in f){const _=f[v];if(_.type==="subcommand")continue;_.alias&&delete C[_.alias];let k=C[v];if(_.deprecates)for(const M of _.deprecates)C.hasOwnProperty(M)&&(k||(k=C[M],k&&l.onDeprecatedOption(M,_.deprecationMessage||(0,S.localize)(11550,null,v))),delete C[M]);if(typeof k<"u"){if(_.type==="string[]"){if(Array.isArray(k)||(k=[k]),!_.allowEmptyValue){const M=k.filter(q=>q.length>0);M.length!==k.length&&(l.onEmptyValue(v),k=M.length>0?M:void 0)}}else _.type==="string"&&(Array.isArray(k)?(k=k.pop(),l.onMultipleValues(v,k)):!k&&!_.allowEmptyValue&&(l.onEmptyValue(v),k=void 0));R[v]=k,_.deprecationMessage&&l.onDeprecatedOption(v,_.deprecationMessage)}delete C[v]}for(const v in C)l.onUnknownOption(v);return R}function $(h,f){let l="";return f.args&&(Array.isArray(f.args)?l=` <${f.args.join("> <")}>`:l=` <${f.args}>`),f.alias?`-${f.alias} --${h}${l}`:`--${h}${l}`}function r(h,f){const l=[];for(const s in h){const p=h[s],E=$(s,p);l.push([E,p.description])}return L(l,f)}function L(h,f){const s=h.reduce((n,o)=>Math.max(n,o[0].length),12)+2+1;if(f-s<25)return h.reduce((n,o)=>n.concat([`  ${o[0]}`,`      ${o[1]}`]),[]);const p=f-s-1,E=[];for(const n of h){const o=n[0],i=d(n[1],p),m=b(s-o.length-2);E.push("  "+o+m+i[0]);for(let R=1;R<i.length;R++)E.push(b(s)+i[R])}return E}function b(h){return" ".repeat(h)}function d(h,f){const l=[];for(;h.length;){const s=h.length<f?h.length:h.lastIndexOf(" ",f),p=h.slice(0,s).trim();h=h.slice(s),l.push(p)}return l}function u(h,f,l,s,p){const E=process.stdout.isTTY&&process.stdout.columns||80,n=p?.noInputFiles!==!0?`[${(0,S.localize)(11551,null)}...]`:"",o=[`${h} ${l}`];o.push(""),o.push(`${(0,S.localize)(11552,null)}: ${f} [${(0,S.localize)(11553,null)}]${n}`),o.push(""),p?.noPipe!==!0&&(t.$j?o.push((0,S.localize)(11554,null,f)):o.push((0,S.localize)(11555,null,f)),o.push(""));const i={},m=[];for(const R in s){const C=s[R];if(C.type==="subcommand")C.description&&m.push({command:R,description:C.description});else if(C.description&&C.cat){let v=i[C.cat];v||(i[C.cat]=v={}),v[R]=C}}for(const R in i){const C=R,v=i[C];v&&(o.push(w[C]),o.push(...r(v,E)),o.push(""))}return m.length&&(o.push((0,S.localize)(11556,null)),o.push(...L(m.map(R=>[R.command,R.description]),E)),o.push("")),o.join(`
`)}function a(h,f){return`${h||(0,S.localize)(11557,null)}
${f||(0,S.localize)(11558,null)}
${process.arch}`}}),function(){function ie(e,c,t){function S(B,A){const $=w(B,A),r=[$];return e.isAbsolute($)||r.unshift(t),e.resolve(...r)}function w(B,A){process.env.VSCODE_DEV&&(A="code-oss-dev");const $=process.env.VSCODE_PORTABLE;if($)return e.join($,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,A);const L=B["user-data-dir"];if(L)return L;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(b,"AppData","Roaming")}break;case"darwin":r=e.join(c.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(c.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,A)}return{getUserDataPath:S}}if(typeof define=="function")define(he[70],fe([71,21,15]),function(e,c,t){return ie(e,c,t.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),c=require("os");module.exports=ie(e,c,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(he[72],fe([0,1,21,68,70]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=B,e.$0m=A;class w extends t.$5m{constructor(r,L){super(r,{homeDir:(0,c.homedir)(),tmpDir:(0,c.tmpdir)(),userDataDir:(0,S.getUserDataPath)(r,L.nameShort)},L)}}e.$8m=w;function B($,r){return(0,t.$7m)($["inspect-ptyhost"],$["inspect-brk-ptyhost"],5877,r,$.extensionEnvironment)}function A($,r){return(0,t.$7m)($["inspect-sharedprocess"],$["inspect-brk-sharedprocess"],5879,r,$.extensionEnvironment)}}),define(he[22],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=S,e.$Fi=w;var c;(function(B){B.serviceIds=new Map,B.DI_TARGET="$di$target",B.DI_DEPENDENCIES="$di$dependencies";function A($){return $[B.DI_DEPENDENCIES]||[]}B.getServiceDependencies=A})(c||(e._util=c={})),e.$Di=S("instantiationService");function t(B,A,$){A[c.DI_TARGET]===A?A[c.DI_DEPENDENCIES].push({id:B,index:$}):(A[c.DI_DEPENDENCIES]=[{id:B,index:$}],A[c.DI_TARGET]=A)}function S(B){if(c.serviceIds.has(B))return c.serviceIds.get(B);const A=function($,r,L){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(A,$,L)};return A.toString=()=>B,c.serviceIds.set(B,A),A}function w(B){return B}}),define(he[38],fe([0,1,13,3,10,67,22,12,7]),function(ie,e,c,t,S,w,B,A,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=L,e.$Dj=m,e.$Ej=R,e.$Xj=W;const r=new Map;r.set("false",!1),r.set("true",!0),r.set("isMac",t.$k),r.set("isLinux",t.$l),r.set("isWindows",t.$j),r.set("isWeb",t.$p),r.set("isMacNative",t.$k&&!t.$p),r.set("isEdge",t.$I),r.set("isFirefox",t.$G),r.set("isChrome",t.$F),r.set("isSafari",t.$H);function L(te,g){if(r.get(te)!==void 0)throw(0,$.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");r.set(te,g)}const b=Object.prototype.hasOwnProperty;var d;(function(te){te[te.False=0]="False",te[te.True=1]="True",te[te.Defined=2]="Defined",te[te.Not=3]="Not",te[te.Equals=4]="Equals",te[te.NotEquals=5]="NotEquals",te[te.And=6]="And",te[te.Regex=7]="Regex",te[te.NotRegex=8]="NotRegex",te[te.Or=9]="Or",te[te.In=10]="In",te[te.NotIn=11]="NotIn",te[te.Greater=12]="Greater",te[te.GreaterEquals=13]="GreaterEquals",te[te.Smaller=14]="Smaller",te[te.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const u={regexParsingWithErrorRecovery:!0},a=(0,A.localize)(11588,null),h=(0,A.localize)(11589,null),f=(0,A.localize)(11590,null),l=(0,A.localize)(11591,null),s=(0,A.localize)(11592,null),p=(0,A.localize)(11593,null),E=(0,A.localize)(11594,null),n=(0,A.localize)(11595,null);class o{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(g=u){this.k=g,this.d=new w.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(g){if(g===""){this.h.push({message:a,offset:0,lexeme:"",additionalInfo:h});return}this.f=this.d.reset(g).scan(),this.g=0,this.h=[];try{const G=this.l();if(!this.E()){const oe=this.D(),N=oe.type===w.TokenType.Str?p:void 0;throw this.h.push({message:s,offset:oe.offset,lexeme:w.$zj.getLexeme(oe),additionalInfo:N}),o.c}return G}catch(G){if(G!==o.c)throw G;return}}l(){return this.m()}m(){const g=[this.o()];for(;this.y(w.TokenType.Or);){const G=this.o();g.push(G)}return g.length===1?g[0]:i.or(...g)}o(){const g=[this.s()];for(;this.y(w.TokenType.And);){const G=this.s();g.push(G)}return g.length===1?g[0]:i.and(...g)}s(){if(this.y(w.TokenType.Neg)){const g=this.D();switch(g.type){case w.TokenType.True:return this.z(),v.INSTANCE;case w.TokenType.False:return this.z(),_.INSTANCE;case w.TokenType.LParen:{this.z();const G=this.l();return this.A(w.TokenType.RParen,l),G?.negate()}case w.TokenType.Str:return this.z(),U.create(g.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",g)}}return this.t()}t(){const g=this.D();switch(g.type){case w.TokenType.True:return this.z(),i.true();case w.TokenType.False:return this.z(),i.false();case w.TokenType.LParen:{this.z();const G=this.l();return this.A(w.TokenType.RParen,l),G}case w.TokenType.Str:{const G=g.lexeme;if(this.z(),this.y(w.TokenType.RegexOp)){const N=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),N.type!==w.TokenType.RegexStr)throw this.B("REGEX",N);const K=N.lexeme,T=K.lastIndexOf("/"),O=T===K.length-1?void 0:this.w(K.substring(T+1));let H;try{H=new RegExp(K.substring(1,T),O)}catch{throw this.B("REGEX",N)}return Z.create(G,H)}switch(N.type){case w.TokenType.RegexStr:case w.TokenType.Error:{const K=[N.lexeme];this.z();let T=this.D(),O=0;for(let ve=0;ve<N.lexeme.length;ve++)N.lexeme.charCodeAt(ve)===c.CharCode.OpenParen?O++:N.lexeme.charCodeAt(ve)===c.CharCode.CloseParen&&O--;for(;!this.E()&&T.type!==w.TokenType.And&&T.type!==w.TokenType.Or;){switch(T.type){case w.TokenType.LParen:O++;break;case w.TokenType.RParen:O--;break;case w.TokenType.RegexStr:case w.TokenType.QuotedStr:for(let ve=0;ve<T.lexeme.length;ve++)T.lexeme.charCodeAt(ve)===c.CharCode.OpenParen?O++:N.lexeme.charCodeAt(ve)===c.CharCode.CloseParen&&O--}if(O<0)break;K.push(w.$zj.getLexeme(T)),this.z(),T=this.D()}const H=K.join(""),x=H.lastIndexOf("/"),ne=x===H.length-1?void 0:this.w(H.substring(x+1));let be;try{be=new RegExp(H.substring(1,x),ne)}catch{throw this.B("REGEX",N)}return i.regex(G,be)}case w.TokenType.QuotedStr:{const K=N.lexeme;this.z();let T=null;if(!(0,S.$cf)(K)){const O=K.indexOf("/"),H=K.lastIndexOf("/");if(O!==H&&O>=0){const x=K.slice(O+1,H),ne=K[H+1]==="i"?"i":"";try{T=new RegExp(x,ne)}catch{throw this.B("REGEX",N)}}}if(T===null)throw this.B("REGEX",N);return Z.create(G,T)}default:throw this.B("REGEX",this.D())}}if(this.y(w.TokenType.Not)){this.A(w.TokenType.In,f);const N=this.u();return i.notIn(G,N)}switch(this.D().type){case w.TokenType.Eq:{this.z();const N=this.u();if(this.x().type===w.TokenType.QuotedStr)return i.equals(G,N);switch(N){case"true":return i.has(G);case"false":return i.not(G);default:return i.equals(G,N)}}case w.TokenType.NotEq:{this.z();const N=this.u();if(this.x().type===w.TokenType.QuotedStr)return i.notEquals(G,N);switch(N){case"true":return i.not(G);case"false":return i.has(G);default:return i.notEquals(G,N)}}case w.TokenType.Lt:return this.z(),Q.create(G,this.u());case w.TokenType.LtEq:return this.z(),V.create(G,this.u());case w.TokenType.Gt:return this.z(),P.create(G,this.u());case w.TokenType.GtEq:return this.z(),F.create(G,this.u());case w.TokenType.In:return this.z(),i.in(G,this.u());default:return i.has(G)}}case w.TokenType.EOF:throw this.h.push({message:E,offset:g.offset,lexeme:"",additionalInfo:n}),o.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const g=this.D();switch(g.type){case w.TokenType.Str:case w.TokenType.QuotedStr:return this.z(),g.lexeme;case w.TokenType.True:return this.z(),"true";case w.TokenType.False:return this.z(),"false";case w.TokenType.In:return this.z(),"in";default:return""}}w(g){return g.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(g){return this.C(g)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(g,G){if(this.C(g))return this.z();throw this.B(G,this.D())}B(g,G,oe){const N=(0,A.localize)(11596,null,g,w.$zj.getLexeme(G)),K=G.offset,T=w.$zj.getLexeme(G);return this.h.push({message:N,offset:K,lexeme:T,additionalInfo:oe}),o.c}C(g){return this.D().type===g}D(){return this.f[this.g]}E(){return this.D().type===w.TokenType.EOF}}e.$Bj=o;class i{static false(){return v.INSTANCE}static true(){return _.INSTANCE}static has(g){return k.create(g)}static equals(g,G){return M.create(g,G)}static notEquals(g,G){return y.create(g,G)}static regex(g,G){return Z.create(g,G)}static in(g,G){return q.create(g,G)}static notIn(g,G){return I.create(g,G)}static not(g){return U.create(g)}static and(...g){return X.create(g,null,!0)}static or(...g){return j.create(g,null,!0)}static greater(g,G){return P.create(g,G)}static greaterEquals(g,G){return F.create(g,G)}static smaller(g,G){return Q.create(g,G)}static smallerEquals(g,G){return V.create(g,G)}static{this.c=new o({regexParsingWithErrorRecovery:!1})}static deserialize(g){return g==null?void 0:this.c.parse(g)}}e.$Cj=i;function m(te){const g=new o({regexParsingWithErrorRecovery:!1});return te.map(G=>(g.parse(G),g.lexingErrors.length>0?g.lexingErrors.map(oe=>({errorMessage:oe.additionalInfo?(0,A.localize)(11597,null,oe.additionalInfo):(0,A.localize)(11598,null),offset:oe.offset,length:oe.lexeme.length})):g.parsingErrors.length>0?g.parsingErrors.map(oe=>({errorMessage:oe.additionalInfo?`${oe.message}. ${oe.additionalInfo}`:oe.message,offset:oe.offset,length:oe.lexeme.length})):[]))}function R(te,g){const G=te?te.substituteConstants():void 0,oe=g?g.substituteConstants():void 0;return!G&&!oe?!0:!G||!oe?!1:G.equals(oe)}function C(te,g){return te.cmp(g)}class v{static{this.INSTANCE=new v}constructor(){this.type=d.False}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return _.INSTANCE}}e.$Fj=v;class _{static{this.INSTANCE=new _}constructor(){this.type=d.True}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return v.INSTANCE}}e.$Gj=_;class k{static create(g,G=null){const oe=r.get(g);return typeof oe=="boolean"?oe?_.INSTANCE:v.INSTANCE:new k(g,G)}constructor(g,G){this.key=g,this.c=G,this.type=d.Defined}cmp(g){return g.type!==this.type?this.type-g.type:ee(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=r.get(this.key);return typeof g=="boolean"?g?_.INSTANCE:v.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.c||(this.c=U.create(this.key,this)),this.c}}e.$Hj=k;class M{static create(g,G,oe=null){if(typeof G=="boolean")return G?k.create(g,oe):U.create(g,oe);const N=r.get(g);return typeof N=="boolean"?G===(N?"true":"false")?_.INSTANCE:v.INSTANCE:new M(g,G,oe)}constructor(g,G,oe){this.c=g,this.d=G,this.f=oe,this.type=d.Equals}cmp(g){return g.type!==this.type?this.type-g.type:le(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=r.get(this.c);if(typeof g=="boolean"){const G=g?"true":"false";return this.d===G?_.INSTANCE:v.INSTANCE}return this}evaluate(g){return g.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(g){return g.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Ij=M;class q{static create(g,G){return new q(g,G)}constructor(g,G){this.d=g,this.f=G,this.type=d.In,this.c=null}cmp(g){return g.type!==this.type?this.type-g.type:le(this.d,this.f,g.d,g.f)}equals(g){return g.type===this.type?this.d===g.d&&this.f===g.f:!1}substituteConstants(){return this}evaluate(g){const G=g.getValue(this.f),oe=g.getValue(this.d);return Array.isArray(G)?G.includes(oe):typeof oe=="string"&&typeof G=="object"&&G!==null?b.call(G,oe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(g){return g.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$Jj=q;class I{static create(g,G){return new I(g,G)}constructor(g,G){this.d=g,this.f=G,this.type=d.NotIn,this.c=q.create(g,G)}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(g){return g.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=I;class y{static create(g,G,oe=null){if(typeof G=="boolean")return G?U.create(g,oe):k.create(g,oe);const N=r.get(g);return typeof N=="boolean"?G===(N?"true":"false")?v.INSTANCE:_.INSTANCE:new y(g,G,oe)}constructor(g,G,oe){this.c=g,this.d=G,this.f=oe,this.type=d.NotEquals}cmp(g){return g.type!==this.type?this.type-g.type:le(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=r.get(this.c);if(typeof g=="boolean"){const G=g?"true":"false";return this.d===G?v.INSTANCE:_.INSTANCE}return this}evaluate(g){return g.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(g){return g.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Lj=y;class U{static create(g,G=null){const oe=r.get(g);return typeof oe=="boolean"?oe?v.INSTANCE:_.INSTANCE:new U(g,G)}constructor(g,G){this.c=g,this.d=G,this.type=d.Not}cmp(g){return g.type!==this.type?this.type-g.type:ee(this.c,g.c)}equals(g){return g.type===this.type?this.c===g.c:!1}substituteConstants(){const g=r.get(this.c);return typeof g=="boolean"?g?v.INSTANCE:_.INSTANCE:this}evaluate(g){return!g.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(g){return g.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$Mj=U;function D(te,g){if(typeof te=="string"){const G=parseFloat(te);isNaN(G)||(te=G)}return typeof te=="string"||typeof te=="number"?g(te):v.INSTANCE}class P{static create(g,G,oe=null){return D(G,N=>new P(g,N,oe))}constructor(g,G,oe){this.c=g,this.d=G,this.f=oe,this.type=d.Greater}cmp(g){return g.type!==this.type?this.type-g.type:le(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Nj=P;class F{static create(g,G,oe=null){return D(G,N=>new F(g,N,oe))}constructor(g,G,oe){this.c=g,this.d=G,this.f=oe,this.type=d.GreaterEquals}cmp(g){return g.type!==this.type?this.type-g.type:le(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Q.create(this.c,this.d,this)),this.f}}e.$Oj=F;class Q{static create(g,G,oe=null){return D(G,N=>new Q(g,N,oe))}constructor(g,G,oe){this.c=g,this.d=G,this.f=oe,this.type=d.Smaller}cmp(g){return g.type!==this.type?this.type-g.type:le(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Pj=Q;class V{static create(g,G,oe=null){return D(G,N=>new V(g,N,oe))}constructor(g,G,oe){this.c=g,this.d=G,this.f=oe,this.type=d.SmallerEquals}cmp(g){return g.type!==this.type?this.type-g.type:le(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Qj=V;class Z{static create(g,G){return new Z(g,G)}constructor(g,G){this.d=g,this.f=G,this.type=d.Regex,this.c=null}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.d<g.d)return-1;if(this.d>g.d)return 1;const G=this.f?this.f.source:"",oe=g.f?g.f.source:"";return G<oe?-1:G>oe?1:0}equals(g){if(g.type===this.type){const G=this.f?this.f.source:"",oe=g.f?g.f.source:"";return this.d===g.d&&G===oe}return!1}substituteConstants(){return this}evaluate(g){const G=g.getValue(this.d);return this.f?this.f.test(G):!1}serialize(){const g=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${g}`}keys(){return[this.d]}map(g){return g.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=re.create(this)),this.c}}e.$Rj=Z;class re{static create(g){return new re(g)}constructor(g){this.c=g,this.type=d.NotRegex}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(g){return new re(this.c.map(g))}negate(){return this.c}}e.$Sj=re;function ae(te){let g=null;for(let G=0,oe=te.length;G<oe;G++){const N=te[G].substituteConstants();if(te[G]!==N&&g===null){g=[];for(let K=0;K<G;K++)g[K]=te[K]}g!==null&&(g[G]=N)}return g===null?te:g}class X{static create(g,G,oe){return X.d(g,G,oe)}constructor(g,G){this.expr=g,this.c=G,this.type=d.And}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let G=0,oe=this.expr.length;G<oe;G++){const N=C(this.expr[G],g.expr[G]);if(N!==0)return N}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let G=0,oe=this.expr.length;G<oe;G++)if(!this.expr[G].equals(g.expr[G]))return!1;return!0}return!1}substituteConstants(){const g=ae(this.expr);return g===this.expr?this:X.create(g,this.c,!1)}evaluate(g){for(let G=0,oe=this.expr.length;G<oe;G++)if(!this.expr[G].evaluate(g))return!1;return!0}static d(g,G,oe){const N=[];let K=!1;for(const T of g)if(T){if(T.type===d.True){K=!0;continue}if(T.type===d.False)return v.INSTANCE;if(T.type===d.And){N.push(...T.expr);continue}N.push(T)}if(N.length===0&&K)return _.INSTANCE;if(N.length!==0){if(N.length===1)return N[0];N.sort(C);for(let T=1;T<N.length;T++)N[T-1].equals(N[T])&&(N.splice(T,1),T--);if(N.length===1)return N[0];for(;N.length>1;){const T=N[N.length-1];if(T.type!==d.Or)break;N.pop();const O=N.pop(),H=N.length===0,x=j.create(T.expr.map(ne=>X.create([ne,O],null,oe)),null,H);x&&(N.push(x),N.sort(C))}if(N.length===1)return N[0];if(oe){for(let T=0;T<N.length;T++)for(let O=T+1;O<N.length;O++)if(N[T].negate().equals(N[O]))return v.INSTANCE;if(N.length===1)return N[0]}return new X(N,G)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(const G of this.expr)g.push(...G.keys());return g}map(g){return new X(this.expr.map(G=>G.map(g)),null)}negate(){if(!this.c){const g=[];for(const G of this.expr)g.push(G.negate());this.c=j.create(g,this,!0)}return this.c}}e.$Tj=X;class j{static create(g,G,oe){return j.d(g,G,oe)}constructor(g,G){this.expr=g,this.c=G,this.type=d.Or}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let G=0,oe=this.expr.length;G<oe;G++){const N=C(this.expr[G],g.expr[G]);if(N!==0)return N}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let G=0,oe=this.expr.length;G<oe;G++)if(!this.expr[G].equals(g.expr[G]))return!1;return!0}return!1}substituteConstants(){const g=ae(this.expr);return g===this.expr?this:j.create(g,this.c,!1)}evaluate(g){for(let G=0,oe=this.expr.length;G<oe;G++)if(this.expr[G].evaluate(g))return!0;return!1}static d(g,G,oe){let N=[],K=!1;if(g){for(let T=0,O=g.length;T<O;T++){const H=g[T];if(H){if(H.type===d.False){K=!0;continue}if(H.type===d.True)return _.INSTANCE;if(H.type===d.Or){N=N.concat(H.expr);continue}N.push(H)}}if(N.length===0&&K)return v.INSTANCE;N.sort(C)}if(N.length!==0){if(N.length===1)return N[0];for(let T=1;T<N.length;T++)N[T-1].equals(N[T])&&(N.splice(T,1),T--);if(N.length===1)return N[0];if(oe){for(let T=0;T<N.length;T++)for(let O=T+1;O<N.length;O++)if(N[T].negate().equals(N[O]))return _.INSTANCE;if(N.length===1)return N[0]}return new j(N,G)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(const G of this.expr)g.push(...G.keys());return g}map(g){return new j(this.expr.map(G=>G.map(g)),null)}negate(){if(!this.c){const g=[];for(const G of this.expr)g.push(G.negate());for(;g.length>1;){const G=g.shift(),oe=g.shift(),N=[];for(const K of ge(G))for(const T of ge(oe))N.push(X.create([K,T],null,!1));g.unshift(j.create(N,null,!1))}this.c=j.create(g,this,!0)}return this.c}}e.$Uj=j;class J extends k{static{this.d=[]}static all(){return J.d.values()}constructor(g,G,oe){super(g,null),this.f=G,typeof oe=="object"?J.d.push({...oe,key:g}):oe!==!0&&J.d.push({key:g,description:oe,type:G!=null?typeof G:void 0})}bindTo(g){return g.createKey(this.key,this.f)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return M.create(this.key,g)}notEqualsTo(g){return y.create(this.key,g)}}e.$Vj=J,e.$Wj=(0,B.$Ei)("contextKeyService");function ee(te,g){return te<g?-1:te>g?1:0}function le(te,g,G,oe){return te<G?-1:te>G?1:g<oe?-1:g>oe?1:0}function W(te,g){if(te.type===d.False||g.type===d.True)return!0;if(te.type===d.Or)return g.type===d.Or?ce(te.expr,g.expr):!1;if(g.type===d.Or){for(const G of g.expr)if(W(te,G))return!0;return!1}if(te.type===d.And){if(g.type===d.And)return ce(g.expr,te.expr);for(const G of te.expr)if(W(G,g))return!0;return!1}return te.equals(g)}function ce(te,g){let G=0,oe=0;for(;G<te.length&&oe<g.length;){const N=te[G].cmp(g[oe]);if(N<0)return!1;N===0&&G++,oe++}return G===te.length}function ge(te){return te.type===d.Or?te.expr:[te]}}),define(he[73],fe([0,1,55,5,10,9,6,12,22,3,20,24]),function(ie,e,c,t,S,w,B,A,$,r,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=d,e.$bl=f,e.$cl=s,e.$dl=p,e.$el=E,e.$fl=n,e.$gl=o,e.$hl=i,e.$il=m,e.$jl=R,e.$kl=C,e.$ml=k,e.$nl=M,e.$ol=q,e.$pl=I,e.$ql=y,e.$tl=Q,e.$Fl=j,e.$Gl=J,e.$Il=le,e.$_k=(0,$.$Ei)("fileService");function d(W){return W.create===!0}var u;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var a;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var h;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(h||(e.FileChangeFilter=h={}));function f(W){const ce=W;return!!ce&&typeof ce.onDidChange=="function"}var l;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(l||(e.FileSystemProviderCapabilities=l={}));function s(W){return!!(W.capabilities&l.FileReadWrite)}function p(W){return!!(W.capabilities&l.FileFolderCopy)}function E(W){return!!(W.capabilities&l.FileClone)}function n(W){return!!(W.capabilities&l.FileOpenReadWriteClose)}function o(W){return!!(W.capabilities&l.FileReadStream)}function i(W){return s(W)?!!(W.capabilities&l.FileAtomicRead):!1}function m(W){return s(W)?!!(W.capabilities&l.FileAtomicWrite):!1}function R(W){return!!(W.capabilities&l.FileAtomicDelete)}function C(W){return!!(W.capabilities&l.Readonly)}var v;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class _ extends Error{static create(ce,ge){const te=new _(ce.toString(),ge);return q(te,ge),te}constructor(ce,ge){super(ce),this.code=ge}}e.$ll=_;function k(W,ce){return _.create(W,ce)}function M(W){return W||k((0,A.localize)(11374,null),v.Unknown)}function q(W,ce){return W.name=ce?`${ce} (FileSystemError)`:"FileSystemError",W}function I(W){if(!W)return v.Unknown;if(W instanceof _)return W.code;const ce=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!ce)return v.Unknown;switch(ce[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}function y(W){if(W instanceof V)return W.fileOperationResult;switch(I(W)){case v.FileNotFound:return ae.FILE_NOT_FOUND;case v.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case v.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case v.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case v.NoPermissions:return ae.FILE_PERMISSION_DENIED;case v.FileExists:return ae.FILE_MOVE_CONFLICT;case v.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var U;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(U||(e.FileOperation=U={}));class D{constructor(ce,ge,te){this.resource=ce,this.operation=ge,this.target=te}isOperation(ce){return this.operation===ce}}e.$rl=D;var P;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class F{static{this.a=null}constructor(ce,ge){this.c=ge,this.b=void 0,this.d=new b.$T(()=>{const te=c.$Ki.forUris(()=>this.c);return te.fill(this.rawAdded.map(g=>[g,!0])),te}),this.f=new b.$T(()=>{const te=c.$Ki.forUris(()=>this.c);return te.fill(this.rawUpdated.map(g=>[g,!0])),te}),this.g=new b.$T(()=>{const te=c.$Ki.forUris(()=>this.c);return te.fill(this.rawDeleted.map(g=>[g,!0])),te}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const te of ce){switch(te.type){case P.ADDED:this.rawAdded.push(te.resource);break;case P.UPDATED:this.rawUpdated.push(te.resource);break;case P.DELETED:this.rawDeleted.push(te.resource);break}this.b!==F.a&&(typeof te.cId=="number"?this.b===void 0?this.b=te.cId:this.b!==te.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ce,...ge){return this.h(ce,{includeChildren:!1},...ge)}affects(ce,...ge){return this.h(ce,{includeChildren:!0},...ge)}h(ce,ge,...te){if(!ce)return!1;const g=te.length>0;return!!((!g||te.includes(P.ADDED))&&(this.d.value.get(ce)||ge.includeChildren&&this.d.value.findSuperstr(ce))||(!g||te.includes(P.UPDATED))&&(this.f.value.get(ce)||ge.includeChildren&&this.f.value.findSuperstr(ce))||(!g||te.includes(P.DELETED))&&(this.g.value.findSubstr(ce)||ge.includeChildren&&this.g.value.findSuperstr(ce)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ce){return this.b===ce}hasCorrelation(){return typeof this.b=="number"}}e.$sl=F;function Q(W,ce,ge){return!W||!ce||W===ce||ce.length>W.length?!1:(ce.charAt(ce.length-1)!==t.sep&&(ce+=t.sep),ge?(0,S.$Gf)(W,ce):W.indexOf(ce)===0)}class V extends Error{constructor(ce,ge,te){super(ce),this.fileOperationResult=ge,this.options=te}}e.$ul=V;class Z extends V{constructor(ce,ge,te,g){super(ce,ge,g),this.fileOperationResult=ge,this.size=te}}e.$vl=Z;class re extends V{constructor(ce,ge,te){super(ce,ae.FILE_NOT_MODIFIED_SINCE,te),this.stat=ge}}e.$wl=re;var ae;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var X;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$El="";function j(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function J(W,ce){if(!ce.hasProvider(B.URI.from({scheme:W.scheme})))return new Promise(ge=>{const te=ce.onDidChangeFileSystemProviderRegistrations(g=>{g.scheme===W.scheme&&g.added&&(te.dispose(),ge())})})}class ee{static{this.KB=1024}static{this.MB=ee.KB*ee.KB}static{this.GB=ee.MB*ee.KB}static{this.TB=ee.GB*ee.KB}static formatSize(ce){return(0,w.$ig)(ce)||(ce=0),ce<ee.KB?(0,A.localize)(11375,null,ce.toFixed(0)):ce<ee.MB?(0,A.localize)(11376,null,(ce/ee.KB).toFixed(2)):ce<ee.GB?(0,A.localize)(11377,null,(ce/ee.MB).toFixed(2)):ce<ee.TB?(0,A.localize)(11378,null,(ce/ee.GB).toFixed(2)):(0,A.localize)(11379,null,(ce/ee.TB).toFixed(2))}}e.$Hl=ee;function le(W){const ce=typeof W=="string"||W?.scheme===L.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===L.Schemas.file?1024*ee.MB:ce?10*ee.MB:r.$p?50*ee.MB:1024*ee.MB}}),define(he[8],fe([0,1,12,66,4,54,2,26,3,25,9,6,38,22]),function(ie,e,c,t,S,w,B,A,$,r,L,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=h,e.log=l,e.$nk=_,e.$ok=k,e.$pk=M,e.$qk=q,c=Se(c),e.$_j=(0,u.$Ei)("logService"),e.$ak=(0,u.$Ei)("loggerService");function a(){return new Date().toISOString()}function h(I){return(0,L.$ig)(I)}var f;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$ck=f.Info;function l(I,y,U){switch(y){case f.Trace:I.trace(U);break;case f.Debug:I.debug(U);break;case f.Info:I.info(U);break;case f.Warning:I.warn(U);break;case f.Error:I.error(U);break;case f.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function s(I,y=!1){let U="";for(let D=0;D<I.length;D++){let P=I[D];if(P instanceof Error&&(P=(0,t.$pj)(P,y)),typeof P=="object")try{P=JSON.stringify(P)}catch{}U+=(D>0?" ":"")+P}return U}class p extends B.$Uc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new S.$le),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==f.Off&&this.b<=y}}e.$ek=p;class E extends p{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...U){this.f(f.Trace)&&this.g(f.Trace,s([y,...U],!0))}debug(y,...U){this.f(f.Debug)&&this.g(f.Debug,s([y,...U]))}info(y,...U){this.f(f.Info)&&this.g(f.Info,s([y,...U]))}warn(y,...U){this.f(f.Warning)&&this.g(f.Warning,s([y,...U]))}error(y,...U){if(this.f(f.Error))if(y instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=y.stack,this.g(f.Error,s(D))}else this.g(f.Error,s([y,...U]))}flush(){}}e.$fk=E;class n extends p{constructor(y=e.$ck){super(),this.setLevel(y),this.g=!$.$j}trace(y,...U){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,y,...U):console.log(`[main ${a()}]`,y,...U))}debug(y,...U){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,y,...U):console.log(`[main ${a()}]`,y,...U))}info(y,...U){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,y,...U):console.log(`[main ${a()}]`,y,...U))}warn(y,...U){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,y,...U):console.warn(`[main ${a()}]`,y,...U))}error(y,...U){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,y,...U):console.error(`[main ${a()}]`,y,...U))}flush(){}}e.$gk=n;class o extends p{constructor(y=e.$ck,U=!0){super(),this.g=U,this.setLevel(y)}trace(y,...U){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...U):console.log(y,...U))}debug(y,...U){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...U):console.log(y,...U))}info(y,...U){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...U):console.log(y,...U))}warn(y,...U){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...U):console.log(y,...U))}error(y,...U){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...U):console.error(y,...U))}flush(){}}e.$hk=o;class i extends p{constructor(y,U=e.$ck){super(),this.g=y,this.setLevel(U)}trace(y,...U){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(y),...U])}debug(y,...U){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(y),...U])}info(y,...U){this.f(f.Info)&&this.g.log(f.Info,[this.h(y),...U])}warn(y,...U){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(y),...U])}error(y,...U){this.f(f.Error)&&this.g.log(f.Error,[this.h(y),...U])}h(y){return typeof y=="string"?y:(0,t.$pj)(y,this.f(f.Trace))}flush(){}}e.$ik=i;class m extends p{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const U of this.g)U.setLevel(y);super.setLevel(y)}trace(y,...U){for(const D of this.g)D.trace(y,...U)}debug(y,...U){for(const D of this.g)D.debug(y,...U)}info(y,...U){for(const D of this.g)D.info(y,...U)}warn(y,...U){for(const D of this.g)D.warn(y,...U)}error(y,...U){for(const D of this.g)D.error(y,...U)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$jk=m;class R extends B.$Uc{constructor(y,U,D){if(super(),this.h=y,this.j=U,this.b=new A.$Ac,this.c=this.B(new S.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$le),this.onDidChangeVisibility=this.g.event,D)for(const P of D)this.b.set(P.resource,{logger:void 0,info:P})}m(y){return(0,L.$eg)(y)?[...this.b.values()].find(U=>U.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,U){const D=this.n(y),P=(0,L.$eg)(y)?y:U?.id??(0,w.$sj)(D.toString()).toString(16);let F=this.b.get(D)?.logger;const Q=U?.logLevel==="always"?f.Trace:U?.logLevel;F||(F=this.s(D,Q??this.getLogLevel(D)??this.h,{...U,id:P}));const V={logger:F,info:{resource:D,id:P,logLevel:Q,name:U?.name,hidden:U?.hidden,extensionId:U?.extensionId,when:U?.when}};return this.registerLogger(V.info),this.b.set(D,V),F}n(y){return(0,L.$eg)(y)?(0,r.$fh)(this.j,`${y}.log`):y}setLogLevel(y,U){if(b.URI.isUri(y)){const D=y,P=U,F=this.b.get(D);F&&P!==F.info.logLevel&&(F.info.logLevel=P===this.h?void 0:P,F.logger?.setLevel(P),this.b.set(F.info.resource,F),this.f.fire([D,P]))}else{this.h=y;for(const[D,P]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&P.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,U){const D=this.m(y);D&&U!==!D.info.hidden&&(D.info.hidden=!U,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,U]))}getLogLevel(y){let U;return y&&(U=this.b.get(y)?.info.logLevel),U??this.h}registerLogger(y){const U=this.b.get(y.resource);U?U.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const U=this.b.get(y);U&&(U.logger&&U.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[U.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=R;class C{constructor(){this.onDidChangeLogLevel=new S.$le().event}setLevel(y){}getLevel(){return f.Info}trace(y,...U){}debug(y,...U){}info(y,...U){}warn(y,...U){}error(y,...U){}critical(y,...U){}dispose(){}flush(){}}e.$lk=C;class v extends C{}e.$mk=v;function _(I){if(I.verbose)return f.Trace;if(typeof I.logLevel=="string"){const y=q(I.logLevel.toLowerCase());if(y!==void 0)return y}return e.$ck}function k(I){switch(I){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function M(I){switch(I){case f.Trace:return{original:"Trace",value:c.localize(11307,null)};case f.Debug:return{original:"Debug",value:c.localize(11308,null)};case f.Info:return{original:"Info",value:c.localize(11309,null)};case f.Warning:return{original:"Warning",value:c.localize(11310,null)};case f.Error:return{original:"Error",value:c.localize(11311,null)};case f.Off:return{original:"Off",value:c.localize(11312,null)}}}function q(I){switch(I){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$rk=new d.$Vj("logLevel",k(f.Info))}),define(he[74],fe([0,1,6,4,8,2]),function(ie,e,c,t,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=e.$ts=e.$ss=void 0;class B extends S.$kk{constructor(b,d,u,a,h){super(d,u,a),this.r=b,this.t=h,this.B(h.listen("onDidChangeLogLevel",b)(f=>{(0,S.$bk)(f)?super.setLogLevel(f):super.setLogLevel(c.URI.revive(f[0]),f[1])})),this.B(h.listen("onDidChangeVisibility",b)(([f,l])=>super.setVisibility(c.URI.revive(f),l))),this.B(h.listen("onDidChangeLoggers",b)(({added:f,removed:l})=>{for(const s of f)super.registerLogger({...s,resource:c.URI.revive(s.resource)});for(const s of l)super.deregisterLogger(s.resource)}))}createConsoleMainLogger(){return new S.$ik({log:(b,d)=>{this.t.call("consoleLog",[b,d])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,d){super.setLogLevel(b,d),this.t.call("setLogLevel",[b,d])}setVisibility(b,d){super.setVisibility(b,d),this.t.call("setVisibility",[this.n(b),d])}s(b,d,u){return new A(this.t,b,d,u,this.r)}static setLogLevel(b,d,u){return b.call("setLogLevel",[d,u])}}e.$ss=B;class A extends S.$fk{constructor(b,d,u,a,h){super(a?.logLevel==="always"),this.r=b,this.s=d,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[d,a,h]).then(()=>{this.u(this.n),this.m=!0})}g(b,d){const u=[[b,d]];this.m?this.u(u):this.n.push(...u)}u(b){this.r.call("log",[this.s,b])}}class ${constructor(b,d){this.a=b,this.b=d}listen(b,d){const u=this.b(b);switch(d){case"onDidChangeLoggers":return t.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(h=>this.c(h,u)),removed:[...a.removed].map(h=>this.c(h,u))}));case"onDidChangeVisibility":return t.Event.map(this.a.onDidChangeVisibility,a=>[u.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return t.Event.map(this.a.onDidChangeLogLevel,a=>(0,S.$bk)(a)?a:[u.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${d}`)}async call(b,d,u){const a=this.b(b);switch(d){case"setLogLevel":return(0,S.$bk)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(c.URI.revive(a.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(h=>this.c(h,a)))}throw new Error(`Call not found: ${d}`)}c(b,d){return{...b,resource:d.transformOutgoingURI(b.resource)}}}e.$ts=$;class r extends w.$Uc{constructor(b,d){super(),d.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(u=>d.call("setLogLevel",[u]))),d.call("getRegisteredLoggers").then(u=>{for(const a of u)b.registerLogger({...a,resource:c.URI.revive(a.resource)})}),this.B(d.listen("onDidChangeVisibility")(([u,a])=>b.setVisibility(c.URI.revive(u),a))),this.B(d.listen("onDidChangeLoggers")(({added:u,removed:a})=>{for(const h of u)b.registerLogger({...h,resource:c.URI.revive(h.resource)});for(const h of a)b.deregisterLogger(h.resource)}))}}e.$us=r}),define(he[75],fe([0,1,2,8]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=void 0;class S extends c.$Uc{constructor(B,A=[]){super(),this.a=new t.$jk([B,...A]),this.B(B.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(B){this.a.setLevel(B)}getLevel(){return this.a.getLevel()}trace(B,...A){this.a.trace(B,...A)}debug(B,...A){this.a.debug(B,...A)}info(B,...A){this.a.info(B,...A)}warn(B,...A){this.a.warn(B,...A)}error(B,...A){this.a.error(B,...A)}flush(){this.a.flush()}}e.$JR=S}),define(he[76],fe([0,1,73,8]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yR=void 0;var S;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(S||(S={}));async function w(r,L,b,d,u){try{const a=await new Promise((f,l)=>{ie(["@vscode/spdlog"],f,l)}).then(Se);a.setFlushOn(S.Trace);const h=await a.createAsyncRotatingLogger(r,L,b,d);return u?h.clearFormatters():h.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),h}catch(a){console.error(a)}return null}function B(r,L,b){switch(L){case t.LogLevel.Trace:r.trace(b);break;case t.LogLevel.Debug:r.debug(b);break;case t.LogLevel.Info:r.info(b);break;case t.LogLevel.Warning:r.warn(b);break;case t.LogLevel.Error:r.error(b);break;case t.LogLevel.Off:break;default:throw new Error(`Invalid log level ${L}`)}}function A(r,L){switch(L){case t.LogLevel.Trace:r.setLevel(S.Trace);break;case t.LogLevel.Debug:r.setLevel(S.Debug);break;case t.LogLevel.Info:r.setLevel(S.Info);break;case t.LogLevel.Warning:r.setLevel(S.Warning);break;case t.LogLevel.Error:r.setLevel(S.Error);break;case t.LogLevel.Off:r.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${L}`)}}class $ extends t.$fk{constructor(L,b,d,u,a){super(),this.m=[],this.setLevel(a),this.n=this.s(L,b,d,u),this.B(this.onDidChangeLogLevel(h=>{this.r&&A(this.r,h)}))}async s(L,b,d,u){const a=d?6:1,h=30/a*c.$Hl.MB,f=await w(L,b,h,a,u);if(f){this.r=f,A(this.r,this.getLevel());for(const{level:l,message:s}of this.m)B(this.r,l,s);this.m=[]}}g(L,b){this.r?B(this.r,L,b):this.getLevel()<=L&&this.m.push({level:L,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$yR=$}),define(he[77],fe([0,1,59,8,76]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zR=void 0;class w extends t.$kk{s(A,$,r){return new S.$yR((0,c.$1g)(),A.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,$)}}e.$zR=w}),define(he[78],fe([0,1,15]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let t;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const w=S.context.configuration();if(w)t=w.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(t=globalThis._VSCODE_PRODUCT_JSON,c.env.VSCODE_DEV&&Object.assign(t,{nameShort:`${t.nameShort} Dev`,nameLong:`${t.nameLong} Dev`,dataFolderName:`${t.dataFolderName}-dev`,serverDataFolderName:t.serverDataFolderName?`${t.serverDataFolderName}-dev`:void 0}),!t.version){const w=globalThis._VSCODE_PACKAGE_JSON;Object.assign(t,{version:w.version})}}else t={},Object.keys(t).length===0&&Object.assign(t,{version:"1.91.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=t}),define(he[79],fe([0,1,22]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,c.$Ei)("productService"),e.$tk="vscode://schemas/vscode-product"}),define(he[80],fe([0,1,45,9]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,c=Se(c),t=Se(t);class S{constructor(){this.a=new Map}add(B,A){c.ok(t.$eg(B)),c.ok(t.$gg(A)),c.ok(!this.a.has(B),"There is already an extension with this id"),this.a.set(B,A)}knows(B){return this.a.has(B)}as(B){return this.a.get(B)||null}}e.$qo=new S}),define(he[23],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CommandInvalidationReason=e.TerminalCapability=void 0;var c;(function(S){S[S.CwdDetection=0]="CwdDetection",S[S.NaiveCwdDetection=1]="NaiveCwdDetection",S[S.CommandDetection=2]="CommandDetection",S[S.PartialCommandDetection=3]="PartialCommandDetection",S[S.BufferMarkDetection=4]="BufferMarkDetection"})(c||(e.TerminalCapability=c={}));var t;(function(S){S.Windows="windows",S.NoProblemsReported="noProblemsReported"})(t||(e.CommandInvalidationReason=t={}))}),define(he[81],fe([0,1,4,2,23]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kwb=void 0;class w extends t.$Uc{constructor(A){super(),this.f=A,this.type=S.TerminalCapability.BufferMarkDetection,this.a=new Map,this.b=new Map,this.c=this.B(new c.$le),this.onMarkAdded=this.c.event}*markers(){for(const A of this.a.values())yield A;for(const A of this.b.values())yield A}addMark(A){const $=A?.marker||this.f.registerMarker(),r=A?.id;$&&(r?(this.a.set(r,$),$.onDispose(()=>this.a.delete(r))):(this.b.set($.id,$),$.onDispose(()=>this.b.delete($.id))),this.c.fire({marker:$,id:r,hidden:A?.hidden,hoverMessage:A?.hoverMessage}))}getMark(A){return this.a.get(A)}}e.$Kwb=w});var Be=this&&this.__param||function(ie,e){return function(c,t){e(c,t,ie)}};define(he[82],fe([0,1,4,2,8,14]),function(ie,e,c,t,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=void 0;var B;(function($){$[$.Unknown=0]="Unknown",$[$.Input=1]="Input",$[$.Execute=2]="Execute"})(B||(B={}));let A=class extends t.$Uc{get value(){return this.j}get cursorIndex(){return this.m}get ghostTextIndex(){return this.n}constructor(r,L,b,d){super(),this.w=r,this.z=d,this.a=B.Unknown,this.c=0,this.h="",this.j="",this.m=0,this.n=-1,this.r=this.B(new c.$le),this.onDidStartInput=this.r.event,this.s=this.B(new c.$le),this.onDidChangeInput=this.s.event,this.t=this.B(new c.$le),this.onDidFinishInput=this.t.event,this.u=this.B(new c.$le),this.onDidInterrupt=this.u.event,this.B(c.Event.any(this.w.onCursorMove,this.w.onData,this.w.onWriteParsed)(()=>this.G())),this.B(this.w.onData(u=>this.I(u))),this.B(L(u=>this.D(u))),this.B(b(()=>this.F())),this.B(this.onDidStartInput(()=>this.C("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.C("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.C("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.C("PromptInputModel#onDidInterrupt")))}C(r){this.z.getLevel()===S.LogLevel.Trace&&this.z.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.g=r,this.G()}setLastPromptLine(r){this.f=r,this.G()}setConfidentCommandLine(r){this.j!==r&&(this.j=r,this.m=-1,this.n=-1,this.s.fire(this.Q()))}getCombinedString(){const r=this.j.replaceAll(`
`,"\u23CE");if(this.m===-1)return r;let L=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(L+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,L+=`${r.substring(this.ghostTextIndex)}]`):L+=r.substring(this.cursorIndex),L}serialize(){return{modelState:this.Q(),commandStartX:this.c,lastPromptLine:this.f,continuationPrompt:this.g,lastUserInput:this.h}}deserialize(r){this.j=r.modelState.value,this.m=r.modelState.cursorIndex,this.n=r.modelState.ghostTextIndex,this.c=r.commandStartX,this.f=r.lastPromptLine,this.g=r.continuationPrompt,this.h=r.lastUserInput}D(r){this.a!==B.Input&&(this.a=B.Input,this.b=r.marker,this.c=this.w.buffer.active.cursorX,this.j="",this.m=0,this.r.fire(this.Q()),this.s.fire(this.Q()),this.f&&this.c!==this.f.length&&this.w.buffer.active.getLine(this.b.line)?.translateToString(!0).startsWith(this.f)&&(this.c=this.f.length,this.G()))}F(){if(this.a===B.Execute)return;this.m=-1,this.n!==-1&&(this.j=this.j.substring(0,this.n),this.n=-1);const r=this.Q();this.h===""&&(this.h="",this.u.fire(r)),this.a=B.Execute,this.t.fire(r),this.s.fire(r)}G(){try{this.H()}catch(r){this.z.error("Error while syncing prompt input model",r)}}H(){if(this.a!==B.Input)return;const r=this.b?.line;if(r===void 0)return;const L=this.w.buffer.active;let b=L.getLine(r);const d=b?.translateToString(!0,this.c);if(!b||d===void 0){this.z.trace("PromptInputModel#_sync: no line");return}const u=L.baseY+L.cursorY;let a=d,h=-1,f;u===r?f=this.O(this.c,L,b):f=d.trimEnd().length,u===r&&L.cursorX>1&&(h=this.J(L,b,f));for(let l=r+1;l<=u;l++){b=L.getLine(l);const s=b?.translateToString(!0);if(s&&b)if(b.isWrapped){a+=s;const p=this.O(0,L,b);u===l?f+=p:f+=s.length}else if(this.g===void 0||this.M(s)){const p=this.L(s);if(a+=`
${p}`,u===l){const E=this.N(b,s),n=this.O(E,L,b);f+=n+1}else f+=p.length+1}else break}for(let l=u+1;l<L.baseY+this.w.rows;l++){b=L.getLine(l);const s=b?.translateToString(!0);if(s&&b)if(this.g===void 0||this.M(s))a+=`
${this.L(s)}`;else break;else break}this.z.getLevel()===S.LogLevel.Trace&&this.z.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`);{let l=this.j.length-this.j.trimEnd().length;this.h==="\x7F"&&(this.h="",f===this.m-1&&(this.j.trimEnd().length>a.trimEnd().length&&a.trimEnd().length<=f?l=Math.max(this.j.length-1-a.trimEnd().length,0):l=Math.max(l-1,0))),this.h==="\x1B[3~"&&(this.h="",f===this.m&&(l=Math.max(l-1,0)));const s=a.split(`
`),p=s.length>1,E=a.trimEnd();if(!p){E.length<a.length&&(this.h===" "&&(this.h="",f>E.length&&f>this.m&&l++),l=Math.max(f-E.length,l,0));const n=f===0?"":a[f-1];l>0&&f===this.m+1&&this.h!==""&&n!==" "&&(l=this.j.length-this.m)}if(p){s[s.length-1]=s.at(-1)?.trimEnd()??"";const n=(s.length-1)*(this.g?.length??0);l=Math.max(0,f-a.length-n)}a=s.map(n=>n.trimEnd()).join(`
`)+" ".repeat(l)}(this.j!==a||this.m!==f||this.n!==h)&&(this.j=a,this.m=f,this.n=h,this.s.fire(this.Q()))}I(r){this.h=r}J(r,L,b){let d=-1,u=!1,a=r.cursorX;for(;a>0;){const h=L.getCell(--a);if(!h)break;if(h.getChars().trim().length>0){u=!this.P(h);break}}if(u){let h=0,f=r.cursorX;for(;f<L.length;){const l=L.getCell(f++);if(!l||l.getCode()===0)break;if(this.P(l)){d=b+h;break}h+=l.getChars().length}}return d}L(r){return this.M(r)&&(r=r.substring(this.g.length)),r}M(r){return!!(this.g&&r.startsWith(this.g))}N(r,L){if(!this.g||!L.startsWith(this.g))return 0;let b="",d=0;for(;b!==this.g;)b+=r.getCell(d++).getChars();return d}O(r,L,b){return b?.translateToString(!0,r,L.cursorX).length??0}P(r){return!!(r.isItalic()||r.isDim())}Q(){return Object.freeze({value:this.j,cursorIndex:this.m,ghostTextIndex:this.n})}};e.$js=A,$e([(0,w.$$h)(0)],A.prototype,"G",null),e.$js=A=$e([Be(3,S.$_j)],A)}),define(he[83],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=void 0;class c{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(L){this.b.endMarker=L}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(L,b){this.a=L,this.b=b}static deserialize(L,b,d){const u=L.buffer.normal,a=b.startLine!==void 0?L.registerMarker(b.startLine-(u.baseY+u.cursorY)):void 0;if(!a)return;const h=b.promptStartLine!==void 0?L.registerMarker(b.promptStartLine-(u.baseY+u.cursorY)):void 0,f=b.endLine!==void 0?L.registerMarker(b.endLine-(u.baseY+u.cursorY)):void 0,l=b.executedLine!==void 0?L.registerMarker(b.executedLine-(u.baseY+u.cursorY)):void 0;return new c(L,{command:d?"":b.command,commandLineConfidence:b.commandLineConfidence??"low",isTrusted:b.isTrusted,promptStartMarker:h,marker:a,startX:b.startX,endMarker:f,executedMarker:l,executedX:b.executedX,timestamp:b.timestamp,duration:b.duration,cwd:b.cwd,commandStartLineContent:b.commandStartLineContent,exitCode:b.exitCode,markProperties:b.markProperties,aliases:void 0,wasReplayed:!0})}serialize(L){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:L?"":this.command,commandLineConfidence:L?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return S(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const L=this.executedMarker.line,b=this.endMarker.line;if(L===b)return;let d="",u;for(let a=L;a<b;a++)u=this.a.buffer.active.getLine(a),u&&(d+=u.translateToString(!u.isWrapped)+(u.isWrapped?"":`
`));return d===""?void 0:d}getOutputMatch(L){if(!this.executedMarker||!this.endMarker)return;const b=this.endMarker.line;if(b===-1)return;const d=this.a.buffer.active,u=Math.max(this.executedMarker.line,0),a=L.lineMatcher,h=typeof a=="string"?1:L.length||B(a),f=[];let l;if(L.anchor==="bottom")for(let s=b-(L.offset||0);s>=u;s--){let p=s;const E=s;for(;p>=u&&d.getLine(p)?.isWrapped;)p--;if(s=p,f.unshift(w(d,p,E,this.a.cols)),l||(l=f[0].match(a)),f.length>=h)break}else for(let s=u+(L.offset||0);s<b;s++){const p=s;let E=s;for(;E+1<b&&d.getLine(E+1)?.isWrapped;)E++;if(s=E,f.push(w(d,p,E,this.a.cols)),l||(l=f[f.length-1].match(a)),f.length>=h)break}return l?{regexMatch:l,outputLines:f}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return A(this,this.a.buffer.active)}getCommandRowCount(){return $(this)}}e.$ks=c;class t{constructor(L){this.c=L}serialize(L){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:L,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(L,b,d,u){if(b===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||d)return new c(this.c,{command:d?"":this.command||"",commandLineConfidence:d?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:L,exitCode:b,commandStartLineContent:this.commandStartLineContent,markProperties:u})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return S(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return A(this,this.c.buffer.active)}getCommandRowCount(){return $(this)}}e.$ls=t;function S(r,L,b,d,u,a){if(!b||!u||d===void 0||a===void 0)return"";let h="";for(let f=b.line;f<=u.line;f++){const l=r.getLine(f);l&&(h+=l.translateToString(!0,f===b.line?d:0,f===u.line?a:L))}return h}function w(r,L,b,d){const u=Math.max(2048/d*2);b=Math.min(b,L+u);let a="";for(let h=L;h<=b;h++){const f=r.getLine(h);f&&(a+=f.translateToString(!0,0,d))}return a}function B(r){if(!r.multiline)return 1;const L=r.source;let b=1,d=L.indexOf("\\n");for(;d!==-1;)b++,d=L.indexOf("\\n",d+1);return b}function A(r,L){const b="hasOutput"in r?r.marker:r.commandStartMarker;if(!b||!r.promptStartMarker)return 1;let d=1,u=r.promptStartMarker.line;for(;u<b.line&&(L.getLine(u)?.translateToString(!0)??"").length===0;)u++;return d=b.line-u+1,d}function $(r){const L="hasOutput"in r?r.marker:r.commandStartMarker,b="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!L||!b)return 1;let u=Math.max(b.line,L.line)-L.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&u--,u}}),define(he[84],fe([0,1,11,14,4,2,8,23,83,82]),function(ie,e,c,t,S,w,B,A,$,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gwb=void 0,e.$Hwb=a;let L=class extends w.$Uc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.n.command}get executingCommandObject(){if(this.n.commandStartMarker)return{marker:this.n.commandStartMarker}}get currentCommand(){return this.n}get cwd(){return this.g}get promptTerminator(){return this.h}constructor(s,p){super(),this.L=s,this.M=p,this.type=A.TerminalCapability.CommandDetection,this.f=[],this.n=new $.$ls(this.L),this.r=[],this.t=!1,this.D=this.B(new S.$le),this.onCommandStarted=this.D.event,this.F=this.B(new S.$le),this.onBeforeCommandFinished=this.F.event,this.G=this.B(new S.$le),this.onCommandFinished=this.G.event,this.H=this.B(new S.$le),this.onCommandExecuted=this.H.event,this.I=this.B(new S.$le),this.onCommandInvalidated=this.I.event,this.J=this.B(new S.$le),this.onCurrentCommandInvalidated=this.J.event,this.c=this.B(new r.$js(this.L,this.onCommandStarted,this.onCommandExecuted,this.M)),this.B(this.onCommandExecuted(n=>{if(n.commandLineConfidence!=="high"){const o=n;n.command=o.extractCommandLine(),n.commandLineConfidence="low","getOutput"in o?o.promptStartMarker&&o.marker&&o.executedMarker&&n.command.indexOf(`
`)===-1&&o.startX!==void 0&&o.startX>0&&(n.commandLineConfidence="medium"):o.promptStartMarker&&o.commandStartMarker&&o.commandExecutedMarker&&n.command.indexOf(`
`)===-1&&o.commandStartX!==void 0&&o.commandStartX>0&&(n.commandLineConfidence="medium")}}));const E=this;this.z=new class{get onCurrentCommandInvalidatedEmitter(){return E.J}get onCommandStartedEmitter(){return E.D}get onCommandExecutedEmitter(){return E.H}get dimensions(){return E.s}get isCommandStorageDisabled(){return E.t}get commandMarkers(){return E.r}set commandMarkers(n){E.r=n}get clearCommandsInViewport(){return E.P.bind(E)}commitCommandFinished(){E.w?.flush(),E.w=void 0}},this.C=this.B(new w.$Wc(new b(this.L,this,this.z,this.M))),this.s={cols:this.L.cols,rows:this.L.rows},this.B(this.L.onResize(n=>this.N(n))),this.B(this.L.onCursorMove(()=>this.O()))}N(s){this.C.value.preHandleResize?.(s),this.s.cols=s.cols,this.s.rows=s.rows}O(){this.q.isDisposed||this.L.buffer.active===this.L.buffer.normal&&this.n.commandStartMarker&&this.L.buffer.active.baseY+this.L.buffer.active.cursorY<this.n.commandStartMarker.line&&(this.P(),this.n.isInvalid=!0,this.J.fire({reason:A.CommandInvalidationReason.Windows}))}P(){let s=0;for(let p=this.f.length-1;p>=0;p--){const E=this.f[p].marker?.line;if(E&&E<this.L.buffer.active.baseY)break;s++}s>0&&this.I.fire(this.f.splice(this.f.length-s,s))}setContinuationPrompt(s){this.c.setContinuationPrompt(s)}setPromptTerminator(s,p){this.M.debug("CommandDetectionCapability#setPromptTerminator",s),this.h=s,this.c.setLastPromptLine(p)}setCwd(s){this.g=s}setIsWindowsPty(s){if(s&&!(this.C.value instanceof u)){const p=this;this.C.value=new u(this.L,this,new class{get onCurrentCommandInvalidatedEmitter(){return p.J}get onCommandStartedEmitter(){return p.D}get onCommandExecutedEmitter(){return p.H}get dimensions(){return p.s}get isCommandStorageDisabled(){return p.t}get commandMarkers(){return p.r}set commandMarkers(E){p.r=E}get clearCommandsInViewport(){return p.P.bind(p)}commitCommandFinished(){p.w?.flush(),p.w=void 0}},this.M)}else!s&&!(this.C.value instanceof b)&&(this.C.value=new b(this.L,this,this.z,this.M))}setIsCommandStorageDisabled(){this.t=!0}getCommandForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.n;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>s)){for(let p=this.commands.length-1;p>=0;p--)if((this.commands[p].promptStartMarker??this.commands[p].marker).line<=s)return this.commands[p]}}getCwdForLine(s){if(this.n.promptStartMarker&&s>=this.n.promptStartMarker?.line)return this.g;const p=this.getCommandForLine(s);if(p&&"cwd"in p)return p.cwd}handlePromptStart(s){const p=this.commands.at(-1);p?.endMarker&&p?.executedMarker&&p.endMarker.line===p.executedMarker.line&&(this.M.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${p.endMarker.line} -> ${p.executedMarker.line+1}`),p.endMarker=f(this.L,p.executedMarker,1)),this.n.promptStartMarker=s?.marker||(p?.endMarker?f(this.L,p.endMarker):this.L.registerMarker(0)),this.M.debug("CommandDetectionCapability#handlePromptStart",this.L.buffer.active.cursorX,this.n.promptStartMarker?.line)}handleContinuationStart(){this.n.currentContinuationMarker=this.L.registerMarker(0),this.M.debug("CommandDetectionCapability#handleContinuationStart",this.n.currentContinuationMarker)}handleContinuationEnd(){if(!this.n.currentContinuationMarker){this.M.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.n.continuations||(this.n.continuations=[]),this.n.continuations.push({marker:this.n.currentContinuationMarker,end:this.L.buffer.active.cursorX}),this.n.currentContinuationMarker=void 0,this.M.debug("CommandDetectionCapability#handleContinuationEnd",this.n.continuations[this.n.continuations.length-1])}handleRightPromptStart(){this.n.commandRightPromptStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptStart",this.n.commandRightPromptStartX)}handleRightPromptEnd(){this.n.commandRightPromptEndX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptEnd",this.n.commandRightPromptEndX)}handleCommandStart(s){if(this.u=s,this.n.cwd=this.g,this.n.commandStartMarker=s?.marker||this.n.commandStartMarker,this.n.commandStartMarker?.line===this.L.buffer.active.cursorY){this.n.commandStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleCommandStart",this.n.commandStartX,this.n.commandStartMarker?.line);return}this.C.value.handleCommandStart(s)}handleGenericCommand(s){s?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(s),this.handleCommandStart(s),this.handleCommandExecuted(s),this.handleCommandFinished(void 0,s)}handleCommandExecuted(s){this.C.value.handleCommandExecuted(s),this.n.markExecutedTime()}handleCommandFinished(s,p){if(this.n.markFinishedTime(),this.C.value.preHandleCommandFinished?.(),this.M.debug("CommandDetectionCapability#handleCommandFinished",this.L.buffer.active.cursorX,p?.marker?.line,this.n.command,this.n),s===void 0){const n=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.n.command&&this.n.command.length>0&&n?.command===this.n.command&&(s=n.exitCode)}if(this.n.commandStartMarker===void 0||!this.L.buffer.active)return;this.n.commandFinishedMarker=p?.marker||this.L.registerMarker(0),this.C.value.postHandleCommandFinished?.();const E=this.n.promoteToFullCommand(this.g,s,this.u?.ignoreCommandLine??!1,p?.markProperties);E&&(this.f.push(E),this.w=new c.$Qh(()=>{this.F.fire(E),this.n.isInvalid||(this.M.debug("CommandDetectionCapability#onCommandFinished",E),this.G.fire(E))},50),this.w.schedule()),this.n=new $.$ls(this.L),this.u=void 0}setCommandLine(s,p){this.M.debug("CommandDetectionCapability#setCommandLine",s,p),this.n.command=s,this.n.commandLineConfidence="high",this.n.isTrusted=p,p&&this.c.setConfidentCommandLine(s)}serialize(){const s=this.commands.map(E=>E.serialize(this.t)),p=this.n.serialize(this.g);return p&&s.push(p),{isWindowsPty:this.C.value instanceof u,commands:s,promptInputModel:this.c.serialize()}}deserialize(s){s.isWindowsPty&&this.setIsWindowsPty(s.isWindowsPty);const p=this.L.buffer.normal;for(const E of s.commands){if(!E.endLine){const o=E.startLine!==void 0?this.L.registerMarker(E.startLine-(p.baseY+p.cursorY)):void 0;if(!o)continue;this.n.commandStartMarker=E.startLine!==void 0?this.L.registerMarker(E.startLine-(p.baseY+p.cursorY)):void 0,this.n.commandStartX=E.startX,this.n.promptStartMarker=E.promptStartLine!==void 0?this.L.registerMarker(E.promptStartLine-(p.baseY+p.cursorY)):void 0,this.g=E.cwd,this.D.fire({marker:o});continue}const n=$.$ks.deserialize(this.L,E,this.t);n&&(this.f.push(n),this.M.debug("CommandDetectionCapability#onCommandFinished",n),this.G.fire(n))}s.promptInputModel&&this.c.deserialize(s.promptInputModel)}};e.$Gwb=L,$e([(0,t.$0h)(500)],L.prototype,"O",null),e.$Gwb=L=$e([Be(1,B.$_j)],L);class b extends w.$Uc{constructor(s,p,E,n){super(),this.c=s,this.f=p,this.g=E,this.h=n,this.B(s.parser.registerCsiHandler({final:"J"},o=>(o.length>=1&&(o[0]===2||o[0]===3)&&E.clearCommandsInViewport(),!1)))}handleCommandStart(s){this.g.commitCommandFinished();const p=this.f.currentCommand;p.commandStartX=this.c.buffer.active.cursorX,p.commandStartMarker=s?.marker||this.c.registerMarker(0),p.commandExecutedMarker?.dispose(),p.commandExecutedMarker=void 0,p.commandExecutedX=void 0;for(const E of this.g.commandMarkers)E.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:s?.marker||p.commandStartMarker,markProperties:s?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",p.commandStartX,p.commandStartMarker?.line)}handleCommandExecuted(s){const p=this.f.currentCommand;if(p.commandExecutedMarker=s?.marker||this.c.registerMarker(0),p.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",p.commandExecutedX,p.commandExecutedMarker?.line),!p.commandStartMarker||!p.commandExecutedMarker||p.commandStartX===void 0)return;p.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(p.commandStartMarker.line)?.translateToString(!0,p.commandStartX,p.commandRightPromptStartX).trim();let E=p.commandStartMarker.line+1;const n=p.commandExecutedMarker.line;for(;E<n;E++){const o=this.c.buffer.active.getLine(E);if(o){const i=p.continuations?.find(R=>R.marker.line===E);i&&(p.command+=`
`);const m=i?.end??0;p.command+=o.translateToString(!0,m)}}E===n&&(p.command+=this.c.buffer.active.getLine(n)?.translateToString(!0,void 0,p.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(p)}}var d;(function(l){l[l.MaxCheckLineCount=10]="MaxCheckLineCount",l[l.Interval=20]="Interval",l[l.MaximumPollCount=10]="MaximumPollCount"})(d||(d={}));let u=class extends w.$Uc{constructor(s,p,E,n){super(),this.n=s,this.r=p,this.s=E,this.t=n,this.c=this.B(new w.$Vc),this.g=0,this.h=0,this.B(s.parser.registerCsiHandler({final:"J"},o=>(o.length>=1&&(o[0]===2||o[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(o=>{(o.command.trim().toLowerCase()==="clear"||o.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:A.CommandInvalidationReason.Windows}))}))}preHandleResize(s){const p=this.n.buffer.active.baseY,E=s.rows-this.s.dimensions.rows;E>0&&this.D().then(()=>{const n=Math.min(E,p);for(let o=this.r.commands.length-1;o>=0;o--){const i=this.r.commands[o];if(!i.marker||i.marker.line<p||i.commandStartLineContent===void 0)break;const m=this.n.buffer.active.getLine(i.marker.line);if(!m||m.translateToString(!0)===i.commandStartLineContent)continue;const R=i.marker.line-n;this.n.buffer.active.getLine(R)?.translateToString(!0)===i.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:n})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const s=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?f(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new c.$Qh(()=>this.u(s),d.Interval),this.f.schedule()}u(s){if(this.q.isDisposed)return;const p=this.n.buffer.active;let E=this.g;for(;E<d.MaxCheckLineCount&&s.line+E<p.baseY+this.n.rows;){if(this.C()){const n=this.F(s.line+E);if(n){const o=typeof n=="string"?n:n.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof n=="object"&&n.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=f(this.n,this.r.currentCommand.commandStartMarker);const i=this.r.commands.at(-1);i&&this.r.currentCommand.commandStartMarker.line!==i.endMarker?.line&&(i.endMarker?.dispose(),i.endMarker=f(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=o.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${s.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}E++}E<d.MaxCheckLineCount?(this.g=E,++this.h<d.MaximumPollCount?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=d.MaximumPollCount,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const s=this.n.registerMarker(0);s&&this.s.commandMarkers.push(s)}})),this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(s){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const s=this.r.currentCommand,p=s.command,E=s.commandStartMarker?.line,n=s.commandExecutedMarker?.line;if(!p||p.length===0||E===void 0||E===-1||n===void 0||n===-1)return;let o=0,i=!1;for(let m=E;m<=n;m++){const R=this.n.buffer.active.getLine(m);if(!R)break;const C=R.translateToString(!0);for(let v=0;v<C.length;v++){for(;p.length<o&&p[o]===" ";)o++;if(C[v]===p[o]&&o++,o===p.length){const _=v>=this.n.cols-1;s.commandExecutedMarker=this.n.registerMarker(m-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(_?1:0)),s.commandExecutedX=_?0:v+1,i=!0;break}}if(i)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((s,p)=>s.line-p.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const s=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);s&&(this.r.currentCommand.commandStartLineContent=s.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const s=this.r.commands.at(-1);if(!s)return!0;const p=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,E=(s.endMarker?s.endMarker.line:s.marker?.line)??-1;return p>E}D(){const s=this.n.buffer.active.cursorX,p=this.n.buffer.active.cursorY;let E=0;return new Promise((n,o)=>{const i=setInterval(()=>{if(s!==this.n.buffer.active.cursorX||p!==this.n.buffer.active.cursorY){n(),clearInterval(i);return}E+=10,E>1e3&&(clearInterval(i),n())},10)})}F(s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const p=this.n.buffer.active.getLine(s);if(!p)return;const E=p.translateToString(!0);if(!E)return;const n=E.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(n){const C=this.G(n,E,">");if(C)return{prompt:C,likelySingleLine:!0}}const o=E.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(o){const C=this.G(o,E,"\u276F");if(C)return C}const i=E.match(/^(?<prompt>\$)/)?.groups?.prompt;if(i){const C=this.G(i,E,"$");if(C)return C}const m=E.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(m)return{prompt:m,likelySingleLine:!0};if(this.r.promptTerminator&&E.trim().endsWith(this.r.promptTerminator)){const C=this.G(E,E,this.r.promptTerminator);if(C)return C}const R=E.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return R?.groups?.prompt?{prompt:R.groups.prompt,likelySingleLine:!0}:void 0}G(s,p,E){if(s)return p===s&&s.endsWith(E)&&(s+=" "),s}};u=$e([Be(3,B.$_j)],u);function a(l,s,p,E){if(!E)return;const n=s.executedMarker,o=s.endMarker;if(!n||!o)return;const i=n.line,m=o.line,R=E.length,C=[];if(E.anchor==="bottom")for(let v=m-(E.offset||0);v>=i;v--){let _=v;const k=v;for(;_>=i&&l.getLine(_)?.isWrapped;)_--;v=_,C.unshift(h(l,_,k,p)),C.length>R&&C.pop()}else for(let v=i+(E.offset||0);v<m;v++){const _=v;let k=v;for(;k+1<m&&l.getLine(k+1)?.isWrapped;)k++;v=k,C.push(h(l,_,k,p)),C.length===R&&C.shift()}return C}function h(l,s,p,E){const n=Math.max(2048/E*2);p=Math.min(p,s+n);let o="";for(let i=s;i<=p;i++){const m=l.getLine(i);m&&(o+=m.translateToString(!0,0,E))}return o}function f(l,s,p=0){return l.registerMarker(s.line-(l.buffer.active.baseY+l.buffer.active.cursorY)+p)}}),define(he[85],fe([0,1,4,2,23]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iwb=void 0;class w extends t.$Uc{constructor(){super(...arguments),this.type=S.TerminalCapability.CwdDetection,this.a="",this.b=new Map,this.c=this.B(new c.$le),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(A){const $=this.a!==A;this.a=A;const r=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,r+1),$&&this.c.fire(A)}}e.$Iwb=w}),define(he[86],fe([0,1,4,2,23]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jwb=void 0;var w;(function(A){A[A.MinimumPromptLength=2]="MinimumPromptLength"})(w||(w={}));class B extends t.$Tc{get commands(){return this.a}constructor($){super(),this.c=$,this.type=S.TerminalCapability.PartialCommandDetection,this.a=[],this.b=this.add(new c.$le),this.onCommandFinished=this.b.event,this.add(this.c.onData(r=>this.h(r))),this.add(this.c.parser.registerCsiHandler({final:"J"},r=>(r.length>=1&&(r[0]===2||r[0]===3)&&this.m(),!1)))}h($){$==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=w.MinimumPromptLength){const $=this.c.registerMarker(0);$&&(this.a.push($),this.b.fire($))}}m(){let $=0;for(let r=this.a.length-1;r>=0&&!(this.a[r].line<this.c.buffer.active.baseY);r--)$++;this.a.splice(this.a.length-$,$)}}e.$Jwb=B}),define(he[87],fe([0,1,4,2]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fwb=e.$Ewb=void 0;class S extends t.$Uc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new c.$le),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new c.$le),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new c.$le),this.onDidRemoveCapability=this.g.event,this.h=this.B(new c.$le),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(A,$){this.a.set(A,$),this.f.fire(A),this.h.fire({id:A,capability:$})}get(A){return this.a.get(A)}remove(A){const $=this.a.get(A);$&&(this.a.delete(A),this.b.fire(A),this.h.fire({id:A,capability:$}))}has(A){return this.a.has(A)}}e.$Ewb=S;class w extends t.$Uc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new c.$le),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new c.$le),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new c.$le),this.onDidRemoveCapability=this.f.event,this.g=this.B(new c.$le),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const A of this._stores)for(const $ of A.items)yield $}has(A){for(const $ of this._stores)for(const r of $.items)if(r===A)return!0;return!1}get(A){for(const $ of this._stores){const r=$.get(A);if(r)return r}}add(A){this._stores.push(A);for(const $ of A.items)this.b.fire($),this.g.fire({id:$,capability:A.get($)});this.B(A.onDidAddCapabilityType($=>this.b.fire($))),this.B(A.onDidAddCapability($=>this.g.fire($))),this.B(A.onDidRemoveCapabilityType($=>this.a.fire($))),this.B(A.onDidRemoveCapability($=>this.f.fire($)))}}e.$Fwb=w}),define(he[39],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var c;(function(t){t[t.Replace=1]="Replace",t[t.Append=2]="Append",t[t.Prepend=3]="Prepend"})(c||(e.EnvironmentVariableMutatorType=c={}))}),define(he[88],fe([0,1,3,39]),function(ie,e,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=void 0;const S=new Map([[t.EnvironmentVariableMutatorType.Append,"APPEND"],[t.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[t.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class w{constructor(L){this.collections=L,this.a=new Map,this.b=new Map,L.forEach((b,d)=>{this.d(b,d);const u=b.map.entries();let a=u.next();for(;!a.done;){const h=a.value[1],f=a.value[0];let l=this.a.get(f);if(l||(l=[],this.a.set(f,l)),l.length>0&&l[0].type===t.EnvironmentVariableMutatorType.Replace){a=u.next();continue}const s={extensionIdentifier:d,value:h.value,type:h.type,scope:h.scope,variable:h.variable,options:h.options};s.scope||delete s.scope,l.unshift(s),a=u.next()}})}async applyToProcessEnvironment(L,b,d){let u;c.$j&&(u={},Object.keys(L).forEach(a=>u[a.toLowerCase()]=a));for(const[a,h]of this.getVariableMap(b)){const f=c.$j&&u[a.toLowerCase()]||a;for(const l of h){const s=d?await d(l.value):l.value;if(l.options?.applyAtProcessCreation??!0)switch(l.type){case t.EnvironmentVariableMutatorType.Append:L[f]=(L[f]||"")+s;break;case t.EnvironmentVariableMutatorType.Prepend:L[f]=s+(L[f]||"");break;case t.EnvironmentVariableMutatorType.Replace:L[f]=s;break}if(l.options?.applyAtShellIntegration??!1){const p=`VSCODE_ENV_${S.get(l.type)}`;L[p]=(L[p]?L[p]+":":"")+a+"="+this.c(s)}}}}c(L){return L.replaceAll(":","\\x3a")}diff(L,b){const d=new Map,u=new Map,a=new Map;if(L.getVariableMap(b).forEach((h,f)=>{const l=this.getVariableMap(b).get(f),s=A(h,l);s&&d.set(f,s)}),this.getVariableMap(b).forEach((h,f)=>{const l=L.getVariableMap(b).get(f),s=A(h,l);s&&a.set(f,s)}),this.getVariableMap(b).forEach((h,f)=>{const l=L.getVariableMap(b).get(f),s=$(h,l);s&&u.set(f,s)}),!(d.size===0&&u.size===0&&a.size===0))return{added:d,changed:u,removed:a}}getVariableMap(L){const b=new Map;for(const d of this.a.values()){const u=d.filter(a=>B(a,L));u.length>0&&b.set(u[0].variable,u)}return b}getDescriptionMap(L){const b=new Map;for(const d of this.b.values()){const u=d.filter(a=>B(a,L,!0));for(const a of u)b.set(a.extensionIdentifier,a.description)}return b}d(L,b){if(!L.descriptionMap)return;const d=L.descriptionMap.entries();let u=d.next();for(;!u.done;){const a=u.value[1],h=u.value[0];let f=this.b.get(h);f||(f=[],this.b.set(h,f));const l={extensionIdentifier:b,scope:a.scope,description:a.description};l.scope||delete l.scope,f.push(l),u=d.next()}}}e.$Ks=w;function B(r,L,b=!1){return r.scope?!!(r.scope.workspaceFolder&&L?.workspaceFolder&&r.scope.workspaceFolder.index===L.workspaceFolder.index):b?L===r.scope:!0}function A(r,L){if(!L)return r;const b=new Set;L.forEach(u=>b.add(u.extensionIdentifier));const d=[];return r.forEach(u=>{b.has(u.extensionIdentifier)||d.push(u)}),d.length===0?void 0:d}function $(r,L){if(!L)return;const b=new Map;L.forEach(u=>b.set(u.extensionIdentifier,u));const d=[];return r.forEach(u=>{const a=b.get(u.extensionIdentifier);a&&(u.type!==a.type||u.value!==a.value||u.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&d.push(a)}),d.length===0?void 0:d}}),define(he[89],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=c,e.$Fs=t,e.$Gs=S,e.$Hs=w,e.$Is=B,e.$Js=A;function c($){return[...$.entries()]}function t($){return $?[...$.entries()]:[]}function S($){return new Map($)}function w($){return new Map($??[])}function B($){return Array.from($.entries()).map(r=>[r[0],c(r[1].map),t(r[1].descriptionMap)])}function A($){return new Map($.map(r=>[r[0],{map:S(r[1]),descriptionMap:w(r[2])}]))}}),define(he[90],fe([0,1,11,18,4,2,8]),function(ie,e,c,t,S,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;let A=class extends w.$Uc{constructor(r,L){super(),this.h=L,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$le),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,w.$Sc)(()=>{for(const b of this.f.values())(0,w.$Pc)(b)}))}createRequest(r){return new Promise((L,b)=>{const d=++this.a;this.c.set(d,L),this.g.fire({requestId:d,...r});const u=new t.$we;(0,c.$Fh)(this.b,u.token).then(()=>b(`Request ${d} timed out (${this.b}ms)`)),this.f.set(d,[(0,w.$Sc)(()=>u.cancel())])})}acceptReply(r,L){const b=this.c.get(r);b?(this.c.delete(r),(0,w.$Pc)(this.f.get(r)||[]),this.f.delete(r),b(L)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$vs=A,e.$vs=A=$e([Be(1,B.$_j)],A)}),define(he[16],fe([0,1,22,38,80]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$os=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ns=void 0,e.$ns=new t.$Vj("terminalTabFocusMode",!1,!0);var w;(function(n){n.AutomationProfile="terminal.integrated.automationProfile.",n.DefaultProfile="terminal.integrated.defaultProfile.",n.Profiles="terminal.integrated.profiles."})(w||(e.TerminalSettingPrefix=w={}));var B;(function(n){n.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",n.AutomationProfileLinux="terminal.integrated.automationProfile.linux",n.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",n.AutomationProfileWindows="terminal.integrated.automationProfile.windows",n.ProfilesWindows="terminal.integrated.profiles.windows",n.ProfilesMacOs="terminal.integrated.profiles.osx",n.ProfilesLinux="terminal.integrated.profiles.linux",n.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",n.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",n.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",n.UseWslProfiles="terminal.integrated.useWslProfiles",n.TabsDefaultColor="terminal.integrated.tabs.defaultColor",n.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",n.TabsEnabled="terminal.integrated.tabs.enabled",n.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",n.TabsHideCondition="terminal.integrated.tabs.hideCondition",n.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",n.TabsShowActions="terminal.integrated.tabs.showActions",n.TabsLocation="terminal.integrated.tabs.location",n.TabsFocusMode="terminal.integrated.tabs.focusMode",n.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",n.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",n.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",n.CopyOnSelection="terminal.integrated.copyOnSelection",n.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",n.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",n.FontFamily="terminal.integrated.fontFamily",n.FontSize="terminal.integrated.fontSize",n.LetterSpacing="terminal.integrated.letterSpacing",n.LineHeight="terminal.integrated.lineHeight",n.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",n.TabStopWidth="terminal.integrated.tabStopWidth",n.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",n.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",n.BellDuration="terminal.integrated.bellDuration",n.FontWeight="terminal.integrated.fontWeight",n.FontWeightBold="terminal.integrated.fontWeightBold",n.CursorBlinking="terminal.integrated.cursorBlinking",n.CursorStyle="terminal.integrated.cursorStyle",n.CursorStyleInactive="terminal.integrated.cursorStyleInactive",n.CursorWidth="terminal.integrated.cursorWidth",n.Scrollback="terminal.integrated.scrollback",n.DetectLocale="terminal.integrated.detectLocale",n.DefaultLocation="terminal.integrated.defaultLocation",n.GpuAcceleration="terminal.integrated.gpuAcceleration",n.TerminalTitleSeparator="terminal.integrated.tabs.separator",n.TerminalTitle="terminal.integrated.tabs.title",n.TerminalDescription="terminal.integrated.tabs.description",n.RightClickBehavior="terminal.integrated.rightClickBehavior",n.MiddleClickBehavior="terminal.integrated.middleClickBehavior",n.Cwd="terminal.integrated.cwd",n.ConfirmOnExit="terminal.integrated.confirmOnExit",n.ConfirmOnKill="terminal.integrated.confirmOnKill",n.EnableBell="terminal.integrated.enableBell",n.EnableVisualBell="terminal.integrated.enableVisualBell",n.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",n.AllowChords="terminal.integrated.allowChords",n.AllowMnemonics="terminal.integrated.allowMnemonics",n.TabFocusMode="terminal.integrated.tabFocusMode",n.EnvMacOs="terminal.integrated.env.osx",n.EnvLinux="terminal.integrated.env.linux",n.EnvWindows="terminal.integrated.env.windows",n.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",n.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",n.ShowExitAlert="terminal.integrated.showExitAlert",n.SplitCwd="terminal.integrated.splitCwd",n.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",n.WordSeparators="terminal.integrated.wordSeparators",n.EnableFileLinks="terminal.integrated.enableFileLinks",n.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",n.UnicodeVersion="terminal.integrated.unicodeVersion",n.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",n.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",n.HideOnStartup="terminal.integrated.hideOnStartup",n.CustomGlyphs="terminal.integrated.customGlyphs",n.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",n.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",n.InheritEnv="terminal.integrated.inheritEnv",n.ShowLinkHover="terminal.integrated.showLinkHover",n.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",n.AutoReplies="terminal.integrated.autoReplies",n.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",n.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",n.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",n.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",n.EnableImages="terminal.integrated.enableImages",n.SmoothScrolling="terminal.integrated.smoothScrolling",n.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",n.FocusAfterRun="terminal.integrated.focusAfterRun",n.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",n.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",n.DevMode="terminal.integrated.developer.devMode"})(B||(e.TerminalSettingId=B={}));var A;(function(n){n.PowerShell="pwsh",n.Bash="bash",n.Fish="fish",n.Sh="sh",n.Csh="csh",n.Ksh="ksh",n.Zsh="zsh",n.Python="python"})(A||(e.PosixShellType=A={}));var $;(function(n){n.CommandPrompt="cmd",n.PowerShell="pwsh",n.Wsl="wsl",n.GitBash="gitbash",n.Python="python"})($||(e.WindowsShellType=$={}));var r;(function(n){n[n.Api=0]="Api",n[n.Process=1]="Process",n[n.Sequence=2]="Sequence",n[n.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var L;(function(n){n.LocalPty="localPty",n.PtyHost="ptyHost",n.PtyHostWindow="ptyHostWindow",n.Logger="logger",n.Heartbeat="heartbeat"})(L||(e.TerminalIpcChannels=L={}));var b;(function(n){n.Cwd="cwd",n.InitialCwd="initialCwd",n.FixedDimensions="fixedDimensions",n.Title="title",n.ShellType="shellType",n.HasChildProcesses="hasChildProcesses",n.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",n.OverrideDimensions="overrideDimensions",n.FailedShellIntegrationActivation="failedShellIntegrationActivation",n.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$os=(0,c.$Ei)("ptyService");var d;(function(n){n[n.BeatInterval=5e3]="BeatInterval",n[n.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",n[n.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",n[n.SecondWaitMultiplier=1]="SecondWaitMultiplier",n[n.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(d||(e.HeartbeatConstants=d={}));var u;(function(n){n[n.Panel=1]="Panel",n[n.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var a;(function(n){n.TerminalView="view",n.Editor="editor"})(a||(e.TerminalLocationString=a={}));var h;(function(n){n[n.GraceTime=6e4]="GraceTime",n[n.ShortGraceTime=6e3]="ShortGraceTime"})(h||(e.LocalReconnectConstants=h={}));var f;(function(n){n[n.HighWatermarkChars=1e5]="HighWatermarkChars",n[n.LowWatermarkChars=5e3]="LowWatermarkChars",n[n.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var l;(function(n){n.GitBash="Git Bash",n.Pwsh="PowerShell"})(l||(e.ProfileSource=l={}));var s;(function(n){n[n.Off=0]="Off",n[n.FinalTerm=1]="FinalTerm",n[n.VSCode=2]="VSCode"})(s||(e.ShellIntegrationStatus=s={}));var p;(function(n){n[n.Unknown=0]="Unknown",n[n.Shutdown=1]="Shutdown",n[n.Process=2]="Process",n[n.User=3]="User",n[n.Extension=4]="Extension"})(p||(e.TerminalExitReason=p={})),e.$ps={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(o){const i=this.b(o.remoteAuthority);if(this.a.has(i))throw new Error(`A terminal backend with remote authority '${i}' was already registered.`);this.a.set(i,o)}getTerminalBackend(o){return this.a.get(this.b(o))}b(o){return o?.toLowerCase()??""}}S.$qo.add(e.$ps.Backend,new E),e.$qs=(0,c.$Ei)("localPtyService"),e.$rs=(0,c.$Ei)("terminalLogService")}),define(he[91],fe([0,1,11,2,3]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imc=void 0;class w extends t.$Uc{constructor(A,$,r,L){super(),this.a=0,this.b=!1,this.c=!1,this.B(A.onProcessData(b=>{if(this.b||this.c)return;const d=typeof b=="string"?b:b.data;for(let u=0;u<d.length;u++)d[u]===$[this.a]?this.a++:this.f(),this.a===$.length&&(L.debug(`Auto reply match: "${$}", response: "${r}"`),A.input(r),this.c=!0,(0,c.$Fh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){S.$j&&(this.b=!0)}handleInput(){this.b=!1}}e.$Imc=w}),define(he[92],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uxb=void 0;class c{constructor(S){this.b=S,this.a=new Map}dispose(){for(const S of this.a.values())S.dispose()}startBuffering(S,w,B=5){const A=w($=>{const r=typeof $=="string"?$:$.data;let L=this.a.get(S);if(L){L.data.push(r);return}const b=setTimeout(()=>this.flushBuffer(S),B);L={data:[r],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(S),A.dispose()}},this.a.set(S,L)});return A}stopBuffering(S){this.a.get(S)?.dispose()}flushBuffer(S){const w=this.a.get(S);w&&(this.a.delete(S),this.b(S,w.data.join("")))}}e.$Uxb=c}),define(he[40],fe([0,1,3]),function(ie,e,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_Q=t,e.$aR=S,e.$bR=w,e.$cR=B;function t(A){let $=A;$.includes("\\")&&($=$.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return $=$.replace(r,""),`'${$}'`}function S(A,$,r){if(!A)return"";if(!$)return A;$.match(/[\/\\]$/)&&($=$.slice(0,$.length-1));const L=A.replace(/\\/g,"/").toLowerCase(),b=$.replace(/\\/g,"/").toLowerCase();return L.includes(b)?`~${r}${A.slice($.length+1)}`:A}function w(A){return A.match(/^['"].*['"]$/)&&(A=A.substring(1,A.length-1)),c.OS===c.OperatingSystem.Windows&&A&&A[1]===":"?A[0].toUpperCase()+A.substring(1):A}function B(A){return!A.strictEnv}}),define(he[93],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=t;var c;(function(S){S[S.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(c||(c={}));function t(S){const w=[];let B=0;for(let A=0;A<S.length-1;A++)(A-B+1>=c.WriteMaxChunkSize||S[A+1]==="\x1B")&&(w.push(S.substring(B,A+1)),B=A+1,A++);return B!==S.length&&w.push(S.substring(B)),w}}),define(he[94],fe([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LXb=c;function c(t,S={}){let w="";return S.excludeLeadingNewLine||(w+=`\r
`),w+="\x1B[0m\x1B[7m * ",S.loudFormatting?w+="\x1B[0;104m":w+="\x1B[0m",w+=` ${t} \x1B[0m
\r`,w}}),define(he[95],fe([0,1,16,2,87,84,85,23,86,4,81,6,40,10]),function(ie,e,c,t,S,w,B,A,$,r,L,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lwb=e.ShellIntegrationOscPs=void 0,e.$Mwb=p,e.$Nwb=E,e.$Owb=n;var a;(function(o){o[o.FinalTerm=133]="FinalTerm",o[o.VSCode=633]="VSCode",o[o.ITerm=1337]="ITerm",o[o.SetCwd=7]="SetCwd",o[o.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(a||(e.ShellIntegrationOscPs=a={}));var h;(function(o){o.PromptStart="A",o.CommandStart="B",o.CommandExecuted="C",o.CommandFinished="D"})(h||(h={}));var f;(function(o){o.PromptStart="A",o.CommandStart="B",o.CommandExecuted="C",o.CommandFinished="D",o.CommandLine="E",o.ContinuationStart="F",o.ContinuationEnd="G",o.RightPromptStart="H",o.RightPromptEnd="I",o.Property="P",o.SetMark="SetMark"})(f||(f={}));var l;(function(o){o.SetMark="SetMark",o.CurrentDir="CurrentDir"})(l||(l={}));class s extends t.$Uc{get status(){return this.g}constructor(i,m,R,C){super(),this.j=i,this.m=m,this.n=R,this.r=C,this.capabilities=this.B(new S.$Ewb),this.b=!1,this.f=[],this.g=c.ShellIntegrationStatus.Off,this.h=new r.$le,this.onDidChangeStatus=this.h.event,this.B((0,t.$Sc)(()=>{this.z(),this.s()}))}s(){(0,t.$Pc)(this.f),this.f.length=0}activate(i){this.a=i,this.capabilities.add(A.TerminalCapability.PartialCommandDetection,this.B(new $.$Jwb(this.a))),this.B(i.parser.registerOscHandler(a.VSCode,m=>this.w(m))),this.B(i.parser.registerOscHandler(a.ITerm,m=>this.H(m))),this.f.push(i.parser.registerOscHandler(a.FinalTerm,m=>this.t(m))),this.B(i.parser.registerOscHandler(a.SetCwd,m=>this.J(m))),this.B(i.parser.registerOscHandler(a.SetWindowsFriendlyCwd,m=>this.I(m))),this.y()}getMarkerId(i,m){this.N(i).getMark(m)}t(i){const m=this.u(i);return this.g===c.ShellIntegrationStatus.Off&&(this.g=c.ShellIntegrationStatus.FinalTerm,this.h.fire(this.g)),m}u(i){if(!this.a)return!1;const[m,...R]=i.split(";");switch(m){case h.PromptStart:return this.M(this.a).handlePromptStart(),!0;case h.CommandStart:return this.M(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case h.CommandExecuted:return this.M(this.a).handleCommandExecuted(),!0;case h.CommandFinished:{const C=R.length===1?parseInt(R[0]):void 0;return this.M(this.a).handleCommandFinished(C),!0}}return!1}w(i){const m=this.C(i);return!this.b&&m&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==c.ShellIntegrationStatus.VSCode&&(this.g=c.ShellIntegrationStatus.VSCode,this.h.fire(this.g)),m}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(A.TerminalCapability.CommandDetection)&&!this.capabilities.get(A.TerminalCapability.CwdDetection)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(i){if(!this.a)return!1;const m=i.indexOf(";"),R=m===-1?i:i.substring(0,m),C=m===-1?[]:i.substring(m+1).split(";");switch(R){case f.PromptStart:return this.M(this.a).handlePromptStart(),!0;case f.CommandStart:return this.M(this.a).handleCommandStart(),!0;case f.CommandExecuted:return this.M(this.a).handleCommandExecuted(),!0;case f.CommandFinished:{const v=C[0],_=v!==void 0?parseInt(v):void 0;return this.M(this.a).handleCommandFinished(_),!0}case f.CommandLine:{const v=C[0],_=C[1];let k;return v!==void 0?k=p(v):k="",this.M(this.a).setCommandLine(k,_===this.j),!0}case f.ContinuationStart:return this.M(this.a).handleContinuationStart(),!0;case f.ContinuationEnd:return this.M(this.a).handleContinuationEnd(),!0;case f.RightPromptStart:return this.M(this.a).handleRightPromptStart(),!0;case f.RightPromptEnd:return this.M(this.a).handleRightPromptEnd(),!0;case f.Property:{const v=C[0],_=v!==void 0?p(v):"",{key:k,value:M}=E(_);if(M===void 0)return!0;switch(k){case"ContinuationPrompt":return this.D((0,u.$3f)(M)),!0;case"Cwd":return this.G(M),!0;case"IsWindows":return this.M(this.a).setIsWindowsPty(M==="True"),!0;case"Prompt":{const q=M.replace(/\x1b\[[0-9;]*m/g,"");return this.F(q),!0}case"Task":return this.N(this.a),this.capabilities.get(A.TerminalCapability.CommandDetection)?.setIsCommandStorageDisabled(),!0}}case f.SetMark:return this.N(this.a).addMark(n(C)),!0}return!1}D(i){this.a&&this.M(this.a).setContinuationPrompt(i)}F(i){if(!this.a)return;const m=i.substring(i.lastIndexOf(`
`)+1),R=m.substring(m.lastIndexOf(" "));R&&this.M(this.a).setPromptTerminator(R,m)}G(i){i=(0,d.$bR)(i),this.L().updateCwd(i),this.capabilities.get(A.TerminalCapability.CommandDetection)?.setCwd(i)}H(i){if(!this.a)return!1;const[m]=i.split(";");switch(m){case l.SetMark:this.N(this.a).addMark();default:{const{key:R,value:C}=E(m);if(C===void 0)return!0;switch(R){case l.CurrentDir:return this.G(C),!0}}}return!1}I(i){if(!this.a)return!1;const[m,...R]=i.split(";");switch(m){case"9":return R.length&&this.G(R[0]),!0}return!1}J(i){if(!this.a)return!1;const[m]=i.split(";");if(m.match(/^file:\/\/.*\//)){const R=b.URI.parse(m);if(R.path&&R.path.length>0)return this.G(R.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(A.TerminalCapability.CommandDetection)?{isWindowsPty:!1,commands:[],promptInputModel:void 0}:this.M(this.a).serialize()}deserialize(i){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.M(this.a).deserialize(i)}L(){let i=this.capabilities.get(A.TerminalCapability.CwdDetection);return i||(i=this.B(new B.$Iwb),this.capabilities.add(A.TerminalCapability.CwdDetection,i)),i}M(i){let m=this.capabilities.get(A.TerminalCapability.CommandDetection);return m||(m=this.B(new w.$Gwb(i,this.r)),this.capabilities.add(A.TerminalCapability.CommandDetection,m)),m}N(i){let m=this.capabilities.get(A.TerminalCapability.BufferMarkDetection);return m||(m=this.B(new L.$Kwb(i)),this.capabilities.add(A.TerminalCapability.BufferMarkDetection,m)),m}}e.$Lwb=s;function p(o){return o.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(i,m,R)=>R?String.fromCharCode(parseInt(R,16)):m)}function E(o){const i=o.indexOf("=");return i===-1?{key:o,value:void 0}:{key:o.substring(0,i),value:o.substring(1+i)}}function n(o){let i,m=!1;for(const R of o)R!==void 0&&(R==="Hidden"&&(m=!0),R.startsWith("Id=")&&(i=R.substring(3)));return{id:i,hidden:m}}}),define(he[41],fe([0,1,5,14,4,2,61,8]),function(ie,e,c,t,S,w,B,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=e.$Jmc=void 0;var $;(function(L){L[L.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",L[L.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})($||($={})),e.$Jmc=[];let r=class extends w.$Uc{set hasChildProcesses(b){this.a!==b&&(this.a=b,this.f.debug("ChildProcessMonitor: Has child processes changed",b),this.b.fire(b))}get hasChildProcesses(){return this.a}constructor(b,d){super(),this.c=b,this.f=d,this.a=!1,this.b=this.B(new S.$le),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const b=await(0,B.$Ws)(this.c);this.hasChildProcesses=this.j(b)}catch(b){this.f.debug("ChildProcessMonitor: Fetching process tree failed",b)}}h(){this.g()}j(b){if(!b.children)return!1;if(b.children.length===1){const d=b.children[0];let u;if(d.cmd.startsWith('"'))u=d.cmd.substring(1,d.cmd.indexOf('"',1));else{const a=d.cmd.indexOf(" ");a===-1?u=d.cmd:u=d.cmd.substring(0,a)}return e.$Jmc.indexOf((0,c.$qc)(u).name)===-1}return b.children.length>0}};e.$Kmc=r,$e([(0,t.$0h)($.ActiveDebounceDuration)],r.prototype,"g",null),$e([(0,t.$$h)($.InactiveThrottleDuration)],r.prototype,"h",null),e.$Kmc=r=$e([Be(1,A.$_j)],r)}),define(he[96],fe([0,1,4,2,16]),function(ie,e,c,t,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lmc=void 0;class w extends t.$Uc{constructor(){super(),this.a=this.B(new c.$le),this.onBeat=this.a.event;const A=setInterval(()=>{this.a.fire()},S.HeartbeatConstants.BeatInterval);this.B((0,t.$Sc)(()=>clearInterval(A)))}}e.$Lmc=w}),define(he[42],fe([0,1,21,20,33,5,3,15,10,9,28,39,89,88]),function(ie,e,c,t,S,w,B,A,$,r,L,b,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=a,e.$Ms=h,e.$Ns=f,c=Se(c),w=Se(w),A=Se(A),L=Se(L);function a(){const v=/(\d+)\.(\d+)\.(\d+)/g.exec(c.release());let _=0;return v&&v.length===4&&(_=parseInt(v[3])),_}async function h(v,_,k,M=A.env,q=L.Promises.exists){if(w.$ic(v))return await q(v)?v:void 0;if(_===void 0&&(_=A.cwd()),w.$mc(v)!=="."){const D=w.$jc(_,v);return await q(D)?D:void 0}const y=(0,S.$ko)(M,"PATH");if(k===void 0&&(0,r.$eg)(y)&&(k=y.split(w.$tc)),k===void 0||k.length===0){const D=w.$jc(_,v);return await q(D)?D:void 0}for(const D of k){let P;if(w.$ic(D)?P=w.$jc(D,v):P=w.$jc(_,D,v),await q(P))return P;if(B.$j){let F=P+".com";if(await q(F)||(F=P+".exe",await q(F)))return F}}const U=w.$jc(_,v);return await q(U)?U:void 0}function f(v,_,k,M,q){const I=B.$j&&(!_.windowsEnableConpty||a()<18309);if(!_.shellIntegration.enabled||!v.executable||v.isFeatureTerminal&&!v.forceShellIntegration||v.ignoreShellIntegration||I)return;const y=v.args,U=A.$dc==="win32"?w.$nc(v.executable).toLowerCase():w.$nc(v.executable),D=w.$mc(t.$Yg.asFileUri("").fsPath);let P;const F={VSCODE_INJECTION:"1"};if(_.shellIntegration.nonce&&(F.VSCODE_NONCE=_.shellIntegration.nonce),B.$j){if(U==="pwsh.exe"||U==="powershell.exe")return!y||R(y)?P=p.get(s.WindowsPwsh):m(y)&&(P=p.get(s.WindowsPwshLogin)),P?(P=[...P],P[P.length-1]=(0,$.$df)(P[P.length-1],D,""),F.VSCODE_STABLE=q.quality==="stable"?"1":"0",_.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),{newArgs:P,envMixin:F}):void 0;if(U==="bash.exe")return!y||y.length===0?P=p.get(s.Bash):C(y)&&(F.VSCODE_SHELL_LOGIN="1",l(_,F),P=p.get(s.Bash)),P?(P=[...P],P[P.length-1]=(0,$.$df)(P[P.length-1],D),F.VSCODE_STABLE=q.quality==="stable"?"1":"0",{newArgs:P,envMixin:F}):void 0;M.warn(`Shell integration cannot be enabled for executable "${v.executable}" and args`,v.args);return}switch(U){case"bash":return!y||y.length===0?P=p.get(s.Bash):C(y)&&(F.VSCODE_SHELL_LOGIN="1",l(_,F),P=p.get(s.Bash)),P?(P=[...P],P[P.length-1]=(0,$.$df)(P[P.length-1],D),F.VSCODE_STABLE=q.quality==="stable"?"1":"0",{newArgs:P,envMixin:F}):void 0;case"fish":{const Q=k?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",V=w.$jc(D,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return F.XDG_DATA_DIRS=`${Q}:${V}`,l(_,F),{newArgs:void 0,envMixin:F}}case"pwsh":return!y||R(y)?P=p.get(s.Pwsh):m(y)&&(P=p.get(s.PwshLogin)),P?(_.shellIntegration.suggestEnabled&&(F.VSCODE_SUGGEST="1"),P=[...P],P[P.length-1]=(0,$.$df)(P[P.length-1],D,""),F.VSCODE_STABLE=q.quality==="stable"?"1":"0",{newArgs:P,envMixin:F}):void 0;case"zsh":{if(!y||y.length===0?P=p.get(s.Zsh):C(y)?(P=p.get(s.ZshLogin),l(_,F)):(y===p.get(s.Zsh)||y===p.get(s.ZshLogin))&&(P=y),!P)return;P=[...P],P[P.length-1]=(0,$.$df)(P[P.length-1],D);let Q;try{Q=c.userInfo().username}catch{Q="unknown"}const V=w.$jc(c.tmpdir(),`${Q}-${q.applicationName}-zsh`);F.ZDOTDIR=V;const Z=k?.ZDOTDIR??c.homedir()??"~";F.USER_ZDOTDIR=Z;const re=[];return re.push({source:w.$jc(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:w.$jc(V,".zshrc")}),re.push({source:w.$jc(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:w.$jc(V,".zprofile")}),re.push({source:w.$jc(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:w.$jc(V,".zshenv")}),re.push({source:w.$jc(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:w.$jc(V,".zlogin")}),{newArgs:P,envMixin:F,filesToCopy:re}}}M.warn(`Shell integration cannot be enabled for executable "${v.executable}" and args`,v.args)}function l(v,_){if(B.$k&&v.environmentVariableCollections){const k=(0,d.$Js)(v.environmentVariableCollections),q=new u.$Ks(k).getVariableMap({workspaceFolder:v.workspaceFolder}).get("PATH"),I=[];if(q)for(const y of q)y.type===b.EnvironmentVariableMutatorType.Prepend&&I.push(y.value);I.length>0&&(_.VSCODE_PATH_PREFIX=I.join(""))}}var s;(function(v){v.WindowsPwsh="windows-pwsh",v.WindowsPwshLogin="windows-pwsh-login",v.Pwsh="pwsh",v.PwshLogin="pwsh-login",v.Zsh="zsh",v.ZshLogin="zsh-login",v.Bash="bash"})(s||(s={}));const p=new Map;p.set(s.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(s.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(s.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(s.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(s.Zsh,["-i"]),p.set(s.ZshLogin,["-il"]),p.set(s.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],n=["--login","-l"],o=["-i","--interactive"],i=["-nol","-nologo"];function m(v){return typeof v=="string"?E.includes(v.toLowerCase()):v.length===1&&E.includes(v[0].toLowerCase())||v.length===2&&(E.includes(v[0].toLowerCase())||E.includes(v[1].toLowerCase()))&&(i.includes(v[0].toLowerCase())||i.includes(v[1].toLowerCase()))}function R(v){return typeof v=="string"?i.includes(v.toLowerCase()):v.length===0||v?.length===1&&i.includes(v[0].toLowerCase())}function C(v){return typeof v!="string"&&(v=v.filter(_=>!o.includes(_.toLowerCase()))),v==="string"&&n.includes(v.toLowerCase())||typeof v!="string"&&v.length===1&&n.includes(v[0].toLowerCase())}}),define(he[97],fe([0,1,11,14,4,2,3,16]),function(ie,e,c,t,S,w,B,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=void 0;const $=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let r;class L extends w.$Uc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(d){if(super(),this.h=d,this.c="",this.f=new S.$le,this.g=new S.$le,!B.$j)throw new Error(`WindowsShellHelper cannot be instantiated on ${B.$v}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){B.$j&&(await(0,c.$Fh)(300),this.getShellName().then(d=>{const u=this.getShellType(d);u!==this.b&&(this.g.fire(u),this.f.fire(d),this.b=u,this.c=d)}))}m(d){if(!d)return"";if($.indexOf(d.name)===-1||!d.children||d.children.length===0)return d.name;let u=0;for(;u<d.children.length;u++){const a=d.children[u];if(!a.children||a.children.length===0||a.children[0].name!=="conhost.exe")break}return u>=d.children.length?d.name:this.m(d.children[u])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(r||(r=await new Promise((d,u)=>{ie(["@vscode/windows-process-tree"],d,u)}).then(Se)),this.a=new Promise(d=>{r.getProcessTree(this.h,u=>{const a=this.m(u);this.a=void 0,d(a)})}),this.a)}getShellType(d){switch(d.toLowerCase()){case"cmd.exe":return A.WindowsShellType.CommandPrompt;case"powershell.exe":case"pwsh.exe":return A.WindowsShellType.PowerShell;case"bash.exe":case"git-cmd.exe":return A.WindowsShellType.GitBash;case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return A.WindowsShellType.Wsl;default:return d.match(/python(\d(\.\d{0,2})?)?\.exe/)?A.WindowsShellType.Python:void 0}}}e.$Mmc=L,$e([(0,t.$0h)(500)],L.prototype,"checkShell",null)}),define(he[98],fe([0,1,35,29,11,4,2,5,3,6,12,8,79,16,41,42,97,102,93]),function(ie,e,c,t,S,w,B,A,$,r,L,b,d,u,a,h,f,l,s){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=void 0,c=Se(c),A=Se(A);var E;(function(R){R[R.DataFlushTimeout=250]="DataFlushTimeout",R[R.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(E||(E={}));var n;(function(R){R[R.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",R[R.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",R[R.WriteInterval=5]="WriteInterval"})(n||(n={}));const o=new Map([["bash",u.PosixShellType.Bash],["csh",u.PosixShellType.Csh],["fish",u.PosixShellType.Fish],["ksh",u.PosixShellType.Ksh],["sh",u.PosixShellType.Sh],["pwsh",u.PosixShellType.PowerShell],["python",u.PosixShellType.Python],["zsh",u.PosixShellType.Zsh]]);let i=class extends B.$Uc{static{p=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return $.$j?this.t?.shellType:o.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(C,v,_,k,M,q,I,y,U){super(),this.shellLaunchConfig=C,this.N=q,this.O=I,this.P=y,this.Q=U,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new w.$le),this.onProcessData=this.I.event,this.J=this.B(new w.$le),this.onProcessReady=this.J.event,this.L=this.B(new w.$le),this.onDidChangeProperty=this.L.event,this.M=this.B(new w.$le),this.onProcessExit=this.M.event;let D;$.$j?D=A.$nc(this.shellLaunchConfig.executable||""):D="xterm-256color",this.D=v,this.a[u.ProcessPropertyType.InitialCwd]=this.D,this.a[u.ProcessPropertyType.Cwd]=this.D;const P=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,h.$Ls)()>=18309;this.F={name:D,cwd:v,env:M,cols:_,rows:k,useConpty:P,conptyInheritCursor:P&&!!C.initialText},$.$j&&(P&&_===0&&k===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new m,this.B(this.C.onTrigger(F=>{this.C?.dispose(),this.C=void 0,F.cols&&F.rows&&this.resize(F.cols,F.rows)}))),this.onProcessReady(F=>{this.t=this.B(new f.$Mmc(F.pid)),this.B(this.t.onShellTypeChanged(Q=>this.L.fire({type:u.ProcessPropertyType.ShellType,value:Q}))),this.B(this.t.onShellNameChanged(Q=>this.L.fire({type:u.ProcessPropertyType.Title,value:Q})))})),this.B((0,B.$Sc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const v=(await Promise.all([this.R(),this.S()])).find(k=>k!==void 0);if(v)return v;let _;if(this.O.shellIntegration.enabled)if(_=(0,h.$Ns)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),_){if(this.L.fire({type:u.ProcessPropertyType.UsedShellIntegrationInjection,value:!0}),_.envMixin)for(const[k,M]of Object.entries(_.envMixin))this.F.env||={},this.F.env[k]=M;if(_.filesToCopy)for(const k of _.filesToCopy){await c.promises.mkdir(A.$mc(k.dest),{recursive:!0});try{await c.promises.copyFile(k.source,k.dest)}catch{}}}else this.L.fire({type:u.ProcessPropertyType.FailedShellIntegrationActivation,value:!0});try{return await this.U(this.shellLaunchConfig,this.F,_),_?.newArgs?{injectedArgs:_.newArgs}:void 0}catch(k){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",k),{message:`A native exception occurred during launch (${k.message})`}}}async R(){try{if(!(await c.promises.stat(this.D)).isDirectory())return{message:(0,L.localize)(11147,null,this.D.toString())}}catch(C){if(C?.code==="ENOENT")return{message:(0,L.localize)(11148,null,this.D.toString())}}this.L.fire({type:u.ProcessPropertyType.InitialCwd,value:this.D})}async S(){const C=this.shellLaunchConfig;if(!C.executable)throw new Error("IShellLaunchConfig.executable not set");const v=C.cwd instanceof r.URI?C.cwd.path:C.cwd,_=C.env&&C.env.PATH?C.env.PATH.split(A.$tc):void 0,k=await(0,h.$Ms)(C.executable,v,_,this.N);if(!k)return{message:(0,L.localize)(11149,null,C.executable)};try{const M=await c.promises.stat(k);if(!M.isFile()&&!M.isSymbolicLink())return{message:(0,L.localize)(11150,null,C.executable)};C.executable=k}catch(M){if(M?.code!=="EACCES")throw M}}async U(C,v,_){const k=_?.newArgs||C.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",C.executable,k,v);const M=(0,l.spawn)(C.executable,k,v);this.m=M,this.u=this.B(new a.$Kmc(M.pid,this.P)),this.u.onDidChangeHasChildProcesses(q=>this.L.fire({type:u.ProcessPropertyType.HasChildProcesses,value:q})),this.s=new Promise(q=>{this.onProcessReady(()=>q())}),M.onData(q=>{this.H+=q.length,!this.G&&this.H>u.FlowControlConstants.HighWatermarkChars&&(this.P.trace(`Flow control: Pause (${this.H} > ${u.FlowControlConstants.HighWatermarkChars})`),this.G=!0,M.pause()),this.P.trace("node-pty.IPty#onData",q),this.I.fire(q),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),M.onExit(q=>{this.g=q.exitCode,this.X()}),this.$(M.pid),this.W(M)}W(C){setTimeout(()=>this.ab(C)),$.$j||(this.w=setInterval(()=>{this.n!==C.process&&this.ab(C)},200))}X(){this.P.getLevel()===b.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},E.DataFlushTimeout)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!$.$j||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-p.b<n.KillSpawnThrottleInterval;)this.P.trace("Throttling kill/spawn call"),await(0,S.$Fh)(n.KillSpawnThrottleInterval-(Date.now()-p.b)+n.KillSpawnSpacingDuration);p.b=Date.now()}}$(C){this.J.fire({pid:C,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(C){if(this.q.isDisposed)return;this.n=C.process,this.L.fire({type:u.ProcessPropertyType.Title,value:this.n});const v=this.currentTitle.replace(/ \(figterm\)$/g,"");v.toLowerCase().startsWith("python")?this.L.fire({type:u.ProcessPropertyType.ShellType,value:u.PosixShellType.Python}):this.L.fire({type:u.ProcessPropertyType.ShellType,value:o.get(v)})}shutdown(C){this.P.getLevel()===b.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),C&&!$.$j?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},E.MaximumShutdownTime))}input(C,v=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,s.$ms)(C).map(_=>({isBinary:v,data:_}))),this.bb())}async processBinary(C){this.input(C,!0)}async refreshProperty(C){switch(C){case u.ProcessPropertyType.Cwd:{const v=await this.getCwd();return v!==this.a.cwd&&(this.a.cwd=v,this.L.fire({type:u.ProcessPropertyType.Cwd,value:this.a.cwd})),v}case u.ProcessPropertyType.InitialCwd:{const v=await this.getInitialCwd();return v!==this.a.initialCwd&&(this.a.initialCwd=v,this.L.fire({type:u.ProcessPropertyType.InitialCwd,value:this.a.initialCwd})),v}case u.ProcessPropertyType.Title:return this.currentTitle;default:return this.shellType}}async updateProperty(C,v){C===u.ProcessPropertyType.FixedDimensions&&(this.a.fixedDimensions=v)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},n.WriteInterval)}}cb(){const C=this.y.shift();this.P.trace("node-pty.IPty#write",C.data),C.isBinary?this.m.write(Buffer.from(C.data,"binary")):this.m.write(C.data),this.u?.handleInput()}resize(C,v){if(!this.q.isDisposed&&!(typeof C!="number"||typeof v!="number"||isNaN(C)||isNaN(v))&&this.m){if(C=Math.max(C,1),v=Math.max(v,1),this.C){this.C.cols=C,this.C.rows=v;return}this.P.trace("node-pty.IPty#resize",C,v);try{this.m.resize(C,v)}catch(_){if(this.P.trace("node-pty.IPty#resize exception "+_.message),this.g!==void 0&&_.message!=="ioctl(2) failed, EBADF"&&_.message!=="Cannot resize a pty that has already exited")throw _}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(C){this.H=Math.max(this.H-C,0),this.P.trace(`Flow control: Ack ${C} chars (unacknowledged: ${this.H})`),this.G&&this.H<u.FlowControlConstants.LowWatermarkChars&&(this.P.trace(`Flow control: Resume (${this.H} < ${u.FlowControlConstants.LowWatermarkChars})`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(C){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if($.$k)return new Promise(C=>{if(!this.m){C(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,t.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(v,_,k)=>{!v&&_!==""?C(_.substring(_.indexOf("/"),_.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",v,_,k),C(this.D))})});if($.$l){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await c.promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return $.$j?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,h.$Ls)()}:void 0}};e.$Nmc=i,e.$Nmc=i=p=$e([Be(7,b.$_j),Be(8,d.$sk)],i);class m extends B.$Uc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new w.$le),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,B.$Sc)(()=>clearTimeout(this.a)))}}}),define(he[99],fe([0,1,29,11,4,2,3,62,8,90,16,92,40,42,98,12,41,91,7,95,94,71,14,103,104]),function(ie,e,c,t,S,w,B,A,$,r,L,b,d,u,a,h,f,l,s,p,E,n,o,i,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=void 0,e.$Omc=R,i=Se(i);function R(U,D,P){if(typeof P.value!="function")throw new Error("not supported");const F="value",Q=P.value;P[F]=async function(...V){this.traceRpcArgs.logService.getLevel()===$.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${Q.name}(${V.map(re=>JSON.stringify(re)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,t.$Fh)(this.traceRpcArgs.simulatedLatency);let Z;try{Z=await Q.apply(this,V)}catch(re){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${Q.name}`,re),re}return this.traceRpcArgs.logService.getLevel()===$.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${Q.name}`,Z),Z}}let C,v;class _ extends w.$Uc{H(D,P){return P(F=>{this.I.getLevel()===$.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${D}.fire(${JSON.stringify(F)})`)}),P}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(D,P,F,Q){super(),this.I=D,this.J=P,this.L=F,this.M=Q,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new S.$le),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new S.$le),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new S.$le),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new S.$le),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new S.$le),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new S.$le),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new S.$le),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new S.$le),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,w.$Sc)(()=>{for(const V of this.a.values())V.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$vs(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(D){f.$Jmc.length=0,f.$Jmc.push(...D)}async requestDetachInstance(D,P){return this.f.createRequest({workspaceId:D,instanceId:P})}async acceptDetachInstanceReply(D,P){let F;const Q=this.a.get(P);Q&&(F=await this.S(P,Q)),this.f.acceptReply(D,F)}async freePortKillProcess(D){const F=(await new Promise((Q,V)=>{(0,c.exec)(B.$j?`netstat -ano | findstr "${D}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${D}`,{},(Z,re)=>{if(Z)return V("Problem occurred when listing active processes");Q(re)})})).split(/\r?\n/).filter(Q=>!!Q.trim());if(F.length>=1){const Q=/\s+(\d+)(?:\s+|$)/,V=F[0].match(Q)?.[1];if(V)try{process.kill(Number.parseInt(V))}catch{}else throw new Error(`Processes for port ${D} were not found`);return{port:D,processId:V}}throw new Error(`Could not kill process with port ${D}`)}async serializeTerminalState(D){const P=[];for(const[Q,V]of this.a.entries())V.hasWrittenData&&D.indexOf(Q)!==-1&&P.push(t.Promises.withAsyncBody(async Z=>{Z({id:Q,shellLaunchConfig:V.shellLaunchConfig,processDetails:await this.S(Q,V),processLaunchConfig:V.processLaunchOptions,unicodeVersion:V.unicodeVersion,replayEvent:await V.serializeNormalBuffer(),timestamp:Date.now()})}));const F={version:1,state:await Promise.all(P)};return JSON.stringify(F)}async reviveTerminalProcesses(D,P,F){const Q=[];for(const V of P)Q.push(this.N(D,V));await Promise.all(Q)}async N(D,P){const F=(0,h.localize)(11151,null),Q=await this.createProcess({...P.shellLaunchConfig,cwd:P.processDetails.cwd,color:P.processDetails.color,icon:P.processDetails.icon,name:P.processDetails.titleSource===L.TitleEventSource.Api?P.processDetails.title:void 0,initialText:P.replayEvent.events[0].data+(0,E.$LXb)(F,{loudFormatting:!0})},P.processDetails.cwd,P.replayEvent.events[0].cols,P.replayEvent.events[0].rows,P.unicodeVersion,P.processLaunchConfig.env,P.processLaunchConfig.executableEnv,P.processLaunchConfig.options,!0,P.processDetails.workspaceId,P.processDetails.workspaceName,!0,P.replayEvent.events[0].data),V=this.R(D,P.id);this.g.set(V,{newId:Q,state:P}),this.I.info(`Revived process, old id ${V} -> new id ${Q}`)}async shutdownAll(){this.dispose()}async createProcess(D,P,F,Q,V,Z,re,ae,X,j,J,ee,le){if(D.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const W=++this.n,ce=new a.$Nmc(D,P,F,Q,Z,re,ae,this.I,this.J),ge={env:Z,executableEnv:re,options:ae},te=new M(W,ce,j,J,X,F,Q,ge,V,this.L,this.I,ee&&typeof D.initialText=="string"?D.initialText:void 0,le,D.icon,D.color,D.name,D.fixedDimensions);return ce.onProcessExit(g=>{te.dispose(),this.a.delete(W),this.C.fire({id:W,event:g})}),te.onProcessData(g=>this.w.fire({id:W,event:g})),te.onProcessReplay(g=>this.y.fire({id:W,event:g})),te.onProcessReady(g=>this.z.fire({id:W,event:g})),te.onProcessOrphanQuestion(()=>this.D.fire({id:W})),te.onDidChangeProperty(g=>this.G.fire({id:W,property:g})),te.onPersistentProcessReady(()=>{for(const g of this.j.entries())te.installAutoReply(g[0],g[1])}),this.a.set(W,te),W}async attachToProcess(D){try{await this.U(D).attach(),this.I.info(`Persistent process reconnection "${D}"`)}catch(P){throw this.I.warn(`Persistent process reconnection "${D}" failed`,P.message),P}}async updateTitle(D,P,F){this.U(D).setTitle(P,F)}async updateIcon(D,P,F,Q){this.U(D).setIcon(P,F,Q)}async clearBuffer(D){this.U(D).clearBuffer()}async refreshProperty(D,P){return this.U(D).refreshProperty(P)}async updateProperty(D,P,F){return this.U(D).updateProperty(P,F)}async detachFromProcess(D,P){return this.U(D).detach(P)}async reduceConnectionGraceTime(){for(const D of this.a.values())D.reduceGraceTime()}async listProcesses(){const D=Array.from(this.a.entries()).filter(([Q,V])=>V.shouldPersistTerminal);this.I.info(`Listing ${D.length} persistent terminals, ${this.a.size} total terminals`);const P=D.map(async([Q,V])=>this.S(Q,V));return(await Promise.all(P)).filter(Q=>Q.isOrphan)}async getPerformanceMarks(){return i.getMarks()}async start(D){const P=this.a.get(D);return P?P.start():{message:`Could not find pty with id "${D}"`}}async shutdown(D,P){return this.a.get(D)?.shutdown(P)}async input(D,P){return this.U(D).input(P)}async processBinary(D,P){return this.U(D).writeBinary(P)}async resize(D,P,F){return this.U(D).resize(P,F)}async getInitialCwd(D){return this.U(D).getInitialCwd()}async getCwd(D){return this.U(D).getCwd()}async acknowledgeDataEvent(D,P){return this.U(D).acknowledgeDataEvent(P)}async setUnicodeVersion(D,P){return this.U(D).setUnicodeVersion(P)}async getLatency(){return[]}async orphanQuestionReply(D){return this.U(D).orphanQuestionReply()}async installAutoReply(D,P){this.j.set(D,P);for(const F of this.a.values())F.installAutoReply(D,P)}async uninstallAllAutoReplies(){for(const D of this.j.keys())for(const P of this.a.values())P.uninstallAutoReply(D)}async uninstallAutoReply(D){for(const P of this.a.values())P.uninstallAutoReply(D)}async getDefaultSystemShell(D=B.OS){return(0,A.$zm)(D,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(D,P){if(P==="win-to-unix"){if(!B.$j)return D;if((0,u.$Ls)()<17063)return D.replace(/\\/g,"/");const F=this.O();return F?new Promise(Q=>{(0,c.execFile)(F,["-e","wslpath",D],{},(Z,re,ae)=>{Q(Z?D:(0,d.$_Q)(re.trim()))}).stdin.end()}):D}if(P==="unix-to-win"&&B.$j){if((0,u.$Ls)()<17063)return D;const F=this.O();return F?new Promise(Q=>{(0,c.execFile)(F,["-e","wslpath","-w",D],{},(Z,re,ae)=>{Q(Z?D:re.trim())}).stdin.end()}):D}return D}O(){const D=(0,u.$Ls)()>=16299,P=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),F=process.env.SystemRoot;if(F)return(0,n.join)(F,P?"Sysnative":"System32",D?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(D,P){try{return this.g.get(this.R(D,P))?.newId}catch(F){this.I.warn(`Couldn't find terminal ID ${D}-${P}`,F.message)}}async setTerminalLayoutInfo(D){this.b.set(D.workspaceId,D)}async getTerminalLayoutInfo(D){i.mark("code/willGetTerminalLayoutInfo");const P=this.b.get(D.workspaceId);if(P){const F=new Set,V=(await Promise.all(P.tabs.map(async Z=>this.P(D.workspaceId,Z,F)))).filter(Z=>Z.terminals.length>0);return i.mark("code/didGetTerminalLayoutInfo"),{tabs:V}}i.mark("code/didGetTerminalLayoutInfo")}async P(D,P,F){const V=(await Promise.all(P.terminals.map(Z=>this.Q(D,Z,F)))).filter(Z=>Z.terminal!==null);return{isActive:P.isActive,activePersistentProcessId:P.activePersistentProcessId,terminals:V}}async Q(D,P,F){try{const Q=this.R(D,P.terminal),V=this.g.get(Q)?.newId;this.I.info(`Expanding terminal instance, old id ${Q} -> new id ${V}`),this.g.delete(Q);const Z=V??P.terminal;if(F.has(Z))throw new Error(`Terminal ${Z} has already been expanded`);F.add(Z);const re=this.U(Z);return{terminal:{...re&&await this.S(P.terminal,re,V!==void 0),id:Z},relativeSize:P.relativeSize}}catch(Q){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",Q.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",P),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:P.relativeSize}}}R(D,P){return`${D}-${P}`}async S(D,P,F=!1){i.mark(`code/willBuildProcessDetails/${D}`);const[Q,V]=await Promise.all([P.getCwd(),F?!0:P.isOrphaned()]),Z={id:D,title:P.title,titleSource:P.titleSource,pid:P.pid,workspaceId:P.workspaceId,workspaceName:P.workspaceName,cwd:Q,isOrphan:V,icon:P.icon,color:P.color,fixedDimensions:P.fixedDimensions,environmentVariableCollections:P.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:P.shellLaunchConfig.reconnectionProperties,waitOnExit:P.shellLaunchConfig.waitOnExit,hideFromUser:P.shellLaunchConfig.hideFromUser,isFeatureTerminal:P.shellLaunchConfig.isFeatureTerminal,type:P.shellLaunchConfig.type,hasChildProcesses:P.hasChildProcesses,shellIntegrationNonce:P.processLaunchOptions.options.shellIntegration.nonce};return i.mark(`code/didBuildProcessDetails/${D}`),Z}U(D){const P=this.a.get(D);if(!P)throw new s.$ab("Could not find pty on pty host");return P}}e.$Pmc=_,$e([o.$9h],_.prototype,"traceRpcArgs",null),$e([R],_.prototype,"refreshIgnoreProcessNames",null),$e([R],_.prototype,"requestDetachInstance",null),$e([R],_.prototype,"acceptDetachInstanceReply",null),$e([R],_.prototype,"freePortKillProcess",null),$e([R],_.prototype,"serializeTerminalState",null),$e([R],_.prototype,"reviveTerminalProcesses",null),$e([R],_.prototype,"shutdownAll",null),$e([R],_.prototype,"createProcess",null),$e([R],_.prototype,"attachToProcess",null),$e([R],_.prototype,"updateTitle",null),$e([R],_.prototype,"updateIcon",null),$e([R],_.prototype,"clearBuffer",null),$e([R],_.prototype,"refreshProperty",null),$e([R],_.prototype,"updateProperty",null),$e([R],_.prototype,"detachFromProcess",null),$e([R],_.prototype,"reduceConnectionGraceTime",null),$e([R],_.prototype,"listProcesses",null),$e([R],_.prototype,"getPerformanceMarks",null),$e([R],_.prototype,"start",null),$e([R],_.prototype,"shutdown",null),$e([R],_.prototype,"input",null),$e([R],_.prototype,"processBinary",null),$e([R],_.prototype,"resize",null),$e([R],_.prototype,"getInitialCwd",null),$e([R],_.prototype,"getCwd",null),$e([R],_.prototype,"acknowledgeDataEvent",null),$e([R],_.prototype,"setUnicodeVersion",null),$e([R],_.prototype,"getLatency",null),$e([R],_.prototype,"orphanQuestionReply",null),$e([R],_.prototype,"installAutoReply",null),$e([R],_.prototype,"uninstallAllAutoReplies",null),$e([R],_.prototype,"uninstallAutoReply",null),$e([R],_.prototype,"getDefaultSystemShell",null),$e([R],_.prototype,"getEnvironment",null),$e([R],_.prototype,"getWslPath",null),$e([R],_.prototype,"getRevivedPtyNewId",null),$e([R],_.prototype,"setTerminalLayoutInfo",null),$e([R],_.prototype,"getTerminalLayoutInfo",null);var k;(function(U){U.None="None",U.ReplayOnly="ReplayOnly",U.Session="Session"})(k||(k={}));class M extends w.$Uc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!==k.None}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(D,P){P===L.TitleEventSource.Api&&(this.j.setValue(k.Session,"setTitle"),this.P.freeRawReviveBuffer()),this.N=D,this.O=P}setIcon(D,P,F){(!this.Y||"id"in P&&"id"in this.Y&&P.id!==this.Y.id||!this.color||F!==this.Z)&&(this.P.freeRawReviveBuffer(),D&&this.j.setValue(k.Session,"setIcon")),this.Y=P,this.Z=F}S(D){this.R=D}constructor(D,P,F,Q,V,Z,re,ae,X,j,J,ee,le,W,ce,ge,te){super(),this.U=D,this.W=P,this.workspaceId=F,this.workspaceName=Q,this.shouldPersistTerminal=V,this.processLaunchOptions=ae,this.unicodeVersion=X,this.X=J,this.Y=W,this.Z=ce,this.b=new Map,this.f=new Map,this.g=!1,this.w=new t.$Lh,this.C=this.B(new S.$le),this.onProcessReplay=this.C.event,this.D=this.B(new S.$le),this.onProcessReady=this.D.event,this.F=this.B(new S.$le),this.onPersistentProcessReady=this.F.event,this.G=this.B(new S.$le),this.onProcessData=this.G.event,this.H=this.B(new S.$le),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new S.$le),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=L.TitleEventSource.Process,this.j=new q(`Persistent process "${this.U}" interaction state`,k.None,this.X),this.Q=ee!==void 0,this.P=new I(Z,re,j.scrollback,X,ee,ae.options.shellIntegration.nonce,V?le:void 0,this.X),ge&&this.setTitle(ge,L.TitleEventSource.Api),this.R=te,this.n=null,this.u=0,this.y=this.B(new t.$Rh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${y(j.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},j.graceTime)),this.z=this.B(new t.$Rh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${y(j.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},j.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(g=>{this.L=g.pid,this.M=g.cwd,this.D.fire(g)})),this.B(this.W.onDidChangeProperty(g=>{this.I.fire(g)})),this.a=new b.$Uxb((g,G)=>this.G.fire(G)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(g=>this.P.handleData(g))),this.B((0,w.$Sc)(()=>{for(const g of this.b.values())g.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(D){this.shouldPersistTerminal&&(this.j.value!==k.None||D)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!==k.Session)}async refreshProperty(D){return this.W.refreshProperty(D)}async updateProperty(D,P){if(D===L.ProcessPropertyType.FixedDimensions)return this.S(P)}async start(){if(!this.g){const D=await this.W.start();return D&&"message"in D||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),D}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:L.ProcessPropertyType.Title,value:this.W.currentTitle}),this.I.fire({type:L.ProcessPropertyType.ShellType,value:this.W.shellType}),this.triggerReplay()}shutdown(D){return this.W.shutdown(D)}input(D){if(this.j.setValue(k.Session,"input"),this.P.freeRawReviveBuffer(),!this.J){for(const P of this.b.values())P.handleInput();return this.W.input(D)}}writeBinary(D){return this.W.processBinary(D)}resize(D,P){if(!this.J){this.P.handleResize(D,P),this.a.flushBuffer(this.U);for(const F of this.b.values())F.handleResize();return this.W.resize(D,P)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(D){this.unicodeVersion=D,this.P.setUnicodeVersion?.(D)}acknowledgeDataEvent(D){if(!this.J)return this.W.acknowledgeDataEvent(D)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value===k.None&&this.j.setValue(k.ReplayOnly,"triggerReplay");const D=await this.P.generateReplayEvent();let P=0;for(const F of D.events)P+=F.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${P} chars and ${D.events.length} size events`),this.C.fire(D),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(D,P){this.b.get(D)?.dispose(),this.b.set(D,new l.$Imc(this.W,D,P,this.X))}uninstallAutoReply(D){this.b.get(D)?.dispose(),this.b.delete(D)}sendCommandResult(D,P,F){this.f.get(D)&&this.f.delete(D)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const D=this.n;this.n=null,D.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new t.$Eh(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class q{get value(){return this.b}setValue(D,P){this.b!==D&&(this.b=D,this.f(P))}constructor(D,P,F){this.a=D,this.b=P,this.d=F,this.f("initialized")}f(D){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${D}`)}}class I{constructor(D,P,F,Q,V,Z,re,ae){this.f=re,this.a=new m.Terminal({cols:D,rows:P,scrollback:F,allowProposedApi:!0}),V&&this.a.writeln(V),this.setUnicodeVersion(Q),this.b=new p.$Lwb(Z,!0,void 0,ae),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(D){this.a.write(D)}handleResize(D,P){this.a.resize(D,P)}clearBuffer(){this.a.clear()}async generateReplayEvent(D,P){const F=new(await this._getSerializeConstructor());this.a.loadAddon(F);const Q={scrollback:this.a.options.scrollback};D&&(Q.excludeAltBuffer=!0,Q.excludeModes=!0);let V;return P&&this.f?V=this.f:V=F.serialize(Q),{events:[{cols:this.a.cols,rows:this.a.rows,data:V}],commands:this.b.serialize()}}async setUnicodeVersion(D){this.a.unicode.activeVersion!==D&&(D==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=D)}async _getUnicode11Constructor(){return v||(v=(await new Promise((D,P)=>{ie(["@xterm/addon-unicode11"],D,P)}).then(Se)).Unicode11Addon),v}async _getSerializeConstructor(){return C||(C=(await new Promise((D,P)=>{ie(["@xterm/addon-serialize"],D,P)}).then(Se)).SerializeAddon),C}}function y(U){let D=0,P=0,F=0;U>=1e3&&(F=Math.floor(U/1e3),U-=F*1e3),F>=60&&(P=Math.floor(F/60),F-=P*60),P>=60&&(D=Math.floor(P/60),P-=D*60);const Q=D?`${D}h`:"",V=P?`${P}m`:"",Z=F?`${F}s`:"",re=U?`${U}ms`:"";return`${Q}${V}${Z}${re}`}});var Xe=this&&this.__importDefault||function(ie){return ie&&ie.__esModule?ie:{default:ie}};define(he[105],fe([0,1,58,30,63,64,12,69,72,8,74,75,77,78,16,96,99,37,11,2]),function(ie,e,c,t,S,w,B,A,$,r,L,b,d,u,a,h,f,l,s,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),u=Xe(u),E();async function E(){const n=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),o=parseInt(process.env.VSCODE_LATENCY??"0"),i={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,n&&await(0,s.$Fh)(n);const m=(0,l.$8X)(process);let R;m?R=new w.$9X:R=new S.$gr(a.TerminalIpcChannels.PtyHost);const C={_serviceBrand:void 0,...u.default},v=new $.$8m((0,A.$Cm)(process.argv,A.$Bm),C),_=new d.$zR((0,r.$nk)(v),v.logsHome);R.registerChannel(a.TerminalIpcChannels.Logger,new L.$ts(_,()=>c.$Mn));const k=_.createLogger("ptyhost",{name:(0,B.localize)(11152,null)}),M=new b.$JR(k);n&&M.warn(`Pty Host startup is delayed ${n}ms`),o&&M.warn(`Pty host is simulating ${o}ms latency`);const q=new p.$Tc,I=new h.$Lmc;R.registerChannel(a.TerminalIpcChannels.Heartbeat,t.ProxyChannel.fromService(I,q));const y=new f.$Pmc(M,C,i,o),U=t.ProxyChannel.fromService(y,q);R.registerChannel(a.TerminalIpcChannels.PtyHost,U),m&&R.registerChannel(a.TerminalIpcChannels.PtyHostWindow,U),process.once("exit",()=>{M.trace("Pty host exiting"),M.dispose(),I.dispose(),y.dispose()})}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/22e3447b4b410dcf8426bf70743c5dd4030d6122/core/vs/platform/terminal/node/ptyHostMain.js.map
