/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ne=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/lifecycle","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/platform/extensions/common/extensions","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/charCode","vs/base/common/map","vs/platform/files/common/files","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/editor/common/core/range","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/marshallingIds","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/iterator","vs/base/common/glob","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/extpath","vs/editor/common/model","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/workbench/api/common/extHostTesting","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iconLabels","vs/base/common/labels","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model/textModelSearch","vs/editor/common/services/semanticTokensDto","vs/platform/extensions/common/extensionsApiProposals","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","vs/workbench/common/editor","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/jsonSchema","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/comparers","vs/base/common/scrollable","vs/base/common/stream","vs/base/common/symbols","vs/base/common/filters","vs/base/common/uriIpc","vs/base/common/dataTransfer","vs/base/parts/storage/common/storage","vs/editor/common/core/eolCounter","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/core/textModelDefaults","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/encodedTokenAttributes","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/editor/common/services/treeViewsDnd","vs/base/common/actions","vs/base/common/date","vs/platform/contextkey/common/scanner","vs/platform/instantiation/common/graph","vs/platform/accessibility/common/accessibility","vs/editor/common/core/wordHelper","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensionValidator","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/contrib/testing/common/constants","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/contrib/chat/common/languageModels","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguageModelTools","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/uint","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/base/common/arraysFind","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Le=function(ve){for(var e=[],v=0,R=ve.length;v<R;v++)e[v]=Ne[ve[v]];return e};define(Ne[71],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=R,e.$0h=P,e.$$h=O;function v(A){return(T,p,o)=>{let I=null,y=null;if(typeof o.value=="function"?(I="value",y=o.value):typeof o.get=="function"&&(I="get",y=o.get),!y)throw new Error("not supported");o[I]=A(y,p)}}function R(A,T,p){let o=null,I=null;if(typeof p.value=="function"?(o="value",I=p.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof p.get=="function"&&(o="get",I=p.get),!I)throw new Error("not supported");const y=`$memoize$${T}`;p[o]=function(...a){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,a)}),this[y]}}function P(A,T,p){return v((o,I)=>{const y=`$debounce$${I}`,a=`$debounce$result$${I}`;return function(...S){this[a]||(this[a]=p?p():void 0),clearTimeout(this[y]),T&&(this[a]=T(this[a],...S),S=[this[a]]),this[y]=setTimeout(()=>{o.apply(this,S),this[a]=p?p():void 0},A)}})}function O(A,T,p){return v((o,I)=>{const y=`$throttle$timer$${I}`,a=`$throttle$result$${I}`,S=`$throttle$lastRun$${I}`,d=`$throttle$pending$${I}`;return function(...r){if(this[a]||(this[a]=p?p():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),T&&(this[a]=T(this[a],...r)),this[d])return;const s=this[S]+A;s<=Date.now()?(this[S]=Date.now(),o.apply(this,[this[a]]),this[a]=p?p():void 0):(this[d]=!0,this[y]=setTimeout(()=>{this[d]=!1,this[S]=Date.now(),o.apply(this,[this[a]]),this[a]=p?p():void 0},s-Date.now()))}})}});var Kn=this&&this.__createBinding||(Object.create?function(ve,e,v,R){R===void 0&&(R=v);var P=Object.getOwnPropertyDescriptor(e,v);(!P||("get"in P?!e.__esModule:P.writable||P.configurable))&&(P={enumerable:!0,get:function(){return e[v]}}),Object.defineProperty(ve,R,P)}:function(ve,e,v,R){R===void 0&&(R=v),ve[R]=e[v]}),Gn=this&&this.__setModuleDefault||(Object.create?function(ve,e){Object.defineProperty(ve,"default",{enumerable:!0,value:e})}:function(ve,e){ve.default=e}),We=this&&this.__importStar||function(ve){if(ve&&ve.__esModule)return ve;var e={};if(ve!=null)for(var v in ve)v!=="default"&&Object.prototype.hasOwnProperty.call(ve,v)&&Kn(e,ve,v);return Gn(e,ve),e};define(Ne[135],Le([1,0,17]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=P,e.$8c=O,e.$9c=A,e.$0c=T,e.$$c=p,e.$_c=o,v=We(v);const R=(S,d)=>S===d;e.$6c=R;function P(S=e.$6c){return(d,r)=>v.$tb(d,r,S)}function O(){return(S,d)=>JSON.stringify(S)===JSON.stringify(d)}function A(){return(S,d)=>S.equals(d)}function T(S,d,r){if(r!==void 0){const s=S;return s==null||d===void 0||d===null?d===s:r(s,d)}else{const s=S;return(c,l)=>c==null||l===void 0||l===null?l===c:s(c,l)}}function p(S,d){if(S===d)return!0;if(Array.isArray(S)&&Array.isArray(d)){if(S.length!==d.length)return!1;for(let r=0;r<S.length;r++)if(!p(S[r],d[r]))return!1;return!0}if(S&&typeof S=="object"&&d&&typeof d=="object"&&Object.getPrototypeOf(S)===Object.prototype&&Object.getPrototypeOf(d)===Object.prototype){const r=S,s=d,c=Object.keys(r),l=Object.keys(s),i=new Set(l);if(c.length!==l.length)return!1;for(const n of c)if(!i.has(n)||!p(r[n],s[n]))return!1;return!0}return!1}function o(S){return JSON.stringify(a(S))}let I=0;const y=new WeakMap;function a(S){if(Array.isArray(S))return S.map(a);if(S&&typeof S=="object")if(Object.getPrototypeOf(S)===Object.prototype){const d=S,r=Object.create(null);for(const s of Object.keys(d).sort())r[s]=a(d[s]);return r}else{let d=y.get(S);return d===void 0&&(d=I++,y.set(S,d)),d+"----2b76a038c20c4bcc"}return S}}),define(Ne[96],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=e.$oQ=void 0;class v{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$oQ=v,e.$pQ=new v("id#")}),define(Ne[136],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Vn=A,e.$Wn=y,e.$Xn=a,e.$Yn=S,e.$Zn=d,e.$1n=r,e.$2n=s,e.$3n=c,e.$4n=l,e.$5n=i,e.$6n=n;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v||(e.ScanError=v={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var P;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var O;(function(t){t.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function A(t,g=!1){let u=0;const $=t.length;let m="",h=0,E=R.Unknown,D=v.None;function w(L){let W=0,K=0;for(;W<L;){const q=t.charCodeAt(u);if(q>=I._0&&q<=I._9)K=K*16+q-I._0;else if(q>=I.A&&q<=I.F)K=K*16+q-I.A+10;else if(q>=I.a&&q<=I.f)K=K*16+q-I.a+10;else break;u++,W++}return W<L&&(K=-1),K}function C(L){u=L,m="",h=0,E=R.Unknown,D=v.None}function k(){const L=u;if(t.charCodeAt(u)===I._0)u++;else for(u++;u<t.length&&o(t.charCodeAt(u));)u++;if(u<t.length&&t.charCodeAt(u)===I.dot)if(u++,u<t.length&&o(t.charCodeAt(u)))for(u++;u<t.length&&o(t.charCodeAt(u));)u++;else return D=v.UnexpectedEndOfNumber,t.substring(L,u);let W=u;if(u<t.length&&(t.charCodeAt(u)===I.E||t.charCodeAt(u)===I.e))if(u++,(u<t.length&&t.charCodeAt(u)===I.plus||t.charCodeAt(u)===I.minus)&&u++,u<t.length&&o(t.charCodeAt(u))){for(u++;u<t.length&&o(t.charCodeAt(u));)u++;W=u}else D=v.UnexpectedEndOfNumber;return t.substring(L,W)}function f(){let L="",W=u;for(;;){if(u>=$){L+=t.substring(W,u),D=v.UnexpectedEndOfString;break}const K=t.charCodeAt(u);if(K===I.doubleQuote){L+=t.substring(W,u),u++;break}if(K===I.backslash){if(L+=t.substring(W,u),u++,u>=$){D=v.UnexpectedEndOfString;break}switch(t.charCodeAt(u++)){case I.doubleQuote:L+='"';break;case I.backslash:L+="\\";break;case I.slash:L+="/";break;case I.b:L+="\b";break;case I.f:L+="\f";break;case I.n:L+=`
`;break;case I.r:L+="\r";break;case I.t:L+="	";break;case I.u:{const G=w(4);G>=0?L+=String.fromCharCode(G):D=v.InvalidUnicode;break}default:D=v.InvalidEscapeCharacter}W=u;continue}if(K>=0&&K<=31)if(p(K)){L+=t.substring(W,u),D=v.UnexpectedEndOfString;break}else D=v.InvalidCharacter;u++}return L}function b(){if(m="",D=v.None,h=u,u>=$)return h=$,E=R.EOF;let L=t.charCodeAt(u);if(T(L)){do u++,m+=String.fromCharCode(L),L=t.charCodeAt(u);while(T(L));return E=R.Trivia}if(p(L))return u++,m+=String.fromCharCode(L),L===I.carriageReturn&&t.charCodeAt(u)===I.lineFeed&&(u++,m+=`
`),E=R.LineBreakTrivia;switch(L){case I.openBrace:return u++,E=R.OpenBraceToken;case I.closeBrace:return u++,E=R.CloseBraceToken;case I.openBracket:return u++,E=R.OpenBracketToken;case I.closeBracket:return u++,E=R.CloseBracketToken;case I.colon:return u++,E=R.ColonToken;case I.comma:return u++,E=R.CommaToken;case I.doubleQuote:return u++,m=f(),E=R.StringLiteral;case I.slash:{const W=u-1;if(t.charCodeAt(u+1)===I.slash){for(u+=2;u<$&&!p(t.charCodeAt(u));)u++;return m=t.substring(W,u),E=R.LineCommentTrivia}if(t.charCodeAt(u+1)===I.asterisk){u+=2;const K=$-1;let q=!1;for(;u<K;){if(t.charCodeAt(u)===I.asterisk&&t.charCodeAt(u+1)===I.slash){u+=2,q=!0;break}u++}return q||(u++,D=v.UnexpectedEndOfComment),m=t.substring(W,u),E=R.BlockCommentTrivia}return m+=String.fromCharCode(L),u++,E=R.Unknown}case I.minus:if(m+=String.fromCharCode(L),u++,u===$||!o(t.charCodeAt(u)))return E=R.Unknown;case I._0:case I._1:case I._2:case I._3:case I._4:case I._5:case I._6:case I._7:case I._8:case I._9:return m+=k(),E=R.NumericLiteral;default:for(;u<$&&M(L);)u++,L=t.charCodeAt(u);if(h!==u){switch(m=t.substring(h,u),m){case"true":return E=R.TrueKeyword;case"false":return E=R.FalseKeyword;case"null":return E=R.NullKeyword}return E=R.Unknown}return m+=String.fromCharCode(L),u++,E=R.Unknown}}function M(L){if(T(L)||p(L))return!1;switch(L){case I.closeBrace:case I.closeBracket:case I.openBrace:case I.openBracket:case I.doubleQuote:case I.colon:case I.comma:case I.slash:return!1}return!0}function N(){let L;do L=b();while(L>=R.LineCommentTrivia&&L<=R.Trivia);return L}return{setPosition:C,getPosition:()=>u,scan:g?N:b,getToken:()=>E,getTokenValue:()=>m,getTokenOffset:()=>h,getTokenLength:()=>u-h,getTokenError:()=>D}}function T(t){return t===I.space||t===I.tab||t===I.verticalTab||t===I.formFeed||t===I.nonBreakingSpace||t===I.ogham||t>=I.enQuad&&t<=I.zeroWidthSpace||t===I.narrowNoBreakSpace||t===I.mathematicalSpace||t===I.ideographicSpace||t===I.byteOrderMark}function p(t){return t===I.lineFeed||t===I.carriageReturn||t===I.lineSeparator||t===I.paragraphSeparator}function o(t){return t>=I._0&&t<=I._9}var I;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(I||(I={}));function y(t,g){const u=[],$=new Object;let m;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(w,C,k,f){h.value=w,h.offset=C,h.length=k,h.type=f,h.colonOffset=void 0,m=h}try{i(t,{onObjectBegin:(w,C)=>{if(g<=w)throw $;m=void 0,E=g>w,u.push("")},onObjectProperty:(w,C,k)=>{if(g<C||(D(w,C,k,"property"),u[u.length-1]=w,g<=C+k))throw $},onObjectEnd:(w,C)=>{if(g<=w)throw $;m=void 0,u.pop()},onArrayBegin:(w,C)=>{if(g<=w)throw $;m=void 0,u.push(0)},onArrayEnd:(w,C)=>{if(g<=w)throw $;m=void 0,u.pop()},onLiteralValue:(w,C,k)=>{if(g<C||(D(w,C,k,n(w)),g<=C+k))throw $},onSeparator:(w,C,k)=>{if(g<=C)throw $;if(w===":"&&m&&m.type==="property")m.colonOffset=C,E=!1,m=void 0;else if(w===","){const f=u[u.length-1];typeof f=="number"?u[u.length-1]=f+1:(E=!0,u[u.length-1]=""),m=void 0}}})}catch(w){if(w!==$)throw w}return{path:u,previousNode:m,isAtPropertyKey:E,matches:w=>{let C=0;for(let k=0;C<w.length&&k<u.length;k++)if(w[C]===u[k]||w[C]==="*")C++;else if(w[C]!=="**")return!1;return C===w.length}}}function a(t,g=[],u=O.DEFAULT){let $=null,m=[];const h=[];function E(w){Array.isArray(m)?m.push(w):$!==null&&(m[$]=w)}return i(t,{onObjectBegin:()=>{const w={};E(w),h.push(m),m=w,$=null},onObjectProperty:w=>{$=w},onObjectEnd:()=>{m=h.pop()},onArrayBegin:()=>{const w=[];E(w),h.push(m),m=w,$=null},onArrayEnd:()=>{m=h.pop()},onLiteralValue:E,onError:(w,C,k)=>{g.push({error:w,offset:C,length:k})}},u),m[0]}function S(t,g=[],u=O.DEFAULT){let $={type:"array",offset:-1,length:-1,children:[],parent:void 0};function m(w){$.type==="property"&&($.length=w-$.offset,$=$.parent)}function h(w){return $.children.push(w),w}i(t,{onObjectBegin:w=>{$=h({type:"object",offset:w,length:-1,parent:$,children:[]})},onObjectProperty:(w,C,k)=>{$=h({type:"property",offset:C,length:-1,parent:$,children:[]}),$.children.push({type:"string",value:w,offset:C,length:k,parent:$})},onObjectEnd:(w,C)=>{$.length=w+C-$.offset,$=$.parent,m(w+C)},onArrayBegin:(w,C)=>{$=h({type:"array",offset:w,length:-1,parent:$,children:[]})},onArrayEnd:(w,C)=>{$.length=w+C-$.offset,$=$.parent,m(w+C)},onLiteralValue:(w,C,k)=>{h({type:n(w),offset:C,length:k,parent:$,value:w}),m(C+k)},onSeparator:(w,C,k)=>{$.type==="property"&&(w===":"?$.colonOffset=C:w===","&&m(C))},onError:(w,C,k)=>{g.push({error:w,offset:C,length:k})}},u);const D=$.children[0];return D&&delete D.parent,D}function d(t,g){if(!t)return;let u=t;for(const $ of g)if(typeof $=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let m=!1;for(const h of u.children)if(Array.isArray(h.children)&&h.children[0].value===$){u=h.children[1],m=!0;break}if(!m)return}else{const m=$;if(u.type!=="array"||m<0||!Array.isArray(u.children)||m>=u.children.length)return;u=u.children[m]}return u}function r(t){if(!t.parent||!t.parent.children)return[];const g=r(t.parent);if(t.parent.type==="property"){const u=t.parent.children[0].value;g.push(u)}else if(t.parent.type==="array"){const u=t.parent.children.indexOf(t);u!==-1&&g.push(u)}return g}function s(t){switch(t.type){case"array":return t.children.map(s);case"object":{const g=Object.create(null);for(const u of t.children){const $=u.children[1];$&&(g[u.children[0].value]=s($))}return g}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,g,u=!1){return g>=t.offset&&g<t.offset+t.length||u&&g===t.offset+t.length}function l(t,g,u=!1){if(c(t,g,u)){const $=t.children;if(Array.isArray($))for(let m=0;m<$.length&&$[m].offset<=g;m++){const h=l($[m],g,u);if(h)return h}return t}}function i(t,g,u=O.DEFAULT){const $=A(t,!1);function m(ce){return ce?()=>ce($.getTokenOffset(),$.getTokenLength()):()=>!0}function h(ce){return ce?me=>ce(me,$.getTokenOffset(),$.getTokenLength()):()=>!0}const E=m(g.onObjectBegin),D=h(g.onObjectProperty),w=m(g.onObjectEnd),C=m(g.onArrayBegin),k=m(g.onArrayEnd),f=h(g.onLiteralValue),b=h(g.onSeparator),M=m(g.onComment),N=h(g.onError),L=u&&u.disallowComments,W=u&&u.allowTrailingComma;function K(){for(;;){const ce=$.scan();switch($.getTokenError()){case v.InvalidUnicode:q(P.InvalidUnicode);break;case v.InvalidEscapeCharacter:q(P.InvalidEscapeCharacter);break;case v.UnexpectedEndOfNumber:q(P.UnexpectedEndOfNumber);break;case v.UnexpectedEndOfComment:L||q(P.UnexpectedEndOfComment);break;case v.UnexpectedEndOfString:q(P.UnexpectedEndOfString);break;case v.InvalidCharacter:q(P.InvalidCharacter);break}switch(ce){case R.LineCommentTrivia:case R.BlockCommentTrivia:L?q(P.InvalidCommentToken):M();break;case R.Unknown:q(P.InvalidSymbol);break;case R.Trivia:case R.LineBreakTrivia:break;default:return ce}}}function q(ce,me=[],oe=[]){if(N(ce),me.length+oe.length>0){let ke=$.getToken();for(;ke!==R.EOF;){if(me.indexOf(ke)!==-1){K();break}else if(oe.indexOf(ke)!==-1)break;ke=K()}}}function G(ce){const me=$.getTokenValue();return ce?f(me):D(me),K(),!0}function Q(){switch($.getToken()){case R.NumericLiteral:{let ce=0;try{ce=JSON.parse($.getTokenValue()),typeof ce!="number"&&(q(P.InvalidNumberFormat),ce=0)}catch{q(P.InvalidNumberFormat)}f(ce);break}case R.NullKeyword:f(null);break;case R.TrueKeyword:f(!0);break;case R.FalseKeyword:f(!1);break;default:return!1}return K(),!0}function ae(){return $.getToken()!==R.StringLiteral?(q(P.PropertyNameExpected,[],[R.CloseBraceToken,R.CommaToken]),!1):(G(!1),$.getToken()===R.ColonToken?(b(":"),K(),_()||q(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken])):q(P.ColonExpected,[],[R.CloseBraceToken,R.CommaToken]),!0)}function we(){E(),K();let ce=!1;for(;$.getToken()!==R.CloseBraceToken&&$.getToken()!==R.EOF;){if($.getToken()===R.CommaToken){if(ce||q(P.ValueExpected,[],[]),b(","),K(),$.getToken()===R.CloseBraceToken&&W)break}else ce&&q(P.CommaExpected,[],[]);ae()||q(P.ValueExpected,[],[R.CloseBraceToken,R.CommaToken]),ce=!0}return w(),$.getToken()!==R.CloseBraceToken?q(P.CloseBraceExpected,[R.CloseBraceToken],[]):K(),!0}function le(){C(),K();let ce=!1;for(;$.getToken()!==R.CloseBracketToken&&$.getToken()!==R.EOF;){if($.getToken()===R.CommaToken){if(ce||q(P.ValueExpected,[],[]),b(","),K(),$.getToken()===R.CloseBracketToken&&W)break}else ce&&q(P.CommaExpected,[],[]);_()||q(P.ValueExpected,[],[R.CloseBracketToken,R.CommaToken]),ce=!0}return k(),$.getToken()!==R.CloseBracketToken?q(P.CloseBracketExpected,[R.CloseBracketToken],[]):K(),!0}function _(){switch($.getToken()){case R.OpenBracketToken:return le();case R.OpenBraceToken:return we();case R.StringLiteral:return G(!0);default:return Q()}}return K(),$.getToken()===R.EOF?u.allowEmptyContent?!0:(q(P.ValueExpected,[],[]),!1):_()?($.getToken()!==R.EOF&&q(P.EndOfFileExpected,[],[]),!0):(q(P.ValueExpected,[],[]),!1)}function n(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(Ne[137],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7j=v;function v(O){let A=!1;const T=new Map,p=new Map;if(P(O,r=>{if(O===r)return!0;const s=JSON.stringify(r);if(s.length<30)return!0;const c=T.get(s);if(!c){const l={schemas:[r]};return T.set(s,l),p.set(r,l),!0}return c.schemas.push(r),p.set(r,c),A=!0,!1}),T.clear(),!A)return JSON.stringify(O);let I="$defs";for(;O.hasOwnProperty(I);)I+="_";const y=[];function a(r){return JSON.stringify(r,(s,c)=>{if(c!==r){const l=p.get(c);if(l&&l.schemas.length>1)return l.id||(l.id=`_${y.length}`,y.push(l.schemas[0])),{$ref:`#/${I}/${l.id}`}}return c})}const S=a(O),d=[];for(let r=0;r<y.length;r++)d.push(`"_${r}":${a(y[r])}`);return d.length?`${S.substring(0,S.length-1)},"${I}":{${d.join(",")}}}`:S}function R(O){return typeof O=="object"&&O!==null}function P(O,A){if(!O||typeof O!="object")return;const T=(...S)=>{for(const d of S)R(d)&&y.push(d)},p=(...S)=>{for(const d of S)if(R(d))for(const r in d){const s=d[r];R(s)&&y.push(s)}},o=(...S)=>{for(const d of S)if(Array.isArray(d))for(const r of d)R(r)&&y.push(r)},I=S=>{if(Array.isArray(S))for(const d of S)R(d)&&y.push(d);else R(S)&&y.push(S)},y=[O];let a=y.pop();for(;a;)A(a)&&(T(a.additionalItems,a.additionalProperties,a.not,a.contains,a.propertyNames,a.if,a.then,a.else,a.unevaluatedItems,a.unevaluatedProperties),p(a.definitions,a.$defs,a.properties,a.patternProperties,a.dependencies,a.dependentSchemas),o(a.anyOf,a.allOf,a.oneOf,a.prefixItems),I(a.items)),a=y.pop()}}),function(ve,e){typeof define=="function"&&define.amd?define(Ne[138],Le([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ve=typeof globalThis<"u"?globalThis:ve||self,e(ve.marked={}))}(this,function(ve){"use strict";function e(fe,be){for(var he=0;he<be.length;he++){var X=be[he];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(fe,X.key,X)}}function v(fe,be,he){return be&&e(fe.prototype,be),he&&e(fe,he),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function R(fe,be){if(fe){if(typeof fe=="string")return P(fe,be);var he=Object.prototype.toString.call(fe).slice(8,-1);if(he==="Object"&&fe.constructor&&(he=fe.constructor.name),he==="Map"||he==="Set")return Array.from(fe);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return P(fe,be)}}function P(fe,be){(be==null||be>fe.length)&&(be=fe.length);for(var he=0,X=new Array(be);he<be;he++)X[he]=fe[he];return X}function O(fe,be){var he=typeof Symbol<"u"&&fe[Symbol.iterator]||fe["@@iterator"];if(he)return(he=he.call(fe)).next.bind(he);if(Array.isArray(fe)||(he=R(fe))||be&&fe&&typeof fe.length=="number"){he&&(fe=he);var X=0;return function(){return X>=fe.length?{done:!0}:{done:!1,value:fe[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ve.defaults=A();function T(fe){ve.defaults=fe}var p=/[&<>"']/,o=/[&<>"']/g,I=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,a={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(be){return a[be]};function d(fe,be){if(be){if(p.test(fe))return fe.replace(o,S)}else if(I.test(fe))return fe.replace(y,S);return fe}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(fe){return fe.replace(r,function(be,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var c=/(^|[^\[])\^/g;function l(fe,be){fe=typeof fe=="string"?fe:fe.source,be=be||"";var he={replace:function(x,$e){return $e=$e.source||$e,$e=$e.replace(c,"$1"),fe=fe.replace(x,$e),he},getRegex:function(){return new RegExp(fe,be)}};return he}var i=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function t(fe,be,he){if(fe){var X;try{X=decodeURIComponent(s(he)).replace(i,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}be&&!n.test(he)&&(he=h(be,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var g={},u=/^[^:]+:\/*[^/]*$/,$=/^([^:]+:)[\s\S]*$/,m=/^([^:]+:\/*[^/]*)[\s\S]*$/;function h(fe,be){g[" "+fe]||(u.test(fe)?g[" "+fe]=fe+"/":g[" "+fe]=C(fe,"/",!0)),fe=g[" "+fe];var he=fe.indexOf(":")===-1;return be.substring(0,2)==="//"?he?be:fe.replace($,"$1")+be:be.charAt(0)==="/"?he?be:fe.replace(m,"$1")+be:fe+be}var E={exec:function(){}};function D(fe){for(var be=1,he,X;be<arguments.length;be++){he=arguments[be];for(X in he)Object.prototype.hasOwnProperty.call(he,X)&&(fe[X]=he[X])}return fe}function w(fe,be){var he=fe.replace(/\|/g,function($e,pe,Ae){for(var Ue=!1,Ie=pe;--Ie>=0&&Ae[Ie]==="\\";)Ue=!Ue;return Ue?"|":" |"}),X=he.split(/ \|/),x=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>be)X.splice(be);else for(;X.length<be;)X.push("");for(;x<X.length;x++)X[x]=X[x].trim().replace(/\\\|/g,"|");return X}function C(fe,be,he){var X=fe.length;if(X===0)return"";for(var x=0;x<X;){var $e=fe.charAt(X-x-1);if($e===be&&!he)x++;else if($e!==be&&he)x++;else break}return fe.slice(0,X-x)}function k(fe,be){if(fe.indexOf(be[1])===-1)return-1;for(var he=fe.length,X=0,x=0;x<he;x++)if(fe[x]==="\\")x++;else if(fe[x]===be[0])X++;else if(fe[x]===be[1]&&(X--,X<0))return x;return-1}function f(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function b(fe,be){if(be<1)return"";for(var he="";be>1;)be&1&&(he+=fe),be>>=1,fe+=fe;return he+fe}function M(fe,be,he,X){var x=be.href,$e=be.title?d(be.title):null,pe=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){X.state.inLink=!0;var Ae={type:"link",raw:he,href:x,title:$e,text:pe,tokens:X.inlineTokens(pe)};return X.state.inLink=!1,Ae}return{type:"image",raw:he,href:x,title:$e,text:d(pe)}}function N(fe,be){var he=fe.match(/^(\s+)(?:```)/);if(he===null)return be;var X=he[1];return be.split(`
`).map(function(x){var $e=x.match(/^\s+/);if($e===null)return x;var pe=$e[0];return pe.length>=X.length?x.slice(X.length):x}).join(`
`)}var L=function(){function fe(he){this.options=he||ve.defaults}var be=fe.prototype;return be.space=function(X){var x=this.rules.block.newline.exec(X);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},be.code=function(X){var x=this.rules.block.code.exec(X);if(x){var $e=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?$e:C($e,`
`)}}},be.fences=function(X){var x=this.rules.block.fences.exec(X);if(x){var $e=x[0],pe=N($e,x[3]||"");return{type:"code",raw:$e,lang:x[2]?x[2].trim():x[2],text:pe}}},be.heading=function(X){var x=this.rules.block.heading.exec(X);if(x){var $e=x[2].trim();if(/#$/.test($e)){var pe=C($e,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&($e=pe.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:$e,tokens:this.lexer.inline($e)}}},be.hr=function(X){var x=this.rules.block.hr.exec(X);if(x)return{type:"hr",raw:x[0]}},be.blockquote=function(X){var x=this.rules.block.blockquote.exec(X);if(x){var $e=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens($e,[]),text:$e}}},be.list=function(X){var x=this.rules.block.list.exec(X);if(x){var $e,pe,Ae,Ue,Ie,Pe,Oe,z,j,H,V,re,ge=x[1].trim(),Ce=ge.length>1,ze={type:"list",raw:"",ordered:Ce,start:Ce?+ge.slice(0,-1):"",loose:!1,items:[]};ge=Ce?"\\d{1,9}\\"+ge.slice(-1):"\\"+ge,this.options.pedantic&&(ge=Ce?ge:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(re=!1,!(!(x=Qe.exec(X))||this.rules.block.hr.test(X)));){if($e=x[0],X=X.substring($e.length),z=x[2].split(`
`,1)[0],j=X.split(`
`,1)[0],this.options.pedantic?(Ue=2,V=z.trimLeft()):(Ue=x[2].search(/[^ ]/),Ue=Ue>4?1:Ue,V=z.slice(Ue),Ue+=x[1].length),Pe=!1,!z&&/^ *$/.test(j)&&($e+=j+`
`,X=X.substring(j.length+1),re=!0),!re)for(var _e=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),tt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),nt=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}#");X&&(H=X.split(`
`,1)[0],z=H,this.options.pedantic&&(z=z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(z)||et.test(z)||_e.test(z)||tt.test(X)));){if(z.search(/[^ ]/)>=Ue||!z.trim())V+=`
`+z.slice(Ue);else if(!Pe)V+=`
`+z;else break;!Pe&&!z.trim()&&(Pe=!0),$e+=H+`
`,X=X.substring(H.length+1)}ze.loose||(Oe?ze.loose=!0:/\n *\n *$/.test($e)&&(Oe=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(V),pe&&(Ae=pe[0]!=="[ ] ",V=V.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:$e,task:!!pe,checked:Ae,loose:!1,text:V}),ze.raw+=$e}ze.items[ze.items.length-1].raw=$e.trimRight(),ze.items[ze.items.length-1].text=V.trimRight(),ze.raw=ze.raw.trimRight();var rt=ze.items.length;for(Ie=0;Ie<rt;Ie++){this.lexer.state.top=!1,ze.items[Ie].tokens=this.lexer.blockTokens(ze.items[Ie].text,[]);var ft=ze.items[Ie].tokens.filter(function(st){return st.type==="space"}),lt=ft.every(function(st){for(var ct=st.raw.split(""),mt=0,$t=O(ct),qe;!(qe=$t()).done;){var je=qe.value;if(je===`
`&&(mt+=1),mt>1)return!0}return!1});!ze.loose&&ft.length&&lt&&(ze.loose=!0,ze.items[Ie].loose=!0)}return ze}},be.html=function(X){var x=this.rules.block.html.exec(X);if(x){var $e={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]);$e.type="paragraph",$e.text=pe,$e.tokens=this.lexer.inline(pe)}return $e}},be.def=function(X){var x=this.rules.block.def.exec(X);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var $e=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:$e,raw:x[0],href:x[2],title:x[3]}}},be.table=function(X){var x=this.rules.block.table.exec(X);if(x){var $e={type:"table",header:w(x[1]).map(function(Oe){return{text:Oe}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if($e.header.length===$e.align.length){$e.raw=x[0];var pe=$e.align.length,Ae,Ue,Ie,Pe;for(Ae=0;Ae<pe;Ae++)/^ *-+: *$/.test($e.align[Ae])?$e.align[Ae]="right":/^ *:-+: *$/.test($e.align[Ae])?$e.align[Ae]="center":/^ *:-+ *$/.test($e.align[Ae])?$e.align[Ae]="left":$e.align[Ae]=null;for(pe=$e.rows.length,Ae=0;Ae<pe;Ae++)$e.rows[Ae]=w($e.rows[Ae],$e.header.length).map(function(Oe){return{text:Oe}});for(pe=$e.header.length,Ue=0;Ue<pe;Ue++)$e.header[Ue].tokens=this.lexer.inline($e.header[Ue].text);for(pe=$e.rows.length,Ue=0;Ue<pe;Ue++)for(Pe=$e.rows[Ue],Ie=0;Ie<Pe.length;Ie++)Pe[Ie].tokens=this.lexer.inline(Pe[Ie].text);return $e}}},be.lheading=function(X){var x=this.rules.block.lheading.exec(X);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},be.paragraph=function(X){var x=this.rules.block.paragraph.exec(X);if(x){var $e=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:$e,tokens:this.lexer.inline($e)}}},be.text=function(X){var x=this.rules.block.text.exec(X);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},be.escape=function(X){var x=this.rules.inline.escape.exec(X);if(x)return{type:"escape",raw:x[0],text:d(x[1])}},be.tag=function(X){var x=this.rules.inline.tag.exec(X);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):d(x[0]):x[0]}},be.link=function(X){var x=this.rules.inline.link.exec(X);if(x){var $e=x[2].trim();if(!this.options.pedantic&&/^</.test($e)){if(!/>$/.test($e))return;var pe=C($e.slice(0,-1),"\\");if(($e.length-pe.length)%2===0)return}else{var Ae=k(x[2],"()");if(Ae>-1){var Ue=x[0].indexOf("!")===0?5:4,Ie=Ue+x[1].length+Ae;x[2]=x[2].substring(0,Ae),x[0]=x[0].substring(0,Ie).trim(),x[3]=""}}var Pe=x[2],Oe="";if(this.options.pedantic){var z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Pe);z&&(Pe=z[1],Oe=z[3])}else Oe=x[3]?x[3].slice(1,-1):"";return Pe=Pe.trim(),/^</.test(Pe)&&(this.options.pedantic&&!/>$/.test($e)?Pe=Pe.slice(1):Pe=Pe.slice(1,-1)),M(x,{href:Pe&&Pe.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},be.reflink=function(X,x){var $e;if(($e=this.rules.inline.reflink.exec(X))||($e=this.rules.inline.nolink.exec(X))){var pe=($e[2]||$e[1]).replace(/\s+/g," ");if(pe=x[pe.toLowerCase()],!pe||!pe.href){var Ae=$e[0].charAt(0);return{type:"text",raw:Ae,text:Ae}}return M($e,pe,$e[0],this.lexer)}},be.emStrong=function(X,x,$e){$e===void 0&&($e="");var pe=this.rules.inline.emStrong.lDelim.exec(X);if(pe&&!(pe[3]&&$e.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ae=pe[1]||pe[2]||"";if(!Ae||Ae&&($e===""||this.rules.inline.punctuation.exec($e))){var Ue=pe[0].length-1,Ie,Pe,Oe=Ue,z=0,j=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,x=x.slice(-1*X.length+Ue);(pe=j.exec(x))!=null;)if(Ie=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Ie){if(Pe=Ie.length,pe[3]||pe[4]){Oe+=Pe;continue}else if((pe[5]||pe[6])&&Ue%3&&!((Ue+Pe)%3)){z+=Pe;continue}if(Oe-=Pe,!(Oe>0)){if(Pe=Math.min(Pe,Pe+Oe+z),Math.min(Ue,Pe)%2){var H=X.slice(1,Ue+pe.index+Pe);return{type:"em",raw:X.slice(0,Ue+pe.index+Pe+1),text:H,tokens:this.lexer.inlineTokens(H)}}var V=X.slice(2,Ue+pe.index+Pe-1);return{type:"strong",raw:X.slice(0,Ue+pe.index+Pe+1),text:V,tokens:this.lexer.inlineTokens(V)}}}}}},be.codespan=function(X){var x=this.rules.inline.code.exec(X);if(x){var $e=x[2].replace(/\n/g," "),pe=/[^ ]/.test($e),Ae=/^ /.test($e)&&/ $/.test($e);return pe&&Ae&&($e=$e.substring(1,$e.length-1)),$e=d($e,!0),{type:"codespan",raw:x[0],text:$e}}},be.br=function(X){var x=this.rules.inline.br.exec(X);if(x)return{type:"br",raw:x[0]}},be.del=function(X){var x=this.rules.inline.del.exec(X);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},be.autolink=function(X,x){var $e=this.rules.inline.autolink.exec(X);if($e){var pe,Ae;return $e[2]==="@"?(pe=d(this.options.mangle?x($e[1]):$e[1]),Ae="mailto:"+pe):(pe=d($e[1]),Ae=pe),{type:"link",raw:$e[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},be.url=function(X,x){var $e;if($e=this.rules.inline.url.exec(X)){var pe,Ae;if($e[2]==="@")pe=d(this.options.mangle?x($e[0]):$e[0]),Ae="mailto:"+pe;else{var Ue;do Ue=$e[0],$e[0]=this.rules.inline._backpedal.exec($e[0])[0];while(Ue!==$e[0]);pe=d($e[0]),$e[1]==="www."?Ae="http://"+pe:Ae=pe}return{type:"link",raw:$e[0],text:pe,href:Ae,tokens:[{type:"text",raw:pe,text:pe}]}}},be.inlineText=function(X,x){var $e=this.rules.inline.text.exec(X);if($e){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer($e[0]):d($e[0]):$e[0]:pe=d(this.options.smartypants?x($e[0]):$e[0]),{type:"text",raw:$e[0],text:pe}}},fe}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:E,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=l(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=l(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=l(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=l(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=l(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=l(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=D({},W),W.gfm=D({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=l(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=l(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=D({},W.normal,{html:l(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:E,paragraph:l(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var K={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:E,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:E,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};K._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",K.punctuation=l(K.punctuation).replace(/punctuation/g,K._punctuation).getRegex(),K.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,K.escapedEmSt=/\\\*|\\_/g,K._comment=l(W._comment).replace("(?:-->|$)","-->").getRegex(),K.emStrong.lDelim=l(K.emStrong.lDelim).replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimAst=l(K.emStrong.rDelimAst,"g").replace(/punct/g,K._punctuation).getRegex(),K.emStrong.rDelimUnd=l(K.emStrong.rDelimUnd,"g").replace(/punct/g,K._punctuation).getRegex(),K._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,K._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,K._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,K.autolink=l(K.autolink).replace("scheme",K._scheme).replace("email",K._email).getRegex(),K._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,K.tag=l(K.tag).replace("comment",K._comment).replace("attribute",K._attribute).getRegex(),K._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,K._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,K._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,K.link=l(K.link).replace("label",K._label).replace("href",K._href).replace("title",K._title).getRegex(),K.reflink=l(K.reflink).replace("label",K._label).replace("ref",W._label).getRegex(),K.nolink=l(K.nolink).replace("ref",W._label).getRegex(),K.reflinkSearch=l(K.reflinkSearch,"g").replace("reflink",K.reflink).replace("nolink",K.nolink).getRegex(),K.normal=D({},K),K.pedantic=D({},K.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:l(/^!?\[(label)\]\((.*?)\)/).replace("label",K._label).getRegex(),reflink:l(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",K._label).getRegex()}),K.gfm=D({},K.normal,{escape:l(K.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),K.gfm.url=l(K.gfm.url,"i").replace("email",K.gfm._extended_email).getRegex(),K.breaks=D({},K.gfm,{br:l(K.br).replace("{2,}","*").getRegex(),text:l(K.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function q(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function G(fe){var be="",he,X,x=fe.length;for(he=0;he<x;he++)X=fe.charCodeAt(he),Math.random()>.5&&(X="x"+X.toString(16)),be+="&#"+X+";";return be}var Q=function(){function fe(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||ve.defaults,this.options.tokenizer=this.options.tokenizer||new L,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:W.normal,inline:K.normal};this.options.pedantic?(X.block=W.pedantic,X.inline=K.pedantic):this.options.gfm&&(X.block=W.gfm,this.options.breaks?X.inline=K.breaks:X.inline=K.gfm),this.tokenizer.rules=X}fe.lex=function(X,x){var $e=new fe(x);return $e.lex(X)},fe.lexInline=function(X,x){var $e=new fe(x);return $e.inlineTokens(X)};var be=fe.prototype;return be.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},be.blockTokens=function(X,x){var $e=this;x===void 0&&(x=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(Oe,z,j){return z+"    ".repeat(j.length)});for(var pe,Ae,Ue,Ie;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Oe){return(pe=Oe.call({lexer:$e},X,x))?(X=X.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.space(X)){X=X.substring(pe.raw.length),pe.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(pe);continue}if(pe=this.tokenizer.code(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(pe=this.tokenizer.fences(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.heading(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.hr(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.blockquote(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.list(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.html(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.def(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&(Ae.type==="paragraph"||Ae.type==="text")?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.lheading(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Oe=1/0,z=X.slice(1),j=void 0;$e.options.extensions.startBlock.forEach(function(H){j=H.call({lexer:this},z),typeof j=="number"&&j>=0&&(Oe=Math.min(Oe,j))}),Oe<1/0&&Oe>=0&&(Ue=X.substring(0,Oe+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(Ue))){Ae=x[x.length-1],Ie&&Ae.type==="paragraph"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe),Ie=Ue.length!==X.length,X=X.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=`
`+pe.raw,Ae.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ae.text):x.push(pe);continue}if(X){var Pe="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return this.state.top=!0,x},be.inline=function(X,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:X,tokens:x}),x},be.inlineTokens=function(X,x){var $e=this;x===void 0&&(x=[]);var pe,Ae,Ue,Ie=X,Pe,Oe,z;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Pe=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)j.includes(Pe[0].slice(Pe[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Pe=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,Pe.index)+"["+b("a",Pe[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Pe=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,Pe.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Oe||(z=""),Oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(V){return(pe=V.call({lexer:$e},X,x))?(X=X.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.tag(X)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.link(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(pe.raw.length),Ae=x[x.length-1],Ae&&pe.type==="text"&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.emStrong(X,Ie,z)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.codespan(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.br(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.del(X)){X=X.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.autolink(X,G)){X=X.substring(pe.raw.length),x.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(X,G))){X=X.substring(pe.raw.length),x.push(pe);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startInline&&function(){var V=1/0,re=X.slice(1),ge=void 0;$e.options.extensions.startInline.forEach(function(Ce){ge=Ce.call({lexer:this},re),typeof ge=="number"&&ge>=0&&(V=Math.min(V,ge))}),V<1/0&&V>=0&&(Ue=X.substring(0,V+1))}(),pe=this.tokenizer.inlineText(Ue,q)){X=X.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(z=pe.raw.slice(-1)),Oe=!0,Ae=x[x.length-1],Ae&&Ae.type==="text"?(Ae.raw+=pe.raw,Ae.text+=pe.text):x.push(pe);continue}if(X){var H="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return x},v(fe,null,[{key:"rules",get:function(){return{block:W,inline:K}}}]),fe}(),ae=function(){function fe(he){this.options=he||ve.defaults}var be=fe.prototype;return be.code=function(X,x,$e){var pe=(x||"").match(/\S*/)[0];if(this.options.highlight){var Ae=this.options.highlight(X,pe);Ae!=null&&Ae!==X&&($e=!0,X=Ae)}return X=X.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+d(pe,!0)+'">'+($e?X:d(X,!0))+`</code></pre>
`:"<pre><code>"+($e?X:d(X,!0))+`</code></pre>
`},be.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},be.html=function(X){return X},be.heading=function(X,x,$e,pe){if(this.options.headerIds){var Ae=this.options.headerPrefix+pe.slug($e);return"<h"+x+' id="'+Ae+'">'+X+"</h"+x+`>
`}return"<h"+x+">"+X+"</h"+x+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(X,x,$e){var pe=x?"ol":"ul",Ae=x&&$e!==1?' start="'+$e+'"':"";return"<"+pe+Ae+`>
`+X+"</"+pe+`>
`},be.listitem=function(X){return"<li>"+X+`</li>
`},be.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(X){return"<p>"+X+`</p>
`},be.table=function(X,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+x+`</table>
`},be.tablerow=function(X){return`<tr>
`+X+`</tr>
`},be.tablecell=function(X,x){var $e=x.header?"th":"td",pe=x.align?"<"+$e+' align="'+x.align+'">':"<"+$e+">";return pe+X+("</"+$e+`>
`)},be.strong=function(X){return"<strong>"+X+"</strong>"},be.em=function(X){return"<em>"+X+"</em>"},be.codespan=function(X){return"<code>"+X+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(X){return"<del>"+X+"</del>"},be.link=function(X,x,$e){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return $e;var pe='<a href="'+d(X)+'"';return x&&(pe+=' title="'+x+'"'),pe+=">"+$e+"</a>",pe},be.image=function(X,x,$e){if(X=t(this.options.sanitize,this.options.baseUrl,X),X===null)return $e;var pe='<img src="'+X+'" alt="'+$e+'"';return x&&(pe+=' title="'+x+'"'),pe+=this.options.xhtml?"/>":">",pe},be.text=function(X){return X},fe}(),we=function(){function fe(){}var be=fe.prototype;return be.strong=function(X){return X},be.em=function(X){return X},be.codespan=function(X){return X},be.del=function(X){return X},be.html=function(X){return X},be.text=function(X){return X},be.link=function(X,x,$e){return""+$e},be.image=function(X,x,$e){return""+$e},be.br=function(){return""},fe}(),le=function(){function fe(){this.seen={}}var be=fe.prototype;return be.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(X,x){var $e=X,pe=0;if(this.seen.hasOwnProperty($e)){pe=this.seen[X];do pe++,$e=X+"-"+pe;while(this.seen.hasOwnProperty($e))}return x||(this.seen[X]=pe,this.seen[$e]=0),$e},be.slug=function(X,x){x===void 0&&(x={});var $e=this.serialize(X);return this.getNextSafeSlug($e,x.dryrun)},fe}(),_=function(){function fe(he){this.options=he||ve.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new le}fe.parse=function(X,x){var $e=new fe(x);return $e.parse(X)},fe.parseInline=function(X,x){var $e=new fe(x);return $e.parseInline(X)};var be=fe.prototype;return be.parse=function(X,x){x===void 0&&(x=!0);var $e="",pe,Ae,Ue,Ie,Pe,Oe,z,j,H,V,re,ge,Ce,ze,Qe,_e,tt,nt,et,rt=X.length;for(pe=0;pe<rt;pe++){if(V=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[V.type]&&(et=this.options.extensions.renderers[V.type].call({parser:this},V),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(V.type))){$e+=et||"";continue}switch(V.type){case"space":continue;case"hr":{$e+=this.renderer.hr();continue}case"heading":{$e+=this.renderer.heading(this.parseInline(V.tokens),V.depth,s(this.parseInline(V.tokens,this.textRenderer)),this.slugger);continue}case"code":{$e+=this.renderer.code(V.text,V.lang,V.escaped);continue}case"table":{for(j="",z="",Ie=V.header.length,Ae=0;Ae<Ie;Ae++)z+=this.renderer.tablecell(this.parseInline(V.header[Ae].tokens),{header:!0,align:V.align[Ae]});for(j+=this.renderer.tablerow(z),H="",Ie=V.rows.length,Ae=0;Ae<Ie;Ae++){for(Oe=V.rows[Ae],z="",Pe=Oe.length,Ue=0;Ue<Pe;Ue++)z+=this.renderer.tablecell(this.parseInline(Oe[Ue].tokens),{header:!1,align:V.align[Ue]});H+=this.renderer.tablerow(z)}$e+=this.renderer.table(j,H);continue}case"blockquote":{H=this.parse(V.tokens),$e+=this.renderer.blockquote(H);continue}case"list":{for(re=V.ordered,ge=V.start,Ce=V.loose,Ie=V.items.length,H="",Ae=0;Ae<Ie;Ae++)Qe=V.items[Ae],_e=Qe.checked,tt=Qe.task,ze="",Qe.task&&(nt=this.renderer.checkbox(_e),Ce?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=nt+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=nt+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:nt}):ze+=nt),ze+=this.parse(Qe.tokens,Ce),H+=this.renderer.listitem(ze,tt,_e);$e+=this.renderer.list(H,re,ge);continue}case"html":{$e+=this.renderer.html(V.text);continue}case"paragraph":{$e+=this.renderer.paragraph(this.parseInline(V.tokens));continue}case"text":{for(H=V.tokens?this.parseInline(V.tokens):V.text;pe+1<rt&&X[pe+1].type==="text";)V=X[++pe],H+=`
`+(V.tokens?this.parseInline(V.tokens):V.text);$e+=x?this.renderer.paragraph(H):H;continue}default:{var ft='Token with "'+V.type+'" type was not found.';if(this.options.silent){console.error(ft);return}else throw new Error(ft)}}}return $e},be.parseInline=function(X,x){x=x||this.renderer;var $e="",pe,Ae,Ue,Ie=X.length;for(pe=0;pe<Ie;pe++){if(Ae=X[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&(Ue=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ae.type))){$e+=Ue||"";continue}switch(Ae.type){case"escape":{$e+=x.text(Ae.text);break}case"html":{$e+=x.html(Ae.text);break}case"link":{$e+=x.link(Ae.href,Ae.title,this.parseInline(Ae.tokens,x));break}case"image":{$e+=x.image(Ae.href,Ae.title,Ae.text);break}case"strong":{$e+=x.strong(this.parseInline(Ae.tokens,x));break}case"em":{$e+=x.em(this.parseInline(Ae.tokens,x));break}case"codespan":{$e+=x.codespan(Ae.text);break}case"br":{$e+=x.br();break}case"del":{$e+=x.del(this.parseInline(Ae.tokens,x));break}case"text":{$e+=x.text(Ae.text);break}default:{var Pe='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}}return $e},fe}();function ce(fe,be,he){if(typeof fe>"u"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof be=="function"&&(he=be,be=null),be=D({},ce.defaults,be||{}),f(be),he){var X=be.highlight,x;try{x=Q.lex(fe,be)}catch(Ie){return he(Ie)}var $e=function(Pe){var Oe;if(!Pe)try{be.walkTokens&&ce.walkTokens(x,be.walkTokens),Oe=_.parse(x,be)}catch(z){Pe=z}return be.highlight=X,Pe?he(Pe):he(null,Oe)};if(!X||X.length<3||(delete be.highlight,!x.length))return $e();var pe=0;ce.walkTokens(x,function(Ie){Ie.type==="code"&&(pe++,setTimeout(function(){X(Ie.text,Ie.lang,function(Pe,Oe){if(Pe)return $e(Pe);Oe!=null&&Oe!==Ie.text&&(Ie.text=Oe,Ie.escaped=!0),pe--,pe===0&&$e()})},0))}),pe===0&&$e();return}function Ae(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(Ie.message+"",!0)+"</pre>";throw Ie}try{var Ue=Q.lex(fe,be);if(be.walkTokens){if(be.async)return Promise.all(ce.walkTokens(Ue,be.walkTokens)).then(function(){return _.parse(Ue,be)}).catch(Ae);ce.walkTokens(Ue,be.walkTokens)}return _.parse(Ue,be)}catch(Ie){Ae(Ie)}}ce.options=ce.setOptions=function(fe){return D(ce.defaults,fe),T(ce.defaults),ce},ce.getDefaults=A,ce.defaults=ve.defaults,ce.use=function(){for(var fe=arguments.length,be=new Array(fe),he=0;he<fe;he++)be[he]=arguments[he];var X=D.apply(void 0,[{}].concat(be)),x=ce.defaults.extensions||{renderers:{},childTokens:{}},$e;be.forEach(function(pe){if(pe.extensions&&($e=!0,pe.extensions.forEach(function(Ue){if(!Ue.name)throw new Error("extension name required");if(Ue.renderer){var Ie=x.renderers?x.renderers[Ue.name]:null;Ie?x.renderers[Ue.name]=function(){for(var Pe=arguments.length,Oe=new Array(Pe),z=0;z<Pe;z++)Oe[z]=arguments[z];var j=Ue.renderer.apply(this,Oe);return j===!1&&(j=Ie.apply(this,Oe)),j}:x.renderers[Ue.name]=Ue.renderer}if(Ue.tokenizer){if(!Ue.level||Ue.level!=="block"&&Ue.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[Ue.level]?x[Ue.level].unshift(Ue.tokenizer):x[Ue.level]=[Ue.tokenizer],Ue.start&&(Ue.level==="block"?x.startBlock?x.startBlock.push(Ue.start):x.startBlock=[Ue.start]:Ue.level==="inline"&&(x.startInline?x.startInline.push(Ue.start):x.startInline=[Ue.start]))}Ue.childTokens&&(x.childTokens[Ue.name]=Ue.childTokens)})),pe.renderer&&function(){var Ue=ce.defaults.renderer||new ae,Ie=function(z){var j=Ue[z];Ue[z]=function(){for(var H=arguments.length,V=new Array(H),re=0;re<H;re++)V[re]=arguments[re];var ge=pe.renderer[z].apply(Ue,V);return ge===!1&&(ge=j.apply(Ue,V)),ge}};for(var Pe in pe.renderer)Ie(Pe);X.renderer=Ue}(),pe.tokenizer&&function(){var Ue=ce.defaults.tokenizer||new L,Ie=function(z){var j=Ue[z];Ue[z]=function(){for(var H=arguments.length,V=new Array(H),re=0;re<H;re++)V[re]=arguments[re];var ge=pe.tokenizer[z].apply(Ue,V);return ge===!1&&(ge=j.apply(Ue,V)),ge}};for(var Pe in pe.tokenizer)Ie(Pe);X.tokenizer=Ue}(),pe.walkTokens){var Ae=ce.defaults.walkTokens;X.walkTokens=function(Ue){var Ie=[];return Ie.push(pe.walkTokens.call(this,Ue)),Ae&&(Ie=Ie.concat(Ae.call(this,Ue))),Ie}}$e&&(X.extensions=x),ce.setOptions(X)})},ce.walkTokens=function(fe,be){for(var he=[],X=function(){var Ae=$e.value;switch(he=he.concat(be.call(ce,Ae)),Ae.type){case"table":{for(var Ue=O(Ae.header),Ie;!(Ie=Ue()).done;){var Pe=Ie.value;he=he.concat(ce.walkTokens(Pe.tokens,be))}for(var Oe=O(Ae.rows),z;!(z=Oe()).done;)for(var j=z.value,H=O(j),V;!(V=H()).done;){var re=V.value;he=he.concat(ce.walkTokens(re.tokens,be))}break}case"list":{he=he.concat(ce.walkTokens(Ae.items,be));break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[Ae.type]?ce.defaults.extensions.childTokens[Ae.type].forEach(function(ge){he=he.concat(ce.walkTokens(Ae[ge],be))}):Ae.tokens&&(he=he.concat(ce.walkTokens(Ae.tokens,be)))}},x=O(fe),$e;!($e=x()).done;)X();return he},ce.parseInline=function(fe,be){if(typeof fe>"u"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");be=D({},ce.defaults,be||{}),f(be);try{var he=Q.lexInline(fe,be);return be.walkTokens&&ce.walkTokens(he,be.walkTokens),_.parseInline(he,be)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+d(X.message+"",!0)+"</pre>";throw X}},ce.Parser=_,ce.parser=_.parse,ce.Renderer=ae,ce.TextRenderer=we,ce.Lexer=Q,ce.lexer=Q.lex,ce.Tokenizer=L,ce.Slugger=le,ce.parse=ce;var me=ce.options,oe=ce.setOptions,ke=ce.use,Te=ce.walkTokens,Z=ce.parseInline,B=ce,ne=_.parse,Ee=Q.lex;ve.Lexer=Q,ve.Parser=_,ve.Renderer=ae,ve.Slugger=le,ve.TextRenderer=we,ve.Tokenizer=L,ve.getDefaults=A,ve.lexer=Ee,ve.marked=ce,ve.options=me,ve.parse=B,ve.parseInline=Z,ve.parser=ne,ve.setOptions=oe,ve.use=ke,ve.walkTokens=Te,Object.defineProperty(ve,"__esModule",{value:!0})}),define(Ne[139],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ek=v;function v(r){const s=O(r);if(s&&s.length>0)return new Uint32Array(s)}let R=0;const P=new Uint32Array(10);function O(r){if(R=0,A(r,y,p.InitialConsonant),R>0||(A(r,a,p.Vowel),R>0)||(A(r,S,p.FinalConsonant),R>0)||(A(r,d,p.CompatibilityJamo),R))return P.subarray(0,R);if(r>=44032&&r<=55203){const s=r-44032,c=s%588,l=Math.floor(s/588),i=Math.floor(c/28),n=c%28-1;if(l<y.length?A(l,y,0):p.InitialConsonant+l-p.CompatibilityJamo<d.length&&A(p.InitialConsonant+l,d,p.CompatibilityJamo),i<a.length?A(i,a,0):p.Vowel+i-p.CompatibilityJamo<d.length&&A(p.Vowel+i-p.CompatibilityJamo,d,p.CompatibilityJamo),n>=0&&(n<S.length?A(n,S,0):p.FinalConsonant+n-p.CompatibilityJamo<d.length&&A(p.FinalConsonant+n-p.CompatibilityJamo,d,p.CompatibilityJamo)),R>0)return P.subarray(0,R)}}function A(r,s,c){r>=c&&r<c+s.length&&T(s[r-c])}function T(r){r!==o.NUL&&(P[R++]=r&255,r>>8&&(P[R++]=r>>8&255),r>>16&&(P[R++]=r>>16&255))}var p;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(p||(p={}));var o;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(o||(o={}));var I;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(I||(I={}));const y=new Uint8Array([o.r,o.R,o.s,o.e,o.E,o.f,o.a,o.q,o.Q,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g]),a=new Uint16Array([o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,I.hk,I.ho,I.hl,o.y,o.n,I.nj,I.np,I.nl,o.b,o.m,I.ml,o.l]),S=new Uint16Array([o.r,o.R,I.rt,o.s,I.sw,I.sg,o.e,o.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,o.a,o.q,I.qt,o.t,o.T,o.d,o.w,o.c,o.z,o.x,o.v,o.g]),d=new Uint16Array([o.r,o.R,I.rt,o.s,I.sw,I.sg,o.e,o.E,o.f,I.fr,I.fa,I.fq,I.ft,I.fx,I.fv,I.fg,o.a,o.q,o.Q,I.qt,o.t,o.T,o.d,o.w,o.W,o.c,o.z,o.x,o.v,o.g,o.k,o.o,o.i,o.O,o.j,o.p,o.u,o.P,o.h,I.hk,I.ho,I.hl,o.y,o.n,I.nj,I.np,I.nl,o.b,o.m,I.ml,o.l])}),define(Ne[140],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Om=e.$Nm=e.$Mm=void 0,e.$Km=v,e.rot=R,e.$Pm=T;function v(p,o,I){return Math.min(Math.max(p,o),I)}function R(p,o){return(o+p%o)%o}class P{constructor(){this.a=0}getNext(){return this.a++}}e.$Mm=P;class O{constructor(){this.a=1,this.b=0}update(o){return this.b=this.b+(o-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Nm=O;class A{constructor(o){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(o),this.c.fill(0,0,o)}update(o){const I=this.c[this.d];return this.c[this.d]=o,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=o,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Om=A;function T(p,o,I,y,a,S,d,r){const s=d-I,c=r-y,l=a-I,i=S-y,n=p-I,t=o-y,g=s*s+c*c,u=s*l+c*i,$=s*n+c*t,m=l*l+i*i,h=l*n+i*t,E=1/(g*m-u*u),D=(m*$-u*h)*E,w=(g*h-u*$)*E;return D>=0&&w>=0&&D+w<1}}),define(Ne[141],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=O,e.$cd=a;class v{constructor(d,r,s){this.owner=d,this.debugNameSource=r,this.referenceFn=s}getDebugName(d){return O(d,this)}}e.$ad=v;const R=new Map,P=new WeakMap;function O(S,d){const r=P.get(S);if(r)return r;const s=A(S,d);if(s){let c=R.get(s)??0;c++,R.set(s,c);const l=c===1?s:`${s}#${c}`;return P.set(S,l),l}}function A(S,d){const r=P.get(S);if(r)return r;const s=d.owner?I(d.owner)+".":"";let c;const l=d.debugNameSource;if(l!==void 0)if(typeof l=="function"){if(c=l(),c!==void 0)return s+c}else return s+l;const i=d.referenceFn;if(i!==void 0&&(c=a(i),c!==void 0))return s+c;if(d.owner!==void 0){const n=T(d.owner,S);if(n!==void 0)return s+n}}function T(S,d){for(const r in S)if(S[r]===d)return r}const p=new Map,o=new WeakMap;function I(S){const d=o.get(S);if(d)return d;const r=y(S);let s=p.get(r)??0;s++,p.set(r,s);const c=s===1?r:`${r}#${s}`;return o.set(S,c),c}function y(S){const d=S.constructor;return d?d.name:"Object"}function a(S){const d=S.toString(),s=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(d);return(s?s[1]:void 0)?.trim()}}),define(Ne[142],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Md=void 0,e.$Kd=R,e.$Ld=P;let v;function R(r){v=r}function P(){return v}class O{constructor(){this.a=0,this.d=new WeakMap}b(s){return A([T(S("|  ",this.a)),s])}c(s){return s.hadValue?s.didChange?[T(" "),o(I(s.oldValue,70),{color:"red",strikeThrough:!0}),T(" "),o(I(s.newValue,60),{color:"green"})]:[T(" (unchanged)")]:[T(" "),o(I(s.newValue,60),{color:"green"}),T(" (initial)")]}handleObservableChanged(s,c){console.log(...this.b([p("observable value changed"),o(s.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(s){if(s.size!==0)return o(" (changed deps: "+[...s].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(s){const c=s.handleChange;this.d.set(s,new Set),s.handleChange=(l,i)=>(this.d.get(s).add(l),c.apply(s,[l,i]))}handleDerivedRecomputed(s,c){const l=this.d.get(s);console.log(...this.b([p("derived recomputed"),o(s.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(l),{data:[{fn:s._debugNameData.referenceFn??s._computeFn}]}])),l.clear()}handleFromEventObservableTriggered(s,c){console.log(...this.b([p("observable from event triggered"),o(s.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:s._getValue}]}]))}handleAutorunCreated(s){const c=s.handleChange;this.d.set(s,new Set),s.handleChange=(l,i)=>(this.d.get(s).add(l),c.apply(s,[l,i]))}handleAutorunTriggered(s){const c=this.d.get(s);console.log(...this.b([p("autorun"),o(s.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:s._debugNameData.referenceFn??s._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(s){this.a--}handleBeginTransaction(s){let c=s.getDebugName();c===void 0&&(c=""),console.log(...this.b([p("transaction"),o(c,{color:"BlueViolet"}),{data:[{fn:s._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Md=O;function A(r){const s=new Array,c=[];let l="";function i(t){if("length"in t)for(const g of t)g&&i(g);else"text"in t?(l+=`%c${t.text}`,s.push(t.style),t.data&&c.push(...t.data)):"data"in t&&c.push(...t.data)}i(r);const n=[l,...s];return n.push(...c),n}function T(r){return o(r,{color:"black"})}function p(r){return o(d(`${r}: `,10),{color:"black",bold:!0})}function o(r,s={color:"black"}){function c(i){return Object.entries(i).reduce((n,[t,g])=>`${n}${t}:${g};`,"")}const l={color:s.color};return s.strikeThrough&&(l["text-decoration"]="line-through"),s.bold&&(l["font-weight"]="bold"),{text:r,style:c(l)}}function I(r,s){switch(typeof r){case"number":return""+r;case"string":return r.length+2<=s?`"${r}"`:`"${r.substr(0,s-7)}"+...`;case"boolean":return r?"true":"false";case"undefined":return"undefined";case"object":return r===null?"null":Array.isArray(r)?y(r,s):a(r,s);case"symbol":return r.toString();case"function":return`[[Function${r.name?" "+r.name:""}]]`;default:return""+r}}function y(r,s){let c="[ ",l=!0;for(const i of r){if(l||(c+=", "),c.length-5>s){c+="...";break}l=!1,c+=`${I(i,s-c.length)}`}return c+=" ]",c}function a(r,s){let c="{ ",l=!0;for(const[i,n]of Object.entries(r)){if(l||(c+=", "),c.length-5>s){c+="...";break}l=!1,c+=`${i}: ${I(n,s-c.length)}`}return c+=" }",c}function S(r,s){let c="";for(let l=1;l<=s;l++)c+=r;return c}function d(r,s){for(;r.length<s;)r+=" ";return r}}),define(Ne[143],Le([1,0,135,141,142]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9d=e.$7d=e.$5d=e.$Zd=e.$Yd=void 0,e.$Vd=A,e.$Wd=p,e.$Xd=I,e.$1d=S,e.$2d=r,e.$3d=s,e.$4d=c,e.$6d=i,e.$8d=t;let O;function A(u){O=u}let T;function p(u){T=u}let o;function I(u){o=u}class y{get TChange(){return null}reportChanges(){this.get()}read($){return $?$.readObservable(this):this.get()}map($,m){const h=m===void 0?void 0:$,E=m===void 0?$:m;return o({owner:h,debugName:()=>{const D=(0,R.$cd)(E);if(D!==void 0)return D;const C=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(E.toString());if(C)return`${this.debugName}.${C[2]}`;if(!h)return`${this.debugName} (mapped)`},debugReferenceFn:E},D=>E(this.read(D),D))}flatten(){return o({owner:void 0,debugName:()=>`${this.debugName} (flattened)`},$=>this.read($).read($))}recomputeInitiallyAndOnChange($,m){return $.add(O(this,m)),this}keepObserved($){return $.add(T(this)),this}get a(){return this.get()}}e.$Yd=y;class a extends y{constructor(){super(...arguments),this.b=new Set}addObserver($){const m=this.b.size;this.b.add($),m===0&&this.c()}removeObserver($){this.b.delete($)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Zd=a;function S(u,$){const m=new l(u,$);try{u(m)}finally{m.finish()}}let d;function r(u){if(d)u(d);else{const $=new l(u,void 0);d=$;try{u($)}finally{$.finish(),d=void 0}}}async function s(u,$){const m=new l(u,$);try{await u(m)}finally{m.finish()}}function c(u,$,m){u?$(u):S($,m)}class l{constructor($,m){this._fn=$,this.b=m,this.a=[],(0,P.$Ld)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,R.$cd)(this._fn)}updateObserver($,m){this.a.push({observer:$,observable:m}),$.beginUpdate(m)}finish(){const $=this.a;for(let m=0;m<$.length;m++){const{observer:h,observable:E}=$[m];h.endUpdate(E)}this.a=null,(0,P.$Ld)()?.handleEndTransaction()}}e.$5d=l;function i(u,$){let m;return typeof u=="string"?m=new R.$ad(void 0,u,void 0):m=new R.$ad(u,void 0,void 0),new n(m,$,v.$6c)}class n extends a{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor($,m,h){super(),this.e=$,this.g=h,this.d=m}get(){return this.d}set($,m,h){if(h===void 0&&this.g(this.d,$))return;let E;m||(m=E=new l(()=>{},()=>`Setting ${this.debugName}`));try{const D=this.d;this.h($),(0,P.$Ld)()?.handleObservableChanged(this,{oldValue:D,newValue:$,change:h,didChange:!0,hadValue:!0});for(const w of this.b)m.updateObserver(w,this),w.handleChange(this,h)}finally{E&&E.finish()}}toString(){return`${this.debugName}: ${this.d}`}h($){this.d=$}}e.$7d=n;function t(u,$){let m;return typeof u=="string"?m=new R.$ad(void 0,u,void 0):m=new R.$ad(u,void 0,void 0),new g(m,$,v.$6c)}class g extends n{h($){this.d!==$&&(this.d&&this.d.dispose(),this.d=$)}dispose(){this.d?.dispose()}}e.$9d=g}),function(){function ve(P){const O=[];typeof P=="number"&&O.push("code/timeOrigin",P);function A(p){O.push(p,Date.now())}function T(){const p=[];for(let o=0;o<O.length;o+=2)p.push({name:O[o],startTime:O[o+1]});return p}return{mark:A,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ve():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(P+A.startTime)});return O}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ve(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),ve()}function v(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))}(),define(Ne[144],Le([1,0,40]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5I=void 0;const R=Symbol("unset");class P{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||v.Iterable.empty()}get entries(){return this.a.children?.entries()||v.Iterable.empty()}insert(p,o,I){this.d(p,y=>y._value=o,I)}mutate(p,o){this.d(p,I=>I._value=o(I._value===R?void 0:I._value))}mutatePath(p,o){this.d(p,()=>{},I=>o(I))}delete(p){const o=this.c(p);if(!o)return;let I=o.length-1;const y=o[I].node._value;if(y!==R){for(this.b--,o[I].node._value=R;I>0;I--){const{node:a,part:S}=o[I];if(a.children?.size||a._value!==R)break;o[I-1].node.children.delete(S)}return y}}*deleteRecursive(p){const o=this.c(p);if(!o)return;const I=o[o.length-1].node;for(let y=o.length-1;y>0;y--){const a=o[y-1];if(a.node.children.delete(o[y].part),a.node.children.size>0||a.node._value!==R)break}for(const y of O(I))y._value!==R&&(this.b--,yield y._value)}find(p){let o=this.a;for(const I of p){const y=o.children?.get(I);if(!y)return;o=y}return o._value===R?void 0:o._value}hasKeyOrParent(p){let o=this.a;for(const I of p){const y=o.children?.get(I);if(!y)return!1;if(y._value!==R)return!0;o=y}return!1}hasKeyOrChildren(p){let o=this.a;for(const I of p){const y=o.children?.get(I);if(!y)return!1;o=y}return!0}hasKey(p){let o=this.a;for(const I of p){const y=o.children?.get(I);if(!y)return!1;o=y}return o._value!==R}c(p){const o=[{part:"",node:this.a}];let I=0;for(const y of p){const a=o[I].node.children?.get(y);if(!a)return;o.push({part:y,node:a}),I++}return o}d(p,o,I){let y=this.a;for(const d of p){if(y.children)if(y.children.has(d))y=y.children.get(d);else{const r=new A;y.children.set(d,r),y=r}else{const r=new A;y.children=new Map([[d,r]]),y=r}I?.(y)}const a=y._value===R?0:1;o(y);const S=y._value===R?0:1;this.b+=S-a}*values(){for(const{_value:p}of O(this.a))p!==R&&(yield p)}}e.$5I=P;function*O(T){const p=[T];for(;p.length>0;){const o=p.pop();if(yield o,o.children)for(const I of o.children.values())p.push(I)}}class A{constructor(){this._value=R}get value(){return this._value===R?void 0:this._value}set value(p){this._value=p===void 0?R:p}}}),define(Ne[145],Le([1,0,48,19]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=T,e.$Ar=p,e.$Br=o,e.$Cr=I,e.$Dr=y,e.$Er=a,e.$Fr=S,e.$Gr=d,e.$Hr=r,e.$Ir=s,e.$Jr=h,e.$Kr=E,e.$Lr=D;const P=new v.$T(()=>{const w=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:w,collatorIsNumeric:w.resolvedOptions().numeric}}),O=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new v.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(w,C,k=!1){const f=w||"",b=C||"",M=P.value.collator.compare(f,b);return P.value.collatorIsNumeric&&M===0&&f!==b?f<b?-1:1:M}function p(w,C){const k=O.value.collator;return w=w||"",C=C||"",n(k,w,C)}function o(w,C){const k=O.value.collator;return w=w||"",C=C||"",$(w,C)||n(k,w,C)}function I(w,C){const k=O.value.collator;return w=w||"",C=C||"",u(w,C)||n(k,w,C)}function y(w,C){return w=w||"",C=C||"",w===C?0:w<C?-1:1}function a(w,C){const[k,f]=l(w),[b,M]=l(C);let N=P.value.collator.compare(f,M);if(N===0){if(P.value.collatorIsNumeric&&f!==M)return f<M?-1:1;if(N=P.value.collator.compare(k,b),P.value.collatorIsNumeric&&N===0&&k!==b)return k<b?-1:1}return N}function S(w,C){w=w||"",C=C||"";const k=i(w),f=i(C),b=O.value.collator,M=A.value.collator;return n(M,k,f)||n(b,w,C)}function d(w,C){w=w||"",C=C||"";const k=i(w),f=i(C),b=O.value.collator,M=A.value.collator;return n(M,k,f)||$(w,C)||n(b,w,C)}function r(w,C){w=w||"",C=C||"";const k=i(w),f=i(C),b=O.value.collator,M=A.value.collator;return n(M,k,f)||u(w,C)||n(b,w,C)}function s(w,C){w=w||"",C=C||"";const k=i(w).toLowerCase(),f=i(C).toLowerCase();return k!==f?k<f?-1:1:w!==C?w<C?-1:1:0}const c=/^(.*?)(\.([^.]*))?$/;function l(w,C=!1){const k=w?c.exec(w):[];let f=[k&&k[1]||"",k&&k[3]||""];return C&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function i(w){const C=w?c.exec(w):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function n(w,C,k){const f=w.compare(C,k);return f!==0?f:C.length!==k.length?C.length<k.length?-1:1:0}function t(w){const C=w.charAt(0);return C.toLocaleUpperCase()!==C}function g(w){const C=w.charAt(0);return C.toLocaleLowerCase()!==C}function u(w,C){return t(w)&&g(C)?-1:g(w)&&t(C)?1:0}function $(w,C){return g(w)&&t(C)?-1:t(w)&&g(C)?1:0}function m(w,C,k=!1){return k||(w=w&&w.toLowerCase(),C=C&&C.toLowerCase()),w===C?0:w<C?-1:1}function h(w,C,k=!1){const f=w.split(R.sep),b=C.split(R.sep),M=f.length-1,N=b.length-1;let L,W;for(let K=0;;K++){if(L=M===K,W=N===K,L&&W)return T(f[K],b[K],k);if(L)return-1;if(W)return 1;const q=m(f[K],b[K],k);if(q!==0)return q}}function E(w,C,k){const f=w.toLowerCase(),b=C.toLowerCase(),M=D(w,C,k);if(M)return M;const N=f.endsWith(k),L=b.endsWith(k);if(N!==L)return N?-1:1;const W=T(f,b);return W!==0?W:f.localeCompare(b)}function D(w,C,k){const f=w.toLowerCase(),b=C.toLowerCase(),M=f.startsWith(k),N=b.startsWith(k);if(M!==N)return M?-1:1;if(M&&N){if(f.length<b.length)return-1;if(f.length>b.length)return 1}return 0}}),define(Ne[72],Le([1,0,19]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0s=void 0,e.$$s=O,e.$_s=A,e.$at=T,e.$bt=o,e.$0s=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(I){const y=(0,v.$oc)(I),a=R[y.toLowerCase()];return a!==void 0?a:A(I)}function A(I){const y=(0,v.$oc)(I);return P[y.toLowerCase()]}function T(I){for(const y in P)if(P[y]===I)return y}const p=/^(.+)\/(.+?)(;.+)?$/;function o(I,y){const a=p.exec(I);return a?`${a[1].toLowerCase()}/${a[2].toLowerCase()}${a[3]??""}`:y?void 0:I}}),function(ve,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var R in v)(typeof exports=="object"?exports:ve)[R]=v[R]}}(typeof self<"u"?self:this,function(){return function(ve){var e={};function v(R){if(e[R])return e[R].exports;var P=e[R]={i:R,l:!1,exports:{}};return ve[R].call(P.exports,P,P.exports,v),P.l=!0,P.exports}return v.m=ve,v.c=e,v.d=function(R,P,O){v.o(R,P)||Object.defineProperty(R,P,{enumerable:!0,get:O})},v.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},v.t=function(R,P){if(1&P&&(R=v(R)),8&P||4&P&&typeof R=="object"&&R&&R.__esModule)return R;var O=Object.create(null);if(v.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:R}),2&P&&typeof R!="string")for(var A in R)v.d(O,A,function(T){return R[T]}.bind(null,A));return O},v.n=function(R){var P=R&&R.__esModule?function(){return R.default}:function(){return R};return v.d(P,"a",P),P},v.o=function(R,P){return Object.prototype.hasOwnProperty.call(R,P)},v.p="",v(v.s=0)}([function(ve,e,v){(function(R){var P;e=ve.exports=ke,P=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],p=e.src=[],o=0,I=o++;p[I]="0|[1-9]\\d*";var y=o++;p[y]="[0-9]+";var a=o++;p[a]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=o++;p[S]="("+p[I]+")\\.("+p[I]+")\\.("+p[I]+")";var d=o++;p[d]="("+p[y]+")\\.("+p[y]+")\\.("+p[y]+")";var r=o++;p[r]="(?:"+p[I]+"|"+p[a]+")";var s=o++;p[s]="(?:"+p[y]+"|"+p[a]+")";var c=o++;p[c]="(?:-("+p[r]+"(?:\\."+p[r]+")*))";var l=o++;p[l]="(?:-?("+p[s]+"(?:\\."+p[s]+")*))";var i=o++;p[i]="[0-9A-Za-z-]+";var n=o++;p[n]="(?:\\+("+p[i]+"(?:\\."+p[i]+")*))";var t=o++,g="v?"+p[S]+p[c]+"?"+p[n]+"?";p[t]="^"+g+"$";var u="[v=\\s]*"+p[d]+p[l]+"?"+p[n]+"?",$=o++;p[$]="^"+u+"$";var m=o++;p[m]="((?:<|>)?=?)";var h=o++;p[h]=p[y]+"|x|X|\\*";var E=o++;p[E]=p[I]+"|x|X|\\*";var D=o++;p[D]="[v=\\s]*("+p[E]+")(?:\\.("+p[E]+")(?:\\.("+p[E]+")(?:"+p[c]+")?"+p[n]+"?)?)?";var w=o++;p[w]="[v=\\s]*("+p[h]+")(?:\\.("+p[h]+")(?:\\.("+p[h]+")(?:"+p[l]+")?"+p[n]+"?)?)?";var C=o++;p[C]="^"+p[m]+"\\s*"+p[D]+"$";var k=o++;p[k]="^"+p[m]+"\\s*"+p[w]+"$";var f=o++;p[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var b=o++;p[b]="(?:~>?)";var M=o++;p[M]="(\\s*)"+p[b]+"\\s+",T[M]=new RegExp(p[M],"g");var N=o++;p[N]="^"+p[b]+p[D]+"$";var L=o++;p[L]="^"+p[b]+p[w]+"$";var W=o++;p[W]="(?:\\^)";var K=o++;p[K]="(\\s*)"+p[W]+"\\s+",T[K]=new RegExp(p[K],"g");var q=o++;p[q]="^"+p[W]+p[D]+"$";var G=o++;p[G]="^"+p[W]+p[w]+"$";var Q=o++;p[Q]="^"+p[m]+"\\s*("+u+")$|^$";var ae=o++;p[ae]="^"+p[m]+"\\s*("+g+")$|^$";var we=o++;p[we]="(\\s*)"+p[m]+"\\s*("+u+"|"+p[D]+")",T[we]=new RegExp(p[we],"g");var le=o++;p[le]="^\\s*("+p[D]+")\\s+-\\s+("+p[D]+")\\s*$";var _=o++;p[_]="^\\s*("+p[w]+")\\s+-\\s+("+p[w]+")\\s*$";var ce=o++;p[ce]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)P(me,p[me]),T[me]||(T[me]=new RegExp(p[me]));function oe(j,H){if(j instanceof ke)return j;if(typeof j!="string"||j.length>O||!(H?T[$]:T[t]).test(j))return null;try{return new ke(j,H)}catch{return null}}function ke(j,H){if(j instanceof ke){if(j.loose===H)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof ke))return new ke(j,H);P("SemVer",j,H),this.loose=H;var V=j.trim().match(H?T[$]:T[t]);if(!V)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+V[1],this.minor=+V[2],this.patch=+V[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");V[4]?this.prerelease=V[4].split(".").map(function(re){if(/^[0-9]+$/.test(re)){var ge=+re;if(ge>=0&&ge<A)return ge}return re}):this.prerelease=[],this.build=V[5]?V[5].split("."):[],this.format()}e.parse=oe,e.valid=function(j,H){var V=oe(j,H);return V?V.version:null},e.clean=function(j,H){var V=oe(j.trim().replace(/^[=v]+/,""),H);return V?V.version:null},e.SemVer=ke,ke.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ke.prototype.toString=function(){return this.version},ke.prototype.compare=function(j){return P("SemVer.compare",this.version,this.loose,j),j instanceof ke||(j=new ke(j,this.loose)),this.compareMain(j)||this.comparePre(j)},ke.prototype.compareMain=function(j){return j instanceof ke||(j=new ke(j,this.loose)),Z(this.major,j.major)||Z(this.minor,j.minor)||Z(this.patch,j.patch)},ke.prototype.comparePre=function(j){if(j instanceof ke||(j=new ke(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var H=0;do{var V=this.prerelease[H],re=j.prerelease[H];if(P("prerelease compare",H,V,re),V===void 0&&re===void 0)return 0;if(re===void 0)return 1;if(V===void 0)return-1;if(V!==re)return Z(V,re)}while(++H)},ke.prototype.inc=function(j,H){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var V=this.prerelease.length;--V>=0;)typeof this.prerelease[V]=="number"&&(this.prerelease[V]++,V=-2);V===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,H,V,re){typeof V=="string"&&(re=V,V=void 0);try{return new ke(j,V).inc(H,re).version}catch{return null}},e.diff=function(j,H){if(fe(j,H))return null;var V=oe(j),re=oe(H);if(V.prerelease.length||re.prerelease.length){for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return"pre"+ge;return"prerelease"}for(var ge in V)if((ge==="major"||ge==="minor"||ge==="patch")&&V[ge]!==re[ge])return ge},e.compareIdentifiers=Z;var Te=/^[0-9]+$/;function Z(j,H){var V=Te.test(j),re=Te.test(H);return V&&re&&(j=+j,H=+H),V&&!re?-1:re&&!V?1:j<H?-1:j>H?1:0}function B(j,H,V){return new ke(j,V).compare(new ke(H,V))}function ne(j,H,V){return B(j,H,V)>0}function Ee(j,H,V){return B(j,H,V)<0}function fe(j,H,V){return B(j,H,V)===0}function be(j,H,V){return B(j,H,V)!==0}function he(j,H,V){return B(j,H,V)>=0}function X(j,H,V){return B(j,H,V)<=0}function x(j,H,V,re){var ge;switch(H){case"===":typeof j=="object"&&(j=j.version),typeof V=="object"&&(V=V.version),ge=j===V;break;case"!==":typeof j=="object"&&(j=j.version),typeof V=="object"&&(V=V.version),ge=j!==V;break;case"":case"=":case"==":ge=fe(j,V,re);break;case"!=":ge=be(j,V,re);break;case">":ge=ne(j,V,re);break;case">=":ge=he(j,V,re);break;case"<":ge=Ee(j,V,re);break;case"<=":ge=X(j,V,re);break;default:throw new TypeError("Invalid operator: "+H)}return ge}function $e(j,H){if(j instanceof $e){if(j.loose===H)return j;j=j.value}if(!(this instanceof $e))return new $e(j,H);P("comparator",j,H),this.loose=H,this.parse(j),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(j,H){return Z(H,j)},e.major=function(j,H){return new ke(j,H).major},e.minor=function(j,H){return new ke(j,H).minor},e.patch=function(j,H){return new ke(j,H).patch},e.compare=B,e.compareLoose=function(j,H){return B(j,H,!0)},e.rcompare=function(j,H,V){return B(H,j,V)},e.sort=function(j,H){return j.sort(function(V,re){return e.compare(V,re,H)})},e.rsort=function(j,H){return j.sort(function(V,re){return e.rcompare(V,re,H)})},e.gt=ne,e.lt=Ee,e.eq=fe,e.neq=be,e.gte=he,e.lte=X,e.cmp=x,e.Comparator=$e;var pe={};function Ae(j,H){if(j instanceof Ae)return j.loose===H?j:new Ae(j.raw,H);if(j instanceof $e)return new Ae(j.value,H);if(!(this instanceof Ae))return new Ae(j,H);if(this.loose=H,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(V){return this.parseRange(V.trim())},this).filter(function(V){return V.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function Ue(j){return!j||j.toLowerCase()==="x"||j==="*"}function Ie(j,H,V,re,ge,Ce,ze,Qe,_e,tt,nt,et,rt){return((H=Ue(V)?"":Ue(re)?">="+V+".0.0":Ue(ge)?">="+V+"."+re+".0":">="+H)+" "+(Qe=Ue(_e)?"":Ue(tt)?"<"+(+_e+1)+".0.0":Ue(nt)?"<"+_e+"."+(+tt+1)+".0":et?"<="+_e+"."+tt+"."+nt+"-"+et:"<="+Qe)).trim()}function Pe(j,H){for(var V=0;V<j.length;V++)if(!j[V].test(H))return!1;if(H.prerelease.length){for(V=0;V<j.length;V++)if(P(j[V].semver),j[V].semver!==pe&&j[V].semver.prerelease.length>0){var re=j[V].semver;if(re.major===H.major&&re.minor===H.minor&&re.patch===H.patch)return!0}return!1}return!0}function Oe(j,H,V){try{H=new Ae(H,V)}catch{return!1}return H.test(j)}function z(j,H,V,re){var ge,Ce,ze,Qe,_e;switch(j=new ke(j,re),H=new Ae(H,re),V){case">":ge=ne,Ce=X,ze=Ee,Qe=">",_e=">=";break;case"<":ge=Ee,Ce=he,ze=ne,Qe="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(j,H,re))return!1;for(var tt=0;tt<H.set.length;++tt){var nt=H.set[tt],et=null,rt=null;if(nt.forEach(function(ft){ft.semver===pe&&(ft=new $e(">=0.0.0")),et=et||ft,rt=rt||ft,ge(ft.semver,et.semver,re)?et=ft:ze(ft.semver,rt.semver,re)&&(rt=ft)}),et.operator===Qe||et.operator===_e||(!rt.operator||rt.operator===Qe)&&Ce(j,rt.semver)||rt.operator===_e&&ze(j,rt.semver))return!1}return!0}$e.prototype.parse=function(j){var H=this.loose?T[Q]:T[ae],V=j.match(H);if(!V)throw new TypeError("Invalid comparator: "+j);this.operator=V[1],this.operator==="="&&(this.operator=""),V[2]?this.semver=new ke(V[2],this.loose):this.semver=pe},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(j){return P("Comparator.test",j,this.loose),this.semver===pe||(typeof j=="string"&&(j=new ke(j,this.loose)),x(j,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(j,H){if(!(j instanceof $e))throw new TypeError("a Comparator is required");var V;if(this.operator==="")return V=new Ae(j.value,H),Oe(this.value,V,H);if(j.operator==="")return V=new Ae(this.value,H),Oe(j.semver,V,H);var re=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),ge=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Ce=this.semver.version===j.semver.version,ze=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Qe=x(this.semver,"<",j.semver,H)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=x(this.semver,">",j.semver,H)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return re||ge||Ce&&ze||Qe||_e},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(j){var H=this.loose;j=j.trim(),P("range",j,H);var V=H?T[_]:T[le];j=j.replace(V,Ie),P("hyphen replace",j),j=j.replace(T[we],"$1$2$3"),P("comparator trim",j,T[we]),j=(j=(j=j.replace(T[M],"$1~")).replace(T[K],"$1^")).split(/\s+/).join(" ");var re=H?T[Q]:T[ae],ge=j.split(" ").map(function(Ce){return function(ze,Qe){return P("comp",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){P("caret",et,rt);var ft=rt?T[G]:T[q];return et.replace(ft,function(lt,st,ct,mt,$t){var qe;return P("caret",et,lt,st,ct,mt,$t),Ue(st)?qe="":Ue(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(mt)?qe=st==="0"?">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+".0 <"+(+st+1)+".0.0":$t?(P("replaceCaret pr",$t),$t.charAt(0)!=="-"&&($t="-"+$t),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+mt+$t+" <"+st+"."+ct+"."+(+mt+1):">="+st+"."+ct+"."+mt+$t+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+mt+$t+" <"+(+st+1)+".0.0"):(P("no pr"),qe=st==="0"?ct==="0"?">="+st+"."+ct+"."+mt+" <"+st+"."+ct+"."+(+mt+1):">="+st+"."+ct+"."+mt+" <"+st+"."+(+ct+1)+".0":">="+st+"."+ct+"."+mt+" <"+(+st+1)+".0.0"),P("caret return",qe),qe})}(nt,tt)}).join(" ")}(ze,Qe),P("caret",ze),ze=function(_e,tt){return _e.trim().split(/\s+/).map(function(nt){return function(et,rt){var ft=rt?T[L]:T[N];return et.replace(ft,function(lt,st,ct,mt,$t){var qe;return P("tilde",et,lt,st,ct,mt,$t),Ue(st)?qe="":Ue(ct)?qe=">="+st+".0.0 <"+(+st+1)+".0.0":Ue(mt)?qe=">="+st+"."+ct+".0 <"+st+"."+(+ct+1)+".0":$t?(P("replaceTilde pr",$t),$t.charAt(0)!=="-"&&($t="-"+$t),qe=">="+st+"."+ct+"."+mt+$t+" <"+st+"."+(+ct+1)+".0"):qe=">="+st+"."+ct+"."+mt+" <"+st+"."+(+ct+1)+".0",P("tilde return",qe),qe})}(nt,tt)}).join(" ")}(ze,Qe),P("tildes",ze),ze=function(_e,tt){return P("replaceXRanges",_e,tt),_e.split(/\s+/).map(function(nt){return function(et,rt){et=et.trim();var ft=rt?T[k]:T[C];return et.replace(ft,function(lt,st,ct,mt,$t,qe){P("xRange",et,lt,st,ct,mt,$t,qe);var je=Ue(ct),ie=je||Ue(mt),ee=ie||Ue($t);return st==="="&&ee&&(st=""),je?lt=st===">"||st==="<"?"<0.0.0":"*":st&&ee?(ie&&(mt=0),ee&&($t=0),st===">"?(st=">=",ie?(ct=+ct+1,mt=0,$t=0):ee&&(mt=+mt+1,$t=0)):st==="<="&&(st="<",ie?ct=+ct+1:mt=+mt+1),lt=st+ct+"."+mt+"."+$t):ie?lt=">="+ct+".0.0 <"+(+ct+1)+".0.0":ee&&(lt=">="+ct+"."+mt+".0 <"+ct+"."+(+mt+1)+".0"),P("xRange return",lt),lt})}(nt,tt)}).join(" ")}(ze,Qe),P("xrange",ze),ze=function(_e,tt){return P("replaceStars",_e,tt),_e.trim().replace(T[ce],"")}(ze,Qe),P("stars",ze),ze}(Ce,H)}).join(" ").split(/\s+/);return this.loose&&(ge=ge.filter(function(Ce){return!!Ce.match(re)})),ge=ge.map(function(Ce){return new $e(Ce,H)})},Ae.prototype.intersects=function(j,H){if(!(j instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(V){return V.every(function(re){return j.set.some(function(ge){return ge.every(function(Ce){return re.intersects(Ce,H)})})})})},e.toComparators=function(j,H){return new Ae(j,H).set.map(function(V){return V.map(function(re){return re.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new ke(j,this.loose));for(var H=0;H<this.set.length;H++)if(Pe(this.set[H],j))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(j,H,V){var re=null,ge=null;try{var Ce=new Ae(H,V)}catch{return null}return j.forEach(function(ze){Ce.test(ze)&&(re&&ge.compare(ze)!==-1||(ge=new ke(re=ze,V)))}),re},e.minSatisfying=function(j,H,V){var re=null,ge=null;try{var Ce=new Ae(H,V)}catch{return null}return j.forEach(function(ze){Ce.test(ze)&&(re&&ge.compare(ze)!==1||(ge=new ke(re=ze,V)))}),re},e.validRange=function(j,H){try{return new Ae(j,H).range||"*"}catch{return null}},e.ltr=function(j,H,V){return z(j,H,"<",V)},e.gtr=function(j,H,V){return z(j,H,">",V)},e.outside=z,e.prerelease=function(j,H){var V=oe(j,H);return V&&V.prerelease.length?V.prerelease:null},e.intersects=function(j,H,V){return j=new Ae(j,V),H=new Ae(H,V),j.intersects(H)},e.coerce=function(j){if(j instanceof ke)return j;if(typeof j!="string")return null;var H=j.match(T[f]);return H==null?null:oe((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,v(1))},function(ve,e){var v,R,P=ve.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function T(s){if(v===setTimeout)return setTimeout(s,0);if((v===O||!v)&&setTimeout)return v=setTimeout,setTimeout(s,0);try{return v(s,0)}catch{try{return v.call(null,s,0)}catch{return v.call(this,s,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:O}catch{v=O}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var p,o=[],I=!1,y=-1;function a(){I&&p&&(I=!1,p.length?o=p.concat(o):y=-1,o.length&&S())}function S(){if(!I){var s=T(a);I=!0;for(var c=o.length;c;){for(p=o,o=[];++y<c;)p&&p[y].run();y=-1,c=o.length}p=null,I=!1,function(l){if(R===clearTimeout)return clearTimeout(l);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(l);try{R(l)}catch{try{return R.call(null,l)}catch{return R.call(this,l)}}}(s)}}function d(s,c){this.fun=s,this.array=c}function r(){}P.nextTick=function(s){var c=new Array(arguments.length-1);if(arguments.length>1)for(var l=1;l<arguments.length;l++)c[l-1]=arguments[l];o.push(new d(s,c)),o.length!==1||I||T(S)},d.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=r,P.addListener=r,P.once=r,P.off=r,P.removeListener=r,P.removeAllListeners=r,P.emit=r,P.prependListener=r,P.prependOnceListener=r,P.listeners=function(s){return[]},P.binding=function(s){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(s){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Ne[146],Le([1,0,6,4]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ft=e.$et=e.$dt=e.$ct=e.ScrollbarVisibility=void 0;var P;(function(S){S[S.Auto=1]="Auto",S[S.Hidden=2]="Hidden",S[S.Visible=3]="Visible"})(P||(e.ScrollbarVisibility=P={}));class O{constructor(d,r,s,c,l,i,n){this.c=d,this._scrollStateBrand=void 0,this.c&&(r=r|0,s=s|0,c=c|0,l=l|0,i=i|0,n=n|0),this.rawScrollLeft=c,this.rawScrollTop=n,r<0&&(r=0),c+r>s&&(c=s-r),c<0&&(c=0),l<0&&(l=0),n+l>i&&(n=i-l),n<0&&(n=0),this.width=r,this.scrollWidth=s,this.scrollLeft=c,this.height=l,this.scrollHeight=i,this.scrollTop=n}equals(d){return this.rawScrollLeft===d.rawScrollLeft&&this.rawScrollTop===d.rawScrollTop&&this.width===d.width&&this.scrollWidth===d.scrollWidth&&this.scrollLeft===d.scrollLeft&&this.height===d.height&&this.scrollHeight===d.scrollHeight&&this.scrollTop===d.scrollTop}withScrollDimensions(d,r){return new O(this.c,typeof d.width<"u"?d.width:this.width,typeof d.scrollWidth<"u"?d.scrollWidth:this.scrollWidth,r?this.rawScrollLeft:this.scrollLeft,typeof d.height<"u"?d.height:this.height,typeof d.scrollHeight<"u"?d.scrollHeight:this.scrollHeight,r?this.rawScrollTop:this.scrollTop)}withScrollPosition(d){return new O(this.c,this.width,this.scrollWidth,typeof d.scrollLeft<"u"?d.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof d.scrollTop<"u"?d.scrollTop:this.rawScrollTop)}createScrollEvent(d,r){const s=this.width!==d.width,c=this.scrollWidth!==d.scrollWidth,l=this.scrollLeft!==d.scrollLeft,i=this.height!==d.height,n=this.scrollHeight!==d.scrollHeight,t=this.scrollTop!==d.scrollTop;return{inSmoothScrolling:r,oldWidth:d.width,oldScrollWidth:d.scrollWidth,oldScrollLeft:d.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:d.height,oldScrollHeight:d.scrollHeight,oldScrollTop:d.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:s,scrollWidthChanged:c,scrollLeftChanged:l,heightChanged:i,scrollHeightChanged:n,scrollTopChanged:t}}}e.$ct=O;class A extends R.$Uc{constructor(d){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$le),this.onScroll=this.j.event,this.c=d.smoothScrollDuration,this.f=d.scheduleAtNextAnimationFrame,this.g=new O(d.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(d){this.c=d}validateScrollPosition(d){return this.g.withScrollPosition(d)}getScrollDimensions(){return this.g}setScrollDimensions(d,r){const s=this.g.withScrollDimensions(d,r);this.n(s,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(d){const r=this.g.withScrollPosition(d);this.h&&(this.h.dispose(),this.h=null),this.n(r,!1)}setScrollPositionSmooth(d,r){if(this.c===0)return this.setScrollPositionNow(d);if(this.h){d={scrollLeft:typeof d.scrollLeft>"u"?this.h.to.scrollLeft:d.scrollLeft,scrollTop:typeof d.scrollTop>"u"?this.h.to.scrollTop:d.scrollTop};const s=this.g.withScrollPosition(d);if(this.h.to.scrollLeft===s.scrollLeft&&this.h.to.scrollTop===s.scrollTop)return;let c;r?c=new I(this.h.from,s,this.h.startTime,this.h.duration):c=this.h.combine(this.g,s,this.c),this.h.dispose(),this.h=c}else{const s=this.g.withScrollPosition(d);this.h=I.start(this.g,s,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const d=this.h.tick(),r=this.g.withScrollPosition(d);if(this.n(r,!0),!!this.h){if(d.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(d,r){const s=this.g;s.equals(d)||(this.g=d,this.j.fire(this.g.createScrollEvent(s,r)))}}e.$dt=A;class T{constructor(d,r,s){this.scrollLeft=d,this.scrollTop=r,this.isDone=s}}e.$et=T;function p(S,d){const r=d-S;return function(s){return S+r*a(s)}}function o(S,d,r){return function(s){return s<r?S(s/r):d((s-r)/(1-r))}}class I{constructor(d,r,s,c){this.from=d,this.to=r,this.duration=c,this.startTime=s,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(d,r,s){if(Math.abs(d-r)>2.5*s){let l,i;return d<r?(l=d+.75*s,i=r-.75*s):(l=d-.75*s,i=r+.75*s),o(p(d,l),p(i,r),.33)}return p(d,r)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(d){this.to=d.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(d){const r=(d-this.startTime)/this.duration;if(r<1){const s=this.c(r),c=this.d(r);return new T(s,c,!1)}return new T(this.to.scrollLeft,this.to.scrollTop,!0)}combine(d,r,s){return I.start(d,r,s)}static start(d,r,s){s=s+10;const c=Date.now()-10;return new I(d,r,c,s)}}e.$ft=I;function y(S){return Math.pow(S,3)}function a(S){return 1-y(1-S)}}),define(Ne[147],Le([1,0,13,4]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ye=P,e.$ze=O,e.$Ae=A,e.$Be=T,e.$Ce=o,e.$De=I,e.$Ee=y,e.$Fe=a,e.$Ge=S,e.$He=d,e.$Ie=r,e.$Je=s,e.$Ke=c,e.$Le=l,e.$Me=i;function P(n){const t=n;return t?typeof t.read=="function":!1}function O(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(g=>typeof g=="function"):!1}function A(n){const t=n;return t?O(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}function T(n,t){return new p(n,t)}class p{constructor(t,g){this.e=t,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(g=>g(t))}h(t){this.c.error.length===0?(0,v.$Y)(t):this.c.error.slice(0).forEach(g=>g(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,g){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(t,g){if(this.a.destroyed)return;let u;switch(t){case"data":u=this.c.data;break;case"end":u=this.c.end;break;case"error":u=this.c.error;break}if(u){const $=u.indexOf(g);$>=0&&u.splice($,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(u=>u())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function o(n,t){const g=[];let u;for(;(u=n.read())!==null;)g.push(u);return t(g)}function I(n,t,g){const u=[];let $;for(;($=n.read())!==null&&u.length<g;)u.push($);return $===null&&u.length>0?t(u):{read:()=>{if(u.length>0)return u.shift();if(typeof $<"u"){const m=$;return $=void 0,m}return n.read()}}}function y(n,t){return new Promise((g,u)=>{const $=[];a(n,{onData:m=>{t&&$.push(m)},onError:m=>{t?u(m):g(void 0)},onEnd:()=>{g(t?t($):void 0)}})})}function a(n,t,g){n.on("error",u=>{g?.isCancellationRequested||t.onError(u)}),n.on("end",()=>{g?.isCancellationRequested||t.onEnd()}),n.on("data",u=>{g?.isCancellationRequested||t.onData(u)})}function S(n,t){return new Promise((g,u)=>{const $=new R.$Tc,m=[],h=w=>{if(m.push(w),m.length>t)return $.dispose(),n.pause(),g({stream:n,buffer:m,ended:!1})},E=w=>($.dispose(),u(w)),D=()=>($.dispose(),g({stream:n,buffer:m,ended:!0}));$.add((0,R.$Sc)(()=>n.removeListener("error",E))),n.on("error",E),$.add((0,R.$Sc)(()=>n.removeListener("end",D))),n.on("end",D),$.add((0,R.$Sc)(()=>n.removeListener("data",h))),n.on("data",h)})}function d(n,t){const g=T(t);return g.end(n),g}function r(){const n=T(()=>{throw new Error("not supported")});return n.end(),n}function s(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}function c(n,t,g){const u=T(g);return a(n,{onData:$=>u.write(t.data($)),onError:$=>u.error(t.error?t.error($):$),onEnd:()=>u.end()}),u}function l(n,t,g){let u=!1;return{read:()=>{const $=t.read();return u?$:(u=!0,$!==null?g([n,$]):n)}}}function i(n,t,g){let u=!1;const $=T(g);return a(t,{onData:m=>u?$.write(m):(u=!0,$.write(g([n,m]))),onError:m=>$.error(m),onEnd:()=>{u||(u=!0,$.write(n)),$.end()}}),$}}),define(Ne[22],Le([1,0,48,147]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ne=void 0,e.$Oe=o,e.$Pe=I,e.$Qe=y,e.$Re=a,e.$Se=S,e.$Te=d,e.$Ue=r,e.$Ve=s,e.$We=c,e.$Xe=l,e.$Ye=i,e.$Ze=n,e.$1e=t,e.$2e=g,e.$3e=u,e.$4e=$,e.$5e=m,e.$6e=h,e.$7e=E,e.$8e=C,R=We(R);const P=typeof Buffer<"u",O=new v.$T(()=>new Uint8Array(256));let A,T;class p{static alloc(f){return P?new p(Buffer.allocUnsafe(f)):new p(new Uint8Array(f))}static wrap(f){return P&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new p(f)}static fromString(f,b){return!(b?.dontUseNodeBuffer||!1)&&P?new p(Buffer.from(f)):(A||(A=new TextEncoder),new p(A.encode(f)))}static fromByteArray(f){const b=p.alloc(f.length);for(let M=0,N=f.length;M<N;M++)b.buffer[M]=f[M];return b}static concat(f,b){if(typeof b>"u"){b=0;for(let L=0,W=f.length;L<W;L++)b+=f[L].byteLength}const M=p.alloc(b);let N=0;for(let L=0,W=f.length;L<W;L++){const K=f[L];M.set(K,N),N+=K.byteLength}return M}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=p.alloc(this.byteLength);return f.set(this),f}toString(){return P?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(f,b){return new p(this.buffer.subarray(f,b))}set(f,b){if(f instanceof p)this.buffer.set(f.buffer,b);else if(f instanceof Uint8Array)this.buffer.set(f,b);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),b);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),b);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return a(this.buffer,f)}writeUInt32BE(f,b){S(this.buffer,f,b)}readUInt32LE(f){return d(this.buffer,f)}writeUInt32LE(f,b){r(this.buffer,f,b)}readUInt8(f){return s(this.buffer,f)}writeUInt8(f,b){c(this.buffer,f,b)}indexOf(f,b=0){return o(this.buffer,f instanceof p?f.buffer:f,b)}}e.$Ne=p;function o(k,f,b=0){const M=f.byteLength,N=k.byteLength;if(M===0)return 0;if(M===1)return k.indexOf(f[0]);if(M>N-b)return-1;const L=O.value;L.fill(f.length);for(let G=0;G<f.length;G++)L[f[G]]=f.length-G-1;let W=b+f.length-1,K=W,q=-1;for(;W<N;)if(k[W]===f[K]){if(K===0){q=W;break}W--,K--}else W+=Math.max(f.length-K,L[k[W]]),K=f.length-1;return q}function I(k,f){return k[f+0]<<0>>>0|k[f+1]<<8>>>0}function y(k,f,b){k[b+0]=f&255,f=f>>>8,k[b+1]=f&255}function a(k,f){return k[f]*2**24+k[f+1]*2**16+k[f+2]*2**8+k[f+3]}function S(k,f,b){k[b+3]=f,f=f>>>8,k[b+2]=f,f=f>>>8,k[b+1]=f,f=f>>>8,k[b]=f}function d(k,f){return k[f+0]<<0>>>0|k[f+1]<<8>>>0|k[f+2]<<16>>>0|k[f+3]<<24>>>0}function r(k,f,b){k[b+0]=f&255,f=f>>>8,k[b+1]=f&255,f=f>>>8,k[b+2]=f&255,f=f>>>8,k[b+3]=f&255}function s(k,f){return k[f]}function c(k,f,b){k[b]=f}function l(k){return R.$Ce(k,f=>p.concat(f))}function i(k){return R.$Je(k)}function n(k){return R.$Ee(k,f=>p.concat(f))}async function t(k){return k.ended?p.concat(k.buffer):p.concat([...k.buffer,await n(k.stream)])}function g(k){return R.$He(k,f=>p.concat(f))}function u(k){return R.$Ke(k,{data:f=>typeof f=="string"?p.fromString(f):p.wrap(f)},f=>p.concat(f))}function $(k){return R.$Be(f=>p.concat(f),k)}function m(k,f){return R.$Le(k,f,b=>p.concat(b))}function h(k,f){return R.$Me(k,f,b=>p.concat(b))}function E(k){let f=0,b=0,M=0;const N=new Uint8Array(Math.floor(k.length/4*3)),L=K=>{switch(b){case 3:N[M++]=f|K,b=0;break;case 2:N[M++]=f|K>>>2,f=K<<6,b=3;break;case 1:N[M++]=f|K>>>4,f=K<<4,b=2;break;default:f=K<<2,b=1}};for(let K=0;K<k.length;K++){const q=k.charCodeAt(K);if(q>=65&&q<=90)L(q-65);else if(q>=97&&q<=122)L(q-97+26);else if(q>=48&&q<=57)L(q-48+52);else if(q===43||q===45)L(62);else if(q===47||q===95)L(63);else{if(q===61)break;throw new SyntaxError(`Unexpected base64 character ${k[K]}`)}}const W=M;for(;b>0;)L(0);return p.wrap(N).slice(0,W)}const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:k},f=!0,b=!1){const M=b?w:D;let N="";const L=k.byteLength%3;let W=0;for(;W<k.byteLength-L;W+=3){const K=k[W+0],q=k[W+1],G=k[W+2];N+=M[K>>>2],N+=M[(K<<4|q>>>4)&63],N+=M[(q<<2|G>>>6)&63],N+=M[G&63]}if(L===1){const K=k[W+0];N+=M[K>>>2],N+=M[K<<4&63],f&&(N+="==")}else if(L===2){const K=k[W+0],q=k[W+1];N+=M[K>>>2],N+=M[(K<<4|q>>>4)&63],N+=M[q<<2&63],f&&(N+="=")}return N}}),define(Ne[148],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ge=void 0,e.$ge=Symbol("MicrotaskDelay")}),define(Ne[34],Le([1,0,97]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$5j=P;var R;(function(A){function T(p){return p&&typeof p=="object"&&typeof p.id=="string"}A.isThemeColor=T})(R||(e.ThemeColor=R={}));function P(A){return{id:A}}var O;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const T=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function p(l){const i=T.exec(l.id);if(!i)return p(v.$4j.error);const[,n,t]=i,g=["codicon","codicon-"+n];return t&&g.push("codicon-modifier-"+t.substring(1)),g}A.asClassNameArray=p;function o(l){return p(l).join(" ")}A.asClassName=o;function I(l){return"."+p(l).join(".")}A.asCSSSelector=I;function y(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(typeof l.color>"u"||R.isThemeColor(l.color))}A.isThemeIcon=y;const a=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(l){const i=a.exec(l);if(!i)return;const[,n]=i;return{id:n}}A.fromString=S;function d(l){return{id:l}}A.fromId=d;function r(l,i){let n=l.id;const t=n.lastIndexOf("~");return t!==-1&&(n=n.substring(0,t)),i&&(n=`${n}~${i}`),{id:n}}A.modify=r;function s(l){const i=l.id.lastIndexOf("~");if(i!==-1)return l.id.substring(i+1)}A.getModifier=s;function c(l,i){return l.id===i.id&&l.color?.id===i.color?.id}A.isEqual=c})(O||(e.ThemeIcon=O={}))}),define(Ne[51],Le([1,0,27,19,20,12,14]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wg=T,e.$xg=p,e.$yg=o,e.$zg=I,e.$Ag=y,e.$Bg=r,e.$Cg=s,e.$Dg=c,e.$Eg=l,e.$Fg=i,e.$Gg=n,e.$Hg=t,e.$Ig=g,e.$Jg=u,e.$Kg=$,e.$Lg=m,e.$Mg=D;function T(w){return w===v.CharCode.Slash||w===v.CharCode.Backslash}function p(w){return w.replace(/[\\/]/g,R.$gc.sep)}function o(w){return w.indexOf("/")===-1&&(w=p(w)),/^[a-zA-Z]:(\/|$)/.test(w)&&(w="/"+w),w}function I(w,C=R.$gc.sep){if(!w)return"";const k=w.length,f=w.charCodeAt(0);if(T(f)){if(T(w.charCodeAt(1))&&!T(w.charCodeAt(2))){let M=3;const N=M;for(;M<k&&!T(w.charCodeAt(M));M++);if(N!==M&&!T(w.charCodeAt(M+1))){for(M+=1;M<k;M++)if(T(w.charCodeAt(M)))return w.slice(0,M+1).replace(/[\\/]/g,C)}}return C}else if(l(f)&&w.charCodeAt(1)===v.CharCode.Colon)return T(w.charCodeAt(2))?w.slice(0,2)+C:w.slice(0,2);let b=w.indexOf("://");if(b!==-1){for(b+=3;b<k;b++)if(T(w.charCodeAt(b)))return w.slice(0,b+1)}return""}function y(w){if(!P.$j||!w||w.length<5)return!1;let C=w.charCodeAt(0);if(C!==v.CharCode.Backslash||(C=w.charCodeAt(1),C!==v.CharCode.Backslash))return!1;let k=2;const f=k;for(;k<w.length&&(C=w.charCodeAt(k),C!==v.CharCode.Backslash);k++);return!(f===k||(C=w.charCodeAt(k+1),isNaN(C)||C===v.CharCode.Backslash))}const a=/[\\/:\*\?"<>\|]/g,S=/[/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function r(w,C=P.$j){const k=C?a:S;return!(!w||w.length===0||/^\s+$/.test(w)||(k.lastIndex=0,k.test(w))||C&&d.test(w)||w==="."||w===".."||C&&w[w.length-1]==="."||C&&w.length!==w.trim().length||w.length>255)}function s(w,C,k){const f=w===C;return!k||f?f:!w||!C?!1:(0,O.$Ff)(w,C)}function c(w,C,k,f=R.sep){if(w===C)return!0;if(!w||!C||C.length>w.length)return!1;if(k){if(!(0,O.$Gf)(w,C))return!1;if(C.length===w.length)return!0;let M=C.length;return C.charAt(C.length-1)===f&&M--,w.charAt(M)===f}return C.charAt(C.length-1)!==f&&(C+=f),w.indexOf(C)===0}function l(w){return w>=v.CharCode.A&&w<=v.CharCode.Z||w>=v.CharCode.a&&w<=v.CharCode.z}function i(w,C){return P.$j&&w.endsWith(":")&&(w+=R.sep),(0,R.$ic)(w)||(w=(0,R.$jc)(C,w)),w=(0,R.$hc)(w),n(w)}function n(w){return P.$j?(w=(0,O.$nf)(w,R.sep),w.endsWith(":")&&(w+=R.sep)):(w=(0,O.$nf)(w,R.sep),w||(w=R.sep)),w}function t(w){const C=(0,R.$hc)(w);return P.$j?w.length>3?!1:g(C)&&(w.length===2||C.charCodeAt(2)===v.CharCode.Backslash):C===R.$gc.sep}function g(w,C=P.$j){return C?l(w.charCodeAt(0))&&w.charCodeAt(1)===v.CharCode.Colon:!1}function u(w,C=P.$j){return g(w,C)?w[0]:void 0}function $(w,C,k){return C.length>w.length?-1:w===C?0:(k&&(w=w.toLowerCase(),C=C.toLowerCase()),w.indexOf(C))}function m(w){const C=w.split(":");let k,f,b;for(const M of C){const N=Number(M);(0,A.$ig)(N)?f===void 0?f=N:b===void 0&&(b=N):k=k?[k,M].join(":"):M}if(!k)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:k,line:f!==void 0?f:void 0,column:b!==void 0?b:f!==void 0?1:void 0}}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",E="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(w,C,k=8){let f="";for(let M=0;M<k;M++){let N;M===0&&P.$j&&!C&&(k===3||k===4)?N=E:N=h,f+=N.charAt(Math.floor(Math.random()*N.length))}let b;return C?b=`${C}-${f}`:b=f,w?(0,R.$jc)(w,b):b}}),define(Ne[149],Le([1,0,27,28,139,12]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.FuzzyScore=e.$Hk=e.$Gk=void 0,e.or=A,e.$Ik=p,e.$Jk=o,e.$Kk=a,e.$Lk=D,e.$Mk=w,e.$Nk=N,e.$Ok=L,e.$Pk=W,e.$Qk=K,e.$Rk=ne,e.$Tk=he,e.$Uk=$e,e.$Vk=pe,O=We(O);function A(...Ie){return function(Pe,Oe){for(let z=0,j=Ie.length;z<j;z++){const H=Ie[z](Pe,Oe);if(H)return H}return null}}e.$Gk=T.bind(void 0,!1),e.$Hk=T.bind(void 0,!0);function T(Ie,Pe,Oe){if(!Oe||Oe.length<Pe.length)return null;let z;return Ie?z=O.$Gf(Oe,Pe):z=Oe.indexOf(Pe)===0,z?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(Ie,Pe){const Oe=Pe.toLowerCase().indexOf(Ie.toLowerCase());return Oe===-1?null:[{start:Oe,end:Oe+Ie.length}]}function o(Ie,Pe){return I(Ie.toLowerCase(),Pe.toLowerCase(),0,0)}function I(Ie,Pe,Oe,z){if(Oe===Ie.length)return[];if(z===Pe.length)return null;if(Ie[Oe]===Pe[z]){let j=null;return(j=I(Ie,Pe,Oe+1,z+1))?t({start:z,end:z+1},j):null}return I(Ie,Pe,Oe,z+1)}function y(Ie){return v.CharCode.a<=Ie&&Ie<=v.CharCode.z}function a(Ie){return v.CharCode.A<=Ie&&Ie<=v.CharCode.Z}function S(Ie){return v.CharCode.Digit0<=Ie&&Ie<=v.CharCode.Digit9}function d(Ie){return Ie===v.CharCode.Space||Ie===v.CharCode.Tab||Ie===v.CharCode.LineFeed||Ie===v.CharCode.CarriageReturn}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Ie=>r.add(Ie.charCodeAt(0)));function s(Ie){return d(Ie)||r.has(Ie)}function c(Ie,Pe){return Ie===Pe||s(Ie)&&s(Pe)}const l=new Map;function i(Ie){if(l.has(Ie))return l.get(Ie);let Pe;const Oe=(0,P.$Ek)(Ie);return Oe&&(Pe=Oe),l.set(Ie,Pe),Pe}function n(Ie){return y(Ie)||a(Ie)||S(Ie)}function t(Ie,Pe){return Pe.length===0?Pe=[Ie]:Ie.end===Pe[0].start?Pe[0].start=Ie.start:Pe.unshift(Ie),Pe}function g(Ie,Pe){for(let Oe=Pe;Oe<Ie.length;Oe++){const z=Ie.charCodeAt(Oe);if(a(z)||S(z)||Oe>0&&!n(Ie.charCodeAt(Oe-1)))return Oe}return Ie.length}function u(Ie,Pe,Oe,z){if(Oe===Ie.length)return[];if(z===Pe.length)return null;if(Ie[Oe]!==Pe[z].toLowerCase())return null;{let j=null,H=z+1;for(j=u(Ie,Pe,Oe+1,z+1);!j&&(H=g(Pe,H))<Pe.length;)j=u(Ie,Pe,Oe+1,H),H++;return j===null?null:t({start:z,end:z+1},j)}}function $(Ie){let Pe=0,Oe=0,z=0,j=0,H=0;for(let ze=0;ze<Ie.length;ze++)H=Ie.charCodeAt(ze),a(H)&&Pe++,y(H)&&Oe++,n(H)&&z++,S(H)&&j++;const V=Pe/Ie.length,re=Oe/Ie.length,ge=z/Ie.length,Ce=j/Ie.length;return{upperPercent:V,lowerPercent:re,alphaPercent:ge,numericPercent:Ce}}function m(Ie){const{upperPercent:Pe,lowerPercent:Oe}=Ie;return Oe===0&&Pe>.6}function h(Ie){const{upperPercent:Pe,lowerPercent:Oe,alphaPercent:z,numericPercent:j}=Ie;return Oe>.2&&Pe<.8&&z>.6&&j<.2}function E(Ie){let Pe=0,Oe=0,z=0,j=0;for(let H=0;H<Ie.length;H++)z=Ie.charCodeAt(H),a(z)&&Pe++,y(z)&&Oe++,d(z)&&j++;return(Pe===0||Oe===0)&&j===0?Ie.length<=30:Pe<=5}function D(Ie,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!E(Ie))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Oe=$(Pe);if(!h(Oe)){if(!m(Oe))return null;Pe=Pe.toLowerCase()}let z=null,j=0;for(Ie=Ie.toLowerCase();j<Pe.length&&(z=u(Ie,Pe,0,j))===null;)j=g(Pe,j+1);return z}function w(Ie,Pe,Oe=!1){if(!Pe||Pe.length===0)return null;let z=null,j=0;for(Ie=Ie.toLowerCase(),Pe=Pe.toLowerCase();j<Pe.length&&(z=C(Ie,Pe,0,j,Oe),z===null);)j=k(Pe,j+1);return z}function C(Ie,Pe,Oe,z,j){let H=0;if(Oe===Ie.length)return[];if(z===Pe.length)return null;if(!c(Ie.charCodeAt(Oe),Pe.charCodeAt(z))){const ge=i(Ie.charCodeAt(Oe));if(!ge)return null;for(let Ce=0;Ce<ge.length;Ce++)if(!c(ge[Ce],Pe.charCodeAt(z+Ce)))return null;H+=ge.length-1}let V=null,re=z+H+1;if(V=C(Ie,Pe,Oe+1,re,j),!j)for(;!V&&(re=k(Pe,re))<Pe.length;)V=C(Ie,Pe,Oe+1,re,j),re++;if(!V)return null;if(Ie.charCodeAt(Oe)!==Pe.charCodeAt(z)){const ge=i(Ie.charCodeAt(Oe));if(!ge)return V;for(let Ce=0;Ce<ge.length;Ce++)if(ge[Ce]!==Pe.charCodeAt(z+Ce))return V}return t({start:z,end:z+H+1},V)}function k(Ie,Pe){for(let Oe=Pe;Oe<Ie.length;Oe++)if(s(Ie.charCodeAt(Oe))||Oe>0&&s(Ie.charCodeAt(Oe-1)))return Oe;return Ie.length}const f=A(e.$Hk,D,p),b=A(e.$Hk,D,o),M=new R.$Dc(1e4);function N(Ie,Pe,Oe=!1){if(typeof Ie!="string"||typeof Pe!="string")return null;let z=M.get(Ie);z||(z=new RegExp(O.$of(Ie),"i"),M.set(Ie,z));const j=z.exec(Pe);return j?[{start:j.index,end:j.index+j[0].length}]:Oe?b(Ie,Pe):f(Ie,Pe)}function L(Ie,Pe){const Oe=he(Ie,Ie.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Oe?K(Oe):null}function W(Ie,Pe,Oe,z,j,H){const V=Math.min(13,Ie.length);for(;Oe<V;Oe++){const re=he(Ie,Pe,Oe,z,j,H,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(re)return re}return[0,H]}function K(Ie){if(typeof Ie>"u")return[];const Pe=[],Oe=Ie[1];for(let z=Ie.length-1;z>1;z--){const j=Ie[z]+Oe,H=Pe[Pe.length-1];H&&H.end===j?H.end=j+1:Pe.push({start:j,end:j+1})}return Pe}const q=128;function G(){const Ie=[],Pe=[];for(let Oe=0;Oe<=q;Oe++)Pe[Oe]=0;for(let Oe=0;Oe<=q;Oe++)Ie.push(Pe.slice(0));return Ie}function Q(Ie){const Pe=[];for(let Oe=0;Oe<=Ie;Oe++)Pe[Oe]=0;return Pe}const ae=Q(2*q),we=Q(2*q),le=G(),_=G(),ce=G(),me=!1;function oe(Ie,Pe,Oe,z,j){function H(re,ge,Ce=" "){for(;re.length<ge;)re=Ce+re;return re}let V=` |   |${z.split("").map(re=>H(re,3)).join("|")}
`;for(let re=0;re<=Oe;re++)re===0?V+=" |":V+=`${Pe[re-1]}|`,V+=Ie[re].slice(0,j+1).map(ge=>H(ge.toString(),3)).join("|")+`
`;return V}function ke(Ie,Pe,Oe,z){Ie=Ie.substr(Pe),Oe=Oe.substr(z),console.log(oe(_,Ie,Ie.length,Oe,Oe.length)),console.log(oe(ce,Ie,Ie.length,Oe,Oe.length)),console.log(oe(le,Ie,Ie.length,Oe,Oe.length))}function Te(Ie,Pe){if(Pe<0||Pe>=Ie.length)return!1;const Oe=Ie.codePointAt(Pe);switch(Oe){case v.CharCode.Underline:case v.CharCode.Dash:case v.CharCode.Period:case v.CharCode.Space:case v.CharCode.Slash:case v.CharCode.Backslash:case v.CharCode.SingleQuote:case v.CharCode.DoubleQuote:case v.CharCode.Colon:case v.CharCode.DollarSign:case v.CharCode.LessThan:case v.CharCode.GreaterThan:case v.CharCode.OpenParen:case v.CharCode.CloseParen:case v.CharCode.OpenSquareBracket:case v.CharCode.CloseSquareBracket:case v.CharCode.OpenCurlyBrace:case v.CharCode.CloseCurlyBrace:return!0;case void 0:return!1;default:return!!O.$Yf(Oe)}}function Z(Ie,Pe){if(Pe<0||Pe>=Ie.length)return!1;switch(Ie.charCodeAt(Pe)){case v.CharCode.Space:case v.CharCode.Tab:return!0;default:return!1}}function B(Ie,Pe,Oe){return Pe[Ie]!==Oe[Ie]}function ne(Ie,Pe,Oe,z,j,H,V=!1){for(;Pe<Oe&&j<H;)Ie[Pe]===z[j]&&(V&&(ae[Pe]=j),Pe+=1),j+=1;return Pe===Oe}var Ee;(function(Ie){Ie[Ie.Diag=1]="Diag",Ie[Ie.Left=2]="Left",Ie[Ie.LeftLeft=3]="LeftLeft"})(Ee||(Ee={}));var fe;(function(Ie){Ie.Default=[-100,0];function Pe(Oe){return!Oe||Oe.length===2&&Oe[0]===-100&&Oe[1]===0}Ie.isDefault=Pe})(fe||(e.FuzzyScore=fe={}));class be{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Oe){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Oe}}e.$Sk=be;function he(Ie,Pe,Oe,z,j,H,V=be.default){const re=Ie.length>q?q:Ie.length,ge=z.length>q?q:z.length;if(Oe>=re||H>=ge||re-Oe>ge-H||!ne(Pe,Oe,re,j,H,ge,!0))return;X(re,ge,Oe,H,Pe,j);let Ce=1,ze=1,Qe=Oe,_e=H;const tt=[!1];for(Ce=1,Qe=Oe;Qe<re;Ce++,Qe++){const lt=ae[Qe],st=we[Qe],ct=Qe+1<re?we[Qe+1]:ge;for(ze=lt-H+1,_e=lt;_e<ct;ze++,_e++){let mt=Number.MIN_SAFE_INTEGER,$t=!1;_e<=st&&(mt=x(Ie,Pe,Qe,Oe,z,j,_e,ge,H,le[Ce-1][ze-1]===0,tt));let qe=0;mt!==Number.MAX_SAFE_INTEGER&&($t=!0,qe=mt+_[Ce-1][ze-1]);const je=_e>lt,ie=je?_[Ce][ze-1]+(le[Ce][ze-1]>0?-5:0):0,ee=_e>lt+1&&le[Ce][ze-1]>0,Y=ee?_[Ce][ze-2]+(le[Ce][ze-2]>0?-5:0):0;if(ee&&(!je||Y>=ie)&&(!$t||Y>=qe))_[Ce][ze]=Y,ce[Ce][ze]=Ee.LeftLeft,le[Ce][ze]=0;else if(je&&(!$t||ie>=qe))_[Ce][ze]=ie,ce[Ce][ze]=Ee.Left,le[Ce][ze]=0;else if($t)_[Ce][ze]=qe,ce[Ce][ze]=Ee.Diag,le[Ce][ze]=le[Ce-1][ze-1]+1;else throw new Error("not possible")}}if(me&&ke(Ie,Oe,z,H),!tt[0]&&!V.firstMatchCanBeWeak)return;Ce--,ze--;const nt=[_[Ce][ze],H];let et=0,rt=0;for(;Ce>=1;){let lt=ze;do{const st=ce[Ce][lt];if(st===Ee.LeftLeft)lt=lt-2;else if(st===Ee.Left)lt=lt-1;else break}while(lt>=1);et>1&&Pe[Oe+Ce-1]===j[H+ze-1]&&!B(lt+H-1,z,j)&&et+1>le[Ce][lt]&&(lt=ze),lt===ze?et++:et=1,rt||(rt=lt),Ce--,ze=lt-1,nt.push(ze)}ge-H===re&&V.boostFullMatch&&(nt[0]+=2);const ft=rt-re;return nt[0]-=ft,nt}function X(Ie,Pe,Oe,z,j,H){let V=Ie-1,re=Pe-1;for(;V>=Oe&&re>=z;)j[V]===H[re]&&(we[V]=re,V--),re--}function x(Ie,Pe,Oe,z,j,H,V,re,ge,Ce,ze){if(Pe[Oe]!==H[V])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return V===Oe-z?Qe=Ie[Oe]===j[V]?7:5:B(V,j,H)&&(V===0||!B(V-1,j,H))?(Qe=Ie[Oe]===j[V]?7:5,_e=!0):Te(H,V)&&(V===0||!Te(H,V-1))?Qe=5:(Te(H,V-1)||Z(H,V-1))&&(Qe=5,_e=!0),Qe>1&&Oe===z&&(ze[0]=!0),_e||(_e=B(V,j,H)||Te(H,V-1)||Z(H,V-1)),Oe===z?V>ge&&(Qe-=_e?3:5):Ce?Qe+=_e?2:0:Qe+=_e?0:1,V+1===re&&(Qe-=_e?3:5),Qe}function $e(Ie,Pe,Oe,z,j,H,V){return Ae(Ie,Pe,Oe,z,j,H,!0,V)}function pe(Ie,Pe,Oe,z,j,H,V){return Ae(Ie,Pe,Oe,z,j,H,!1,V)}function Ae(Ie,Pe,Oe,z,j,H,V,re){let ge=he(Ie,Pe,Oe,z,j,H,re);if(ge&&!V)return ge;if(Ie.length>=3){const Ce=Math.min(7,Ie.length-1);for(let ze=Oe+1;ze<Ce;ze++){const Qe=Ue(Ie,ze);if(Qe){const _e=he(Qe,Qe.toLowerCase(),Oe,z,j,H,re);_e&&(_e[0]-=3,(!ge||_e[0]>ge[0])&&(ge=_e))}}}return ge}function Ue(Ie,Pe){if(Pe+1>=Ie.length)return;const Oe=Ie[Pe],z=Ie[Pe+1];if(Oe!==z)return Ie.slice(0,Pe)+z+Oe+Ie.slice(Pe+2)}}),define(Ne[98],Le([1,0,149,12,34]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wk=p,e.$Xk=I,e.$Yk=a,e.$Zk=S,e.$1k=r,e.$2k=s;const O="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),T=new RegExp(`(\\\\)?${A.source}`,"g");function p(c){return c.replace(T,(l,i)=>i?l:`\\${l}`)}const o=new RegExp(`\\\\${A.source}`,"g");function I(c){return c.replace(o,l=>`\\${l}`)}const y=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function a(c){return c.indexOf(O)===-1?c:c.replace(y,(l,i,n,t)=>n?l:i||t||"")}function S(c){return c?c.replace(/\$\((.*?)\)/g,(l,i)=>` ${i} `).trim():""}const d=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(c){d.lastIndex=0;let l="";const i=[];let n=0;for(;;){const t=d.lastIndex,g=d.exec(c),u=c.substring(t,g?.index);if(u.length>0){l+=u;for(let $=0;$<u.length;$++)i.push(n)}if(!g)break;n+=g[0].length}return{text:l,iconOffsets:i}}function s(c,l,i=!1){const{text:n,iconOffsets:t}=l;if(!t||t.length===0)return(0,v.$Nk)(c,n,i);const g=(0,R.$mf)(n," "),u=n.length-g.length,$=(0,v.$Nk)(c,g,i);if($)for(const m of $){const h=t[m.start+u]+u;m.start+=h,m.end+=h}return $}}),define(Ne[35],Le([1,0,12]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v=We(v);var R;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(R||(R={})),function(P){const O="error",A="warning",T="warn",p="info",o="ignore";function I(a){return a?v.$Ff(O,a)?P.Error:v.$Ff(A,a)||v.$Ff(T,a)?P.Warning:v.$Ff(p,a)?P.Info:P.Ignore:P.Ignore}P.fromValue=I;function y(a){switch(a){case P.Error:return O;case P.Warning:return A;case P.Info:return p;default:return o}}P.toString=y}(R||(R={})),e.default=R}),define(Ne[58],Le([1,0,17,27,12]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=void 0;class O{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const r=d.charCodeAt(0),s=this.b.charCodeAt(this.c);return r-s}value(){return this.b[this.c]}}e.$Gi=O;class A{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===R.CharCode.Period)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,P.$zf)(d,this.b,0,d.length,this.c,this.d):(0,P.$Bf)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Hi=A;class T{constructor(d=!0,r=!0){this.f=d,this.g=r}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let r=d.length-1;r>=0;r--,this.c--){const s=this.b.charCodeAt(r);if(!(s===R.CharCode.Slash||this.f&&s===R.CharCode.Backslash))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const r=this.b.charCodeAt(this.e);if(r===R.CharCode.Slash||this.f&&r===R.CharCode.Backslash)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,P.$zf)(d,this.b,0,d.length,this.d,this.e):(0,P.$Bf)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ii=T;var p;(function(S){S[S.Scheme=1]="Scheme",S[S.Authority=2]="Authority",S[S.Path=3]="Path",S[S.Query=4]="Query",S[S.Fragment=5]="Fragment"})(p||(p={}));class o{constructor(d,r){this.f=d,this.g=r,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(p.Scheme),this.c.authority&&this.d.push(p.Authority),this.c.path&&(this.b=new T(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(p.Path)),this.g(d)||(this.c.query&&this.d.push(p.Query),this.c.fragment&&this.d.push(p.Fragment)),this.e=0,this}next(){return this.d[this.e]===p.Path&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===p.Path&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===p.Scheme)return(0,P.$Af)(d,this.c.scheme);if(this.d[this.e]===p.Authority)return(0,P.$Af)(d,this.c.authority);if(this.d[this.e]===p.Path)return this.b.cmp(d);if(this.d[this.e]===p.Query)return(0,P.$yf)(d,this.c.query);if(this.d[this.e]===p.Fragment)return(0,P.$yf)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===p.Scheme)return this.c.scheme;if(this.d[this.e]===p.Authority)return this.c.authority;if(this.d[this.e]===p.Path)return this.b.value();if(this.d[this.e]===p.Query)return this.c.query;if(this.d[this.e]===p.Fragment)return this.c.fragment;throw new Error}}e.$Ji=o;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(S){S[S.Left=-1]="Left",S[S.Mid=0]="Mid",S[S.Right=1]="Right"})(y||(y={}));class a{static forUris(d=()=>!1,r=()=>!1){return new a(new o(d,r))}static forPaths(d=!1){return new a(new T(void 0,!d))}static forStrings(){return new a(new O)}static forConfigKeys(){return new a(new A)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,r){if(r){const s=r.slice(0);(0,v.$Vb)(s);for(const c of s)this.set(c,d)}else{const s=d.slice(0);(0,v.$Vb)(s);for(const c of s)this.set(c[0],c[1])}}set(d,r){const s=this.b.reset(d);let c;this.c||(this.c=new I,this.c.segment=s.value());const l=[];for(c=this.c;;){const n=s.cmp(c.segment);if(n>0)c.left||(c.left=new I,c.left.segment=s.value()),l.push([y.Left,c]),c=c.left;else if(n<0)c.right||(c.right=new I,c.right.segment=s.value()),l.push([y.Right,c]),c=c.right;else if(s.hasNext())s.next(),c.mid||(c.mid=new I,c.mid.segment=s.value()),l.push([y.Mid,c]),c=c.mid;else break}const i=c.value;c.value=r,c.key=d;for(let n=l.length-1;n>=0;n--){const t=l[n][1];t.updateHeight();const g=t.balanceFactor();if(g<-1||g>1){const u=l[n][0],$=l[n+1][0];if(u===y.Right&&$===y.Right)l[n][1]=t.rotateLeft();else if(u===y.Left&&$===y.Left)l[n][1]=t.rotateRight();else if(u===y.Right&&$===y.Left)t.right=l[n+1][1]=l[n+1][1].rotateRight(),l[n][1]=t.rotateLeft();else if(u===y.Left&&$===y.Right)t.left=l[n+1][1]=l[n+1][1].rotateLeft(),l[n][1]=t.rotateRight();else throw new Error;if(n>0)switch(l[n-1][0]){case y.Left:l[n-1][1].left=l[n][1];break;case y.Right:l[n-1][1].right=l[n][1];break;case y.Mid:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}return i}get(d){return this.d(d)?.value}d(d){const r=this.b.reset(d);let s=this.c;for(;s;){const c=r.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(d){const r=this.d(d);return!(r?.value===void 0&&r?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,r){const s=this.b.reset(d),c=[];let l=this.c;for(;l;){const i=s.cmp(l.segment);if(i>0)c.push([y.Left,l]),l=l.left;else if(i<0)c.push([y.Right,l]),l=l.right;else if(s.hasNext())s.next(),c.push([y.Mid,l]),l=l.mid;else break}if(l){if(r?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const i=this.f(l.right);if(i.key){const{key:n,value:t,segment:g}=i;this.e(i.key,!1),l.key=n,l.value=t,l.segment=g}}else{const i=l.left??l.right;if(c.length>0){const[n,t]=c[c.length-1];switch(n){case y.Left:t.left=i;break;case y.Mid:t.mid=i;break;case y.Right:t.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const n=c[i][1];n.updateHeight();const t=n.balanceFactor();if(t>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),c[i][1]=n.rotateLeft()):t<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),c[i][1]=n.rotateRight()),i>0)switch(c[i-1][0]){case y.Left:c[i-1][1].left=c[i][1];break;case y.Right:c[i-1][1].right=c[i][1];break;case y.Mid:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const r=this.b.reset(d);let s=this.c,c;for(;s;){const l=r.cmp(s.segment);if(l>0)s=s.left;else if(l<0)s=s.right;else if(r.hasNext())r.next(),c=s.value||c,s=s.mid;else break}return s&&s.value||c}findSuperstr(d){return this.g(d,!1)}g(d,r){const s=this.b.reset(d);let c=this.c;for(;c;){const l=s.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(s.hasNext())s.next(),c=c.mid;else return c.mid?this.h(c.mid):r?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[r,s]of this)d(s,r)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const r=[];return this.j(d,r),r[Symbol.iterator]()}j(d,r){d&&(d.left&&this.j(d.left,r),d.value&&r.push([d.key,d.value]),d.mid&&this.j(d.mid,r),d.right&&this.j(d.right,r))}_isBalanced(){const d=r=>{if(!r)return!0;const s=r.balanceFactor();return s<-1||s>1?!1:d(r.left)&&d(r.right)};return d(this.c)}}e.$Ki=a}),define(Ne[36],Le([1,0,22,2,37]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=O,e.$ai=A,e.$bi=p;function O(o){return JSON.stringify(o,T)}function A(o){let I=JSON.parse(o);return I=p(I),I}function T(o,I){return I instanceof RegExp?{$mid:P.MarshalledId.Regexp,source:I.source,flags:I.flags}:I}function p(o,I=0){if(!o||I>200)return o;if(typeof o=="object"){switch(o.$mid){case P.MarshalledId.Uri:return R.URI.revive(o);case P.MarshalledId.Regexp:return new RegExp(o.source,o.flags);case P.MarshalledId.Date:return new Date(o.source)}if(o instanceof v.$Ne||o instanceof Uint8Array)return o;if(Array.isArray(o))for(let y=0;y<o.length;++y)o[y]=p(o[y],I+1);else for(const y in o)Object.hasOwnProperty.call(o,y)&&(o[y]=p(o[y],I+1))}return o}}),define(Ne[15],Le([1,0,13,20,12,2,19]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Rg=e.$Qg=e.$Pg=e.Schemas=void 0,e.$Ng=p,e.$Og=o,e.$Sg=y,v=We(v),R=We(R),A=We(A);var T;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeCopilotBackingChatCodeBlock="vscode-copilot-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(T||(e.Schemas=T={}));function p(d,r){return O.URI.isUri(d)?(0,P.$Ff)(d.scheme,r):(0,P.$Gf)(d,r+":")}function o(d,...r){return r.some(s=>p(d,s))}e.$Pg="vscode-tkn",e.$Qg="tkn";class I{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r,s){this.f=y(r,s)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,T.vscodeRemoteResource)}set(r,s,c){this.a[r]=s,this.b[r]=c}setConnectionToken(r,s){this.c[r]=s}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(t){return v.$Y(t),r}const s=r.authority;let c=this.a[s];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const l=this.b[s],i=this.c[s];let n=`path=${encodeURIComponent(r.path)}`;return typeof i=="string"&&(n+=`&${e.$Qg}=${encodeURIComponent(i)}`),O.URI.from({scheme:R.$p?this.d:T.vscodeRemoteResource,authority:`${c}:${l}`,path:this.g,query:n})}}e.$Rg=new I;function y(d,r){return A.$gc.join(r??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Tg="vs/../../extensions",e.$Ug="vs/../../node_modules",e.$Vg="vs/../../node_modules.asar",e.$Wg="vs/../../node_modules.asar.unpacked",e.$Xg="vscode-app";class a{static{this.a=e.$Xg}asBrowserUri(r){const s=this.b(r,ve);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===T.vscodeRemote?e.$Rg.rewrite(r):r.scheme===T.file&&(R.$n||R.$r===`${T.vscodeFileResource}://${a.a}`)?r.with({scheme:T.vscodeFileResource,authority:r.authority||a.a,query:null,fragment:null}):r}asFileUri(r){const s=this.b(r,ve);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===T.vscodeFileResource?r.with({scheme:T.file,authority:r.authority!==a.a?r.authority:null,query:null,fragment:null}):r}b(r,s){return O.URI.isUri(r)?r:O.URI.parse(s.toUrl(r))}}e.$Yg=new a;var S;(function(d){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function c(i){let n;typeof i=="string"?n=new URL(i).searchParams:i instanceof URL?n=i.searchParams:O.URI.isUri(i)&&(n=new URL(i.toString(!0)).searchParams);const t=n?.get(s);if(t)return r.get(t)}d.getHeadersFromQuery=c;function l(i,n,t){if(!globalThis.crossOriginIsolated)return;const g=n&&t?"3":t?"2":"1";i instanceof URLSearchParams?i.set(s,g):i[s]=g}d.addSearchParam=l})(S||(e.COI=S={}))}),define(Ne[23],Le([1,0,27,51,15,19,20,12,2]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=void 0,e.$6g=o,e.$oh=y,e.$ph=S,R=We(R),O=We(O);function o(d){return(0,p.$wc)(d,!0)}class I{constructor(r){this.a=r}compare(r,s,c=!1){return r===s?0:(0,T.$yf)(this.getComparisonKey(r,c),this.getComparisonKey(s,c))}isEqual(r,s,c=!1){return r===s?!0:!r||!s?!1:this.getComparisonKey(r,c)===this.getComparisonKey(s,c)}getComparisonKey(r,s=!1){return r.with({path:this.a(r)?r.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(r){return this.a(r)}isEqualOrParent(r,s,c=!1){if(r.scheme===s.scheme){if(r.scheme===P.Schemas.file)return R.$Dg(o(r),o(s),this.a(r))&&r.query===s.query&&(c||r.fragment===s.fragment);if((0,e.$kh)(r.authority,s.authority))return R.$Dg(r.path,s.path,this.a(r),"/")&&r.query===s.query&&(c||r.fragment===s.fragment)}return!1}joinPath(r,...s){return p.URI.joinPath(r,...s)}basenameOrAuthority(r){return(0,e.$ch)(r)||r.authority}basename(r){return O.$gc.basename(r.path)}extname(r){return O.$gc.extname(r.path)}dirname(r){if(r.path.length===0)return r;let s;return r.scheme===P.Schemas.file?s=p.URI.file(O.$mc(o(r))).path:(s=O.$gc.dirname(r.path),r.authority&&s.length&&s.charCodeAt(0)!==v.CharCode.Slash&&(console.error(`dirname("${r.toString})) resulted in a relative path`),s="/")),r.with({path:s})}normalizePath(r){if(!r.path.length)return r;let s;return r.scheme===P.Schemas.file?s=p.URI.file(O.$hc(o(r))).path:s=O.$gc.normalize(r.path),r.with({path:s})}relativePath(r,s){if(r.scheme!==s.scheme||!(0,e.$kh)(r.authority,s.authority))return;if(r.scheme===P.Schemas.file){const i=O.$lc(o(r),o(s));return A.$j?R.$xg(i):i}let c=r.path||"/";const l=s.path||"/";if(this.a(r)){let i=0;for(const n=Math.min(c.length,l.length);i<n&&!(c.charCodeAt(i)!==l.charCodeAt(i)&&c.charAt(i).toLowerCase()!==l.charAt(i).toLowerCase());i++);c=l.substr(0,i)+c.substr(i)}return O.$gc.relative(c,l)}resolvePath(r,s){if(r.scheme===P.Schemas.file){const c=p.URI.file(O.$kc(o(r),s));return r.with({authority:c.authority,path:c.path})}return s=R.$yg(s),r.with({path:O.$gc.resolve(r.path,s)})}isAbsolutePath(r){return!!r.path&&r.path[0]==="/"}isEqualAuthority(r,s){return r===s||r!==void 0&&s!==void 0&&(0,T.$Ff)(r,s)}hasTrailingPathSeparator(r,s=O.sep){if(r.scheme===P.Schemas.file){const c=o(r);return c.length>R.$zg(c).length&&c[c.length-1]===s}else{const c=r.path;return c.length>1&&c.charCodeAt(c.length-1)===v.CharCode.Slash&&!/^[a-zA-Z]:(\/$|\\$)/.test(r.fsPath)}}removeTrailingPathSeparator(r,s=O.sep){return(0,e.$lh)(r,s)?r.with({path:r.path.substr(0,r.path.length-1)}):r}addTrailingPathSeparator(r,s=O.sep){let c=!1;if(r.scheme===P.Schemas.file){const l=o(r);c=l!==void 0&&l.length===R.$zg(l).length&&l[l.length-1]===s}else{s="/";const l=r.path;c=l.length===1&&l.charCodeAt(l.length-1)===v.CharCode.Slash}return!c&&!(0,e.$lh)(r,s)?r.with({path:r.path+"/"}):r}}e.$7g=I,e.$8g=new I(()=>!1),e.$9g=new I(d=>d.scheme===P.Schemas.file?!A.$l:!0),e.$0g=new I(d=>!0),e.$$g=e.$8g.isEqual.bind(e.$8g),e.$_g=e.$8g.isEqualOrParent.bind(e.$8g),e.$ah=e.$8g.getComparisonKey.bind(e.$8g),e.$bh=e.$8g.basenameOrAuthority.bind(e.$8g),e.$ch=e.$8g.basename.bind(e.$8g),e.$dh=e.$8g.extname.bind(e.$8g),e.$eh=e.$8g.dirname.bind(e.$8g),e.$fh=e.$8g.joinPath.bind(e.$8g),e.$gh=e.$8g.normalizePath.bind(e.$8g),e.$hh=e.$8g.relativePath.bind(e.$8g),e.$ih=e.$8g.resolvePath.bind(e.$8g),e.$jh=e.$8g.isAbsolutePath.bind(e.$8g),e.$kh=e.$8g.isEqualAuthority.bind(e.$8g),e.$lh=e.$8g.hasTrailingPathSeparator.bind(e.$8g),e.$mh=e.$8g.removeTrailingPathSeparator.bind(e.$8g),e.$nh=e.$8g.addTrailingPathSeparator.bind(e.$8g);function y(d,r){const s=[];for(let c=0;c<d.length;c++){const l=r(d[c]);d.some((i,n)=>n===c?!1:(0,e.$_g)(l,r(i)))||s.push(d[c])}return s}var a;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function r(s){const c=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[t,g]=n.split(":");t&&g&&c.set(t,g)});const i=s.path.substring(0,s.path.indexOf(";"));return i&&c.set(d.META_DATA_MIME,i),c}d.parseMetaData=r})(a||(e.DataUri=a={}));function S(d,r,s){if(r){let c=d.path;return c&&c[0]!==O.$gc.sep&&(c=O.$gc.sep+c),d.with({scheme:s,authority:r,path:c})}return d.with({scheme:s})}}),define(Ne[10],Le([1,0,21,13,6,4,23,20,148,48]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$6h=e.$5h=e.$4h=e.$3h=e.Promises=e.$2h=e.$1h=e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=void 0,e.$qh=I,e.$rh=y,e.$sh=a,e.$th=S,e.$uh=d,e.$vh=r,e.$wh=s,e.$xh=c,e.$Fh=E,e.$Gh=D,e.$Hh=w,e.$Ih=C,e.$Jh=k,e.$Yh=le,e.$7h=fe;function I(he){return!!he&&typeof he.then=="function"}function y(he){const X=new v.$we,x=he(X.token),$e=new Promise((pe,Ae)=>{const Ue=X.token.onCancellationRequested(()=>{Ue.dispose(),Ae(new R.$4)});Promise.resolve(x).then(Ie=>{Ue.dispose(),X.dispose(),pe(Ie)},Ie=>{Ue.dispose(),X.dispose(),Ae(Ie)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,Ae){return $e.then(pe,Ae)}catch(pe){return this.then(void 0,pe)}finally(pe){return $e.finally(pe)}}}function a(he,X,x){return new Promise(($e,pe)=>{const Ae=X.onCancellationRequested(()=>{Ae.dispose(),$e(x)});he.then($e,pe).finally(()=>Ae.dispose())})}function S(he,X){return new Promise((x,$e)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),$e(new R.$4)});he.then(x,$e).finally(()=>pe.dispose())})}async function d(he){let X=-1;const x=he.map(($e,pe)=>$e.then(Ae=>(X=pe,Ae)));try{return await Promise.race(x)}finally{he.forEach(($e,pe)=>{pe!==X&&$e.cancel()})}}function r(he,X,x){let $e;const pe=setTimeout(()=>{$e?.(void 0),x?.()},X);return Promise.race([he.finally(()=>clearTimeout(pe)),new Promise(Ae=>$e=Ae)])}function s(he){return new Promise((X,x)=>{const $e=he();I($e)?$e.then(X,x):X($e)})}function c(){let he,X;return{promise:new Promise(($e,pe)=>{he=$e,X=pe}),resolve:he,reject:X}}class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const x=()=>{if(this.b=null,this.f)return;const $e=this.queue(this.d);return this.d=null,$e};this.b=new Promise($e=>{this.a.then(x,x).then($e)})}return new Promise((x,$e)=>{this.b.then(x,$e)})}return this.a=X(),new Promise((x,$e)=>{this.a.then(pe=>{this.a=null,x(pe)},pe=>{this.a=null,$e(pe)})})}dispose(){this.f=!0}}e.$yh=l;class i{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$zh=i;class n{constructor(){this.a=new Map}queue(X,x){const pe=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(x).finally(()=>{this.a.get(X)===pe&&this.a.delete(X)});return this.a.set(X,pe),pe}}e.$Ah=n;const t=(he,X)=>{let x=!0;const $e=setTimeout(()=>{x=!1,X()},he);return{isTriggered:()=>x,dispose:()=>{clearTimeout($e),x=!1}}},g=he=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,he())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class u{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,x=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((pe,Ae)=>{this.d=pe,this.f=Ae}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const $e=()=>{this.a=null,this.d?.(null)};return this.a=x===p.$ge?g($e):t(x,$e),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Bh=u;class ${constructor(X){this.a=new u(X),this.b=new l}trigger(X,x){return this.a.trigger(()=>this.b.queue(X),x)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Ch=$;class m{constructor(){this.a=!1,this.b=new Promise((X,x)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Dh=m;class h extends m{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$Eh=h;function E(he,X){return X?new Promise((x,$e)=>{const pe=setTimeout(()=>{Ae.dispose(),x()},he),Ae=X.onCancellationRequested(()=>{clearTimeout(pe),Ae.dispose(),$e(new R.$4)})}):y(x=>E(he,x))}function D(he,X=0,x){const $e=setTimeout(()=>{he(),x&&pe.dispose()},X),pe=(0,O.$Sc)(()=>{clearTimeout($e),x?.deleteAndLeak(pe)});return x?.add(pe),pe}function w(he){const X=[];let x=0;const $e=he.length;function pe(){return x<$e?he[x++]():null}function Ae(Ue){Ue!=null&&X.push(Ue);const Ie=pe();return Ie?Ie.then(Ae):Promise.resolve(X)}return Promise.resolve(null).then(Ae)}function C(he,X=$e=>!!$e,x=null){let $e=0;const pe=he.length,Ae=()=>{if($e>=pe)return Promise.resolve(x);const Ue=he[$e++];return Promise.resolve(Ue()).then(Pe=>X(Pe)?Promise.resolve(Pe):Ae())};return Ae()}function k(he,X=$e=>!!$e,x=null){if(he.length===0)return Promise.resolve(x);let $e=he.length;const pe=()=>{$e=-1;for(const Ae of he)Ae.cancel?.()};return new Promise((Ae,Ue)=>{for(const Ie of he)Ie.then(Pe=>{--$e>=0&&X(Pe)?(pe(),Ae(Pe)):$e===0&&Ae(x)}).catch(Pe=>{--$e>=0&&(pe(),Ue(Pe))})})}class f{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new P.$le}whenIdle(){return this.size>0?P.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((x,$e)=>{this.g.push({factory:X,c:x,e:$e}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const x=X.factory();x.then(X.c,X.e),x.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Kh=f;class b extends f{constructor(){super(1)}}e.$Lh=b;class M{constructor(){this.a=new _,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Mh=M;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new oe;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,x=A.$8g){const $e=x.getComparisonKey(X);return this.a.get($e)?.size??0}queueFor(X,x,$e=A.$8g){const pe=$e.getComparisonKey(X);let Ae=this.a.get(pe);if(!Ae){Ae=new b;const Ue=this.f++,Ie=P.Event.once(Ae.onDrained)(()=>{Ae?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(Ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$4c),this.d.set(Ue,Ie),this.a.set(pe,Ae)}return Ae.queue(x)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Nh=N;class L{constructor(X,x){this.b=!1,this.a=-1,typeof X=="function"&&typeof x=="number"&&this.setIfNotSet(X,x)}dispose(){this.cancel(),this.b=!0}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,x){if(this.b)throw new R.$bb("Calling 'cancelAndSet' on a disposed TimeoutTimer");this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},x)}setIfNotSet(X,x){if(this.b)throw new R.$bb("Calling 'setIfNotSet' on a disposed TimeoutTimer");this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},x))}}e.$Oh=L;class W{constructor(){this.d=void 0,this.f=!1}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,x,$e=globalThis){if(this.f)throw new R.$bb("Calling 'cancelAndSet' on a disposed IntervalTimer");this.cancel();const pe=$e.setInterval(()=>{X()},x);this.d=(0,O.$Sc)(()=>{$e.clearInterval(pe),this.d=void 0})}dispose(){this.cancel(),this.f=!0}}e.$Ph=W;class K{constructor(X,x){this.b=-1,this.a=X,this.d=x,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Qh=K;class q{constructor(X,x){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.a=X,this.b=x,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Rh=q;class G extends K{constructor(X,x){super(X,x),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Sh=G;class Q extends O.$Uc{constructor(X,x){super(),this.g=X,this.h=x,this.a=[],this.b=this.B(new O.$Vc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const x of X)this.a.push(x);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Th=Q,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Vh=(he,X)=>{(0,T.$C)(()=>{if(x)return;const $e=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,$e-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.$Vh=(he,X,x)=>{const $e=he.requestIdleCallback(X,typeof x=="number"?{timeout:x}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,he.cancelIdleCallback($e))}}},e.$Uh=he=>(0,e.$Vh)(globalThis,he)}();class ae{constructor(X,x){this.g=!1,this.d=()=>{try{this.j=x()}catch($e){this.l=$e}finally{this.g=!0}},this.f=(0,e.$Vh)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Wh=ae;class we extends ae{constructor(X){super(globalThis,X)}}e.$Xh=we;async function le(he,X,x){let $e;for(let pe=0;pe<x;pe++)try{return await he()}catch(Ae){$e=Ae,await E(X)}throw $e}class _{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,x,$e){return this.a={taskId:X,cancel:()=>$e?.(),promise:x},x.then(()=>this.d(X),()=>this.d(X)),x}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:x,resolve:$e,reject:pe}=c();this.b={run:X,promise:x,promiseResolve:$e,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Zh=_;class ce{constructor(X,x=()=>Date.now()){this.d=X,this.f=x,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$1h=ce;var me;(function(he){he[he.Resolved=0]="Resolved",he[he.Rejected=1]="Rejected"})(me||(me={}));class oe{get isRejected(){return this.d?.outcome===me.Rejected}get isResolved(){return this.d?.outcome===me.Resolved}get isSettled(){return!!this.d}get value(){return this.d?.outcome===me.Resolved?this.d?.value:void 0}constructor(){this.p=new Promise((X,x)=>{this.a=X,this.b=x})}complete(X){return new Promise(x=>{this.a(X),this.d={outcome:me.Resolved,value:X},x()})}error(X){return new Promise(x=>{this.b(X),this.d={outcome:me.Rejected,value:X},x()})}cancel(){return this.error(new R.$4)}}e.$2h=oe;var ke;(function(he){async function X($e){let pe;const Ae=await Promise.all($e.map(Ue=>Ue.then(Ie=>Ie,Ie=>{pe||(pe=Ie)})));if(typeof pe<"u")throw pe;return Ae}he.settled=X;function x($e){return new Promise(async(pe,Ae)=>{try{await $e(pe,Ae)}catch(Ue){Ae(Ue)}})}he.withAsyncBody=x})(ke||(e.Promises=ke={}));class Te{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(x=>(this.a=x,this.d=!0,x),x=>{throw this.b=x,this.d=!0,x})}requireValue(){if(!this.d)throw new R.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$3h=Te;class Z{constructor(X){this.b=X,this.a=new o.$T(()=>new Te(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$4h=Z;var B;(function(he){he[he.Initial=0]="Initial",he[he.DoneOK=1]="DoneOK",he[he.DoneError=2]="DoneError"})(B||(B={}));class ne{static fromArray(X){return new ne(x=>{x.emitMany(X)})}static fromPromise(X){return new ne(async x=>{x.emitMany(await X)})}static fromPromises(X){return new ne(async x=>{await Promise.all(X.map(async $e=>x.emitOne(await $e)))})}static merge(X){return new ne(async x=>{await Promise.all(X.map(async $e=>{for await(const pe of $e)x.emitOne(pe)}))})}static{this.EMPTY=ne.fromArray([])}constructor(X,x){this.a=B.Initial,this.b=[],this.d=null,this.f=x,this.g=new P.$le,queueMicrotask(async()=>{const $e={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(X($e)),this.k()}catch(pe){this.l(pe)}finally{$e.emitOne=void 0,$e.emitMany=void 0,$e.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===B.DoneError)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===B.DoneOK)return{done:!0,value:void 0};await P.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,x){return new ne(async $e=>{for await(const pe of X)$e.emitOne(x(pe))})}map(X){return ne.map(this,X)}static filter(X,x){return new ne(async $e=>{for await(const pe of X)x(pe)&&$e.emitOne(pe)})}filter(X){return ne.filter(this,X)}static coalesce(X){return ne.filter(X,x=>!!x)}coalesce(){return ne.coalesce(this)}static async toPromise(X){const x=[];for await(const $e of X)x.push($e);return x}toPromise(){return ne.toPromise(this)}h(X){this.a===B.Initial&&(this.b.push(X),this.g.fire())}j(X){this.a===B.Initial&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===B.Initial&&(this.a=B.DoneOK,this.g.fire())}l(X){this.a===B.Initial&&(this.a=B.DoneError,this.d=X,this.g.fire())}}e.$5h=ne;class Ee extends ne{constructor(X,x){super(x),this.m=X}cancel(){this.m.cancel()}}e.$6h=Ee;function fe(he){const X=new v.$we,x=he(X.token);return new Ee(X,async $e=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),$e.reject(new R.$4)});try{for await(const Ae of x){if(X.token.isCancellationRequested)return;$e.emitOne(Ae)}pe.dispose(),X.dispose()}catch(Ae){pe.dispose(),X.dispose(),$e.reject(Ae)}})}class be{constructor(X){this.a=new oe,this.b=new ne(pe=>{if(x){pe.reject(x);return}return $e&&pe.emitMany($e),this.d=Ae=>pe.reject(Ae),this.f=Ae=>pe.emitOne(Ae),this.a.p},X);let x,$e;this.f=pe=>{$e||($e=[]),$e.push(pe)},this.d=pe=>{x||(x=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$8h=be}),define(Ne[41],Le([1,0,17,10,27,51,28,19,20,12]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wk=e.$vk=void 0,e.$uk=I,e.$xk=r,e.$yk=M,e.$zk=N,e.$Ak=L,e.$Bk=W,e.$Ck=K,e.$Dk=ae;function I(){return Object.create(null)}e.$vk="**",e.$wk="/";const y="[/\\\\]",a="[^/\\\\]",S=/\//g;function d(we,le){switch(we){case 0:return"";case 1:return`${a}*?`;default:return`(?:${y}|${a}+${y}${le?`|${y}${a}+`:""})*?`}}function r(we,le){if(!we)return[];const _=[];let ce=!1,me=!1,oe="";for(const ke of we){switch(ke){case le:if(!ce&&!me){_.push(oe),oe="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":me=!0;break;case"]":me=!1;break}oe+=ke}return oe&&_.push(oe),_}function s(we){if(!we)return"";let le="";const _=r(we,e.$wk);if(_.every(ce=>ce===e.$vk))le=".*";else{let ce=!1;_.forEach((me,oe)=>{if(me===e.$vk){if(ce)return;le+=d(2,oe===_.length-1)}else{let ke=!1,Te="",Z=!1,B="";for(const ne of me){if(ne!=="}"&&ke){Te+=ne;continue}if(Z&&(ne!=="]"||!B)){let Ee;ne==="-"?Ee=ne:(ne==="^"||ne==="!")&&!B?Ee="^":ne===e.$wk?Ee="":Ee=(0,o.$hf)(ne),B+=Ee;continue}switch(ne){case"{":ke=!0;continue;case"[":Z=!0;continue;case"}":{const fe=`(?:${r(Te,",").map(be=>s(be)).join("|")})`;le+=fe,ke=!1,Te="";break}case"]":{le+="["+B+"]",Z=!1,B="";break}case"?":le+=a;continue;case"*":le+=d(1);continue;default:le+=(0,o.$hf)(ne)}}oe<_.length-1&&(_[oe+1]!==e.$vk||oe+2<_.length)&&(le+=y)}ce=me===e.$vk})}return le}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,t=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,u=new A.$Dc(1e4),$=function(){return!1},m=function(){return null};function h(we,le){if(!we)return m;let _;typeof we!="string"?_=we.pattern:_=we,_=_.trim();const ce=`${_}_${!!le.trimForExclusions}`;let me=u.get(ce);if(me)return E(me,we);let oe;return c.test(_)?me=w(_.substr(4),_):(oe=l.exec(D(_,le)))?me=C(oe[1],_):(le.trimForExclusions?n:i).test(_)?me=k(_,le):(oe=t.exec(D(_,le)))?me=f(oe[1].substr(1),_,!0):(oe=g.exec(D(_,le)))?me=f(oe[1],_,!1):me=b(_),u.set(ce,me),E(me,we)}function E(we,le){if(typeof le=="string")return we;const _=function(ce,me){return(0,O.$Dg)(ce,le.base,!p.$l)?we((0,o.$mf)(ce.substr(le.base.length),T.sep),me):null};return _.allBasenames=we.allBasenames,_.allPaths=we.allPaths,_.basenames=we.basenames,_.patterns=we.patterns,_}function D(we,le){return le.trimForExclusions&&we.endsWith("/**")?we.substr(0,we.length-2):we}function w(we,le){return function(_,ce){return typeof _=="string"&&_.endsWith(we)?le:null}}function C(we,le){const _=`/${we}`,ce=`\\${we}`,me=function(ke,Te){return typeof ke!="string"?null:Te?Te===we?le:null:ke===we||ke.endsWith(_)||ke.endsWith(ce)?le:null},oe=[we];return me.basenames=oe,me.patterns=[le],me.allBasenames=oe,me}function k(we,le){const _=Q(we.slice(1,-1).split(",").map(Te=>h(Te,le)).filter(Te=>Te!==m),we),ce=_.length;if(!ce)return m;if(ce===1)return _[0];const me=function(Te,Z){for(let B=0,ne=_.length;B<ne;B++)if(_[B](Te,Z))return we;return null},oe=_.find(Te=>!!Te.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const ke=_.reduce((Te,Z)=>Z.allPaths?Te.concat(Z.allPaths):Te,[]);return ke.length&&(me.allPaths=ke),me}function f(we,le,_){const ce=T.sep===T.$gc.sep,me=ce?we:we.replace(S,T.sep),oe=T.sep+me,ke=T.$gc.sep+we;let Te;return _?Te=function(Z,B){return typeof Z=="string"&&(Z===me||Z.endsWith(oe)||!ce&&(Z===we||Z.endsWith(ke)))?le:null}:Te=function(Z,B){return typeof Z=="string"&&(Z===me||!ce&&Z===we)?le:null},Te.allPaths=[(_?"*/":"./")+we],Te}function b(we){try{const le=new RegExp(`^${s(we)}$`);return function(_){return le.lastIndex=0,typeof _=="string"&&le.test(_)?we:null}}catch{return m}}function M(we,le,_){return!we||typeof le!="string"?!1:N(we)(le,void 0,_)}function N(we,le={}){if(!we)return $;if(typeof we=="string"||L(we)){const _=h(we,le);if(_===m)return $;const ce=function(me,oe){return!!_(me,oe)};return _.allBasenames&&(ce.allBasenames=_.allBasenames),_.allPaths&&(ce.allPaths=_.allPaths),ce}return q(we,le)}function L(we){const le=we;return le?typeof le.base=="string"&&typeof le.pattern=="string":!1}function W(we){return we.allBasenames||[]}function K(we){return we.allPaths||[]}function q(we,le){const _=Q(Object.getOwnPropertyNames(we).map(Te=>G(Te,we[Te],le)).filter(Te=>Te!==m)),ce=_.length;if(!ce)return m;if(!_.some(Te=>!!Te.requiresSiblings)){if(ce===1)return _[0];const Te=function(ne,Ee){let fe;for(let be=0,he=_.length;be<he;be++){const X=_[be](ne,Ee);if(typeof X=="string")return X;(0,R.$qh)(X)&&(fe||(fe=[]),fe.push(X))}return fe?(async()=>{for(const be of fe){const he=await be;if(typeof he=="string")return he}return null})():null},Z=_.find(ne=>!!ne.allBasenames);Z&&(Te.allBasenames=Z.allBasenames);const B=_.reduce((ne,Ee)=>Ee.allPaths?ne.concat(Ee.allPaths):ne,[]);return B.length&&(Te.allPaths=B),Te}const me=function(Te,Z,B){let ne,Ee;for(let fe=0,be=_.length;fe<be;fe++){const he=_[fe];he.requiresSiblings&&B&&(Z||(Z=(0,T.$nc)(Te)),ne||(ne=Z.substr(0,Z.length-(0,T.$oc)(Te).length)));const X=he(Te,Z,ne,B);if(typeof X=="string")return X;(0,R.$qh)(X)&&(Ee||(Ee=[]),Ee.push(X))}return Ee?(async()=>{for(const fe of Ee){const be=await fe;if(typeof be=="string")return be}return null})():null},oe=_.find(Te=>!!Te.allBasenames);oe&&(me.allBasenames=oe.allBasenames);const ke=_.reduce((Te,Z)=>Z.allPaths?Te.concat(Z.allPaths):Te,[]);return ke.length&&(me.allPaths=ke),me}function G(we,le,_){if(le===!1)return m;const ce=h(we,_);if(ce===m)return m;if(typeof le=="boolean")return ce;if(le){const me=le.when;if(typeof me=="string"){const oe=(ke,Te,Z,B)=>{if(!B||!ce(ke,Te))return null;const ne=me.replace("$(basename)",()=>Z),Ee=B(ne);return(0,R.$qh)(Ee)?Ee.then(fe=>fe?we:null):Ee?we:null};return oe.requiresSiblings=!0,oe}}return ce}function Q(we,le){const _=we.filter(Te=>!!Te.basenames);if(_.length<2)return we;const ce=_.reduce((Te,Z)=>{const B=Z.basenames;return B?Te.concat(B):Te},[]);let me;if(le){me=[];for(let Te=0,Z=ce.length;Te<Z;Te++)me.push(le)}else me=_.reduce((Te,Z)=>{const B=Z.patterns;return B?Te.concat(B):Te},[]);const oe=function(Te,Z){if(typeof Te!="string")return null;if(!Z){let ne;for(ne=Te.length;ne>0;ne--){const Ee=Te.charCodeAt(ne-1);if(Ee===P.CharCode.Slash||Ee===P.CharCode.Backslash)break}Z=Te.substr(ne)}const B=ce.indexOf(Z);return B!==-1?me[B]:null};oe.basenames=ce,oe.patterns=me,oe.allBasenames=ce;const ke=we.filter(Te=>!Te.basenames);return ke.push(oe),ke}function ae(we,le){return(0,v.$tb)(we,le,(_,ce)=>typeof _=="string"&&typeof ce=="string"?_===ce:typeof _!="string"&&typeof ce!="string"?_.base===ce.base&&_.pattern===ce.pattern:!1)}}),define(Ne[59],Le([1,0,13,98,23,12,2]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3k=e.MarkdownStringTextNewlineStyle=void 0,e.$4k=o,e.$5k=I,e.$6k=y,e.$7k=a,e.$8k=S,e.$9k=d,e.$0k=r,e.$$k=s;var T;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(T||(e.MarkdownStringTextNewlineStyle=T={}));class p{constructor(l="",i=!1){if(this.value=l,typeof this.value!="string")throw(0,v.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(l,i=T.Paragraph){return this.value+=a(this.supportThemeIcons?(0,R.$Wk)(l):l).replace(/([ \t]+)/g,(n,t)=>"&nbsp;".repeat(t.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===T.Break?`\\
`:`

`),this}appendMarkdown(l){return this.value+=l,this}appendCodeblock(l,i){return this.value+=`
${S(i,l)}
`,this}appendLink(l,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(l),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(l,i){const n=new RegExp((0,O.$hf)(i),"g");return l.replace(n,(t,g)=>l.charAt(g-1)!=="\\"?`\\${t}`:t)}}e.$3k=p;function o(c){return I(c)?!c.value:Array.isArray(c)?c.every(o):!0}function I(c){return c instanceof p?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function y(c,l){return c===l?!0:!c||!l?!1:c.value===l.value&&c.isTrusted===l.isTrusted&&c.supportThemeIcons===l.supportThemeIcons&&c.supportHtml===l.supportHtml&&(c.baseUri===l.baseUri||!!c.baseUri&&!!l.baseUri&&(0,P.$$g)(A.URI.from(c.baseUri),A.URI.from(l.baseUri)))}function a(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function S(c,l){const i=c.match(/^`+/gm)?.reduce((t,g)=>t.length>g.length?t:g).length??0,n=i>=3?i+1:3;return[`${"`".repeat(n)}${l}`,c,`${"`".repeat(n)}`].join(`
`)}function d(c){return c.replace(/"/g,"&quot;")}function r(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function s(c){const l=[],i=c.split("|").map(t=>t.trim());c=i[0];const n=i[1];if(n){const t=/height=(\d+)/.exec(n),g=/width=(\d+)/.exec(n),u=t?t[1]:"",$=g?g[1]:"",m=isFinite(parseInt($)),h=isFinite(parseInt(u));m&&l.push(`width="${$}"`),h&&l.push(`height="${u}"`)}return{href:c,dimensions:l}}}),define(Ne[99],Le([1,0,17,51,19,20,23,12]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yw=p,e.$Zw=I,e.$1w=a,e.$2w=S,e.$3w=c,e.$4w=i,e.$5w=n,e.$6w=t,e.$7w=g,e.$8w=u;function p(m,h){const{os:E,tildify:D,relative:w}=h;if(w){const f=o(m,w,E);if(typeof f=="string")return f}let C=m.fsPath;if(E===O.OperatingSystem.Windows&&!O.$j?C=C.replace(/\//g,"\\"):E!==O.OperatingSystem.Windows&&O.$j&&(C=C.replace(/\\/g,"/")),E!==O.OperatingSystem.Windows&&D?.userHome){const f=D.userHome.fsPath;let b;m.scheme!==D.userHome.scheme&&m.path[0]===P.$gc.sep&&m.path[1]!==P.$gc.sep?b=D.userHome.with({path:m.path}).fsPath:b=C,C=a(b,f,E)}return(E===O.OperatingSystem.Windows?P.$fc:P.$gc).normalize(I(C,E===O.OperatingSystem.Windows))}function o(m,h,E){const D=E===O.OperatingSystem.Windows?P.$fc:P.$gc,w=E===O.OperatingSystem.Linux?A.$8g:A.$0g,C=h.getWorkspace(),k=(0,v.$Nb)(C.folders);if(!k)return;m.scheme!==k.uri.scheme&&m.path[0]===P.$gc.sep&&m.path[1]!==P.$gc.sep&&(m=k.uri.with({path:m.path}));const f=h.getWorkspaceFolder(m);if(!f)return;let b;if(w.isEqual(f.uri,m)?b="":b=w.relativePath(f.uri,m)??"",b&&(b=D.normalize(b)),C.folders.length>1&&!h.noPrefix){const M=f.name?f.name:w.basenameOrAuthority(f.uri);b=b?`${M} \u2022 ${b}`:M}return b}function I(m,h=O.$j){return(0,R.$Ig)(m,h)?m.charAt(0).toUpperCase()+m.slice(1):m}let y=Object.create(null);function a(m,h,E=O.OS){if(E===O.OperatingSystem.Windows||!m||!h)return m;let D=y.original===h?y.normalized:void 0;D||(D=h,O.$j&&(D=(0,R.$xg)(D)),D=`${(0,T.$nf)(D,P.$gc.sep)}${P.$gc.sep}`,y={original:h,normalized:D});let w=m;return O.$j&&(w=(0,R.$xg)(w)),(E===O.OperatingSystem.Linux?w.startsWith(D):(0,T.$Gf)(w,D))?`~/${w.substr(D.length)}`:m}function S(m,h){return m.replace(/^~($|\/|\\)/,`${h}$1`)}const d="\u2026",r="\\\\",s="~";function c(m,h=P.sep){const E=new Array(m.length);let D=!1;for(let w=0;w<m.length;w++){const C=m[w];if(C===""){E[w]=`.${h}`;continue}if(!C){E[w]=C;continue}D=!0;let k="",f=C;f.indexOf(r)===0?(k=f.substr(0,f.indexOf(r)+r.length),f=f.substr(f.indexOf(r)+r.length)):f.indexOf(h)===0?(k=f.substr(0,f.indexOf(h)+h.length),f=f.substr(f.indexOf(h)+h.length)):f.indexOf(s)===0&&(k=f.substr(0,f.indexOf(s)+s.length),f=f.substr(f.indexOf(s)+s.length));const b=f.split(h);for(let M=1;D&&M<=b.length;M++)for(let N=b.length-M;D&&N>=0;N--){D=!1;let L=b.slice(N,N+M).join(h);for(let W=0;!D&&W<m.length;W++)if(W!==w&&m[W]&&m[W].indexOf(L)>-1){const K=N+M===b.length,q=N>0&&m[W].indexOf(h)>-1?h+L:L,G=m[W].endsWith(q);D=!K||G}if(!D){let W="";(b[0].endsWith(":")||k!=="")&&(N===1&&(N=0,M++,L=b[0]+h+L),N>0&&(W=b[0]+h),W=k+W),N>0&&(W=W+d+h),W=W+L,N+M<b.length&&(W=W+h+d),E[w]=W}}D&&(E[w]=C)}return E}var l;(function(m){m[m.TEXT=0]="TEXT",m[m.VARIABLE=1]="VARIABLE",m[m.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function i(m,h=Object.create(null)){const E=[];let D=!1,w="";for(const C of m)if(C==="$"||D&&C==="{")w&&E.push({value:w,type:l.TEXT}),w="",D=!0;else if(C==="}"&&D){const k=h[w];if(typeof k=="string")k.length&&E.push({value:k,type:l.VARIABLE});else if(k){const f=E[E.length-1];(!f||f.type!==l.SEPARATOR)&&E.push({value:k.label,type:l.SEPARATOR})}w="",D=!1}else w+=C;return w&&!D&&E.push({value:w,type:l.TEXT}),E.filter((C,k)=>{if(C.type===l.SEPARATOR){const f=E[k-1],b=E[k+1];return[f,b].every(M=>M&&(M.type===l.VARIABLE||M.type===l.TEXT)&&M.value.length>0)}return!0}).map(C=>C.value).join("")}function n(m,h){return O.$k||h?m.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$k?"&":"&&"):m.replace(/&&|&/g,E=>E==="&"?"&&":"&")}function t(m,h){return O.$k||h?m.replace(/\(&&\w\)|&&/g,""):O.$j?m.replace(/&&|&/g,E=>E==="&"?"&&":"&"):m.replace(/&&/g,"_")}function g(m){return m.replace(/&/g,"&&")}function u(m){if(m.endsWith("]")){const h=m.lastIndexOf(" [",m.length-2);if(h!==-1){const E=$(m.substring(0,h)),D=m.substring(h);return{name:E.name+D,parentPath:E.parentPath}}}return $(m)}function $(m){const h=m.indexOf("/")!==-1?P.$gc:P.$fc,E=h.basename(m),D=h.dirname(m);return E.length?{name:E,parentPath:D}:{name:D,parentPath:""}}}),define(Ne[150],Le([1,0,22,37,2]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mn=e.$Ln=void 0,e.$Nn=p,e.$On=I,e.$Pn=y;function O(a){return a.toJSON()}class A{constructor(S){this.a=S}transformIncoming(S){const d=this.a.transformIncoming(S);return d===S?S:O(P.URI.from(d))}transformOutgoing(S){const d=this.a.transformOutgoing(S);return d===S?S:O(P.URI.from(d))}transformOutgoingURI(S){const d=this.a.transformOutgoing(S);return d===S?S:P.URI.from(d)}transformOutgoingScheme(S){return this.a.transformOutgoingScheme(S)}}e.$Ln=A,e.$Mn=new class{transformIncoming(a){return a}transformOutgoing(a){return a}transformOutgoingURI(a){return a}transformOutgoingScheme(a){return a}};function T(a,S,d){if(!a||d>200)return null;if(typeof a=="object"){if(a instanceof P.URI)return S.transformOutgoing(a);for(const r in a)if(Object.hasOwnProperty.call(a,r)){const s=T(a[r],S,d+1);s!==null&&(a[r]=s)}}return null}function p(a,S){const d=T(a,S,0);return d===null?a:d}function o(a,S,d,r){if(!a||r>200)return null;if(typeof a=="object"){if(a.$mid===R.MarshalledId.Uri)return d?P.URI.revive(S.transformIncoming(a)):S.transformIncoming(a);if(a instanceof v.$Ne)return null;for(const s in a)if(Object.hasOwnProperty.call(a,s)){const c=o(a[s],S,d,r+1);c!==null&&(a[s]=c)}}return null}function I(a,S){const d=o(a,S,!1,0);return d===null?a:d}function y(a,S){const d=o(a,S,!0,0);return d===null?a:d}}),define(Ne[38],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1g=void 0,e.$Zg=R;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(P){return v.test(P)}e.$1g=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(T){for(let p=0;p<T.length;p++)T[p]=Math.floor(Math.random()*256);return T};const O=new Uint8Array(16),A=[];for(let T=0;T<256;T++)A.push(T.toString(16).padStart(2,"0"));return function(){P(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let p=0,o="";return o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+="-",o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o+=A[O[p++]],o}}()}),define(Ne[151],Le([1,0,17,40,38]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$su=e.$qu=void 0,e.$ou=O,e.$pu=A,e.$ru=o;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function A(y,a,S){const d={id:(0,P.$1g)(),name:y,uri:a,data:S};return{asString:async()=>"",asFile:()=>d,value:void 0}}class T{constructor(){this.a=new Map}get size(){let a=0;for(const S of this.a)a++;return a}has(a){return this.a.has(this.b(a))}matches(a){const S=[...this.a.keys()];return R.Iterable.some(this,([d,r])=>r.asFile())&&S.push("files"),I(p(a),S)}get(a){return this.a.get(this.b(a))?.[0]}append(a,S){const d=this.a.get(a);d?d.push(S):this.a.set(this.b(a),[S])}replace(a,S){this.a.set(this.b(a),[S])}delete(a){this.a.delete(this.b(a))}*[Symbol.iterator](){for(const[a,S]of this.a)for(const d of S)yield[a,d]}b(a){return p(a)}}e.$qu=T;function p(y){return y.toLowerCase()}function o(y,a){return I(p(y),a.map(p))}function I(y,a){if(y==="*/*")return a.length>0;if(a.includes(y))return!0;const S=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[d,r,s]=S;return s==="*"?a.some(c=>c.startsWith(r+"/")):!1}e.$su=Object.freeze({create:y=>(0,v.$Lb)(y.map(a=>a.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$su.split(y).filter(a=>!a.startsWith("#"))})}),define(Ne[152],Le([1,0,10,6,4,36,14]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eq=e.$dq=e.StorageState=e.StorageHint=void 0,e.$cq=p;var T;(function(a){a[a.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",a[a.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function p(a){const S=a;return S?.changed instanceof Map||S?.deleted instanceof Set}var o;(function(a){a[a.None=0]="None",a[a.Initialized=1]="Initialized",a[a.Closed=2]="Closed"})(o||(e.StorageState=o={}));class I extends P.$Uc{static{this.a=100}constructor(S,d=Object.create(null)){super(),this.r=S,this.s=d,this.b=this.B(new R.$oe),this.onDidChangeStorage=this.b.event,this.c=o.None,this.f=new Map,this.g=this.B(new v.$Ch(I.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(S=>this.u(S)))}u(S){this.b.pause();try{S.changed?.forEach((d,r)=>this.w(r,d)),S.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(S,d){if(this.c===o.Closed)return;let r=!1;(0,A.$ng)(d)?r=this.f.delete(S):this.f.get(S)!==d&&(this.f.set(S,d),r=!0),r&&this.b.fire({key:S,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===o.None&&(this.c=o.Initialized,this.s.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(S,d){const r=this.f.get(S);return(0,A.$ng)(r)?d:r}getBoolean(S,d){const r=this.get(S);return(0,A.$ng)(r)?d:r==="true"}getNumber(S,d){const r=this.get(S);return(0,A.$ng)(r)?d:parseInt(r,10)}getObject(S,d){const r=this.get(S);return(0,A.$ng)(r)?d:(0,O.$ai)(r)}async set(S,d,r=!1){if(this.c===o.Closed)return;if((0,A.$ng)(d))return this.delete(S,r);const s=(0,A.$gg)(d)||Array.isArray(d)?(0,O.$_h)(d):String(d);if(this.f.get(S)!==s)return this.f.set(S,s),this.j.set(S,s),this.h.delete(S),this.b.fire({key:S,external:r}),this.D()}async delete(S,d=!1){if(!(this.c===o.Closed||!this.f.delete(S)))return this.h.has(S)||this.h.add(S),this.j.delete(S),this.b.fire({key:S,external:d}),this.D()}async optimize(){if(this.c!==o.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=o.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const S={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(S).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(S){if(!(this.c===o.Closed||this.m))return this.D(S)}async D(S){return this.s.hint===T.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),S)}async whenFlushed(){if(this.z)return new Promise(S=>this.n.push(S))}isInMemory(){return this.s.hint===T.STORAGE_IN_MEMORY}}e.$dq=I;class y{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(S){S.insert?.forEach((d,r)=>this.a.set(r,d)),S.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$eq=y}),define(Ne[153],Le([1,0,27]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$yu=P;var R;(function(O){O[O.Unknown=0]="Unknown",O[O.Invalid=3]="Invalid",O[O.LF=1]="LF",O[O.CRLF=2]="CRLF"})(R||(e.StringEOL=R={}));function P(O){let A=0,T=0,p=0,o=R.Unknown;for(let I=0,y=O.length;I<y;I++){const a=O.charCodeAt(I);a===v.CharCode.CarriageReturn?(A===0&&(T=I),A++,I+1<y&&O.charCodeAt(I+1)===v.CharCode.LineFeed?(o|=R.CRLF,I++):o|=R.Invalid,p=I+1):a===v.CharCode.LineFeed&&(o|=R.LF,A===0&&(T=I),A++,p=I+1)}return A===0&&(T=O.length),[A,T,O.length-p,o]}}),define(Ne[154],Le([1,0,12,20,22]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=void 0,e.$bu=I,e.$cu=y,v=We(v),R=We(R),P=We(P);let O;function A(){return O||(O=new TextDecoder("UTF-16LE")),O}let T;function p(){return T||(T=new TextDecoder("UTF-16BE")),T}let o;function I(){return o||(o=R.$E()?A():p()),o}function y(d,r,s){const c=new Uint16Array(d.buffer,r,s);return s>0&&(c[0]===65279||c[0]===65534)?a(d,r,s):A().decode(c)}function a(d,r,s){const c=[];let l=0;for(let i=0;i<s;i++){const n=P.$Pe(d,r);r+=2,c[l++]=String.fromCharCode(n)}return c.join("")}class S{constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return I().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const s=this.a-this.d;s<=1&&(s===0||v.$Jf(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const s=r.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=r;return}for(let c=0;c<s;c++)this.b[this.d++]=r.charCodeAt(c)}}e.$du=S}),define(Ne[155],Le([1,0,22,154]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eu=void 0,e.$fu=A,v=We(v);function P(p){return p.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(o,I,y,a){this.oldPosition=o,this.oldText=I,this.newPosition=y,this.newText=a}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(o){return 4+2*o.length}static c(o,I,y){const a=I.length;v.$Se(o,a,y),y+=4;for(let S=0;S<a;S++)v.$Qe(o,I.charCodeAt(S),y),y+=2;return y}static d(o,I){const y=v.$Re(o,I);return I+=4,(0,R.$cu)(o,I,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(o,I){return v.$Se(o,this.oldPosition,I),I+=4,v.$Se(o,this.newPosition,I),I+=4,I=O.c(o,this.oldText,I),I=O.c(o,this.newText,I),I}static read(o,I,y){const a=v.$Re(o,I);I+=4;const S=v.$Re(o,I);I+=4;const d=O.d(o,I);I+=O.a(d);const r=O.d(o,I);return I+=O.a(r),y.push(new O(a,d,S,r)),I}}e.$eu=O;function A(p,o){return p===null||p.length===0?o:new T(p,o).compress()}class T{constructor(o,I){this.a=o,this.c=I,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let o=0,I=0,y=this.n(o),a=this.l(I);for(;o<this.f||I<this.h;){if(y===null){this.k(a),a=this.l(++I);continue}if(a===null){this.m(y),y=this.n(++o);continue}if(a.oldEnd<=y.newPosition){this.k(a),a=this.l(++I);continue}if(y.newEnd<=a.oldPosition){this.m(y),y=this.n(++o);continue}if(a.oldPosition<y.newPosition){const[c,l]=T.r(a,y.newPosition-a.oldPosition);this.k(c),a=l;continue}if(y.newPosition<a.oldPosition){const[c,l]=T.q(y,a.oldPosition-y.newPosition);this.m(c),y=l;continue}let r,s;if(a.oldEnd===y.newEnd)r=y,s=a,y=this.n(++o),a=this.l(++I);else if(a.oldEnd<y.newEnd){const[c,l]=T.q(y,a.oldLength);r=c,s=a,y=l,a=this.l(++I)}else{const[c,l]=T.r(a,y.newLength);r=y,s=c,y=this.n(++o),a=l}this.d[this.e++]=new O(r.oldPosition,r.oldText,s.newPosition,s.newText),this.g+=r.newLength-r.oldLength,this.j+=s.newLength-s.oldLength}const S=T.s(this.d);return T.t(S)}k(o){this.d[this.e++]=T.o(this.g,o),this.j+=o.newLength-o.oldLength}l(o){return o<this.h?this.c[o]:null}m(o){this.d[this.e++]=T.p(this.j,o),this.g+=o.newLength-o.oldLength}n(o){return o<this.f?this.a[o]:null}static o(o,I){return new O(I.oldPosition-o,I.oldText,I.newPosition,I.newText)}static p(o,I){return new O(I.oldPosition,I.oldText,I.newPosition+o,I.newText)}static q(o,I){const y=o.newText.substr(0,I),a=o.newText.substr(I);return[new O(o.oldPosition,o.oldText,o.newPosition,y),new O(o.oldEnd,"",o.newPosition+I,a)]}static r(o,I){const y=o.oldText.substr(0,I),a=o.oldText.substr(I);return[new O(o.oldPosition,y,o.newPosition,o.newText),new O(o.oldPosition+I,a,o.newEnd,"")]}static s(o){if(o.length===0)return o;const I=[];let y=0,a=o[0];for(let S=1;S<o.length;S++){const d=o[S];a.oldEnd===d.oldPosition?a=new O(a.oldPosition,a.oldText+d.oldText,a.newPosition,a.newText+d.newText):(I[y++]=a,a=d)}return I[y++]=a,I}static t(o){if(o.length===0)return o;const I=[];let y=0;for(let a=0;a<o.length;a++){const S=o[a];S.oldText!==S.newText&&(I[y++]=S)}return I}}}),define(Ne[156],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0,e.$kt={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ne[157],Le([1,0,41,19]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vu=P,e.$wu=O;function P(A,T,p,o,I,y){if(Array.isArray(A)){let a=0;for(const S of A){const d=P(S,T,p,o,I,y);if(d===10)return d;d>a&&(a=d)}return a}else{if(typeof A=="string")return o?A==="*"?5:A===p?10:0:0;if(A){const{language:a,pattern:S,scheme:d,hasAccessToAllModels:r,notebookType:s}=A;if(!o&&!r)return 0;s&&I&&(T=I);let c=0;if(d)if(d===T.scheme)c=10;else if(d==="*")c=5;else return 0;if(a)if(a===p)c=10;else if(a==="*")c=Math.max(c,5);else return 0;if(s)if(s===y)c=10;else if(s==="*"&&y!==void 0)c=Math.max(c,5);else return 0;if(S){let l;if(typeof S=="string"?l=S:l={...S,base:(0,R.$hc)(S.base)},l===T.fsPath||(0,v.$yk)(l,T.fsPath))c=10;else return 0}return c}else return 0}}function O(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(O):!!A.notebookType}}),define(Ne[158],Le([1,0,27,159]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wu=e.$Vu=e.IndentAction=void 0;var P;(function(p){p[p.None=0]="None",p[p.Indent=1]="Indent",p[p.IndentOutdent=2]="IndentOutdent",p[p.Outdent=3]="Outdent"})(P||(e.IndentAction=P={}));class O{constructor(o){if(this.e=null,this.f=!1,this.open=o.open,this.close=o.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(o.notIn))for(let I=0,y=o.notIn.length;I<y;I++)switch(o.notIn[I]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(o){switch(o){case R.StandardTokenType.Other:return!0;case R.StandardTokenType.Comment:return this.c;case R.StandardTokenType.String:return this.b;case R.StandardTokenType.RegEx:return this.d}}shouldAutoClose(o,I){if(o.getTokenCount()===0)return!0;const y=o.findTokenIndexAtOffset(I-2),a=o.getStandardTokenType(y);return this.isOK(a)}g(o,I){for(let y=o;y<=I;y++){const a=String.fromCharCode(y);if(!this.open.includes(a)&&!this.close.includes(a))return a}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(v.CharCode.Digit0,v.CharCode.Digit9)),this.e||(this.e=this.g(v.CharCode.a,v.CharCode.z)),this.e||(this.e=this.g(v.CharCode.A,v.CharCode.Z))),this.e}}e.$Vu=O;class A{constructor(o){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const I of o)T(this.autoClosingPairsOpenByStart,I.open.charAt(0),I),T(this.autoClosingPairsOpenByEnd,I.open.charAt(I.open.length-1),I),T(this.autoClosingPairsCloseByStart,I.close.charAt(0),I),T(this.autoClosingPairsCloseByEnd,I.close.charAt(I.close.length-1),I),I.close.length===1&&I.open.length===1&&T(this.autoClosingPairsCloseSingleChar,I.close,I)}}e.$Wu=A;function T(p,o,I){p.has(o)?p.get(o).push(I):p.set(o,[I])}}),define(Ne[160],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aD=e.NodeColor=e.$_C=void 0,e.$bD=P,e.$cD=O,e.$dD=o,e.$eD=I,e.$fD=y,e.$gD=a,e.$hD=S,e.$iD=d;class v{constructor(s,c){this.piece=s,this.color=c,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$aD)return P(this.right);let s=this;for(;s.parent!==e.$aD&&s.parent.left!==s;)s=s.parent;return s.parent===e.$aD?e.$aD:s.parent}prev(){if(this.left!==e.$aD)return O(this.left);let s=this;for(;s.parent!==e.$aD&&s.parent.right!==s;)s=s.parent;return s.parent===e.$aD?e.$aD:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$_C=v;var R;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(R||(e.NodeColor=R={})),e.$aD=new v(null,R.Black),e.$aD.parent=e.$aD,e.$aD.left=e.$aD,e.$aD.right=e.$aD,e.$aD.color=R.Black;function P(r){for(;r.left!==e.$aD;)r=r.left;return r}function O(r){for(;r.right!==e.$aD;)r=r.right;return r}function A(r){return r===e.$aD?0:r.size_left+r.piece.length+A(r.right)}function T(r){return r===e.$aD?0:r.lf_left+r.piece.lineFeedCnt+T(r.right)}function p(){e.$aD.parent=e.$aD}function o(r,s){const c=s.right;c.size_left+=s.size_left+(s.piece?s.piece.length:0),c.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=c.left,c.left!==e.$aD&&(c.left.parent=s),c.parent=s.parent,s.parent===e.$aD?r.root=c:s.parent.left===s?s.parent.left=c:s.parent.right=c,c.left=s,s.parent=c}function I(r,s){const c=s.left;s.left=c.right,c.right!==e.$aD&&(c.right.parent=s),c.parent=s.parent,s.size_left-=c.size_left+(c.piece?c.piece.length:0),s.lf_left-=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),s.parent===e.$aD?r.root=c:s===s.parent.right?s.parent.right=c:s.parent.left=c,c.right=s,s.parent=c}function y(r,s){let c,l;if(s.left===e.$aD?(l=s,c=l.right):s.right===e.$aD?(l=s,c=l.left):(l=P(s.right),c=l.right),l===r.root){r.root=c,c.color=R.Black,s.detach(),p(),r.root.parent=e.$aD;return}const i=l.color===R.Red;if(l===l.parent.left?l.parent.left=c:l.parent.right=c,l===s?(c.parent=l.parent,d(r,c)):(l.parent===s?c.parent=l:c.parent=l.parent,d(r,c),l.left=s.left,l.right=s.right,l.parent=s.parent,l.color=s.color,s===r.root?r.root=l:s===s.parent.left?s.parent.left=l:s.parent.right=l,l.left!==e.$aD&&(l.left.parent=l),l.right!==e.$aD&&(l.right.parent=l),l.size_left=s.size_left,l.lf_left=s.lf_left,d(r,l)),s.detach(),c.parent.left===c){const t=A(c),g=T(c);if(t!==c.parent.size_left||g!==c.parent.lf_left){const u=t-c.parent.size_left,$=g-c.parent.lf_left;c.parent.size_left=t,c.parent.lf_left=g,S(r,c.parent,u,$)}}if(d(r,c.parent),i){p();return}let n;for(;c!==r.root&&c.color===R.Black;)c===c.parent.left?(n=c.parent.right,n.color===R.Red&&(n.color=R.Black,c.parent.color=R.Red,o(r,c.parent),n=c.parent.right),n.left.color===R.Black&&n.right.color===R.Black?(n.color=R.Red,c=c.parent):(n.right.color===R.Black&&(n.left.color=R.Black,n.color=R.Red,I(r,n),n=c.parent.right),n.color=c.parent.color,c.parent.color=R.Black,n.right.color=R.Black,o(r,c.parent),c=r.root)):(n=c.parent.left,n.color===R.Red&&(n.color=R.Black,c.parent.color=R.Red,I(r,c.parent),n=c.parent.left),n.left.color===R.Black&&n.right.color===R.Black?(n.color=R.Red,c=c.parent):(n.left.color===R.Black&&(n.right.color=R.Black,n.color=R.Red,o(r,n),n=c.parent.left),n.color=c.parent.color,c.parent.color=R.Black,n.left.color=R.Black,I(r,c.parent),c=r.root));c.color=R.Black,p()}function a(r,s){for(d(r,s);s!==r.root&&s.parent.color===R.Red;)if(s.parent===s.parent.parent.left){const c=s.parent.parent.right;c.color===R.Red?(s.parent.color=R.Black,c.color=R.Black,s.parent.parent.color=R.Red,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,o(r,s)),s.parent.color=R.Black,s.parent.parent.color=R.Red,I(r,s.parent.parent))}else{const c=s.parent.parent.left;c.color===R.Red?(s.parent.color=R.Black,c.color=R.Black,s.parent.parent.color=R.Red,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,I(r,s)),s.parent.color=R.Black,s.parent.parent.color=R.Red,o(r,s.parent.parent))}r.root.color=R.Black}function S(r,s,c,l){for(;s!==r.root&&s!==e.$aD;)s.parent.left===s&&(s.parent.size_left+=c,s.parent.lf_left+=l),s=s.parent}function d(r,s){let c=0,l=0;if(s!==r.root){for(;s!==r.root&&s===s.parent.right;)s=s.parent;if(s!==r.root)for(s=s.parent,c=A(s.left)-s.size_left,l=T(s.left)-s.lf_left,s.size_left+=c,s.lf_left+=l;s!==r.root&&(c!==0||l!==0);)s.parent.left===s&&(s.parent.size_left+=c,s.parent.lf_left+=l),s=s.parent}}}),define(Ne[100],Le([1,0,27,101,32,52,160,102]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tD=e.$sD=e.$rD=void 0,e.$pD=y,e.$qD=a;const p=65535;function o(l){let i;return l[l.length-1]<65536?i=new Uint16Array(l.length):i=new Uint32Array(l.length),i.set(l,0),i}class I{constructor(i,n,t,g,u){this.lineStarts=i,this.cr=n,this.lf=t,this.crlf=g,this.isBasicASCII=u}}function y(l,i=!0){const n=[0];let t=1;for(let g=0,u=l.length;g<u;g++){const $=l.charCodeAt(g);$===v.CharCode.CarriageReturn?g+1<u&&l.charCodeAt(g+1)===v.CharCode.LineFeed?(n[t++]=g+2,g++):n[t++]=g+1:$===v.CharCode.LineFeed&&(n[t++]=g+1)}return i?o(n):n}function a(l,i){l.length=0,l[0]=0;let n=1,t=0,g=0,u=0,$=!0;for(let h=0,E=i.length;h<E;h++){const D=i.charCodeAt(h);D===v.CharCode.CarriageReturn?h+1<E&&i.charCodeAt(h+1)===v.CharCode.LineFeed?(u++,l[n++]=h+2,h++):(t++,l[n++]=h+1):D===v.CharCode.LineFeed?(g++,l[n++]=h+1):$&&D!==v.CharCode.Tab&&(D<32||D>126)&&($=!1)}const m=new I(o(l),t,g,u,$);return l.length=0,m}class S{constructor(i,n,t,g,u){this.bufferIndex=i,this.start=n,this.end=t,this.lineFeedCnt=g,this.length=u}}e.$rD=S;class d{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$sD=d;class r{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==A.$aD&&i.iterate(i.root,t=>(t!==A.$aD&&this.a.push(t.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartOffset<=i&&t.nodeStartOffset+t.node.piece.length>=i)return t}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const t=this.b[n];if(t.nodeStartLineNumber&&t.nodeStartLineNumber<i&&t.nodeStartLineNumber+t.node.piece.lineFeedCnt>=i)return t}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const t=this.b;for(let g=0;g<t.length;g++){const u=t[g];if(u.node.parent===null||u.nodeStartOffset>=i){t[g]=null,n=!0;continue}}if(n){const g=[];for(const u of t)u!==null&&g.push(u);this.b=g}}}class c{constructor(i,n,t){this.create(i,n,t)}create(i,n,t){this.a=[new d("",[0])],this.g={line:0,column:0},this.root=A.$aD,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=t;let g=null;for(let u=0,$=i.length;u<$;u++)if(i[u].buffer.length>0){i[u].lineStarts||(i[u].lineStarts=y(i[u].buffer));const m=new S(u+1,{line:0,column:0},{line:i[u].lineStarts.length-1,column:i[u].buffer.length-i[u].lineStarts[i[u].lineStarts.length-1]},i[u].lineStarts.length-1,i[u].buffer.length);this.a.push(i[u]),g=this.S(g,m)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=p,t=n-Math.floor(n/3),g=t*2;let u="",$=0;const m=[];if(this.iterate(this.root,h=>{const E=this.R(h),D=E.length;if($<=t||$+D<g)return u+=E,$+=D,!0;const w=u.replace(/\r\n|\r|\n/g,i);return m.push(new d(w,y(w))),u=E,$=D,!0}),$>0){const h=u.replace(/\r\n|\r|\n/g,i);m.push(new d(h,y(h)))}this.create(m,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new r(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,g=>{if(g===A.$aD)return!0;const u=this.R(g),$=u.length,m=i.G(n),h=i.G(n+$),E=i.getValueInRange2(m,h);return n+=$,u===E})}getOffsetAt(i,n){let t=0,g=this.root;for(;g!==A.$aD;)if(g.left!==A.$aD&&g.lf_left+1>=i)g=g.left;else if(g.lf_left+g.piece.lineFeedCnt+1>=i){t+=g.size_left;const u=this.B(g,i-g.lf_left-2);return t+=u+n-1}else i-=g.lf_left+g.piece.lineFeedCnt,t+=g.size_left+g.piece.length,g=g.right;return t}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,t=0;const g=i;for(;n!==A.$aD;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const u=this.A(n,i-n.size_left);if(t+=n.lf_left+u.index,u.index===0){const $=this.getOffsetAt(t+1,1),m=g-$;return new R.$Mt(t+1,m+1)}return new R.$Mt(t+1,u.remainder+1)}else if(i-=n.size_left+n.piece.length,t+=n.lf_left+n.piece.lineFeedCnt,n.right===A.$aD){const u=this.getOffsetAt(t+1,1),$=g-i-u;return new R.$Mt(t+1,$+1)}else n=n.right;return new R.$Mt(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const t=this.H(i.startLineNumber,i.startColumn),g=this.H(i.endLineNumber,i.endColumn),u=this.getValueInRange2(t,g);return n?n!==this.d||!this.f?u.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?u:u.replace(/\r\n|\r|\n/g,n):u}getValueInRange2(i,n){if(i.node===n.node){const m=i.node,h=this.a[m.piece.bufferIndex].buffer,E=this.u(m.piece.bufferIndex,m.piece.start);return h.substring(E+i.remainder,E+n.remainder)}let t=i.node;const g=this.a[t.piece.bufferIndex].buffer,u=this.u(t.piece.bufferIndex,t.piece.start);let $=g.substring(u+i.remainder,u+t.piece.length);for(t=t.next();t!==A.$aD;){const m=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(t===n.node){$+=m.substring(h,h+n.remainder);break}else $+=m.substr(h,t.piece.length);t=t.next()}return $}getLinesContent(){const i=[];let n=0,t="",g=!1;return this.iterate(this.root,u=>{if(u===A.$aD)return!0;const $=u.piece;let m=$.length;if(m===0)return!0;const h=this.a[$.bufferIndex].buffer,E=this.a[$.bufferIndex].lineStarts,D=$.start.line,w=$.end.line;let C=E[D]+$.start.column;if(g&&(h.charCodeAt(C)===v.CharCode.LineFeed&&(C++,m--),i[n++]=t,t="",g=!1,m===0))return!0;if(D===w)return!this.f&&h.charCodeAt(C+m-1)===v.CharCode.CarriageReturn?(g=!0,t+=h.substr(C,m-1)):t+=h.substr(C,m),!0;t+=this.f?h.substring(C,Math.max(C,E[D+1]-this.e)):h.substring(C,E[D+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;for(let k=D+1;k<w;k++)t=this.f?h.substring(E[k],E[k+1]-this.e):h.substring(E[k],E[k+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=t;return!this.f&&h.charCodeAt(E[w]+$.end.column-1)===v.CharCode.CarriageReturn?(g=!0,$.end.column===0?n--:t=h.substr(E[w],$.end.column-1)):t=h.substr(E[w],$.end.column),!0}),g&&(i[n++]=t,t=""),i[n++]=t,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const t=this.a[n.piece.bufferIndex],g=this.u(n.piece.bufferIndex,n.piece.start);return t.buffer.charCodeAt(g)}else{const n=this.a[i.node.piece.bufferIndex],g=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(g)}}getLineCharCode(i,n){const t=this.H(i,n+1);return this.l(t)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}getNearestChunk(i){const n=this.G(i);if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t||t===A.$aD)return"";const g=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return g.buffer.substring(u,u+t.piece.length)}else{const t=this.a[n.node.piece.bufferIndex],g=this.u(n.node.piece.bufferIndex,n.node.piece.start),u=g+n.remainder,$=g+n.node.piece.length;return t.buffer.substring(u,$)}}findMatchesInNode(i,n,t,g,u,$,m,h,E,D,w){const C=this.a[i.piece.bufferIndex],k=this.u(i.piece.bufferIndex,i.piece.start),f=this.u(i.piece.bufferIndex,u),b=this.u(i.piece.bufferIndex,$);let M;const N={line:0,column:0};let L,W;n._wordSeparators?(L=C.buffer.substring(f,b),W=K=>K+f,n.reset(0)):(L=C.buffer,W=K=>K,n.reset(f));do if(M=n.next(L),M){if(W(M.index)>=b)return D;this.s(i,W(M.index)-k,N);const K=this.t(i.piece.bufferIndex,u,N),q=N.line===u.line?N.column-u.column+g:N.column+1,G=q+M[0].length;if(w[D++]=(0,T.$lD)(new P.$Nt(t+K,q,t+K,G),M,h),W(M.index)+M[0].length>=b||D>=E)return D}while(M);return D}findMatchesLineByLine(i,n,t,g){const u=[];let $=0;const m=new T.$oD(n.wordSeparators,n.regex);let h=this.H(i.startLineNumber,i.startColumn);if(h===null)return[];const E=this.H(i.endLineNumber,i.endColumn);if(E===null)return[];let D=this.s(h.node,h.remainder);const w=this.s(E.node,E.remainder);if(h.node===E.node)return this.findMatchesInNode(h.node,m,i.startLineNumber,i.startColumn,D,w,n,t,g,$,u),u;let C=i.startLineNumber,k=h.node;for(;k!==E.node;){const b=this.t(k.piece.bufferIndex,D,k.piece.end);if(b>=1){const N=this.a[k.piece.bufferIndex].lineStarts,L=this.u(k.piece.bufferIndex,k.piece.start),W=N[D.line+b],K=C===i.startLineNumber?i.startColumn:1;if($=this.findMatchesInNode(k,m,C,K,D,this.s(k,W-L),n,t,g,$,u),$>=g)return u;C+=b}const M=C===i.startLineNumber?i.startColumn-1:0;if(C===i.endLineNumber){const N=this.getLineContent(C).substring(M,i.endColumn-1);return $=this.n(n,m,N,i.endLineNumber,M,$,u,t,g),u}if($=this.n(n,m,this.getLineContent(C).substr(M),C,M,$,u,t,g),$>=g)return u;C++,h=this.H(C,1),k=h.node,D=this.s(h.node,h.remainder)}if(C===i.endLineNumber){const b=C===i.startLineNumber?i.startColumn-1:0,M=this.getLineContent(C).substring(b,i.endColumn-1);return $=this.n(n,m,M,i.endLineNumber,b,$,u,t,g),u}const f=C===i.startLineNumber?i.startColumn:1;return $=this.findMatchesInNode(E.node,m,C,f,D,w,n,t,g,$,u),u}n(i,n,t,g,u,$,m,h,E){const D=i.wordSeparators;if(!h&&i.simpleSearch){const C=i.simpleSearch,k=C.length,f=t.length;let b=-k;for(;(b=t.indexOf(C,b+k))!==-1;)if((!D||(0,T.$nD)(D,t,f,b,k))&&(m[$++]=new O.$dw(new P.$Nt(g,b+1+u,g,b+1+k+u),null),$>=E))return $;return $}let w;n.reset(0);do if(w=n.next(t),w&&(m[$++]=(0,T.$lD)(new P.$Nt(g,w.index+1+u,g,w.index+1+w[0].length+u),w,h),$>=E))return $;while(w);return $}insert(i,n,t=!1){if(this.f=this.f&&t,this.j.lineNumber=0,this.j.value="",this.root!==A.$aD){const{node:g,remainder:u,nodeStartOffset:$}=this.G(i),m=g.piece,h=m.bufferIndex,E=this.s(g,u);if(g.piece.bufferIndex===0&&m.end.line===this.g.line&&m.end.column===this.g.column&&$+m.length===i&&n.length<p){this.F(g,n),this.y();return}if($===i)this.o(n,g),this.h.validate(i);else if($+g.piece.length>i){const D=[];let w=new S(m.bufferIndex,E,m.end,this.t(m.bufferIndex,E,m.end),this.u(h,m.end)-this.u(h,E));if(this.K()&&this.M(n)&&this.I(g,u)===10){const b={line:w.start.line+1,column:0};w=new S(w.bufferIndex,b,w.end,this.t(w.bufferIndex,b,w.end),w.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(g,u-1)===13){const b=this.s(g,u-1);this.C(g,b),n="\r"+n,g.piece.length===0&&D.push(g)}else this.C(g,E);else this.C(g,E);const C=this.w(n);w.length>0&&this.S(g,w);let k=g;for(let f=0;f<C.length;f++)k=this.S(k,C[f]);this.v(D)}else this.q(n,g)}else{const g=this.w(n);let u=this.T(null,g[0]);for(let $=1;$<g.length;$++)u=this.S(u,g[$])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===A.$aD)return;const t=this.G(i),g=this.G(i+n),u=t.node,$=g.node;if(u===$){const C=this.s(u,t.remainder),k=this.s(u,g.remainder);if(t.nodeStartOffset===i){if(n===u.piece.length){const f=u.next();(0,A.$fD)(this,u),this.N(f),this.y();return}this.D(u,k),this.h.validate(i),this.N(u),this.y();return}if(t.nodeStartOffset+u.piece.length===i+n){this.C(u,C),this.O(u),this.y();return}this.E(u,C,k),this.y();return}const m=[],h=this.s(u,t.remainder);this.C(u,h),this.h.validate(i),u.piece.length===0&&m.push(u);const E=this.s($,g.remainder);this.D($,E),$.piece.length===0&&m.push($);const D=u.next();for(let C=D;C!==A.$aD&&C!==$;C=C.next())m.push(C);const w=u.piece.length===0?u.prev():u;this.v(m),this.O(w),this.y()}o(i,n){const t=[];if(this.K()&&this.M(i)&&this.L(n)){const $=n.piece,m={line:$.start.line+1,column:0},h=new S($.bufferIndex,m,$.end,this.t($.bufferIndex,m,$.end),$.length-1);n.piece=h,i+=`
`,(0,A.$hD)(this,n,-1,-1),n.piece.length===0&&t.push(n)}const g=this.w(i);let u=this.T(n,g[g.length-1]);for(let $=g.length-2;$>=0;$--)u=this.T(u,g[$]);this.N(u),this.v(t)}q(i,n){this.Q(i,n)&&(i+=`
`);const t=this.w(i),g=this.S(n,t[0]);let u=g;for(let $=1;$<t.length;$++)u=this.S(u,t[$]);this.N(g)}s(i,n,t){const g=i.piece,u=i.piece.bufferIndex,$=this.a[u].lineStarts,h=$[g.start.line]+g.start.column+n;let E=g.start.line,D=g.end.line,w=0,C=0,k=0;for(;E<=D&&(w=E+(D-E)/2|0,k=$[w],w!==D);)if(C=$[w+1],h<k)D=w-1;else if(h>=C)E=w+1;else break;return t?(t.line=w,t.column=h-k,null):{line:w,column:h-k}}t(i,n,t){if(t.column===0)return t.line-n.line;const g=this.a[i].lineStarts;if(t.line===g.length-1)return t.line-n.line;const u=g[t.line+1],$=g[t.line]+t.column;if(u>$+1)return t.line-n.line;const m=$-1;return this.a[i].buffer.charCodeAt(m)===13?t.line-n.line+1:t.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,A.$fD)(this,i[n])}w(i){if(i.length>p){const D=[];for(;i.length>p;){const C=i.charCodeAt(p-1);let k;C===v.CharCode.CarriageReturn||C>=55296&&C<=56319?(k=i.substring(0,p-1),i=i.substring(p-1)):(k=i.substring(0,p),i=i.substring(p));const f=y(k);D.push(new S(this.a.length,{line:0,column:0},{line:f.length-1,column:k.length-f[f.length-1]},f.length-1,k.length)),this.a.push(new d(k,f))}const w=y(i);return D.push(new S(this.a.length,{line:0,column:0},{line:w.length-1,column:i.length-w[w.length-1]},w.length-1,i.length)),this.a.push(new d(i,w)),D}let n=this.a[0].buffer.length;const t=y(i,!1);let g=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},g=this.g;for(let D=0;D<t.length;D++)t[D]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let D=0;D<t.length;D++)t[D]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1)),this.a[0].buffer+=i}const u=this.a[0].buffer.length,$=this.a[0].lineStarts.length-1,m=u-this.a[0].lineStarts[$],h={line:$,column:m},E=new S(0,g,h,this.t(0,g,h),u-n);return this.g=h,[E]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let t=this.root,g="";const u=this.h.get2(i);if(u){t=u.node;const $=this.B(t,i-u.nodeStartLineNumber-1),m=this.a[t.piece.bufferIndex].buffer,h=this.u(t.piece.bufferIndex,t.piece.start);if(u.nodeStartLineNumber+t.piece.lineFeedCnt===i)g=m.substring(h+$,h+t.piece.length);else{const E=this.B(t,i-u.nodeStartLineNumber);return m.substring(h+$,h+E-n)}}else{let $=0;const m=i;for(;t!==A.$aD;)if(t.left!==A.$aD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const h=this.B(t,i-t.lf_left-2),E=this.B(t,i-t.lf_left-1),D=this.a[t.piece.bufferIndex].buffer,w=this.u(t.piece.bufferIndex,t.piece.start);return $+=t.size_left,this.h.set({node:t,nodeStartOffset:$,nodeStartLineNumber:m-(i-1-t.lf_left)}),D.substring(w+h,w+E-n)}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const h=this.B(t,i-t.lf_left-2),E=this.a[t.piece.bufferIndex].buffer,D=this.u(t.piece.bufferIndex,t.piece.start);g=E.substring(D+h,D+t.piece.length);break}else i-=t.lf_left+t.piece.lineFeedCnt,$+=t.size_left+t.piece.length,t=t.right}for(t=t.next();t!==A.$aD;){const $=this.a[t.piece.bufferIndex].buffer;if(t.piece.lineFeedCnt>0){const m=this.B(t,0),h=this.u(t.piece.bufferIndex,t.piece.start);return g+=$.substring(h,h+m-n),g}else{const m=this.u(t.piece.bufferIndex,t.piece.start);g+=$.substr(m,t.piece.length)}t=t.next()}return g}y(){let i=this.root,n=1,t=0;for(;i!==A.$aD;)n+=i.lf_left+i.piece.lineFeedCnt,t+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=t,this.h.validate(this.c)}A(i,n){const t=i.piece,g=this.s(i,n),u=g.line-t.start.line;if(this.u(t.bufferIndex,t.end)-this.u(t.bufferIndex,t.start)===n){const $=this.t(i.piece.bufferIndex,t.start,g);if($!==u)return{index:$,remainder:0}}return{index:u,remainder:g.column}}B(i,n){if(n<0)return 0;const t=i.piece,g=this.a[t.bufferIndex].lineStarts,u=t.start.line+n+1;return u>t.end.line?g[t.end.line]+t.end.column-g[t.start.line]-t.start.column:g[u]-g[t.start.line]-t.start.column}C(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.end),$=n,m=this.u(t.bufferIndex,$),h=this.t(t.bufferIndex,t.start,$),E=h-g,D=m-u,w=t.length+D;i.piece=new S(t.bufferIndex,t.start,$,h,w),(0,A.$hD)(this,i,D,E)}D(i,n){const t=i.piece,g=t.lineFeedCnt,u=this.u(t.bufferIndex,t.start),$=n,m=this.t(t.bufferIndex,$,t.end),h=this.u(t.bufferIndex,$),E=m-g,D=u-h,w=t.length+D;i.piece=new S(t.bufferIndex,$,t.end,m,w),(0,A.$hD)(this,i,D,E)}E(i,n,t){const g=i.piece,u=g.start,$=g.end,m=g.length,h=g.lineFeedCnt,E=n,D=this.t(g.bufferIndex,g.start,E),w=this.u(g.bufferIndex,n)-this.u(g.bufferIndex,u);i.piece=new S(g.bufferIndex,g.start,E,D,w),(0,A.$hD)(this,i,w-m,D-h);const C=new S(g.bufferIndex,t,$,this.t(g.bufferIndex,t,$),this.u(g.bufferIndex,$)-this.u(g.bufferIndex,t)),k=this.S(i,C);this.N(k)}F(i,n){this.Q(n,i)&&(n+=`
`);const t=this.K()&&this.L(n)&&this.M(i),g=this.a[0].buffer.length;this.a[0].buffer+=n;const u=y(n,!1);for(let k=0;k<u.length;k++)u[k]+=g;if(t){const k=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:g-k}}this.a[0].lineStarts=this.a[0].lineStarts.concat(u.slice(1));const $=this.a[0].lineStarts.length-1,m=this.a[0].buffer.length-this.a[0].lineStarts[$],h={line:$,column:m},E=i.piece.length+n.length,D=i.piece.lineFeedCnt,w=this.t(0,i.piece.start,h),C=w-D;i.piece=new S(i.piece.bufferIndex,i.piece.start,h,w,E),this.g=h,(0,A.$hD)(this,i,n.length,C)}G(i){let n=this.root;const t=this.h.get(i);if(t)return{node:t.node,nodeStartOffset:t.nodeStartOffset,remainder:i-t.nodeStartOffset};let g=0;for(;n!==A.$aD;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){g+=n.size_left;const u={node:n,remainder:i-n.size_left,nodeStartOffset:g};return this.h.set(u),u}else i-=n.size_left+n.piece.length,g+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let t=this.root,g=0;for(;t!==A.$aD;)if(t.left!==A.$aD&&t.lf_left>=i-1)t=t.left;else if(t.lf_left+t.piece.lineFeedCnt>i-1){const u=this.B(t,i-t.lf_left-2),$=this.B(t,i-t.lf_left-1);return g+=t.size_left,{node:t,remainder:Math.min(u+n-1,$),nodeStartOffset:g}}else if(t.lf_left+t.piece.lineFeedCnt===i-1){const u=this.B(t,i-t.lf_left-2);if(u+n-1<=t.piece.length)return{node:t,remainder:u+n-1,nodeStartOffset:g};n-=t.piece.length-u;break}else i-=t.lf_left+t.piece.lineFeedCnt,g+=t.size_left+t.piece.length,t=t.right;for(t=t.next();t!==A.$aD;){if(t.piece.lineFeedCnt>0){const u=this.B(t,0),$=this.J(t);return{node:t,remainder:Math.min(n-1,u),nodeStartOffset:$}}else if(t.piece.length>=n-1){const u=this.J(t);return{node:t,remainder:n-1,nodeStartOffset:u}}else n-=t.piece.length;t=t.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const t=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start)+n;return t.buffer.charCodeAt(g)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===A.$aD||i.piece.lineFeedCnt===0)return!1;const n=i.piece,t=this.a[n.bufferIndex].lineStarts,g=n.start.line,u=t[g]+n.start.column;return g===t.length-1||t[g+1]>u+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(u)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===A.$aD||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const t=[],g=this.a[i.piece.bufferIndex].lineStarts;let u;i.piece.end.column===0?u={line:i.piece.end.line-1,column:g[i.piece.end.line]-g[i.piece.end.line-1]-1}:u={line:i.piece.end.line,column:i.piece.end.column-1};const $=i.piece.length-1,m=i.piece.lineFeedCnt-1;i.piece=new S(i.piece.bufferIndex,i.piece.start,u,m,$),(0,A.$hD)(this,i,-1,-1),i.piece.length===0&&t.push(i);const h={line:n.piece.start.line+1,column:0},E=n.piece.length-1,D=this.t(n.piece.bufferIndex,h,n.piece.end);n.piece=new S(n.piece.bufferIndex,h,n.piece.end,D,E),(0,A.$hD)(this,n,-1,-1),n.piece.length===0&&t.push(n);const w=this.w(`\r
`);this.S(i,w[0]);for(let C=0;C<t.length;C++)(0,A.$fD)(this,t[C])}Q(i,n){if(this.K()&&this.M(i)){const t=n.next();if(this.L(t)){if(i+=`
`,t.piece.length===1)(0,A.$fD)(this,t);else{const g=t.piece,u={line:g.start.line+1,column:0},$=g.length-1,m=this.t(g.bufferIndex,u,g.end);t.piece=new S(g.bufferIndex,u,g.end,m,$),(0,A.$hD)(this,t,-1,-1)}return!0}}return!1}iterate(i,n){if(i===A.$aD)return n(A.$aD);const t=this.iterate(i.left,n);return t&&n(i)&&this.iterate(i.right,n)}R(i){if(i===A.$aD)return"";const n=this.a[i.piece.bufferIndex],t=i.piece,g=this.u(t.bufferIndex,t.start),u=this.u(t.bufferIndex,t.end);return n.buffer.substring(g,u)}getPieceContent(i){const n=this.a[i.bufferIndex],t=this.u(i.bufferIndex,i.start),g=this.u(i.bufferIndex,i.end);return n.buffer.substring(t,g)}S(i,n){const t=new A.$_C(n,A.NodeColor.Red);if(t.left=A.$aD,t.right=A.$aD,t.parent=A.$aD,t.size_left=0,t.lf_left=0,this.root===A.$aD)this.root=t,t.color=A.NodeColor.Black;else if(i.right===A.$aD)i.right=t,t.parent=i;else{const u=(0,A.$bD)(i.right);u.left=t,t.parent=u}return(0,A.$gD)(this,t),t}T(i,n){const t=new A.$_C(n,A.NodeColor.Red);if(t.left=A.$aD,t.right=A.$aD,t.parent=A.$aD,t.size_left=0,t.lf_left=0,this.root===A.$aD)this.root=t,t.color=A.NodeColor.Black;else if(i.left===A.$aD)i.left=t,t.parent=i;else{const g=(0,A.$cD)(i.left);g.right=t,t.parent=g}return(0,A.$gD)(this,t),t}U(i){let n="";return this.iterate(i,t=>(n+=this.R(t),!0)),n}}e.$tD=c}),define(Ne[161],Le([1,0,6,12,32,52,100,153,155,4]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uD=void 0,R=We(R);class I extends o.$Uc{constructor(a,S,d,r,s,c,l){super(),this.m=this.B(new v.$le),this.onDidChangeContent=this.m.event,this.f=S,this.j=!c,this.g=r,this.h=s,this.c=new A.$tD(a,d,l)}equals(a){return!(a instanceof I)||this.f!==a.f||this.getEOL()!==a.getEOL()?!1:this.c.equal(a.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(a){return this.c.createSnapshot(a?this.f:"")}getOffsetAt(a,S){return this.c.getOffsetAt(a,S)}getPositionAt(a){return this.c.getPositionAt(a)}getRangeAt(a,S){const d=a+S,r=this.getPositionAt(a),s=this.getPositionAt(d);return new P.$Nt(r.lineNumber,r.column,s.lineNumber,s.column)}getValueInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return"";const d=this.n(S);return this.c.getValueInRange(a,d)}getValueLengthInRange(a,S=O.EndOfLinePreference.TextDefined){if(a.isEmpty())return 0;if(a.startLineNumber===a.endLineNumber)return a.endColumn-a.startColumn;const d=this.getOffsetAt(a.startLineNumber,a.startColumn),r=this.getOffsetAt(a.endLineNumber,a.endColumn);let s=0;const c=this.n(S),l=this.getEOL();if(c.length!==l.length){const i=c.length-l.length,n=a.endLineNumber-a.startLineNumber;s=i*n}return r-d+s}getCharacterCountInRange(a,S=O.EndOfLinePreference.TextDefined){if(this.j){let d=0;const r=a.startLineNumber,s=a.endLineNumber;for(let c=r;c<=s;c++){const l=this.getLineContent(c),i=c===r?a.startColumn-1:0,n=c===s?a.endColumn-1:l.length;for(let t=i;t<n;t++)R.$Jf(l.charCodeAt(t))?(d=d+1,t=t+1):d=d+1}return d+=this.n(S).length*(s-r),d}return this.getValueLengthInRange(a,S)}getNearestChunk(a){return this.c.getNearestChunk(a)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(a){return this.c.getLineContent(a)}getLineCharCode(a,S){return this.c.getLineCharCode(a,S)}getCharCode(a){return this.c.getCharCode(a)}getLineLength(a){return this.c.getLineLength(a)}getLineMinColumn(a){return 1}getLineMaxColumn(a){return this.getLineLength(a)+1}getLineFirstNonWhitespaceColumn(a){const S=R.$uf(this.getLineContent(a));return S===-1?0:S+1}getLineLastNonWhitespaceColumn(a){const S=R.$wf(this.getLineContent(a));return S===-1?0:S+2}n(a){switch(a){case O.EndOfLinePreference.LF:return`
`;case O.EndOfLinePreference.CRLF:return`\r
`;case O.EndOfLinePreference.TextDefined:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(a){this.c.setEOL(a)}applyEdits(a,S,d){let r=this.g,s=this.h,c=this.j,l=!0,i=[];for(let h=0;h<a.length;h++){const E=a[h];l&&E._isTracked&&(l=!1);const D=E.range;if(E.text){let b=!0;c||(b=!R.$Uf(E.text),c=b),!r&&b&&(r=R.$Tf(E.text)),!s&&b&&(s=R.$Wf(E.text))}let w="",C=0,k=0,f=0;if(E.text){let b;[C,k,f,b]=(0,T.$yu)(E.text);const M=this.getEOL(),N=M===`\r
`?T.StringEOL.CRLF:T.StringEOL.LF;b===T.StringEOL.Unknown||b===N?w=E.text:w=E.text.replace(/\r\n|\r|\n/g,M)}i[h]={sortIndex:h,identifier:E.identifier||null,range:D,rangeOffset:this.getOffsetAt(D.startLineNumber,D.startColumn),rangeLength:this.getValueLengthInRange(D),text:w,eolCount:C,firstLineLength:k,lastLineLength:f,forceMoveMarkers:!!E.forceMoveMarkers,isAutoWhitespaceEdit:E.isAutoWhitespaceEdit||!1}}i.sort(I.u);let n=!1;for(let h=0,E=i.length-1;h<E;h++){const D=i[h].range.getEndPosition(),w=i[h+1].range.getStartPosition();if(w.isBeforeOrEqual(D)){if(w.isBefore(D))throw new Error("Overlapping ranges are not allowed!");n=!0}}l&&(i=this.s(i));const t=d||S?I._getInverseEditRanges(i):[],g=[];if(S)for(let h=0;h<i.length;h++){const E=i[h],D=t[h];if(E.isAutoWhitespaceEdit&&E.range.isEmpty())for(let w=D.startLineNumber;w<=D.endLineNumber;w++){let C="";w===D.startLineNumber&&(C=this.getLineContent(E.range.startLineNumber),R.$uf(C)!==-1)||g.push({lineNumber:w,oldContent:C})}}let u=null;if(d){let h=0;u=[];for(let E=0;E<i.length;E++){const D=i[E],w=t[E],C=this.getValueInRange(D.range),k=D.rangeOffset+h;h+=D.text.length-C.length,u[E]={sortIndex:D.sortIndex,identifier:D.identifier,range:w,text:C,textChange:new p.$eu(D.rangeOffset,C,k,D.text)}}n||u.sort((E,D)=>E.sortIndex-D.sortIndex)}this.g=r,this.h=s,this.j=c;const $=this.t(i);let m=null;if(S&&g.length>0){g.sort((h,E)=>E.lineNumber-h.lineNumber),m=[];for(let h=0,E=g.length;h<E;h++){const D=g[h].lineNumber;if(h>0&&g[h-1].lineNumber===D)continue;const w=g[h].oldContent,C=this.getLineContent(D);C.length===0||C===w||R.$uf(C)!==-1||m.push(D)}}return this.m.fire(),new O.$hw(u,$,m)}s(a){return a.length<1e3?a:[this._toSingleEditOperation(a)]}_toSingleEditOperation(a){let S=!1;const d=a[0].range,r=a[a.length-1].range,s=new P.$Nt(d.startLineNumber,d.startColumn,r.endLineNumber,r.endColumn);let c=d.startLineNumber,l=d.startColumn;const i=[];for(let $=0,m=a.length;$<m;$++){const h=a[$],E=h.range;S=S||h.forceMoveMarkers,i.push(this.getValueInRange(new P.$Nt(c,l,E.startLineNumber,E.startColumn))),h.text.length>0&&i.push(h.text),c=E.endLineNumber,l=E.endColumn}const n=i.join(""),[t,g,u]=(0,T.$yu)(n);return{sortIndex:0,identifier:a[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,O.EndOfLinePreference.TextDefined),text:n,eolCount:t,firstLineLength:g,lastLineLength:u,forceMoveMarkers:S,isAutoWhitespaceEdit:!1}}t(a){a.sort(I.w);const S=[];for(let d=0;d<a.length;d++){const r=a[d],s=r.range.startLineNumber,c=r.range.startColumn,l=r.range.endLineNumber,i=r.range.endColumn;if(s===l&&c===i&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const n=new P.$Nt(s,c,l,i);S.push({range:n,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return S}findMatchesLineByLine(a,S,d,r){return this.c.findMatchesLineByLine(a,S,d,r)}getPieceTree(){return this.c}static _getInverseEditRange(a,S){const d=a.startLineNumber,r=a.startColumn,[s,c,l]=(0,T.$yu)(S);let i;if(S.length>0){const n=s+1;n===1?i=new P.$Nt(d,r,d,r+c):i=new P.$Nt(d,r,d+n-1,l+1)}else i=new P.$Nt(d,r,d,r);return i}static _getInverseEditRanges(a){const S=[];let d=0,r=0,s=null;for(let c=0,l=a.length;c<l;c++){const i=a[c];let n,t;s?s.range.endLineNumber===i.range.startLineNumber?(n=d,t=r+(i.range.startColumn-s.range.endColumn)):(n=d+(i.range.startLineNumber-s.range.endLineNumber),t=i.range.startColumn):(n=i.range.startLineNumber,t=i.range.startColumn);let g;if(i.text.length>0){const u=i.eolCount+1;u===1?g=new P.$Nt(n,t,n,t+i.firstLineLength):g=new P.$Nt(n,t,n+u-1,i.lastLineLength+1)}else g=new P.$Nt(n,t,n,t);d=g.endLineNumber,r=g.endColumn,S.push(g),s=i}return S}static u(a,S){const d=P.$Nt.compareRangesUsingEnds(a.range,S.range);return d===0?a.sortIndex-S.sortIndex:d}static w(a,S){const d=P.$Nt.compareRangesUsingEnds(a.range,S.range);return d===0?S.sortIndex-a.sortIndex:-d}}e.$uD=I}),define(Ne[162],Le([1,0,27,12,52,100,161]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vD=void 0,R=We(R);class T{constructor(I,y,a,S,d,r,s,c,l){this.a=I,this.b=y,this.c=a,this.d=S,this.e=d,this.f=r,this.g=s,this.h=c,this.j=l}k(I){const y=this.c+this.d+this.e,a=this.c+this.e;return y===0?I===P.DefaultEndOfLine.LF?`
`:`\r
`:a>y/2?`\r
`:`
`}create(I){const y=this.k(I),a=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let d=0,r=a.length;d<r;d++){const s=a[d].buffer.replace(/\r\n|\r|\n/g,y),c=(0,O.$pD)(s);a[d]=new O.$sD(s,c)}const S=new A.$uD(a,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(I){return this.a[0].buffer.substr(0,I).split(/\r\n|\r|\n/)[0]}}class p{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(I){if(I.length===0)return;this.a.length===0&&R.$5f(I)&&(this.b=R.$4f,I=I.substr(1));const y=I.charCodeAt(I.length-1);y===v.CharCode.CarriageReturn||y>=55296&&y<=56319?(this.m(I.substr(0,I.length-1),!1),this.c=!0,this.d=y):(this.m(I,!1),this.c=!1,this.d=y)}m(I,y){!y&&I.length===0||(this.c?this.n(String.fromCharCode(this.d)+I):this.n(I))}n(I){const y=(0,O.$qD)(this.e,I);this.a.push(new O.$sD(I,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=R.$Tf(I)),this.k||(this.k=R.$Wf(I)))}finish(I=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,I)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const I=this.a[this.a.length-1];I.buffer+=String.fromCharCode(this.d);const y=(0,O.$pD)(I.buffer);I.lineStarts=y,this.d===v.CharCode.CarriageReturn&&this.f++}}}e.$vD=p}),define(Ne[103],Le([1,0,22,20]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wdb=p,e.$Xdb=I,R=We(R);var P;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(P||(P={}));function O(y){for(let a=0,S=y.length;a<S;a+=4){const d=y[a+0],r=y[a+1],s=y[a+2],c=y[a+3];y[a+0]=c,y[a+1]=s,y[a+2]=r,y[a+3]=d}}function A(y){const a=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return R.$E()||O(a),v.$Ne.wrap(a)}function T(y){const a=y.buffer;if(R.$E()||O(a),a.byteOffset%4===0)return new Uint32Array(a.buffer,a.byteOffset,a.length/4);{const S=new Uint8Array(a.byteLength);return S.set(a),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function p(y){const a=new Uint32Array(o(y));let S=0;if(a[S++]=y.id,y.type==="full")a[S++]=P.Full,a[S++]=y.data.length,a.set(y.data,S),S+=y.data.length;else{a[S++]=P.Delta,a[S++]=y.deltas.length;for(const d of y.deltas)a[S++]=d.start,a[S++]=d.deleteCount,d.data?(a[S++]=d.data.length,a.set(d.data,S),S+=d.data.length):a[S++]=0}return A(a)}function o(y){let a=0;if(a+=2,y.type==="full")a+=1+y.data.length;else{a+=1,a+=3*y.deltas.length;for(const S of y.deltas)S.data&&(a+=S.data.length)}return a}function I(y){const a=T(y);let S=0;const d=a[S++];if(a[S++]===P.Full){const l=a[S++],i=a.subarray(S,S+l);return S+=l,{id:d,type:"full",data:i}}const s=a[S++],c=[];for(let l=0;l<s;l++){const i=a[S++],n=a[S++],t=a[S++];let g;t>0&&(g=a.subarray(S,S+t),S+=t),c[l]={start:i,deleteCount:n,data:g}}return{id:d,type:"delta",deltas:c}}}),define(Ne[163],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_=e.$N_=void 0;class v{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const A=this.a.get(O);return this.a.delete(O),A}}addDragOperationTransfer(O,A){this.a.set(O,A)}}e.$N_=v;class R{constructor(O){this.identifier=O}}e.$O_=R}),define(Ne[164],Le([1,0,6,4,9]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=void 0,e.$oj=I,P=We(P);class O extends R.$Uc{constructor(a,S="",d="",r=!0,s){super(),this.j=this.B(new v.$le),this.onDidChange=this.j.event,this.z=!0,this.m=a,this.n=S,this.w=d,this.z=r,this.D=s}get id(){return this.m}get label(){return this.n}set label(a){this.F(a)}F(a){this.n!==a&&(this.n=a,this.j.fire({label:a}))}get tooltip(){return this.u||""}set tooltip(a){this.G(a)}G(a){this.u!==a&&(this.u=a,this.j.fire({tooltip:a}))}get class(){return this.w}set class(a){this.H(a)}H(a){this.w!==a&&(this.w=a,this.j.fire({class:a}))}get enabled(){return this.z}set enabled(a){this.I(a)}I(a){this.z!==a&&(this.z=a,this.j.fire({enabled:a}))}get checked(){return this.C}set checked(a){this.J(a)}J(a){this.C!==a&&(this.C=a,this.j.fire({checked:a}))}async run(a,S){this.D&&await this.D(a)}}e.$jj=O;class A extends R.$Uc{constructor(){super(...arguments),this.f=this.B(new v.$le),this.onWillRun=this.f.event,this.m=this.B(new v.$le),this.onDidRun=this.m.event}async run(a,S){if(!a.enabled)return;this.f.fire({action:a});let d;try{await this.u(a,S)}catch(r){d=r}this.m.fire({action:a,error:d})}async u(a,S){await a.run(S)}}e.$kj=A;class T{constructor(){this.id=T.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...a){let S=[];for(const d of a)d.length&&(S.length?S=[...S,new T,...d]:S=d);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$lj=T;class p{get actions(){return this.a}constructor(a,S,d,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=a,this.label=S,this.class=r,this.a=d}async run(){}}e.$mj=p;class o extends O{static{this.ID="vs.actions.empty"}constructor(){super(o.ID,P.localize(13039,null),void 0,!1)}}e.$nj=o;function I(y){return{id:y.id,label:y.label,tooltip:y.tooltip??y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...a)=>y.run(...a)}}}),define(Ne[165],Le([1,0,9]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=o,e.$2m=I,e.$3m=y;const R=60,P=R*60,O=P*24,A=O*7,T=O*30,p=O*365;function o(a,S,d,r){typeof a!="number"&&(a=a.getTime());const s=Math.round((new Date().getTime()-a)/1e3);if(s<-30)return(0,v.localize)(12976,null,o(new Date().getTime()+s*1e3,!1));if(!r&&s<30)return(0,v.localize)(12977,null);let c;return s<R?(c=s,S?c===1?d?(0,v.localize)(12978,null,c):(0,v.localize)(12979,null,c):d?(0,v.localize)(12980,null,c):(0,v.localize)(12981,null,c):c===1?d?(0,v.localize)(12982,null,c):(0,v.localize)(12983,null,c):d?(0,v.localize)(12984,null,c):(0,v.localize)(12985,null,c)):s<P?(c=Math.floor(s/R),S?c===1?d?(0,v.localize)(12986,null,c):(0,v.localize)(12987,null,c):d?(0,v.localize)(12988,null,c):(0,v.localize)(12989,null,c):c===1?d?(0,v.localize)(12990,null,c):(0,v.localize)(12991,null,c):d?(0,v.localize)(12992,null,c):(0,v.localize)(12993,null,c)):s<O?(c=Math.floor(s/P),S?c===1?d?(0,v.localize)(12994,null,c):(0,v.localize)(12995,null,c):d?(0,v.localize)(12996,null,c):(0,v.localize)(12997,null,c):c===1?d?(0,v.localize)(12998,null,c):(0,v.localize)(12999,null,c):d?(0,v.localize)(13e3,null,c):(0,v.localize)(13001,null,c)):s<A?(c=Math.floor(s/O),S?c===1?(0,v.localize)(13002,null,c):(0,v.localize)(13003,null,c):c===1?(0,v.localize)(13004,null,c):(0,v.localize)(13005,null,c)):s<T?(c=Math.floor(s/A),S?c===1?d?(0,v.localize)(13006,null,c):(0,v.localize)(13007,null,c):d?(0,v.localize)(13008,null,c):(0,v.localize)(13009,null,c):c===1?d?(0,v.localize)(13010,null,c):(0,v.localize)(13011,null,c):d?(0,v.localize)(13012,null,c):(0,v.localize)(13013,null,c)):s<p?(c=Math.floor(s/T),S?c===1?d?(0,v.localize)(13014,null,c):(0,v.localize)(13015,null,c):d?(0,v.localize)(13016,null,c):(0,v.localize)(13017,null,c):c===1?d?(0,v.localize)(13018,null,c):(0,v.localize)(13019,null,c):d?(0,v.localize)(13020,null,c):(0,v.localize)(13021,null,c)):(c=Math.floor(s/p),S?c===1?d?(0,v.localize)(13022,null,c):(0,v.localize)(13023,null,c):d?(0,v.localize)(13024,null,c):(0,v.localize)(13025,null,c):c===1?d?(0,v.localize)(13026,null,c):(0,v.localize)(13027,null,c):d?(0,v.localize)(13028,null,c):(0,v.localize)(13029,null,c))}function I(a,S){const d=Math.abs(a/1e3);return d<1?S?(0,v.localize)(13030,null,a):(0,v.localize)(13031,null,a):d<R?S?(0,v.localize)(13032,null,Math.round(a)/1e3):(0,v.localize)(13033,null,Math.round(a)/1e3):d<P?S?(0,v.localize)(13034,null,Math.round(a/(1e3*R))):(0,v.localize)(13035,null,Math.round(a/(1e3*R))):d<O?S?(0,v.localize)(13036,null,Math.round(a/(1e3*P))):(0,v.localize)(13037,null,Math.round(a/(1e3*P))):(0,v.localize)(13038,null,Math.round(a/(1e3*O)))}function y(a){return a.getFullYear()+"-"+String(a.getMonth()+1).padStart(2,"0")+"-"+String(a.getDate()).padStart(2,"0")+"T"+String(a.getHours()).padStart(2,"0")+":"+String(a.getMinutes()).padStart(2,"0")+":"+String(a.getSeconds()).padStart(2,"0")+"."+(a.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ne[42],Le([1,0,17,14,9]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=p,e.$qj=o,e.$rj=I,v=We(v),R=We(R),P=We(P);function O(y,a){return a&&(y.stack||y.stacktrace)?P.localize(12970,null,T(y),A(y.stack)||A(y.stacktrace)):T(y)}function A(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?P.localize(12971,null,y.message):y.message||P.localize(12972,null)}function p(y=null,a=!1){if(!y)return P.localize(12973,null);if(Array.isArray(y)){const S=v.$Gb(y),d=p(S[0],a);return S.length>1?P.localize(12974,null,d,S.length):d}if(R.$eg(y))return y;if(y.detail){const S=y.detail;if(S.error)return O(S.error,a);if(S.exception)return O(S.exception,a)}return y.stack?O(y,a):y.message?y.message:P.localize(12975,null)}function o(y){const a=y;return a instanceof Error&&Array.isArray(a.actions)}function I(y,a){let S;return typeof y=="string"?S=new Error(y):S=y,S.actions=a,S}}),define(Ne[166],Le([1,0,27,13,9]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zj=e.TokenType=void 0;var O;(function(I){I[I.LParen=0]="LParen",I[I.RParen=1]="RParen",I[I.Neg=2]="Neg",I[I.Eq=3]="Eq",I[I.NotEq=4]="NotEq",I[I.Lt=5]="Lt",I[I.LtEq=6]="LtEq",I[I.Gt=7]="Gt",I[I.GtEq=8]="GtEq",I[I.RegexOp=9]="RegexOp",I[I.RegexStr=10]="RegexStr",I[I.True=11]="True",I[I.False=12]="False",I[I.In=13]="In",I[I.Not=14]="Not",I[I.And=15]="And",I[I.Or=16]="Or",I[I.Str=17]="Str",I[I.QuotedStr=18]="QuotedStr",I[I.Error=19]="Error",I[I.EOF=20]="EOF"})(O||(e.TokenType=O={}));function A(...I){switch(I.length){case 1:return(0,P.localize)(11574,null,I[0]);case 2:return(0,P.localize)(11575,null,I[0],I[1]);case 3:return(0,P.localize)(11576,null,I[0],I[1],I[2]);default:return}}const T=(0,P.localize)(11577,null),p=(0,P.localize)(11578,null);class o{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case O.LParen:return"(";case O.RParen:return")";case O.Neg:return"!";case O.Eq:return y.isTripleEq?"===":"==";case O.NotEq:return y.isTripleEq?"!==":"!=";case O.Lt:return"<";case O.LtEq:return"<=";case O.Gt:return">=";case O.GtEq:return">=";case O.RegexOp:return"=~";case O.RegexStr:return y.lexeme;case O.True:return"true";case O.False:return"false";case O.In:return"in";case O.Not:return"not";case O.And:return"&&";case O.Or:return"||";case O.Str:return y.lexeme;case O.QuotedStr:return y.lexeme;case O.Error:return y.lexeme;case O.EOF:return"EOF";default:throw(0,R.$7)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",O.Not],["in",O.In],["false",O.False],["true",O.True]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case v.CharCode.OpenParen:this.k(O.LParen);break;case v.CharCode.CloseParen:this.k(O.RParen);break;case v.CharCode.ExclamationMark:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.NotEq,offset:this.d,isTripleEq:a})}else this.k(O.Neg);break;case v.CharCode.SingleQuote:this.o();break;case v.CharCode.Slash:this.q();break;case v.CharCode.Equals:if(this.h(v.CharCode.Equals)){const a=this.h(v.CharCode.Equals);this.f.push({type:O.Eq,offset:this.d,isTripleEq:a})}else this.h(v.CharCode.Tilde)?this.k(O.RegexOp):this.l(A("==","=~"));break;case v.CharCode.LessThan:this.k(this.h(v.CharCode.Equals)?O.LtEq:O.Lt);break;case v.CharCode.GreaterThan:this.k(this.h(v.CharCode.Equals)?O.GtEq:O.Gt);break;case v.CharCode.Ampersand:this.h(v.CharCode.Ampersand)?this.k(O.And):this.l(A("&&"));break;case v.CharCode.Pipe:this.h(v.CharCode.Pipe)?this.k(O.Or):this.l(A("||"));break;case v.CharCode.Space:case v.CharCode.CarriageReturn:case v.CharCode.Tab:case v.CharCode.LineFeed:case v.CharCode.NoBreakSpace:break;default:this.n()}return this.d=this.e,this.k(O.EOF),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?v.CharCode.Null:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const a=this.d,S=this.c.substring(this.d,this.e),d={type:O.Error,offset:this.d,lexeme:S};this.g.push({offset:a,lexeme:S,additionalInfo:y}),this.f.push(d)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const a=this.c.substring(this.d,this.e),S=o.b.get(a);S?this.k(S):this.f.push({type:O.Str,lexeme:a,offset:this.d})}}o(){for(;this.j()!==v.CharCode.SingleQuote&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:O.QuotedStr,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,a=!1,S=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(p);return}const r=this.c.charCodeAt(y);if(a)a=!1;else if(r===v.CharCode.Slash&&!S){y++;break}else r===v.CharCode.OpenSquareBracket?S=!0:r===v.CharCode.Backslash?a=!0:r===v.CharCode.CloseSquareBracket&&(S=!1);y++}for(;y<this.c.length&&o.a.has(this.c.charCodeAt(y));)y++;this.e=y;const d=this.c.substring(this.d,this.e);this.f.push({type:O.RegexStr,lexeme:d,offset:this.d})}r(){return this.e>=this.c.length}}e.$zj=o}),define(Ne[104],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0;const v={activeComment:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts"},aiRelatedInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts"},aiTextSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts"},aiTextSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProviderNew.d.ts"},attributableCoverage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts"},authGetSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts"},authLearnMore:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts"},authSession:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts"},canonicalUriProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts"},chatParticipantAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts"},chatParticipantPrivate:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantPrivate.d.ts",version:2},chatProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts"},chatTab:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts"},chatVariableResolver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts"},codeActionAI:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts"},codeActionRanges:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts"},codiconDecoration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts"},commentReactor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts"},commentReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReveal.d.ts"},commentThreadApplicability:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts"},commentingRangeHint:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts"},commentsDraftState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts"},contribAccessibilityHelpContent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts"},contribCommentEditorActionsMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts"},contribCommentPeekContext:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts"},contribCommentThreadAdditionalMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts"},contribCommentsViewThreadMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts"},contribDiffEditorGutterToolBarMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts"},contribEditSessions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts"},contribEditorContentMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts"},contribIssueReporter:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts"},contribLabelFormatterWorkspaceTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts"},contribMenuBarHome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts"},contribMergeEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts"},contribMultiDiffEditorMenus:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts"},contribNotebookStaticPreloads:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts"},contribRemoteHelp:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts"},contribShareMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts"},contribSourceControlHistoryItemChangesMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemChangesMenu.d.ts"},contribSourceControlHistoryItemGroupMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts"},contribSourceControlHistoryItemMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts"},contribSourceControlInputBoxMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts"},contribSourceControlTitleMenu:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts"},contribStatusBarItems:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts"},contribViewsRemote:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts"},contribViewsWelcome:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts"},createFileSystemWatcher:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts"},customEditorMove:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts"},debugVisualization:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts"},defaultChatParticipant:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts"},diffCommand:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts"},diffContentOptions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts"},documentFiltersExclusive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts"},documentPaste:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts"},editSessionIdentityProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts"},editorHoverVerbosityLevel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts"},editorInsets:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts"},embeddings:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts"},extensionRuntime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts"},extensionsAny:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts"},externalUriOpener:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts"},fileComments:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts"},fileSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts"},fileSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProviderNew.d.ts"},findFiles2:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts"},findFiles2New:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2New.d.ts"},findTextInFiles:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts"},findTextInFilesNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFilesNew.d.ts"},fsChunks:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts"},idToken:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts"},inlineCompletionsAdditions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts"},inlineEdit:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts"},interactive:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts"},interactiveWindow:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts"},ipc:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts"},languageModelSystem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts"},languageStatusText:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts"},lmTools:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.lmTools.d.ts",version:2},mappedEditsProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts"},multiDocumentHighlightProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts"},newSymbolNamesProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts"},notebookCellExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts"},notebookCellExecutionState:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts"},notebookControllerAffinityHidden:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts"},notebookDeprecated:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts"},notebookExecution:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts"},notebookKernelSource:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts"},notebookLiveShare:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts"},notebookMessaging:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts"},notebookMime:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts"},notebookVariableProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts"},portsAttributes:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts"},profileContentHandlers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts"},quickDiffProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts"},quickInputButtonLocation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickInputButtonLocation.d.ts"},quickPickItemTooltip:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts"},quickPickSortByLabel:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts"},resolvers:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts"},scmActionButton:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts"},scmHistoryProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts"},scmMultiDiffEditor:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts"},scmSelectedProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts"},scmTextDocument:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts"},scmValidation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts"},shareProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts"},showLocal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts"},speech:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts"},tabInputMultiDiff:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts"},tabInputTextMerge:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts"},taskPresentationGroup:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts"},telemetry:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts"},terminalDataWriteEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts"},terminalDimensions:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts"},terminalExecuteCommandEvent:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts"},terminalQuickFixProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts"},terminalSelection:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts"},terminalShellIntegration:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts"},testMessageStackTrace:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testMessageStackTrace.d.ts"},testObserver:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts"},testRelatedCode:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testRelatedCode.d.ts"},textSearchCompleteNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchCompleteNew.d.ts"},textSearchProvider:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts"},textSearchProviderNew:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProviderNew.d.ts"},timeline:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts"},tokenInformation:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts"},treeViewActiveItem:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts"},treeViewMarkdownMessage:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts"},treeViewReveal:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts"},tunnelFactory:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts"},tunnels:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts"},workspaceTrust:{proposal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"}};e.allApiProposals=Object.freeze(v)}),define(Ne[73],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=void 0;class v{constructor(P,O=[],A=!1){this.ctor=P,this.staticArguments=O,this.supportsDelayedInstantiation=A}}e.$Bi=v}),define(Ne[60],Le([1,0,73]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Qs=O,e.$Rs=A;const R=[];var P;(function(T){T[T.Eager=0]="Eager",T[T.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function O(T,p,o){p instanceof v.$Bi||(p=new v.$Bi(p,[],!!o)),R.push([T,p])}function A(){return R}}),define(Ne[167],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=e.$tr=void 0;class v{constructor(O,A){this.key=O,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$tr=v;class R{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const A of this.a.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const T=this.lookupOrInsertNode(O),p=this.lookupOrInsertNode(A);T.outgoing.set(p.key,p),p.incoming.set(T.key,T)}removeNode(O){const A=this.b(O);this.a.delete(A);for(const T of this.a.values())T.outgoing.delete(A),T.incoming.delete(A)}lookupOrInsertNode(O){const A=this.b(O);let T=this.a.get(A);return T||(T=new v(A,O),this.a.set(A,T)),T}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[A,T]of this.a)O.push(`${A}
	(-> incoming)[${[...T.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...T.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this.a){const T=new Set([O]),p=this.c(A,T);if(p)return p}}c(O,A){for(const[T,p]of O.outgoing){if(A.has(T))return[...A,T].join(" -> ");A.add(T);const o=this.c(p,A);if(o)return o;A.delete(T)}}}e.$ur=R}),define(Ne[3],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e._util=void 0,e.$Ei=P,e.$Fi=O;var v;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function T(p){return p[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=T})(v||(e._util=v={})),e.$Di=P("instantiationService");function R(A,T,p){T[v.DI_TARGET]===T?T[v.DI_DEPENDENCIES].push({id:A,index:p}):(T[v.DI_DEPENDENCIES]=[{id:A,index:p}],T[v.DI_TARGET]=T)}function P(A){if(v.serviceIds.has(A))return v.serviceIds.get(A);const T=function(p,o,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(T,p,I)};return T.toString=()=>A,v.serviceIds.set(A,T),T}function O(A){return A}}),define(Ne[43],Le([1,0,14,2,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$$i=void 0,e.$_i=O,e.$aj=A,e.$bj=p,e.$cj=o,e.$dj=I,e.$ej=y,e.$fj=a,e.$gj=d,e.$hj=r,e.$ij=s,v=We(v),e.$$i=(0,P.$Ei)("configurationService");function O(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof R.URI)}function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof R.URI)}var T;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(T||(e.ConfigurationTarget=T={}));function p(c){switch(c){case T.APPLICATION:return"APPLICATION";case T.USER:return"USER";case T.USER_LOCAL:return"USER_LOCAL";case T.USER_REMOTE:return"USER_REMOTE";case T.WORKSPACE:return"WORKSPACE";case T.WORKSPACE_FOLDER:return"WORKSPACE_FOLDER";case T.DEFAULT:return"DEFAULT";case T.MEMORY:return"MEMORY"}}function o(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function I(c,l){const i=Object.create(null);for(const n in c)y(i,n,c[n],l);return i}function y(c,l,i,n){const t=l.split("."),g=t.pop();let u=c;for(let $=0;$<t.length;$++){const m=t[$];let h=u[m];switch(typeof h){case"undefined":h=u[m]=Object.create(null);break;case"object":if(h===null){n(`Ignoring ${l} as ${t.slice(0,$+1).join(".")} is null`);return}break;default:n(`Ignoring ${l} as ${t.slice(0,$+1).join(".")} is ${JSON.stringify(h)}`);return}u=h}if(typeof u=="object"&&u!==null)try{u[g]=i}catch{n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}else n(`Ignoring ${l} as ${t.join(".")} is ${JSON.stringify(u)}`)}function a(c,l){const i=l.split(".");S(c,i)}function S(c,l){const i=l.shift();if(l.length===0){delete c[i];return}if(Object.keys(c).indexOf(i)!==-1){const n=c[i];typeof n=="object"&&!Array.isArray(n)&&(S(n,l),Object.keys(n).length===0&&delete c[i])}}function d(c,l,i){function n(u,$){let m=u;for(const h of $){if(typeof m!="object"||m===null)return;m=m[h]}return m}const t=l.split("."),g=n(c,t);return typeof g>"u"?i:g}function r(c,l,i){Object.keys(l).forEach(n=>{n!=="__proto__"&&(n in c?v.$gg(c[n])&&v.$gg(l[n])?r(c[n],l[n],i):i&&(c[n]=l[n]):c[n]=l[n])})}function s(c){return c.replace(/[\[\]]/g,"")}}),define(Ne[31],Le([1,0,27,20,12,166,3,9,13]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Cj=e.$Bj=e.ContextKeyExprType=void 0,e.$Aj=I,e.$Dj=$,e.$Ej=m,e.$Xj=oe;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",R.$k),o.set("isLinux",R.$l),o.set("isWindows",R.$j),o.set("isWeb",R.$p),o.set("isMacNative",R.$k&&!R.$p),o.set("isEdge",R.$I),o.set("isFirefox",R.$G),o.set("isChrome",R.$F),o.set("isSafari",R.$H);function I(Z,B){if(o.get(Z)!==void 0)throw(0,p.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");o.set(Z,B)}const y=Object.prototype.hasOwnProperty;var a;(function(Z){Z[Z.False=0]="False",Z[Z.True=1]="True",Z[Z.Defined=2]="Defined",Z[Z.Not=3]="Not",Z[Z.Equals=4]="Equals",Z[Z.NotEquals=5]="NotEquals",Z[Z.And=6]="And",Z[Z.Regex=7]="Regex",Z[Z.NotRegex=8]="NotRegex",Z[Z.Or=9]="Or",Z[Z.In=10]="In",Z[Z.NotIn=11]="NotIn",Z[Z.Greater=12]="Greater",Z[Z.GreaterEquals=13]="GreaterEquals",Z[Z.Smaller=14]="Smaller",Z[Z.SmallerEquals=15]="SmallerEquals"})(a||(e.ContextKeyExprType=a={}));const S={regexParsingWithErrorRecovery:!0},d=(0,T.localize)(11588,null),r=(0,T.localize)(11589,null),s=(0,T.localize)(11590,null),c=(0,T.localize)(11591,null),l=(0,T.localize)(11592,null),i=(0,T.localize)(11593,null),n=(0,T.localize)(11594,null),t=(0,T.localize)(11595,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=S){this.k=B,this.d=new O.$zj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:d,offset:0,lexeme:"",additionalInfo:r});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const Ee=this.D(),fe=Ee.type===O.TokenType.Str?i:void 0;throw this.h.push({message:l,offset:Ee.offset,lexeme:O.$zj.getLexeme(Ee),additionalInfo:fe}),g.c}return ne}catch(ne){if(ne!==g.c)throw ne;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(O.TokenType.Or);){const ne=this.o();B.push(ne)}return B.length===1?B[0]:u.or(...B)}o(){const B=[this.s()];for(;this.y(O.TokenType.And);){const ne=this.s();B.push(ne)}return B.length===1?B[0]:u.and(...B)}s(){if(this.y(O.TokenType.Neg)){const B=this.D();switch(B.type){case O.TokenType.True:return this.z(),E.INSTANCE;case O.TokenType.False:return this.z(),D.INSTANCE;case O.TokenType.LParen:{this.z();const ne=this.l();return this.A(O.TokenType.RParen,c),ne?.negate()}case O.TokenType.Str:return this.z(),M.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case O.TokenType.True:return this.z(),u.true();case O.TokenType.False:return this.z(),u.false();case O.TokenType.LParen:{this.z();const ne=this.l();return this.A(O.TokenType.RParen,c),ne}case O.TokenType.Str:{const ne=B.lexeme;if(this.z(),this.y(O.TokenType.RegexOp)){const fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),fe.type!==O.TokenType.RegexStr)throw this.B("REGEX",fe);const be=fe.lexeme,he=be.lastIndexOf("/"),X=he===be.length-1?void 0:this.w(be.substring(he+1));let x;try{x=new RegExp(be.substring(1,he),X)}catch{throw this.B("REGEX",fe)}return G.create(ne,x)}switch(fe.type){case O.TokenType.RegexStr:case O.TokenType.Error:{const be=[fe.lexeme];this.z();let he=this.D(),X=0;for(let Ue=0;Ue<fe.lexeme.length;Ue++)fe.lexeme.charCodeAt(Ue)===v.CharCode.OpenParen?X++:fe.lexeme.charCodeAt(Ue)===v.CharCode.CloseParen&&X--;for(;!this.E()&&he.type!==O.TokenType.And&&he.type!==O.TokenType.Or;){switch(he.type){case O.TokenType.LParen:X++;break;case O.TokenType.RParen:X--;break;case O.TokenType.RegexStr:case O.TokenType.QuotedStr:for(let Ue=0;Ue<he.lexeme.length;Ue++)he.lexeme.charCodeAt(Ue)===v.CharCode.OpenParen?X++:fe.lexeme.charCodeAt(Ue)===v.CharCode.CloseParen&&X--}if(X<0)break;be.push(O.$zj.getLexeme(he)),this.z(),he=this.D()}const x=be.join(""),$e=x.lastIndexOf("/"),pe=$e===x.length-1?void 0:this.w(x.substring($e+1));let Ae;try{Ae=new RegExp(x.substring(1,$e),pe)}catch{throw this.B("REGEX",fe)}return u.regex(ne,Ae)}case O.TokenType.QuotedStr:{const be=fe.lexeme;this.z();let he=null;if(!(0,P.$cf)(be)){const X=be.indexOf("/"),x=be.lastIndexOf("/");if(X!==x&&X>=0){const $e=be.slice(X+1,x),pe=be[x+1]==="i"?"i":"";try{he=new RegExp($e,pe)}catch{throw this.B("REGEX",fe)}}}if(he===null)throw this.B("REGEX",fe);return G.create(ne,he)}default:throw this.B("REGEX",this.D())}}if(this.y(O.TokenType.Not)){this.A(O.TokenType.In,s);const fe=this.u();return u.notIn(ne,fe)}switch(this.D().type){case O.TokenType.Eq:{this.z();const fe=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.equals(ne,fe);switch(fe){case"true":return u.has(ne);case"false":return u.not(ne);default:return u.equals(ne,fe)}}case O.TokenType.NotEq:{this.z();const fe=this.u();if(this.x().type===O.TokenType.QuotedStr)return u.notEquals(ne,fe);switch(fe){case"true":return u.not(ne);case"false":return u.has(ne);default:return u.notEquals(ne,fe)}}case O.TokenType.Lt:return this.z(),K.create(ne,this.u());case O.TokenType.LtEq:return this.z(),q.create(ne,this.u());case O.TokenType.Gt:return this.z(),L.create(ne,this.u());case O.TokenType.GtEq:return this.z(),W.create(ne,this.u());case O.TokenType.In:return this.z(),u.in(ne,this.u());default:return u.has(ne)}}case O.TokenType.EOF:throw this.h.push({message:n,offset:B.offset,lexeme:"",additionalInfo:t}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case O.TokenType.Str:case O.TokenType.QuotedStr:return this.z(),B.lexeme;case O.TokenType.True:return this.z(),"true";case O.TokenType.False:return this.z(),"false";case O.TokenType.In:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,ne){if(this.C(B))return this.z();throw this.B(ne,this.D())}B(B,ne,Ee){const fe=(0,T.localize)(11596,null,B,O.$zj.getLexeme(ne)),be=ne.offset,he=O.$zj.getLexeme(ne);return this.h.push({message:fe,offset:be,lexeme:he,additionalInfo:Ee}),g.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===O.TokenType.EOF}}e.$Bj=g;class u{static false(){return E.INSTANCE}static true(){return D.INSTANCE}static has(B){return w.create(B)}static equals(B,ne){return C.create(B,ne)}static notEquals(B,ne){return b.create(B,ne)}static regex(B,ne){return G.create(B,ne)}static in(B,ne){return k.create(B,ne)}static notIn(B,ne){return f.create(B,ne)}static not(B){return M.create(B)}static and(...B){return we.create(B,null,!0)}static or(...B){return le.create(B,null,!0)}static greater(B,ne){return L.create(B,ne)}static greaterEquals(B,ne){return W.create(B,ne)}static smaller(B,ne){return K.create(B,ne)}static smallerEquals(B,ne){return q.create(B,ne)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$Cj=u;function $(Z){const B=new g({regexParsingWithErrorRecovery:!1});return Z.map(ne=>(B.parse(ne),B.lexingErrors.length>0?B.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,T.localize)(11597,null,Ee.additionalInfo):(0,T.localize)(11598,null),offset:Ee.offset,length:Ee.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}function m(Z,B){const ne=Z?Z.substituteConstants():void 0,Ee=B?B.substituteConstants():void 0;return!ne&&!Ee?!0:!ne||!Ee?!1:ne.equals(Ee)}function h(Z,B){return Z.cmp(B)}class E{static{this.INSTANCE=new E}constructor(){this.type=a.False}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return D.INSTANCE}}e.$Fj=E;class D{static{this.INSTANCE=new D}constructor(){this.type=a.True}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return E.INSTANCE}}e.$Gj=D;class w{static create(B,ne=null){const Ee=o.get(B);return typeof Ee=="boolean"?Ee?D.INSTANCE:E.INSTANCE:new w(B,ne)}constructor(B,ne){this.key=B,this.c=ne,this.type=a.Defined}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=o.get(this.key);return typeof B=="boolean"?B?D.INSTANCE:E.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Hj=w;class C{static create(B,ne,Ee=null){if(typeof ne=="boolean")return ne?w.create(B,Ee):M.create(B,Ee);const fe=o.get(B);return typeof fe=="boolean"?ne===(fe?"true":"false")?D.INSTANCE:E.INSTANCE:new C(B,ne,Ee)}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.Equals}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=o.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?D.INSTANCE:E.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$Ij=C;class k{static create(B,ne){return new k(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=a.In,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:me(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.f),Ee=B.getValue(this.d);return Array.isArray(ne)?ne.includes(Ee):typeof Ee=="string"&&typeof ne=="object"&&ne!==null?y.call(ne,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Jj=k;class f{static create(B,ne){return new f(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=a.NotIn,this.c=k.create(B,ne)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Kj=f;class b{static create(B,ne,Ee=null){if(typeof ne=="boolean")return ne?M.create(B,Ee):w.create(B,Ee);const fe=o.get(B);return typeof fe=="boolean"?ne===(fe?"true":"false")?E.INSTANCE:D.INSTANCE:new b(B,ne,Ee)}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.NotEquals}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=o.get(this.c);if(typeof B=="boolean"){const ne=B?"true":"false";return this.d===ne?E.INSTANCE:D.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$Lj=b;class M{static create(B,ne=null){const Ee=o.get(B);return typeof Ee=="boolean"?Ee?E.INSTANCE:D.INSTANCE:new M(B,ne)}constructor(B,ne){this.c=B,this.d=ne,this.type=a.Not}cmp(B){return B.type!==this.type?this.type-B.type:ce(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=o.get(this.c);return typeof B=="boolean"?B?E.INSTANCE:D.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=w.create(this.c,this)),this.d}}e.$Mj=M;function N(Z,B){if(typeof Z=="string"){const ne=parseFloat(Z);isNaN(ne)||(Z=ne)}return typeof Z=="string"||typeof Z=="number"?B(Z):E.INSTANCE}class L{static create(B,ne,Ee=null){return N(ne,fe=>new L(B,fe,Ee))}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.Greater}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Nj=L;class W{static create(B,ne,Ee=null){return N(ne,fe=>new W(B,fe,Ee))}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.GreaterEquals}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=K.create(this.c,this.d,this)),this.f}}e.$Oj=W;class K{static create(B,ne,Ee=null){return N(ne,fe=>new K(B,fe,Ee))}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.Smaller}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Pj=K;class q{static create(B,ne,Ee=null){return N(ne,fe=>new q(B,fe,Ee))}constructor(B,ne,Ee){this.c=B,this.d=ne,this.f=Ee,this.type=a.SmallerEquals}cmp(B){return B.type!==this.type?this.type-B.type:me(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Qj=q;class G{static create(B,ne){return new G(B,ne)}constructor(B,ne){this.d=B,this.f=ne,this.type=a.Regex,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const ne=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return ne<Ee?-1:ne>Ee?1:0}equals(B){if(B.type===this.type){const ne=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return this.d===B.d&&ne===Ee}return!1}substituteConstants(){return this}evaluate(B){const ne=B.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Q.create(this)),this.c}}e.$Rj=G;class Q{static create(B){return new Q(B)}constructor(B){this.c=B,this.type=a.NotRegex}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new Q(this.c.map(B))}negate(){return this.c}}e.$Sj=Q;function ae(Z){let B=null;for(let ne=0,Ee=Z.length;ne<Ee;ne++){const fe=Z[ne].substituteConstants();if(Z[ne]!==fe&&B===null){B=[];for(let be=0;be<ne;be++)B[be]=Z[be]}B!==null&&(B[ne]=fe)}return B===null?Z:B}class we{static create(B,ne,Ee){return we.d(B,ne,Ee)}constructor(B,ne){this.expr=B,this.c=ne,this.type=a.And}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++){const fe=h(this.expr[ne],B.expr[ne]);if(fe!==0)return fe}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=ae(this.expr);return B===this.expr?this:we.create(B,this.c,!1)}evaluate(B){for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].evaluate(B))return!1;return!0}static d(B,ne,Ee){const fe=[];let be=!1;for(const he of B)if(he){if(he.type===a.True){be=!0;continue}if(he.type===a.False)return E.INSTANCE;if(he.type===a.And){fe.push(...he.expr);continue}fe.push(he)}if(fe.length===0&&be)return D.INSTANCE;if(fe.length!==0){if(fe.length===1)return fe[0];fe.sort(h);for(let he=1;he<fe.length;he++)fe[he-1].equals(fe[he])&&(fe.splice(he,1),he--);if(fe.length===1)return fe[0];for(;fe.length>1;){const he=fe[fe.length-1];if(he.type!==a.Or)break;fe.pop();const X=fe.pop(),x=fe.length===0,$e=le.create(he.expr.map(pe=>we.create([pe,X],null,Ee)),null,x);$e&&(fe.push($e),fe.sort(h))}if(fe.length===1)return fe[0];if(Ee){for(let he=0;he<fe.length;he++)for(let X=he+1;X<fe.length;X++)if(fe[he].negate().equals(fe[X]))return E.INSTANCE;if(fe.length===1)return fe[0]}return new we(fe,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new we(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());this.c=le.create(B,this,!0)}return this.c}}e.$Tj=we;class le{static create(B,ne,Ee){return le.d(B,ne,Ee)}constructor(B,ne){this.expr=B,this.c=ne,this.type=a.Or}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++){const fe=h(this.expr[ne],B.expr[ne]);if(fe!==0)return fe}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(!this.expr[ne].equals(B.expr[ne]))return!1;return!0}return!1}substituteConstants(){const B=ae(this.expr);return B===this.expr?this:le.create(B,this.c,!1)}evaluate(B){for(let ne=0,Ee=this.expr.length;ne<Ee;ne++)if(this.expr[ne].evaluate(B))return!0;return!1}static d(B,ne,Ee){let fe=[],be=!1;if(B){for(let he=0,X=B.length;he<X;he++){const x=B[he];if(x){if(x.type===a.False){be=!0;continue}if(x.type===a.True)return D.INSTANCE;if(x.type===a.Or){fe=fe.concat(x.expr);continue}fe.push(x)}}if(fe.length===0&&be)return E.INSTANCE;fe.sort(h)}if(fe.length!==0){if(fe.length===1)return fe[0];for(let he=1;he<fe.length;he++)fe[he-1].equals(fe[he])&&(fe.splice(he,1),he--);if(fe.length===1)return fe[0];if(Ee){for(let he=0;he<fe.length;he++)for(let X=he+1;X<fe.length;X++)if(fe[he].negate().equals(fe[X]))return D.INSTANCE;if(fe.length===1)return fe[0]}return new le(fe,ne)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const ne of this.expr)B.push(...ne.keys());return B}map(B){return new le(this.expr.map(ne=>ne.map(B)),null)}negate(){if(!this.c){const B=[];for(const ne of this.expr)B.push(ne.negate());for(;B.length>1;){const ne=B.shift(),Ee=B.shift(),fe=[];for(const be of Te(ne))for(const he of Te(Ee))fe.push(we.create([be,he],null,!1));B.unshift(le.create(fe,null,!1))}this.c=le.create(B,this,!0)}return this.c}}e.$Uj=le;class _ extends w{static{this.d=[]}static all(){return _.d.values()}constructor(B,ne,Ee){super(B,null),this.f=ne,typeof Ee=="object"?_.d.push({...Ee,key:B}):Ee!==!0&&_.d.push({key:B,description:Ee,type:ne!=null?typeof ne:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return C.create(this.key,B)}notEqualsTo(B){return b.create(this.key,B)}}e.$Vj=_,e.$Wj=(0,A.$Ei)("contextKeyService");function ce(Z,B){return Z<B?-1:Z>B?1:0}function me(Z,B,ne,Ee){return Z<ne?-1:Z>ne?1:B<Ee?-1:B>Ee?1:0}function oe(Z,B){if(Z.type===a.False||B.type===a.True)return!0;if(Z.type===a.Or)return B.type===a.Or?ke(Z.expr,B.expr):!1;if(B.type===a.Or){for(const ne of B.expr)if(oe(Z,ne))return!0;return!1}if(Z.type===a.And){if(B.type===a.And)return ke(B.expr,Z.expr);for(const ne of Z.expr)if(oe(ne,B))return!0;return!1}return Z.equals(B)}function ke(Z,B){let ne=0,Ee=0;for(;ne<Z.length&&Ee<B.length;){const fe=Z[ne].cmp(B[Ee]);if(fe<0)return!1;fe===0&&ne++,Ee++}return ne===Z.length}function Te(Z){return Z.type===a.Or?Z.expr:[Z]}}),define(Ne[168],Le([1,0,31,3]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$rt=e.AccessibilitySupport=e.$qt=void 0,e.$st=O,e.$qt=(0,R.$Ei)("accessibilityService");var P;(function(A){A[A.Unknown=0]="Unknown",A[A.Disabled=1]="Disabled",A[A.Enabled=2]="Enabled"})(P||(e.AccessibilitySupport=P={})),e.$rt=new v.$Vj("accessibilityModeEnabled",!1);function O(A){return A&&typeof A=="object"&&typeof A.label=="string"&&(typeof A.role>"u"||typeof A.role=="string")}e.$tt="ACCESSIBLE_VIEW_SHOWN_"}),define(Ne[105],Le([1,0,17,25,20,146,280,156,169,9,168]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=i,e.clampedInt=t,e.clampedFloat=u,e.stringSet=h,e.cursorStyleToString=N,e.filterValidationDecorations=Pe,v=We(v),R=We(R),P=We(P),o=We(o);var y;(function(ie){ie[ie.None=0]="None",ie[ie.Keep=1]="Keep",ie[ie.Brackets=2]="Brackets",ie[ie.Advanced=3]="Advanced",ie[ie.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class a{constructor(ee){this.c=ee}hasChanged(ee){return this.c[ee]}}e.ConfigurationChangedEvent=a;class S{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=S;class d{constructor(ee,Y,Xe,xe){this.id=ee,this.name=Y,this.defaultValue=Xe,this.schema=xe}applyUpdate(ee,Y){return s(ee,Y)}compute(ee,Y,Xe){return Xe}}class r{constructor(ee,Y){this.newValue=ee,this.didChange=Y}}e.ApplyUpdateResult=r;function s(ie,ee){if(typeof ie!="object"||typeof ee!="object"||!ie||!ee)return new r(ee,ie!==ee);if(Array.isArray(ie)||Array.isArray(ee)){const Xe=Array.isArray(ie)&&Array.isArray(ee)&&v.$tb(ie,ee);return new r(ee,!Xe)}let Y=!1;for(const Xe in ee)if(ee.hasOwnProperty(Xe)){const xe=s(ie[Xe],ee[Xe]);xe.didChange&&(ie[Xe]=xe.newValue,Y=!0)}return new r(ie,Y)}class c{constructor(ee){this.schema=void 0,this.id=ee,this.name="_never_",this.defaultValue=void 0}applyUpdate(ee,Y){return s(ee,Y)}validate(ee){return this.defaultValue}}class l{constructor(ee,Y,Xe,xe){this.id=ee,this.name=Y,this.defaultValue=Xe,this.schema=xe}applyUpdate(ee,Y){return s(ee,Y)}validate(ee){return typeof ee>"u"?this.defaultValue:ee}compute(ee,Y,Xe){return Xe}}function i(ie,ee){return typeof ie>"u"?ee:ie==="false"?!1:!!ie}class n extends l{constructor(ee,Y,Xe,xe=void 0){typeof xe<"u"&&(xe.type="boolean",xe.default=Xe),super(ee,Y,Xe,xe)}validate(ee){return i(ee,this.defaultValue)}}function t(ie,ee,Y,Xe){if(typeof ie>"u")return ee;let xe=parseInt(ie,10);return isNaN(xe)?ee:(xe=Math.max(Y,xe),xe=Math.min(Xe,xe),xe|0)}class g extends l{static clampedInt(ee,Y,Xe,xe){return t(ee,Y,Xe,xe)}constructor(ee,Y,Xe,xe,ht,bt=void 0){typeof bt<"u"&&(bt.type="integer",bt.default=Xe,bt.minimum=xe,bt.maximum=ht),super(ee,Y,Xe,bt),this.minimum=xe,this.maximum=ht}validate(ee){return g.clampedInt(ee,this.defaultValue,this.minimum,this.maximum)}}function u(ie,ee,Y,Xe){if(typeof ie>"u")return ee;const xe=$.float(ie,ee);return $.clamp(xe,Y,Xe)}class $ extends l{static clamp(ee,Y,Xe){return ee<Y?Y:ee>Xe?Xe:ee}static float(ee,Y){if(typeof ee=="number")return ee;if(typeof ee>"u")return Y;const Xe=parseFloat(ee);return isNaN(Xe)?Y:Xe}constructor(ee,Y,Xe,xe,ht){typeof ht<"u"&&(ht.type="number",ht.default=Xe),super(ee,Y,Xe,ht),this.validationFn=xe}validate(ee){return this.validationFn($.float(ee,this.defaultValue))}}class m extends l{static string(ee,Y){return typeof ee!="string"?Y:ee}constructor(ee,Y,Xe,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.default=Xe),super(ee,Y,Xe,xe)}validate(ee){return m.string(ee,this.defaultValue)}}function h(ie,ee,Y,Xe){return typeof ie!="string"?ee:Xe&&ie in Xe?Xe[ie]:Y.indexOf(ie)===-1?ee:ie}class E extends l{constructor(ee,Y,Xe,xe,ht=void 0){typeof ht<"u"&&(ht.type="string",ht.enum=xe,ht.default=Xe),super(ee,Y,Xe,ht),this.c=xe}validate(ee){return h(ee,this.defaultValue,this.c)}}class D extends d{constructor(ee,Y,Xe,xe,ht,bt,Mt=void 0){typeof Mt<"u"&&(Mt.type="string",Mt.enum=ht,Mt.default=xe),super(ee,Y,Xe,Mt),this.c=ht,this.d=bt}validate(ee){return typeof ee!="string"?this.defaultValue:this.c.indexOf(ee)===-1?this.defaultValue:this.d(ee)}}function w(ie){switch(ie){case"none":return y.None;case"keep":return y.Keep;case"brackets":return y.Brackets;case"advanced":return y.Advanced;case"full":return y.Full}}class C extends d{constructor(){super(je.accessibilitySupport,"accessibilitySupport",I.AccessibilitySupport.Unknown,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(11764,null),o.localize(11765,null),o.localize(11766,null)],default:"auto",tags:["accessibility"],description:o.localize(11767,null)})}validate(ee){switch(ee){case"auto":return I.AccessibilitySupport.Unknown;case"off":return I.AccessibilitySupport.Disabled;case"on":return I.AccessibilitySupport.Enabled}return this.defaultValue}compute(ee,Y,Xe){return Xe===I.AccessibilitySupport.Unknown?ee.accessibilitySupport:Xe}}class k extends d{constructor(){const ee={insertSpace:!0,ignoreEmptyLines:!0};super(je.comments,"comments",ee,{"editor.comments.insertSpace":{type:"boolean",default:ee.insertSpace,description:o.localize(11768,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ee.ignoreEmptyLines,description:o.localize(11769,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{insertSpace:i(Y.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(Y.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var f;(function(ie){ie[ie.Hidden=0]="Hidden",ie[ie.Blink=1]="Blink",ie[ie.Smooth=2]="Smooth",ie[ie.Phase=3]="Phase",ie[ie.Expand=4]="Expand",ie[ie.Solid=5]="Solid"})(f||(e.TextEditorCursorBlinkingStyle=f={}));function b(ie){switch(ie){case"blink":return f.Blink;case"smooth":return f.Smooth;case"phase":return f.Phase;case"expand":return f.Expand;case"solid":return f.Solid}}var M;(function(ie){ie[ie.Line=1]="Line",ie[ie.Block=2]="Block",ie[ie.Underline=3]="Underline",ie[ie.LineThin=4]="LineThin",ie[ie.BlockOutline=5]="BlockOutline",ie[ie.UnderlineThin=6]="UnderlineThin"})(M||(e.TextEditorCursorStyle=M={}));function N(ie){switch(ie){case M.Line:return"line";case M.Block:return"block";case M.Underline:return"underline";case M.LineThin:return"line-thin";case M.BlockOutline:return"block-outline";case M.UnderlineThin:return"underline-thin"}}function L(ie){switch(ie){case"line":return M.Line;case"block":return M.Block;case"underline":return M.Underline;case"line-thin":return M.LineThin;case"block-outline":return M.BlockOutline;case"underline-thin":return M.UnderlineThin}}class W extends c{constructor(){super(je.editorClassName)}compute(ee,Y,Xe){const xe=["monaco-editor"];return Y.get(je.extraEditorClassName)&&xe.push(Y.get(je.extraEditorClassName)),ee.extraEditorClassName&&xe.push(ee.extraEditorClassName),Y.get(je.mouseStyle)==="default"?xe.push("mouse-default"):Y.get(je.mouseStyle)==="copy"&&xe.push("mouse-copy"),Y.get(je.showUnused)&&xe.push("showUnused"),Y.get(je.showDeprecated)&&xe.push("showDeprecated"),xe.join(" ")}}class K extends n{constructor(){super(je.emptySelectionClipboard,"emptySelectionClipboard",!0,{description:o.localize(11770,null)})}compute(ee,Y,Xe){return Xe&&ee.emptySelectionClipboard}}class q extends d{constructor(){const ee={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(je.find,"find",ee,{"editor.find.cursorMoveOnType":{type:"boolean",default:ee.cursorMoveOnType,description:o.localize(11771,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:ee.seedSearchStringFromSelection,enumDescriptions:[o.localize(11772,null),o.localize(11773,null),o.localize(11774,null)],description:o.localize(11775,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ee.autoFindInSelection,enumDescriptions:[o.localize(11776,null),o.localize(11777,null),o.localize(11778,null)],description:o.localize(11779,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ee.globalFindClipboard,description:o.localize(11780,null),included:P.$k},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ee.addExtraSpaceOnTop,description:o.localize(11781,null)},"editor.find.loop":{type:"boolean",default:ee.loop,description:o.localize(11782,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{cursorMoveOnType:i(Y.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof ee.seedSearchStringFromSelection=="boolean"?ee.seedSearchStringFromSelection?"always":"never":h(Y.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof ee.autoFindInSelection=="boolean"?ee.autoFindInSelection?"always":"never":h(Y.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(Y.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(Y.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(Y.loop,this.defaultValue.loop)}}}class G extends d{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(je.fontLigatures,"fontLigatures",G.OFF,{anyOf:[{type:"boolean",description:o.localize(11783,null)},{type:"string",description:o.localize(11784,null)}],description:o.localize(11785,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"||ee.length===0?G.OFF:ee==="true"?G.ON:ee:ee?G.ON:G.OFF}}e.EditorFontLigatures=G;class Q extends d{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(je.fontVariations,"fontVariations",Q.OFF,{anyOf:[{type:"boolean",description:o.localize(11786,null)},{type:"string",description:o.localize(11787,null)}],description:o.localize(11788,null),default:!1})}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee==="false"?Q.OFF:ee==="true"?Q.TRANSLATE:ee:ee?Q.TRANSLATE:Q.OFF}compute(ee,Y,Xe){return ee.fontInfo.fontVariationSettings}}e.EditorFontVariations=Q;class ae extends c{constructor(){super(je.fontInfo)}compute(ee,Y,Xe){return ee.fontInfo}}class we extends l{constructor(){super(je.fontSize,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(11789,null)})}validate(ee){const Y=$.float(ee,this.defaultValue);return Y===0?e.EDITOR_FONT_DEFAULTS.fontSize:$.clamp(Y,6,100)}compute(ee,Y,Xe){return ee.fontInfo.fontSize}}class le extends d{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(je.fontWeight,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:le.d,maximum:le.e,errorMessage:o.localize(11790,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:le.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(11791,null)})}validate(ee){return ee==="normal"||ee==="bold"?ee:String(g.clampedInt(ee,e.EDITOR_FONT_DEFAULTS.fontWeight,le.d,le.e))}}class _ extends d{constructor(){const ee={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",multipleTests:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:"",alternativeTestsCommand:""},Y={type:"string",enum:["peek","gotoAndPeek","goto"],default:ee.multiple,enumDescriptions:[o.localize(11792,null),o.localize(11793,null),o.localize(11794,null)]},Xe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(je.gotoLocation,"gotoLocation",ee,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(11795,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(11796,null),...Y},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(11797,null),...Y},"editor.gotoLocation.multipleDeclarations":{description:o.localize(11798,null),...Y},"editor.gotoLocation.multipleImplementations":{description:o.localize(11799,null),...Y},"editor.gotoLocation.multipleReferences":{description:o.localize(11800,null),...Y},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ee.alternativeDefinitionCommand,enum:Xe,description:o.localize(11801,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ee.alternativeTypeDefinitionCommand,enum:Xe,description:o.localize(11802,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ee.alternativeDeclarationCommand,enum:Xe,description:o.localize(11803,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ee.alternativeImplementationCommand,enum:Xe,description:o.localize(11804,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ee.alternativeReferenceCommand,enum:Xe,description:o.localize(11805,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{multiple:h(Y.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Y.multipleDefinitions??h(Y.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Y.multipleTypeDefinitions??h(Y.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Y.multipleDeclarations??h(Y.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Y.multipleImplementations??h(Y.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Y.multipleReferences??h(Y.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),multipleTests:Y.multipleTests??h(Y.multipleTests,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:m.string(Y.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:m.string(Y.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:m.string(Y.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:m.string(Y.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:m.string(Y.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand),alternativeTestsCommand:m.string(Y.alternativeTestsCommand,this.defaultValue.alternativeTestsCommand)}}}class ce extends d{constructor(){const ee={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(je.hover,"hover",ee,{"editor.hover.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11806,null)},"editor.hover.delay":{type:"number",default:ee.delay,minimum:0,maximum:1e4,description:o.localize(11807,null)},"editor.hover.sticky":{type:"boolean",default:ee.sticky,description:o.localize(11808,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:ee.hidingDelay,description:o.localize(11809,null)},"editor.hover.above":{type:"boolean",default:ee.above,description:o.localize(11810,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),delay:g.clampedInt(Y.delay,this.defaultValue.delay,0,1e4),sticky:i(Y.sticky,this.defaultValue.sticky),hidingDelay:g.clampedInt(Y.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:i(Y.above,this.defaultValue.above)}}}var me;(function(ie){ie[ie.None=0]="None",ie[ie.Text=1]="Text",ie[ie.Blocks=2]="Blocks"})(me||(e.RenderMinimap=me={}));class oe extends c{constructor(){super(je.layoutInfo)}compute(ee,Y,Xe){return oe.computeLayout(Y,{memory:ee.memory,outerWidth:ee.outerWidth,outerHeight:ee.outerHeight,isDominatedByLongLines:ee.isDominatedByLongLines,lineHeight:ee.fontInfo.lineHeight,viewLineCount:ee.viewLineCount,lineNumbersDigitCount:ee.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ee.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ee.fontInfo.maxDigitWidth,pixelRatio:ee.pixelRatio,glyphMarginDecorationLaneCount:ee.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(ee){const Y=ee.height/ee.lineHeight,Xe=Math.floor(ee.paddingTop/ee.lineHeight);let xe=Math.floor(ee.paddingBottom/ee.lineHeight);ee.scrollBeyondLastLine&&(xe=Math.max(xe,Y-1));const ht=(Xe+ee.viewLineCount+xe)/(ee.pixelRatio*ee.height),bt=Math.floor(ee.viewLineCount/ht);return{typicalViewportLineCount:Y,extraLinesBeforeFirstLine:Xe,extraLinesBeyondLastLine:xe,desiredRatio:ht,minimapLineCount:bt}}static c(ee,Y){const Xe=ee.outerWidth,xe=ee.outerHeight,ht=ee.pixelRatio;if(!ee.minimap.enabled)return{renderMinimap:me.None,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ht*xe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:xe};const bt=Y.stableMinimapLayoutInput,Mt=bt&&ee.outerHeight===bt.outerHeight&&ee.lineHeight===bt.lineHeight&&ee.typicalHalfwidthCharacterWidth===bt.typicalHalfwidthCharacterWidth&&ee.pixelRatio===bt.pixelRatio&&ee.scrollBeyondLastLine===bt.scrollBeyondLastLine&&ee.paddingTop===bt.paddingTop&&ee.paddingBottom===bt.paddingBottom&&ee.minimap.enabled===bt.minimap.enabled&&ee.minimap.side===bt.minimap.side&&ee.minimap.size===bt.minimap.size&&ee.minimap.showSlider===bt.minimap.showSlider&&ee.minimap.renderCharacters===bt.minimap.renderCharacters&&ee.minimap.maxColumn===bt.minimap.maxColumn&&ee.minimap.scale===bt.minimap.scale&&ee.verticalScrollbarWidth===bt.verticalScrollbarWidth&&ee.isViewportWrapping===bt.isViewportWrapping,Ht=ee.lineHeight,_t=ee.typicalHalfwidthCharacterWidth,ei=ee.scrollBeyondLastLine,oi=ee.minimap.renderCharacters;let At=ht>=2?Math.round(ee.minimap.scale*2):ee.minimap.scale;const Ye=ee.minimap.maxColumn,Ct=ee.minimap.size,hi=ee.minimap.side,pt=ee.verticalScrollbarWidth,Dt=ee.viewLineCount,ti=ee.remainingWidth,ii=ee.isViewportWrapping,jt=oi?2:3;let gt=Math.floor(ht*xe);const zt=gt/ht;let ni=!1,ai=!1,Ge=jt*At,ci=At/ht,di=1;if(Ct==="fill"||Ct==="fit"){const{typicalViewportLineCount:Kt,extraLinesBeforeFirstLine:li,extraLinesBeyondLastLine:Bt,desiredRatio:Qt,minimapLineCount:Gt}=oe.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:ei,paddingTop:ee.paddingTop,paddingBottom:ee.paddingBottom,height:xe,lineHeight:Ht,pixelRatio:ht});if(Dt/Gt>1)ni=!0,ai=!0,At=1,Ge=1,ci=At/ht;else{let wt=!1,kt=At+1;if(Ct==="fit"){const Vt=Math.ceil((li+Dt+Bt)*Ge);ii&&Mt&&ti<=Y.stableFitRemainingWidth?(wt=!0,kt=Y.stableFitMaxMinimapScale):wt=Vt>gt}if(Ct==="fill"||wt){ni=!0;const Vt=At;Ge=Math.min(Ht*ht,Math.max(1,Math.floor(1/Qt))),ii&&Mt&&ti<=Y.stableFitRemainingWidth&&(kt=Y.stableFitMaxMinimapScale),At=Math.min(kt,Math.max(1,Math.floor(Ge/jt))),At>Vt&&(di=Math.min(2,At/Vt)),ci=At/ht/di,gt=Math.ceil(Math.max(Kt,li+Dt+Bt)*Ge),ii?(Y.stableMinimapLayoutInput=ee,Y.stableFitRemainingWidth=ti,Y.stableFitMaxMinimapScale=At):(Y.stableMinimapLayoutInput=null,Y.stableFitRemainingWidth=0)}}}const fi=Math.floor(Ye*ci),vt=Math.min(fi,Math.max(0,Math.floor((ti-pt-2)*ci/(_t+ci)))+e.MINIMAP_GUTTER_WIDTH);let Ft=Math.floor(ht*vt);const Nt=Ft/ht;Ft=Math.floor(Ft*di);const Wt=oi?me.Text:me.Blocks,ri=hi==="left"?0:Xe-vt-pt;return{renderMinimap:Wt,minimapLeft:ri,minimapWidth:vt,minimapHeightIsEditorHeight:ni,minimapIsSampling:ai,minimapScale:At,minimapLineHeight:Ge,minimapCanvasInnerWidth:Ft,minimapCanvasInnerHeight:gt,minimapCanvasOuterWidth:Nt,minimapCanvasOuterHeight:zt}}static computeLayout(ee,Y){const Xe=Y.outerWidth|0,xe=Y.outerHeight|0,ht=Y.lineHeight|0,bt=Y.lineNumbersDigitCount|0,Mt=Y.typicalHalfwidthCharacterWidth,Ht=Y.maxDigitWidth,_t=Y.pixelRatio,ei=Y.viewLineCount,oi=ee.get(je.wordWrapOverride2),At=oi==="inherit"?ee.get(je.wordWrapOverride1):oi,Ye=At==="inherit"?ee.get(je.wordWrap):At,Ct=ee.get(je.wordWrapColumn),hi=Y.isDominatedByLongLines,pt=ee.get(je.glyphMargin),Dt=ee.get(je.lineNumbers).renderType!==Ue.Off,ti=ee.get(je.lineNumbersMinChars),ii=ee.get(je.scrollBeyondLastLine),jt=ee.get(je.padding),gt=ee.get(je.minimap),zt=ee.get(je.scrollbar),ni=zt.verticalScrollbarSize,ai=zt.verticalHasArrows,Ge=zt.arrowSize,ci=zt.horizontalScrollbarSize,di=ee.get(je.folding),fi=ee.get(je.showFoldingControls)!=="never";let vt=ee.get(je.lineDecorationsWidth);di&&fi&&(vt+=16);let Ft=0;if(Dt){const mi=Math.max(bt,ti);Ft=Math.round(mi*Ht)}let Nt=0;pt&&(Nt=ht*Y.glyphMarginDecorationLaneCount);let Wt=0,ri=Wt+Nt,Kt=ri+Ft,li=Kt+vt;const Bt=Xe-Nt-Ft-vt;let Qt=!1,Gt=!1,Lt=-1;At==="inherit"&&hi?(Qt=!0,Gt=!0):Ye==="on"||Ye==="bounded"?Gt=!0:Ye==="wordWrapColumn"&&(Lt=Ct);const wt=oe.c({outerWidth:Xe,outerHeight:xe,lineHeight:ht,typicalHalfwidthCharacterWidth:Mt,pixelRatio:_t,scrollBeyondLastLine:ii,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:gt,verticalScrollbarWidth:ni,viewLineCount:ei,remainingWidth:Bt,isViewportWrapping:Gt},Y.memory||new S);wt.renderMinimap!==me.None&&wt.minimapLeft===0&&(Wt+=wt.minimapWidth,ri+=wt.minimapWidth,Kt+=wt.minimapWidth,li+=wt.minimapWidth);const kt=Bt-wt.minimapWidth,Vt=Math.max(1,Math.floor((kt-ni-2)/Mt)),It=ai?Ge:0;return Gt&&(Lt=Math.max(1,Vt),Ye==="bounded"&&(Lt=Math.min(Lt,Ct))),{width:Xe,height:xe,glyphMarginLeft:Wt,glyphMarginWidth:Nt,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount,lineNumbersLeft:ri,lineNumbersWidth:Ft,decorationsLeft:Kt,decorationsWidth:vt,contentLeft:li,contentWidth:kt,minimap:wt,viewportColumn:Vt,isWordWrapMinified:Qt,isViewportWrapping:Gt,wrappingColumn:Lt,verticalScrollbarWidth:ni,horizontalScrollbarHeight:ci,overviewRuler:{top:It,width:ni,height:xe-2*It,right:0}}}}e.EditorLayoutInfoComputer=oe;class ke extends d{constructor(){super(je.wrappingStrategy,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(11811,null),o.localize(11812,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(11813,null)}})}validate(ee){return h(ee,"simple",["simple","advanced"])}compute(ee,Y,Xe){return Y.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?"advanced":Xe}}var Te;(function(ie){ie.Off="off",ie.OnCode="onCode",ie.On="on"})(Te||(e.ShowLightbulbIconMode=Te={}));class Z extends d{constructor(){const ee={enabled:Te.On};super(je.lightbulb,"lightbulb",ee,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Te.Off,Te.OnCode,Te.On],default:ee.enabled,enumDescriptions:[o.localize(11814,null),o.localize(11815,null),o.localize(11816,null)],description:o.localize(11817,null)}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{enabled:h(ee.enabled,this.defaultValue.enabled,[Te.Off,Te.OnCode,Te.On])}}}class B extends d{constructor(){const ee={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(je.stickyScroll,"stickyScroll",ee,{"editor.stickyScroll.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11818,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:ee.maxLineCount,minimum:1,maximum:20,description:o.localize(11819,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:ee.defaultModel,description:o.localize(11820,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:ee.scrollWithEditor,description:o.localize(11821,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),maxLineCount:g.clampedInt(Y.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:h(Y.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:i(Y.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends d{constructor(){const ee={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(je.inlayHints,"inlayHints",ee,{"editor.inlayHints.enabled":{type:"string",default:ee.enabled,description:o.localize(11822,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(11823,null),o.localize(11824,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),o.localize(11825,null,P.$k?"Ctrl+Option":"Ctrl+Alt"),o.localize(11826,null)]},"editor.inlayHints.fontSize":{type:"number",default:ee.fontSize,markdownDescription:o.localize(11827,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:ee.fontFamily,markdownDescription:o.localize(11828,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:ee.padding,description:o.localize(11829,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return typeof Y.enabled=="boolean"&&(Y.enabled=Y.enabled?"on":"off"),{enabled:h(Y.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:g.clampedInt(Y.fontSize,this.defaultValue.fontSize,0,100),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily),padding:i(Y.padding,this.defaultValue.padding)}}}class Ee extends d{constructor(){super(je.lineDecorationsWidth,"lineDecorationsWidth",10)}validate(ee){return typeof ee=="string"&&/^\d+(\.\d+)?ch$/.test(ee)?-parseFloat(ee.substring(0,ee.length-2)):g.clampedInt(ee,this.defaultValue,0,1e3)}compute(ee,Y,Xe){return Xe<0?g.clampedInt(-Xe*ee.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Xe}}class fe extends ${constructor(){super(je.lineHeight,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ee=>$.clamp(ee,0,150),{markdownDescription:o.localize(11830,null)})}compute(ee,Y,Xe){return ee.fontInfo.lineHeight}}class be extends d{constructor(){const ee={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9,sectionHeaderLetterSpacing:1};super(je.minimap,"minimap",ee,{"editor.minimap.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11831,null)},"editor.minimap.autohide":{type:"boolean",default:ee.autohide,description:o.localize(11832,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(11833,null),o.localize(11834,null),o.localize(11835,null)],default:ee.size,description:o.localize(11836,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ee.side,description:o.localize(11837,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ee.showSlider,description:o.localize(11838,null)},"editor.minimap.scale":{type:"number",default:ee.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(11839,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ee.renderCharacters,description:o.localize(11840,null)},"editor.minimap.maxColumn":{type:"number",default:ee.maxColumn,description:o.localize(11841,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:ee.showRegionSectionHeaders,description:o.localize(11842,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:ee.showMarkSectionHeaders,description:o.localize(11843,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:ee.sectionHeaderFontSize,description:o.localize(11844,null)},"editor.minimap.sectionHeaderLetterSpacing":{type:"number",default:ee.sectionHeaderLetterSpacing,description:o.localize(11845,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),autohide:i(Y.autohide,this.defaultValue.autohide),size:h(Y.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Y.side,this.defaultValue.side,["right","left"]),showSlider:h(Y.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(Y.renderCharacters,this.defaultValue.renderCharacters),scale:g.clampedInt(Y.scale,1,1,3),maxColumn:g.clampedInt(Y.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:i(Y.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:i(Y.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:$.clamp(Y.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32),sectionHeaderLetterSpacing:$.clamp(Y.sectionHeaderLetterSpacing??this.defaultValue.sectionHeaderLetterSpacing,0,5)}}}function he(ie){return ie==="ctrlCmd"?P.$k?"metaKey":"ctrlKey":"altKey"}class X extends d{constructor(){super(je.padding,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(11846,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(11847,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{top:g.clampedInt(Y.top,0,0,1e3),bottom:g.clampedInt(Y.bottom,0,0,1e3)}}}class x extends d{constructor(){const ee={enabled:!0,cycle:!0};super(je.parameterHints,"parameterHints",ee,{"editor.parameterHints.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11848,null)},"editor.parameterHints.cycle":{type:"boolean",default:ee.cycle,description:o.localize(11849,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),cycle:i(Y.cycle,this.defaultValue.cycle)}}}class $e extends c{constructor(){super(je.pixelRatio)}compute(ee,Y,Xe){return ee.pixelRatio}}class pe extends d{constructor(){super(je.placeholder,"placeholder",void 0)}validate(ee){return typeof ee>"u"?this.defaultValue:typeof ee=="string"?ee:this.defaultValue}}class Ae extends d{constructor(){const ee={other:"on",comments:"off",strings:"off"},Y=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(11850,null),o.localize(11851,null),o.localize(11852,null)]}];super(je.quickSuggestions,"quickSuggestions",ee,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Y,default:ee.strings,description:o.localize(11853,null)},comments:{anyOf:Y,default:ee.comments,description:o.localize(11854,null)},other:{anyOf:Y,default:ee.other,description:o.localize(11855,null)}},default:ee,markdownDescription:o.localize(11856,null,"`#editor.suggestOnTriggerCharacters#`")}),this.defaultValue=ee}validate(ee){if(typeof ee=="boolean"){const _t=ee?"on":"off";return{comments:_t,strings:_t,other:_t}}if(!ee||typeof ee!="object")return this.defaultValue;const{other:Y,comments:Xe,strings:xe}=ee,ht=["on","inline","off"];let bt,Mt,Ht;return typeof Y=="boolean"?bt=Y?"on":"off":bt=h(Y,this.defaultValue.other,ht),typeof Xe=="boolean"?Mt=Xe?"on":"off":Mt=h(Xe,this.defaultValue.comments,ht),typeof xe=="boolean"?Ht=xe?"on":"off":Ht=h(xe,this.defaultValue.strings,ht),{other:bt,comments:Mt,strings:Ht}}}var Ue;(function(ie){ie[ie.Off=0]="Off",ie[ie.On=1]="On",ie[ie.Relative=2]="Relative",ie[ie.Interval=3]="Interval",ie[ie.Custom=4]="Custom"})(Ue||(e.RenderLineNumbersType=Ue={}));class Ie extends d{constructor(){super(je.lineNumbers,"lineNumbers",{renderType:Ue.On,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(11857,null),o.localize(11858,null),o.localize(11859,null),o.localize(11860,null)],default:"on",description:o.localize(11861,null)})}validate(ee){let Y=this.defaultValue.renderType,Xe=this.defaultValue.renderFn;return typeof ee<"u"&&(typeof ee=="function"?(Y=Ue.Custom,Xe=ee):ee==="interval"?Y=Ue.Interval:ee==="relative"?Y=Ue.Relative:ee==="on"?Y=Ue.On:Y=Ue.Off),{renderType:Y,renderFn:Xe}}}function Pe(ie){const ee=ie.get(je.renderValidationDecorations);return ee==="editable"?ie.get(je.readOnly):ee!=="on"}class Oe extends d{constructor(){const ee=[],Y={type:"number",description:o.localize(11862,null)};super(je.rulers,"rulers",ee,{type:"array",items:{anyOf:[Y,{type:["object"],properties:{column:Y,color:{type:"string",description:o.localize(11863,null),format:"color-hex"}}}]},default:ee,description:o.localize(11864,null)})}validate(ee){if(Array.isArray(ee)){const Y=[];for(const Xe of ee)if(typeof Xe=="number")Y.push({column:g.clampedInt(Xe,0,0,1e4),color:null});else if(Xe&&typeof Xe=="object"){const xe=Xe;Y.push({column:g.clampedInt(xe.column,0,0,1e4),color:xe.color})}return Y.sort((Xe,xe)=>Xe.column-xe.column),Y}return this.defaultValue}}class z extends d{constructor(){super(je.readOnlyMessage,"readOnlyMessage",void 0)}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:ee}}function j(ie,ee){if(typeof ie!="string")return ee;switch(ie){case"hidden":return O.ScrollbarVisibility.Hidden;case"visible":return O.ScrollbarVisibility.Visible;default:return O.ScrollbarVisibility.Auto}}class H extends d{constructor(){const ee={vertical:O.ScrollbarVisibility.Auto,horizontal:O.ScrollbarVisibility.Auto,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(je.scrollbar,"scrollbar",ee,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(11865,null),o.localize(11866,null),o.localize(11867,null)],default:"auto",description:o.localize(11868,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(11869,null),o.localize(11870,null),o.localize(11871,null)],default:"auto",description:o.localize(11872,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:ee.verticalScrollbarSize,description:o.localize(11873,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:ee.horizontalScrollbarSize,description:o.localize(11874,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:ee.scrollByPage,description:o.localize(11875,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:ee.ignoreHorizontalScrollbarInContentHeight,description:o.localize(11876,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee,Xe=g.clampedInt(Y.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),xe=g.clampedInt(Y.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:g.clampedInt(Y.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:j(Y.vertical,this.defaultValue.vertical),horizontal:j(Y.horizontal,this.defaultValue.horizontal),useShadows:i(Y.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(Y.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(Y.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(Y.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(Y.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Xe,horizontalSliderSize:g.clampedInt(Y.horizontalSliderSize,Xe,0,1e3),verticalScrollbarSize:xe,verticalSliderSize:g.clampedInt(Y.verticalSliderSize,xe,0,1e3),scrollByPage:i(Y.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:i(Y.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class V extends d{constructor(){const ee={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(je.unicodeHighlighting,"unicodeHighlight",ee,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.nonBasicASCII,description:o.localize(11877,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:ee.invisibleCharacters,description:o.localize(11878,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:ee.ambiguousCharacters,description:o.localize(11879,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeComments,description:o.localize(11880,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:ee.includeStrings,description:o.localize(11881,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:ee.allowedCharacters,description:o.localize(11882,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:ee.allowedLocales,description:o.localize(11883,null)}})}applyUpdate(ee,Y){let Xe=!1;Y.allowedCharacters&&ee&&(R.$ho(ee.allowedCharacters,Y.allowedCharacters)||(ee={...ee,allowedCharacters:Y.allowedCharacters},Xe=!0)),Y.allowedLocales&&ee&&(R.$ho(ee.allowedLocales,Y.allowedLocales)||(ee={...ee,allowedLocales:Y.allowedLocales},Xe=!0));const xe=super.applyUpdate(ee,Y);return Xe?new r(xe.newValue,!0):xe}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{nonBasicASCII:Qe(Y.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(Y.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(Y.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Qe(Y.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Qe(Y.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(ee.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(ee.allowedLocales,this.defaultValue.allowedLocales)}}c(ee,Y){if(typeof ee!="object"||!ee)return Y;const Xe={};for(const[xe,ht]of Object.entries(ee))ht===!0&&(Xe[xe]=!0);return Xe}}class re extends d{constructor(){const ee={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(je.inlineSuggest,"inlineSuggest",ee,{"editor.inlineSuggest.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11884,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(11885,null),o.localize(11886,null),o.localize(11887,null)],description:o.localize(11888,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:ee.suppressSuggestions,description:o.localize(11889,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(11890,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),mode:h(Y.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Y.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:i(Y.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(Y.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily)}}}class ge extends d{constructor(){const ee={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1};super(je.inlineEdit,"experimentalInlineEdit",ee,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:ee.enabled,description:o.localize(11891,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:ee.showToolbar,enum:["always","onHover","never"],enumDescriptions:[o.localize(11892,null),o.localize(11893,null),o.localize(11894,null)],description:o.localize(11895,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:ee.fontFamily,description:o.localize(11896,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showToolbar:h(Y.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:m.string(Y.fontFamily,this.defaultValue.fontFamily),keepOnBlur:i(Y.keepOnBlur,this.defaultValue.keepOnBlur)}}}class Ce extends d{constructor(){const ee={enabled:T.$kt.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$kt.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(je.bracketPairColorization,"bracketPairColorization",ee,{"editor.bracketPairColorization.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11897,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:ee.independentColorPoolPerBracketType,description:o.localize(11898,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(Y.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ze extends d{constructor(){const ee={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(je.guides,"guides",ee,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(11899,null),o.localize(11900,null),o.localize(11901,null)],default:ee.bracketPairs,description:o.localize(11902,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(11903,null),o.localize(11904,null),o.localize(11905,null)],default:ee.bracketPairsHorizontal,description:o.localize(11906,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:ee.highlightActiveBracketPair,description:o.localize(11907,null)},"editor.guides.indentation":{type:"boolean",default:ee.indentation,description:o.localize(11908,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(11909,null),o.localize(11910,null),o.localize(11911,null)],default:ee.highlightActiveIndentation,description:o.localize(11912,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{bracketPairs:Qe(Y.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Qe(Y.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(Y.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(Y.indentation,this.defaultValue.indentation),highlightActiveIndentation:Qe(Y.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Qe(ie,ee,Y){const Xe=Y.indexOf(ie);return Xe===-1?ee:Y[Xe]}class _e extends d{constructor(){const ee={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(je.suggest,"suggest",ee,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(11913,null),o.localize(11914,null)],default:ee.insertMode,description:o.localize(11915,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ee.filterGraceful,description:o.localize(11916,null)},"editor.suggest.localityBonus":{type:"boolean",default:ee.localityBonus,description:o.localize(11917,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ee.shareSuggestSelections,markdownDescription:o.localize(11918,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(11919,null),o.localize(11920,null),o.localize(11921,null),o.localize(11922,null)],default:ee.selectionMode,markdownDescription:o.localize(11923,null,"`#editor.quickSuggestions#`","`#editor.suggestOnTriggerCharacters#`")},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ee.snippetsPreventQuickSuggestions,description:o.localize(11924,null)},"editor.suggest.showIcons":{type:"boolean",default:ee.showIcons,description:o.localize(11925,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ee.showStatusBar,description:o.localize(11926,null)},"editor.suggest.preview":{type:"boolean",default:ee.preview,description:o.localize(11927,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ee.showInlineDetails,description:o.localize(11928,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(11929,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(11930,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(11931,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(11932,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(11933,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(11934,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(11935,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(11936,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(11937,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(11938,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(11939,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(11940,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(11941,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(11942,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(11943,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(11944,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(11945,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(11946,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(11947,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(11948,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(11949,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(11950,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(11951,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(11952,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(11953,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(11954,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(11955,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(11956,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(11957,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(11958,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(11959,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(11960,null)}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{insertMode:h(Y.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(Y.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(Y.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(Y.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(Y.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Y.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(Y.showIcons,this.defaultValue.showIcons),showStatusBar:i(Y.showStatusBar,this.defaultValue.showStatusBar),preview:i(Y.preview,this.defaultValue.preview),previewMode:h(Y.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(Y.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(Y.showMethods,this.defaultValue.showMethods),showFunctions:i(Y.showFunctions,this.defaultValue.showFunctions),showConstructors:i(Y.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(Y.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(Y.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(Y.showFields,this.defaultValue.showFields),showVariables:i(Y.showVariables,this.defaultValue.showVariables),showClasses:i(Y.showClasses,this.defaultValue.showClasses),showStructs:i(Y.showStructs,this.defaultValue.showStructs),showInterfaces:i(Y.showInterfaces,this.defaultValue.showInterfaces),showModules:i(Y.showModules,this.defaultValue.showModules),showProperties:i(Y.showProperties,this.defaultValue.showProperties),showEvents:i(Y.showEvents,this.defaultValue.showEvents),showOperators:i(Y.showOperators,this.defaultValue.showOperators),showUnits:i(Y.showUnits,this.defaultValue.showUnits),showValues:i(Y.showValues,this.defaultValue.showValues),showConstants:i(Y.showConstants,this.defaultValue.showConstants),showEnums:i(Y.showEnums,this.defaultValue.showEnums),showEnumMembers:i(Y.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(Y.showKeywords,this.defaultValue.showKeywords),showWords:i(Y.showWords,this.defaultValue.showWords),showColors:i(Y.showColors,this.defaultValue.showColors),showFiles:i(Y.showFiles,this.defaultValue.showFiles),showReferences:i(Y.showReferences,this.defaultValue.showReferences),showFolders:i(Y.showFolders,this.defaultValue.showFolders),showTypeParameters:i(Y.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(Y.showSnippets,this.defaultValue.showSnippets),showUsers:i(Y.showUsers,this.defaultValue.showUsers),showIssues:i(Y.showIssues,this.defaultValue.showIssues)}}}class tt extends d{constructor(){super(je.smartSelect,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(11961,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:o.localize(11962,null),default:!0,type:"boolean"}})}validate(ee){return!ee||typeof ee!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(ee.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:i(ee.selectSubwords,this.defaultValue.selectSubwords)}}}class nt extends d{constructor(){const ee=[];super(je.wordSegmenterLocales,"wordSegmenterLocales",ee,{anyOf:[{description:o.localize(11963,null),type:"string"},{description:o.localize(11964,null),type:"array",items:{type:"string"}}]})}validate(ee){if(typeof ee=="string"&&(ee=[ee]),Array.isArray(ee)){const Y=[];for(const Xe of ee)if(typeof Xe=="string")try{Intl.Segmenter.supportedLocalesOf(Xe).length>0&&Y.push(Xe)}catch{}return Y}return this.defaultValue}}var et;(function(ie){ie[ie.None=0]="None",ie[ie.Same=1]="Same",ie[ie.Indent=2]="Indent",ie[ie.DeepIndent=3]="DeepIndent"})(et||(e.WrappingIndent=et={}));class rt extends d{constructor(){super(je.wrappingIndent,"wrappingIndent",et.Same,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(11965,null),o.localize(11966,null),o.localize(11967,null),o.localize(11968,null)],description:o.localize(11969,null),default:"same"}})}validate(ee){switch(ee){case"none":return et.None;case"same":return et.Same;case"indent":return et.Indent;case"deepIndent":return et.DeepIndent}return et.Same}compute(ee,Y,Xe){return Y.get(je.accessibilitySupport)===I.AccessibilitySupport.Enabled?et.None:Xe}}class ft extends c{constructor(){super(je.wrappingInfo)}compute(ee,Y,Xe){const xe=Y.get(je.layoutInfo);return{isDominatedByLongLines:ee.isDominatedByLongLines,isWordWrapMinified:xe.isWordWrapMinified,isViewportWrapping:xe.isViewportWrapping,wrappingColumn:xe.wrappingColumn}}}class lt extends d{constructor(){const ee={enabled:!0,showDropSelector:"afterDrop"};super(je.dropIntoEditor,"dropIntoEditor",ee,{"editor.dropIntoEditor.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11970,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(11971,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(11972,null),o.localize(11973,null)],default:"afterDrop"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showDropSelector:h(Y.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends d{constructor(){const ee={enabled:!0,showPasteSelector:"afterPaste"};super(je.pasteAs,"pasteAs",ee,{"editor.pasteAs.enabled":{type:"boolean",default:ee.enabled,markdownDescription:o.localize(11974,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:o.localize(11975,null),enum:["afterPaste","never"],enumDescriptions:[o.localize(11976,null),o.localize(11977,null)],default:"afterPaste"}})}validate(ee){if(!ee||typeof ee!="object")return this.defaultValue;const Y=ee;return{enabled:i(Y.enabled,this.defaultValue.enabled),showPasteSelector:h(Y.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",mt="Menlo, Monaco, 'Courier New', monospace",$t="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$k?mt:P.$l?$t:ct,fontWeight:"normal",fontSize:P.$k?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function qe(ie){return e.editorOptionsRegistry[ie.id]=ie,ie}var je;(function(ie){ie[ie.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ie[ie.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ie[ie.accessibilitySupport=2]="accessibilitySupport",ie[ie.accessibilityPageSize=3]="accessibilityPageSize",ie[ie.ariaLabel=4]="ariaLabel",ie[ie.ariaRequired=5]="ariaRequired",ie[ie.autoClosingBrackets=6]="autoClosingBrackets",ie[ie.autoClosingComments=7]="autoClosingComments",ie[ie.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ie[ie.autoClosingDelete=9]="autoClosingDelete",ie[ie.autoClosingOvertype=10]="autoClosingOvertype",ie[ie.autoClosingQuotes=11]="autoClosingQuotes",ie[ie.autoIndent=12]="autoIndent",ie[ie.automaticLayout=13]="automaticLayout",ie[ie.autoSurround=14]="autoSurround",ie[ie.bracketPairColorization=15]="bracketPairColorization",ie[ie.guides=16]="guides",ie[ie.codeLens=17]="codeLens",ie[ie.codeLensFontFamily=18]="codeLensFontFamily",ie[ie.codeLensFontSize=19]="codeLensFontSize",ie[ie.colorDecorators=20]="colorDecorators",ie[ie.colorDecoratorsLimit=21]="colorDecoratorsLimit",ie[ie.columnSelection=22]="columnSelection",ie[ie.comments=23]="comments",ie[ie.contextmenu=24]="contextmenu",ie[ie.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ie[ie.cursorBlinking=26]="cursorBlinking",ie[ie.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ie[ie.cursorStyle=28]="cursorStyle",ie[ie.cursorSurroundingLines=29]="cursorSurroundingLines",ie[ie.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ie[ie.cursorWidth=31]="cursorWidth",ie[ie.disableLayerHinting=32]="disableLayerHinting",ie[ie.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ie[ie.domReadOnly=34]="domReadOnly",ie[ie.dragAndDrop=35]="dragAndDrop",ie[ie.dropIntoEditor=36]="dropIntoEditor",ie[ie.emptySelectionClipboard=37]="emptySelectionClipboard",ie[ie.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ie[ie.extraEditorClassName=39]="extraEditorClassName",ie[ie.fastScrollSensitivity=40]="fastScrollSensitivity",ie[ie.find=41]="find",ie[ie.fixedOverflowWidgets=42]="fixedOverflowWidgets",ie[ie.folding=43]="folding",ie[ie.foldingStrategy=44]="foldingStrategy",ie[ie.foldingHighlight=45]="foldingHighlight",ie[ie.foldingImportsByDefault=46]="foldingImportsByDefault",ie[ie.foldingMaximumRegions=47]="foldingMaximumRegions",ie[ie.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ie[ie.fontFamily=49]="fontFamily",ie[ie.fontInfo=50]="fontInfo",ie[ie.fontLigatures=51]="fontLigatures",ie[ie.fontSize=52]="fontSize",ie[ie.fontWeight=53]="fontWeight",ie[ie.fontVariations=54]="fontVariations",ie[ie.formatOnPaste=55]="formatOnPaste",ie[ie.formatOnType=56]="formatOnType",ie[ie.glyphMargin=57]="glyphMargin",ie[ie.gotoLocation=58]="gotoLocation",ie[ie.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ie[ie.hover=60]="hover",ie[ie.inDiffEditor=61]="inDiffEditor",ie[ie.inlineSuggest=62]="inlineSuggest",ie[ie.inlineEdit=63]="inlineEdit",ie[ie.letterSpacing=64]="letterSpacing",ie[ie.lightbulb=65]="lightbulb",ie[ie.lineDecorationsWidth=66]="lineDecorationsWidth",ie[ie.lineHeight=67]="lineHeight",ie[ie.lineNumbers=68]="lineNumbers",ie[ie.lineNumbersMinChars=69]="lineNumbersMinChars",ie[ie.linkedEditing=70]="linkedEditing",ie[ie.links=71]="links",ie[ie.matchBrackets=72]="matchBrackets",ie[ie.minimap=73]="minimap",ie[ie.mouseStyle=74]="mouseStyle",ie[ie.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",ie[ie.mouseWheelZoom=76]="mouseWheelZoom",ie[ie.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",ie[ie.multiCursorModifier=78]="multiCursorModifier",ie[ie.multiCursorPaste=79]="multiCursorPaste",ie[ie.multiCursorLimit=80]="multiCursorLimit",ie[ie.occurrencesHighlight=81]="occurrencesHighlight",ie[ie.overviewRulerBorder=82]="overviewRulerBorder",ie[ie.overviewRulerLanes=83]="overviewRulerLanes",ie[ie.padding=84]="padding",ie[ie.pasteAs=85]="pasteAs",ie[ie.parameterHints=86]="parameterHints",ie[ie.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",ie[ie.placeholder=88]="placeholder",ie[ie.definitionLinkOpensInPeek=89]="definitionLinkOpensInPeek",ie[ie.quickSuggestions=90]="quickSuggestions",ie[ie.quickSuggestionsDelay=91]="quickSuggestionsDelay",ie[ie.readOnly=92]="readOnly",ie[ie.readOnlyMessage=93]="readOnlyMessage",ie[ie.renameOnType=94]="renameOnType",ie[ie.renderControlCharacters=95]="renderControlCharacters",ie[ie.renderFinalNewline=96]="renderFinalNewline",ie[ie.renderLineHighlight=97]="renderLineHighlight",ie[ie.renderLineHighlightOnlyWhenFocus=98]="renderLineHighlightOnlyWhenFocus",ie[ie.renderValidationDecorations=99]="renderValidationDecorations",ie[ie.renderWhitespace=100]="renderWhitespace",ie[ie.revealHorizontalRightPadding=101]="revealHorizontalRightPadding",ie[ie.roundedSelection=102]="roundedSelection",ie[ie.rulers=103]="rulers",ie[ie.scrollbar=104]="scrollbar",ie[ie.scrollBeyondLastColumn=105]="scrollBeyondLastColumn",ie[ie.scrollBeyondLastLine=106]="scrollBeyondLastLine",ie[ie.scrollPredominantAxis=107]="scrollPredominantAxis",ie[ie.selectionClipboard=108]="selectionClipboard",ie[ie.selectionHighlight=109]="selectionHighlight",ie[ie.selectOnLineNumbers=110]="selectOnLineNumbers",ie[ie.showFoldingControls=111]="showFoldingControls",ie[ie.showUnused=112]="showUnused",ie[ie.snippetSuggestions=113]="snippetSuggestions",ie[ie.smartSelect=114]="smartSelect",ie[ie.smoothScrolling=115]="smoothScrolling",ie[ie.stickyScroll=116]="stickyScroll",ie[ie.stickyTabStops=117]="stickyTabStops",ie[ie.stopRenderingLineAfter=118]="stopRenderingLineAfter",ie[ie.suggest=119]="suggest",ie[ie.suggestFontSize=120]="suggestFontSize",ie[ie.suggestLineHeight=121]="suggestLineHeight",ie[ie.suggestOnTriggerCharacters=122]="suggestOnTriggerCharacters",ie[ie.suggestSelection=123]="suggestSelection",ie[ie.tabCompletion=124]="tabCompletion",ie[ie.tabIndex=125]="tabIndex",ie[ie.unicodeHighlighting=126]="unicodeHighlighting",ie[ie.unusualLineTerminators=127]="unusualLineTerminators",ie[ie.useShadowDOM=128]="useShadowDOM",ie[ie.useTabStops=129]="useTabStops",ie[ie.wordBreak=130]="wordBreak",ie[ie.wordSegmenterLocales=131]="wordSegmenterLocales",ie[ie.wordSeparators=132]="wordSeparators",ie[ie.wordWrap=133]="wordWrap",ie[ie.wordWrapBreakAfterCharacters=134]="wordWrapBreakAfterCharacters",ie[ie.wordWrapBreakBeforeCharacters=135]="wordWrapBreakBeforeCharacters",ie[ie.wordWrapColumn=136]="wordWrapColumn",ie[ie.wordWrapOverride1=137]="wordWrapOverride1",ie[ie.wordWrapOverride2=138]="wordWrapOverride2",ie[ie.wrappingIndent=139]="wrappingIndent",ie[ie.wrappingStrategy=140]="wrappingStrategy",ie[ie.showDeprecated=141]="showDeprecated",ie[ie.inlayHints=142]="inlayHints",ie[ie.editorClassName=143]="editorClassName",ie[ie.pixelRatio=144]="pixelRatio",ie[ie.tabFocusMode=145]="tabFocusMode",ie[ie.layoutInfo=146]="layoutInfo",ie[ie.wrappingInfo=147]="wrappingInfo",ie[ie.defaultColorDecorators=148]="defaultColorDecorators",ie[ie.colorDecoratorsActivatedOn=149]="colorDecoratorsActivatedOn",ie[ie.inlineCompletionsAccessibilityVerbose=150]="inlineCompletionsAccessibilityVerbose"})(je||(e.EditorOption=je={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:qe(new n(je.acceptSuggestionOnCommitCharacter,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(11978,null)})),acceptSuggestionOnEnter:qe(new E(je.acceptSuggestionOnEnter,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(11979,null),""],markdownDescription:o.localize(11980,null)})),accessibilitySupport:qe(new C),accessibilityPageSize:qe(new g(je.accessibilityPageSize,"accessibilityPageSize",10,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(11981,null),tags:["accessibility"]})),ariaLabel:qe(new m(je.ariaLabel,"ariaLabel",o.localize(11982,null))),ariaRequired:qe(new n(je.ariaRequired,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:qe(new n(je.screenReaderAnnounceInlineSuggestion,"screenReaderAnnounceInlineSuggestion",!0,{description:o.localize(11983,null),tags:["accessibility"]})),autoClosingBrackets:qe(new E(je.autoClosingBrackets,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11984,null),o.localize(11985,null),""],description:o.localize(11986,null)})),autoClosingComments:qe(new E(je.autoClosingComments,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11987,null),o.localize(11988,null),""],description:o.localize(11989,null)})),autoClosingDelete:qe(new E(je.autoClosingDelete,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(11990,null),""],description:o.localize(11991,null)})),autoClosingOvertype:qe(new E(je.autoClosingOvertype,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(11992,null),""],description:o.localize(11993,null)})),autoClosingQuotes:qe(new E(je.autoClosingQuotes,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(11994,null),o.localize(11995,null),""],description:o.localize(11996,null)})),autoIndent:qe(new D(je.autoIndent,"autoIndent",y.Full,"full",["none","keep","brackets","advanced","full"],w,{enumDescriptions:[o.localize(11997,null),o.localize(11998,null),o.localize(11999,null),o.localize(12e3,null),o.localize(12001,null)],description:o.localize(12002,null)})),automaticLayout:qe(new n(je.automaticLayout,"automaticLayout",!1)),autoSurround:qe(new E(je.autoSurround,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(12003,null),o.localize(12004,null),o.localize(12005,null),""],description:o.localize(12006,null)})),bracketPairColorization:qe(new Ce),bracketPairGuides:qe(new ze),stickyTabStops:qe(new n(je.stickyTabStops,"stickyTabStops",!1,{description:o.localize(12007,null)})),codeLens:qe(new n(je.codeLens,"codeLens",!0,{description:o.localize(12008,null)})),codeLensFontFamily:qe(new m(je.codeLensFontFamily,"codeLensFontFamily","",{description:o.localize(12009,null)})),codeLensFontSize:qe(new g(je.codeLensFontSize,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(12010,null)})),colorDecorators:qe(new n(je.colorDecorators,"colorDecorators",!0,{description:o.localize(12011,null)})),colorDecoratorActivatedOn:qe(new E(je.colorDecoratorsActivatedOn,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[o.localize(12012,null),o.localize(12013,null),o.localize(12014,null)],description:o.localize(12015,null)})),colorDecoratorsLimit:qe(new g(je.colorDecoratorsLimit,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(12016,null)})),columnSelection:qe(new n(je.columnSelection,"columnSelection",!1,{description:o.localize(12017,null)})),comments:qe(new k),contextmenu:qe(new n(je.contextmenu,"contextmenu",!0)),copyWithSyntaxHighlighting:qe(new n(je.copyWithSyntaxHighlighting,"copyWithSyntaxHighlighting",!0,{description:o.localize(12018,null)})),cursorBlinking:qe(new D(je.cursorBlinking,"cursorBlinking",f.Blink,"blink",["blink","smooth","phase","expand","solid"],b,{description:o.localize(12019,null)})),cursorSmoothCaretAnimation:qe(new E(je.cursorSmoothCaretAnimation,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(12020,null),o.localize(12021,null),o.localize(12022,null)],description:o.localize(12023,null)})),cursorStyle:qe(new D(je.cursorStyle,"cursorStyle",M.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:o.localize(12024,null)})),cursorSurroundingLines:qe(new g(je.cursorSurroundingLines,"cursorSurroundingLines",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12025,null)})),cursorSurroundingLinesStyle:qe(new E(je.cursorSurroundingLinesStyle,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(12026,null),o.localize(12027,null)],markdownDescription:o.localize(12028,null)})),cursorWidth:qe(new g(je.cursorWidth,"cursorWidth",0,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(12029,null)})),disableLayerHinting:qe(new n(je.disableLayerHinting,"disableLayerHinting",!1)),disableMonospaceOptimizations:qe(new n(je.disableMonospaceOptimizations,"disableMonospaceOptimizations",!1)),domReadOnly:qe(new n(je.domReadOnly,"domReadOnly",!1)),dragAndDrop:qe(new n(je.dragAndDrop,"dragAndDrop",!0,{description:o.localize(12030,null)})),emptySelectionClipboard:qe(new K),dropIntoEditor:qe(new lt),stickyScroll:qe(new B),experimentalWhitespaceRendering:qe(new E(je.experimentalWhitespaceRendering,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(12031,null),o.localize(12032,null),o.localize(12033,null)],description:o.localize(12034,null)})),extraEditorClassName:qe(new m(je.extraEditorClassName,"extraEditorClassName","")),fastScrollSensitivity:qe(new $(je.fastScrollSensitivity,"fastScrollSensitivity",5,ie=>ie<=0?5:ie,{markdownDescription:o.localize(12035,null)})),find:qe(new q),fixedOverflowWidgets:qe(new n(je.fixedOverflowWidgets,"fixedOverflowWidgets",!1)),folding:qe(new n(je.folding,"folding",!0,{description:o.localize(12036,null)})),foldingStrategy:qe(new E(je.foldingStrategy,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(12037,null),o.localize(12038,null)],description:o.localize(12039,null)})),foldingHighlight:qe(new n(je.foldingHighlight,"foldingHighlight",!0,{description:o.localize(12040,null)})),foldingImportsByDefault:qe(new n(je.foldingImportsByDefault,"foldingImportsByDefault",!1,{description:o.localize(12041,null)})),foldingMaximumRegions:qe(new g(je.foldingMaximumRegions,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(12042,null)})),unfoldOnClickAfterEndOfLine:qe(new n(je.unfoldOnClickAfterEndOfLine,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(12043,null)})),fontFamily:qe(new m(je.fontFamily,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(12044,null)})),fontInfo:qe(new ae),fontLigatures2:qe(new G),fontSize:qe(new we),fontWeight:qe(new le),fontVariations:qe(new Q),formatOnPaste:qe(new n(je.formatOnPaste,"formatOnPaste",!1,{description:o.localize(12045,null)})),formatOnType:qe(new n(je.formatOnType,"formatOnType",!1,{description:o.localize(12046,null)})),glyphMargin:qe(new n(je.glyphMargin,"glyphMargin",!0,{description:o.localize(12047,null)})),gotoLocation:qe(new _),hideCursorInOverviewRuler:qe(new n(je.hideCursorInOverviewRuler,"hideCursorInOverviewRuler",!1,{description:o.localize(12048,null)})),hover:qe(new ce),inDiffEditor:qe(new n(je.inDiffEditor,"inDiffEditor",!1)),letterSpacing:qe(new $(je.letterSpacing,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ie=>$.clamp(ie,-5,20),{description:o.localize(12049,null)})),lightbulb:qe(new Z),lineDecorationsWidth:qe(new Ee),lineHeight:qe(new fe),lineNumbers:qe(new Ie),lineNumbersMinChars:qe(new g(je.lineNumbersMinChars,"lineNumbersMinChars",5,1,300)),linkedEditing:qe(new n(je.linkedEditing,"linkedEditing",!1,{description:o.localize(12050,null)})),links:qe(new n(je.links,"links",!0,{description:o.localize(12051,null)})),matchBrackets:qe(new E(je.matchBrackets,"matchBrackets","always",["always","near","never"],{description:o.localize(12052,null)})),minimap:qe(new be),mouseStyle:qe(new E(je.mouseStyle,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:qe(new $(je.mouseWheelScrollSensitivity,"mouseWheelScrollSensitivity",1,ie=>ie===0?1:ie,{markdownDescription:o.localize(12053,null)})),mouseWheelZoom:qe(new n(je.mouseWheelZoom,"mouseWheelZoom",!1,{markdownDescription:P.$k?o.localize(12054,null):o.localize(12055,null)})),multiCursorMergeOverlapping:qe(new n(je.multiCursorMergeOverlapping,"multiCursorMergeOverlapping",!0,{description:o.localize(12056,null)})),multiCursorModifier:qe(new D(je.multiCursorModifier,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],he,{markdownEnumDescriptions:[o.localize(12057,null),o.localize(12058,null)],markdownDescription:o.localize(12059,null)})),multiCursorPaste:qe(new E(je.multiCursorPaste,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(12060,null),o.localize(12061,null)],markdownDescription:o.localize(12062,null)})),multiCursorLimit:qe(new g(je.multiCursorLimit,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(12063,null)})),occurrencesHighlight:qe(new E(je.occurrencesHighlight,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[o.localize(12064,null),o.localize(12065,null),o.localize(12066,null)],markdownDescription:o.localize(12067,null)})),overviewRulerBorder:qe(new n(je.overviewRulerBorder,"overviewRulerBorder",!0,{description:o.localize(12068,null)})),overviewRulerLanes:qe(new g(je.overviewRulerLanes,"overviewRulerLanes",3,0,3)),padding:qe(new X),pasteAs:qe(new st),parameterHints:qe(new x),peekWidgetDefaultFocus:qe(new E(je.peekWidgetDefaultFocus,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(12069,null),o.localize(12070,null)],description:o.localize(12071,null)})),placeholder:qe(new pe),definitionLinkOpensInPeek:qe(new n(je.definitionLinkOpensInPeek,"definitionLinkOpensInPeek",!1,{description:o.localize(12072,null)})),quickSuggestions:qe(new Ae),quickSuggestionsDelay:qe(new g(je.quickSuggestionsDelay,"quickSuggestionsDelay",10,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12073,null)})),readOnly:qe(new n(je.readOnly,"readOnly",!1)),readOnlyMessage:qe(new z),renameOnType:qe(new n(je.renameOnType,"renameOnType",!1,{description:o.localize(12074,null),markdownDeprecationMessage:o.localize(12075,null)})),renderControlCharacters:qe(new n(je.renderControlCharacters,"renderControlCharacters",!0,{description:o.localize(12076,null),restricted:!0})),renderFinalNewline:qe(new E(je.renderFinalNewline,"renderFinalNewline",P.$l?"dimmed":"on",["off","on","dimmed"],{description:o.localize(12077,null)})),renderLineHighlight:qe(new E(je.renderLineHighlight,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(12078,null)],description:o.localize(12079,null)})),renderLineHighlightOnlyWhenFocus:qe(new n(je.renderLineHighlightOnlyWhenFocus,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(12080,null)})),renderValidationDecorations:qe(new E(je.renderValidationDecorations,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:qe(new E(je.renderWhitespace,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(12081,null),o.localize(12082,null),o.localize(12083,null),""],description:o.localize(12084,null)})),revealHorizontalRightPadding:qe(new g(je.revealHorizontalRightPadding,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:qe(new n(je.roundedSelection,"roundedSelection",!0,{description:o.localize(12085,null)})),rulers:qe(new Oe),scrollbar:qe(new H),scrollBeyondLastColumn:qe(new g(je.scrollBeyondLastColumn,"scrollBeyondLastColumn",4,0,A.Constants.MAX_SAFE_SMALL_INTEGER,{description:o.localize(12086,null)})),scrollBeyondLastLine:qe(new n(je.scrollBeyondLastLine,"scrollBeyondLastLine",!0,{description:o.localize(12087,null)})),scrollPredominantAxis:qe(new n(je.scrollPredominantAxis,"scrollPredominantAxis",!0,{description:o.localize(12088,null)})),selectionClipboard:qe(new n(je.selectionClipboard,"selectionClipboard",!0,{description:o.localize(12089,null),included:P.$l})),selectionHighlight:qe(new n(je.selectionHighlight,"selectionHighlight",!0,{description:o.localize(12090,null)})),selectOnLineNumbers:qe(new n(je.selectOnLineNumbers,"selectOnLineNumbers",!0)),showFoldingControls:qe(new E(je.showFoldingControls,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(12091,null),o.localize(12092,null),o.localize(12093,null)],description:o.localize(12094,null)})),showUnused:qe(new n(je.showUnused,"showUnused",!0,{description:o.localize(12095,null)})),showDeprecated:qe(new n(je.showDeprecated,"showDeprecated",!0,{description:o.localize(12096,null)})),inlayHints:qe(new ne),snippetSuggestions:qe(new E(je.snippetSuggestions,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(12097,null),o.localize(12098,null),o.localize(12099,null),o.localize(12100,null)],description:o.localize(12101,null)})),smartSelect:qe(new tt),smoothScrolling:qe(new n(je.smoothScrolling,"smoothScrolling",!1,{description:o.localize(12102,null)})),stopRenderingLineAfter:qe(new g(je.stopRenderingLineAfter,"stopRenderingLineAfter",1e4,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),suggest:qe(new _e),inlineSuggest:qe(new re),inlineEdit:qe(new ge),inlineCompletionsAccessibilityVerbose:qe(new n(je.inlineCompletionsAccessibilityVerbose,"inlineCompletionsAccessibilityVerbose",!1,{description:o.localize(12103,null)})),suggestFontSize:qe(new g(je.suggestFontSize,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(12104,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:qe(new g(je.suggestLineHeight,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(12105,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:qe(new n(je.suggestOnTriggerCharacters,"suggestOnTriggerCharacters",!0,{description:o.localize(12106,null)})),suggestSelection:qe(new E(je.suggestSelection,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(12107,null),o.localize(12108,null),o.localize(12109,null)],description:o.localize(12110,null)})),tabCompletion:qe(new E(je.tabCompletion,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(12111,null),o.localize(12112,null),o.localize(12113,null)],description:o.localize(12114,null)})),tabIndex:qe(new g(je.tabIndex,"tabIndex",0,-1,A.Constants.MAX_SAFE_SMALL_INTEGER)),unicodeHighlight:qe(new V),unusualLineTerminators:qe(new E(je.unusualLineTerminators,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(12115,null),o.localize(12116,null),o.localize(12117,null)],description:o.localize(12118,null)})),useShadowDOM:qe(new n(je.useShadowDOM,"useShadowDOM",!0)),useTabStops:qe(new n(je.useTabStops,"useTabStops",!0,{description:o.localize(12119,null)})),wordBreak:qe(new E(je.wordBreak,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(12120,null),o.localize(12121,null)],description:o.localize(12122,null)})),wordSegmenterLocales:qe(new nt),wordSeparators:qe(new m(je.wordSeparators,"wordSeparators",p.$lt,{description:o.localize(12123,null)})),wordWrap:qe(new E(je.wordWrap,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(12124,null),o.localize(12125,null),o.localize(12126,null),o.localize(12127,null)],description:o.localize(12128,null)})),wordWrapBreakAfterCharacters:qe(new m(je.wordWrapBreakAfterCharacters,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:qe(new m(je.wordWrapBreakBeforeCharacters,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:qe(new g(je.wordWrapColumn,"wordWrapColumn",80,1,A.Constants.MAX_SAFE_SMALL_INTEGER,{markdownDescription:o.localize(12129,null)})),wordWrapOverride1:qe(new E(je.wordWrapOverride1,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:qe(new E(je.wordWrapOverride2,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:qe(new W),defaultColorDecorators:qe(new n(je.defaultColorDecorators,"defaultColorDecorators",!1,{markdownDescription:o.localize(12130,null)})),pixelRatio:qe(new $e),tabFocusMode:qe(new n(je.tabFocusMode,"tabFocusMode",!1,{markdownDescription:o.localize(12131,null)})),layoutInfo:qe(new oe),wrappingInfo:qe(new ft),wrappingIndent:qe(new rt),wrappingStrategy:qe(new ke)}}),define(Ne[106],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=void 0,e.$Li=(0,v.$Ei)("environmentService"),e.$Mi=(0,v.$Fi)(e.$Li)}),define(Ne[29],Le([1,0,58,19,12,14,2,9,3,20,15,48]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hl=e.$El=e.FileKind=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.FileOperationResult=e.$wl=e.$vl=e.$ul=e.$sl=e.FileChangeType=e.$rl=e.FileOperation=e.$ll=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$_k=void 0,e.$al=a,e.$bl=s,e.$cl=l,e.$dl=i,e.$el=n,e.$fl=t,e.$gl=g,e.$hl=u,e.$il=$,e.$jl=m,e.$kl=h,e.$ml=w,e.$nl=C,e.$ol=k,e.$pl=f,e.$ql=b,e.$tl=K,e.$Fl=le,e.$Gl=_,e.$Il=me,e.$_k=(0,p.$Ei)("fileService");function a(oe){return oe.create===!0}var S;(function(oe){oe[oe.Unknown=0]="Unknown",oe[oe.File=1]="File",oe[oe.Directory=2]="Directory",oe[oe.SymbolicLink=64]="SymbolicLink"})(S||(e.FileType=S={}));var d;(function(oe){oe[oe.Readonly=1]="Readonly",oe[oe.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var r;(function(oe){oe[oe.UPDATED=2]="UPDATED",oe[oe.ADDED=4]="ADDED",oe[oe.DELETED=8]="DELETED"})(r||(e.FileChangeFilter=r={}));function s(oe){const ke=oe;return!!ke&&typeof ke.onDidChange=="function"}var c;(function(oe){oe[oe.None=0]="None",oe[oe.FileReadWrite=2]="FileReadWrite",oe[oe.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",oe[oe.FileReadStream=16]="FileReadStream",oe[oe.FileFolderCopy=8]="FileFolderCopy",oe[oe.PathCaseSensitive=1024]="PathCaseSensitive",oe[oe.Readonly=2048]="Readonly",oe[oe.Trash=4096]="Trash",oe[oe.FileWriteUnlock=8192]="FileWriteUnlock",oe[oe.FileAtomicRead=16384]="FileAtomicRead",oe[oe.FileAtomicWrite=32768]="FileAtomicWrite",oe[oe.FileAtomicDelete=65536]="FileAtomicDelete",oe[oe.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function l(oe){return!!(oe.capabilities&c.FileReadWrite)}function i(oe){return!!(oe.capabilities&c.FileFolderCopy)}function n(oe){return!!(oe.capabilities&c.FileClone)}function t(oe){return!!(oe.capabilities&c.FileOpenReadWriteClose)}function g(oe){return!!(oe.capabilities&c.FileReadStream)}function u(oe){return l(oe)?!!(oe.capabilities&c.FileAtomicRead):!1}function $(oe){return l(oe)?!!(oe.capabilities&c.FileAtomicWrite):!1}function m(oe){return!!(oe.capabilities&c.FileAtomicDelete)}function h(oe){return!!(oe.capabilities&c.Readonly)}var E;(function(oe){oe.FileExists="EntryExists",oe.FileNotFound="EntryNotFound",oe.FileNotADirectory="EntryNotADirectory",oe.FileIsADirectory="EntryIsADirectory",oe.FileExceedsStorageQuota="EntryExceedsStorageQuota",oe.FileTooLarge="EntryTooLarge",oe.FileWriteLocked="EntryWriteLocked",oe.NoPermissions="NoPermissions",oe.Unavailable="Unavailable",oe.Unknown="Unknown"})(E||(e.FileSystemProviderErrorCode=E={}));class D extends Error{static create(ke,Te){const Z=new D(ke.toString(),Te);return k(Z,Te),Z}constructor(ke,Te){super(ke),this.code=Te}}e.$ll=D;function w(oe,ke){return D.create(oe,ke)}function C(oe){return oe||w((0,T.localize)(11374,null),E.Unknown)}function k(oe,ke){return oe.name=ke?`${ke} (FileSystemError)`:"FileSystemError",oe}function f(oe){if(!oe)return E.Unknown;if(oe instanceof D)return oe.code;const ke=/^(.+) \(FileSystemError\)$/.exec(oe.name);if(!ke)return E.Unknown;switch(ke[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}function b(oe){if(oe instanceof q)return oe.fileOperationResult;switch(f(oe)){case E.FileNotFound:return ae.FILE_NOT_FOUND;case E.FileIsADirectory:return ae.FILE_IS_DIRECTORY;case E.FileNotADirectory:return ae.FILE_NOT_DIRECTORY;case E.FileWriteLocked:return ae.FILE_WRITE_LOCKED;case E.NoPermissions:return ae.FILE_PERMISSION_DENIED;case E.FileExists:return ae.FILE_MOVE_CONFLICT;case E.FileTooLarge:return ae.FILE_TOO_LARGE;default:return ae.FILE_OTHER_ERROR}}var M;(function(oe){oe[oe.CREATE=0]="CREATE",oe[oe.DELETE=1]="DELETE",oe[oe.MOVE=2]="MOVE",oe[oe.COPY=3]="COPY",oe[oe.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class N{constructor(ke,Te,Z){this.resource=ke,this.operation=Te,this.target=Z}isOperation(ke){return this.operation===ke}}e.$rl=N;var L;(function(oe){oe[oe.UPDATED=0]="UPDATED",oe[oe.ADDED=1]="ADDED",oe[oe.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class W{static{this.a=null}constructor(ke,Te){this.c=Te,this.b=void 0,this.d=new y.$T(()=>{const Z=v.$Ki.forUris(()=>this.c);return Z.fill(this.rawAdded.map(B=>[B,!0])),Z}),this.f=new y.$T(()=>{const Z=v.$Ki.forUris(()=>this.c);return Z.fill(this.rawUpdated.map(B=>[B,!0])),Z}),this.g=new y.$T(()=>{const Z=v.$Ki.forUris(()=>this.c);return Z.fill(this.rawDeleted.map(B=>[B,!0])),Z}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Z of ke){switch(Z.type){case L.ADDED:this.rawAdded.push(Z.resource);break;case L.UPDATED:this.rawUpdated.push(Z.resource);break;case L.DELETED:this.rawDeleted.push(Z.resource);break}this.b!==W.a&&(typeof Z.cId=="number"?this.b===void 0?this.b=Z.cId:this.b!==Z.cId&&(this.b=W.a):this.b!==void 0&&(this.b=W.a))}}contains(ke,...Te){return this.h(ke,{includeChildren:!1},...Te)}affects(ke,...Te){return this.h(ke,{includeChildren:!0},...Te)}h(ke,Te,...Z){if(!ke)return!1;const B=Z.length>0;return!!((!B||Z.includes(L.ADDED))&&(this.d.value.get(ke)||Te.includeChildren&&this.d.value.findSuperstr(ke))||(!B||Z.includes(L.UPDATED))&&(this.f.value.get(ke)||Te.includeChildren&&this.f.value.findSuperstr(ke))||(!B||Z.includes(L.DELETED))&&(this.g.value.findSubstr(ke)||Te.includeChildren&&this.g.value.findSuperstr(ke)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ke){return this.b===ke}hasCorrelation(){return typeof this.b=="number"}}e.$sl=W;function K(oe,ke,Te){return!oe||!ke||oe===ke||ke.length>oe.length?!1:(ke.charAt(ke.length-1)!==R.sep&&(ke+=R.sep),Te?(0,P.$Gf)(oe,ke):oe.indexOf(ke)===0)}class q extends Error{constructor(ke,Te,Z){super(ke),this.fileOperationResult=Te,this.options=Z}}e.$ul=q;class G extends q{constructor(ke,Te,Z,B){super(ke,Te,B),this.fileOperationResult=Te,this.size=Z}}e.$vl=G;class Q extends q{constructor(ke,Te,Z){super(ke,ae.FILE_NOT_MODIFIED_SINCE,Z),this.stat=Te}}e.$wl=Q;var ae;(function(oe){oe[oe.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",oe[oe.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",oe[oe.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",oe[oe.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",oe[oe.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",oe[oe.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",oe[oe.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",oe[oe.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",oe[oe.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",oe[oe.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",oe[oe.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$xl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$yl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$zl="files.associations",e.$Al="files.exclude",e.$Bl="files.readonlyInclude",e.$Cl="files.readonlyExclude",e.$Dl="files.readonlyFromPermissions";var we;(function(oe){oe[oe.FILE=0]="FILE",oe[oe.FOLDER=1]="FOLDER",oe[oe.ROOT_FOLDER=2]="ROOT_FOLDER"})(we||(e.FileKind=we={})),e.$El="";function le(oe){if(!(typeof oe.size!="number"||typeof oe.mtime!="number"))return oe.mtime.toString(29)+oe.size.toString(31)}async function _(oe,ke){if(!ke.hasProvider(A.URI.from({scheme:oe.scheme})))return new Promise(Te=>{const Z=ke.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===oe.scheme&&B.added&&(Z.dispose(),Te())})})}class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(ke){return(0,O.$ig)(ke)||(ke=0),ke<ce.KB?(0,T.localize)(11375,null,ke.toFixed(0)):ke<ce.MB?(0,T.localize)(11376,null,(ke/ce.KB).toFixed(2)):ke<ce.GB?(0,T.localize)(11377,null,(ke/ce.MB).toFixed(2)):ke<ce.TB?(0,T.localize)(11378,null,(ke/ce.GB).toFixed(2)):(0,T.localize)(11379,null,(ke/ce.TB).toFixed(2))}}e.$Hl=ce;function me(oe){const ke=typeof oe=="string"||oe?.scheme===I.Schemas.vscodeRemote;return typeof oe!="string"&&oe?.scheme===I.Schemas.file?1024*ce.MB:ke?10*ce.MB:o.$p?50*ce.MB:1024*ce.MB}}),define(Ne[74],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=void 0;class v{constructor(...P){this.a=new Map;for(const[O,A]of P)this.set(O,A)}set(P,O){const A=this.a.get(P);return this.a.set(P,O),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Ci=v}),define(Ne[170],Le([1,0,10,13,4,73,167,3,74,171]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=void 0;const I=!1;class y extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class a{constructor(s=new p.$Ci,c=!1,l,i=I){this.i=s,this.j=c,this.k=l,this.l=i,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(T.$Di,this),this._globalGraph=i?l?._globalGraph??new A.$ur(n=>n):void 0}dispose(){if(!this.f){this.f=!0,(0,P.$Pc)(this.h),this.h.clear();for(const s of this.g)(0,P.$Oc)(s)&&s.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(s,c){this.m();const l=this,i=new class extends a{dispose(){l.h.delete(i),super.dispose()}}(s,this.j,this,this.l);return this.h.add(i),c?.add(i),i}invokeFunction(s,...c){this.m();const l=d.traceInvocation(this.l,s);let i=!1;try{return s({get:t=>{if(i)throw(0,R.$7)("service accessor is only valid during the invocation of its target method");const g=this.s(t,l);if(!g)throw new Error(`[invokeFunction] unknown service '${t}'`);return g}},...c)}finally{i=!0,l.stop()}}createInstance(s,...c){this.m();let l,i;return s instanceof O.$Bi?(l=d.traceCreation(this.l,s.ctor),i=this.o(s.ctor,s.staticArguments.concat(c),l)):(l=d.traceCreation(this.l,s),i=this.o(s,c,l)),l.stop(),i}o(s,c=[],l){const i=T._util.getServiceDependencies(s).sort((g,u)=>g.index-u.index),n=[];for(const g of i){const u=this.s(g.id,l);u||this.y(`[createInstance] ${s.name} depends on UNKNOWN service ${g.id}.`,!1),n.push(u)}const t=i.length>0?i[0].index:c.length;if(c.length!==t){console.trace(`[createInstance] First service dependency of ${s.name} at position ${t+1} conflicts with ${c.length} static arguments`);const g=t-c.length;g>0?c=c.concat(new Array(g)):c=c.slice(0,t)}return Reflect.construct(s,c.concat(n))}q(s,c){if(this.i.get(s)instanceof O.$Bi)this.i.set(s,c);else if(this.k)this.k.q(s,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(s){const c=this.i.get(s);return!c&&this.k?this.k.r(s):c}s(s,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const l=this.r(s);return l instanceof O.$Bi?this.u(s,l,c.branch(s,!0)):(c.branch(s,!1),l)}u(s,c,l){if(this.t.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.t.add(s);try{return this.v(s,c,l)}finally{this.t.delete(s)}}v(s,c,l){const i=new A.$ur(u=>u.id.toString());let n=0;const t=[{id:s,desc:c,_trace:l}],g=new Set;for(;t.length;){const u=t.pop();if(!g.has(String(u.id))){if(g.add(String(u.id)),i.lookupOrInsertNode(u),n++>1e3)throw new y(i);for(const $ of T._util.getServiceDependencies(u.desc.ctor)){const m=this.r($.id);if(m||this.y(`[createInstance] ${s} depends on ${$.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(u.id),String($.id)),m instanceof O.$Bi){const h={id:$.id,desc:m,_trace:u._trace.branch($.id,!0)};i.insertEdge(u,h),t.push(h)}}}}for(;;){const u=i.roots();if(u.length===0){if(!i.isEmpty())throw new y(i);break}for(const{data:$}of u){if(this.r($.id)instanceof O.$Bi){const h=this.w($.id,$.desc.ctor,$.desc.staticArguments,$.desc.supportsDelayedInstantiation,$._trace);this.q($.id,h)}i.removeNode($)}}return this.r(s)}w(s,c,l=[],i,n){if(this.i.get(s)instanceof O.$Bi)return this.x(s,c,l,i,n,this.g);if(this.k)return this.k.w(s,c,l,i,n);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(s,c,l=[],i,n,t){if(i){const g=new a(void 0,this.j,this,this.l);g.c=String(s);const u=new Map,$=new v.$Xh(()=>{const m=g.o(c,l,n);for(const[h,E]of u){const D=m[h];if(typeof D=="function")for(const w of E)w.disposable=D.apply(m,w.listener)}return u.clear(),t.add(m),m});return new Proxy(Object.create(null),{get(m,h){if(!$.isInitialized&&typeof h=="string"&&(h.startsWith("onDid")||h.startsWith("onWill"))){let w=u.get(h);return w||(w=new o.$5c,u.set(h,w)),(k,f,b)=>{if($.isInitialized)return $.value[h](k,f,b);{const M={listener:[k,f,b],disposable:void 0},N=w.push(M);return(0,P.$Sc)(()=>{N(),M.disposable?.dispose()})}}}if(h in m)return m[h];const E=$.value;let D=E[h];return typeof D!="function"||(D=D.bind(E),m[h]=D),D},set(m,h,E){return $.value[h]=E,!0},getPrototypeOf(m){return c.prototype}})}else{const g=this.o(c,l,n);return t.add(g),g}}y(s,c){if(c&&console.warn(s),this.j)throw new Error(s)}}e.$vr=a;var S;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})(S||(S={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(S.None,null)}stop(){}branch(){return this}}}static traceInvocation(s,c){return s?new d(S.Invocation,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(s,c){return s?new d(S.Creation,c.name):d.c}static{this.f=0}constructor(s,c){this.type=s,this.name=c,this.g=Date.now(),this.h=[]}branch(s,c){const l=new d(S.Branch,s.toString());return this.h.push([s,c,l]),l}stop(){const s=Date.now()-this.g;d.f+=s;let c=!1;function l(n,t){const g=[],u=new Array(n+1).join("	");for(const[$,m,h]of t.h)if(m&&h){c=!0,g.push(`${u}CREATES -> ${$}`);const E=l(n+1,h);E&&g.push(E)}else g.push(`${u}uses -> ${$}`);return g.join(`
`)}const i=[`${this.type===S.Creation?"CREATE":"CALL"} ${this.name}`,`${l(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(s>2||c)&&d.all.add(i.join(`
`))}}e.$wr=d}),define(Ne[11],Le([1,0,9,42,6,75,4,28,20,23,14,2,31,3]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$ck=e.LogLevel=e.$ak=e.$_j=void 0,e.$bk=r,e.log=c,e.$nk=D,e.$ok=w,e.$pk=C,e.$qk=k,v=We(v),e.$_j=(0,S.$Ei)("logService"),e.$ak=(0,S.$Ei)("loggerService");function d(){return new Date().toISOString()}function r(f){return(0,I.$ig)(f)}var s;(function(f){f[f.Off=0]="Off",f[f.Trace=1]="Trace",f[f.Debug=2]="Debug",f[f.Info=3]="Info",f[f.Warning=4]="Warning",f[f.Error=5]="Error"})(s||(e.LogLevel=s={})),e.$ck=s.Info;function c(f,b,M){switch(b){case s.Trace:f.trace(M);break;case s.Debug:f.debug(M);break;case s.Info:f.info(M);break;case s.Warning:f.warn(M);break;case s.Error:f.error(M);break;case s.Off:break;default:throw new Error(`Invalid log level ${b}`)}}function l(f,b=!1){let M="";for(let N=0;N<f.length;N++){let L=f[N];if(L instanceof Error&&(L=(0,R.$pj)(L,b)),typeof L=="object")try{L=JSON.stringify(L)}catch{}M+=(N>0?" ":"")+L}return M}class i extends A.$Uc{constructor(){super(...arguments),this.b=e.$ck,this.c=this.B(new P.$le),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==s.Off&&this.b<=b}}e.$ek=i;class n extends i{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...M){this.f(s.Trace)&&this.g(s.Trace,l([b,...M],!0))}debug(b,...M){this.f(s.Debug)&&this.g(s.Debug,l([b,...M]))}info(b,...M){this.f(s.Info)&&this.g(s.Info,l([b,...M]))}warn(b,...M){this.f(s.Warning)&&this.g(s.Warning,l([b,...M]))}error(b,...M){if(this.f(s.Error))if(b instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=b.stack,this.g(s.Error,l(N))}else this.g(s.Error,l([b,...M]))}flush(){}}e.$fk=n;class t extends i{constructor(b=e.$ck){super(),this.setLevel(b),this.g=!p.$j}trace(b,...M){this.f(s.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...M):console.log(`[main ${d()}]`,b,...M))}debug(b,...M){this.f(s.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...M):console.log(`[main ${d()}]`,b,...M))}info(b,...M){this.f(s.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,b,...M):console.log(`[main ${d()}]`,b,...M))}warn(b,...M){this.f(s.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,b,...M):console.warn(`[main ${d()}]`,b,...M))}error(b,...M){this.f(s.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,b,...M):console.error(`[main ${d()}]`,b,...M))}flush(){}}e.$gk=t;class g extends i{constructor(b=e.$ck,M=!0){super(),this.g=M,this.setLevel(b)}trace(b,...M){this.f(s.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...M):console.log(b,...M))}debug(b,...M){this.f(s.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...M):console.log(b,...M))}info(b,...M){this.f(s.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...M):console.log(b,...M))}warn(b,...M){this.f(s.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...M):console.log(b,...M))}error(b,...M){this.f(s.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...M):console.error(b,...M))}flush(){}}e.$hk=g;class u extends i{constructor(b,M=e.$ck){super(),this.g=b,this.setLevel(M)}trace(b,...M){this.f(s.Trace)&&this.g.log(s.Trace,[this.h(b),...M])}debug(b,...M){this.f(s.Debug)&&this.g.log(s.Debug,[this.h(b),...M])}info(b,...M){this.f(s.Info)&&this.g.log(s.Info,[this.h(b),...M])}warn(b,...M){this.f(s.Warning)&&this.g.log(s.Warning,[this.h(b),...M])}error(b,...M){this.f(s.Error)&&this.g.log(s.Error,[this.h(b),...M])}h(b){return typeof b=="string"?b:(0,R.$pj)(b,this.f(s.Trace))}flush(){}}e.$ik=u;class $ extends i{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const M of this.g)M.setLevel(b);super.setLevel(b)}trace(b,...M){for(const N of this.g)N.trace(b,...M)}debug(b,...M){for(const N of this.g)N.debug(b,...M)}info(b,...M){for(const N of this.g)N.info(b,...M)}warn(b,...M){for(const N of this.g)N.warn(b,...M)}error(b,...M){for(const N of this.g)N.error(b,...M)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose();super.dispose()}}e.$jk=$;class m extends A.$Uc{constructor(b,M,N){if(super(),this.h=b,this.j=M,this.b=new T.$Ac,this.c=this.B(new P.$le),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.$le),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.$le),this.onDidChangeVisibility=this.g.event,N)for(const L of N)this.b.set(L.resource,{logger:void 0,info:L})}m(b){return(0,I.$eg)(b)?[...this.b.values()].find(M=>M.info.id===b):this.b.get(b)}getLogger(b){return this.m(b)?.logger}createLogger(b,M){const N=this.n(b),L=(0,I.$eg)(b)?b:M?.id??(0,O.$sj)(N.toString()).toString(16);let W=this.b.get(N)?.logger;const K=M?.logLevel==="always"?s.Trace:M?.logLevel;W||(W=this.s(N,K??this.getLogLevel(N)??this.h,{...M,id:L}));const q={logger:W,info:{resource:N,id:L,logLevel:K,name:M?.name,hidden:M?.hidden,extensionId:M?.extensionId,when:M?.when}};return this.registerLogger(q.info),this.b.set(N,q),W}n(b){return(0,I.$eg)(b)?(0,o.$fh)(this.j,`${b}.log`):b}setLogLevel(b,M){if(y.URI.isUri(b)){const N=b,L=M,W=this.b.get(N);W&&L!==W.info.logLevel&&(W.info.logLevel=L===this.h?void 0:L,W.logger?.setLevel(L),this.b.set(W.info.resource,W),this.f.fire([N,L]))}else{this.h=b;for(const[N,L]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&L.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,M){const N=this.m(b);N&&M!==!N.info.hidden&&(N.info.hidden=!M,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,M]))}getLogLevel(b){let M;return b&&(M=this.b.get(b)?.info.logLevel),M??this.h}registerLogger(b){const M=this.b.get(b.resource);M?M.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const M=this.b.get(b);M&&(M.logger&&M.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[M.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.$kk=m;class h{constructor(){this.onDidChangeLogLevel=new P.$le().event}setLevel(b){}getLevel(){return s.Info}trace(b,...M){}debug(b,...M){}info(b,...M){}warn(b,...M){}error(b,...M){}critical(b,...M){}dispose(){}flush(){}}e.$lk=h;class E extends h{}e.$mk=E;function D(f){if(f.verbose)return s.Trace;if(typeof f.logLevel=="string"){const b=k(f.logLevel.toLowerCase());if(b!==void 0)return b}return e.$ck}function w(f){switch(f){case s.Trace:return"trace";case s.Debug:return"debug";case s.Info:return"info";case s.Warning:return"warn";case s.Error:return"error";case s.Off:return"off"}}function C(f){switch(f){case s.Trace:return{original:"Trace",value:v.localize(11307,null)};case s.Debug:return{original:"Debug",value:v.localize(11308,null)};case s.Info:return{original:"Info",value:v.localize(11309,null)};case s.Warning:return{original:"Warning",value:v.localize(11310,null)};case s.Error:return{original:"Error",value:v.localize(11311,null)};case s.Off:return{original:"Off",value:v.localize(11312,null)}}}function k(f){switch(f){case"trace":return s.Trace;case"debug":return s.Debug;case"info":return s.Info;case"warn":return s.Warning;case"error":return s.Error;case"critical":return s.Error;case"off":return s.Off}}e.$rk=new a.$Vj("logLevel",w(s.Info))}),define(Ne[172],Le([1,0,4,11]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JR=void 0;class P extends v.$Uc{constructor(A,T=[]){super(),this.a=new R.$jk([A,...T]),this.B(A.onDidChangeLogLevel(p=>this.setLevel(p)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...T){this.a.trace(A,...T)}debug(A,...T){this.a.debug(A,...T)}info(A,...T){this.a.info(A,...T)}warn(A,...T){this.a.warn(A,...T)}error(A,...T){this.a.error(A,...T)}flush(){this.a.flush()}}e.$JR=P});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[107],Le([1,0,35,9,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0,v=xt(v);var O;(function(p){p[p.Unnecessary=1]="Unnecessary",p[p.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var A;(function(p){p[p.Hint=1]="Hint",p[p.Info=2]="Info",p[p.Warning=4]="Warning",p[p.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(p){function o(d,r){return r-d}p.compare=o;const I=Object.create(null);I[p.Error]=(0,R.localize)(11304,null),I[p.Warning]=(0,R.localize)(11305,null),I[p.Info]=(0,R.localize)(11306,null);function y(d){return I[d]||""}p.toString=y;function a(d){switch(d){case v.default.Error:return p.Error;case v.default.Warning:return p.Warning;case v.default.Info:return p.Info;case v.default.Ignore:return p.Hint}}p.fromSeverity=a;function S(d){switch(d){case p.Error:return v.default.Error;case p.Warning:return v.default.Warning;case p.Info:return v.default.Info;case p.Hint:return v.default.Ignore}}p.toSeverity=S}(A||(e.MarkerSeverity=A={}));var T;(function(p){const o="";function I(a){return y(a,!0)}p.makeKey=I;function y(a,S){const d=[o];return a.source?d.push(a.source.replace("\xA6","\\\xA6")):d.push(o),a.code?typeof a.code=="string"?d.push(a.code.replace("\xA6","\\\xA6")):d.push(a.code.value.replace("\xA6","\\\xA6")):d.push(o),a.severity!==void 0&&a.severity!==null?d.push(A.toString(a.severity)):d.push(o),a.message&&S?d.push(a.message.replace("\xA6","\\\xA6")):d.push(o),a.startLineNumber!==void 0&&a.startLineNumber!==null?d.push(a.startLineNumber.toString()):d.push(o),a.startColumn!==void 0&&a.startColumn!==null?d.push(a.startColumn.toString()):d.push(o),a.endLineNumber!==void 0&&a.endLineNumber!==null?d.push(a.endLineNumber.toString()):d.push(o),a.endColumn!==void 0&&a.endColumn!==null?d.push(a.endColumn.toString()):d.push(o),d.push(o),d.join("\xA6")}p.makeKeyOptionalMessage=y})(T||(e.IMarkerData=T={})),e.$Fu=(0,P.$Ei)("markerService")});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[173],Le([1,0,6,35,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vw=e.$uw=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$sw=e.Severity=void 0,e.$tw=T,R=xt(R),e.Severity=R.default,e.$sw=(0,P.$Ei)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var A;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function T(y){if(y){const a=y;return typeof a.id=="string"&&typeof a.label=="string"}return!1}var p;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(p||(e.NotificationsFilter=p={}));class o{constructor(){this.progress=new I,this.onDidClose=v.Event.None,this.onDidChangeVisibility=v.Event.None}updateSeverity(a){}updateMessage(a){}updateActions(a){}close(){}}e.$uw=o;class I{infinite(){}done(){}total(a){}worked(a){}}e.$vw=I}),define(Ne[108],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=void 0,e.$sk=(0,v.$Ei)("productService"),e.$tk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ve,e,v,R){var P=arguments.length,O=P<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ve,e,v,R);else for(var T=ve.length-1;T>=0;T--)(A=ve[T])&&(O=(P<3?A(O):P>3?A(e,v,O):A(e,v))||O);return P>3&&O&&Object.defineProperty(e,v,O),O},Ve=this&&this.__param||function(ve,e){return function(v,R){e(v,R,ve)}};define(Ne[76],Le([1,0,10,21,4,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.ProgressLocation=e.$ww=void 0,e.$ww=(0,O.$Ei)("progressService");var A;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$xw=Object.freeze({total(){},worked(){},done(){}});class T{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(a){this.b=a}report(a){this.a=a,this.b(this.a)}}e.$yw=T;class p{get value(){return this.a}constructor(a){this.e=a}report(a){this.b?this.b.push(a):this.b=[a],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const a=this.b.shift();this.a=a,await this.e(this.a)}}finally{this.c=!1;const a=this.d;this.d=void 0,a?.()}}drain(){return this.c?new Promise(a=>{const S=this.d;this.d=()=>{S?.(),a()}}):Promise.resolve()}}e.$zw=p;let o=class extends P.$Uc{constructor(a,S){super(),this.a=new v.$2h,S.withProgress(a,d=>(this.b=d,this.c&&d.report(this.c),this.a.p)),this.B((0,P.$Sc)(()=>this.a.complete()))}report(a){this.b?this.b.report(a):this.c=a}};e.$Aw=o,e.$Aw=o=Je([Ve(1,e.$ww)],o);class I extends P.$Uc{constructor(a){super(),this.g=a,this.a=0,this.b=this.B(new P.$Tc)}start(a){this.stop();const S=++this.a,d=new R.$we;return this.f=setTimeout(()=>{S===this.a&&(this.c=this.g.show(!0))},a),this.b.add((0,P.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Sc)(()=>d.cancel())),this.b.add((0,P.$Sc)(()=>this.c?this.c.done():void 0)),{id:S,token:d.token,stop:()=>this.h(S),isCurrent:()=>this.a===S}}stop(){this.h(this.a)}h(a){this.a===a&&this.b.clear()}}e.$Bw=I,e.$Cw=(0,O.$Ei)("editorProgressService")}),define(Ne[30],Le([1,0,61,14]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=void 0,v=We(v),R=We(R);class P{constructor(){this.a=new Map}add(A,T){v.ok(R.$eg(A)),v.ok(R.$gg(T)),v.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,T)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$qo=new P}),define(Ne[77],Le([1,0,6,137,30]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=void 0,P=We(P),e.$ro={JSONContribution:"base.contributions.json"};function O(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class A{constructor(){this.b=new v.$le,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(o,I){this.a[O(o)]=I,this.b.fire(o)}notifySchemaChanged(o){this.b.fire(o)}getSchemaContributions(){return{schemas:this.a}}getSchemaContent(o){const I=this.a[o];return I?(0,R.$7j)(I):void 0}hasSchemaContent(o){return!!this.a[o]}}const T=new A;P.$qo.add(e.$ro.JSONContribution,T)}),define(Ne[53],Le([1,0,17,6,14,9,43,77,30]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.ConfigurationScope=e.$vo=e.EditPresentationTypes=void 0,e.$Go=r,e.$Ho=s,e.$Io=c,e.$Jo=i,e.$Ko=n,e.$Lo=t,e.$Mo=g,P=We(P),O=We(O);var o;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(o||(e.EditPresentationTypes=o={})),e.$vo={Configuration:"base.contributions.configuration"};var I;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(I||(e.ConfigurationScope=I={})),e.$wo={properties:{},patternProperties:{}},e.$xo={properties:{},patternProperties:{}},e.$yo={properties:{},patternProperties:{}},e.$zo={properties:{},patternProperties:{}},e.$Ao={properties:{},patternProperties:{}},e.$Bo={properties:{},patternProperties:{}},e.$Co="vscode://schemas/settings/resourceLanguage",e.$Do="vscode://schemas/settings/configurationDefaults";const y=p.$qo.as(T.$ro.JSONContribution);class a{constructor(){this.a=[],this.i=new Set,this.j=new R.$le,this.onDidSchemaChange=this.j.event,this.k=new R.$le,this.onDidUpdateConfiguration=this.k.event,this.b=new Map,this.c={id:"defaultOverrides",title:O.localize(11600,null),properties:{}},this.d=[this.c],this.h={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.e={},this.f=new Map,this.g={},y.registerSchema(e.$Co,this.h),this.z()}registerConfiguration($,m=!0){this.registerConfigurations([$],m)}registerConfigurations($,m=!0){const h=new Set;this.r($,m,h),y.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:h})}deregisterConfigurations($){const m=new Set;this.s($,m),y.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:m})}updateConfigurations({add:$,remove:m}){const h=new Set;this.s(m,h),this.r($,!1,h),y.registerSchema(e.$Co,this.h),this.j.fire(),this.k.fire({properties:h})}registerDefaultConfigurations($){const m=new Set;this.l($,m),this.j.fire(),this.k.fire({properties:m,defaultsOverrides:!0})}l($,m){this.a.push(...$);const h=[];for(const{overrides:E,source:D}of $)for(const w in E){m.add(w);const C=this.b.get(w)??this.b.set(w,{configurationDefaultOverrides:[]}).get(w),k=E[w];if(C.configurationDefaultOverrides.push({value:k,source:D}),e.$Fo.test(w)){const f=this.o(w,k,D,C.configurationDefaultOverrideValue);if(!f)continue;C.configurationDefaultOverrideValue=f,this.n(w,f,D),h.push(...r(w))}else{const f=this.p(w,k,D,C.configurationDefaultOverrideValue);if(!f)continue;C.configurationDefaultOverrideValue=f;const b=this.e[w];b&&(this.A(w,b),this.w(w,b))}}this.q(h)}deregisterDefaultConfigurations($){const m=new Set;this.m($,m),this.j.fire(),this.k.fire({properties:m,defaultsOverrides:!0})}m($,m){for(const h of $){const E=this.a.indexOf(h);E!==-1&&this.a.splice(E,1)}for(const{overrides:h,source:E}of $)for(const D in h){const w=this.b.get(D);if(!w)continue;const C=w.configurationDefaultOverrides.findIndex(k=>E?k.source?.id===E.id:k.value===h[D]);if(C!==-1){if(w.configurationDefaultOverrides.splice(C,1),w.configurationDefaultOverrides.length===0&&this.b.delete(D),e.$Fo.test(D)){let k;for(const f of w.configurationDefaultOverrides)k=this.o(D,f.value,f.source,k);k&&!P.$rg(k.value)?(w.configurationDefaultOverrideValue=k,this.n(D,k,E)):(this.b.delete(D),delete this.e[D],delete this.c.properties[D])}else{let k;for(const b of w.configurationDefaultOverrides)k=this.p(D,b.value,b.source,k);w.configurationDefaultOverrideValue=k;const f=this.e[D];f&&(this.A(D,f),this.w(D,f))}m.add(D)}}this.y()}n($,m,h){const E={type:"object",default:m.value,description:O.localize(11601,null,(0,A.$ij)($)),$ref:e.$Co,defaultDefaultValue:m.value,source:h,defaultValueSource:h};this.e[$]=E,this.c.properties[$]=E}o($,m,h,E){const D=E?.value||{},w=E?.source??new Map;if(!(w instanceof Map)){console.error("objectConfigurationSources is not a Map");return}for(const C of Object.keys(m)){const k=m[C];if(P.$gg(k)&&(P.$lg(D[C])||P.$gg(D[C]))){if(D[C]={...D[C]??{},...k},h)for(const b in k)w.set(`${C}.${b}`,h)}else D[C]=k,h?w.set(C,h):w.delete(C)}return{value:D,source:w}}p($,m,h,E){const D=this.e[$],w=E?.value??D?.defaultDefaultValue;let C=h;if(P.$gg(m)&&(D!==void 0&&D.type==="object"||D===void 0&&(P.$lg(w)||P.$gg(w)))){if(C=E?.source??new Map,!(C instanceof Map)){console.error("defaultValueSource is not a Map");return}for(const f in m)h&&C.set(`${$}.${f}`,h);m={...P.$gg(w)?w:{},...m}}return{value:m,source:C}}deltaConfiguration($){let m=!1;const h=new Set;$.removedDefaults&&(this.m($.removedDefaults,h),m=!0),$.addedDefaults&&(this.l($.addedDefaults,h),m=!0),$.removedConfigurations&&this.s($.removedConfigurations,h),$.addedConfigurations&&this.r($.addedConfigurations,!1,h),this.j.fire(),this.k.fire({properties:h,defaultsOverrides:m})}notifyConfigurationSchemaUpdated(...$){this.j.fire()}registerOverrideIdentifiers($){this.q($),this.j.fire()}q($){for(const m of $)this.i.add(m);this.y()}r($,m,h){$.forEach(E=>{this.u(E,m,E.extensionInfo,E.restrictedProperties,void 0,h),this.d.push(E),this.v(E)})}s($,m){const h=E=>{if(E.properties)for(const D in E.properties){m.add(D);const w=this.e[D];w?.policy?.name&&this.f.delete(w.policy.name),delete this.e[D],this.x(D,E.properties[D])}E.allOf?.forEach(D=>h(D))};for(const E of $){h(E);const D=this.d.indexOf(E);D!==-1&&this.d.splice(D,1)}}u($,m=!0,h,E,D=I.WINDOW,w){D=P.$ng($.scope)?D:$.scope;const C=$.properties;if(C)for(const f in C){const b=C[f];if(m&&i(f,b)){delete C[f];continue}if(b.source=h,b.defaultDefaultValue=C[f].default,this.A(f,b),e.$Fo.test(f)?b.scope=void 0:(b.scope=P.$ng(b.scope)?D:b.scope,b.restricted=P.$ng(b.restricted)?!!E?.includes(f):b.restricted),C[f].hasOwnProperty("included")&&!C[f].included){this.g[f]=C[f],delete C[f];continue}else this.e[f]=C[f],C[f].policy?.name&&this.f.set(C[f].policy.name,f);!C[f].deprecationMessage&&C[f].markdownDeprecationMessage&&(C[f].deprecationMessage=C[f].markdownDeprecationMessage),w.add(f)}const k=$.allOf;if(k)for(const f of k)this.u(f,m,h,E,D,w)}getConfigurations(){return this.d}getConfigurationProperties(){return this.e}getPolicyConfigurations(){return this.f}getExcludedConfigurationProperties(){return this.g}getRegisteredDefaultConfigurations(){return[...this.a]}getConfigurationDefaultsOverrides(){const $=new Map;for(const[m,h]of this.b)h.configurationDefaultOverrideValue&&$.set(m,h.configurationDefaultOverrideValue);return $}v($){const m=h=>{const E=h.properties;if(E)for(const w in E)this.w(w,E[w]);h.allOf?.forEach(m)};m($)}w($,m){switch(e.$wo.properties[$]=m,m.scope){case I.APPLICATION:e.$xo.properties[$]=m;break;case I.MACHINE:e.$yo.properties[$]=m;break;case I.MACHINE_OVERRIDABLE:e.$zo.properties[$]=m;break;case I.WINDOW:e.$Ao.properties[$]=m;break;case I.RESOURCE:e.$Bo.properties[$]=m;break;case I.LANGUAGE_OVERRIDABLE:e.$Bo.properties[$]=m,this.h.properties[$]=m;break}}x($,m){switch(delete e.$wo.properties[$],m.scope){case I.APPLICATION:delete e.$xo.properties[$];break;case I.MACHINE:delete e.$yo.properties[$];break;case I.MACHINE_OVERRIDABLE:delete e.$zo.properties[$];break;case I.WINDOW:delete e.$Ao.properties[$];break;case I.RESOURCE:case I.LANGUAGE_OVERRIDABLE:delete e.$Bo.properties[$],delete this.h.properties[$];break}}y(){for(const $ of this.i.values()){const m=`[${$}]`,h={type:"object",description:O.localize(11602,null),errorMessage:O.localize(11603,null),$ref:e.$Co};this.A(m,h),e.$wo.properties[m]=h,e.$xo.properties[m]=h,e.$yo.properties[m]=h,e.$zo.properties[m]=h,e.$Ao.properties[m]=h,e.$Bo.properties[m]=h}}z(){const $={type:"object",description:O.localize(11604,null),errorMessage:O.localize(11605,null),$ref:e.$Co};e.$wo.patternProperties[e.$Eo]=$,e.$xo.patternProperties[e.$Eo]=$,e.$yo.patternProperties[e.$Eo]=$,e.$zo.patternProperties[e.$Eo]=$,e.$Ao.patternProperties[e.$Eo]=$,e.$Bo.patternProperties[e.$Eo]=$,this.j.fire()}A($,m){const h=this.b.get($)?.configurationDefaultOverrideValue;let E,D;h&&(!m.disallowConfigurationDefault||!h.source)&&(E=h.value,D=h.source),P.$lg(E)&&(E=m.defaultDefaultValue,D=void 0),P.$lg(E)&&(E=c(m.type)),m.default=E,m.defaultValueSource=D}}const S="\\[([^\\]]+)\\]",d=new RegExp(S,"g");e.$Eo=`^(${S})+$`,e.$Fo=new RegExp(e.$Eo);function r(u){const $=[];if(e.$Fo.test(u)){let m=d.exec(u);for(;m?.length;){const h=m[1].trim();h&&$.push(h),m=d.exec(u)}}return(0,v.$Lb)($)}function s(u){return u.reduce(($,m)=>`${$}[${m}]`,"")}function c(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const l=new a;p.$qo.add(e.$vo.Configuration,l);function i(u,$){return u.trim()?e.$Fo.test(u)?O.localize(11607,null,u):l.getConfigurationProperties()[u]!==void 0?O.localize(11608,null,u):$.policy?.name&&l.getPolicyConfigurations().get($.policy?.name)!==void 0?O.localize(11609,null,u,$.policy?.name,l.getPolicyConfigurations().get($.policy?.name)):null:O.localize(11606,null)}function n(){const u=[],$=l.getConfigurationProperties();for(const m of Object.keys($))u.push([m,$[m].scope]);return u.push(["launch",I.RESOURCE]),u.push(["task",I.RESOURCE]),u}function t(u){const $={};for(const m of u){const h=m.properties;if(P.$gg(h))for(const E in h)$[E]=h[E];m.allOf&&Object.assign($,t(m.allOf))}return $}function g(u){switch(u){case"application":return I.APPLICATION;case"machine":return I.MACHINE;case"resource":return I.RESOURCE;case"machine-overridable":return I.MACHINE_OVERRIDABLE;case"language-overridable":return I.LANGUAGE_OVERRIDABLE;default:return I.WINDOW}}}),define(Ne[174],Le([1,0,17,6,136,4,28,25,14,2,43,53,29,30]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Qo=e.$Po=e.$Oo=e.$No=void 0,e.$Ro=n,v=We(v),P=We(P),T=We(T),p=We(p);function d($){return Object.isFrozen($)?$:T.$eo($)}class r{static createEmptyModel(m){return new r({},[],[],void 0,m)}constructor(m,h,E,D,w){this.b=m,this.c=h,this.d=E,this.raw=D,this.f=w,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const m=this.raw.map(h=>{if(h instanceof r)return h;const E=new s("",this.f);return E.parseRaw(h),E.configurationModel});this.g=m.reduce((h,E)=>E===h?E:h.merge(E),m[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(m){return m?(0,I.$gj)(this.contents,m):this.contents}inspect(m,h){const E=this;return{get value(){return d(E.rawConfiguration.getValue(m))},get override(){return h?d(E.rawConfiguration.getOverrideValue(m,h)):void 0},get merged(){return d(h?E.rawConfiguration.override(h).getValue(m):E.rawConfiguration.getValue(m))},get overrides(){const D=[];for(const{contents:w,identifiers:C,keys:k}of E.rawConfiguration.overrides){const f=new r(w,k,[],void 0,E.f).getValue(m);f!==void 0&&D.push({identifiers:C,value:f})}return D.length?d(D):void 0}}}getOverrideValue(m,h){const E=this.j(h);return E?m?(0,I.$gj)(E,m):E:void 0}getKeysForOverrideIdentifier(m){const h=[];for(const E of this.overrides)E.identifiers.includes(m)&&h.push(...E.keys);return v.$Lb(h)}getAllOverrideIdentifiers(){const m=[];for(const h of this.overrides)m.push(...h.identifiers);return v.$Lb(m)}override(m){let h=this.a.get(m);return h||(h=this.h(m),this.a.set(m,h)),h}merge(...m){const h=T.$do(this.contents),E=T.$do(this.overrides),D=[...this.keys],w=this.raw?.length?[...this.raw]:[this];for(const C of m)if(w.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.i(h,C.contents);for(const k of C.overrides){const[f]=E.filter(b=>v.$tb(b.identifiers,k.identifiers));f?(this.i(f.contents,k.contents),f.keys.push(...k.keys),f.keys=v.$Lb(f.keys)):E.push(T.$do(k))}for(const k of C.keys)D.indexOf(k)===-1&&D.push(k)}return new r(h,D,E,w.every(C=>C instanceof r)?void 0:w,this.f)}h(m){const h=this.j(m);if(!h||typeof h!="object"||!Object.keys(h).length)return this;const E={};for(const D of v.$Lb([...Object.keys(this.contents),...Object.keys(h)])){let w=this.contents[D];const C=h[D];C&&(typeof w=="object"&&typeof C=="object"?(w=T.$do(w),this.i(w,C)):w=C),E[D]=w}return new r(E,this.keys,this.overrides,void 0,this.f)}i(m,h){for(const E of Object.keys(h)){if(E in m&&p.$gg(m[E])&&p.$gg(h[E])){this.i(m[E],h[E]);continue}m[E]=T.$do(h[E])}}j(m){let h=null,E=null;const D=w=>{w&&(E?this.i(E,w):E=T.$do(w))};for(const w of this.overrides)w.identifiers.length===1&&w.identifiers[0]===m?h=w.contents:w.identifiers.includes(m)&&D(w.contents);return D(h),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(m,h){this.k(m,h,!0)}setValue(m,h){this.k(m,h,!1)}removeValue(m){const h=this.keys.indexOf(m);h!==-1&&(this.keys.splice(h,1),(0,I.$fj)(this.contents,m),y.$Fo.test(m)&&this.overrides.splice(this.overrides.findIndex(E=>v.$tb(E.identifiers,(0,y.$Go)(m))),1))}k(m,h,E){if((0,I.$ej)(this.contents,m,h,D=>this.f.error(D)),E=E||this.keys.indexOf(m)===-1,E&&this.keys.push(m),y.$Fo.test(m)){const D=(0,y.$Go)(m),w={identifiers:D,keys:Object.keys(this.contents[m]),contents:(0,I.$dj)(this.contents[m],k=>this.f.error(k))},C=this.overrides.findIndex(k=>v.$tb(k.identifiers,D));C!==-1?this.overrides[C]=w:this.overrides.push(w)}}}e.$No=r;class s{constructor(m,h){this.f=m,this.g=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||r.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(m,h){if(!p.$ng(m)){const E=this.h(m);this.parseRaw(E,h)}}reparse(m){this.a&&this.parseRaw(this.a,m)}parseRaw(m,h){this.a=m;const{contents:E,keys:D,overrides:w,restricted:C,hasExcludedProperties:k}=this.i(m,h);this.b=new r(E,D,w,k?[m]:void 0,this.g),this.c=C||[]}h(m){let h={},E=null,D=[];const w=[],C=[];function k(b){Array.isArray(D)?D.push(b):E!==null&&(D[E]=b)}const f={onObjectBegin:()=>{const b={};k(b),w.push(D),D=b,E=null},onObjectProperty:b=>{E=b},onObjectEnd:()=>{D=w.pop()},onArrayBegin:()=>{const b=[];k(b),w.push(D),D=b,E=null},onArrayEnd:()=>{D=w.pop()},onLiteralValue:k,onError:(b,M,N)=>{C.push({error:b,offset:M,length:N})}};if(m)try{P.$5n(m,f),h=D[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return h}i(m,h){const E=S.$qo.as(y.$vo.Configuration).getConfigurationProperties(),D=this.j(m,E,!0,h);m=D.raw;const w=(0,I.$dj)(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`)),C=Object.keys(m),k=this.l(m,f=>this.g.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:w,keys:C,overrides:k,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}j(m,h,E,D){let w=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:m,restricted:[],hasExcludedProperties:w};const C={},k=[];for(const f in m)if(y.$Fo.test(f)&&E){const b=this.j(m[f],h,!1,D);C[f]=b.raw,w=w||b.hasExcludedProperties,k.push(...b.restricted)}else{const b=h[f],M=b?typeof b.scope<"u"?b.scope:y.ConfigurationScope.WINDOW:void 0;b?.restricted&&k.push(f),!D.exclude?.includes(f)&&(D.include?.includes(f)||(M===void 0||D.scopes===void 0||D.scopes.includes(M))&&!(D.skipRestricted&&b?.restricted))?C[f]=m[f]:w=!0}return{raw:C,restricted:k,hasExcludedProperties:w}}l(m,h){const E=[];for(const D of Object.keys(m))if(y.$Fo.test(D)){const w={};for(const C in m[D])w[C]=m[D][C];E.push({identifiers:(0,y.$Go)(D),keys:Object.keys(w),contents:(0,I.$dj)(w,h)})}return E}}e.$Oo=s;class c extends O.$Uc{constructor(m,h,E,D,w){super(),this.c=m,this.f=h,this.g=D,this.h=w,this.b=this.B(new R.$le),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),w),this.B(this.g.watch(E.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,C=>C.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,C=>(C.isOperation(a.FileOperation.CREATE)||C.isOperation(a.FileOperation.COPY)||C.isOperation(a.FileOperation.DELETE)||C.isOperation(a.FileOperation.WRITE))&&E.isEqual(C.resource,m)))(()=>this.b.fire()))}async loadConfiguration(){try{const m=await this.g.readFile(this.c);return this.a.parse(m.value.toString()||"{}",this.f),this.a.configurationModel}catch{return r.createEmptyModel(this.h)}}reparse(m){return m&&(this.f=m),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Po=c;class l{constructor(m,h,E,D,w,C,k,f,b,M,N,L,W){this.a=m,this.b=h,this.c=E,this.overrideIdentifiers=D,this.d=w,this.f=C,this.g=k,this.h=f,this.i=b,this.j=M,this.k=N,this.l=L,this.m=W}get value(){return d(this.c)}n(m){return m?.value!==void 0||m?.override!==void 0||m?.overrides!==void 0?m:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(m,h,E,D,w,C,k,f,b,M){this.j=m,this.l=h,this.m=E,this.n=D,this.p=w,this.q=C,this.r=k,this.s=f,this.t=b,this.u=M,this.h=null,this.i=new A.$Ac,this.v=null}getValue(m,h,E){return this.w(m,h,E).getValue(m)}updateValue(m,h,E={}){let D;E.resource?(D=this.t.get(E.resource),D||(D=r.createEmptyModel(this.u),this.t.set(E.resource,D))):D=this.s,h===void 0?D.removeValue(m):D.setValue(m,h),E.resource||(this.h=null)}inspect(m,h,E){const D=this.w(m,h,E),w=this.A(h.resource,E),C=h.resource?this.t.get(h.resource)||this.s:this.s,k=new Set;for(const f of D.overrides)for(const b of f.identifiers)D.getOverrideValue(m,b)!==void 0&&k.add(b);return new l(m,h,D.getValue(m),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.q:void 0,w||void 0,C)}keys(m){const h=this.A(void 0,m);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:h?h.keys.slice(0):[]}}updateDefaultConfiguration(m){this.j=m,this.h=null,this.i.clear()}updatePolicyConfiguration(m){this.l=m}updateApplicationConfiguration(m){this.m=m,this.h=null,this.i.clear()}updateLocalUserConfiguration(m){this.n=m,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(m){this.p=m,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(m){this.q=m,this.h=null,this.i.clear()}updateFolderConfiguration(m,h){this.r.set(m,h),this.i.delete(m)}deleteFolderConfiguration(m){this.folderConfigurations.delete(m),this.i.delete(m)}compareAndUpdateDefaultConfiguration(m,h){const E=[];if(!h){const{added:D,updated:w,removed:C}=g(this.j,m);h=[...D,...w,...C]}for(const D of h)for(const w of(0,y.$Go)(D)){const C=this.j.getKeysForOverrideIdentifier(w),k=m.getKeysForOverrideIdentifier(w),f=[...k.filter(b=>C.indexOf(b)===-1),...C.filter(b=>k.indexOf(b)===-1),...C.filter(b=>!T.$ho(this.j.override(w).getValue(b),m.override(w).getValue(b)))];E.push([w,f])}return this.updateDefaultConfiguration(m),{keys:h,overrides:E}}compareAndUpdatePolicyConfiguration(m){const{added:h,updated:E,removed:D}=g(this.l,m),w=[...h,...E,...D];return w.length&&this.updatePolicyConfiguration(m),{keys:w,overrides:[]}}compareAndUpdateApplicationConfiguration(m){const{added:h,updated:E,removed:D,overrides:w}=g(this.applicationConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateApplicationConfiguration(m),{keys:C,overrides:w}}compareAndUpdateLocalUserConfiguration(m){const{added:h,updated:E,removed:D,overrides:w}=g(this.localUserConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateLocalUserConfiguration(m),{keys:C,overrides:w}}compareAndUpdateRemoteUserConfiguration(m){const{added:h,updated:E,removed:D,overrides:w}=g(this.remoteUserConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateRemoteUserConfiguration(m),{keys:C,overrides:w}}compareAndUpdateWorkspaceConfiguration(m){const{added:h,updated:E,removed:D,overrides:w}=g(this.workspaceConfiguration,m),C=[...h,...E,...D];return C.length&&this.updateWorkspaceConfiguration(m),{keys:C,overrides:w}}compareAndUpdateFolderConfiguration(m,h){const E=this.folderConfigurations.get(m),{added:D,updated:w,removed:C,overrides:k}=g(E,h),f=[...D,...w,...C];return(f.length||!E)&&this.updateFolderConfiguration(m,h),{keys:f,overrides:k}}compareAndDeleteFolderConfiguration(m){const h=this.folderConfigurations.get(m);if(!h)throw new Error("Unknown folder");this.deleteFolderConfiguration(m);const{added:E,updated:D,removed:w,overrides:C}=g(h,void 0);return{keys:[...E,...D,...w],overrides:C}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(m,h,E){let D=this.x(h,E);return h.overrideIdentifier&&(D=D.override(h.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(m)!==void 0&&(D=D.merge(this.l)),D}x({resource:m},h){let E=this.y();if(h&&m){const D=h.getFolder(m);D&&(E=this.z(D.uri)||E);const w=this.t.get(m);w&&(E=E.merge(w))}return E}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(m){let h=this.i.get(m);if(!h){const E=this.y(),D=this.r.get(m);D?(h=E.merge(D),this.i.set(m,h)):h=E}return h}A(m,h){if(h&&m){const E=h.getFolder(m);if(E)return this.r.get(E.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((m,h)=>{const{contents:E,overrides:D,keys:w}=this.r.get(h);return m.push([h,{contents:E,overrides:D,keys:w}]),m},[])}}allKeys(){const m=new Set;return this.j.keys.forEach(h=>m.add(h)),this.userConfiguration.keys.forEach(h=>m.add(h)),this.q.keys.forEach(h=>m.add(h)),this.r.forEach(h=>h.keys.forEach(E=>m.add(E))),[...m.values()]}B(){const m=new Set;return this.j.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.userConfiguration.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.q.getAllOverrideIdentifiers().forEach(h=>m.add(h)),this.r.forEach(h=>h.getAllOverrideIdentifiers().forEach(E=>m.add(E))),[...m.values()]}D(m){const h=new Set;return this.j.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.q.getKeysForOverrideIdentifier(m).forEach(E=>h.add(E)),this.r.forEach(E=>E.getKeysForOverrideIdentifier(m).forEach(D=>h.add(D))),[...h.values()]}static parse(m,h){const E=this.E(m.defaults,h),D=this.E(m.policy,h),w=this.E(m.application,h),C=this.E(m.user,h),k=this.E(m.workspace,h),f=m.folders.reduce((b,M)=>(b.set(o.URI.revive(M[0]),this.E(M[1],h)),b),new A.$Ac);return new i(E,D,w,C,r.createEmptyModel(h),k,f,r.createEmptyModel(h),new A.$Ac,h)}static E(m,h){return new r(m.contents,m.keys,m.overrides,void 0,h)}}e.$Qo=i;function n(...$){if($.length===0)return{keys:[],overrides:[]};if($.length===1)return $[0];const m=new Set,h=new Map;for(const D of $)D.keys.forEach(w=>m.add(w)),D.overrides.forEach(([w,C])=>{const k=(0,A.$xc)(h,w,new Set);C.forEach(f=>k.add(f))});const E=[];return h.forEach((D,w)=>E.push([w,[...D.values()]])),{keys:[...m.values()],overrides:E}}class t{constructor(m,h,E,D,w){this.change=m,this.f=h,this.g=E,this.h=D,this.i=w,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const C of m.keys)this.affectedKeys.add(C);for(const[,C]of m.overrides)for(const k of C)this.affectedKeys.add(k);this.d=this.a;for(const C of this.affectedKeys)this.d+=C+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=i.parse(this.f.data,this.i)),this.j}affectsConfiguration(m,h){const E=this.a+m,D=this.d.indexOf(E);if(D<0)return!1;const w=D+E.length;if(w>=this.d.length)return!1;const C=this.d.charCodeAt(w);if(C!==this.b&&C!==this.c)return!1;if(h){const k=this.previousConfiguration?this.previousConfiguration.getValue(m,h,this.f?.workspace):void 0,f=this.g.getValue(m,h,this.h);return!T.$ho(k,f)}return!0}}e.$So=t;function g($,m){const{added:h,removed:E,updated:D}=u(m?.rawConfiguration,$?.rawConfiguration),w=[],C=$?.getAllOverrideIdentifiers()||[],k=m?.getAllOverrideIdentifiers()||[];if(m){const f=k.filter(b=>!C.includes(b));for(const b of f)w.push([b,m.getKeysForOverrideIdentifier(b)])}if($){const f=C.filter(b=>!k.includes(b));for(const b of f)w.push([b,$.getKeysForOverrideIdentifier(b)])}if(m&&$){for(const f of C)if(k.includes(f)){const b=u({contents:$.getOverrideValue(void 0,f)||{},keys:$.getKeysForOverrideIdentifier(f)},{contents:m.getOverrideValue(void 0,f)||{},keys:m.getKeysForOverrideIdentifier(f)});w.push([f,[...b.added,...b.removed,...b.updated]])}}return{added:h,removed:E,updated:D,overrides:w}}function u($,m){const h=$?m?$.keys.filter(w=>m.keys.indexOf(w)===-1):[...$.keys]:[],E=m?$?m.keys.filter(w=>$.keys.indexOf(w)===-1):[...m.keys]:[],D=[];if($&&m){for(const w of m.keys)if($.keys.indexOf(w)!==-1){const C=(0,I.$gj)(m.contents,w),k=(0,I.$gj)($.contents,w);T.$ho(C,k)||D.push(w)}}return{added:h,removed:E,updated:D}}}),define(Ne[109],Le([1,0,13,3]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tl=e.RemoteAuthorityResolverErrorCode=e.$Sl=e.$Rl=e.RemoteConnectionType=e.$Ql=void 0,e.$Ul=o,e.$Ql=(0,R.$Ei)("remoteAuthorityResolverService");var P;(function(I){I[I.WebSocket=0]="WebSocket",I[I.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class O{constructor(y){this.id=y,this.type=P.Managed}toString(){return`Managed(${this.id})`}}e.$Rl=O;class A{constructor(y,a){this.host=y,this.port=a,this.type=P.WebSocket}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Sl=A;var T;(function(I){I.Unknown="Unknown",I.NotAvailable="NotAvailable",I.TemporarilyNotAvailable="TemporarilyNotAvailable",I.NoResolverFound="NoResolverFound",I.InvalidAuthority="InvalidAuthority"})(T||(e.RemoteAuthorityResolverErrorCode=T={}));class p extends v.$ab{static isNotAvailable(y){return y instanceof p&&y._code===T.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof p&&y._code===T.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof p&&y._code===T.NoResolverFound}static isInvalidAuthority(y){return y instanceof p&&y._code===T.InvalidAuthority}static isHandled(y){return y instanceof p&&y.isHandled}constructor(y,a=T.Unknown,S){super(y),this._message=y,this._code=a,this._detail=S,this.isHandled=a===T.NotAvailable&&S===!0,Object.setPrototypeOf(this,p.prototype)}}e.$Tl=p;function o(I){const y=I.indexOf("+");return y===-1?I:I.substring(0,y)}}),define(Ne[62],Le([1,0,15]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=R,e.$hn=P,e.$in=O,e.$jn=A;function R(p){return p.scheme===v.Schemas.vscodeRemote?p.authority:void 0}function P(p){if(!p)return;const o=p.indexOf("+");return o<0?p:p.substr(0,o)}function O(p){const{host:o,port:I}=T(p);if(typeof I>"u")throw new Error(`Invalid remote authority: ${p}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:o,port:I}}function A(p,o){let{host:I,port:y}=T(p);return typeof y>"u"&&(y=o),{host:I,port:y}}function T(p){const o=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(o)return{host:o[1],port:parseInt(o[2],10)};const I=p.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const y=p.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:p,port:void 0}}}),define(Ne[18],Le([1,0,12,3,62]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$sn=e.$rn=e.$qn=e.TargetPlatform=e.ExtensionType=e.$pn=e.$nn=e.$mn=e.$ln=e.$kn=void 0,e.$on=O,e.$tn=y,e.$un=a,e.$vn=S,e.$wn=d,e.$xn=r,e.$yn=s,v=We(v),e.$kn="extensions.user.cache",e.$ln="extensions.builtin.cache",e.$mn="undefined_publisher",e.$nn=["ui","workspace","web"];function O(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$pn=["AI","Azure","Chat","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A||(e.ExtensionType=A={}));var T;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(T||(e.TargetPlatform=T={}));class p{constructor(l){this.value=l,this._lower=l.toLowerCase()}static equals(l,i){if(typeof l>"u"||l===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof l=="string"||typeof i=="string"){const n=typeof l=="string"?l:l.value,t=typeof i=="string"?i:i.value;return v.$Ff(n,t)}return l._lower===i._lower}static toKey(l){return typeof l=="string"?l.toLowerCase():l._lower}}e.$qn=p;class o{get size(){return this.c.size}constructor(l){if(this.c=new Set,l)for(const i of l)this.add(i)}add(l){this.c.add(p.toKey(l))}delete(l){return this.c.delete(p.toKey(l))}has(l){return this.c.has(p.toKey(l))}}e.$rn=o;class I{constructor(){this.c=new Map}clear(){this.c.clear()}delete(l){this.c.delete(p.toKey(l))}get(l){return this.c.get(p.toKey(l))}has(l){return this.c.has(p.toKey(l))}set(l,i){this.c.set(p.toKey(l),i)}values(){return this.c.values()}forEach(l){this.c.forEach(l)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$sn=I;function y(c){return a(c)}function a(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}function S(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}function d(c,l){if(l){const i=`onResolveRemoteAuthority:${(0,P.$hn)(l)}`;return!!c.activationEvents?.includes(i)}return!1}function r(c){return c.map(l=>{const[i,n]=l.split("@");return{proposalName:i,version:n?parseInt(n):void 0}})}function s(c){return c.map(l=>l.split("@")[0])}e.$zn=(0,R.$Ei)("IBuiltinExtensionsScannerService")}),define(Ne[110],Le([1,0,20,9,18,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tp=e.$sp=e.$rp=e.$qp=e.$pp=e.$op=e.$np=e.$mp=e.ExtensionManagementErrorCode=e.$lp=e.ExtensionGalleryErrorCode=e.$kp=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=void 0,e.$ep=T,e.$fp=p,e.$gp=o,e.$hp=I,e.$ip=y,e.$jp=a,e.$0o="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$$o=new RegExp(e.$0o),e.$_o="__web_extension",e.$ap="skipWalkthrough",e.$bp="extensionInstallSource",e.$cp="dependecyOrPackExtensionInstall",e.$dp="clientTargetPlatform";var A;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(A||(e.ExtensionInstallSource=A={}));function T(t){switch(t){case P.TargetPlatform.WIN32_X64:return"Windows 64 bit";case P.TargetPlatform.WIN32_ARM64:return"Windows ARM";case P.TargetPlatform.LINUX_X64:return"Linux 64 bit";case P.TargetPlatform.LINUX_ARM64:return"Linux ARM 64";case P.TargetPlatform.LINUX_ARMHF:return"Linux ARM";case P.TargetPlatform.ALPINE_X64:return"Alpine Linux 64 bit";case P.TargetPlatform.ALPINE_ARM64:return"Alpine ARM 64";case P.TargetPlatform.DARWIN_X64:return"Mac";case P.TargetPlatform.DARWIN_ARM64:return"Mac Silicon";case P.TargetPlatform.WEB:return"Web";case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;case P.TargetPlatform.UNKNOWN:return P.TargetPlatform.UNKNOWN;case P.TargetPlatform.UNDEFINED:return P.TargetPlatform.UNDEFINED}}function p(t){switch(t){case P.TargetPlatform.WIN32_X64:return P.TargetPlatform.WIN32_X64;case P.TargetPlatform.WIN32_ARM64:return P.TargetPlatform.WIN32_ARM64;case P.TargetPlatform.LINUX_X64:return P.TargetPlatform.LINUX_X64;case P.TargetPlatform.LINUX_ARM64:return P.TargetPlatform.LINUX_ARM64;case P.TargetPlatform.LINUX_ARMHF:return P.TargetPlatform.LINUX_ARMHF;case P.TargetPlatform.ALPINE_X64:return P.TargetPlatform.ALPINE_X64;case P.TargetPlatform.ALPINE_ARM64:return P.TargetPlatform.ALPINE_ARM64;case P.TargetPlatform.DARWIN_X64:return P.TargetPlatform.DARWIN_X64;case P.TargetPlatform.DARWIN_ARM64:return P.TargetPlatform.DARWIN_ARM64;case P.TargetPlatform.WEB:return P.TargetPlatform.WEB;case P.TargetPlatform.UNIVERSAL:return P.TargetPlatform.UNIVERSAL;default:return P.TargetPlatform.UNKNOWN}}function o(t,g){switch(t){case v.Platform.Windows:return g==="x64"?P.TargetPlatform.WIN32_X64:g==="arm64"?P.TargetPlatform.WIN32_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Linux:return g==="x64"?P.TargetPlatform.LINUX_X64:g==="arm64"?P.TargetPlatform.LINUX_ARM64:g==="arm"?P.TargetPlatform.LINUX_ARMHF:P.TargetPlatform.UNKNOWN;case"alpine":return g==="x64"?P.TargetPlatform.ALPINE_X64:g==="arm64"?P.TargetPlatform.ALPINE_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Mac:return g==="x64"?P.TargetPlatform.DARWIN_X64:g==="arm64"?P.TargetPlatform.DARWIN_ARM64:P.TargetPlatform.UNKNOWN;case v.Platform.Web:return P.TargetPlatform.WEB}}function I(t,g){return g===P.TargetPlatform.WEB&&!t.includes(P.TargetPlatform.WEB)}function y(t,g,u){return I(g,u)?!1:t===P.TargetPlatform.UNDEFINED||t===P.TargetPlatform.UNIVERSAL?!0:t===P.TargetPlatform.UNKNOWN?!1:t===u}function a(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var r;(function(t){t.Install="install",t.Uninstall="uninstall"})(r||(e.StatisticType=r={}));var s;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(s||(e.InstallOperation=s={})),e.$kp=(0,O.$Ei)("extensionGalleryService");var c;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(c||(e.ExtensionGalleryErrorCode=c={}));class l extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$lp=l;var i;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleApi="IncompatibleApi",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.InstalledExtensionNotFound="InstalledExtensionNotFound",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(i||(e.ExtensionManagementErrorCode=i={}));class n extends Error{constructor(g,u){super(g),this.code=u,this.name=u}}e.$mp=n,e.$np=(0,O.$Ei)("extensionManagementService"),e.$op="extensionsIdentifiers/disabled",e.$pp="extensionsIdentifiers/enabled",e.$qp=(0,O.$Ei)("IGlobalExtensionEnablementService"),e.$rp=(0,O.$Ei)("IExtensionTipsService"),e.$sp=(0,R.localize2)(11490,"Extensions"),e.$tp=(0,R.localize2)(11491,"Preferences")}),define(Ne[111],Le([1,0,13,18]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XG=e.$WG=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,T){this.a.set(A,T)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const T=Object.create(null);for(const p of A){const o=this.readActivationEvents(p);o.length>0&&(T[R.$qn.toKey(p.identifier)]=o)}return T}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const T=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let p=0;p<T.length;p++)T[p]==="onUri"&&(T[p]=`onUri:${R.$qn.toKey(A.identifier)}`);if(!A.contributes)return T;for(const p in A.contributes){const o=this.a.get(p);if(!o)continue;const I=A.contributes[p],y=Array.isArray(I)?I:[I];try{o(y,T)}catch(a){(0,v.$Y)(a)}}return T}}e.$WG=P,e.$XG=new P});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[175],Le([1,0,23,35,9,281,18,104]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=I,e.$Zp=y,e.$1p=a,e.$2p=S,e.$3p=d,e.$4p=r,e.$5p=s,e.$6p=c,R=xt(R),P=We(P),O=We(O);const p=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,o=/^-(\d{4})(\d{2})(\d{2})$/;function I(n){return n=n.trim(),n==="*"||p.test(n)}function y(n){if(!I(n))return null;if(n=n.trim(),n==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=n.match(p);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function a(n){if(!n)return null;const t=n.majorBase,g=n.majorMustEqual,u=n.minorBase;let $=n.minorMustEqual;const m=n.patchBase;let h=n.patchMustEqual;n.hasCaret&&(t===0||($=!1),h=!1);let E=0;if(n.preRelease){const D=o.exec(n.preRelease);if(D){const[,w,C,k]=D;E=Date.UTC(Number(w),Number(C)-1,Number(k))}}return{majorBase:t,majorMustEqual:g,minorBase:u,minorMustEqual:$,patchBase:m,patchMustEqual:h,isMinimum:n.hasGreaterEquals,notBefore:E}}function S(n,t,g){let u;typeof n=="string"?u=a(y(n)):u=n;let $;t instanceof Date?$=t.getTime():typeof t=="string"&&($=new Date(t).getTime());let m;if(typeof g=="string"?m=a(y(g)):m=g,!u||!m)return!1;const h=u.majorBase,E=u.minorBase,D=u.patchBase;let w=m.majorBase,C=m.minorBase,k=m.patchBase;const f=m.notBefore;let b=m.majorMustEqual,M=m.minorMustEqual,N=m.patchMustEqual;return m.isMinimum?h>w?!0:h<w?!1:E>C?!0:E<C||$&&$<f?!1:D>=k:(h===1&&w===0&&(!b||!M||!N)&&(w=1,C=0,k=0,b=!0,M=!1,N=!1),h<w?!1:h>w?!b:E<C?!1:E>C?!M:D<k?!1:D>k?!N:!($&&$<f))}function d(n,t,g,u,$,m){const h=[];if(typeof u.publisher<"u"&&typeof u.publisher!="string")return h.push([R.default.Error,P.localize(11421,null)]),h;if(typeof u.name!="string")return h.push([R.default.Error,P.localize(11422,null,"name")]),h;if(typeof u.version!="string")return h.push([R.default.Error,P.localize(11423,null,"version")]),h;if(!u.engines)return h.push([R.default.Error,P.localize(11424,null,"engines")]),h;if(typeof u.engines.vscode!="string")return h.push([R.default.Error,P.localize(11425,null,"engines.vscode")]),h;if(typeof u.extensionDependencies<"u"&&!i(u.extensionDependencies))return h.push([R.default.Error,P.localize(11426,null,"extensionDependencies")]),h;if(typeof u.activationEvents<"u"){if(!i(u.activationEvents))return h.push([R.default.Error,P.localize(11427,null,"activationEvents")]),h;if(typeof u.main>"u"&&typeof u.browser>"u")return h.push([R.default.Error,P.localize(11428,null,"activationEvents","main","browser")]),h}if(typeof u.extensionKind<"u"&&typeof u.main>"u"&&h.push([R.default.Warning,P.localize(11429,null,"extensionKind")]),typeof u.main<"u"){if(typeof u.main!="string")return h.push([R.default.Error,P.localize(11430,null,"main")]),h;{const w=(0,v.$fh)(g,u.main);(0,v.$_g)(w,g)||h.push([R.default.Warning,P.localize(11431,null,w.path,g.path)])}}if(typeof u.browser<"u"){if(typeof u.browser!="string")return h.push([R.default.Error,P.localize(11432,null,"browser")]),h;{const w=(0,v.$fh)(g,u.browser);(0,v.$_g)(w,g)||h.push([R.default.Warning,P.localize(11433,null,w.path,g.path)])}}if(!O.valid(u.version))return h.push([R.default.Error,P.localize(11434,null)]),h;const E=[];if(!r(n,t,u,$,E))for(const w of E)h.push([R.default.Error,w]);if(m&&u.enabledApiProposals?.length){const w=[];if(!c([...u.enabledApiProposals],w))for(const C of w)h.push([R.default.Error,C])}return h}function r(n,t,g,u,$){return u||typeof g.main>"u"&&typeof g.browser>"u"?!0:l(n,t,g.engines.vscode,$)}function s(n,t,g){return n==="*"||l(t,g,n)}function c(n,t){if(n.length===0)return!0;const g=Array.isArray(t)?t:void 0,u=(g?void 0:t)??T.allApiProposals,$=[],m=(0,A.$xn)(n);for(const{proposalName:h,version:E}of m){const D=u[h];D&&E&&D.version!==E&&$.push(P.localize(11435,null,h))}return g?.push(...$),$.length===0}function l(n,t,g,u=[]){const $=a(y(g));if(!$)return u.push(P.localize(11436,null,g)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return u.push(P.localize(11437,null,g)),!1}else if(!$.majorMustEqual)return u.push(P.localize(11438,null,g)),!1;return S(n,t,$)?!0:(u.push(P.localize(11439,null,n,g)),!1)}function i(n){if(!Array.isArray(n))return!1;for(let t=0,g=n.length;t<g;t++)if(typeof n[t]!="string")return!1;return!0}}),define(Ne[176],Le([1,0,22,13,4,9,53,3,11,30]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=e.$7p=void 0,e.$9p=a,e.$0p=S,e.$$p=d,e.$_p=r,e.$aq=s,e.$bq=c,e.$7p=(0,T.$Ei)("requestService");class I{constructor(t){this.b=t}toJSON(){if(!this.a){const t=Object.create(null);for(const g in this.b)g.toLowerCase()==="authorization"||g.toLowerCase()==="proxy-authorization"?t[g]="*****":t[g]=this.b[g];this.a=t}return this.a}}class y extends P.$Uc{constructor(t){super(),this.b=0,this.a=t.createLogger("network",{name:(0,O.localize)(11208,null),when:p.$rk.isEqualTo((0,p.$ok)(p.LogLevel.Trace)).serialize()})}async c(t,g,u){const $=`${t} #${++this.b}: ${g.url}`;this.a.trace(`${$} - begin`,g.type,new I(g.headers??{}));try{const m=await u();return this.a.trace(`${$} - end`,g.type,m.res.statusCode,m.res.headers),m}catch(m){throw this.a.error(`${$} - error`,g.type,(0,R.$9)(m)),m}}}e.$8p=y;function a(n){return n.res.statusCode&&n.res.statusCode>=200&&n.res.statusCode<300||n.res.statusCode===1223}function S(n){return n.res.statusCode===204}async function d(n){return S(n)?null:(await(0,v.$Ze)(n.stream)).toString()}async function r(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);return d(n)}async function s(n){if(!a(n))throw new Error("Server returned "+n.res.statusCode);if(S(n))return null;const g=(await(0,v.$Ze)(n.stream)).toString();try{return JSON.parse(g)}catch(u){throw u.message+=`:
`+g,u}}function c(n){i(n)}let l;function i(n){const t=o.$qo.as(A.$vo.Configuration),g=l;l={id:"http",order:15,title:(0,O.localize)(11209,null),type:"object",scope:n,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(11210,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(11211,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,O.localize)(11212,null),restricted:!0},"http.noProxy":{type:"array",items:{type:"string"},markdownDescription:(0,O.localize)(11213,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(11214,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(11215,null),(0,O.localize)(11216,null),(0,O.localize)(11217,null),(0,O.localize)(11218,null)],default:"override",description:(0,O.localize)(11219,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11220,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,O.localize)(11221,null),restricted:!0}}},t.updateConfigurations({add:[l],remove:g?[g]:[]})}i(A.ConfigurationScope.APPLICATION)}),define(Ne[177],Le([1,0,20,78,38]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$up=A,e.$vp=T;function O(p){if(v.$v===v.Platform.Linux&&/^penguin(\.|$)/i.test(p))return"chromebook"}function A(p,o,I,y,a,S,d,r,s,c){const l=Object.create(null);l["common.machineId"]=S,l["common.sqmId"]=d,l["common.devDeviceId"]=r,l.sessionID=(0,P.$1g)()+Date.now(),l.commitHash=y,l.version=a,l["common.platformVersion"]=(p||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,v.$i)(v.$v),l["common.nodePlatform"]=R.$dc,l["common.nodeArch"]=I,l["common.product"]=c||"desktop",s&&(l["common.msftInternal"]=s);let i=0;const n=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),v.$m&&(l["common.snap"]="true");const t=O(o);return t&&(l["common.platformDetail"]=t),l}function T(p){const o=R.env.USERDNSDOMAIN;if(!o)return!1;const I=o.toLowerCase();return p.some(y=>I===y)}}),define(Ne[112],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=void 0,e.$$l=(0,v.$Ei)("telemetryService"),e.$_l=(0,v.$Ei)("customEndpointTelemetryService"),e.$am="telemetry.currentSessionDate",e.$bm="telemetry.firstSessionDate",e.$cm="telemetry.lastSessionDate",e.$dm="telemetry.machineId",e.$em="telemetry.sqmId",e.$fm="telemetry.devDeviceId",e.$gm="telemetry",e.$hm="telemetry.telemetryLevel",e.$im="telemetry.enableCrashReporter",e.$jm="telemetry.enableTelemetry";var R;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var P;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Ne[63],Le([1,0,25,14,62,177,112]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$Bp=e.$Ap=e.$zp=e.$yp=e.$xp=e.$wp=void 0,e.$Dp=I,e.$Ep=y,e.$Fp=a,e.$Gp=S,e.$Hp=r,e.$Ip=c,e.$Jp=l,e.$Kp=t;class T{constructor(u){this.value=u,this.isTrustedTelemetryValue=!0}}e.$wp=T;class p{constructor(){this.telemetryLevel=A.TelemetryLevel.NONE,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.devDeviceId="someValue.devDeviceId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$xp=p,e.$yp=new p;class o{async publicLog(u,$,m){}async publicLogError(u,$,m){}}e.$zp=o,e.$Ap="telemetry",e.$Bp="extensionTelemetryLog",e.$Cp={log:()=>null,flush:()=>Promise.resolve(null)};function I(g,u){return!u.isBuilt&&!u.disableTelemetry?!0:!(u.disableTelemetry||!g.enableTelemetry)}function y(g,u){return u.extensionTestsLocationURI?!0:!(u.isBuilt||u.disableTelemetry||g.enableTelemetry&&g.aiConfig?.ariaKey)}function a(g){const u=g.getValue(A.$hm),$=g.getValue(A.$im);if(g.getValue(A.$jm)===!1||$===!1)return A.TelemetryLevel.NONE;switch(u??A.TelemetryConfiguration.ON){case A.TelemetryConfiguration.ON:return A.TelemetryLevel.USAGE;case A.TelemetryConfiguration.ERROR:return A.TelemetryLevel.ERROR;case A.TelemetryConfiguration.CRASH:return A.TelemetryLevel.CRASH;case A.TelemetryConfiguration.OFF:return A.TelemetryLevel.NONE}}function S(g){const u={},$={},m={};s(g,m);for(let h in m){h=h.length>150?h.substr(h.length-149):h;const E=m[h];typeof E=="number"?$[h]=E:typeof E=="boolean"?$[h]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${h} has been trimmed to 8192, the original length is ${E.length}`),u[h]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(u[h]=E)}return{properties:u,measurements:$}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(g){if(!g)return"none";const u=(0,P.$hn)(g);return d.has(u)?u:"other"}function s(g,u,$=0,m){if(g)for(const h of Object.getOwnPropertyNames(g)){const E=g[h],D=m?m+h:h;Array.isArray(E)?u[D]=(0,v.$io)(E):E instanceof Date?u[D]=E.toISOString():(0,R.$gg)(E)?$<2?s(E,u,$+1,D+"."):u[D]=(0,v.$io)(E):u[D]=E}}function c(g,u){const $=g.msftInternalDomains||[],m=u.getValue("telemetry.internalTesting");return(0,O.$vp)($)||m}function l(g){return[g.appRoot,g.extensionsPath,g.userHome.fsPath,g.tmpDir.fsPath,g.userDataPath]}function i(g,u){if(!g||!g.includes("/")&&!g.includes("\\"))return g;let $=g;const m=[];for(const w of u)for(;;){const C=w.exec(g);if(!C)break;m.push([C.index,w.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for($="";;){const w=E.exec(g);if(!w)break;const C=m.some(([k,f])=>w.index<f&&k<E.lastIndex);!h.test(w[0])&&!C&&($+=g.substring(D,w.index)+"<REDACTED: user-file-path>",D=E.lastIndex)}return D<g.length&&($+=g.substr(D)),$}function n(g){if(!g)return g;const u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const $ of u)if($.regex.test(g))return`<REDACTED: ${$.label}>`;return g}function t(g,u){return(0,v.$fo)(g,$=>{if($ instanceof T||Object.hasOwnProperty.call($,"isTrustedTelemetryValue"))return $.value;if(typeof $=="string"){let m=$.replaceAll("%20"," ");m=i(m,u);for(const h of u)m=m.replace(h,"");return m=n(m),m}})}}),define(Ne[178],Le([1,0,12,110,18,20,2,13,78,63]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Up=e.$Mp=void 0,e.$Lp=I,e.$Np=d,e.$Op=r,e.$Pp=s,e.$Qp=c,e.$Rp=l,e.$Sp=i,e.$Tp=n,e.$Vp=t,e.$Wp=u;function I($,m){return $.uuid&&m.uuid?$.uuid===m.uuid:$.id===m.id?!0:(0,v.$Af)($.id,m.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class a{static create(m){const h=m.manifest?m.manifest.version:m.version,E=m.manifest?m.targetPlatform:m.properties.targetPlatform;return new a(m.identifier,h,E)}static parse(m){const h=y.exec(m);return h&&h[1]&&h[2]?new a({id:h[1]},h[2],h[4]||void 0):null}constructor(m,h,E=P.TargetPlatform.UNDEFINED){this.identifier=m,this.version=h,this.targetPlatform=E,this.id=m.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!==P.TargetPlatform.UNDEFINED?`-${this.targetPlatform}`:""}`}equals(m){return m instanceof a?I(this,m)&&this.version===m.version&&this.targetPlatform===m.targetPlatform:!1}}e.$Mp=a;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d($){const m=S.exec($);return m&&m[1]?[s(m[1]),m[2]]:[s($),void 0]}function r($,m){return`${$}.${m}`}function s($){return $.toLowerCase()}function c($,m){return s(r($??P.$mn,m))}function l($,m){const h=[],E=D=>{for(const w of h)if(w.some(C=>I(m(C),m(D))))return w;return null};for(const D of $){const w=E(D);w?w.push(D):h.push([D])}return h}function i($){return{id:$.identifier.id,name:$.manifest.name,galleryId:null,publisherId:$.publisherId,publisherName:$.manifest.publisher,publisherDisplayName:$.publisherDisplayName,dependencies:$.manifest.extensionDependencies&&$.manifest.extensionDependencies.length>0}}function n($){return{id:new o.$wp($.identifier.id),name:new o.$wp($.name),version:$.version,galleryId:$.identifier.uuid,publisherId:$.publisherId,publisherName:$.publisher,publisherDisplayName:$.publisherDisplayName,isPreReleaseVersion:$.properties.isPreReleaseVersion,dependencies:!!($.properties.dependencies&&$.properties.dependencies.length>0),isSigned:$.isSigned,...$.telemetryData}}e.$Up=new P.$qn("pprice.better-merge");function t($,m){const h=[],E=m.manifest.extensionDependencies?.slice(0)??[];for(;E.length;){const D=E.shift();if(D&&h.every(w=>!I(w.identifier,{id:D}))){const w=$.filter(C=>I(C.identifier,{id:D}));w.length===1&&(h.push(w[0]),E.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}async function g($,m){if(!O.$l)return!1;let h;try{h=(await $.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{h=(await $.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(D){m.debug("Error while getting the os-release file.",(0,T.$9)(D))}}return!!h&&(h.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function u($,m){const h=await g($,m),E=(0,R.$gp)(h?"alpine":O.$v,p.$ec);return m.debug("ComputeTargetPlatform:",E),E}}),define(Ne[179],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=v,e.$Fs=R,e.$Gs=P,e.$Hs=O,e.$Is=A,e.$Js=T;function v(p){return[...p.entries()]}function R(p){return p?[...p.entries()]:[]}function P(p){return new Map(p)}function O(p){return new Map(p??[])}function A(p){return Array.from(p.entries()).map(o=>[o[0],v(o[1].map),R(o[1].descriptionMap)])}function T(p){return new Map(p.map(o=>[o[0],{map:P(o[1]),descriptionMap:O(o[2])}]))}}),define(Ne[180],Le([1,0,3,31,30]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=e.$qs=e.$ps=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$os=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$ns=void 0,e.$ns=new R.$Vj("terminalTabFocusMode",!1,!0);var O;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(O||(e.TerminalSettingPrefix=O={}));var A;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.MiddleClickBehavior="terminal.integrated.middleClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.EnableVisualBell="terminal.integrated.enableVisualBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(A||(e.TerminalSettingId=A={}));var T;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh",t.Python="python"})(T||(e.PosixShellType=T={}));var p;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash",t.Python="python"})(p||(e.WindowsShellType=p={}));var o;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(o||(e.TitleEventSource=o={}));var I;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(I||(e.TerminalIpcChannels=I={}));var y;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(y||(e.ProcessPropertyType=y={})),e.$os=(0,v.$Ei)("ptyService");var a;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(a||(e.HeartbeatConstants=a={}));var S;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(S||(e.TerminalLocation=S={}));var d;(function(t){t.TerminalView="view",t.Editor="editor"})(d||(e.TerminalLocationString=d={}));var r;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(r||(e.LocalReconnectConstants=r={}));var s;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(s||(e.FlowControlConstants=s={}));var c;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var l;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(l||(e.ShellIntegrationStatus=l={}));var i;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(i||(e.TerminalExitReason=i={})),e.$ps={Backend:"workbench.contributions.terminal.processBackend"};class n{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(g){const u=this.b(g.remoteAuthority);if(this.a.has(u))throw new Error(`A terminal backend with remote authority '${u}' was already registered.`);this.a.set(u,g)}getTerminalBackend(g){return this.a.get(this.b(g))}b(g){return g?.toLowerCase()??""}}P.$qo.add(e.$ps.Backend,new n),e.$qs=(0,v.$Ei)("localPtyService"),e.$rs=(0,v.$Ei)("terminalLogService")}),define(Ne[181],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uxb=void 0;class v{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,O,A=5){const T=O(p=>{const o=typeof p=="string"?p:p.data;let I=this.a.get(P);if(I){I.data.push(o);return}const y=setTimeout(()=>this.flushBuffer(P),A);I={data:[o],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(P),T.dispose()}},this.a.set(P,I)});return T}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const O=this.a.get(P);O&&(this.a.delete(P),this.b(P,O.data.join("")))}}e.$Uxb=v}),define(Ne[182],Le([1,0,10,97,282,34,6,14,2,9,77,30]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hx=e.$Gx=e.$Fx=e.$Ex=e.$Dx=e.$Cx=e.IconFontDefinition=e.IconContribution=e.$zx=void 0,e.$Ax=s,e.$Bx=c,y=We(y),e.$zx={IconContribution:"base.contributions.icons"};var a;(function(t){function g(u,$){let m=u.defaults;for(;O.ThemeIcon.isThemeIcon(m);){const h=r.getIcon(m.id);if(!h)return;m=h.defaults}return m}t.getDefinition=g})(a||(e.IconContribution=a={}));var S;(function(t){function g($){return{weight:$.weight,style:$.style,src:$.src.map(m=>({format:m.format,location:m.location.toString()}))}}t.toJSONObject=g;function u($){const m=h=>(0,T.$eg)(h)?h:void 0;if($&&Array.isArray($.src)&&$.src.every(h=>(0,T.$eg)(h.format)&&(0,T.$eg)(h.location)))return{weight:m($.weight),style:m($.style),src:$.src.map(h=>({format:h.format,location:p.URI.parse(h.location)}))}}t.fromJSONObject=u})(S||(e.IconFontDefinition=S={}));class d{constructor(){this.a=new A.$le,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,o.localize)(11140,null)},fontCharacter:{type:"string",description:(0,o.localize)(11141,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,u,$,m){const h=this.b[g];if(h){if($&&!h.description){h.description=$,this.d.properties[g].markdownDescription=`${$} $(${g})`;const w=this.e.enum.indexOf(g);w!==-1&&(this.e.enumDescriptions[w]=$),this.a.fire()}return h}const E={id:g,description:$,defaults:u,deprecationMessage:m};this.b[g]=E;const D={$ref:"#/definitions/icons"};return m&&(D.deprecationMessage=m),$&&(D.markdownDescription=`${$}: $(${g})`),this.d.properties[g]=D,this.e.enum.push(g),this.e.enumDescriptions.push($||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const u=this.e.enum.indexOf(g);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,u){const $=this.f[g];return $||(this.f[g]=u,this.a.fire(),u)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(h,E)=>h.id.localeCompare(E.id),u=h=>{for(;O.ThemeIcon.isThemeIcon(h.defaults);)h=this.b[h.defaults.id];return`codicon codicon-${h?h.id:""}`},$=[];$.push("| preview     | identifier                        | default codicon ID                | description"),$.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.b).map(h=>this.b[h]);for(const h of m.filter(E=>!!E.description).sort(g))$.push(`|<i class="${u(h)}"></i>|${h.id}|${O.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);$.push("| preview     | identifier                        "),$.push("| ----------- | --------------------------------- |");for(const h of m.filter(E=>!O.ThemeIcon.isThemeIcon(E.defaults)).sort(g))$.push(`|<i class="${u(h)}"></i>|${h.id}|`);return $.join(`
`)}}const r=new d;y.$qo.add(e.$zx.IconContribution,r);function s(t,g,u,$){return r.registerIcon(t,g,u,$)}function c(){return r}function l(){const t=(0,P.$Zj)();for(const g in t){const u="\\"+t[g].toString(16);r.registerIcon(g,{fontCharacter:u})}}l(),e.$Cx="vscode://schemas/icons";const i=y.$qo.as(I.$ro.JSONContribution);i.registerSchema(e.$Cx,r.getIconSchema());const n=new v.$Qh(()=>i.notifySchemaChanged(e.$Cx),200);r.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$Dx=s("widget-close",R.$4j.close,(0,o.localize)(11142,null)),e.$Ex=s("goto-previous-location",R.$4j.arrowUp,(0,o.localize)(11143,null)),e.$Fx=s("goto-next-location",R.$4j.arrowDown,(0,o.localize)(11144,null)),e.$Gx=O.ThemeIcon.modify(R.$4j.sync,"spin"),e.$Hx=O.ThemeIcon.modify(R.$4j.loading,"spin")}),define(Ne[183],Le([1,0,6,4,20,2,43,3,11]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ow=e.$Nw=e.$Kw=e.$Iw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ew=e.$Dw=void 0,e.$Fw=y,e.$Gw=S,e.$Hw=d,e.$Jw=r,e.$Lw=s,e.$Mw=c,e.$Dw=(0,T.$Ei)("tunnelService"),e.$Ew=(0,T.$Ei)("sharedTunnelsService");var o;(function(n){n.Http="http",n.Https="https"})(o||(e.TunnelProtocol=o={}));var I;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(I||(e.TunnelPrivacyId=I={}));function y(n){return!!n.forwardPort}var a;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(a||(e.ProvidedOnAutoForward=a={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function d(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const g of t){const u=g.split("=")[1];if(/^https?:/.exec(u)){const $=S(O.URI.parse(u));if($)return $}}}e.$Iw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function r(n){return e.$Iw.indexOf(n)>=0}e.$Kw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function s(n){return e.$Kw.indexOf(n)>=0}function c(n,t,g,u){if(g===P.OperatingSystem.Windows)return!1;if(g===P.OperatingSystem.Macintosh&&s(t)){const $=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if($?.length===4&&parseInt($[1])>=18)return!1}return n<1024}class l{constructor(t,g,u){this.remoteAddress=t,this.localAddress=g,this.b=u,this.a=new v.$le,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Nw=l;let i=class extends R.$Uc{constructor(t,g){super(),this.r=t,this.s=g,this.a=new v.$le,this.onTunnelOpened=this.a.event,this.b=new v.$le,this.onTunnelClosed=this.b.event,this.c=new v.$le,this.onAddedTunnelProvider=this.c.event,this.f=new Map,this.h=!1,this.j=!0,this.m=[],this.n=new Set}get hasTunnelProvider(){return!!this.g}get t(){const t=this.s.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.g=t,t?(this.c.fire(),{dispose:()=>{this.g=void 0,this.h=!1,this.m=[]}}):(this.h=!1,this.m=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.h=t.elevation,this.m=t.privacyOptions,this.j=t.protocol}get canChangeProtocol(){return this.j}get canElevate(){return this.h}get canChangePrivacy(){return this.m.length>0}get privacyOptions(){return this.m}get tunnels(){return this.u()}async u(){const t=[],g=Array.from(this.f.values());for(const u of g){const $=Array.from(u.values());for(const m of $){const h=await m.value;h&&typeof h!="string"&&t.push(h)}}return t}async dispose(){super.dispose();for(const t of this.f.values()){for(const{value:g}of t.values())await g.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.f.clear()}setEnvironmentTunnel(t,g,u,$,m){this.z(t,g,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:g,localAddress:u,privacy:$,protocol:m,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,g){(s(t)||r(t))&&(t=e.$Iw[0]);const u=this.D(t,g);if(u)return++u.refcount,u.value}openTunnel(t,g,u,$,m,h=!1,E,D){this.r.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${u} on local port ${m}.`);const w=this.g??t;if(!w)return;if(g||(g="localhost"),$||($=this.t),this.g&&this.n.has(u)){this.r.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const C=this.F(w,g,u,$,m,h,E,D);return C?C.then(k=>{if(k){if(typeof k=="string")return this.r.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.C(g,u),k}else{this.r.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.C(g,u);return}this.r.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.w(k);return(k.tunnelRemoteHost!==g||k.tunnelRemotePort!==u)&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),E&&k.privacy!==E&&this.r.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.r.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),C)}w(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.r.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const g=this.f.get(t.tunnelRemoteHost);if(g){const u=g.get(t.tunnelRemotePort);u&&(u.refcount--,await this.y(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async y(t,g,u){if(u.refcount<=0){this.r.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${g}.`);const $=u.value.then(async m=>{m&&typeof m!="string"&&(await m.dispose(!0),this.b.fire({host:m.tunnelRemoteHost,port:m.tunnelRemotePort}))});return this.f.has(t)&&this.f.get(t).delete(g),$}}async closeTunnel(t,g){this.r.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${g} `);const u=this.f.get(t);if(u&&u.has(g)){const $=u.get(g);$.refcount=0,await this.y(t,g,$)}}z(t,g,u){this.f.has(t)||this.f.set(t,new Map),this.f.get(t).set(g,{refcount:1,value:u})}async C(t,g){const u=this.f.get(t);if(u){const $=u.get(g),m=$?await $.value:void 0;(!m||typeof m=="string")&&u.delete(g),u.size===0&&this.f.delete(t)}}D(t,g){const u=[t];r(t)?(u.push(...e.$Iw),u.push(...e.$Kw)):s(t)&&u.push(...e.$Kw);const $=u.map(m=>this.f.get(m));for(const m of $){const h=m?.get(g);if(h)return h}}canTunnel(t){return!!S(t)}G(t,g,u,$,m,h,E){this.r.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${u} on local port ${$}.`);const D=u;this.n.add(D);const w=$===void 0?u:$,C={elevationRequired:m?this.isPortPrivileged(w):!1},k={remoteAddress:{host:g,port:u},localAddressPort:$,privacy:h,public:h?h!==I.Private:void 0,protocol:E},f=t.forwardPort(k,C);return f?(this.z(g,u,f),f.finally(()=>{this.r.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.n.delete(D)})):this.n.delete(D),f}};e.$Ow=i,e.$Ow=i=Je([Ve(0,p.$_j),Ve(1,A.$$i)],i)}),define(Ne[184],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=void 0,e.$Jl=(0,v.$Ei)("IUriIdentityService")}),define(Ne[185],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Pw=void 0,e.$Pw=(0,v.$Ei)("editSessionIdentityService");var R;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Ne[186],Le([1,0,15]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=R,e.$hN=P,e.$iN=O,e.$jN=A,e.$kN=T;function R(p){return p.scheme!==v.Schemas.file&&p.scheme!==v.Schemas.vscodeRemote}function P(p){if(p.folders.length)return p.folders.every(o=>R(o.uri))?p.folders[0].uri:void 0;if(p.configuration&&R(p.configuration))return p.configuration}function O(p){return P(p)?.scheme}function A(p){return P(p)?.authority}function T(p){return P(p)!==void 0}}),define(Ne[49],Le([1,0,9,19,58,23,2,3,15]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Yi=e.$Xi=e.WorkbenchState=e.$Ri=e.$Qi=e.$Ni=void 0,e.$Oi=o,e.$Pi=I,e.$Si=y,e.$Ti=a,e.$Ui=S,e.$Vi=r,e.$Wi=s,e.$Zi=i,e.$5i=n,e.$6i=t,e.$8i=g,e.$9i=u,e.$0i=$,e.$Ni=(0,T.$Ei)("contextService");function o(m){const h=m;return typeof h?.id=="string"&&A.URI.isUri(h.uri)}function I(m){return typeof m?.id=="string"&&!o(m)&&!a(m)}e.$Qi={id:"ext-dev"},e.$Ri={id:"empty-window"};function y(m,h){if(typeof m=="string"||typeof m>"u")return typeof m=="string"?{id:(0,R.$nc)(m)}:h?e.$Qi:e.$Ri;const E=m;return E.configuration?{id:E.id,configPath:E.configuration}:E.folders.length===1?{id:E.id,uri:E.folders[0].uri}:{id:E.id}}function a(m){const h=m;return typeof h?.id=="string"&&A.URI.isUri(h.configPath)}function S(m){const h=m;if(h?.uri)return{id:h.id,uri:A.URI.revive(h.uri)};const E=m;if(E?.configPath)return{id:E.id,configPath:A.URI.revive(E.configPath)};if(m?.id)return{id:m.id}}var d;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function r(m){const h=m;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}function s(m){const h=m;return!!(h&&typeof h=="object"&&A.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}class c{constructor(h,E,D,w,C){this.h=h,this.j=D,this.k=w,this.l=C,this.c=P.$Ki.forUris(this.l,()=>!0),this.folders=E}update(h){this.h=h.id,this.k=h.configuration,this.j=h.transient,this.l=h.l,this.folders=h.folders}get folders(){return this.g}set folders(h){this.g=h,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(h){this.k=h}getFolder(h){return h&&this.c.findSubstr(h)||null}n(){this.c=P.$Ki.forUris(this.l,()=>!0);for(const h of this.folders)this.c.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Xi=c;class l{constructor(h,E){this.raw=E,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return(0,O.$fh)(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Yi=l;function i(m){return new l({uri:m,index:0,name:(0,O.$bh)(m)},{uri:m.toString()})}e.$1i="code-workspace",e.$2i=`.${e.$1i}`,e.$3i=[{name:(0,v.localize)(11019,null),extensions:[e.$1i]}],e.$4i="workspace.json";function n(m,h){return O.$9g.isEqualOrParent(m,h.untitledWorkspacesHome)}function t(m){let h;return A.URI.isUri(m)?h=m:h=m.configuration,h?.scheme===p.Schemas.tmp}e.$7i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function g(m){return m.id===e.$7i}function u(m,h){return!n(m,h)&&!t(m)}function $(m){return(typeof m=="string"?(0,R.$oc)(m):(0,O.$dh)(m))===e.$2i}}),define(Ne[113],Le([1,0,75,6,4,23,2,9,106,29,3,11,49,28,184,10,38,12,14]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=e.$Ll=e.ProfileResourceType=void 0,e.$Kl=n,e.$Ml=t,e.$Nl=g;var i;(function(m){m.Settings="settings",m.Keybindings="keybindings",m.Snippets="snippets",m.Tasks="tasks",m.Extensions="extensions",m.GlobalState="globalState"})(i||(e.ProfileResourceType=i={}));function n(m){const h=m;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&typeof h.isDefault=="boolean"&&typeof h.name=="string"&&A.URI.isUri(h.location)&&A.URI.isUri(h.globalStorageHome)&&A.URI.isUri(h.settingsResource)&&A.URI.isUri(h.keybindingsResource)&&A.URI.isUri(h.tasksResource)&&A.URI.isUri(h.snippetsHome)&&A.URI.isUri(h.extensionsResource))}e.$Ll=(0,I.$Ei)("IUserDataProfilesService");function t(m,h){return{id:m.id,isDefault:m.isDefault,name:m.name,shortName:m.shortName,icon:m.icon,location:A.URI.revive(m.location).with({scheme:h}),globalStorageHome:A.URI.revive(m.globalStorageHome).with({scheme:h}),settingsResource:A.URI.revive(m.settingsResource).with({scheme:h}),keybindingsResource:A.URI.revive(m.keybindingsResource).with({scheme:h}),tasksResource:A.URI.revive(m.tasksResource).with({scheme:h}),snippetsHome:A.URI.revive(m.snippetsHome).with({scheme:h}),extensionsResource:A.URI.revive(m.extensionsResource).with({scheme:h}),cacheHome:A.URI.revive(m.cacheHome).with({scheme:h}),useDefaultFlags:m.useDefaultFlags,isTransient:m.isTransient}}function g(m,h,E,D,w,C){return{id:m,name:h,location:E,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:C&&w?.useDefaultFlags?.globalState?C.globalStorageHome:(0,O.$fh)(E,"globalStorage"),settingsResource:C&&w?.useDefaultFlags?.settings?C.settingsResource:(0,O.$fh)(E,"settings.json"),keybindingsResource:C&&w?.useDefaultFlags?.keybindings?C.keybindingsResource:(0,O.$fh)(E,"keybindings.json"),tasksResource:C&&w?.useDefaultFlags?.tasks?C.tasksResource:(0,O.$fh)(E,"tasks.json"),snippetsHome:C&&w?.useDefaultFlags?.snippets?C.snippetsHome:(0,O.$fh)(E,"snippets"),extensionsResource:C&&w?.useDefaultFlags?.extensions?C.extensionsResource:(0,O.$fh)(E,"extensions.json"),cacheHome:(0,O.$fh)(D,m),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let u=class extends P.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(h,E,D,w){super(),this.t=h,this.u=E,this.w=D,this.y=w,this.f=!0,this.h=this.B(new R.$le),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$le),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$le),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$le),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],folders:new S.$Ac,workspaces:new S.$Ac,emptyWindows:new Map},this.profilesHome=(0,O.$fh)(this.t.userRoamingDataHome,"profiles"),this.g=(0,O.$fh)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(h){this.f!==h&&(this.z=void 0,this.f=h)}isEnabled(){return this.f}get C(){if(!this.z){const h=this.D(),E=[h];if(this.f)try{for(const C of this.O()){if(!C.name||!(0,l.$eg)(C.name)||!C.location){this.y.warn("Skipping the invalid stored profile",C.location||C.name);continue}E.push(g((0,O.$ch)(C.location),C.name,C.location,this.g,{shortName:C.shortName,icon:C.icon,useDefaultFlags:C.useDefaultFlags},h))}}catch(C){this.y.error(C)}const D=new S.$Ac,w=new Map;if(E.length)try{const C=this.Q();if(C.workspaces)for(const[k,f]of Object.entries(C.workspaces)){const b=A.URI.parse(k),M=E.find(N=>N.id===f);M&&D.set(b,M)}if(C.emptyWindows)for(const[k,f]of Object.entries(C.emptyWindows)){const b=E.find(M=>M.id===f);b&&w.set(k,b)}}catch(C){this.y.error(C)}this.z={profiles:E,workspaces:D,emptyWindows:w}}return this.z}D(){const h=g("__default__profile__",(0,T.localize)(11066,null),this.t.userRoamingDataHome,this.g);return{...h,extensionsResource:this.S()??h.extensionsResource,isDefault:!0}}async createTransientProfile(h){const E="Temp",D=new RegExp(`${(0,c.$hf)(E)}\\s(\\d+)`);let w=0;for(const k of this.profiles){const f=D.exec(k.name),b=f?parseInt(f[1]):0;w=b>w?b:w}const C=`${E} ${w+1}`;return this.createProfile((0,v.$sj)((0,s.$1g)()).toString(16),C,{transient:!0},h)}async createNamedProfile(h,E,D){return this.createProfile((0,v.$sj)((0,s.$1g)()).toString(16),h,E,D)}async createProfile(h,E,D,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const C=await this.F(h,E,D);return w&&await this.setProfileForWorkspace(w,C),C}async F(h,E,D){if(!(0,l.$eg)(E)||!E)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(E);return w||(w=(async()=>{try{if(this.profiles.find(b=>b.name===E||b.id===h))throw new Error(`Profile with ${E} name already exists`);const k=g(h,E,(0,O.$fh)(this.profilesHome,h),this.g,D,this.defaultProfile);await this.u.createFolder(k.location);const f=[];return this.j.fire({profile:k,join(b){f.push(b)}}),await r.Promises.settled(f),this.I([k],[],[]),k}finally{this.r.delete(E)}})(),this.r.set(E,w)),w}async updateProfile(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let D=this.profiles.find(w=>w.id===h.id);if(!D)throw new Error(`Profile '${h.name}' does not exist`);return D=g(D.id,E.name??D.name,D.location,this.g,{shortName:E.shortName??D.shortName,icon:E.icon===null?void 0:E.icon??D.icon,transient:E.transient??D.isTransient,useDefaultFlags:E.useDefaultFlags??D.useDefaultFlags},this.defaultProfile),this.I([],[],[D]),D}async removeProfile(h){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(h.isDefault)throw new Error("Cannot remove default profile");const E=this.profiles.find(w=>w.id===h.id);if(!E)throw new Error(`Profile '${h.name}' does not exist`);const D=[];this.m.fire({profile:E,join(w){D.push(w)}});try{await Promise.allSettled(D)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])E.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])E.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[E],[]);try{await this.u.del(E.cacheHome,{recursive:!0})}catch(w){(0,o.$ql)(w)!==o.FileOperationResult.FILE_NOT_FOUND&&this.y.error(w)}}async setProfileForWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=this.profiles.find(w=>w.id===E.id);if(!D)throw new Error(`Profile '${E.name}' does not exist`);this.L(h,D)}unsetWorkspace(h,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(h,void 0,E)}async resetWorkspaces(){this.s.folders.clear(),this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const h=await this.u.resolve(this.profilesHome);await Promise.all((h.children||[]).filter(E=>E.isDirectory&&this.profiles.every(D=>!this.w.extUri.isEqual(D.location,E.resource))).map(E=>this.u.del(E.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const h=this.s.profiles.filter(E=>!this.H(E));await Promise.allSettled(h.map(E=>this.removeProfile(E)))}getProfileForWorkspace(h){const E=this.G(h),D=A.URI.isUri(E)?this.C.workspaces.get(E):this.C.emptyWindows.get(E);return D||((0,a.$Oi)(h)?this.s.folders.get(h.uri):(0,a.$Ti)(h)?this.s.workspaces.get(h.configPath):this.s.emptyWindows.get(h.id))}G(h){return(0,a.$Oi)(h)?h.uri:(0,a.$Ti)(h)?h.configPath:h.id}H(h){return!!([...this.C.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.C.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.emptyWindows.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.workspaces.values()].some(E=>this.w.extUri.isEqual(E.location,h.location))||[...this.s.folders.values()].some(E=>this.w.extUri.isEqual(E.location,h.location)))}I(h,E,D){const w=[...this.profiles,...h],C=[],k=this.s.profiles;this.s.profiles=[];for(let f of w){if(f.isDefault||E.some(M=>f.id===M.id))continue;f=D.find(M=>f.id===M.id)??f;const b=k.find(M=>f.id===M.id);if(f.isTransient)this.s.profiles.push(f);else{if(b){for(const[M,N]of this.s.emptyWindows.entries())if(f.id===N.id){this.L({id:M},f);break}for(const[M,N]of this.s.workspaces.entries())if(f.id===N.id){this.L({id:"",configPath:M},f);break}for(const[M,N]of this.s.folders.entries())if(f.id===N.id){this.L({id:"",uri:M},f);break}}C.push({location:f.location,name:f.name,shortName:f.shortName,icon:f.icon,useDefaultFlags:f.useDefaultFlags})}}this.P(C),this.z=void 0,this.J(h,E,D)}J(h,E,D){this.h.fire({added:h,removed:E,updated:D,all:this.profiles})}L(h,E,D){if(D=E?.isTransient?!0:D,D)(0,a.$Oi)(h)?(this.s.folders.delete(h.uri),E&&this.s.folders.set(h.uri,E)):(0,a.$Ti)(h)?(this.s.workspaces.delete(h.configPath),E&&this.s.workspaces.set(h.configPath,E)):(this.s.emptyWindows.delete(h.id),E&&this.s.emptyWindows.set(h.id,E));else{this.L(h,void 0,!0);const w=this.G(h);A.URI.isUri(w)?(this.C.workspaces.delete(w),E&&this.C.workspaces.set(w,E)):(this.C.emptyWindows.delete(w),E&&this.C.emptyWindows.set(w,E)),this.M()}}M(){const h={};for(const[D,w]of this.C.workspaces.entries())h[D.toString()]=w.id;const E={};for(const[D,w]of this.C.emptyWindows.entries())E[D.toString()]=w.id;this.R({workspaces:h,emptyWindows:E}),this.z=void 0}N(h){const E={},D=this.D();if(h.workspaces)for(const[C,k]of Object.entries(h.workspaces)){const f=A.URI.parse(k);E[C]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}const w={};if(h.emptyWindows)for(const[C,k]of Object.entries(h.emptyWindows)){const f=A.URI.parse(k);w[C]=this.w.extUri.isEqual(f,D.location)?D.id:this.w.extUri.basename(f)}return{workspaces:E,emptyWindows:w}}O(){return[]}P(h){throw new Error("not implemented")}Q(){return{}}R(h){throw new Error("not implemented")}S(){}};e.$Ol=u,e.$Ol=u=Je([Ve(0,p.$Li),Ve(1,o.$_k),Ve(2,d.$Jl),Ve(3,y.$_j)],u);class $ extends u{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(h){this.a=h}Q(){return this.X}R(h){this.X=h}}e.$Pl=$}),define(Ne[187],Le([1,0,10,6,4,64,14,152,3,113]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$jq=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$hq=e.$gq=e.$fq=void 0,e.$iq=S,e.$kq=r,e.$mq=c,e.$fq="__$__isNewStorageMarker",e.$gq="__$__targetStorageMarker",e.$hq=(0,p.$Ei)("storageService");var I;(function(l){l[l.NONE=0]="NONE",l[l.SHUTDOWN=1]="SHUTDOWN"})(I||(e.WillSaveStateReason=I={}));var y;(function(l){l[l.APPLICATION=-1]="APPLICATION",l[l.PROFILE=0]="PROFILE",l[l.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var a;(function(l){l[l.USER=0]="USER",l[l.MACHINE=1]="MACHINE"})(a||(e.StorageTarget=a={}));function S(l){const i=l.get(e.$gq);if(i)try{return JSON.parse(i)}catch{}return Object.create(null)}class d extends P.$Uc{static{this.a=60*1e3}constructor(i={flushInterval:d.a}){super(),this.m=i,this.b=this.B(new R.$oe),this.c=this.B(new R.$oe),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$le),this.onWillSaveState=this.f.event,this.h=this.B(new v.$Qh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new P.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(i,n,t){return R.Event.filter(this.b.event,g=>g.scope===i&&(n===void 0||g.key===n),t)}n(){this.j.value=(0,v.$Uh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,P.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.O()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(i,n){const{key:t,external:g}=n;if(t===e.$gq){switch(i){case y.APPLICATION:this.H=void 0;break;case y.PROFILE:this.F=void 0;break;case y.WORKSPACE:this.C=void 0;break}this.c.fire({scope:i})}else this.b.fire({scope:i,key:t,target:this.J(i)[t],external:g})}w(i){this.f.fire({reason:i})}get(i,n,t){return this.P(n)?.get(i,t)}getBoolean(i,n,t){return this.P(n)?.getBoolean(i,t)}getNumber(i,n,t){return this.P(n)?.getNumber(i,t)}getObject(i,n,t){return this.P(n)?.getObject(i,t)}storeAll(i,n){this.y(()=>{for(const t of i)this.store(t.key,t.value,t.scope,t.target,n)})}store(i,n,t,g,u=!1){if((0,A.$ng)(n)){this.remove(i,t,u);return}this.y(()=>{this.z(i,t,g),this.P(t)?.set(i,n,u)})}remove(i,n,t=!1){this.y(()=>{this.z(i,n,void 0),this.P(n)?.delete(i,t)})}y(i){this.b.pause(),this.c.pause();try{i()}finally{this.b.resume(),this.c.resume()}}keys(i,n){const t=[],g=this.J(i);for(const u of Object.keys(g))g[u]===n&&t.push(u);return t}z(i,n,t,g=!1){const u=this.J(n);typeof t=="number"?u[i]!==t&&(u[i]=t,this.P(n)?.set(e.$gq,JSON.stringify(u),g)):typeof u[i]=="number"&&(delete u[i],this.P(n)?.set(e.$gq,JSON.stringify(u),g))}get D(){return this.C||(this.C=this.L(y.WORKSPACE)),this.C}get G(){return this.F||(this.F=this.L(y.PROFILE)),this.F}get I(){return this.H||(this.H=this.L(y.APPLICATION)),this.H}J(i){switch(i){case y.APPLICATION:return this.I;case y.PROFILE:return this.G;default:return this.D}}L(i){const n=this.P(i);return n?S(n):Object.create(null)}isNew(i){return this.getBoolean(e.$fq,i)===!0}async flush(i=I.NONE){this.f.fire({reason:i});const n=this.P(y.APPLICATION),t=this.P(y.PROFILE),g=this.P(y.WORKSPACE);switch(i){case I.NONE:await v.Promises.settled([n?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await v.Promises.settled([n?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async log(){const i=this.P(y.APPLICATION)?.items??new Map,n=this.P(y.PROFILE)?.items??new Map,t=this.P(y.WORKSPACE)?.items??new Map;return c(i,n,t,this.Q(y.APPLICATION)??"",this.Q(y.PROFILE)??"",this.Q(y.WORKSPACE)??"")}async optimize(i){return await this.flush(),this.P(i)?.optimize()}async switch(i,n){return this.w(I.NONE),(0,o.$Kl)(i)?this.R(i,n):this.S(i,n)}M(i,n){return!(i.id===n.id||r(n)&&r(i))}N(i,n,t){this.y(()=>{const g=new Set;for(const[u,$]of i)g.add(u),n.get(u)!==$&&this.u(t,{key:u,external:!0});for(const[u]of n.items)g.has(u)||this.u(t,{key:u,external:!0})})}}e.$jq=d;function r(l){return l.isDefault||!!l.useDefaultFlags?.globalState}class s extends d{constructor(){super(),this.U=this.B(new T.$dq(new T.$eq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new T.$dq(new T.$eq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new T.$dq(new T.$eq,{hint:T.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(i=>this.u(y.WORKSPACE,i))),this.B(this.W.onDidChangeStorage(i=>this.u(y.PROFILE,i))),this.B(this.U.onDidChangeStorage(i=>this.u(y.APPLICATION,i)))}P(i){switch(i){case y.APPLICATION:return this.U;case y.PROFILE:return this.W;default:return this.X}}Q(i){switch(i){case y.APPLICATION:return"inMemory (application)";case y.PROFILE:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(i){return!1}}e.$lq=s;async function c(l,i,n,t,g,u){const $=b=>{try{return JSON.parse(b)}catch{return b}},m=new Map,h=new Map;l.forEach((b,M)=>{m.set(M,b),h.set(M,$(b))});const E=new Map,D=new Map;i.forEach((b,M)=>{E.set(M,b),D.set(M,$(b))});const w=new Map,C=new Map;n.forEach((b,M)=>{w.set(M,b),C.set(M,$(b))}),console.group(t!==g?`Storage: Application (path: ${t})`:`Storage: Application & Profile (path: ${t}, default profile)`);const k=[];if(m.forEach((b,M)=>{k.push({key:M,value:b})}),console.table(k),console.groupEnd(),console.log(h),t!==g){console.group(`Storage: Profile (path: ${g}, profile specific)`);const b=[];E.forEach((M,N)=>{b.push({key:N,value:M})}),console.table(b),console.groupEnd(),console.log(D)}console.group(`Storage: Workspace (path: ${u})`);const f=[];w.forEach((b,M)=>{f.push({key:M,value:b})}),console.table(f),console.groupEnd(),console.log(C)}}),define(Ne[79],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lpc=void 0;class v{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const O=this.c++;return this.b.set(O,P),this.e(),O}get(P,O){return this.b.has(P)?this.b.get(P)[O]:void 0}delete(P){this.b.delete(P),this.e()}e(){v.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$lpc=v}),define(Ne[50],Le([1,0,15,23,29,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rpc=e.$qpc=void 0;class A{constructor(){this.a=new Set(Object.keys(v.Schemas)),this.b=new Map,this.extUri=new R.$7g(p=>{const o=this.b.get(p.scheme);return!(o===void 0||o&P.FileSystemProviderCapabilities.PathCaseSensitive)})}$acceptProviderInfos(p,o){o===null?this.b.delete(p.scheme):this.b.set(p.scheme,o)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$qpc=A,e.$rpc=(0,O.$Ei)("IExtHostFileSystemInfo")}),define(Ne[26],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0,e.$zQ=(0,v.$Ei)("IExtHostInitDataService")}),define(Ne[188],Le([1,0,9,11,172,26]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zrc=void 0;let A=class extends P.$JR{constructor(p,o,I){const y=I.remote.isRemote?"remoteexthost":p?"workerexthost":"exthost",a=I.remote.isRemote?(0,v.localize)(10819,null):p?(0,v.localize)(10820,null):(0,v.localize)(10821,null);super(o.createLogger(y,{name:a}))}};e.$zrc=A,e.$zrc=A=Je([Ve(1,R.$ak),Ve(2,O.$zQ)],A)}),define(Ne[189],Le([1,0,10]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0pc=e.$9pc=void 0;class R{constructor(A,T,p){this.h=new Map,this.a=A,this.b=T,this.c=p,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(o=>(this.f=o,this)),this.g=this.c.onDidChangeStorage(o=>{o.shared===this.b&&o.key===this.a&&(this.f=o.value)}),this.i=new v.$Qh(()=>{const o=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const I of o.values())I.complete()}catch(I){for(const y of o.values())y.error(I)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,T){let p=this.f[A];return typeof p>"u"&&(p=T),p}update(A,T){this.f[A]=T;const p=this.h.get(A);if(p!==void 0)return p.p;const o=new v.$2h;return this.h.set(A,o),this.i.isScheduled()||this.i.schedule(),o.p}dispose(){this.g.dispose()}}e.$9pc=R;class P extends R{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,T){super(A.identifier.value,!0,T),this.j=A}}e.$0pc=P}),define(Ne[190],Le([1,0,6,2]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4qc=void 0;class P{constructor(A){this.c=A,this.a=new v.$le,this.onDidSaveNotebookDocument=this.a.event,this.b=new v.$le,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,T,p,o){const y=this.c.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(T.value,p,o);this.b.fire(y)}$acceptDirtyStateChanged(A,T){this.c.getNotebookDocument(R.URI.revive(A)).acceptDirty(T)}$acceptModelSaved(A){const T=this.c.getNotebookDocument(R.URI.revive(A));this.a.fire(T.apiNotebook)}}e.$4qc=P}),define(Ne[16],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=e.$jQ=void 0,e.$jQ=(0,v.$Ei)("IExtHostRpcService");class R{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$kQ=R}),define(Ne[191],Le([1,0,18,6,4]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gqc=void 0;class O{#e;constructor(T,p){this.disposables=new P.$Tc,this.a=v.$qn.toKey(T.identifier),this.#e=p,this.onDidChange=R.Event.map(R.Event.filter(this.#e.onDidChangePassword,o=>o.extensionId===this.a),o=>({key:o.key}),this.disposables)}dispose(){this.disposables.dispose()}get(T){return this.#e.get(this.a,T)}store(T,p){return this.#e.store(this.a,T,p)}delete(T){return this.#e.delete(this.a,T)}}e.$gqc=O}),define(Ne[65],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hpc=e.$Gpc=void 0,e.$Gpc=(0,v.$Ei)("IURITransformerService");class R{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Hpc=R});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[114],Le([1,0,9,14,2,4,3,30,29,15,42,164,35]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$pG=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$fG=e.EditorInputCapabilities=e.$eG=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=void 0,e.$8F=r,e.$9F=s,e.$0F=c,e.$$F=l,e.$_F=i,e.$aG=n,e.$bG=t,e.$cG=g,e.$dG=u,e.$gG=w,e.$hG=k,e.$iG=f,e.$jG=b,e.$kG=M,e.$lG=N,e.$mG=L,e.$nG=W,e.$oG=we,e.$qG=ce,e.$rG=oe,e.$sG=ke,e.$tG=Te,a=xt(a),e.$3F={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$4F={id:"default",displayName:(0,v.localize)(12462,null),providerDisplayName:(0,v.localize)(12463,null)},e.$5F="workbench.editor.sidebysideEditor",e.$6F="workbench.editors.textDiffEditor",e.$7F="workbench.editors.binaryResourceDiffEditor";var S;(function(Z){Z[Z.PROGRAMMATIC=1]="PROGRAMMATIC",Z[Z.USER=2]="USER",Z[Z.EDIT=3]="EDIT",Z[Z.NAVIGATION=4]="NAVIGATION",Z[Z.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var d;(function(Z){Z[Z.IDENTICAL=1]="IDENTICAL",Z[Z.SIMILAR=2]="SIMILAR",Z[Z.DIFFERENT=3]="DIFFERENT"})(d||(e.EditorPaneSelectionCompareResult=d={}));function r(Z){const B=Z;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}function s(Z){const B=Z;return!!B&&typeof B.getScrollPosition=="function"&&typeof B.setScrollPosition=="function"&&!!B.onDidChangeScroll}function c(Z,B,ne){for(const Ee of ne.visibleEditorPanes)if(Ee.group.id===B&&Z.matches(Ee.input))return Ee.getViewState()}function l(Z){if(w(Z))return!1;const B=Z;return P.URI.isUri(B?.resource)}function i(Z){if(w(Z))return!1;const B=Z;return B?.original!==void 0&&B.modified!==void 0}function n(Z){if(w(Z))return!1;const B=Z;return!B||B.resources&&!Array.isArray(B.resources)?!1:!!B.resources||!!B.multiDiffSource}function t(Z){if(w(Z)||i(Z))return!1;const B=Z;return B?.primary!==void 0&&B.secondary!==void 0}function g(Z){if(w(Z))return!1;const B=Z;return B?B.resource===void 0||B.resource.scheme===o.Schemas.untitled||B.forceUntitled===!0:!1}function u(Z){if(w(Z))return!1;const B=Z;return P.URI.isUri(B?.base?.resource)&&P.URI.isUri(B?.input1?.resource)&&P.URI.isUri(B?.input2?.resource)&&P.URI.isUri(B?.result?.resource)}var $;(function(Z){Z[Z.SHORT=0]="SHORT",Z[Z.MEDIUM=1]="MEDIUM",Z[Z.LONG=2]="LONG"})($||(e.Verbosity=$={}));var m;(function(Z){Z[Z.EXPLICIT=1]="EXPLICIT",Z[Z.AUTO=2]="AUTO",Z[Z.FOCUS_CHANGE=3]="FOCUS_CHANGE",Z[Z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(m||(e.SaveReason=m={}));class h{constructor(){this.a=new Map}registerSource(B,ne){let Ee=this.a.get(B);return Ee||(Ee={source:B,label:ne},this.a.set(B,Ee)),Ee.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.$eG=new h;var E;(function(Z){Z[Z.None=0]="None",Z[Z.Readonly=2]="Readonly",Z[Z.Untitled=4]="Untitled",Z[Z.Singleton=8]="Singleton",Z[Z.RequiresTrust=16]="RequiresTrust",Z[Z.CanSplitInGroup=32]="CanSplitInGroup",Z[Z.ForceDescription=64]="ForceDescription",Z[Z.CanDropIntoEditor=128]="CanDropIntoEditor",Z[Z.MultipleEditors=256]="MultipleEditors",Z[Z.Scratchpad=512]="Scratchpad"})(E||(e.EditorInputCapabilities=E={}));class D extends O.$Uc{}e.$fG=D;function w(Z){return Z instanceof D}function C(Z){const B=Z;return P.URI.isUri(B?.preferredResource)}function k(Z){const B=Z;return w(B?.primary)&&w(B?.secondary)}function f(Z){const B=Z;return w(B?.modified)&&w(B?.original)}function b(Z,B,ne,Ee,fe){return Te(Ee,[(0,y.$oj)({id:"workbench.action.openLargeFile",label:(0,v.localize)(12464,null),run:()=>{const be={...ne,limits:{size:Number.MAX_VALUE}};Z.openEditor(B,be)}}),(0,y.$oj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,v.localize)(12465,null),run:()=>fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:a.default.Warning})}function M(Z){return w(Z?.editor)}function N(Z){const B=Z;return M(Z)&&B?.group!==void 0}function L(Z){const B=Z;return typeof B?.groupId=="number"&&w(B.editor)}function W(Z){return typeof Z?.groupId=="number"}var K;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.REPLACE=1]="REPLACE",Z[Z.MOVE=2]="MOVE",Z[Z.UNPIN=3]="UNPIN"})(K||(e.EditorCloseContext=K={}));var q;(function(Z){Z[Z.GROUP_ACTIVE=0]="GROUP_ACTIVE",Z[Z.GROUP_INDEX=1]="GROUP_INDEX",Z[Z.GROUP_LABEL=2]="GROUP_LABEL",Z[Z.GROUP_LOCKED=3]="GROUP_LOCKED",Z[Z.EDITORS_SELECTION=4]="EDITORS_SELECTION",Z[Z.EDITOR_OPEN=5]="EDITOR_OPEN",Z[Z.EDITOR_CLOSE=6]="EDITOR_CLOSE",Z[Z.EDITOR_MOVE=7]="EDITOR_MOVE",Z[Z.EDITOR_ACTIVE=8]="EDITOR_ACTIVE",Z[Z.EDITOR_LABEL=9]="EDITOR_LABEL",Z[Z.EDITOR_CAPABILITIES=10]="EDITOR_CAPABILITIES",Z[Z.EDITOR_PIN=11]="EDITOR_PIN",Z[Z.EDITOR_TRANSIENT=12]="EDITOR_TRANSIENT",Z[Z.EDITOR_STICKY=13]="EDITOR_STICKY",Z[Z.EDITOR_DIRTY=14]="EDITOR_DIRTY",Z[Z.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(q||(e.GroupModelChangeKind=q={}));var G;(function(Z){Z[Z.PRIMARY=1]="PRIMARY",Z[Z.SECONDARY=2]="SECONDARY",Z[Z.BOTH=3]="BOTH",Z[Z.ANY=4]="ANY"})(G||(e.SideBySideEditor=G={}));class Q{getOriginalUri(B,ne){if(!B)return;if(u(B))return e.$pG.getOriginalUri(B.result,ne);if(ne?.supportSideBySide){const{primary:fe,secondary:be}=this.a(B);if(fe&&be){if(ne?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(fe,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(be,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===G.ANY)return this.getOriginalUri(fe,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(be,{filterByScheme:ne.filterByScheme});B=ne.supportSideBySide===G.PRIMARY?fe:be}}if(i(B)||n(B)||t(B)||u(B))return;const Ee=C(B)?B.preferredResource:B.resource;return!Ee||!ne||!ne.filterByScheme?Ee:this.b(Ee,ne.filterByScheme)}a(B){return k(B)||t(B)?{primary:B.primary,secondary:B.secondary}:f(B)||i(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,ne){if(!B)return;if(u(B))return e.$pG.getCanonicalUri(B.result,ne);if(ne?.supportSideBySide){const{primary:fe,secondary:be}=this.a(B);if(fe&&be){if(ne?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(fe,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(be,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===G.ANY)return this.getCanonicalUri(fe,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(be,{filterByScheme:ne.filterByScheme});B=ne.supportSideBySide===G.PRIMARY?fe:be}}if(i(B)||n(B)||t(B)||u(B))return;const Ee=B.resource;return!Ee||!ne||!ne.filterByScheme?Ee:this.b(Ee,ne.filterByScheme)}b(B,ne){if(Array.isArray(ne)){if(ne.some(Ee=>B.scheme===Ee))return B}else if(ne===B.scheme)return B}}var ae;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.KEYBOARD=1]="KEYBOARD",Z[Z.MOUSE=2]="MOUSE"})(ae||(e.EditorCloseMethod=ae={}));function we(Z,B,ne,Ee){if(!Z.isSticky(B))return!1;switch(Ee.preventPinnedEditorClose){case"keyboardAndMouse":return ne===ae.MOUSE||ne===ae.KEYBOARD;case"mouse":return ne===ae.MOUSE;case"keyboard":return ne===ae.KEYBOARD}return!1}e.$pG=new Q;var le;(function(Z){Z[Z.LEFT=0]="LEFT",Z[Z.RIGHT=1]="RIGHT"})(le||(e.CloseDirection=le={}));class _{constructor(){this.c=new Map,this.d=new Map}start(B){const ne=this.a=B.get(A.$Di);for(const[Ee,fe]of this.c)this.e(Ee,fe,ne);this.c.clear()}e(B,ne,Ee){const fe=Ee.createInstance(ne);this.d.set(B,fe)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,R.$pg)(this.b)}registerEditorSerializer(B,ne){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,ne,this.a):this.c.set(B,ne),(0,O.$Sc)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}T.$qo.add(e.$3F.EditorFactory,new _);async function ce(Z,B,ne){return!Z||!Z.length?[]:await Promise.all(Z.map(async Ee=>{const fe=P.URI.revive(Ee.fileUri);if(!fe){ne.info("Cannot resolve the path because it is not valid.",Ee);return}if(!await B.canHandleResource(fe)){ne.info("Cannot resolve the path because it cannot be handled",Ee);return}let he=Ee.exists,X=Ee.type;if(typeof he!="boolean"||typeof X!="number")try{X=(await B.stat(fe)).isDirectory?p.FileType.Directory:p.FileType.Unknown,he=!0}catch($e){ne.error($e),he=!1}if(!he&&Ee.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",Ee);return}if(X===p.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",Ee);return}const x={...Ee.options,pinned:!0};return he?{resource:fe,options:x}:{resource:fe,options:x,forceUntitled:!0}}))}var me;(function(Z){Z[Z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Z[Z.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function oe(Z){const B=Z;if(!B)return!1;const ne=B;if(ne.modified)return oe(ne.modified);const Ee=B;return!!(Ee.contributionsState&&Ee.viewState&&Array.isArray(Ee.cursorState))}function ke(Z){return(0,I.$qj)(Z)}function Te(Z,B,ne){const Ee=(0,I.$rj)(Z,B);return Ee.forceMessage=ne?.forceMessage,Ee.forceSeverity=ne?.forceSeverity,Ee.allowDialog=ne?.allowDialog,Ee}}),define(Ne[192],Le([1,0,6,9,3,4,28,30,25,97,182]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BG=e.$AG=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$zG=e.ViewContentGroups=e.$xG=e.ViewContainerLocation=e.Extensions=e.$wG=e.$vG=e.$uG=void 0,e.$yG=S,e.$uG="views",e.$vG=(0,R.localize)(12302,null),e.$wG=(0,I.$Ax)("default-view-icon",o.$4j.window,(0,R.localize)(12303,null));var y;(function(g){g.ViewContainersRegistry="workbench.registry.view.containers",g.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var a;(function(g){g[g.Sidebar=0]="Sidebar",g[g.Panel=1]="Panel",g[g.AuxiliaryBar=2]="AuxiliaryBar"})(a||(e.ViewContainerLocation=a={})),e.$xG=[a.Sidebar,a.Panel,a.AuxiliaryBar];function S(g){switch(g){case a.Sidebar:return"sidebar";case a.Panel:return"panel";case a.AuxiliaryBar:return"auxiliarybar"}}class d extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new v.$le),this.onDidRegister=this.c.event,this.f=this.B(new v.$le),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(u,$,m){const h=this.get(u.id);if(h)return h;const E=u;return E.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:E.openCommandActionDescriptor??{id:E.id},(0,A.$xc)(this.g,$,[]).push(E),m?.isDefault&&this.h.push(E),this.c.fire({viewContainer:E,viewContainerLocation:$}),E}deregisterViewContainer(u){for(const $ of this.g.keys()){const m=this.g.get($),h=m?.indexOf(u);if(h!==-1){m?.splice(h,1),m.length===0&&this.g.delete($),this.f.fire({viewContainer:u,viewContainerLocation:$});return}}}get(u){return this.all.filter($=>$.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter($=>this.getViewContainers($).filter(m=>m?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find($=>this.getViewContainerLocation($)===u)}}T.$qo.add(y.ViewContainersRegistry,new d);var r;(function(g){g.Open="2_open",g.Debug="4_debug",g.SCM="5_scm",g.More="9_more"})(r||(e.ViewContentGroups=r={}));function s(g,u){const $=g.group??r.More,m=u.group??r.More;return $!==m?$.localeCompare(m):(g.order??5)-(u.order??5)}class c extends O.$Uc{constructor(){super(...arguments),this.c=this.B(new v.$le),this.onViewsRegistered=this.c.event,this.f=this.B(new v.$le),this.onViewsDeregistered=this.f.event,this.g=this.B(new v.$le),this.onDidChangeContainer=this.g.event,this.h=this.B(new v.$le),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(u,$){this.registerViews2([{views:u,viewContainer:$}])}registerViews2(u){u.forEach(({views:$,viewContainer:m})=>this.r($,m)),this.c.fire(u)}deregisterViews(u,$){const m=this.s(u,$);m.length&&this.f.fire({views:m,viewContainer:$})}moveViews(u,$){for(const m of this.m.keys())if(m!==$){const h=this.s(u,m);h.length&&(this.r(h,$),this.g.fire({views:h,from:m,to:$}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const $ of this.j){const m=(this.m.get($)||[]).filter(h=>h.id===u)[0];if(m)return m}return null}getViewContainer(u){for(const $ of this.j)if((this.m.get($)||[]).filter(h=>h.id===u)[0])return $;return null}registerViewWelcomeContent(u,$){return this.n.add(u,$),this.h.fire(u),(0,O.$Sc)(()=>{this.n.delete(u,$),this.h.fire(u)})}registerViewWelcomeContent2(u,$){const m=new Map;for(const[h,E]of $)this.n.add(u,E),m.set(h,(0,O.$Sc)(()=>{this.n.delete(u,E),this.h.fire(u)}));return this.h.fire(u),m}getViewWelcomeContent(u){const $=[];return this.n.forEach(u,m=>$.push(m)),$.sort(s)}r(u,$){let m=this.m.get($);m||(m=[],this.m.set($,m),this.j.push($));for(const h of u){if(this.getView(h.id)!==null)throw new Error((0,R.localize)(12304,null,h.id));m.push(h)}}s(u,$){const m=this.m.get($);if(!m)return[];const h=[],E=[];for(const D of m)u.includes(D)?h.push(D):E.push(D);return h.length&&(E.length?this.m.set($,E):(this.m.delete($),this.j.splice(this.j.indexOf($),1))),h}}T.$qo.add(y.ViewsRegistry,new c),e.$zG=(0,P.$Ei)("viewDescriptorService");var l;(function(g){g[g.Default=0]="Default",g[g.Expand=1]="Expand"})(l||(e.ViewVisibilityState=l={}));var i;(function(g){g[g.None=0]="None",g[g.Collapsed=1]="Collapsed",g[g.Expanded=2]="Expanded"})(i||(e.TreeItemCollapsibleState=i={}));class n{constructor(u,$){this.c=!1,this.d=!1,(0,p.$go)(this,u),this.d=!!$,this.resolve=async m=>{if($&&!this.c){const h=await $(m);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$AG=n;class t extends Error{constructor(u){super((0,R.localize)(12305,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$BG=t}),define(Ne[193],Le([1,0,9,31]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=void 0,e.$FG=new R.$Vj("chatSessionResponseVote","",{type:"string",description:(0,v.localize)(8425,null)}),e.$GG=new R.$Vj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,v.localize)(8426,null)}),e.$HG=new R.$Vj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,v.localize)(8427,null)}),e.$IG=new R.$Vj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,v.localize)(8428,null)}),e.$JG=new R.$Vj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,v.localize)(8429,null)}),e.$KG=new R.$Vj("chatResponse",!1,{type:"boolean",description:(0,v.localize)(8430,null)}),e.$LG=new R.$Vj("chatRequest",!1,{type:"boolean",description:(0,v.localize)(8431,null)}),e.$MG=new R.$Vj("chatEditApplied",!1,{type:"boolean",description:(0,v.localize)(8432,null)}),e.$NG=new R.$Vj("chatInputHasText",!1,{type:"boolean",description:(0,v.localize)(8433,null)}),e.$OG=new R.$Vj("chatInputHasFocus",!1,{type:"boolean",description:(0,v.localize)(8434,null)}),e.$PG=new R.$Vj("inChatInput",!1,{type:"boolean",description:(0,v.localize)(8435,null)}),e.$QG=new R.$Vj("inChat",!1,{type:"boolean",description:(0,v.localize)(8436,null)}),e.$RG=new R.$Vj("chatIsEnabled",!1,{type:"boolean",description:(0,v.localize)(8437,null)}),e.$SG=new R.$Vj("chatCursorAtTop",!1),e.$TG=new R.$Vj("chatInputHasAgent",!1),e.$UG=new R.$Vj("chatLocation",void 0),e.$VG=new R.$Vj("quickChatHasFocus",!1,{type:"boolean",description:(0,v.localize)(8438,null)})}),define(Ne[115],Le([1,0,283,10,21,6,40,4,36,143,12,31,18,3,11,108,176,187,193]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.ChatAgentLocation=void 0,e.$1H=$,e.$2H=m;var n;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(h){function E(D){switch(D){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=E}(n||(e.ChatAgentLocation=n={})),e.$VH=(0,S.$Ei)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(E){this.f=E,this.b=new Map,this.d=new O.$le,this.onDidChangeAgents=this.d.event,this.g=new Map,this.e=l.$RG.bindTo(this.f)}registerAgent(E,D){if(this.getAgent(E))throw new Error(`Agent already registered: ${JSON.stringify(E)}`);const C=this,k=D.slashCommands;D={...D,get slashCommands(){return k.filter(b=>!b.when||C.f.contextMatchesRules(y.$Cj.deserialize(b.when)))}};const f={data:D};return this.b.set(E,f),(0,T.$Sc)(()=>{this.b.delete(E),this.d.fire(void 0)})}registerAgentImplementation(E,D){const w=this.b.get(E);if(!w)throw new Error(`Unknown agent: ${JSON.stringify(E)}`);if(w.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(E)}`);return w.data.isDefault&&this.e.set(!0),w.impl=D,this.d.fire(new g(w.data,D)),(0,T.$Sc)(()=>{w.impl=void 0,this.d.fire(void 0),w.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(E,D){E.isDynamic=!0;const w={data:E,impl:D};return this.b.set(E.id,w),this.d.fire(new g(E,D)),(0,T.$Sc)(()=>{this.b.delete(E.id),this.d.fire(void 0)})}registerAgentCompletionProvider(E,D){return this.g.set(E,D),{dispose:()=>{this.g.delete(E)}}}async getAgentCompletionItems(E,D,w){return await this.g.get(E)?.(D,w)??[]}updateAgent(E,D){const w=this.b.get(E);if(!w?.impl)throw new Error(`No activated agent with id ${JSON.stringify(E)} registered`);w.data.metadata={...w.data.metadata,...D},this.d.fire(new g(w.data,w.impl))}getDefaultAgent(E){return(0,v.$eb)(this.getActivatedAgents(),D=>!!D.isDefault&&D.locations.includes(E))}getContributedDefaultAgent(E){return this.getAgents().find(D=>!!D.isDefault&&D.locations.includes(E))}getSecondaryAgent(){return A.Iterable.find(this.b.values(),E=>!!E.data.metadata.isSecondary)?.data}getAgent(E){if(this.h(E))return this.b.get(E)?.data}h(E){const D=this.b.get(E);return!D?.data.when||this.f.contextMatchesRules(y.$Cj.deserialize(D.data.when))}getAgentByFullyQualifiedId(E){const D=A.Iterable.find(this.b.values(),w=>$(w.data)===E)?.data;if(!(D&&!this.h(D.id)))return D}getAgents(){return Array.from(this.b.values()).map(E=>E.data).filter(E=>this.h(E.id))}getActivatedAgents(){return Array.from(this.b.values()).filter(E=>!!E.impl).filter(E=>this.h(E.data.id)).map(E=>new g(E.data,E.impl))}getAgentsByName(E){return this.getAgents().filter(D=>D.name===E)}agentHasDupeName(E){const D=this.getAgent(E);return D?this.getAgentsByName(D.name).filter(w=>w.extensionId.value!==D.extensionId.value).length>0:!1}async invokeAgent(E,D,w,C,k){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return await f.impl.invoke(D,w,C,k)}async getFollowups(E,D,w,C,k){const f=this.b.get(E);if(!f?.impl)throw new Error(`No activated agent with id "${E}"`);return f.impl?.provideFollowups?f.impl.provideFollowups(D,w,C,k):[]}};e.$WH=t,e.$WH=t=Je([Ve(0,y.$Wj)],t);class g{constructor(E,D){this.b=E,this.d=D}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get locations(){return this.b.locations}async invoke(E,D,w,C){return this.d.invoke(E,D,w,C)}async provideFollowups(E,D,w,C){return this.d.provideFollowups?this.d.provideFollowups(E,D,w,C):[]}provideWelcomeMessage(E,D){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(E,D)}provideSampleQuestions(E,D){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(E,D)}}e.$XH=g,e.$YH=(0,S.$Ei)("chatAgentNameService");let u=class{static{i=this}static{this.b="chat.participantNameRegistry"}constructor(E,D,w,C){if(this.g=D,this.h=w,this.i=C,this.e=(0,o.$6d)(this,Object.create(null)),this.f=!1,!E.chatParticipantRegistry)return;this.d=E.chatParticipantRegistry;const k=C.get(i.b,c.StorageScope.APPLICATION);try{this.e.set(JSON.parse(k??"{}"),void 0)}catch{C.remove(i.b,c.StorageScope.APPLICATION)}this.j()}j(){this.f||this.k().catch(E=>this.h.warn("Failed to fetch chat participant registry",E)).then(()=>(0,R.$Fh)(5*60*1e3)).then(()=>this.j())}async k(){const E=await this.g.request({type:"GET",url:this.d},P.CancellationToken.None);if(E.res.statusCode!==200)throw new Error("Could not get extensions report.");const D=await(0,s.$aq)(E);if(!D||D.version!==1)throw new Error("Unexpected chat participant registry response.");const w=D.restrictedChatParticipants;this.e.set(w,void 0),this.i.store(i.b,JSON.stringify(w),c.StorageScope.APPLICATION,c.StorageTarget.MACHINE)}getAgentNameRestriction(E){const D=this.l(E.name,E).get(),w=!E.fullName||this.l(E.fullName.replace(/\s/g,""),E).get();return D&&w}l(E,D){return this.e.map(C=>C[E.toLowerCase()]).map(C=>C?C.some(k=>(0,I.$Ff)(k,k.includes(".")?D.extensionId.value:D.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$ZH=u,e.$ZH=u=i=Je([Ve(0,r.$sk),Ve(1,s.$7p),Ve(2,d.$_j),Ve(3,c.$hq)],u);function $(h){return`${h.extensionId.value}.${h.id}`}function m(h){const E="name"in h?h:{...h,name:h.id};return"extensionPublisherId"in E||(E.extensionPublisherId=E.extensionPublisher??""),"extensionDisplayName"in E||(E.extensionDisplayName=""),"extensionId"in E||(E.extensionId=new a.$qn("")),(0,p.$bi)(E)}}),define(Ne[194],Le([1,0,2,32,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tH=e.$sH=e.ChatCopyKind=e.ChatAgentVoteDirection=e.ChatResponseReferencePartStatusKind=void 0,e.$qH=O,e.$rH=A;function O(I){return!!I&&typeof I=="object"&&"uri"in I&&I.uri instanceof v.URI&&"version"in I&&typeof I.version=="number"&&"ranges"in I&&Array.isArray(I.ranges)&&I.ranges.every(R.$Nt.isIRange)}function A(I){return!!I&&typeof I=="object"&&"documents"in I&&Array.isArray(I.documents)&&I.documents.every(O)}var T;(function(I){I[I.Complete=1]="Complete",I[I.Partial=2]="Partial",I[I.Omitted=3]="Omitted"})(T||(e.ChatResponseReferencePartStatusKind=T={}));var p;(function(I){I[I.Down=0]="Down",I[I.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var o;(function(I){I[I.Action=1]="Action",I[I.Toolbar=2]="Toolbar"})(o||(e.ChatCopyKind=o={})),e.$sH=(0,P.$Ei)("IChatService"),e.$tH="accessibility.voice.keywordActivation"}),define(Ne[195],Le([1,0,6,10,9]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7tb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new v.$le,this.o=new v.$le,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(T){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=T}onEvent(T){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=T}onRequest(T){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=T}sendResponse(T){T.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.u("response",T)}sendRequest(T,p,o,I){const y={command:T};if(p&&Object.keys(p).length>0&&(y.arguments=p),this.u("request",y),typeof I=="number"){const a=setTimeout(()=>{clearTimeout(a);const S=this.f.get(y.seq);if(S){this.f.delete(y.seq);const d={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,P.localize)(7518,null,I,T)};S(d)}},I)}return o&&this.f.set(y.seq,o),y.seq}acceptMessage(T){this.k?this.k(T):(this.m.push(T),this.m.length===1&&this.s())}q(T,p){return T.type!=="event"||p.type!=="event"}async s(){let T;for(;this.m.length;){if((!T||this.q(this.m[0],T))&&await(0,R.$Fh)(0),T=this.m.shift(),!T)return;switch(T.type){case"event":this.j?.(T);break;case"request":this.g?.(T);break;case"response":{const p=T,o=this.f.get(p.request_seq);o&&(this.f.delete(p.request_seq),o(p));break}}}}u(T,p){p.type=T,p.seq=this.d++,this.sendMessage(p)}async w(){if(this.f.size===0)return Promise.resolve();const T=new Map;this.f.forEach((p,o)=>T.set(o,p)),await(0,R.$Fh)(500),T.forEach((p,o)=>{p({type:"response",seq:0,request_seq:o,success:!1,command:"canceled",message:"canceled"}),this.f.delete(o)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$7tb=O}),define(Ne[80],Le([1,0,2,9,31,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$OK=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$MK=e.MemoryRangeType=e.State=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=e.$kK=e.$jK=e.$iK=e.$hK=e.$gK=e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=e.$aK=e.$_J=e.$$J=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.$5J=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=void 0,e.$LK=p,e.$NK=I,R=We(R),e.$zJ="workbench.view.debug",e.$AJ="workbench.debug.variablesView",e.$BJ="workbench.debug.watchExpressionsView",e.$CJ="workbench.debug.callStackView",e.$DJ="workbench.debug.loadedScriptsView",e.$EJ="workbench.debug.breakPointsView",e.$FJ="workbench.debug.disassemblyView",e.$GJ="workbench.panel.repl",e.$HJ="workbench.panel.repl.view",e.$IJ=new P.$Vj("debugType",void 0,{type:"string",description:R.localize(7455,null)}),e.$JJ=new P.$Vj("debugConfigurationType",void 0,{type:"string",description:R.localize(7456,null)}),e.$KJ=new P.$Vj("debugState","inactive",{type:"string",description:R.localize(7457,null)}),e.$LJ="debugUx",e.$MJ=new P.$Vj(e.$LJ,"default",{type:"string",description:R.localize(7458,null)}),e.$NJ=new P.$Vj("hasDebugged",!1,{type:"boolean",description:R.localize(7459,null)}),e.$OJ=new P.$Vj("inDebugMode",!1,{type:"boolean",description:R.localize(7460,null)}),e.$PJ=new P.$Vj("inDebugRepl",!1,{type:"boolean",description:R.localize(7461,null)}),e.$QJ=new P.$Vj("breakpointWidgetVisible",!1,{type:"boolean",description:R.localize(7462,null)}),e.$RJ=new P.$Vj("inBreakpointWidget",!1,{type:"boolean",description:R.localize(7463,null)}),e.$SJ=new P.$Vj("breakpointsFocused",!0,{type:"boolean",description:R.localize(7464,null)}),e.$TJ=new P.$Vj("watchExpressionsFocused",!0,{type:"boolean",description:R.localize(7465,null)}),e.$UJ=new P.$Vj("watchExpressionsExist",!1,{type:"boolean",description:R.localize(7466,null)}),e.$VJ=new P.$Vj("variablesFocused",!0,{type:"boolean",description:R.localize(7467,null)}),e.$WJ=new P.$Vj("expressionSelected",!1,{type:"boolean",description:R.localize(7468,null)}),e.$XJ=new P.$Vj("breakpointInputFocused",!1,{type:"boolean",description:R.localize(7469,null)}),e.$YJ=new P.$Vj("callStackItemType",void 0,{type:"string",description:R.localize(7470,null)}),e.$ZJ=new P.$Vj("callStackSessionIsAttach",!1,{type:"boolean",description:R.localize(7471,null)}),e.$1J=new P.$Vj("callStackItemStopped",!1,{type:"boolean",description:R.localize(7472,null)}),e.$2J=new P.$Vj("callStackSessionHasOneThread",!1,{type:"boolean",description:R.localize(7473,null)}),e.$3J=new P.$Vj("watchItemType",void 0,{type:"string",description:R.localize(7474,null)}),e.$4J=new P.$Vj("canViewMemory",void 0,{type:"boolean",description:R.localize(7475,null)}),e.$5J=new P.$Vj("breakpointItemType",void 0,{type:"string",description:R.localize(7476,null)}),e.$6J=new P.$Vj("breakpointItemBytes",void 0,{type:"boolean",description:R.localize(7477,null)}),e.$7J=new P.$Vj("breakpointHasModes",!1,{type:"boolean",description:R.localize(7478,null)}),e.$8J=new P.$Vj("breakpointSupportsCondition",!1,{type:"boolean",description:R.localize(7479,null)}),e.$9J=new P.$Vj("loadedScriptsSupported",!1,{type:"boolean",description:R.localize(7480,null)}),e.$0J=new P.$Vj("loadedScriptsItemType",void 0,{type:"string",description:R.localize(7481,null)}),e.$$J=new P.$Vj("focusedSessionIsAttach",!1,{type:"boolean",description:R.localize(7482,null)}),e.$_J=new P.$Vj("focusedSessionIsNoDebug",!1,{type:"boolean",description:R.localize(7483,null)}),e.$aK=new P.$Vj("stepBackSupported",!1,{type:"boolean",description:R.localize(7484,null)}),e.$bK=new P.$Vj("restartFrameSupported",!1,{type:"boolean",description:R.localize(7485,null)}),e.$cK=new P.$Vj("stackFrameSupportsRestart",!1,{type:"boolean",description:R.localize(7486,null)}),e.$dK=new P.$Vj("jumpToCursorSupported",!1,{type:"boolean",description:R.localize(7487,null)}),e.$eK=new P.$Vj("stepIntoTargetsSupported",!1,{type:"boolean",description:R.localize(7488,null)}),e.$fK=new P.$Vj("breakpointsExist",!1,{type:"boolean",description:R.localize(7489,null)}),e.$gK=new P.$Vj("debuggersAvailable",!1,{type:"boolean",description:R.localize(7490,null)}),e.$hK=new P.$Vj("debugExtensionAvailable",!0,{type:"boolean",description:R.localize(7491,null)}),e.$iK=new P.$Vj("debugProtocolVariableMenuContext",void 0,{type:"string",description:R.localize(7492,null)}),e.$jK=new P.$Vj("debugSetVariableSupported",!1,{type:"boolean",description:R.localize(7493,null)}),e.$kK=new P.$Vj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:R.localize(7494,null)}),e.$lK=new P.$Vj("debugSetExpressionSupported",!1,{type:"boolean",description:R.localize(7495,null)}),e.$mK=new P.$Vj("breakWhenValueChangesSupported",!1,{type:"boolean",description:R.localize(7496,null)}),e.$nK=new P.$Vj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:R.localize(7497,null)}),e.$oK=new P.$Vj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:R.localize(7498,null)}),e.$pK=new P.$Vj("terminateDebuggeeSupported",!1,{type:"boolean",description:R.localize(7499,null)}),e.$qK=new P.$Vj("suspendDebuggeeSupported",!1,{type:"boolean",description:R.localize(7500,null)}),e.$rK=new P.$Vj("variableEvaluateNamePresent",!1,{type:"boolean",description:R.localize(7501,null)}),e.$sK=new P.$Vj("variableIsReadonly",!1,{type:"boolean",description:R.localize(7502,null)}),e.$tK=new P.$Vj("variableValue",!1,{type:"string",description:R.localize(7503,null)}),e.$uK=new P.$Vj("variableType",!1,{type:"string",description:R.localize(7504,null)}),e.$vK=new P.$Vj("variableInterfaces",!1,{type:"array",description:R.localize(7505,null)}),e.$wK=new P.$Vj("variableName",!1,{type:"string",description:R.localize(7506,null)}),e.$xK=new P.$Vj("variableLanguage",!1,{type:"string",description:R.localize(7507,null)}),e.$yK=new P.$Vj("variableExtensionId",!1,{type:"string",description:R.localize(7508,null)}),e.$zK=new P.$Vj("exceptionWidgetVisible",!1,{type:"boolean",description:R.localize(7509,null)}),e.$AK=new P.$Vj("multiSessionRepl",!1,{type:"boolean",description:R.localize(7510,null)}),e.$BK=new P.$Vj("multiSessionDebug",!1,{type:"boolean",description:R.localize(7511,null)}),e.$CK=new P.$Vj("disassembleRequestSupported",!1,{type:"boolean",description:R.localize(7512,null)}),e.$DK=new P.$Vj("disassemblyViewFocus",!1,{type:"boolean",description:R.localize(7513,null)}),e.$EK=new P.$Vj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:R.localize(7514,null)}),e.$FK=new P.$Vj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:R.localize(7515,null)});const A=i=>R.localize(7516,null,i);e.$GK=A,e.$HK="editor.contrib.debug",e.$IK="editor.contrib.breakpoint",e.$JK="debug",e.$KK={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:R.localize(7517,null)};var T;(function(i){i[i.Inactive=0]="Inactive",i[i.Initializing=1]="Initializing",i[i.Stopped=2]="Stopped",i[i.Running=3]="Running"})(T||(e.State=T={}));function p(i){switch(i){case T.Initializing:return"initializing";case T.Stopped:return"stopped";case T.Running:return"running";default:return"inactive"}}var o;(function(i){i[i.Valid=0]="Valid",i[i.Unreadable=1]="Unreadable",i[i.Error=2]="Error"})(o||(e.MemoryRangeType=o={})),e.$MK="vscode-debug-memory";function I(i){const n=i.presentationHint??i.source.presentationHint;return n==="deemphasize"||n==="subtle"}var y;(function(i){i[i.Variable=0]="Variable",i[i.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var a;(function(i){i[i.Initial=1]="Initial",i[i.Dynamic=2]="Dynamic"})(a||(e.DebugConfigurationProviderTriggerKind=a={}));var S;(function(i){i.UnverifiedBreakpoints="unverifiedBreakpoints"})(S||(e.DebuggerString=S={})),e.$OK=(0,O.$Ei)("debugService");var d;(function(i){i[i.CONDITION=0]="CONDITION",i[i.HIT_COUNT=1]="HIT_COUNT",i[i.LOG_MESSAGE=2]="LOG_MESSAGE",i[i.TRIGGER_POINT=3]="TRIGGER_POINT"})(d||(e.BreakpointWidgetContext=d={}));var r;(function(i){i[i.Command=0]="Command",i[i.Tree=1]="Tree"})(r||(e.DebugVisualizationType=r={}));var s;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(s||(e.DebugTreeItemCollapsibleState=s={}));var c;(function(i){i.deserialize=n=>n,i.serialize=n=>n})(c||(e.IDebugVisualizationTreeItem=c={}));var l;(function(i){i.deserialize=n=>({id:n.id,name:n.name,iconPath:n.iconPath&&{light:v.URI.revive(n.iconPath.light),dark:v.URI.revive(n.iconPath.dark)},iconClass:n.iconClass,visualization:n.visualization}),i.serialize=n=>n})(l||(e.IDebugVisualization=l={}))}),define(Ne[196],Le([1,0,12,2,19,25,15,32,21,17]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gI=void 0,e.$7H=y,e.$8H=a,e.$9H=S,e.$0H=d,e.$$H=r,e.$_H=s,e.$aI=c,e.$bI=i,e.$cI=g,e.$dI=u,e.$eI=m,e.$fI=E;const I=/{([^}]+)}/g;function y(w,C,k){return w.replace(I,function(f,b){return C&&b.length>0&&b[0]!=="_"?f:k&&k.hasOwnProperty(b)?k[b]:f})}function a(w){const C={};for(const k of Object.keys(w))k.startsWith("!")||(C[k]=w[k]);return C}function S(w){return w.configuration.request==="attach"&&!d(w)&&(!w.parentSession||S(w.parentSession))}function d(w){let C=w.configuration.type;if(C)return C==="vslsShare"&&(C=w.configuration.adapterProxy.configuration.type),(0,v.$Ff)(C,"extensionhost")||(0,v.$Ff)(C,"pwa-extensionhost")?w:w.parentSession?d(w.parentSession):void 0}function r(w){return w.type&&(w.label||w.program||w.runtime)}function s(w,C,k){let f,b=0;const M=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let N=null;for(;N=M.exec(w);){const L=N.index+1,W=L+N[0].length;if(L<=C&&W>=k){f=N[0],b=L;break}}if(f){const L=/(\w|\p{L})+/gu;let W=null;for(;(W=L.exec(f))&&!(W.index+1+b+W[0].length>=k););W&&(f=f.substring(0,L.lastIndex))}return f?{start:b,end:b+f.length-1}:{start:0,end:0}}async function c(w,C,k,f){if(w.evaluatableExpressionProvider.has(C)){const b=w.evaluatableExpressionProvider.ordered(C),M=(0,o.$Gb)(await Promise.all(b.map(async N=>{try{return await N.provideEvaluatableExpression(C,k,f??p.CancellationToken.None)}catch{return}})));if(M.length>0){let N=M[0].expression;const L=M[0].range;return N||(N=C.getLineContent(k.lineNumber).substring(L.startColumn-1,L.endColumn-1)),{range:L,matchingExpression:N}}}else{const b=C.getLineContent(k.lineNumber),{start:M,end:N}=s(b,k.column,k.column),L=b.substring(M-1,N);return{matchingExpression:L,range:new T.$Nt(k.lineNumber,M,k.lineNumber,M+L.length)}}return null}const l=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function i(w){return!!(w&&w.match(l))}function n(w){if(typeof w.path=="string"&&!(typeof w.sourceReference=="number"&&w.sourceReference>0)){if(i(w.path))return R.URI.parse(w.path);if((0,P.$ic)(w.path))return R.URI.file(w.path)}return w.path}function t(w){if(typeof w.path=="object"){const C=R.URI.revive(w.path);if(C)return C.scheme===A.Schemas.file?C.fsPath:C.toString()}return w.path}function g(w,C){const k=C?n:t,f=(0,O.$do)(w);return $(f,(b,M)=>{b&&M&&(M.path=k(M))}),f}function u(w,C){const k=C?n:t,f=(0,O.$do)(w);return $(f,(b,M)=>{!b&&M&&(M.path=k(M))}),f}function $(w,C){switch(w.type){case"event":{const k=w;switch(k.event){case"output":C(!1,k.body.source);break;case"loadedSource":C(!1,k.body.source);break;case"breakpoint":C(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=w;switch(k.command){case"setBreakpoints":C(!0,k.arguments.source);break;case"breakpointLocations":C(!0,k.arguments.source);break;case"source":C(!0,k.arguments.source);break;case"gotoTargets":C(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(f=>C(!1,f));break;default:break}break}case"response":{const k=w;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(f=>C(!1,f.source));break;case"loadedSources":k.body.sources.forEach(f=>C(!1,f));break;case"scopes":k.body.scopes.forEach(f=>C(!1,f.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(f=>C(!1,f.source));break;case"setBreakpoints":k.body.breakpoints.forEach(f=>C(!1,f.source));break;case"disassemble":k.body?.instructions.forEach(b=>C(!1,b.location));break;default:break}break}}}function m(w){return w.filter(C=>!C.presentation?.hidden).sort((C,k)=>C.presentation?k.presentation?C.presentation.group?k.presentation.group?C.presentation.group!==k.presentation.group?C.presentation.group.localeCompare(k.presentation.group):h(C.presentation.order,k.presentation.order):-1:k.presentation.group?1:h(C.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function h(w,C){return typeof w!="number"?typeof C!="number"?0:1:typeof C!="number"?-1:w-C}async function E(w,C){const k=w.getValue("debug.saveBeforeStart",{overrideIdentifier:C.activeTextEditorLanguageId});if(k!=="none"&&(await C.saveAll(),k==="allEditorsInActiveGroup")){const f=C.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await C.save({editor:f.input,groupId:f.group.id})}await w.reloadConfiguration()}const D=(w,C)=>!w||!C?w===C:w.name===C.name&&w.path===C.path&&w.sourceReference===C.sourceReference;e.$gI=D}),define(Ne[197],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WK=e.CellExecutionUpdateType=void 0;var R;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.$WK=(0,v.$Ei)("INotebookExecutionService")}),define(Ne[198],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1K=e.$ZK=e.ProxyKernelState=e.$YK=void 0,e.$YK=100;var R;(function(P){P[P.Disconnected=1]="Disconnected",P[P.Connected=2]="Connected",P[P.Initializing=3]="Initializing"})(R||(e.ProxyKernelState=R={})),e.$ZK=(0,v.$Ei)("INotebookKernelService"),e.$1K=(0,v.$Ei)("INotebookKernelHistoryService")}),define(Ne[199],Le([1,0,4,32,52,162,102]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f1b=void 0;class T extends v.$Uc{constructor(o,I,y){super(),this._source=o,this.b=I,this.c=y,this.a=void 0}f(o){const I=o.getLineCount();return new R.$Nt(1,1,I,this.g(o,I))}g(o,I){if(I<1||I>o.getLineCount())throw new Error("Illegal value for lineNumber");return o.getLineLength(I)+1}get inputTextBuffer(){if(!this.b){const o=new O.$vD;o.acceptChunk(this._source);const I=o.finish(!0),{textBuffer:y,disposable:a}=I.create(P.DefaultEndOfLine.LF);this.b=y,this.B(a)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(o=>{const I=new O.$vD;I.acceptChunk(o);const y=I.finish(!0),{textBuffer:a,disposable:S}=y.create(P.DefaultEndOfLine.LF);return this.B(S),a})),this.a}findInInputs(o){const y=new A.$jD(o,!1,!1,null).parseSearchRequest();if(!y)return[];const a=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(a,y,!0,5e3)}findInOutputs(o){const y=new A.$jD(o,!1,!1,null).parseSearchRequest();return y?this.outputTextBuffers.map(a=>{const S=a.findMatchesLineByLine(this.f(a),y,!0,5e3);if(S.length!==0)return{textBuffer:a,matches:S}}).filter(a=>!!a):[]}}e.$f1b=T}),define(Ne[54],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6I=e.TestPosition=e.TestIdPathParts=void 0;var v;(function(O){O.Delimiter="\0"})(v||(e.TestIdPathParts=v={}));var R;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class P{static fromExtHostTestItem(A,T,p=A.parent){if(A._isRoot)return new P([T]);const o=[A.id];for(let I=p;I&&I.id!==T;I=I.parent)o.push(I.id);return o.push(T),new P(o.reverse())}static isRoot(A){return!A.includes(v.Delimiter)}static root(A){const T=A.indexOf(v.Delimiter);return T===-1?A:A.slice(0,T)}static fromString(A){return new P(A.split(v.Delimiter))}static join(A,T){return new P([...A.path,T])}static joinToString(A,T){return A.toString()+v.Delimiter+T}static parentId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?void 0:A.slice(0,T)}static localId(A){const T=A.lastIndexOf(v.Delimiter);return T===-1?A:A.slice(T+v.Delimiter.length)}static isChild(A,T){return T[A.length]===v.Delimiter&&T.startsWith(A)}static compare(A,T){return A===T?R.IsSame:P.isChild(A,T)?R.IsChild:P.isChild(T,A)?R.IsParent:R.Disconnected}static getLengthOfCommonPrefix(A,T){if(A===0)return 0;let p=0;for(;p<A-1;){for(let o=1;o<A;o++){const I=T(o-1),y=T(o);if(I.path[p]!==y.path[p])return p}p++}return p}constructor(A,T=A.length){if(this.path=A,this.d=T,A.length===0||T<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let T=0;T<A.d&&T<this.d;T++)if(A.path[T]!==this.path[T])return R.Disconnected;return A.d>this.d?R.IsChild:A.d<this.d?R.IsParent:R.IsSame}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+=v.Delimiter,this.c+=this.path[A]}return this.c}}e.$6I=P}),define(Ne[55],Le([1,0,2,101,32,54]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$bJ=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$aJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$_I=e.$$I=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$0I=e.ITestErrorMessage=e.ITestMessageStackFrame=e.TestMessageType=e.IRichLocation=e.$9I=e.$8I=e.TestRunProfileBitset=e.TestControllerCapability=e.ExtTestRunProfileKind=e.$7I=e.TestResultState=void 0;var A;(function(G){G[G.Unset=0]="Unset",G[G.Queued=1]="Queued",G[G.Running=2]="Running",G[G.Passed=3]="Passed",G[G.Failed=4]="Failed",G[G.Skipped=5]="Skipped",G[G.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$7I={[A.Unset]:"unset",[A.Queued]:"queued",[A.Running]:"running",[A.Passed]:"passed",[A.Failed]:"failed",[A.Skipped]:"skipped",[A.Errored]:"errored"};var T;(function(G){G[G.Run=1]="Run",G[G.Debug=2]="Debug",G[G.Coverage=3]="Coverage"})(T||(e.ExtTestRunProfileKind=T={}));var p;(function(G){G[G.Refresh=2]="Refresh",G[G.CodeRelatedToTest=4]="CodeRelatedToTest",G[G.TestRelatedToCode=8]="TestRelatedToCode"})(p||(e.TestControllerCapability=p={}));var o;(function(G){G[G.Run=2]="Run",G[G.Debug=4]="Debug",G[G.Coverage=8]="Coverage",G[G.HasNonDefaultProfile=16]="HasNonDefaultProfile",G[G.HasConfigurable=32]="HasConfigurable",G[G.SupportsContinuousRun=64]="SupportsContinuousRun"})(o||(e.TestRunProfileBitset=o={})),e.$8I=[o.Run,o.Debug,o.Coverage,o.HasNonDefaultProfile,o.HasConfigurable,o.SupportsContinuousRun];const I=G=>"runId"in G;e.$9I=I;var y;(function(G){G.serialize=Q=>({range:Q.range.toJSON(),uri:Q.uri.toJSON()}),G.deserialize=(Q,ae)=>({range:P.$Nt.lift(ae.range),uri:Q.asCanonicalUri(v.URI.revive(ae.uri))})})(y||(e.IRichLocation=y={}));var a;(function(G){G[G.Error=0]="Error",G[G.Output=1]="Output"})(a||(e.TestMessageType=a={}));var S;(function(G){G.serialize=Q=>({label:Q.label,uri:Q.uri?.toJSON(),position:Q.position?.toJSON()}),G.deserialize=(Q,ae)=>({label:ae.label,uri:ae.uri?Q.asCanonicalUri(v.URI.revive(ae.uri)):void 0,position:ae.position?R.$Mt.lift(ae.position):void 0})})(S||(e.ITestMessageStackFrame=S={}));var d;(function(G){G.serialize=Q=>({message:Q.message,type:a.Error,expected:Q.expected,actual:Q.actual,contextValue:Q.contextValue,location:Q.location&&y.serialize(Q.location),stackTrace:Q.stackTrace?.map(S.serialize)}),G.deserialize=(Q,ae)=>({message:ae.message,type:a.Error,expected:ae.expected,actual:ae.actual,contextValue:ae.contextValue,location:ae.location&&y.deserialize(Q,ae.location),stackTrace:ae.stackTrace&&ae.stackTrace.map(we=>S.deserialize(Q,we))})})(d||(e.ITestErrorMessage=d={}));const r=(G,Q)=>`${Q?"s":"e"}${G}`;e.$0I=r;var s;(function(G){G.serialize=Q=>({message:Q.message,type:a.Output,offset:Q.offset,length:Q.length,location:Q.location&&y.serialize(Q.location)}),G.deserialize=(Q,ae)=>({message:ae.message,type:a.Output,offset:ae.offset,length:ae.length,location:ae.location&&y.deserialize(Q,ae.location)})})(s||(e.ITestOutputMessage=s={}));var c;(function(G){G.serialize=Q=>Q.type===a.Error?d.serialize(Q):s.serialize(Q),G.deserialize=(Q,ae)=>ae.type===a.Error?d.deserialize(Q,ae):s.deserialize(Q,ae),G.isDiffable=Q=>Q.type===a.Error&&Q.actual!==void 0&&Q.expected!==void 0})(c||(e.ITestMessage=c={}));var l;(function(G){G.serializeWithoutMessages=Q=>({state:Q.state,duration:Q.duration,messages:[]}),G.serialize=Q=>({state:Q.state,duration:Q.duration,messages:Q.messages.map(c.serialize)}),G.deserialize=(Q,ae)=>({state:ae.state,duration:ae.duration,messages:ae.messages.map(we=>c.deserialize(Q,we))})})(l||(e.ITestTaskState=l={}));const i="\0",n=(G,Q)=>G+i+Q;e.$$I=n;const t=G=>{const Q=G.indexOf(i);return{ctrlId:G.slice(0,Q),tagId:G.slice(Q+1)}};e.$_I=t;var g;(function(G){G.serialize=Q=>({extId:Q.extId,label:Q.label,tags:Q.tags,busy:Q.busy,children:void 0,uri:Q.uri?.toJSON(),range:Q.range?.toJSON()||null,description:Q.description,error:Q.error,sortText:Q.sortText}),G.deserialize=(Q,ae)=>({extId:ae.extId,label:ae.label,tags:ae.tags,busy:ae.busy,children:void 0,uri:ae.uri?Q.asCanonicalUri(v.URI.revive(ae.uri)):void 0,range:ae.range?P.$Nt.lift(ae.range):null,description:ae.description,error:ae.error,sortText:ae.sortText})})(g||(e.ITestItem=g={}));var u;(function(G){G[G.NotExpandable=0]="NotExpandable",G[G.Expandable=1]="Expandable",G[G.BusyExpanding=2]="BusyExpanding",G[G.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var $;(function(G){G.serialize=Q=>({expand:Q.expand,item:g.serialize(Q.item)}),G.deserialize=(Q,ae)=>({controllerId:O.$6I.root(ae.item.extId),expand:ae.expand,item:g.deserialize(Q,ae.item)})})($||(e.InternalTestItem=$={}));var m;(function(G){G.serialize=Q=>{let ae;return Q.item&&(ae={},Q.item.label!==void 0&&(ae.label=Q.item.label),Q.item.tags!==void 0&&(ae.tags=Q.item.tags),Q.item.busy!==void 0&&(ae.busy=Q.item.busy),Q.item.uri!==void 0&&(ae.uri=Q.item.uri?.toJSON()),Q.item.range!==void 0&&(ae.range=Q.item.range?.toJSON()),Q.item.description!==void 0&&(ae.description=Q.item.description),Q.item.error!==void 0&&(ae.error=Q.item.error),Q.item.sortText!==void 0&&(ae.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:ae}},G.deserialize=Q=>{let ae;return Q.item&&(ae={},Q.item.label!==void 0&&(ae.label=Q.item.label),Q.item.tags!==void 0&&(ae.tags=Q.item.tags),Q.item.busy!==void 0&&(ae.busy=Q.item.busy),Q.item.range!==void 0&&(ae.range=Q.item.range?P.$Nt.lift(Q.item.range):null),Q.item.description!==void 0&&(ae.description=Q.item.description),Q.item.error!==void 0&&(ae.error=Q.item.error),Q.item.sortText!==void 0&&(ae.sortText=Q.item.sortText)),{extId:Q.extId,expand:Q.expand,item:ae}}})(m||(e.ITestItemUpdate=m={}));const h=(G,Q)=>{Q.expand!==void 0&&(G.expand=Q.expand),Q.item!==void 0&&(G.item=G.item?Object.assign(G.item,Q.item):Q.item)};e.$aJ=h;var E;(function(G){G.serializeWithoutMessages=Q=>({...$.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(l.serializeWithoutMessages)}),G.serialize=Q=>({...$.serialize(Q),ownComputedState:Q.ownComputedState,computedState:Q.computedState,tasks:Q.tasks.map(l.serialize)}),G.deserialize=(Q,ae)=>({...$.deserialize(Q,ae),ownComputedState:ae.ownComputedState,computedState:ae.computedState,tasks:ae.tasks.map(we=>l.deserialize(Q,we)),retired:!0})})(E||(e.TestResultItem=E={}));var D;(function(G){G.empty=()=>({covered:0,total:0}),G.sum=(Q,ae)=>{Q.covered+=ae.covered,Q.total+=ae.total}})(D||(e.ICoverageCount=D={}));var w;(function(G){G.serialize=Q=>({id:Q.id,statement:Q.statement,branch:Q.branch,declaration:Q.declaration,testIds:Q.testIds,uri:Q.uri.toJSON()}),G.deserialize=(Q,ae)=>({id:ae.id,statement:ae.statement,branch:ae.branch,declaration:ae.declaration,testIds:ae.testIds,uri:Q.asCanonicalUri(v.URI.revive(ae.uri))}),G.empty=(Q,ae)=>({id:Q,uri:ae,statement:D.empty()})})(w||(e.IFileCoverage=w={}));function C(G){return{...G,location:G.location?.toJSON()}}function k(G){return G.location=G.location?R.$Mt.isIPosition(G.location)?R.$Mt.lift(G.location):P.$Nt.lift(G.location):void 0,G}e.$bJ=3;var f;(function(G){G[G.Declaration=0]="Declaration",G[G.Statement=1]="Statement",G[G.Branch=2]="Branch"})(f||(e.DetailType=f={}));var b;(function(G){G.serialize=Q=>Q.type===f.Declaration?N.serialize(Q):L.serialize(Q),G.deserialize=Q=>Q.type===f.Declaration?N.deserialize(Q):L.deserialize(Q)})(b||(e.CoverageDetails=b={}));var M;(function(G){G.serialize=C,G.deserialize=k})(M||(e.IBranchCoverage=M={}));var N;(function(G){G.serialize=C,G.deserialize=k})(N||(e.IDeclarationCoverage=N={}));var L;(function(G){G.serialize=Q=>({...C(Q),branches:Q.branches?.map(M.serialize)}),G.deserialize=Q=>({...k(Q),branches:Q.branches?.map(M.deserialize)})})(L||(e.IStatementCoverage=L={}));var W;(function(G){G[G.Add=0]="Add",G[G.Update=1]="Update",G[G.DocumentSynced=2]="DocumentSynced",G[G.Remove=3]="Remove",G[G.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",G[G.Retire=5]="Retire",G[G.AddTag=6]="AddTag",G[G.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var K;(function(G){G.deserialize=(Q,ae)=>ae.op===W.Add?{op:ae.op,item:$.deserialize(Q,ae.item)}:ae.op===W.Update?{op:ae.op,item:m.deserialize(ae.item)}:ae.op===W.DocumentSynced?{op:ae.op,uri:Q.asCanonicalUri(v.URI.revive(ae.uri)),docv:ae.docv}:ae,G.serialize=Q=>Q.op===W.Add?{op:Q.op,item:$.serialize(Q.item)}:Q.op===W.Update?{op:Q.op,item:m.serialize(Q.item)}:Q})(K||(e.TestsDiffOp=K={}));class q{constructor(Q){this.l=Q,this.f=new Map,this.g=new Map,this.h=new Set,this.j=0,this.k=0,this.tags=this.f}apply(Q){const ae=this.x();for(const we of Q)switch(we.op){case W.Add:this.p($.deserialize(this.l,we.item),ae);break;case W.Update:this.q(m.deserialize(we.item),ae);break;case W.Remove:this.v(we.itemId,ae);break;case W.Retire:this.w(we.itemId);break;case W.IncrementPendingExtHosts:this.updatePendingRoots(we.amount);break;case W.AddTag:this.f.set(we.tag.id,we.tag);break;case W.RemoveTag:this.f.delete(we.id);break}ae.complete?.()}p(Q,ae){const we=O.$6I.parentId(Q.item.extId)?.toString();let le;if(!we)le=this.y(Q),this.h.add(le),this.g.set(Q.item.extId,le);else if(this.g.has(we)){const _=this.g.get(we);_.children.add(Q.item.extId),le=this.y(Q,_),this.g.set(Q.item.extId,le)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(Q)}`);return}return ae.add?.(le),Q.expand===u.BusyExpanding&&this.j++,le}q(Q,ae){const we=this.g.get(Q.extId);if(we)return Q.expand!==void 0&&(we.expand===u.BusyExpanding&&this.j--,Q.expand===u.BusyExpanding&&this.j++),(0,e.$aJ)(we,Q),ae.update?.(we),we}v(Q,ae){const we=this.g.get(Q);if(!we)return;const le=O.$6I.parentId(we.item.extId)?.toString();le?this.g.get(le).children.delete(we.item.extId):this.h.delete(we);const _=[[Q]];for(;_.length;)for(const ce of _.pop()){const me=this.g.get(ce);me&&(_.push(me.children),this.g.delete(ce),ae.remove?.(me,me!==we),me.expand===u.BusyExpanding&&this.j--)}}w(Q){}updatePendingRoots(Q){this.k+=Q}x(){return{}}}e.$cJ=q}),define(Ne[200],Le([1,0,98,9,55]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestCommandId=e.$KGb=e.$JGb=e.TestExplorerViewSorting=e.TestExplorerViewMode=e.Testing=void 0;var O;(function(y){y.ViewletId="workbench.view.extension.test",y.ExplorerViewId="workbench.view.testing",y.OutputPeekContributionId="editor.contrib.testingOutputPeek",y.DecorationsContributionId="editor.contrib.testingDecorations",y.CoverageDecorationsContributionId="editor.contrib.coverageDecorations",y.CoverageViewId="workbench.view.testCoverage",y.ResultsPanelId="workbench.panel.testResults",y.ResultsViewId="workbench.panel.testResults.view",y.MessageLanguageId="vscodeInternalTestMessage"})(O||(e.Testing=O={}));var A;(function(y){y.List="list",y.Tree="true"})(A||(e.TestExplorerViewMode=A={}));var T;(function(y){y.ByLocation="location",y.ByStatus="status",y.ByDuration="duration"})(T||(e.TestExplorerViewSorting=T={}));const p={[P.TestResultState.Errored]:(0,R.localize)(3178,null),[P.TestResultState.Failed]:(0,R.localize)(3179,null),[P.TestResultState.Passed]:(0,R.localize)(3180,null),[P.TestResultState.Queued]:(0,R.localize)(3181,null),[P.TestResultState.Running]:(0,R.localize)(3182,null),[P.TestResultState.Skipped]:(0,R.localize)(3183,null),[P.TestResultState.Unset]:(0,R.localize)(3184,null)},o=(y,a)=>(0,R.localize)(3185,null,(0,v.$Yk)(y),p[a]);e.$JGb=o,e.$KGb={[P.TestRunProfileBitset.Debug]:(0,R.localize)(3186,null),[P.TestRunProfileBitset.Run]:(0,R.localize)(3187,null),[P.TestRunProfileBitset.Coverage]:(0,R.localize)(3188,null)};var I;(function(y){y.CancelTestRefreshAction="testing.cancelTestRefresh",y.CancelTestRunAction="testing.cancelRun",y.ClearTestResultsAction="testing.clearTestResults",y.CollapseAllAction="testing.collapseAll",y.ConfigureTestProfilesAction="testing.configureProfile",y.ContinousRunUsingForTest="testing.continuousRunUsingForTest",y.CoverageAtCursor="testing.coverageAtCursor",y.CoverageByUri="testing.coverage.uri",y.CoverageClear="testing.coverage.close",y.CoverageCurrentFile="testing.coverageCurrentFile",y.CoverageFilterToTest="testing.coverageFilterToTest",y.CoverageFilterToTestInEditor="testing.coverageFilterToTestInEditor",y.CoverageLastRun="testing.coverageLastRun",y.CoverageSelectedAction="testing.coverageSelected",y.CoverageToggleToolbar="testing.coverageToggleToolbar",y.CoverageViewChangeSorting="testing.coverageViewChangeSorting",y.DebugAction="testing.debug",y.DebugAllAction="testing.debugAll",y.DebugAtCursor="testing.debugAtCursor",y.DebugByUri="testing.debug.uri",y.DebugCurrentFile="testing.debugCurrentFile",y.DebugFailedTests="testing.debugFailTests",y.DebugLastRun="testing.debugLastRun",y.DebugSelectedAction="testing.debugSelected",y.FilterAction="workbench.actions.treeView.testExplorer.filter",y.GetExplorerSelection="_testing.getExplorerSelection",y.GetSelectedProfiles="testing.getSelectedProfiles",y.GoToTest="testing.editFocusedTest",y.GoToRelatedTest="testing.goToRelatedTest",y.PeekRelatedTest="testing.peekRelatedTest",y.GoToRelatedCode="testing.goToRelatedCode",y.PeekRelatedCode="testing.peekRelatedCode",y.HideTestAction="testing.hideTest",y.OpenCoverage="testing.openCoverage",y.OpenOutputPeek="testing.openOutputPeek",y.RefreshTestsAction="testing.refreshTests",y.ReRunFailedTests="testing.reRunFailTests",y.ReRunLastRun="testing.reRunLastRun",y.RunAction="testing.run",y.RunAllAction="testing.runAll",y.RunAllWithCoverageAction="testing.coverageAll",y.RunAtCursor="testing.runAtCursor",y.RunByUri="testing.run.uri",y.RunCurrentFile="testing.runCurrentFile",y.RunSelectedAction="testing.runSelected",y.RunUsingProfileAction="testing.runUsing",y.RunWithCoverageAction="testing.coverage",y.SearchForTestExtension="testing.searchForTestExtension",y.SelectDefaultTestProfiles="testing.selectDefaultTestProfiles",y.ShowMostRecentOutputAction="testing.showMostRecentOutput",y.StartContinousRun="testing.startContinuousRun",y.StopContinousRun="testing.stopContinuousRun",y.TestingSortByDurationAction="testing.sortByDuration",y.TestingSortByLocationAction="testing.sortByLocation",y.TestingSortByStatusAction="testing.sortByStatus",y.TestingViewAsListAction="testing.viewAsList",y.TestingViewAsTreeAction="testing.viewAsTree",y.ToggleContinousRunForTest="testing.toggleContinuousRunForTest",y.ToggleInlineTestOutput="testing.toggleInlineTestOutput",y.UnhideAllTestsAction="testing.unhideAllTests",y.UnhideTestAction="testing.unhideTest"})(I||(e.TestCommandId=I={}))}),define(Ne[81],Le([1,0,10,6,4,61,55,54]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=e.$cQ=e.$bQ=e.$aQ=e.$_P=e.TestItemEventOp=void 0;var p;(function(l){l[l.Upsert=0]="Upsert",l[l.SetTags=1]="SetTags",l[l.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",l[l.RemoveChild=3]="RemoveChild",l[l.SetProp=4]="SetProp",l[l.Bulk=5]="Bulk",l[l.DocumentSynced=6]="DocumentSynced"})(p||(e.TestItemEventOp=p={}));const o=(l,i)=>l===i,y=Object.entries({range:(l,i)=>l===i?!0:!l||!i?!1:l.equalsRange(i),busy:o,label:o,description:o,error:o,sortText:o,tags:(l,i)=>!(l.length!==i.length||l.some(n=>!i.includes(n)))}),a=(l,i)=>{let n;for(const[t,g]of y)g(l[t],i[t])||(n?n[t]=i[t]:n={[t]:i[t]});return n};class S extends P.$Uc{get root(){return this.s.root}constructor(i){super(),this.s=i,this.f=this.B(new v.$Qh(()=>this.flushDiff(),200)),this.g=this.B(new R.$le),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(i){this.h=i;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const i=this.m;return this.m=[],i}pushDiff(i){switch(i.op){case A.TestDiffOpType.DocumentSynced:{for(const n of this.m)if(n.op===A.TestDiffOpType.DocumentSynced&&n.uri===i.uri){n.docv=i.docv;return}break}case A.TestDiffOpType.Update:{const n=this.m[this.m.length-1];if(n){if(n.op===A.TestDiffOpType.Update&&n.item.extId===i.item.extId){(0,A.$aJ)(n.item,i.item);return}if(n.op===A.TestDiffOpType.Add&&n.item.item.extId===i.item.extId){(0,A.$aJ)(n.item,i.item);return}}break}}this.m.push(i),this.f.isScheduled()||this.f.schedule()}expand(i,n){const t=this.tree.get(i);if(t){if((t.expandLevels===void 0||n>t.expandLevels)&&(t.expandLevels=n),t.expand===A.TestItemExpandState.Expandable){const g=this.M(t);return g.isOpen()?this.L(t,n-1):g.wait().then(()=>this.L(t,n-1))}else if(t.expand===A.TestItemExpandState.Expanded)return t.resolveBarrier?.isOpen()===!1?t.resolveBarrier.wait().then(()=>this.L(t,n-1)):this.L(t,n-1)}}dispose(){for(const i of this.tree.values())this.s.getApiFor(i.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(i,n){switch(n.op){case p.RemoveChild:this.O(T.$6I.joinToString(i.fullId,n.id));break;case p.Upsert:this.z(n.item,i);break;case p.Bulk:for(const t of n.ops)this.w(i,t);break;case p.SetTags:this.C(n.new,n.old,i.fullId.toString());break;case p.UpdateCanResolveChildren:this.J(i);break;case p.SetProp:this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),item:n.update}});break;case p.DocumentSynced:this.y(i.actual.uri);break;default:(0,O.$ed)(n)}}y(i){i&&this.pushDiff({op:A.TestDiffOpType.DocumentSynced,uri:i,docv:this.s.getDocumentVersion(i)})}z(i,n){const t=T.$6I.fromExtHostTestItem(i,this.root.id,n?.actual),g=this.s.getApiFor(i);g.parent&&g.parent!==n?.actual&&this.s.getChildren(g.parent).delete(i.id);let u=this.tree.get(t.toString());if(!u){u={fullId:t,actual:i,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:A.TestItemExpandState.NotExpandable},i.tags.forEach(this.D,this),this.tree.set(u.fullId.toString(),u),this.G(i,n),this.pushDiff({op:A.TestDiffOpType.Add,item:{controllerId:this.s.controllerId,expand:u.expand,item:this.s.toITestItem(i)}}),this.I(i,u,n);return}if(u.actual===i){this.H(i,u,n);return}if(u.actual.uri?.toString()!==i.uri?.toString())return this.O(t.toString()),this.z(i,n);const $=this.s.getChildren(u.actual),m=u.actual,h=a(this.s.toITestItem(m),this.s.toITestItem(i));this.s.getApiFor(m).listener=void 0,u.actual=i,u.resolveBarrier=void 0,u.expand=A.TestItemExpandState.NotExpandable,h&&(h.hasOwnProperty("tags")&&(this.C(i.tags,m.tags,t.toString()),delete h.tags),this.w(u,{op:p.SetProp,update:h})),this.I(i,u,n);for(const[D,w]of $)this.s.getChildren(i).get(w.id)||this.O(T.$6I.joinToString(t,w.id));const E=u.expandLevels;E!==void 0&&queueMicrotask(()=>{u.expand===A.TestItemExpandState.Expandable&&(u.expandLevels=void 0,this.expand(t.toString(),E))}),this.y(u.actual.uri)}C(i,n,t){const g=new Set(n.map(u=>u.id));for(const u of i)g.delete(u.id)||this.D(u);this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:t,item:{tags:i.map(u=>(0,A.$$I)(this.s.controllerId,u.id))}}}),g.forEach(this.F,this)}D(i){const n=this.j.get(i.id);n?n.refCount++:(this.j.set(i.id,{refCount:1}),this.pushDiff({op:A.TestDiffOpType.AddTag,tag:{id:(0,A.$$I)(this.s.controllerId,i.id)}}))}F(i){const n=this.j.get(i);n&&!--n.refCount&&(this.j.delete(i),this.pushDiff({op:A.TestDiffOpType.RemoveTag,id:(0,A.$$I)(this.s.controllerId,i)}))}G(i,n){this.s.getApiFor(i).parent=n&&n.actual!==this.root?n.actual:void 0}H(i,n,t){this.G(i,t);const g=this.s.getApiFor(i);g.parent=t?.actual,g.listener=u=>this.w(n,u),this.J(n)}I(i,n,t){this.H(i,n,t);for(const[g,u]of this.s.getChildren(i))this.z(u,n)}J(i){let n;this.h?i.resolveBarrier?n=i.resolveBarrier.isOpen()?A.TestItemExpandState.Expanded:A.TestItemExpandState.BusyExpanding:n=i.actual.canResolveChildren?A.TestItemExpandState.Expandable:A.TestItemExpandState.NotExpandable:n=A.TestItemExpandState.NotExpandable,n!==i.expand&&(i.expand=n,this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:n}}),n===A.TestItemExpandState.Expandable&&i.expandLevels!==void 0&&this.M(i))}L(i,n){if(n<0)return;const t=[];for(const[g,u]of this.s.getChildren(i.actual)){const $=this.expand(T.$6I.joinToString(i.fullId,u.id),n);(0,v.$qh)($)&&t.push($)}if(t.length)return Promise.all(t).then(()=>{})}M(i){if(i.resolveBarrier)return i.resolveBarrier;if(!this.h){const u=new v.$Dh;return u.open(),u}i.expand=A.TestItemExpandState.BusyExpanding,this.N(i);const n=i.resolveBarrier=new v.$Dh,t=u=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,u)};let g;try{g=this.h(i.actual===this.root?void 0:i.actual)}catch(u){t(u)}return(0,v.$qh)(g)?g.catch(t).then(()=>{n.open(),this.J(i)}):(n.open(),this.J(i)),i.resolveBarrier}N(i){this.pushDiff({op:A.TestDiffOpType.Update,item:{extId:i.fullId.toString(),expand:i.expand}})}O(i){const n=this.tree.get(i);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:A.TestDiffOpType.Remove,itemId:i});const t=[n];for(;t.length;){const g=t.pop();if(g){this.s.getApiFor(g.actual).listener=void 0;for(const u of g.actual.tags)this.F(u.id);this.tree.delete(g.fullId.toString());for(const[u,$]of this.s.getChildren(g.actual))t.push(this.tree.get(T.$6I.joinToString(g.fullId,$.id)))}}}flushDiff(){const i=this.collectDiff();i.length&&this.g.fire(i)}}e.$_P=S;class d extends Error{constructor(i){super(`Attempted to insert a duplicate test item ID ${i}`)}}e.$aQ=d;class r extends Error{constructor(i){super(`TestItem with ID "${i}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$bQ=r;class s extends Error{constructor(i,n,t){super(`TestItem with ID "${i}" is from controller "${n}" and cannot be added as a child of an item from controller "${t}".`)}}e.$cQ=s;const c=(l,i,n)=>{let t=new Map;return{get size(){return t.size},forEach(g,u){for(const $ of t.values())g.call(u,$,this)},[Symbol.iterator](){return t.entries()},replace(g){const u=new Map,$=new Set(t.keys()),m={op:p.Bulk,ops:[]};for(const h of g){if(!(h instanceof n))throw new r(h.id);const E=i(h).controllerId;if(E!==l.controllerId)throw new s(h.id,E,l.controllerId);if(u.has(h.id))throw new d(h.id);u.set(h.id,h),$.delete(h.id),m.ops.push({op:p.Upsert,item:h})}for(const h of $.keys())m.ops.push({op:p.RemoveChild,id:h});l.listener?.(m),t=u},add(g){if(!(g instanceof n))throw new r(g.id);t.set(g.id,g),l.listener?.({op:p.Upsert,item:g})},delete(g){t.delete(g)&&l.listener?.({op:p.RemoveChild,id:g})},get(g){return t.get(g)},toJSON(){return Array.from(t.values())}}};e.$dQ=c}),define(Ne[116],Le([1,0,81]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fQ=e.$eQ=void 0;const R=new WeakMap,P=(A,T)=>{const p={controllerId:T};return R.set(A,p),p};e.$eQ=P;const O=A=>{const T=R.get(A);if(!T)throw new v.$bQ(A?.id||"<unknown>");return T};e.$fQ=O}),define(Ne[82],Le([1,0,27,15,2]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DDb=e.$CDb=e.$BDb=void 0,e.$EDb=O,e.$FDb=T,e.$BDb="vscode-cdn.net",e.$CDb=`vscode-resource.${e.$BDb}`,e.$DDb=`'self' https://*.${e.$BDb}`;function O(p,o){return p.scheme===R.Schemas.http||p.scheme===R.Schemas.https?p:(o&&o.authority&&o.isRemote&&p.scheme===R.Schemas.file&&(p=P.URI.from({scheme:R.Schemas.vscodeRemote,authority:o.authority,path:p.path})),P.URI.from({scheme:R.Schemas.https,authority:`${p.scheme}+${A(p.authority)}.${e.$CDb}`,path:p.path,fragment:p.fragment,query:p.query}))}function A(p){return p.replace(/./g,o=>{const I=o.charCodeAt(0);return I>=v.CharCode.a&&I<=v.CharCode.z||I>=v.CharCode.A&&I<=v.CharCode.Z||I>=v.CharCode.Digit0&&I<=v.CharCode.Digit9?o:"-"+I.toString(16).padStart(4,"0")})}function T(p){return p.replace(/-([0-9a-f]{4})/g,(o,I)=>String.fromCharCode(parseInt(I,16)))}}),define(Ne[201],Le([1,0,6,4,82]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Epc=void 0;class O{constructor(T,p,o){this.d=T,this.e=p,this.f=o,this.a=0,this.b=new R.$Tc,this.c=new Map,this.b.add(p.onDidChangeVisibleTextEditors(()=>{const I=p.getVisibleTextEditors();for(const y of this.c.values())I.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(T=>T.inset.dispose()),this.b.dispose()}createWebviewEditorInset(T,p,o,I,y){let a;for(const i of this.e.getVisibleTextEditors(!0))if(i.value===T){a=i;break}if(!a)throw new Error("not a visible editor");const S=this,d=this.a++,r=new v.$le,s=new v.$le,c=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(i){return(0,P.$EDb)(i,S.f)}get cspSource(){return P.$DDb}set options(i){this.b=i,S.d.$setOptions(d,i)}get options(){return this.b}set html(i){this.a=i,S.d.$setHtml(d,i)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(i){return S.d.$postMessage(d,i)}},l=new class{constructor(){this.editor=T,this.line=p,this.height=o,this.webview=c,this.onDidDispose=s.event}dispose(){S.c.has(d)&&(S.c.delete(d),S.d.$disposeEditorInset(d),s.fire(),s.dispose(),r.dispose())}};return this.d.$createEditorInset(d,a.id,a.value.document.uri,p+1,o,I||{},y.identifier,y.extensionLocation),this.c.set(d,{editor:T,inset:l,onDidReceiveMessage:r}),l}$onDidDispose(T){const p=this.c.get(T);p&&p.inset.dispose()}$onDidReceiveMessage(T,p){this.c.get(T)?.onDidReceiveMessage.fire(p)}}e.$Epc=O}),define(Ne[117],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=e.$LM=void 0,e.$LM="__",e.$MM=(0,v.$Ei)("IAuthenticationService"),e.$NM=(0,v.$Ei)("IAuthenticationExtensionsService")}),define(Ne[202],Le([1,0,3]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$Q=e.VariableKind=e.$0Q=void 0,e.$0Q=(0,v.$Ei)("configurationResolverService");var R;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(R||(e.VariableKind=R={}));class P extends Error{constructor(A,T){super(T),this.variable=A}}e.$$Q=P}),define(Ne[203],Le([1,0,19,78,14,25,20,99,9,202,12]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nR=void 0,v=We(v),R=We(R),P=We(P),O=We(O);class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,d,r,s){this.h=new Map,this.a=S,this.b=d,this.g=r,s&&(this.c=s.then(c=>this.i(c)))}i(S){if(A.$j){const d=Object.create(null);return Object.keys(S).forEach(r=>{d[r.toLowerCase()]=S[r]}),d}return S}resolveWithEnvironment(S,d,r){return this.l({env:this.i(S),userHome:void 0},d?d.uri:void 0,r)}async resolveAsync(S,d){const r={env:await this.c,userHome:await this.g};return this.l(r,S?S.uri:void 0,d)}async j(S,d,r,s){const c=O.$do(d);A.$j&&c.windows?Object.keys(c.windows).forEach(i=>c[i]=c.windows[i]):A.$k&&c.osx?Object.keys(c.osx).forEach(i=>c[i]=c.osx[i]):A.$l&&c.linux&&Object.keys(c.linux).forEach(i=>c[i]=c.linux[i]),delete c.windows,delete c.osx,delete c.linux;const l={env:await this.c,userHome:await this.g};return this.l(l,S?S.uri:void 0,c,r,s)}async resolveAnyAsync(S,d,r){return this.j(S,d,r)}async resolveAnyMap(S,d,r){const s=new Map;return{newConfig:await this.j(S,d,r,s),resolvedVariables:s}}resolveWithInteractionReplace(S,d,r,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,d,r,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,d){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,d)}async l(S,d,r,s,c){if(P.$eg(r))return this.m(S,d,r,s,c);if(Array.isArray(r))return Promise.all(r.map(l=>this.l(S,d,l,s,c)));if(P.$gg(r)){const l=Object.create(null),i=await Promise.all(Object.keys(r).map(async n=>[await this.m(S,d,n,s,c),await this.l(S,d,r[n],s,c)]));for(const[n,t]of i)l[n]=t;return l}return r}m(S,d,r,s,c){return(0,I.$xf)(r,y.VARIABLE_REGEXP,async(l,i)=>{if(i.includes(y.VARIABLE_LHS))return l;let n=await this.o(S,l,i,d,s);return c?.set(i,n),n!==l&&P.$eg(n)&&n.match(y.VARIABLE_REGEXP)&&(n=await this.m(S,d,n,s,c)),n})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,d,r,s,c){let l;const i=r.split(":");i.length>1&&(r=i[0],l=i[1]);const n=u=>{const $=this.a.getFilePath();if($)return(0,T.$Zw)($);throw new o.$$Q(u,(0,p.localize)(2072,null,d))},t=u=>{const $=n(u);if(this.a.getWorkspaceFolderPathForFile){const m=this.a.getWorkspaceFolderPathForFile();if(m)return(0,T.$Zw)(m)}throw new o.$$Q(u,(0,p.localize)(2073,null,d,v.$nc($)))},g=u=>{if(l){const $=this.a.getFolderUri(l);if($)return $;throw new o.$$Q(u,(0,p.localize)(2074,null,d,l))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new o.$$Q(u,(0,p.localize)(2075,null,d)):new o.$$Q(u,(0,p.localize)(2076,null,d))};switch(r){case"env":if(l){if(S.env){const u=S.env[A.$j?l.toLowerCase():l];if(P.$eg(u))return u}return""}throw new o.$$Q(o.VariableKind.Env,(0,p.localize)(2077,null,d));case"config":if(l){const u=this.a.getConfigurationValue(s,l);if(P.$ng(u))throw new o.$$Q(o.VariableKind.Config,(0,p.localize)(2078,null,d,l));if(P.$gg(u))throw new o.$$Q(o.VariableKind.Config,(0,p.localize)(2079,null,d,l));return u}throw new o.$$Q(o.VariableKind.Config,(0,p.localize)(2080,null,d));case"command":return this.p(o.VariableKind.Command,d,l,c,"command");case"input":return this.p(o.VariableKind.Input,d,l,c,"input");case"extensionInstallFolder":if(l){const u=await this.a.getExtension(l);if(!u)throw new o.$$Q(o.VariableKind.ExtensionInstallFolder,(0,p.localize)(2081,null,d,l));return this.n(u.extensionLocation)}throw new o.$$Q(o.VariableKind.ExtensionInstallFolder,(0,p.localize)(2082,null,d));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,T.$Zw)(this.n(g(o.VariableKind.WorkspaceFolder)));case"cwd":return s||l?(0,T.$Zw)(this.n(g(o.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,T.$Zw)(v.$nc(this.n(g(o.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new o.$$Q(o.VariableKind.UserHome,(0,p.localize)(2083,null,d))}case"lineNumber":{const u=this.a.getLineNumber();if(u)return u;throw new o.$$Q(o.VariableKind.LineNumber,(0,p.localize)(2084,null,d))}case"selectedText":{const u=this.a.getSelectedText();if(u)return u;throw new o.$$Q(o.VariableKind.SelectedText,(0,p.localize)(2085,null,d))}case"file":return n(o.VariableKind.File);case"fileWorkspaceFolder":return t(o.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return v.$nc(t(o.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||l?v.$lc(this.n(g(o.VariableKind.RelativeFile)),n(o.VariableKind.RelativeFile)):n(o.VariableKind.RelativeFile);case"relativeFileDirname":{const u=v.$mc(n(o.VariableKind.RelativeFileDirname));if(s||l){const $=v.$lc(this.n(g(o.VariableKind.RelativeFileDirname)),u);return $.length===0?".":$}return u}case"fileDirname":return v.$mc(n(o.VariableKind.FileDirname));case"fileExtname":return v.$oc(n(o.VariableKind.FileExtname));case"fileBasename":return v.$nc(n(o.VariableKind.FileBasename));case"fileBasenameNoExtension":{const u=v.$nc(n(o.VariableKind.FileBasenameNoExtension));return u.slice(0,u.length-v.$oc(u).length)}case"fileDirnameBasename":return v.$nc(v.$mc(n(o.VariableKind.FileDirnameBasename)));case"execPath":{const u=this.a.getExecPath();return u||d}case"execInstallFolder":{const u=this.a.getAppRoot();return u||d}case"pathSeparator":case"/":return v.sep;default:try{const u=l?`${r}:${l}`:r;return this.p(o.VariableKind.Unknown,d,u,c,void 0)}catch{return d}}}}p(S,d,r,s,c){if(r&&s){const l=c===void 0?s[r]:s[c+":"+r];if(typeof l=="string")return l;throw new o.$$Q(S,(0,p.localize)(2086,null,d))}return d}}e.$nR=y}),define(Ne[118],Le([1,0,3,114]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$sE=void 0,e.$tE=o,e.$uE=a,e.$vE=S,e.$sE=(0,v.$Ei)("editorGroupsService");var P;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var O;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var A;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var T;(function(d){d[d.MAXIMIZE=0]="MAXIMIZE",d[d.EXPAND=1]="EXPAND",d[d.EVEN=2]="EVEN"})(T||(e.GroupsArrangement=T={}));var p;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(p||(e.MergeGroupMode=p={}));function o(d){const r=d;return(0,R.$gG)(r?.editor)&&(0,R.$gG)(r?.replacement)}var I;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(I||(e.GroupsOrder=I={}));var y;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function a(d){const r=d;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}function S(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?P.DOWN:P.RIGHT}}),define(Ne[204],Le([1,0,3,118]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zE=e.$yE=e.$xE=e.$wE=void 0,e.$AE=P,e.$wE=(0,v.$Ei)("editorService"),e.$xE=-1,e.$yE=-2,e.$zE=-3;function P(O){const A=O;return typeof O=="number"||(0,R.$uE)(A)}}),define(Ne[205],Le([1,0,3,106]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7M=void 0,e.$7M=(0,v.$Fi)(R.$Li)}),define(Ne[119],Le([1,0,18,6,19,4,10]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=e.$Jdc=e.$Idc=e.$Hdc=e.$Gdc=void 0,P=We(P);class T{constructor(l,i){this.versionId=l,this.removedDueToLooping=i}}e.$Gdc=T;class p{static isHostExtension(l,i,n){if(i.getExtensionDescription(l))return!1;const t=n.getExtensionDescription(l);return t?!!((t.main||t.browser)&&t.api==="none"):!1}constructor(l,i){this.j=l,this.c=new R.$le,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(r),this.f=new v.$sn,this.g=[],this.h=new Map;for(const l of this.e){if(this.f.has(l.identifier)){console.error("Extension `"+l.identifier.value+"` is already registered");continue}this.f.set(l.identifier,l),this.g.push(l);const i=this.j.readActivationEvents(l);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(l)}}set(l){return this.e=l,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(l,i){this.e=s(this.e,i),this.e=this.e.concat(l);const n=p.l(this.e);return this.e=s(this.e,n.map(t=>t.identifier)),this.k(),this.d++,this.c.fire(void 0),new T(this.d,n)}static l(l){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode($){this.d.has($)||(this.d.add($),this.e.push($))}addArc($,m){this.addNode($),this.addNode(m),this.c.has($)?this.c.get($).push(m):this.c.set($,[m])}getArcs($){return this.c.has($)?this.c.get($):[]}hasOnlyGoodArcs($,m){const h=i.getArcs($);for(let E=0;E<h.length;E++)if(!m.has(h[E]))return!1;return!0}getNodes(){return this.e}},n=new v.$sn;for(const $ of l)if(n.set($.identifier,$),$.extensionDependencies)for(const m of $.extensionDependencies)i.addArc(v.$qn.toKey($.identifier),v.$qn.toKey(m));const t=new Set;i.getNodes().filter($=>i.getArcs($).length===0).forEach($=>t.add($));const g=i.getNodes().filter($=>!t.has($));let u;do{u=!1;for(let $=0;$<g.length;$++){const m=g[$];i.hasOnlyGoodArcs(m,t)&&(g.splice($,1),$--,t.add(m),u=!0)}}while(u);return g.map($=>n.get($))}containsActivationEvent(l){return this.h.has(l)}containsExtension(l){return this.f.has(l)}getExtensionDescriptionsForActivationEvent(l){const i=this.h.get(l);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new o(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(l){const i=this.f.get(l);return i||void 0}getExtensionDescriptionByUUID(l){for(const i of this.g)if(i.uuid===l)return i}getExtensionDescriptionByIdOrUUID(l,i){return this.getExtensionDescription(l)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$Hdc=p;class o{constructor(l,i){this.versionId=l,this.extensions=i}}e.$Idc=o;class I{constructor(l){this.d=new S,this.c=new p(l,[])}async acquireLock(l){const i=await this.d.acquire(l);return new y(this,i)}deltaExtensions(l,i,n){if(!l.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(l){return this.c.containsActivationEvent(l)}containsExtension(l){return this.c.containsExtension(l)}getExtensionDescriptionsForActivationEvent(l){return this.c.getExtensionDescriptionsForActivationEvent(l)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(l){return this.c.getExtensionDescription(l)}getExtensionDescriptionByUUID(l){return this.c.getExtensionDescriptionByUUID(l)}getExtensionDescriptionByIdOrUUID(l,i){return this.c.getExtensionDescriptionByIdOrUUID(l,i)}}e.$Jdc=I;class y extends O.$Uc{constructor(l,i){super(),this.f=l,this.c=!1,this.B(i)}isAcquiredFor(l){return!this.c&&this.f===l}}e.$Kdc=y;class a{constructor(l){this.name=l;const i=(0,A.$xh)();this.promise=i.promise,this.c=i.resolve}resolve(l){this.c(l)}}class S{constructor(){this.c=[],this.d=!1}async acquire(l){const i=new a(l);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const l=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${l.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),t=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};l.resolve((0,O.$Sc)(t))}}var d;(function(c){c[c.Builtin=0]="Builtin",c[c.User=1]="User",c[c.Dev=2]="Dev"})(d||(d={}));function r(c,l){const i=c.isBuiltin?d.Builtin:c.isUnderDevelopment?d.Dev:d.User,n=l.isBuiltin?d.Builtin:l.isUnderDevelopment?d.Dev:d.User;if(i!==n)return i-n;const t=P.$gc.basename(c.extensionLocation.path),g=P.$gc.basename(l.extensionLocation.path);return t<g?-1:t>g?1:0}function s(c,l){const i=new v.$rn(l);return c.filter(n=>!i.has(n.identifier))}}),define(Ne[83],Le([1,0,22]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$An=A,e.$Bn=T;var R;(function(o){o[o.Desktop=1]="Desktop",o[o.Web=2]="Web"})(R||(e.UIKind=R={}));var P;(function(o){o[o.VersionMismatch=55]="VersionMismatch",o[o.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var O;(function(o){o[o.Initialized=0]="Initialized",o[o.Ready=1]="Ready",o[o.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function A(o){const I=v.$Ne.alloc(1);switch(o){case O.Initialized:I.writeUInt8(1,0);break;case O.Ready:I.writeUInt8(2,0);break;case O.Terminate:I.writeUInt8(3,0);break}return I}function T(o,I){if(o.byteLength!==1)return!1;switch(o.readUInt8(0)){case 1:return I===O.Initialized;case 2:return I===O.Ready;case 3:return I===O.Terminate;default:return!1}}var p;(function(o){o.Start="START_NATIVE_LOG",o.End="END_NATIVE_LOG"})(p||(e.NativeLogMarkers=p={}))}),define(Ne[66],Le([1,0,3,6,112,11,26,83,62,63,25,2,4,9]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$BQ=e.$AQ=void 0,e.$CQ=s;let d=class extends a.$Uc{constructor(l,i){super(),this.s=l,this.t=i,this.a=this.B(new R.$le),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.$le),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=P.TelemetryLevel.NONE,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:o.$Bp,name:(0,S.localize)(10814,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(n=>{(0,O.$bk)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===O.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===P.TelemetryLevel.USAGE}getTelemetryDetails(){return{isCrashEnabled:this.f>=P.TelemetryLevel.CRASH,isErrorsEnabled:this.c.error?this.f>=P.TelemetryLevel.ERROR:!1,isUsageEnabled:this.c.usage?this.f>=P.TelemetryLevel.USAGE:!1}}instantiateLogger(l,i,n){const t=this.getTelemetryDetails(),g=new r(i,n,l,this.n,this.j,this.getBuiltInCommonProperties(l),{isUsageEnabled:t.isUsageEnabled,isErrorsEnabled:t.isErrorsEnabled}),u=this.r.get(l.identifier.value)??[];return this.r.set(l.identifier.value,[...u,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(l,i,n){this.f=l,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(l){const i=Object.create(null);switch(i["common.extname"]=`${l.publisher}.${l.name}`,i["common.extversion"]=l.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.devDeviceId"]=this.s.telemetryInfo.devDeviceId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case T.UIKind.Web:i["common.uikind"]="web";break;case T.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,p.$hn)((0,o.$Hp)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(l){this.h=this.getTelemetryConfiguration(),this.f=l;const i=this.getTelemetryDetails();this.r.forEach((n,t)=>{const g=n.filter(u=>!u.isDisposed);g.length===0?this.r.delete(t):this.r.set(t,g)}),this.r.forEach(n=>{for(const t of n)t.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(l,i){const t=this.r.get(l.value)?.filter(u=>!u.isDisposed);if(!t)return this.r.delete(l.value),!1;let g=!1;for(const u of t)u.ignoreUnhandledExtHostErrors||(u.logError(i),g=!0);return g}};e.$AQ=d,e.$AQ=d=Je([Ve(0,A.$zQ),Ve(1,O.$ak)],d);class r{static validateSender(l){if(typeof l!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof l.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof l.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof l.flush<"u"&&typeof l.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(l,i,n,t,g,u,$){this.g=n,this.h=t,this.i=g,this.j=u,this.a=new R.$le,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=l,this.d={isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}}updateTelemetryEnablements(l,i){this.e&&(this.d={isUsageEnabled:l,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(l){let i="properties"in l?l.properties??{}:l;return i=(0,o.$Kp)(i,[]),this.c&&(i=(0,I.$go)(i,this.c)),this.b||(i=(0,I.$go)(i,this.j)),"properties"in l?l.properties=i:l=i,l}k(l,i){this.f&&(this.g.publisher==="vscode"?l=this.g.name+"/"+l:l=this.g.identifier.value+"/"+l,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(l,i),this.h.trace(l,i))}logUsage(l,i){this.d.isUsageEnabled&&this.k(l,i)}logError(l,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof l=="string")this.k(l,i);else{const n={name:l.name,message:l.message,stack:l.stack,cause:l.cause},t=(0,o.$Kp)(n,[]),g=new Error(t.message,{cause:t.cause});g.stack=t.stack,g.name=t.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(g,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const l=this,i={logUsage:l.logUsage.bind(l),get isUsageEnabled(){return l.d.isUsageEnabled},get isErrorsEnabled(){return l.d.isErrorsEnabled},logError:l.logError.bind(l),dispose:l.dispose.bind(l),onDidChangeEnableStates:l.a.event.bind(l)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let l=this.f;this.f=void 0,Promise.resolve(l.flush()).then(l=void 0),this.e=void 0}else this.f=void 0}}e.$BQ=r;function s(c){const l=Date.now()-new Date(c).getTime();return isNaN(l)?!1:l<1e3*60*60*24}e.$DQ=(0,v.$Ei)("IExtHostTelemetry")}),define(Ne[24],Le([1,0,6,2,178,111,18,3]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kH=e.ActivationKind=e.$hH=e.$gH=e.$dH=e.ExtensionHostStartup=e.$cH=e.$bH=e.$aH=e.$_G=void 0,e.$eH=a,e.$fH=S,e.$iH=c,e.$jH=l,e.$_G=Object.freeze({identifier:new A.$qn("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:A.TargetPlatform.UNDEFINED,isUserBuiltin:!1,isUnderDevelopment:!1}),e.$aH="extensions.webWorker",e.$bH=(0,T.$Ei)("extensionService");class p{constructor(t){this.dependency=t}}e.$cH=p;var o;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(o||(e.ExtensionHostStartup=o={}));class I{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(t,g,u){this.c=t,this.d=g.slice(0),this.e=u.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$XG.createActivationEventsMap(this.d)}}set(t,g,u){if(this.c>t)throw new Error(`ExtensionHostExtensions: invalid versionId ${t} (current: ${this.c})`);const $=[],m=[],h=[],E=[],D=y(this.d),w=y(g),C=(N,L)=>N.extensionLocation.toString()===L.extensionLocation.toString()||N.isBuiltin===L.isBuiltin||N.isUserBuiltin===L.isUserBuiltin||N.isUnderDevelopment===L.isUnderDevelopment;for(const N of this.d){const L=w.get(N.identifier);if(!L){$.push(N.identifier),D.delete(N.identifier);continue}if(!C(N,L)){$.push(N.identifier),D.delete(N.identifier);continue}}for(const N of g){const L=D.get(N.identifier);if(!L){m.push(N);continue}if(!C(L,N)){$.push(L.identifier),D.delete(L.identifier);continue}}const k=new A.$rn(this.e),f=new A.$rn(u);for(const N of this.e)f.has(N)||h.push(N);for(const N of u)k.has(N)||E.push(N);const b=O.$XG.createActivationEventsMap(m),M={versionId:t,toRemove:$,toAdd:m,addActivationEvents:b,myToRemove:h,myToAdd:E};return this.delta(M),M}delta(t){if(this.c>=t.versionId)return null;const{toRemove:g,toAdd:u,myToRemove:$,myToAdd:m}=t,h=new A.$rn(g),E=new A.$rn($);for(let D=0;D<this.d.length;D++)h.has(this.d[D].identifier)&&(this.d.splice(D,1),D--);for(let D=0;D<this.e.length;D++)E.has(this.e[D])&&(this.e.splice(D,1),D--);for(const D of u)this.d.push(D);for(const D of m)this.e.push(D);return this.f=null,t}containsExtension(t){for(const g of this.e)if(A.$qn.equals(g,t))return!0;return!1}containsActivationEvent(t){return this.f||(this.f=this.g()),this.f.has(t)}g(){const t=new Set;for(const g of this.d){if(!this.containsExtension(g.identifier))continue;const u=O.$XG.readActivationEvents(g);for(const $ of u)t.add($)}return t}}e.$dH=I;function y(n){const t=new A.$sn;for(const g of n)t.set(g.identifier,g);return t}function a(n,t){return n.enabledApiProposals?n.enabledApiProposals.includes(t):!1}function S(n,t){if(!a(n,t))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}class d{constructor(t,g,u,$){this.codeLoadingTime=t,this.activateCallTime=g,this.activateResolvedTime=u,this.activationReason=$}}e.$gH=d;class r{constructor(t,g){this.description=t,this.value=g}}e.$hH=r;var s;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function c(n){return{type:n.isBuiltin?A.ExtensionType.System:A.ExtensionType.User,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,P.$Qp)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}function l(n,t){const g=(0,P.$Op)(n.manifest.publisher,n.manifest.name);return{id:g,identifier:new A.$qn(g),isBuiltin:n.type===A.ExtensionType.System,isUserBuiltin:n.type===A.ExtensionType.User&&n.isBuiltin,isUnderDevelopment:!!t,extensionLocation:n.location,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform,publisherDisplayName:n.publisherDisplayName,...n.manifest}}class i{constructor(){this.onDidRegisterExtensions=v.Event.None,this.onDidChangeExtensionsStatus=v.Event.None,this.onDidChangeExtensions=v.Event.None,this.onWillActivateByEvent=v.Event.None,this.onDidChangeResponsiveChange=v.Event.None,this.onWillStop=v.Event.None,this.extensions=[]}activateByEvent(t){return Promise.resolve(void 0)}activateById(t,g){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(t,g){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$kH=i}),define(Ne[206],Le([1,0,13,4,119,18,24,11,10]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6pc=e.$5pc=e.$4pc=e.$3pc=e.$2pc=e.$1pc=void 0,v=We(v);class o{static{this.NONE=new o(!1,-1,-1,-1)}constructor(l,i,n,t){this.startup=l,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=t}}e.$1pc=o;class I{constructor(l){this.a=l,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(l,i){return l===-1||i===-1?-1:i-l}build(){return new o(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$2pc=I;class y{constructor(l,i,n,t,g,u){this.activationFailed=l,this.activationFailedError=i,this.activationTimes=n,this.module=t,this.exports=g,this.disposable=u}}e.$3pc=y;class a extends y{constructor(l){super(!1,null,l,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}e.$4pc=a;class S extends y{constructor(){super(!1,null,o.NONE,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}e.$5pc=S;class d extends y{constructor(l){super(!0,l,o.NONE,{activate:void 0,deactivate:void 0},void 0,R.$Uc.None)}}let r=class{constructor(l,i,n,t){this.g=t,this.a=l,this.b=i,this.c=n,this.d=new O.$sn,this.f=Object.create(null)}dispose(){for(const[l,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const l=[];for(const[i,n]of this.d)l.push(n.wait());await Promise.all(l)}isActivated(l){const i=this.d.get(l);return!!(i&&i.value)}getActivatedExtension(l){const i=this.d.get(l);if(!i||!i.value)throw new Error(`Extension '${l.value}' is not known or not activated`);return i.value}async activateByEvent(l,i){if(this.f[l])return;const n=this.a.getExtensionDescriptionsForActivationEvent(l);await this.h(n.map(t=>({id:t.identifier,reason:{startup:i,extensionId:t.identifier,activationEvent:l}}))),this.f[l]=!0}activateById(l,i){const n=this.a.getExtensionDescription(l);if(!n)throw new Error(`Extension '${l.value}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(l){const i=l.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(l){if(this.d.has(l.id))return this.d.get(l.id);if(this.l(l.id))return this.k(l,null,[],null);const i=this.a.getExtensionDescription(l.id);if(!i){const g=new Error(`Cannot activate unknown extension '${l.id.value}'`),u=this.k(l,null,[],new d(g));return this.c.onExtensionActivationError(l.id,g,new A.$cH(l.id.value)),u}const n=[],t=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const g of t){if(this.m(g))continue;const u=this.d.get(g);if(u){n.push(u);continue}if(this.l(g)){n.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:l.reason}));continue}const $=this.a.getExtensionDescription(g);if($){if(!$.main&&!$.browser)continue;n.push(this.j({id:$.identifier,reason:l.reason}));continue}const m=i.displayName||i.identifier.value,h=new Error(`Cannot activate the '${m}' extension because it depends on unknown extension '${g}'`),E=this.k(l,i.displayName,[],new d(h));return this.c.onExtensionActivationError(i.identifier,h,new A.$cH(g)),E}return this.k(l,i.displayName,n,null)}k(l,i,n,t){const g=new s(l.id,i,l.reason,n,t,this.c,this.g);return this.d.set(l.id,g),g}l(l){return P.$Hdc.isHostExtension(l,this.a,this.b)}m(l){const i=this.b.getExtensionDescription(l);return i?!i.main&&!i.browser:!1}};e.$6pc=r,e.$6pc=r=Je([Ve(3,T.$_j)],r);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(l,i,n,t,g,u,$){this.c=l,this.d=i,this.f=n,this.g=t,this.h=g,this.j=u,this.k=$,this.a=new p.$Dh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let l=0;l<this.g.length;l++){const i=this.g[l];if(i.value&&!i.value.activationFailed){this.g.splice(l,1),l--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new d(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(l=>l.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(l){const i=new Error;if(l&&l.name&&(i.name=l.name),l&&l.message?i.message=`Activating extension '${this.c.value}' failed: ${l.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${l}.`,l&&l.stack&&(i.stack=l.stack),this.h=new d(i),this.b&&v.$3(l))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(l)}}};s=Je([Ve(6,T.$_j)],s)});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[120],Le([1,0,9,13,35,110,77,30,18,108,111,104]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=void 0,v=We(v),P=xt(P);const a=T.$qo.as(A.$ro.JSONContribution);class S{constructor(t,g,u){this.a=t,this.b=g,this.c=u}d(t,g){this.a({type:t,message:g,extensionId:this.b.identifier,extensionPointId:this.c})}error(t){this.d(P.default.Error,t)}warn(t){this.d(P.default.Warning,t)}info(t){this.d(P.default.Info,t)}}e.$6G=S;class d{static a(t){const g=new p.$rn;for(let u=0,$=t.length;u<$;u++)g.add(t[u].description.identifier);return g}static compute(t,g){if(!t||!t.length)return new d(g,[]);if(!g||!g.length)return new d([],t);const u=this.a(t),$=this.a(g),m=g.filter(E=>!u.has(E.description.identifier)),h=t.filter(E=>!$.has(E.description.identifier));return new d(m,h)}constructor(t,g){this.added=t,this.removed=g}}e.$7G=d;class r{constructor(t,g){this.name=t,this.defaultExtensionKind=g,this.a=null,this.b=null,this.c=null}setHandler(t){if(this.a!==null)throw new Error("Handler already set!");return this.a=t,this.d(),{dispose:()=>{this.a=null}}}acceptUsers(t){this.c=d.compute(this.b,t),this.b=t,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(t){(0,R.$Y)(t)}}}e.$8G=r;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[v.localize(1837,null),v.localize(1838,null)]},c="vscode://schemas/vscode-extensions";e.$9G={properties:{engines:{type:"object",description:v.localize(1839,null),properties:{vscode:{type:"string",description:v.localize(1840,null),default:"^1.22.0"}}},publisher:{description:v.localize(1841,null),type:"string"},displayName:{description:v.localize(1842,null),type:"string"},categories:{description:v.localize(1843,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:p.$pn},{type:"string",const:"Languages",deprecationMessage:v.localize(1844,null)}]}},galleryBanner:{type:"object",description:v.localize(1845,null),properties:{color:{description:v.localize(1846,null),type:"string"},theme:{description:v.localize(1847,null),type:"string",enum:["dark","light"]}}},contributes:{description:v.localize(1848,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:v.localize(1849,null)},enableProposedApi:{type:"boolean",deprecationMessage:v.localize(1850,null)},enabledApiProposals:{markdownDescription:v.localize(1851,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals).map(n=>n),markdownEnumDescriptions:Object.values(y.allApiProposals).map(n=>n.proposal)}},api:{markdownDescription:v.localize(1852,null),type:"string",enum:["none"],enumDescriptions:[v.localize(1853,null)]},activationEvents:{description:v.localize(1854,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:v.localize(1855,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:v.localize(1856,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:v.localize(1857,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:v.localize(1858,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:v.localize(1859,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:v.localize(1860,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:v.localize(1861,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:v.localize(1862,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:v.localize(1863,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:v.localize(1864,null),body:"onStartupFinished"},{label:"onTaskType",description:v.localize(1865,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:v.localize(1866,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:v.localize(1867,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:v.localize(1868,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:v.localize(1869,null)},{label:"onUri",body:"onUri",description:v.localize(1870,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:v.localize(1871,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:v.localize(1872,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:v.localize(1873,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:v.localize(1874,null)},{label:"onRenderer",description:v.localize(1875,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:v.localize(1876,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:v.localize(1877,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:v.localize(1878,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:v.localize(1879,null)},{label:"onChatParticipant",body:"onChatParticipant:${1:participantId}",description:v.localize(1880,null)},{label:"onLanguageModelTool",body:"onLanguageModelTool:${1:toolName}",description:v.localize(1881,null)},{label:"*",description:v.localize(1882,null),body:"*"}]}},badges:{type:"array",description:v.localize(1883,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:v.localize(1884,null)},href:{type:"string",description:v.localize(1885,null)},description:{type:"string",description:v.localize(1886,null)}}}},markdown:{type:"string",description:v.localize(1887,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:v.localize(1888,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:v.localize(1889,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$0o}},extensionPack:{description:v.localize(1890,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$0o}},extensionKind:{description:v.localize(1891,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:v.localize(1892,null)},{body:["workspace"],description:v.localize(1893,null)},{body:["ui","workspace"],description:v.localize(1894,null)},{body:["workspace","ui"],description:v.localize(1895,null)},{body:[],description:v.localize(1896,null)}]},capabilities:{description:v.localize(1897,null),type:"object",properties:{virtualWorkspaces:{description:v.localize(1898,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:v.localize(1899,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1900,null),v.localize(1901,null),v.localize(1902,null)]},description:{type:"string",markdownDescription:v.localize(1903,null)}}},untrustedWorkspaces:{description:v.localize(1904,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:v.localize(1905,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[v.localize(1906,null),v.localize(1907,null),v.localize(1908,null)]},restrictedConfigurations:{description:v.localize(1909,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:v.localize(1910,null)}}}}},sponsor:{description:v.localize(1911,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:v.localize(1912,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:v.localize(1913,null),type:"string"},"vscode:uninstall":{description:v.localize(1914,null),type:"string"}}},icon:{type:"string",description:v.localize(1915,null)},l10n:{type:"string",description:v.localize(1916,null)},pricing:{type:"string",markdownDescription:v.localize(1917,null),enum:["Free","Trial"],default:"Free"}}};class l{constructor(){this.a=new Map}registerExtensionPoint(t){if(this.a.has(t.extensionPoint))throw new Error("Duplicate extension point: "+t.extensionPoint);const g=new r(t.extensionPoint,t.defaultExtensionKind);return this.a.set(t.extensionPoint,g),t.activationEventsGenerator&&I.$XG.register(t.extensionPoint,t.activationEventsGenerator),e.$9G.properties.contributes.properties[t.extensionPoint]=t.jsonSchema,a.registerSchema(c,e.$9G),g}getExtensionPoints(){return Array.from(this.a.values())}}e.$0G=l;const i={ExtensionsRegistry:"ExtensionsRegistry"};T.$qo.add(i.ExtensionsRegistry,new l),e.$$G=T.$qo.as(i.ExtensionsRegistry),a.registerSchema(c,e.$9G),a.registerSchema(o.$tk,{properties:{extensionEnabledApiProposals:{description:v.localize(1918,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals).map(n=>n.proposal)}}]}}}})}),define(Ne[207],Le([1,0,6,40,4,12,9,18,3,11,24,120]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nH=e.$mH=e.$lH=e.ChatMessageRole=void 0;var a;(function(r){r[r.System=0]="System",r[r.User=1]="User",r[r.Assistant=2]="Assistant"})(a||(e.ChatMessageRole=a={})),e.$lH=(0,p.$Ei)("ILanguageModelsService");const S={type:"object",properties:{vendor:{type:"string",description:(0,A.localize)(8413,null)}}};e.$mH=y.$$G.registerExtensionPoint({extensionPoint:"languageModels",jsonSchema:{description:(0,A.localize)(8414,null),oneOf:[S,{type:"array",items:S}]},activationEventsGenerator:(r,s)=>{for(const c of r)s.push(`onLanguageModelChat:${c.vendor}`)}});let d=class{constructor(s,c){this.e=s,this.f=c,this.a=new P.$Tc,this.b=new Map,this.c=new Set,this.d=this.a.add(new v.$le),this.onDidChangeLanguageModels=this.d.event,this.a.add(e.$mH.setHandler(l=>{this.c.clear();for(const n of l){if(!(0,I.$eH)(n.description,"chatProvider")){n.collector.error((0,A.localize)(8415,null));continue}for(const t of R.Iterable.wrap(n.value)){if(this.c.has(t.vendor)){n.collector.error((0,A.localize)(8416,null,t.vendor));continue}if((0,O.$cf)(t.vendor)){n.collector.error((0,A.localize)(8417,null));continue}if(t.vendor.trim()!==t.vendor){n.collector.error((0,A.localize)(8418,null));continue}this.c.add(t.vendor)}}const i=[];for(const[n,t]of this.b)this.c.has(t.metadata.vendor)||(this.b.delete(n),i.push(n));i.length>0&&this.d.fire({removed:i})}))}dispose(){this.a.dispose(),this.b.clear()}getLanguageModelIds(){return Array.from(this.b.keys())}lookupLanguageModel(s){return this.b.get(s)?.metadata}async selectLanguageModels(s){if(s.vendor)await this.e.activateByEvent(`onLanguageModelChat:${s.vendor}}`);else{const l=Array.from(this.c).map(i=>this.e.activateByEvent(`onLanguageModelChat:${i}`));await Promise.all(l)}const c=[];for(const[l,i]of this.b)(s.vendor===void 0||i.metadata.vendor===s.vendor)&&(s.family===void 0||i.metadata.family===s.family)&&(s.version===void 0||i.metadata.version===s.version)&&(s.identifier===void 0||i.metadata.id===s.identifier)&&(!i.metadata.targetExtensions||i.metadata.targetExtensions.some(n=>T.$qn.equals(n,s.extension)))&&c.push(l);return this.f.trace("[LM] selected language models",s,c),c}registerLanguageModelChat(s,c){if(this.f.trace("[LM] registering language model chat",s,c.metadata),!this.c.has(c.metadata.vendor))throw new Error(`Chat response provider uses UNKNOWN vendor ${c.metadata.vendor}.`);if(this.b.has(s))throw new Error(`Chat response provider with identifier ${s} is already registered.`);return this.b.set(s,c),this.d.fire({added:[{identifier:s,metadata:c.metadata}]}),(0,P.$Sc)(()=>{this.b.delete(s)&&(this.d.fire({removed:[s]}),this.f.trace("[LM] UNregistered language model chat",s,c.metadata))})}async sendChatRequest(s,c,l,i,n){const t=this.b.get(s);if(!t)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return t.sendChatRequest(l,c,i,n)}computeTokenLength(s,c,l){const i=this.b.get(s);if(!i)throw new Error(`Chat response provider with identifier ${s} is not registered.`);return i.provideTokenCount(c,l)}};e.$nH=d,e.$nH=d=Je([Ve(0,I.$bH),Ve(1,o.$_j)],d)}),define(Ne[208],Le([1,0,9,14,25,120,31,6]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TI=void 0,v=We(v),R=We(R),P=We(P);const p={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:v.localize(3916,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:v.localize(3917,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:v.localize(3918,null),default:""}}};var o;(function(a){function S(d,r,s){if(!d)return;const c=R.$eg(d.type)?d.type:void 0;if(!c||c.length===0){s.error(v.localize(3919,null));return}const l=[];if(Array.isArray(d.required))for(const i of d.required)R.$eg(i)&&l.push(i);return{extensionId:r.value,taskType:c,required:l,properties:d.properties?P.$do(d.properties):{},when:d.when?A.$Cj.deserialize(d.when):void 0}}a.from=S})(o||(o={}));const I=O.$$G.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(a,S)=>{for(const d of a)d.type&&S.push(`onTaskType:${d.type}`)},jsonSchema:{description:v.localize(3920,null),type:"array",items:p}});class y{constructor(){this.d=new T.$le,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,d)=>{I.setHandler((r,s)=>{this.c=void 0;try{for(const c of s.removed){const l=c.value;for(const i of l)this.a&&i.type&&this.a[i.type]&&delete this.a[i.type]}for(const c of s.added){const l=c.value;for(const i of l){const n=o.from(i,c.description.identifier,c.collector);n&&(this.a[n.taskType]=n)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const d of this.all()){const r={type:"object",additionalProperties:!1};d.required.length>0&&(r.required=d.required.slice(0)),d.properties!==void 0?r.properties=P.$do(d.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[d.taskType]},S.push(r)}this.c={oneOf:S}}return this.c}}e.$TI=new y}),define(Ne[209],Le([1,0,9,14,23,25,31,208,43]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$4I=e.JsonSchemaVersion=e.ExecutionEngine=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$XI=e.ShellQuoting=e.$WI=e.$VI=e.$UI=void 0,v=We(v),R=We(R),P=We(P),O=We(O),e.$UI="settings",e.$VI=new A.$Vj("taskRunning",!1,v.localize(3904,null)),e.$WI=v.localize2(3906,"Tasks");var o;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(o||(e.ShellQuoting=o={})),e.$XI="$customized",function(q){function G(Q){if(!Q)return q.Strong;switch(Q.toLowerCase()){case"escape":return q.Escape;case"strong":return q.Strong;case"weak":return q.Weak;default:return q.Strong}}q.from=G}(o||(e.ShellQuoting=o={}));var I;(function(q){q.defaults={cwd:"${workspaceFolder}"}})(I||(e.CommandOptions=I={}));var y;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(y||(e.RevealKind=y={})),function(q){function G(Q){switch(Q.toLowerCase()){case"always":return q.Always;case"silent":return q.Silent;case"never":return q.Never;default:return q.Always}}q.fromString=G}(y||(e.RevealKind=y={}));var a;(function(q){q[q.Never=1]="Never",q[q.OnProblem=2]="OnProblem",q[q.Always=3]="Always"})(a||(e.RevealProblemKind=a={})),function(q){function G(Q){switch(Q.toLowerCase()){case"always":return q.Always;case"never":return q.Never;case"onproblem":return q.OnProblem;default:return q.OnProblem}}q.fromString=G}(a||(e.RevealProblemKind=a={}));var S;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(S||(e.PanelKind=S={})),function(q){function G(Q){switch(Q.toLowerCase()){case"shared":return q.Shared;case"dedicated":return q.Dedicated;case"new":return q.New;default:return q.Shared}}q.fromString=G}(S||(e.PanelKind=S={}));var d;(function(q){q.defaults={echo:!0,reveal:y.Always,revealProblems:a.Never,focus:!1,panel:S.Shared,showReuseMessage:!0,clear:!1}})(d||(e.PresentationOptions=d={}));var r;(function(q){q[q.Shell=1]="Shell",q[q.Process=2]="Process",q[q.CustomExecution=3]="CustomExecution"})(r||(e.RuntimeType=r={})),function(q){function G(ae){switch(ae.toLowerCase()){case"shell":return q.Shell;case"process":return q.Process;case"customExecution":return q.CustomExecution;default:return q.Process}}q.fromString=G;function Q(ae){switch(ae){case q.Shell:return"shell";case q.Process:return"process";case q.CustomExecution:return"customExecution";default:return"process"}}q.toString=Q}(r||(e.RuntimeType=r={}));var s;(function(q){function G(Q){return R.$eg(Q)?Q:Q.value}q.value=G})(s||(e.CommandString=s={}));var c;(function(q){q.Clean={_id:"clean",isDefault:!1},q.Build={_id:"build",isDefault:!1},q.Rebuild={_id:"rebuild",isDefault:!1},q.Test={_id:"test",isDefault:!1};function G(ae){return ae===q.Clean._id||ae===q.Build._id||ae===q.Rebuild._id||ae===q.Test._id}q.is=G;function Q(ae){if(ae!==void 0)return R.$eg(ae)?G(ae)?{_id:ae,isDefault:!1}:void 0:ae}q.from=Q})(c||(e.TaskGroup=c={}));var l;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.Folder=3]="Folder"})(l||(e.TaskScope=l={}));var i;(function(q){q.Workspace="workspace",q.Extension="extension",q.InMemory="inMemory",q.WorkspaceFile="workspaceFile",q.User="user";function G(Q){switch(Q){case q.User:return p.ConfigurationTarget.USER;case q.WorkspaceFile:return p.ConfigurationTarget.WORKSPACE;default:return p.ConfigurationTarget.WORKSPACE_FOLDER}}q.toConfigurationTarget=G})(i||(e.TaskSourceKind=i={}));var n;(function(q){q.parallel="parallel",q.sequence="sequence"})(n||(e.DependsOrder=n={}));var t;(function(q){q[q.default=1]="default",q[q.folderOpen=2]="folderOpen"})(t||(e.RunOnOptions=t={}));var g;(function(q){q.defaults={reevaluateOnRerun:!0,runOn:t.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class u{constructor(G,Q,ae,we,le,_){this._label="",this._id=G,Q&&(this._label=Q),ae&&(this.type=ae),this.runOptions=we,this.configurationProperties=le,this._source=_}getDefinition(G){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const G={folder:this.d(),id:this._id};return JSON.stringify(G)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(G,Q=!1){if(G===void 0)return!1;if(R.$eg(G))return G===this._label||G===this.configurationProperties.identifier||Q&&G===this._id;const ae=this.getDefinition(!0);return ae!==void 0&&ae._key===G._key}getQualifiedLabel(){const G=this.getWorkspaceFolder();return G?`${this._label} (${G.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(G){this.c===void 0&&(this.c=[]),G&&(this.c=this.c.concat(G))}get taskLoadMessages(){return this.c}}e.$YI=u;class $ extends u{constructor(G,Q,ae,we,le,_,ce,me){super(G,ae,void 0,ce,me,Q),this.command={},this._source=Q,this.hasDefinedMatchers=_,le&&(this.command=le)}clone(){return new $(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(G=!1){if(G&&this._source.customizes!==void 0)return this._source.customizes;{let Q;switch(this.command?this.command.runtime:void 0){case r.Shell:Q="shell";break;case r.Process:Q="process";break;case r.CustomExecution:Q="customExecution";break;case void 0:Q="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Q,_key:this._id,id:this._id}}}static is(G){return G instanceof $}getMapKey(){const G=this._source.config.workspaceFolder;return G?`${G.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$UI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const G=this.d();if(!G)return;let Q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Q+=this._source.kind);const ae={type:e.$XI,folder:G,id:Q};return JSON.stringify(ae)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ch(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(G){return new $(G._id,G._source,G._label,G.type,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.$ZI=$;class m extends u{constructor(G,Q,ae,we,le,_,ce){super(G,ae,we,_,ce,Q),this._source=Q,this.configures=le}static is(G){return G instanceof m}f(G){return G}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$ch(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$UI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const G=this.d();if(!G)return;let Q=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(Q+=this._source.kind);const ae={type:e.$XI,folder:G,id:Q};return JSON.stringify(ae)}}e.$1I=m;class h extends u{constructor(G,Q,ae,we,le,_,ce,me,oe){super(G,ae,we,me,oe,Q),this.defines=le,this.hasDefinedMatchers=ce,this.command=_,this.icon=oe.icon,this.hide=oe.hide}clone(){return new h(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(G){return G instanceof h}getMapKey(){const G=this._source.workspaceFolder;return G?`${this._source.scope.toString()}|${G.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===l.Folder&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const G={type:"contributed",scope:this._source.scope,id:this._id};return G.folder=this.d(),JSON.stringify(G)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(G){return new h(G._id,G._source,G._label,G.type,G.defines,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.$2I=h;class E extends u{constructor(G,Q,ae,we,le,_){super(G,ae,we,le,_,Q),this._source=Q}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(G){return G instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(G){return new E(G._id,G._source,G._label,G.type,G.runOptions,G.configurationProperties)}}e.$3I=E;var D;(function(q){q[q.Process=1]="Process",q[q.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(q){q._default=q.Terminal}(D||(e.ExecutionEngine=D={}));var w;(function(q){q[q.V0_1_0=1]="V0_1_0",q[q.V2_0_0=2]="V2_0_0"})(w||(e.JsonSchemaVersion=w={}));class C{constructor(G){this.c=new Map;for(let Q=0;Q<G.length;Q++)this.c.set(G[Q].uri.toString(),Q)}compare(G,Q){const ae=G.getWorkspaceFolder(),we=Q.getWorkspaceFolder();if(ae&&we){let le=this.c.get(ae.uri.toString());le=le===void 0?0:le+1;let _=this.c.get(we.uri.toString());return _=_===void 0?0:_+1,le===_?G._label.localeCompare(Q._label):le-_}else return!ae&&we?-1:ae&&!we?1:0}}e.$4I=C;var k;(function(q){q.DependsOnStarted="dependsOnStarted",q.AcquiredInput="acquiredInput",q.Start="start",q.ProcessStarted="processStarted",q.Active="active",q.Inactive="inactive",q.Changed="changed",q.Terminated="terminated",q.ProcessEnded="processEnded",q.End="end"})(k||(e.TaskEventKind=k={}));var f;(function(q){q.SingleRun="singleRun",q.Background="background"})(f||(e.TaskRunType=f={}));var b;(function(q){q[q.System=0]="System",q[q.User=1]="User",q[q.FolderOpen=2]="FolderOpen",q[q.ConfigurationChange=3]="ConfigurationChange",q[q.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var M;(function(q){function G(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?f.Background:f.SingleRun,group:me.configurationProperties.group,__task:me}}function Q(me,oe,ke){return{...G(me),kind:k.Start,terminalId:oe,resolvedVariables:ke}}q.start=Q;function ae(me,oe,ke){return{...G(me),kind:k.ProcessStarted,terminalId:oe,processId:ke}}q.processStarted=ae;function we(me,oe,ke){return{...G(me),kind:k.ProcessEnded,terminalId:oe,exitCode:ke}}q.processEnded=we;function le(me,oe,ke){return{...G(me),kind:k.Terminated,exitReason:ke,terminalId:oe}}q.terminated=le;function _(me,oe,ke){return{...G(oe),kind:me,terminalId:ke}}q.general=_;function ce(){return{kind:k.Changed}}q.changed=ce})(M||(e.TaskEvent=M={}));var N;(function(q){function G(ae){const we=Object.keys(ae).sort();let le="";for(const _ of we){let ce=ae[_];ce instanceof Object?ce=G(ce):typeof ce=="string"&&(ce=ce.replace(/,/g,",,")),le+=_+","+ce+","}return le}function Q(ae){const le={_key:G(ae),type:ae.taskType};return Object.assign(le,ae),le}q.create=Q})(N||(e.KeyedTaskIdentifier=N={}));var L;(function(q){q.AutoDetect="task.autoDetect",q.SaveBeforeRun="task.saveBeforeRun",q.ShowDecorations="task.showDecorations",q.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",q.SlowProviderWarning="task.slowProviderWarning",q.QuickOpenHistory="task.quickOpen.history",q.QuickOpenDetail="task.quickOpen.detail",q.QuickOpenSkip="task.quickOpen.skip",q.QuickOpenShowAll="task.quickOpen.showAll",q.AllowAutomaticTasks="task.allowAutomaticTasks",q.Reconnection="task.reconnection",q.VerboseLogging="task.verboseLogging"})(L||(e.TaskSettingId=L={}));var W;(function(q){q.Tasks="tasks",q.SuppressTaskName="tasks.suppressTaskName",q.Windows="tasks.windows",q.Osx="tasks.osx",q.Linux="tasks.linux",q.ShowOutput="tasks.showOutput",q.IsShellCommand="tasks.isShellCommand",q.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var K;(function(q){function G(Q,ae){const we=T.$TI.get(Q.type);if(we===void 0){const me=O.$do(Q);return delete me._key,N.create(me)}const le=Object.create(null);le.type=we.taskType;const _=new Set;we.required.forEach(me=>_.add(me));const ce=we.properties;for(const me of Object.keys(ce)){const oe=Q[me];if(oe!=null)le[me]=oe;else if(_.has(me)){const ke=ce[me];if(ke.default!==void 0)le[me]=O.$do(ke.default);else switch(ke.type){case"boolean":le[me]=!1;break;case"number":case"integer":le[me]=0;break;case"string":le[me]="";break;default:ae.error(v.localize(3905,null,JSON.stringify(Q,void 0,0),me));return}}}return N.create(le)}q.createTaskIdentifier=G})(K||(e.TaskDefinition=K={}))}),define(Ne[210],Le([1,0,13]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mdc=e.$Ldc=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,T)=>{this.b=A,this.d=T,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,v.$Y)(A))}then(A,T){return this.j().then(A,T)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Ldc=R;class P extends R{constructor(){super(),this.h=!0,this.i=new v.$4}}e.$Mdc=P}),define(Ne[39],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ww=e.$Tw=void 0,e.$Uw=P,e.$Vw=O;class v{static{this.count=0}constructor(p){this._proxyIdentifierBrand=void 0,this.sid=p,this.nid=++v.count}}e.$Tw=v;const R=[];function P(T){const p=new v(T);return R[p.nid]=p,p}function O(T){return R[T].sid}class A{constructor(p){this.value=p}}e.$Ww=A}),define(Ne[5],Le([1,0,39]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KN=e.$JN=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$IN=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var P;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput",r[r.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(P||(e.TabInputKind=P={}));var O;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var A;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var T;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(T||(e.WebviewMessageArrayBufferViewType=T={}));var p;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(p||(e.CellOutputKind=p={}));var o;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(o||(e.NotebookEditorRevealType=o={}));var I;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output",r[r.Hybrid=3]="Hybrid"})(I||(e.CandidatePortSource=I={}));class y{static{this.a=0}static mixin(s){return s._id=y.a++,s}}e.$IN=y;var a;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(a||(e.ISuggestDataDtoField=a={}));var S;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var d;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(d||(e.ExtHostTestingResource=d={})),e.$JN={MainThreadAuthentication:(0,v.$Uw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,v.$Uw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,v.$Uw)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,v.$Uw)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,v.$Uw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,v.$Uw)("MainThreadChatVariables"),MainThreadLanguageModelTools:(0,v.$Uw)("MainThreadChatSkills"),MainThreadClipboard:(0,v.$Uw)("MainThreadClipboard"),MainThreadCommands:(0,v.$Uw)("MainThreadCommands"),MainThreadComments:(0,v.$Uw)("MainThreadComments"),MainThreadConfiguration:(0,v.$Uw)("MainThreadConfiguration"),MainThreadConsole:(0,v.$Uw)("MainThreadConsole"),MainThreadDebugService:(0,v.$Uw)("MainThreadDebugService"),MainThreadDecorations:(0,v.$Uw)("MainThreadDecorations"),MainThreadDiagnostics:(0,v.$Uw)("MainThreadDiagnostics"),MainThreadDialogs:(0,v.$Uw)("MainThreadDiaglogs"),MainThreadDocuments:(0,v.$Uw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,v.$Uw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,v.$Uw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,v.$Uw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,v.$Uw)("MainThreadEditorTabs"),MainThreadErrors:(0,v.$Uw)("MainThreadErrors"),MainThreadTreeViews:(0,v.$Uw)("MainThreadTreeViews"),MainThreadDownloadService:(0,v.$Uw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,v.$Uw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,v.$Uw)("MainThreadLanguages"),MainThreadLogger:(0,v.$Uw)("MainThreadLogger"),MainThreadMessageService:(0,v.$Uw)("MainThreadMessageService"),MainThreadOutputService:(0,v.$Uw)("MainThreadOutputService"),MainThreadProgress:(0,v.$Uw)("MainThreadProgress"),MainThreadQuickDiff:(0,v.$Uw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,v.$Uw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,v.$Uw)("MainThreadStatusBar"),MainThreadSecretState:(0,v.$Uw)("MainThreadSecretState"),MainThreadStorage:(0,v.$Uw)("MainThreadStorage"),MainThreadSpeech:(0,v.$Uw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,v.$Uw)("MainThreadTelemetry"),MainThreadTerminalService:(0,v.$Uw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,v.$Uw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,v.$Uw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,v.$Uw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,v.$Uw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,v.$Uw)("MainThreadCustomEditors"),MainThreadUrls:(0,v.$Uw)("MainThreadUrls"),MainThreadUriOpeners:(0,v.$Uw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,v.$Uw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,v.$Uw)("MainThreadWorkspace"),MainThreadFileSystem:(0,v.$Uw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,v.$Uw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,v.$Uw)("MainThreadExtensionService"),MainThreadSCM:(0,v.$Uw)("MainThreadSCM"),MainThreadSearch:(0,v.$Uw)("MainThreadSearch"),MainThreadShare:(0,v.$Uw)("MainThreadShare"),MainThreadTask:(0,v.$Uw)("MainThreadTask"),MainThreadWindow:(0,v.$Uw)("MainThreadWindow"),MainThreadLabelService:(0,v.$Uw)("MainThreadLabelService"),MainThreadNotebook:(0,v.$Uw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,v.$Uw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,v.$Uw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,v.$Uw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,v.$Uw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,v.$Uw)("MainThreadInteractive"),MainThreadTheming:(0,v.$Uw)("MainThreadTheming"),MainThreadTunnelService:(0,v.$Uw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,v.$Uw)("MainThreadManagedSockets"),MainThreadTimeline:(0,v.$Uw)("MainThreadTimeline"),MainThreadTesting:(0,v.$Uw)("MainThreadTesting"),MainThreadLocalization:(0,v.$Uw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,v.$Uw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,v.$Uw)("MainThreadAiEmbeddingVector")},e.$KN={ExtHostCommands:(0,v.$Uw)("ExtHostCommands"),ExtHostConfiguration:(0,v.$Uw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,v.$Uw)("ExtHostDiagnostics"),ExtHostDebugService:(0,v.$Uw)("ExtHostDebugService"),ExtHostDecorations:(0,v.$Uw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,v.$Uw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,v.$Uw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,v.$Uw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,v.$Uw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,v.$Uw)("ExtHostEditors"),ExtHostTreeViews:(0,v.$Uw)("ExtHostTreeViews"),ExtHostFileSystem:(0,v.$Uw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,v.$Uw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,v.$Uw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,v.$Uw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,v.$Uw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,v.$Uw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,v.$Uw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,v.$Uw)("ExtHostStatusBar"),ExtHostShare:(0,v.$Uw)("ExtHostShare"),ExtHostExtensionService:(0,v.$Uw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,v.$Uw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,v.$Uw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,v.$Uw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,v.$Uw)("ExtHostSCM"),ExtHostSearch:(0,v.$Uw)("ExtHostSearch"),ExtHostTask:(0,v.$Uw)("ExtHostTask"),ExtHostWorkspace:(0,v.$Uw)("ExtHostWorkspace"),ExtHostWindow:(0,v.$Uw)("ExtHostWindow"),ExtHostWebviews:(0,v.$Uw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,v.$Uw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,v.$Uw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,v.$Uw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,v.$Uw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,v.$Uw)("ExtHostEditorTabs"),ExtHostProgress:(0,v.$Uw)("ExtHostProgress"),ExtHostComments:(0,v.$Uw)("ExtHostComments"),ExtHostSecretState:(0,v.$Uw)("ExtHostSecretState"),ExtHostStorage:(0,v.$Uw)("ExtHostStorage"),ExtHostUrls:(0,v.$Uw)("ExtHostUrls"),ExtHostUriOpeners:(0,v.$Uw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,v.$Uw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,v.$Uw)("ExtHostOutputService"),ExtHostLabelService:(0,v.$Uw)("ExtHostLabelService"),ExtHostNotebook:(0,v.$Uw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,v.$Uw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,v.$Uw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,v.$Uw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,v.$Uw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,v.$Uw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,v.$Uw)("ExtHostInteractive"),ExtHostChatAgents2:(0,v.$Uw)("ExtHostChatAgents"),ExtHostChatVariables:(0,v.$Uw)("ExtHostChatVariables"),ExtHostLanguageModelTools:(0,v.$Uw)("ExtHostChatSkills"),ExtHostChatProvider:(0,v.$Uw)("ExtHostChatProvider"),ExtHostSpeech:(0,v.$Uw)("ExtHostSpeech"),ExtHostEmbeddings:(0,v.$Uw)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,v.$Uw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,v.$Uw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,v.$Uw)("ExtHostTheming"),ExtHostTunnelService:(0,v.$Uw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,v.$Uw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,v.$Uw)("ExtHostAuthentication"),ExtHostTimeline:(0,v.$Uw)("ExtHostTimeline"),ExtHostTesting:(0,v.$Uw)("ExtHostTesting"),ExtHostTelemetry:(0,v.$Uw)("ExtHostTelemetry"),ExtHostLocalization:(0,v.$Uw)("ExtHostLocalization")}}),define(Ne[84],Le([1,0,3,11,5,16]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ppc=e.$opc=e.$npc=void 0,P=We(P),e.$npc=(0,v.$Ei)("IExtHostApiDeprecationService");let A=class{constructor(p,o){this.c=o,this.a=new Set,this.b=p.getProxy(P.$JN.MainThreadTelemetry)}report(p,o,I){const y=this.d(p,o);this.a.has(y)||(this.a.add(y),o.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${p}' is deprecated. ${I}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:o.identifier.value,apiId:p}))}d(p,o){return`${p}-${o.identifier.value}`}};e.$opc=A,e.$opc=A=Je([Ve(0,O.$jQ),Ve(1,R.$_j)],A),e.$ppc=Object.freeze(new class{report(T,p,o){}})}),define(Ne[211],Le([1,0,5]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cpc=void 0;class R{constructor(O){const A=O.getProxy(v.$JN.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(T){return A.$writeText(T)}})}}e.$Cpc=R}),define(Ne[212],Le([1,0,25,5,26,16]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yrc=void 0;let A=class{constructor(I,y){this.a=I.getProxy(R.$JN.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(I,y){const a=this,S=console[I];Object.defineProperty(console,I,{set:()=>{},get:()=>function(){a.e(I,y,S,arguments)}})}e(I,y,a,S){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:p(S,this.b)}),this.c&&this.f(I,a,S)}};e.$yrc=A,e.$yrc=A=Je([Ve(0,O.$jQ),Ve(1,P.$zQ)],A);const T=1e5;function p(o,I){const y=[];if(o.length)for(let a=0;a<o.length;a++){let S=o[a];if(typeof S>"u")S="undefined";else if(S instanceof Error){const d=S;d.stack?S=d.stack:S=d.toString()}y.push(S)}if(I){const a=new Error().stack;a&&y.push({__$stack:a.split(`
`).slice(3).join(`
`)})}try{const a=(0,v.$io)(y);return a.length>T?"Output omitted for a large object that exceeds the limits":a}catch(a){return`Output omitted for an object that cannot be inspected ('${a.toString()}')`}}}),define(Ne[213],Le([1,0,2,5,24]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eqc=void 0;class O{constructor(T){this.a=T.getProxy(R.$JN.MainThreadDialogs)}showOpenDialog(T,p){return p?.allowUIResources&&(0,P.$fH)(T,"showLocal"),this.a.$showOpenDialog(p).then(o=>o?o.map(I=>v.URI.revive(I)):void 0)}showSaveDialog(T){return this.a.$showSaveDialog(T).then(p=>p?v.URI.revive(p):void 0)}}e.$Eqc=O}),define(Ne[214],Le([1,0,21,6,4,5]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hqc=void 0;class A{constructor(p){this.b=new Map,this.c=new R.$le,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=p.getProxy(O.$JN.MainThreadEmbeddings)}registerEmbeddingsProvider(p,o,I){if(this.d.has(o))throw new Error("An embeddings provider for this model is already registered");const y=this.e++;return this.a.$registerEmbeddingProvider(y,o),this.b.set(y,{id:o,provider:I}),(0,P.$Sc)(()=>{this.d.delete(o),this.a.$unregisterEmbeddingProvider(y),this.b.delete(y)})}async computeEmbeddings(p,o,I){I??=v.CancellationToken.None;let y=!1;typeof o=="string"&&(o=[o],y=!0);const a=await this.a.$computeEmbeddings(p,o,I);if(a.length!==o.length)throw new Error;if(y){if(a.length!==1)throw new Error;return a[0]}return a}async $provideEmbeddings(p,o,I){const y=this.b.get(p);if(!y)return[];const a=await y.provider.provideEmbeddings(o,I);return a||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(p){this.d=new Set(p),this.c.fire()}}e.$Hqc=A}),define(Ne[215],Le([1,0,4,5]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yqc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(R.$JN.MainThreadLabelService)}$registerResourceLabelFormatter(A){const T=this.b++;return this.a.$registerResourceLabelFormatter(T,A),(0,v.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(T)})}}e.$Yqc=P}),define(Ne[85],Le([1,0,20,12,2,3,11,5,26,16]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iqc=e.$hqc=void 0;let I=class{constructor(a,S,d){this.f=d,this.d=new Map,this.a=S.getProxy(T.$JN.MainThreadLocalization),this.b=a.environment.appLanguage,this.c=this.b===v.$h}getMessage(a,S){const{message:d,args:r,comment:s}=S;if(this.c)return(0,R.$ef)(d,r??{});let c=d;s&&s.length>0&&(c+=`/${Array.isArray(s)?s.join(""):s}`);const l=this.d.get(a)?.contents[c];return l||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${c}`),(0,R.$ef)(l??d,r??{})}getBundle(a){return this.d.get(a)?.contents}getBundleUri(a){return this.d.get(a)?.uri}async initializeLocalizedMessages(a){if(this.c||!a.l10n&&!a.isBuiltin||this.d.has(a.identifier.value))return;let S;const d=await this.g(a);if(!d){this.f.error(`No bundle location found for extension ${a.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(d),s=JSON.parse(r);S=a.isBuiltin?s.contents?.bundle:s}catch(r){this.f.error(`Failed to load translations for ${a.identifier.value} from ${d}: ${r.message}`);return}S&&this.d.set(a.identifier.value,{contents:S,uri:d})}async g(a){if(a.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(a.identifier.value,this.b);return P.URI.revive(S)}return a.l10n?P.URI.joinPath(a.extensionLocation,a.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$hqc=I,e.$hqc=I=Je([Ve(0,p.$zQ),Ve(1,o.$jQ),Ve(2,A.$_j)],I),e.$iqc=(0,O.$Ei)("IExtHostLocalizationService")}),define(Ne[216],Le([1,0,11,5,26,16,2,36]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xrc=void 0;let p=class extends v.$kk{constructor(y,a){super(a.logLevel,a.logsLocation,a.loggers.map(S=>(0,T.$bi)(S))),this.r=y.getProxy(R.$JN.MainThreadLogger)}$setLogLevel(y,a){a?this.setLogLevel(A.URI.revive(a),y):this.setLogLevel(y)}setVisibility(y,a){super.setVisibility(y,a),this.r.$setVisibility(y,a)}s(y,a,S){return new o(this.r,y,a,S)}};e.$xrc=p,e.$xrc=p=Je([Ve(0,O.$jQ),Ve(1,P.$zQ)],p);class o extends v.$fk{constructor(y,a,S,d){super(d?.logLevel==="always"),this.r=y,this.s=a,this.m=!1,this.n=[],this.setLevel(S),this.r.$createLogger(a,d).then(()=>{this.u(this.n),this.m=!0})}g(y,a){const S=[[y,a]];this.m?this.u(S):this.n.push(...S)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ne[86],Le([1,0,5,3,4,16,22]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kqc=e.$jqc=void 0,e.$jqc=(0,R.$Ei)("IExtHostManagedSockets");let T=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(v.$JN.MainThreadManagedSockets)}setFactory(y,a){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new p(y,a),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const a=++this.b,S=await this.c.makeConnection(),d=new P.$Tc;return this.d.set(a,new o(a,S,d)),d.add((0,P.$Sc)(()=>this.d.delete(a))),d.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(a),d.dispose()})),d.add(S.onDidClose(r=>{this.a.$onDidManagedSocketClose(a,r?.stack??r?.message),d.dispose()})),d.add(S.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(a,A.$Ne.wrap(r)))),a}$remoteSocketWrite(y,a){this.d.get(y)?.actual.send(a.buffer)}$remoteSocketEnd(y){const a=this.d.get(y);a&&(a.actual.end(),a.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$kqc=T,e.$kqc=T=Je([Ve(0,O.$jQ)],T);class p{constructor(y,a){this.socketFactoryId=y,this.makeConnection=a}}class o extends P.$Uc{constructor(y,a,S){super(),this.socketId=y,this.actual=a,this.B(S)}}}),define(Ne[217],Le([1,0,5,11,24]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2qc=void 0;function O(T){return T&&T.title}let A=class{constructor(p,o){this.b=o,this.a=p.getProxy(v.$JN.MainThreadMessageService)}showMessage(p,o,I,y,a){const S={source:{identifier:p.identifier,label:p.displayName||p.name}};let d;typeof y=="string"||O(y)?d=[y,...a]:(S.modal=y?.modal,S.useCustom=y?.useCustom,S.detail=y?.detail,d=a),S.useCustom&&(0,P.$fH)(p,"resolvers");const r=[];let s=!1;for(let c=0;c<d.length;c++){const l=d[c];if(typeof l=="string")r.push({title:l,handle:c,isCloseAffordance:!1});else if(typeof l=="object"){const{title:i,isCloseAffordance:n}=l;r.push({title:i,isCloseAffordance:!!n,handle:c}),n&&(s?this.b.warn(`[${p.identifier}] Only one message item can have 'isCloseAffordance':`,l):s=!0)}else this.b.warn(`[${p.identifier}] Invalid message item:`,l)}return this.a.$showMessage(o,I,S,r).then(c=>{if(typeof c=="number")return d[c]})}};e.$2qc=A,e.$2qc=A=Je([Ve(1,R.$_j)],A)}),define(Ne[218],Le([1,0,4,14,2,24,5]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$qc=void 0;class T{constructor(o){this.b=new Map,this.a=o.getProxy(A.$JN.MainThreadProfileContentHandlers)}registerProfileContentHandler(o,I,y){if((0,O.$fH)(o,"profileContentHandlers"),this.b.has(I))throw new Error(`Handler with id '${I}' already registered`);return this.b.set(I,y),this.a.$registerProfileContentHandler(I,y.name,y.description,o.identifier.value),(0,v.$Sc)(()=>{this.b.delete(I),this.a.$unregisterProfileContentHandler(I)})}async $saveProfile(o,I,y,a){const S=this.b.get(o);if(!S)throw new Error(`Unknown handler with id: ${o}`);return S.saveProfile(I,y,a)}async $readProfile(o,I,y){const a=this.b.get(o);if(!a)throw new Error(`Unknown handler with id: ${o}`);return a.readProfile((0,R.$eg)(I)?I:P.URI.revive(I),y)}}e.$$qc=T}),define(Ne[87],Le([1,0,5,6,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fqc=e.$eqc=void 0;class O{constructor(T){this.b=new R.$le,this.onDidChangePassword=this.b.event,this.a=T.getProxy(v.$JN.MainThreadSecretState)}async $onDidChangePassword(T){this.b.fire(T)}get(T,p){return this.a.$getPassword(T,p)}store(T,p,o){return this.a.$setPassword(T,p,o)}delete(T,p){return this.a.$deletePassword(T,p)}}e.$eqc=O,e.$fqc=(0,P.$Ei)("IExtHostSecretState")}),define(Ne[219],Le([1,0,21,4,5]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$frc=void 0;class O{static{this.a=1}constructor(T){this.c=new Map,this.d=new Map,this.f=new Map,this.b=T.getProxy(P.$JN.MainThreadSpeech)}async $createSpeechToTextSession(T,p,o){const I=this.c.get(T);if(!I)return;const y=new R.$Tc,a=new v.$we;this.d.set(p,a);const S=await I.provideSpeechToTextSession(a.token,o?{language:o}:void 0);S&&(y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(p,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $cancelSpeechToTextSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}async $createTextToSpeechSession(T,p,o){const I=this.c.get(T);if(!I)return;const y=new R.$Tc,a=new v.$we;this.d.set(p,a);const S=await I.provideTextToSpeechSession(a.token,o?{language:o}:void 0);S&&(this.f.set(p,S),y.add(S.onDidChange(d=>{a.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(p,d)})),y.add(a.token.onCancellationRequested(()=>y.dispose())))}async $synthesizeSpeech(T,p){this.f.get(T)?.synthesize(p)}async $cancelTextToSpeechSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T),this.f.delete(T)}async $createKeywordRecognitionSession(T,p){const o=this.c.get(T);if(!o)return;const I=new R.$Tc,y=new v.$we;this.d.set(p,y);const a=await o.provideKeywordRecognitionSession(y.token);a&&(I.add(a.onDidChange(S=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(p,S)})),I.add(y.token.onCancellationRequested(()=>I.dispose())))}async $cancelKeywordRecognitionSession(T){this.d.get(T)?.dispose(!0),this.d.delete(T)}registerProvider(T,p,o){const I=O.a++;return this.c.set(I,o),this.b.$registerProvider(I,p,{extension:T,displayName:T.value}),(0,R.$Sc)(()=>{this.b.$unregisterProvider(I),this.c.delete(I)})}}e.$frc=O}),define(Ne[88],Le([1,0,5,6,3]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8pc=e.$7pc=void 0;class O{constructor(T,p){this.c=p,this.b=new R.$le,this.onDidChangeStorage=this.b.event,this.a=T.getProxy(v.$JN.MainThreadStorage)}registerExtensionStorageKeysToSync(T,p){this.a.$registerExtensionStorageKeysToSync(T,p)}async initializeExtensionStorage(T,p,o){const I=await this.a.$initializeExtensionStorage(T,p);let y;return I&&(y=this.d(T,p,I)),y||o}setValue(T,p,o){return this.a.$setValue(T,p,o)}$acceptValue(T,p,o){const I=this.d(T,p,o);I&&this.b.fire({shared:T,key:p,value:I})}d(T,p,o){try{return JSON.parse(o)}catch(I){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${p}, global: ${T}): ${I}`)}}}e.$7pc=O,e.$8pc=(0,P.$Ei)("IExtHostStorage")}),define(Ne[220],Le([1,0,4,15,2,5]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rrc=void 0;class A{static{this.a=new Set([R.Schemas.http,R.Schemas.https])}constructor(p){this.c=new Map,this.b=p.getProxy(O.$JN.MainThreadUriOpeners)}registerExternalUriOpener(p,o,I,y){if(this.c.has(o))throw new Error(`Opener with id '${o}' already registered`);const a=y.schemes.find(S=>!A.a.has(S));if(a)throw new Error(`Scheme '${a}' is not supported. Only http and https are currently supported.`);return this.c.set(o,I),this.b.$registerUriOpener(o,y.schemes,p,y.label),(0,v.$Sc)(()=>{this.c.delete(o),this.b.$unregisterUriOpener(o)})}async $canOpenUri(p,o,I){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener with id: ${p}`);const a=P.URI.revive(o);return y.canOpenExternalUri(a,I)}async $openUri(p,o,I){const y=this.c.get(p);if(!y)throw new Error(`Unknown opener id: '${p}'`);return y.openExternalUri(P.URI.revive(o.resolvedUri),{sourceUri:P.URI.revive(o.sourceUri)},I)}}e.$rrc=A}),define(Ne[221],Le([1,0,5,2,4,13,18]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$src=void 0;class T{static{this.a=0}constructor(o){this.c=new A.$rn,this.d=new Map,this.b=o.getProxy(v.$JN.MainThreadUrls)}registerUriHandler(o,I){const y=o.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const a=T.a++;return this.c.add(y),this.d.set(a,I),this.b.$registerUriHandler(a,y,o.displayName||o.name),(0,P.$Sc)(()=>{this.c.delete(y),this.d.delete(a),this.b.$unregisterUriHandler(a)})}$handleExternalUri(o,I){const y=this.d.get(o);if(!y)return Promise.resolve(void 0);try{y.handleUri(R.URI.revive(I))}catch(a){(0,O.$Y)(a)}return Promise.resolve(void 0)}async createAppUri(o){return R.URI.revive(await this.b.$createAppUri(o))}}e.$src=T}),define(Ne[222],Le([1,0,22,5]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ttb=O,e.$Utb=T,R=We(R);class P{constructor(){this.buffers=[]}add(o){let I=this.buffers.indexOf(o);return I<0&&(I=this.buffers.length,this.buffers.push(o)),I}}function O(p,o){if(o.serializeBuffersForPostMessage){const I=new P,a=JSON.stringify(p,(d,r)=>{if(r instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r)};if(ArrayBuffer.isView(r)){const s=A(r);if(s)return{$$vscode_array_buffer_reference$$:!0,index:I.add(r.buffer),view:{type:s,byteLength:r.byteLength,byteOffset:r.byteOffset}}}return r}),S=I.buffers.map(d=>{const r=new Uint8Array(d);return v.$Ne.wrap(r)});return{message:a,buffers:S}}else return{message:JSON.stringify(p),buffers:[]}}function A(p){switch(p.constructor.name){case"Int8Array":return R.WebviewMessageArrayBufferViewType.Int8Array;case"Uint8Array":return R.WebviewMessageArrayBufferViewType.Uint8Array;case"Uint8ClampedArray":return R.WebviewMessageArrayBufferViewType.Uint8ClampedArray;case"Int16Array":return R.WebviewMessageArrayBufferViewType.Int16Array;case"Uint16Array":return R.WebviewMessageArrayBufferViewType.Uint16Array;case"Int32Array":return R.WebviewMessageArrayBufferViewType.Int32Array;case"Uint32Array":return R.WebviewMessageArrayBufferViewType.Uint32Array;case"Float32Array":return R.WebviewMessageArrayBufferViewType.Float32Array;case"Float64Array":return R.WebviewMessageArrayBufferViewType.Float64Array;case"BigInt64Array":return R.WebviewMessageArrayBufferViewType.BigInt64Array;case"BigUint64Array":return R.WebviewMessageArrayBufferViewType.BigUint64Array}}function T(p,o){const I=o.map(S=>{const d=new ArrayBuffer(S.byteLength);return new Uint8Array(d).set(S.buffer),d}),y=o.length?(S,d)=>{if(d&&typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const r=d,{index:s}=r,c=I[s];if(r.view)switch(r.view.type){case R.WebviewMessageArrayBufferViewType.Int8Array:return new Int8Array(c,r.view.byteOffset,r.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8Array:return new Uint8Array(c,r.view.byteOffset,r.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint8ClampedArray:return new Uint8ClampedArray(c,r.view.byteOffset,r.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int16Array:return new Int16Array(c,r.view.byteOffset,r.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint16Array:return new Uint16Array(c,r.view.byteOffset,r.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Int32Array:return new Int32Array(c,r.view.byteOffset,r.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Uint32Array:return new Uint32Array(c,r.view.byteOffset,r.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float32Array:return new Float32Array(c,r.view.byteOffset,r.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.Float64Array:return new Float64Array(c,r.view.byteOffset,r.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigInt64Array:return new BigInt64Array(c,r.view.byteOffset,r.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case R.WebviewMessageArrayBufferViewType.BigUint64Array:return new BigUint64Array(c,r.view.byteOffset,r.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return d}:void 0;return{message:JSON.parse(p,y),arrayBuffers:I}}}),define(Ne[67],Le([1,0,6,4,15,25,2,175,222,82,5]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tpc=e.$Rpc=void 0,e.$Spc=a,e.$Upc=r,e.$Vpc=s,O=We(O),I=We(I);class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;constructor(n,t,g,u,$,m,h){this.#a="",this.#c=!1,this.#l=!1,this._onMessageEmitter=new v.$le,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new v.$le,this._onDidDispose=this.#h.event,this.#e=n,this.#t=t,this.#o=g,this.#n=u,this.#s=$,this.#r=m,this.#u=a(m),this.#d=S(m),this.#i=h}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#l=!0,(0,o.$EDb)(n,this.#n)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===P.Schemas.https||n.scheme===P.Schemas.http){let t=n.toString();return t.endsWith("/")||(t+="/"),t+" "+o.$DDb}return o.$DDb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#l&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#l=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#o}set options(n){this.a(),O.$ho(this.#o,n)||this.#t.$setOptions(this.#e,s(this.#r,this.#s,n)),this.#o=n}async postMessage(n){if(this.#c)return!1;const t=(0,p.$Ttb)(n,{serializeBuffersForPostMessage:this.#u});return this.#t.$postMessage(this.#e,t.message,...t.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const t=this.#r.extensionLocation?.scheme===P.Schemas.vscodeRemote,g=this.#r.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,$,m,h,E,D)=>{const w=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),C=(0,o.$EDb)(w,{isRemote:t,authority:g}).toString();return`${$}${C}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(u,$,m,h,E,D)=>{const w=A.URI.from({scheme:h||"file",path:decodeURIComponent(E)}),C=(0,o.$EDb)(w,{isRemote:t,authority:g}).toString();return`${$}${C}${D}`})}}e.$Rpc=y;function a(i){try{const n=(0,T.$1p)((0,T.$Zp)(i.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}function S(i){try{const n=(0,T.$1p)((0,T.$Zp)(i.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class d extends R.$Uc{constructor(n,t,g,u,$){super(),this.c=t,this.f=g,this.g=u,this.h=$,this.b=new Map,this.a=n.getProxy(I.$JN.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,t,g){const u=this.j(n);if(u){const{message:$}=(0,p.$Utb)(t,g.value);u._onMessageEmitter.fire($)}}$onMissingCsp(n,t){this.g.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,t,g){const u=new y(n,this.a,c(t),this.c,this.f,g,this.h);this.b.set(n,u);const $=u._onDidDispose(()=>{$.dispose(),this.deleteWebview(n)});return u}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$Tpc=d;function r(i){return{id:i.identifier,location:i.extensionLocation}}function s(i,n,t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots||l(i,n)}}function c(i){return{enableCommandUris:i.enableCommandUris,enableScripts:i.enableScripts,enableForms:i.enableForms,portMapping:i.portMapping,localResourceRoots:i.localResourceRoots?.map(n=>A.URI.from(n))}}function l(i,n){return[...(n?.getWorkspaceFolders()||[]).map(t=>t.uri),i.extensionLocation]}}),define(Ne[121],Le([1,0,6,15,12,2,3,16,5]),function(ve,e,v,R,P,O,A,T,p){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$vrc=e.$urc=void 0;let I=class{static{o=this}static{this.a={focused:!0,active:!0}}getState(){const a=this.d;return{get focused(){return a.focused},get active(){return a.active}}}constructor(a){this.c=new v.$le,this.onDidChangeWindowState=this.c.event,this.d=o.a,this.b=a.getProxy(p.$JN.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:d})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",d)})}$onDidChangeWindowFocus(a){this.onDidChangeWindowProperty("focused",a)}$onDidChangeWindowActive(a){this.onDidChangeWindowProperty("active",a)}onDidChangeWindowProperty(a,S){S!==this.d[a]&&(this.d={...this.d,[a]:S},this.c.fire(this.d))}openUri(a,S){let d;if(typeof a=="string"){d=a;try{a=O.URI.parse(a)}catch{return Promise.reject(`Invalid uri - '${a}'`)}}return(0,P.$cf)(a.scheme)?Promise.reject("Invalid scheme - cannot be empty"):a.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${a.scheme}'`):this.b.$openUri(a,d,S)}async asExternalUri(a,S){if((0,P.$cf)(a.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this.b.$asExternalUri(a,S);return O.URI.from(d)}};e.$urc=I,e.$urc=I=o=Je([Ve(0,T.$jQ)],I),e.$vrc=(0,A.$Ei)("IExtHostWindow")}),define(Ne[223],Le([1,0,212,26,16]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Itc=void 0;let O=class extends v.$yrc{constructor(T,p){super(T,p)}f(T,p,o){p.apply(console,o)}};e.$Itc=O,e.$Itc=O=Je([Ve(0,P.$jQ),Ve(1,R.$zQ)],O)}),define(Ne[224],Le([1,0,10,22,21,27,13,6,4,37,150,210,39]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.ResponsiveState=e.RequestInitiator=void 0,e.$Ndc=l,e.$Odc=i,A=We(A);function d(M,N){try{return JSON.stringify(M,N)}catch{return"null"}}const r="$$ref$$",s={[r]:-1};class c{constructor(N,L){this.jsonString=N,this.referencedBuffers=L}}function l(M,N=null,L=!1){const W=[];return{jsonString:(L?d:JSON.stringify)(M,(q,G)=>{if(typeof G>"u")return s;if(typeof G=="object"){if(G instanceof R.$Ne){const Q=W.push(G)-1;return{[r]:Q}}if(N)return N(q,G)}return G}),referencedBuffers:W}}function i(M,N,L){return JSON.parse(M,(W,K)=>{if(K){const q=K[r];if(typeof q=="number")return N[q];if(L&&K.$mid===o.MarshalledId.Uri)return L.transformIncoming(K)}return K})}function n(M,N){return JSON.stringify(M,N)}function t(M){return M?(N,L)=>L&&L.$mid===o.MarshalledId.Uri?M.transformOutgoing(L):L:null}var g;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));var u;(function(M){M[M.Responsive=0]="Responsive",M[M.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const $=()=>{},m=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class E extends p.$Uc{static{S=m}static{this.a=3*1e3}constructor(N,L=null,W=null){super(),this[S]=!0,this.b=this.B(new T.$le),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=L,this.g=W,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let K=0,q=a.$Tw.count;K<q;K++)this.m[K]=null,this.s[K]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=u.Responsive,this.z=0,this.C=0,this.D=this.B(new v.$Qh(()=>this.H(),1e3)),this.B(this.c.onMessage(K=>this.L(K)))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const L=this.w[N];delete this.w[N],L.resolveErr(A.$5())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+E.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+E.a,this.z--,this.z===0&&this.D.cancel(),this.I(u.Responsive)}H(){this.z!==0&&(Date.now()>this.C?this.I(u.Unresponsive):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,I.$On)(N,this.g):N}getProxy(N){const{nid:L,sid:W}=N;return this.s[L]||(this.s[L]=this.J(L,W)),this.s[L]}J(N,L){const W={get:(K,q)=>(typeof q=="string"&&!K[q]&&q.charCodeAt(0)===O.CharCode.DollarSign&&(K[q]=(...G)=>this.U(N,q,G)),q===h?L:K[q])};return new Proxy(Object.create(null),W)}set(N,L){return this.m[N.nid]=L,L}assertRegistered(N){for(let L=0,W=N.length;L<W;L++){const K=N[L];if(!this.m[K.nid])throw new Error(`Missing proxy instance ${K.sid}`)}}L(N){if(this.j)return;const L=N.byteLength,W=w.read(N,0),K=W.readUInt8(),q=W.readUInt32();switch(K){case f.RequestJSONArgs:case f.RequestJSONArgsWithCancellation:{let{rpcId:G,method:Q,args:ae}=k.deserializeRequestJSONArgs(W);this.g&&(ae=(0,I.$On)(ae,this.g)),this.M(L,q,G,Q,ae,K===f.RequestJSONArgsWithCancellation);break}case f.RequestMixedArgs:case f.RequestMixedArgsWithCancellation:{let{rpcId:G,method:Q,args:ae}=k.deserializeRequestMixedArgs(W);this.g&&(ae=(0,I.$On)(ae,this.g)),this.M(L,q,G,Q,ae,K===f.RequestMixedArgsWithCancellation);break}case f.Acknowledged:{this.f?.logIncoming(L,q,g.LocalSide,"ack"),this.G(q);break}case f.Cancel:{this.N(L,q);break}case f.ReplyOKEmpty:{this.O(L,q,void 0);break}case f.ReplyOKJSON:{let G=k.deserializeReplyOKJSON(W);this.g&&(G=(0,I.$On)(G,this.g)),this.O(L,q,G);break}case f.ReplyOKJSONWithBuffers:{const G=k.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(L,q,G);break}case f.ReplyOKVSBuffer:{const G=k.deserializeReplyOKVSBuffer(W);this.O(L,q,G);break}case f.ReplyErrError:{let G=k.deserializeReplyErrError(W);this.g&&(G=(0,I.$On)(G,this.g)),this.P(L,q,G);break}case f.ReplyErrEmpty:{this.P(L,q,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,L,W,K,q,G){this.f?.logIncoming(N,L,g.OtherSide,`receiveRequest ${(0,a.$Vw)(W)}.${K}(`,q);const Q=String(L);let ae,we;if(G){const _=new P.$we;q.push(_.token),ae=this.Q(W,K,q),we=()=>_.cancel()}else ae=this.Q(W,K,q),we=$;this.u[Q]=we;const le=k.serializeAcknowledged(L);this.f?.logOutgoing(le.byteLength,L,g.OtherSide,"ack"),this.c.send(le),ae.then(_=>{delete this.u[Q];const ce=k.serializeReplyOK(L,_,this.h);this.f?.logOutgoing(ce.byteLength,L,g.OtherSide,"reply:",_),this.c.send(ce)},_=>{delete this.u[Q];const ce=k.serializeReplyErr(L,_);this.f?.logOutgoing(ce.byteLength,L,g.OtherSide,"replyErr:",_),this.c.send(ce)})}N(N,L){this.f?.logIncoming(N,L,g.OtherSide,"receiveCancel");const W=String(L);this.u[W]?.()}O(N,L,W){this.f?.logIncoming(N,L,g.LocalSide,"receiveReply:",W);const K=String(L);if(!this.w.hasOwnProperty(K))return;const q=this.w[K];delete this.w[K],q.resolveOk(W)}P(N,L,W){this.f?.logIncoming(N,L,g.LocalSide,"receiveReplyErr:",W);const K=String(L);if(!this.w.hasOwnProperty(K))return;const q=this.w[K];delete this.w[K];let G;W&&(W.$isError?(G=new Error,G.name=W.name,G.message=W.message,G.stack=W.stack):G=W),q.resolveErr(G)}Q(N,L,W){try{return Promise.resolve(this.S(N,L,W))}catch(K){return Promise.reject(K)}}S(N,L,W){const K=this.m[N];if(!K)throw new Error("Unknown actor "+(0,a.$Vw)(N));const q=K[L];if(typeof q!="function")throw new Error("Unknown method "+L+" on actor "+(0,a.$Vw)(N));return q.apply(K,W)}U(N,L,W){if(this.j)return new y.$Mdc;let K=null;if(W.length>0&&P.CancellationToken.isCancellationToken(W[W.length-1])&&(K=W.pop()),K&&K.isCancellationRequested)return Promise.reject(A.$5());const q=k.serializeRequestArguments(W,this.h),G=++this.t,Q=String(G),ae=new y.$Ldc,we=new p.$Tc;K&&we.add(K.onCancellationRequested(()=>{const _=k.serializeCancel(G);this.f?.logOutgoing(_.byteLength,G,g.LocalSide,"cancel"),this.c.send(k.serializeCancel(G))})),this.w[Q]=new D(ae,we),this.F(G);const le=k.serializeRequest(G,N,L,q,!!K);return this.f?.logOutgoing(le.byteLength,G,g.LocalSide,`request: ${(0,a.$Vw)(N)}.${L}(`,W),this.c.send(le),ae}}e.$Pdc=E;class D{constructor(N,L){this.a=N,this.b=L}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class w{static alloc(N,L,W){const K=new w(R.$Ne.alloc(W+1+4),0);return K.writeUInt8(N),K.writeUInt32(L),K}static read(N,L){return new w(N,L)}get buffer(){return this.a}constructor(N,L){this.a=N,this.b=L}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+N).toString();return this.b+=N,W}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const L=this.a.slice(this.b,this.b+N);return this.b+=N,L}static sizeMixedArray(N){let L=0;L+=1;for(let W=0,K=N.length;W<K;W++){const q=N[W];switch(L+=1,q.type){case b.String:L+=this.sizeLongString(q.value);break;case b.VSBuffer:L+=this.sizeVSBuffer(q.value);break;case b.SerializedObjectWithBuffers:L+=this.sizeUInt32,L+=this.sizeLongString(q.value);for(let G=0;G<q.buffers.length;++G)L+=this.sizeVSBuffer(q.buffers[G]);break;case b.Undefined:break}}return L}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let L=0,W=N.length;L<W;L++){const K=N[L];switch(K.type){case b.String:this.writeUInt8(b.String),this.writeLongString(K.value);break;case b.VSBuffer:this.writeUInt8(b.VSBuffer),this.writeVSBuffer(K.value);break;case b.SerializedObjectWithBuffers:this.writeUInt8(b.SerializedObjectWithBuffers),this.writeUInt32(K.buffers.length),this.writeLongString(K.value);for(let q=0;q<K.buffers.length;++q)this.writeBuffer(K.buffers[q]);break;case b.Undefined:this.writeUInt8(b.Undefined);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const L=new Array(N);for(let W=0;W<N;W++)switch(this.readUInt8()){case b.String:L[W]=this.readLongString();break;case b.VSBuffer:L[W]=this.readVSBuffer();break;case b.SerializedObjectWithBuffers:{const q=this.readUInt32(),G=this.readLongString(),Q=[];for(let ae=0;ae<q;++ae)Q.push(this.readVSBuffer());L[W]=new a.$Ww(i(G,Q,null));break}case b.Undefined:L[W]=void 0;break}return L}}var C;(function(M){M[M.Simple=0]="Simple",M[M.Mixed=1]="Mixed"})(C||(C={}));class k{static a(N){for(let L=0,W=N.length;L<W;L++)if(N[L]instanceof R.$Ne||N[L]instanceof a.$Ww||typeof N[L]>"u")return!0;return!1}static serializeRequestArguments(N,L){if(this.a(N)){const W=[];for(let K=0,q=N.length;K<q;K++){const G=N[K];if(G instanceof R.$Ne)W[K]={type:b.VSBuffer,value:G};else if(typeof G>"u")W[K]={type:b.Undefined};else if(G instanceof a.$Ww){const{jsonString:Q,referencedBuffers:ae}=l(G.value,L);W[K]={type:b.SerializedObjectWithBuffers,value:R.$Ne.fromString(Q),buffers:ae}}else W[K]={type:b.String,value:R.$Ne.fromString(n(G,L))}}return{type:C.Mixed,args:W}}return{type:C.Simple,args:n(N,L)}}static serializeRequest(N,L,W,K,q){switch(K.type){case C.Simple:return this.b(N,L,W,K.args,q);case C.Mixed:return this.c(N,L,W,K.args,q)}}static b(N,L,W,K,q){const G=R.$Ne.fromString(W),Q=R.$Ne.fromString(K);let ae=0;ae+=w.sizeUInt8(),ae+=w.sizeShortString(G),ae+=w.sizeLongString(Q);const we=w.alloc(q?f.RequestJSONArgsWithCancellation:f.RequestJSONArgs,N,ae);return we.writeUInt8(L),we.writeShortString(G),we.writeLongString(Q),we.buffer}static deserializeRequestJSONArgs(N){const L=N.readUInt8(),W=N.readShortString(),K=N.readLongString();return{rpcId:L,method:W,args:JSON.parse(K)}}static c(N,L,W,K,q){const G=R.$Ne.fromString(W);let Q=0;Q+=w.sizeUInt8(),Q+=w.sizeShortString(G),Q+=w.sizeMixedArray(K);const ae=w.alloc(q?f.RequestMixedArgsWithCancellation:f.RequestMixedArgs,N,Q);return ae.writeUInt8(L),ae.writeShortString(G),ae.writeMixedArray(K),ae.buffer}static deserializeRequestMixedArgs(N){const L=N.readUInt8(),W=N.readShortString(),K=N.readMixedArray(),q=new Array(K.length);for(let G=0,Q=K.length;G<Q;G++){const ae=K[G];typeof ae=="string"?q[G]=JSON.parse(ae):q[G]=ae}return{rpcId:L,method:W,args:q}}static serializeAcknowledged(N){return w.alloc(f.Acknowledged,N,0).buffer}static serializeCancel(N){return w.alloc(f.Cancel,N,0).buffer}static serializeReplyOK(N,L,W){if(typeof L>"u")return this.d(N);if(L instanceof R.$Ne)return this.e(N,L);if(L instanceof a.$Ww){const{jsonString:K,referencedBuffers:q}=l(L.value,W,!0);return this.g(N,K,q)}else return this.f(N,d(L,W))}static d(N){return w.alloc(f.ReplyOKEmpty,N,0).buffer}static e(N,L){let W=0;W+=w.sizeVSBuffer(L);const K=w.alloc(f.ReplyOKVSBuffer,N,W);return K.writeVSBuffer(L),K.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,L){const W=R.$Ne.fromString(L);let K=0;K+=w.sizeLongString(W);const q=w.alloc(f.ReplyOKJSON,N,K);return q.writeLongString(W),q.buffer}static g(N,L,W){const K=R.$Ne.fromString(L);let q=0;q+=w.sizeUInt32,q+=w.sizeLongString(K);for(const Q of W)q+=w.sizeVSBuffer(Q);const G=w.alloc(f.ReplyOKJSONWithBuffers,N,q);G.writeUInt32(W.length),G.writeLongString(K);for(const Q of W)G.writeBuffer(Q);return G.buffer}static deserializeReplyOKJSON(N){const L=N.readLongString();return JSON.parse(L)}static deserializeReplyOKJSONWithBuffers(N,L){const W=N.readUInt32(),K=N.readLongString(),q=[];for(let G=0;G<W;++G)q.push(N.readVSBuffer());return new a.$Ww(i(K,q,L))}static serializeReplyErr(N,L){const W=L?d(A.$1(L),null):void 0;if(typeof W!="string")return this.h(N);const K=R.$Ne.fromString(W);let q=0;q+=w.sizeLongString(K);const G=w.alloc(f.ReplyErrError,N,q);return G.writeLongString(K),G.buffer}static deserializeReplyErrError(N){const L=N.readLongString();return JSON.parse(L)}static h(N){return w.alloc(f.ReplyErrEmpty,N,0).buffer}}var f;(function(M){M[M.RequestJSONArgs=1]="RequestJSONArgs",M[M.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",M[M.RequestMixedArgs=3]="RequestMixedArgs",M[M.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",M[M.Acknowledged=5]="Acknowledged",M[M.Cancel=6]="Cancel",M[M.ReplyOKEmpty=7]="ReplyOKEmpty",M[M.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",M[M.ReplyOKJSON=9]="ReplyOKJSON",M[M.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",M[M.ReplyErrError=11]="ReplyErrError",M[M.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var b;(function(M){M[M.String=1]="String",M[M.VSBuffer=2]="VSBuffer",M[M.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",M[M.Undefined=4]="Undefined"})(b||(b={}))}),define(Ne[225],Le([1,0]),function(ve,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ktc=void 0;const v=function(O){const A=T=>{globalThis.removeEventListener("message",A);const p=T.data;Object.defineProperties(globalThis,{postMessage:{value(o,I){p.postMessage(o,I)}},onmessage:{get(){return p.onmessage},set(o){p.onmessage=o}}}),p.addEventListener("message",o=>{globalThis.dispatchEvent(new MessageEvent("message",{data:o.data,ports:o.ports?[...o.ports]:void 0}))}),p.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",A)}.toString();class R extends EventTarget{constructor(O,A,T){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const p=`((${v})('${A}'))`,o=new Blob([p],{type:"application/javascript"}),I=URL.createObjectURL(o),y=new MessageChannel,a=I,S={type:"_newWorker",id:a,port:y.port2,url:I,options:T};O(S,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:a}),URL.revokeObjectURL(I),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(d){y.port1.onmessage=d}},onmessageerror:{get(){return y.port1.onmessageerror},set(d){y.port1.onmessageerror=d}}}),y.port1.addEventListener("messageerror",d=>{const r=new MessageEvent("messageerror",{data:d.data});this.dispatchEvent(r)}),y.port1.addEventListener("message",d=>{const r=new MessageEvent("message",{data:d.data});this.dispatchEvent(r)}),y.port1.start()}}e.$Ktc=R}),define(Ne[226],Le([1,0,22,28,15,60,3]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=e.$qL=void 0,e.$rL=I,e.$sL=y,e.$qL=(0,A.$Ei)("notebookDocumentService");const T=["W","X","Y","Z","a","b","c","d","e","f"],p=new RegExp(`^[${T.join("")}]+`),o=7;function I(S){if(S.scheme!==P.Schemas.vscodeNotebookCell)return;const d=S.fragment.indexOf("s");if(d<0)return;const r=parseInt(S.fragment.substring(0,d).replace(p,""),o),s=(0,v.$7e)(S.fragment.substring(d+1)).toString();if(!isNaN(r))return{handle:r,notebook:S.with({scheme:s,fragment:null})}}function y(S,d){const r=d.toString(o),c=`${r.length<T.length?T[r.length-1]:"z"}${r}s${(0,v.$8e)(v.$Ne.fromString(S.scheme),!0,!0)}`;return S.with({scheme:P.Schemas.vscodeNotebookCell,fragment:c})}class a{constructor(){this.a=new R.$Ac}getNotebook(d){if(d.scheme===P.Schemas.vscodeNotebookCell){const r=I(d);if(r){const s=this.a.get(r.notebook);if(s)return s}}return this.a.get(d)}addNotebookDocument(d){this.a.set(d.uri,d)}removeNotebookDocument(d){this.a.delete(d.uri)}}e.$tL=a,(0,O.$Qs)(e.$qL,a,O.InstantiationType.Delayed)}),define(Ne[89],Le([1,0,22,41,40,72,15,19,20,31,226]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NL=e.$KL=e.CellStatusbarAlignment=e.$JL=e.NotebookFindScopeType=e.NotebookEditorPriority=e.$GL=e.$FL=e.$DL=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$CL=e.$BL=e.$AL=e.$zL=e.CellKind=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=void 0,e.$EL=u,e.$HL=h,e.$IL=E,e.$LL=C,e.$ML=f,R=We(R),e.$uL="workbench.editor.notebook",e.$vL="workbench.editor.notebookTextDiffEditor",e.$wL="workbench.editor.interactive",e.$xL="workbench.editor.repl",e.$yL="replNotebook.input.execute";var y;(function(Q){Q[Q.Markup=1]="Markup",Q[Q.Code=2]="Code"})(y||(e.CellKind=y={})),e.$zL=["application/json","application/javascript","text/html","image/svg+xml",O.$0s.latex,O.$0s.markdown,"image/png","image/jpeg",O.$0s.text],e.$AL=[O.$0s.latex,O.$0s.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$0s.text],e.$BL=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$CL="_notAvailable";var a;(function(Q){Q[Q.Running=1]="Running",Q[Q.Idle=2]="Idle"})(a||(e.NotebookRunState=a={}));var S;(function(Q){Q[Q.Unconfirmed=1]="Unconfirmed",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(S||(e.NotebookCellExecutionState=S={}));var d;(function(Q){Q[Q.Unconfirmed=1]="Unconfirmed",Q[Q.Pending=2]="Pending",Q[Q.Executing=3]="Executing"})(d||(e.NotebookExecutionState=d={}));var r;(function(Q){Q[Q.WithHardKernelDependency=0]="WithHardKernelDependency",Q[Q.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",Q[Q.Pure=2]="Pure",Q[Q.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var s;(function(Q){Q.Always="always",Q.Never="never",Q.Optional="optional"})(s||(e.RendererMessagingSpec=s={}));var c;(function(Q){Q[Q.ModelChange=1]="ModelChange",Q[Q.Move=2]="Move",Q[Q.ChangeCellLanguage=5]="ChangeCellLanguage",Q[Q.Initialize=6]="Initialize",Q[Q.ChangeCellMetadata=7]="ChangeCellMetadata",Q[Q.Output=8]="Output",Q[Q.OutputItem=9]="OutputItem",Q[Q.ChangeCellContent=10]="ChangeCellContent",Q[Q.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",Q[Q.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",Q[Q.ChangeCellMime=13]="ChangeCellMime",Q[Q.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var l;(function(Q){Q[Q.Handle=0]="Handle",Q[Q.Index=1]="Index"})(l||(e.SelectionStateType=l={}));var i;(function(Q){Q[Q.Replace=1]="Replace",Q[Q.Output=2]="Output",Q[Q.Metadata=3]="Metadata",Q[Q.CellLanguage=4]="CellLanguage",Q[Q.DocumentMetadata=5]="DocumentMetadata",Q[Q.Move=6]="Move",Q[Q.OutputItems=7]="OutputItems",Q[Q.PartialMetadata=8]="PartialMetadata",Q[Q.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(Q){Q.scheme=A.Schemas.vscodeNotebookCell;function ae(oe,ke){return(0,I.$sL)(oe,ke)}Q.generate=ae;function we(oe){return(0,I.$rL)(oe)}Q.parse=we;function le(oe,ke){return oe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${ke??""},${oe.scheme!==A.Schemas.file?oe.scheme:""}`})}Q.generateCellOutputUri=le;function _(oe){if(oe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const ke=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(oe.fragment);if(!ke)return;const Te=ke[1]&&ke[1]!==""?ke[1]:void 0,Z=ke[2];return{outputId:Te,notebook:oe.with({scheme:Z||A.Schemas.file,fragment:null})}}Q.parseCellOutputUri=_;function ce(oe,ke,Te){return Q.generate(oe,ke).with({scheme:Te})}Q.generateCellPropertyUri=ce;function me(oe,ke){if(oe.scheme===ke)return Q.parse(oe.with({scheme:Q.scheme}))}Q.parseCellPropertyUri=me})(n||(e.CellUri=n={}));const t=Q=>p.$j?Q.replace(/\//g,"\\"):Q;class g{constructor(ae=[],we=e.$zL){this.e=we,this.d=[...new Set(ae)].map(le=>({pattern:le,matches:R.$zk(t(le))}))}sort(ae){const we=new Map(P.Iterable.map(ae,_=>[_,t(_)]));let le=[];for(const{matches:_}of this.d)for(const[ce,me]of we)if(_(me)){le.push(ce),we.delete(ce);break}return we.size&&(le=le.concat([...we.keys()].sort((_,ce)=>this.e.indexOf(_)-this.e.indexOf(ce)))),le}prioritize(ae,we){const le=this.f(ae);if(le===-1){this.d.unshift({pattern:ae,matches:R.$zk(t(ae))});return}const _=new Set(we.map(me=>this.f(me,le)));_.delete(-1);const ce=Array.from(_).sort();this.d.splice(le+1,0,...ce.map(me=>this.d[me]));for(let me=ce.length-1;me>=0;me--)this.d.splice(ce[me],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,we=this.d.length){const le=t(ae);for(let _=0;_<we;_++)if(this.d[_].matches(le))return _;return-1}}e.$DL=g;function u(Q,ae,we,le=(_,ce)=>_===ce){const _=[];function ce(ke,Te,Z){if(Te===0&&Z.length===0)return;const B=_[_.length-1];B&&B.start+B.deleteCount===ke?(B.deleteCount+=Te,B.toInsert.push(...Z)):_.push({start:ke,deleteCount:Te,toInsert:Z})}let me=0,oe=0;for(;;){if(me===Q.length){ce(me,0,ae.slice(oe));break}if(oe===ae.length){ce(me,Q.length-me,[]);break}const ke=Q[me],Te=ae[oe];if(le(ke,Te)){me+=1,oe+=1;continue}we(Te)?(ce(me,1,[]),me+=1):(ce(me,0,[Te]),oe+=1)}return _}e.$FL=new o.$Vj("notebookEditorCursorAtBoundary","none"),e.$GL=new o.$Vj("notebookEditorCursorAtLineBoundary","none");var $;(function(Q){Q.default="default",Q.option="option"})($||(e.NotebookEditorPriority=$={}));var m;(function(Q){Q.Cells="cells",Q.Text="text",Q.None="none"})(m||(e.NotebookFindScopeType=m={}));function h(Q){const ae=Q;return!!((typeof ae.include=="string"||R.$Ak(ae.include))&&(typeof ae.exclude=="string"||R.$Ak(ae.exclude)))}function E(Q,ae,we){if(Array.isArray(Q.viewType)&&Q.viewType.indexOf(ae)>=0||Q.viewType===ae)return!0;if(Q.filenamePattern){const le=h(Q.filenamePattern)?Q.filenamePattern.include:Q.filenamePattern,_=h(Q.filenamePattern)?Q.filenamePattern.exclude:void 0;if(R.$yk(le,(0,T.$nc)(we.fsPath).toLowerCase()))return!(_&&R.$yk(_,(0,T.$nc)(we.fsPath).toLowerCase()))}return!1}e.$JL={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",defaultFormatter:"notebook.defaultFormatter",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findFilters:"notebook.find.filters",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var D;(function(Q){Q[Q.Left=1]="Left",Q[Q.Right=2]="Right"})(D||(e.CellStatusbarAlignment=D={}));class w{static{this.d="notebook/"}static create(ae){return`${w.d}${ae}`}static parse(ae){if(ae.startsWith(w.d))return ae.substring(w.d.length)}}e.$KL=w;function C(Q){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(Q)}const k=new TextDecoder;function f(Q){const ae=[];let we=!1;for(const me of Q)(ae.length===0||we)&&(ae.push(me),we=!0);let le=N(ae);const _=v.$Ne.concat(ae.map(me=>v.$Ne.wrap(me))),ce=G(_);return le=le||ce.byteLength!==_.byteLength,{data:ce,didCompression:le}}e.$NL="\x1B[A";const b=e.$NL.split("").map(Q=>Q.charCodeAt(0)),M=10;function N(Q){let ae=!1;return Q.forEach((we,le)=>{if(le===0||we.length<e.$NL.length)return;const _=Q[le-1],ce=we.subarray(0,e.$NL.length);if(ce[0]===b[0]&&ce[1]===b[1]&&ce[2]===b[2]){const me=_.lastIndexOf(M);if(me===-1)return;ae=!0,Q[le-1]=_.subarray(0,me),Q[le]=we.subarray(e.$NL.length)}}),ae}function L(Q){let ae=Q;do Q=ae,ae=Q.replace(/[^\n]\x08/gm,"");while(ae.length<Q.length);return Q}function W(Q){for(Q=Q.replace(/\r+\n/gm,`
`);Q.search(/\r[^$]/g)>-1;){const ae=Q.match(/^(.*)\r+/m)[1];let we=Q.match(/\r+(.*)$/m)[1];we=we+ae.slice(we.length,ae.length),Q=Q.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,we)}return Q}const K=8,q=13;function G(Q){return!Q.buffer.includes(K)&&!Q.buffer.includes(q)?Q:v.$Ne.fromString(W(L(k.decode(Q.buffer))))}}),define(Ne[7],Le([1,0,17,13,59,28,72,12,14,2,38,18,29,109,89]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d){"use strict";var r,s,c,l,i,n,t,g,u,$,m,h,E,D,w,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$$P=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$0P=e.$9P=e.$8P=e.$7P=e.$6P=e.$5P=e.$4P=e.$3P=e.LanguageModelChatMessageRole=e.$2P=e.$1P=e.ChatResponseReferencePartStatusKind=e.ChatLocation=e.$ZP=e.$YP=e.$XP=e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=e.$QP=e.$PP=e.$OP=e.$NP=e.$MP=e.$LP=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$KP=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$JP=e.$IP=e.$HP=e.$GP=e.$FP=e.$EP=e.$DP=e.$CP=e.$BP=e.$AP=e.$zP=e.$yP=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$xP=e.$wP=e.$vP=e.$uP=e.$sP=e.$rP=e.$qP=e.$pP=e.$oP=e.TestRunProfileKind=e.TestResultState=e.$nP=e.$mP=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$lP=e.NotebookVariablesRequestKind=e.$kP=e.$jP=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$iP=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$hP=e.$gP=e.$fP=e.$eP=e.$dP=e.ColorThemeKind=e.$cP=e.$bP=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$aP=e.QuickInputButtonLocation=e.$_O=e.DebugConsoleMode=e.$$O=e.$0O=e.$9O=e.$8O=e.$7O=e.CommentThreadFocus=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$6O=e.$5O=e.FileChangeType=e.$4O=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$3O=e.$2O=e.$1O=e.$ZO=e.InlineCompletionTriggerKind=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$MO=e.ConfigurationTarget=e.$LO=e.$KO=e.$JO=e.$IO=e.DocumentPasteTriggerKind=e.$HO=e.$GO=e.$FO=e.$EO=e.$DO=e.$CO=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$BO=e.ViewBadge=e.ProgressLocation=e.$AO=e.$zO=e.TaskScope=e.ShellQuoting=e.$yO=e.$xO=e.$wO=e.TaskPanelKind=e.TaskRevealKind=e.$vO=e.TerminalLocation=e.$uO=e.$tO=e.$sO=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$rO=e.$qO=e.$pO=e.$oO=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$mO=e.$lO=e.$kO=e.$jO=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$iO=e.$hO=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.LanguageStatusSeverity=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.$9N=e.CodeActionTriggerKind=e.$8N=e.$7N=e.SymbolTag=e.SymbolKind=e.$6N=e.$5N=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.DiagnosticSeverity=e.DiagnosticTag=e.$YN=e.$XN=e.FileEditType=e.$WN=e.$VN=e.$UN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$TN=e.$SN=e.$RN=e.$ON=e.$NN=e.$MN=e.$LN=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$PN=q,e.$QN=G,e.$nO=bt,e.$NO=Li,e.$tP=Rn;function f(U){return Object.assign(U,{apply:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const Se=se.length===1?[]:se[1];return Reflect.construct(U,Se,se[0].constructor)}},call:function(...se){if(se.length===0)return Reflect.construct(U,[]);{const[Se,...Ke]=se;return Reflect.construct(U,Ke,Se.constructor)}}})}var b;(function(U){U[U.Top=0]="Top",U[U.Bottom=1]="Bottom"})(b||(e.TerminalOutputAnchor=b={}));var M;(function(U){U[U.TerminalCommand=0]="TerminalCommand",U[U.Opener=1]="Opener",U[U.Command=3]="Command"})(M||(e.TerminalQuickFixType=M={}));let N=r=class{static from(...F){let se=F;return new r(function(){if(se){for(const Se of se)Se&&typeof Se.dispose=="function"&&Se.dispose();se=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$LN=N,e.$LN=N=r=Je([f],N);let L=s=class{static Min(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let Se=1;Se<F.length;Se++){const Ke=F[Se];Ke.isBefore(se)&&(se=Ke)}return se}static Max(...F){if(F.length===0)throw new TypeError;let se=F[0];for(let Se=1;Se<F.length;Se++){const Ke=F[Se];Ke.isAfter(se)&&(se=Ke)}return se}static isPosition(F){if(!F)return!1;if(F instanceof s)return!0;const{line:se,character:Se}=F;return typeof se=="number"&&typeof Se=="number"}static of(F){if(F instanceof s)return F;if(this.isPosition(F))return new s(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,se){if(F<0)throw(0,R.$6)("line must be non-negative");if(se<0)throw(0,R.$6)("character must be non-negative");this.c=F,this.e=se}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,se=0){if(F===null||se===null)throw(0,R.$6)();let Se;return typeof F>"u"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,se=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&se===0?this:new s(this.line+Se,this.character+se)}with(F,se=this.character){if(F===null||se===null)throw(0,R.$6)();let Se;return typeof F>"u"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,se=typeof F.character=="number"?F.character:this.character),Se===this.line&&se===this.character?this:new s(Se,se)}toJSON(){return{line:this.line,character:this.character}}[Symbol.for("debug.description")](){return`(${this.line}:${this.character})`}};e.$MN=L,e.$MN=L=s=Je([f],L);let W=c=class{static isRange(F){return F instanceof c?!0:F?L.isPosition(F.start)&&L.isPosition(F.end):!1}static of(F){if(F instanceof c)return F;if(this.isRange(F))return new c(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,se,Se,Ke){let it,dt;if(typeof F=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ke=="number"?(it=new L(F,se),dt=new L(Se,Ke)):L.isPosition(F)&&L.isPosition(se)&&(it=L.of(F),dt=L.of(se)),!it||!dt)throw new Error("Invalid arguments");it.isBefore(dt)?(this.c=it,this.e=dt):(this.c=dt,this.e=it)}contains(F){return c.isRange(F)?this.contains(F.start)&&this.contains(F.end):L.isPosition(F)?!(L.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const se=L.Max(F.start,this.c),Se=L.Min(F.end,this.e);if(!se.isAfter(Se))return new c(se,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const se=L.Min(F.start,this.c),Se=L.Max(F.end,this.end);return new c(se,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,se=this.end){if(F===null||se===null)throw(0,R.$6)();let Se;return F?L.isPosition(F)?Se=F:(Se=F.start||this.start,se=F.end||this.end):Se=this.start,Se.isEqual(this.c)&&se.isEqual(this.end)?this:new c(Se,se)}toJSON(){return[this.start,this.end]}[Symbol.for("debug.description")](){return q(this)}};e.$NN=W,e.$NN=W=c=Je([f],W);let K=l=class extends W{static isSelection(F){return F instanceof l?!0:F?W.isRange(F)&&L.isPosition(F.anchor)&&L.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,se,Se,Ke){let it,dt;if(typeof F=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ke=="number"?(it=new L(F,se),dt=new L(Se,Ke)):L.isPosition(F)&&L.isPosition(se)&&(it=L.of(F),dt=L.of(se)),!it||!dt)throw new Error("Invalid arguments");super(it,dt),this.f=it,this.g=dt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}[Symbol.for("debug.description")](){return G(this)}};e.$ON=K,e.$ON=K=l=Je([f],K);function q(U){return U.isEmpty?`[${U.start.line}:${U.start.character})`:`[${U.start.line}:${U.start.character} -> ${U.end.line}:${U.end.character})`}function G(U){let F=q(U);return U.isEmpty||(U.active.isEqual(U.start)?F=`|${F}`:F=`${F}|`),F}const Q=U=>{if(typeof U!="string"||U.length===0||!/^[0-9A-Za-z_\-]+$/.test(U))throw(0,R.$6)("connectionToken")};class ae{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se,Se){if(typeof F!="string"||F.length===0)throw(0,R.$6)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,R.$6)("port");typeof Se<"u"&&Q(Se),this.host=F,this.port=Math.round(se),this.connectionToken=Se}}e.$RN=ae;class we{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,se){this.makeConnection=F,this.connectionToken=se,typeof se<"u"&&Q(se)}}e.$SN=we;class le extends Error{static NotAvailable(F,se){return new le(F,S.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(F){return new le(F,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,se=S.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F),this._message=F,this._code=se,this._detail=Se,Object.setPrototypeOf(this,le.prototype)}}e.$TN=le;var _;(function(U){U[U.LF=1]="LF",U[U.CRLF=2]="CRLF"})(_||(e.EndOfLine=_={}));var ce;(function(U){U[U.Replace=1]="Replace",U[U.Append=2]="Append",U[U.Prepend=3]="Prepend"})(ce||(e.EnvironmentVariableMutatorType=ce={}));let me=i=class{static isTextEdit(F){return F instanceof i?!0:F?W.isRange(F)&&typeof F.newText=="string":!1}static replace(F,se){return new i(F,se)}static insert(F,se){return i.replace(new W(F,F),se)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const se=new i(new W(new L(0,0),new L(0,0)),"");return se.newEol=F,se}get range(){return this.c}set range(F){if(F&&!W.isRange(F))throw(0,R.$6)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,R.$6)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,R.$6)("newEol");this.f=F}constructor(F,se){this.c=F,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$UN=me,e.$UN=me=i=Je([f],me);let oe=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?yi.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,se){return new n(F,se)}static insertCells(F,se){return new n(new yi(F,F),se)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,se){const Se=new n(new yi(F,F),[]);return Se.newCellMetadata=se,Se}static updateNotebookMetadata(F){const se=new n(new yi(0,0),[]);return se.newNotebookMetadata=F,se}constructor(F,se){this.range=F,this.newCells=se}};e.$VN=oe,e.$VN=oe=n=Je([f],oe);class ke{static isSnippetTextEdit(F){return F instanceof ke?!0:F?W.isRange(F.range)&&B.isSnippetString(F.snippet):!1}static replace(F,se){return new ke(F,se)}static insert(F,se){return ke.replace(new W(F,F),se)}constructor(F,se){this.range=F,this.snippet=se}}e.$WN=ke;var Te;(function(U){U[U.File=1]="File",U[U.Text=2]="Text",U[U.Cell=3]="Cell",U[U.CellReplace=5]="CellReplace",U[U.Snippet=6]="Snippet"})(Te||(e.FileEditType=Te={}));let Z=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,se,Se,Ke){this.c.push({_type:Te.File,from:F,to:se,options:Se,metadata:Ke})}createFile(F,se,Se){this.c.push({_type:Te.File,from:void 0,to:F,options:se,metadata:Se})}deleteFile(F,se,Se){this.c.push({_type:Te.File,from:F,to:void 0,options:se,metadata:Se})}e(F,se,Se){this.c.push({_type:Te.Cell,metadata:Se,uri:F,edit:{editType:d.CellEditType.DocumentMetadata,metadata:se},notebookMetadata:se})}f(F,se,Se,Ke){const it=se.start,dt=se.end;(it!==dt||Se.length>0)&&this.c.push({_type:Te.CellReplace,uri:F,index:it,count:dt-it,cells:Se,metadata:Ke})}g(F,se,Se,Ke){this.c.push({_type:Te.Cell,metadata:Ke,uri:F,edit:{editType:d.CellEditType.Metadata,index:se,metadata:Se}})}replace(F,se,Se,Ke){this.c.push({_type:Te.Text,uri:F,edit:new me(se,Se),metadata:Ke})}insert(F,se,Se,Ke){this.replace(F,new W(se,se),Se,Ke)}delete(F,se,Se){this.replace(F,se,"",Se)}has(F){return this.c.some(se=>se._type===Te.Text&&se.uri.toString()===F.toString())}set(F,se){if(se)for(const Se of se){if(!Se)continue;let Ke,it;Array.isArray(Se)?(Ke=Se[0],it=Se[1]):Ke=Se,oe.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(F,Ke.range.start,Ke.newCellMetadata,it):Ke.newNotebookMetadata?this.e(F,Ke.newNotebookMetadata,it):this.f(F,Ke.range,Ke.newCells,it):ke.isSnippetTextEdit(Ke)?this.c.push({_type:Te.Snippet,uri:F,range:Ke.range,edit:Ke.snippet,metadata:it}):this.c.push({_type:Te.Text,uri:F,edit:Ke,metadata:it})}else{for(let Se=0;Se<this.c.length;Se++){const Ke=this.c[Se];switch(Ke._type){case Te.Text:case Te.Snippet:case Te.Cell:case Te.CellReplace:Ke.uri.toString()===F.toString()&&(this.c[Se]=void 0);break}}(0,v.$Hb)(this.c)}}get(F){const se=[];for(const Se of this.c)Se._type===Te.Text&&Se.uri.toString()===F.toString()&&se.push(Se.edit);return se}entries(){const F=new O.$Ac;for(const se of this.c)if(se._type===Te.Text){let Se=F.get(se.uri);Se||(Se=[se.uri,[]],F.set(se.uri,Se)),Se[1].push(se.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$XN=Z,e.$XN=Z=Je([f],Z);let B=t=class{static isSnippetString(F){return F instanceof t?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=t.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,se=this.e++){if(typeof F=="function"){const Se=new t;Se.e=this.e,F(Se),this.e=Se.e,F=Se.value}else F=t.c(F);return this.value+="${",this.value+=se,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,se=this.e++){const Se=F.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,se){if(typeof se=="function"){const Se=new t;Se.e=this.e,se(Se),this.e=Se.e,se=Se.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.$YN=B,e.$YN=B=t=Je([f],B);var ne;(function(U){U[U.Unnecessary=1]="Unnecessary",U[U.Deprecated=2]="Deprecated"})(ne||(e.DiagnosticTag=ne={}));var Ee;(function(U){U[U.Hint=3]="Hint",U[U.Information=2]="Information",U[U.Warning=1]="Warning",U[U.Error=0]="Error"})(Ee||(e.DiagnosticSeverity=Ee={}));let fe=g=class{static isLocation(F){return F instanceof g?!0:F?W.isRange(F.range)&&o.URI.isUri(F.uri):!1}constructor(F,se){if(this.uri=F,se)if(W.isRange(se))this.range=W.of(se);else if(L.isPosition(se))this.range=new W(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$ZN=fe,e.$ZN=fe=g=Je([f],fe);let be=class{static is(F){return F?typeof F.message=="string"&&F.location&&W.isRange(F.location.range)&&o.URI.isUri(F.location.uri):!1}constructor(F,se){this.location=F,this.message=se}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.location.range.isEqual(se.location.range)&&F.location.uri.toString()===se.location.uri.toString()}};e.$1N=be,e.$1N=be=Je([f],be);let he=class{constructor(F,se,Se=Ee.Error){if(!W.isRange(F))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=F,this.message=se,this.severity=Se}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,se){return F===se?!0:!F||!se?!1:F.message===se.message&&F.severity===se.severity&&F.code===se.code&&F.severity===se.severity&&F.source===se.source&&F.range.isEqual(se.range)&&(0,v.$tb)(F.tags,se.tags)&&(0,v.$tb)(F.relatedInformation,se.relatedInformation,be.isEqual)}};e.$2N=he,e.$2N=he=Je([f],he);let X=class{constructor(F,se){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=se}};e.$3N=X,e.$3N=X=Je([f],X);let x=class extends X{constructor(F,se,Se,Ke){super(F,se),this.canIncreaseVerbosity=Se,this.canDecreaseVerbosity=Ke}};e.$4N=x,e.$4N=x=Je([f],x);var $e;(function(U){U[U.Increase=0]="Increase",U[U.Decrease=1]="Decrease"})($e||(e.HoverVerbosityAction=$e={}));var pe;(function(U){U[U.Text=0]="Text",U[U.Read=1]="Read",U[U.Write=2]="Write"})(pe||(e.DocumentHighlightKind=pe={}));let Ae=class{constructor(F,se=pe.Text){this.range=F,this.kind=se}toJSON(){return{range:this.range,kind:pe[this.kind]}}};e.$5N=Ae,e.$5N=Ae=Je([f],Ae);let Ue=class{constructor(F,se){this.uri=F,this.highlights=se}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$6N=Ue,e.$6N=Ue=Je([f],Ue);var Ie;(function(U){U[U.File=0]="File",U[U.Module=1]="Module",U[U.Namespace=2]="Namespace",U[U.Package=3]="Package",U[U.Class=4]="Class",U[U.Method=5]="Method",U[U.Property=6]="Property",U[U.Field=7]="Field",U[U.Constructor=8]="Constructor",U[U.Enum=9]="Enum",U[U.Interface=10]="Interface",U[U.Function=11]="Function",U[U.Variable=12]="Variable",U[U.Constant=13]="Constant",U[U.String=14]="String",U[U.Number=15]="Number",U[U.Boolean=16]="Boolean",U[U.Array=17]="Array",U[U.Object=18]="Object",U[U.Key=19]="Key",U[U.Null=20]="Null",U[U.EnumMember=21]="EnumMember",U[U.Struct=22]="Struct",U[U.Event=23]="Event",U[U.Operator=24]="Operator",U[U.TypeParameter=25]="TypeParameter"})(Ie||(e.SymbolKind=Ie={}));var Pe;(function(U){U[U.Deprecated=1]="Deprecated"})(Pe||(e.SymbolTag=Pe={}));let Oe=u=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,se,Se,Ke,it){this.name=F,this.kind=se,this.containerName=it,typeof Se=="string"&&(this.containerName=Se),Ke instanceof fe?this.location=Ke:Se instanceof W&&(this.location=new fe(Ke,Se)),u.validate(this)}toJSON(){return{name:this.name,kind:Ie[this.kind],location:this.location,containerName:this.containerName}}};e.$7N=Oe,e.$7N=Oe=u=Je([f],Oe);let z=$=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach($.validate)}constructor(F,se,Se,Ke,it){this.name=F,this.detail=se,this.kind=Se,this.range=Ke,this.selectionRange=it,this.children=[],$.validate(this)}};e.$8N=z,e.$8N=z=$=Je([f],z);var j;(function(U){U[U.Invoke=1]="Invoke",U[U.Automatic=2]="Automatic"})(j||(e.CodeActionTriggerKind=j={}));let H=class{constructor(F,se){this.title=F,this.kind=se}};e.$9N=H,e.$9N=H=Je([f],H);let V=class{static{m=this}static{this.c="."}constructor(F){this.value=F}append(F){return new m(this.value?this.value+m.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+m.c)}};e.$0N=V,e.$0N=V=m=Je([f],V),V.Empty=new V(""),V.QuickFix=V.Empty.append("quickfix"),V.Refactor=V.Empty.append("refactor"),V.RefactorExtract=V.Refactor.append("extract"),V.RefactorInline=V.Refactor.append("inline"),V.RefactorMove=V.Refactor.append("move"),V.RefactorRewrite=V.Refactor.append("rewrite"),V.Source=V.Empty.append("source"),V.SourceOrganizeImports=V.Source.append("organizeImports"),V.SourceFixAll=V.Source.append("fixAll"),V.Notebook=V.Empty.append("notebook");let re=class{constructor(F,se){if(this.range=F,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$$N=re,e.$$N=re=Je([f],re);class ge{constructor(F,se,Se,Ke,it,dt){this.kind=F,this.name=se,this.detail=Se,this.uri=Ke,this.range=it,this.selectionRange=dt}}e.$_N=ge;class Ce{constructor(F,se){this.fromRanges=se,this.from=F}}e.$aO=Ce;class ze{constructor(F,se){this.fromRanges=se,this.to=F}}e.$bO=ze;var Qe;(function(U){U[U.Information=0]="Information",U[U.Warning=1]="Warning",U[U.Error=2]="Error"})(Qe||(e.LanguageStatusSeverity=Qe={}));let _e=class{constructor(F,se){this.range=F,this.command=se}get isResolved(){return!!this.command}};e.$cO=_e,e.$cO=_e=Je([f],_e);let tt=h=class{#e;static isMarkdownString(F){return F instanceof h?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,se=!1){this.#e=new P.$3k(F,{supportThemeIcons:se})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,se){return this.#e.appendCodeblock(se??"",F),this}};e.$dO=tt,e.$dO=tt=h=Je([f],tt);let nt=class{constructor(F,se){this.label=F,this.documentation=se}};e.$eO=nt,e.$eO=nt=Je([f],nt);let et=class{constructor(F,se){this.label=F,this.documentation=se,this.parameters=[]}};e.$fO=et,e.$fO=et=Je([f],et);let rt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$gO=rt,e.$gO=rt=Je([f],rt);var ft;(function(U){U[U.Invoke=1]="Invoke",U[U.TriggerCharacter=2]="TriggerCharacter",U[U.ContentChange=3]="ContentChange"})(ft||(e.SignatureHelpTriggerKind=ft={}));var lt;(function(U){U[U.Type=1]="Type",U[U.Parameter=2]="Parameter"})(lt||(e.InlayHintKind=lt={}));let st=class{constructor(F){this.value=F}};e.$hO=st,e.$hO=st=Je([f],st);let ct=class{constructor(F,se,Se){this.position=F,this.label=se,this.kind=Se}};e.$iO=ct,e.$iO=ct=Je([f],ct);var mt;(function(U){U[U.Invoke=0]="Invoke",U[U.TriggerCharacter=1]="TriggerCharacter",U[U.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(mt||(e.CompletionTriggerKind=mt={}));var $t;(function(U){U[U.Text=0]="Text",U[U.Method=1]="Method",U[U.Function=2]="Function",U[U.Constructor=3]="Constructor",U[U.Field=4]="Field",U[U.Variable=5]="Variable",U[U.Class=6]="Class",U[U.Interface=7]="Interface",U[U.Module=8]="Module",U[U.Property=9]="Property",U[U.Unit=10]="Unit",U[U.Value=11]="Value",U[U.Enum=12]="Enum",U[U.Keyword=13]="Keyword",U[U.Snippet=14]="Snippet",U[U.Color=15]="Color",U[U.File=16]="File",U[U.Reference=17]="Reference",U[U.Folder=18]="Folder",U[U.EnumMember=19]="EnumMember",U[U.Constant=20]="Constant",U[U.Struct=21]="Struct",U[U.Event=22]="Event",U[U.Operator=23]="Operator",U[U.TypeParameter=24]="TypeParameter",U[U.User=25]="User",U[U.Issue=26]="Issue"})($t||(e.CompletionItemKind=$t={}));var qe;(function(U){U[U.Deprecated=1]="Deprecated"})(qe||(e.CompletionItemTag=qe={}));let je=class{constructor(F,se){this.label=F,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&$t[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$jO=je,e.$jO=je=Je([f],je);let ie=class{constructor(F=[],se=!1){this.items=F,this.isIncomplete=se}};e.$kO=ie,e.$kO=ie=Je([f],ie);let ee=class{constructor(F,se,Se){this.insertText=F,this.range=se,this.command=Se}};e.$lO=ee,e.$lO=ee=Je([f],ee);let Y=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$mO=Y,e.$mO=Y=Je([f],Y);var Xe;(function(U){U[U.Unknown=0]="Unknown",U[U.Word=1]="Word",U[U.Line=2]="Line",U[U.Suggest=3]="Suggest"})(Xe||(e.PartialAcceptTriggerKind=Xe={}));var xe;(function(U){U[U.Active=-1]="Active",U[U.Beside=-2]="Beside",U[U.One=1]="One",U[U.Two=2]="Two",U[U.Three=3]="Three",U[U.Four=4]="Four",U[U.Five=5]="Five",U[U.Six=6]="Six",U[U.Seven=7]="Seven",U[U.Eight=8]="Eight",U[U.Nine=9]="Nine"})(xe||(e.ViewColumn=xe={}));var ht;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(ht||(e.StatusBarAlignment=ht={}));function bt(U,F){return`${y.$qn.toKey(U)}.${F}`}var Mt;(function(U){U[U.Off=0]="Off",U[U.On=1]="On",U[U.Relative=2]="Relative",U[U.Interval=3]="Interval"})(Mt||(e.TextEditorLineNumbersStyle=Mt={}));var Ht;(function(U){U[U.Manual=1]="Manual",U[U.AfterDelay=2]="AfterDelay",U[U.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var _t;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(_t||(e.TextEditorRevealType=_t={}));var ei;(function(U){U[U.Keyboard=1]="Keyboard",U[U.Mouse=2]="Mouse",U[U.Command=3]="Command"})(ei||(e.TextEditorSelectionChangeKind=ei={}));var oi;(function(U){U[U.Undo=1]="Undo",U[U.Redo=2]="Redo"})(oi||(e.TextDocumentChangeReason=oi={}));var At;(function(U){U[U.OpenOpen=0]="OpenOpen",U[U.ClosedClosed=1]="ClosedClosed",U[U.OpenClosed=2]="OpenClosed",U[U.ClosedOpen=3]="ClosedOpen"})(At||(e.DecorationRangeBehavior=At={})),function(U){function F(se){switch(se){case"keyboard":return U.Keyboard;case"mouse":return U.Mouse;case"api":return U.Command}}U.fromValue=F}(ei||(e.TextEditorSelectionChangeKind=ei={}));var Ye;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(Ye||(e.SyntaxTokenType=Ye={})),function(U){function F(se){switch(se){case U.Other:return"other";case U.Comment:return"comment";case U.String:return"string";case U.RegEx:return"regex"}return"other"}U.toString=F}(Ye||(e.SyntaxTokenType=Ye={}));let Ct=class{constructor(F,se){if(se&&!o.URI.isUri(se))throw(0,R.$6)("target");if(!W.isRange(F)||F.isEmpty)throw(0,R.$6)("range");this.range=F,this.target=se}};e.$oO=Ct,e.$oO=Ct=Je([f],Ct);let hi=class{constructor(F,se,Se,Ke){this.red=F,this.green=se,this.blue=Se,this.alpha=Ke}};e.$pO=hi,e.$pO=hi=Je([f],hi);let pt=class{constructor(F,se){if(se&&!(se instanceof hi))throw(0,R.$6)("color");if(!W.isRange(F)||F.isEmpty)throw(0,R.$6)("range");this.range=F,this.color=se}};e.$qO=pt,e.$qO=pt=Je([f],pt);let Dt=class{constructor(F){if(!F||typeof F!="string")throw(0,R.$6)("label");this.label=F}};e.$rO=Dt,e.$rO=Dt=Je([f],Dt);var ti;(function(U){U[U.RGB=0]="RGB",U[U.HEX=1]="HEX",U[U.HSL=2]="HSL"})(ti||(e.ColorFormat=ti={}));var ii;(function(U){U[U.Error=0]="Error",U[U.Warning=1]="Warning",U[U.Information=2]="Information"})(ii||(e.SourceControlInputBoxValidationType=ii={}));var jt;(function(U){U[U.Unknown=0]="Unknown",U[U.Shutdown=1]="Shutdown",U[U.Process=2]="Process",U[U.User=3]="User",U[U.Extension=4]="Extension"})(jt||(e.TerminalExitReason=jt={}));var gt;(function(U){U[U.Low=0]="Low",U[U.Medium=1]="Medium",U[U.High=2]="High"})(gt||(e.TerminalShellExecutionCommandLineConfidence=gt={}));class zt{constructor(F,se,Se){if(this.startIndex=F,this.length=se,this.tooltip=Se,typeof F!="number"||F<0)throw(0,R.$6)("startIndex");if(typeof se!="number"||se<1)throw(0,R.$6)("length");if(Se!==void 0&&typeof Se!="string")throw(0,R.$6)("tooltip")}}e.$sO=zt;class ni{constructor(F){this.uri=F}}e.$tO=ni;class ai{constructor(F){this.terminalCommand=F}}e.$uO=ai;var Ge;(function(U){U[U.Panel=1]="Panel",U[U.Editor=2]="Editor"})(Ge||(e.TerminalLocation=Ge={}));class ci{constructor(F){if(this.options=F,typeof F!="object")throw(0,R.$6)("options")}}e.$vO=ci;var di;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(di||(e.TaskRevealKind=di={}));var fi;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(fi||(e.TaskPanelKind=fi={}));let vt=class{static{E=this}static{this.Clean=new E("clean","Clean")}static{this.Build=new E("build","Build")}static{this.Rebuild=new E("rebuild","Rebuild")}static{this.Test=new E("test","Test")}static from(F){switch(F){case"clean":return E.Clean;case"build":return E.Build;case"rebuild":return E.Rebuild;case"test":return E.Test;default:return}}constructor(F,se){if(this.label=se,typeof F!="string"||typeof se!="string")throw(0,R.$6)("name");this.c=F}get id(){return this.c}};e.$wO=vt,e.$wO=vt=E=Je([f],vt);function Ft(U){let F="";for(let se=0;se<U.length;se++)F+=U[se].replace(/,/g,",,")+",";return F}let Nt=class{constructor(F,se,Se){if(typeof F!="string")throw(0,R.$6)("process");this.e=[],this.c=F,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Se):this.f=se)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,R.$6)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const se of this.e)F.push(se);return Ft(F)}};e.$xO=Nt,e.$xO=Nt=Je([f],Nt);let Wt=class{constructor(F,se,Se){if(this.f=[],Array.isArray(se)){if(!F)throw(0,R.$6)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,R.$6)("command");this.e=F,this.f=se,this.g=Se}else{if(typeof F!="string")throw(0,R.$6)("commandLine");this.c=F,this.g=se}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,R.$6)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,R.$6)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)F.push(typeof se=="string"?se:se.value);return Ft(F)}};e.$yO=Wt,e.$yO=Wt=Je([f],Wt);var ri;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(ri||(e.ShellQuoting=ri={}));var Kt;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace"})(Kt||(e.TaskScope=Kt={}));class li{constructor(F){this.c=F}computeId(){return"customExecution"+(0,I.$1g)()}set callback(F){this.c=F}get callback(){return this.c}}e.$zO=li;let Bt=class{static{D=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,se,Se,Ke,it,dt){this.k=!1,this.l=this.definition=F;let Et;typeof se=="string"?(this.o=this.name=se,this.w=this.source=Se,this.execution=Ke,Et=it,this.k=!0):se===Kt.Global||se===Kt.Workspace?(this.target=se,this.o=this.name=Se,this.w=this.source=Ke,this.execution=it,Et=dt):(this.target=se,this.o=this.name=Se,this.w=this.source=Ke,this.execution=it,Et=dt),typeof Et=="string"?(this.r=[Et],this.t=!0):Array.isArray(Et)?(this.r=Et,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Nt?this.l={type:D.e,id:this.q.computeId()}:this.q instanceof Wt?this.l={type:D.f,id:this.q.computeId()}:this.q instanceof li?this.l={type:D.c,id:this.q.computeId()}:this.l={type:D.g,id:(0,I.$1g)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,R.$6)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,R.$6)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const se=this.l.type;(D.g===se||D.e===se||D.f===se||D.c===se)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,R.$6)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$AO=Bt,e.$AO=Bt=D=Je([f],Bt);var Qt;(function(U){U[U.SourceControl=1]="SourceControl",U[U.Window=10]="Window",U[U.Notification=15]="Notification"})(Qt||(e.ProgressLocation=Qt={}));var Gt;(function(U){function F(se){const Se=se;return(0,p.$ig)(Se.value)?Se.tooltip&&!(0,p.$eg)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}U.isViewBadge=F})(Gt||(e.ViewBadge=Gt={}));let Lt=w=class{static isTreeItem(F,se){const Se=F;if(Se.checkboxState!==void 0){const Ke=(0,p.$ig)(Se.checkboxState)?Se.checkboxState:(0,p.$gg)(Se.checkboxState)&&(0,p.$ig)(Se.checkboxState.state)?Se.checkboxState.state:void 0,it=!(0,p.$ig)(Se.checkboxState)&&(0,p.$gg)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==kt.Checked&&Ke!==kt.Unchecked||it!==void 0&&!(0,p.$eg)(it))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(F instanceof w)return!0;if(Se.label!==void 0&&!(0,p.$eg)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,p.$eg)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,p.$eg)(Se.iconPath)&&!o.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,p.$eg)(Se.iconPath.id))){const Ke=Se.iconPath;if(!Ke||!(0,p.$eg)(Ke.light)&&!o.URI.isUri(Ke.light)&&!(0,p.$eg)(Ke.dark)&&!o.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,p.$eg)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!o.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,p.$eg)(Se.tooltip)&&!(Se.tooltip instanceof tt)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<wt.None&&Se.collapsibleState>wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,p.$eg)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(F,se=wt.None){this.collapsibleState=se,o.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$BO=Lt,e.$BO=Lt=w=Je([f],Lt);var wt;(function(U){U[U.None=0]="None",U[U.Collapsed=1]="Collapsed",U[U.Expanded=2]="Expanded"})(wt||(e.TreeItemCollapsibleState=wt={}));var kt;(function(U){U[U.Unchecked=0]="Unchecked",U[U.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let Vt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$CO=Vt,e.$CO=Vt=Je([f],Vt);class It extends Vt{}e.$DO=It;class mi extends It{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$EO=mi;class Zt{constructor(F,se,Se,Ke){this.name=F,this.uri=se,this._itemId=Se,this.c=Ke}data(){return this.c()}}e.$FO=Zt;let ki=class{#e=new Map;constructor(F){for(const[se,Se]of F??[]){const Ke=this.#e.get(this.#t(se));Ke?Ke.push(Se):this.#e.set(this.#t(se),[Se])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,se){this.#e.set(this.#t(F),[se])}forEach(F,se){for(const[Se,Ke]of this.#e)for(const it of Ke)F.call(se,it,Se,this)}*[Symbol.iterator](){for(const[F,se]of this.#e)for(const Se of se)yield[F,Se]}#t(F){return F.toLowerCase()}};e.$GO=ki,e.$GO=ki=Je([f],ki);let wi=class{constructor(F,se,Se){this.insertText=F,this.title=se,this.kind=Se}};e.$HO=wi,e.$HO=wi=Je([f],wi);var Ai;(function(U){U[U.Automatic=0]="Automatic",U[U.PasteAs=1]="PasteAs"})(Ai||(e.DocumentPasteTriggerKind=Ai={}));class Tt{static{this.c="."}constructor(F){this.value=F}append(...F){return new Tt((this.value?[this.value,...F]:F).join(Tt.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+Tt.c)}}e.$IO=Tt,Tt.Empty=new Tt("");class Ni{constructor(F,se,Se){this.title=se,this.insertText=F,this.kind=Se}}e.$JO=Ni;let ui=class{constructor(F,se){this.id=F,this.color=se}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$KO=ui,e.$KO=ui=Je([f],ui),ui.File=new ui("file"),ui.Folder=new ui("folder");let Pt=class{constructor(F){this.id=F}};e.$LO=Pt,e.$LO=Pt=Je([f],Pt);var Ti;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.WorkspaceFolder=3]="WorkspaceFolder"})(Ti||(e.ConfigurationTarget=Ti={}));let Ii=class{get base(){return this.c}set base(F){this.c=F,this.e=o.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,se){if(typeof F!="string"&&(!F||!o.URI.isUri(F)&&!o.URI.isUri(F.uri)))throw(0,R.$6)("base");if(typeof se!="string")throw(0,R.$6)("pattern");typeof F=="string"?this.baseUri=o.URI.file(F):o.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$MO=Ii,e.$MO=Ii=Je([f],Ii);const Di=new WeakMap;function Li(U,F){Di.set(U,F)}let bi=class{constructor(F,se,Se,Ke,it){this.enabled=typeof F=="boolean"?F:!0,typeof se=="string"&&(this.condition=se),typeof Se=="string"&&(this.hitCondition=Se),typeof Ke=="string"&&(this.logMessage=Ke),typeof it=="string"&&(this.mode=it)}get id(){return this.c||(this.c=Di.get(this)??(0,I.$1g)()),this.c}};e.$OO=bi,e.$OO=bi=Je([f],bi);let qt=class extends bi{constructor(F,se,Se,Ke,it,dt){if(super(se,Se,Ke,it,dt),F===null)throw(0,R.$6)("location");this.location=F}};e.$PO=qt,e.$PO=qt=Je([f],qt);let De=class extends bi{constructor(F,se,Se,Ke,it,dt){super(se,Se,Ke,it,dt),this.functionName=F}};e.$QO=De,e.$QO=De=Je([f],De);let Re=class extends bi{constructor(F,se,Se,Ke,it,dt,Et,Xt){if(super(Ke,it,dt,Et,Xt),!se)throw(0,R.$6)("dataId");this.label=F,this.dataId=se,this.canPersist=Se}};e.$RO=Re,e.$RO=Re=Je([f],Re);let de=class{constructor(F,se,Se){this.command=F,this.args=se||[],this.options=Se}};e.$SO=de,e.$SO=de=Je([f],de);let J=class{constructor(F,se){this.port=F,this.host=se}};e.$TO=J,e.$TO=J=Je([f],J);let ye=class{constructor(F){this.path=F}};e.$UO=ye,e.$UO=ye=Je([f],ye);let Be=class{constructor(F){this.implementation=F}};e.$VO=Be,e.$VO=Be=Je([f],Be);class Ze{constructor(F,se,Se){this.session=F,this.threadId=se,this.frameId=Se}}e.$WO=Ze;class He{constructor(F,se){this.session=F,this.threadId=se}}e.$XO=He;let ut=class{constructor(F,se){this.range=F,this.expression=se}};e.$YO=ut,e.$YO=ut=Je([f],ut);var Rt;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Rt||(e.InlineCompletionTriggerKind=Rt={}));let Jt=class{constructor(F,se){this.range=F,this.text=se}};e.$ZO=Jt,e.$ZO=Jt=Je([f],Jt);let si=class{constructor(F,se,Se=!0){this.range=F,this.variableName=se,this.caseSensitiveLookup=Se}};e.$1O=si,e.$1O=si=Je([f],si);let Ut=class{constructor(F,se){this.range=F,this.expression=se}};e.$2O=Ut,e.$2O=Ut=Je([f],Ut);let Yt=class{constructor(F,se){this.frameId=F,this.stoppedLocation=se}};e.$3O=Yt,e.$3O=Yt=Je([f],Yt);var Wi;(function(U){U[U.AIGenerated=1]="AIGenerated"})(Wi||(e.NewSymbolNameTag=Wi={}));var rn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(rn||(e.NewSymbolNameTriggerKind=rn={}));class Vi{constructor(F,se){this.newSymbolName=F,this.tags=se}}e.$4O=Vi;var Fi;(function(U){U[U.Changed=1]="Changed",U[U.Created=2]="Created",U[U.Deleted=3]="Deleted"})(Fi||(e.FileChangeType=Fi={}));let Hi=C=class extends Error{static FileExists(F){return new C(F,a.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(F){return new C(F,a.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(F){return new C(F,a.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(F){return new C(F,a.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(F){return new C(F,a.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(F){return new C(F,a.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}constructor(F,se=a.FileSystemProviderErrorCode.Unknown,Se){super(o.URI.isUri(F)?F.toString(!0):F),this.code=Se?.name??"Unknown",(0,a.$ol)(this,se),Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$5O=Hi,e.$5O=Hi=C=Je([f],Hi);let Qi=class{constructor(F,se,Se){this.start=F,this.end=se,this.kind=Se}};e.$6O=Qi,e.$6O=Qi=Je([f],Qi);var Ci;(function(U){U[U.Comment=1]="Comment",U[U.Imports=2]="Imports",U[U.Region=3]="Region"})(Ci||(e.FoldingRangeKind=Ci={}));var sn;(function(U){U[U.Collapsed=0]="Collapsed",U[U.Expanded=1]="Expanded"})(sn||(e.CommentThreadCollapsibleState=sn={}));var on;(function(U){U[U.Editing=0]="Editing",U[U.Preview=1]="Preview"})(on||(e.CommentMode=on={}));var Ui;(function(U){U[U.Published=0]="Published",U[U.Draft=1]="Draft"})(Ui||(e.CommentState=Ui={}));var an;(function(U){U[U.Unresolved=0]="Unresolved",U[U.Resolved=1]="Resolved"})(an||(e.CommentThreadState=an={}));var zi;(function(U){U[U.Current=0]="Current",U[U.Outdated=1]="Outdated"})(zi||(e.CommentThreadApplicability=zi={}));var Ki;(function(U){U[U.Reply=1]="Reply",U[U.Comment=2]="Comment"})(Ki||(e.CommentThreadFocus=Ki={}));class En{constructor(F,se=[]){this.tokenTypes=F,this.tokenModifiers=se}}e.$7O=En;function cn(U){return typeof U>"u"||(0,p.$fg)(U)}class Gi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let se=0,Se=F.tokenTypes.length;se<Se;se++)this.k.set(F.tokenTypes[se],se);for(let se=0,Se=F.tokenModifiers.length;se<Se;se++)this.l.set(F.tokenModifiers[se],se)}}push(F,se,Se,Ke,it){if(typeof F=="number"&&typeof se=="number"&&typeof Se=="number"&&typeof Ke=="number"&&(typeof it=="number"||typeof it>"u"))return typeof it>"u"&&(it=0),this.q(F,se,Se,Ke,it);if(W.isRange(F)&&typeof se=="string"&&cn(Se))return this.o(F,se,Se);throw(0,R.$6)()}o(F,se,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(se))throw new Error("`tokenType` is not in the provided legend");const Ke=F.start.line,it=F.start.character,dt=F.end.character-F.start.character,Et=this.k.get(se);let Xt=0;if(Se)for(const $i of Se){if(!this.l.has($i))throw new Error("`tokenModifier` is not in the provided legend");const Ei=this.l.get($i);Xt|=1<<Ei>>>0}this.q(Ke,it,dt,Et,Xt)}q(F,se,Se,Ke,it){if(this.f&&(F<this.c||F===this.c&&se<this.e)){this.f=!1;const Xt=this.g.length/5|0;let $i=0,Ei=0;for(let Si=0;Si<Xt;Si++){let Ri=this.g[5*Si],tn=this.g[5*Si+1];Ri===0?(Ri=$i,tn+=Ei):Ri+=$i,this.g[5*Si]=Ri,this.g[5*Si+1]=tn,$i=Ri,Ei=tn}}let dt=F,Et=se;this.f&&this.j>0&&(dt-=this.c,dt===0&&(Et-=this.e)),this.g[this.j++]=dt,this.g[this.j++]=Et,this.g[this.j++]=Se,this.g[this.j++]=Ke,this.g[this.j++]=it,this.c=F,this.e=se}static r(F){const se=[],Se=F.length/5|0;for(let Et=0;Et<Se;Et++)se[Et]=Et;se.sort((Et,Xt)=>{const $i=F[5*Et],Ei=F[5*Xt];if($i===Ei){const Si=F[5*Et+1],Ri=F[5*Xt+1];return Si-Ri}return $i-Ei});const Ke=new Uint32Array(F.length);let it=0,dt=0;for(let Et=0;Et<Se;Et++){const Xt=5*se[Et],$i=F[Xt+0],Ei=F[Xt+1],Si=F[Xt+2],Ri=F[Xt+3],tn=F[Xt+4],Qn=$i-it,Lr=Qn===0?Ei-dt:Ei,nn=5*Et;Ke[nn+0]=Qn,Ke[nn+1]=Lr,Ke[nn+2]=Si,Ke[nn+3]=Ri,Ke[nn+4]=tn,it=$i,dt=Ei}return Ke}build(F){return this.f?new Pi(new Uint32Array(this.g),F):new Pi(Gi.r(this.g),F)}}e.$8O=Gi;class Pi{constructor(F,se){this.resultId=se,this.data=F}}e.$9O=Pi;class Dn{constructor(F,se,Se){this.start=F,this.deleteCount=se,this.data=Se}}e.$0O=Dn;class Sn{constructor(F,se){this.resultId=se,this.edits=F}}e.$$O=Sn;var ln;(function(U){U[U.Separate=0]="Separate",U[U.MergeWithParent=1]="MergeWithParent"})(ln||(e.DebugConsoleMode=ln={}));class Ji{constructor(F){this.name=F}}e.$_O=Ji;var Xi;(function(U){U[U.Title=1]="Title",U[U.Inline=2]="Inline"})(Xi||(e.QuickInputButtonLocation=Xi={}));let Fe=class{static{this.Back={iconPath:new ui("arrow-left")}}constructor(){}};e.$aP=Fe,e.$aP=Fe=Je([f],Fe);var vi;(function(U){U[U.Separator=-1]="Separator",U[U.Default=0]="Default"})(vi||(e.QuickPickItemKind=vi={}));var Zi;(function(U){U[U.Info=1]="Info",U[U.Warning=2]="Warning",U[U.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var ot;(function(U){U[U.UI=1]="UI",U[U.Workspace=2]="Workspace"})(ot||(e.ExtensionKind=ot={}));class St{static validate(F){if(typeof F.badge=="string"){let se=(0,T.$Pf)(F.badge,0);if(se<F.badge.length&&(se+=(0,T.$Pf)(F.badge,se)),F.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!ui.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,se,Se){this.badge=F,this.tooltip=se,this.color=Se}}e.$bP=St;let Yi=class{constructor(F){this.kind=F}};e.$cP=Yi,e.$cP=Yi=Je([f],Yi);var un;(function(U){U[U.Light=1]="Light",U[U.Dark=2]="Dark",U[U.HighContrast=3]="HighContrast",U[U.HighContrastLight=4]="HighContrastLight"})(un||(e.ColorThemeKind=un={}));class yi{static isNotebookRange(F){return F instanceof yi?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,se){if(F<0)throw(0,R.$6)("start must be positive");if(se<0)throw(0,R.$6)("end must be positive");F<=se?(this.c=F,this.e=se):(this.c=se,this.e=F)}with(F){let se=this.c,Se=this.e;return F.start!==void 0&&(se=F.start),F.end!==void 0&&(Se=F.end),se===this.c&&Se===this.e?this:new yi(se,Se)}}e.$dP=yi;class ji{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(se=>ji.isNotebookCellData(se))}static isNotebookCellData(F){return!0}constructor(F,se,Se,Ke,it,dt,Et){this.kind=F,this.value=se,this.languageId=Se,this.mime=Ke,this.outputs=it??[],this.metadata=dt,this.executionSummary=Et,ji.validate(this)}}e.$eP=ji;class Bi{constructor(F){this.cells=F}}e.$fP=Bi;class pi{static isNotebookCellOutputItem(F){return F instanceof pi?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const se={name:F.name,message:F.message,stack:F.stack};return pi.json(se,"application/vnd.code.notebook.error")}static stdout(F){return pi.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return pi.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,se="application/octet-stream"){return new pi(F,se)}static#e=new TextEncoder;static text(F,se=A.$0s.text){const Se=pi.#e.encode(String(F));return new pi(Se,se)}static json(F,se="text/x-json"){const Se=JSON.stringify(F,void 0,"	");return pi.text(Se,se)}constructor(F,se){this.data=F,this.mime=se;const Se=(0,A.$bt)(se,!0);if(!Se)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$gP=pi;class qi{static isNotebookCellOutput(F){return F instanceof qi?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,se=!1){const Se=new Set,Ke=new Set;for(let it=0;it<F.length;it++){const dt=F[it],Et=(0,A.$bt)(dt.mime);if(!Se.has(Et)||(0,d.$LL)(Et)){Se.add(Et);continue}Ke.add(it),se&&console.warn(`DUPLICATED mime type '${dt.mime}' will be dropped`)}return Ke.size===0?F:F.filter((it,dt)=>!Ke.has(dt))}constructor(F,se,Se){this.items=qi.ensureUniqueMimeTypes(F,!0),typeof se=="string"?(this.id=se,this.metadata=Se):(this.id=(0,I.$1g)(),this.metadata=se??Se)}}e.$hP=qi;var hn;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(hn||(e.NotebookCellKind=hn={}));var xi;(function(U){U[U.Idle=1]="Idle",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var dn;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(dn||(e.NotebookCellStatusBarAlignment=dn={}));var fn;(function(U){U[U.Default=0]="Default",U[U.InCenter=1]="InCenter",U[U.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",U[U.AtTop=3]="AtTop"})(fn||(e.NotebookEditorRevealType=fn={}));class kn{constructor(F,se){this.text=F,this.alignment=se}}e.$iP=kn;var gn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred"})(gn||(e.NotebookControllerAffinity=gn={}));var mn;(function(U){U[U.Default=1]="Default",U[U.Preferred=2]="Preferred",U[U.Hidden=-1]="Hidden"})(mn||(e.NotebookControllerAffinity2=mn={}));class In{constructor(F,se=[]){this.uri=F,this.provides=(0,v.$1b)(se)}}e.$jP=In;class Cn{constructor(F){this.label=F}}e.$kP=Cn;var pn;(function(U){U[U.Named=1]="Named",U[U.Indexed=2]="Indexed"})(pn||(e.NotebookVariablesRequestKind=pn={}));let _i=class{constructor(F,se){this.label=F,this.timestamp=se}};e.$lP=_i,e.$lP=_i=Je([f],_i);var $n;(function(U){U[U.Production=1]="Production",U[U.Development=2]="Development",U[U.Test=3]="Test"})($n||(e.ExtensionMode=$n={}));var wn;(function(U){U[U.Node=1]="Node",U[U.Webworker=2]="Webworker"})(wn||(e.ExtensionRuntime=wn={}));var te;(function(U){U[U.Other=0]="Other",U[U.Comment=1]="Comment",U[U.String=2]="String",U[U.RegEx=3]="RegEx"})(te||(e.StandardTokenType=te={}));class ue{constructor(F,se){this.ranges=F,this.wordPattern=se}}e.$mP=ue;class Me{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$nP=Me;var at;(function(U){U[U.Queued=1]="Queued",U[U.Running=2]="Running",U[U.Passed=3]="Passed",U[U.Failed=4]="Failed",U[U.Skipped=5]="Skipped",U[U.Errored=6]="Errored"})(at||(e.TestResultState=at={}));var yt;(function(U){U[U.Run=1]="Run",U[U.Debug=2]="Debug",U[U.Coverage=3]="Coverage"})(yt||(e.TestRunProfileKind=yt={}));let Ot=class{constructor(F=void 0,se=void 0,Se=void 0,Ke=!1,it=!0){this.include=F,this.exclude=se,this.profile=Se,this.continuous=Ke,this.preserveFocus=it}};e.$oP=Ot,e.$oP=Ot=Je([f],Ot);let gi=k=class{static diff(F,se,Se){const Ke=new k(F);return Ke.expectedOutput=se,Ke.actualOutput=Se,Ke}constructor(F){this.message=F}};e.$pP=gi,e.$pP=gi=k=Je([f],gi);let Mi=class{constructor(F){this.id=F}};e.$qP=Mi,e.$qP=Mi=Je([f],Mi);class en{constructor(F,se,Se){this.label=F,this.file=se,this.position=Se}}e.$rP=en;class bn{constructor(F,se){this.covered=F,this.total=se,Rn(this)}}e.$sP=bn;function Rn(U){if(U){if(U.covered>U.total)throw new Error(`The total number of covered items (${U.covered}) cannot be greater than the total (${U.total})`);if(U.total<0)throw new Error(`The number of covered items (${U.total}) cannot be negative`)}}class Pn{static fromDetails(F,se){const Se=new bn(0,0),Ke=new bn(0,0),it=new bn(0,0);for(const Et of se)if("branches"in Et){Se.total+=1,Se.covered+=Et.executed?1:0;for(const Xt of Et.branches)Ke.total+=1,Ke.covered+=Xt.executed?1:0}else it.total+=1,it.covered+=Et.executed?1:0;const dt=new Pn(F,Se,Ke.total>0?Ke:void 0,it.total>0?it:void 0);return dt.detailedCoverage=se,dt}constructor(F,se,Se,Ke,it=[]){this.uri=F,this.statementCoverage=se,this.branchCoverage=Se,this.declarationCoverage=Ke,this.fromTests=it}}e.$uP=Pn;class Jn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,Se=[]){this.executed=F,this.location=se,this.branches=Se}}e.$vP=Jn;class Xn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,Se){this.executed=F,this.location=se,this.label=Se}}e.$wP=Xn;class Zn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,se,Se){this.name=F,this.executed=se,this.location=Se}}e.$xP=Zn;var An;(function(U){U[U.None=0]="None",U[U.Option=1]="Option",U[U.Default=2]="Default",U[U.Preferred=3]="Preferred"})(An||(e.ExternalUriOpenerPriority=An={}));var Tn;(function(U){U[U.Untrusted=0]="Untrusted",U[U.Trusted=1]="Trusted",U[U.Unspecified=2]="Unspecified"})(Tn||(e.WorkspaceTrustState=Tn={}));var On;(function(U){U[U.Notify=1]="Notify",U[U.OpenBrowser=2]="OpenBrowser",U[U.OpenPreview=3]="OpenPreview",U[U.Silent=4]="Silent",U[U.Ignore=5]="Ignore",U[U.OpenBrowserOnce=6]="OpenBrowserOnce"})(On||(e.PortAutoForwardAction=On={}));class Yn{constructor(F,se,Se,Ke,it,dt){this.kind=F,this.name=se,this.detail=Se,this.uri=Ke,this.range=it,this.selectionRange=dt}}e.$yP=Yn;class xn{constructor(F){this.uri=F}}e.$zP=xn;class _n{constructor(F,se){this.original=F,this.modified=se}}e.$AP=_n;class er{constructor(F,se,Se,Ke){this.base=F,this.input1=se,this.input2=Se,this.result=Ke}}e.$BP=er;class tr{constructor(F,se){this.uri=F,this.viewType=se}}e.$CP=tr;class ir{constructor(F){this.viewType=F}}e.$DP=ir;class nr{constructor(F,se){this.uri=F,this.notebookType=se}}e.$EP=nr;class rr{constructor(F,se,Se){this.original=F,this.modified=se,this.notebookType=Se}}e.$FP=rr;class sr{constructor(){}}e.$GP=sr;class or{constructor(F,se){this.uri=F,this.inputBoxUri=se}}e.$HP=or;class ar{constructor(){}}e.$IP=ar;class cr{constructor(F){this.textDiffs=F}}e.$JP=cr;var Nn;(function(U){U[U.Down=0]="Down",U[U.Up=1]="Up"})(Nn||(e.InteractiveSessionVoteDirection=Nn={}));var Ln;(function(U){U[U.Action=1]="Action",U[U.Toolbar=2]="Toolbar"})(Ln||(e.ChatCopyKind=Ln={}));var Mn;(function(U){U[U.Short=1]="Short",U[U.Medium=2]="Medium",U[U.Full=3]="Full"})(Mn||(e.ChatVariableLevel=Mn={}));class lr{constructor(F,se,Se){this.id=F,this.label=se,this.values=Se}}e.$KP=lr;var Fn;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful",U[U.Undone=2]="Undone",U[U.Accepted=3]="Accepted",U[U.Bug=4]="Bug"})(Fn||(e.InteractiveEditorResponseFeedbackKind=Fn={}));var Un;(function(U){U[U.Unhelpful=0]="Unhelpful",U[U.Helpful=1]="Helpful"})(Un||(e.ChatResultFeedbackKind=Un={}));class ur{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.$LP=ur;class hr{constructor(F,se){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F,this.vulnerabilities=se}}e.$MP=hr;class dr{constructor(F,se){this.participant=F,this.command=se}}e.$NP=dr;class fr{constructor(F,se,Se,Ke){this.title=F,this.message=se,this.data=Se,this.buttons=Ke}}e.$OP=fr;class gr{constructor(F,se){this.value=F,this.baseUri=se}}e.$PP=gr;class mr{constructor(F,se){this.value=F,this.title=se}}e.$QP=mr;class pr{constructor(F){this.value=F}}e.$RP=pr;class $r{constructor(F,se){this.value=F,this.task=se}}e.$SP=$r;class wr{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new tt(F):F}}e.$TP=wr;class br{constructor(F){this.value=F}}e.$UP=br;class vr{constructor(F,se,Se){this.value=F,this.iconPath=se,this.options=Se}}e.$VP=vr;class yr{constructor(F,se,Se){this.value=F,this.license=se,this.snippet=Se}}e.$WP=yr;class Er{constructor(F,se){this.uri=F,this.edits=Array.isArray(se)?se:[se]}}e.$XP=Er;class Dr{constructor(F,se,Se,Ke){this.prompt=F,this.command=se,this.references=Se,this.participant=Ke}}e.$YP=Dr;class Sr{constructor(F,se,Se,Ke){this.response=F,this.result=se,this.participant=Se,this.command=Ke}}e.$ZP=Sr;var zn;(function(U){U[U.Panel=1]="Panel",U[U.Terminal=2]="Terminal",U[U.Notebook=3]="Notebook",U[U.Editor=4]="Editor"})(zn||(e.ChatLocation=zn={}));var jn;(function(U){U[U.Complete=1]="Complete",U[U.Partial=2]="Partial",U[U.Omitted=3]="Omitted"})(jn||(e.ChatResponseReferencePartStatusKind=jn={}));class kr{constructor(F,se,Se){this.document=F,this.selection=se,this.wholeRange=Se}}e.$1P=kr;class Ir{constructor(F){this.cell=F}}e.$2P=Ir;var vn;(function(U){U[U.User=1]="User",U[U.Assistant=2]="Assistant",U[U.System=3]="System"})(vn||(e.LanguageModelChatMessageRole=vn={}));class Cr{constructor(F,se,Se){this.name=F,this.content=se,this.isError=Se??!1}}e.$3P=Cr;class yn{static User(F,se){const Se=new yn(vn.User,typeof F=="string"?F:"",se);return Se.content2=F,Se}static Assistant(F,se){return new yn(vn.Assistant,F,se)}constructor(F,se,Se){this.role=F,this.content=se,this.content2=se,this.name=Se}}e.$4P=yn;class Pr{constructor(F,se){this.name=F,this.parameters=se}}e.$5P=Pr;class Rr{constructor(F){this.value=F}}e.$6P=Rr;class Ar{constructor(F){this.content=F}}e.$7P=Ar;class Tr{constructor(F,se){this.content=F,this.name=se}}e.$8P=Tr;class Or{constructor(F,se){this.content=F,this.name=se}}e.$9P=Or;class Oi extends Error{static NotFound(F){return new Oi(F,Oi.NotFound.name)}static NoPermissions(F){return new Oi(F,Oi.NoPermissions.name)}static Blocked(F){return new Oi(F,Oi.Blocked.name)}constructor(F,se,Se){super(F,{cause:Se}),this.name="LanguageModelError",this.code=se??""}}e.$0P=Oi;var Bn;(function(U){U[U.SymbolInformation=1]="SymbolInformation",U[U.CommandInformation=2]="CommandInformation",U[U.SearchInformation=3]="SearchInformation",U[U.SettingInformation=4]="SettingInformation"})(Bn||(e.RelatedInformationType=Bn={}));var qn;(function(U){U[U.Started=1]="Started",U[U.Recognizing=2]="Recognizing",U[U.Recognized=3]="Recognized",U[U.Stopped=4]="Stopped",U[U.Error=5]="Error"})(qn||(e.SpeechToTextStatus=qn={}));var Wn;(function(U){U[U.Started=1]="Started",U[U.Stopped=2]="Stopped",U[U.Error=3]="Error"})(Wn||(e.TextToSpeechStatus=Wn={}));var Vn;(function(U){U[U.Recognized=1]="Recognized",U[U.Stopped=2]="Stopped"})(Vn||(e.KeywordRecognitionStatus=Vn={}));class Nr{constructor(F,se){this.text=F,this.range=se}}e.$$P=Nr;var Hn;(function(U){U[U.Invoke=0]="Invoke",U[U.Automatic=1]="Automatic"})(Hn||(e.InlineEditTriggerKind=Hn={}))}),define(Ne[227],Le([1,0,5,7]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mpc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$JN.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,T,p){if(this.a.size===0)throw new Error("No related information providers registered");const o=this.a.get(A);if(!o)throw new Error("related information provider not found");return await o.provideRelatedInformation(T,p)??[]}getRelatedInformation(A,T,p){return this.c.$getAiRelatedInformation(T,p)}registerRelatedInformationProvider(A,T,p){const o=this.b;return this.b++,this.a.set(o,p),this.c.$registerAiRelatedInformationProvider(o,T),new R.$LN(()=>{this.c.$unregisterAiRelatedInformationProvider(o),this.a.delete(o)})}}e.$mpc=P}),define(Ne[90],Le([1,0,6,5,7,18,117,3,16]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ypc=e.$xpc=void 0,e.$xpc=(0,T.$Ei)("IExtHostAuthentication");let o=class{constructor(a){this.b=new Map,this.c=new v.$le,this.onDidChangeSessions=this.c.event,this.d=new I,this.a=a.getProxy(R.$JN.MainThreadAuthentication)}async getSession(a,S,d,r={}){const s=O.$qn.toKey(a.identifier),c=[...d].sort().join(" ");return await this.d.getOrCreate(`${s} ${S} ${c}`,async()=>{await this.a.$ensureProvider(S);const l=a.displayName||a.name;return this.a.$getSession(S,d,s,l,r)})}async getAccounts(a){return await this.a.$ensureProvider(a),await this.a.$getAccounts(a)}async removeSession(a,S){const d=this.b.get(a);return d?d.provider.removeSession(S):this.a.$removeSession(a,S)}registerAuthenticationProvider(a,S,d,r){if(this.b.get(a))throw new Error(`An authentication provider with id '${a}' is already registered.`);this.b.set(a,{label:S,provider:d,options:r??{supportsMultipleAccounts:!1}});const s=d.onDidChangeSessions(c=>this.a.$sendDidChangeSessions(a,c));return this.a.$registerAuthenticationProvider(a,S,r?.supportsMultipleAccounts??!1),new P.$LN(()=>{s.dispose(),this.b.delete(a),this.a.$unregisterAuthenticationProvider(a)})}async $createSession(a,S,d){const r=this.b.get(a);if(r)return await r.provider.createSession(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $removeSession(a,S){const d=this.b.get(a);if(d)return await d.provider.removeSession(S);throw new Error(`Unable to find authentication provider with handle: ${a}`)}async $getSessions(a,S,d){const r=this.b.get(a);if(r)return await r.provider.getSessions(S,d);throw new Error(`Unable to find authentication provider with handle: ${a}`)}$onDidChangeAuthenticationSessions(a,S){return a.startsWith(A.$LM)||this.c.fire({provider:{id:a,label:S}}),Promise.resolve()}};e.$ypc=o,e.$ypc=o=Je([Ve(0,p.$jQ)],o);class I{constructor(){this.a=new Map}getOrCreate(a,S){const d=this.a.get(a);if(d)return d;const r=S().finally(()=>this.a.delete(a));return this.a.set(a,r),r}}}),define(Ne[122],Le([1,0,2,5,7,3,16,11,17,12,19,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dqc=e.$Cqc=void 0;let S=class{static{a=this}static{this.c=0}static{this.d=250}constructor(r,s){this.h=s,this.f=new Map,this.g=r.getProxy(R.$JN.MainThreadDecorations)}registerFileDecorationProvider(r,s){const c=a.c++;this.f.set(c,{provider:r,extensionDescription:s}),this.g.$registerDecorationProvider(c,s.identifier.value);const l=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(i=>{if(!i){this.g.$onDidChange(c,null);return}const n=(0,p.$1b)(i);if(n.length<=a.d){this.g.$onDidChange(c,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,n.length);const t=n.map($=>({uri:$,rank:(0,o.$if)($.path,"/")})),g=(0,p.$yb)(t,($,m)=>$.rank-m.rank||(0,o.$yf)($.uri.path,m.uri.path)),u=[];e:for(const $ of g){let m;for(const h of $){const E=(0,I.$mc)(h.uri.path);if(m!==E&&(m=E,u.push(h.uri)>=a.d))break e}}this.g.$onDidChange(c,u)});return new P.$LN(()=>{l?.dispose(),this.g.$unregisterDecorationProvider(c),this.f.delete(c)})}async $provideDecorations(r,s,c){if(!this.f.has(r))return Object.create(null);const l=Object.create(null),{provider:i,extensionDescription:n}=this.f.get(r);return await Promise.all(s.map(async t=>{try{const{uri:g,id:u}=t,$=await Promise.resolve(i.provideFileDecoration(v.URI.revive(g),c));if(!$)return;try{P.$bP.validate($),$.badge&&typeof $.badge!="string"&&(0,y.$fH)(n,"codiconDecoration"),l[u]=[$.propagate,$.tooltip,$.badge,$.color]}catch(m){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${m}`)}}catch(g){this.h.error(g)}})),l}};e.$Cqc=S,e.$Cqc=S=a=Je([Ve(0,A.$jQ),Ve(1,T.$_j)],S),e.$Dqc=(0,O.$Ei)("IExtHostDecorations")}),define(Ne[228],Le([1,0,13,2,7,5,15,21,12]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fqc=void 0;class o{static{this.a=0}constructor(y,a,S){this.d=a,this.e=S,this.b=new Map,this.c=y.getProxy(O.$JN.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,a){if(Object.keys(A.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const S=o.a++;this.b.set(S,a),this.c.$registerTextContentProvider(S,y);let d;if(typeof a.onDidChange=="function"){let r;d=a.onDidChange(async s=>{if(s.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${s.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(s))return;r&&await r;const c=this.$provideTextDocumentContent(S,s).then(async l=>{if(!l&&typeof l!="string")return;const i=this.d.getDocument(s);if(!i)return;const n=(0,p.$sf)(l);if(!i.equalLines(n))return this.c.$onVirtualDocumentChange(s,l)}).catch(v.$Y).finally(()=>{r===c&&(r=void 0)});r=c})}return new P.$LN(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),d&&(d.dispose(),d=void 0)})}$provideTextDocumentContent(y,a){const S=this.b.get(y);return S?Promise.resolve(S.provideTextDocumentContent(R.URI.revive(a),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${a.scheme}`))}}e.$Fqc=o}),define(Ne[123],Le([1,0,61,15,12,284,169,7,17]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=e.$mQ=void 0,e.$lQ=I;const o=new Map;function I(d,r){r?o.set(d,r):o.delete(d)}function y(d){return o.get(d)}class a extends O.$ow{constructor(r,s,c,l,i,n,t){super(s,c,l,i),this.c=r,this.m=n,this.q=t,this.b=!1}dispose(){(0,v.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,p.$tb)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===R.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(s){return s?r.s(s):r.getText()},get eol(){return r.g===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(s){return r.t(s)},offsetAt(s){return r.u(s)},positionAt(s){return r.v(s)},validateRange(s){return r.w(s)},validatePosition(s){return r.x(s)},getWordRangeAtPosition(s,c){return r.y(s,c)},[Symbol.for("debug.description")](){return`TextDocument(${r.d.toString()})`}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,v.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,v.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const s=this.w(r);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const c=this.g,l=s.start.line,i=s.end.line,n=[];n.push(this.f[l].substring(s.start.character));for(let t=l+1;t<i;t++)n.push(this.f[t]);return n.push(this.f[i].substring(0,s.end.character)),n.join(c)}t(r){let s;if(r instanceof T.$MN?s=r.line:typeof r=="number"&&(s=r),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new S(s,this.f[s],s===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const s=this.j.getIndexOf(r),c=this.f[s.index].length;return new T.$MN(s.index,Math.min(s.remainder,c))}w(r){if(!(r instanceof T.$NN))throw new Error("Invalid argument");const s=this.x(r.start),c=this.x(r.end);return s===r.start&&c===r.end?r:new T.$NN(s.line,s.character,c.line,c.character)}x(r){if(!(r instanceof T.$MN))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:s,character:c}=r,l=!1;if(s<0)s=0,c=0,l=!0;else if(s>=this.f.length)s=this.f.length-1,c=this.f[s].length,l=!0;else{const i=this.f[s].length;c<0?(c=0,l=!0):c>i&&(c=i,l=!0)}return l?new T.$MN(s,c):r}y(r,s){const c=this.x(r);if(!s)s=y(this.m);else if((0,P.$rf)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const l=(0,A.$pt)(c.character+1,(0,A.$nt)(s),this.f[c.line],0);if(l)return new T.$NN(c.line,l.startColumn-1,c.line,l.endColumn-1)}}e.$mQ=a;class S{constructor(r,s,c){this.a=r,this.b=s,this.c=c}get lineNumber(){return this.a}get text(){return this.b}get range(){return new T.$NN(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new T.$NN(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$nQ=S}),define(Ne[229],Le([1,0,5,7]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iqc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(v.$JN.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,T,p){if(this.a.size===0)throw new Error("No embedding vector providers registered");const o=this.a.get(A);if(!o)throw new Error("Embedding vector provider not found");const I=await o.provideEmbeddingVector(T,p);if(!I)throw new Error("Embedding vector provider returned undefined");return I}registerEmbeddingVectorProvider(A,T,p){const o=this.b;return this.b++,this.a.set(o,p),this.c.$registerAiEmbeddingVectorProvider(T,o),new R.$LN(()=>{this.c.$unregisterAiEmbeddingVectorProvider(o),this.a.delete(o)})}}e.$Iqc=P}),define(Ne[68],Le([1,0,5,29,7,22,3,16,50,4,10,23,15]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Opc=e.$Npc=void 0,R=We(R);let d=S=class{constructor(s,c){this.b=new Map,this.c=new I.$Nh,this.a=s.getProxy(v.$JN.MainThreadFileSystem);const l=this;this.value=Object.freeze({async stat(i){try{let n;const t=l.b.get(i.scheme);return t?(await l.a.$ensureActivation(i.scheme),n=await t.impl.stat(i)):n=await l.a.$stat(i),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===R.FilePermission.Readonly?1:void 0}}catch(n){S.e(n)}},async readDirectory(i){try{const n=l.b.get(i.scheme);return n?(await l.a.$ensureActivation(i.scheme),(await n.impl.readDirectory(i)).slice()):await l.a.$readdir(i)}catch(n){return S.e(n)}},async createDirectory(i){try{const n=l.b.get(i.scheme);return n&&!n.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(n.impl,n.extUri,i)):await l.a.$mkdir(i)}catch(n){return S.e(n)}},async readFile(i){try{const n=l.b.get(i.scheme);return n?(await l.a.$ensureActivation(i.scheme),(await n.impl.readFile(i)).slice()):(await l.a.$readFile(i)).buffer}catch(n){return S.e(n)}},async writeFile(i,n){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly?(await l.a.$ensureActivation(i.scheme),await l.d(t.impl,t.extUri,t.extUri.dirname(i)),await l.c.queueFor(i,()=>Promise.resolve(t.impl.writeFile(i,n,{create:!0,overwrite:!0})))):await l.a.$writeFile(i,O.$Ne.wrap(n))}catch(t){return S.e(t)}},async delete(i,n){try{const t=l.b.get(i.scheme);return t&&!t.isReadonly&&!n?.useTrash?(await l.a.$ensureActivation(i.scheme),await t.impl.delete(i,{recursive:!1,...n})):await l.a.$delete(i,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(t){return S.e(t)}},async rename(i,n,t){try{return await l.a.$rename(i,n,{overwrite:!1,...t})}catch(g){return S.e(g)}},async copy(i,n,t){try{return await l.a.$copy(i,n,{overwrite:!1,...t})}catch(g){return S.e(g)}},isWritableFileSystem(i){const n=c.getCapabilities(i);if(typeof n=="number")return!(n&R.FileSystemProviderCapabilities.Readonly)}})}async d(s,c,l){const i=[];for(;!c.isEqual(l,c.dirname(l));)try{if(!((await s.stat(l)).type&R.FileType.Directory))throw P.$5O.FileExists(`Unable to create folder '${l.scheme===a.Schemas.file?l.fsPath:l.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(R.$pl(n)!==R.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(c.basename(l)),l=c.dirname(l)}for(let n=i.length-1;n>=0;n--){l=c.joinPath(l,i[n]);try{await s.createDirectory(l)}catch(t){if(R.$pl(t)!==R.FileSystemProviderErrorCode.FileExists)throw t}}}static e(s){if(s instanceof P.$5O)throw s;if(s instanceof R.$ll)switch(s.code){case R.FileSystemProviderErrorCode.FileExists:throw P.$5O.FileExists(s.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$5O.FileNotFound(s.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$5O.FileNotADirectory(s.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$5O.FileIsADirectory(s.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$5O.NoPermissions(s.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$5O.Unavailable(s.message);default:throw new P.$5O(s.message,s.name)}if(!(s instanceof Error))throw new P.$5O(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw P.$5O.Unavailable(s.message);switch(s.name){case R.FileSystemProviderErrorCode.FileExists:throw P.$5O.FileExists(s.message);case R.FileSystemProviderErrorCode.FileNotFound:throw P.$5O.FileNotFound(s.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw P.$5O.FileNotADirectory(s.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw P.$5O.FileIsADirectory(s.message);case R.FileSystemProviderErrorCode.NoPermissions:throw P.$5O.NoPermissions(s.message);case R.FileSystemProviderErrorCode.Unavailable:throw P.$5O.Unavailable(s.message);default:throw new P.$5O(s.message,s.name)}}addFileSystemProvider(s,c,l){return this.b.set(s,{impl:c,extUri:l?.isCaseSensitive?y.$8g:y.$0g,isReadonly:!!l?.isReadonly}),(0,o.$Sc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??y.$8g}};e.$Npc=d,e.$Npc=d=S=Je([Ve(0,T.$jQ),Ve(1,p.$rpc)],d),e.$Opc=(0,A.$Ei)("IExtHostConsumerFileSystem")}),define(Ne[91],Le([1,0,3,26,11,68,2]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpc=e.$Ppc=void 0,e.$Ppc=(0,v.$Ei)("IExtensionStoragePaths");let T=class{constructor(o,I,y){this.d=I,this.f=y,this.a=o.workspace??void 0,this.b=o.environment,this.whenReady=this.h().then(a=>this.c=a)}async g(o){return A.URI.joinPath(this.b.workspaceStorageHome,o)}async h(){if(!this.a)return Promise.resolve(void 0);const o=this.a.id,I=await this.g(o);try{return await this.f.value.stat(I),this.d.trace("[ExtHostStorage] storage dir already exists",I),I}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",I),await this.f.value.createDirectory(I),await this.f.value.writeFile(A.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),I}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(o){if(this.c)return A.URI.joinPath(this.c,o.identifier.value)}globalValue(o){return A.URI.joinPath(this.b.globalStorageHome,o.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Qpc=T,e.$Qpc=T=Je([Ve(0,R.$zQ),Ve(1,P.$_j),Ve(2,O.$Opc)],T)}),define(Ne[230],Le([1,0,7,16,6]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nrc=void 0;let O=class{constructor(T){this.a=new v.$cP(v.ColorThemeKind.Dark),this.b=new P.$le}get activeColorTheme(){return this.a}$onColorThemeChange(T){let p;switch(T){case"light":p=v.ColorThemeKind.Light;break;case"hcDark":p=v.ColorThemeKind.HighContrast;break;case"hcLight":p=v.ColorThemeKind.HighContrastLight;break;default:p=v.ColorThemeKind.Dark}this.a=new v.$cP(p),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$nrc=O,e.$nrc=O=Je([Ve(0,R.$jQ)],O)}),define(Ne[92],Le([1,0,21,6,4,9,3,11,183,5,26,16,7]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hGb=e.$gGb=e.TunnelDtoConverter=void 0,O=We(O),a=We(a);class S extends p.$Nw{}var d;(function(s){function c(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public,privacy:i.privacy??(i.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:i.protocol}}s.fromApiTunnel=c;function l(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.privacy!==p.TunnelPrivacyId.ConstantPrivate&&i.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:i.privacy,protocol:i.protocol}}s.fromServiceTunnel=l})(d||(e.TunnelDtoConverter=d={})),e.$gGb=(0,A.$Ei)("IExtHostTunnelService");let r=class extends P.$Uc{constructor(c,l,i){super(),this.s=i,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new R.$le,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=c.getProxy(o.$JN.MainThreadTunnelService)}async openTunnel(c,l){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${c.identifier.value} called openTunnel API for ${l.remoteAddress.host}:${l.remoteAddress.port}.`);const i=await this.a.$openTunnel(l,c.displayName);if(i){const n=new S(i.remoteAddress,i.localAddress,()=>this.a.$closeTunnel(i.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(c,l){c.portRange===void 0&&c.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const i=this.u();return this.r.set(i,{selector:c,provider:l}),this.a.$registerPortsAttributesProvider(c,i),new a.$LN(()=>{this.r.delete(i),this.a.$unregisterPortsAttributesProvider(i)})}async $providePortAttributes(c,l,i,n,t){const g=[];for(const $ of c){const m=this.r.get($);if(!m)return[];g.push(...await Promise.all(l.map(async h=>{let E;try{E=await m.provider.providePortAttributes({port:h,pid:i,commandLine:n},t)}catch{E=await m.provider.providePortAttributes(h,i,n,t)}return{providedAttributes:E,port:h}})))}const u=g.filter($=>!!$.providedAttributes);return u.length>0?u.map($=>({autoForwardAction:$.providedAttributes.autoForwardAction,port:$.port})):[]}async $registerCandidateFinder(c){}registerTunnelProvider(c,l){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,t)=>await c.provideTunnel(n,t,v.CancellationToken.None)??void 0;const i=l.tunnelFeatures?{elevation:!!l.tunnelFeatures?.elevation,privacyOptions:l.tunnelFeatures?.privacyOptions,protocol:l.tunnelFeatures.protocol===void 0?!0:l.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(i),Promise.resolve((0,P.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(c,l){if(c){c.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(c.candidatePortSource),c.showCandidatePort&&(this.f=c.showCandidatePort,this.a.$setCandidateFilter());const i=c.tunnelFactory??(l?this.w(l):void 0);if(i){this.b=i;let n=c.tunnelFeatures?.privacyOptions??[];c.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:O.localize(10810,null),themeIcon:"lock"},{id:"public",label:O.localize(10811,null),themeIcon:"eye"}]);const t=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,public:!!c.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(t)}}else this.b=void 0;return(0,P.$Sc)(()=>{this.b=void 0})}w(c){}async $closeTunnel(c,l){if(this.g.has(c.host)){const i=this.g.get(c.host);i.has(c.port)&&(l&&i.get(c.port).disposeListener.dispose(),await i.get(c.port).tunnel.dispose(),i.delete(c.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(c,l){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const i=this.b(c,l);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),i!==void 0){const n=await i;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(c.remoteAddress.host)||this.g.set(c.remoteAddress.host,new Map);const t=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(c.remoteAddress.host).set(c.remoteAddress.port,{tunnel:n,disposeListener:t}),d.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(i){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),i instanceof Error)return i.message}}async $applyCandidateFilter(c){const l=await Promise.all(c.map(n=>this.f(n.host,n.port,n.detail??""))),i=c.filter((n,t)=>l[t]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${c.map(n=>n.port).join(", ")} to ${i.map(n=>n.port).join(", ")}`),i}};e.$hGb=r,e.$hGb=r=Je([Ve(0,y.$jQ),Ve(1,I.$zQ),Ve(2,T.$_j)],r)}),define(Ne[8],Le([1,0,17,22,151,231,59,28,138,36,72,25,144,23,34,14,2,105,32,159,93,52,107,76,116,114,115,207,80,89,54,55,204,7]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E,D,w,C,k,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageModelToolDescription=e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseCodeCitationPart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.LanguageModelChatMessageRole=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$gQ=ce,e.$hQ=oe,e.$iQ=ke,A=We(A),l=We(l),i=We(i),n=We(n),E=We(E),w=We(w),b=We(b);var M;(function(De){function Re(J){const{selectionStartLineNumber:ye,selectionStartColumn:Be,positionLineNumber:Ze,positionColumn:He}=J,ut=new b.$MN(ye-1,Be-1),Rt=new b.$MN(Ze-1,He-1);return new b.$ON(ut,Rt)}De.to=Re;function de(J){const{anchor:ye,active:Be}=J;return{selectionStartLineNumber:ye.line+1,selectionStartColumn:ye.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}De.from=de})(M||(e.Selection=M={}));var N;(function(De){function Re(J){if(!J)return;const{start:ye,end:Be}=J;return{startLineNumber:ye.line+1,startColumn:ye.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}De.from=Re;function de(J){if(!J)return;const{startLineNumber:ye,startColumn:Be,endLineNumber:Ze,endColumn:He}=J;return new b.$NN(ye-1,Be-1,Ze-1,He-1)}De.to=de})(N||(e.Range=N={}));var L;(function(De){function Re(J){return{uri:J.uri,range:N.from(J.range)}}De.from=Re;function de(J){return new b.$ZN(s.URI.revive(J.uri),N.to(J.range))}De.to=de})(L||(e.Location=L={}));var W;(function(De){function Re(de){switch(de){case i.StandardTokenType.Comment:return b.StandardTokenType.Comment;case i.StandardTokenType.Other:return b.StandardTokenType.Other;case i.StandardTokenType.RegEx:return b.StandardTokenType.RegEx;case i.StandardTokenType.String:return b.StandardTokenType.String}}De.to=Re})(W||(e.TokenType=W={}));var K;(function(De){function Re(J){return new b.$MN(J.lineNumber-1,J.column-1)}De.to=Re;function de(J){return{lineNumber:J.line+1,column:J.character+1}}De.from=de})(K||(e.Position=K={}));var q;(function(De){function Re(ye,Be,Ze){return(0,v.$Gb)((0,v.$1b)(ye).map(He=>de(He,Be,Ze)))}De.from=Re;function de(ye,Be,Ze){if(typeof ye=="string")return{$serialized:!0,language:ye,isBuiltin:Ze?.isBuiltin};if(ye)return{$serialized:!0,language:ye.language,scheme:J(ye.scheme,Be),pattern:xe.from(ye.pattern)??void 0,exclusive:ye.exclusive,notebookType:ye.notebookType,isBuiltin:Ze?.isBuiltin}}function J(ye,Be){return Be&&typeof ye=="string"?Be.transformOutgoingScheme(ye):ye}})(q||(e.DocumentSelector=q={}));var G;(function(De){function Re(J){switch(J){case b.DiagnosticTag.Unnecessary:return g.MarkerTag.Unnecessary;case b.DiagnosticTag.Deprecated:return g.MarkerTag.Deprecated}}De.from=Re;function de(J){switch(J){case g.MarkerTag.Unnecessary:return b.DiagnosticTag.Unnecessary;case g.MarkerTag.Deprecated:return b.DiagnosticTag.Deprecated;default:return}}De.to=de})(G||(e.DiagnosticTag=G={}));var Q;(function(De){function Re(J){let ye;return J.code&&((0,r.$eg)(J.code)||(0,r.$ig)(J.code)?ye=String(J.code):ye={value:String(J.code.value),target:J.code.target}),{...N.from(J.range),message:J.message,source:J.source,code:ye,severity:we.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(ae.from),tags:Array.isArray(J.tags)?(0,v.$Gb)(J.tags.map(G.from)):void 0}}De.from=Re;function de(J){const ye=new b.$2N(N.to(J),J.message,we.to(J.severity));return ye.source=J.source,ye.code=(0,r.$eg)(J.code)?J.code:J.code?.value,ye.relatedInformation=J.relatedInformation&&J.relatedInformation.map(ae.to),ye.tags=J.tags&&(0,v.$Gb)(J.tags.map(G.to)),ye}De.to=de})(Q||(e.Diagnostic=Q={}));var ae;(function(De){function Re(J){return{...N.from(J.location.range),message:J.message,resource:J.location.uri}}De.from=Re;function de(J){return new b.$1N(new b.$ZN(J.resource,N.to(J)),J.message)}De.to=de})(ae||(e.DiagnosticRelatedInformation=ae={}));var we;(function(De){function Re(J){switch(J){case b.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}De.from=Re;function de(J){switch(J){case g.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}De.to=de})(we||(e.DiagnosticSeverity=we={}));var le;(function(De){function Re(J){return typeof J=="number"&&J>=b.ViewColumn.One?J-1:J===b.ViewColumn.Beside?f.$yE:f.$xE}De.from=Re;function de(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=de})(le||(e.ViewColumn=le={}));function _(De){return typeof De.range<"u"}function ce(De){return De.length===0?!0:!!_(De[0])}var me;(function(De){function Re(He){return He.map(De.from)}De.fromMany=Re;function de(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function J(He){let ut;if(de(He)){const{language:Ut,value:Yt}=He;ut={value:"```"+Ut+`
`+Yt+"\n```\n"}}else b.$dO.isMarkdownString(He)?ut={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?ut={value:He}:ut={value:""};const Rt=Object.create(null);ut.uris=Rt;const Jt=Ut=>{try{let Yt=s.URI.parse(Ut,!0);Yt=Yt.with({query:ye(Yt.query,Rt)}),Rt[Ut]=Yt}catch{}return""},si=new p.marked.Renderer;return si.link=Jt,si.image=Ut=>typeof Ut=="string"?Jt(A.$$k(Ut).href):"",(0,p.marked)(ut.value,{renderer:si}),ut}De.from=J;function ye(He,ut){if(!He)return He;let Rt;try{Rt=(0,o.$ai)(He)}catch{}if(!Rt)return He;let Jt=!1;return Rt=(0,y.$fo)(Rt,si=>{if(s.URI.isUri(si)){const Ut=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ut]=si,Jt=!0,Ut}else return}),Jt?JSON.stringify(Rt):He}function Be(He){const ut=new b.$dO(He.value,He.supportThemeIcons);return ut.isTrusted=He.isTrusted,ut.supportHtml=He.supportHtml,ut.baseUri=He.baseUri?s.URI.from(He.baseUri):void 0,ut}De.to=Be;function Ze(He){if(He)return typeof He=="string"?He:De.from(He)}De.fromStrict=Ze})(me||(e.MarkdownString=me={}));function oe(De){return ce(De)?De.map(Re=>({range:N.from(Re.range),hoverMessage:Array.isArray(Re.hoverMessage)?me.fromMany(Re.hoverMessage):Re.hoverMessage?me.from(Re.hoverMessage):void 0,renderOptions:Re.renderOptions})):De.map(Re=>({range:N.from(Re)}))}function ke(De){return typeof De>"u"?De:typeof De=="string"?s.URI.file(De):De}var Te;(function(De){function Re(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?ke(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}De.from=Re})(Te||(e.ThemableDecorationAttachmentRenderOptions=Te={}));var Z;(function(De){function Re(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ke(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Te.from(de.before):void 0,after:de.after?Te.from(de.after):void 0}}De.from=Re})(Z||(e.ThemableDecorationRenderOptions=Z={}));var B;(function(De){function Re(de){if(typeof de>"u")return de;switch(de){case b.DecorationRangeBehavior.OpenOpen:return t.TrackedRangeStickiness.AlwaysGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.ClosedClosed:return t.TrackedRangeStickiness.NeverGrowsWhenTypingAtEdges;case b.DecorationRangeBehavior.OpenClosed:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingBefore;case b.DecorationRangeBehavior.ClosedOpen:return t.TrackedRangeStickiness.GrowsOnlyWhenTypingAfter}}De.from=Re})(B||(e.DecorationRangeBehavior=B={}));var ne;(function(De){function Re(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?B.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?Z.from(de.light):void 0,dark:de.dark?Z.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?ke(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?Te.from(de.before):void 0,after:de.after?Te.from(de.after):void 0}}De.from=Re})(ne||(e.DecorationRenderOptions=ne={}));var Ee;(function(De){function Re(J){return{text:J.newText,eol:J.newEol&&je.from(J.newEol),range:N.from(J.range)}}De.from=Re;function de(J){const ye=new b.$UN(N.to(J.range),J.text);return ye.newEol=typeof J.eol>"u"?void 0:je.to(J.eol),ye}De.to=de})(Ee||(e.TextEdit=Ee={}));var fe;(function(De){function Re(J,ye){const Be={edits:[]};if(J instanceof b.$XN){const Ze=new T.$Bc;for(const He of J._allEntries())He._type===b.FileEditType.File&&s.URI.isUri(He.to)&&He.from===void 0&&Ze.add(He.to);for(const He of J._allEntries())if(He._type===b.FileEditType.File){let ut;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?ut={type:"base64",value:(0,R.$8e)(R.$Ne.wrap(He.options.contents))}:ut={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:ut},metadata:He.metadata})}else He._type===b.FileEditType.Text?Be.edits.push({resource:He.uri,textEdit:Ee.from(He.edit),versionId:Ze.has(He.uri)?void 0:ye?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===b.FileEditType.Snippet?Be.edits.push({resource:He.uri,textEdit:{range:N.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Ze.has(He.uri)?void 0:ye?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===b.FileEditType.Cell?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:ye?.getNotebookDocumentVersion(He.uri)}):He._type===b.FileEditType.CellReplace&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:ye?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:w.CellEditType.Replace,index:He.index,count:He.count,cells:He.cells.map(At.from)}})}return Be}De.from=Re;function de(J){const ye=new b.$XN,Be=new T.$Ac;for(const Ze of J.edits)if(Ze.textEdit){const He=Ze,ut=s.URI.revive(He.resource),Rt=N.to(He.textEdit.range),Jt=He.textEdit.text,si=He.textEdit.insertAsSnippet;let Ut;si?Ut=b.$WN.replace(Rt,new b.$YN(Jt)):Ut=b.$UN.replace(Rt,Jt);const Yt=Be.get(ut);Yt?Yt.push(Ut):Be.set(ut,[Ut])}else ye.renameFile(s.URI.revive(Ze.oldResource),s.URI.revive(Ze.newResource),Ze.options);for(const[Ze,He]of Be)ye.set(Ze,He);return ye}De.to=de})(fe||(e.WorkspaceEdit=fe={}));var be;(function(De){const Re=Object.create(null);Re[b.SymbolKind.File]=n.SymbolKind.File,Re[b.SymbolKind.Module]=n.SymbolKind.Module,Re[b.SymbolKind.Namespace]=n.SymbolKind.Namespace,Re[b.SymbolKind.Package]=n.SymbolKind.Package,Re[b.SymbolKind.Class]=n.SymbolKind.Class,Re[b.SymbolKind.Method]=n.SymbolKind.Method,Re[b.SymbolKind.Property]=n.SymbolKind.Property,Re[b.SymbolKind.Field]=n.SymbolKind.Field,Re[b.SymbolKind.Constructor]=n.SymbolKind.Constructor,Re[b.SymbolKind.Enum]=n.SymbolKind.Enum,Re[b.SymbolKind.Interface]=n.SymbolKind.Interface,Re[b.SymbolKind.Function]=n.SymbolKind.Function,Re[b.SymbolKind.Variable]=n.SymbolKind.Variable,Re[b.SymbolKind.Constant]=n.SymbolKind.Constant,Re[b.SymbolKind.String]=n.SymbolKind.String,Re[b.SymbolKind.Number]=n.SymbolKind.Number,Re[b.SymbolKind.Boolean]=n.SymbolKind.Boolean,Re[b.SymbolKind.Array]=n.SymbolKind.Array,Re[b.SymbolKind.Object]=n.SymbolKind.Object,Re[b.SymbolKind.Key]=n.SymbolKind.Key,Re[b.SymbolKind.Null]=n.SymbolKind.Null,Re[b.SymbolKind.EnumMember]=n.SymbolKind.EnumMember,Re[b.SymbolKind.Struct]=n.SymbolKind.Struct,Re[b.SymbolKind.Event]=n.SymbolKind.Event,Re[b.SymbolKind.Operator]=n.SymbolKind.Operator,Re[b.SymbolKind.TypeParameter]=n.SymbolKind.TypeParameter;function de(ye){return typeof Re[ye]=="number"?Re[ye]:n.SymbolKind.Property}De.from=de;function J(ye){for(const Be in Re)if(Re[Be]===ye)return Number(Be);return b.SymbolKind.Property}De.to=J})(be||(e.SymbolKind=be={}));var he;(function(De){function Re(J){switch(J){case b.SymbolTag.Deprecated:return n.SymbolTag.Deprecated}}De.from=Re;function de(J){switch(J){case n.SymbolTag.Deprecated:return b.SymbolTag.Deprecated}}De.to=de})(he||(e.SymbolTag=he={}));var X;(function(De){function Re(J){return{name:J.name,kind:be.from(J.kind),tags:J.tags&&J.tags.map(he.from),containerName:J.containerName,location:Ue.from(J.location)}}De.from=Re;function de(J){const ye=new b.$7N(J.name,be.to(J.kind),J.containerName,Ue.to(J.location));return ye.tags=J.tags&&J.tags.map(he.to),ye}De.to=de})(X||(e.WorkspaceSymbol=X={}));var x;(function(De){function Re(J){const ye={name:J.name||"!!MISSING: name!!",detail:J.detail,range:N.from(J.range),selectionRange:N.from(J.selectionRange),kind:be.from(J.kind),tags:J.tags?.map(he.from)??[]};return J.children&&(ye.children=J.children.map(Re)),ye}De.from=Re;function de(J){const ye=new b.$8N(J.name,J.detail,be.to(J.kind),N.to(J.range),N.to(J.selectionRange));return(0,v.$Kb)(J.tags)&&(ye.tags=J.tags.map(he.to)),J.children&&(ye.children=J.children.map(de)),ye}De.to=de})(x||(e.DocumentSymbol=x={}));var $e;(function(De){function Re(J){const ye=new b.$_N(be.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return ye._sessionId=J._sessionId,ye._itemId=J._itemId,ye}De.to=Re;function de(J,ye,Be){if(ye=ye??J._sessionId,Be=Be??J._itemId,ye===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Be,name:J.name,detail:J.detail,kind:be.from(J.kind),uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(he.from)}}De.from=de})($e||(e.CallHierarchyItem=$e={}));var pe;(function(De){function Re(de){return new b.$aO($e.to(de.from),de.fromRanges.map(J=>N.to(J)))}De.to=Re})(pe||(e.CallHierarchyIncomingCall=pe={}));var Ae;(function(De){function Re(de){return new b.$bO($e.to(de.to),de.fromRanges.map(J=>N.to(J)))}De.to=Re})(Ae||(e.CallHierarchyOutgoingCall=Ae={}));var Ue;(function(De){function Re(J){return{range:J.range&&N.from(J.range),uri:J.uri}}De.from=Re;function de(J){return new b.$ZN(s.URI.revive(J.uri),N.to(J.range))}De.to=de})(Ue||(e.location=Ue={}));var Ie;(function(De){function Re(J){const ye=J,Be=J;return{originSelectionRange:ye.originSelectionRange?N.from(ye.originSelectionRange):void 0,uri:ye.targetUri?ye.targetUri:Be.uri,range:N.from(ye.targetRange?ye.targetRange:Be.range),targetSelectionRange:ye.targetSelectionRange?N.from(ye.targetSelectionRange):void 0}}De.from=Re;function de(J){return{targetUri:s.URI.revive(J.uri),targetRange:N.to(J.range),targetSelectionRange:J.targetSelectionRange?N.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?N.to(J.originSelectionRange):void 0}}De.to=de})(Ie||(e.DefinitionLink=Ie={}));var Pe;(function(De){function Re(J){return{range:N.from(J.range),contents:me.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}De.from=Re;function de(J){const ye=J.contents.map(me.to),Be=N.to(J.range),Ze=J.canIncreaseVerbosity,He=J.canDecreaseVerbosity;return new b.$4N(ye,Be,Ze,He)}De.to=de})(Pe||(e.Hover=Pe={}));var Oe;(function(De){function Re(J){return{range:N.from(J.range),expression:J.expression}}De.from=Re;function de(J){return new b.$YO(N.to(J.range),J.expression)}De.to=de})(Oe||(e.EvaluatableExpression=Oe={}));var z;(function(De){function Re(J){if(J instanceof b.$ZO)return{type:"text",range:N.from(J.range),text:J.text};if(J instanceof b.$1O)return{type:"variable",range:N.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof b.$2O)return{type:"expression",range:N.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Re;function de(J){switch(J.type){case"text":return{range:N.to(J.range),text:J.text};case"variable":return{range:N.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:N.to(J.range),expression:J.expression}}}De.to=de})(z||(e.InlineValue=z={}));var j;(function(De){function Re(J){return{frameId:J.frameId,stoppedLocation:N.from(J.stoppedLocation)}}De.from=Re;function de(J){return new b.$3O(J.frameId,N.to(J.stoppedLocation))}De.to=de})(j||(e.InlineValueContext=j={}));var H;(function(De){function Re(J){return{range:N.from(J.range),kind:J.kind}}De.from=Re;function de(J){return new b.$5N(N.to(J.range),J.kind)}De.to=de})(H||(e.DocumentHighlight=H={}));var V;(function(De){function Re(J){return{uri:J.uri,highlights:J.highlights.map(H.from)}}De.from=Re;function de(J){return new b.$6N(s.URI.revive(J.uri),J.highlights.map(H.to))}De.to=de})(V||(e.MultiDocumentHighlight=V={}));var re;(function(De){function Re(de){switch(de){case n.CompletionTriggerKind.TriggerCharacter:return b.CompletionTriggerKind.TriggerCharacter;case n.CompletionTriggerKind.TriggerForIncompleteCompletions:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case n.CompletionTriggerKind.Invoke:default:return b.CompletionTriggerKind.Invoke}}De.to=Re})(re||(e.CompletionTriggerKind=re={}));var ge;(function(De){function Re(de){return{triggerKind:re.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}De.to=Re})(ge||(e.CompletionContext=ge={}));var Ce;(function(De){function Re(J){switch(J){case b.CompletionItemTag.Deprecated:return n.CompletionItemTag.Deprecated}}De.from=Re;function de(J){switch(J){case n.CompletionItemTag.Deprecated:return b.CompletionItemTag.Deprecated}}De.to=de})(Ce||(e.CompletionItemTag=Ce={}));var ze;(function(De){const Re=new Map([[b.CompletionItemKind.Method,n.CompletionItemKind.Method],[b.CompletionItemKind.Function,n.CompletionItemKind.Function],[b.CompletionItemKind.Constructor,n.CompletionItemKind.Constructor],[b.CompletionItemKind.Field,n.CompletionItemKind.Field],[b.CompletionItemKind.Variable,n.CompletionItemKind.Variable],[b.CompletionItemKind.Class,n.CompletionItemKind.Class],[b.CompletionItemKind.Interface,n.CompletionItemKind.Interface],[b.CompletionItemKind.Struct,n.CompletionItemKind.Struct],[b.CompletionItemKind.Module,n.CompletionItemKind.Module],[b.CompletionItemKind.Property,n.CompletionItemKind.Property],[b.CompletionItemKind.Unit,n.CompletionItemKind.Unit],[b.CompletionItemKind.Value,n.CompletionItemKind.Value],[b.CompletionItemKind.Constant,n.CompletionItemKind.Constant],[b.CompletionItemKind.Enum,n.CompletionItemKind.Enum],[b.CompletionItemKind.EnumMember,n.CompletionItemKind.EnumMember],[b.CompletionItemKind.Keyword,n.CompletionItemKind.Keyword],[b.CompletionItemKind.Snippet,n.CompletionItemKind.Snippet],[b.CompletionItemKind.Text,n.CompletionItemKind.Text],[b.CompletionItemKind.Color,n.CompletionItemKind.Color],[b.CompletionItemKind.File,n.CompletionItemKind.File],[b.CompletionItemKind.Reference,n.CompletionItemKind.Reference],[b.CompletionItemKind.Folder,n.CompletionItemKind.Folder],[b.CompletionItemKind.Event,n.CompletionItemKind.Event],[b.CompletionItemKind.Operator,n.CompletionItemKind.Operator],[b.CompletionItemKind.TypeParameter,n.CompletionItemKind.TypeParameter],[b.CompletionItemKind.Issue,n.CompletionItemKind.Issue],[b.CompletionItemKind.User,n.CompletionItemKind.User]]);function de(Be){return Re.get(Be)??n.CompletionItemKind.Property}De.from=de;const J=new Map([[n.CompletionItemKind.Method,b.CompletionItemKind.Method],[n.CompletionItemKind.Function,b.CompletionItemKind.Function],[n.CompletionItemKind.Constructor,b.CompletionItemKind.Constructor],[n.CompletionItemKind.Field,b.CompletionItemKind.Field],[n.CompletionItemKind.Variable,b.CompletionItemKind.Variable],[n.CompletionItemKind.Class,b.CompletionItemKind.Class],[n.CompletionItemKind.Interface,b.CompletionItemKind.Interface],[n.CompletionItemKind.Struct,b.CompletionItemKind.Struct],[n.CompletionItemKind.Module,b.CompletionItemKind.Module],[n.CompletionItemKind.Property,b.CompletionItemKind.Property],[n.CompletionItemKind.Unit,b.CompletionItemKind.Unit],[n.CompletionItemKind.Value,b.CompletionItemKind.Value],[n.CompletionItemKind.Constant,b.CompletionItemKind.Constant],[n.CompletionItemKind.Enum,b.CompletionItemKind.Enum],[n.CompletionItemKind.EnumMember,b.CompletionItemKind.EnumMember],[n.CompletionItemKind.Keyword,b.CompletionItemKind.Keyword],[n.CompletionItemKind.Snippet,b.CompletionItemKind.Snippet],[n.CompletionItemKind.Text,b.CompletionItemKind.Text],[n.CompletionItemKind.Color,b.CompletionItemKind.Color],[n.CompletionItemKind.File,b.CompletionItemKind.File],[n.CompletionItemKind.Reference,b.CompletionItemKind.Reference],[n.CompletionItemKind.Folder,b.CompletionItemKind.Folder],[n.CompletionItemKind.Event,b.CompletionItemKind.Event],[n.CompletionItemKind.Operator,b.CompletionItemKind.Operator],[n.CompletionItemKind.TypeParameter,b.CompletionItemKind.TypeParameter],[n.CompletionItemKind.User,b.CompletionItemKind.User],[n.CompletionItemKind.Issue,b.CompletionItemKind.Issue]]);function ye(Be){return J.get(Be)??b.CompletionItemKind.Property}De.to=ye})(ze||(e.CompletionItemKind=ze={}));var Qe;(function(De){function Re(de,J){const ye=new b.$jO(de.label);return ye.insertText=de.insertText,ye.kind=ze.to(de.kind),ye.tags=de.tags?.map(Ce.to),ye.detail=de.detail,ye.documentation=A.$5k(de.documentation)?me.to(de.documentation):de.documentation,ye.sortText=de.sortText,ye.filterText=de.filterText,ye.preselect=de.preselect,ye.commitCharacters=de.commitCharacters,l.$Nt.isIRange(de.range)?ye.range=N.to(de.range):typeof de.range=="object"&&(ye.range={inserting:N.to(de.range.insert),replacing:N.to(de.range.replace)}),ye.keepWhitespace=typeof de.insertTextRules>"u"?!1:!!(de.insertTextRules&n.CompletionItemInsertTextRule.KeepWhitespace),typeof de.insertTextRules<"u"&&de.insertTextRules&n.CompletionItemInsertTextRule.InsertAsSnippet?ye.insertText=new b.$YN(de.insertText):(ye.insertText=de.insertText,ye.textEdit=ye.range instanceof b.$NN?new b.$UN(ye.range,ye.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(ye.additionalTextEdits=de.additionalTextEdits.map(Be=>Ee.to(Be))),ye.command=J&&de.command?J.fromInternal(de.command):void 0,ye}De.to=Re})(Qe||(e.CompletionItem=Qe={}));var _e;(function(De){function Re(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:me.fromStrict(J.documentation)}}De.from=Re;function de(J){return{label:J.label,documentation:A.$5k(J.documentation)?me.to(J.documentation):J.documentation}}De.to=de})(_e||(e.ParameterInformation=_e={}));var tt;(function(De){function Re(J){return{label:J.label,documentation:me.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(_e.from):[],activeParameter:J.activeParameter}}De.from=Re;function de(J){return{label:J.label,documentation:A.$5k(J.documentation)?me.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(_e.to):[],activeParameter:J.activeParameter}}De.to=de})(tt||(e.SignatureInformation=tt={}));var nt;(function(De){function Re(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.from):[]}}De.from=Re;function de(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(tt.to):[]}}De.to=de})(nt||(e.SignatureHelp=nt={}));var et;(function(De){function Re(de,J){const ye=new b.$iO(K.to(J.position),typeof J.label=="string"?J.label:J.label.map(rt.to.bind(void 0,de)),J.kind&&ft.to(J.kind));return ye.textEdits=J.textEdits&&J.textEdits.map(Ee.to),ye.tooltip=A.$5k(J.tooltip)?me.to(J.tooltip):J.tooltip,ye.paddingLeft=J.paddingLeft,ye.paddingRight=J.paddingRight,ye}De.to=Re})(et||(e.InlayHint=et={}));var rt;(function(De){function Re(de,J){const ye=new b.$hO(J.label);return ye.tooltip=A.$5k(J.tooltip)?me.to(J.tooltip):J.tooltip,n.Command.is(J.command)&&(ye.command=de.fromInternal(J.command)),J.location&&(ye.location=Ue.to(J.location)),ye}De.to=Re})(rt||(e.InlayHintLabelPart=rt={}));var ft;(function(De){function Re(J){return J}De.from=Re;function de(J){return J}De.to=de})(ft||(e.InlayHintKind=ft={}));var lt;(function(De){function Re(J){return{range:N.from(J.range),url:J.target,tooltip:J.tooltip}}De.from=Re;function de(J){let ye;if(J.url)try{ye=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}const Be=new b.$oO(N.to(J.range),ye);return Be.tooltip=J.tooltip,Be}De.to=de})(lt||(e.DocumentLink=lt={}));var st;(function(De){function Re(J){const ye=new b.$rO(J.label);return J.textEdit&&(ye.textEdit=Ee.to(J.textEdit)),J.additionalTextEdits&&(ye.additionalTextEdits=J.additionalTextEdits.map(Be=>Ee.to(Be))),ye}De.to=Re;function de(J){return{label:J.label,textEdit:J.textEdit?Ee.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ye=>Ee.from(ye)):void 0}}De.from=de})(st||(e.ColorPresentation=st={}));var ct;(function(De){function Re(J){return new b.$pO(J[0],J[1],J[2],J[3])}De.to=Re;function de(J){return[J.red,J.green,J.blue,J.alpha]}De.from=de})(ct||(e.Color=ct={}));var mt;(function(De){function Re(J){return{range:N.from(J.range)}}De.from=Re;function de(J){return new b.$$N(N.to(J.range))}De.to=de})(mt||(e.SelectionRange=mt={}));var $t;(function(De){function Re(de){switch(de){case m.SaveReason.AUTO:return b.TextDocumentSaveReason.AfterDelay;case m.SaveReason.EXPLICIT:return b.TextDocumentSaveReason.Manual;case m.SaveReason.FOCUS_CHANGE:case m.SaveReason.WINDOW_CHANGE:return b.TextDocumentSaveReason.FocusOut}}De.to=Re})($t||(e.TextDocumentSaveReason=$t={}));var qe;(function(De){function Re(J){switch(J){case b.TextEditorLineNumbersStyle.Off:return c.RenderLineNumbersType.Off;case b.TextEditorLineNumbersStyle.Relative:return c.RenderLineNumbersType.Relative;case b.TextEditorLineNumbersStyle.Interval:return c.RenderLineNumbersType.Interval;case b.TextEditorLineNumbersStyle.On:default:return c.RenderLineNumbersType.On}}De.from=Re;function de(J){switch(J){case c.RenderLineNumbersType.Off:return b.TextEditorLineNumbersStyle.Off;case c.RenderLineNumbersType.Relative:return b.TextEditorLineNumbersStyle.Relative;case c.RenderLineNumbersType.Interval:return b.TextEditorLineNumbersStyle.Interval;case c.RenderLineNumbersType.On:default:return b.TextEditorLineNumbersStyle.On}}De.to=de})(qe||(e.TextEditorLineNumbersStyle=qe={}));var je;(function(De){function Re(J){if(J===b.EndOfLine.CRLF)return t.EndOfLineSequence.CRLF;if(J===b.EndOfLine.LF)return t.EndOfLineSequence.LF}De.from=Re;function de(J){if(J===t.EndOfLineSequence.CRLF)return b.EndOfLine.CRLF;if(J===t.EndOfLineSequence.LF)return b.EndOfLine.LF}De.to=de})(je||(e.EndOfLine=je={}));var ie;(function(De){function Re(de){if(typeof de=="object")return de.viewId;switch(de){case b.ProgressLocation.SourceControl:return u.ProgressLocation.Scm;case b.ProgressLocation.Window:return u.ProgressLocation.Window;case b.ProgressLocation.Notification:return u.ProgressLocation.Notification}throw new Error("Unknown 'ProgressLocation'")}De.from=Re})(ie||(e.ProgressLocation=ie={}));var ee;(function(De){function Re(J){const ye={start:J.start+1,end:J.end+1};return J.kind&&(ye.kind=Y.from(J.kind)),ye}De.from=Re;function de(J){const ye={start:J.start-1,end:J.end-1};return J.kind&&(ye.kind=Y.to(J.kind)),ye}De.to=de})(ee||(e.FoldingRange=ee={}));var Y;(function(De){function Re(J){if(J)switch(J){case b.FoldingRangeKind.Comment:return n.$Ou.Comment;case b.FoldingRangeKind.Imports:return n.$Ou.Imports;case b.FoldingRangeKind.Region:return n.$Ou.Region}}De.from=Re;function de(J){if(J)switch(J.value){case n.$Ou.Comment.value:return b.FoldingRangeKind.Comment;case n.$Ou.Imports.value:return b.FoldingRangeKind.Imports;case n.$Ou.Region.value:return b.FoldingRangeKind.Region}}De.to=de})(Y||(e.FoldingRangeKind=Y={}));var Xe;(function(De){function Re(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?N.from(de.selection):void 0,override:typeof de.override=="boolean"?m.$4F.id:void 0}}De.from=Re})(Xe||(e.TextEditorOpenOptions=Xe={}));var xe;(function(De){function Re(Be){return Be instanceof b.$MO?Be.toJSON():typeof Be=="string"?Be:de(Be)||J(Be)?new b.$MO(Be.baseUri??Be.base,Be.pattern).toJSON():Be}De.from=Re;function de(Be){const Ze=Be;return Ze?s.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function J(Be){const Ze=Be;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function ye(Be){return typeof Be=="string"?Be:new b.$MO(s.URI.revive(Be.baseUri),Be.pattern)}De.to=ye})(xe||(e.GlobPattern=xe={}));var ht;(function(De){function Re(de){if(de){if(Array.isArray(de))return de.map(Re);if(typeof de=="string")return de;{const J=de;return{language:J.language,scheme:J.scheme,pattern:xe.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}De.from=Re})(ht||(e.LanguageSelector=ht={}));var bt;(function(De){function Re(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ye=>Array.isArray(ye)&&ye.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&s.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(Ze=>Ze instanceof b.$NN)))}De.is=Re;function de(J){return{documents:J.documents.map(ye=>ye.map(Be=>({uri:s.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(Ze=>N.from(Ze))})))}}De.from=de})(bt||(e.MappedEditsContext=bt={}));var Mt;(function(De){function Re(J){return{start:J.start,end:J.end}}De.from=Re;function de(J){return new b.$dP(J.start,J.end)}De.to=de})(Mt||(e.NotebookRange=Mt={}));var Ht;(function(De){function Re(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}De.to=Re;function de(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}De.from=de})(Ht||(e.NotebookCellExecutionSummary=Ht={}));var _t;(function(De){function Re(de){if(de===w.NotebookCellExecutionState.Unconfirmed)return b.NotebookCellExecutionState.Pending;if(de===w.NotebookCellExecutionState.Pending)return;if(de===w.NotebookCellExecutionState.Executing)return b.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}De.to=Re})(_t||(e.NotebookCellExecutionState=_t={}));var ei;(function(De){function Re(J){switch(J){case b.NotebookCellKind.Markup:return w.CellKind.Markup;case b.NotebookCellKind.Code:default:return w.CellKind.Code}}De.from=Re;function de(J){switch(J){case w.CellKind.Markup:return b.NotebookCellKind.Markup;case w.CellKind.Code:default:return b.NotebookCellKind.Code}}De.to=de})(ei||(e.NotebookCellKind=ei={}));var oi;(function(De){function Re(J){const ye={metadata:J.metadata??Object.create(null),cells:[]};for(const Be of J.cells)b.$eP.validate(Be),ye.cells.push(At.from(Be));return ye}De.from=Re;function de(J){const ye=new b.$fP(J.cells.map(At.to));return(0,r.$rg)(J.metadata)||(ye.metadata=J.metadata),ye}De.to=de})(oi||(e.NotebookData=oi={}));var At;(function(De){function Re(J){return{cellKind:ei.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:Ht.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Ct.from):[]}}De.from=Re;function de(J){return new b.$eP(ei.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Ct.to):void 0,J.metadata,J.internalMetadata?Ht.to(J.internalMetadata):void 0)}De.to=de})(At||(e.NotebookCellData=At={}));var Ye;(function(De){function Re(J){return{mime:J.mime,valueBytes:R.$Ne.wrap(J.data)}}De.from=Re;function de(J){return new b.$gP(J.valueBytes.buffer,J.mime)}De.to=de})(Ye||(e.NotebookCellOutputItem=Ye={}));var Ct;(function(De){function Re(J){return{outputId:J.id,items:J.items.map(Ye.from),metadata:J.metadata}}De.from=Re;function de(J){const ye=J.items.map(Ye.to);return new b.$hP(ye,J.outputId,J.metadata)}De.to=de})(Ct||(e.NotebookCellOutput=Ct={}));var hi;(function(De){function Re(ye){return J(ye)?{include:xe.from(ye.include)??void 0,exclude:xe.from(ye.exclude)??void 0}:xe.from(ye)??void 0}De.from=Re;function de(ye){return J(ye)?{include:xe.to(ye.include),exclude:xe.to(ye.exclude)}:xe.to(ye)}De.to=de;function J(ye){const Be=ye;return Be?!(0,r.$ng)(Be.include)&&!(0,r.$ng)(Be.exclude):!1}})(hi||(e.NotebookExclusiveDocumentPattern=hi={}));var pt;(function(De){function Re(de,J,ye){const Be=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===b.NotebookCellStatusBarAlignment.Left?w.CellStatusbarAlignment.Left:w.CellStatusbarAlignment.Right,command:J.toInternal(Be,ye),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}De.from=Re})(pt||(e.NotebookStatusBarItem=pt={}));var Dt;(function(De){function Re(de,J,ye){const Be=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:J.toInternal(Be,ye),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}De.from=Re})(Dt||(e.NotebookKernelSourceAction=Dt={}));var ti;(function(De){function Re(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}De.from=Re})(ti||(e.NotebookDocumentContentOptions=ti={}));var ii;(function(De){function Re(J){return{uri:J.uri,provides:J.provides}}De.from=Re;function de(J){return new b.$jP(s.URI.revive(J.uri),J.provides)}De.to=de})(ii||(e.NotebookRendererScript=ii={}));var jt;(function(De){function Re(J){return{message:me.fromStrict(J.message)||"",type:k.TestMessageType.Error,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:N.from(J.location.range),uri:J.location.uri},stackTrace:J.stackTrace?.map(ye=>({label:ye.label,position:ye.position&&K.from(ye.position),uri:ye.file&&s.URI.revive(ye.file).toJSON()}))}}De.from=Re;function de(J){const ye=new b.$pP(typeof J.message=="string"?J.message:me.to(J.message));return ye.actualOutput=J.actual,ye.expectedOutput=J.expected,ye.contextValue=J.contextValue,ye.location=J.location?Ue.to(J.location):void 0,ye}De.to=de})(jt||(e.TestMessage=jt={}));var gt;(function(De){De.namespace=k.$$I,De.denamespace=k.$_I})(gt||(e.TestTag=gt={}));var zt;(function(De){function Re(J){const ye=(0,$.$fQ)(J).controllerId;return{extId:C.$6I.fromExtHostTestItem(J,ye).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Be=>gt.namespace(ye,Be.id)),range:l.$Nt.lift(N.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&me.fromStrict(J.error)||null}}De.from=Re;function de(J){return{parent:void 0,error:void 0,id:C.$6I.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(ye=>{const{tagId:Be}=gt.denamespace(ye);return new b.$qP(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:N.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}De.toPlain=de})(zt||(e.TestItem=zt={})),function(De){function Re(J){return{id:J.id}}De.from=Re;function de(J){return new b.$qP(J.id)}De.to=de}(gt||(e.TestTag=gt={}));var ni;(function(De){const Re=(J,ye)=>{const Be=J.value;if(!Be)return;const Ze={...zt.toPlain(Be.item),parent:ye,taskStates:Be.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(ut=>ut.type===k.TestMessageType.Error).map(jt.to)})),children:[]};if(J.children)for(const He of J.children.values()){const ut=Re(He,Ze);ut&&Ze.children.push(ut)}return Ze};function de(J){const ye=new a.$5I;for(const He of J.items)ye.insert(C.$6I.fromString(He.item.extId).path,He);const Be=[ye.nodes],Ze=[];for(;Be.length;)for(const He of Be.pop())He.value?Ze.push(He):He.children&&Be.push(He.children.values());return{completedAt:J.completedAt,results:Ze.map(He=>Re(He)).filter(r.$mg)}}De.to=de})(ni||(e.TestResults=ni={}));var ai;(function(De){function Re(Be){return{covered:Be.covered,total:Be.total}}function de(Be){return"line"in Be?K.from(Be):N.from(Be)}function J(Be){if(typeof Be.executed=="number"&&Be.executed<0)throw new Error(`Invalid coverage count ${Be.executed}`);return"branches"in Be?{count:Be.executed,location:de(Be.location),type:k.DetailType.Statement,branches:Be.branches.length?Be.branches.map(Ze=>({count:Ze.executed,location:Ze.location&&de(Ze.location),label:Ze.label})):void 0}:{type:k.DetailType.Declaration,name:Be.name,count:Be.executed,location:de(Be.location)}}De.fromDetails=J;function ye(Be,Ze,He){return b.$tP(He.statementCoverage),b.$tP(He.branchCoverage),b.$tP(He.declarationCoverage),{id:Ze,uri:He.uri,statement:Re(He.statementCoverage),branch:He.branchCoverage&&Re(He.branchCoverage),declaration:He.declarationCoverage&&Re(He.declarationCoverage),testIds:He instanceof b.$uP&&He.fromTests.length?He.fromTests.map(ut=>C.$6I.fromExtHostTestItem(ut,Be).toString()):void 0}}De.fromFile=ye})(ai||(e.TestCoverage=ai={}));var Ge;(function(De){function Re(de){switch(de){case n.CodeActionTriggerType.Invoke:return b.CodeActionTriggerKind.Invoke;case n.CodeActionTriggerType.Auto:return b.CodeActionTriggerKind.Automatic}}De.to=Re})(Ge||(e.CodeActionTriggerKind=Ge={}));var ci;(function(De){function Re(J){const ye=new b.$yP(be.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),N.to(J.range),N.to(J.selectionRange));return ye._sessionId=J._sessionId,ye._itemId=J._itemId,ye}De.to=Re;function de(J,ye,Be){if(ye=ye??J._sessionId,Be=Be??J._itemId,ye===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:ye,_itemId:Be,kind:be.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:N.from(J.range),selectionRange:N.from(J.selectionRange),tags:J.tags?.map(he.from)}}De.from=de})(ci||(e.TypeHierarchyItem=ci={}));var di;(function(De){function Re(de){if(de)return{value:de.value,tooltip:de.tooltip}}De.from=Re})(di||(e.ViewBadge=di={}));var fi;(function(De){function Re(Be,Ze,He){const ut=Ze.fileData;return ut?new b.$EO(new b.$FO(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.$cb)(()=>He(ut.id)))):Be===I.$0s.uriList&&Ze.uriListData?new b.$DO(ye(Ze.uriListData)):new b.$DO(Ze.asString)}De.to=Re;async function de(Be,Ze){const He=await Ze.asString();if(Be===I.$0s.uriList)return{asString:He,fileData:void 0,uriListData:J(He)};const ut=Ze.asFile();return{asString:He,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}De.from=de;function J(Be){return P.$su.split(Be).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return s.URI.parse(Ze)}catch{}return Ze})}function ye(Be){return P.$su.create(Be.map(Ze=>typeof Ze=="string"?Ze:s.URI.revive(Ze)))}})(fi||(e.DataTransferItem=fi={}));var vt;(function(De){function Re(J,ye){const Be=J.items.map(([Ze,He])=>[Ze,fi.to(Ze,He,ye)]);return new b.$GO(Be)}De.toDataTransfer=Re;async function de(J){const ye={items:[]},Be=[];for(const[Ze,He]of J)Be.push((async()=>{ye.items.push([Ze,await fi.from(Ze,He)])})());return await Promise.all(Be),ye}De.from=de})(vt||(e.DataTransfer=vt={}));var Ft;(function(De){function Re(J,ye){return{kind:"reply",agentId:J.participant??ye?.agentId??"",subCommand:J.command??ye?.command,message:J.prompt,title:J.label}}De.from=Re;function de(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}De.to=de})(Ft||(e.ChatFollowup=Ft={}));var Nt;(function(De){function Re(J){switch(J){case E.ChatMessageRole.System:return b.LanguageModelChatMessageRole.System;case E.ChatMessageRole.User:return b.LanguageModelChatMessageRole.User;case E.ChatMessageRole.Assistant:return b.LanguageModelChatMessageRole.Assistant}}De.to=Re;function de(J){switch(J){case b.LanguageModelChatMessageRole.System:return E.ChatMessageRole.System;case b.LanguageModelChatMessageRole.User:return E.ChatMessageRole.User;case b.LanguageModelChatMessageRole.Assistant:return E.ChatMessageRole.Assistant}return E.ChatMessageRole.User}De.from=de})(Nt||(e.LanguageModelChatMessageRole=Nt={}));var Wt;(function(De){function Re(J){let ye="",Be;J.content.type==="text"?ye=J.content.value:Be=new b.$3P(J.content.name,J.content.value,J.content.isError);const Ze=Nt.to(J.role),He=new b.$4P(Ze,ye,J.name);return Be!==void 0&&(He.content2=Be),He}De.to=Re;function de(J){const ye=Nt.from(J.role),Be=J.name;let Ze;return J.content2 instanceof b.$3P?Ze={type:"function_result",name:J.content2.name,value:J.content2.content,isError:J.content2.isError}:Ze={type:"text",value:J.content},{role:ye,name:Be,content:Ze}}De.from=de})(Wt||(e.LanguageModelChatMessage=Wt={}));var ri;(function(De){function Re(J){return{kind:"markdownContent",content:me.from(J.value)}}De.from=Re;function de(J){return new b.$LP(me.to(J.content))}De.to=de})(ri||(e.ChatResponseMarkdownPart=ri={}));var Kt;(function(De){function Re(J){return{kind:"markdownVuln",content:me.from(J.value),vulnerabilities:J.vulnerabilities}}De.from=Re;function de(J){return new b.$MP(me.to(J.content),J.vulnerabilities)}De.to=de})(Kt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Kt={}));var li;(function(De){function Re(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}De.from=Re;function de(J){return new b.$NP(J.agentId,J.command)}De.to=de})(li||(e.ChatResponseDetectedParticipantPart=li={}));var Bt;(function(De){function Re(de){return{kind:"confirmation",title:de.title,message:de.message,data:de.data,buttons:de.buttons}}De.from=Re})(Bt||(e.ChatResponseConfirmationPart=Bt={}));var Qt;(function(De){function Re(J){const{value:ye,baseUri:Be}=J;function Ze(He,ut){return He.map(Rt=>{const Jt=s.URI.joinPath(ut,Rt.name);return{label:Rt.name,uri:Jt,children:Rt.children&&Ze(Rt.children,Jt)}})}return{kind:"treeData",treeData:{label:(0,S.$ch)(Be),uri:Be,children:Ze(ye,Be)}}}De.from=Re;function de(J){const ye=(0,o.$bi)(J.treeData);function Be(ut){return ut.map(Rt=>({name:Rt.label,children:Rt.children&&Be(Rt.children)}))}const Ze=ye.uri,He=ye.children?Be(ye.children):[];return new b.$PP(He,Ze)}De.to=de})(Qt||(e.ChatResponseFilesPart=Qt={}));var Gt;(function(De){function Re(J){const ye=Be=>s.URI.isUri(Be);return{kind:"inlineReference",name:J.title,inlineReference:ye(J.value)?J.value:L.from(J.value)}}De.from=Re;function de(J){const ye=(0,o.$bi)(J);return new b.$QP(s.URI.isUri(ye.inlineReference)?ye.inlineReference:L.to(ye.inlineReference),J.name)}De.to=de})(Gt||(e.ChatResponseAnchorPart=Gt={}));var Lt;(function(De){function Re(J){return{kind:"progressMessage",content:me.from(J.value)}}De.from=Re;function de(J){return new b.$RP(J.content.value)}De.to=de})(Lt||(e.ChatResponseProgressPart=Lt={}));var wt;(function(De){function Re(J){return{kind:"warning",content:me.from(J.value)}}De.from=Re;function de(J){return new b.$TP(J.content.value)}De.to=de})(wt||(e.ChatResponseWarningPart=wt={}));var kt;(function(De){function Re(de){return{kind:"progressTask",content:me.from(de.value)}}De.from=Re})(kt||(e.ChatTask=kt={}));var Vt;(function(De){function Re(de){return{kind:"progressTaskResult",content:typeof de=="string"?me.from(de):void 0}}De.from=Re})(Vt||(e.ChatTaskResult=Vt={}));var It;(function(De){function Re(J,ye,Be){return{kind:"command",command:ye.toInternal(J.value,Be)??{command:J.value.command,title:J.value.title}}}De.from=Re;function de(J,ye){return new b.$UP(ye.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}De.to=de})(It||(e.ChatResponseCommandButtonPart=It={}));var mi;(function(De){function Re(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ye=>Ee.from(ye))}}De.from=Re;function de(J){return new b.$XP(s.URI.revive(J.uri),J.edits.map(ye=>Ee.to(ye)))}De.to=de})(mi||(e.ChatResponseTextEditPart=mi={}));var Zt;(function(De){function Re(J){const ye=d.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:s.URI.isUri(J.iconPath)?{light:s.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&s.URI.isUri(J.iconPath.light)&&s.URI.isUri(J.iconPath.dark)?{light:s.URI.revive(J.iconPath.light),dark:s.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:L.from(J.value.value)},iconPath:ye,options:J.options}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:L.from(J.value),iconPath:ye,options:J.options}}De.from=Re;function de(J){const ye=(0,o.$bi)(J),Be=Ze=>s.URI.isUri(Ze)?Ze:L.to(Ze);return new b.$VP("variableName"in ye.reference?{variableName:ye.reference.variableName,value:ye.reference.value&&Be(ye.reference.value)}:Be(ye.reference))}De.to=de})(Zt||(e.ChatResponseReferencePart=Zt={}));var ki;(function(De){function Re(de){return{kind:"codeCitation",value:de.value,license:de.license,snippet:de.snippet}}De.from=Re})(ki||(e.ChatResponseCodeCitationPart=ki={}));var wi;(function(De){function Re(ye,Be,Ze){return ye instanceof b.$LP?ri.from(ye):ye instanceof b.$QP?Gt.from(ye):ye instanceof b.$VP?Zt.from(ye):ye instanceof b.$RP?Lt.from(ye):ye instanceof b.$PP?Qt.from(ye):ye instanceof b.$UP?It.from(ye,Be,Ze):ye instanceof b.$XP?mi.from(ye):ye instanceof b.$MP?Kt.from(ye):ye instanceof b.$NP?li.from(ye):ye instanceof b.$TP?wt.from(ye):ye instanceof b.$OP?Bt.from(ye):ye instanceof b.$WP?ki.from(ye):{kind:"markdownContent",content:me.from("")}}De.from=Re;function de(ye,Be){switch(ye.kind){case"reference":return Zt.to(ye);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ye,Be)}}De.to=de;function J(ye,Be){switch(ye.kind){case"markdownContent":return ri.to(ye);case"inlineReference":return Gt.to(ye);case"progressMessage":return;case"treeData":return Qt.to(ye);case"command":return It.to(ye,Be)}}De.toContent=J})(wi||(e.ChatResponsePart=wi={}));var Ai;(function(De){function Re(de,J){const ye=de.variables.variables.filter(Ze=>Ze.isTool).map(Ze=>Ze.id),Be=de.variables.variables.filter(Ze=>!Ze.isTool);return{prompt:de.message,command:de.command,attempt:de.attempt??0,enableCommandDetection:de.enableCommandDetection??!0,references:Be.map(Ni.to),location:Tt.to(de.location),acceptedConfirmationData:de.acceptedConfirmationData,rejectedConfirmationData:de.rejectedConfirmationData,location2:J,requestedTools:ye}}De.to=Re})(Ai||(e.ChatAgentRequest=Ai={}));var Tt;(function(De){function Re(J){switch(J){case h.ChatAgentLocation.Notebook:return b.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return b.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return b.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return b.ChatLocation.Editor}}De.to=Re;function de(J){switch(J){case b.ChatLocation.Notebook:return h.ChatAgentLocation.Notebook;case b.ChatLocation.Terminal:return h.ChatAgentLocation.Terminal;case b.ChatLocation.Panel:return h.ChatAgentLocation.Panel;case b.ChatLocation.Editor:return h.ChatAgentLocation.Editor}}De.from=de})(Tt||(e.ChatLocation=Tt={}));var Ni;(function(De){function Re(de){const J=de.value;if(!J)throw new Error("Invalid value reference");return{id:de.id,name:de.name,range:de.range&&[de.range.start,de.range.endExclusive],value:(0,s.$vc)(J)?s.URI.revive(J):J&&typeof J=="object"&&"uri"in J&&"range"in J&&(0,s.$vc)(J.uri)?L.to((0,o.$bi)(J)):J,modelDescription:de.modelDescription}}De.to=Re})(Ni||(e.ChatAgentValueReference=Ni={}));var ui;(function(De){function Re(de,J,ye){return{id:de.id,label:de.label,fullName:de.fullName,icon:de.icon?.id,value:de.values[0].value,insertText:de.insertText,detail:de.detail,documentation:de.documentation,command:J.toInternal(de.command,ye)}}De.from=Re})(ui||(e.ChatAgentCompletionItem=ui={}));var Pt;(function(De){function Re(de){return{errorDetails:de.errorDetails,metadata:de.metadata}}De.to=Re})(Pt||(e.ChatAgentResult=Pt={}));var Ti;(function(De){function Re(de,J,ye){if(J.action.kind==="vote")return;const Be=Pt.to(de);if(J.action.kind==="command"){const Ze=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ye.fromInternal(Ze)??{command:Ze.id,title:Ze.title}}},result:Be}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:Ft.to(J.action.followup)},result:Be}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Be}:{action:J.action,result:Be}}De.to=Re})(Ti||(e.ChatAgentUserActionEvent=Ti={}));var Ii;(function(De){function Re(de,J,ye){return"terminalCommand"in de?{terminalCommand:de.terminalCommand,shouldExecute:de.shouldExecute}:"uri"in de?{uri:de.uri}:J.toInternal(de,ye)}De.from=Re})(Ii||(e.TerminalQuickFix=Ii={}));var Di;(function(De){function Re(de){return{kind:Li.to(de.kind)}}De.to=Re})(Di||(e.PartialAcceptInfo=Di={}));var Li;(function(De){function Re(de){switch(de){case n.PartialAcceptTriggerKind.Word:return b.PartialAcceptTriggerKind.Word;case n.PartialAcceptTriggerKind.Line:return b.PartialAcceptTriggerKind.Line;case n.PartialAcceptTriggerKind.Suggest:return b.PartialAcceptTriggerKind.Suggest;default:return b.PartialAcceptTriggerKind.Unknown}}De.to=Re})(Li||(e.PartialAcceptTriggerKind=Li={}));var bi;(function(De){function Re(de,J){return{id:J,label:de.label,description:de.description,canEdit:de.canEdit,collapsibleState:de.collapsibleState||D.DebugTreeItemCollapsibleState.None,contextValue:de.contextValue}}De.from=Re})(bi||(e.DebugTreeItem=bi={}));var qt;(function(De){function Re(de){return{name:de.name,description:de.description,parametersSchema:de.parametersSchema}}De.to=Re})(qt||(e.LanguageModelToolDescription=qt={}))}),define(Ne[232],Le([1,0,5,16,8,39]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zpc=void 0;let A=class{constructor(p,o){this.a=p.getProxy(v.$JN.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>o.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(p,o,I){const y=new O.$Ww(P.WorkspaceEdit.from(p,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,I?.isRefactoring??!1)}};e.$zpc=A,e.$zpc=A=Je([Ve(0,R.$jQ)],A)}),define(Ne[233],Le([1,0,17,10,42,6,40,4,36,69,14,2,18,5,8,7,115,194,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Apc=void 0,d=We(d),r=We(r);class i{constructor(u,$,m,h,E){this.j=u,this.k=$,this.l=m,this.m=h,this.n=E,this.b=o.$fe.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let $=function(h){if(u.c){const E=new Error("Response stream has been closed");throw Error.captureStackTrace(E,h),E}};const u=this;this.b.reset();const m=(h,E)=>{if(typeof this.d>"u"&&"content"in h&&(this.d=this.b.elapsed()),E){const D=this.l.$handleProgressChunk(this.k.requestId,h),w={report:C=>{D?.then(k=>{k&&(r.$dO.isMarkdownString(C.value)?this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseWarningPart.from(C),k):this.l.$handleProgressChunk(this.k.requestId,d.ChatResponseReferencePart.from(C),k))})}};Promise.all([D,E?.(w)]).then(([C,k])=>{C!==void 0&&k!==void 0&&this.l.$handleProgressChunk(this.k.requestId,d.ChatTaskResult.from(k),C)})}else this.l.$handleProgressChunk(this.k.requestId,h)};this.g={markdown(h){$(this.markdown);const E=new r.$LP(h),D=d.ChatResponseMarkdownPart.from(E);return m(D),this},markdownWithVulnerabilities(h,E){$(this.markdown),E&&(0,l.$fH)(u.j,"chatParticipantAdditions");const D=new r.$MP(h,E),w=d.ChatResponseMarkdownWithVulnerabilitiesPart.from(D);return m(w),this},filetree(h,E){$(this.filetree);const D=new r.$PP(h,E),w=d.ChatResponseFilesPart.from(D);return m(w),this},anchor(h,E){$(this.anchor);const D=new r.$QP(h,E),w=d.ChatResponseAnchorPart.from(D);return m(w),this},button(h){$(this.anchor);const E=new r.$UP(h),D=d.ChatResponseCommandButtonPart.from(E,u.m,u.n);return m(D),this},progress(h,E){$(this.progress);const D=new r.$SP(h,E),w=E?d.ChatTask.from(D):d.ChatResponseProgressPart.from(D);return m(w,E),this},warning(h){$(this.progress),(0,l.$fH)(u.j,"chatParticipantAdditions");const E=new r.$TP(h),D=d.ChatResponseWarningPart.from(E);return m(D),this},reference(h,E){return this.reference2(h,E)},reference2(h,E,D){if($(this.reference),"variableName"in h&&(0,l.$fH)(u.j,"chatParticipantAdditions"),"variableName"in h&&!h.value){const w=u.k.variables.variables.find(C=>C.name===h.variableName);if(w){let C;if(w.references?.length)C=w.references.map(k=>({kind:"reference",reference:{variableName:h.variableName,value:k.reference}}));else{const k=new r.$VP(h,E,D);C=[d.ChatResponseReferencePart.from(k)]}return C.forEach(k=>m(k)),this}}else{const w=new r.$VP(h,E,D),C=d.ChatResponseReferencePart.from(w);m(C)}return this},codeCitation(h,E,D){$(this.codeCitation),(0,l.$fH)(u.j,"chatParticipantAdditions");const w=new r.$WP(h,E,D),C=d.ChatResponseCodeCitationPart.from(w);m(C)},textEdit(h,E){$(this.textEdit),(0,l.$fH)(u.j,"chatParticipantAdditions");const D=new r.$XP(h,E),w=d.ChatResponseTextEditPart.from(D);return m(w),this},detectedParticipant(h,E){$(this.detectedParticipant),(0,l.$fH)(u.j,"chatParticipantAdditions");const D=new r.$NP(h,E),w=d.ChatResponseDetectedParticipantPart.from(D);return m(w),this},confirmation(h,E,D,w){$(this.confirmation),(0,l.$fH)(u.j,"chatParticipantAdditions");const C=new r.$OP(h,E,D,w),k=d.ChatResponseConfirmationPart.from(C);return m(k),this},push(h){if($(this.push),(h instanceof r.$XP||h instanceof r.$MP||h instanceof r.$NP||h instanceof r.$TP||h instanceof r.$OP||h instanceof r.$WP)&&(0,l.$fH)(u.j,"chatParticipantAdditions"),h instanceof r.$VP)this.reference2(h.value,h.iconPath,h.options);else{const E=d.ChatResponsePart.from(h,u.m,u.n);m(E)}return this}}}return this.g}}class n extends T.$Uc{static{this.b=0}constructor(u,$,m,h){super(),this.n=$,this.s=m,this.t=h,this.c=new Map,this.j=this.B(new T.$4c),this.m=this.B(new T.$4c),this.g=u.getProxy(S.$JN.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,$,m){const h=n.b++,E=new t(u,$,this.g,h,m);return this.c.set(h,E),this.g.$registerAgent(h,u.identifier,$,{},void 0),E.apiAgent}createDynamicChatAgent(u,$,m,h){const E=n.b++,D=new t(u,$,this.g,E,h);return this.c.set(E,D),this.g.$registerAgent(E,u.identifier,$,{isSticky:!0},m),D.apiAgent}async $invokeAgent(u,$,m,h){const E=this.c.get(u);if(!E)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);const D=(0,p.$bi)($);let w=this.j.get(D.sessionId);w||(w=new T.$Tc,this.j.set(D.sessionId,w));const C=new i(E.extension,D,this.g,this.s.converter,w);try{const k=await this.u(D.agentId,m);let f;if(D.locationData?.type===s.ChatAgentLocation.Editor){const M=this.t.getDocument(D.locationData.document);f=new r.$1P(M,d.Selection.to(D.locationData.selection),d.Range.to(D.locationData.wholeRange))}else if(D.locationData?.type===s.ChatAgentLocation.Notebook){const M=this.t.getDocument(D.locationData.sessionInputUri);f=new r.$2P(M)}else D.locationData?.type,s.ChatAgentLocation.Terminal;const b=E.invoke(d.ChatAgentRequest.to(D,f),{history:k},C.apiObject,h);return await(0,R.$sh)(Promise.resolve(b).then(M=>{if(M?.metadata)try{JSON.stringify(M.metadata)}catch(L){const W=`result.metadata MUST be JSON.stringify-able. Got error: ${L.message}`;return this.n.error(`[${E.extension.identifier.value}] [@${E.id}] ${W}`,E.extension),{errorDetails:{message:W},timings:C.timings}}let N;return M?.errorDetails&&(N={...M.errorDetails,responseIsIncomplete:!0}),N?.responseIsRedacted&&(0,l.$fH)(E.extension,"chatParticipantPrivate"),{errorDetails:N,timings:C.timings,metadata:M?.metadata}}),h)}catch(k){return this.n.error(k,E.extension),k instanceof r.$0P&&k.cause&&(k=k.cause),{errorDetails:{message:(0,P.$pj)(k),responseIsIncomplete:!0}}}finally{C.close()}}async u(u,$){const m=[];for(const h of $.history){const E=d.ChatAgentResult.to(h.result),D=u===h.request.agentId?E:{...E,metadata:void 0},w=h.request.variables.variables.filter(k=>!k.isTool).map(d.ChatAgentValueReference.to);m.push(new r.$YP(h.request.message,h.request.command,w,h.request.agentId));const C=(0,v.$Gb)(h.response.map(k=>d.ChatResponsePart.toContent(k,this.s.converter)));m.push(new r.$ZP(C,D,h.request.agentId,h.request.command))}return m}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,$,m,h,E){const D=this.c.get($);if(!D)return Promise.resolve([]);const w=(0,p.$bi)(u),C=await this.u(D.id,h),k=d.ChatAgentResult.to(m);return(await D.provideFollowups(k,{history:C},E)).filter(f=>{const b=!f.participant||A.Iterable.some(this.c.values(),M=>M.id===f.participant&&a.$qn.equals(M.extension.identifier,D.extension.identifier));return b||this.n.warn(`[@${D.id}] ChatFollowup refers to an unknown participant: ${f.participant}`),b}).map(f=>d.ChatFollowup.from(f,w))}$acceptFeedback(u,$,m,h){const E=this.c.get(u);if(!E)return;const D=d.ChatAgentResult.to($);let w;switch(m){case c.ChatAgentVoteDirection.Down:w=r.ChatResultFeedbackKind.Unhelpful;break;case c.ChatAgentVoteDirection.Up:w=r.ChatResultFeedbackKind.Helpful;break}E.acceptFeedback(Object.freeze(h?{result:D,kind:w,reportIssue:h}:{result:D,kind:w}))}$acceptAction(u,$,m){const h=this.c.get(u);if(!h||m.action.kind==="vote")return;const E=d.ChatAgentUserActionEvent.to($,m,this.s.converter);E&&h.acceptAction(Object.freeze(E))}async $invokeCompletionProvider(u,$,m){const h=this.c.get(u);if(!h)return[];let E=this.m.get(u);return E?E.clear():(E=new T.$Tc,this.m.set(u,E)),(await h.invokeCompletionProvider($,m)).map(w=>d.ChatAgentCompletionItem.from(w,this.s.converter,E))}async $provideWelcomeMessage(u,$,m){const h=this.c.get(u);if(h)return await h.provideWelcomeMessage(d.ChatLocation.to($),m)}async $provideSampleQuestions(u,$,m){const h=this.c.get(u);if(h)return(await h.provideSampleQuestions(d.ChatLocation.to($),m)).map(E=>d.ChatFollowup.from(E,void 0))}}e.$Apc=n;class t{constructor(u,$,m,h,E){this.extension=u,this.id=$,this.w=m,this.x=h,this.y=E,this.m=new O.$le,this.n=new O.$le}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,$){return this.q?await this.q.provider.provideCompletionItems(u,$)??[]:[]}async provideFollowups(u,$,m){if(!this.b)return[];const h=await this.b.provideFollowups(u,$,m);return h?h.filter(E=>!(E&&"commandId"in E)).filter(E=>!(E&&"message"in E)):[]}async provideWelcomeMessage(u,$){if(!this.s)return[];const m=await this.s.provideWelcomeMessage(u,$);return m?m.map(h=>typeof h=="string"?h:d.MarkdownString.from(h)):[]}async provideSampleQuestions(u,$){if(!this.s||!this.s.provideSampleQuestions)return[];const m=await this.s.provideSampleQuestions(u,$);return m||[]}get apiAgent(){let u=!1,$=!1;const m=()=>{u||$||($=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{icon:this.c?this.c instanceof y.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof r.$KO?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:d.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:d.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:d.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t,supportsSlowVariables:this.u}),$=!1}))},h=this;return{get id(){return h.id},get iconPath(){return h.c},set iconPath(E){h.c=E,m()},get requestHandler(){return h.y},set requestHandler(E){(0,I.$og)(typeof E=="function","Invalid request handler"),h.y=E},get followupProvider(){return h.b},set followupProvider(E){h.b=E,m()},get isDefault(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.d},set isDefault(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.d=E,m()},get helpTextPrefix(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.g},set helpTextPrefix(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.g=E,m()},get helpTextVariablesPrefix(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.j},set helpTextVariablesPrefix(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.j=E,m()},get helpTextPostfix(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.k},set helpTextPostfix(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.k=E,m()},get isSecondary(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.l},set isSecondary(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.l=E,m()},get supportIssueReporting(){return(0,l.$fH)(h.extension,"chatParticipantPrivate"),h.o},set supportIssueReporting(E){(0,l.$fH)(h.extension,"chatParticipantPrivate"),h.o=E,m()},get onDidReceiveFeedback(){return h.m.event},set participantVariableProvider(E){if((0,l.$fH)(h.extension,"chatParticipantAdditions"),h.q=E,E){if(!E.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,h.id,E.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x,h.id)},get participantVariableProvider(){return(0,l.$fH)(h.extension,"chatParticipantAdditions"),h.q},set welcomeMessageProvider(E){(0,l.$fH)(h.extension,"defaultChatParticipant"),h.s=E,m()},get welcomeMessageProvider(){return(0,l.$fH)(h.extension,"defaultChatParticipant"),h.s},onDidPerformAction:(0,l.$eH)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(E){h.t=E,m()},get requester(){return h.t},set supportsSlowReferences(E){(0,l.$fH)(h.extension,"chatParticipantPrivate"),h.u=E,m()},get supportsSlowReferences(){return(0,l.$fH)(h.extension,"chatParticipantPrivate"),h.u},dispose(){u=!0,h.b=void 0,h.m.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(u,$,m,h){return this.y(u,$,m,h)}}}),define(Ne[234],Le([1,0,13,4,34,5,8,7,24]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bpc=void 0,A=We(A),T=We(T);class o{static{this.a=0}constructor(a){this.b=new Map,this.c=a.getProxy(O.$JN.MainThreadChatVariables)}async $resolveVariable(a,S,d,r){const s=this.b.get(a);if(s)try{if(s.resolver.resolve2){(0,p.$fH)(s.extension,"chatParticipantAdditions");const c=new I(S,this.c),l=await s.resolver.resolve2(s.data.name,{prompt:d},c.apiObject,r);if(l&&l[0])return l[0].value}else{const c=await s.resolver.resolve(s.data.name,{prompt:d},r);if(c&&c[0])return c[0].value}}catch(c){(0,v.$Z)(c)}}registerVariableResolver(a,S,d,r,s,c,l,i,n){const t=o.a++,g=n?P.ThemeIcon.fromId(n):void 0;return this.b.set(t,{extension:a,data:{id:S,name:d,description:r,modelDescription:s,icon:g},resolver:l}),this.c.$registerVariable(t,{id:S,name:d,description:r,modelDescription:s,isSlow:c,fullName:i,icon:g}),(0,R.$Sc)(()=>{this.b.delete(t),this.c.$unregisterVariable(t)})}}e.$Bpc=o;class I{constructor(a,S){this.c=a,this.d=S,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let S=function(r){if(a.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,r),s}};const a=this,d=r=>{this.d.$handleProgressChunk(this.c,r)};this.b={progress(r){S(this.progress);const s=new T.$RP(r),c=A.ChatResponseProgressPart.from(s);return d(c),this},reference(r){S(this.reference);const s=new T.$VP(r),c=A.ChatResponseReferencePart.from(s);return d(c),this},push(r){return S(this.push),r instanceof T.$VP?d(A.ChatResponseReferencePart.from(r)):r instanceof T.$RP&&d(A.ChatResponseProgressPart.from(r)),this}}}return this.b}}}),define(Ne[235],Le([1,0,10,71,6,4,37,2,93,18,8,7,5,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fpc=d,p=We(p),I=We(I),y=We(y);function d(r,s,c){const l=r.getProxy(a.$JN.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new o.$sn,s.registerArgumentProcessor({processArgument:w=>{if(w&&w.$mid===A.MarshalledId.CommentController){const C=this.b.get(w.handle);return C?C.value:w}else if(w&&w.$mid===A.MarshalledId.CommentThread){const C=w,k=this.b.get(C.commentControlHandle);if(!k)return C;const f=k.getCommentThread(C.commentThreadHandle);return f?f.value:C}else if(w&&(w.$mid===A.MarshalledId.CommentThreadReply||w.$mid===A.MarshalledId.CommentThreadInstance)){const C=this.b.get(w.thread.commentControlHandle);if(!C)return w;const k=C.getCommentThread(w.thread.commentThreadHandle);return k?w.$mid===A.MarshalledId.CommentThreadInstance?k.value:{thread:k.value,text:w.text}:w}else if(w&&w.$mid===A.MarshalledId.CommentNode){const C=this.b.get(w.thread.commentControlHandle);if(!C)return w;const k=C.getCommentThread(w.thread.commentThreadHandle);if(!k)return w;const f=w.commentUniqueId,b=k.getCommentByUniqueId(f);return b||w}else if(w&&w.$mid===A.MarshalledId.CommentThreadNode){const C=this.b.get(w.thread.commentControlHandle);if(!C)return w;const k=C.getCommentThread(w.thread.commentThreadHandle);if(!k)return w;const f=w.text,b=w.commentUniqueId,M=k.getCommentByUniqueId(b);return M?(typeof M.body=="string"?M.body=f:M.body=new y.$dO(f),M):w}return w}})}createCommentController(w,C,k){const f=i.a++,b=new t(w,f,C,k);this.b.set(b.handle,b);const M=this.c.get(w.identifier)||[];return M.push(b),this.c.set(w.identifier,M),b.value}async $createCommentThreadTemplate(w,C,k,f){const b=this.b.get(w);b&&b.$createCommentThreadTemplate(C,k,f)}async $setActiveComment(w,C){const k=this.b.get(w);k&&k.$setActiveComment(C??void 0)}async $updateCommentThreadTemplate(w,C,k){const f=this.b.get(w);f&&f.$updateCommentThreadTemplate(C,k)}$deleteCommentThread(w,C){this.b.get(w)?.$deleteCommentThread(C)}async $provideCommentingRanges(w,C,k){const f=this.b.get(w);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const b=await c.ensureDocumentData(T.URI.revive(C));return(0,v.$wh)(async()=>{const M=await f.commentingRangeProvider.provideCommentingRanges(b.document,k);let N;return Array.isArray(M)?N={ranges:M,fileComments:!1}:M?N={ranges:M.ranges||[],fileComments:M.enableFileComments||!1}:N=M??void 0,N}).then(M=>{let N;return M&&(N={ranges:M.ranges.map(L=>I.Range.from(L)),fileComments:M.fileComments}),N})}$toggleReaction(w,C,k,f,b){const M=this.b.get(w);return!M||!M.reactionHandler?Promise.resolve(void 0):(0,v.$wh)(()=>{const N=M.getCommentThread(C);if(N){const L=N.getCommentByUniqueId(f.uniqueIdInThread);if(M!==void 0&&L&&M.reactionHandler)return M.reactionHandler(L,$(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(w){this.n=w}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(w){(w===void 0!=(this.p===void 0)||!w||!this.p||!w.isEqual(this.p))&&(this.p=w,this.b.range=w,this.c.fire())}get range(){return this.p}set canReply(w){this.d!==w&&(this.d=w,this.b.canReply=w,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(w){this.e=w,this.b.label=w,this.c.fire()}get contextValue(){return this.f}set contextValue(w){this.f=w,this.b.contextValue=w,this.c.fire()}get comments(){return this.q}set comments(w){this.q=w,this.b.comments=w,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(w){this.g=w,this.b.collapsibleState=w,this.c.fire()}get state(){return this.h}set state(w){this.h=w,typeof w=="object"?((0,S.$fH)(this.extensionDescription,"commentThreadApplicability"),this.b.state=w.resolved,this.b.applicability=w.applicability):this.b.state=w,this.c.fire()}get isDisposed(){return this.j}constructor(w,C,k,f,b,M,N,L,W){this.m=C,this.n=k,this.o=f,this.p=b,this.q=M,this.extensionDescription=N,this.r=L,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$le,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Vc,this.l.value=new O.$Tc,this.n===void 0&&(this.n=`${w}.${this.handle}`),l.$createCommentThread(C,this.handle,this.n,this.o,I.Range.from(this.p),this.q.map(q=>g(this,q,this.k,this.extensionDescription)),N.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.i.push({dispose:()=>{l.$deleteCommentThread(C,this.handle)}});const K=this;this.value={get uri(){return K.uri},get range(){return K.range},set range(q){K.range=q},get comments(){return K.comments},set comments(q){K.comments=q},get collapsibleState(){return K.collapsibleState},set collapsibleState(q){K.collapsibleState=q},get canReply(){return K.canReply},set canReply(q){K.canReply=q},get contextValue(){return K.contextValue},set contextValue(q){K.contextValue=q},get label(){return K.label},set label(q){K.label=q},get state(){return K.state},set state(q){K.state=q},reveal:(q,G)=>K.reveal(q,G),hide:()=>K.hide(),dispose:()=>{K.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Tc);const w=k=>Object.prototype.hasOwnProperty.call(this.b,k),C={};w("range")&&(C.range=I.Range.from(this.p)),w("label")&&(C.label=this.label),w("contextValue")&&(C.contextValue=this.contextValue??null),w("comments")&&(C.comments=this.q.map(k=>g(this,k,this.k,this.extensionDescription))),w("collapsibleState")&&(C.collapseState=m(this.g)),w("canReply")&&(C.canReply=this.canReply),w("state")&&(C.state=h(this.h)),w("applicability")&&(C.applicability=E(this.h)),w("isTemplate")&&(C.isTemplate=this.r),this.b={},l.$updateCommentThread(this.m,this.handle,this.n,this.o,C)}getCommentByUniqueId(w){for(const C of this.k){const k=C[0],f=C[1];if(w===f)return k}}async reveal(w,C){(0,S.$fH)(this.extensionDescription,"commentReveal");let k;w&&w.body!==void 0?k=w:C=C??w;let f=k?this.k.get(k):void 0;f??=this.k.get(this.q[0]);let b=!0,M=!1;return C?.focus===y.CommentThreadFocus.Reply?(M=!0,b=!1):C?.focus===y.CommentThreadFocus.Comment&&(b=!1),l.$revealCommentThread(this.m,this.handle,f,{preserveFocus:b,focusReply:M})}async hide(){return l.$hideCommentThread(this.m,this.handle)}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(w=>w.dispose())}}Je([(0,R.$0h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class t{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(w){this.b=w,w?.resourceHints&&(0,S.$fH)(this.h,"commentingRangeHint"),l.$updateCommentingRanges(this.handle,w?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(w){this.c=w,l.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!w})}get options(){return this.d}set options(w){this.d=w,l.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,S.$fH)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,S.$fH)(this.h,"activeComment"),this.f}constructor(w,C,k,f){this.h=w,this.i=C,this.j=k,this.k=f,this.a=new Map,l.$registerCommentController(this.handle,k,f,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(M){b.options=M},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(M){b.commentingRangeProvider=M},get reactionHandler(){return b.reactionHandler},set reactionHandler(M){b.reactionHandler=M},get activeCommentThread(){return b.activeCommentThread},createCommentThread(M,N,L){return b.createCommentThread(M,N,L).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{l.$unregisterCommentController(this.handle)}})}createCommentThread(w,C,k){C===void 0&&(0,S.$fH)(this.h,"fileComments");const f=new n(this.id,this.handle,void 0,w,C,k,this.h,!1);return this.a.set(f.handle,f),f}$setActiveComment(w){if(!w){this.e=void 0,this.f=void 0;return}const C=this.a.get(w.commentThreadHandle);C&&(this.e=w.uniqueIdInThread?C.getCommentByUniqueId(w.uniqueIdInThread):void 0,this.f=C)}$createCommentThreadTemplate(w,C,k){const f=new n(this.id,this.handle,void 0,T.URI.revive(w),I.Range.to(C),[],this.h,!0,k);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(w,C){const k=this.a.get(w);k&&(k.range=I.Range.to(C))}$deleteCommentThread(w){this.a.get(w)?.dispose(),this.a.delete(w)}getCommentThread(w){return this.a.get(w)}dispose(){this.a.forEach(w=>{w.dispose()}),this.g.forEach(w=>w.dispose())}}function g(D,w,C,k){let f=C.get(w);return f||(f=++D.commentHandle,C.set(w,f)),w.state!==void 0&&(0,S.$fH)(k,"commentsDraftState"),w.reactions?.some(b=>b.reactors!==void 0)&&(0,S.$fH)(k,"commentReactor"),{mode:w.mode,contextValue:w.contextValue,uniqueIdInThread:f,body:typeof w.body=="string"?w.body:I.MarkdownString.from(w.body),userName:w.author.name,userIconPath:w.author.iconPath,label:w.label,commentReactions:w.reactions?w.reactions.map(b=>u(b)):void 0,state:w.state,timestamp:w.timestamp?.toJSON()}}function u(D){return{label:D.label,iconPath:D.iconPath?I.$iQ(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(w=>w.name):D.reactors}}function $(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?T.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(w=>({name:w}))}}function m(D){if(D!==void 0)switch(D){case y.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case y.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function h(D){let w;if(typeof D=="object"?w=D.resolved:w=D,w!==void 0)switch(w){case y.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case y.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function E(D){let w;if(typeof D=="object"&&(w=D.applicability),w!==void 0)switch(w){case y.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case y.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new i}}),define(Ne[236],Le([1,0,21,75,4,15,23,2,8,67,79,5,7]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xpc=void 0,p=We(p),y=We(y),a=We(a);class S{constructor(u,$){this.document=u,this.b=$,this.a=1,this.c=new I.$lpc("custom documents")}addEdit(u){return this.c.add([u])}async undo(u,$){await this.f(u).undo(),$||this.disposeBackup()}async redo(u,$){await this.f(u).redo(),$||this.disposeBackup()}disposeEdits(u){for(const $ of u)this.c.delete($)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const u=t(this.document.uri)+this.a++;return(0,A.$fh)(this.b,u)}updateBackup(u){this.d?.delete(),this.d=u}disposeBackup(){this.d?.delete(),this.d=void 0}f(u){const $=this.c.get(u,0);if(!$)throw new Error("No edit found");return $}}class d{constructor(){this.a=new Map}get(u,$){return this.a.get(this.b(u,$))}add(u,$,m){const h=this.b(u,$.uri);if(this.a.has(h))throw new Error(`Document already exists for viewType:${u} resource:${$.uri}`);const E=new S($,m);return this.a.set(h,E),E}delete(u,$){const m=this.b(u,$.uri);this.a.delete(m)}b(u,$){return`${u}@@@${$}`}}var r;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(r||(r={}));class s{constructor(){this.a=new Map}addTextProvider(u,$,m){return this.b(u,{type:r.Text,extension:$,provider:m})}addCustomProvider(u,$,m){return this.b(u,{type:r.Custom,extension:$,provider:m})}get(u){return this.a.get(u)}b(u,$){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,$),new a.$LN(()=>this.a.delete(u))}}class c{constructor(u,$,m,h,E){this.d=$,this.f=m,this.g=h,this.h=E,this.b=new s,this.c=new d,this.a=u.getProxy(y.$JN.MainThreadCustomEditors)}registerCustomEditorProvider(u,$,m,h){const E=new P.$Tc;return i(m)?(E.add(this.b.addTextProvider($,u,m)),this.a.$registerTextEditorProvider((0,o.$Upc)(u),$,h.webviewOptions||{},{supportsMove:!!m.moveCustomTextEditor},(0,o.$Spc)(u))):(E.add(this.b.addCustomProvider($,u,m)),l(m)&&E.add(m.onDidChangeCustomDocument(D=>{const w=this.i($,D.document.uri);if(n(D)){const C=w.addEdit(D);this.a.$onDidEdit(D.document.uri,$,C,D.label)}else this.a.$onContentChange(D.document.uri,$)})),this.a.$registerCustomEditorProvider((0,o.$Upc)(u),$,h.webviewOptions||{},!!h.supportsMultipleEditorsPerDocument,(0,o.$Spc)(u))),a.$LN.from(E,new a.$LN(()=>{this.a.$unregisterEditorProvider($)}))}async $createCustomDocument(u,$,m,h,E){const D=this.b.get($);if(!D)throw new Error(`No provider found for '${$}'`);if(D.type!==r.Custom)throw new Error(`Invalid provide type for '${$}'`);const w=T.URI.revive(u),C=await D.provider.openCustomDocument(w,{backupId:m,untitledDocumentData:h?.buffer},E);let k;return l(D.provider)&&this.f&&(k=this.f.workspaceValue(D.extension)??this.f.globalValue(D.extension)),this.c.add($,C,k),{editable:l(D.provider)}}async $disposeCustomDocument(u,$){const m=this.b.get($);if(!m)throw new Error(`No provider found for '${$}'`);if(m.type!==r.Custom)throw new Error(`Invalid provider type for '${$}'`);const h=T.URI.revive(u),{document:E}=this.i($,h);this.c.delete($,E),E.dispose()}async $resolveCustomEditor(u,$,m,h,E,D){const w=this.b.get(m);if(!w)throw new Error(`No provider found for '${m}'`);const C=p.ViewColumn.to(E),k=this.g.createNewWebview($,h.contentOptions,w.extension),f=this.h.createNewWebviewPanel($,m,h.title,C,h.options,k,h.active),b=T.URI.revive(u);switch(w.type){case r.Custom:{const{document:M}=this.i(m,b);return w.provider.resolveCustomEditor(M,f,D)}case r.Text:{const M=this.d.getDocument(b);return w.provider.resolveCustomTextEditor(M,f,D)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(u,$,m){this.i($,u).disposeEdits(m)}async $onMoveCustomEditor(u,$,m){const h=this.b.get(m);if(!h)throw new Error(`No provider found for '${m}'`);if(!h.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${m}'`);const E=this.h.getWebviewPanel(u);if(!E)throw new Error("No webview found");const D=T.URI.revive($),w=this.d.getDocument(D);await h.provider.moveCustomTextEditor(w,E,v.CancellationToken.None)}async $undo(u,$,m,h){return this.i($,u).undo(m,h)}async $redo(u,$,m,h){return this.i($,u).redo(m,h)}async $revert(u,$,m){const h=this.i($,u);await this.j($).revertCustomDocument(h.document,m),h.disposeBackup()}async $onSave(u,$,m){const h=this.i($,u);await this.j($).saveCustomDocument(h.document,m),h.disposeBackup()}async $onSaveAs(u,$,m,h){const E=this.i($,u);return this.j($).saveCustomDocumentAs(E.document,T.URI.revive(m),h)}async $backup(u,$,m){const h=this.i($,u),D=await this.j($).backupCustomDocument(h.document,{destination:h.getNewBackupUri()},m);return h.updateBackup(D),D.id}i(u,$){const m=this.c.get(u,T.URI.revive($));if(!m)throw new Error("No custom document found");return m}j(u){const m=this.b.get(u)?.provider;if(!m||!l(m))throw new Error("Custom document is not editable");return m}}e.$Xpc=c;function l(g){return!!g.onDidChangeCustomDocument}function i(g){return typeof g.resolveCustomTextEditor=="function"}function n(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function t(g){const u=g.scheme===O.Schemas.file||g.scheme===O.Schemas.untitled?g.fsPath:g.toString();return(0,R.$sj)(u)+""}}),define(Ne[237],Le([1,0,9,107,2,5,7,8,6,11,28,50]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$tpc=e.$spc=void 0,T=We(T);class S{#e;#t;#i;constructor(s,c,l,i,n,t,g,u){this.d=s,this.e=c,this.f=l,this.g=i,this.h=n,this.c=!1,this.f=Math.max(i,l),this.#i=new I.$Ac($=>t.getComparisonKey($)),this.#e=g,this.#t=u}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,c){if(!s){this.clear();return}this.j();let l=[];if(P.URI.isUri(s)){if(!c){this.delete(s);return}this.#i.set(s,c.slice()),l=[s]}else if(Array.isArray(s)){l=[];let t;s=[...s].sort(S.k);for(const g of s){const[u,$]=g;if((!t||u.toString()!==t.toString())&&(t&&this.#i.get(t).length===0&&this.#i.delete(t),t=u,l.push(u),this.#i.set(u,[])),$)this.#i.get(u)?.push(...$);else{const m=this.#i.get(u);m&&(m.length=0)}}}if(this.#t.fire(l),!this.#e)return;const i=[];let n=0;for(const t of l){let g=[];const u=this.#i.get(t);if(u)if(u.length>this.g){g=[];const $=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let m=0;m<4;m++)for(const h of u)if(h.severity===$[m]&&g.push({...T.Diagnostic.from(h),modelVersionId:this.h(t)})===this.g)break e;g.push({severity:R.MarkerSeverity.Info,message:(0,v.localize)(10827,null,u.length-this.g),startLineNumber:g[g.length-1].startLineNumber,startColumn:g[g.length-1].startColumn,endLineNumber:g[g.length-1].endLineNumber,endColumn:g[g.length-1].endColumn})}else g=u.map($=>({...T.Diagnostic.from($),modelVersionId:this.h(t)}));if(i.push([t,g]),n+=g.length,n>this.f)break}this.#e.$changeMany(this.e,i)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,c){this.j();for(const[l,i]of this)s.call(c,l,i,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const c=this.#i.get(s);return Array.isArray(c)?Object.freeze(c.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,c){return s[0].toString()<c[0].toString()?-1:s[0].toString()>c[0].toString()?1:0}}e.$spc=S;let d=class{static{a=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*this.d}static _mapper(s){const c=new I.$Ac;for(const l of s)c.set(l,l);return{uris:Object.freeze(Array.from(c.values()))}}constructor(s,c,l,i){this.j=c,this.k=l,this.l=i,this.g=new Map,this.h=new p.$pe({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=p.Event.map(this.h.event,a._mapper),this.f=s.getProxy(O.$JN.MainThreadDiagnostics)}createDiagnosticCollection(s,c){const{g:l,f:i,h:n,j:t,k:g,l:u}=this,$=new class{$changeMany(E,D){i.$changeMany(E,D),t.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,E,D.length===0?"CLEARING":D)}$clear(E){i.$clear(E),t.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,E)}dispose(){i.dispose()}};let m;if(!c)c="_generated_diagnostic_collection_name_#"+a.c++,m=c;else if(!l.has(c))m=c;else{this.j.warn(`DiagnosticCollection with name '${c}' does already exist.`);do m=c+a.c++;while(l.has(m))}return new class extends S{constructor(){super(c,m,a.e,a.d,E=>u.getDocument(E)?.version,g.extUri,$,n),l.set(m,this)}dispose(){super.dispose(),l.delete(m)}}}getDiagnostics(s){if(s)return this.m(s);{const c=new Map,l=[];for(const i of this.g.values())i.forEach((n,t)=>{let g=c.get(n.toString());typeof g>"u"&&(g=l.length,c.set(n.toString(),g),l.push([n,[]])),l[g][1]=l[g][1].concat(...t)});return l}}m(s){let c=[];for(const l of this.g.values())l.has(s)&&(c=c.concat(l.get(s)));return c}$acceptMarkersChange(s){if(!this.n){const c="_generated_mirror",l=new S(c,c,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,i=>{},this.k.extUri,void 0,this.h);this.g.set(c,l),this.n=l}for(const[c,l]of s)this.n.set(P.URI.revive(c),l.map(T.Diagnostic.to))}};e.$tpc=d,e.$tpc=d=a=Je([Ve(1,o.$_j),Ve(2,y.$rpc)],d)}),define(Ne[238],Le([1,0,2,13,7,8,171,39]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gqc=void 0;class p{constructor(I,y,a,S={timeout:1500,errors:3}){this.c=I,this.d=y,this.f=a,this.g=S,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(y,a,S)=>{const r={dispose:this.a.push([y,a,I])};return Array.isArray(S)&&S.push(r),r}}async $participateInSave(I,y){const a=v.URI.revive(I);let S=!1;const d=setTimeout(()=>S=!0,this.g.timeout),r=[];try{for(const s of[...this.a]){if(S)break;const c=this.d.getDocument(a),l=await this.h(s,{document:c,reason:O.TextDocumentSaveReason.to(y)});r.push(l)}}finally{clearTimeout(d)}return r}h([I,y,a],S){const d=this.b.get(I);return typeof d=="number"&&d>this.g.errors?Promise.resolve(!1):this.i(a,I,y,S).then(()=>!0,r=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' threw ERROR`),this.c.error(r),!(r instanceof Error)||r.message!=="concurrent_edits"){const s=this.b.get(I);this.b.set(I,s?s+1:1),typeof s=="number"&&s>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${a.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,y,a,S){const d=[],r=Date.now(),{document:s,reason:c}=S,{version:l}=s,i=Object.freeze({document:s,reason:c,waitUntil(n){if(Object.isFrozen(d))throw(0,R.$7)("waitUntil can not be called async");d.push(Promise.resolve(n))}});try{y.apply(a,[i])}catch(n){return Promise.reject(n)}return Object.freeze(d),new Promise((n,t)=>{const g=setTimeout(()=>t(new Error("timeout")),this.g.timeout);return Promise.all(d).then(u=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-r}ms`),clearTimeout(g),n(u)}).catch(u=>{clearTimeout(g),t(u)})}).then(n=>{const t={edits:[]};for(const g of n)if(Array.isArray(g)&&g.every(u=>u instanceof P.$UN))for(const{newText:u,newEol:$,range:m}of g)t.edits.push({resource:s.uri,versionId:void 0,textEdit:{range:m&&O.Range.from(m),text:u,eol:$&&O.EndOfLine.from($)}});if(t.edits.length!==0)return l===s.version?this.f.$tryApplyWorkspaceEdit(new T.$Ww(t)):Promise.reject(new Error("concurrent_edits"))})}}e.$Gqc=p}),define(Ne[239],Le([1,0,6,4,2,5,123,8,14,25,7]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$upc=void 0,T=We(T);class y{constructor(S,d){this.a=new v.$le,this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.$Tc,this.h=new Map,this.f=S.getProxy(O.$JN.MainThreadDocuments),this.g=d,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const d=this.g.getDocument(S);if(d)return d}getDocument(S){const d=this.getDocumentData(S);if(!d?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return d.document}ensureDocumentData(S){const d=this.g.getDocument(S);if(d)return Promise.resolve(d);let r=this.h.get(S.toString());return r||(r=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const c=P.URI.revive(s);return(0,p.$pg)(this.g.getDocument(c))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),r)),r}createDocumentData(S){return this.f.$tryCreateDocument(S).then(d=>P.URI.revive(d))}$acceptModelLanguageChanged(S,d){const r=P.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(d),this.a.fire(s.document)}$acceptModelSaved(S){const d=P.URI.revive(S),r=this.g.getDocument(d);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(S,d){const r=P.URI.revive(S),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(d),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,d,r){const s=P.URI.revive(S),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(d);let l;d.isUndoing?l=I.TextDocumentChangeReason.Undo:d.isRedoing&&(l=I.TextDocumentChangeReason.Redo),this.c.fire((0,o.$eo)({document:c.document,contentChanges:d.changes.map(i=>({range:T.Range.to(i.range),rangeOffset:i.rangeOffset,rangeLength:i.rangeLength,text:i.text})),reason:l}))}setWordDefinitionFor(S,d){(0,A.$lQ)(S,d)}}e.$upc=y}),define(Ne[70],Le([1,0,240,6,14,2,3,5,16,8,7]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zpc=e.$Ypc=void 0,o=We(o),e.$Ypc=(0,A.$Ei)("IExtHostEditorTabs");class y{constructor(s,c,l){this.e=l,this.d=c,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,c={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(c)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case T.TabInputKind.TextInput:return new I.$zP(O.URI.revive(this.b.input.uri));case T.TabInputKind.TextDiffInput:return new I.$AP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case T.TabInputKind.TextMergeInput:return new I.$BP(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case T.TabInputKind.CustomEditorInput:return new I.$CP(O.URI.revive(this.b.input.uri),this.b.input.viewType);case T.TabInputKind.WebviewEditorInput:return new I.$DP(this.b.input.viewType);case T.TabInputKind.NotebookInput:return new I.$EP(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case T.TabInputKind.NotebookDiffInput:return new I.$FP(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case T.TabInputKind.TerminalEditorInput:return new I.$GP;case T.TabInputKind.InteractiveEditorInput:return new I.$HP(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case T.TabInputKind.ChatEditorInput:return new I.$IP;case T.TabInputKind.MultiDiffEditorInput:return new I.$JP(this.b.input.diffEditors.map(s=>new I.$AP(O.URI.revive(s.original),O.URI.revive(s.modified))));default:return}}}class a{constructor(s,c){this.c=[],this.d="",this.b=s,this.e=c;for(const l of s.tabs)l.isActive&&(this.d=l.id),this.c.push(new y(l,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,c={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return o.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(l=>l.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(l=>l.apiObject))}};this.a=Object.freeze(c)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===T.TabModelOperationKind.TAB_OPEN){const l=new y(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,l),s.tabDto.isActive&&(this.d=l.tabId),l}else if(s.kind===T.TabModelOperationKind.TAB_CLOSE){const l=this.c.splice(s.index,1)[0];if(!l)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return l.tabId===this.d&&(this.d=""),l}else if(s.kind===T.TabModelOperationKind.TAB_MOVE){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const l=this.c.splice(s.oldIndex,1)[0];if(!l)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,l),l}const c=this.c.find(l=>l.tabId===s.tabDto.id);if(!c)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),c.acceptDtoUpdate(s.tabDto),c}activeTabId(){return this.d}}let S=class{constructor(s){this.b=new R.$le,this.c=new R.$le,this.e=[],this.a=s.getProxy(T.$JN.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,c={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(l=>l.apiObject))},get activeTabGroup(){const l=s.d;return(0,P.$pg)(s.e.find(n=>n.groupId===l)?.apiObject)},close:async(l,i)=>{const n=Array.isArray(l)?l:[l];return n.length?d(n[0])?this.j(n,i):this.i(n,i):!0}};this.f=Object.freeze(c)}return this.f}$acceptEditorTabModel(s){const c=new Set(this.e.map($=>$.groupId)),l=new Set(s.map($=>$.groupId)),i=(0,v.$d)(c,l),n=this.e.filter($=>i.removed.includes($.groupId)).map($=>$.apiObject),t=[],g=[];this.e=s.map($=>{const m=new a($,()=>this.d);return i.added.includes(m.groupId)?t.push(m.apiObject):g.push(m.apiObject),m});const u=(0,P.$pg)(s.find($=>$.isActive===!0)?.groupId);u!==void 0&&this.d!==u&&(this.d=u),this.c.fire(Object.freeze({opened:t,closed:n,changed:g}))}$acceptTabGroupUpdate(s){const c=this.e.find(l=>l.groupId===s.groupId);if(!c)throw new Error("Update Group IPC call received before group creation.");c.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[c.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const c=this.e.find(i=>i.groupId===s.groupId);if(!c)throw new Error("Update Tabs IPC call received before group creation.");const l=c.acceptTabOperation(s);switch(s.kind){case T.TabModelOperationKind.TAB_OPEN:this.b.fire(Object.freeze({opened:[l.apiObject],closed:[],changed:[]}));return;case T.TabModelOperationKind.TAB_CLOSE:this.b.fire(Object.freeze({opened:[],closed:[l.apiObject],changed:[]}));return;case T.TabModelOperationKind.TAB_MOVE:case T.TabModelOperationKind.TAB_UPDATE:this.b.fire(Object.freeze({opened:[],closed:[],changed:[l.apiObject]}));return}}g(s){for(const c of this.e)for(const l of c.tabs)if(l.apiObject===s)return l}h(s){return this.e.find(c=>c.apiObject===s)}async i(s,c){const l=[];for(const i of s){const n=this.g(i);if(!n)throw new Error("Tab close: Invalid tab not found!");l.push(n.tabId)}return this.a.$closeTab(l,c)}async j(s,c){const l=[];for(const i of s){const n=this.h(i);if(!n)throw new Error("Group close: Invalid group not found!");l.push(n.groupId)}return this.a.$closeGroup(l,c)}};e.$Zpc=S,e.$Zpc=S=Je([Ve(0,p.$jQ)],S);function d(r){return r.tabs!==void 0}}),define(Ne[241],Le([1,0,2,5,29,4,7,8,285,12,27,22,24,59]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jqc=void 0,P=We(P),T=We(T);class d{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const l=this.a.indexOf(c);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),l=[];let i,n,t=p.State.LastKnownState,g=p.State.LastKnownState;for(const u of c){let $=i?(0,o.$Hf)(i,u):0;for($===0?n=p.State.Start:n=g;$<u.length;$++)$+1===u.length?(t=g,g=p.State.BeforeColon):g+=1,l.push([n,u.toUpperCase().charCodeAt($),g]),l.push([n,u.toLowerCase().charCodeAt($),g]),n=g;i=u,g=t}l.push([p.State.BeforeColon,I.CharCode.Colon,p.State.AfterColon]),l.push([p.State.AfterColon,I.CharCode.Slash,p.State.End]),this.b=new p.$E4(l)}}provideDocumentLinks(c){this.c();const l=[],i=p.$F4.computeLinks({getLineContent(n){return c.lineAt(n-1).text},getLineCount(){return c.lineCount}},this.b);for(const n of i){const t=T.DocumentLink.to(n);t.target&&l.push(t)}return l}}class r{constructor(c,l){this.i=l,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(R.$JN.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,l,i,n={}){if(r.j(i),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const t=this.h++;this.b.add(l),this.d.add(l),this.c.set(t,i);let g=P.FileSystemProviderCapabilities.FileReadWrite;n.isCaseSensitive&&(g+=P.FileSystemProviderCapabilities.PathCaseSensitive),n.isReadonly&&(g+=P.FileSystemProviderCapabilities.Readonly),typeof i.copy=="function"&&(g+=P.FileSystemProviderCapabilities.FileFolderCopy),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,a.$fH)(c,"fsChunks"),g+=P.FileSystemProviderCapabilities.FileOpenReadWriteClose);let u;n.isReadonly&&(0,S.$5k)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,l,g,u).catch(m=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${l}`),console.error(m)});const $=i.onDidChangeFile(m=>{const h=[];for(const E of m){const{uri:D,type:w}=E;if(D.scheme!==l)continue;let C;switch(w){case A.FileChangeType.Changed:C=P.FileChangeType.UPDATED;break;case A.FileChangeType.Created:C=P.FileChangeType.ADDED;break;case A.FileChangeType.Deleted:C=P.FileChangeType.DELETED;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:D,type:C})}this.a.$onFileSystemChange(t,h)});return(0,O.$Sc)(()=>{$.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:l,ctime:i,mtime:n,size:t,permissions:g}=c;return{type:l,ctime:i,mtime:n,size:t,permissions:g}}$stat(c,l){return Promise.resolve(this.l(c).stat(v.URI.revive(l))).then(i=>r.k(i))}$readdir(c,l){return Promise.resolve(this.l(c).readDirectory(v.URI.revive(l)))}$readFile(c,l){return Promise.resolve(this.l(c).readFile(v.URI.revive(l))).then(i=>y.$Ne.wrap(i))}$writeFile(c,l,i,n){return Promise.resolve(this.l(c).writeFile(v.URI.revive(l),i.buffer,n))}$delete(c,l,i){return Promise.resolve(this.l(c).delete(v.URI.revive(l),i))}$rename(c,l,i,n){return Promise.resolve(this.l(c).rename(v.URI.revive(l),v.URI.revive(i),n))}$copy(c,l,i,n){const t=this.l(c);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(v.URI.revive(l),v.URI.revive(i),n))}$mkdir(c,l){return Promise.resolve(this.l(c).createDirectory(v.URI.revive(l)))}$watch(c,l,i,n){const t=this.l(c).watch(v.URI.revive(i),n);this.f.set(l,t)}$unwatch(c,l){const i=this.f.get(l);i&&(i.dispose(),this.f.delete(l))}$open(c,l,i){const n=this.l(c);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(v.URI.revive(l),i))}$close(c,l){const i=this.l(c);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(l))}$read(c,l,i,n){const t=this.l(c);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const g=y.$Ne.alloc(n);return Promise.resolve(t.read(l,i,g.buffer,0,n)).then(u=>g.slice(0,u))}$write(c,l,i,n){const t=this.l(c);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(l,i,n.buffer,0,n.byteLength))}l(c){const l=this.c.get(c);if(!l){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return l}}e.$Jqc=r}),define(Ne[242],Le([1,0,6,41,2,5,8,7,29,48]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kqc=void 0,A=We(A);class I{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(d,r,s,c,l,i){this.a=Math.random(),this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,R.$zk)(l),t=typeof l=="string",g=i?.correlate,u=c($=>{if(!(typeof $.session=="number"&&$.session!==this.a)&&!(g&&typeof $.session>"u")){if(!i?.ignoreCreateEvents)for(const m of $.created){const h=P.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.b.fire(h)}if(!i?.ignoreChangeEvents)for(const m of $.changed){const h=P.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.c.fire(h)}if(!i?.ignoreDeleteEvents)for(const m of $.deleted){const h=P.URI.revive(m);n(h.fsPath)&&(!t||r.getWorkspaceFolder(h))&&this.d.fire(h)}}});this.g=T.$LN.from(this.i(d,s,l,i,i?.correlate),this.b,this.c,this.d,u)}i(d,r,s,c,l){const i=T.$LN.from();if(typeof s=="string"||c?.ignoreChangeEvents&&c?.ignoreCreateEvents&&c?.ignoreDeleteEvents)return i;const n=d.getProxy(O.$JN.MainThreadFileSystemEventService);let t=!1;(s.pattern.includes(R.$vk)||s.pattern.includes(R.$wk))&&(t=!0);let g;return l&&(c?.ignoreChangeEvents||c?.ignoreCreateEvents||c?.ignoreDeleteEvents)&&(g=p.FileChangeFilter.UPDATED|p.FileChangeFilter.ADDED|p.FileChangeFilter.DELETED,c?.ignoreChangeEvents&&(g&=~p.FileChangeFilter.UPDATED),c?.ignoreCreateEvents&&(g&=~p.FileChangeFilter.ADDED),c?.ignoreDeleteEvents&&(g&=~p.FileChangeFilter.DELETED)),n.$watch(r.identifier.value,this.a,s.baseUri,{recursive:t,excludes:c?.excludes??[],filter:g},!!l),T.$LN.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class y{constructor(d){this.a=d,this.session=this.a.session,this.b=new o.$T(()=>this.a.created.map(P.URI.revive)),this.c=new o.$T(()=>this.a.changed.map(P.URI.revive)),this.d=new o.$T(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class a{constructor(d,r,s){this.j=d,this.k=r,this.l=s,this.a=new v.$le,this.b=new v.$le,this.c=new v.$le,this.d=new v.$le,this.g=new v.$ne,this.h=new v.$ne,this.i=new v.$ne,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(d,r,s,c){return new I(this.j,d,r,this.a.event,A.GlobPattern.from(s),c)}$onFileEvent(d){this.a.fire(new y(d))}$onDidRunFileOperation(d,r){switch(d){case p.FileOperation.MOVE:this.b.fire(Object.freeze({files:r.map(s=>({oldUri:P.URI.revive(s.source),newUri:P.URI.revive(s.target)}))}));break;case p.FileOperation.DELETE:this.d.fire(Object.freeze({files:r.map(s=>P.URI.revive(s.target))}));break;case p.FileOperation.CREATE:case p.FileOperation.COPY:this.c.fire(Object.freeze({files:r.map(s=>P.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(d){return this.m(d,this.g)}getOnWillCreateFileEvent(d){return this.m(d,this.h)}getOnWillDeleteFileEvent(d){return this.m(d,this.i)}m(d,r){return(s,c,l)=>{const i=function(t){s.call(c,t)};return i.extension=d,r.event(i,void 0,l)}}async $onWillRunFileOperation(d,r,s,c){switch(d){case p.FileOperation.MOVE:return await this.n(this.g,{files:r.map(l=>({oldUri:P.URI.revive(l.source),newUri:P.URI.revive(l.target)}))},s,c);case p.FileOperation.DELETE:return await this.n(this.i,{files:r.map(l=>P.URI.revive(l.target))},s,c);case p.FileOperation.CREATE:case p.FileOperation.COPY:return await this.n(this.h,{files:r.map(l=>P.URI.revive(l.target))},s,c)}}async n(d,r,s,c){const l=new Set,i=[];if(await d.fireAsync(r,c,async(t,g)=>{const u=Date.now(),$=await Promise.resolve(t);$ instanceof T.$XN&&(i.push([g.extension,$]),l.add(g.extension.displayName??g.extension.identifier.value)),Date.now()-u>s&&this.k.warn("SLOW file-participant",g.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,t]of i){const{edits:g}=A.WorkspaceEdit.from(t,{getTextDocumentVersion:u=>this.l.getDocument(u)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(g)}return{edit:n,extensionNames:Array.from(l)}}}e.$Kqc=a}),define(Ne[243],Le([1,0,17,10,21,13,96,4,25,69,12,14,2,32,286,93,103,9,18,8,7,24,79,5]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vpc=void 0,r=We(r),i=We(i),u=We(u);class ${constructor(z,j){this.d=z,this.e=j}async provideDocumentSymbols(z,j){const H=this.d.getDocument(z),V=await this.e.provideDocumentSymbols(H,j);if(!(0,v.$Jb)(V))return V[0]instanceof n.$8N?V.map(i.DocumentSymbol.from):$.f(V)}static f(z){z=z.slice(0).sort((V,re)=>{let ge=V.location.range.start.compareTo(re.location.range.start);return ge===0&&(ge=re.location.range.end.compareTo(V.location.range.end)),ge});const j=[],H=[];for(const V of z){const re={name:V.name||"!!MISSING: name!!",kind:i.SymbolKind.from(V.kind),tags:V.tags?.map(i.SymbolTag.from)||[],detail:"",containerName:V.containerName,range:i.Range.from(V.location.range),selectionRange:i.Range.from(V.location.range),children:[]};for(;;){if(H.length===0){H.push(re),j.push(re);break}const ge=H[H.length-1];if(S.$Nt.containsRange(ge.range,re.range)&&!S.$Nt.equalsRange(ge.range,re.range)){ge.children?.push(re),H.push(re);break}H.pop()}}return j}}class m{constructor(z,j,H,V,re,ge){this.f=z,this.g=j,this.h=H,this.j=V,this.k=re,this.l=ge,this.d=new g.$lpc("CodeLens"),this.e=new Map}async provideCodeLenses(z,j){const H=this.f.getDocument(z),V=await this.h.provideCodeLenses(H,j);if(!V||j.isCancellationRequested)return;const re=this.d.add(V),ge=new T.$Tc;this.e.set(re,ge);const Ce={cacheId:re,lenses:[]};for(let ze=0;ze<V.length;ze++)Ce.lenses.push({cacheId:[re,ze],range:i.Range.from(V[ze].range),command:this.g.toInternal(V[ze].command,ge)});return Ce}async resolveCodeLens(z,j){const H=z.cacheId&&this.d.get(...z.cacheId);if(!H)return;let V;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?V=H:V=await this.h.resolveCodeLens(H,j),V||(V=H),j.isCancellationRequested)return;const re=z.cacheId&&this.e.get(z.cacheId[0]);if(re){if(!V.command){const ge=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ge),this.l.error(ge);return}return z.command=this.g.toInternal(V.command,re),z}}releaseCodeLenses(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}}function h(Oe){return Array.isArray(Oe)?Oe.map(i.DefinitionLink.from):Oe?[i.DefinitionLink.from(Oe)]:[]}class E{constructor(z,j){this.d=z,this.e=j}async provideDefinition(z,j,H){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideDefinition(V,re,H);return h(ge)}}class D{constructor(z,j){this.d=z,this.e=j}async provideDeclaration(z,j,H){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideDeclaration(V,re,H);return h(ge)}}class w{constructor(z,j){this.d=z,this.e=j}async provideImplementation(z,j,H){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideImplementation(V,re,H);return h(ge)}}class C{constructor(z,j){this.d=z,this.e=j}async provideTypeDefinition(z,j,H){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideTypeDefinition(V,re,H);return h(ge)}}class k{static{this.f=10}constructor(z,j){this.g=z,this.h=j,this.d=0,this.e=new Map}async provideHover(z,j,H,V){const re=this.g.getDocument(z),ge=i.Position.to(j);let Ce;if(H&&H.verbosityRequest){const tt=H.verbosityRequest.previousHover.id,nt=this.e.get(tt);if(!nt)throw new Error(`Hover with id ${tt} not found`);const et={verbosityDelta:H.verbosityRequest.verbosityDelta,previousHover:nt};Ce=await this.h.provideHover(re,ge,V,et)}else Ce=await this.h.provideHover(re,ge,V);if(!Ce||(0,v.$Jb)(Ce.contents))return;Ce.range||(Ce.range=re.getWordRangeAtPosition(ge)),Ce.range||(Ce.range=new n.$NN(ge,ge));const ze=i.Hover.from(Ce),Qe=this.d;if(this.e.size===k.f){const tt=Math.min(...this.e.keys());this.e.delete(tt)}return this.e.set(Qe,Ce),this.d+=1,{...ze,id:Qe}}releaseHover(z){this.e.delete(z)}}class f{constructor(z,j){this.d=z,this.e=j}async provideEvaluatableExpression(z,j,H){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideEvaluatableExpression(V,re,H);if(ge)return i.EvaluatableExpression.from(ge)}}class b{constructor(z,j){this.d=z,this.e=j}async provideInlineValues(z,j,H,V){const re=this.d.getDocument(z),ge=await this.e.provideInlineValues(re,i.Range.to(j),i.InlineValueContext.to(H),V);if(Array.isArray(ge))return ge.map(Ce=>i.InlineValue.from(Ce))}}class M{constructor(z,j){this.d=z,this.e=j}async provideDocumentHighlights(z,j,H){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideDocumentHighlights(V,re,H);if(Array.isArray(ge))return ge.map(i.DocumentHighlight.from)}}class N{constructor(z,j){this.d=z,this.e=j}async provideMultiDocumentHighlights(z,j,H,V){const re=this.d.getDocument(z),ge=H.map(Qe=>this.d.getDocument(Qe)),Ce=i.Position.to(j),ze=await this.e.provideMultiDocumentHighlights(re,Ce,ge,V);if(Array.isArray(ze))return ze.map(i.MultiDocumentHighlight.from)}}class L{constructor(z,j){this.d=z,this.e=j}async provideLinkedEditingRanges(z,j,H){const V=this.d.getDocument(z),re=i.Position.to(j),ge=await this.e.provideLinkedEditingRanges(V,re,H);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,v.$Gb)(ge.ranges.map(i.Range.from)),wordPattern:ge.wordPattern}}}class W{constructor(z,j){this.d=z,this.e=j}async provideReferences(z,j,H,V){const re=this.d.getDocument(z),ge=i.Position.to(j),Ce=await this.e.provideReferences(re,ge,H,V);if(Array.isArray(Ce))return Ce.map(i.location.from)}}class K{static{this.d=1e3}constructor(z,j,H,V,re,ge,Ce){this.g=z,this.h=j,this.j=H,this.k=V,this.l=re,this.m=ge,this.n=Ce,this.e=new g.$lpc("CodeAction"),this.f=new Map}async provideCodeActions(z,j,H,V){const re=this.g.getDocument(z),ge=d.$Pt.isISelection(j)?i.Selection.to(j):i.Range.to(j),Ce=[];for(const et of this.j.getDiagnostics(z))if(ge.intersection(et.range)&&Ce.push(et)>K.d)break;const ze={diagnostics:Ce,only:H.only?new n.$0N(H.only):void 0,triggerKind:i.CodeActionTriggerKind.to(H.trigger)},Qe=await this.k.provideCodeActions(re,ge,ze,V);if(!(0,v.$Kb)(Qe)||V.isCancellationRequested)return;const _e=this.e.add(Qe),tt=new T.$Tc;this.f.set(_e,tt);const nt=[];for(let et=0;et<Qe.length;et++){const rt=Qe[et];if(rt)if(K.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),nt.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,tt)});else{ze.only&&(rt.kind?ze.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value}' requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ft=rt.ranges??[];nt.push({cacheId:[_e,et],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,tt),diagnostics:rt.diagnostics&&rt.diagnostics.map(i.Diagnostic.from),edit:rt.edit&&i.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$eH)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$eH)(this.m,"codeActionRanges")?(0,v.$Gb)(ft.map(i.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:_e,actions:nt}}async resolveCodeAction(z,j){const[H,V]=z,re=this.e.get(H,V);if(!re||K.o(re))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(re,j)??re;let Ce;ge.edit&&(Ce=i.WorkspaceEdit.from(ge.edit,void 0));let ze;if(ge.command){const Qe=this.f.get(H);Qe&&(ze=this.h.toInternal(ge.command,Qe))}return{edit:Ce,command:ze}}releaseCodeActions(z){this.f.get(z)?.dispose(),this.f.delete(z),this.e.delete(z)}static o(z){return typeof z.command=="string"&&typeof z.title=="string"}}class q{constructor(z,j,H,V,re){this.e=z,this.f=j,this.g=H,this.h=V,this.j=re,this.d=new g.$lpc("DocumentPasteEdit")}async prepareDocumentPaste(z,j,H,V){if(!this.g.prepareDocumentPaste)return;const re=this.f.getDocument(z),ge=j.map(Qe=>i.Range.to(Qe)),Ce=i.DataTransfer.toDataTransfer(H,()=>{throw new O.$0});if(await this.g.prepareDocumentPaste(re,ge,Ce,V),V.isCancellationRequested)return;const ze=Array.from(Ce).filter(([,Qe])=>!(Qe instanceof n.$DO));return i.DataTransfer.from(ze)}async providePasteEdits(z,j,H,V,re,ge){if(!this.g.provideDocumentPasteEdits)return[];const Ce=this.f.getDocument(j),ze=H.map(nt=>i.Range.to(nt)),Qe=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolvePasteFileData(this.h,z,nt)).buffer),_e=await this.g.provideDocumentPasteEdits(Ce,ze,Qe,{only:re.only?new n.$IO(re.only):void 0,triggerKind:re.triggerKind},ge);if(!_e||ge.isCancellationRequested)return[];const tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10823,null,this.j.displayName||this.j.name),kind:nt.kind,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(z,j){const[H,V]=z,re=this.d.get(H,V);if(!re||!this.g.resolveDocumentPasteEdit)return{};const ge=await this.g.resolveDocumentPasteEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releasePasteEdits(z){this.d.delete(z)}}class G{constructor(z,j){this.d=z,this.e=j}async provideDocumentFormattingEdits(z,j,H){const V=this.d.getDocument(z),re=await this.e.provideDocumentFormattingEdits(V,j,H);if(Array.isArray(re))return re.map(i.TextEdit.from)}}class Q{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeFormattingEdits(z,j,H,V){const re=this.d.getDocument(z),ge=i.Range.to(j),Ce=await this.e.provideDocumentRangeFormattingEdits(re,ge,H,V);if(Array.isArray(Ce))return Ce.map(i.TextEdit.from)}async provideDocumentRangesFormattingEdits(z,j,H,V){(0,y.$og)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const re=this.d.getDocument(z),ge=j.map(i.Range.to),Ce=await this.e.provideDocumentRangesFormattingEdits(re,ge,H,V);if(Array.isArray(Ce))return Ce.map(i.TextEdit.from)}}class ae{constructor(z,j){this.d=z,this.e=j,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(z,j,H,V,re){const ge=this.d.getDocument(z),Ce=i.Position.to(j),ze=await this.e.provideOnTypeFormattingEdits(ge,Ce,H,V,re);if(Array.isArray(ze))return ze.map(i.TextEdit.from)}}class we{constructor(z,j){this.e=z,this.f=j,this.d=new g.$lpc("WorkspaceSymbols")}async provideWorkspaceSymbols(z,j){const H=await this.e.provideWorkspaceSymbols(z,j);if(!(0,v.$Kb)(H))return{symbols:[]};const V=this.d.add(H),re={cacheId:V,symbols:[]};for(let ge=0;ge<H.length;ge++){const Ce=H[ge];if(!Ce||!Ce.name){this.f.warn("INVALID SymbolInformation",Ce);continue}re.symbols.push({...i.WorkspaceSymbol.from(Ce),cacheId:[V,ge]})}return re}async resolveWorkspaceSymbol(z,j){if(typeof this.e.resolveWorkspaceSymbol!="function"||!z.cacheId)return z;const H=this.d.get(...z.cacheId);if(H){const V=await this.e.resolveWorkspaceSymbol(H,j);return V&&(0,p.$go)(z,i.WorkspaceSymbol.from(V),!0)}}releaseWorkspaceSymbols(z){this.d.delete(z)}}class le{static supportsResolving(z){return typeof z.prepareRename=="function"}constructor(z,j,H){this.d=z,this.e=j,this.f=H}async provideRenameEdits(z,j,H,V){const re=this.d.getDocument(z),ge=i.Position.to(j);try{const Ce=await this.e.provideRenameEdits(re,ge,H,V);return Ce?i.WorkspaceEdit.from(Ce):void 0}catch(Ce){const ze=le.g(Ce);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ce)}}async resolveRenameLocation(z,j,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const V=this.d.getDocument(z),re=i.Position.to(j);try{const ge=await this.e.prepareRename(V,re,H);let Ce,ze;if(n.$NN.isRange(ge)?(Ce=ge,ze=V.getText(ge)):(0,y.$gg)(ge)&&(Ce=ge.range,ze=ge.placeholder),!Ce||!ze)return;if(Ce.start.line>re.line||Ce.end.line<re.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:i.Range.from(Ce),text:ze}}catch(ge){const Ce=le.g(ge);return Ce?{rejectReason:Ce,range:void 0,text:void 0}:Promise.reject(ge)}}static g(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class _{static{this.d={[r.NewSymbolNameTriggerKind.Invoke]:n.NewSymbolNameTriggerKind.Invoke,[r.NewSymbolNameTriggerKind.Automatic]:n.NewSymbolNameTriggerKind.Automatic}}constructor(z,j,H){this.e=z,this.f=j,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(z,j,H,V){const re=this.e.getDocument(z),ge=i.Range.to(j);try{const Ce=_.d[H],ze=await this.f.provideNewSymbolNames(re,ge,Ce,V);return ze?ze.map(Qe=>typeof Qe=="string"?{newSymbolName:Qe}:{newSymbolName:Qe.newSymbolName,tags:Qe.tags}):void 0}catch(Ce){this.g.error(_.h(Ce)??JSON.stringify(Ce,null,"	"));return}}static h(z){return typeof z=="string"?z:z instanceof Error&&typeof z.message=="string"?z.message:void 0}}class ce{constructor(z,j){this.resultId=z,this.tokens=j}}class me{constructor(z,j){this.f=z,this.g=j,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(z,j,H){const V=this.f.getDocument(z),re=j!==0?this.d.get(j):null;let ge=typeof re?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(V,re.resultId,H):await this.g.provideDocumentSemanticTokens(V,H);return re&&this.d.delete(j),ge?(ge=me.h(ge),this.o(me.n(re,ge),ge)):null}async releaseDocumentSemanticColoring(z){this.d.delete(z)}static h(z){return me.j(z)?me.k(z)?z:new n.$9O(new Uint32Array(z.data),z.resultId):me.l(z)?me.m(z)?z:new n.$$O(z.edits.map(j=>new n.$0O(j.start,j.deleteCount,j.data?new Uint32Array(j.data):j.data)),z.resultId):z}static j(z){return z&&!!z.data}static k(z){return z.data instanceof Uint32Array}static l(z){return z&&Array.isArray(z.edits)}static m(z){for(const j of z.edits)if(!(j.data instanceof Uint32Array))return!1;return!0}static n(z,j){if(!me.j(j)||!z||!z.tokens)return j;const H=z.tokens,V=H.length,re=j.data,ge=re.length;let Ce=0;const ze=Math.min(V,ge);for(;Ce<ze&&H[Ce]===re[Ce];)Ce++;if(Ce===V&&Ce===ge)return new n.$$O([],j.resultId);let Qe=0;const _e=ze-Ce;for(;Qe<_e&&H[V-Qe-1]===re[ge-Qe-1];)Qe++;return new n.$$O([{start:Ce,deleteCount:V-Ce-Qe,data:re.subarray(Ce,ge-Qe)}],j.resultId)}o(z,j){if(me.j(z)){const H=this.e++;return this.d.set(H,new ce(z.resultId,z.data)),(0,s.$Wdb)({id:H,type:"full",data:z.data})}if(me.l(z)){const H=this.e++;return me.j(j)?this.d.set(H,new ce(j.resultId,j.data)):this.d.set(H,new ce(z.resultId)),(0,s.$Wdb)({id:H,type:"delta",deltas:(z.edits||[]).map(V=>({start:V.start,deleteCount:V.deleteCount,data:V.data}))})}return null}}class oe{constructor(z,j){this.d=z,this.e=j}async provideDocumentRangeSemanticTokens(z,j,H){const V=this.d.getDocument(z),re=await this.e.provideDocumentRangeSemanticTokens(V,i.Range.to(j),H);return re?this.f(re):null}f(z){return(0,s.$Wdb)({id:0,type:"full",data:z.data})}}class ke{static supportsResolving(z){return typeof z.resolveCompletionItem=="function"}constructor(z,j,H,V,re){this.f=z,this.g=j,this.h=H,this.j=V,this.k=re,this.d=new g.$lpc("CompletionItem"),this.e=new Map}async provideCompletionItems(z,j,H,V){const re=this.f.getDocument(z),ge=i.Position.to(j),Ce=re.getWordRangeAtPosition(ge)||new n.$NN(ge,ge),ze=Ce.with({end:ge}),Qe=new o.$fe,_e=await this.h.provideCompletionItems(re,ge,V,i.CompletionContext.to(H));if(!_e||V.isCancellationRequested)return;const tt=Array.isArray(_e)?new n.$kO(_e):_e,nt=ke.supportsResolving(this.h)?this.d.add(tt.items):this.d.add([]),et=new T.$Tc;this.e.set(nt,et);const rt=[],ft={x:nt,[u.ISuggestResultDtoField.completions]:rt,[u.ISuggestResultDtoField.defaultRanges]:{replace:i.Range.from(Ce),insert:i.Range.from(ze)},[u.ISuggestResultDtoField.isIncomplete]:tt.isIncomplete||void 0,[u.ISuggestResultDtoField.duration]:Qe.elapsed()};for(let lt=0;lt<tt.items.length;lt++){const st=tt.items[lt],ct=this.l(st,[nt,lt],ze,Ce);rt.push(ct)}return ft}async resolveCompletionItem(z,j){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...z);if(!H)return;const V=this.l(H,z),re=await this.h.resolveCompletionItem(H,j);if(!re)return;const ge=this.l(re,z);return(V[u.ISuggestDataDtoField.insertText]!==ge[u.ISuggestDataDtoField.insertText]||V[u.ISuggestDataDtoField.insertTextRules]!==ge[u.ISuggestDataDtoField.insertTextRules])&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(V[u.ISuggestDataDtoField.commandIdent]!==ge[u.ISuggestDataDtoField.commandIdent]||V[u.ISuggestDataDtoField.commandId]!==ge[u.ISuggestDataDtoField.commandId]||!(0,p.$ho)(V[u.ISuggestDataDtoField.commandArguments],ge[u.ISuggestDataDtoField.commandArguments]))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...V,[u.ISuggestDataDtoField.documentation]:ge[u.ISuggestDataDtoField.documentation],[u.ISuggestDataDtoField.detail]:ge[u.ISuggestDataDtoField.detail],[u.ISuggestDataDtoField.additionalTextEdits]:ge[u.ISuggestDataDtoField.additionalTextEdits],[u.ISuggestDataDtoField.insertText]:ge[u.ISuggestDataDtoField.insertText],[u.ISuggestDataDtoField.insertTextRules]:ge[u.ISuggestDataDtoField.insertTextRules],[u.ISuggestDataDtoField.commandIdent]:ge[u.ISuggestDataDtoField.commandIdent],[u.ISuggestDataDtoField.commandId]:ge[u.ISuggestDataDtoField.commandId],[u.ISuggestDataDtoField.commandArguments]:ge[u.ISuggestDataDtoField.commandArguments]}}releaseCompletionItems(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j,H,V){const re=this.e.get(j[0]);if(!re)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(z.command,re),Ce={x:j,[u.ISuggestDataDtoField.label]:z.label,[u.ISuggestDataDtoField.kind]:z.kind!==void 0?i.CompletionItemKind.from(z.kind):void 0,[u.ISuggestDataDtoField.kindModifier]:z.tags&&z.tags.map(i.CompletionItemTag.from),[u.ISuggestDataDtoField.detail]:z.detail,[u.ISuggestDataDtoField.documentation]:typeof z.documentation>"u"?void 0:i.MarkdownString.fromStrict(z.documentation),[u.ISuggestDataDtoField.sortText]:z.sortText!==z.label?z.sortText:void 0,[u.ISuggestDataDtoField.filterText]:z.filterText!==z.label?z.filterText:void 0,[u.ISuggestDataDtoField.preselect]:z.preselect||void 0,[u.ISuggestDataDtoField.insertTextRules]:z.keepWhitespace?r.CompletionItemInsertTextRule.KeepWhitespace:r.CompletionItemInsertTextRule.None,[u.ISuggestDataDtoField.commitCharacters]:z.commitCharacters?.join(""),[u.ISuggestDataDtoField.additionalTextEdits]:z.additionalTextEdits&&z.additionalTextEdits.map(i.TextEdit.from),[u.ISuggestDataDtoField.commandIdent]:ge?.$ident,[u.ISuggestDataDtoField.commandId]:ge?.id,[u.ISuggestDataDtoField.commandArguments]:ge?.$ident?void 0:ge?.arguments};z.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ce[u.ISuggestDataDtoField.insertText]=z.textEdit.newText):typeof z.insertText=="string"?Ce[u.ISuggestDataDtoField.insertText]=z.insertText:z.insertText instanceof n.$YN&&(Ce[u.ISuggestDataDtoField.insertText]=z.insertText.value,Ce[u.ISuggestDataDtoField.insertTextRules]|=r.CompletionItemInsertTextRule.InsertAsSnippet);let ze;return z.textEdit?ze=z.textEdit.range:z.range&&(ze=z.range),n.$NN.isRange(ze)?Ce[u.ISuggestDataDtoField.range]=i.Range.from(ze):ze&&(!H?.isEqual(ze.inserting)||!V?.isEqual(ze.replacing))&&(Ce[u.ISuggestDataDtoField.range]={insert:i.Range.from(ze.inserting),replace:i.Range.from(ze.replacing)}),Ce}}class Te{async provideInlineCompletions(z,j,H,V){}async provideInlineEdits(z,j,H,V){}disposeCompletions(z){}handleDidShowCompletionItem(z,j,H){}handlePartialAccept(z,j,H,V){}}class Z extends Te{constructor(z,j,H,V){super(),this.f=z,this.g=j,this.h=H,this.j=V,this.d=new ne,this.e=(0,t.$eH)(this.f,"inlineCompletionsAdditions"),this.k={[r.InlineCompletionTriggerKind.Automatic]:n.InlineCompletionTriggerKind.Automatic,[r.InlineCompletionTriggerKind.Explicit]:n.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$eH)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(z,j,H,V){const re=this.g.getDocument(z),ge=i.Position.to(j),Ce=await this.h.provideInlineCompletionItems(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},V);if(!Ce||V.isCancellationRequested)return;const ze=Array.isArray(Ce)?Ce:Ce.items,Qe=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[],_e=this.e&&!Array.isArray(Ce)?Ce.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Tc),ft=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new T.$Tc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}async provideInlineEdits(z,j,H,V){if(!this.h.provideInlineEdits)return;(0,t.$fH)(this.f,"inlineCompletionsAdditions");const re=this.g.getDocument(z),ge=i.Range.to(j),Ce=await this.h.provideInlineEdits(re,ge,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:i.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind],userPrompt:H.userPrompt},V);if(!Ce||V.isCancellationRequested)return;const ze=Array.isArray(Ce)?Ce:Ce.items,Qe=this.e?Array.isArray(Ce)?[]:Ce.commands||[]:[],_e=this.e&&!Array.isArray(Ce)?Ce.enableForwardStability:void 0;let tt;return{pid:this.d.createReferenceId({dispose(){tt?.dispose()},items:ze}),items:ze.map((et,rt)=>{let ft;et.command&&(tt||(tt=new T.$Tc),ft=this.j.toInternal(et.command,tt));const lt=et.insertText;return{insertText:typeof lt=="string"?lt:{snippet:lt.value},filterText:et.filterText,range:et.range?i.Range.from(et.range):void 0,command:ft,idx:rt,completeBracketPairs:this.e?et.completeBracketPairs:!1}}),commands:Qe.map(et=>(tt||(tt=new T.$Tc),this.j.toInternal(et,tt))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(z){this.d.disposeReferenceId(z)?.dispose()}handleDidShowCompletionItem(z,j,H){const V=this.d.get(z)?.items[j];V&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(V,H)}handlePartialAccept(z,j,H,V){const re=this.d.get(z)?.items[j];re&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(re,H),this.h.handleDidPartiallyAcceptCompletionItem(re,i.PartialAcceptInfo.to(V)))}}class B{async provideInlineEdits(z,j,H){const V=this.f.getDocument(z),re=await this.g.provideInlineEdit(V,{triggerKind:this.e[j.triggerKind]},H);if(!re||H.isCancellationRequested)return;let ge;const Ce=this.d.createReferenceId({dispose(){ge?.dispose()},item:re});let ze;re.accepted&&(ge||(ge=new T.$Tc),ze=this.h.toInternal(re.accepted,ge));let Qe;return re.rejected&&(ge||(ge=new T.$Tc),Qe=this.h.toInternal(re.rejected,ge)),{pid:Ce,text:re.text,range:i.Range.from(re.range),accepted:ze,rejected:Qe}}disposeEdit(z){this.d.disposeReferenceId(z)?.dispose()}constructor(z,j,H,V){this.f=j,this.g=H,this.h=V,this.d=new ne,this.e={[r.InlineEditTriggerKind.Automatic]:n.InlineEditTriggerKind.Automatic,[r.InlineEditTriggerKind.Invoke]:n.InlineEditTriggerKind.Invoke}}}class ne{constructor(){this.d=new Map,this.e=1}createReferenceId(z){const j=this.e++;return this.d.set(j,z),j}disposeReferenceId(z){const j=this.d.get(z);return this.d.delete(z),j}get(z){return this.d.get(z)}}class Ee{constructor(z,j){this.e=z,this.f=j,this.d=new g.$lpc("SignatureHelp")}async provideSignatureHelp(z,j,H,V){const re=this.e.getDocument(z),ge=i.Position.to(j),Ce=this.g(H),ze=await this.f.provideSignatureHelp(re,ge,V,Ce);if(ze){const Qe=this.d.add([ze]);return{...i.SignatureHelp.from(ze),id:Qe}}}g(z){let j;if(z.activeSignatureHelp){const H=i.SignatureHelp.to(z.activeSignatureHelp),V=this.d.get(z.activeSignatureHelp.id,0);V?(j=V,j.activeSignature=H.activeSignature,j.activeParameter=H.activeParameter):j=H}return{...z,activeSignatureHelp:j}}releaseSignatureHelp(z){this.d.delete(z)}}class fe{constructor(z,j,H,V,re){this.f=z,this.g=j,this.h=H,this.j=V,this.k=re,this.d=new g.$lpc("InlayHints"),this.e=new Map}async provideInlayHints(z,j,H){const V=this.f.getDocument(z),re=i.Range.to(j),ge=await this.h.provideInlayHints(V,re,H);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`);return}if(H.isCancellationRequested)return;const Ce=this.d.add(ge);this.e.set(Ce,new T.$Tc);const ze={hints:[],cacheId:Ce};for(let Qe=0;Qe<ge.length;Qe++)this.l(ge[Qe],re)&&ze.hints.push(this.m(ge[Qe],[Ce,Qe]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(j)}`),ze}async resolveInlayHint(z,j){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...z);if(!H)return;const V=await this.h.resolveInlayHint(H,j);if(V&&this.l(V))return this.m(V,z)}releaseHints(z){this.e.get(z)?.dispose(),this.e.delete(z),this.d.delete(z)}l(z,j){return z.label.length===0||Array.isArray(z.label)&&z.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",z),!1):!(j&&!j.contains(z.position))}m(z,j){const H=this.e.get(j[0]);if(!H)throw Error("DisposableStore is missing...");const V={label:"",cacheId:j,tooltip:i.MarkdownString.fromStrict(z.tooltip),position:i.Position.from(z.position),textEdits:z.textEdits&&z.textEdits.map(i.TextEdit.from),kind:z.kind&&i.InlayHintKind.from(z.kind),paddingLeft:z.paddingLeft,paddingRight:z.paddingRight};if(typeof z.label=="string")V.label=z.label;else{const re=[];V.label=re;for(const ge of z.label){if(!ge.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ce={label:ge.value,tooltip:i.MarkdownString.fromStrict(ge.tooltip)};n.$ZN.isLocation(ge.location)&&(Ce.location=i.location.from(ge.location)),ge.command&&(Ce.command=this.g.toInternal(ge.command,H)),re.push(Ce)}}return V}}class be{constructor(z,j){this.e=z,this.f=j,this.d=new g.$lpc("DocumentLink")}async provideLinks(z,j){const H=this.e.getDocument(z),V=await this.f.provideDocumentLinks(H,j);if(!(!Array.isArray(V)||V.length===0)&&!j.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:V.filter(be.g).map(i.DocumentLink.from)};{const re=this.d.add(V),ge={links:[],cacheId:re};for(let Ce=0;Ce<V.length;Ce++){if(!be.g(V[Ce]))continue;const ze=i.DocumentLink.from(V[Ce]);ze.cacheId=[re,Ce],ge.links.push(ze)}return ge}}}static g(z){return z.target&&z.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(z,j){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...z);if(!H)return;const V=await this.f.resolveDocumentLink(H,j);if(!(!V||!be.g(V)))return i.DocumentLink.from(V)}releaseLinks(z){this.d.delete(z)}}class he{constructor(z,j){this.d=z,this.e=j}async provideColors(z,j){const H=this.d.getDocument(z),V=await this.e.provideDocumentColors(H,j);return Array.isArray(V)?V.map(ge=>({color:i.Color.from(ge.color),range:i.Range.from(ge.range)})):[]}async provideColorPresentations(z,j,H){const V=this.d.getDocument(z),re=i.Range.to(j.range),ge=i.Color.to(j.color),Ce=await this.e.provideColorPresentations(ge,{document:V,range:re},H);if(Array.isArray(Ce))return Ce.map(i.ColorPresentation.from)}}class X{constructor(z,j){this.d=z,this.e=j}async provideFoldingRanges(z,j,H){const V=this.d.getDocument(z),re=await this.e.provideFoldingRanges(V,j,H);if(Array.isArray(re))return re.map(i.FoldingRange.from)}}class x{constructor(z,j,H){this.d=z,this.e=j,this.f=H}async provideSelectionRanges(z,j,H){const V=this.d.getDocument(z),re=j.map(i.Position.to),ge=await this.e.provideSelectionRanges(V,re,H);if(!(0,v.$Kb)(ge))return[];if(ge.length!==re.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ce=[];for(let ze=0;ze<re.length;ze++){const Qe=[];Ce.push(Qe);let _e=re[ze],tt=ge[ze];for(;;){if(!tt.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(i.SelectionRange.from(tt)),!tt.parent)break;_e=tt.range,tt=tt.parent}}return Ce}}class $e{constructor(z,j){this.f=z,this.g=j,this.d=new A.$oQ(""),this.e=new Map}async prepareSession(z,j,H){const V=this.f.getDocument(z),re=i.Position.to(j),ge=await this.g.prepareCallHierarchy(V,re,H);if(!ge)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ce,ze)):[this.h(Ce,ge)]}async provideCallsTo(z,j,H){const V=this.j(z,j);if(!V)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyIncomingCalls(V,H);if(re)return re.map(ge=>({from:this.h(z,ge.from),fromRanges:ge.fromRanges.map(Ce=>i.Range.from(Ce))}))}async provideCallsFrom(z,j,H){const V=this.j(z,j);if(!V)throw new Error("missing call hierarchy item");const re=await this.g.provideCallHierarchyOutgoingCalls(V,H);if(re)return re.map(ge=>({to:this.h(z,ge.to),fromRanges:ge.fromRanges.map(Ce=>i.Range.from(Ce))}))}releaseSession(z){this.e.delete(z)}h(z,j){const H=this.e.get(z),V=i.CallHierarchyItem.from(j,z,H.size.toString(36));return H.set(V._itemId,j),V}j(z,j){return this.e.get(z)?.get(j)}}class pe{constructor(z,j){this.f=z,this.g=j,this.d=new A.$oQ(""),this.e=new Map}async prepareSession(z,j,H){const V=this.f.getDocument(z),re=i.Position.to(j),ge=await this.g.prepareTypeHierarchy(V,re,H);if(!ge)return;const Ce=this.d.nextId();return this.e.set(Ce,new Map),Array.isArray(ge)?ge.map(ze=>this.h(Ce,ze)):[this.h(Ce,ge)]}async provideSupertypes(z,j,H){const V=this.j(z,j);if(!V)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySupertypes(V,H);if(re)return re.map(ge=>this.h(z,ge))}async provideSubtypes(z,j,H){const V=this.j(z,j);if(!V)throw new Error("missing type hierarchy item");const re=await this.g.provideTypeHierarchySubtypes(V,H);if(re)return re.map(ge=>this.h(z,ge))}releaseSession(z){this.e.delete(z)}h(z,j){const H=this.e.get(z),V=i.TypeHierarchyItem.from(j,z,H.size.toString(36));return H.set(V._itemId,j),V}j(z,j){return this.e.get(z)?.get(j)}}class Ae{constructor(z,j,H,V,re){this.e=z,this.f=j,this.g=H,this.h=V,this.j=re,this.d=new g.$lpc("DocumentDropEdit")}async provideDocumentOnDropEdits(z,j,H,V,re){const ge=this.f.getDocument(j),Ce=i.Position.to(H),ze=i.DataTransfer.toDataTransfer(V,async nt=>(await this.e.$resolveDocumentOnDropFileData(this.h,z,nt)).buffer),Qe=await this.g.provideDocumentDropEdits(ge,Ce,ze,re);if(!Qe)return;const _e=(0,v.$1b)(Qe),tt=this.d.add(_e);return _e.map((nt,et)=>({_cacheId:[tt,et],title:nt.title??(0,c.localize)(10824,null,this.j.displayName||this.j.name),kind:nt.kind?.value,yieldTo:nt.yieldTo?.map(rt=>rt.value),insertText:typeof nt.insertText=="string"?nt.insertText:{snippet:nt.insertText.value},additionalEdit:nt.additionalEdit?i.WorkspaceEdit.from(nt.additionalEdit,void 0):void 0}))}async resolveDropEdit(z,j){const[H,V]=z,re=this.d.get(H,V);if(!re||!this.g.resolveDocumentDropEdit)return{};const ge=await this.g.resolveDocumentDropEdit(re,j)??re;return{additionalEdit:ge.additionalEdit?i.WorkspaceEdit.from(ge.additionalEdit,void 0):void 0}}releaseDropEdits(z){this.d.delete(z)}}class Ue{constructor(z,j){this.d=z,this.e=j}async provideMappedEdits(z,j,H,V){const re=a.URI.revive(z),ge=this.d.getDocument(re),Ce=H.documents.map(_e=>_e.map(tt=>({uri:a.URI.revive(tt.uri),version:tt.version,ranges:tt.ranges.map(nt=>i.Range.to(nt))}))),ze={documents:Ce,selections:Ce[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(ge,j,ze,V);return Qe?i.WorkspaceEdit.from(Qe):null}}class Ie{constructor(z,j){this.adapter=z,this.extension=j}}class Pe{static{this.d=0}constructor(z,j,H,V,re,ge,Ce,ze){this.g=j,this.h=H,this.j=V,this.k=re,this.l=ge,this.m=Ce,this.n=ze,this.f=new Map,this.e=z.getProxy(u.$JN.MainThreadLanguageFeatures)}o(z,j){return i.DocumentSelector.from(z,this.g,j)}p(z){return new n.$LN(()=>{this.f.delete(z),this.e.$unregister(z)})}q(){return Pe.d++}async s(z,j,H,V,re,ge=!1){const Ce=this.f.get(z);if(!Ce||!(Ce.adapter instanceof j))return V;const ze=Date.now();ge||this.l.trace(`[${Ce.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Qe=H(Ce.adapter,Ce.extension);return Promise.resolve(Qe).catch(_e=>{(0,O.$3)(_e)||(this.l.error(`[${Ce.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Ce.extension.identifier,_e))}).finally(()=>{ge||this.l.trace(`[${Ce.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),P.CancellationToken.isCancellationToken(re)?(0,R.$th)(Qe,re):Qe}t(z,j){const H=this.q();return this.f.set(H,new Ie(z,j)),H}static u(z){return z.displayName||z.name}static w(z){return z.identifier.value}registerDocumentSymbolProvider(z,j,H,V){const re=this.t(new $(this.h,H),z),ge=V&&V.label||Pe.u(z);return this.e.$registerDocumentSymbolProvider(re,this.o(j,z),ge),this.p(re)}$provideDocumentSymbols(z,j,H){return this.s(z,$,V=>V.provideDocumentSymbols(a.URI.revive(j),H),void 0,H)}registerCodeLensProvider(z,j,H){const V=this.q(),re=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(V,new Ie(new m(this.h,this.j.converter,H,z,this.n,this.l),z)),this.e.$registerCodeLensSupport(V,this.o(j,z),re);let ge=this.p(V);if(re!==void 0){const Ce=H.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(re));ge=n.$LN.from(ge,Ce)}return ge}$provideCodeLenses(z,j,H){return this.s(z,m,V=>V.provideCodeLenses(a.URI.revive(j),H),void 0,H)}$resolveCodeLens(z,j,H){return this.s(z,m,V=>V.resolveCodeLens(j,H),void 0,void 0)}$releaseCodeLenses(z,j){this.s(z,m,H=>Promise.resolve(H.releaseCodeLenses(j)),void 0,void 0)}registerDefinitionProvider(z,j,H){const V=this.t(new E(this.h,H),z);return this.e.$registerDefinitionSupport(V,this.o(j,z)),this.p(V)}$provideDefinition(z,j,H,V){return this.s(z,E,re=>re.provideDefinition(a.URI.revive(j),H,V),[],V)}registerDeclarationProvider(z,j,H){const V=this.t(new D(this.h,H),z);return this.e.$registerDeclarationSupport(V,this.o(j,z)),this.p(V)}$provideDeclaration(z,j,H,V){return this.s(z,D,re=>re.provideDeclaration(a.URI.revive(j),H,V),[],V)}registerImplementationProvider(z,j,H){const V=this.t(new w(this.h,H),z);return this.e.$registerImplementationSupport(V,this.o(j,z)),this.p(V)}$provideImplementation(z,j,H,V){return this.s(z,w,re=>re.provideImplementation(a.URI.revive(j),H,V),[],V)}registerTypeDefinitionProvider(z,j,H){const V=this.t(new C(this.h,H),z);return this.e.$registerTypeDefinitionSupport(V,this.o(j,z)),this.p(V)}$provideTypeDefinition(z,j,H,V){return this.s(z,C,re=>re.provideTypeDefinition(a.URI.revive(j),H,V),[],V)}registerHoverProvider(z,j,H,V){const re=this.t(new k(this.h,H),z);return this.e.$registerHoverProvider(re,this.o(j,z)),this.p(re)}$provideHover(z,j,H,V,re){return this.s(z,k,ge=>ge.provideHover(a.URI.revive(j),H,V,re),void 0,re)}$releaseHover(z,j){this.s(z,k,H=>Promise.resolve(H.releaseHover(j)),void 0,void 0)}registerEvaluatableExpressionProvider(z,j,H,V){const re=this.t(new f(this.h,H),z);return this.e.$registerEvaluatableExpressionProvider(re,this.o(j,z)),this.p(re)}$provideEvaluatableExpression(z,j,H,V){return this.s(z,f,re=>re.provideEvaluatableExpression(a.URI.revive(j),H,V),void 0,V)}registerInlineValuesProvider(z,j,H,V){const re=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new b(this.h,H),z);this.e.$registerInlineValuesProvider(ge,this.o(j,z),re);let Ce=this.p(ge);if(re!==void 0){const ze=H.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(re));Ce=n.$LN.from(Ce,ze)}return Ce}$provideInlineValues(z,j,H,V,re){return this.s(z,b,ge=>ge.provideInlineValues(a.URI.revive(j),H,V,re),void 0,re)}registerDocumentHighlightProvider(z,j,H){const V=this.t(new M(this.h,H),z);return this.e.$registerDocumentHighlightProvider(V,this.o(j,z)),this.p(V)}registerMultiDocumentHighlightProvider(z,j,H){const V=this.t(new N(this.h,H),z);return this.e.$registerMultiDocumentHighlightProvider(V,this.o(j,z)),this.p(V)}$provideDocumentHighlights(z,j,H,V){return this.s(z,M,re=>re.provideDocumentHighlights(a.URI.revive(j),H,V),void 0,V)}$provideMultiDocumentHighlights(z,j,H,V,re){return this.s(z,N,ge=>ge.provideMultiDocumentHighlights(a.URI.revive(j),H,V.map(Ce=>a.URI.revive(Ce)),re),void 0,re)}registerLinkedEditingRangeProvider(z,j,H){const V=this.t(new L(this.h,H),z);return this.e.$registerLinkedEditingRangeProvider(V,this.o(j,z)),this.p(V)}$provideLinkedEditingRanges(z,j,H,V){return this.s(z,L,async re=>{const ge=await re.provideLinkedEditingRanges(a.URI.revive(j),H,V);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?Pe.y(ge.wordPattern):void 0}},void 0,V)}registerReferenceProvider(z,j,H){const V=this.t(new W(this.h,H),z);return this.e.$registerReferenceSupport(V,this.o(j,z)),this.p(V)}$provideReferences(z,j,H,V,re){return this.s(z,W,ge=>ge.provideReferences(a.URI.revive(j),H,V,re),void 0,re)}registerCodeActionProvider(z,j,H,V){const re=new T.$Tc,ge=this.t(new K(this.h,this.j.converter,this.k,H,this.l,z,this.m),z);return this.e.$registerCodeActionSupport(ge,this.o(j,z),{providedKinds:V?.providedCodeActionKinds?.map(Ce=>Ce.value),documentation:V?.documentation?.map(Ce=>({kind:Ce.kind.value,command:this.j.converter.toInternal(Ce.command,re)}))},Pe.u(z),Pe.w(z),!!H.resolveCodeAction),re.add(this.p(ge)),re}$provideCodeActions(z,j,H,V,re){return this.s(z,K,ge=>ge.provideCodeActions(a.URI.revive(j),H,V,re),void 0,re)}$resolveCodeAction(z,j,H){return this.s(z,K,V=>V.resolveCodeAction(j,H),{},void 0)}$releaseCodeActions(z,j){this.s(z,K,H=>Promise.resolve(H.releaseCodeActions(j)),void 0,void 0)}registerDocumentFormattingEditProvider(z,j,H){const V=this.t(new G(this.h,H),z);return this.e.$registerDocumentFormattingSupport(V,this.o(j,z),z.identifier,z.displayName||z.name),this.p(V)}$provideDocumentFormattingEdits(z,j,H,V){return this.s(z,G,re=>re.provideDocumentFormattingEdits(a.URI.revive(j),H,V),void 0,V)}registerDocumentRangeFormattingEditProvider(z,j,H){const V=typeof H.provideDocumentRangesFormattingEdits=="function",re=this.t(new Q(this.h,H),z);return this.e.$registerRangeFormattingSupport(re,this.o(j,z),z.identifier,z.displayName||z.name,V),this.p(re)}$provideDocumentRangeFormattingEdits(z,j,H,V,re){return this.s(z,Q,ge=>ge.provideDocumentRangeFormattingEdits(a.URI.revive(j),H,V,re),void 0,re)}$provideDocumentRangesFormattingEdits(z,j,H,V,re){return this.s(z,Q,ge=>ge.provideDocumentRangesFormattingEdits(a.URI.revive(j),H,V,re),void 0,re)}registerOnTypeFormattingEditProvider(z,j,H,V){const re=this.t(new ae(this.h,H),z);return this.e.$registerOnTypeFormattingSupport(re,this.o(j,z),V,z.identifier),this.p(re)}$provideOnTypeFormattingEdits(z,j,H,V,re,ge){return this.s(z,ae,Ce=>Ce.provideOnTypeFormattingEdits(a.URI.revive(j),H,V,re,ge),void 0,ge)}registerWorkspaceSymbolProvider(z,j){const H=this.t(new we(j,this.l),z);return this.e.$registerNavigateTypeSupport(H,typeof j.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(z,j,H){return this.s(z,we,V=>V.provideWorkspaceSymbols(j,H),{symbols:[]},H)}$resolveWorkspaceSymbol(z,j,H){return this.s(z,we,V=>V.resolveWorkspaceSymbol(j,H),void 0,void 0)}$releaseWorkspaceSymbols(z,j){this.s(z,we,H=>H.releaseWorkspaceSymbols(j),void 0,void 0)}registerRenameProvider(z,j,H){const V=this.t(new le(this.h,H,this.l),z);return this.e.$registerRenameSupport(V,this.o(j,z),le.supportsResolving(H)),this.p(V)}$provideRenameEdits(z,j,H,V,re){return this.s(z,le,ge=>ge.provideRenameEdits(a.URI.revive(j),H,V,re),void 0,re)}$resolveRenameLocation(z,j,H,V){return this.s(z,le,re=>re.resolveRenameLocation(a.URI.revive(j),H,V),void 0,V)}registerNewSymbolNamesProvider(z,j,H){const V=this.t(new _(this.h,H,this.l),z);return this.e.$registerNewSymbolNamesProvider(V,this.o(j,z)),this.p(V)}$supportsAutomaticNewSymbolNamesTriggerKind(z){return this.s(z,_,j=>j.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(z,j,H,V,re){return this.s(z,_,ge=>ge.provideNewSymbolNames(a.URI.revive(j),H,V,re),void 0,re)}registerDocumentSemanticTokensProvider(z,j,H,V){const re=this.t(new me(this.h,H),z),ge=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(re,this.o(j,z),V,ge);let Ce=this.p(re);if(ge){const ze=H.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(ge));Ce=n.$LN.from(Ce,ze)}return Ce}$provideDocumentSemanticTokens(z,j,H,V){return this.s(z,me,re=>re.provideDocumentSemanticTokens(a.URI.revive(j),H,V),null,V)}$releaseDocumentSemanticTokens(z,j){this.s(z,me,H=>H.releaseDocumentSemanticColoring(j),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(z,j,H,V){const re=this.t(new oe(this.h,H),z);return this.e.$registerDocumentRangeSemanticTokensProvider(re,this.o(j,z),V),this.p(re)}$provideDocumentRangeSemanticTokens(z,j,H,V){return this.s(z,oe,re=>re.provideDocumentRangeSemanticTokens(a.URI.revive(j),H,V),null,V)}registerCompletionItemProvider(z,j,H,V){const re=this.t(new ke(this.h,this.j.converter,H,this.m,z),z);return this.e.$registerCompletionsProvider(re,this.o(j,z),V,ke.supportsResolving(H),z.identifier),this.p(re)}$provideCompletionItems(z,j,H,V,re){return this.s(z,ke,ge=>ge.provideCompletionItems(a.URI.revive(j),H,V,re),void 0,re)}$resolveCompletionItem(z,j,H){return this.s(z,ke,V=>V.resolveCompletionItem(j,H),void 0,H)}$releaseCompletionItems(z,j){this.s(z,ke,H=>H.releaseCompletionItems(j),void 0,void 0)}registerInlineCompletionsProvider(z,j,H,V){const re=new Z(z,this.h,H,this.j.converter),ge=this.t(re,z);return this.e.$registerInlineCompletionsSupport(ge,this.o(j,z),re.supportsHandleEvents,l.$qn.toKey(z.identifier.value),V?.yieldTo?.map(Ce=>l.$qn.toKey(Ce))||[]),this.p(ge)}$provideInlineCompletions(z,j,H,V,re){return this.s(z,Te,ge=>ge.provideInlineCompletions(a.URI.revive(j),H,V,re),void 0,re)}$provideInlineEdits(z,j,H,V,re){return this.s(z,Te,ge=>ge.provideInlineEdits(a.URI.revive(j),H,V,re),void 0,re)}$handleInlineCompletionDidShow(z,j,H,V){this.s(z,Te,async re=>{re.handleDidShowCompletionItem(j,H,V)},void 0,void 0)}$handleInlineCompletionPartialAccept(z,j,H,V,re){this.s(z,Te,async ge=>{ge.handlePartialAccept(j,H,V,re)},void 0,void 0)}$freeInlineCompletionsList(z,j){this.s(z,Te,async H=>{H.disposeCompletions(j)},void 0,void 0)}registerInlineEditProvider(z,j,H){const V=new B(z,this.h,H,this.j.converter),re=this.t(V,z);return this.e.$registerInlineEditProvider(re,this.o(j,z),z.identifier),this.p(re)}$provideInlineEdit(z,j,H,V){return this.s(z,B,re=>re.provideInlineEdits(a.URI.revive(j),H,V),void 0,V)}$freeInlineEdit(z,j){this.s(z,B,async H=>{H.disposeEdit(j)},void 0,void 0)}registerSignatureHelpProvider(z,j,H,V){const re=Array.isArray(V)?{triggerCharacters:V,retriggerCharacters:[]}:V,ge=this.t(new Ee(this.h,H),z);return this.e.$registerSignatureHelpProvider(ge,this.o(j,z),re),this.p(ge)}$provideSignatureHelp(z,j,H,V,re){return this.s(z,Ee,ge=>ge.provideSignatureHelp(a.URI.revive(j),H,V,re),void 0,re)}$releaseSignatureHelp(z,j){this.s(z,Ee,H=>H.releaseSignatureHelp(j),void 0,void 0)}registerInlayHintsProvider(z,j,H){const V=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,re=this.t(new fe(this.h,this.j.converter,H,this.l,z),z);this.e.$registerInlayHintsProvider(re,this.o(j,z),typeof H.resolveInlayHint=="function",V,Pe.u(z));let ge=this.p(re);if(V!==void 0){const Ce=H.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(V));ge=n.$LN.from(ge,Ce)}return ge}$provideInlayHints(z,j,H,V){return this.s(z,fe,re=>re.provideInlayHints(a.URI.revive(j),H,V),void 0,V)}$resolveInlayHint(z,j,H){return this.s(z,fe,V=>V.resolveInlayHint(j,H),void 0,H)}$releaseInlayHints(z,j){this.s(z,fe,H=>H.releaseHints(j),void 0,void 0)}registerDocumentLinkProvider(z,j,H){const V=this.t(new be(this.h,H),z);return this.e.$registerDocumentLinkProvider(V,this.o(j,z),typeof H.resolveDocumentLink=="function"),this.p(V)}$provideDocumentLinks(z,j,H){return this.s(z,be,V=>V.provideLinks(a.URI.revive(j),H),void 0,H,j.scheme==="output")}$resolveDocumentLink(z,j,H){return this.s(z,be,V=>V.resolveLink(j,H),void 0,void 0,!0)}$releaseDocumentLinks(z,j){this.s(z,be,H=>H.releaseLinks(j),void 0,void 0,!0)}registerColorProvider(z,j,H){const V=this.t(new he(this.h,H),z);return this.e.$registerDocumentColorProvider(V,this.o(j,z)),this.p(V)}$provideDocumentColors(z,j,H){return this.s(z,he,V=>V.provideColors(a.URI.revive(j),H),[],H)}$provideColorPresentations(z,j,H,V){return this.s(z,he,re=>re.provideColorPresentations(a.URI.revive(j),H,V),void 0,V)}registerFoldingRangeProvider(z,j,H){const V=this.q(),re=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(V,new Ie(new X(this.h,H),z)),this.e.$registerFoldingRangeProvider(V,this.o(j,z),z.identifier,re);let ge=this.p(V);if(re!==void 0){const Ce=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(re));ge=n.$LN.from(ge,Ce)}return ge}$provideFoldingRanges(z,j,H,V){return this.s(z,X,re=>re.provideFoldingRanges(a.URI.revive(j),H,V),void 0,V)}registerSelectionRangeProvider(z,j,H){const V=this.t(new x(this.h,H,this.l),z);return this.e.$registerSelectionRangeProvider(V,this.o(j,z)),this.p(V)}$provideSelectionRanges(z,j,H,V){return this.s(z,x,re=>re.provideSelectionRanges(a.URI.revive(j),H,V),[],V)}registerCallHierarchyProvider(z,j,H){const V=this.t(new $e(this.h,H),z);return this.e.$registerCallHierarchyProvider(V,this.o(j,z)),this.p(V)}$prepareCallHierarchy(z,j,H,V){return this.s(z,$e,re=>Promise.resolve(re.prepareSession(a.URI.revive(j),H,V)),void 0,V)}$provideCallHierarchyIncomingCalls(z,j,H,V){return this.s(z,$e,re=>re.provideCallsTo(j,H,V),void 0,V)}$provideCallHierarchyOutgoingCalls(z,j,H,V){return this.s(z,$e,re=>re.provideCallsFrom(j,H,V),void 0,V)}$releaseCallHierarchy(z,j){this.s(z,$e,H=>Promise.resolve(H.releaseSession(j)),void 0,void 0)}registerTypeHierarchyProvider(z,j,H){const V=this.t(new pe(this.h,H),z);return this.e.$registerTypeHierarchyProvider(V,this.o(j,z)),this.p(V)}$prepareTypeHierarchy(z,j,H,V){return this.s(z,pe,re=>Promise.resolve(re.prepareSession(a.URI.revive(j),H,V)),void 0,V)}$provideTypeHierarchySupertypes(z,j,H,V){return this.s(z,pe,re=>re.provideSupertypes(j,H,V),void 0,V)}$provideTypeHierarchySubtypes(z,j,H,V){return this.s(z,pe,re=>re.provideSubtypes(j,H,V),void 0,V)}$releaseTypeHierarchy(z,j){this.s(z,pe,H=>Promise.resolve(H.releaseSession(j)),void 0,void 0)}registerDocumentOnDropEditProvider(z,j,H,V){const re=this.q();return this.f.set(re,new Ie(new Ae(this.e,this.h,H,re,z),z)),this.e.$registerDocumentOnDropEditProvider(re,this.o(j,z),(0,t.$eH)(z,"documentPaste")&&V?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:V.dropMimeTypes}:void 0),this.p(re)}$provideDocumentOnDropEdits(z,j,H,V,re,ge){return this.s(z,Ae,Ce=>Promise.resolve(Ce.provideDocumentOnDropEdits(j,a.URI.revive(H),V,re,ge)),void 0,void 0)}$resolveDropEdit(z,j,H){return this.s(z,Ae,V=>V.resolveDropEdit(j,H),{},void 0)}$releaseDocumentOnDropEdits(z,j){this.s(z,Ae,H=>Promise.resolve(H.releaseDropEdits(j)),void 0,void 0)}registerMappedEditsProvider(z,j,H){const V=this.t(new Ue(this.h,H),z);return this.e.$registerMappedEditsProvider(V,this.o(j,z),z.displayName??z.name),this.p(V)}$provideMappedEdits(z,j,H,V,re){return this.s(z,Ue,ge=>Promise.resolve(ge.provideMappedEdits(j,H,V,re)),null,re)}registerDocumentPasteEditProvider(z,j,H,V){const re=this.q();return this.f.set(re,new Ie(new q(this.e,this.h,H,re,z),z)),this.e.$registerPasteEditProvider(re,this.o(j,z),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:V.providedPasteEditKinds?.map(ge=>ge.value),copyMimeTypes:V.copyMimeTypes,pasteMimeTypes:V.pasteMimeTypes}),this.p(re)}$prepareDocumentPaste(z,j,H,V,re){return this.s(z,q,ge=>ge.prepareDocumentPaste(a.URI.revive(j),H,V,re),void 0,re)}$providePasteEdits(z,j,H,V,re,ge,Ce){return this.s(z,q,ze=>ze.providePasteEdits(j,a.URI.revive(H),V,re,ge,Ce),void 0,Ce)}$resolvePasteEdit(z,j,H){return this.s(z,q,V=>V.resolvePasteEdit(j,H),{},void 0)}$releasePasteEdits(z,j){this.s(z,q,H=>Promise.resolve(H.releasePasteEdits(j)),void 0,void 0)}static y(z){return{pattern:z.source,flags:z.flags}}static z(z){return{decreaseIndentPattern:Pe.y(z.decreaseIndentPattern),increaseIndentPattern:Pe.y(z.increaseIndentPattern),indentNextLinePattern:z.indentNextLinePattern?Pe.y(z.indentNextLinePattern):void 0,unIndentedLinePattern:z.unIndentedLinePattern?Pe.y(z.unIndentedLinePattern):void 0}}static B(z){return{beforeText:Pe.y(z.beforeText),afterText:z.afterText?Pe.y(z.afterText):void 0,previousLineText:z.previousLineText?Pe.y(z.previousLineText):void 0,action:z.action}}static C(z){return z.map(Pe.B)}static D(z){return{open:z.open,close:z.close,notIn:z.notIn?z.notIn.map(j=>n.SyntaxTokenType.toString(j)):void 0}}static E(z){return z.map(Pe.D)}setLanguageConfiguration(z,j,H){const{wordPattern:V}=H;if(V&&(0,I.$rf)(V))throw new Error(`Invalid language configuration: wordPattern '${V}' is not allowed to match the empty string.`);V?this.h.setWordDefinitionFor(j,V):this.h.setWordDefinitionFor(j,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",z,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",z,"Do not use.");const re=this.q(),ge={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Pe.y(H.wordPattern):void 0,indentationRules:H.indentationRules?Pe.z(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Pe.C(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Pe.E(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(re,j,ge),this.p(re)}$setWordDefinitions(z){for(const j of z)this.h.setWordDefinitionFor(j.languageId,new RegExp(j.regexSource,j.regexFlags))}}e.$vpc=Pe}),define(Ne[244],Le([1,0,4,36,5,8]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zqc=void 0,O=We(O);class A{constructor(p){this.a=new Map,this.c=new Map,this.b=p.getProxy(P.$JN.MainThreadLanguageModelTools),this.b.$getTools().then(o=>{for(const I of o)this.c.set(I.name,(0,R.$bi)(I))})}async invokeTool(p,o,I){return await this.b.$invokeTool(p,o,I)}async $acceptToolDelta(p){p.added&&this.c.set(p.added.name,p.added),p.removed&&this.c.delete(p.removed)}get tools(){return Array.from(this.c.values()).map(p=>O.LanguageModelToolDescription.to(p))}async $invokeTool(p,o,I){const y=this.a.get(p);if(!y)throw new Error(`Unknown tool ${p}`);return await y.tool.invoke(o,I)}registerTool(p,o,I){return this.a.set(o,{extension:p,tool:I}),this.b.$registerTool(o),(0,v.$Sc)(()=>{this.a.delete(o),this.b.$unregisterTool(o)})}}e.$Zqc=A}),define(Ne[94],Le([1,0,10,21,42,13,6,40,4,9,18,3,11,76,5,90,16,8,7,117,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$dqc=e.$cqc=void 0,c=We(c),l=We(l),e.$cqc=(0,y.$Ei)("IExtHostLanguageModels");class g{constructor(h,E){this.option=h,this.stream=new v.$8h,this.stream=E??new v.$8h}}class u{constructor(){this.a=new Map,this.b=new v.$8h,this.c=!1;const h=this;this.apiObject={get stream(){return h.b.asyncIterable},get text(){return v.$5h.map(h.b.asyncIterable,E=>{if(E instanceof l.$6P)return E.value}).coalesce()}}}*d(){if(this.a.size>0)for(const[,h]of this.a)yield h.stream;else yield this.b}handleFragment(h){if(this.c)return;let E=this.a.get(h.index);E||(this.a.size===0?E=new g(h.index,this.b):E=new g(h.index),this.a.set(h.index,E));let D;h.part.type==="text"?D=new l.$6P(h.part.value):D=new l.$5P(h.part.name,h.part.parameters),E.stream.emitOne(D)}reject(h){this.c=!0;for(const E of this.d())E.reject(h)}resolve(){this.c=!0;for(const h of this.d())h.resolve()}}let $=class{static{t=this}static{this.a=1}constructor(h,E,D){this.j=E,this.k=D,this.c=new A.$le,this.d=new A.$le,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new I.$sn,this.i=new Map,this.s=new Set,this.b=h.getProxy(d.$JN.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(h,E,D,w){const C=t.a++;this.f.set(C,{extension:h.identifier,provider:D,languageModelId:E});let k;w.auth&&(k={providerLabel:h.displayName||h.name,accountLabel:typeof w.auth=="object"?w.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,`${I.$qn.toKey(h.identifier)}/${C}/${E}`,{extension:h.identifier,id:E,vendor:w.vendor??I.$qn.toKey(h.identifier),name:w.name??"",family:w.family??"",version:w.version,maxInputTokens:w.maxInputTokens,maxOutputTokens:w.maxOutputTokens,auth:k,targetExtensions:w.extensions});const f=D.onDidReceiveLanguageModelResponse2?.(({extensionId:b,participant:M,tokenCount:N})=>{this.b.$whenLanguageModelChatRequestMade(E,new I.$qn(b),M,N)});return(0,p.$Sc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C),f?.dispose()})}async $startChatRequest(h,E,D,w,C,k){const f=this.f.get(h);if(!f)throw new Error("Provider not found");const b=new S.$yw(async N=>{if(k.isCancellationRequested){this.j.warn(`[CHAT](${f.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}let L;if(N.part instanceof l.$5P?L={type:"function_use",name:N.part.name,parameters:N.part.parameters}:N.part instanceof l.$6P&&(L={type:"text",value:N.part.value}),!L){this.j.warn(`[CHAT](${f.extension.value}) UNKNOWN part ${JSON.stringify(N)}`);return}this.b.$reportResponsePart(E,{index:N.index,part:L})});let M;if(f.provider.provideLanguageModelResponse2)M=Promise.resolve(f.provider.provideLanguageModelResponse2(w.map(c.LanguageModelChatMessage.to),C,I.$qn.toKey(D),b,k));else{const N=new S.$yw(async L=>{b.report({index:L.index,part:new l.$6P(L.part)})});M=Promise.resolve(f.provider.provideLanguageModelResponse(w.map(c.LanguageModelChatMessage.to),C?.modelOptions??{},I.$qn.toKey(D),N,k))}M.then(()=>{this.b.$reportResponseDone(E,void 0)},N=>{this.b.$reportResponseDone(E,(0,O.$1)(N))})}$provideTokenLength(h,E,D){const w=this.f.get(h);return w?Promise.resolve(w.provider.provideTokenCount(E,D)):Promise.resolve(0)}$acceptChatModelMetadata(h){if(h.added)for(const{identifier:E,metadata:D}of h.added)this.g.set(E,{metadata:D,apiObjects:new I.$sn});if(h.removed)for(const E of h.removed){this.g.delete(E);for(const[D,w]of this.i)w.languageModelId===E&&(w.res.reject(new O.$4),this.i.delete(D))}h.added?.forEach(E=>this.q(E.metadata)),this.d.fire(void 0)}async selectLanguageModels(h,E){const D=await this.b.$selectChatModels({...E,extension:h.identifier}),w=[],C=this;for(const k of D){const f=this.g.get(k);if(!f)continue;this.o(h.identifier,f.metadata)&&await this.q(f.metadata);let b=f.apiObjects.get(h.identifier);b||(b={id:k,vendor:f.metadata.vendor,family:f.metadata.family,version:f.metadata.version,name:f.metadata.name,maxInputTokens:f.metadata.maxInputTokens,countTokens(M,N){if(!C.g.has(k))throw l.$0P.NotFound(k);return C.r(k,M,N??R.CancellationToken.None)},sendRequest(M,N,L){if(!C.g.has(k))throw l.$0P.NotFound(k);return C.l(h,k,M,N??{},L??R.CancellationToken.None)}},Object.freeze(b),f.apiObjects.set(h.identifier,b)),w.push(b)}return w}async l(h,E,D,w,C){const k=this.m(h,D),f=h.identifier,b=this.g.get(E)?.metadata;if(!b||!this.g.has(E))throw l.$0P.NotFound(`Language model '${E}' is unknown.`);if(this.o(f,b)&&(!await this.n(h,{identifier:b.extension,displayName:b.auth.providerLabel},w.justification,!1)||!this.h.get(f)?.has(b.extension)))throw l.$0P.NoPermissions(`Language model '${E}' cannot be used by '${f.value}'.`);try{const M=Math.random()*1e6|0,N=new u;this.i.set(M,{languageModelId:E,res:N});try{await this.b.$tryStartChatRequest(f,E,M,k,w,C)}catch(L){throw this.i.delete(M),L}return N.apiObject}catch(M){throw M.name===l.$0P.name?M:new l.$0P(`Language model '${E}' errored: ${(0,P.$pj)(M)}`,"Unknown",M)}}m(h,E){const D=[];for(const w of E)w.role===l.LanguageModelChatMessageRole.System&&(0,n.$fH)(h,"languageModelSystem"),w.content2 instanceof l.$3P&&(0,n.$fH)(h,"lmTools"),D.push(c.LanguageModelChatMessage.from(w));return D}async $acceptResponsePart(h,E){const D=this.i.get(h);D&&D.res.handleFragment(E)}async $acceptResponseDone(h,E){const D=this.i.get(h);D&&(this.i.delete(h),E?D.res.reject((0,O.$2)(E)):D.res.resolve())}async n(h,E,D,w){const C=i.$LM+E.identifier.value;if(await this.k.getSession(h,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0;if(w)return!1;try{const f=D?(0,o.localize)(10822,null,E.displayName,D):void 0;return await this.k.getSession(h,C,[],{forceNewSession:{detail:f}}),this.$updateModelAccesslist([{from:h.identifier,to:E.identifier,enabled:!0}]),!0}catch{return!1}}o(h,E){return!!E.auth&&!I.$qn.equals(E.extension,h)}async q(h){if(h.auth)for(const E of this.s)try{await this.n(E,{identifier:h.extension,displayName:""},void 0,!0)}catch(D){this.j.error("Fake Auth request failed"),this.j.error(D)}}async r(h,E,D){if(!this.g.get(h))throw l.$0P.NotFound(`Language model '${h}' is unknown.`);const C=T.Iterable.find(this.f.values(),k=>k.languageModelId===h);return C?C.provider.provideTokenCount(E,D):this.b.$countTokens(h,typeof E=="string"?E:c.LanguageModelChatMessage.from(E),D)}$updateModelAccesslist(h){const E=new Array;for(const{from:D,to:w,enabled:C}of h){const k=this.h.get(D)??new I.$rn;if(k.has(w)!==C){C?k.add(w):k.delete(w),this.h.set(D,k);const b={from:D,to:w};E.push(b),this.c.fire(b)}}}createLanguageModelAccessInformation(h){this.s.add(h);const E=this,D=A.Event.signal(A.Event.filter(this.c.event,C=>I.$qn.equals(C.from,h.identifier))),w=A.Event.signal(this.d.event);return{get onDidChange(){return A.Event.any(D,w)},canSendRequest(C){let k;e:for(const[b,M]of E.g)for(const N of M.apiObjects.values())if(N===C){k=M.metadata;break e}if(!k)return;if(!E.o(h.identifier,k))return!0;const f=E.h.get(h.identifier);if(f)return f.has(k.extension)}}}};e.$dqc=$,e.$dqc=$=t=Je([Ve(0,s.$jQ),Ve(1,a.$_j),Ve(2,r.$xpc)],$)});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[245],Le([1,0,5,8,7,35,10,4,24]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1qc=void 0,R=We(R),O=xt(O);class o{constructor(y,a,S,d){this.c=a,this.d=S,this.e=d,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(v.$JN.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,a){await this.a.$changeLanguage(y,a);const S=this.c.getDocumentData(y);if(!S)throw new Error(`document '${y.toString()}' NOT found`);return S.document}async tokenAtPosition(y,a){const S=y.version,d=R.Position.from(a),r=await this.a.$tokensAtPosition(y.uri,d),s={type:P.StandardTokenType.Other,range:y.getWordRangeAtPosition(a)??new P.$NN(a.line,a.character,a.line,a.character)};if(!r)return s;const c={range:R.Range.to(r.range),type:R.TokenType.to(r.type)};return!c.range.contains(a)||S!==y.version?s:c}createLanguageStatusItem(y,a,S){const d=this.f++,r=this.a,s=this.g,c=`${y.identifier.value}/${a}`;if(s.has(c))throw new Error(`LanguageStatusItem with id '${a}' ALREADY exists`);s.add(c);const l={selector:S,id:a,name:y.displayName??y.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let i;const n=new T.$Tc,t=()=>{if(i?.dispose(),!s.has(c)){console.warn(`LanguageStatusItem (${a}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}i=(0,A.$Gh)(()=>{n.clear(),this.a.$setLanguageStatus(d,{id:c,name:l.name??y.displayName??y.name,source:y.displayName??y.name,selector:R.DocumentSelector.from(l.selector,this.e),label:l.text,detail:l.detail??"",severity:l.severity===P.LanguageStatusSeverity.Error?O.default.Error:l.severity===P.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:l.command&&this.d.toInternal(l.command,n),accessibilityInfo:l.accessibilityInformation,busy:l.busy})},0)},g={dispose(){n.dispose(),i?.dispose(),r.$removeLanguageStatus(d),s.delete(c)},get id(){return l.id},get name(){return l.name},set name(u){l.name=u,t()},get selector(){return l.selector},set selector(u){l.selector=u,t()},get text(){return l.text},set text(u){l.text=u,t()},set text2(u){(0,p.$fH)(y,"languageStatusText"),l.text=u,t()},get text2(){return(0,p.$fH)(y,"languageStatusText"),l.text},get detail(){return l.detail},set detail(u){l.detail=u,t()},get severity(){return l.severity},set severity(u){l.severity=u,t()},get accessibilityInformation(){return l.accessibilityInformation},set accessibilityInformation(u){l.accessibilityInformation=u,t()},get command(){return l.command},set command(u){l.command=u,t()},get busy(){return l.busy},set busy(u){l.busy=u,t()}};return t(),g}}e.$1qc=o}),define(Ne[246],Le([1,0,15,2,8,7,89]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mqc=e.$Lqc=void 0,P=We(P),A=We(A);class T{constructor(y,a,S,d){this.start=y,this.deletedCount=a,this.deletedItems=S,this.items=d}asApiEvent(){return{range:new O.$dP(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class p{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,a,S){this.notebook=y,this.h=a,this.j=S,this.handle=S.handle,this.uri=R.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(P.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,a=this.h.getDocument(this.uri);if(!a)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:a.document,get mime(){return y.g},set mime(d){y.g=d},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(S)}return this.f}setOutputs(y){this.a=y.map(P.NotebookCellOutput.to)}setOutputItems(y,a,S){const d=S.map(P.NotebookCellOutputItem.to),r=this.a.find(s=>s.id===y);if(r&&(a||(r.items.length=0),r.items.push(...d),r.items.length>1&&r.items.every(s=>A.$LL(s.mime)))){const s=new Map,c=[];r.items.forEach(l=>{let i;s.has(l.mime)?i=s.get(l.mime):(i=[],s.set(l.mime,i),c.push(l.mime)),i.push(l.data)}),r.items.length=0,c.forEach(l=>{const i=A.$ML(s.get(l));r.items.push({mime:l,data:i.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$Lqc=p;class o{static{this.a=0}constructor(y,a,S,d,r){this.k=y,this.l=a,this.m=S,this.uri=d,this.handle=o.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,a={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===v.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(S){return S=y.n(S),y.b[S].apiCell},getCells(S){return(S?y.p(S):y.b).map(r=>r.apiCell)},save(){return y.q()},[Symbol.for("debug.description")](){return`NotebookDocument(${this.uri.toString()})`}};this.e=Object.freeze(a)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,a,S){this.g=y.versionId,this.h=a,this.acceptDocumentPropertiesChanged({metadata:S});const d={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},r=[];for(const c of y.rawEvents)c.kind===A.NotebookCellsChangeType.ModelChange?this.r(c.changes,!1,d.contentChanges):c.kind===A.NotebookCellsChangeType.Move?this.s(c.index,c.length,c.newIdx,d.contentChanges):c.kind===A.NotebookCellsChangeType.Output?(this.t(c.index,c.outputs),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.OutputItem?(this.u(c.index,c.outputId,c.append,c.outputItems),r.push({cell:this.b[c.index].apiCell,outputs:this.b[c.index].apiCell.outputs})):c.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(c.index,c.language),r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document})):c.kind===A.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[c.index].apiCell,document:this.b[c.index].apiCell.document}):c.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(c.index,c.mime):c.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(c.index,c.metadata),r.push({cell:this.b[c.index].apiCell,metadata:this.b[c.index].apiCell.metadata})):c.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(c.index,c.internalMetadata),r.push({cell:this.b[c.index].apiCell,executionSummary:this.b[c.index].apiCell.executionSummary}));const s=new Map;for(let c=0;c<r.length;c++){const l=r[c],i=s.get(l.cell);if(i===void 0){const n=d.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...l});s.set(l.cell,n-1)}else d.cellChanges[i]={...d.cellChanges[i],...l}}return Object.freeze(d),Object.freeze(d.cellChanges),Object.freeze(d.contentChanges),d}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let a=y.start|0,S=y.end|0;return a<0&&(a=0),S>this.b.length&&(S=this.b.length),y.with({start:a,end:S})}p(y){y=this.o(y);const a=[];for(let S=y.start;S<y.end;S++)a.push(this.b[S]);return a}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,a,S){if(this.j)return;const d=[],r=[],s=[];if(y.reverse().forEach(c=>{const i=c[2].map(g=>{const u=new p(this,this.l,g);return a||r.push(p.asModelAddData(g)),u}),n=new T(c[0],c[1],[],i),t=this.b.splice(c[0],c[1],...i);for(const g of t)s.push(g.uri),n.deletedItems.push(g.apiCell);d.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:s}),S)for(const c of d)S.push(c.asApiEvent())}s(y,a,S,d){const r=this.b.splice(y,a);this.b.splice(S,0,...r);const s=[new T(y,a,r.map(c=>c.apiCell),[]),new T(S,0,[],r)];for(const c of s)d.push(c.asApiEvent())}t(y,a){this.b[y].setOutputs(a)}u(y,a,S,d){this.b[y].setOutputItems(a,S,d)}v(y,a){const S=this.b[y];S.apiCell.document.languageId!==a&&this.m.$acceptModelLanguageChanged(S.uri,a)}w(y,a){const S=this.b[y];S.apiCell.mime=a}x(y,a){this.b[y].setMetadata(a)}y(y,a){this.b[y].setInternalMetadata(a)}getCellFromApiCell(y){return this.b.find(a=>a.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(a=>a.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$Mqc=o}),define(Ne[247],Le([1,0,6,2,8,7,39]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3qc=void 0;class T{constructor(o,I,y,a={timeout:1500,errors:3}){this.b=o,this.c=I,this.d=y,this.f=a,this.a=new v.$ne}dispose(){}getOnWillSaveNotebookDocumentEvent(o){return(I,y,a)=>{const S=function(r){I.call(y,r)};return S.extension=o,this.a.event(S,void 0,a)}}async $participateInSave(o,I,y){const a=R.URI.revive(o),S=this.c.getNotebookDocument(a);if(!S)throw new Error("Unable to resolve notebook document");const d=[];if(await this.a.fireAsync({notebook:S.apiNotebook,reason:P.TextDocumentSaveReason.to(I)},y,async(s,c)=>{const l=Date.now(),i=await await Promise.resolve(s);Date.now()-l>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!y.isCancellationRequested&&i&&(i instanceof O.$XN?d.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(d.length===0)return!0;const r={edits:[]};for(const s of d){const{edits:c}=P.WorkspaceEdit.from(s);r.edits=r.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(new A.$Ww(r))}}e.$3qc=T}),define(Ne[124],Le([1,0,13,8,7]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqc=void 0,R=We(R),P=We(P);class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(T,p,o,I,y,a){this.id=T,this.f=p,this.notebookData=o,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=I,this.c=a}get apiEditor(){if(!this.e){const T=this;this.e={get notebook(){return T.notebookData.apiNotebook},get selection(){return T.a[0]},set selection(p){this.selections=[p]},get selections(){return T.a},set selections(p){if(!Array.isArray(p)||!p.every(P.$dP.isNotebookRange))throw(0,v.$6)("selections");T.a=p,T.g(p)},get visibleRanges(){return T.b},revealRange(p,o){T.f.$tryRevealRange(T.id,R.NotebookRange.from(p),o??P.NotebookEditorRevealType.Default)},get viewColumn(){return T.c},[Symbol.for("debug.description")](){return`NotebookEditor(${this.notebook.uri.toString()})`}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(T){this.d=T}_acceptVisibleRanges(T){this.b=T}_acceptSelections(T){this.a=T}g(T){this.f.$trySetSelections(this.id,T.map(R.NotebookRange.from))}_acceptViewColumn(T){this.c=T}}e.$Nqc=O}),define(Ne[248],Le([1,0,6,11,8]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qc=void 0,P=We(P);let O=class{constructor(T,p){this.c=T,this.d=p,this.a=new v.$le,this.b=new v.$le,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(T,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,p);const o=this.d.getEditorById(T);p.visibleRanges&&o._acceptVisibleRanges(p.visibleRanges.ranges.map(P.NotebookRange.to)),p.selections&&o._acceptSelections(p.selections.selections.map(P.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:o.apiEditor,visibleRanges:o.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:o.apiEditor,selections:o.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const p in T)this.d.getEditorById(p)._acceptViewColumn(P.ViewColumn.to(T[p]))}};e.$5qc=O,e.$5qc=O=Je([Ve(0,R.$_j)],O)}),define(Ne[249],Le([1,0,6,5,124]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8qc=void 0;class O{constructor(T,p){this.c=p,this.a=new Map,this.b=T.getProxy(R.$JN.MainThreadNotebookRenderers)}$postRendererMessage(T,p,o){const I=this.c.getEditorById(T);this.a.get(p)?.fire({editor:I.apiEditor,message:o})}createRendererMessaging(T,p){if(!T.contributes?.notebookRenderer?.some(I=>I.id===p))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${p})`);return{onDidReceiveMessage:(I,y,a)=>this.d(p).event(I,y,a),postMessage:(I,y)=>{P.$Nqc.apiEditorsToExtHost.has(I)&&([I,y]=[y,I]);const a=y&&P.$Nqc.apiEditorsToExtHost.get(y);return this.b.$postMessage(a?.id,p,I)}}}d(T){let p=this.a.get(T);return p||(p=new v.$le({onDidRemoveLastListener:()=>{p?.dispose(),this.a.delete(T)}}),this.a.set(T,p),p)}}e.$8qc=O}),define(Ne[250],Le([1,0,8,76,21,71,13]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_qc=void 0;class T{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,a,S){const d=this.b++,{title:r,location:s,cancellable:c}=a,l={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(d,{location:v.ProgressLocation.from(s),title:r,source:l,cancellable:c},y.isUnderDevelopment?void 0:y.identifier.value).catch(A.$Z),this.d(d,S,!!c)}d(y,a,S){let d;S&&(d=new P.$we,this.c.set(y,d));const r=c=>{this.a.$progressEnd(c),this.c.delete(c),d?.dispose()};let s;try{s=a(new o(this.a,y),S&&d?d.token:P.CancellationToken.None)}catch(c){throw r(y),c}return s.then(c=>r(y),c=>r(y)),s}$acceptProgressCanceled(y){const a=this.c.get(y);a&&(a.cancel(),this.c.delete(y))}}e.$_qc=T;function p(I,y){return I.message=y.message,typeof y.increment=="number"&&(typeof I.increment=="number"?I.increment+=y.increment:I.increment=y.increment),I}class o extends R.$yw{constructor(y,a){super(S=>this.throttledReport(S)),this.c=y,this.d=a}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,O.$$h)(100,(I,y)=>p(I,y),()=>Object.create(null))],o.prototype,"throttledReport",null)}),define(Ne[251],Le([1,0,2,5,10,8]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$arc=void 0;class A{static{this.a=0}constructor(p,o){this.d=o,this.c=new Map,this.b=p.getProxy(R.$JN.MainThreadQuickDiff)}$provideOriginalResource(p,o,I){const y=v.URI.revive(o),a=this.c.get(p);return a?(0,P.$wh)(()=>a.provideOriginalResource(y,I)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(p,o,I,y){const a=A.a++;return this.c.set(a,o),this.b.$registerQuickDiffProvider(a,O.DocumentSelector.from(p,this.d),I,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(a),this.c.delete(a)}}}}e.$arc=A});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[252],Le([1,0,21,6,4,5,2,7,13,17,35,34,24,8]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$brc=d,I=xt(I);function d(r,s,c){const l=r.getProxy(O.$JN.MainThreadQuickOpen);class i{constructor(D,w){this.e=new Map,this.f=0,this.a=D,this.b=w}showQuickPick(D,w,C,k=v.CancellationToken.None){this.c=void 0;const f=Promise.resolve(w),b=++this.f,M=l.$show(b,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},k),N={},L=M.then(()=>N);return Promise.race([L,f]).then(W=>{if(W===N)return;const K=(0,a.$eH)(D,"quickPickItemTooltip");return f.then(q=>{const G=[];for(let Q=0;Q<q.length;Q++){const ae=q[Q];if(typeof ae=="string")G.push({label:ae,handle:Q});else if(ae.kind===T.QuickPickItemKind.Separator)G.push({type:"separator",label:ae.label});else{ae.tooltip&&!K&&console.warn(`Extension '${D.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${D.identifier.value}`);const we=ae.iconPath?$(ae.iconPath):void 0;G.push({label:ae.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:K?S.MarkdownString.fromStrict(ae.tooltip):void 0,handle:Q})}}return C&&typeof C.onDidSelectItem=="function"&&(this.c=Q=>{C.onDidSelectItem(q[Q])}),l.$setItems(b,G),M.then(Q=>{if(typeof Q=="number")return q[Q];if(Array.isArray(Q))return Q.map(ae=>q[ae])})})}).then(void 0,W=>{if(!(0,p.$3)(W))return l.$setError(b,W),Promise.reject(W)})}$onItemSelected(D){this.c?.(D)}showInput(D,w=v.CancellationToken.None){return this.d=D?.validateInput,l.$input(D,typeof this.d=="function",w).then(void 0,C=>{if(!(0,p.$3)(C))return Promise.reject(C)})}async $validateInput(D){if(!this.d)return;const w=await this.d(D);if(!w||typeof w=="string")return w;let C;switch(w.severity){case T.InputBoxValidationSeverity.Info:C=I.default.Info;break;case T.InputBoxValidationSeverity.Warning:C=I.default.Warning;break;case T.InputBoxValidationSeverity.Error:C=I.default.Error;break;default:C=w.message?I.default.Error:I.default.Ignore;break}return{content:w.message,severity:C}}async showWorkspaceFolderPick(D,w=v.CancellationToken.None){const C=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[D]);if(!C)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(f=>f.uri.toString()===C.uri.toString())}createQuickPick(D){const w=new m(D,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}createInputBox(D){const w=new h(D,()=>this.e.delete(w._id));return this.e.set(w._id,w),w}$onDidChangeValue(D,w){this.e.get(D)?._fireDidChangeValue(w)}$onDidAccept(D){this.e.get(D)?._fireDidAccept()}$onDidChangeActive(D,w){const C=this.e.get(D);C instanceof m&&C._fireDidChangeActive(w)}$onDidChangeSelection(D,w){const C=this.e.get(D);C instanceof m&&C._fireDidChangeSelection(w)}$onDidTriggerButton(D,w){this.e.get(D)?._fireDidTriggerButton(w)}$onDidTriggerItemButton(D,w,C){const k=this.e.get(D);k instanceof m&&k._fireDidTriggerItemButton(w,C)}$onDidHide(D){this.e.get(D)?._fireDidHide()}}class n{static{this.a=1}constructor(D,w){this.x=D,this.y=w,this._id=m.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.$le,this.q=new R.$le,this.r=new R.$le,this.s=new R.$le,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(D){this.b=D,this.z({title:D})}get step(){return this.c}set step(D){this.c=D,this.z({step:D})}get totalSteps(){return this.d}set totalSteps(D){this.d=D,this.z({totalSteps:D})}get enabled(){return this.g}set enabled(D){this.g=D,this.z({enabled:D})}get busy(){return this.j}set busy(D){this.j=D,this.z({busy:D})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(D){this.k=D,this.z({ignoreFocusOut:D})}get value(){return this.l}set value(D){this.l=D,this.z({value:D})}get placeholder(){return this.m}set placeholder(D){this.m=D,this.z({placeholder:D})}get buttons(){return this.n}set buttons(D){const w=(0,a.$eH)(this.x,"quickInputButtonLocation");!w&&D.some(C=>C.location)&&console.warn(`Extension '${this.x.identifier.value}' uses a button location which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`),this.n=D.slice(),this.o.clear(),D.forEach((C,k)=>{const f=C===T.$aP.Back?-1:k;this.o.set(f,C)}),this.z({buttons:D.map((C,k)=>({...$(C.iconPath),tooltip:C.tooltip,handle:C===T.$aP.Back?-1:k,location:w?C.location:void 0}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(D){this.l=D,this.q.fire(D)}_fireDidTriggerButton(D){const w=this.o.get(D);w&&this.r.fire(w)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),l.$dispose(this._id))}z(D){if(!this.v){for(const w of Object.keys(D)){const C=D[w];this.u[w]=C===void 0?null:C}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){l.$createOrUpdate(this.u),this.u={id:this._id}}}function t(E){if(E instanceof T.$KO)return{id:E.id};const D=u(E),w=g(E);return{dark:typeof D=="string"?A.URI.file(D):D,light:typeof w=="string"?A.URI.file(w):w}}function g(E){return typeof E=="object"&&"light"in E?E.light:E}function u(E){return typeof E=="object"&&"dark"in E?E.dark:E}function $(E){const D=t(E);let w,C;return"id"in D?C=y.ThemeIcon.asClassName(D):w=D,{iconPath:w,iconClass:C}}class m extends n{constructor(D,w){super(D,w),this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.$le,this.L=[],this.M=new R.$le,this.N=new R.$le,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(D){this.B=D.slice(),this.C.clear(),this.D.clear(),D.forEach((k,f)=>{this.C.set(f,k),this.D.set(k,f)});const w=(0,a.$eH)(this.x,"quickPickItemTooltip"),C=[];for(let k=0;k<D.length;k++){const f=D[k];if(f.kind===T.QuickPickItemKind.Separator)C.push({type:"separator",label:f.label});else{f.tooltip&&!w&&console.warn(`Extension '${this.x.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.x.identifier.value}`);const b=f.iconPath?$(f.iconPath):void 0;C.push({handle:k,label:f.label,iconPath:b?.iconPath,iconClass:b?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:w?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((M,N)=>({...$(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.z({items:C})}get canSelectMany(){return this.E}set canSelectMany(D){this.E=D,this.z({canSelectMany:D})}get matchOnDescription(){return this.F}set matchOnDescription(D){this.F=D,this.z({matchOnDescription:D})}get matchOnDetail(){return this.G}set matchOnDetail(D){this.G=D,this.z({matchOnDetail:D})}get sortByLabel(){return this.H}set sortByLabel(D){this.H=D,this.z({sortByLabel:D})}get keepScrollPosition(){return this.I}set keepScrollPosition(D){this.I=D,this.z({keepScrollPosition:D})}get activeItems(){return this.J}set activeItems(D){this.J=D.filter(w=>this.D.has(w)),this.z({activeItems:this.J.map(w=>this.D.get(w))})}get selectedItems(){return this.L}set selectedItems(D){this.L=D.filter(w=>this.D.has(w)),this.z({selectedItems:this.L.map(w=>this.D.get(w))})}_fireDidChangeActive(D){const w=(0,o.$Gb)(D.map(C=>this.C.get(C)));this.J=w,this.K.fire(w)}_fireDidChangeSelection(D){const w=(0,o.$Gb)(D.map(C=>this.C.get(C)));this.L=w,this.M.fire(w)}_fireDidTriggerItemButton(D,w){const C=this.C.get(D);if(!C||!C.buttons||!C.buttons.length)return;const k=C.buttons[w];k&&this.N.fire({button:k,item:C})}}class h extends n{constructor(D,w){super(D,w),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(D){this.B=D,this.z({password:D})}get prompt(){return this.C}set prompt(D){this.C=D,this.z({prompt:D})}get valueSelection(){return this.D}set valueSelection(D){this.D=D,this.z({valueSelection:D})}get validationMessage(){return this.E}set validationMessage(D){this.E=D,D?typeof D=="string"?this.z({validationMessage:D,severity:I.default.Error}):this.z({validationMessage:D.message,severity:D.severity??I.default.Error}):this.z({validationMessage:void 0,severity:I.default.Ignore})}}return new i(s,c)}}),define(Ne[253],Le([1,0,2,6,71,4,10,5,17,145,11,18,37,34,8,24,15,20]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$drc=e.$crc=void 0;function i(N){return N instanceof v.URI}function n(N,L){return N.scheme===s.Schemas.file&&L.scheme===s.Schemas.file&&c.$l?N.toString()===L.toString():N.toString().toLowerCase()===L.toString().toLowerCase()}function t(N){if(N)return typeof N.iconPath=="string"?v.URI.file(N.iconPath):v.URI.isUri(N.iconPath)||S.ThemeIcon.isThemeIcon(N.iconPath)?N.iconPath:void 0}function g(N){if(N){if(v.URI.isUri(N))return N;if(S.ThemeIcon.isThemeIcon(N))return N;{const L=N;return{light:L.light,dark:L.dark}}}else return}function u(N){const L=g(N.icon),W=N.labels?.map(K=>({title:K.title,icon:g(K.icon)}));return{...N,icon:L,labels:W}}function $(N,L){if(!N.iconPath&&!L.iconPath)return 0;if(N.iconPath){if(!L.iconPath)return 1}else return-1;const W=typeof N.iconPath=="string"?N.iconPath:v.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id,K=typeof L.iconPath=="string"?L.iconPath:v.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id;return(0,o.$Jr)(W,K)}function m(N,L){let W=0;if(N.strikeThrough!==L.strikeThrough)return N.strikeThrough?1:-1;if(N.faded!==L.faded)return N.faded?1:-1;if(N.tooltip!==L.tooltip)return(N.tooltip||"").localeCompare(L.tooltip||"");if(W=$(N,L),W!==0)return W;if(N.light&&L.light)W=$(N.light,L.light);else{if(N.light)return 1;if(L.light)return-1}if(W!==0)return W;if(N.dark&&L.dark)W=$(N.dark,L.dark);else{if(N.dark)return 1;if(L.dark)return-1}return W}function h(N,L){if(N.command!==L.command)return N.command<L.command?-1:1;if(N.title!==L.title)return N.title<L.title?-1:1;if(N.tooltip!==L.tooltip){if(N.tooltip!==void 0&&L.tooltip!==void 0)return N.tooltip<L.tooltip?-1:1;if(N.tooltip!==void 0)return 1;if(L.tooltip!==void 0)return-1}if(N.arguments===L.arguments)return 0;if(N.arguments)if(L.arguments){if(N.arguments.length!==L.arguments.length)return N.arguments.length-L.arguments.length}else return 1;else return-1;for(let W=0;W<N.arguments.length;W++){const K=N.arguments[W],q=L.arguments[W];if(K!==q&&!(i(K)&&i(q)&&n(K,q)))return K<q?-1:1}return 0}function E(N,L){let W=(0,o.$Jr)(N.resourceUri.fsPath,L.resourceUri.fsPath,!0);if(W!==0)return W;if(N.command&&L.command)W=h(N.command,L.command);else{if(N.command)return 1;if(L.command)return-1}if(W!==0)return W;if(N.decorations&&L.decorations)W=m(N.decorations,L.decorations);else{if(N.decorations)return 1;if(L.decorations)return-1}if(N.multiFileDiffEditorModifiedUri&&L.multiFileDiffEditorModifiedUri)W=(0,o.$Jr)(N.multiFileDiffEditorModifiedUri.fsPath,L.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(N.multiFileDiffEditorModifiedUri)return 1;if(L.multiFileDiffEditorModifiedUri)return-1}if(N.multiDiffEditorOriginalUri&&L.multiDiffEditorOriginalUri)W=(0,o.$Jr)(N.multiDiffEditorOriginalUri.fsPath,L.multiDiffEditorOriginalUri.fsPath,!0);else{if(N.multiDiffEditorOriginalUri)return 1;if(L.multiDiffEditorOriginalUri)return-1}return W}function D(N,L){for(let W=0;W<N.length;W++)if(N[W]!==L[W])return!1;return!0}function w(N,L){return N.command===L.command&&N.title===L.title&&N.tooltip===L.tooltip&&(N.arguments&&L.arguments?D(N.arguments,L.arguments):N.arguments===L.arguments)}function C(N,L){return(0,p.$tb)(N,L,w)}class k{#e;#t;get value(){return this.d}set value(L){L=L??"",this.#e.$setInputBoxValue(this.m,L),this.o(L)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(L){this.#e.$setInputBoxPlaceholder(this.m,L),this.f=L}get validateInput(){return(0,r.$fH)(this.k,"scmValidation"),this.g}set validateInput(L){if((0,r.$fH)(this.k,"scmValidation"),L&&typeof L!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=L,this.#e.$setValidationProviderIsEnabled(this.m,!!L)}get enabled(){return this.h}set enabled(L){L=!!L,this.h!==L&&(this.h=L,this.#e.$setInputBoxEnablement(this.m,L))}get visible(){return this.j}set visible(L){L=!!L,this.j!==L&&(this.j=L,this.#e.$setInputBoxVisibility(this.m,L))}get document(){return(0,r.$fH)(this.k,"scmTextDocument"),this.#t.getDocument(this.n)}constructor(L,W,K,q,G){this.k=L,this.m=q,this.n=G,this.d="",this.e=new R.$le,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=K}showValidationMessage(L,W){(0,r.$fH)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.m,L,W)}$onInputBoxValueChange(L){this.o(L)}o(L){this.d=L,this.e.fire(L)}}e.$crc=k;class f{static{this.d=0}get disposed(){return this.m}get id(){return this.v}get label(){return this.w}set label(L){this.w=L,this.s.$updateGroupLabel(this.u,this.handle,L)}get hideWhenEmpty(){return this.q}set hideWhenEmpty(L){this.q=L,this.s.$updateGroup(this.u,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(L){this.f=[...L],this.k.fire()}constructor(L,W,K,q,G,Q,ae){this.s=L,this.t=W,this.u=K,this.v=q,this.w=G,this.multiDiffEditorEnableViewChanges=Q,this.x=ae,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.$le,this.onDidUpdateResourceStates=this.k.event,this.m=!1,this.n=new R.$le,this.onDidDispose=this.n.event,this.o=[],this.p=[],this.q=void 0,this.handle=f.d++}getResourceState(L){return this.g.get(L)}$executeResourceCommand(L,W){const K=this.h.get(L);return K?(0,A.$wh)(()=>this.t.executeCommand(K.command,...K.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const L=[...this.f].sort(E),K=(0,p.$Cb)(this.p,L,E).map(Q=>{const ae=Q.toInsert.map(we=>{const le=this.e++;this.g.set(le,we);const _=we.resourceUri;let ce;if(we.command)if(we.command.command==="vscode.open"||we.command.command==="vscode.diff"||we.command.command==="vscode.changes"){const x=new O.$Tc;ce=this.t.converter.toInternal(we.command,x),this.j.set(le,x)}else this.h.set(le,we.command);const me=(0,r.$eH)(this.x,"scmMultiDiffEditor"),oe=me?we.multiDiffEditorOriginalUri:void 0,ke=me?we.multiFileDiffEditorModifiedUri:void 0,Te=t(we.decorations),Z=we.decorations&&t(we.decorations.light)||Te,B=we.decorations&&t(we.decorations.dark)||Te,ne=[Z,B],Ee=we.decorations&&we.decorations.tooltip||"",fe=we.decorations&&!!we.decorations.strikeThrough,be=we.decorations&&!!we.decorations.faded,he=we.contextValue||"";return{rawResource:[le,_,ne,Ee,fe,be,he,ce,oe,ke],handle:le}});return{start:Q.start,deleteCount:Q.deleteCount,toInsert:ae}}),q=K.map(({start:Q,deleteCount:ae,toInsert:we})=>[Q,ae,we.map(le=>le.rawResource)]),G=K.reverse();for(const{start:Q,deleteCount:ae,toInsert:we}of G){const le=we.map(ce=>ce.handle),_=this.o.splice(Q,ae,...le);for(const ce of _)this.g.delete(ce),this.h.delete(ce),this.j.get(ce)?.dispose(),this.j.delete(ce)}return this.p=L,q}dispose(){this.m=!0,this.n.fire()}}class b{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(L){this.g!==L&&(this.g=L,this.#e.$updateSourceControl(this.x,{count:L}))}get quickDiffProvider(){return this.h}set quickDiffProvider(L){this.h=L;let W;(0,r.$eH)(this.y,"quickDiffProvider")&&(W=L?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!L,quickDiffLabel:W})}get historyProvider(){return(0,r.$fH)(this.y,"scmHistoryProvider"),this.j}set historyProvider(L){(0,r.$fH)(this.y,"scmHistoryProvider"),this.j=L,this.k.value=new O.$Tc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!L}),L&&this.k.value.add(L.onDidChangeCurrentHistoryItemGroup(()=>{this.m=L?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.m)}))}get commitTemplate(){return this.n}set commitTemplate(L){L!==this.n&&(this.n=L,this.#e.$updateSourceControl(this.x,{commitTemplate:L}))}get acceptInputCommand(){return this.p}set acceptInputCommand(L){this.o.value=new O.$Tc,this.p=L;const W=this.z.converter.toInternal(L,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:W})}get actionButton(){return(0,r.$fH)(this.y,"scmActionButton"),this.s}set actionButton(L){(0,r.$fH)(this.y,"scmActionButton"),this.q.value=new O.$Tc,this.s=L;const W=L!==void 0?{command:this.z.converter.toInternal(L.command,this.q.value),secondaryCommands:L.secondaryCommands?.map(K=>K.map(q=>this.z.converter.toInternal(q,this.q.value))),description:L.description,enabled:L.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:W??null})}get statusBarCommands(){return this.u}set statusBarCommands(L){if(this.u&&L&&C(this.u,L))return;this.t.value=new O.$Tc,this.u=L;const W=(L||[]).map(K=>this.z.converter.toInternal(K,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:W})}get selected(){return this.v}constructor(L,W,K,q,G,Q,ae){this.y=L,this.z=q,this.A=G,this.B=Q,this.C=ae,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Vc,this.n=void 0,this.o=new O.$Vc,this.p=void 0,this.q=new O.$Vc,this.t=new O.$Vc,this.u=void 0,this.v=!1,this.w=new R.$le,this.onDidChangeSelection=this.w.event,this.x=b.d++,this.D=new Map,this.E=new Set,this.#e=K;const we=v.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${G}/scm${this.x}/input`,query:ae?`rootUri=${encodeURIComponent(ae.toString())}`:void 0});this.f=new k(L,W,this.#e,this.x,we),this.#e.$registerSourceControl(this.x,G,Q,ae,we)}createResourceGroup(L,W,K){const q=(0,r.$eH)(this.y,"scmMultiDiffEditor")&&K?.multiDiffEditorEnableViewChanges===!0,G=new f(this.#e,this.z,this.x,L,W,q,this.y),Q=R.Event.once(G.onDidDispose)(()=>this.D.delete(G));return this.D.set(G,Q),this.eventuallyAddResourceGroups(),G}eventuallyAddResourceGroups(){const L=[],W=[];for(const[K,q]of this.D){q.dispose();const G=K.onDidUpdateResourceStates(()=>{this.E.add(K),this.eventuallyUpdateResourceStates()});R.Event.once(K.onDidDispose)(()=>{this.E.delete(K),G.dispose(),this.e.delete(K.handle),this.#e.$unregisterGroup(this.x,K.handle)}),L.push([K.handle,K.id,K.label,K.features,K.multiDiffEditorEnableViewChanges]);const Q=K._takeResourceStateSnapshot();Q.length>0&&W.push([K.handle,Q]),this.e.set(K.handle,K)}this.#e.$registerGroups(this.x,L,W),this.D.clear()}eventuallyUpdateResourceStates(){const L=[];this.E.forEach(W=>{const K=W._takeResourceStateSnapshot();K.length!==0&&L.push([W.handle,K])}),L.length>0&&this.#e.$spliceResourceStates(this.x,L),this.E.clear()}getResourceGroup(L){return this.e.get(L)}setSelectionState(L){this.v=L,this.w.fire(L)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(L=>L.dispose()),this.#e.$unregisterSourceControl(this.x)}}Je([(0,P.$0h)(100)],b.prototype,"eventuallyAddResourceGroups",null),Je([(0,P.$0h)(100)],b.prototype,"eventuallyUpdateResourceStates",null);let M=class{static{l=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(L,W,K,q){this.m=W,this.n=K,this.o=q,this.g=new Map,this.h=new y.$sn,this.j=new R.$le,this.e=L.getProxy(T.$JN.MainThreadSCM),this.f=L.getProxy(T.$JN.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:G=>{if(G&&G.$mid===a.MarshalledId.ScmResource){const Q=this.g.get(G.sourceControlHandle);if(!Q)return G;const ae=Q.getResourceGroup(G.groupHandle);return ae?ae.getResourceState(G.handle):G}else if(G&&G.$mid===a.MarshalledId.ScmResourceGroup){const Q=this.g.get(G.sourceControlHandle);return Q?Q.getResourceGroup(G.groupHandle):G}else if(G&&G.$mid===a.MarshalledId.ScmProvider){const Q=this.g.get(G.handle);return Q||G}return G}})}createSourceControl(L,W,K,q){this.o.trace("ExtHostSCM#createSourceControl",L.identifier.value,W,K,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:L.identifier.value});const G=l.d++,Q=new b(L,this.n,this.e,this.m,W,K,q);this.g.set(G,Q);const ae=this.h.get(L.identifier)||[];return ae.push(Q),this.h.set(L.identifier,ae),Q}getLastInputBox(L){this.o.trace("ExtHostSCM#getLastInputBox",L.identifier.value);const W=this.h.get(L.identifier),K=W&&W[W.length-1];return K&&K.inputBox}$provideOriginalResource(L,W,K){const q=v.URI.revive(W);this.o.trace("ExtHostSCM#$provideOriginalResource",L,q.toString());const G=this.g.get(L);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$wh)(()=>G.quickDiffProvider.provideOriginalResource(q,K)).then(Q=>Q||null)}$onInputBoxValueChange(L,W){this.o.trace("ExtHostSCM#$onInputBoxValueChange",L);const K=this.g.get(L);return K&&K.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(L,W,K,q){this.o.trace("ExtHostSCM#$executeResourceCommand",L,W,K);const G=this.g.get(L);if(!G)return Promise.resolve(void 0);const Q=G.getResourceGroup(W);return Q?Q.$executeResourceCommand(K,q):Promise.resolve(void 0)}$validateInput(L,W,K){this.o.trace("ExtHostSCM#$validateInput",L);const q=this.g.get(L);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$wh)(()=>q.inputBox.validateInput(W,K)).then(G=>{if(!G)return Promise.resolve(void 0);const Q=d.MarkdownString.fromStrict(G.message);return Q?Promise.resolve([Q,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(L){return this.o.trace("ExtHostSCM#$setSelectedSourceControl",L),L!==void 0&&this.g.get(L)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=L,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(L,W,K,q){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,K,q)??void 0}async $resolveHistoryItemGroupCommonAncestor2(L,W,K){return await this.g.get(L)?.historyProvider?.resolveHistoryItemGroupCommonAncestor2(W,K)??void 0}async $provideHistoryItems(L,W,K,q){return(await this.g.get(L)?.historyProvider?.provideHistoryItems(W,K,q))?.map(ae=>u(ae))??void 0}async $provideHistoryItems2(L,W,K){return(await this.g.get(L)?.historyProvider?.provideHistoryItems2(W,K))?.map(Q=>u(Q))??void 0}async $provideHistoryItemSummary(L,W,K,q){const G=this.g.get(L)?.historyProvider;if(typeof G?.provideHistoryItemSummary!="function")return;const Q=await G.provideHistoryItemSummary(W,K,q);return Q?u(Q):void 0}async $provideHistoryItemChanges(L,W,K,q){return await this.g.get(L)?.historyProvider?.provideHistoryItemChanges(W,K,q)??void 0}};e.$drc=M,e.$drc=M=l=Je([Ve(3,I.$_j)],M)}),define(Ne[254],Le([1,0,5,8,2]),function(ve,e,v,R,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$erc=void 0;class O{static{this.a=0}constructor(T,p){this.d=p,this.c=new Map,this.b=T.getProxy(v.$JN.MainThreadShare)}async $provideShare(T,p,o){return await this.c.get(T)?.provideShare({selection:R.Range.to(p.selection),resourceUri:P.URI.revive(p.resourceUri)},o)??void 0}registerShareProvider(T,p){const o=O.a++;return this.c.set(o,p),this.b.$registerShareProvider(o,R.DocumentSelector.from(T,this.d),p.id,p.label,p.priority),{dispose:()=>{this.b.$unregisterShareProvider(o),this.c.delete(o)}}}}e.$erc=O}),define(Ne[255],Le([1,0,7,5,9,4,8,14]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hrc=e.$grc=void 0;class p{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new v.$LO("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new v.$LO("statusBarItem.warningForeground")]])}#e;#t;constructor(a,S,d,r,s,c=v.StatusBarAlignment.Left,l){if(this.i=!1,this.k="",this.q=new O.$Tc,this.#e=a,this.#t=S,s&&r){this.c=(0,v.$nO)(r.identifier,s);const i=d.get(this.c);i&&(c=i.alignLeft?v.StatusBarAlignment.Left:v.StatusBarAlignment.Right,l=i.priority,this.j=!0,this.name=i.name,this.text=i.text,this.tooltip=i.tooltip,this.command=i.command,this.accessibilityInformation=i.accessibilityInformation)}else this.c=String(p.a++);this.e=r,this.f=s,this.g=c,this.h=this.u(l)}u(a){if((0,T.$ig)(a))return a===Number.POSITIVE_INFINITY?Number.MAX_VALUE:a===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:a}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(a){this.k=a,this.v()}set name(a){this.m=a,this.v()}set tooltip(a){this.l=a,this.v()}set color(a){this.n=a,this.v()}set backgroundColor(a){a&&!p.b.has(a.id)&&(a=void 0),this.o=a,this.v()}set command(a){this.r?.fromApi!==a&&(this.p&&this.q.add(this.p),this.p=new O.$Tc,typeof a=="string"?this.r={fromApi:a,internal:this.#t.toInternal({title:"",command:a},this.p)}:a?this.r={fromApi:a,internal:this.#t.toInternal(a,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(a){this.t=a,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let a;this.e?this.f?a=`${this.e.identifier.value}.${this.f}`:a=this.e.identifier.value:a=this.f;let S;this.m?S=this.m:S=(0,P.localize)(10815,null,this.e.displayName||this.e.name);let d=this.n;this.o&&(d=p.b.get(this.o.id));const r=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,a,this.e?.identifier.value,S,this.k,r,this.r?.internal,d,this.o,this.g===v.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$grc=p;class o{constructor(a){this.b=[],this.a=a.createStatusBarEntry(void 0,"status.extensionMessage",v.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(10816,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(a){const S={message:a};return this.b.unshift(S),this.c(),new v.$LN(()=>{const d=this.b.indexOf(S);d>=0&&(this.b.splice(d,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class I{constructor(a,S){this.e=new Map,this.a=a.getProxy(R.$JN.MainThreadStatusBar),this.b=S,this.c=new o(this)}$acceptStaticEntries(a){for(const S of a)this.e.set(S.entryId,S)}createStatusBarEntry(a,S,d,r){return new p(this.a,this.b,this.e,a,S,d,r)}setStatusBarMessage(a,S){const d=this.c.setMessage(a);let r;return typeof S=="number"?r=setTimeout(()=>d.dispose(),S):typeof S<"u"&&S.then(()=>d.dispose(),()=>d.dispose()),new v.$LN(()=>{d.dispose(),clearTimeout(r)})}}e.$hrc=I}),define(Ne[125],Le([1,0,32,116,54,81,55,8,2]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=e.$xQ=e.$wQ=e.$vQ=void 0,v=We(v),T=We(T);const o=(i,n,t,g)=>{let u=n;return{enumerable:!0,configurable:!1,get(){return u},set($){if(!t(u,$)){const m=u;u=$,i.listener?.(g($,m))}}}},I=(i,n)=>i===n,y={range:(i,n)=>i===n?!0:!i||!n?!1:i.isEqual(n),label:I,description:I,sortText:I,busy:I,error:I,canResolveChildren:I,tags:(i,n)=>!(i.length!==n.length||i.some(t=>!n.find(g=>t.id===g.id)))},a=i=>n=>({op:O.TestItemEventOp.SetProp,update:i(n)}),S=(i,n)=>({range:(()=>{let t;const g=a(u=>({range:v.$Nt.lift(T.Range.from(u))}));return{enumerable:!0,configurable:!1,get(){return t},set(u){i.listener?.({op:O.TestItemEventOp.DocumentSynced}),y.range(t,u)||(t=u,i.listener?.(g(u)))}}})(),label:o(i,n,y.label,a(t=>({label:t}))),description:o(i,void 0,y.description,a(t=>({description:t}))),sortText:o(i,void 0,y.sortText,a(t=>({sortText:t}))),canResolveChildren:o(i,!1,y.canResolveChildren,t=>({op:O.TestItemEventOp.UpdateCanResolveChildren,state:t})),busy:o(i,!1,y.busy,a(t=>({busy:t}))),error:o(i,void 0,y.error,a(t=>({error:T.MarkdownString.fromStrict(t)||null}))),tags:o(i,[],y.tags,(t,g)=>({op:O.TestItemEventOp.SetTags,new:t.map(T.TestTag.from),old:g.map(T.TestTag.from)}))}),d=i=>{const n=P.$6I.fromString(i.extId),t=new s(n.controllerId,n.localId,i.label,p.URI.revive(i.uri)||void 0);return t.range=T.Range.to(i.range||void 0),t.description=i.description||void 0,t.sortText=i.sortText||void 0,t.tags=i.tags.map(g=>T.TestTag.to({id:(0,A.$_I)(g).tagId})),t},r=i=>{let n;for(const t of i.tests){const g=d(t.item);(0,R.$fQ)(g).parent=n,n=g}return n};e.$vQ=r;class s{constructor(n,t,g,u){if(t.includes(P.TestIdPathParts.Delimiter))throw new Error(`Test IDs may not include the ${JSON.stringify(t)} symbol`);const $=(0,R.$eQ)(this,n);Object.defineProperties(this,{id:{value:t,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return $.parent instanceof c?void 0:$.parent}},children:{value:(0,O.$dQ)($,R.$fQ,s),enumerable:!0,writable:!1},...S($,g)})}}e.$wQ=s;class c extends s{constructor(n,t){super(n,n,t,void 0),this._isRoot=!0}}e.$xQ=c;class l extends O.$_P{constructor(n,t,g){super({controllerId:n,getDocumentVersion:u=>u&&g.getDocument(u)?.version,getApiFor:R.$fQ,getChildren:u=>u.children,root:new c(n,t),toITestItem:T.TestItem.from})}}e.$yQ=l}),define(Ne[33],Le([1,0,14,7,8,25,5,17,11,36,32,101,2,4,3,16,125,22,39,42,69,63,66,38]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=e.$IQ=e.$HQ=e.$GQ=e.$FQ=e.$EQ=void 0,R=We(R),P=We(P);let $=class{#e;#t;#i;constructor(C,k,f){this.b=new Map,this.c=new Map,this.#e=C.getProxy(A.$JN.MainThreadCommands),this.d=k,this.#i=f,this.#t=C.getProxy(A.$JN.MainThreadTelemetry),this.converter=new m(this,b=>{const M=this.c.get(b);return M?.result===E.Void?M:void 0},k),this.f=[{processArgument(b){return(0,o.$bi)(b)}},{processArgument(b){return(0,O.$fo)(b,function(M){if(I.$Nt.isIRange(M))return P.Range.to(M);if(y.$Mt.isIPosition(M))return P.Position.to(M);if(I.$Nt.isIRange(M.range)&&a.URI.isUri(M.uri))return P.location.to(M);if(M instanceof c.$Ne)return M.buffer.buffer;if(!Array.isArray(M))return M})}}]}registerArgumentProcessor(C){this.f.push(C)}registerApiCommand(C){const k=this.registerCommand(!1,C.id,async(...f)=>{const b=C.args.map((N,L)=>{if(!N.validate(f[L]))throw new Error(`Invalid argument '${N.name}' when running '${C.id}', received: ${typeof f[L]=="object"?JSON.stringify(f[L],null,"	"):f[L]} `);return N.convert(f[L])}),M=await this.executeCommand(C.internalId,...b);return C.result.convert(M,f,this.converter)},void 0,{description:C.description,args:C.args,returns:C.result.description});return this.c.set(C.id,C),new R.$LN(()=>{k.dispose(),this.c.delete(C.id)})}registerCommand(C,k,f,b,M,N){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:f,thisArg:b,metadata:M,extension:N}),C&&this.#e.$registerCommand(k),new R.$LN(()=>{this.b.delete(k)&&C&&this.#e.$unregisterCommand(k)})}executeCommand(C,...k){return this.d.trace("ExtHostCommands#executeCommand",C),this.g(C,k,!0)}async g(C,k,f){if(this.b.has(C))return this.#e.$fireCommandActivationEvent(C),this.h(C,k,!1);{let b=!1;const M=(0,O.$fo)(k,function(N){if(N instanceof R.$MN)return P.Position.from(N);if(N instanceof R.$NN)return P.Range.from(N);if(N instanceof R.$ZN)return P.location.from(N);if(R.$dP.isNotebookRange(N))return P.NotebookRange.from(N);if(N instanceof ArrayBuffer)return b=!0,c.$Ne.wrap(new Uint8Array(N));if(N instanceof Uint8Array)return b=!0,c.$Ne.wrap(N);if(N instanceof c.$Ne)return b=!0,N;if(!Array.isArray(N))return N});try{const N=await this.#e.$executeCommand(C,b?new l.$Ww(M):M,f);return(0,o.$bi)(N)}catch(N){if(N instanceof Error&&N.message==="$executeCommand:retry")return this.g(C,k,!1);throw N}}}async h(C,k,f){const b=this.b.get(C);if(!b)throw new Error("Unknown command");const{callback:M,thisArg:N,metadata:L}=b;if(L?.args)for(let K=0;K<L.args.length;K++)try{(0,v.$vg)(k[K],L.args[K].constraint)}catch{throw new Error(`Running the contributed command: '${C}' failed. Illegal argument '${L.args[K].name}' - ${L.args[K].description}`)}const W=n.$fe.create();try{return await M.apply(N,k)}catch(K){if(C===this.converter.delegatingCommandId){const q=this.converter.getActualCommand(...k);q&&(C=q.command)}if(this.d.error(K,C,b.extension?.identifier),!f)throw K;if(b.extension?.identifier){const q=this.#i.onExtensionError(b.extension.identifier,K);this.d.trace("forwarded error to extension?",q,b.extension?.identifier)}throw new class extends Error{constructor(){super((0,i.$pj)(K)),this.id=C,this.source=b.extension?.displayName??b.extension?.name}}}finally{this.j(b,C,W.elapsed())}}j(C,k,f){C.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:C.extension.identifier.value,id:new t.$wp(k),duration:f})}$executeContributedCommand(C,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",C);const f=this.b.get(C);return f?(k=k.map(b=>this.f.reduce((M,N)=>N.processArgument(M,f.extension?.identifier),b)),this.h(C,k,!0)):Promise.reject(new Error(`Contributed command '${C}' does not exist.`))}getCommands(C=!1){return this.d.trace("ExtHostCommands#getCommands",C),this.#e.$getCommands().then(k=>(C&&(k=k.filter(f=>f[0]!=="_")),k))}$getContributedCommandMetadata(){const C=Object.create(null);for(const[k,f]of this.b){const{metadata:b}=f;b&&(C[k]=b)}return Promise.resolve(C)}};e.$EQ=$,e.$EQ=$=Je([Ve(0,r.$jQ),Ve(1,p.$_j),Ve(2,g.$DQ)],$),e.$FQ=(0,d.$Ei)("IExtHostCommands");class m{constructor(C,k,f){this.d=C,this.f=k,this.g=f,this.delegatingCommandId=`__vsc${(0,u.$1g)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(C,k){if(!C)return;const f={$ident:void 0,id:C.command,title:C.title,tooltip:C.tooltip};if(!C.command)return f;const b=this.f(C.command);if(b)f.id=b.internalId,f.arguments=b.args.map((M,N)=>M.convert(C.arguments&&C.arguments[N]));else if((0,T.$Kb)(C.arguments)){const M=`${C.command} /${++this.c}`;this.b.set(M,C),k.add((0,S.$Sc)(()=>{this.b.delete(M),this.g.trace("CommandsConverter#DISPOSE",M)})),f.$ident=M,f.id=this.delegatingCommandId,f.arguments=[M],this.g.trace("CommandsConverter#CREATE",C.command,M)}return f}fromInternal(C){return typeof C.$ident=="string"?this.b.get(C.$ident):{command:C.id,title:C.title,arguments:C.arguments}}getActualCommand(...C){return this.b.get(C[0])}h(...C){const k=this.getActualCommand(...C);return this.g.trace("CommandsConverter#EXECUTE",C[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${C[0]}`)}}e.$GQ=m;class h{static{this.Uri=new h("uri","Uri of a text document",C=>a.URI.isUri(C),C=>C)}static{this.Position=new h("position","A position in a text document",C=>R.$MN.isPosition(C),P.Position.from)}static{this.Range=new h("range","A range in a text document",C=>R.$NN.isRange(C),P.Range.from)}static{this.Selection=new h("selection","A selection in a text document",C=>R.$ON.isSelection(C),P.Selection.from)}static{this.Number=new h("number","",C=>typeof C=="number",C=>C)}static{this.String=new h("string","",C=>typeof C=="string",C=>C)}static{this.StringArray=h.Arr(h.String)}static Arr(C){return new h(`${C.name}_array`,`Array of ${C.name}, ${C.description}`,k=>Array.isArray(k)&&k.every(f=>C.validate(f)),k=>k.map(f=>C.convert(f)))}static{this.CallHierarchyItem=new h("item","A call hierarchy item",C=>C instanceof R.$_N,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new h("item","A type hierarchy item",C=>C instanceof R.$yP,P.TypeHierarchyItem.from)}static{this.TestItem=new h("testItem","A VS Code TestItem",C=>C instanceof s.$wQ,P.TestItem.from)}constructor(C,k,f,b){this.name=C,this.description=k,this.validate=f,this.convert=b}optional(){return new h(this.name,`(optional) ${this.description}`,C=>C==null||this.validate(C),C=>C===void 0?void 0:C===null?null:this.convert(C))}with(C,k){return new h(C??this.name,k??this.description,this.validate,this.convert)}}e.$HQ=h;class E{static{this.Void=new E("no result",C=>C)}constructor(C,k){this.description=C,this.convert=k}}e.$IQ=E;class D{constructor(C,k,f,b,M){this.id=C,this.internalId=k,this.description=f,this.args=b,this.result=M}}e.$JQ=D}),define(Ne[256],Le([1,0,17,15,2,93,103,31,33,8,7]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wpc=void 0,O=We(O),o=We(o),I=We(I);const y=[new p.$JQ("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of DocumentHighlight-instances.",S(o.DocumentHighlight.to))),new p.$JQ("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.$HQ.Uri],new p.$IQ("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,v.$Jb)(r))return;class c extends I.$7N{static to(i){const n=new c(i.name,o.SymbolKind.to(i.kind),i.containerName||"",new I.$ZN(s[0],o.Range.to(i.range)));return n.detail=i.detail,n.range=n.location.range,n.selectionRange=o.Range.to(i.selectionRange),n.children=i.children?i.children.map(c.to):[],n}}return r.map(c.to)})),new p.$JQ("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.$HQ.Uri,new p.$HQ("options","Formatting options",r=>!0,r=>r)],new p.$IQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new p.$JQ("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.$HQ.Uri,p.$HQ.Range,new p.$HQ("options","Formatting options",r=>!0,r=>r)],new p.$IQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new p.$JQ("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.$HQ.Uri,p.$HQ.Position,new p.$HQ("ch","Trigger character",r=>typeof r=="string",r=>r),new p.$HQ("options","Formatting options",r=>!0,r=>r)],new p.$IQ("A promise that resolves to an array of TextEdits.",S(o.TextEdit.to))),new p.$JQ("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$JQ("vscode.experimental.executeDefinitionProvider_recursive","_executeDefinitionProvider_recursive","Execute all definition providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$JQ("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$JQ("vscode.experimental.executeTypeDefinitionProvider_recursive","_executeTypeDefinitionProvider_recursive","Execute all type definition providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$JQ("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$JQ("vscode.experimental.executeDeclarationProvider_recursive","_executeDeclarationProvider_recursive","Execute all declaration providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$JQ("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$JQ("vscode.experimental.executeImplementationProvider_recursive","_executeImplementationProvider_recursive","Execute all implementation providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location or LocationLink instances.",d)),new p.$JQ("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location-instances.",S(o.location.to))),new p.$JQ("vscode.experimental.executeReferenceProvider","_executeReferenceProvider_recursive","Execute all reference providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Location-instances.",S(o.location.to))),new p.$JQ("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Hover-instances.",S(o.Hover.to))),new p.$JQ("vscode.experimental.executeHoverProvider_recursive","_executeHoverProvider_recursive","Execute all hover providers.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of Hover-instances.",S(o.Hover.to))),new p.$JQ("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.$HQ.Uri,new p.$HQ("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>I.$MN.isPosition(s)),r=>r.map(o.Position.from))],new p.$IQ("A promise that resolves to an array of ranges.",r=>r.map(s=>{let c;for(const l of s.reverse())c=new I.$$N(o.Range.to(l),c);return c}))),new p.$JQ("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.$HQ.String.with("query","Search string")],new p.$IQ("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(o.WorkspaceSymbol.to))),new p.$JQ("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(o.CallHierarchyItem.to))),new p.$JQ("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.$HQ.CallHierarchyItem],new p.$IQ("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(o.CallHierarchyIncomingCall.to))),new p.$JQ("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.$HQ.CallHierarchyItem],new p.$IQ("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(o.CallHierarchyOutgoingCall.to))),new p.$JQ("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:o.Range.to(r.range),placeholder:r.text}})),new p.$JQ("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.$HQ.Uri,p.$HQ.Position,p.$HQ.String.with("newName","The new symbol name")],new p.$IQ("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return o.WorkspaceEdit.to(r)}})),new p.$JQ("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.$HQ.Uri,p.$HQ.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.$IQ("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(o.DocumentLink.to))),new p.$JQ("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.$HQ.Uri],new p.$IQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$7O(r.tokenTypes,r.tokenModifiers)})),new p.$JQ("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.$HQ.Uri],new p.$IQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$Xdb)(r);if(s.type==="full")return new I.$9O(s.data,void 0)})),new p.$JQ("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.$HQ.Uri,p.$HQ.Range.optional()],new p.$IQ("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$7O(r.tokenTypes,r.tokenModifiers)})),new p.$JQ("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.$HQ.Uri,p.$HQ.Range],new p.$IQ("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$Xdb)(r);if(s.type==="full")return new I.$9O(s.data,void 0)})),new p.$JQ("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.$HQ.Uri,p.$HQ.Position,p.$HQ.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.$HQ.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.$IQ("A promise that resolves to a CompletionList-instance.",(r,s,c)=>{if(!r)return new I.$kO([]);const l=r.suggestions.map(i=>o.CompletionItem.to(i,c));return new I.$kO(l,r.incomplete)})),new p.$JQ("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.$HQ.Uri,p.$HQ.Position,p.$HQ.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.$IQ("A promise that resolves to SignatureHelp.",r=>{if(r)return o.SignatureHelp.to(r)})),new p.$JQ("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.$HQ.Uri,p.$HQ.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.$IQ("A promise that resolves to an array of CodeLens-instances.",(r,s,c)=>S(l=>new I.$cO(o.Range.to(l.range),l.command&&c.fromInternal(l.command)))(r))),new p.$JQ("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.$HQ.Uri,new p.$HQ("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$NN.isRange(r),r=>I.$ON.isSelection(r)?o.Selection.from(r):o.Range.from(r)),p.$HQ.String.with("kind","Code action kind to return code actions for").optional(),p.$HQ.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.$IQ("A promise that resolves to an array of Command-instances.",(r,s,c)=>S(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(l.command)}else{const i=new I.$9N(l.title,l.kind?new I.$0N(l.kind):void 0);return l.edit&&(i.edit=o.WorkspaceEdit.to(l.edit)),l.command&&(i.command=c.fromInternal(l.command)),i.isPreferred=l.isPreferred,i}})(r))),new p.$JQ("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.$HQ.Uri],new p.$IQ("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new I.$qO(o.Range.to(s.range),o.Color.to(s.color))):[])),new p.$JQ("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.$HQ("color","The color to show and insert",r=>r instanceof I.$pO,o.Color.from),new p.$HQ("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:o.Range.from(r.range)}))],new p.$IQ("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(o.ColorPresentation.to):[])),new p.$JQ("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.$HQ.Uri,p.$HQ.Range],new p.$IQ("A promise that resolves to an array of Inlay objects",(r,s,c)=>r.map(o.InlayHint.to.bind(void 0,c)))),new p.$JQ("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.$HQ.Uri],new p.$IQ("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(o.FoldingRange.to)})),new p.$JQ("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.$IQ("A promise that resolves to an array of NotebookContentProvider static info objects.",S(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>o.NotebookExclusiveDocumentPattern.to(s))})))),new p.$JQ("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.$HQ.Uri,p.$HQ.Range,new p.$HQ("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof I.$NN,r=>o.InlineValueContext.from(r))],new p.$IQ("A promise that resolves to an array of InlineValue objects",r=>r.map(o.InlineValue.to))),new p.$JQ("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.$HQ("uriOrString","Uri-instance or string (only http/https)",r=>P.URI.isUri(r)||typeof r=="string"&&(0,R.$Og)(r,R.Schemas.http,R.Schemas.https),r=>r),new p.$HQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[o.ViewColumn.from(r),void 0]:[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)])).optional(),p.$HQ.String.with("label","").optional()],p.$IQ.Void),new p.$JQ("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.$HQ.Uri.with("resource","Resource to open"),p.$HQ.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new p.$HQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[o.ViewColumn.from(r),void 0]:[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)])).optional()],p.$IQ.Void),new p.$JQ("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.$HQ.Uri.with("left","Left-hand side resource of the diff editor"),p.$HQ.Uri.with("right","Right-hand side resource of the diff editor"),p.$HQ.String.with("title","Human readable title for the diff editor").optional(),new p.$HQ("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[o.ViewColumn.from(r.viewColumn),o.TextEditorOpenOptions.from(r)]).optional()],p.$IQ.Void),new p.$JQ("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[p.$HQ.String.with("title","Human readable title for the changes editor"),new p.$HQ("resourceList","List of resources to compare",r=>{for(const s of r){if(s.length!==3)return!1;const[c,l,i]=s;if(!P.URI.isUri(c)||!P.URI.isUri(l)&&l!==void 0&&l!==null||!P.URI.isUri(i)&&i!==void 0&&i!==null)return!1}return!0},r=>r)],p.$IQ.Void),new p.$JQ("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.$HQ.Uri,p.$HQ.Position],new p.$IQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.$JQ("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.$HQ.TypeHierarchyItem],new p.$IQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.$JQ("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.$HQ.TypeHierarchyItem],new p.$IQ("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(o.TypeHierarchyItem.to))),new p.$JQ("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.$HQ.TestItem],p.$IQ.Void),new p.$JQ("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.$HQ.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.$IQ.Void),new p.$JQ("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.$HQ.String.with("name","The context key name"),new p.$HQ("value","The context key value",()=>!0,r=>r)],p.$IQ.Void),new p.$JQ("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[p.$HQ.Uri,p.$HQ.StringArray,new p.$HQ("MappedEditsContext","Mapped Edits Context",r=>o.MappedEditsContext.is(r),r=>o.MappedEditsContext.from(r))],new p.$IQ("A promise that resolves to a workspace edit or null",r=>r?o.WorkspaceEdit.to(r):null)),new p.$JQ("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new p.$HQ("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?o.Range.from(r.initialRange):void 0,initialSelection:I.$ON.isSelection(r.initialSelection)?o.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?o.Position.from(r.position):void 0}})],p.$IQ.Void)];class a{static register(s){y.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",T.$Dj)}}e.$wpc=a;function S(r){return s=>{if(Array.isArray(s))return s.map(r)}}function d(r){if(!Array.isArray(r))return;const s=[];for(const c of r)O.$Ku(c)?s.push(o.DefinitionLink.to(c)):s.push(o.location.to(c));return s}}),define(Ne[257],Le([1,0,2,33]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xqc=void 0;class P{constructor(A,T,p,o,I){this.a=T,this.b=p,this.c=o;const y=new R.$JQ("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.$HQ("showOptions","Show Options",a=>!0,a=>a),new R.$HQ("resource","Interactive resource Uri",a=>!0,a=>a),new R.$HQ("controllerId","Notebook controller Id",a=>!0,a=>a),new R.$HQ("title","Interactive editor title",a=>!0,a=>a)],new R.$IQ("Notebook and input URI",a=>{if(I.debug("[ExtHostInteractive] open iw with notebook editor id",a.notebookEditorId),a.notebookEditorId!==void 0){const S=this.a.getEditorById(a.notebookEditorId);return I.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri),notebookEditor:S.apiEditor}}return I.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",a.notebookUri,a.inputUri),{notebookUri:v.URI.revive(a.notebookUri),inputUri:v.URI.revive(a.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(A,T,p,o){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:p,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,T){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Xqc=P}),define(Ne[258],Le([1,0,17,10,21,6,4,28,2,18,11,5,33,8,7,82,197,24,39,198]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6qc=void 0,e.$7qc=h,S=We(S);let n=class{constructor(D,w,C,k,f){this.m=w,this.n=C,this.o=k,this.q=f,this.b=new T.$Ac,this.c=new T.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$le,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=D.getProxy(y.$JN.MainThreadNotebookKernels);const b=new a.$JQ("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new a.$HQ("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const L=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:L}}else if(N&&"notebookEditor"in N){const L=this.n.getIdByEditor(N.notebookEditor);if(L===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:L}}return N})],a.$IQ.Void),M=new a.$JQ("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[a.$HQ.Uri],new a.$IQ("A promise that resolves to an array of variables",(N,L)=>N.map(W=>({variable:{name:W.name,value:W.value,expression:W.expression,type:W.type,language:W.language},hasNamedChildren:W.hasNamedChildren,indexedChildrenCount:W.indexedChildrenCount}))));this.o.registerApiCommand(b),this.o.registerApiCommand(M)}createNotebookController(D,w,C,k,f,b){for(const oe of this.j.values())if(oe.controller.id===w&&o.$qn.equals(D.identifier,oe.extensionId))throw new Error(`notebook controller with id '${w}' ALREADY exist`);const M=this.k++,N=this;this.q.trace(`NotebookController[${M}], CREATED by ${D.identifier.value}, ${w}`);const L=()=>console.warn(`NO execute handler from notebook controller '${G.id}' of extension: '${D.identifier}'`);let W=!1;const K=new O.$le,q=new O.$le,G={id:h(D.identifier,w),notebookType:C,extensionId:D.identifier,extensionLocation:D.extensionLocation,label:k||D.identifier.value,preloads:b?b.map(S.NotebookRendererScript.from):[]};let Q=f??L,ae,we;this.a.$addKernel(M,G).catch(oe=>{console.log(oe),W=!0});let le=0;const _=()=>{if(W)return;const oe=++le;Promise.resolve().then(()=>{oe===le&&this.a.$updateKernel(M,G)})},ce=new T.$Ac,me={get id(){return w},get notebookType(){return G.notebookType},onDidChangeSelectedNotebooks:K.event,get label(){return G.label},set label(oe){G.label=oe??D.displayName??D.name,_()},get detail(){return G.detail??""},set detail(oe){G.detail=oe,_()},get description(){return G.description??""},set description(oe){G.description=oe,_()},get supportedLanguages(){return G.supportedLanguages},set supportedLanguages(oe){G.supportedLanguages=oe,_()},get supportsExecutionOrder(){return G.supportsExecutionOrder??!1},set supportsExecutionOrder(oe){G.supportsExecutionOrder=oe,_()},get rendererScripts(){return G.preloads?G.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return Q},set executeHandler(oe){Q=oe??L},get interruptHandler(){return ae},set interruptHandler(oe){ae=oe,G.supportsInterrupt=!!oe,_()},set variableProvider(oe){(0,c.$fH)(D,"notebookVariableProvider"),we=oe,G.hasVariableProvider=!!oe,oe?.onDidChangeVariables(ke=>N.a.$variablesUpdated(ke.uri)),_()},get variableProvider(){return we},createNotebookCellExecution(oe){if(W)throw new Error("notebook controller is DISPOSED");if(!ce.has(oe.notebook.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.notebook.uri.toString()}`);return N._createNotebookCellExecution(oe,h(D.identifier,this.id))},createNotebookExecution(oe){if((0,c.$fH)(D,"notebookExecution"),W)throw new Error("notebook controller is DISPOSED");if(!ce.has(oe.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${oe.uri.toString()}`);return N._createNotebookExecution(oe,h(D.identifier,this.id))},dispose:()=>{W||(this.q.trace(`NotebookController[${M}], DISPOSED`),W=!0,this.j.delete(M),K.dispose(),q.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(oe,ke){ke===d.NotebookControllerAffinity2.Hidden&&(0,c.$fH)(D,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(M,oe.uri,ke)},onDidReceiveMessage:q.event,postMessage(oe,ke){return(0,c.$fH)(D,"notebookMessaging"),N.a.$postMessage(M,ke&&N.n.getIdByEditor(ke),oe)},asWebviewUri(oe){return(0,c.$fH)(D,"notebookMessaging"),(0,r.$EDb)(oe,N.m.remote)}};return this.j.set(M,{extensionId:D.identifier,controller:me,onDidReceiveMessage:q,onDidChangeSelection:K,associatedNotebooks:ce}),me}getIdByController(D){for(const[w,C]of this.j)if(C.controller===D)return h(C.extensionId,D.id);return null}createNotebookControllerDetectionTask(D,w){const C=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${C}], CREATED by ${D.identifier.value}`),this.a.$addKernelDetectionTask(C,w);const f={dispose:()=>{this.f.delete(C),k.a.$removeKernelDetectionTask(C)}};return this.f.set(C,f),f}registerKernelSourceActionProvider(D,w,C){const k=this.i++,f=typeof C.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,b=this;this.h.set(k,C),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${D.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,w);let M;return f!==void 0&&(M=C.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.h.delete(k),b.a.$removeKernelSourceActionProvider(k,k),M?.dispose()}}}async $provideKernelSourceActions(D,w){const C=this.h.get(D);if(C){const k=new A.$Tc;return(await C.provideNotebookKernelSourceActions(w)??[]).map(b=>S.NotebookKernelSourceAction.from(b,this.o.converter,k))}return[]}$acceptNotebookAssociation(D,w,C){const k=this.j.get(D);if(k){const f=this.n.getNotebookDocument(p.URI.revive(w));C?k.associatedNotebooks.set(f.uri,!0):k.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${D}] ASSOCIATE notebook`,f.uri.toString(),C),k.onDidChangeSelection.fire({selected:C,notebook:f.apiNotebook})}}async $executeCells(D,w,C){const k=this.j.get(D);if(!k)return;const f=this.n.getNotebookDocument(p.URI.revive(w)),b=[];for(const M of C){const N=f.getCell(M);N&&b.push(N.apiCell)}try{this.q.trace(`NotebookController[${D}] EXECUTE cells`,f.uri.toString(),b.length),await k.controller.executeHandler.call(k.controller,b,f.apiNotebook,k.controller)}catch(M){this.q.error(`NotebookController[${D}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(D,w,C){const k=this.j.get(D);if(!k)return;const f=this.n.getNotebookDocument(p.URI.revive(w));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,f.apiNotebook);else for(const b of C){const M=f.getCell(b);M&&this.b.get(M.uri)?.cancel()}if(k.controller.interruptHandler){const b=this.c.get(f.uri);this.c.delete(f.uri),C.length&&Array.isArray(b)&&b.length&&b.forEach(M=>M.dispose())}}async $provideVariables(D,w,C,k,f,b,M){const N=this.j.get(D);if(!N)return;const L=this.n.getNotebookDocument(p.URI.revive(C)),W=N.controller.variableProvider;if(!W)return;let K;if(k!==void 0){if(K=this.s[k],!K)return}else this.s={};const q=f==="named"?d.NotebookVariablesRequestKind.Named:d.NotebookVariablesRequestKind.Indexed,G=W.provideVariables(L.apiNotebook,K,q,b,M);let Q=0;for await(const ae of G){if(M.isCancellationRequested)return;const we={id:this.r++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,interfaces:ae.variable.interfaces,language:ae.variable.language,expression:ae.variable.expression,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:N.extensionId.value};if(this.s[we.id]=ae.variable,this.a.$receiveVariable(w,we),Q++>=i.$YK)return}}$acceptKernelMessageFromRenderer(D,w,C){const k=this.j.get(D);if(!k)return;const f=this.n.getEditorById(w);k.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:C}))}$cellExecutionChanged(D,w,C){const f=this.n.getNotebookDocument(p.URI.revive(D)).getCell(w);if(f){const b=C?S.NotebookCellExecutionState.to(C):d.NotebookCellExecutionState.Idle;b!==void 0&&this.l.fire({cell:f.apiCell,state:b})}}_createNotebookCellExecution(D,w){if(D.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(D.notebook.uri).getCellFromApiCell(D);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const f=new g(w,k,this.a);this.b.set(k.uri,f);const b=f.onDidChangeState(()=>{f.state===t.Resolved&&(f.dispose(),b.dispose(),this.b.delete(k.uri))});return f.asApiObject()}_createNotebookExecution(D,w){const C=this.n.getNotebookDocument(D.uri),k=D.getCells().find(M=>{const N=C.getCellFromApiCell(M);return N&&this.b.has(N.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(C.uri))throw new Error(`duplicate notebook execution for ${C.uri}`);const f=new $(w,C,this.a),b=f.onDidChangeState(()=>{f.state===u.Resolved&&(f.dispose(),b.dispose(),this.c.delete(C.uri))});return this.c.set(C.uri,[f,b]),f.asApiObject()}};e.$6qc=n,e.$6qc=n=Je([Ve(4,I.$_j)],n);var t;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(t||(t={}));class g extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(D,w,C){super(),this.m=w,this.n=C,this.b=g.a++,this.c=new O.$le,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new P.$we),this.h=new m(10,k=>this.s(k)),this.j=w.internalMetadata.executionOrder,this.n.$createExecution(this.b,D,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(D){await this.h.addItem(D)}async s(D){const w=Array.isArray(D)?D:[D];return this.n.$updateExecution(this.b,new l.$Ww(w))}t(){if(this.f===t.Init)throw new Error("Must call start before modifying cell output");if(this.f===t.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(D){let w=this.m;if(D&&(w=this.m.notebook.getCellFromApiCell(D)),!w)throw new Error("INVALID cell");return w.handle}y(D){return D.map(w=>{const C=d.$hP.ensureUniqueMimeTypes(w.items,!0);return C===w.items?S.NotebookCellOutput.from(w):S.NotebookCellOutput.from({items:C,id:w.id,metadata:w.metadata})})}async z(D,w,C){const k=this.w(w),f=this.y((0,v.$1b)(D));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:k,append:C,outputs:f})}async C(D,w,C){return D=d.$hP.ensureUniqueMimeTypes((0,v.$1b)(D),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:D.map(S.NotebookCellOutputItem.from),outputId:w.id,append:C})}asApiObject(){const D=this;return Object.freeze({get token(){return D.g.token},get cell(){return D.m.apiCell},get executionOrder(){return D.j},set executionOrder(C){D.j=C,D.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:D.j}])},start(C){if(D.f===t.Resolved||D.f===t.Started)throw new Error("Cannot call start again");D.f=t.Started,D.c.fire(),D.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:C})},end(C,k,f){if(D.f===t.Resolved)throw new Error("Cannot call resolve twice");D.f=t.Resolved,D.c.fire(),D.h.flush();const b=f?{message:f.message,stack:f.stack,location:f?.location?{startLineNumber:f.location.start.line,startColumn:f.location.start.character,endLineNumber:f.location.end.line,endColumn:f.location.end.character}:void 0,uri:f.uri}:void 0;D.n.$completeExecution(D.b,new l.$Ww({runEndTime:k,lastRunSuccess:C,error:b}))},clearOutput(C){return D.t(),D.z([],C,!1)},appendOutput(C,k){return D.t(),D.z(C,k,!0)},replaceOutput(C,k){return D.t(),D.z(C,k,!1)},appendOutputItems(C,k){return D.t(),D.C(C,k,!0)},replaceOutputItems(C,k){return D.t(),D.C(C,k,!1)}})}}var u;(function(E){E[E.Init=0]="Init",E[E.Started=1]="Started",E[E.Resolved=2]="Resolved"})(u||(u={}));class $ extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(D,w,C){super(),this.h=w,this.j=C,this.b=$.a++,this.c=new O.$le,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new P.$we),this.j.$createNotebookExecution(this.b,D,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===u.Resolved||this.f===u.Started)throw new Error("Cannot call start again");this.f=u.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===u.Resolved)throw new Error("Cannot call resolve twice");this.f=u.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class m{constructor(D,w){this.f=D,this.g=w,this.a=[],this.b=Date.now()}addItem(D){return this.a.push(D),this.c||(this.c=new R.$2h,this.b=Date.now(),(0,R.$Fh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const D=this.c;this.c=void 0;const w=this.a;return this.a=[],this.g(w).finally(()=>D.complete())}}function h(E,D){return`${E.value}/${D}`}}),define(Ne[56],Le([1,0,6,5,3,2,16,4,7,9,13,179,21,38,180,181,34,10,8,33,37]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bqc=e.$aqc=e.$_pc=e.$$pc=void 0,e.$$pc=(0,P.$Ei)("IExtHostTerminalService");class t extends T.$Uc{constructor(f,b,M,N){super(),this.u=f,this._id=b,this.w=M,this.y=N,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new v.$le),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const L=this;this.value={get name(){return L.y||""},get processId(){return L.b},get creationOptions(){return L.w},get exitStatus(){return L.j},get state(){return L.m},get selection(){return L.n},get shellIntegration(){return L.shellIntegration},sendText(W,K=!0){L.C(),L.u.$sendText(L._id,W,K)},show(W){L.C(),L.u.$show(L._id,W)},hide(){L.C(),L.u.$hide(L._id)},dispose(){L.a||(L.a=!0,L.u.$dispose(L._id))},get dimensions(){if(!(L.f===void 0||L.h===void 0))return{columns:L.f,rows:L.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,b){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??b?.cwd??void 0,env:f.env??void 0,icon:D(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:b?.forceShellIntegration??void 0,isFeatureTerminal:b?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:b?.useShellEnvironment??void 0,location:b?.location||this.z(f.location,b?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,b,M,N,L){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:N,color:s.ThemeColor.isThemeColor(L)?L.id:void 0,location:b?.location||this.z(f,M),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,b){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&b?{parentTerminal:b}:"viewColumn"in f?{viewColumn:l.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,b){this.j=Object.freeze({code:f,reason:b})}setDimensions(f,b){return f===this.f&&b===this.h||f===0||b===0?!1:(this.f=f,this.h=b,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(b=>{b!==f&&(this.b=Promise.resolve(f))})}}e.$_pc=t;class g{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new v.$le,this.onProcessData=this.a.event,this.b=new v.$le,this.d=new v.$le,this.onDidChangeProperty=this.d.event,this.f=new v.$le,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,b){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${b}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,b){this.g.setDimensions?.({columns:f,rows:b})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(b=>this.a.fire(b)),this.g.onDidClose?.((b=void 0)=>{this.f.fire(b===void 0?void 0:b)}),this.g.onDidOverrideDimensions?.(b=>{b&&this.d.fire({type:d.ProcessPropertyType.OverrideDimensions,value:{cols:b.columns,rows:b.rows}})}),this.g.onDidChangeName?.(b=>{this.d.fire({type:d.ProcessPropertyType.Title,value:b})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,$=class extends T.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,b,M){super(),this.Q=b,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new T.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new v.$le,this.onDidCloseTerminal=this.H.event,this.I=new v.$le,this.onDidOpenTerminal=this.I.event,this.J=new v.$le,this.onDidChangeActiveTerminal=this.J.event,this.L=new v.$le,this.onDidChangeTerminalDimensions=this.L.event,this.M=new v.$le,this.onDidChangeTerminalState=this.M.event,this.N=new v.$le,this.onDidChangeShell=this.N.event,this.O=new v.$le({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new v.$le({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=M.getProxy(R.$JN.MainThreadTerminalService),this.y=new r.$Uxb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:N=>{const L=W=>{const K=W;return this.getTerminalById(K.instanceId)?.value};switch(N?.$mid){case n.MarshalledId.TerminalContext:return L(N);default:{if(Array.isArray(N))for(let W=0;W<N.length&&N[W].$mid===n.MarshalledId.TerminalContext;W++)N[W]=L(N[W]);return N}}}}),this.B({dispose:()=>{for(const[N,L]of this.g)L.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,b){const M=new t(this.a,(0,S.$1g)(),f,f.name),N=new g(f.pty);return M.createExtensionTerminal(f.location,b,this.R(f,b).resolvedExtHostIdentifier,D(f.iconPath),w(f.color)).then(L=>{const W=this.S(L,N);this.h[L]=W}),this.f.push(M),M.value}R(f,b){if(b=b||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const M=f.location.parentTerminal;if(M){const N=this.f.find(L=>L.value===M);N&&(b.resolvedExtHostIdentifier=N._id)}}else f.location&&typeof f.location!="object"?b.location=f.location:b.location&&typeof b.location=="object"&&"splitActiveTerminal"in b.location&&(b.location={splitActiveTerminal:!0});return b}attachPtyToTerminal(f,b){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const N=new g(b),L=this.S(f,N);this.h[f]=L}async $acceptActiveTerminalChanged(f){const b=this.b;if(f===null){this.b=void 0,b!==this.b&&this.J.fire(this.b);return}const M=this.getTerminalById(f);M&&(this.b=M,b!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,b){const M=this.getTerminalById(f);M&&this.O.fire({terminal:M.value,data:b})}async $acceptTerminalDimensions(f,b,M){const N=this.getTerminalById(f);N&&N.setDimensions(b,M)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(f,b){const M=this.getTerminalById(f);M&&this.P.fire({terminal:M.value,...b})}async $acceptTerminalMaximumDimensions(f,b,M){this.g.get(f)?.resize(b,M)}async $acceptTerminalTitleChange(f,b){const M=this.getTerminalById(f);M&&(M.name=b)}async $acceptTerminalClosed(f,b,M){const N=this.X(this.f,f);if(N!==null){const L=this.f.splice(N,1)[0];L.setExitStatus(b,M),this.H.fire(L.value)}}$acceptTerminalOpened(f,b,M,N){if(b){const K=this.X(this.f,b);if(K!==null){this.f[K]._id=f,this.I.fire(this.terminals[K]),this.f[K].isOpen=!0;return}}const L={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:O.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},W=new t(this.a,f,L,M);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,b){this.getTerminalById(f)?._setProcessId(b)}async $startExtensionTerminal(f,b){const M=this.getTerminalById(f);if(!M)return{message:(0,o.localize)(10813,null,f)};M.isOpen||await new Promise(L=>{const W=this.onDidOpenTerminal(async K=>{K===M.value&&(W.dispose(),L())})});const N=this.g.get(f);N?N.startSendingEvents(b):this.j[f]={initialDimensions:b}}S(f,b){const M=new T.$Tc;M.add(b.onProcessReady(L=>this.a.$sendProcessReady(f,L.pid,L.cwd,L.windowsPty))),M.add(b.onDidChangeProperty(L=>this.a.$sendProcessProperty(f,L))),this.y.startBuffering(f,b.onProcessData),M.add(b.onProcessExit(L=>this.U(f,L))),this.g.set(f,b);const N=this.j[f];return N&&b instanceof g&&(b.startSendingEvents(N.initialDimensions),delete this.j[f]),M}$acceptProcessAckDataEvent(f,b){this.g.get(f)?.acknowledgeDataEvent(b)}$acceptProcessInput(f,b){this.g.get(f)?.input(b)}$acceptTerminalInteraction(f){const b=this.getTerminalById(f);b?.setInteractedWith()&&this.M.fire(b.value)}$acceptTerminalSelection(f,b){this.getTerminalById(f)?.setSelection(b)}$acceptProcessResize(f,b,M){try{this.g.get(f)?.resize(b,M)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(f,b){this.g.get(f)?.shutdown(b)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(b=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.InitialCwd,value:b}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(b=>this.a.$sendProcessProperty(f,{type:d.ProcessPropertyType.Cwd,value:b}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new p.$LN(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,b,M){if(this.C.has(b))throw new Error(`Terminal profile provider "${b}" already registered`);return this.C.set(b,M),this.a.$registerProfileProvider(b,f.identifier.value),new p.$LN(()=>{this.C.delete(b),this.a.$unregisterProfileProvider(b)})}registerTerminalQuickFixProvider(f,b,M){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,M),this.a.$registerQuickFixProvider(f,b),new p.$LN(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,b){const M=new a.$we().token;if(M.isCancellationRequested)return;const N=this.D.get(f);if(!N)return;const L=await N.provideTerminalQuickFixes(b,M);if(L===null||Array.isArray(L)&&L.length===0)return;const W=new T.$Tc;if(this.w.value=W,!Array.isArray(L))return L?l.TerminalQuickFix.from(L,this.Q.converter,W):void 0;const K=[];for(const q of L){const G=l.TerminalQuickFix.from(q,this.Q.converter,W);G&&K.push(G)}return K}async $createContributedProfileTerminal(f,b){const M=new a.$we().token;let N=await this.C.get(f)?.provideTerminalProfile(M);if(!M.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,b);return}this.createTerminalFromOptions(N.options,b)}}async $provideLinks(f,b){const M=this.getTerminalById(f);if(!M)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const L=new a.$we;this.G.set(f,L);const W=[],K={terminal:M.value,line:b},q=[];for(const ae of this.z)q.push(c.Promises.withAsyncBody(async we=>{L.token.onCancellationRequested(()=>we({provider:ae,links:[]}));const le=await ae.provideTerminalLinks(K,L.token)||[];L.token.isCancellationRequested||we({provider:ae,links:le})}));const G=await Promise.all(q);if(L.token.isCancellationRequested)return[];const Q=new Map;for(const ae of G)ae&&ae.links.length>0&&W.push(...ae.links.map(we=>{const le={id:u++,startIndex:we.startIndex,length:we.length,label:we.tooltip};return Q.set(le.id,{provider:ae.provider,link:we}),le}));return this.F.set(f,Q),W}$activateLink(f,b){const M=this.F.get(f)?.get(b);M&&M.provider.handleTerminalLink(M.link)}U(f,b){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const M=this.h[f];M&&(M.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,b)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const b=this.f.findIndex(M=>M.value===f);return b>=0?b:null}W(f,b){const M=this.X(f,b);return M!==null?f[M]:null}X(f,b){const M=f.findIndex(N=>N._id===b);return M>=0?M:null}getEnvironmentVariableCollection(f){let b=this.n.get(f.identifier.value);return b||(b=this.B(new m),this.Z(f.identifier.value,b)),b.getScopedEnvironmentVariableCollection(void 0)}Y(f,b){const M=(0,y.$Es)(b.map),N=(0,y.$Fs)(b.descriptionMap);this.a.$setEnvironmentVariableCollection(f,b.persistent,M.length===0?void 0:M,N)}$initEnvironmentVariableCollections(f){f.forEach(b=>{const M=b[0],N=this.B(new m(b[1]));this.Z(M,N)})}$acceptDefaultProfile(f,b){const M=this.s;this.s=f,this.u=b,M?.path!==f.path&&this.N.fire(f.path)}Z(f,b){this.n.set(f,b),this.B(b.onDidChangeCollection(()=>{this.Y(f,b)}))}};e.$aqc=$,e.$aqc=$=Je([Ve(1,i.$FQ),Ve(2,A.$jQ)],$);class m extends T.$Uc{get persistent(){return this.b}set persistent(f){this.b=f,this.f.fire()}get onDidChangeCollection(){return this.f&&this.f.event}constructor(f){super(),this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.f=new v.$le,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const b=this.j(f);let M=this.a.get(b);return M||(M=new h(this,f),this.a.set(b,M),this.B(M.onDidChangeCollection(()=>this.f.fire()))),M}replace(f,b,M,N){this.g(f,{value:b,type:p.EnvironmentVariableMutatorType.Replace,options:M??{applyAtProcessCreation:!0},scope:N})}append(f,b,M,N){this.g(f,{value:b,type:p.EnvironmentVariableMutatorType.Append,options:M??{applyAtProcessCreation:!0},scope:N})}prepend(f,b,M,N){this.g(f,{value:b,type:p.EnvironmentVariableMutatorType.Prepend,options:M??{applyAtProcessCreation:!0},scope:N})}g(f,b){if(b.options&&b.options.applyAtProcessCreation===!1&&!b.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const M=this.h(f,b.scope),N=this.map.get(M),L=b.options?{applyAtProcessCreation:b.options.applyAtProcessCreation??!1,applyAtShellIntegration:b.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==b.value||N.type!==b.type||N.options?.applyAtProcessCreation!==L.applyAtProcessCreation||N.options?.applyAtShellIntegration!==L.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==b.scope?.workspaceFolder?.index){const W=this.h(f,b.scope),K={variable:f,...b,options:L};this.map.set(W,K),this.f.fire()}}get(f,b){const M=this.h(f,b),N=this.map.get(M);return N?C(N):void 0}h(f,b){const M=this.j(b);return M.length?`${f}:::${M}`:f}j(f){return this.m(f?.workspaceFolder)??""}m(f){return f?f.uri.toString():void 0}getVariableMap(f){const b=new Map;for(const[M,N]of this.map)this.j(N.scope)===this.j(f)&&b.set(N.variable,C(N));return b}delete(f,b){const M=this.h(f,b);this.map.delete(M),this.f.fire()}clear(f){if(f?.workspaceFolder){for(const[b,M]of this.map)M.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(b);this.n(f)}else this.map.clear(),this.descriptionMap.clear();this.f.fire()}setDescription(f,b){const M=this.j(b),N=this.descriptionMap.get(M);if(!N||N.description!==f){let L;typeof f=="string"?L=f:L=f?.value.split(`

`)[0];const W={description:L,scope:b};this.descriptionMap.set(M,W),this.f.fire()}}getDescription(f){const b=this.j(f);return this.descriptionMap.get(b)?.description}n(f){const b=this.j(f);this.descriptionMap.delete(b)}}class h{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,b){this.b=f,this.d=b,this.a=new v.$le}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,b,M){this.b.replace(f,b,M,this.d)}append(f,b,M){this.b.append(f,b,M,this.d)}prepend(f,b,M){this.b.prepend(f,b,M,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,b){this.b.getVariableMap(this.d).forEach((M,N)=>f.call(b,N,M,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let E=class extends ${constructor(f,b){super(!1,f,b)}createTerminal(f,b,M){throw new I.$$}createTerminalFromOptions(f,b){throw new I.$$}};e.$bqc=E,e.$bqc=E=Je([Ve(0,i.$FQ),Ve(1,A.$jQ)],E);function D(k){if(!(!k||typeof k=="string"))return"id"in k?{id:k.id,color:k.color}:k}function w(k){return s.ThemeColor.isThemeColor(k)?k:void 0}function C(k){const f={...k};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Ne[126],Le([1,0,7,4,3,5,16,56,6,2,10]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mrc=e.$lrc=void 0,e.$lrc=(0,P.$Ei)("IExtHostTerminalShellIntegration");let y=class extends R.$Uc{constructor(s,c){super(),this.h=c,this.b=new Map,this.c=new p.$le,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new p.$le,this.onDidStartTerminalShellExecution=this.f.event,this.g=new p.$le,this.onDidEndTerminalShellExecution=this.g.event,this.a=s.getProxy(O.$JN.MainThreadTerminalShellIntegration),this.B((0,R.$Sc)(()=>{for(const[l,i]of this.b)i.dispose();this.b.clear()}))}$shellIntegrationChange(s){const c=this.h.getTerminalById(s);if(!c)return;const l=c.value;let i=this.b.get(s);i||(i=new a(c.value,this.f),this.b.set(s,i),i.store.add(c.onWillDispose(()=>this.b.get(s)?.dispose())),i.store.add(i.onDidRequestShellExecution(n=>this.a.$executeCommand(s,n))),i.store.add(i.onDidRequestEndExecution(n=>this.g.fire(n))),i.store.add(i.onDidRequestChangeShellIntegration(n=>this.c.fire(n))),c.shellIntegration=i.value),this.c.fire({terminal:l,shellIntegration:i.value})}$shellExecutionStart(s,c,l,i,n){this.b.has(s)||this.$shellIntegrationChange(s);const t={value:c,confidence:l,isTrusted:i};this.b.get(s)?.startShellExecution(t,o.URI.revive(n))}$shellExecutionEnd(s,c,l,i,n){const t={value:c,confidence:l,isTrusted:i};this.b.get(s)?.endShellExecution(t,n)}$shellExecutionData(s,c){this.b.get(s)?.emitData(c)}$cwdChange(s,c){this.b.get(s)?.setCwd(o.URI.revive(c))}$closeTerminal(s){this.b.get(s)?.dispose(),this.b.delete(s)}};e.$mrc=y,e.$mrc=y=Je([Ve(0,A.$jQ),Ve(1,T.$$pc)],y);class a extends R.$Uc{get currentExecution(){return this.a}constructor(s,c){super(),this.j=s,this.m=c,this.b=!1,this.store=this.B(new R.$Tc),this.f=this.B(new p.$le),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new p.$le),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new p.$le),this.onDidRequestEndExecution=this.h.event;const l=this;this.value={get cwd(){return l.c},executeCommand(i,n){let t=i;n&&(t+=` "${n.map($=>`${$.replaceAll('"','\\"')}`).join('" "')}"`),l.g.fire(t);const g={value:t,confidence:v.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},u=l.startShellExecution(g,l.c,!0).value;return l.b=!0,u}}}startShellExecution(s,c,l){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const i=this.a=new S(s,c??this.c);l?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:i.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(s){this.currentExecution?.emitData(s)}endShellExecution(s,c){this.a&&(this.a.endExecution(s),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:c}),this.a=void 0)}setCwd(s){let c=!1;o.URI.isUri(this.c)?c=!o.URI.isUri(s)||this.c.toString()!==s.toString():this.c!==s&&(c=!0),c&&(this.c=s,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class S{constructor(s,c){this.c=s,this.cwd=c,this.b=!1;const l=this;this.value={get commandLine(){return l.c},get cwd(){return l.cwd},read(){return l.d()}}}d(){if(!this.a){if(this.b)return I.$5h.EMPTY;this.a=new d}return this.a.createIterable()}emitData(s){this.a?.emitData(s)}endExecution(s){s&&(this.c=s),this.a?.endExecution(),this.a=void 0,this.b=!0}}class d extends R.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new I.$Dh);const s=this.a;return new I.$5h(async l=>{this.b.push(l),await s.wait()})}emitData(s){for(const c of this.b)c.emitOne(s)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ne[127],Le([1,0,61,13,96,8,7]),function(ve,e,v,R,P,O,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=e.$qQ=void 0,O=We(O);class T{static{this.c=new P.$oQ("TextEditorDecorationType")}constructor(a,S,d){const r=T.c.nextId();a.$registerTextEditorDecorationType(S.identifier,r,O.DecorationRenderOptions.from(d)),this.value=Object.freeze({key:r,dispose(){a.$removeTextEditorDecorationType(r)}})}}e.$qQ=T;class p{constructor(a,S){this.g=[],this.h=void 0,this.j=!1,this.c=a,this.d=a.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(a,S){this.k();let d=null;if(a instanceof A.$MN)d=new A.$NN(a,a);else if(a instanceof A.$NN)d=a;else throw new Error("Unrecognized location");this.l(d,S,!1)}insert(a,S){this.k(),this.l(new A.$NN(a,a),S,!0)}delete(a){this.k();let S=null;if(a instanceof A.$NN)S=a;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(a,S,d){const r=this.c.validateRange(a);this.g.push({range:r,text:S,forceMoveMarkers:d})}setEndOfLine(a){if(this.k(),a!==A.EndOfLine.LF&&a!==A.EndOfLine.CRLF)throw(0,R.$6)("endOfLine");this.h=a}}class o{constructor(a,S,d,r){this.c=a,this.d=S,this._accept(d),this.e=r;const s=this;this.value={get tabSize(){return s.f},set tabSize(c){s.n(c)},get indentSize(){return s.g},set indentSize(c){s.p(c)},get insertSpaces(){return s.j},set insertSpaces(c){s.s(c)},get cursorStyle(){return s.k},set cursorStyle(c){s.t(c)},get lineNumbers(){return s.l},set lineNumbers(c){s.u(c)}}}_accept(a){this.f=a.tabSize,this.g=a.indentSize,this.h=a.originalIndentSize,this.j=a.insertSpaces,this.k=a.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(a.lineNumbers)}m(a){if(a==="auto")return"auto";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}n(a){const S=this.m(a);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}o(a){if(a==="tabSize")return"tabSize";if(typeof a=="number"){const S=Math.floor(a);return S>0?S:null}if(typeof a=="string"){const S=parseInt(a,10);return isNaN(S)?null:S>0?S:null}return null}p(a){const S=this.o(a);if(S!==null){if(typeof S=="number"){if(this.h===S)return;this.g=S,this.h=S}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}q(a){return a==="auto"?"auto":a==="false"?!1:!!a}s(a){const S=this.q(a);if(typeof S=="boolean"){if(this.j===S)return;this.j=S}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}t(a){this.k!==a&&(this.k=a,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:a})))}u(a){this.l!==a&&(this.l=a,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(a)})))}assign(a){const S={};let d=!1;if(typeof a.tabSize<"u"){const r=this.m(a.tabSize);r==="auto"?(d=!0,S.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,d=!0,S.tabSize=r)}if(typeof a.indentSize<"u"){const r=this.o(a.indentSize);r==="tabSize"?(d=!0,S.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,d=!0,S.indentSize=r)}if(typeof a.insertSpaces<"u"){const r=this.q(a.insertSpaces);r==="auto"?(d=!0,S.insertSpaces=r):this.j!==r&&(this.j=r,d=!0,S.insertSpaces=r)}typeof a.cursorStyle<"u"&&this.k!==a.cursorStyle&&(this.k=a.cursorStyle,d=!0,S.cursorStyle=a.cursorStyle),typeof a.lineNumbers<"u"&&this.l!==a.lineNumbers&&(this.l=a.lineNumbers,d=!0,S.lineNumbers=O.TextEditorLineNumbersStyle.from(a.lineNumbers)),d&&this.v("setOptions",this.c.$trySetOptions(this.d,S))}v(a,S){S.catch(d=>{this.e.warn(`ExtHostTextEditorOptions '${a}' failed:'`),this.e.warn(d)})}}e.$rQ=o;class I{constructor(a,S,d,r,s,c,l,i){this.id=a,this.j=S,this.k=d,this.g=!1,this.h=new Set,this.c=s,this.d=new o(this.j,this.id,c,d),this.e=l,this.f=i;const n=this;this.value=Object.freeze({get document(){return r.value},set document(t){throw new R.$8("document")},get selection(){return n.c&&n.c[0]},set selection(t){if(!(t instanceof A.$ON))throw(0,R.$6)("selection");n.c=[t],n.l()},get selections(){return n.c},set selections(t){if(!Array.isArray(t)||t.some(g=>!(g instanceof A.$ON)))throw(0,R.$6)("selections");n.c=t,n.l()},get visibleRanges(){return n.e},set visibleRanges(t){throw new R.$8("visibleRanges")},get options(){return n.d.value},set options(t){n.g||n.d.assign(t)},get viewColumn(){return n.f},set viewColumn(t){throw new R.$8("viewColumn")},edit(t,g={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new p(r.value,g);return t(u),n.m(u)},insertSnippet(t,g,u={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let $;if(!g||Array.isArray(g)&&g.length===0)$=n.c.map(m=>O.Range.from(m));else if(g instanceof A.$MN){const{lineNumber:m,column:h}=O.Position.from(g);$=[{startLineNumber:m,startColumn:h,endLineNumber:m,endColumn:h}]}else if(g instanceof A.$NN)$=[O.Range.from(g)];else{$=[];for(const m of g)if(m instanceof A.$NN)$.push(O.Range.from(m));else{const{lineNumber:h,column:E}=O.Position.from(m);$.push({startLineNumber:h,startColumn:E,endLineNumber:h,endColumn:E})}}return S.$tryInsertSnippet(a,r.value.version,t.value,$,u)},setDecorations(t,g){const u=g.length===0;u&&!n.h.has(t.key)||(u?n.h.delete(t.key):n.h.add(t.key),n.n(()=>{if(O.$gQ(g))return S.$trySetDecorations(a,t.key,O.$hQ(g));{const $=new Array(4*g.length);for(let m=0,h=g.length;m<h;m++){const E=g[m];$[4*m]=E.start.line+1,$[4*m+1]=E.start.character+1,$[4*m+2]=E.end.line+1,$[4*m+3]=E.end.character+1}return S.$trySetDecorationsFast(a,t.key,$)}}))},revealRange(t,g){n.n(()=>S.$tryRevealRange(a,O.Range.from(t),g||A.TextEditorRevealType.Default))},show(t){S.$tryShowEditor(a,O.ViewColumn.from(t))},hide(){S.$tryHideEditor(a)},[Symbol.for("debug.description")](){return`TextEditor(${this.document.uri.toString()})`}})}dispose(){(0,v.ok)(!this.g),this.g=!0}_acceptOptions(a){(0,v.ok)(!this.g),this.d._accept(a)}_acceptVisibleRanges(a){(0,v.ok)(!this.g),this.e=a}_acceptViewColumn(a){(0,v.ok)(!this.g),this.f=a}_acceptSelections(a){(0,v.ok)(!this.g),this.c=a}async l(){const a=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,a)),this.value}m(a){const S=a.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const d=S.edits.map(s=>s.range);d.sort((s,c)=>s.end.line===c.end.line?s.end.character===c.end.character?s.start.line===c.start.line?s.start.character-c.start.character:s.start.line-c.start.line:s.end.character-c.end.character:s.end.line-c.end.line);for(let s=0,c=d.length-1;s<c;s++){const l=d[s].end;if(d[s+1].start.isBefore(l))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=S.edits.map(s=>({range:O.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,r,{setEndOfLine:typeof S.setEndOfLine=="number"?O.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(a){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):a().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$sQ=I}),define(Ne[57],Le([1,0,61,6,4,2,3,5,123,16,127,8,11,28,15,40,48]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uQ=e.$tQ=void 0,v=We(v),y=We(y);class c{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let l=class{constructor(n,t){this.h=n,this.i=t,this.a=null,this.b=new Map,this.c=new S.$Ac,this.d=new R.$le,this.e=new R.$le,this.f=new R.$le,this.g=new R.$le,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const t=[],g=[],u=[];if(n.removedDocuments)for(const $ of n.removedDocuments){const m=O.URI.revive($),h=this.c.get(m);h?.unref()&&(this.c.delete(m),t.push(h.value))}if(n.addedDocuments)for(const $ of n.addedDocuments){const m=O.URI.revive($.uri);let h=this.c.get(m);if(h&&m.scheme!==d.Schemas.vscodeNotebookCell&&m.scheme!==d.Schemas.vscodeInteractiveInput)throw new Error(`document '${m} already exists!'`);h||(h=new c(new p.$mQ(this.h.getProxy(T.$JN.MainThreadDocuments),m,$.lines,$.EOL,$.versionId,$.languageId,$.isDirty)),this.c.set(m,h),g.push(h.value)),h.ref()}if(n.removedEditors)for(const $ of n.removedEditors){const m=this.b.get($);this.b.delete($),m&&u.push(m)}if(n.addedEditors)for(const $ of n.addedEditors){const m=O.URI.revive($.documentUri);v.ok(this.c.has(m),`document '${m}' does not exist`),v.ok(!this.b.has($.id),`editor '${$.id}' already exists!`);const h=this.c.get(m).value,E=new I.$sQ($.id,this.h.getProxy(T.$JN.MainThreadTextEditors),this.i,new s.$T(()=>h.document),$.selections.map(y.Selection.to),$.options,$.visibleRanges.map(D=>y.Range.to(D)),typeof $.editorPosition=="number"?y.ViewColumn.to($.editorPosition):void 0);this.b.set($.id,E)}n.newActiveEditor!==void 0&&(v.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,P.$Pc)(t),(0,P.$Pc)(u),n.removedDocuments&&this.e.fire(t),n.addedDocuments&&this.d.fire(g),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map($=>$.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return r.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const t=this.b.get(this.a);return n?t:t?.value}allEditors(){return[...this.b.values()]}};e.$tQ=l,e.$tQ=l=Je([Ve(0,o.$jQ),Ve(1,a.$_j)],l),e.$uQ=(0,A.$Ei)("IExtHostDocumentsAndEditors")}),define(Ne[95],Le([1,0,10,22,21,6,231,75,4,37,14,2,38,3,11,5,33,57,16,125,8,7,200,54,81,55,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wqc=e.$vqc=e.$uqc=e.$tqc=e.$sqc=void 0,n=We(n);let E=0;const D=new WeakMap;e.$sqc=(0,S.$Ei)("IExtHostTesting");let w=class extends p.$Uc{constructor(le,_,ce,me){super(),this.C=_,this.D=ce,this.F=me,this.f=this.B(new O.$le),this.g=new Map,this.w=this.B(new O.$le),this.y=new Set,this.z=new Map,this.onResultsChanged=this.f.event,this.results=[],this.h=le.getProxy(r.$JN.MainThreadTesting),this.m=new K(this.h),this.j=new b(this.h,_),ce.registerArgumentProcessor({processArgument:oe=>{switch(oe?.$mid){case o.MarshalledId.TestItemContext:{const ke=oe,Te=ke.tests[ke.tests.length-1].item.extId;return this.g.get(u.$6I.root(Te))?.collection.tree.get(Te)?.actual??(0,i.$vQ)(oe)}case o.MarshalledId.TestMessageMenuArgs:{const{test:ke,message:Te}=oe,Z=ke.item.extId;return{test:this.g.get(u.$6I.root(Z))?.collection.tree.get(Z)?.actual??(0,i.$vQ)({$mid:o.MarshalledId.TestItemContext,tests:[ke]}),message:n.TestMessage.to(Te)}}default:return oe}}}),ce.registerCommand(!1,"testing.getExplorerSelection",async()=>{const oe=await ce.executeCommand(g.TestCommandId.GetExplorerSelection),ke=Te=>{const Z=this.g.get(u.$6I.root(Te));if(Z)return u.$6I.isRoot(Te)?Z.controller:Z.collection.tree.get(Te)?.actual};return{include:oe?.include.map(ke).filter(I.$mg)||[],exclude:oe?.exclude.map(ke).filter(I.$mg)||[]}})}createTestController(le,_,ce,me){if(this.g.has(_))throw new Error(`Attempt to insert a duplicate controller with ID "${_}"`);const oe=new p.$Tc,ke=oe.add(new i.$yQ(_,ce,this.F));ke.root.label=ce;const Te=new Map,Z=new Set,B=this.h,ne=()=>{let be=0;me&&(be|=m.TestControllerCapability.Refresh);const he=fe.relatedCodeProvider;return he&&(he?.provideRelatedTests&&(be|=m.TestControllerCapability.TestRelatedToCode),he?.provideRelatedCode&&(be|=m.TestControllerCapability.CodeRelatedToTest)),be},Ee={items:ke.root.children,get label(){return ce},set label(be){ce=be,ke.root.label=be,B.$updateController(_,{label:ce})},get refreshHandler(){return me},set refreshHandler(be){me=be,B.$updateController(_,{capabilities:ne()})},get id(){return _},get relatedCodeProvider(){return fe.relatedCodeProvider},set relatedCodeProvider(be){(0,h.$fH)(le,"testRelatedCode"),fe.relatedCodeProvider=be,B.$updateController(_,{capabilities:ne()})},createRunProfile:(be,he,X,x,$e,pe)=>{let Ae=(0,T.$sj)(be);for(;Te.has(Ae);)Ae++;return new G(this.h,Te,Z,this.w.event,_,Ae,be,he,X,x,$e,pe)},createTestItem(be,he,X){return new i.$wQ(_,be,he,X)},createTestRun:(be,he,X=!0)=>this.j.createTestRun(le,_,ke,be,he,X),invalidateTestResults:be=>{if(be===void 0)this.h.$markTestRetired(void 0);else{const he=be instanceof Array?be:[be];this.h.$markTestRetired(he.map(X=>u.$6I.fromExtHostTestItem(X,_).toString()))}},set resolveHandler(be){ke.resolveHandler=be},get resolveHandler(){return ke.resolveHandler},dispose:()=>{oe.dispose()}},fe={controller:Ee,collection:ke,profiles:Te,extension:le,activeProfiles:Z};return B.$registerTestController(_,ce,ne()),oe.add((0,p.$Sc)(()=>B.$unregisterTestController(_))),this.g.set(_,fe),oe.add((0,p.$Sc)(()=>this.g.delete(_))),oe.add(ke.onDidGenerateDiff(be=>B.$publishDiff(_,be.map(m.TestsDiffOp.serialize)))),Ee}createTestObserver(){return this.m.checkout()}async runTests(le,_=P.CancellationToken.None){const ce=M(le);if(!ce)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const me=this.g.get(ce.controllerId);if(!me)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:le.preserveFocus??!0,group:Q[ce.kind],targets:[{testIds:le.include?.map(oe=>u.$6I.fromExtHostTestItem(oe,me.collection.root.id).toString())??[me.collection.root.id],profileId:ce.profileId,controllerId:ce.controllerId}],exclude:le.exclude?.map(oe=>oe.id)},_)}registerTestFollowupProvider(le){return this.y.add(le),{dispose:()=>{this.y.delete(le)}}}async $getTestsRelatedToCode(le,_,ce){const me=this.F.getDocument(y.URI.revive(le));if(!me)return[];const oe=n.Position.to(_),ke=[];return await Promise.all([...this.g.values()].map(async Te=>{let Z;try{Z=await Te.relatedCodeProvider?.provideRelatedTests?.(me.document,oe,ce)}catch(B){ce.isCancellationRequested||this.C.warn(`Error thrown while providing related tests for ${Te.controller.label}`,B)}if(Z){for(const B of Z)ke.push(u.$6I.fromExtHostTestItem(B,Te.controller.id).toString());Te.collection.flushDiff()}})),ke}async $getCodeRelatedToTest(le,_){const ce=this.g.get(u.$6I.root(le));if(!ce)return[];const me=ce.collection.tree.get(le);return me?(await ce.relatedCodeProvider?.provideRelatedCode?.(me.actual,_))?.map(n.location.from)??[]:[]}$syncTests(){for(const{collection:le}of this.g.values())le.flushDiff();return Promise.resolve()}async $getCoverageDetails(le,_,ce){return(await this.j.getCoverageDetails(le,_,ce))?.map(n.TestCoverage.fromDetails)}async $disposeRun(le){this.j.disposeTestRun(le)}$configureRunProfile(le,_){this.g.get(le)?.profiles.get(_)?.configureHandler?.()}$setDefaultRunProfiles(le){const _=new Map;for(const[ce,me]of Object.entries(le)){const oe=this.g.get(ce);if(!oe)continue;const ke=new Map,Te=me.filter(B=>!oe.activeProfiles.has(B)),Z=[...oe.activeProfiles].filter(B=>!me.includes(B));for(const B of Te)ke.set(B,!0),oe.activeProfiles.add(B);for(const B of Z)ke.set(B,!1),oe.activeProfiles.delete(B);ke.size&&_.set(ce,ke)}this.w.fire(_)}async $refreshTests(le,_){await this.g.get(le)?.controller.refreshHandler?.(_)}$publishTestResults(le){this.results=Object.freeze(le.map(_=>{const ce=n.TestResults.to(_);return D.set(ce,_.id),ce}).concat(this.results).sort((_,ce)=>ce.completedAt-_.completedAt).slice(0,32)),this.f.fire()}async $expandTest(le,_){const ce=this.g.get(u.$6I.fromString(le).controllerId)?.collection;ce&&(await ce.expand(le,_<0?1/0:_),ce.flushDiff())}$acceptDiff(le){this.m.applyDiff(le.map(_=>m.TestsDiffOp.deserialize({asCanonicalUri:ce=>ce},_)))}async $runControllerTests(le,_){return Promise.all(le.map(ce=>this.G(ce,!1,_)))}async $startContinuousRun(le,_){const ce=new P.$we(_),me=await Promise.all(le.map(oe=>this.G(oe,!0,ce.token)));return!_.isCancellationRequested&&!me.some(oe=>oe.error)&&await new Promise(oe=>_.onCancellationRequested(oe)),ce.dispose(!0),me}async $provideTestFollowups(le,_){const ce=this.results.find(ke=>D.get(ke)===le.resultId),me=ce&&ae(u.$6I.fromString(le.extId),ce?.results);if(!me)return[];let oe=[];return await Promise.all([...this.y].map(async ke=>{try{const Te=await ke.provideFollowup(ce,me,le.taskIndex,le.messageIndex,_);Te&&(oe=oe.concat(Te))}catch(Te){this.C.error("Error thrown while providing followup for test message",Te)}})),_.isCancellationRequested?[]:oe.map(ke=>{const Te=E++;return this.z.set(Te,ke),{title:ke.title,id:Te}})}$disposeTestFollowups(le){for(const _ of le)this.z.delete(_)}$executeTestFollowup(le){const _=this.z.get(le);return _?this.D.executeCommand(_.command,..._.arguments||[]):Promise.resolve()}$cancelExtensionTestRun(le){le===void 0?this.j.cancelAllRuns():this.j.cancelRunById(le)}getMetadataForRun(le){for(const _ of this.j.trackers){const ce=_.getTaskIdForRun(le);if(ce)return{taskId:ce,runId:_.id}}}async G(le,_,ce){const me=this.g.get(le.controllerId);if(!me)return{};const{collection:oe,profiles:ke,extension:Te}=me,Z=ke.get(le.profileId);if(!Z)return{};const B=le.testIds.map(be=>oe.tree.get(be)).filter(I.$mg),ne=le.excludeExtIds.map(be=>me.collection.tree.get(be)).filter(I.$mg).filter(be=>B.some(he=>he.fullId.compare(be.fullId)===u.TestPosition.IsChild));if(!B.length)return{};const Ee=new t.$oP(B.some(be=>be.actual instanceof i.$xQ)?void 0:B.map(be=>be.actual),ne.map(be=>be.actual),Z,_),fe=(0,m.$9I)(le)&&this.j.prepareForMainThreadTestRun(Te,Ee,N.fromInternal(le,me.collection),Z,ce);try{return await Z.runHandler(Ee,ce),{}}catch(be){return{error:String(be)}}finally{fe&&fe.hasRunningTasks&&!ce.isCancellationRequested&&await O.Event.toPromise(fe.onEnd)}}};e.$tqc=w,e.$tqc=w=Je([Ve(0,l.$jQ),Ve(1,d.$_j),Ve(2,s.$FQ),Ve(3,c.$uQ)],w);const C=1e4;var k;(function(we){we[we.Running=0]="Running",we[we.Cancelling=1]="Cancelling",we[we.Ended=2]="Ended"})(k||(k={}));class f extends p.$Uc{get hasRunningTasks(){return this.g>0}get id(){return this.C.id}constructor(le,_,ce,me,oe,ke){super(),this.C=le,this.D=_,this.F=ce,this.G=me,this.H=oe,this.f=k.Running,this.g=0,this.h=new Map,this.j=new Set,this.w=this.B(new O.$le),this.z=new Map,this.onEnd=this.w.event,this.m=this.B(new P.$we(ke));const Te=this.B(new v.$Qh(()=>this.I(),C));this.B(this.m.token.onCancellationRequested(()=>Te.schedule()));const Z=new O.$le;this.y=Z.event,this.B((0,p.$Sc)(()=>{Z.fire(),Z.dispose()}))}getTaskIdForRun(le){for(const[_,{run:ce}]of this.h)if(ce===le)return _}cancel(){this.f===k.Running?(this.m.cancel(),this.f=k.Cancelling):this.f===k.Cancelling&&this.I()}async getCoverageDetails(le,_,ce){const[,me]=u.$6I.fromString(le).path,oe=this.z.get(le);if(!oe)return[];const{report:ke,extIds:Te}=oe,Z=this.h.get(me);if(!Z)throw new Error("unreachable: run task was not found");let B;if(_&&ke instanceof t.$uP){const Ee=Te.indexOf(_);if(Ee===-1)return[];B=ke.fromTests[Ee]}return await(B?this.G?.loadDetailedCoverageForTest?.(Z.run,ke,B,ce):this.G?.loadDetailedCoverage?.(Z.run,ke,ce))??[]}createRun(le){const _=this.C.id,ce=this.C.controllerId,me=(0,a.$1g)(),oe=B=>(ne,...Ee)=>{if(Te){this.F.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.L(ne),B(ne,...Ee)},ke=(B,ne)=>{const Ee=ne instanceof Array?ne.map(n.TestMessage.from):[n.TestMessage.from(ne)];if(B.uri&&B.range){const fe={range:n.Range.from(B.range),uri:B.uri};for(const be of Ee)be.location=be.location||fe}this.D.$appendTestMessagesInRun(_,me,u.$6I.fromExtHostTestItem(B,ce).toString(),Ee)};let Te=!1;const Z={isPersisted:this.C.isPersisted,token:this.m.token,name:le,onDidDispose:this.y,addCoverage:B=>{if(Te)return;const ne=B instanceof t.$uP?B.fromTests:[];if(ne.length){(0,h.$fH)(this.H,"attributableCoverage");for(const be of ne)this.L(be)}const Ee=B.uri.toString(),fe=new u.$6I([_,me,Ee]).toString();this.z.set(fe,{report:B,extIds:ne.map(be=>u.$6I.fromExtHostTestItem(be,ce).toString())}),this.D.$appendCoverage(_,me,n.TestCoverage.fromFile(ce,fe,B))},enqueued:oe(B=>{this.D.$updateTestStateInRun(_,me,u.$6I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Queued)}),skipped:oe(B=>{this.D.$updateTestStateInRun(_,me,u.$6I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Skipped)}),started:oe(B=>{this.D.$updateTestStateInRun(_,me,u.$6I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Running)}),errored:oe((B,ne,Ee)=>{ke(B,ne),this.D.$updateTestStateInRun(_,me,u.$6I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Errored,Ee)}),failed:oe((B,ne,Ee)=>{ke(B,ne),this.D.$updateTestStateInRun(_,me,u.$6I.fromExtHostTestItem(B,ce).toString(),m.TestResultState.Failed,Ee)}),passed:oe((B,ne)=>{this.D.$updateTestStateInRun(_,me,u.$6I.fromExtHostTestItem(B,this.C.controllerId).toString(),m.TestResultState.Passed,ne)}),appendOutput:(B,ne,Ee)=>{Te||(Ee&&this.L(Ee),this.D.$appendOutputToRun(_,me,R.$Ne.fromString(B),ne&&n.location.from(ne),Ee&&u.$6I.fromExtHostTestItem(Ee,ce).toString()))},end:()=>{Te||(Te=!0,this.D.$finishedTestRunTask(_,me),--this.g||this.J())}};return this.g++,this.h.set(me,{run:Z}),this.D.$startedTestRunTask(_,{id:me,ctrlId:this.C.controllerId,name:le,running:!0}),Z}I(){for(const{run:le}of this.h.values())le.end()}J(){this.f!==k.Ended&&(this.f=k.Ended,this.w.fire())}L(le){if(!(le instanceof i.$wQ))throw new $.$bQ(le.id);if(this.j.has(u.$6I.fromExtHostTestItem(le,this.C.controllerId).toString()))return;const _=[],ce=this.C.colllection.root;for(;;){const me=n.TestItem.from(le);if(_.unshift(me),this.j.has(me.extId)||(this.j.add(me.extId),le===ce))break;le=le.parent||ce}this.D.$addTestsToRun(this.C.controllerId,this.C.id,_)}dispose(){this.J(),super.dispose()}}class b{get trackers(){return this.f.values()}constructor(le,_){this.h=le,this.j=_,this.f=new Map,this.g=new Map}getCoverageDetails(le,_,ce){const me=u.$6I.root(le);return this.g.get(me)?.getCoverageDetails(le,_,ce)||[]}disposeTestRun(le){this.g.get(le)?.dispose(),this.g.delete(le);for(const[_,{id:ce}]of this.f)ce===le&&this.f.delete(_)}prepareForMainThreadTestRun(le,_,ce,me,oe){return this.k(_,ce,me,le,oe)}cancelRunById(le){this.g.get(le)?.cancel()}cancelAllRuns(){for(const le of this.f.values())le.cancel()}createTestRun(le,_,ce,me,oe,ke){const Te=this.f.get(me);if(Te)return Te.createRun(oe);const Z=N.fromPublic(_,ce,me,ke),B=M(me);this.h.$startedExtensionTestRun({controllerId:_,continuous:!!me.continuous,profile:B&&{group:Q[B.kind],id:B.profileId},exclude:me.exclude?.map(Ee=>u.$6I.fromExtHostTestItem(Ee,ce.root.id).toString())??[],id:Z.id,include:me.include?.map(Ee=>u.$6I.fromExtHostTestItem(Ee,ce.root.id).toString())??[ce.root.id],preserveFocus:me.preserveFocus??!0,persist:ke});const ne=this.k(me,Z,me.profile,le);return O.Event.once(ne.onEnd)(()=>{this.h.$finishedExtensionTestRun(Z.id)}),ne.createRun(oe)}k(le,_,ce,me,oe){const ke=new f(_,this.h,this.j,ce,me,oe);return this.f.set(le,ke),this.g.set(ke.id,ke),ke}}e.$uqc=b;const M=we=>{if(we.profile){if(!(we.profile instanceof G))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return we.profile}};class N{static fromPublic(le,_,ce,me){return new N(le,(0,a.$1g)(),me,_)}static fromInternal(le,_){return new N(le.controllerId,le.runId,!0,_)}constructor(le,_,ce,me){this.controllerId=le,this.id=_,this.isPersisted=ce,this.colllection=me}}e.$vqc=N;class L{get isEmpty(){return this.f.size===0&&this.h.size===0&&this.g.size===0}constructor(le){this.k=le,this.f=new Set,this.g=new Set,this.h=new Set,this.j=new Set}add(le){this.f.add(le)}update(le){Object.assign(le.revived,n.TestItem.toPlain(le.item)),this.f.has(le)||this.g.add(le)}remove(le){if(this.f.has(le)){this.f.delete(le);return}this.g.delete(le);const _=u.$6I.parentId(le.item.extId);if(_&&this.j.has(_.toString())){this.j.add(le.item.extId);return}this.h.add(le)}getChangeEvent(){const{f:le,g:_,h:ce}=this;return{get added(){return[...le].map(me=>me.revived)},get updated(){return[..._].map(me=>me.revived)},get removed(){return[...ce].map(me=>me.revived)}}}complete(){this.isEmpty||this.k.fire(this.getChangeEvent())}}class W extends m.$cJ{constructor(){super(...arguments),this.z=new O.$le,this.onDidChangeTests=this.z.event}get rootTests(){return this.h}getMirroredTestDataById(le){return this.g.get(le)}getMirroredTestDataByReference(le){return this.g.get(le.id)}y(le,_){return{...le,revived:n.TestItem.toPlain(le.item),depth:_?_.depth+1:0,children:new Set}}x(){return new L(this.z)}}class K{constructor(le){this.g=le}checkout(){this.f||(this.f=this.h());const le=this.f;return le.observers++,{onDidChangeTest:le.tests.onDidChangeTests,get tests(){return[...le.tests.rootTests].map(_=>_.revived)},dispose:(0,A.$cb)(()=>{--le.observers===0&&(this.g.$unsubscribeFromDiffs(),this.f=void 0)})}}getMirroredTestDataByReference(le){return this.f?.tests.getMirroredTestDataByReference(le)}applyDiff(le){this.f?.tests.apply(le)}h(){const le=new W({asCanonicalUri:_=>_});return this.g.$subscribeToDiffs(),{observers:0,tests:le}}}const q=(we,le,_,ce)=>{_?Object.assign(_,ce):le.$updateTestRunConfig(we.controllerId,we.profileId,ce)};class G{#e;#t;#i;#n;#s;get label(){return this.g}set label(le){le!==this.g&&(this.g=le,q(this,this.#e,this.#n,{label:le}))}get supportsContinuousRun(){return this.h}set supportsContinuousRun(le){le!==this.h&&(this.h=le,q(this,this.#e,this.#n,{supportsContinuousRun:le}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(le){le!==this.isDefault&&(le?this.#t.add(this.profileId):this.#t.delete(this.profileId),q(this,this.#e,this.#n,{isDefault:le}))}get tag(){return this._tag}set tag(le){le?.id!==this._tag?.id&&(this._tag=le,q(this,this.#e,this.#n,{tag:le?n.TestTag.namespace(this.controllerId,le.id):null}))}get configureHandler(){return this.f}set configureHandler(le){le!==this.f&&(this.f=le,q(this,this.#e,this.#n,{hasConfigurationHandler:!!le}))}get onDidChangeDefault(){return O.Event.chain(this.#i,le=>le.map(_=>_.get(this.controllerId)?.get(this.profileId)).filter(I.$mg))}constructor(le,_,ce,me,oe,ke,Te,Z,B,ne=!1,Ee=void 0,fe=!1){this.controllerId=oe,this.profileId=ke,this.g=Te,this.kind=Z,this.runHandler=B,this._tag=Ee,this.h=fe,this.#e=le,this.#s=_,this.#t=ce,this.#i=me,_.set(ke,this);const be=Q[Z];if(typeof be!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);ne&&ce.add(ke),this.#n={profileId:ke,controllerId:oe,tag:Ee?n.TestTag.namespace(this.controllerId,Ee.id):null,label:Te,group:be,isDefault:ne,hasConfigurationHandler:!1,supportsContinuousRun:fe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$wqc=G;const Q={[t.TestRunProfileKind.Coverage]:m.TestRunProfileBitset.Coverage,[t.TestRunProfileKind.Debug]:m.TestRunProfileBitset.Debug,[t.TestRunProfileKind.Run]:m.TestRunProfileBitset.Run};function ae(we,le){for(let _=0;_<we.path.length;_++){const ce=le.find(me=>me.id===we.path[_]);if(!ce)return;if(_===we.path.length-1)return ce;le=ce.children}}}),define(Ne[259],Le([1,0,17,6,4,5,127,8,7]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dpc=void 0,v=We(v),T=We(T);class o extends P.$Uc{constructor(y,a){super(),this.m=a,this.a=new R.$le,this.b=new R.$le,this.c=new R.$le,this.f=new R.$le,this.g=new R.$le,this.h=new R.$le,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.f.event,this.onDidChangeActiveTextEditor=this.g.event,this.onDidChangeVisibleTextEditors=this.h.event,this.j=y.getProxy(O.$JN.MainThreadTextEditors),this.B(this.m.onDidChangeVisibleTextEditors(S=>this.h.fire(S))),this.B(this.m.onDidChangeActiveTextEditor(S=>this.g.fire(S)))}getActiveTextEditor(){return this.m.activeEditor()}getVisibleTextEditors(y){const a=this.m.allEditors();return y?a:a.map(S=>S.value)}async showTextDocument(y,a,S){let d;typeof a=="number"?d={position:T.ViewColumn.from(a),preserveFocus:S}:typeof a=="object"?d={position:T.ViewColumn.from(a.viewColumn),preserveFocus:a.preserveFocus,selection:typeof a.selection=="object"?T.Range.from(a.selection):void 0,pinned:typeof a.preview=="boolean"?!a.preview:void 0}:d={preserveFocus:!1};const r=await this.j.$tryShowTextDocument(y.uri,d),s=r&&this.m.getEditor(r);if(s)return s.value;throw r?new Error(`Could NOT open editor for "${y.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${y.uri.toString()}".`)}createTextEditorDecorationType(y,a){return new A.$qQ(this.j,y,a).value}$acceptEditorPropertiesChanged(y,a){const S=this.m.getEditor(y);if(!S)throw new Error("unknown text editor");if(a.options&&S._acceptOptions(a.options),a.selections){const d=a.selections.selections.map(T.Selection.to);S._acceptSelections(d)}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(T.Range.to));S._acceptVisibleRanges(d)}if(a.options&&this.b.fire({textEditor:S.value,options:{...a.options,lineNumbers:T.TextEditorLineNumbersStyle.to(a.options.lineNumbers)}}),a.selections){const d=p.TextEditorSelectionChangeKind.fromValue(a.selections.source),r=a.selections.selections.map(T.Selection.to);this.a.fire({textEditor:S.value,selections:r,kind:d})}if(a.visibleRanges){const d=v.$Gb(a.visibleRanges.map(T.Range.to));this.c.fire({textEditor:S.value,visibleRanges:d})}}$acceptEditorPositionData(y){for(const a in y){const S=this.m.getEditor(a);if(!S)throw new Error("Unknown text editor");const d=T.ViewColumn.to(y[a]);S.value.viewColumn!==d&&(S._acceptViewColumn(d),this.f.fire({textEditor:S.value,viewColumn:d}))}}getDiffInformation(y){return Promise.resolve(this.j.$getDiffInformation(y))}}e.$Dpc=o}),define(Ne[260],Le([1,0,2,3,5,4,7,8,18,37,14]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$prc=e.$orc=void 0,e.$orc=(0,R.$Ei)("IExtHostTimeline");class y{constructor(d,r){this.b=new Map,this.c=new Map,this.a=d.getProxy(P.$JN.MainThreadTimeline),r.registerArgumentProcessor({processArgument:(s,c)=>{if(s&&s.$mid===o.MarshalledId.TimelineActionContext)if(this.b.get(s.source)&&p.$qn.equals(c,this.b.get(s.source)?.extension)){const l=s.uri===void 0?void 0:v.URI.revive(s.uri);return this.c.get(s.source)?.get(a(l))?.get(s.handle)}else return;return s}})}async $getTimeline(d,r,s,c){return this.b.get(d)?.provider.provideTimeline(v.URI.revive(r),s,c)}registerTimelineProvider(d,r,s,c){const l=new O.$Tc,i=this.d(r.id,c,l).bind(this);let n;r.onDidChange&&(n=r.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:r.id}),this));const t=this.c;return this.f({...r,scheme:d,onDidChange:void 0,async provideTimeline(g,u,$){u?.resetCache&&(l.clear(),t.get(r.id)?.clear());const m=await r.provideTimeline(g,u,$);if(m==null)return;const h=i(g,u);return{...m,source:r.id,items:m.items.map(h)}},dispose(){for(const g of t.values())g.get(r.id)?.clear();n?.dispose(),l.dispose()}},s)}d(d,r,s){return(c,l)=>{let i;if(l?.cacheResults){let n=this.c.get(d);n===void 0&&(n=new Map,this.c.set(d,n));const t=a(c);i=n.get(t),i===void 0&&(i=new Map,n.set(t,i))}return n=>{const{iconPath:t,...g}=n,u=`${d}|${n.id??n.timestamp}`;i?.set(u,n);let $,m,h;n.iconPath&&(t instanceof A.$KO?h={id:t.id,color:t.color}:v.URI.isUri(t)?($=t,m=t):{light:$,dark:m}=t);let E;return A.$dO.isMarkdownString(g.tooltip)?E=T.MarkdownString.from(g.tooltip):(0,I.$eg)(g.tooltip)?E=g.tooltip:A.$dO.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=T.MarkdownString.from(g.detail)):(0,I.$eg)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=g.detail),{...g,id:g.id??void 0,handle:u,source:d,command:n.command?r.toInternal(n.command,s):void 0,icon:$,iconDark:m,themeIcon:h,tooltip:E,accessibilityInformation:n.accessibilityInformation}}}}f(d,r){if(this.b.get(d.id))throw new Error(`Timeline Provider ${d.id} already exists.`);return this.a.$registerTimelineProvider({id:d.id,label:d.label,scheme:d.scheme}),this.b.set(d.id,{provider:d,extension:r}),(0,O.$Sc)(()=>{for(const c of this.c.values())c.get(d.id)?.clear();this.b.delete(d.id),this.a.$unregisterTimelineProvider(d.id),d.dispose()})}}e.$prc=y;function a(S){return S?.toString()}}),define(Ne[261],Le([1,0,9,23,2,6,4,192,10,7,14,17,8,59,21,163,24]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qrc=void 0,o=We(o);function c(n,t){if((0,I.$eg)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let g;return Array.isArray(n.highlights)&&(g=n.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),g=g.length?g:void 0),{label:n.label,highlights:g}}}class l extends A.$Uc{constructor(t,g,u){super(),this.f=t,this.g=g,this.h=u,this.a=new Map,this.b=new r.$N_;function $(m){return m&&m.$treeViewId&&(m.$treeItemHandle||m.$selectedTreeItems||m.$focusedTreeItem)}g.registerArgumentProcessor({processArgument:m=>$(m)?this.r(m):Array.isArray(m)&&m.length>0?m.map(h=>$(h)?this.r(h):h):m})}registerTreeDataProvider(t,g,u){const $=this.createTreeView(t,{treeDataProvider:g},u);return{dispose:()=>$.dispose()}}createTreeView(t,g,u){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const $=g.dragAndDropController?.dropMimeTypes??[],m=g.dragAndDropController?.dragMimeTypes??[],h=!!g.dragAndDropController?.handleDrag,E=!!g.dragAndDropController?.handleDrop,D=this.m(t,g,u),w={showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,dropMimeTypes:$,dragMimeTypes:m,hasHandleDrag:h,hasHandleDrop:E,manuallyManageCheckboxes:!!g.manageCheckboxStateManually},C=this.f.$registerTreeViewDataProvider(t,w),k={get onDidCollapseElement(){return D.onDidCollapseElement},get onDidExpandElement(){return D.onDidExpandElement},get selection(){return D.selectedElements},get onDidChangeSelection(){return D.onDidChangeSelection},get activeItem(){return(0,s.$fH)(u,"treeViewActiveItem"),D.focusedElement},get onDidChangeActiveItem(){return(0,s.$fH)(u,"treeViewActiveItem"),D.onDidChangeActiveItem},get visible(){return D.visible},get onDidChangeVisibility(){return D.onDidChangeVisibility},get onDidChangeCheckboxState(){return D.onDidChangeCheckboxState},get message(){return D.message},set message(f){(0,S.$5k)(f)&&(0,s.$fH)(u,"treeViewMarkdownMessage"),D.message=f},get title(){return D.title},set title(f){D.title=f},get description(){return D.description},set description(f){D.description=f},get badge(){return D.badge},set badge(f){f!==void 0&&o.ViewBadge.isViewBadge(f)?D.badge={value:Math.floor(Math.abs(f.value)),tooltip:f.tooltip}:f===void 0&&(D.badge=void 0)},reveal:(f,b)=>D.reveal(f,b),dispose:async()=>{await C,this.a.delete(t),D.dispose()}};return this.B(k),k}$getChildren(t,g){const u=this.a.get(t);return u?u.getChildren(g):Promise.reject(new T.$BG(t))}async $handleDrop(t,g,u,$,m,h,E,D){const w=this.a.get(t);if(!w)return Promise.reject(new T.$BG(t));const C=a.DataTransfer.toDataTransfer(u,async k=>(await this.f.$resolveDropFileData(t,g,k)).buffer);return E===t&&D&&await this.j(C,w,D,m,h),w.onDrop(C,$,m)}async j(t,g,u,$,m){const h=this.b.removeDragOperationTransfer(m);if(h)(await h)?.forEach((E,D)=>{E&&t.set(D,E)});else if(m&&g.handleDrag){const E=g.handleDrag(u,t,$);this.b.addDragOperationTransfer(m,E),await E}return t}async $handleDrag(t,g,u,$){const m=this.a.get(t);if(!m)return Promise.reject(new T.$BG(t));const h=await this.j(new o.$GO,m,g,$,u);if(!(!h||$.isCancellationRequested))return a.DataTransfer.from(h)}async $hasResolve(t){const g=this.a.get(t);if(!g)throw new T.$BG(t);return g.hasResolve}$resolve(t,g,u){const $=this.a.get(t);if(!$)throw new T.$BG(t);return $.resolveTreeItem(g,u)}$setExpanded(t,g,u){const $=this.a.get(t);if(!$)throw new T.$BG(t);$.setExpanded(g,u)}$setSelectionAndFocus(t,g,u){const $=this.a.get(t);if(!$)throw new T.$BG(t);$.setSelectionAndFocus(g,u)}$setVisible(t,g){const u=this.a.get(t);if(!u){if(!g)return;throw new T.$BG(t)}u.setVisible(g)}$changeCheckboxState(t,g){const u=this.a.get(t);if(!u)throw new T.$BG(t);u.setCheckboxState(g)}m(t,g,u){const $=this.B(new i(t,g,this.f,this.g.converter,this.h,u));return this.a.set(t,$),$}r(t){const g=this.a.get(t.$treeViewId);return g&&"$treeItemHandle"in t?g.getExtensionElement(t.$treeItemHandle):g&&"$focusedTreeItem"in t&&t.$focusedTreeItem?g.focusedElement:null}}e.$qrc=l;class i extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(t=>this.getExtensionElement(t)).filter(t=>!(0,I.$ng)(t))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(t,g,u,$,m,h){if(super(),this.I=t,this.J=u,this.L=$,this.M=m,this.N=h,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$le),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$le),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$le),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$le),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$le),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$le),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$le),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new d.$we,h.contributes&&h.contributes.views)for(const C in h.contributes.views)for(const k of h.contributes.views[C])k.id===t&&(this.P=k.name);this.f=g.treeDataProvider,this.g=g.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(C=>{Array.isArray(C)&&C.length===0||this.F.fire({message:!1,element:C})}));let E,D;const w=O.Event.debounce(this.F.event,(C,k)=>(C||(C={message:!1,elements:[]}),k.element!==!1&&(E||(E=new Promise(f=>D=f),this.G=this.G.then(()=>E)),Array.isArray(k.element)?C.elements.push(...k.element):C.elements.push(k.element)),k.message&&(C.message=!0),C),200,!0);this.B(w(({message:C,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const f=D;return E=null,this.$(k).then(()=>f())})),C&&this.J.$setMessage(this.I,a.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(t){const g=t?this.getExtensionElement(t):void 0;if(t&&!g)return this.M.error(`No tree item with id '${t}' found.`),Promise.resolve([]);let u=this.X(t);return u||(u=await this.Y(g)),u?u.map($=>$.item):void 0}getExtensionElement(t){return this.j.get(t)}reveal(t,g){g=g||{select:!0,focus:!1};const u=(0,I.$ng)(g.select)?!0:g.select,$=(0,I.$ng)(g.focus)?!1:g.focus,m=(0,I.$ng)(g.expand)?!1:g.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):t?this.G.then(()=>this.S(t)).then(h=>this.W(t,h[h.length-1]).then(E=>this.J.$reveal(this.I,{item:E.item,parentChain:h.map(D=>D.item)},{select:u,focus:$,expand:m})),h=>this.M.error(h)):this.J.$reveal(this.I,void 0,{select:u,focus:$,expand:m})}get message(){return this.O}set message(t){this.O=t,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(t){this.P=t,this.J.$setTitle(this.I,t,this.Q)}get description(){return this.Q}set description(t){this.Q=t,this.J.$setTitle(this.I,this.P,t)}get badge(){return this.R}set badge(t){this.R?.value===t?.value&&this.R?.tooltip===t?.tooltip||(this.R=a.ViewBadge.from(t),this.J.$setBadge(this.I,t))}setExpanded(t,g){const u=this.getExtensionElement(t);u&&(g?this.u.fire(Object.freeze({element:u})):this.w.fire(Object.freeze({element:u})))}setSelectionAndFocus(t,g){const u=!(0,y.$tb)(this.s,t);this.s=t;const $=this.t!==g;this.t=g,u&&this.y.fire(Object.freeze({selection:this.selectedElements})),$&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(t){t!==this.r&&(this.r=t,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(t){const g=(await Promise.all(t.map(async u=>{const $=this.getExtensionElement(u.treeItemHandle);return $?{extensionItem:$,treeItem:await this.f.getTreeItem($),newState:u.newState?o.TreeItemCheckboxState.Checked:o.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(u=>u!==void 0);g.forEach(u=>{u.treeItem.checkboxState=u.newState?o.TreeItemCheckboxState.Checked:o.TreeItemCheckboxState.Unchecked}),this.D.fire({items:g.map(u=>[u.extensionItem,u.newState])})}async handleDrag(t,g,u){const $=[];for(const m of t){const h=this.getExtensionElement(m);h&&$.push(h)}if(!(!this.g?.handleDrag||$.length===0))return await this.g.handleDrag($,g,u),g}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(t,g,u){const $=g?this.getExtensionElement(g):void 0;if(!(!$&&g||!this.g?.handleDrop))return(0,p.$wh)(()=>this.g?.handleDrop?this.g.handleDrop($,t,u):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(t,g){if(!this.f.resolveTreeItem)return;const u=this.j.get(t);if(u){const $=this.m.get(u);if($){const m=await this.f.resolveTreeItem($.extensionItem,u,g)??$.extensionItem;return this.hb(m),$.item.tooltip=this.eb(m.tooltip),$.item.command=this.fb($.disposableStore,m.command),$.item}}}S(t){return this.U(t).then(g=>g?this.S(g).then(u=>this.W(g,u[u.length-1]).then($=>(u.push($),u))):Promise.resolve([]))}U(t){const g=this.m.get(t);return g?Promise.resolve(g.parent?this.j.get(g.parent.item.handle):void 0):(0,p.$wh)(()=>this.f.getParent(t))}W(t,g){const u=this.m.get(t);return u?Promise.resolve(u):(0,p.$wh)(()=>this.f.getTreeItem(t)).then($=>this.kb(t,$,g,!0)).then($=>this.getChildren(g?g.item.handle:void 0).then(()=>{const m=this.getExtensionElement($);if(m){const h=this.m.get(m);if(h)return Promise.resolve(h)}throw new Error(`Cannot resolve tree item for element ${$} from extension ${this.N.identifier.value}`)}))}X(t){if(t){let g;if(typeof t=="string"){const u=this.getExtensionElement(t);g=u?this.m.get(u):void 0}else g=t;return g&&g.children||void 0}return this.h}async Y(t){this.rb(t);const g=new d.$we(this.Z.token);try{const u=t?this.m.get(t):void 0,$=await this.f.getChildren(t);if(g.token.isCancellationRequested)return;const m=(0,y.$Gb)($||[]),h=await Promise.all((0,y.$Gb)(m).map(D=>this.f.getTreeItem(D)));if(g.token.isCancellationRequested)return;const E=h.map((D,w)=>D?this.db(m[w],D,u):null);return(0,y.$Gb)(E)}finally{g.dispose()}}$(t){if(t.some(u=>!u))return this.Z.dispose(!0),this.Z=new d.$we,this.tb(),this.J.$refresh(this.I);{const u=this.ab(t);if(u.length)return this.bb(u)}return Promise.resolve(void 0)}ab(t){const g=new Set,u=t.map(m=>this.m.get(m));for(const m of u)if(m&&!g.has(m.item.handle)){let h=m;for(;h&&h.parent&&u.findIndex(E=>h&&h.parent&&E&&E.item.handle===h.parent.item.handle)===-1;){const E=this.j.get(h.parent.item.handle);h=E?this.m.get(E):void 0}h&&!h.parent&&g.add(m.item.handle)}const $=[];return g.forEach(m=>{const h=this.j.get(m);if(h){const E=this.m.get(h);E&&(!E.parent||!g.has(E.parent.item.handle))&&$.push(m)}}),$}bb(t){const g={};return Promise.all(t.map(u=>this.cb(u).then($=>{$&&(g[u]=$.item)}))).then(()=>Object.keys(g).length?this.J.$refresh(this.I,g):void 0)}cb(t){const g=this.getExtensionElement(t);if(g){const u=this.m.get(g);if(u)return this.rb(g),(0,p.$wh)(()=>this.f.getTreeItem(g)).then($=>{if($){const m=this.ib(g,$,u.parent);return this.pb(g,m,u,u.parent),u.dispose(),m}return null})}return Promise.resolve(null)}db(t,g,u){const $=this.ib(t,g,u);if(g.id&&this.j.has($.item.handle))throw new Error((0,v.localize)(10812,null,g.id));return this.ob(t,$),this.qb($,u),$}eb(t){return o.$dO.isMarkdownString(t)?a.MarkdownString.from(t):t}fb(t,g){return g?{...this.L.toInternal(g,t),originalId:g.command}:void 0}gb(t){if(t.checkboxState===void 0)return;let g,u,$;return typeof t.checkboxState=="number"?g=t.checkboxState:(g=t.checkboxState.state,u=t.checkboxState.tooltip,$=t.checkboxState.accessibilityInformation),{isChecked:g===o.TreeItemCheckboxState.Checked,tooltip:u,accessibilityInformation:$}}hb(t){if(!o.$BO.isTreeItem(t,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(t,g,u){this.hb(g);const $=this.B(new A.$Tc),m=this.kb(t,g,u),h=this.lb(g);return{item:{handle:m,parentHandle:u?u.item.handle:void 0,label:c(g.label,this.N),description:g.description,resourceUri:g.resourceUri,tooltip:this.eb(g.tooltip),command:this.fb($,g.command),contextValue:g.contextValue,icon:h,iconDark:this.mb(g)||h,themeIcon:this.jb(g),collapsibleState:(0,I.$ng)(g.collapsibleState)?o.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation,checkbox:this.gb(g)},extensionItem:g,parent:u,children:void 0,disposableStore:$,dispose(){$.dispose()}}}jb(t){return t.iconPath instanceof o.$KO?t.iconPath:void 0}kb(t,{id:g,label:u,resourceUri:$},m,h){if(g)return`${i.b}/${g}`;const E=c(u,this.N),D=m?m.item.handle:i.a;let w=E?E.label:$?(0,R.$ch)($):"";w=w.indexOf("/")!==-1?w.replace("/","//"):w;const C=this.m.has(t)?this.m.get(t).item.handle:void 0,k=this.X(m)||[];let f,b=0;do{if(f=`${D}/${b}:${w}`,h||!this.j.has(f)||C===f)break;b++}while(b<=k.length);return f}lb(t){if(t.iconPath&&!(t.iconPath instanceof o.$KO))return typeof t.iconPath=="string"||P.URI.isUri(t.iconPath)?this.nb(t.iconPath):this.nb(t.iconPath.light)}mb(t){if(t.iconPath&&!(t.iconPath instanceof o.$KO)&&t.iconPath.dark)return this.nb(t.iconPath.dark)}nb(t){return P.URI.isUri(t)?t:P.URI.file(t)}ob(t,g){this.j.set(g.item.handle,t),this.m.set(t,g)}pb(t,g,u,$){this.j.delete(g.item.handle),this.m.delete(t),g.item.handle!==u.item.handle&&this.j.delete(u.item.handle),this.ob(t,g);const m=this.X($)||[],h=m.filter(E=>E.item.handle===u.item.handle)[0];h&&m.splice(m.indexOf(h),1,g)}qb(t,g){g?(g.children||(g.children=[]),g.children.push(t)):(this.h||(this.h=[]),this.h.push(t))}rb(t){if(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const $=this.j.get(u.item.handle);$&&this.sb($)}g.children=void 0}}else this.tb()}sb(t){const g=this.m.get(t);if(g){if(g.children)for(const u of g.children){const $=this.j.get(u.item.handle);$&&this.sb($)}this.m.delete(t),this.j.delete(g.item.handle),g.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(t=>t.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ne[262],Le([1,0,6,4,2,38,8,67,5,7]),function(ve,e,v,R,P,O,A,T,p,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wpc=void 0,A=We(A),p=We(p),o=We(o);class I extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#l;#u;#d;#h;constructor(d,r,s,c){super(),this.#o=void 0,this.#c=!0,this.#u=!1,this.#d=this.B(new v.$le),this.onDidDispose=this.#d.event,this.#h=this.B(new v.$le),this.onDidChangeViewState=this.#h.event,this.#e=d,this.#t=r,this.#n=s,this.#i=c.viewType,this.#s=c.panelOptions,this.#o=c.viewColumn,this.#r=c.title,this.#l=c.active}dispose(){this.#u||(this.#u=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(d){this.c(),this.#r!==d&&(this.#r=d,this.#t.$setTitle(this.#e,d))}get iconPath(){return this.c(),this.#a}set iconPath(d){this.c(),this.#a!==d&&(this.#a=d,this.#t.$setIconPath(this.#e,P.URI.isUri(d)?{light:d,dark:d}:d))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#l}get visible(){return this.c(),this.#c}_updateViewState(d){this.#u||(this.active!==d.active||this.visible!==d.visible||this.viewColumn!==d.viewColumn)&&(this.#l=d.active,this.#c=d.visible,this.#o=d.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(d,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof d>"u"?void 0:A.ViewColumn.from(d),preserveFocus:!!r})}c(){if(this.#u)throw new Error("Webview is disposed")}}class y extends R.$Uc{static c(){return(0,O.$1g)()}constructor(d,r,s){super(),this.j=r,this.m=s,this.g=new Map,this.h=new Map,this.f=d.getProxy(p.$JN.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(d=>d.dispose()),this.g.clear()}createWebviewPanel(d,r,s,c,l={}){const i=typeof c=="object"?c.viewColumn:c,n={viewColumn:A.ViewColumn.from(i),preserveFocus:typeof c=="object"&&!!c.preserveFocus},t=(0,T.$Spc)(d),g=y.c();this.f.$createWebviewPanel((0,T.$Upc)(d),g,r,{title:s,panelOptions:a(l),webviewOptions:(0,T.$Vpc)(d,this.m,l),serializeBuffersForPostMessage:t},n);const u=this.j.createNewWebview(g,l,d);return this.createNewWebviewPanel(g,r,s,i,l,u,!0)}$onDidChangeWebviewPanelViewStates(d){const r=Object.keys(d);r.sort((s,c)=>{const l=d[s],i=d[c];return l.active?1:i.active?-1:+l.visible-+i.visible});for(const s of r){const c=this.getWebviewPanel(s);if(!c)continue;const l=d[s];c._updateViewState({active:l.active,visible:l.visible,viewColumn:A.ViewColumn.to(l.position)})}}async $onDidDisposeWebviewPanel(d){this.getWebviewPanel(d)?.dispose(),this.g.delete(d),this.j.deleteWebview(d)}registerWebviewPanelSerializer(d,r,s){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:s,extension:d}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,T.$Spc)(d)}),new o.$LN(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(d,r,s,c){const l=this.h.get(r);if(!l)throw new Error(`No serializer found for '${r}'`);const{serializer:i,extension:n}=l,t=this.j.createNewWebview(d,s.webviewOptions,n),g=this.createNewWebviewPanel(d,r,s.title,c,s.panelOptions,t,s.active);await i.deserializeWebviewPanel(g,s.state)}createNewWebviewPanel(d,r,s,c,l,i,n){const t=new I(d,this.f,i,{viewType:r,title:s,viewColumn:c,panelOptions:l,active:n});return this.g.set(d,t),t}getWebviewPanel(d){return this.g.get(d)}}e.$Wpc=y;function a(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(Ne[263],Le([1,0,6,4,67,8,5,7]),function(ve,e,v,R,P,O,A,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$trc=void 0,A=We(A),T=We(T);class p extends R.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,a,S,d,r,s){super(),this.#s=!1,this.#l=this.B(new v.$le),this.onDidChangeVisibility=this.#l.event,this.#u=this.B(new v.$le),this.onDidDispose=this.#u.event,this.#i=S,this.#a=d,this.#e=y,this.#t=a,this.#n=r,this.#r=s}dispose(){this.#s||(this.#s=!0,this.#u.fire(),this.#n.dispose(),super.dispose())}#l;#u;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#l.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class o{constructor(y,a){this.d=a,this.b=new Map,this.c=new Map,this.a=y.getProxy(A.$JN.MainThreadWebviewViews)}registerWebviewViewProvider(y,a,S,d){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:S,extension:y}),this.a.$registerWebviewViewProvider((0,P.$Upc)(y),a,{retainContextWhenHidden:d?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$Spc)(y)}),new T.$LN(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(y,a,S,d,r){const s=this.b.get(a);if(!s)throw new Error(`No view provider found for '${a}'`);const{provider:c,extension:l}=s,i=this.d.createNewWebview(y,{},l),n=new p(y,this.a,a,S,i,!0);this.c.set(y,n),await c.resolveWebviewView(n,{state:d},r)}async $onDidChangeWebviewViewVisibility(y,a){this.e(y)._setVisible(a)}async $disposeWebviewView(y){const a=this.e(y);this.c.delete(y),a.dispose(),this.d.deleteWebview(y)}e(y){const a=this.c.get(y);if(!a)throw new Error("No webview found");return a}}e.$trc=o}),define(Ne[264],Le([1,0,6,30,31,3]),function(ve,e,v,R,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6M=e.$5M=e.OutputChannelUpdateMode=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.$TM=e.$SM=e.$RM=void 0,e.$RM="text/x-code-output",e.$SM="output",e.$TM="Log",e.$UM="text/x-code-log-output",e.$VM="log",e.$WM="workbench.panel.output",e.$XM=new P.$Vj("inOutput",!1),e.$YM=new P.$Vj("activeLogOutput",!1),e.$ZM=new P.$Vj("activeLogOutput.levelSettable",!1),e.$1M=new P.$Vj("activeLogOutput.level",""),e.$2M=new P.$Vj("activeLogOutput.levelIsDefault",!1),e.$3M=new P.$Vj("outputView.scrollLock",!1),e.$4M=(0,O.$Ei)("outputService");var A;(function(p){p[p.Append=1]="Append",p[p.Replace=2]="Replace",p[p.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$5M={OutputChannels:"workbench.contributions.outputChannels"};class T{constructor(){this.a=new Map,this.b=new v.$le,this.onDidRegisterChannel=this.b.event,this.c=new v.$le,this.onDidRemoveChannel=this.c.event}registerChannel(o){this.a.has(o.id)||(this.a.set(o.id,o),this.b.fire(o.id))}getChannels(){const o=[];return this.a.forEach(I=>o.push(I)),o}getChannel(o){return this.a.get(o)}removeChannel(o){this.a.delete(o),this.c.fire(o)}}R.$qo.add(e.$5M.OutputChannels,new T),e.$6M=new P.$Vj("activeOutputChannel","")}),define(Ne[128],Le([1,0,5,3,16,18,11,264,68,26,50,165,22,14,29,6,4]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0qc=e.$9qc=void 0;class c extends A.$fk{get disposed(){return this.n}constructor(t,g,u,$,m){super(),this.id=t,this.name=g,this.r=u,this.s=$,this.extension=m,this.m=0,this.n=!1,this.visible=!1,this.setLevel(u.getLevel()),this.B(u.onDidChangeLogLevel(h=>this.setLevel(h)))}get logLevel(){return this.getLevel()}appendLine(t){this.append(t+`
`)}append(t){this.info(t)}clear(){const t=this.m;this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Clear,t)}replace(t){const g=this.m;this.info(t),this.s.$update(this.id,T.OutputChannelUpdateMode.Replace,g),this.visible&&this.r.flush()}show(t,g){this.r.flush(),this.s.$reveal(this.id,!!(typeof t=="boolean"?t:g))}hide(){this.s.$close(this.id)}g(t,g){this.m+=a.$Ne.fromString(g).byteLength,(0,A.log)(this.r,t,g),this.visible&&(this.r.flush(),this.s.$update(this.id,T.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class l extends c{appendLine(t){this.append(t)}}let i=class{constructor(t,g,u,$,m,h){this.i=g,this.j=u,this.k=$,this.l=m,this.m=h,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=t.getProxy(v.$JN.MainThreadOutputService),this.b=this.k.extUri.joinPath(g.logsLocation,`output_logging_${(0,y.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(t){this.h=t;for(const[g,u]of this.g)u.visible=g===this.h}createOutputChannel(t,g,u){if(t=t.trim(),!t)throw new Error("illegal argument `name`. must not be falsy");const $=typeof g=="object"&&g.log,m=(0,S.$eg)(g)?g:void 0;if((0,S.$eg)(m)&&!m.trim())throw new Error("illegal argument `languageId`. must not be empty");let h;const E=this.i.environment.extensionLogLevel?.find(([w])=>O.$qn.equals(u.identifier,w))?.[1];E&&(h=(0,A.$qk)(E));const D=$?this.o(t,h,u):this.n(t,m,u);return D.then(w=>{this.g.set(w.id,w),w.visible=w.id===this.h}),$?this.r(t,h??this.m.getLevel(),D):this.q(t,D)}async n(t,g,u){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const $=await this.c,m=this.k.extUri.joinPath($,`${this.f++}-${t.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),h=this.l.createLogger(m,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),E=await this.a.$register(t,m,g,u.identifier.value);return new c(E,t,h,this.a,u)}async o(t,g,u){const $=await this.p(u),m=t.replace(/[\\/:\*\?"<>\|]/g,""),h=this.k.extUri.joinPath($,`${m}.log`),E=`${u.identifier.value}.${m}`,D=this.l.createLogger(h,{id:E,name:t,logLevel:g,extensionId:u.identifier.value});return new l(E,t,D,this.a,u)}p(t){let g=this.d.get(t.identifier.value);if(!g){const u=this.k.extUri.joinPath(this.i.logsLocation,t.identifier.value);this.d.set(t.identifier.value,g=(async()=>{try{await this.j.value.createDirectory(u)}catch($){if((0,d.$pl)($)!==d.FileSystemProviderErrorCode.FileExists)throw $}return u})())}return g}q(t,g){let u=!1;const $=()=>{if(u)throw new Error("Channel has been closed")};return{get name(){return t},append(m){$(),g.then(h=>h.append(m))},appendLine(m){$(),g.then(h=>h.appendLine(m))},clear(){$(),g.then(m=>m.clear())},replace(m){$(),g.then(h=>h.replace(m))},show(m,h){$(),g.then(E=>E.show(m,h))},hide(){$(),g.then(m=>m.hide())},dispose(){u=!0,g.then(m=>m.dispose())}}}r(t,g,u){const $=new s.$Tc,m=()=>{if($.isDisposed)throw new Error("Channel has been closed")},h=$.add(new r.$le);function E(D){g=D,h.fire(D)}return u.then(D=>{$.add(D),D.logLevel!==g&&E(D.logLevel),$.add(D.onDidChangeLogLevel(w=>E(w)))}),{...this.q(t,u),get logLevel(){return g},onDidChangeLogLevel:h.event,trace(D,...w){m(),u.then(C=>C.trace(D,...w))},debug(D,...w){m(),u.then(C=>C.debug(D,...w))},info(D,...w){m(),u.then(C=>C.info(D,...w))},warn(D,...w){m(),u.then(C=>C.warn(D,...w))},error(D,...w){m(),u.then(C=>C.error(D,...w))},dispose(){$.dispose()}}}};e.$9qc=i,e.$9qc=i=Je([Ve(0,P.$jQ),Ve(1,o.$zQ),Ve(2,p.$Opc),Ve(3,I.$rpc),Ve(4,A.$ak),Ve(5,A.$_j)],i),e.$0qc=(0,R.$Ei)("IExtHostOutputService")}),define(Ne[129],Le([1,0,3,10]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wm=e.$Vm=void 0,e.$Vm=(0,v.$Ei)("remoteAgentService"),e.$Wm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let O=1/0;for(let T=0;T<this.maxSampleCount;T++){const p=await P.getRoundTripTime();if(p===void 0)return;O=Math.min(O,p/2),await(0,R.$Fh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(O):A=this.initial.reduce((T,p)=>T+p,0)/this.initial.length,this.lastMeasurement={initial:A,current:O,average:this.average.reduce((T,p)=>T+p,0)/this.average.length,high:typeof A>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ne[265],Le([1,0,9,53,30,49,43,4,6,129,20,25,10,113]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=void 0,e.$cL=Object.freeze({id:"application",order:100,title:(0,v.localize)(12536,null),type:"object"}),e.$dL=Object.freeze({id:"workbench",order:7,title:(0,v.localize)(12537,null),type:"object"}),e.$eL=Object.freeze({id:"security",scope:R.ConfigurationScope.APPLICATION,title:(0,v.localize)(12538,null),type:"object",order:7}),e.$fL=Object.freeze({id:"problems",title:(0,v.localize)(12539,null),type:"object",order:101}),e.$gL=Object.freeze({id:"window",order:8,title:(0,v.localize)(12540,null),type:"object"}),e.$hL={ConfigurationMigration:"base.contributions.configuration.migration"};class d{constructor(){this.migrations=[],this.a=new p.$le,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const r=new d;P.$qo.add(e.$hL.ConfigurationMigration,r);let s=class extends T.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async g=>{for(const u of g.added)await this.f(u,r.migrations)})),this.c(r.migrations),this.B(r.onDidRegisterConfigurationMigration(g=>this.c(g)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(g=>this.g(g,n?.uri))])}async g(n,t){const g=this.a.inspect(n.key,{resource:t}),u=this.b.getWorkbenchState()===O.WorkbenchState.WORKSPACE?[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE],["workspaceFolder",A.ConfigurationTarget.WORKSPACE_FOLDER]]:[["user",A.ConfigurationTarget.USER],["userLocal",A.ConfigurationTarget.USER_LOCAL],["userRemote",A.ConfigurationTarget.USER_REMOTE],["workspace",A.ConfigurationTarget.WORKSPACE]];for(const[$,m]of u){const h=g[$];if(!h)continue;const E=[];if(h.value!==void 0){const D=await this.h(n,$,h.value,t,void 0);for(const w of D??[])E.push([w,[]])}for(const{identifiers:D,value:w}of h.overrides??[])if(w!==void 0){const C=await this.h(n,$,w,t,D);for(const k of C??[])E.push([k,D])}E.length&&await Promise.allSettled(E.map(async([[D,w],C])=>this.a.updateValue(D,w.value,{resource:t,overrideIdentifiers:C},m)))}}async h(n,t,g,u,$){const m=E=>{const w=this.a.inspect(E,{resource:u})[t];if(w)return $?w.overrides?.find(({identifiers:C})=>(0,y.$ho)(C,$))?.value:w.value},h=await n.migrateFn(g,m);return Array.isArray(h)?h:[[n.key,h]]}};e.$iL=s,e.$iL=s=Je([Ve(0,A.$$i),Ve(1,O.$Ni)],s);let c=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new a.$2h,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!I.$j&&(await this.b.getEnvironment())?.os!==I.OperatingSystem.Windows)return;P.$qo.as(R.$vo.Configuration).registerConfiguration({...e.$eL,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,v.localize)(12541,null)},default:[],markdownDescription:(0,v.localize)(12542,null),scope:R.ConfigurationScope.MACHINE},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,v.localize)(12543,null),scope:R.ConfigurationScope.MACHINE}}})}};e.$jL=c,e.$jL=c=Je([Ve(0,o.$Vm)],c),e.$kL="window.newWindowProfile";let l=class extends T.$Uc{static{this.ID="workbench.contrib.dynamicWindowConfiguration"}constructor(n,t){super(),this.c=n,this.f=t,this.g(),this.B(this.c.onDidChangeProfiles(g=>this.g())),this.h(),this.j(),this.B(t.onDidChangeConfiguration(g=>{g.source!==A.ConfigurationTarget.DEFAULT&&g.affectsConfiguration(e.$kL)&&this.h()})),this.B(this.c.onDidChangeProfiles(()=>this.j()))}g(){const n=P.$qo.as(R.$vo.Configuration),t={...e.$gL,properties:{[e.$kL]:{type:["string","null"],default:null,enum:[...this.c.profiles.map(g=>g.name),null],enumItemLabels:[...this.c.profiles.map(g=>""),(0,v.localize)(12544,null)],description:(0,v.localize)(12545,null),scope:R.ConfigurationScope.APPLICATION}}};this.a?n.updateConfigurations({add:[t],remove:[this.a]}):n.registerConfiguration(t),this.a=t}h(){const n=this.f.getValue(e.$kL);this.b=n?this.c.profiles.find(t=>t.name===n):void 0}j(){const n=this.f.getValue(e.$kL);if(!n)return;const t=this.b?this.c.profiles.find(g=>g.id===this.b.id):void 0;n!==t?.name&&this.f.updateValue(e.$kL,t?.name)}};e.$lL=l,e.$lL=l=Je([Ve(0,S.$Ll),Ve(1,A.$$i)],l)}),define(Ne[266],Le([1,0,41,15,19,23,9,265,53,3,30]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$nL=e.$mL=void 0,e.$oL=r,e.$pL=s,v=We(v),e.$mL=(0,o.$Ei)("editorResolverService"),e.$nL="workbench.editorAssociations";const y=I.$qo.as(p.$vo.Configuration),a={...T.$dL,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(2019,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(a);var S;(function(c){c.builtin="builtin",c.option="option",c.exclusive="exclusive",c.default="default"})(S||(e.RegisteredEditorPriority=S={}));var d;(function(c){c[c.ABORT=1]="ABORT",c[c.NONE=2]="NONE"})(d||(e.ResolvedStatus=d={}));function r(c){switch(c){case S.exclusive:return 5;case S.default:return 4;case S.builtin:return 3;case S.option:default:return 1}}function s(c,l){if(new Set([R.Schemas.extension,R.Schemas.webviewPanel,R.Schemas.vscodeWorkspaceTrust,R.Schemas.vscodeSettings]).has(l.scheme))return!1;const t=typeof c=="string"&&c.indexOf(P.$gc.sep)>=0?`${l.scheme}:${l.path}`:(0,O.$ch)(l);return v.$yk(typeof c=="string"?c.toLowerCase():c,t.toLowerCase())}}),define(Ne[267],Le([1,0,51,15,19,20,23,2,3,186,49,205,129]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$mN=e.$lN=void 0,e.$lN=(0,p.$Ei)("pathService");let d=S=class{constructor(s,c,l,i){this.d=s,this.e=c,this.f=l,this.g=i,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??s})()}hasValidBasename(s,c,l){return typeof c=="string"||typeof c>"u"?this.a.then(i=>this.h(s,i,c)):this.h(s,c,l)}h(s,c,l){return s.scheme===R.Schemas.file||s.scheme===R.Schemas.vscodeRemote?(0,v.$Bg)(l??(0,A.$ch)(s),c===O.OperatingSystem.Windows):!0}get defaultUriScheme(){return S.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,c){if(s.remoteAuthority)return R.Schemas.vscodeRemote;const l=(0,o.$iN)(c.getWorkspace());if(l)return l;const i=c.getWorkspace().folders[0];if(i)return i.uri.scheme;const n=c.getWorkspace().configuration;return n?n.scheme:R.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===O.OperatingSystem.Windows?P.$fc:P.$gc)}async fileURI(s){let c="";if(await this.a===O.OperatingSystem.Windows&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const i=s.indexOf("/",2);i===-1?(c=s.substring(2),s="/"):(c=s.substring(2,i),s=s.substring(i)||"/")}return T.URI.from({scheme:R.Schemas.file,authority:c,path:s,query:"",fragment:""})}};e.$mN=d,e.$mN=d=S=Je([Ve(1,a.$Vm),Ve(2,y.$7M),Ve(3,I.$Ni)],d)}),define(Ne[130],Le([1,0,17]),function(ve,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageTypeNew=e.ExcludeSettingOptions=e.$YL=e.$XL=e.TextSearchCompleteMessageType=e.$WL=e.$VL=void 0,e.$ZL=y;class R{constructor(S,d){this.line=S,this.character=d}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,d){return new R(0,0)}with(S){return new R(0,0)}}e.$VL=R;class P{constructor(S,d,r,s){this.isEmpty=!1,this.isSingleLine=!1,this.start=new R(S,d),this.end=new R(r,s)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new P(0,0,0,0)}with(S){return new P(0,0,0,0)}}e.$WL=P;var O;(function(a){a[a.Information=1]="Information",a[a.Warning=2]="Warning"})(O||(e.TextSearchCompleteMessageType=O={}));class A{constructor(S,d,r){this.uri=S,this.ranges=d,this.previewText=r}}e.$XL=A;class T{constructor(S,d,r){this.uri=S,this.text=d,this.lineNumber=r}}e.$YL=T;var p;(function(a){a[a.none=1]="none",a[a.filesExclude=2]="filesExclude",a[a.searchAndFilesExclude=3]="searchAndFilesExclude"})(p||(e.ExcludeSettingOptions=p={}));var o;(function(a){a[a.Information=1]="Information",a[a.Warning=2]="Warning"})(o||(e.TextSearchCompleteMessageTypeNew=o={}));function I(a){return"uri"in a&&"ranges"in a&&"preview"in a}function y(a){if(I(a)){const S=(0,v.$1b)(a.ranges).map(d=>({sourceRange:d,previewRange:d}));return new A(a.uri,S,a.preview.text)}else return new T(a.uri,a.text,a.lineNumber)}}),define(Ne[44],Le([1,0,17,41,25,51,12,3,19,13,130,10]),function(ve,e,v,R,P,O,A,T,p,o,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nM=e.$lM=e.$eM=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$bM=e.$aM=e.$_L=e.$$L=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.$2L=e.$1L=e.TextSearchCompleteMessageType=void 0,e.$8L=c,e.$9L=l,e.$0L=i,e.$cM=D,e.$dM=w,e.$fM=f,e.$gM=b,e.$hM=M,e.$iM=N,e.$jM=L,e.$kM=W,e.$mM=q,e.$oM=ae,e.$pM=we,R=We(R),P=We(P),O=We(O),p=We(p),Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return I.TextSearchCompleteMessageType}}),e.$1L="workbench.view.search",e.$2L="workbench.panel.search",e.$3L="workbench.view.search",e.$4L="search-result",e.$5L="search.exclude",e.$6L=2e4;const a="\u27EA ",S=" characters skipped \u27EB",d=(a.length+S.length+5)*2;e.$7L=(0,T.$Ei)("searchService");var r;(function(_){_[_.file=0]="file",_[_.text=1]="text",_[_.aiText=2]="aiText"})(r||(e.SearchProviderType=r={}));var s;(function(_){_[_.File=1]="File",_[_.Text=2]="Text",_[_.aiText=3]="aiText"})(s||(e.QueryType=s={}));function c(_){return!!_.preview}function l(_){return!!_.resource}function i(_){return!!_.message}var n;(function(_){_[_.Normal=0]="Normal",_[_.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class t{constructor(ce){this.resource=ce,this.results=[]}}e.$$L=t;class g{constructor(ce,me,oe,ke){this.ranges=me,this.webviewIndex=ke;const Te=Array.isArray(me)?me:[me];if(oe&&oe.matchLines===1&&u(Te)){ce=(0,A.$0f)(ce,oe.matchLines);let Z="",B=0,ne=0;const Ee=Math.floor(oe.charsPerLine/5),fe=[];for(const be of Te){const he=Math.max(be.startColumn-Ee,0),X=be.startColumn+oe.charsPerLine;if(he>ne+Ee+d){const x=a+(he-ne)+S;Z+=x+ce.slice(he,X),B+=he-(ne+x.length)}else Z+=ce.slice(ne,X);fe.push(new m(0,be.startColumn-B,be.endColumn-B)),ne=X}this.preview={text:Z,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const Z=Array.isArray(me)?me[0].startLineNumber:me.startLineNumber;this.preview={text:ce,matches:(0,v.$Zb)(me,B=>new $(B.startLineNumber-Z,B.startColumn,B.endLineNumber-Z,B.endColumn))}}}}e.$_L=g;function u(_){const ce=_[0].startLineNumber;for(const me of _)if(me.startLineNumber!==ce||me.endLineNumber!==ce)return!1;return!0}class ${constructor(ce,me,oe,ke){this.startLineNumber=ce,this.startColumn=me,this.endLineNumber=oe,this.endColumn=ke}}e.$aM=$;class m extends ${constructor(ce,me,oe){super(ce,me,ce,oe)}}e.$bM=m;var h;(function(_){_.List="list",_.Tree="tree"})(h||(e.ViewMode=h={}));var E;(function(_){_.Default="default",_.FileNames="fileNames",_.Type="type",_.Modified="modified",_.CountDescending="countDescending",_.CountAscending="countAscending"})(E||(e.SearchSortOrder=E={}));function D(_,ce=!0){const me=_&&_.files&&_.files.exclude,oe=ce&&_&&_.search&&_.search.exclude;if(!me&&!oe)return;if(!me||!oe)return me||oe||void 0;let ke=Object.create(null);return ke=P.$go(ke,P.$do(me)),ke=P.$go(ke,P.$do(oe),!0),ke}function w(_,ce){return _.excludePattern&&R.$yk(_.excludePattern,ce)?!1:_.includePattern||_.usingSearchPaths?_.includePattern&&R.$yk(_.includePattern,ce)?!0:_.usingSearchPaths?!!_.folderQueries&&_.folderQueries.some(me=>{const oe=me.folder.fsPath;if(O.$Dg(ce,oe)){const ke=p.$lc(oe,ce);return!me.includePattern||!!R.$yk(me.includePattern,ke)}else return!1}):!1:!0}var C;(function(_){_[_.unknownEncoding=1]="unknownEncoding",_[_.regexParseError=2]="regexParseError",_[_.globParseError=3]="globParseError",_[_.invalidLiteral=4]="invalidLiteral",_[_.rgProcessError=5]="rgProcessError",_[_.other=6]="other",_[_.canceled=7]="canceled"})(C||(e.SearchErrorCode=C={}));class k extends Error{constructor(ce,me){super(ce),this.code=me}}e.$eM=k;function f(_){const ce=_.message;if((0,o.$3)(_))return new k(ce,C.canceled);try{const me=JSON.parse(ce);return new k(me.message,me.code)}catch{return new k(ce,C.other)}}function b(_){const ce={message:_.message,code:_.code};return new Error(JSON.stringify(ce))}function M(_){return _.type==="error"?!0:_.type==="success"}function N(_){return _.type==="success"}function L(_){return!!_.path}function W(_,ce,me=!0){const oe=_.searchPath?_.searchPath:_.relativePath;return me?(0,A.$7f)(oe,ce):R.$yk(ce,oe)}class K{constructor(ce){this.path=ce,this.results=[]}addMatch(ce){this.results.push(ce)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$lM=K;function q(_,ce){const me={..._||{},...ce||{}};return Object.keys(me).filter(oe=>{const ke=me[oe];return typeof ke=="boolean"&&ke})}class G{constructor(ce,me){this.c=null,this.a={...ce.excludePattern||{},...me.excludePattern||{}},this.b=R.$zk(this.a);let oe=ce.includePattern;me.includePattern&&(oe?oe={...oe,...me.includePattern}:oe=me.includePattern),oe&&(this.c=R.$zk(oe))}matchesExcludesSync(ce,me,oe){return!!(this.b&&this.b(ce,me,oe))}includedInQuerySync(ce,me,oe){return!(this.b&&this.b(ce,me,oe)||this.c&&!this.c(ce,me,oe))}includedInQuery(ce,me,oe){const ke=this.b(ce,me,oe),Te=()=>this.c?!!this.c(ce,me,oe):!0;return(0,y.$qh)(ke)?ke.then(Z=>Z?!1:Te()):Te()}hasSiblingExcludeClauses(){return Q(this.a)}}e.$nM=G;function Q(_){for(const ce in _)if(typeof _[ce]!="boolean")return!0;return!1}function ae(_){if(!_)return;let ce;return me=>(ce||(ce=(_()||Promise.resolve([])).then(oe=>oe?le(oe):{})),ce.then(oe=>!!oe[me]))}function we(_){if(!_)return;let ce;return me=>{if(!ce){const oe=_();ce=oe?le(oe):{}}return!!ce[me]}}function le(_){const ce={};for(const me of _)ce[me]=!0;return ce}}),define(Ne[45],Le([1,0,17,10,21,6,4,58,15,140,23,12,2,9,29,3,11,173,49,50,26,16,8,7,65,44,5,36]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jpc=e.$Ipc=void 0;function D(L,W,K){return new I.$7g(q=>f(q,K)).isEqual(L,W)}function w(L,W,K){return D(L.uri,W.uri,K)?0:(0,y.$yf)(L.uri.toString(),W.uri.toString())}function C(L,W,K){return L.index!==W.index?L.index<W.index?-1:1:D(L.uri,W.uri,K)?(0,y.$yf)(L.name,W.name):(0,y.$yf)(L.uri.toString(),W.uri.toString())}function k(L,W,K,q){const G=L.slice(0).sort((ae,we)=>K(ae,we,q)),Q=W.slice(0).sort((ae,we)=>K(ae,we,q));return(0,v.$Db)(G,Q,(ae,we)=>K(ae,we,q))}function f(L,W){const K=W.getCapabilities(L.scheme);return!(K&&K&d.FileSystemProviderCapabilities.PathCaseSensitive)}class b extends l.$Xi{static toExtHostWorkspace(W,K,q,G){if(!W)return{workspace:null,added:[],removed:[]};const{id:Q,name:ae,folders:we,configuration:le,transient:_,isUntitled:ce}=W,me=[],oe=K;K?we.forEach((B,ne)=>{const Ee=a.URI.revive(B.uri),fe=b.o(q||K,Ee,G);fe?(fe.name=B.name,fe.index=B.index,me.push(fe)):me.push({uri:Ee,name:B.name,index:ne})}):me.push(...we.map(({uri:B,name:ne,index:Ee})=>({uri:a.URI.revive(B),name:ne,index:Ee}))),me.sort((B,ne)=>B.index<ne.index?-1:1);const ke=new b(Q,ae,me,!!_,le?a.URI.revive(le):null,!!ce,B=>f(B,G)),{added:Te,removed:Z}=k(oe?oe.workspaceFolders:[],ke.workspaceFolders,w,G);return{workspace:ke,added:Te,removed:Z}}static o(W,K,q){for(let G=0;G<W.folders.length;G++){const Q=W.workspaceFolders[G];if(D(Q.uri,K,q))return Q}}constructor(W,K,q,G,Q,ae,we){super(W,q.map(le=>new l.$Yi(le)),G,Q,we),this.t=K,this.u=ae,this.q=[],this.s=T.$Ki.forUris(we,()=>!0),q.forEach(le=>{this.q.push(le),this.s.set(le.uri,le)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,K){return K&&this.s.get(W)&&(W=(0,I.$eh)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let M=class{constructor(W,K,q,G,Q){this.c=new O.$le,this.onDidChangeWorkspace=this.c.event,this.g=new O.$le,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$ne,this.C=new Map,this.h=G,this.s=q,this.t=Q,this.j=new o.$Mm,this.k=new R.$Dh,this.o=W.getProxy(h.$JN.MainThreadWorkspace),this.q=W.getProxy(h.$JN.MainThreadMessageService);const ae=K.workspace;this.l=ae?new b(ae.id,ae.name,[],!!ae.transient,ae.configuration?a.URI.revive(ae.configuration):null,!!ae.isUntitled,we=>f(we,q)):void 0}$initializeWorkspace(W,K){this.v=K,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?a.URI.from({scheme:p.Schemas.untitled,path:(0,I.$ch)((0,I.$eh)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,K,q,...G){const Q=[];if(Array.isArray(G)&&G.forEach(ce=>{a.URI.isUri(ce.uri)&&!Q.some(me=>D(me.uri,ce.uri,this.s))&&Q.push({uri:ce.uri,name:ce.name||(0,I.$bh)(ce.uri)})}),this.n||[K,q].some(ce=>typeof ce!="number"||ce<0)||q===0&&Q.length===0)return!1;const ae=this.x?this.x.workspaceFolders:[];if(K+q>ae.length)return!1;const we=ae.slice(0);we.splice(K,q,...Q.map(ce=>({uri:ce.uri,name:ce.name||(0,I.$bh)(ce.uri),index:void 0})));for(let ce=0;ce<we.length;ce++){const me=we[ce];if(we.some((oe,ke)=>ke!==ce&&D(me.uri,oe.uri,this.s)))return!1}we.forEach((ce,me)=>ce.index=me);const{added:le,removed:_}=k(ae,we,C,this.s);if(le.length===0&&_.length===0)return!1;if(this.o){const ce=W.displayName||W.name;this.o.$updateWorkspaceFolders(ce,K,q,Q).then(void 0,me=>{this.n=void 0;const oe={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(c.Severity.Error,(0,S.localize)(10809,null,ce,me.toString()),oe,[])})}return this.y(we),!0}getWorkspaceFolder(W,K){if(this.x)return this.x.getWorkspaceFolder(W,K)}async getWorkspaceFolder2(W,K){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,K)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,K){let q,G="";if(typeof W=="string"?(q=a.URI.file(W),G=W):typeof W<"u"&&(q=W,G=W.fsPath),!q)return G;const Q=this.getWorkspaceFolder(q,!0);if(!Q)return G;typeof K>"u"&&this.x&&(K=this.x.folders.length>1);let ae=(0,I.$hh)(Q.uri,q);return K&&Q.name&&(ae=`${Q.name}/${ae}`),ae}y(W){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:K,added:q,removed:G}=b.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=K||void 0,this.n=void 0,this.c.fire(Object.freeze({added:q,removed:G}))}findFiles(W,K,q,G,Q=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let ae="",we=!0;return K===null?we=!1:K!==void 0&&(typeof K=="string"?ae=K:ae=K.pattern),this.z(W,void 0,{exclude:ae,maxResults:q,useDefaultExcludes:we,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},Q)}findFiles2(W,K={},q,G=P.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${q.value}, entryPoint: findFiles2`),this.z(void 0,W,K,G)}async z(W,K,q,G=P.CancellationToken.None){if(G&&G.isCancellationRequested)return Promise.resolve([]);const Q=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,ae={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof q.useDefaultSearchExcludes=="boolean"?!q.useDefaultSearchExcludes:!1,maxResults:q.maxResults,excludePattern:Q,shouldGlobSearch:typeof q.fuzzy=="boolean"?!q.fuzzy:!0,_reason:"startFileSearch"};let we;if(W){const{includePattern:le,folder:_}=N(g.GlobPattern.from(W));we=_,ae.includePattern=le}else{const{includePattern:le,folder:_}=N(g.GlobPattern.from(K));we=_,ae.filePattern=le}return this.o.$startFileSearch(we??null,ae,G).then(le=>Array.isArray(le)?le.map(_=>a.URI.revive(_)):[])}async findTextInFiles(W,K,q,G,Q=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const ae=this.j.getNext(),we=typeof K.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:K.previewOptions,{includePattern:le,folder:_}=N(g.GlobPattern.from(K.include)),ce=typeof K.exclude=="string"?K.exclude:K.exclude?K.exclude.pattern:void 0,me={ignoreSymlinks:typeof K.followSymlinks=="boolean"?!K.followSymlinks:void 0,disregardIgnoreFiles:typeof K.useIgnoreFiles=="boolean"?!K.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof K.useGlobalIgnoreFiles=="boolean"?!K.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof K.useParentIgnoreFiles=="boolean"?!K.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof K.useDefaultExcludes=="boolean"?!K.useDefaultExcludes:!0,disregardSearchExcludeSettings:typeof K.useSearchExclude=="boolean"?!K.useSearchExclude:!0,fileEncoding:K.encoding,maxResults:K.maxResults,previewOptions:we,afterContext:K.afterContext,beforeContext:K.beforeContext,includePattern:le,excludePattern:ce},oe=!1;if(this.u[ae]=ke=>{if(oe)return;const Te=a.URI.revive(ke.resource);ke.results.forEach(Z=>{const B=(0,E.$bi)(Z);(0,m.$8L)(B)?q({uri:Te,preview:{text:B.preview.text,matches:(0,v.$Zb)(B.preview.matches,ne=>new u.$NN(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,v.$Zb)(B.ranges,ne=>new u.$NN(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):q({uri:Te,text:B.text,lineNumber:B.lineNumber})})},Q.isCancellationRequested)return{};try{const ke=await this.o.$startTextSearch(W,_??null,me,ae,Q);return delete this.u[ae],ke||{}}catch(ke){throw delete this.u[ae],ke}}$handleTextSearchResult(W,K){this.u[K]?.(W)}async save(W){const K=await this.o.$save(W,{saveAs:!1});return a.URI.revive(K)}async saveAs(W){const K=await this.o.$save(W,{saveAs:!0});return a.URI.revive(K)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}lookupAuthorization(W){return this.o.$lookupAuthorization(W)}lookupKerberosAuthorization(W){return this.o.$lookupKerberosAuthorization(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,K){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,K);const q=this.t.transformOutgoingScheme(W),G=this.A++;return this.o.$registerEditSessionIdentityProvider(G,q),(0,A.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(G)})}async $getEditSessionIdentifier(W,K){this.h.info("Getting edit session identifier for workspaceFolder",W);const q=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",q);const G=this.w.get(q.uri.scheme);if(this.h.info(`Provider for scheme ${q.uri.scheme} is defined: `,!!G),!G)return;const Q=await G.provideEditSessionIdentity(q,K);if(this.h.info("Provider returned edit session identifier: ",Q),!!Q)return Q}async $provideEditSessionIdentityMatch(W,K,q,G){this.h.info("Getting edit session identifier for workspaceFolder",W);const Q=await this.resolveWorkspaceFolder(a.URI.revive(W));if(!Q){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Q);const ae=this.w.get(Q.uri.scheme);if(this.h.info(`Provider for scheme ${Q.uri.scheme} is defined: `,!!ae),!ae)return;const we=await ae.provideEditSessionIdentityMatch?.(K,q,G);if(this.h.info("Provider returned edit session identifier match result: ",we),!!we)return we}getOnWillCreateEditSessionIdentityEvent(W){return(K,q,G)=>{const Q=function(we){K.call(q,we)};return Q.extension=W,this.B.event(Q,void 0,G)}}async $onWillCreateEditSessionIdentity(W,K,q){const G=await this.resolveWorkspaceFolder(a.URI.revive(W));if(G===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:G},K,async(Q,ae)=>{const we=Date.now();await Promise.resolve(Q),Date.now()-we>q&&this.h.warn("SLOW edit session create-participant",ae.extension.identifier)}),K.isCancellationRequested}registerCanonicalUriProvider(W,K){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,K);const q=this.t.transformOutgoingScheme(W),G=this.A++;return this.o.$registerCanonicalUriProvider(G,q),(0,A.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(G)})}async provideCanonicalUri(W,K,q){const G=this.C.get(W.scheme);if(!G)return;const Q=await G.provideCanonicalUri?.(a.URI.revive(W),K,q);if(Q)return Q}async $provideCanonicalUri(W,K,q){return this.provideCanonicalUri(a.URI.revive(W),{targetScheme:K},q)}};e.$Ipc=M,e.$Ipc=M=Je([Ve(0,t.$jQ),Ve(1,n.$zQ),Ve(2,i.$rpc),Ve(3,s.$_j),Ve(4,$.$Gpc)],M),e.$Jpc=(0,r.$Ei)("IExtHostWorkspace");function N(L){let W,K;return L&&(typeof L=="string"?W=L:(W=L.pattern,K=a.URI.revive(L.baseUri))),{includePattern:W,folder:K}}}),define(Ne[46],Le([1,0,25,6,45,5,7,43,174,53,14,10,3,16,11,2]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpc=e.$Lpc=e.$Kpc=void 0;function s($,m){if(m){const h=m.split(".");let E=$;for(let D=0;E&&D<h.length;D++)E=E[h[D]];return E}}function c($){return $ instanceof r.URI}function l($){return $&&$.uri instanceof r.URI&&$.languageId&&typeof $.languageId=="string"}function i($){return $&&!$.uri&&$.languageId&&typeof $.languageId=="string"}function n($){return $&&$.uri instanceof r.URI&&(!$.name||typeof $.name=="string")&&(!$.index||typeof $.index=="number")}function t($){if(c($))return{resource:$};if(l($))return{resource:$.uri,overrideIdentifier:$.languageId};if(i($))return{overrideIdentifier:$.languageId};if(n($))return{resource:$.uri};if($===null)return{resource:null}}let g=class{constructor(m,h,E){this.a=m.getProxy(O.$JN.MainThreadConfiguration),this.c=h,this.b=E,this.d=new y.$Dh,this.e=null}getConfigProvider(){return this.d.wait().then(m=>this.e)}$initializeConfiguration(m){this.e=new u(this.a,this.c,m,this.b),this.d.open()}$acceptConfigurationChanged(m,h){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(m,h))}};e.$Kpc=g,e.$Kpc=g=Je([Ve(0,S.$jQ),Ve(1,P.$Jpc),Ve(2,d.$_j)],g);class u{constructor(m,h,E,D){this.a=new R.$le,this.b=m,this.f=D,this.c=h,this.e=p.$Qo.parse(E,D),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(m,h){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Qo.parse(m,this.f),this.d=this.k(m.configurationScopes),this.a.fire(this.j(h,E))}getConfiguration(m,h,E){const D=t(h)||{},w=this.g(m?s(this.e.getValue(void 0,D,this.c.workspace),m):this.e.getValue(void 0,D,this.c.workspace));m&&this.h(m,D,E?.identifier);function C(f){if(f==null)return null;if(typeof f=="boolean")return f?T.ConfigurationTarget.USER:T.ConfigurationTarget.WORKSPACE;switch(f){case A.ConfigurationTarget.Global:return T.ConfigurationTarget.USER;case A.ConfigurationTarget.Workspace:return T.ConfigurationTarget.WORKSPACE;case A.ConfigurationTarget.WorkspaceFolder:return T.ConfigurationTarget.WORKSPACE_FOLDER}}const k={has(f){return typeof s(w,f)<"u"},get:(f,b)=>{this.h(m?`${m}.${f}`:f,D,E?.identifier);let M=s(w,f);if(typeof M>"u")M=b;else{let N;const L=(W,K)=>{if((0,I.$gg)(W)){let q;const G=()=>{N=N||(0,v.$do)(w),q=q||s(N,K)};return new Proxy(W,{get:(Q,ae)=>{if(typeof ae=="string"&&ae.toLowerCase()==="tojson")return G(),()=>q;if(N)return q=q||s(N,K),q[ae];const we=Q[ae];return typeof ae=="string"?L(we,`${K}.${ae}`):we},set:(Q,ae,we)=>(G(),q&&(q[ae]=we),!0),deleteProperty:(Q,ae)=>(G(),q&&delete q[ae],!0),defineProperty:(Q,ae,we)=>(G(),q&&Object.defineProperty(q,ae,we),!0)})}return Array.isArray(W)?(0,v.$do)(W):W};M=L(M,f)}return M},update:(f,b,M,N)=>{f=m?`${m}.${f}`:f;const L=C(M);return b!==void 0?this.b.$updateConfigurationOption(L,f,b,D,N):this.b.$removeConfigurationOption(L,f,D,N)},inspect:f=>{f=m?`${m}.${f}`:f;const b=this.e.inspect(f,D,this.c.workspace);if(b)return{key:f,defaultValue:(0,v.$do)(b.policy?.value??b.default?.value),globalValue:(0,v.$do)(b.user?.value??b.application?.value),workspaceValue:(0,v.$do)(b.workspace?.value),workspaceFolderValue:(0,v.$do)(b.workspaceFolder?.value),defaultLanguageValue:(0,v.$do)(b.default?.override),globalLanguageValue:(0,v.$do)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,v.$do)(b.workspace?.override),workspaceFolderLanguageValue:(0,v.$do)(b.workspaceFolder?.override),languageIds:(0,v.$do)(b.overrideIdentifiers)}}};return typeof w=="object"&&(0,v.$go)(k,w,!1),Object.freeze(k)}g(m){const h=E=>(0,I.$gg)(E)?new Proxy(E,{get:(D,w)=>h(D[w]),set:(D,w,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(D,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(D,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return h(m)}h(m,h,E){const D=o.$Fo.test(m)?o.ConfigurationScope.RESOURCE:this.d.get(m),w=E?`[${E.value}] `:"";if(o.ConfigurationScope.RESOURCE===D){typeof h?.resource>"u"&&this.f.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${m}', provide the URI of a resource or 'null' for any resource.`);return}if(o.ConfigurationScope.WINDOW===D){h?.resource&&this.f.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${m}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(m,h){const E=new p.$So(m,h,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(D,w)=>E.affectsConfiguration(D,t(w))})}k(m){return m.reduce((h,E)=>(h.set(E[0],E[1]),h),new Map)}}e.$Lpc=u,e.$Mpc=(0,a.$Ei)("IExtHostConfiguration")}),define(Ne[131],Le([1,0,2,10,6,5,7,45,57,46,21,56,16,26,3,15,20,11,84,209,13]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$krc=e.$jrc=e.$irc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0,A=We(A),s=We(s);var t;(function(N){function L(K){if(K!=null)return K}N.from=L;function W(K){if(K!=null)return K}N.to=W})(t||(t={}));var g;(function(N){function L(K){if(K!=null)return K}N.from=L;function W(K){if(K!=null)return K}N.to=W})(g||(g={}));var u;(function(N){function L(K){if(K!=null)return K}N.from=L;function W(K){if(K!=null)return K}N.to=W})(u||(u={}));var $;(function(N){function L(q){if(q){const G=q;return G&&!!G.process}else return!1}N.is=L;function W(q){if(q==null)return;const G={process:q.process,args:q.args};return q.options&&(G.options=u.from(q.options)),G}N.from=W;function K(q){if(q!=null)return new A.$xO(q.process,q.args,q.options)}N.to=K})($||($={}));var m;(function(N){function L(K){if(K!=null)return K}N.from=L;function W(K){if(K!=null)return K}N.to=W})(m||(m={}));var h;(function(N){function L(q){if(q){const G=q;return G&&(!!G.commandLine||!!G.command)}else return!1}N.is=L;function W(q){if(q==null)return;const G={};return q.commandLine!==void 0?G.commandLine=q.commandLine:(G.command=q.command,G.args=q.args),q.options&&(G.options=m.from(q.options)),G}N.from=W;function K(q){if(!(q==null||q.command===void 0&&q.commandLine===void 0))return q.commandLine?new A.$yO(q.commandLine,q.options):new A.$yO(q.command,q.args?q.args:[],q.options)}N.to=K})(h||(h={}));var E;(function(N){function L(q){if(q){const G=q;return G&&G.customExecution==="customExecution"}else return!1}N.is=L;function W(q){return{customExecution:"customExecution"}}N.from=W;function K(q,G){return G.get(q)}N.to=K})(E||(e.CustomExecutionDTO=E={}));var D;(function(N){function L(W,K){let q;return W.scope!==void 0&&typeof W.scope!="number"?q=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===A.TaskScope.Workspace&&K&&K.workspaceFile?q=K.workspaceFile:q=i.$UI),{id:W._id,workspaceFolder:q}}N.from=L})(D||(e.TaskHandleDTO=D={}));var w;(function(N){function L(W){if(W!=null)return{_id:W.id,isDefault:W.isDefault}}N.from=L})(w||(w={}));var C;(function(N){function L(q,G){if(q==null)return[];const Q=[];for(const ae of q){const we=W(ae,G);we&&Q.push(we)}return Q}N.fromMany=L;function W(q,G){if(q==null)return;let Q;q.execution instanceof A.$xO?Q=$.from(q.execution):q.execution instanceof A.$yO?Q=h.from(q.execution):q.execution&&q.execution instanceof A.$zO&&(Q=E.from(q.execution));const ae=t.from(q.definition);let we;return q.scope?typeof q.scope=="number"?we=q.scope:we=q.scope.uri:we=A.TaskScope.Workspace,!ae||!we?void 0:{_id:q._id,definition:ae,name:q.name,source:{extensionId:G.identifier.value,label:q.source,scope:we},execution:Q,isBackground:q.isBackground,group:w.from(q.group),presentationOptions:g.from(q.presentationOptions),problemMatchers:q.problemMatchers,hasDefinedMatchers:q.hasDefinedMatchers,runOptions:q.runOptions?q.runOptions:{reevaluateOnRerun:!0},detail:q.detail}}N.from=W;async function K(q,G,Q){if(q==null)return;let ae;$.is(q.execution)?ae=$.to(q.execution):h.is(q.execution)?ae=h.to(q.execution):E.is(q.execution)&&(ae=E.to(q._id,Q));const we=t.to(q.definition);let le;if(q.source&&(q.source.scope!==void 0?typeof q.source.scope=="number"?le=q.source.scope:le=await G.resolveWorkspaceFolder(v.URI.revive(q.source.scope)):le=A.TaskScope.Workspace),!we||!le)return;const _=new A.$AO(we,le,q.name,q.source.label,ae,q.problemMatchers);return q.isBackground!==void 0&&(_.isBackground=q.isBackground),q.group!==void 0&&(_.group=A.$wO.from(q.group._id),_.group&&q.group.isDefault&&(_.group=new A.$wO(_.group.id,_.group.label),q.group.isDefault===!0&&(_.group.isDefault=q.group.isDefault))),q.presentationOptions&&(_.presentationOptions=g.to(q.presentationOptions)),q._id&&(_._id=q._id),q.detail&&(_.detail=q.detail),_}N.to=K})(C||(e.TaskDTO=C={}));var k;(function(N){function L(K){return K}N.from=L;function W(K){if(K)return Object.assign(Object.create(null),K)}N.to=W})(k||(k={}));class f{#e;constructor(L,W,K){this._id=W,this.a=K,this.#e=L}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(L){}fireDidEndProcess(L){}}let b=class{constructor(L,W,K,q,G,Q,ae,we){this.q=new P.$le,this.r=new P.$le,this.s=new P.$le,this.u=new P.$le,this.a=L.getProxy(O.$JN.MainThreadTask),this.b=K,this.c=q,this.d=G,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(L,W,K){if(!K)return new A.$LN(()=>{});const q=this.x();return this.j.set(q,{type:W,provider:K,extension:L}),this.a.$registerTaskProvider(q,W),new A.$LN(()=>{this.j.delete(q),this.a.$unregisterTaskProvider(q)})}registerTaskSystem(L,W){this.a.$registerTaskSystem(L,W)}fetchTasks(L){return this.a.$fetchTasks(k.from(L)).then(async W=>{const K=[];for(const q of W){const G=await C.to(q,this.b,this.m);G&&K.push(G)}return K})}get taskExecutions(){const L=[];return this.k.forEach(W=>L.push(W)),L}terminateTask(L){if(!(L instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(L._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(L,W,K){const q=this.m.get(L.id);q&&(this.o.set(L.id,q),this.e.attachPtyToTerminal(W,await q.callback(K))),this.p=L.id,this.q.fire({execution:await this.z(L)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(L){if(!this.l.has(L.id))return;const W=await this.z(L);this.l.delete(L.id),this.k.delete(L.id),this.B(L),this.r.fire({execution:W})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(L){const W=await this.z(L.id);this.s.fire({execution:W,processId:L.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(L){const W=await this.z(L.id);this.u.fire({execution:W,exitCode:L.exitCode})}$provideTasks(L,W){const K=this.j.get(L);if(!K)return Promise.reject(new Error("no handler found"));const q=[],G=(0,R.$wh)(()=>K.provider.provideTasks(I.CancellationToken.None)).then(Q=>this.v(W,q,K,Q));return new Promise(Q=>{G.then(ae=>{Promise.all(q).then(()=>{Q(ae)})})})}async $resolveTask(L,W){const K=this.j.get(L);if(!K)return Promise.reject(new Error("no handler found"));if(W.definition.type!==K.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${K.type}].`);const q=await C.to(W,this.b,this.m);if(!q)throw new Error("Unexpected: Task cannot be resolved.");const G=await K.provider.resolveTask(q,I.CancellationToken.None);if(!G)return;this.A(G,K);const Q=C.from(G,K.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==q.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return E.is(Q.execution)&&await this.y(Q,G,!0),await this.w(Q)}x(){return this.h++}async y(L,W,K){const q=await this.a.$createTaskId(L);!K&&!this.m.has(q)&&(this.n.add(q),this.o.set(q,W.execution)),this.m.set(q,W.execution)}async z(L,W){if(typeof L=="string"){const G=this.l.get(L);if(!G)throw new n.$ab("Unexpected: The specified task is missing an execution");return G}const K=this.l.get(L.id);if(K)return K;let q;return W?q=Promise.resolve(new f(this,L.id,W)):q=C.to(L.task,this.b,this.m).then(G=>{if(!G)throw new n.$ab("Unexpected: Task does not exist.");return new f(this,L.id,G)}),this.l.set(L.id,q),q.then(G=>(this.k.set(L.id,G),G))}A(L,W){L._deprecated&&this.g.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}B(L){this.o.get(L.id)&&this.o.delete(L.id),this.n.has(L.id)&&this.p!==L.id&&(this.m.delete(L.id),this.n.delete(L.id));const K=this.n.values();let q=K.next();for(;!q.done;)!this.o.has(q.value)&&this.p!==q.value&&(this.m.delete(q.value),this.n.delete(q.value)),q=K.next()}};e.$irc=b,e.$irc=b=Je([Ve(0,a.$jQ),Ve(1,S.$zQ),Ve(2,T.$Jpc),Ve(3,p.$uQ),Ve(4,o.$Mpc),Ve(5,y.$$pc),Ve(6,c.$_j),Ve(7,l.$npc)],b);let M=class extends b{constructor(L,W,K,q,G,Q,ae,we){super(L,W,K,q,G,Q,ae,we),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:s.$i(s.Platform.Web)})}async executeTask(L,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const K=C.from(W,L);if(K===void 0)throw new Error("Task is not valid");if(E.is(K.execution))await this.y(K,W,!1);else throw new n.$$;const q=await this.z(await this.a.$getTaskExecution(K),W);return this.a.$executeTask(K).catch(G=>{throw new Error(G)}),q}v(L,W,K,q){const G=[];if(q)for(const Q of q){if(this.A(Q,K),!Q.definition||!L[Q.definition.type]){const we=Q.source?Q.source:"No task source";this.f.warn(`The task [${we}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=C.from(Q,K.extension);ae&&E.is(ae.execution)?(G.push(ae),W.push(this.y(ae,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:G,extension:K.extension}}async w(L){if(E.is(L.execution))return L;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(L,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(L,W,K){}};e.$jrc=M,e.$jrc=M=Je([Ve(0,a.$jQ),Ve(1,S.$zQ),Ve(2,T.$Jpc),Ve(3,p.$uQ),Ve(4,o.$Mpc),Ve(5,y.$$pc),Ve(6,c.$_j),Ve(7,l.$npc)],M),e.$krc=(0,d.$Ei)("IExtHostTask")}),define(Ne[268],Le([1,0,44,32]),function(ve,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wM=void 0,e.$vM=P,e.$xM=O;function P(A){return"cellResults"in A}e.$wM="rawCell#";function O(A,T){let p=-1;const o=[];let I=[];return A.forEach(a=>{a.range.startLineNumber!==p&&I.length>0&&(o.push([...I]),I=[]),I.push(a),p=a.range.endLineNumber}),I.length>0&&o.push([...I]),o.map(a=>{const S=[],d=a[0].range.startLineNumber,r=a[a.length-1].range.endLineNumber;for(let s=d;s<=r;s++)S.push(T.getLineContent(s));return new v.$_L(S.join(`
`)+`
`,a.map(s=>new R.$Nt(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}}),define(Ne[269],Le([1,0,9,22,6,4,28,37,12,14,2,29,79,5,33,8,7,39,246,124,25,15,44,199,268,266]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wqc=void 0,y=We(y),r=We(r),s=We(s);class h{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,w,C,k,f,b,M){this.q=C,this.r=k,this.s=f,this.t=b,this.u=M,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new P.$le,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$le,this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$le,this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$le,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new a.$lpc("NotebookCellStatusBarCache"),this.x=0,this.y=new Map,this.b=D.getProxy(S.$JN.MainThreadNotebook),this.c=D.getProxy(S.$JN.MainThreadNotebookDocuments),this.d=D.getProxy(S.$JN.MainThreadNotebookEditors),this.i=w.converter,w.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===T.MarshalledId.NotebookCellActionContext){const L=N.notebookEditor?.notebookUri,W=N.cell.handle,q=this.g.get(L)?.getCell(W);if(q)return q.apiCell}if(N&&N.$mid===T.MarshalledId.NotebookActionContext){const L=N.uri,W=this.g.get(L);if(W)return W.apiNotebook}return N}}),h.C(w)}getEditorById(D){const w=this.h.get(D);if(!w)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return w}getIdByEditor(D){for(const[w,C]of this.h)if(C.apiEditor===D)return w}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,w){const C=this.g.get(D);if(!C&&!w)throw new Error(`NO notebook document for '${D}'`);return C}static w(D,w){if(!w)return;const C=w.filenamePattern.map(k=>r.NotebookExclusiveDocumentPattern.from(k)).filter(k=>k!==void 0);if(w.filenamePattern&&!C){console.warn(`Notebook content provider view options file name pattern is invalid ${w.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:w.displayName,filenamePattern:C,priority:w.exclusive?m.RegisteredEditorPriority.exclusive:void 0}}registerNotebookCellStatusBarItemProvider(D,w,C){const k=h.a++,f=typeof C.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(k,C),this.b.$registerNotebookCellStatusBarItemProvider(k,f,w);let b;return f!==void 0&&(b=C.onDidChangeCellStatusBarItems(M=>this.b.$emitCellStatusBarEvent(f))),new s.$LN(()=>{this.f.delete(k),this.b.$unregisterNotebookCellStatusBarItemProvider(k,f),b?.dispose()})}async createNotebookDocument(D){const w=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&r.NotebookData.from(D.content)});return I.URI.revive(w)}async openNotebookDocument(D){const w=this.g.get(D);if(w)return w.apiNotebook;const C=await this.c.$tryOpenNotebook(D),k=this.g.get(I.URI.revive(C));return(0,o.$pg)(k?.apiNotebook)}async showNotebookDocument(D,w){I.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let C;typeof w=="object"?C={position:r.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus,selections:w.selections&&w.selections.map(r.NotebookRange.from),pinned:typeof w.preview=="boolean"?!w.preview:void 0}:C={preserveFocus:!1};const k=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,C),f=k&&this.h.get(k)?.apiEditor;if(f)return f;throw k?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,w,C,k){const f=this.f.get(D),b=I.URI.revive(w),M=this.g.get(b);if(!M||!f)return;const N=M.getCellFromIndex(C);if(!N)return;const L=await f.provideCellStatusBarItems(N.apiCell,k);if(!L)return;const W=new O.$Tc,K=this.p.add([W]),G=(Array.isArray(L)?L:[L]).map(Q=>r.NotebookStatusBarItem.from(Q,this.i,W));return{cacheId:K,items:G}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,w,C,k,f){if((0,p.$cf)(w))throw new Error("viewType cannot be empty or just whitespace");const b=this.x++;return this.y.set(b,{viewType:w,serializer:C,options:k}),this.b.$registerNotebookSerializer(b,{id:D.identifier,location:D.extensionLocation},w,r.NotebookDocumentContentOptions.from(k),h.w(D,f)),(0,O.$Sc)(()=>{this.b.$unregisterNotebookSerializer(b)})}async $dataToNotebook(D,w,C){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const f=await k.serializer.deserializeNotebook(w.buffer,C);return new c.$Ww(r.NotebookData.from(f))}async $notebookToData(D,w,C){const k=this.y.get(D);if(!k)throw new Error("NO serializer found");const f=await k.serializer.serializeNotebook(r.NotebookData.to(w.value),C);return R.$Ne.wrap(f)}async $saveNotebook(D,w,C,k,f){const b=I.URI.revive(w),M=this.y.get(D);if(this.D(`enter saveNotebook(versionId: ${C}, ${b.toString()})`),!M)throw new Error("NO serializer found");const N=this.g.get(b);if(!N)throw new Error("Document NOT found");if(N.versionId!==C)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(b.scheme))throw new y.$ul((0,v.localize)(10817,null,this.A(b)),y.FileOperationResult.FILE_PERMISSION_DENIED);const L={metadata:(0,n.$lo)(N.apiNotebook.metadata,Q=>!(M.options?.transientDocumentMetadata??{})[Q]),cells:[]};for(const Q of N.apiNotebook.getCells()){const ae=new s.$eP(Q.kind,Q.document.getText(),Q.document.languageId,Q.mime,M.options?.transientOutputs?[]:[...Q.outputs],Q.metadata,Q.executionSummary);ae.metadata=(0,n.$lo)(Q.metadata,we=>!(M.options?.transientCellMetadata??{})[we]),L.cells.push(ae)}if(await this.z(b,k),f.isCancellationRequested)throw new Error("canceled");const W=await M.serializer.serializeNotebook(L,f);if(f.isCancellationRequested)throw new Error("canceled");this.D(`serialized versionId: ${C} ${b.toString()}`),await this.s.value.writeFile(b,W),this.D(`Finished write versionId: ${C} ${b.toString()}`);const K=this.s.getFileSystemProviderExtUri(b.scheme),q=await this.s.value.stat(b),G={name:K.basename(b),isFile:(q.type&y.FileType.File)!==0,isDirectory:(q.type&y.FileType.Directory)!==0,isSymbolicLink:(q.type&y.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&y.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(b.scheme),locked:!!((q.permissions??0)&y.FilePermission.Locked),etag:y.$Fl({mtime:q.mtime,size:q.size}),children:void 0};return this.D(`exit saveNotebook(versionId: ${C}, ${b.toString()})`),G}async $searchInNotebooks(D,w,C,k,f){const b=this.y.get(D)?.serializer;if(!b)return{limitHit:!1,results:[]};const M=new A.$Bc;await(async(q,G,Q)=>{await Promise.all(q.map(async ae=>await Promise.all(ae.filenamePatterns.map(we=>{const le={_reason:Q._reason,folderQueries:Q.folderQueries,includePattern:Q.includePattern,excludePattern:Q.excludePattern,maxResults:Q.maxResults,type:g.QueryType.File,filePattern:we};return this.t.doInternalFileSearchWithCustomCallback(le,G,_=>{_.forEach(ce=>{M.has(ce)||k.some(oe=>ae.isFromSettings&&!oe.isFromSettings?!1:oe.filenamePatterns.some(ke=>(0,m.$pL)(ke,ce)))||M.add(ce)})}).catch(_=>{if(_.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw _})}))))})(C,f,w);const L=new A.$Ac;let W=!1;const K=Array.from(M).map(async q=>{const G=[];try{if(f.isCancellationRequested)return;if(w.maxResults&&[...L.values()].reduce((le,_)=>le+_.cellResults.length,0)>w.maxResults){W=!0;return}const Q=[],ae=this.g.get(q);if(ae)ae.apiNotebook.getCells().forEach(_=>Q.push({input:_.document.getText(),outputs:_.outputs.flatMap(ce=>ce.items.map(me=>me.data.toString()))}));else{const le=await this.s.value.readFile(q),_=R.$Ne.fromString(le.toString()),ce=await b.deserializeNotebook(_.buffer,f);if(f.isCancellationRequested)return;r.NotebookData.from(ce).cells.forEach(oe=>Q.push({input:oe.source,outputs:oe.outputs.flatMap(ke=>ke.items.map(Te=>Te.valueBytes.toString()))}))}if(f.isCancellationRequested)return;Q.forEach((le,_)=>{const ce=w.contentPattern.pattern,me=new u.$f1b(le.input,void 0,le.outputs),oe=me.findInInputs(ce),ke=me.findInOutputs(ce),Te=ke.flatMap(Z=>(0,$.$xM)(Z.matches,Z.textBuffer)).map((Z,B)=>(Z.webviewIndex=B,Z));if(oe.length>0||ke.length>0){const Z={index:_,contentResults:(0,$.$xM)(oe,me.inputTextBuffer),webviewResults:Te};G.push(Z)}});const we={resource:q,cellResults:G};L.set(q,we);return}catch{return}});return await Promise.all(K),{limitHit:W,results:[...L.values()]}}async z(D,w){const C=await this.s.value.stat(D);if(typeof w?.mtime=="number"&&typeof w.etag=="string"&&w.etag!==y.$El&&typeof C.mtime=="number"&&typeof C.size=="number"&&w.mtime<C.mtime&&w.etag!==y.$Fl({mtime:w.mtime,size:C.size}))throw new y.$ul((0,v.localize)(10818,null),y.FileOperationResult.FILE_MODIFIED_SINCE,w)}A(D){return D.scheme===t.Schemas.file?D.fsPath:D.toString()}B(D,w,C){if(this.h.has(w))throw new Error(`editor with id ALREADY EXSIST: ${w}`);const k=new i.$Nqc(w,this.d,D,C.visibleRanges.map(r.NotebookRange.to),C.selections.map(r.NotebookRange.to),typeof C.viewColumn=="number"?r.ViewColumn.to(C.viewColumn):void 0);this.h.set(w,k)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const C of D.value.removedDocuments){const k=I.URI.revive(C),f=this.g.get(k);f&&(f.dispose(),this.g.delete(k),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(b=>b.document.uri)}),this.n.fire(f.apiNotebook));for(const b of this.h.values())b.notebookData.uri.toString()===k.toString()&&this.h.delete(b.id)}if(D.value.addedDocuments){const C=[];for(const k of D.value.addedDocuments){const f=I.URI.revive(k.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const b=new l.$Mqc(this.c,this.q,this.r,f,k);C.push(...k.cells.map(M=>l.$Lqc.asModelAddData(M))),this.g.get(f)?.dispose(),this.g.set(f,b),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:C}),this.m.fire(b.apiNotebook)}}if(D.value.addedEditors)for(const C of D.value.addedEditors){if(this.h.has(C.id))return;const k=I.URI.revive(C.documentUri),f=this.g.get(k);f&&this.B(f,C.id,C)}const w=[];if(D.value.removedEditors)for(const C of D.value.removedEditors){const k=this.h.get(C);k&&(this.h.delete(C),this.k?.id===k.id&&(this.k=void 0),w.push(k))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(k=>this.h.get(k)).filter(k=>!!k);const C=new Set;this.l.forEach(k=>C.add(k.id));for(const k of this.h.values()){const f=C.has(k.id);k._acceptVisibility(f)}this.l=[...this.h.values()].map(k=>k).filter(k=>k.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static C(D){const w=d.$HQ.String.with("notebookType","A notebook type"),C=new d.$JQ("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[w,new d.$HQ("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>R.$Ne.wrap(f))],new d.$IQ("Notebook Data",f=>r.NotebookData.to(f.value))),k=new d.$JQ("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[w,new d.$HQ("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new c.$Ww(r.NotebookData.from(f)))],new d.$IQ("Bytes",f=>f.buffer));D.registerApiCommand(C),D.registerApiCommand(k)}D(D){this.u.trace(`[Extension Host Notebook] ${D}`)}}e.$Wqc=h}),define(Ne[270],Le([1,0,19,21,42,41,23,69,44]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oqc=void 0,v=We(v),O=We(O),A=We(A);class o{constructor(a,S,d){this.k=a,this.l=S,this.o=d,this.e=!1,this.f=0,this.g=!1,this.a=a.filePattern,this.b=a.includePattern&&O.$zk(a.includePattern),this.c=a.maxResults||void 0,this.d=a.exists,this.h=new Set,this.j=a.excludePattern&&O.$zk(a.excludePattern)}cancel(){this.g=!0,this.h.forEach(a=>a.cancel()),this.h=new Set}search(a){const S=this.k.folderQueries||[];return new Promise((d,r)=>{const s=c=>{this.f++,a(c)};if(this.g)return d({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(c=>{const l=c.toString(),i=v.$nc(l);this.j&&this.j(l,i)||this.v(s,{base:c,basename:i})}),Promise.all(S.map(c=>this.p(c,s))).then(c=>{d({limitHit:this.e,stats:c[0]||void 0})},c=>{r(new Error((0,P.$pj)(c)))})})}async p(a,S){const d=new R.$we,r=this.q(a),s=this.r(),c=new p.$nM(this.k,a),l=!c.hasSiblingExcludeClauses();let i;try{this.h.add(d),i=T.$fe.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,d.token),t=i.elapsed(),g=T.$fe.create();return this.g&&!this.e||(n&&n.forEach(u=>{const $=v.$gc.relative(a.folder.path,u.path);if(l){const m=v.$nc(u.path);this.v(S,{base:a.folder,relativePath:$,basename:m});return}this.s(s,a.folder,$,S)}),this.g&&!this.e)?null:(this.u(s,c,S),{providerTime:t,postProcessTime:g.elapsed()})}finally{d.dispose(),this.h.delete(d)}}q(a){const S=(0,p.$mM)(this.k.includePattern,a.includePattern),d=(0,p.$mM)(this.k.excludePattern,a.excludePattern);return{folder:a.folder,excludes:d,includes:S,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}s({pathToEntries:a},S,d,r){if(d===this.a){const c=v.$nc(this.a);this.v(r,{base:S,relativePath:this.a,basename:c})}function s(c){const l=v.$nc(c),i=v.$mc(c);let n=a[i];n||(n=a[i]=[],s(i)),n.push({base:S,relativePath:c,basename:l})}s(d)}u({rootEntries:a,pathToEntries:S},d,r){const s=this,c=this.a;function l(i){const n=(0,p.$pM)(()=>i.map(t=>t.basename));for(let t=0,g=i.length;t<g;t++){const u=i[t],{relativePath:$,basename:m}=u;if(d.matchesExcludesSync($,m,c!==m?n:void 0))continue;const h=S[$];if(h)l(h);else{if($===c)continue;s.v(r,u)}if(s.e)break}}l(a)}v(a,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||a(S))}}class I{constructor(){this.b=new Map}static{this.a=512}fileSearch(a,S,d,r){const s=this.c(a.cacheKey),c=new o(a,S,s&&s.token);let l=0;const i=n=>{l+=n.length,d(n.map(t=>this.d(t)))};return this.e(c,I.a,i,r).then(n=>({limitHit:n.limitHit,stats:n.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:l,detailStats:n.stats}:void 0,messages:[]}))}clearCache(a){this.c(a)?.cancel()}c(a){if(a)return this.b.has(a)||this.b.set(a,new R.$we),this.b.get(a)}d(a){return a.relativePath?{resource:A.$fh(a.base,a.relativePath)}:{resource:a.base}}e(a,S,d,r){const s=r.onCancellationRequested(()=>{a.cancel()}),c=i=>{i&&(l.push(i),S>0&&l.length>=S&&(d(l),l=[]))};let l=[];return a.search(c).then(i=>(l.length&&d(l),s.dispose(),i),i=>(l.length&&d(l),s.dispose(),Promise.reject(i)))}}e.$Oqc=I}),define(Ne[271],Le([1,0,17,240,41,99,28,15,19,23,12,14,2,102,9,43,11,49,118,267,44]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nN=void 0,e.$oN=w,v=We(v),R=We(R),P=We(P),p=We(p),I=We(I),d=We(d);let t=class{constructor(k,f,b,M,N){this.a=k,this.b=f,this.c=b,this.d=M,this.e=N}text(k,f,b={}){k=this.f(k,b);const M=this.a.getValue(),N=f&&f.some(W=>!this.a.getValue({resource:W}).search.useRipgrep);return{...this.h(f?.map(c.$Zi),b),type:n.QueryType.Text,contentPattern:k,previewOptions:b.previewOptions,maxFileSize:b.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:b.beforeContext,afterContext:b.afterContext,userDisabledExcludesAndIgnoreFiles:b.disregardExcludeSettings&&b.disregardIgnoreFiles}}f(k,f){const b=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const M={...k,wordSeparators:b.editor.wordSeparators};return this.j(k,f)&&(M.isCaseSensitive=!0),this.k(k)&&(M.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),M}file(k,f={}){return{...this.h(k,f),type:n.QueryType.File,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey,shouldGlobMatchFilePattern:f.shouldGlobSearch}}g(k,f){return k?(k=Array.isArray(k)?k.map(h):h(k),f?this.parseSearchPaths(k):{pattern:u(...Array.isArray(k)?k:[k])}):{}}h(k=[],f={}){const b=this.g(f.includePattern,f.expandPatterns),M=this.g(f.excludePattern,f.expandPatterns),N=k.length>1,L=(b.searchPaths&&b.searchPaths.length?b.searchPaths.map(q=>this.q(q,f,M)):k.map(q=>this.r(q,f,M,N))).filter(q=>!!q),W={_reason:f._reason,folderQueries:L,usingSearchPaths:!!(b.searchPaths&&b.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:M.pattern,includePattern:b.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const q=v.$Gb(this.c.groups.flatMap(ae=>ae.editors.map(we=>we.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const G=q.filter(ae=>(0,n.$dM)(W,ae.fsPath)),Q=this.i(G);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...W,...Q}}const K=f.extraFileResources&&f.extraFileResources.filter(q=>(0,n.$dM)(W,q.fsPath));return W.extraFileResources=K&&K.length?K:void 0,W}i(k){const f=[],b=new A.$Ac,M={};let N=!1;return k.forEach(L=>{if(L.scheme===T.Schemas.walkThrough)return;if((0,o.$jh)(L)){const K=this.b.getWorkspaceFolder(L)?.uri??L.with({path:p.$mc(L.fsPath)});let q=b.get(K);q||(N=!0,q={folder:K,includePattern:{}},f.push(q),b.set(K,q));const G=p.$lc(K.fsPath,L.fsPath);(0,y.$pg)(q.includePattern)[G.replace(/\\/g,"/")]=!0}else L.fsPath&&(N=!0,M[L.fsPath]=!0)}),{folderQueries:f,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(k,f){if(f.isSmartCase){if(k.isRegExp){if(I.$8f(k.pattern,!0))return!0}else if(I.$8f(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,S.$kD)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const f=Q=>p.$ic(Q)||/^\.\.?([\/\\]|$)/.test(Q),M=(Array.isArray(k)?k:$(k)).map(Q=>{const ae=this.e.resolvedUserHome;return ae?(0,O.$2w)(Q,ae.scheme===T.Schemas.file?ae.fsPath:ae.path):Q}),N=R.$c(M,Q=>f(Q)?"searchPaths":"exprSegments"),L=(N.exprSegments||[]).map(Q=>I.$nf(Q,"/")).map(Q=>I.$nf(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),m(Q))),W={},K=this.m(N.searchPaths||[]);K&&K.length&&(W.searchPaths=K);const q=L.flat(),G=u(...q);return G&&(W.pattern=G),W}l(k,f){return f.disregardExcludeSettings?void 0:(0,n.$cM)(k,!f.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const f=k.flatMap(M=>{let{pathPortion:N,globPortion:L}=g(M);return L&&(L=E(L)),this.n(N).flatMap(K=>this.o(K,L))}),b=new Map;return f.forEach(M=>{const N=M.searchPath.toString(),L=b.get(N);L?M.pattern&&(L.pattern=L.pattern||{},L.pattern[M.pattern]=!0):b.set(N,{searchPath:M.searchPath,pattern:M.pattern?u(M.pattern):void 0})}),Array.from(b.values())}n(k){if(p.$ic(k)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==T.Schemas.file?[{searchPath:f[0].uri.with({path:k})}]:[{searchPath:a.URI.file(p.$hc(k))}]}if(this.b.getWorkbenchState()===c.WorkbenchState.FOLDER){const f=this.b.getWorkspace().folders[0].uri;if(k=h(k),k.startsWith("../")||k===".."){const M=p.$gc.resolve(f.path,k);return[{searchPath:f.with({path:M})}]}const b=E(k);return[{searchPath:f,pattern:b}]}else{if(k==="./"||k===".\\")return[];{const f=k.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(N=>{const L=f.match(new RegExp(`^${I.$hf(N.name)}(?:/(.*)|$)`));return L?{match:L,folder:N}:null}).filter(y.$mg);if(M.length)return M.map(N=>{const L=N.match[1];return{searchPath:N.folder.uri,pattern:L&&E(L)}});{const N=k.match(/\.[\/\\](.+)[\/\\]?/),L=N?N[1]:k,W=d.localize(1627,null,L);throw new Error(W)}}}}o(k,f){const b=k.pattern&&f?`${k.pattern}/${f}`:k.pattern||f,M=[{searchPath:k.searchPath,pattern:b}];return b&&!b.endsWith("**")&&M.push({searchPath:k.searchPath,pattern:b+"/**"}),M}q(k,f,b){const M=this.r((0,c.$Zi)(k.searchPath),f,b,!1);return M?{...M,includePattern:k.pattern}:null}r(k,f,b,M){let N;const L=a.URI.isUri(k)?k:k.uri;if(b.searchPaths){const Q=b.searchPaths.filter(ae=>(0,o.$$g)(ae.searchPath,L))[0];if(Q&&!Q.pattern)return null;Q&&(N=Q.pattern)}const W=this.a.getValue({resource:L}),q={...this.l(W,f)||{},...N||{}},G=a.URI.isUri(k)?(0,o.$ch)(k):k.name;return{folder:L,folderName:M?G:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:W.files&&W.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!W.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!W.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!W.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!W.search.followSymlinks}}};e.$nN=t,e.$nN=t=Je([Ve(0,r.$$i),Ve(1,c.$Ni),Ve(2,l.$sE),Ve(3,s.$_j),Ve(4,i.$lN)],t);function g(C){const k=C.match(/[\*\{\}\(\)\[\]\?]/);if(k){const f=k.index,b=C.substr(0,f).match(/[/|\\][^/\\]*$/);if(b){let M=C.substr(0,b.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:C.substr((b.index||0)+1)}}}return{pathPortion:C}}function u(...C){return C.length?C.reduce((k,f)=>(k[f]=!0,k),Object.create(null)):void 0}function $(C){return P.$xk(C,",").map(k=>k.trim()).filter(k=>!!k.length)}function m(C){return[`**/${C}/**`,`**/${C}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function h(C){return C.replace(/\\/g,"/")}function E(C){return h(C).replace(/^\.\//,"").replace(/\/+$/g,"")}function D(C){return C.replace(/([?*[\]])/g,"[$1]")}function w(C,k){C=v.$Lb(C,M=>M.toString());const f=[],b=k.getWorkspace();return C&&C.forEach(M=>{let N;if(k.getWorkbenchState()===c.WorkbenchState.FOLDER)N=(0,o.$hh)(b.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const L=k.getWorkspaceFolder(M);if(L){const W=L.name;if(b.folders.filter(q=>q.name===W).length===1){const q=(0,o.$hh)(L.uri,M);q===""?N=`./${L.name}`:N=`./${L.name}/${q}`}else N=M.fsPath}}N&&f.push(D(N))}),f}}),define(Ne[272],Le([1,0,23,2,21,13,3,271,44,49,10]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ayb=a,e.$Byb=r,v=We(v),O=We(O);const y=7e3;function a(s,c){const l=c.activationEvents;if(!l)return Promise.resolve(void 0);const i=[],n=[];for(const h of l)if(/^workspaceContains:/.test(h)){const E=h.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||s.forceUsingSearch?n.push(E):i.push(E)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);const{promise:t,resolve:g}=(0,I.$xh)(),u=h=>g({activationEvent:h}),$=Promise.all(i.map(h=>S(s,h,u))).then(()=>{}),m=d(s,c.identifier,n,u);return Promise.all([$,m]).then(()=>{g(void 0)}),t}async function S(s,c,l){for(const i of s.folders)if(await s.exists(v.$fh(R.URI.revive(i),c))){l(`workspaceContains:${c}`);return}}async function d(s,c,l,i){if(l.length===0)return Promise.resolve(void 0);const n=new P.$we,t=s.checkExists(s.folders,l,n.token),g=setTimeout(async()=>{n.cancel(),s.logService.info(`Not activating extension '${c.value}': Timed out while searching for 'workspaceContains' pattern ${l.join(",")}`)},y);let u=!1;try{u=await t}catch($){O.$3($)||O.$Y($)}n.dispose(),clearTimeout(g),u&&i(`workspaceContains:${l.join(",")}`)}function r(s,c,l,i){const n=s.get(A.$Di),t=s.get(p.$7L),u=n.createInstance(T.$nN).file(c.map($=>(0,o.$Zi)(R.URI.revive($))),{_reason:"checkExists",includePattern:l,exists:!0});return t.fileSearch(u,i).then($=>!!$.limitHit,$=>O.$3($)?!1:Promise.reject($))}}),define(Ne[47],Le([1,0,9,19,64,23,10,4,58,2,11,5,46,206,88,45,24,119,13,18,22,189,7,109,3,26,91,16,74,92,56,94,6,272,87,191,15,85,69,20,86]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E,D,w,C,k,f,b,M,N,L,W,K,q,G){"use strict";var Q;Object.defineProperty(e,"__esModule",{value:!0}),e.$pqc=e.$oqc=e.$nqc=e.$mqc=e.$lqc=void 0,v=We(v),R=We(R),P=We(P),l=We(l),e.$lqc=(0,$.$Ei)("IHostUtils");let ae=Q=class extends T.$Uc{constructor(Z,B,ne,Ee,fe,be,he,X,x,$e,pe,Ae,Ue){super(),this.Y=Ae,this.Z=Ue,this.a=this.B(new f.$le),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=B,this.g=ne,this.f=he,this.j=Ee,this.m=fe,this.s=be,this.t=x,this.u=$e,this.w=pe,this.y=this.g.getProxy(y.$JN.MainThreadWorkspace),this.z=this.g.getProxy(y.$JN.MainThreadTelemetry),this.C=this.g.getProxy(y.$JN.MainThreadExtensionService),this.D=new A.$Dh,this.F=new A.$Dh,this.G=new A.$Dh,this.H=new A.$Dh,this.I=new ke(this.f.extensions.activationEvents),this.L=new c.$Hdc(this.I,this.f.extensions.allExtensions);const Ie=new i.$rn(this.f.extensions.myExtensions);this.J=new c.$Hdc(this.I,me(this.L,Ie)),q.$u&&(this.s.info(`Creating extension host with the following global extensions: ${_(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${_(this.J)}`)),this.M=new d.$7pc(this.g,this.s),this.N=new M.$eqc(this.g),this.O=X,this.h=this.q.add(Z.createChild(new D.$Ci([d.$8pc,this.M],[M.$fqc,this.N]))),this.P=this.B(new S.$6pc(this.J,this.L,{onExtensionActivationError:(Pe,Oe,z)=>{this.C.$onExtensionActivationError(Pe,l.$1(Oe),z)},actualActivateExtension:async(Pe,Oe)=>{if(c.$Hdc.isHostExtension(Pe,this.J,this.L))return await this.C.$activateExtension(Pe,Oe),new S.$5pc;const z=this.J.getExtensionDescription(Pe);return this.fb(z,Oe)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(Z){l.$Y(Z)}}async $(){this.O.onWillDeactivateAll();let Z=[];try{Z=this.J.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this.eb(fe))}catch{}await Promise.all(Z)}terminate(Z,B=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${Z}`),this.s.flush(),this.u.dispose(),this.P.dispose(),l.setUnexpectedErrorHandler(Ee=>{this.s.error(Ee)}),this.g.dispose();const ne=this.$();Promise.race([(0,A.$Fh)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.s.info(`Extension host exiting with code ${B}`),this.s.flush(),this.s.dispose(),this.c.exit(B)})}isActivated(Z){return this.G.isOpen()?this.P.isActivated(Z):!1}async getExtension(Z){const B=await this.C.$getExtension(Z);return B&&{...B,identifier:new i.$qn(B.identifier.value),extensionLocation:o.URI.revive(B.extensionLocation)}}ab(Z,B){return this.P.activateByEvent(Z,B)}bb(Z,B){return this.P.activateById(Z,B)}activateByIdWithErrors(Z,B){return this.bb(Z,B).then(()=>{const ne=this.P.getActivatedExtension(Z);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Z=>this.J)}getExtensionExports(Z){if(this.G.isOpen())return this.P.getActivatedExtension(Z).exports;try{return this.P.getActivatedExtension(Z).exports}catch{return null}}async cb(Z){if(Z.scheme===L.Schemas.file&&this.c.fsRealpath){const B=Z.fsPath;this.R.has(B)||this.R.set(B,this.c.fsRealpath(B));const ne=await this.R.get(B);return o.URI.file(ne)}return Z}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(Z=>new oe(Z))),this.Q}async db(Z){const B=p.$Ki.forUris(ne=>O.$9g.ignorePathCasing(ne));return await Promise.all(Z.map(async ne=>{if(this.wb(ne)){const Ee=await this.cb(ne.extensionLocation);B.set(Ee,ne)}})),B}eb(Z){let B=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Z))return B;const ne=this.P.getActivatedExtension(Z);if(!ne)return B;try{typeof ne.module.deactivate=="function"&&(B=Promise.resolve(ne.module.deactivate()).then(void 0,Ee=>(this.s.error(Ee),Promise.resolve(void 0))))}catch(Ee){this.s.error(`An error occurred when deactivating the extension '${Z.value}':`),this.s.error(Ee)}try{ne.disposable.dispose()}catch(Ee){this.s.error(`An error occurred when disposing the subscriptions for extension '${Z.value}':`),this.s.error(Ee)}return B}async fb(Z,B){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Z.identifier):await this.C.$onWillActivateExtension(Z.identifier),this.hb(Z,B).then(ne=>{const Ee=ne.activationTimes;return this.C.$onDidActivateExtension(Z.identifier,Ee.codeLoadingTime,Ee.activateCallTime,Ee.activateResolvedTime,B),this.gb(Z,B,"success",Ee),ne},ne=>{throw this.gb(Z,B,"failure"),ne})}gb(Z,B,ne,Ee){const fe=le(Z,B);this.z.$publicLog2("extensionActivationTimes",{...fe,...Ee||{},outcome:ne})}hb(Z,B){const ne=le(Z,B);this.z.$publicLog2("activatePlugin",ne);const Ee=this.wb(Z);if(!Ee)return Promise.resolve(new S.$4pc(S.$1pc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Z.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${Z.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.s.flush();const fe=new T.$Tc,be=new S.$2pc(B.startup);return Promise.all([this.xb(Z,(0,O.$fh)(Z.extensionLocation,Ee),be),this.ib(Z,fe)]).then(he=>(P.mark(`code/extHost/willActivateExtension/${Z.identifier.value}`),Q.jb(this.s,Z.identifier,he[0],he[1],fe,be))).then(he=>(P.mark(`code/extHost/didActivateExtension/${Z.identifier.value}`),he))}ib(Z,B){const ne=this.Z.createLanguageModelAccessInformation(Z),Ee=B.add(new t.$0pc(Z,this.M)),fe=B.add(new t.$9pc(Z.identifier.value,!1,this.M)),be=B.add(new N.$gqc(Z,this.N)),he=Z.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?g.ExtensionMode.Test:g.ExtensionMode.Development:g.ExtensionMode.Production,X=this.f.remote.isRemote?g.ExtensionKind.Workspace:g.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Z.identifier.value}`),Promise.all([Ee.whenReady,fe.whenReady,this.O.whenReady]).then(()=>{const x=this;let $e,pe;const Ae=(0,s.$eH)(Z,"ipc")?this.f.messagePorts?.get(i.$qn.toKey(Z.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:fe,secrets:be,subscriptions:[],get languageModelAccessInformation(){return ne},get extensionUri(){return Z.extensionLocation},get extensionPath(){return Z.extensionLocation.fsPath},asAbsolutePath(Ue){return R.$jc(Z.extensionLocation.fsPath,Ue)},get storagePath(){return x.O.workspaceValue(Z)?.fsPath},get globalStoragePath(){return x.O.globalValue(Z).fsPath},get logPath(){return R.$jc(x.f.logsLocation.fsPath,Z.identifier.value)},get logUri(){return o.URI.joinPath(x.f.logsLocation,Z.identifier.value)},get storageUri(){return x.O.workspaceValue(Z)},get globalStorageUri(){return x.O.globalValue(Z)},get extensionMode(){return he},get extension(){return $e===void 0&&($e=new ce(x,Z.identifier,Z,X,!1)),$e},get extensionRuntime(){return(0,s.$fH)(Z,"extensionRuntime"),x.extensionRuntime},get environmentVariableCollection(){return x.u.getEnvironmentVariableCollection(Z)},get messagePassingProtocol(){if(!pe){if(!Ae)return;const Ue=f.Event.buffer(f.Event.fromDOMEventEmitter(Ae,"message",Ie=>Ie.data));Ae.start(),pe={onDidReceiveMessage:Ue,postMessage:Ae.postMessage.bind(Ae)}}return pe}})})}static jb(Z,B,ne,Ee,fe,be){return ne=ne||{activate:void 0,deactivate:void 0},this.kb(Z,B,ne,Ee,be).then(he=>new S.$3pc(!1,null,be.build(),ne,he,(0,T.$Sc)(()=>{fe.dispose(),(0,T.$Pc)(Ee.subscriptions)})))}static kb(Z,B,ne,Ee,fe){if(typeof ne.activate=="function")try{fe.activateCallStart(),Z.trace(`ExtensionService#_callActivateOptional ${B.value}`);const be=typeof global=="object"?global:self,he=ne.activate.apply(be,[Ee]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(he).then(X=>(fe.activateResolveStop(),X))}catch(be){return Promise.reject(be)}else return Promise.resolve(ne)}lb(Z,B){this.bb(Z.identifier,{startup:!1,extensionId:Z.identifier,activationEvent:B}).then(void 0,ne=>{this.s.error(ne)})}mb(Z,B=0){const Ee=Date.now();(0,q.$C)(()=>{for(let fe=B;fe<Z.length;fe+=1){const be=Z[fe];for(const he of be.activationEvents??[])if(he==="onStartupFinished")if(Date.now()-Ee>50){this.mb(Z,fe);break}else this.lb(be,he)}})}nb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Z=>{const B=Z.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(B)this.mb(ne);else for(const Ee of ne)if(Ee.activationEvents)for(const fe of Ee.activationEvents)fe==="onStartupFinished"&&this.lb(Ee,fe)})}ob(){const Z=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const B=this.j.workspace?this.j.workspace.folders:[],ne=this.pb(B),Ee=this.rb(),fe=Promise.all([Ee,Z,ne]).then(()=>{});return Promise.race([fe,(0,A.$Fh)(1e4)]).then(()=>{this.nb()}),fe}pb(Z){return Z.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(B=>this.qb(Z,B))).then(()=>{})}async qb(Z,B){if(this.isActivated(B.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,Ee={logService:this.s,folders:Z.map(be=>be.uri),forceUsingSearch:ne||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,he,X)=>this.y.$checkExists(be,he,X)},fe=await(0,b.$Ayb)(Ee,B);if(fe)return this.bb(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:fe.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(Z){throw console.error(Z),Z}}async sb(){const{extensionDevelopmentLocationURI:Z,extensionTestsLocationURI:B}=this.f.environment;if(!Z||!B)throw new Error(v.localize(10825,null));const ne=await this.xb(null,B,new S.$2pc(!1));if(!ne||typeof ne.run!="function")throw new Error(v.localize(10826,null,B.toString()));return new Promise((Ee,fe)=>{const be=(x,$e)=>{x?(q.$u&&this.s.error("Test runner called back with error",x),fe(x)):(q.$u&&($e?this.s.info(`Test runner called back with ${$e} failures.`):this.s.info("Test runner called back with successful outcome.")),Ee(typeof $e=="number"&&$e>0?1:0))},he=(0,O.$6g)(B),X=ne.run(he,be);X&&X.then&&X.then(()=>{q.$u&&this.s.info("Test runner finished successfully."),Ee(0)}).catch(x=>{q.$u&&this.s.error("Test runner finished with error",x),fe(x instanceof Error&&x.stack?x.stack:String(x))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$Fh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Z,B){return this.S[Z]=B,(0,T.$Sc)(()=>{delete this.S[Z]})}async getRemoteExecServer(Z){const{resolver:B}=await this.ub(Z);return B?.resolveExecServer?.(Z,{resolveAttempt:0})}async ub(Z){const B=Z.indexOf("+");if(B===-1)throw new g.$TN("Not an authority that can be resolved!",u.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=Z.substr(0,B);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.S[ne]}}async $resolveAuthority(Z,B){const ne=K.$fe.create(!1),Ee=()=>`[resolveAuthority(${(0,u.$Ul)(Z)},${B})][${ne.elapsed()}ms] `,fe=j=>this.s.info(`${Ee()}${j}`),be=j=>this.s.warn(`${Ee()}${j}`),he=(j,H=void 0)=>this.s.error(`${Ee()}${j}`,H),X=j=>{if(j instanceof g.$TN)return{type:"error",error:{code:j._code,message:j._message,detail:j._detail}};throw j},x=async j=>{fe(`activating resolver for ${j}...`);const{resolver:H,authorityPrefix:V}=await this.ub(j);if(!H)throw he(`no resolver for ${V}`),new g.$TN(`No remote extension installed to resolve ${V}.`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:V,remoteAuthority:j}},$e=Z.split(/@|%40/g).reverse();fe(`activating remote resolvers ${$e.join(" -> ")}`);let pe;try{pe=await Promise.all($e.map(x)).catch(async j=>{if(!(j instanceof g.$TN)||j._code!==u.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw j;return be(`resolving nested authorities failed: ${j.message}`),[await x(Z)]})}catch(j){return X(j)}const Ae=new A.$Ph;Ae.cancelAndSet(()=>fe("waiting..."),1e3);let Ue,Ie;for(const[j,{authorityPrefix:H,resolver:V,remoteAuthority:re}]of pe.entries())try{if(j===pe.length-1)fe("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${H}`),Ue=await V.resolve(re,{resolveAttempt:B,execServer:Ie}),P.mark(`code/extHost/didResolveAuthorityOK/${H}`),fe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(V,g.$SN.isManagedResolvedAuthority(Ue)?Ue:void 0));else{if(fe(`invoking resolveExecServer() for ${re}`),P.mark(`code/extHost/willResolveExecServer/${H}`),Ie=await V.resolveExecServer?.(re,{resolveAttempt:B,execServer:Ie}),!Ie)throw new g.$TN(`Exec server was not available for ${re}`,u.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ge){return P.mark(`code/extHost/didResolveAuthorityError/${H}`),he("returned an error",ge),Ae.dispose(),X(ge)}Ae.dispose();const Pe={environmentTunnels:Ue.environmentTunnels,features:Ue.tunnelFeatures?{elevation:Ue.tunnelFeatures.elevation,privacyOptions:Ue.tunnelFeatures.privacyOptions,protocol:Ue.tunnelFeatures.protocol===void 0?!0:Ue.tunnelFeatures.protocol}:void 0},Oe={extensionHostEnv:Ue.extensionHostEnv,isTrusted:Ue.isTrusted,authenticationSession:Ue.authenticationSessionForInitializingExtensions?{id:Ue.authenticationSessionForInitializingExtensions.id,providerId:Ue.authenticationSessionForInitializingExtensions.providerId}:void 0};fe(`returned ${g.$SN.isManagedResolvedAuthority(Ue)?"managed authority":`${Ue.host}:${Ue.port}`}`);let z;if(g.$SN.isManagedResolvedAuthority(Ue)){const j=B;this.Y.setFactory(j,Ue.makeConnection),z={authority:Z,connectTo:new u.$Rl(j),connectionToken:Ue.connectionToken}}else z={authority:Z,connectTo:new u.$Sl(Ue.host,Ue.port),connectionToken:Ue.connectionToken};return{type:"ok",value:{authority:z,options:Oe,tunnelInformation:Pe}}}async $getCanonicalURI(Z,B){this.s.info(`$getCanonicalURI invoked for authority (${(0,u.$Ul)(Z)})`);const{resolver:ne}=await this.ub(Z);if(!ne)return null;const Ee=o.URI.revive(B);if(typeof ne.getCanonicalURI>"u")return Ee;const fe=await(0,A.$wh)(()=>ne.getCanonicalURI(Ee));return fe||Ee}async $startExtensionHost(Z){Z.toAdd.forEach(be=>be.extensionLocation=o.URI.revive(be.extensionLocation));const{globalRegistry:B,myExtensions:ne}=we(this.I,this.L,this.J,Z),Ee=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),q.$u&&(this.s.info(`$startExtensionHost: global extensions: ${_(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${_(this.J)}`)),this.tb()}$activateByEvent(Z,B){return B===s.ActivationKind.Immediate?this.D.wait().then(ne=>this.ab(Z,!1)):this.G.wait().then(ne=>this.ab(Z,!1))}async $activate(Z,B){return await this.G.wait(),this.J.getExtensionDescription(Z)?(await this.bb(Z,B),!0):!1}async $deltaExtensions(Z){Z.toAdd.forEach(be=>be.extensionLocation=o.URI.revive(be.extensionLocation));const{globalRegistry:B,myExtensions:ne}=we(this.I,this.L,this.J,Z),Ee=await this.db(ne);return(await this.getExtensionPathIndex()).setSearchTree(Ee),this.L.set(B.getAllExtensionDescriptions()),this.J.set(ne),q.$u&&(this.s.info(`$deltaExtensions: global extensions: ${_(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${_(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Z){return Z}async $test_up(Z){return Z.byteLength}async $test_down(Z){const B=n.$Ne.alloc(Z),ne=Math.random()%256;for(let Ee=0;Ee<Z;Ee++)B.writeUInt8(ne,Ee);return B}async $updateRemoteConnectionData(Z){this.X=Z,this.a.fire()}};e.$mqc=ae,e.$mqc=ae=Q=Je([Ve(0,$.$Di),Ve(1,e.$lqc),Ve(2,E.$jQ),Ve(3,r.$Jpc),Ve(4,a.$Mpc),Ve(5,I.$_j),Ve(6,m.$zQ),Ve(7,h.$Ppc),Ve(8,w.$gGb),Ve(9,C.$$pc),Ve(10,W.$iqc),Ve(11,G.$jqc),Ve(12,k.$cqc)],ae);function we(Te,Z,B,ne){Te.addActivationEvents(ne.addActivationEvents);const Ee=new c.$Hdc(Te,Z.getAllExtensionDescriptions());Ee.deltaExtensions(ne.toAdd,ne.toRemove);const fe=new i.$rn(B.getAllExtensionDescriptions().map(he=>he.identifier));for(const he of ne.myToRemove)fe.delete(he);for(const he of ne.myToAdd)fe.add(he);const be=me(Ee,fe);return{globalRegistry:Ee,myExtensions:be}}function le(Te,Z){return{id:Te.identifier.value,name:Te.name,extensionVersion:Te.version,publisherDisplayName:Te.publisher,activationEvents:Te.activationEvents?Te.activationEvents.join(","):null,isBuiltin:Te.isBuiltin,reason:Z.activationEvent,reasonId:Z.extensionId.value}}function _(Te){return Te.getAllExtensionDescriptions().map(Z=>Z.identifier.value).join(",")}e.$nqc=(0,$.$Ei)("IExtHostExtensionService");class ce{#e;#t;#i;constructor(Z,B,ne,Ee,fe){this.#e=Z,this.#t=B,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=R.$hc((0,O.$6g)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=Ee,this.isFromDifferentExtensionHost=fe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$oqc=ce;function me(Te,Z){return Te.getAllExtensionDescriptions().filter(B=>Z.has(B.identifier))}class oe{constructor(Z){this.a=Z}setSearchTree(Z){this.a=Z}findSubstr(Z){return this.a.findSubstr(Z)}forEach(Z){return this.a.forEach(Z)}}e.$pqc=oe;class ke{constructor(Z){this.a=new i.$sn,this.addActivationEvents(Z)}readActivationEvents(Z){return this.a.get(Z.identifier)??[]}addActivationEvents(Z){for(const B of Object.keys(Z))this.a.set(B,Z[B])}}}),define(Ne[273],Le([1,0,64,2,5,46,24,18,16,26,3,47,11,12]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Arc=void 0,v=We(v);let r=class{constructor(n,t,g,u,$,m,h){this.c=n,this.d=t,this.e=g,this.f=u,this.g=$,this.h=m,this.i=h,this.a=new Map,this.b=[]}async install(){this.j(),v.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();v.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new c(this.c,t,this.d,n,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(l,t,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const t of n.nodeModuleName)this.a.set(t,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(t=>n.alternativeModuleName(t))}};e.$Arc=r,e.$Arc=r=Je([Ve(2,I.$Di),Ve(3,O.$Mpc),Ve(4,y.$nqc),Ve(5,o.$zQ),Ve(6,a.$_j)],r);let s=class{static{d=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&d.a.size){const t=(0,S.$hf)(this.c(n.environment.appRoot.fsPath)),g="[a-z0-9_.-]",u=`@${g}+\\/${g}+|${g}+`,$="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${$}\\/)(${u})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const t=this.b.exec(this.c(n));if(!t)return;const[,g,u,$]=t,m=d.a.get(u);if(m!==void 0)return console.warn(`${u} as been renamed to ${m}, please update your imports`),g+m+$}c(n){return n.replace(/\\/g,"/")}};s=d=Je([Ve(0,o.$zQ)],s);class c{constructor(n,t,g,u,$){this.c=n,this.d=t,this.e=g,this.f=u,this.g=$,this.nodeModuleName="vscode",this.a=new T.$sn}load(n,t){const g=this.d.findSubstr(t);if(g){let u=this.a.get(g.identifier);return u||(u=this.c(g,this.e,this.f),this.a.set(g.identifier,u)),u}if(!this.b){let u="";this.d.forEach(($,m)=>u+=`	${m} -> ${$.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${u}`),this.b=this.c(A.$_G,this.e,this.f)}return this.b}}let l=class{constructor(n,t,g){this.e=n,this.f=t,this.nodeModuleName=["open","opn"],this.d=g.getProxy(P.$JN.MainThreadTelemetry);const u=g.getProxy(P.$JN.MainThreadWindow);this.c=($,m)=>{const h=R.URI.parse($);return m?this.g($,m):h.scheme==="http"||h.scheme==="https"?u.$openUri(h,$,{allowTunneling:!0}):h.scheme==="mailto"||h.scheme===this.f?u.$openUri(h,$,{}):this.g($,m)}}load(n,t,g){const u=this.e.findSubstr(t);return u&&(this.a=u.identifier.value,this.h()),this.b=g(n),this.c}g(n,t){return this.i(),this.b(n,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};l=Je([Ve(2,p.$jQ)],l)}),define(Ne[132],Le([1,0,48,4,19,78,3,57,70,47,7,45,203,46]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rqc=e.$qqc=void 0,P=We(P),O=We(O),e.$qqc=(0,A.$Ei)("IExtHostVariableResolverProvider");class d extends a.$nR{constructor(c,l,i,n,t,g,u){function $(){if(i){const m=i.activeEditor();if(m)return m.document.uri;const h=n.tabGroups.all.find(E=>E.isActive)?.activeTab;if(h!==void 0){if(h.input instanceof I.$AP||h.input instanceof I.$FP)return h.input.modified;if(h.input instanceof I.$zP||h.input instanceof I.$EP||h.input instanceof I.$CP)return h.input.uri}}}super({getFolderUri:m=>{const h=g.folders.filter(E=>E.name===m);if(h&&h.length>0)return h[0].uri},getWorkspaceFolderCount:()=>g.folders.length,getConfigurationValue:(m,h)=>t.getConfiguration(void 0,m).get(h),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const m=$();if(m)return P.$hc(m.fsPath)},getWorkspaceFolderPathForFile:()=>{if(l){const m=$();if(m){const h=l.getWorkspaceFolder(m);if(h)return P.$hc(h.uri.fsPath)}}},getSelectedText:()=>{if(i){const m=i.activeEditor();if(m&&!m.selection.isEmpty)return m.document.getText(m.selection)}},getLineNumber:()=>{if(i){const m=i.activeEditor();if(m)return String(m.selection.end.line+1)}},getExtension:m=>c.getExtension(m)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(O.env))}}let r=class extends R.$Uc{constructor(c,l,i,n,t){super(),this.b=c,this.c=l,this.g=i,this.h=n,this.j=t,this.a=new v.$T(async()=>{const g=await this.h.getConfigProvider(),$={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async m=>{$.folders=await this.c.getWorkspaceFolders2()||[]})),new d(this.b,this.c,this.g,this.j,g,$,this.m())})}getResolver(){return this.a.value}m(){}};e.$rqc=r,e.$rqc=r=Je([Ve(0,o.$nqc),Ve(1,y.$Jpc),Ve(2,T.$uQ),Ve(3,S.$Mpc),Ve(4,p.$Ypc)],r)}),define(Ne[133],Le([1,0,10,6,2,4,18,3,5,70,47,16,7,45,195,80,196,46,132,34,33,8,17,95]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bqc=e.$Aqc=e.$zqc=e.$yqc=e.$xqc=void 0,t=We(t),e.$xqc=(0,T.$Ei)("IExtHostDebugService");let $=class extends O.$Uc{get onDidStartDebugSession(){return this.y.event}get onDidTerminateDebugSession(){return this.z.event}get onDidChangeActiveDebugSession(){return this.C.event}get activeDebugSession(){return this.D?.api}get onDidReceiveDebugSessionCustomEvent(){return this.F.event}get activeDebugConsole(){return this.G.value}constructor(k,f,b,M,N,L,W,K){super(),this.Y=f,this.Z=b,this.$=M,this.ab=N,this.bb=L,this.cb=W,this.db=K,this.w=new Map,this.O=0,this.P=new Map,this.Q=new Map,this.R=new WeakMap,this.S=new Map,this.W=new Map,this.X=0,this.f=0,this.g=[],this.h=0,this.j=[],this.m=0,this.n=[],this.M=new Map,this.N=new Map,this.y=this.B(new R.$le),this.z=this.B(new R.$le),this.C=this.B(new R.$le),this.F=this.B(new R.$le),this.u=k.getProxy(p.$JN.MainThreadDebugService),this.I=this.B(new R.$le),this.L=this.B(new R.$le),this.G=new h(this.u),this.H=new Map,this.Z.getExtensionRegistry().then(q=>{this.B(q.onDidChange(G=>{this.fb(q)})),this.fb(q)})}async $getVisualizerTreeItem(k,f){const b=this.gb(f);if(!b)return;const M=await this.Q.get(k)?.getTreeItem?.(b);return M?this.eb(k,M):void 0}registerDebugVisualizationTree(k,f,b){const M=A.$qn.toKey(k.identifier),N=this.ub(M,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.Q.set(N,b),this.u.$registerDebugVisualizerTree(N,!!b.editItem),(0,O.$Sc)(()=>{this.u.$unregisterDebugVisualizerTree(N),this.Q.delete(f)})}async $getVisualizerTreeItemChildren(k,f){const b=this.S.get(f)?.item;return b?(await this.Q.get(k)?.getChildren?.(b))?.map(N=>this.eb(k,N))||[]:[]}async $editVisualizerTreeItem(k,f){const b=this.S.get(k);if(!b)return;const M=await this.Q.get(b.provider)?.editItem?.(b.item,f);return this.eb(b.provider,M||b.item)}$disposeVisualizedTree(k){const f=this.S.get(k);if(!f)return;const b=[f.children];for(const M of b)if(M)for(const N of M)b.push(this.S.get(N)?.children),this.S.delete(N)}eb(k,f){let b=this.R.get(f);return b||(b=this.O++,this.R.set(f,b),this.S.set(b,{provider:k,item:f})),t.DebugTreeItem.from(f,b)}asDebugSourceUri(k,f){const b=k;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let M=`debug:${encodeURIComponent(b.path||"")}`,N="?";return f&&(M+=`${N}session=${encodeURIComponent(f.id)}`,N="&"),M+=`${N}ref=${b.sourceReference}`,P.URI.parse(M)}else{if(b.path)return P.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}fb(k){const f=[];for(const b of k.getAllExtensionDescriptions())if(b.contributes){const M=b.contributes.debuggers;if(M&&M.length>0)for(const N of M)(0,s.$$H)(N)&&f.push(N.type)}this.u.$registerDebugTypes(f)}get activeStackItem(){return this.J}get onDidChangeActiveStackItem(){return this.L.event}get onDidChangeBreakpoints(){return this.I.event}get breakpoints(){const k=[];return this.H.forEach(f=>k.push(f)),k}async $resolveDebugVisualizer(k,f){const b=this.W.get(k);if(!b)throw new Error(`No debug visualizer found with id '${k}'`);let{v:M,provider:N,extensionId:L}=b;if(M.visualization||(M=await N.resolveDebugVisualization?.(M,f)||M,b.v=M),!M.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${N}'`);return this.vb(L,M.visualization)}async $executeDebugVisualizerCommand(k){const f=this.W.get(k);if(!f)throw new Error(`No debug visualizer found with id '${k}'`);const b=f.v.visualization;b&&"command"in b&&this.cb.executeCommand(b.command,...b.arguments||[])}gb(k){const f=this.w.get(k.sessionId);return f&&{session:f.api,variable:k.variable,containerId:k.containerId,frameId:k.frameId,threadId:k.threadId}}async $provideDebugVisualizers(k,f,b,M){const N=this.gb(b),L=this.ub(k,f),W=this.P.get(L);if(!N||!W)return[];const K=await W.provideDebugVisualization(N,M);return K?K.map(q=>{const G=++this.X;this.W.set(G,{v:q,provider:W,extensionId:k});const Q=q.iconPath?this.wb(q.iconPath):void 0;return{id:G,name:q.name,iconClass:Q?.iconClass,iconPath:Q?.iconPath,visualization:this.vb(k,q.visualization)}}):[]}$disposeDebugVisualizers(k){for(const f of k)this.W.delete(f)}registerDebugVisualizationProvider(k,f,b){if(!k.contributes?.debugVisualizers?.some(L=>L.id===f))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${f})`);const M=A.$qn.toKey(k.identifier),N=this.ub(M,f);if(this.P.has(N))throw new Error(`A debug visualization provider with id '${f}' is already registered`);return this.P.set(N,b),this.u.$registerDebugVisualizer(M,f),(0,O.$Sc)(()=>{this.u.$unregisterDebugVisualizer(M,f),this.P.delete(f)})}addBreakpoints(k){const f=k.filter(N=>{const L=N.id;return this.H.has(L)?!1:(this.H.set(L,N),!0)});this.rb(f,[],[]);const b=[],M=new Map;for(const N of f)if(N instanceof a.$PO){let L=M.get(N.location.uri.toString());L||(L={type:"sourceMulti",uri:N.location.uri,lines:[]},M.set(N.location.uri.toString(),L),b.push(L)),L.lines.push({id:N.id,enabled:N.enabled,condition:N.condition,hitCondition:N.hitCondition,logMessage:N.logMessage,line:N.location.range.start.line,character:N.location.range.start.character,mode:N.mode})}else N instanceof a.$QO&&b.push({type:"function",id:N.id,enabled:N.enabled,hitCondition:N.hitCondition,logMessage:N.logMessage,condition:N.condition,functionName:N.functionName,mode:N.mode});return this.u.$registerBreakpoints(b)}removeBreakpoints(k){const f=k.filter(L=>this.H.delete(L.id));this.rb([],f,[]);const b=f.filter(L=>L instanceof a.$PO).map(L=>L.id),M=f.filter(L=>L instanceof a.$QO).map(L=>L.id),N=f.filter(L=>L instanceof a.$RO).map(L=>L.id);return this.u.$unregisterBreakpoints(b,M,N)}startDebugging(k,f,b){const M=b.testRun&&this.db.getMetadataForRun(b.testRun);return this.u.$startDebugging(k?k.uri:void 0,f,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===a.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,testRun:M&&{runId:M.runId,taskId:M.taskId},suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(k){return this.u.$stopDebugging(k?k.id:void 0)}registerDebugConfigurationProvider(k,f,b){if(!f)return new a.$LN(()=>{});const M=this.f++;return this.g.push({type:k,handle:M,provider:f}),this.u.$registerDebugConfigurationProvider(k,b,!!f.provideDebugConfigurations,!!f.resolveDebugConfiguration,!!f.resolveDebugConfigurationWithSubstitutedVariables,M),new a.$LN(()=>{this.g=this.g.filter(N=>N.provider!==f),this.u.$unregisterDebugConfigurationProvider(M)})}registerDebugAdapterDescriptorFactory(k,f,b){if(!b)return new a.$LN(()=>{});if(!this.nb(k,f))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${f}' debugger.`);if(this.kb(f))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const M=this.h++;return this.j.push({type:f,handle:M,factory:b}),this.u.$registerDebugAdapterDescriptorFactory(f,M),new a.$LN(()=>{this.j=this.j.filter(N=>N.factory!==b),this.u.$unregisterDebugAdapterDescriptorFactory(M)})}registerDebugAdapterTrackerFactory(k,f){if(!f)return new a.$LN(()=>{});const b=this.m++;return this.n.push({type:k,handle:b,factory:f}),new a.$LN(()=>{this.n=this.n.filter(M=>M.factory!==f)})}async $runInTerminal(k,f){return Promise.resolve(void 0)}async $substituteVariables(k,f){let b;const M=await this.tb(k);return M&&(b={uri:M.uri,name:M.name,index:M.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.bb.getResolver()).resolveAnyAsync(b,f)}hb(k,f){if(k.type==="implementation")return new D(k.implementation)}ib(){}async $startDASession(k,f){const b=this,M=await this.sb(f);return this.pb(this.kb(M.type),M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}' (extension might have failed to activate)`);const L=this.jb(N),W=this.hb(L,M);if(!W)throw new Error(`Couldn't create a debug adapter for type '${M.type}'.`);const K=W;return this.M.set(k,K),this.ob(M).then(q=>(q&&this.N.set(k,q),K.onMessage(async G=>{if(G.type==="request"&&G.command==="handshake"){const Q=G,ae={type:"response",seq:0,command:Q.command,request_seq:Q.seq,success:!0};this.U||(this.U=this.ib());try{if(this.U){const we=await this.U.sign(Q.arguments.value);ae.body={signature:we},K.sendResponse(ae)}else throw new Error("no signer")}catch(we){ae.success=!1,ae.message=we.message,K.sendResponse(ae)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(G),G=(0,s.$dI)(G,!0),b.u.$acceptDAMessage(k,G)}),K.onError(G=>{q&&q.onError&&q.onError(G),this.u.$acceptDAError(k,G.name,G.message,G.stack)}),K.onExit(G=>{q&&q.onExit&&q.onExit(G??void 0,void 0),this.u.$acceptDAExit(k,G??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),K.startSession()))})}$sendDAMessage(k,f){f=(0,s.$cI)(f,!1);const b=this.N.get(k);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(f),this.M.get(k)?.sendMessage(f)}$stopDASession(k){const f=this.N.get(k);this.N.delete(k),f&&f.onWillStopSession&&f.onWillStopSession();const b=this.M.get(k);return this.M.delete(k),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(k){const f=[],b=[],M=[];if(k.added)for(const N of k.added){const L=N.id;if(L&&!this.H.has(L)){let W;if(N.type==="function")W=new a.$QO(N.functionName,N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode);else if(N.type==="data")W=new a.$RO(N.label,N.dataId,N.canPersist,N.enabled,N.hitCondition,N.condition,N.logMessage,N.mode);else{const K=P.URI.revive(N.uri);W=new a.$PO(new a.$ZN(K,new a.$MN(N.line,N.character)),N.enabled,N.condition,N.hitCondition,N.logMessage,N.mode)}(0,a.$NO)(W,L),this.H.set(L,W),f.push(W)}}if(k.removed)for(const N of k.removed){const L=this.H.get(N);L&&(this.H.delete(N),b.push(L))}if(k.changed){for(const N of k.changed)if(N.id){const L=this.H.get(N.id);if(L){if(L instanceof a.$QO&&N.type==="function"){const W=L;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.functionName=N.functionName}else if(L instanceof a.$PO&&N.type==="source"){const W=L;W.enabled=N.enabled,W.condition=N.condition,W.hitCondition=N.hitCondition,W.logMessage=N.logMessage,W.location=new a.$ZN(P.URI.revive(N.uri),new a.$MN(N.line,N.character))}M.push(L)}}}this.rb(f,b,M)}async $acceptStackFrameFocus(k){let f;if(k){const b=await this.sb(k.sessionId);k.kind==="thread"?f=new a.$XO(b.api,k.threadId):f=new a.$WO(b.api,k.threadId,k.frameId)}this.J=f,this.L.fire(this.J)}$provideDebugConfigurations(k,f,b){return(0,v.$wh)(async()=>{const M=this.mb(k);if(!M)throw new Error("no DebugConfigurationProvider found");if(!M.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const N=await this.tb(f);return M.provideDebugConfigurations(N,b)}).then(M=>{if(!M)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return M})}$resolveDebugConfiguration(k,f,b,M){return(0,v.$wh)(async()=>{const N=this.mb(k);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.tb(f);return N.resolveDebugConfiguration(L,b,M)})}$resolveDebugConfigurationWithSubstitutedVariables(k,f,b,M){return(0,v.$wh)(async()=>{const N=this.mb(k);if(!N)throw new Error("no DebugConfigurationProvider found");if(!N.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.tb(f);return N.resolveDebugConfigurationWithSubstitutedVariables(L,b,M)})}async $provideDebugAdapter(k,f){const b=this.lb(k);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const M=await this.sb(f);return this.pb(b,M).then(N=>{if(!N)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${M.type}'`);return this.jb(N)})}async $acceptDebugSessionStarted(k){const f=await this.sb(k);this.y.fire(f.api)}async $acceptDebugSessionTerminated(k){const f=await this.sb(k);f&&(this.z.fire(f.api),this.w.delete(f.id))}async $acceptDebugSessionActiveChanged(k){this.D=k?await this.sb(k):void 0,this.C.fire(this.D?.api)}async $acceptDebugSessionNameChanged(k,f){(await this.sb(k))?._acceptNameChanged(f)}async $acceptDebugSessionCustomEvent(k,f){const M={session:(await this.sb(k)).api,event:f.event,body:f.body};this.F.fire(M)}jb(k){if(k instanceof a.$SO)return{type:"executable",command:k.command,args:k.args,options:k.options};if(k instanceof a.$TO)return{type:"server",port:k.port,host:k.host};if(k instanceof a.$UO)return{type:"pipeServer",path:k.path};if(k instanceof a.$VO)return{type:"implementation",implementation:k.implementation};throw new Error("convertToDto unexpected type")}kb(k){const f=this.j.filter(b=>b.type===k);if(f.length>0)return f[0].factory}lb(k){const f=this.j.filter(b=>b.handle===k);if(f.length>0)return f[0].factory}mb(k){const f=this.g.filter(b=>b.handle===k);if(f.length>0)return f[0].provider}nb(k,f){if(k.contributes){const b=k.contributes.debuggers;if(b&&b.length>0){for(const M of b)if(M.label&&M.type&&M.type===f)return!0}}return!1}ob(k){const b=k.configuration.type,M=this.n.filter(N=>N.type===b||N.type==="*").map(N=>(0,v.$wh)(()=>N.factory.createDebugAdapterTracker(k.api)).then(L=>L,L=>null));return Promise.race([Promise.all(M).then(N=>{const L=(0,g.$Gb)(N);if(L.length>0)return new E(L)}),new Promise(N=>setTimeout(()=>N(void 0),1e3))]).catch(N=>{})}async pb(k,f){const b=f.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new a.$TO(b));if(k){const N=await this.Z.getExtensionRegistry();return(0,v.$wh)(()=>k.createDebugAdapterDescriptor(f.api,this.qb(f,N))).then(L=>{if(L)return L})}const M=await this.Z.getExtensionRegistry();return Promise.resolve(this.qb(f,M))}qb(k,f){}rb(k,f,b){(k.length>0||f.length>0||b.length>0)&&this.I.fire(Object.freeze({added:k,removed:f,changed:b}))}async sb(k){if(k)if(typeof k=="string"){const f=this.w.get(k);if(f)return f}else{let f=this.w.get(k.id);if(!f){const b=await this.tb(k.folderUri),M=k.parent?this.w.get(k.parent):void 0;f=new m(this.u,k.id,k.type,k.name,b,k.configuration,M?.api),this.w.set(f.id,f),this.u.$sessionCached(f.id)}return f}throw new Error("cannot find session")}tb(k){if(k){const f=P.URI.revive(k);return this.Y.resolveWorkspaceFolder(f)}return Promise.resolve(void 0)}ub(k,f){return`${k}\0${f}`}vb(k,f){if(f){if("title"in f&&"command"in f)return{type:r.DebugVisualizationType.Command};if("treeId"in f)return{type:r.DebugVisualizationType.Tree,id:`${k}\0${f.treeId}`};throw new Error("Unsupported debug visualization type")}}wb(k){const f=this.xb(k);let b,M;return"id"in f?M=i.ThemeIcon.asClassName(f):b=f,{iconPath:b,iconClass:M}}xb(k){if(k instanceof a.$KO)return{id:k.id};const f=typeof k=="object"&&"dark"in k?k.dark:k,b=typeof k=="object"&&"light"in k?k.light:k;return{dark:typeof f=="string"?P.URI.file(f):f,light:typeof b=="string"?P.URI.file(b):b}}};e.$yqc=$,e.$yqc=$=Je([Ve(0,y.$jQ),Ve(1,S.$Jpc),Ve(2,I.$nqc),Ve(3,c.$Mpc),Ve(4,o.$Ypc),Ve(5,l.$qqc),Ve(6,n.$FQ),Ve(7,u.$sqc)],$);class m{constructor(k,f,b,M,N,L,W){this.f=k,this.g=f,this.h=b,this.j=M,this.k=N,this.l=L,this.m=W}get api(){const k=this;return this.d??=Object.freeze({id:k.g,type:k.h,get name(){return k.j},set name(f){k.j=f,k.f.$setDebugSessionName(k.g,f)},parentSession:k.m,workspaceFolder:k.k,configuration:k.l,customRequest(f,b){return k.f.$customDebugAdapterRequest(k.g,f,b)},getDebugProtocolBreakpoint(f){return k.f.$getDebugProtocolBreakpoint(k.g,f.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(k){this.j=k}get configuration(){return this.l}}e.$zqc=m;class h{constructor(k){this.value=Object.freeze({append(f){k.$appendDebugConsole(f)},appendLine(f){this.append(f+`
`)}})}}e.$Aqc=h;class E{constructor(k){this.d=k}onWillStartSession(){this.d.forEach(k=>k.onWillStartSession?k.onWillStartSession():void 0)}onWillReceiveMessage(k){this.d.forEach(f=>f.onWillReceiveMessage?f.onWillReceiveMessage(k):void 0)}onDidSendMessage(k){this.d.forEach(f=>f.onDidSendMessage?f.onDidSendMessage(k):void 0)}onWillStopSession(){this.d.forEach(k=>k.onWillStopSession?k.onWillStopSession():void 0)}onError(k){this.d.forEach(f=>f.onError?f.onError(k):void 0)}onExit(k,f){this.d.forEach(b=>b.onExit?b.onExit(k,f):void 0)}}class D extends d.$7tb{constructor(k){super(),this.h=k,k.onDidSendMessage(f=>{this.acceptMessage(f)})}startSession(){return Promise.resolve(void 0)}sendMessage(k){this.h.handleMessage(k)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends ${constructor(k,f,b,M,N,L,W,K){super(k,f,b,M,N,L,W,K)}};e.$Bqc=w,e.$Bqc=w=Je([Ve(0,y.$jQ),Ve(1,S.$Jpc),Ve(2,I.$nqc),Ve(3,c.$Mpc),Ve(4,o.$Ypc),Ve(5,l.$qqc),Ve(6,n.$FQ),Ve(7,u.$sqc)],w)}),define(Ne[274],Le([1,0,13,64,2,5,224,11,60,74,26,170,16,65,47,66]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Crc=e.$Brc=void 0,v=We(v),R=We(R);class s{static async installEarlyHandler(i){Error.stackTraceLimit=100;const n=i.get(T.$_j),g=i.get(a.$jQ).getProxy(O.$JN.MainThreadErrors);v.setUnexpectedErrorHandler(u=>{n.error(u);const $=v.$1(u);g.$onUnexpectedError($)})}static async installFullHandler(i){const n=i.get(T.$_j),t=i.get(a.$jQ),g=i.get(d.$nqc),u=i.get(r.$DQ),$=t.getProxy(O.$JN.MainThreadExtensionService),m=t.getProxy(O.$JN.MainThreadErrors),h=await g.getExtensionPathIndex(),E=new WeakMap;function D(k,f){if(E.has(k))return E.get(k).stack;let b="",M,N;for(const W of f)b+=`
	at ${W.toString()}`,N=W.getFileName(),!M&&N&&(M=h.findSubstr(P.URI.file(N)));const L=`${k.name||"Error"}: ${k.message||""}${b}`;return E.set(k,{extensionIdentifier:M?.identifier,stack:L}),L}const w=Symbol("prepareStackTrace wrapped");let C=D;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return C},set(k){if(k===D||!k||k[w]){C=k||D;return}C=function(f,b){return D(f,b),k.call(Error,f,b)},Object.assign(C,{[w]:!0})}}),v.setUnexpectedErrorHandler(k=>{n.error(k);const f=v.$1(k),b=E.get(k);if(!b?.extensionIdentifier){m.$onUnexpectedError(f);return}$.$onExtensionRuntimeError(b.extensionIdentifier,f);const M=u.onExtensionError(b.extensionIdentifier,k);n.trace("forwarded error to extension?",M,b)})}}e.$Brc=s;class c{constructor(i,n,t,g,u){this.a=t,this.b=new A.$Pdc(i,null,g),n=c.e(n,this.b);const $=new o.$Ci(...(0,p.$Rs)());$.set(I.$zQ,{_serviceBrand:void 0,...n,messagePorts:u}),$.set(a.$jQ,new a.$kQ(this.b)),$.set(S.$Gpc,new S.$Hpc(g)),$.set(d.$lqc,t);const m=new y.$vr($,!0);m.invokeFunction(s.installEarlyHandler),this.d=m.invokeFunction(h=>h.get(T.$_j)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=m.invokeFunction(h=>h.get(d.$nqc)),this.c.initialize(),m.invokeFunction(s.installFullHandler)}async asBrowserUri(i){const n=this.b.getProxy(O.$JN.MainThreadExtensionService);return P.URI.revive(await n.$asBrowserUri(i))}terminate(i){this.c.terminate(i)}static e(i,n){i.extensions.allExtensions.forEach(g=>{g.extensionLocation=P.URI.revive(n.transformIncomingURIs(g.extensionLocation))}),i.environment.appRoot=P.URI.revive(n.transformIncomingURIs(i.environment.appRoot));const t=i.environment.extensionDevelopmentLocationURI;return t&&(i.environment.extensionDevelopmentLocationURI=t.map(g=>P.URI.revive(n.transformIncomingURIs(g)))),i.environment.extensionTestsLocationURI=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTestsLocationURI)),i.environment.globalStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.globalStorageHome)),i.environment.workspaceStorageHome=P.URI.revive(n.transformIncomingURIs(i.environment.workspaceStorageHome)),i.environment.extensionTelemetryLogResource=P.URI.revive(n.transformIncomingURIs(i.environment.extensionTelemetryLogResource)),i.nlsBaseUrl=P.URI.revive(n.transformIncomingURIs(i.nlsBaseUrl)),i.logsLocation=P.URI.revive(n.transformIncomingURIs(i.logsLocation)),i.workspace=n.transformIncomingURIs(i.workspace),i}}e.$Crc=c}),define(Ne[275],Le([1,0,17,10,21,42,15,19,23,2,44]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sqc=e.$Qqc=e.$Pqc=void 0,e.$Rqc=r,T=We(T),p=We(p);class y{constructor(l,i,n){this.d=l,this.e=i,this.f=n,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(l,i){const n=this.g.folderQueries||[],t=new P.$we(i);return new Promise((g,u)=>{this.a=new S(l);let $=!1;const m=(h,E)=>{if(!$&&!this.b){const D=this.h(h);r(h)&&typeof this.g.maxResults=="number"&&this.c+D>this.g.maxResults&&(this.b=!0,$=!0,t.cancel(),h=this.j(h,this.g.maxResults-this.c));const w=this.h(h);this.c+=w,(w>0||!r(h))&&this.a.add(h,E)}};Promise.all(n.map((h,E)=>this.k(h,D=>m(D,E),t.token))).then(h=>{t.dispose(),this.a.flush();const E=h.some(D=>!!D&&!!D.limitHit);g({limitHit:this.b||E,messages:h.flatMap(D=>D?.message?Array.isArray(D.message)?D.message:[D.message]:[]),stats:{type:this.f}})},h=>{t.dispose();const E=(0,O.$pj)(h);u(new Error(E))})})}h(l){return r(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}j(l,i){const n=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:n.slice(0,i),preview:{matches:t.slice(0,i),text:l.preview.text},uri:l.uri}}async k(l,i,n){const t=new I.$nM(this.g,l),g=[],u={report:h=>{if(!this.l(h))return;const E=l.folder.scheme===A.Schemas.file?(0,I.$oM)(()=>this.e.readdir(p.$eh(h.uri))):void 0,D=p.$hh(l.folder,h.uri);if(D){const w=t.includedInQuery(D,T.$nc(D),E);(0,R.$qh)(w)?g.push(w.then(C=>{C&&i(h)})):w&&i(h)}}},$=this.n(l);let m;return this.d.query.type===I.QueryType.aiText?m=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,$,u,n):m=await this.d.provider.provideTextSearchResults(a(this.d.query.contentPattern),$,u,n),g.length&&await Promise.all(g),m}l(l){if(r(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(l){const i=(0,I.$mM)(this.g.includePattern,l.includePattern),n=(0,I.$mM)(this.g.excludePattern,l.excludePattern),t={folder:o.URI.from(l.folder),excludes:n,includes:i,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.e.toCanonicalName(l.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??I.$6L,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(t.usePCRE2=this.g.usePCRE2),t}}e.$Pqc=y;function a(c){return{isCaseSensitive:c.isCaseSensitive||!1,isRegExp:c.isRegExp||!1,isWordMatch:c.isWordMatch||!1,isMultiline:c.isMultiline||!1,pattern:c.pattern}}class S{constructor(l){this.e=l,this.b=-1,this.d=null,this.a=new s(512,i=>this.g(i))}add(l,i){this.d&&(this.b!==i||!p.$$g(this.c,l.uri))&&(this.f(),this.d=null),this.d||(this.b=i,this.d={resource:l.uri,results:[]}),this.d.results.push(d(l))}f(){const l=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,l)}flush(){this.f(),this.a.flush()}g(l){this.e(l)}}e.$Qqc=S;function d(c){return r(c)?{preview:{matches:(0,v.$Zb)(c.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:c.preview.text},ranges:(0,v.$Zb)(c.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:c.text,lineNumber:c.lineNumber}}function r(c){return!!c.preview}class s{static{this.a=4e3}static{this.b=50}constructor(l,i){this.g=l,this.h=i,this.c=0,this.d=[],this.e=0}addItem(l,i){l&&this.j(l,i)}addItems(l,i){l&&this.k(l,i)}j(l,i){this.d.push(l),this.e+=i,this.l()}k(l,i){this.d=this.d.concat(l),this.e+=i,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Sqc=s}),define(Ne[134],Le([1,0,4,5,3,270,16,65,11,2,275]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uqc=e.$Tqc=void 0,e.$Vqc=a,e.$Tqc=(0,P.$Ei)("IExtHostSearch");let y=class{constructor(r,s,c){this.n=r,this.o=s,this.q=c,this.c=this.n.getProxy(R.$JN.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$Oqc}s(r){return this.o.transformOutgoingScheme(r)}registerTextSearchProvider(r,s){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const c=this.d++;return this.e.set(c,s),this.c.$registerTextSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.g.delete(r),this.e.delete(c),this.c.$unregisterProvider(c)})}registerAITextSearchProvider(r,s){if(this.i.has(r))throw new Error(`an AI text search provider for the scheme '${r}'is already registered`);this.i.add(r);const c=this.d++;return this.h.set(c,s),this.c.$registerAITextSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.i.delete(r),this.h.delete(c),this.c.$unregisterProvider(c)})}registerFileSearchProvider(r,s){if(this.k.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.k.add(r);const c=this.d++;return this.j.set(c,s),this.c.$registerFileSearchProvider(c,this.s(r)),(0,v.$Sc)(()=>{this.k.delete(r),this.j.delete(c),this.c.$unregisterProvider(c)})}$provideFileSearchResults(r,s,c,l){const i=a(c),n=this.j.get(r);if(n)return this.l.fileSearch(i,n,t=>{this.c.$handleFileMatch(r,s,t.map(g=>g.resource))},l);throw new Error("3 unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,s,c){return{messages:[]}}$clearCache(r){return this.l.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,s,c,l){const i=this.e.get(r);if(!i||!i.provideTextSearchResults)throw new Error(`Unknown Text Search Provider ${r}`);const n=a(c);return this.t(n,i).search(g=>this.c.$handleTextMatch(r,s,g),l)}$provideAITextSearchResults(r,s,c,l){const i=this.h.get(r);if(!i||!i.provideAITextSearchResults)throw new Error(`Unknown AI Text Search Provider ${r}`);const n=a(c);return this.v(n,i).search(g=>this.c.$handleTextMatch(r,s,g),l)}$enableExtensionHostSearch(){}t(r,s){return new I.$Pqc({query:r,provider:s},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"textSearchProvider")}v(r,s){return new I.$Pqc({query:r,provider:s},{readdir:c=>Promise.resolve([]),toCanonicalName:c=>c},"aiTextSearchProvider")}};e.$Uqc=y,e.$Uqc=y=Je([Ve(0,A.$jQ),Ve(1,T.$Gpc),Ve(2,p.$_j)],y);function a(d){return{...d,folderQueries:d.folderQueries&&d.folderQueries.map(S),extraFileResources:d.extraFileResources&&d.extraFileResources.map(r=>o.URI.revive(r))}}function S(d){return{...d,folder:o.URI.revive(d.folder)}}});var xt=this&&this.__importDefault||function(ve){return ve&&ve.__esModule?ve:{default:ve}};define(Ne[276],Le([1,0,10,21,13,6,4,15,35,2,105,157,158,52,18,29,11,62,63,185,5,227,256,84,90,232,233,234,211,201,33,235,46,236,133,122,237,213,228,238,239,57,70,214,229,47,241,68,242,50,26,257,215,243,244,94,245,85,86,217,269,247,190,248,258,249,128,218,250,251,252,16,253,134,87,254,219,255,88,91,131,66,56,126,95,259,230,260,261,92,8,7,220,65,221,67,262,263,121,45,80,83,24,130]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E,D,w,C,k,f,b,M,N,L,W,K,q,G,Q,ae,we,le,_,ce,me,oe,ke,Te,Z,B,ne,Ee,fe,be,he,X,x,$e,pe,Ae,Ue,Ie,Pe,Oe,z,j,H,V,re,ge,Ce,ze,Qe,_e,tt,nt,et,rt,ft,lt,st,ct,mt,$t,qe,je,ie,ee,Y,Xe,xe,ht,bt,Mt,Ht,_t,ei,oi,At,Ye,Ct){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wrc=hi,P=We(P),p=xt(p),a=We(a),r=We(r),ee=We(ee),Y=We(Y);function hi(pt){const Dt=pt.get(Te.$zQ),ti=pt.get(ke.$rpc),ii=pt.get(me.$Opc),jt=pt.get(_.$nqc),gt=pt.get(ei.$Jpc),zt=pt.get(ft.$DQ),ni=pt.get(f.$Mpc),ai=pt.get(xe.$Gpc),Ge=pt.get(re.$jQ),ci=pt.get(nt.$8pc),di=pt.get(et.$Ppc),fi=pt.get(s.$ak),vt=pt.get(s.$_j),Ft=pt.get(ie.$gGb),Nt=pt.get(u.$npc),Wt=pt.get(_t.$vrc),ri=pt.get(ze.$fqc),Kt=pt.get(ae.$Ypc),li=pt.get(X.$jqc),Bt=pt.get($.$xpc),Qt=pt.get(fe.$cqc);Ge.set(n.$KN.ExtHostFileSystemInfo,ti),Ge.set(n.$KN.ExtHostLogLevelServiceShape,fi),Ge.set(n.$KN.ExtHostWorkspace,gt),Ge.set(n.$KN.ExtHostConfiguration,ni),Ge.set(n.$KN.ExtHostExtensionService,jt),Ge.set(n.$KN.ExtHostStorage,ci),Ge.set(n.$KN.ExtHostTunnelService,Ft),Ge.set(n.$KN.ExtHostWindow,Wt),Ge.set(n.$KN.ExtHostSecretState,ri),Ge.set(n.$KN.ExtHostTelemetry,zt),Ge.set(n.$KN.ExtHostEditorTabs,Kt),Ge.set(n.$KN.ExtHostManagedSockets,li),Ge.set(n.$KN.ExtHostAuthentication,Bt),Ge.set(n.$KN.ExtHostChatProvider,Qt);const Gt=Ge.set(n.$KN.ExtHostDecorations,pt.get(N.$Dqc)),Lt=Ge.set(n.$KN.ExtHostDocumentsAndEditors,pt.get(Q.$uQ)),wt=Ge.set(n.$KN.ExtHostCommands,pt.get(C.$FQ)),kt=Ge.set(n.$KN.ExtHostTerminalService,pt.get(lt.$$pc)),Vt=Ge.set(n.$KN.ExtHostTerminalShellIntegration,pt.get(st.$lrc)),It=Ge.set(n.$KN.ExtHostDebugService,pt.get(M.$xqc)),mi=Ge.set(n.$KN.ExtHostSearch,pt.get(Ce.$Tqc)),Zt=Ge.set(n.$KN.ExtHostTask,pt.get(rt.$krc)),ki=Ge.set(n.$KN.ExtHostOutputService,pt.get(Oe.$0qc)),wi=Ge.set(n.$KN.ExtHostLocalization,pt.get(he.$iqc)),Ai=Ge.set(n.$KN.ExtHostUrls,new ht.$src(Ge)),Tt=Ge.set(n.$KN.ExtHostDocuments,new G.$upc(Ge,Lt)),Ni=Ge.set(n.$KN.ExtHostDocumentContentProviders,new K.$Fqc(Ge,Lt,vt)),ui=Ge.set(n.$KN.ExtHostDocumentSaveParticipant,new q.$Gqc(vt,Tt,Ge.getProxy(n.$JN.MainThreadBulkEdits))),Pt=Ge.set(n.$KN.ExtHostNotebook,new $e.$Wqc(Ge,wt,Lt,Tt,ii,mi,vt)),Ti=Ge.set(n.$KN.ExtHostNotebookDocuments,new Ae.$4qc(Pt)),Ii=Ge.set(n.$KN.ExtHostNotebookEditors,new Ue.$5qc(vt,Pt)),Di=Ge.set(n.$KN.ExtHostNotebookKernels,new Ie.$6qc(Ge,Dt,Pt,wt,vt)),Li=Ge.set(n.$KN.ExtHostNotebookRenderers,new Pe.$8qc(Ge,Pt)),bi=Ge.set(n.$KN.ExtHostNotebookDocumentSaveParticipant,new pe.$3qc(vt,Pt,Ge.getProxy(n.$JN.MainThreadBulkEdits))),qt=Ge.set(n.$KN.ExtHostEditors,new mt.$Dpc(Ge,Lt)),De=Ge.set(n.$KN.ExtHostTreeViews,new je.$qrc(Ge.getProxy(n.$JN.MainThreadTreeViews),wt,vt)),Re=Ge.set(n.$KN.ExtHostEditorInsets,new w.$Epc(Ge.getProxy(n.$JN.MainThreadEditorInsets),qt,Dt.remote)),de=Ge.set(n.$KN.ExtHostDiagnostics,new L.$tpc(Ge,vt,ti,Lt)),J=Ge.set(n.$KN.ExtHostLanguages,new be.$1qc(Ge,Tt,wt.converter,ai)),ye=Ge.set(n.$KN.ExtHostLanguageFeatures,new ne.$vpc(Ge,ai,Tt,wt,de,vt,Nt,zt)),Be=Ge.set(n.$KN.ExtHostFileSystem,new ce.$Jqc(Ge,ye)),Ze=Ge.set(n.$KN.ExtHostFileSystemEventService,new oe.$Kqc(Ge,vt,Lt)),He=Ge.set(n.$KN.ExtHostQuickOpen,(0,V.$brc)(Ge,gt,wt)),ut=Ge.set(n.$KN.ExtHostSCM,new ge.$drc(Ge,wt,Tt,vt)),Rt=Ge.set(n.$KN.ExtHostQuickDiff,new H.$arc(Ge,ai)),Jt=Ge.set(n.$KN.ExtHostShare,new Qe.$erc(Ge,ai)),si=Ge.set(n.$KN.ExtHostComments,(0,k.$Fpc)(Ge,wt,Tt)),Ut=Ge.set(n.$KN.ExtHostProgress,new j.$_qc(Ge.getProxy(n.$JN.MainThreadProgress))),Yt=Ge.set(n.$KN.ExtHostLabelService,new B.$Yqc(Ge)),Wi=Ge.set(n.$KN.ExtHostTheming,new $t.$nrc(Ge)),rn=Ge.set(n.$KN.ExtHostTimeline,new qe.$prc(Ge,wt)),Vi=Ge.set(n.$KN.ExtHostWebviews,new bt.$Tpc(Ge,Dt.remote,gt,vt,Nt)),Fi=Ge.set(n.$KN.ExtHostWebviewPanels,new Mt.$Wpc(Ge,Vi,gt)),Hi=Ge.set(n.$KN.ExtHostCustomEditors,new b.$Xpc(Ge,Tt,di,Vi,Fi)),Qi=Ge.set(n.$KN.ExtHostWebviewViews,new Ht.$trc(Ge,Vi)),Ci=Ge.set(n.$KN.ExtHostTesting,pt.get(ct.$sqc)),sn=Ge.set(n.$KN.ExtHostUriOpeners,new Xe.$rrc(Ge)),on=Ge.set(n.$KN.ExtHostProfileContentHandlers,new z.$$qc(Ge));Ge.set(n.$KN.ExtHostInteractive,new Z.$Xqc(Ge,Pt,Lt,wt,vt));const Ui=Ge.set(n.$KN.ExtHostChatAgents2,new h.$Apc(Ge,vt,wt,Tt)),an=Ge.set(n.$KN.ExtHostChatVariables,new E.$Bpc(Ge)),zi=Ge.set(n.$KN.ExtHostLanguageModelTools,new Ee.$Zqc(Ge)),Ki=Ge.set(n.$KN.ExtHostAiRelatedInformation,new t.$mpc(Ge)),En=Ge.set(n.$KN.ExtHostAiEmbeddingVector,new le.$Iqc(Ge)),cn=Ge.set(n.$KN.ExtHostStatusBar,new tt.$hrc(Ge,wt.converter)),Gi=Ge.set(n.$KN.ExtHostSpeech,new _e.$frc(Ge)),Pi=Ge.set(n.$KN.ExtHostEmbeddings,new we.$Hqc(Ge)),Dn=Object.values(n.$KN);Ge.assertRegistered(Dn);const Sn=new m.$zpc(Ge,Lt),ln=new D.$Cpc(Ge),Ji=new x.$2qc(Ge,vt),Xi=new W.$Eqc(Ge);return g.$wpc.register(wt),function(Fe,vi,Zi){function ot(te){return(ue,Me,at)=>{const yt=te(Ot=>{try{ue.call(Me,Ot)}catch(gi){P.$Z(new Error(`[ExtensionListenerError] Extension '${Fe.identifier.value}' FAILED to handle event: ${gi.toString()}`,{cause:gi})),zt.onExtensionError(Fe.identifier,gi)}});return at?.push(yt),yt}}const St=function(){let te=!Fe.isUnderDevelopment;function ue(){te||(vt.info(`Extension '${Fe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Me(at){if(Array.isArray(at))at.forEach(Me);else if(typeof at=="string")ue();else{const yt=at;typeof yt.scheme>"u"&&ue(),typeof yt.exclusive=="boolean"&&(0,Ye.$fH)(Fe,"documentFiltersExclusive")}return at}}(),Yi={getSession(te,ue,Me){return typeof Me?.forceNewSession=="object"&&Me.forceNewSession.learnMore&&(0,Ye.$fH)(Fe,"authLearnMore"),Me?.account&&(0,Ye.$fH)(Fe,"authGetSessions"),Bt.getSession(Fe,te,ue,Me)},getAccounts(te){return(0,Ye.$fH)(Fe,"authGetSessions"),Bt.getAccounts(te)},async hasSession(te,ue){return(0,Ye.$fH)(Fe,"authSession"),!!await Bt.getSession(Fe,te,ue,{silent:!0})},get onDidChangeSessions(){return ot(Bt.onDidChangeSessions)},registerAuthenticationProvider(te,ue,Me,at){return Bt.registerAuthenticationProvider(te,ue,Me,at)}},un={registerCommand(te,ue,Me){return wt.registerCommand(!0,te,ue,Me,void 0,Fe)},registerTextEditorCommand(te,ue,Me){return wt.registerCommand(!0,te,(...at)=>{const yt=qt.getActiveTextEditor();if(!yt){vt.warn("Cannot execute "+te+" because there is no active text editor.");return}return yt.edit(Ot=>{ue.apply(Me,[yt,Ot,...at])}).then(Ot=>{Ot||vt.warn("Edits from command "+te+" were not applied.")},Ot=>{vt.warn("An error occurred while running command "+te,Ot)})},void 0,void 0,Fe)},registerDiffInformationCommand:(te,ue,Me)=>((0,Ye.$fH)(Fe,"diffCommand"),wt.registerCommand(!0,te,async(...at)=>{const yt=Lt.activeEditor(!0);if(!yt){vt.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ot=await qt.getDiffInformation(yt.id);ue.apply(Me,[Ot,...at])},void 0,void 0,Fe)),executeCommand(te,...ue){return wt.executeCommand(te,...ue)},getCommands(te=!1){return wt.getCommands(te)}},yi={get machineId(){return Dt.telemetryInfo.machineId},get sessionId(){return Dt.telemetryInfo.sessionId},get language(){return Dt.environment.appLanguage},get appName(){return Dt.environment.appName},get appRoot(){return Dt.environment.appRoot?.fsPath??""},get appHost(){return Dt.environment.appHost},get uriScheme(){return Dt.environment.appUriScheme},get clipboard(){return ln.value},get shell(){return kt.getDefaultShell(!1)},get onDidChangeShell(){return ot(kt.onDidChangeShell)},get isTelemetryEnabled(){return zt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(zt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ye.$fH)(Fe,"telemetry"),zt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ye.$fH)(Fe,"telemetry"),ot(zt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,ft.$CQ)(Dt.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ue){return ft.$BQ.validateSender(te),zt.instantiateLogger(Fe,te,ue)},openExternal(te,ue){return Wt.openUri(te,{allowTunneling:!!Dt.remote.authority,allowContributedOpeners:ue?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===Dt.environment.appUriScheme)return Ai.createAppUri(te);try{return await Wt.asExternalUri(te,{allowTunneling:!!Dt.remote.authority})}catch(ue){if((0,T.$Ng)(te,T.Schemas.http)||(0,T.$Ng)(te,T.Schemas.https))return te;throw ue}},get remoteName(){return(0,c.$hn)(Dt.remote.authority)},get remoteAuthority(){return(0,Ye.$fH)(Fe,"resolvers"),Dt.remote.authority},get uiKind(){return Dt.uiKind},get logLevel(){return vt.getLevel()},get onDidChangeLogLevel(){return ot(vt.onDidChangeLogLevel)},get appQuality(){return(0,Ye.$fH)(Fe,"resolvers"),Dt.quality},get appCommit(){return(0,Ye.$fH)(Fe,"resolvers"),Dt.commit}};Dt.environment.extensionTestsLocationURI||Object.freeze(yi);const ji={createTestController(te,ue,Me){return Ci.createTestController(Fe,te,ue,Me)},createTestObserver(){return(0,Ye.$fH)(Fe,"testObserver"),Ci.createTestObserver()},runTests(te){return(0,Ye.$fH)(Fe,"testObserver"),Ci.runTests(te)},registerTestFollowupProvider(te){return(0,Ye.$fH)(Fe,"testObserver"),Ci.registerTestFollowupProvider(te)},get onDidChangeTestResults(){return(0,Ye.$fH)(Fe,"testObserver"),ot(Ci.onResultsChanged)},get testResults(){return(0,Ye.$fH)(Fe,"testObserver"),Ci.results}},Bi=Dt.remote.isRemote?Y.ExtensionKind.Workspace:Y.ExtensionKind.UI,pi={getExtension(te,ue){(0,Ye.$eH)(Fe,"extensionsAny")||(ue=!1);const Me=vi.mine.getExtensionDescription(te);if(Me)return new _.$oqc(jt,Fe.identifier,Me,Bi,!1);if(ue){const at=vi.all.getExtensionDescription(te);if(at)return new _.$oqc(jt,Fe.identifier,at,Bi,!0)}},get all(){const te=[];for(const ue of vi.mine.getAllExtensionDescriptions())te.push(new _.$oqc(jt,Fe.identifier,ue,Bi,!1));return te},get allAcrossExtensionHosts(){(0,Ye.$fH)(Fe,"extensionsAny");const te=new d.$rn(vi.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),ue=[];for(const Me of vi.all.getAllExtensionDescriptions()){const at=!te.has(Me.identifier);ue.push(new _.$oqc(jt,Fe.identifier,Me,Bi,at))}return ue},get onDidChange(){return(0,Ye.$eH)(Fe,"extensionsAny")?ot(O.Event.any(vi.mine.onDidChange,vi.all.onDidChange)):ot(vi.mine.onDidChange)}},qi={createDiagnosticCollection(te){return de.createDiagnosticCollection(Fe.identifier,te)},get onDidChangeDiagnostics(){return ot(de.onDidChangeDiagnostics)},getDiagnostics:te=>de.getDiagnostics(te),getLanguages(){return J.getLanguages()},setTextDocumentLanguage(te,ue){return J.changeLanguage(te.uri,ue)},match(te,ue){const Me=ee.LanguageSelector.from(te);let at;return(0,y.$wu)(Me)&&(at=Pt.notebookDocuments.find(yt=>yt.apiNotebook.getCells().find(Ot=>Ot.document===ue))?.apiNotebook),(0,y.$vu)(Me,ue.uri,ue.languageId,!0,at?.uri,at?.notebookType)},registerCodeActionsProvider(te,ue,Me){return ye.registerCodeActionProvider(Fe,St(te),ue,Me)},registerDocumentPasteEditProvider(te,ue,Me){return(0,Ye.$fH)(Fe,"documentPaste"),ye.registerDocumentPasteEditProvider(Fe,St(te),ue,Me)},registerCodeLensProvider(te,ue){return ye.registerCodeLensProvider(Fe,St(te),ue)},registerDefinitionProvider(te,ue){return ye.registerDefinitionProvider(Fe,St(te),ue)},registerDeclarationProvider(te,ue){return ye.registerDeclarationProvider(Fe,St(te),ue)},registerImplementationProvider(te,ue){return ye.registerImplementationProvider(Fe,St(te),ue)},registerTypeDefinitionProvider(te,ue){return ye.registerTypeDefinitionProvider(Fe,St(te),ue)},registerHoverProvider(te,ue){return ye.registerHoverProvider(Fe,St(te),ue,Fe.identifier)},registerEvaluatableExpressionProvider(te,ue){return ye.registerEvaluatableExpressionProvider(Fe,St(te),ue,Fe.identifier)},registerInlineValuesProvider(te,ue){return ye.registerInlineValuesProvider(Fe,St(te),ue,Fe.identifier)},registerDocumentHighlightProvider(te,ue){return ye.registerDocumentHighlightProvider(Fe,St(te),ue)},registerMultiDocumentHighlightProvider(te,ue){return ye.registerMultiDocumentHighlightProvider(Fe,St(te),ue)},registerLinkedEditingRangeProvider(te,ue){return ye.registerLinkedEditingRangeProvider(Fe,St(te),ue)},registerReferenceProvider(te,ue){return ye.registerReferenceProvider(Fe,St(te),ue)},registerRenameProvider(te,ue){return ye.registerRenameProvider(Fe,St(te),ue)},registerNewSymbolNamesProvider(te,ue){return(0,Ye.$fH)(Fe,"newSymbolNamesProvider"),ye.registerNewSymbolNamesProvider(Fe,St(te),ue)},registerDocumentSymbolProvider(te,ue,Me){return ye.registerDocumentSymbolProvider(Fe,St(te),ue,Me)},registerWorkspaceSymbolProvider(te){return ye.registerWorkspaceSymbolProvider(Fe,te)},registerDocumentFormattingEditProvider(te,ue){return ye.registerDocumentFormattingEditProvider(Fe,St(te),ue)},registerDocumentRangeFormattingEditProvider(te,ue){return ye.registerDocumentRangeFormattingEditProvider(Fe,St(te),ue)},registerOnTypeFormattingEditProvider(te,ue,Me,...at){return ye.registerOnTypeFormattingEditProvider(Fe,St(te),ue,[Me].concat(at))},registerDocumentSemanticTokensProvider(te,ue,Me){return ye.registerDocumentSemanticTokensProvider(Fe,St(te),ue,Me)},registerDocumentRangeSemanticTokensProvider(te,ue,Me){return ye.registerDocumentRangeSemanticTokensProvider(Fe,St(te),ue,Me)},registerSignatureHelpProvider(te,ue,Me,...at){return typeof Me=="object"?ye.registerSignatureHelpProvider(Fe,St(te),ue,Me):ye.registerSignatureHelpProvider(Fe,St(te),ue,typeof Me>"u"?[]:[Me,...at])},registerCompletionItemProvider(te,ue,...Me){return ye.registerCompletionItemProvider(Fe,St(te),ue,Me)},registerInlineCompletionItemProvider(te,ue,Me){return ue.handleDidShowCompletionItem&&(0,Ye.$fH)(Fe,"inlineCompletionsAdditions"),ue.handleDidPartiallyAcceptCompletionItem&&(0,Ye.$fH)(Fe,"inlineCompletionsAdditions"),Me&&(0,Ye.$fH)(Fe,"inlineCompletionsAdditions"),ye.registerInlineCompletionsProvider(Fe,St(te),ue,Me)},registerInlineEditProvider(te,ue){return(0,Ye.$fH)(Fe,"inlineEdit"),ye.registerInlineEditProvider(Fe,St(te),ue)},registerDocumentLinkProvider(te,ue){return ye.registerDocumentLinkProvider(Fe,St(te),ue)},registerColorProvider(te,ue){return ye.registerColorProvider(Fe,St(te),ue)},registerFoldingRangeProvider(te,ue){return ye.registerFoldingRangeProvider(Fe,St(te),ue)},registerSelectionRangeProvider(te,ue){return ye.registerSelectionRangeProvider(Fe,te,ue)},registerCallHierarchyProvider(te,ue){return ye.registerCallHierarchyProvider(Fe,te,ue)},registerTypeHierarchyProvider(te,ue){return ye.registerTypeHierarchyProvider(Fe,te,ue)},setLanguageConfiguration:(te,ue)=>ye.setLanguageConfiguration(Fe,te,ue),getTokenInformationAtPosition(te,ue){return(0,Ye.$fH)(Fe,"tokenInformation"),J.tokenAtPosition(te,ue)},registerInlayHintsProvider(te,ue){return ye.registerInlayHintsProvider(Fe,te,ue)},createLanguageStatusItem(te,ue){return J.createLanguageStatusItem(Fe,te,ue)},registerDocumentDropEditProvider(te,ue,Me){return ye.registerDocumentOnDropEditProvider(Fe,te,ue,(0,Ye.$eH)(Fe,"documentPaste")?Me:void 0)}},hn={get activeTextEditor(){return qt.getActiveTextEditor()},get visibleTextEditors(){return qt.getVisibleTextEditors()},get activeTerminal(){return kt.activeTerminal},get terminals(){return kt.terminals},async showTextDocument(te,ue,Me){o.URI.isUri(te)&&te.scheme===T.Schemas.vscodeRemote&&!te.authority&&Nt.report("workspace.showTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority.");const at=await(o.URI.isUri(te)?Promise.resolve(xi.openTextDocument(te)):Promise.resolve(te));return qt.showTextDocument(at,ue,Me)},createTextEditorDecorationType(te){return qt.createTextEditorDecorationType(Fe,te)},onDidChangeActiveTextEditor(te,ue,Me){return ot(qt.onDidChangeActiveTextEditor)(te,ue,Me)},onDidChangeVisibleTextEditors(te,ue,Me){return ot(qt.onDidChangeVisibleTextEditors)(te,ue,Me)},onDidChangeTextEditorSelection(te,ue,Me){return ot(qt.onDidChangeTextEditorSelection)(te,ue,Me)},onDidChangeTextEditorOptions(te,ue,Me){return ot(qt.onDidChangeTextEditorOptions)(te,ue,Me)},onDidChangeTextEditorVisibleRanges(te,ue,Me){return ot(qt.onDidChangeTextEditorVisibleRanges)(te,ue,Me)},onDidChangeTextEditorViewColumn(te,ue,Me){return ot(qt.onDidChangeTextEditorViewColumn)(te,ue,Me)},onDidCloseTerminal(te,ue,Me){return ot(kt.onDidCloseTerminal)(te,ue,Me)},onDidOpenTerminal(te,ue,Me){return ot(kt.onDidOpenTerminal)(te,ue,Me)},onDidChangeActiveTerminal(te,ue,Me){return ot(kt.onDidChangeActiveTerminal)(te,ue,Me)},onDidChangeTerminalDimensions(te,ue,Me){return(0,Ye.$fH)(Fe,"terminalDimensions"),ot(kt.onDidChangeTerminalDimensions)(te,ue,Me)},onDidChangeTerminalState(te,ue,Me){return ot(kt.onDidChangeTerminalState)(te,ue,Me)},onDidWriteTerminalData(te,ue,Me){return(0,Ye.$fH)(Fe,"terminalDataWriteEvent"),ot(kt.onDidWriteTerminalData)(te,ue,Me)},onDidExecuteTerminalCommand(te,ue,Me){return(0,Ye.$fH)(Fe,"terminalExecuteCommandEvent"),ot(kt.onDidExecuteTerminalCommand)(te,ue,Me)},onDidChangeTerminalShellIntegration(te,ue,Me){return(0,Ye.$fH)(Fe,"terminalShellIntegration"),ot(Vt.onDidChangeTerminalShellIntegration)(te,ue,Me)},onDidStartTerminalShellExecution(te,ue,Me){return(0,Ye.$fH)(Fe,"terminalShellIntegration"),ot(Vt.onDidStartTerminalShellExecution)(te,ue,Me)},onDidEndTerminalShellExecution(te,ue,Me){return(0,Ye.$fH)(Fe,"terminalShellIntegration"),ot(Vt.onDidEndTerminalShellExecution)(te,ue,Me)},get state(){return Wt.getState()},onDidChangeWindowState(te,ue,Me){return ot(Wt.onDidChangeWindowState)(te,ue,Me)},showInformationMessage(te,...ue){return Ji.showMessage(Fe,p.default.Info,te,ue[0],ue.slice(1))},showWarningMessage(te,...ue){return Ji.showMessage(Fe,p.default.Warning,te,ue[0],ue.slice(1))},showErrorMessage(te,...ue){return Ji.showMessage(Fe,p.default.Error,te,ue[0],ue.slice(1))},showQuickPick(te,ue,Me){return He.showQuickPick(Fe,te,ue,Me)},showWorkspaceFolderPick(te){return He.showWorkspaceFolderPick(te)},showInputBox(te,ue){return He.showInput(te,ue)},showOpenDialog(te){return Xi.showOpenDialog(Fe,te)},showSaveDialog(te){return Xi.showSaveDialog(te)},createStatusBarItem(te,ue,Me){let at,yt,Ot;return typeof te=="string"?(at=te,yt=ue,Ot=Me):(yt=te,Ot=ue),cn.createStatusBarEntry(Fe,at,yt,Ot)},setStatusBarMessage(te,ue){return cn.setStatusBarMessage(te,ue)},withScmProgress(te){return Nt.report("window.withScmProgress",Fe,"Use 'withProgress' instead."),Ut.withProgress(Fe,{location:Y.ProgressLocation.SourceControl},(ue,Me)=>te({report(at){}}))},withProgress(te,ue){return Ut.withProgress(Fe,te,ue)},createOutputChannel(te,ue){return ki.createOutputChannel(te,ue,Fe)},createWebviewPanel(te,ue,Me,at){return Fi.createWebviewPanel(Fe,te,ue,Me,at)},createWebviewTextEditorInset(te,ue,Me,at){return(0,Ye.$fH)(Fe,"editorInsets"),Re.createWebviewEditorInset(te,ue,Me,at,Fe)},createTerminal(te,ue,Me){return typeof te=="object"?"pty"in te?kt.createExtensionTerminal(te):kt.createTerminalFromOptions(te):kt.createTerminal(te,ue,Me)},registerTerminalLinkProvider(te){return kt.registerLinkProvider(te)},registerTerminalProfileProvider(te,ue){return kt.registerProfileProvider(Fe,te,ue)},registerTerminalQuickFixProvider(te,ue){return(0,Ye.$fH)(Fe,"terminalQuickFixProvider"),kt.registerTerminalQuickFixProvider(te,Fe.identifier.value,ue)},registerTreeDataProvider(te,ue){return De.registerTreeDataProvider(te,ue,Fe)},createTreeView(te,ue){return De.createTreeView(te,ue,Fe)},registerWebviewPanelSerializer:(te,ue)=>Fi.registerWebviewPanelSerializer(Fe,te,ue),registerCustomEditorProvider:(te,ue,Me={})=>Hi.registerCustomEditorProvider(Fe,te,ue,Me),registerFileDecorationProvider(te){return Gt.registerFileDecorationProvider(te,Fe)},registerUriHandler(te){return Ai.registerUriHandler(Fe,te)},createQuickPick(){return He.createQuickPick(Fe)},createInputBox(){return He.createInputBox(Fe)},get activeColorTheme(){return Wi.activeColorTheme},onDidChangeActiveColorTheme(te,ue,Me){return ot(Wi.onDidChangeActiveColorTheme)(te,ue,Me)},registerWebviewViewProvider(te,ue,Me){return Qi.registerWebviewViewProvider(Fe,te,ue,Me?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ue,Me){return ot(Pt.onDidChangeActiveNotebookEditor)(te,ue,Me)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(te,ue,Me){return ot(Ii.onDidChangeNotebookEditorSelection)(te,ue,Me)},onDidChangeNotebookEditorVisibleRanges(te,ue,Me){return ot(Ii.onDidChangeNotebookEditorVisibleRanges)(te,ue,Me)},showNotebookDocument(te,ue){return Pt.showNotebookDocument(te,ue)},registerExternalUriOpener(te,ue,Me){return(0,Ye.$fH)(Fe,"externalUriOpener"),sn.registerExternalUriOpener(Fe.identifier,te,ue,Me)},registerProfileContentHandler(te,ue){return(0,Ye.$fH)(Fe,"profileContentHandlers"),on.registerProfileContentHandler(Fe,te,ue)},registerQuickDiffProvider(te,ue,Me,at){return(0,Ye.$fH)(Fe,"quickDiffProvider"),Rt.registerQuickDiffProvider(St(te),ue,Me,at)},get tabGroups(){return Kt.tabGroups},registerShareProvider(te,ue){return(0,Ye.$fH)(Fe,"shareProvider"),Jt.registerShareProvider(St(te),ue)}},xi={get rootPath(){return Nt.report("workspace.rootPath",Fe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),gt.getPath()},set rootPath(te){throw new P.$8("rootPath")},getWorkspaceFolder(te){return gt.getWorkspaceFolder(te)},get workspaceFolders(){return gt.getWorkspaceFolders()},get name(){return gt.name},set name(te){throw new P.$8("name")},get workspaceFile(){return gt.workspaceFile},set workspaceFile(te){throw new P.$8("workspaceFile")},updateWorkspaceFolders:(te,ue,...Me)=>gt.updateWorkspaceFolders(Fe,te,ue||0,...Me),onDidChangeWorkspaceFolders:function(te,ue,Me){return ot(gt.onDidChangeWorkspace)(te,ue,Me)},asRelativePath:(te,ue)=>gt.getRelativePath(te,ue),findFiles:(te,ue,Me,at)=>gt.findFiles(te,ue,Me,Fe.identifier,at),findFiles2:(te,ue,Me)=>((0,Ye.$fH)(Fe,"findFiles2"),gt.findFiles2(te,ue,Fe.identifier,Me)),findFiles2New:(te,ue,Me)=>{(0,Ye.$fH)(Fe,"findFiles2New");const at={exclude:ue?.exclude&&ue.exclude.length>0?ue.exclude[0]:void 0,useDefaultExcludes:!ue?.useExcludeSettings||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.filesExclude||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,useDefaultSearchExcludes:!ue?.useExcludeSettings||ue?.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,maxResults:ue?.maxResults,useIgnoreFiles:ue?.useIgnoreFiles?.local,useGlobalIgnoreFiles:ue?.useIgnoreFiles?.global,useParentIgnoreFiles:ue?.useIgnoreFiles?.parent,followSymlinks:ue?.followSymlinks};return gt.findFiles2(te&&te.length>0?te[0]:void 0,at,Fe.identifier,Me)},findTextInFiles:(te,ue,Me,at)=>{(0,Ye.$fH)(Fe,"findTextInFiles");let yt,Ot;return typeof ue=="object"?(yt=ue,Ot=Me):(yt={},Ot=ue,at=Me),gt.findTextInFiles(te,yt||{},Ot,Fe.identifier,at)},findTextInFilesNew:(te,ue,Me)=>{(0,Ye.$fH)(Fe,"findTextInFilesNew"),(0,Ye.$fH)(Fe,"textSearchProviderNew");let at={};ue&&(at={include:ue.include&&ue.include.length>0?ue.include[0]:void 0,exclude:ue.exclude&&ue.exclude.length>0?ue.exclude[0]:void 0,useDefaultExcludes:ue.useExcludeSettings===void 0||ue.useExcludeSettings===Ct.ExcludeSettingOptions.filesExclude||ue.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,useSearchExclude:ue.useExcludeSettings===void 0||ue.useExcludeSettings===Ct.ExcludeSettingOptions.searchAndFilesExclude,maxResults:ue.maxResults,useIgnoreFiles:ue.useIgnoreFiles?.local,useGlobalIgnoreFiles:ue.useIgnoreFiles?.global,useParentIgnoreFiles:ue.useIgnoreFiles?.parent,followSymlinks:ue.followSymlinks,encoding:ue.encoding,previewOptions:ue.previewOptions?{matchLines:ue.previewOptions?.matchLines??100,charsPerLine:ue.previewOptions?.charsPerLine??1e4}:void 0,beforeContext:ue.surroundingContext,afterContext:ue.surroundingContext});const yt=Promise.resolve(void 0);return{results:new v.$5h(async gi=>{const Mi=async en=>(gi.emitOne((0,Ct.$ZL)(en)),en);await yt.then(en=>gt.findTextInFiles(te,at,Mi,Fe.identifier,Me))}),complete:yt.then(gi=>({limitHit:gi?.limitHit??!1}))}},save:te=>gt.save(te),saveAs:te=>gt.saveAs(te),saveAll:te=>gt.saveAll(te),applyEdit(te,ue){return Sn.applyWorkspaceEdit(te,Fe,ue)},createFileSystemWatcher:(te,ue,Me,at)=>{let yt;return typeof ue=="boolean"?yt={ignoreCreateEvents:!!ue,ignoreChangeEvents:!!Me,ignoreDeleteEvents:!!at,correlate:!1}:ue&&((0,Ye.$fH)(Fe,"createFileSystemWatcher"),yt={...ue,correlate:!0}),Ze.createFileSystemWatcher(gt,Fe,te,yt)},get textDocuments(){return Tt.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw new P.$8("textDocuments")},openTextDocument(te){let ue;const Me=te;if(typeof te=="string")ue=Promise.resolve(o.URI.file(te));else if(o.URI.isUri(te))ue=Promise.resolve(te);else if(!Me||typeof Me=="object")ue=Tt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ue.then(at=>(at.scheme===T.Schemas.vscodeRemote&&!at.authority&&Nt.report("workspace.openTextDocument",Fe,"A URI of 'vscode-remote' scheme requires an authority."),Tt.ensureDocumentData(at).then(yt=>yt.document)))},onDidOpenTextDocument:(te,ue,Me)=>ot(Tt.onDidAddDocument)(te,ue,Me),onDidCloseTextDocument:(te,ue,Me)=>ot(Tt.onDidRemoveDocument)(te,ue,Me),onDidChangeTextDocument:(te,ue,Me)=>ot(Tt.onDidChangeDocument)(te,ue,Me),onDidSaveTextDocument:(te,ue,Me)=>ot(Tt.onDidSaveDocument)(te,ue,Me),onWillSaveTextDocument:(te,ue,Me)=>ot(ui.getOnWillSaveTextDocumentEvent(Fe))(te,ue,Me),get notebookDocuments(){return Pt.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ue){let Me;if(o.URI.isUri(te))Me=te,await Pt.openNotebookDocument(te);else if(typeof te=="string")Me=o.URI.revive(await Pt.createNotebookDocument({viewType:te,content:ue}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(te,ue,Me){return ot(Ti.onDidSaveNotebookDocument)(te,ue,Me)},onDidChangeNotebookDocument(te,ue,Me){return ot(Ti.onDidChangeNotebookDocument)(te,ue,Me)},onWillSaveNotebookDocument(te,ue,Me){return ot(bi.getOnWillSaveNotebookDocumentEvent(Fe))(te,ue,Me)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(te,ue,Me,at){return Pt.registerNotebookSerializer(Fe,te,ue,Me,(0,Ye.$eH)(Fe,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(te,ue,Me)=>ot(Zi.onDidChangeConfiguration)(te,ue,Me),getConfiguration(te,ue){return ue=arguments.length===1?void 0:ue,Zi.getConfiguration(te,ue,Fe)},registerTextDocumentContentProvider(te,ue){return Ni.registerTextDocumentContentProvider(te,ue)},registerTaskProvider:(te,ue)=>(Nt.report("window.registerTaskProvider",Fe,"Use the corresponding function on the 'tasks' namespace instead"),Zt.registerTaskProvider(Fe,te,ue)),registerFileSystemProvider(te,ue,Me){return(0,A.$Rc)(Be.registerFileSystemProvider(Fe,te,ue,Me),ii.addFileSystemProvider(te,ue,Me))},get fs(){return ii.value},registerFileSearchProvider:(te,ue)=>((0,Ye.$fH)(Fe,"fileSearchProvider"),mi.registerFileSearchProvider(te,ue)),registerTextSearchProvider:(te,ue)=>((0,Ye.$fH)(Fe,"textSearchProvider"),mi.registerTextSearchProvider(te,ue)),registerAITextSearchProvider:(te,ue)=>((0,Ye.$fH)(Fe,"aiTextSearchProvider"),(0,Ye.$fH)(Fe,"textSearchProvider"),mi.registerAITextSearchProvider(te,ue)),registerFileSearchProviderNew:(te,ue)=>((0,Ye.$fH)(Fe,"fileSearchProviderNew"),{dispose:()=>{}}),registerTextSearchProviderNew:(te,ue)=>((0,Ye.$fH)(Fe,"textSearchProviderNew"),{dispose:()=>{}}),registerAITextSearchProviderNew:(te,ue)=>((0,Ye.$fH)(Fe,"aiTextSearchProviderNew"),(0,Ye.$fH)(Fe,"textSearchProviderNew"),{dispose:()=>{}}),registerRemoteAuthorityResolver:(te,ue)=>((0,Ye.$fH)(Fe,"resolvers"),jt.registerRemoteAuthorityResolver(te,ue)),registerResourceLabelFormatter:te=>((0,Ye.$fH)(Fe,"resolvers"),Yt.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,Ye.$fH)(Fe,"resolvers"),jt.getRemoteExecServer(te)),onDidCreateFiles:(te,ue,Me)=>ot(Ze.onDidCreateFile)(te,ue,Me),onDidDeleteFiles:(te,ue,Me)=>ot(Ze.onDidDeleteFile)(te,ue,Me),onDidRenameFiles:(te,ue,Me)=>ot(Ze.onDidRenameFile)(te,ue,Me),onWillCreateFiles:(te,ue,Me)=>ot(Ze.getOnWillCreateFileEvent(Fe))(te,ue,Me),onWillDeleteFiles:(te,ue,Me)=>ot(Ze.getOnWillDeleteFileEvent(Fe))(te,ue,Me),onWillRenameFiles:(te,ue,Me)=>ot(Ze.getOnWillRenameFileEvent(Fe))(te,ue,Me),openTunnel:te=>((0,Ye.$fH)(Fe,"tunnels"),Ft.openTunnel(Fe,te).then(ue=>{if(!ue)throw new Error("cannot open tunnel");return ue})),get tunnels(){return(0,Ye.$fH)(Fe,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(te,ue,Me)=>((0,Ye.$fH)(Fe,"tunnels"),ot(Ft.onDidChangeTunnels)(te,ue,Me)),registerPortAttributesProvider:(te,ue)=>((0,Ye.$fH)(Fe,"portsAttributes"),Ft.registerPortsAttributesProvider(te,ue)),registerTunnelProvider:(te,ue)=>((0,Ye.$fH)(Fe,"tunnelFactory"),Ft.registerTunnelProvider(te,ue)),registerTimelineProvider:(te,ue)=>((0,Ye.$fH)(Fe,"timeline"),rn.registerTimelineProvider(te,ue,Fe.identifier,wt.converter)),get isTrusted(){return gt.trusted},requestWorkspaceTrust:te=>((0,Ye.$fH)(Fe,"workspaceTrust"),gt.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ue,Me)=>ot(gt.onDidGrantWorkspaceTrust)(te,ue,Me),registerEditSessionIdentityProvider:(te,ue)=>((0,Ye.$fH)(Fe,"editSessionIdentityProvider"),gt.registerEditSessionIdentityProvider(te,ue)),onWillCreateEditSessionIdentity:(te,ue,Me)=>((0,Ye.$fH)(Fe,"editSessionIdentityProvider"),ot(gt.getOnWillCreateEditSessionIdentityEvent(Fe))(te,ue,Me)),registerCanonicalUriProvider:(te,ue)=>((0,Ye.$fH)(Fe,"canonicalUriProvider"),gt.registerCanonicalUriProvider(te,ue)),getCanonicalUri:(te,ue,Me)=>((0,Ye.$fH)(Fe,"canonicalUriProvider"),gt.provideCanonicalUri(te,ue,Me))},dn={get inputBox(){return Nt.report("scm.inputBox",Fe,"Use 'SourceControl.inputBox' instead"),ut.getLastInputBox(Fe)},createSourceControl(te,ue,Me){return ut.createSourceControl(Fe,te,ue,Me)}},fn={createCommentController(te,ue){return si.createCommentController(Fe,te,ue)}},kn={get activeDebugSession(){return It.activeDebugSession},get activeDebugConsole(){return It.activeDebugConsole},get breakpoints(){return It.breakpoints},get activeStackItem(){return It.activeStackItem},registerDebugVisualizationProvider(te,ue){return(0,Ye.$fH)(Fe,"debugVisualization"),It.registerDebugVisualizationProvider(Fe,te,ue)},registerDebugVisualizationTreeProvider(te,ue){return(0,Ye.$fH)(Fe,"debugVisualization"),It.registerDebugVisualizationTree(Fe,te,ue)},onDidStartDebugSession(te,ue,Me){return ot(It.onDidStartDebugSession)(te,ue,Me)},onDidTerminateDebugSession(te,ue,Me){return ot(It.onDidTerminateDebugSession)(te,ue,Me)},onDidChangeActiveDebugSession(te,ue,Me){return ot(It.onDidChangeActiveDebugSession)(te,ue,Me)},onDidReceiveDebugSessionCustomEvent(te,ue,Me){return ot(It.onDidReceiveDebugSessionCustomEvent)(te,ue,Me)},onDidChangeBreakpoints(te,ue,Me){return ot(It.onDidChangeBreakpoints)(te,ue,Me)},onDidChangeActiveStackItem(te,ue,Me){return ot(It.onDidChangeActiveStackItem)(te,ue,Me)},registerDebugConfigurationProvider(te,ue,Me){return It.registerDebugConfigurationProvider(te,ue,Me||oi.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ue){return It.registerDebugAdapterDescriptorFactory(Fe,te,ue)},registerDebugAdapterTrackerFactory(te,ue){return It.registerDebugAdapterTrackerFactory(te,ue)},startDebugging(te,ue,Me){return!Me||typeof Me=="object"&&"configuration"in Me?It.startDebugging(te,ue,{parentSession:Me}):It.startDebugging(te,ue,Me||{})},stopDebugging(te){return It.stopDebugging(te)},addBreakpoints(te){return It.addBreakpoints(te)},removeBreakpoints(te){return It.removeBreakpoints(te)},asDebugSourceUri(te,ue){return It.asDebugSourceUri(te,ue)}},gn={registerTaskProvider:(te,ue)=>Zt.registerTaskProvider(Fe,te,ue),fetchTasks:te=>Zt.fetchTasks(te),executeTask:te=>Zt.executeTask(Fe,te),get taskExecutions(){return Zt.taskExecutions},onDidStartTask:(te,ue,Me)=>ot(Zt.onDidStartTask)(te,ue,Me),onDidEndTask:(te,ue,Me)=>ot(Zt.onDidEndTask)(te,ue,Me),onDidStartTaskProcess:(te,ue,Me)=>ot(Zt.onDidStartTaskProcess)(te,ue,Me),onDidEndTaskProcess:(te,ue,Me)=>ot(Zt.onDidEndTaskProcess)(te,ue,Me)},mn={createNotebookController(te,ue,Me,at,yt){return Di.createNotebookController(Fe,te,ue,Me,at,(0,Ye.$eH)(Fe,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ue)=>Pt.registerNotebookCellStatusBarItemProvider(Fe,te,ue),createRendererMessaging(te){return Li.createRendererMessaging(Fe,te)},createNotebookControllerDetectionTask(te){return(0,Ye.$fH)(Fe,"notebookKernelSource"),Di.createNotebookControllerDetectionTask(Fe,te)},registerKernelSourceActionProvider(te,ue){return(0,Ye.$fH)(Fe,"notebookKernelSource"),Di.registerKernelSourceActionProvider(Fe,te,ue)},onDidChangeNotebookCellExecutionState(te,ue,Me){return(0,Ye.$fH)(Fe,"notebookCellExecutionState"),ot(Di.onDidChangeNotebookCellExecutionState)(te,ue,Me)}},In={t(...te){if(typeof te[0]=="string"){const ue=te.shift(),Me=!te||typeof te[0]!="object"?te:te[0];return wi.getMessage(Fe.identifier.value,{message:ue,args:Me})}return wi.getMessage(Fe.identifier.value,te[0])},get bundle(){return wi.getBundle(Fe.identifier.value)},get uri(){return wi.getBundleUri(Fe.identifier.value)}},Cn={_version:1,transferActiveChat(te){return(0,Ye.$fH)(Fe,"interactive"),Ui.transferActiveChat(te)}},pn={getRelatedInformation(te,ue){return(0,Ye.$fH)(Fe,"aiRelatedInformation"),Ki.getRelatedInformation(Fe,te,ue)},registerRelatedInformationProvider(te,ue){return(0,Ye.$fH)(Fe,"aiRelatedInformation"),Ki.registerRelatedInformationProvider(Fe,te,ue)},registerEmbeddingVectorProvider(te,ue){return(0,Ye.$fH)(Fe,"aiRelatedInformation"),En.registerEmbeddingVectorProvider(Fe,te,ue)}},_i={_version:1,registerChatResponseProvider(te,ue,Me){return(0,Ye.$fH)(Fe,"chatProvider"),Qt.registerLanguageModel(Fe,te,ue,Me)},registerChatVariableResolver(te,ue,Me,at,yt,Ot,gi,Mi){return(0,Ye.$fH)(Fe,"chatVariableResolver"),an.registerVariableResolver(Fe,te,ue,Me,at,yt,Ot,gi,Mi?.id)},registerMappedEditsProvider(te,ue){return(0,Ye.$fH)(Fe,"mappedEditsProvider"),ye.registerMappedEditsProvider(Fe,te,ue)},createChatParticipant(te,ue){return Ui.createChatAgent(Fe,te,ue)},createDynamicChatParticipant(te,ue,Me){return(0,Ye.$fH)(Fe,"chatParticipantPrivate"),Ui.createDynamicChatAgent(Fe,te,ue,Me)}},$n={selectChatModels:te=>Qt.selectLanguageModels(Fe,te??{}),onDidChangeChatModels:(te,ue,Me)=>Qt.onDidChangeProviders(te,ue,Me),registerChatModelProvider:(te,ue,Me)=>((0,Ye.$fH)(Fe,"chatProvider"),Qt.registerLanguageModel(Fe,te,ue,Me)),get embeddingModels(){return(0,Ye.$fH)(Fe,"embeddings"),Pi.embeddingsModels},onDidChangeEmbeddingModels:(te,ue,Me)=>((0,Ye.$fH)(Fe,"embeddings"),Pi.onDidChange(te,ue,Me)),registerEmbeddingsProvider(te,ue){return(0,Ye.$fH)(Fe,"embeddings"),Pi.registerEmbeddingsProvider(Fe,te,ue)},async computeEmbeddings(te,ue,Me){return(0,Ye.$fH)(Fe,"embeddings"),Pi.computeEmbeddings(te,ue,Me)},registerTool(te,ue){return(0,Ye.$fH)(Fe,"lmTools"),zi.registerTool(Fe,te,ue)},invokeTool(te,ue,Me){return(0,Ye.$fH)(Fe,"lmTools"),zi.invokeTool(te,ue,Me)},get tools(){return(0,Ye.$fH)(Fe,"lmTools"),zi.tools}},wn={registerSpeechProvider(te,ue){return(0,Ye.$fH)(Fe,"speech"),Gi.registerProvider(Fe.identifier,te,ue)}};return{version:Dt.version,ai:pn,authentication:Yi,commands:un,comments:fn,chat:_i,debug:kn,env:yi,extensions:pi,interactive:Cn,l10n:In,languages:qi,lm:$n,notebooks:mn,scm:dn,speech:wn,tasks:gn,tests:ji,window:hn,workspace:xi,Breakpoint:Y.$OO,TerminalOutputAnchor:Y.TerminalOutputAnchor,ChatResultFeedbackKind:Y.ChatResultFeedbackKind,ChatVariableLevel:Y.ChatVariableLevel,ChatCompletionItem:Y.$KP,CallHierarchyIncomingCall:Y.$aO,CallHierarchyItem:Y.$_N,CallHierarchyOutgoingCall:Y.$bO,CancellationError:P.$4,CancellationTokenSource:R.$we,CandidatePortSource:n.CandidatePortSource,CodeAction:Y.$9N,CodeActionKind:Y.$0N,CodeActionTriggerKind:Y.CodeActionTriggerKind,CodeLens:Y.$cO,Color:Y.$pO,ColorInformation:Y.$qO,ColorPresentation:Y.$rO,ColorThemeKind:Y.ColorThemeKind,CommentMode:Y.CommentMode,CommentState:Y.CommentState,CommentThreadCollapsibleState:Y.CommentThreadCollapsibleState,CommentThreadState:Y.CommentThreadState,CommentThreadApplicability:Y.CommentThreadApplicability,CommentThreadFocus:Y.CommentThreadFocus,CompletionItem:Y.$jO,CompletionItemKind:Y.CompletionItemKind,CompletionItemTag:Y.CompletionItemTag,CompletionList:Y.$kO,CompletionTriggerKind:Y.CompletionTriggerKind,ConfigurationTarget:Y.ConfigurationTarget,CustomExecution:Y.$zO,DebugAdapterExecutable:Y.$SO,DebugAdapterInlineImplementation:Y.$VO,DebugAdapterNamedPipeServer:Y.$UO,DebugAdapterServer:Y.$TO,DebugConfigurationProviderTriggerKind:oi.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Y.DebugConsoleMode,DebugVisualization:Y.$_O,DecorationRangeBehavior:Y.DecorationRangeBehavior,Diagnostic:Y.$2N,DiagnosticRelatedInformation:Y.$1N,DiagnosticSeverity:Y.DiagnosticSeverity,DiagnosticTag:Y.DiagnosticTag,Disposable:Y.$LN,DocumentHighlight:Y.$5N,DocumentHighlightKind:Y.DocumentHighlightKind,MultiDocumentHighlight:Y.$6N,DocumentLink:Y.$oO,DocumentSymbol:Y.$8N,EndOfLine:Y.EndOfLine,EnvironmentVariableMutatorType:Y.EnvironmentVariableMutatorType,EvaluatableExpression:Y.$YO,InlineValueText:Y.$ZO,InlineValueVariableLookup:Y.$1O,InlineValueEvaluatableExpression:Y.$2O,InlineCompletionTriggerKind:Y.InlineCompletionTriggerKind,EventEmitter:O.$le,ExtensionKind:Y.ExtensionKind,ExtensionMode:Y.ExtensionMode,ExternalUriOpenerPriority:Y.ExternalUriOpenerPriority,FileChangeType:Y.FileChangeType,FileDecoration:Y.$bP,FileDecoration2:Y.$bP,FileSystemError:Y.$5O,FileType:r.FileType,FilePermission:r.FilePermission,FoldingRange:Y.$6O,FoldingRangeKind:Y.FoldingRangeKind,FunctionBreakpoint:Y.$QO,InlineCompletionItem:Y.$lO,InlineCompletionList:Y.$mO,Hover:Y.$3N,VerboseHover:Y.$4N,HoverVerbosityAction:Y.HoverVerbosityAction,IndentAction:a.IndentAction,Location:Y.$ZN,MarkdownString:Y.$dO,OverviewRulerLane:S.OverviewRulerLane,ParameterInformation:Y.$eO,PortAutoForwardAction:Y.PortAutoForwardAction,Position:Y.$MN,ProcessExecution:Y.$xO,ProgressLocation:Y.ProgressLocation,QuickInputButtonLocation:Y.QuickInputButtonLocation,QuickInputButtons:Y.$aP,Range:Y.$NN,RelativePattern:Y.$MO,Selection:Y.$ON,SelectionRange:Y.$$N,SemanticTokens:Y.$9O,SemanticTokensBuilder:Y.$8O,SemanticTokensEdit:Y.$0O,SemanticTokensEdits:Y.$$O,SemanticTokensLegend:Y.$7O,ShellExecution:Y.$yO,ShellQuoting:Y.ShellQuoting,SignatureHelp:Y.$gO,SignatureHelpTriggerKind:Y.SignatureHelpTriggerKind,SignatureInformation:Y.$fO,SnippetString:Y.$YN,SourceBreakpoint:Y.$PO,StandardTokenType:Y.StandardTokenType,StatusBarAlignment:Y.StatusBarAlignment,SymbolInformation:Y.$7N,SymbolKind:Y.SymbolKind,SymbolTag:Y.SymbolTag,Task:Y.$AO,TaskGroup:Y.$wO,TaskPanelKind:Y.TaskPanelKind,TaskRevealKind:Y.TaskRevealKind,TaskScope:Y.TaskScope,TerminalLink:Y.$sO,TerminalQuickFixTerminalCommand:Y.$uO,TerminalQuickFixOpener:Y.$tO,TerminalLocation:Y.TerminalLocation,TerminalProfile:Y.$vO,TerminalExitReason:Y.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:Y.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:Y.TextDocumentSaveReason,TextEdit:Y.$UN,SnippetTextEdit:Y.$WN,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:Y.TextEditorLineNumbersStyle,TextEditorRevealType:Y.TextEditorRevealType,TextEditorSelectionChangeKind:Y.TextEditorSelectionChangeKind,SyntaxTokenType:Y.SyntaxTokenType,TextDocumentChangeReason:Y.TextDocumentChangeReason,ThemeColor:Y.$LO,ThemeIcon:Y.$KO,TreeItem:Y.$BO,TreeItemCheckboxState:Y.TreeItemCheckboxState,TreeItemCollapsibleState:Y.TreeItemCollapsibleState,TypeHierarchyItem:Y.$yP,UIKind:At.UIKind,Uri:o.URI,ViewColumn:Y.ViewColumn,WorkspaceEdit:Y.$XN,DocumentPasteTriggerKind:Y.DocumentPasteTriggerKind,DocumentDropEdit:Y.$HO,DocumentDropOrPasteEditKind:Y.$IO,DocumentPasteEdit:Y.$JO,InlayHint:Y.$iO,InlayHintLabelPart:Y.$hO,InlayHintKind:Y.InlayHintKind,RemoteAuthorityResolverError:Y.$TN,ResolvedAuthority:Y.$RN,ManagedResolvedAuthority:Y.$SN,SourceControlInputBoxValidationType:Y.SourceControlInputBoxValidationType,ExtensionRuntime:Y.ExtensionRuntime,TimelineItem:Y.$lP,NotebookRange:Y.$dP,NotebookCellKind:Y.NotebookCellKind,NotebookCellExecutionState:Y.NotebookCellExecutionState,NotebookCellData:Y.$eP,NotebookData:Y.$fP,NotebookRendererScript:Y.$jP,NotebookCellStatusBarAlignment:Y.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Y.NotebookEditorRevealType,NotebookCellOutput:Y.$hP,NotebookCellOutputItem:Y.$gP,NotebookCellStatusBarItem:Y.$iP,NotebookControllerAffinity:Y.NotebookControllerAffinity,NotebookControllerAffinity2:Y.NotebookControllerAffinity2,NotebookEdit:Y.$VN,NotebookKernelSourceAction:Y.$kP,NotebookVariablesRequestKind:Y.NotebookVariablesRequestKind,PortAttributes:Y.$nP,LinkedEditingRanges:Y.$mP,TestResultState:Y.TestResultState,TestRunRequest:Y.$oP,TestMessage:Y.$pP,TestMessage2:Y.$pP,TestMessageStackFrame:Y.$rP,TestTag:Y.$qP,TestRunProfileKind:Y.TestRunProfileKind,TextSearchCompleteMessageType:Ct.TextSearchCompleteMessageType,DataTransfer:Y.$GO,DataTransferItem:Y.$CO,TestCoverageCount:Y.$sP,FileCoverage:Y.$uP,FileCoverage2:Y.$uP,StatementCoverage:Y.$vP,BranchCoverage:Y.$wP,DeclarationCoverage:Y.$xP,WorkspaceTrustState:Y.WorkspaceTrustState,LanguageStatusSeverity:Y.LanguageStatusSeverity,QuickPickItemKind:Y.QuickPickItemKind,InputBoxValidationSeverity:Y.InputBoxValidationSeverity,TabInputText:Y.$zP,TabInputTextDiff:Y.$AP,TabInputTextMerge:Y.$BP,TabInputCustom:Y.$CP,TabInputNotebook:Y.$EP,TabInputNotebookDiff:Y.$FP,TabInputWebview:Y.$DP,TabInputTerminal:Y.$GP,TabInputInteractiveWindow:Y.$HP,TabInputChat:Y.$IP,TabInputTextMultiDiff:Y.$JP,TelemetryTrustedValue:l.$wp,LogLevel:s.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Y.InteractiveSessionVoteDirection,ChatCopyKind:Y.ChatCopyKind,InteractiveEditorResponseFeedbackKind:Y.InteractiveEditorResponseFeedbackKind,DebugStackFrame:Y.$WO,DebugThread:Y.$XO,RelatedInformationType:Y.RelatedInformationType,SpeechToTextStatus:Y.SpeechToTextStatus,TextToSpeechStatus:Y.TextToSpeechStatus,PartialAcceptTriggerKind:Y.PartialAcceptTriggerKind,KeywordRecognitionStatus:Y.KeywordRecognitionStatus,ChatResponseMarkdownPart:Y.$LP,ChatResponseFileTreePart:Y.$PP,ChatResponseAnchorPart:Y.$QP,ChatResponseProgressPart:Y.$RP,ChatResponseProgressPart2:Y.$SP,ChatResponseReferencePart:Y.$VP,ChatResponseReferencePart2:Y.$VP,ChatResponseCodeCitationPart:Y.$WP,ChatResponseWarningPart:Y.$TP,ChatResponseTextEditPart:Y.$XP,ChatResponseMarkdownWithVulnerabilitiesPart:Y.$MP,ChatResponseCommandButtonPart:Y.$UP,ChatResponseDetectedParticipantPart:Y.$NP,ChatResponseConfirmationPart:Y.$OP,ChatResponseReferencePartStatusKind:Y.ChatResponseReferencePartStatusKind,ChatRequestTurn:Y.$YP,ChatResponseTurn:Y.$ZP,ChatLocation:Y.ChatLocation,ChatRequestEditorData:Y.$1P,ChatRequestNotebookData:Y.$2P,LanguageModelChatMessageRole:Y.LanguageModelChatMessageRole,LanguageModelChatMessage:Y.$4P,LanguageModelChatMessageFunctionResultPart:Y.$3P,LanguageModelChatResponseTextPart:Y.$6P,LanguageModelChatResponseFunctionUsePart:Y.$5P,LanguageModelError:Y.$0P,NewSymbolName:Y.$4O,NewSymbolNameTag:Y.NewSymbolNameTag,NewSymbolNameTriggerKind:Y.NewSymbolNameTriggerKind,InlineEdit:Y.$$P,InlineEditTriggerKind:Y.InlineEditTriggerKind,ExcludeSettingOptions:Ct.ExcludeSettingOptions,TextSearchContextNew:Ct.$YL,TextSearchMatchNew:Ct.$XL,TextSearchCompleteMessageTypeNew:Ct.TextSearchCompleteMessageTypeNew}}}}),define(Ne[277],Le([1,0,60,128,45,122,46,33,57,56,131,133,134,88,92,84,121,68,50,87,66,70,216,11,132,85,86,90,94,126,95]),function(ve,e,v,R,P,O,A,T,p,o,I,y,a,S,d,r,s,c,l,i,n,t,g,u,$,m,h,E,D,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,v.$Qs)(m.$iqc,m.$hqc,v.InstantiationType.Delayed),(0,v.$Qs)(u.$ak,g.$xrc,v.InstantiationType.Delayed),(0,v.$Qs)(r.$npc,r.$opc,v.InstantiationType.Delayed),(0,v.$Qs)(T.$FQ,T.$EQ,v.InstantiationType.Eager),(0,v.$Qs)(E.$xpc,E.$ypc,v.InstantiationType.Eager),(0,v.$Qs)(D.$cqc,D.$dqc,v.InstantiationType.Eager),(0,v.$Qs)(A.$Mpc,A.$Kpc,v.InstantiationType.Eager),(0,v.$Qs)(c.$Opc,c.$Npc,v.InstantiationType.Eager),(0,v.$Qs)(C.$sqc,C.$tqc,v.InstantiationType.Eager),(0,v.$Qs)(y.$xqc,y.$Bqc,v.InstantiationType.Eager),(0,v.$Qs)(O.$Dqc,O.$Cqc,v.InstantiationType.Eager),(0,v.$Qs)(p.$uQ,p.$tQ,v.InstantiationType.Eager),(0,v.$Qs)(h.$jqc,h.$kqc,v.InstantiationType.Eager),(0,v.$Qs)(l.$rpc,l.$qpc,v.InstantiationType.Eager),(0,v.$Qs)(R.$0qc,R.$9qc,v.InstantiationType.Delayed),(0,v.$Qs)(a.$Tqc,a.$Uqc,v.InstantiationType.Eager),(0,v.$Qs)(S.$8pc,S.$7pc,v.InstantiationType.Eager),(0,v.$Qs)(I.$krc,I.$jrc,v.InstantiationType.Eager),(0,v.$Qs)(o.$$pc,o.$bqc,v.InstantiationType.Eager),(0,v.$Qs)(w.$lrc,w.$mrc,v.InstantiationType.Eager),(0,v.$Qs)(d.$gGb,d.$hGb,v.InstantiationType.Eager),(0,v.$Qs)(s.$vrc,s.$urc,v.InstantiationType.Eager),(0,v.$Qs)(P.$Jpc,P.$Ipc,v.InstantiationType.Eager),(0,v.$Qs)(i.$fqc,i.$eqc,v.InstantiationType.Eager),(0,v.$Qs)(n.$DQ,n.$AQ,v.InstantiationType.Eager),(0,v.$Qs)(t.$Ypc,t.$Zpc,v.InstantiationType.Eager),(0,v.$Qs)($.$qqc,$.$rqc,v.InstantiationType.Eager)}),define(Ne[278],Le([1,0,276,47,2,273,7,10,223]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jtc=void 0;class o extends O.$Arc{j(){}getModule(S,d){for(const r of this.b){const s=r(S);if(s){S=s;break}}if(this.a.has(S))return this.a.get(S).load(S,d,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends R.$mqc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(p.$Itc);const S=this.h.invokeFunction(v.$wrc);this.r=this.h.createInstance(o,S,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(S){return S.browser}async xb(S,d,r){d=d.with({path:y(d.path,".js")});const s=S?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const c=P.URI.revive(await this.C.$asBrowserUri(d)),l=await fetch(c.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),l.status!==200)throw new Error(l.statusText);const i=await l.text(),n=`${d.toString(!0)}#vscode-extension`,t=`${i}
//# sourceURL=${n}`;let g;try{g=new Function("module","exports","require",t)}catch(h){throw console.error(s?`Loading code for extension ${s} failed: ${h.message}`:`Loading code failed: ${h.message}`),console.error(`${d.toString(!0)}${typeof h.line=="number"?` line ${h.line}`:""}${typeof h.column=="number"?` column ${h.column}`:""}`),console.error(h),h}S&&await this.w.initializeLocalizedMessages(S);const u={},$={exports:u},m=h=>{const E=this.r.getModule(h,d);if(E===void 0)throw new Error(`Cannot load module '${h}'`);return E};try{return r.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),g($,u,m),$.exports!==u?$.exports:u}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),r.codeLoadingStop()}}async $setRemoteEnvironment(S){}async Bb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const d=Date.now()+S;for(;Date.now()<d&&!("__jsDebugIsReady"in globalThis);)await(0,T.$Fh)(10)}}e.$Jtc=I;function y(a,S){return a.endsWith(S)?a:a+S}}),define(Ne[279],Le([1,0,73,60,11,47,188,91,278]),function(ve,e,v,R,P,O,A,T,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,R.$Qs)(P.$_j,new v.$Bi(A.$zrc,[!0],!0)),(0,R.$Qs)(O.$nqc,p.$Jtc,R.InstantiationType.Eager),(0,R.$Qs)(T.$Ppc,T.$Qpc,R.InstantiationType.Eager)}),define(Ne[287],Le([1,0,22,6,83,274,225,19,64,15,2,277,279]),function(ve,e,v,R,P,O,A,T,p,o,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=t,T=We(T),p=We(p);const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const a=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(g){return/^(file|vscode-remote):/i.test(g)}const d=fetch.bind(self);function r(g){self.fetch=async function(u,$){return u instanceof Request||S(String(u))&&(u=(await g(I.URI.parse(String(u)))).toString(!0)),d(u,$)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,$,m,h,E){(async()=>(S($.toString())&&($=(await g(I.URI.parse($.toString()))).toString(!0)),super.open(u,$,m??!0,h,E)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const g=self.Worker;Worker=function(u,$){if(/^file:/i.test(u.toString()))u=o.$Yg.uriToBrowserUri(I.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const h=`(${function(C){function k(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const f=fetch.bind(self);self.fetch=function(M,N){return M instanceof Request?f(M,N):f(k(M),N)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,N,L,W,K){return super.open(M,k(N),L??!0,W,K)}};const b=importScripts.bind(self);self.importScripts=(...M)=>{b(...M.map(k))},b(C)}.toString()}('${u}'))`;$=$||{},$.name=`${name} -> ${$.name||T.$nc(u.toString())}`;const E=new Blob([h],{type:"application/javascript"}),D=URL.createObjectURL(E);return new g(D,$)}}else self.Worker=class extends A.$Ktc{constructor(g,u){super(a,g,{name:T.$nc(g.toString()),...u})}};const s=new class{constructor(){this.pid=void 0}exit(g){y()}};class c{constructor(){const u=new MessageChannel,$=new R.$le;let m=!1;a(u.port2,[u.port2]),u.port1.onmessage=h=>{const{data:E}=h;if(!(E instanceof ArrayBuffer)){console.warn("UNKNOWN data received",E);return}const D=v.$Ne.wrap(new Uint8Array(E,0,E.byteLength));if((0,P.$Bn)(D,P.MessageType.Terminate)){m=!0,i("received terminate message from renderer");return}$.fire(D)},this.protocol={onMessage:$.event,send:h=>{if(!m){const E=h.buffer.buffer.slice(h.buffer.byteOffset,h.buffer.byteOffset+h.buffer.byteLength);u.port1.postMessage(E,[E])}}}}}function l(g){return new Promise(u=>{const $=g.onMessage(m=>{$.dispose();const h=JSON.parse(m.toString());g.send((0,P.$An)(P.MessageType.Initialized)),u({protocol:g,initData:h})});g.send((0,P.$An)(P.MessageType.Ready))})}let i=g=>y();function n(g){return!!g&&typeof g=="object"&&g.type==="vscode.init"&&g.data instanceof Map}function t(){p.mark("code/extHost/willConnectToRenderer");const g=new c;return{onmessage(u){n(u)&&l(g.protocol).then($=>{p.mark("code/extHost/didWaitForInitData");const m=new O.$Crc($.protocol,$.initData,s,null,u.data);r(h=>m.asBrowserUri(h)),i=h=>m.terminate(h)})}}}})}).call(this);

//# sourceMappingURL=https://main.vscode-cdn.net/sourcemaps/22e3447b4b410dcf8426bf70743c5dd4030d6122/core/vs/workbench/api/worker/extensionHostWorker.js.map
